/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/collections","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(j){for(var t=[],D=0,k=j.length;D<k;D++)t[D]=ne[j[D]];return t};const We=this,Ce=typeof global=="object"?global:{};var fe;(function(j){j.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof j.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}j.Environment=t})(fe||(fe={}));var fe;(function(j){class t{constructor(c,N,o){this.type=c,this.detail=N,this.timestamp=o}}j.LoaderEvent=t;class D{constructor(c){this._events=[new t(1,"",c)]}record(c,N){this._events.push(new t(c,N,j.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}j.LoaderEventRecorder=D;class k{record(c,N){}getEvents(){return[]}}k.INSTANCE=new k,j.NullLoaderEventRecorder=k})(fe||(fe={}));var fe;(function(j){class t{static fileUriToFilePath(k,r){if(r=decodeURI(r).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(k,r){return k.length>=r.length&&k.substr(0,r.length)===r}static endsWith(k,r){return k.length>=r.length&&k.substr(k.length-r.length)===r}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,r){if(k){let c;for(c in k)k.hasOwnProperty(c)&&r(c,k[c])}}static isEmpty(k){let r=!0;return t.forEachProperty(k,()=>{r=!1}),r}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let r=Array.isArray(k)?[]:{};return t.forEachProperty(k,(c,N)=>{N&&typeof N=="object"?r[c]=t.recursiveClone(N):r[c]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=j.global.performance&&typeof j.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?j.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,j.Utilities=t})(fe||(fe={}));var fe;(function(j){function t(r){if(r instanceof Error)return r;const c=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(c.stack=r.stack),c}j.ensureError=t;class D{static validateConfigurationOptions(c){function N(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=N),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(j.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const o=t(new Error("INVALID cached data configuration, 'path' MUST be set"));o.phase="configuration",c.onError(o),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,N=null){let o=j.Utilities.recursiveClone(N||{});return j.Utilities.forEachProperty(c,(l,s)=>{l==="ignoreDuplicateModules"&&typeof o.ignoreDuplicateModules<"u"?o.ignoreDuplicateModules=o.ignoreDuplicateModules.concat(s):l==="paths"&&typeof o.paths<"u"?j.Utilities.forEachProperty(s,(h,E)=>o.paths[h]=E):l==="config"&&typeof o.config<"u"?j.Utilities.forEachProperty(s,(h,E)=>o.config[h]=E):o[l]=j.Utilities.recursiveClone(s)}),D.validateConfigurationOptions(o)}}j.ConfigurationOptionsUtil=D;class k{constructor(c,N){if(this._env=c,this.options=D.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let o=this.options.nodeRequire.main.filename,l=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],j.Utilities.forEachProperty(this.options.paths,(c,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:c,to:N}):this.sortedPathsRules.push({from:c,to:[N]})}),this.sortedPathsRules.sort((c,N)=>N.from.length-c.from.length)}cloneAndMerge(c){return new k(this._env,D.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let N;for(let o=0,l=this.sortedPathsRules.length;o<l;o++)if(N=this.sortedPathsRules[o],j.Utilities.startsWith(c,N.from)){let s=[];for(let h=0,E=N.to.length;h<E;h++)s.push(N.to[h]+c.substr(N.from.length));return s}return[c]}_addUrlArgsToUrl(c){return j.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let N=0,o=c.length;N<o;N++)c[N]=this._addUrlArgsToUrl(c[N]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let N=c,o;if(!j.Utilities.endsWith(N,".js")&&!j.Utilities.isAbsolutePath(N)){o=this._applyPaths(N);for(let l=0,s=o.length;l<s;l++)this.isBuild()&&o[l]==="empty:"||(j.Utilities.isAbsolutePath(o[l])||(o[l]=this.options.baseUrl+o[l]),!j.Utilities.endsWith(o[l],".js")&&!j.Utilities.containsQueryString(o[l])&&(o[l]=o[l]+".js"))}else!j.Utilities.endsWith(N,".js")&&!j.Utilities.containsQueryString(N)&&(N=N+".js"),o=[N];return this._addUrlArgsIfNecessaryToUrls(o)}requireToUrl(c){let N=c;return j.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],j.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||j.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}j.Configuration=k})(fe||(fe={}));var fe;(function(j){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,E,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new D:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new D;let g={callback:E,errorback:d};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(g);return}this._callbackMap[h]=[g],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let E=0;E<h.length;E++)h[E].callback()}triggerErrorback(s,h){let E=this._callbackMap[s];delete this._callbackMap[s];for(let d=0;d<E.length;d++)E[d].errorback(h)}}class D{attachListeners(s,h,E){let d=()=>{s.removeEventListener("load",g),s.removeEventListener("error",e)},g=$=>{d(),h()},e=$=>{d(),E($)};s.addEventListener("load",g),s.addEventListener("error",e)}load(s,h,E,d){if(/^node\|/.test(h)){let g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||j.global.nodeRequire),$=h.split("|"),M=null;try{M=e($[1])}catch(A){d(A);return}s.enqueueDefineAnonymousModule([],()=>M),E()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,E,d);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),g.setAttribute("src",h);const{cspNonce:$}=s.getConfig().getOptionsLiteral();$&&g.setAttribute("nonce",$),document.getElementsByTagName("head")[0].appendChild(g)}}}function k(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(s)),this._cachedCanUseEval}load(s,h,E,d){if(/^node\|/.test(h)){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||j.global.nodeRequire),$=h.split("|");let M=null;try{M=e($[1])}catch(A){d(A);return}s.enqueueDefineAnonymousModule([],function(){return M}),E()}else{const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then($=>{if($.status!==200)throw new Error($.statusText);return $.text()}).then($=>{$=`${$}
//# sourceURL=${h}`,(g?self.eval(g.createScript("",$)):new Function($)).call(self),E()}).then(void 0,d);return}try{g&&(h=g.createScriptURL(h)),importScripts(h),E()}catch($){d($)}}}}class c{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:E}=h.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,g=s("module");function e($){const M=$.constructor;let A=function(v){try{return $.require(v)}finally{}};return A.resolve=function(v,w){return M._resolveFilename(v,$,!1,w)},A.resolve.paths=function(v){return M._resolveLookupPaths(v,$)},A.main=process.mainModule,A.extensions=M._extensions,A.cache=M._cache,A}g.prototype._compile=function($,M){const A=g.wrap($.replace(/^#!.*/,"")),f=h.getRecorder(),v=d._getCachedDataPath(E,M),w={filename:M};let a;try{const p=d._fs.readFileSync(v);a=p.slice(0,16),w.cachedData=p.slice(16),f.record(60,v)}catch{f.record(61,v)}const i=new d._vm.Script(A,w),u=i.runInThisContext(w),L=d._path.dirname(M),m=e(this),b=[this.exports,m,this,M,L,process,Ce,Buffer],P=u.apply(this.exports,b);return d._handleCachedData(i,A,v,!w.cachedData,h),d._verifyCachedData(i,A,v,a,h),P}}load(s,h,E,d){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||j.global.nodeRequire),$=g.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,s);let M=s.getRecorder();if(/^node\|/.test(h)){let A=h.split("|"),f=null;try{f=e(A[1])}catch(v){d(v);return}s.enqueueDefineAnonymousModule([],()=>f),E()}else{h=j.Utilities.fileUriToFilePath(this._env.isWindows,h);const A=this._path.normalize(h),f=this._getElectronRendererScriptPathOrUri(A),v=!!g.nodeCachedData,w=v?this._getCachedDataPath(g.nodeCachedData,h):void 0;this._readSourceAndCachedData(A,w,M,(a,i,u,L)=>{if(a){d(a);return}let m;i.charCodeAt(0)===c._BOM?m=c._PREFIX+i.substring(1)+c._SUFFIX:m=c._PREFIX+i+c._SUFFIX,m=$(m,A);const b={filename:f,cachedData:u},P=this._createAndEvalScript(s,m,b,E,d);this._handleCachedData(P,m,w,v&&!u,s),this._verifyCachedData(P,m,w,L,s)})}}_createAndEvalScript(s,h,E,d,g){const e=s.getRecorder();e.record(31,E.filename);const $=new this._vm.Script(h,E),M=$.runInThisContext(E),A=s.getGlobalAMDDefineFunc();let f=!1;const v=function(){return f=!0,A.apply(null,arguments)};return v.amd=A.amd,M.call(j.global,s.getGlobalAMDRequireFunc(),v,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),f?d():g(new Error(`Didn't receive define call in ${E.filename}!`)),$}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const E=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${d}-${E}.code`)}_handleCachedData(s,h,E,d,g){s.cachedDataRejected?this._fs.unlink(E,e=>{g.getRecorder().record(62,E),this._createAndWriteCachedData(s,h,E,g),e&&g.getConfig().onError(e)}):d&&this._createAndWriteCachedData(s,h,E,g)}_createAndWriteCachedData(s,h,E,d){let g=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,$=0,M;const A=()=>{setTimeout(()=>{M||(M=this._crypto.createHash("md5").update(h,"utf8").digest());const f=s.createCachedData();if(!(f.length===0||f.length===e||$>=5)){if(f.length<e){A();return}e=f.length,this._fs.writeFile(E,Buffer.concat([M,f]),v=>{v&&d.getConfig().onError(v),d.getRecorder().record(63,E),A()})}},g*Math.pow(4,$++))};A()}_readSourceAndCachedData(s,h,E,d){if(!h)this._fs.readFile(s,{encoding:"utf8"},d);else{let g,e,$,M=2;const A=f=>{f?d(f):--M===0&&d(void 0,g,e,$)};this._fs.readFile(s,{encoding:"utf8"},(f,v)=>{g=v,A(f)}),this._fs.readFile(h,(f,v)=>{!f&&v&&v.length>0?($=v.slice(0,16),e=v.slice(16),E.record(60,h)):E.record(61,h),A()})}}_verifyCachedData(s,h,E,d,g){d&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();d.equals(e)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,$=>{$&&g.getConfig().onError($)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function N(l,s){if(s.__$__isRecorded)return s;const h=function(d){l.record(33,d);try{return s(d)}finally{l.record(34,d)}};return h.__$__isRecorded=!0,h}j.ensureRecordedNodeRequire=N;function o(l){return new t(l)}j.createScriptLoader=o})(fe||(fe={}));var fe;(function(j){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return j.Utilities.isAbsolutePath(s)||(j.Utilities.startsWith(s,"./")||j.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),j.ModuleIdResolver=t;class D{constructor(l,s,h,E,d,g){this.id=l,this.strId=s,this.dependencies=h,this._callback=E,this._errorback=d,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(j.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(l,s,h,E){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(h,E):{returnedValue:h.apply(j.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,h,E){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let g=D._invokeFactory(s,this.strId,this._callback,h);d=g.producedError,l.record(22,this.strId),!d&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||j.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(d){let g=j.ensureError(d);g.phase="factory",g.moduleId=this.strId,g.neededBy=E(this.id),this.error=g,s.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}j.Module=D;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),j.RegularDependency=r;class c{constructor(l,s,h){this.id=l,this.pluginId=s,this.pluginParam=h}}j.PluginDependency=c;class N{constructor(l,s,h,E,d=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=d,this._defineFunc=h,this._requireFunc=E,this._moduleIdProvider=new k,this._config=new j.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let h=g=>g.replace(/\\/g,"/"),E=h(l),d=s.split(/\n/);for(let g=0;g<d.length;g++){let e=d[g].match(/(.*):(\d+):(\d+)\)?$/);if(e){let $=e[1],M=e[2],A=e[3],f=Math.max($.lastIndexOf(" ")+1,$.lastIndexOf("(")+1);if($=$.substr(f),$=h($),$===E){let v={line:parseInt(M,10),col:parseInt(A,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let h=0,E=this._modules2.length;h<E;h++){let d=this._modules2[h];if(!d)continue;let g=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,$=this._buildInfoDependencies[d.id];l[s++]={id:d.strId,path:g,defineLocation:g&&e?N._findRelevantLocationInStack(g,e):null,dependencies:$,shim:null,exports:d.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new j.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=j.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:l,callback:s}}defineModule(l,s,h,E,d,g=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let $=new D(e,l,this._normalizeDependencies(s,g),h,E,g);this._modules2[e]=$,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=($.dependencies||[]).map(M=>this._moduleIdProvider.getStrModuleId(M.id))),this._resolve($)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let h=l.indexOf("!");if(h>=0){let E=s.resolveModule(l.substr(0,h)),d=s.resolveModule(l.substr(h+1)),g=this._moduleIdProvider.getModuleId(E+"!"+d),e=this._moduleIdProvider.getModuleId(E);return new c(g,e,d)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let h=[],E=0;for(let d=0,g=l.length;d<g;d++)h[E++]=this._normalizeDependency(l[d],s);return h}_relativeRequire(l,s,h,E){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(j.Utilities.generateAnonymousModule(),s,h,E,null,l)}synchronousRequire(l,s=new t(l)){let h=this._normalizeDependency(l,s),E=this._modules2[h.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(l,s){let h=this._config.shouldRecordStats();s?this._config=new j.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let h=this._moduleIdProvider.getStrModuleId(l),E=(this._inverseDependencies2[l]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const d=j.ensureError(s);return d.phase="loading",d.moduleId=h,d.neededBy=E,d}_onLoadError(l,s){const h=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new D(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let E=[];for(let e=0,$=this._moduleIdProvider.getMaxModuleId();e<$;e++)E[e]=!1;let d=!1,g=[];for(g.push(l),E[l]=!0;g.length>0;){let e=g.shift(),$=this._modules2[e];$&&(d=$.onDependencyError(h)||d);let M=this._inverseDependencies2[e];if(M)for(let A=0,f=M.length;A<f;A++){let v=M[A];E[v]||(g.push(v),E[v]=!0)}}d||this._config.onError(h)}_hasDependencyPath(l,s){let h=this._modules2[l];if(!h)return!1;let E=[];for(let g=0,e=this._moduleIdProvider.getMaxModuleId();g<e;g++)E[g]=!1;let d=[];for(d.push(h),E[l]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let $=0,M=e.length;$<M;$++){let A=e[$];if(A.id===s)return!0;let f=this._modules2[A.id];f&&!E[A.id]&&(E[A.id]=!0,d.push(f))}}return!1}_findCyclePath(l,s,h){if(l===s||h===50)return[l];let E=this._modules2[l];if(!E)return null;let d=E.dependencies;if(d)for(let g=0,e=d.length;g<e;g++){let $=this._findCyclePath(d[g].id,s,h+1);if($!==null)return $.push(l),$}return null}_createRequire(l){let s=(h,E,d)=>this._relativeRequire(l,h,E,d);return s.toUrl=h=>this._config.requireToUrl(l.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,E=!1)=>{this.configure(h,E)},s.__$__nodeRequire=j.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),h=this._config.moduleIdToPaths(s),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||E.test(s))&&h.push("node|"+s);let d=-1,g=e=>{if(d++,d>=h.length)this._onLoadError(l,e);else{let $=h[d],M=this.getRecorder();if(this._config.isBuild()&&$==="empty:"){this._buildInfoPath[l]=$,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}M.record(10,$),this._scriptLoader.load(this,$,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=$),M.record(11,$),this._onLoad(l)},A=>{M.record(12,$),g(A)})}};g(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],E,null,null)};h.error=E=>{this._config.onError(this._createLoadError(s.id,E))},l.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let h=0,E=s.length;h<E;h++){let d=s[h];if(d===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(d===r.MODULE){l.unresolvedDependenciesCount--;continue}if(d===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let g=this._modules2[d.id];if(g&&g.isComplete()){if(g.error){l.onDependencyError(g.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,l.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map($=>this._moduleIdProvider.getStrModuleId($)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(l.id),d instanceof c){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let $=this._inversePluginDependencies2.get(d.pluginId);$||($=[],this._inversePluginDependencies2.set(d.pluginId,$)),$.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let h=l.dependencies,E=[];if(h)for(let $=0,M=h.length;$<M;$++){let A=h[$];if(A===r.EXPORTS){E[$]=l.exports;continue}if(A===r.MODULE){E[$]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(A===r.REQUIRE){E[$]=this._createRequire(l.moduleIdResolver);continue}let f=this._modules2[A.id];if(f){E[$]=f.exports;continue}E[$]=null}const d=$=>(this._inverseDependencies2[$]||[]).map(M=>this._moduleIdProvider.getStrModuleId(M));l.complete(s,this._config,E,d);let g=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,g)for(let $=0,M=g.length;$<M;$++){let A=g[$],f=this._modules2[A];f.unresolvedDependenciesCount--,f.unresolvedDependenciesCount===0&&this._onModuleComplete(f)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let $=0,M=e.length;$<M;$++)this._loadPluginDependency(l.exports,e[$])}}}j.ModuleManager=N})(fe||(fe={}));var te,fe;(function(j){const t=new j.Environment;let D=null;const k=function(o,l,s){typeof o!="string"&&(s=l,l=o,o=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),o?D.defineModule(o,l,s,null,null):D.enqueueDefineAnonymousModule(l,s)};k.amd={jQuery:!0};const r=function(o,l=!1){D.configure(o,l)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(j.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=r,c.getConfig=function(){return D.getConfig().getOptionsLiteral()},c.reset=function(){D=D.reset()},c.getBuildInfo=function(){return D.getBuildInfo()},c.getStats=function(){return D.getLoaderEvents()},c.define=k;function N(){if(typeof j.global.require<"u"||typeof require<"u"){const o=j.global.require||require;if(typeof o=="function"&&typeof o.resolve=="function"){const l=j.ensureRecordedNodeRequire(D.getRecorder(),o);j.global.nodeRequire=l,c.nodeRequire=l,c.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(j.global.define=k),j.global.require=c)}j.init=N,(typeof j.global.define!="function"||!j.global.define.amd)&&(D=new j.ModuleManager(t,j.createScriptLoader(t),k,c,j.Utilities.getHighPerformanceTimestamp()),typeof j.global.require<"u"&&typeof j.global.require!="function"&&c.config(j.global.require),te=function(){return k.apply(null,arguments)},te.amd=k.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),te(ne[68],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(o,l,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const d=l.toUrl(o+".css");k(o,d,()=>{s({})},g=>{typeof s.error=="function"&&s.error("Could not find "+d+".")})}t.load=D;function k(o,l,s,h){if(r(o,l)){s();return}c(o,l,s,h)}function r(o,l){const s=document.getElementsByTagName("link");for(let h=0,E=s.length;h<E;h++){const d=s[h].getAttribute("data-name"),g=s[h].getAttribute("href");if(d===o||g===l)return!0}return!1}function c(o,l,s,h){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",o),N(o,E,s,h),E.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function N(o,l,s,h){const E=()=>{l.removeEventListener("load",d),l.removeEventListener("error",g)},d=e=>{E(),s()},g=e=>{E(),h(e)};l.addEventListener("load",d),l.addEventListener("error",g)}}),te("vs/nls",["require","exports"],function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function r(e,$){let M;return $.length===0?M=e:M=e.replace(/\{(\d+)\}/g,(A,f)=>{const v=f[0],w=$[v];let a=A;return typeof w=="string"?a=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(a=String(w)),a}),D&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M}function c(e,$){let M=e[$];return M||(M=e["*"],M)?M:null}function N(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function o(e,$,M){const A=N(e)+N($)+"vscode/"+N(M),f=await fetch(A);if(f.ok)return await f.json();throw new Error(`${f.status} - ${f.statusText}`)}function l(e){return function($,M){const A=Array.prototype.slice.call(arguments,2);return r(e[$],A)}}function s(e,$,...M){return r($,M)}t.localize=s;function h(e){}t.getConfiguredDefaultLocale=h;function E(e){D=e}t.setPseudoTranslation=E;function d(e,$){return{localize:l($[e]),getConfiguredDefaultLocale:$.getConfiguredDefaultLocale??(M=>{})}}t.create=d;function g(e,$,M,A){const f=A["vs/nls"]??{};if(!e||e.length===0)return M({localize:s,getConfiguredDefaultLocale:()=>f.availableLanguages?.["*"]});const v=f.availableLanguages?c(f.availableLanguages,e):null,w=v===null||v===k;let a=".nls";w||(a=a+"."+v);const i=u=>{Array.isArray(u)?u.localize=l(u):u.localize=l(u[e]),u.getConfiguredDefaultLocale=()=>f.availableLanguages?.["*"],M(u)};typeof f.loadBundle=="function"?f.loadBundle(e,v,(u,L)=>{u?$([e+".nls"],i):i(L)}):f.translationServiceUrl&&!w?(async()=>{try{const u=await o(f.translationServiceUrl,v,e);return i(u)}catch(u){if(!v.includes("-"))return console.error(u),$([e+".nls"],i);try{const L=v.split("-")[0],m=await o(f.translationServiceUrl,L,e);return f.availableLanguages??={},f.availableLanguages["*"]=L,i(m)}catch(L){return console.error(L),$([e+".nls"],i)}}})():$([e+a],i,u=>{if(a===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${v}. Falling back to the default language:`,u),$([e+".nls"],i)})}t.load=g}),function(){const j=globalThis.MonacoEnvironment,t=j&&j.baseUrl?j.baseUrl:"../../../";function D(h,E){if(j?.createTrustedTypesPolicy)try{return j.createTrustedTypesPolicy(h,E)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(h,E)}catch(d){console.warn(d);return}}const k=D("amdLoader",{createScriptURL:h=>h,createScript:(h,...E)=>{const d=E.slice(0,-1).join(","),g=E.pop().toString();return`(function anonymous(${d}) { ${g}
})`}});function r(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((h,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,E);return}k?importScripts(k.createScriptURL(d)):importScripts(d),h()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function o(h){c().then(()=>{N(),require([h],function(E){setTimeout(function(){const d=E.create((g,e)=>{globalThis.postMessage(g,e)},null);for(globalThis.onmessage=g=>d.onmessage(g.data,g.ports);s.length>0;){const g=s.shift();d.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let l=!0;const s=[];globalThis.onmessage=h=>{if(!l){s.push(h);return}l=!1,o(h.data)}}(),te(ne[9],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function D($,M,A){const f=k($,M);if(f!==-1)return $[f]}t.$db=D;function k($,M,A=$.length-1){for(let f=A;f>=0;f--){const v=$[f];if(M(v))return f}return-1}t.$eb=k;function r($,M){const A=c($,M);return A===-1?void 0:$[A]}t.$fb=r;function c($,M,A=0,f=$.length){let v=A,w=f;for(;v<w;){const a=Math.floor((v+w)/2);M($[a])?v=a+1:w=a}return v-1}t.$gb=c;function N($,M){const A=o($,M);return A===$.length?void 0:$[A]}t.$hb=N;function o($,M,A=0,f=$.length){let v=A,w=f;for(;v<w;){const a=Math.floor((v+w)/2);M($[a])?w=a:v=a+1}return v}t.$ib=o;function l($,M,A=0,f=$.length){const v=o($,M,A,f);return v===$.length?-1:v}t.$jb=l;class s{static{this.assertInvariants=!1}constructor(M){this.e=M,this.c=0}findLastMonotonous(M){if(s.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!M(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=M}const A=c(this.e,M,this.c);return this.c=A+1,A===-1?void 0:this.e[A]}}t.$kb=s;function h($,M){if($.length===0)return;let A=$[0];for(let f=1;f<$.length;f++){const v=$[f];M(v,A)>0&&(A=v)}return A}t.$lb=h;function E($,M){if($.length===0)return;let A=$[0];for(let f=1;f<$.length;f++){const v=$[f];M(v,A)>=0&&(A=v)}return A}t.$mb=E;function d($,M){return h($,(A,f)=>-M(A,f))}t.$nb=d;function g($,M){if($.length===0)return-1;let A=0;for(let f=1;f<$.length;f++){const v=$[f];M(v,$[A])>0&&(A=f)}return A}t.$ob=g;function e($,M){for(const A of $){const f=M(A);if(f!==void 0)return f}}t.$pb=e}),te(ne[19],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function D(N,o){const l=Object.create(null);for(const s of N){const h=o(s);let E=l[h];E||(E=l[h]=[]),E.push(s)}return l}t.$I=D;function k(N,o){const l=[],s=[];for(const h of N)o.has(h)||l.push(h);for(const h of o)N.has(h)||s.push(h);return{removed:l,added:s}}t.$J=k;function r(N,o){const l=[],s=[];for(const[h,E]of N)o.has(h)||l.push(E);for(const[h,E]of o)N.has(h)||s.push(E);return{removed:l,added:s}}t.$K=r;class c{constructor(){this.a=new Map}add(o,l){let s=this.a.get(o);s||(s=new Set,this.a.set(o,s)),s.add(l)}delete(o,l){const s=this.a.get(o);s&&(s.delete(l),s.size===0&&this.a.delete(o))}forEach(o,l){const s=this.a.get(o);s&&s.forEach(l)}get(o){const l=this.a.get(o);return l||new Set}}t.$L=c}),te(ne[34],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=t.$Ms=t.$Ls=void 0;function D(o,l){const s=Math.pow(10,l);return Math.round(o*s)/s}class k{constructor(l,s,h,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=D(Math.max(Math.min(1,E),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$Ls=k;class r{constructor(l,s,h,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.l=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,E),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,h=l.g/255,E=l.b/255,d=l.a,g=Math.max(s,h,E),e=Math.min(s,h,E);let $=0,M=0;const A=(e+g)/2,f=g-e;if(f>0){switch(M=Math.min(A<=.5?f/(2*A):f/(2-2*A),1),g){case s:$=(h-E)/f+(h<E?6:0);break;case h:$=(E-s)/f+2;break;case E:$=(s-h)/f+4;break}$*=60,$=Math.round($)}return new r($,M,A,d)}static i(l,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?l+(s-l)*6*h:h<1/2?s:h<2/3?l+(s-l)*(2/3-h)*6:l}static toRGBA(l){const s=l.h/360,{s:h,l:E,a:d}=l;let g,e,$;if(h===0)g=e=$=E;else{const M=E<.5?E*(1+h):E+h-E*h,A=2*E-M;g=r.i(A,M,s+1/3),e=r.i(A,M,s),$=r.i(A,M,s-1/3)}return new k(Math.round(g*255),Math.round(e*255),Math.round($*255),d)}}t.$Ms=r;class c{constructor(l,s,h,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=D(Math.max(Math.min(1,s),0),3),this.v=D(Math.max(Math.min(1,h),0),3),this.a=D(Math.max(Math.min(1,E),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,h=l.g/255,E=l.b/255,d=Math.max(s,h,E),g=Math.min(s,h,E),e=d-g,$=d===0?0:e/d;let M;return e===0?M=0:d===s?M=((h-E)/e%6+6)%6:d===h?M=(E-s)/e+2:M=(s-h)/e+4,new c(Math.round(M*60),$,d,l.a)}static toRGBA(l){const{h:s,s:h,v:E,a:d}=l,g=E*h,e=g*(1-Math.abs(s/60%2-1)),$=E-g;let[M,A,f]=[0,0,0];return s<60?(M=g,A=e):s<120?(M=e,A=g):s<180?(A=g,f=e):s<240?(A=e,f=g):s<300?(M=e,f=g):s<=360&&(M=g,f=e),M=Math.round((M+$)*255),A=Math.round((A+$)*255),f=Math.round((f+$)*255),new k(M,A,f,d)}}t.$Ns=c;class N{static fromHex(l){return N.Format.CSS.parseHex(l)||N.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:c.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof k)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof c)this.j=l,this.rgba=c.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&k.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&c.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=N.k(this.rgba.r),s=N.k(this.rgba.g),h=N.k(this.rgba.b),E=.2126*l+.7152*s+.0722*h;return D(E,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),h=l.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),h=l.getRelativeLuminance();return s>h}isDarkerThan(l){const s=this.getRelativeLuminance(),h=l.getRelativeLuminance();return s<h}lighten(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g:h,b:E,a:d}=this.rgba;return new N(new k(s,h,E,d*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,h=this.rgba.a,E=s.a,d=h+E*(1-h);if(d<1e-6)return N.transparent;const g=this.rgba.r*h/d+s.r*E*(1-h)/d,e=this.rgba.g*h/d+s.g*E*(1-h)/d,$=this.rgba.b*h/d+s.b*E*(1-h)/d;return new N(new k(g,e,$,d))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g:h,b:E,a:d}=this.rgba;return new N(new k(l.rgba.r-d*(l.rgba.r-s),l.rgba.g-d*(l.rgba.g-h),l.rgba.b-d*(l.rgba.b-E),1))}flatten(...l){const s=l.reduceRight((h,E)=>N.o(E,h));return N.o(this,s)}static o(l,s){const h=1-l.rgba.a;return new N(new k(h*s.rgba.r+l.rgba.a*l.rgba.r,h*s.rgba.g+l.rgba.a*l.rgba.g,h*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(l,s,h){if(l.isLighterThan(s))return l;h=h||.5;const E=l.getRelativeLuminance(),d=s.getRelativeLuminance();return h=h*(d-E)/d,l.lighten(h)}static getDarkerColor(l,s,h){if(l.isDarkerThan(s))return l;h=h||.5;const E=l.getRelativeLuminance(),d=s.getRelativeLuminance();return h=h*(E-d)/E,l.darken(h)}static{this.white=new N(new k(255,255,255,1))}static{this.black=new N(new k(0,0,0,1))}static{this.red=new N(new k(255,0,0,1))}static{this.blue=new N(new k(0,0,255,1))}static{this.green=new N(new k(0,255,0,1))}static{this.cyan=new N(new k(0,255,255,1))}static{this.lightgrey=new N(new k(211,211,211,1))}static{this.transparent=new N(new k(0,0,0,0))}}t.$Os=N,function(o){let l;(function(s){let h;(function(E){function d(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:o.Format.CSS.formatRGBA(i)}E.formatRGB=d;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}E.formatRGBA=g;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:o.Format.CSS.formatHSLA(i)}E.formatHSL=e;function $(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}E.formatHSLA=$;function M(i){const u=i.toString(16);return u.length!==2?"0"+u:u}function A(i){return`#${M(i.rgba.r)}${M(i.rgba.g)}${M(i.rgba.b)}`}E.formatHex=A;function f(i,u=!1){return u&&i.rgba.a===1?o.Format.CSS.formatHex(i):`#${M(i.rgba.r)}${M(i.rgba.g)}${M(i.rgba.b)}${M(Math.round(i.rgba.a*255))}`}E.formatHexA=f;function v(i){return i.isOpaque()?o.Format.CSS.formatHex(i):o.Format.CSS.formatRGBA(i)}E.format=v;function w(i){const u=i.length;if(u===0||i.charCodeAt(0)!==35)return null;if(u===7){const L=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),m=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),b=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new o(new k(L,m,b,1))}if(u===9){const L=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),m=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),b=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),P=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new o(new k(L,m,b,P/255))}if(u===4){const L=a(i.charCodeAt(1)),m=a(i.charCodeAt(2)),b=a(i.charCodeAt(3));return new o(new k(16*L+L,16*m+m,16*b+b))}if(u===5){const L=a(i.charCodeAt(1)),m=a(i.charCodeAt(2)),b=a(i.charCodeAt(3)),P=a(i.charCodeAt(4));return new o(new k(16*L+L,16*m+m,16*b+b,(16*P+P)/255))}return null}E.parseHex=w;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(l=o.Format||(o.Format={}))}(N||(t.$Os=N={}))}),te(ne[35],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=void 0;class D{constructor(r,c,N,o){this.originalStart=r,this.originalLength=c,this.modifiedStart=N,this.modifiedLength=o}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ns=D}),te(ne[3],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class D{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?v.isErrorNoTelemetry(i)?new v(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(u=>{u(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$U=D,t.$V=new D;function k(a){t.$V.setUnexpectedErrorHandler(a)}t.setUnexpectedErrorHandler=k;function r(a){if(!a||typeof a!="object")return!1;const i=a;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$X=r;function c(a){s(a)||t.$V.onUnexpectedError(a)}t.$Y=c;function N(a){s(a)||t.$V.onUnexpectedExternalError(a)}t.$Z=N;function o(a){if(a instanceof Error){const{name:i,message:u}=a,L=a.stacktrace||a.stack;return{$isError:!0,name:i,message:u,stack:L,noTelemetry:v.isErrorNoTelemetry(a)}}return a}t.$1=o;const l="Canceled";function s(a){return a instanceof h?!0:a instanceof Error&&a.name===l&&a.message===l}t.$2=s;class h extends Error{constructor(){super(l),this.name=this.message}}t.$3=h;function E(){const a=new Error(l);return a.name=a.message,a}t.$4=E;function d(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}t.$5=d;function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}t.$6=g;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function $(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}t.$8=$;class M extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$9=M;class A extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$0=A;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=f;class v extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof v)return i;const u=new v;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$_=v;class w extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}t.$ab=w}),te(ne[6],re([0,1,3,9]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.CompareResult=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.top=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function r(U,W=0){return U[U.length-(1+W)]}t.$qb=r;function c(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$rb=c;function N(U,W,O=(X,ee)=>X===ee){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let X=0,ee=U.length;X<ee;X++)if(!O(U[X],W[X]))return!1;return!0}t.$sb=N;function o(U,W){const O=U.length-1;W<O&&(U[W]=U[O]),U.pop()}t.$tb=o;function l(U,W,O){return s(U.length,X=>O(U[X],W))}t.$ub=l;function s(U,W){let O=0,X=U-1;for(;O<=X;){const ee=(O+X)/2|0,G=W(ee);if(G<0)O=ee+1;else if(G>0)X=ee-1;else return ee}return-(O+1)}t.$vb=s;function h(U,W,O){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const X=W[Math.floor(W.length*Math.random())],ee=[],G=[],Y=[];for(const Q of W){const K=O(Q,X);K<0?ee.push(Q):K>0?G.push(Q):Y.push(Q)}return U<ee.length?h(U,ee,O):U<ee.length+Y.length?Y[0]:h(U-(ee.length+Y.length),G,O)}t.$wb=h;function E(U,W){const O=[];let X;for(const ee of U.slice(0).sort(W))!X||W(X[0],ee)!==0?(X=[ee],O.push(X)):X.push(ee);return O}t.$xb=E;function*d(U,W){let O,X;for(const ee of U)X!==void 0&&W(X,ee)?O.push(ee):(O&&(yield O),O=[ee]),X=ee;O&&(yield O)}t.$yb=d;function g(U,W){for(let O=0;O<=U.length;O++)W(O===0?void 0:U[O-1],O===U.length?void 0:U[O])}t.$zb=g;function e(U,W){for(let O=0;O<U.length;O++)W(O===0?void 0:U[O-1],U[O],O+1===U.length?void 0:U[O+1])}t.$Ab=e;function $(U,W,O){const X=[];function ee(Q,K,ie){if(K===0&&ie.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=K,le.toInsert.push(...ie)):X.push({start:Q,deleteCount:K,toInsert:ie})}let G=0,Y=0;for(;;){if(G===U.length){ee(G,0,W.slice(Y));break}if(Y===W.length){ee(G,U.length-G,[]);break}const Q=U[G],K=W[Y],ie=O(Q,K);ie===0?(G+=1,Y+=1):ie<0?(ee(G,1,[]),G+=1):ie>0&&(ee(G,0,[K]),Y+=1)}return X}t.$Bb=$;function M(U,W,O){const X=$(U,W,O),ee=[],G=[];for(const Y of X)ee.push(...U.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:ee,added:G}}t.$Cb=M;function A(U,W,O){if(O===0)return[];const X=U.slice(0,O).sort(W);return v(U,W,X,O,U.length),X}t.top=A;function f(U,W,O,X,ee){return O===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const Q=U.length,K=U.slice(0,O).sort(W);for(let ie=O,le=Math.min(O+X,Q);ie<Q;ie=le,le=Math.min(le+X,Q)){if(ie>O&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new D.$3;v(U,W,K,ie,le)}return K})().then(G,Y)})}t.$Eb=f;function v(U,W,O,X,ee){for(const G=O.length;X<ee;X++){const Y=U[X];if(W(Y,O[G-1])<0){O.pop();const Q=(0,k.$ib)(O,K=>W(Y,K)<0);O.splice(Q,0,Y)}}}function w(U){return U.filter(W=>!!W)}t.$Fb=w;function a(U){let W=0;for(let O=0;O<U.length;O++)U[O]&&(U[W]=U[O],W+=1);U.length=W}t.$Gb=a;function i(U,W,O){U.splice(O,0,U.splice(W,1)[0])}t.$Hb=i;function u(U){return!Array.isArray(U)||U.length===0}t.$Ib=u;function L(U){return Array.isArray(U)&&U.length>0}t.$Jb=L;function m(U,W=O=>O){const O=new Set;return U.filter(X=>{const ee=W(X);return O.has(ee)?!1:(O.add(ee),!0)})}t.$Kb=m;function b(U){const W=new Set;return O=>{const X=U(O);return W.has(X)?!1:(W.add(X),!0)}}t.$Lb=b;function P(U,W){return U.length>0?U[0]:W}t.$Mb=P;function p(U,W){return U.length>0?U[U.length-1]:W}t.$Nb=p;function y(U,W,O=(X,ee)=>X===ee){let X=0;for(let ee=0,G=Math.min(U.length,W.length);ee<G&&O(U[ee],W[ee]);ee++)X++;return X}t.$Ob=y;function F(U){return[].concat(...U)}t.$Pb=F;function R(U,W){let O=typeof W=="number"?U:0;typeof W=="number"?O=U:(O=0,W=U);const X=[];if(O<=W)for(let ee=O;ee<W;ee++)X.push(ee);else for(let ee=O;ee>W;ee--)X.push(ee);return X}t.$Qb=R;function S(U,W,O){return U.reduce((X,ee)=>(X[W(ee)]=O?O(ee):ee,X),Object.create(null))}t.$Rb=S;function I(U,W){return U.push(W),()=>q(U,W)}t.$Sb=I;function q(U,W){const O=U.indexOf(W);if(O>-1)return U.splice(O,1),W}t.$Tb=q;function x(U,W,O){const X=U.slice(0,W),ee=U.slice(W);return X.concat(O,ee)}t.$Ub=x;function _(U,W){let O;if(typeof W=="number"){let X=W;O=()=>{const ee=Math.sin(X++)*179426549;return ee-Math.floor(ee)}}else O=Math.random;for(let X=U.length-1;X>0;X-=1){const ee=Math.floor(O()*(X+1)),G=U[X];U[X]=U[ee],U[ee]=G}}t.$Vb=_;function V(U,W){const O=U.indexOf(W);O>-1&&(U.splice(O,1),U.unshift(W))}t.$Wb=V;function H(U,W){const O=U.indexOf(W);O>-1&&(U.splice(O,1),U.push(W))}t.$Xb=H;function C(U,W){for(const O of W)U.push(O)}t.$Yb=C;function J(U,W){return Array.isArray(U)?U.map(W):W(U)}t.$Zb=J;function n(U){return Array.isArray(U)?U:[U]}t.$1b=n;function ue(U){return U[Math.floor(Math.random()*U.length)]}t.$2b=ue;function oe(U,W,O){const X=ve(U,W),ee=U.length,G=O.length;U.length=ee+G;for(let Y=ee-1;Y>=X;Y--)U[Y+G]=U[Y];for(let Y=0;Y<G;Y++)U[Y+X]=O[Y]}t.$3b=oe;function $e(U,W,O,X){const ee=ve(U,W);let G=U.splice(ee,O);return G===void 0&&(G=[]),oe(U,ee,X),G}t.$4b=$e;function ve(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var be;(function(U){function W(G){return G<0}U.isLessThan=W;function O(G){return G<=0}U.isLessThanOrEqual=O;function X(G){return G>0}U.isGreaterThan=X;function ee(G){return G===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(be||(t.CompareResult=be={}));function Ee(U,W){return(O,X)=>W(U(O),U(X))}t.$5b=Ee;function Fe(...U){return(W,O)=>{for(const X of U){const ee=X(W,O);if(!be.isNeitherLessOrGreaterThan(ee))return ee}return be.neitherLessOrGreaterThan}}t.$6b=Fe;const _e=(U,W)=>U-W;t.$7b=_e;const Te=(U,W)=>(0,t.$7b)(U?1:0,W?1:0);t.$8b=Te;function Se(U){return(W,O)=>-U(W,O)}t.$9b=Se;class Ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let O=this.c;for(;O<this.g.length&&W(this.g[O]);)O++;const X=O===this.c?null:this.g.slice(this.c,O);return this.c=O,X}takeFromEndWhile(W){let O=this.d;for(;O>=0&&W(this.g[O]);)O--;const X=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const O=this.g.slice(this.c,this.c+W);return this.c+=W,O}}t.$0b=Ie;class Re{static{this.empty=new Re(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(O=>(W(O),!0))}toArray(){const W=[];return this.iterate(O=>(W.push(O),!0)),W}filter(W){return new Re(O=>this.iterate(X=>W(X)?O(X):!0))}map(W){return new Re(O=>this.iterate(X=>O(W(X))))}some(W){let O=!1;return this.iterate(X=>(O=W(X),!O)),O}findFirst(W){let O;return this.iterate(X=>W(X)?(O=X,!1):!0),O}findLast(W){let O;return this.iterate(X=>(W(X)&&(O=X),!0)),O}findLastMaxBy(W){let O,X=!0;return this.iterate(ee=>((X||be.isGreaterThan(W(ee,O)))&&(X=!1,O=ee),!0)),O}}t.$$b=Re}),te(ne[13],re([0,1,3]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yc=t.$xc=t.$wc=t.$vc=t.ok=void 0;function k(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=k;function r(l,s="Unreachable"){throw new Error(s)}t.$vc=r;function c(l){if(!l)throw new D.$ab("Assertion Failed")}t.$wc=c;function N(l){if(!l()){debugger;l(),(0,D.$Y)(new D.$ab("Assertion Failed"))}}t.$xc=N;function o(l,s){let h=0;for(;h<l.length-1;){const E=l[h],d=l[h+1];if(!s(E,d))return!1;h++}return!0}t.$yc=o}),te(ne[20],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function D(k){const r=this;let c=!1,N;return function(){return c||(c=!0,N=k.apply(r,arguments)),N}}t.$bb=D}),te(ne[21],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(k){function r(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}k.is=r;const c=Object.freeze([]);function N(){return c}k.empty=N;function*o(a){yield a}k.single=o;function l(a){return r(a)?a:o(a)}k.wrap=l;function s(a){return a||c}k.from=s;function*h(a){for(let i=a.length-1;i>=0;i--)yield a[i]}k.reverse=h;function E(a){return!a||a[Symbol.iterator]().next().done===!0}k.isEmpty=E;function d(a){return a[Symbol.iterator]().next().value}k.first=d;function g(a,i){for(const u of a)if(i(u))return!0;return!1}k.some=g;function e(a,i){for(const u of a)if(i(u))return u}k.find=e;function*$(a,i){for(const u of a)i(u)&&(yield u)}k.filter=$;function*M(a,i){let u=0;for(const L of a)yield i(L,u++)}k.map=M;function*A(...a){for(const i of a)for(const u of i)yield u}k.concat=A;function f(a,i,u){let L=u;for(const m of a)L=i(L,m);return L}k.reduce=f;function*v(a,i,u=a.length){for(i<0&&(i+=a.length),u<0?u+=a.length:u>a.length&&(u=a.length);i<u;i++)yield a[i]}k.slice=v;function w(a,i=Number.POSITIVE_INFINITY){const u=[];if(i===0)return[u,a];const L=a[Symbol.iterator]();for(let m=0;m<i;m++){const b=L.next();if(b.done)return[u,k.empty()];u.push(b.value)}return[u,{[Symbol.iterator](){return L}}]}k.consume=w})(D||(t.Iterable=D={}))}),te(ne[36],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vq=t.KeyMod=t.KeyCodeUtils=t.$uq=t.$tq=t.$sq=t.$rq=t.$qq=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(D||(t.KeyCode=D={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define($,M){this._keyCodeToStr[$]=M,this._strToKeyCode[M.toLowerCase()]=$}keyCodeToStr($){return this._keyCodeToStr[$]}strToKeyCode($){return this._strToKeyCode[$.toLowerCase()]||0}}const c=new r,N=new r,o=new r;t.$qq=new Array(230),t.$rq={};const l=[],s=Object.create(null),h=Object.create(null);t.$sq={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$tq=[],t.$uq=[];for(let e=0;e<=193;e++)t.$tq[e]=-1;for(let e=0;e<=132;e++)t.$uq[e]=-1;(function(){const e="",$=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],M=[],A=[];for(const f of $){const[v,w,a,i,u,L,m,b,P]=f;if(A[w]||(A[w]=!0,l[w]=a,s[a]=w,h[a.toLowerCase()]=w,v&&(t.$tq[w]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$uq[i]=w))),!M[i]){if(M[i]=!0,!u)throw new Error(`String representation missing for key code ${i} around scan code ${a}`);c.define(i,u),N.define(i,b||u),o.define(i,P||b||u)}L&&(t.$qq[L]=i),m&&(t.$rq[m]=i)}t.$uq[3]=46})();var E;(function(e){function $(a){return c.keyCodeToStr(a)}e.toString=$;function M(a){return c.strToKeyCode(a)}e.fromString=M;function A(a){return N.keyCodeToStr(a)}e.toUserSettingsUS=A;function f(a){return o.keyCodeToStr(a)}e.toUserSettingsGeneral=f;function v(a){return N.strToKeyCode(a)||o.strToKeyCode(a)}e.fromUserSettings=v;function w(a){if(a>=98&&a<=113)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(a)}e.toElectronAccelerator=w})(E||(t.KeyCodeUtils=E={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function g(e,$){const M=($&65535)<<16>>>0;return(e|M)>>>0}t.$vq=g}),te(ne[37],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=D}),te(ne[10],re([0,1,6,19,20,21]),function(j,t,D,k,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=void 0;const N=!1;let o=null;class l{constructor(){this.b=new Map}static{this.a=0}c(R){let S=this.b.get(R);return S||(S={parent:null,source:null,isSingleton:!1,value:R,idx:l.a++},this.b.set(R,S)),S}trackDisposable(R){const S=this.c(R);S.source||(S.source=new Error().stack)}setParent(R,S){const I=this.c(R);I.parent=S}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,S){const I=S.get(R);if(I)return I;const q=R.parent?this.f(this.c(R.parent),S):R;return S.set(R,q),q}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,R).isSingleton).map(([I])=>I).flat()}computeLeakingDisposables(R=10,S){let I;if(S)I=S;else{const H=new Map,C=[...this.b.values()].filter(n=>n.source!==null&&!this.f(n,H).isSingleton);if(C.length===0)return;const J=new Set(C.map(n=>n.value));if(I=C.filter(n=>!(n.parent&&J.has(n.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function q(H){function C(n,ue){for(;n.length>0&&ue.some(oe=>typeof oe=="string"?oe===n[0]:n[0].match(oe));)n.shift()}const J=H.source.split(`
`).map(n=>n.trim().replace("at ","")).filter(n=>n!=="");return C(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const x=new k.$L;for(const H of I){const C=q(H);for(let J=0;J<=C.length;J++)x.add(C.slice(0,J).join(`
`),H)}I.sort((0,D.$5b)(H=>H.idx,D.$7b));let _="",V=0;for(const H of I.slice(0,R)){V++;const C=q(H),J=[];for(let n=0;n<C.length;n++){let ue=C[n];ue=`(shared with ${x.get(C.slice(0,n+1).join(`
`)).size}/${I.length} leaks) at ${ue}`;const $e=x.get(C.slice(0,n).join(`
`)),ve=(0,k.$I)([...$e].map(be=>q(be)[n]),be=>be);delete ve[C[n]];for(const[be,Ee]of Object.entries(ve))J.unshift(`    - stacktraces of ${Ee.length} other leaks continue with ${be}`);J.unshift(ue)}_+=`


==================== Leaking disposable ${V}/${I.length}: ${H.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return I.length>R&&(_+=`


... and ${I.length-R} more leaking disposables

`),{leaks:I,details:_}}}t.$_b=l;function s(F){o=F}if(t.$ac=s,N){const F="__is_disposable_tracked__";s(new class{trackDisposable(R){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[F]||console.log(S)},3e3)}setParent(R,S){if(R&&R!==a.None)try{R[F]=!0}catch{}}markAsDisposed(R){if(R&&R!==a.None)try{R[F]=!0}catch{}}markAsSingleton(R){}})}function h(F){return o?.trackDisposable(F),F}t.$bc=h;function E(F){o?.markAsDisposed(F)}t.$cc=E;function d(F,R){o?.setParent(F,R)}function g(F,R){if(o)for(const S of F)o.setParent(S,R)}function e(F){return o?.markAsSingleton(F),F}t.$dc=e;function $(F){return typeof F.dispose=="function"&&F.dispose.length===0}t.$ec=$;function M(F){if(c.Iterable.is(F)){const R=[];for(const S of F)if(S)try{S.dispose()}catch(I){R.push(I)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}t.$fc=M;function A(F){for(const R of F)$(R)&&R.dispose();return[]}t.$gc=A;function f(...F){const R=v(()=>M(F));return g(F,R),R}t.$hc=f;function v(F){const R=h({dispose:(0,r.$bb)(()=>{E(R),F()})});return R}t.$ic=v;class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{M(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return d(R,this),this.g?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),d(R,null))}}t.$jc=w;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new w,h(this),d(this.q,this)}dispose(){E(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}t.$kc=a;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&d(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&d(R,null),R}}t.$lc=i;class u{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$mc=u;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(R){let S=R;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,E(this))},this}}t.$nc=L;class m{constructor(){this.a=new Map}acquire(R,...S){let I=this.a.get(R);I||(I={counter:0,object:this.b(R,...S)},this.a.set(R,I));const{object:q}=I,x=(0,r.$bb)(()=>{--I.counter===0&&(this.c(R,I.object),this.a.delete(R))});return I.counter++,{object:q,dispose:x}}}t.$oc=m;class b{constructor(R){this.a=R}async acquire(R,...S){const I=this.a.acquire(R,...S);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(q){throw I.dispose(),q}}}t.$pc=b;class P{constructor(R){this.object=R}dispose(){}}t.$qc=P;function p(F){const R=new w;try{F(R)}finally{R.dispose()}}t.$rc=p;class y{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{M(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,S,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(R)?.dispose(),this.a.set(R,S)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$sc=y}),te(ne[22],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=void 0;class D{static{this.Undefined=new D(void 0)}constructor(c){this.element=c,this.next=D.Undefined,this.prev=D.Undefined}}class k{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let c=this.a;for(;c!==D.Undefined;){const N=c.next;c.prev=D.Undefined,c.next=D.Undefined,c=N}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,N){const o=new D(c);if(this.a===D.Undefined)this.a=o,this.b=o;else if(N){const s=this.b;this.b=o,o.prev=s,s.next=o}else{const s=this.a;this.a=o,o.next=s,s.prev=o}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(o))}}shift(){if(this.a!==D.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==D.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==D.Undefined&&c.next!==D.Undefined){const N=c.prev;N.next=c.next,c.next.prev=N}else c.prev===D.Undefined&&c.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):c.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):c.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==D.Undefined;)yield c.element,c=c.next}}t.$tc=k}),te(ne[23],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(c){return new k(c)}constructor(c){this.c=D&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$bd=k}),te(ne[11],re([0,1,3,20,10,22,23]),function(j,t,D,k,r,c,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=t.$nd=t.$md=t.$ld=t.$kd=t.$jd=t.$id=t.$hd=t.$gd=t.$fd=t.$ed=t.$dd=t.Event=void 0;const o=!1,l=!1;var s;(function(F){F.None=()=>r.$kc.None;function R(G){if(l){const{onDidAddListener:Y}=G,Q=e.create();let K=0;G.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),Y?.()}}}function S(G,Y){return ue(G,()=>{},0,void 0,!0,void 0,Y)}F.defer=S;function I(G){return(Y,Q=null,K)=>{let ie=!1,le;return le=G(ce=>{if(!ie)return le?le.dispose():ie=!0,Y.call(Q,ce)},null,K),ie&&le.dispose(),le}}F.once=I;function q(G,Y,Q){return J((K,ie=null,le)=>G(ce=>K.call(ie,Y(ce)),null,le),Q)}F.map=q;function x(G,Y,Q){return J((K,ie=null,le)=>G(ce=>{Y(ce),K.call(ie,ce)},null,le),Q)}F.forEach=x;function _(G,Y,Q){return J((K,ie=null,le)=>G(ce=>Y(ce)&&K.call(ie,ce),null,le),Q)}F.filter=_;function V(G){return G}F.signal=V;function H(...G){return(Y,Q=null,K)=>{const ie=(0,r.$hc)(...G.map(le=>le(ce=>Y.call(Q,ce))));return n(ie,K)}}F.any=H;function C(G,Y,Q,K){let ie=Q;return q(G,le=>(ie=Y(ie,le),ie),K)}F.reduce=C;function J(G,Y){let Q;const K={onWillAddFirstListener(){Q=G(ie.fire,ie)},onDidRemoveLastListener(){Q?.dispose()}};Y||R(K);const ie=new v(K);return Y?.add(ie),ie.event}function n(G,Y){return Y instanceof Array?Y.push(G):Y&&Y.add(G),G}function ue(G,Y,Q=100,K=!1,ie=!1,le,ce){let ge,he,Me,we=0,ye;const Ue={leakWarningThreshold:le,onWillAddFirstListener(){ge=G(Ve=>{we++,he=Y(he,Ve),K&&!Me&&(ke.fire(he),he=void 0),ye=()=>{const Be=he;he=void 0,Me=void 0,(!K||we>1)&&ke.fire(Be),we=0},typeof Q=="number"?(clearTimeout(Me),Me=setTimeout(ye,Q)):Me===void 0&&(Me=0,queueMicrotask(ye))})},onWillRemoveListener(){ie&&we>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ge.dispose()}};ce||R(Ue);const ke=new v(Ue);return ce?.add(ke),ke.event}F.debounce=ue;function oe(G,Y=0,Q){return F.debounce(G,(K,ie)=>K?(K.push(ie),K):[ie],Y,void 0,!0,void 0,Q)}F.accumulate=oe;function $e(G,Y=(K,ie)=>K===ie,Q){let K=!0,ie;return _(G,le=>{const ce=K||!Y(le,ie);return K=!1,ie=le,ce},Q)}F.latch=$e;function ve(G,Y,Q){return[F.filter(G,Y,Q),F.filter(G,K=>!Y(K),Q)]}F.split=ve;function be(G,Y=!1,Q=[],K){let ie=Q.slice(),le=G(he=>{ie?ie.push(he):ge.fire(he)});K&&K.add(le);const ce=()=>{ie?.forEach(he=>ge.fire(he)),ie=null},ge=new v({onWillAddFirstListener(){le||(le=G(he=>ge.fire(he)),K&&K.add(le))},onDidAddFirstListener(){ie&&(Y?setTimeout(ce):ce())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(ge),ge.event}F.buffer=be;function Ee(G,Y){return(K,ie,le)=>{const ce=Y(new _e);return G(function(ge){const he=ce.evaluate(ge);he!==Fe&&K.call(ie,he)},void 0,le)}}F.chain=Ee;const Fe=Symbol("HaltChainable");class _e{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(Q=>(Y(Q),Q)),this}filter(Y){return this.f.push(Q=>Y(Q)?Q:Fe),this}reduce(Y,Q){let K=Q;return this.f.push(ie=>(K=Y(K,ie),K)),this}latch(Y=(Q,K)=>Q===K){let Q=!0,K;return this.f.push(ie=>{const le=Q||!Y(ie,K);return Q=!1,K=ie,le?ie:Fe}),this}evaluate(Y){for(const Q of this.f)if(Y=Q(Y),Y===Fe)break;return Y}}function Te(G,Y,Q=K=>K){const K=(...ge)=>ce.fire(Q(...ge)),ie=()=>G.on(Y,K),le=()=>G.removeListener(Y,K),ce=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ce.event}F.fromNodeEventEmitter=Te;function Se(G,Y,Q=K=>K){const K=(...ge)=>ce.fire(Q(...ge)),ie=()=>G.addEventListener(Y,K),le=()=>G.removeEventListener(Y,K),ce=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ce.event}F.fromDOMEventEmitter=Se;function Ie(G){return new Promise(Y=>I(G)(Y))}F.toPromise=Ie;function Re(G){const Y=new v;return G.then(Q=>{Y.fire(Q)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}F.fromPromise=Re;function U(G,Y){return Y(void 0),G(Q=>Y(Q))}F.runAndSubscribe=U;function W(G,Y){let Q=null;function K(le){Q?.dispose(),Q=new r.$jc,Y(le,Q)}K(void 0);const ie=G(le=>K(le));return(0,r.$ic)(()=>{ie.dispose(),Q?.dispose()})}F.runAndSubscribeWithStore=W;class O{constructor(Y,Q){this._observable=Y,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};Q||R(K),this.emitter=new v(K),Q&&Q.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,Q){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(G,Y){return new O(G,Y).emitter.event}F.fromObservable=X;function ee(G){return Y=>{let Q=0,K=!1;const ie={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(G.reportChanges(),K&&(K=!1,Y()))},handlePossibleChange(){},handleChange(){K=!0}};return G.addObserver(ie),G.reportChanges(),{dispose(){G.removeObserver(ie)}}}}F.fromObservableLight=ee})(s||(t.Event=s={}));class h{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${h.f++}`,h.all.add(this)}start(R){this.g=new N.$bd,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$dd=h;let E=-1;function d(F){const R=E;return E=F,{dispose(){E=R}}}t.$ed=d;class g{constructor(R,S=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=S,this.g=0}dispose(){this.f?.clear()}check(R,S){const I=this.threshold;if(I<=0||S<I)return;this.f||(this.f=new Map);const q=this.f.get(R.value)||0;if(this.f.set(R.value,q+1),this.g-=1,this.g<=0){this.g=I*.5;let x,_=0;for(const[V,H]of this.f)(!x||_<H)&&(x=V,_=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${_}):`),console.warn(x)}return()=>{const x=this.f.get(R.value)||0;this.f.set(R.value,x-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let $=0;class M{constructor(R){this.value=R,this.id=$++}}const A=2,f=(F,R)=>{if(F instanceof M)R(F);else for(let S=0;S<F.length;S++){const I=F[S];I&&R(I)}};class v{constructor(R){this.x=0,this.f=R,this.g=E>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(o){const R=this.t;queueMicrotask(()=>{f(R,S=>S.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,S,I)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$kc.None;if(this.m)return r.$kc.None;S&&(R=R.bind(S));const q=new M(R);let x,_;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),x=this.g.check(q.stack,this.x+1)),o&&(q.stack=_??e.create()),this.t?this.t instanceof M?(this.u??=new a,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.x++;const V=(0,r.$ic)(()=>{x?.(),this.y(q)});return I instanceof r.$jc?I.add(V):Array.isArray(I)&&I.push(V),V},this.q}y(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const S=this.t,I=S.indexOf(R);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,S[I]=void 0;const q=this.u.current===this;if(this.x*A<=S.length){let x=0;for(let _=0;_<S.length;_++)S[_]?S[x++]=S[_]:q&&(this.u.end--,x<this.u.i&&this.u.i--);S.length=x}}z(R,S){if(!R)return;const I=this.f?.onListenerError||D.$Y;if(!I){R.value(S);return}try{R.value(S)}catch(q){I(q)}}A(R){const S=R.current.t;for(;R.i<R.end;)this.z(S[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof M)this.z(this.t,R);else{const S=this.u;S.enqueue(this,R,this.t.length),this.A(S)}this.j?.stop()}hasListeners(){return this.x>0}}t.$fd=v;const w=()=>new a;t.$gd=w;class a{constructor(){this.i=-1,this.end=0}enqueue(R,S,I){this.i=0,this.end=I,this.current=R,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends v{async fireAsync(R,S,I){if(this.t)for(this.h||(this.h=new c.$tc),f(this.t,q=>this.h.push([q.value,R]));this.h.size>0&&!S.isCancellationRequested;){const[q,x]=this.h.shift(),_=[],V={...x,token:S,waitUntil:H=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");I&&(H=I(H,q)),_.push(H)}};try{q(V)}catch(H){(0,D.$Y)(H);continue}Object.freeze(_),await Promise.allSettled(_).then(H=>{for(const C of H)C.status==="rejected"&&(0,D.$Y)(C.reason)})}}}t.$hd=i;class u extends v{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new c.$tc,this.w=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.w(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.x&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$id=u;class L extends u{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$jd=L;class m extends v{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$kd=m;class b{constructor(){this.g=!1,this.h=[],this.f=new v({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const S={event:R,listener:null};this.h.push(S),this.g&&this.m(S);const I=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,r.$ic)((0,k.$bb)(I))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(S=>this.f.fire(S))}o(R){R.listener&&R.listener.dispose(),R.listener=null}dispose(){this.f.dispose()}}t.$ld=b;class P{constructor(R,S,I,q){this.f=new r.$jc;const x=this.f.add(new b),_=this.f.add(new r.$sc);function V(H){_.set(H,x.add(q(H)))}for(const H of R)V(H);this.f.add(S(H=>{V(H)})),this.f.add(I(H=>{_.deleteAndDispose(H)})),this.event=x.event}dispose(){this.f.dispose()}}t.$md=P;class p{constructor(){this.f=[]}wrapEvent(R){return(S,I,q)=>R(x=>{const _=this.f[this.f.length-1];_?_.push(()=>S.call(I,x)):S.call(I,x)},void 0,q)}bufferEvents(R){const S=[];this.f.push(S);const I=R();return this.f.pop(),S.forEach(q=>q()),I}}t.$nd=p;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$kc.None,this.j=new v({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$od=y}),te(ne[24],re([0,1,11]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pd=t.CancellationToken=void 0;const k=Object.freeze(function(o,l){const s=setTimeout(o.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(o){function l(s){return s===o.None||s===o.Cancelled||s instanceof c?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}o.isCancellationToken=l,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(r||(t.CancellationToken=r={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new D.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new c),this.f}cancel(){this.f?this.f instanceof c&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof c&&this.f.dispose():this.f=r.None}}t.$pd=N}),te(ne[38],re([0,1,24]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$je=t.$ie=t.$he=void 0;class k{constructor(o){this.b=o,this.a=null}get(){if(this.a)return this.a;const o=new D.$pd,l=this.b(o.token);return this.a={promise:l,dispose:()=>{this.a=null,o.cancel(),o.dispose()}},this.a}}t.$he=k;class r{constructor(o){this.c=o,this.a=void 0,this.b=void 0}get(o){const l=JSON.stringify(o);return this.b!==l&&(this.b=l,this.a=this.c(o)),this.a}}t.$ie=r;class c{get cachedValues(){return this.a}constructor(o){this.b=o,this.a=new Map}get(o){if(this.a.has(o))return this.a.get(o);const l=this.b(o);return this.a.set(o,l),l}}t.$je=c}),te(ne[7],re([0,1,38,37]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$if=t.$hf=t.$gf=t.$ff=t.GraphemeBreakType=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=void 0;function r(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$me=r;const c=/{(\d+)}/g;function N(T,...B){return B.length===0?T:T.replace(c,function(z,Z){const se=parseInt(Z,10);return isNaN(se)||se<0||se>=B.length?z:B[se]})}t.$ne=N;const o=/{([^}]+)}/g;function l(T,B){return T.replace(o,(z,Z)=>B[Z]??z)}t.$oe=l;function s(T){return T.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$pe=s;function h(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$qe=h;function E(T,B){let z=0;const Z=B.charCodeAt(0);for(let se=T.length-1;se>=0;se--)T.charCodeAt(se)===Z&&z++;return z}t.$re=E;function d(T,B,z="\u2026"){return T.length<=B?T:`${T.substr(0,B)}${z}`}t.$se=d;function g(T,B=" "){const z=e(T,B);return $(z,B)}t.$te=g;function e(T,B){if(!T||!B)return T;const z=B.length;if(z===0||T.length===0)return T;let Z=0;for(;T.indexOf(B,Z)===Z;)Z=Z+z;return T.substring(Z)}t.$ue=e;function $(T,B){if(!T||!B)return T;const z=B.length,Z=T.length;if(z===0||Z===0)return T;let se=Z,ae=-1;for(;ae=T.lastIndexOf(B,se-1),!(ae===-1||ae+z!==se);){if(ae===0)return"";se=ae}return T.substring(0,se)}t.$ve=$;function M(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$we=M;function A(T){return T.replace(/\*/g,"")}t.$xe=A;function f(T,B,z={}){if(!T)throw new Error("Cannot create regex from empty string");B||(T=h(T)),z.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Z="";return z.global&&(Z+="g"),z.matchCase||(Z+="i"),z.multiline&&(Z+="m"),z.unicode&&(Z+="u"),new RegExp(T,Z)}t.$ye=f;function v(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$ze=v;function w(T){return T.split(/\r\n|\r|\n/)}t.$Ae=w;function a(T){for(let B=0,z=T.length;B<z;B++){const Z=T.charCodeAt(B);if(Z!==32&&Z!==9)return B}return-1}t.$Be=a;function i(T,B=0,z=T.length){for(let Z=B;Z<z;Z++){const se=T.charCodeAt(Z);if(se!==32&&se!==9)return T.substring(B,Z)}return T.substring(B,z)}t.$Ce=i;function u(T,B=T.length-1){for(let z=B;z>=0;z--){const Z=T.charCodeAt(z);if(Z!==32&&Z!==9)return z}return-1}t.$De=u;function L(T,B,z){const Z=[];let se=0;for(const ae of T.matchAll(B)){if(Z.push(T.slice(se,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");se=ae.index+ae[0].length,Z.push(z(ae[0],...ae.slice(1),ae.index,T,ae.groups))}return Z.push(T.slice(se)),Promise.all(Z).then(ae=>ae.join(""))}t.$Ee=L;function m(T,B){return T<B?-1:T>B?1:0}t.$Fe=m;function b(T,B,z=0,Z=T.length,se=0,ae=B.length){for(;z<Z&&se<ae;z++,se++){const Le=T.charCodeAt(z),Ne=B.charCodeAt(se);if(Le<Ne)return-1;if(Le>Ne)return 1}const de=Z-z,Pe=ae-se;return de<Pe?-1:de>Pe?1:0}t.$Ge=b;function P(T,B){return p(T,B,0,T.length,0,B.length)}t.$He=P;function p(T,B,z=0,Z=T.length,se=0,ae=B.length){for(;z<Z&&se<ae;z++,se++){let Le=T.charCodeAt(z),Ne=B.charCodeAt(se);if(Le===Ne)continue;if(Le>=128||Ne>=128)return b(T.toLowerCase(),B.toLowerCase(),z,Z,se,ae);F(Le)&&(Le-=32),F(Ne)&&(Ne-=32);const me=Le-Ne;if(me!==0)return me}const de=Z-z,Pe=ae-se;return de<Pe?-1:de>Pe?1:0}t.$Ie=p;function y(T){return T>=48&&T<=57}t.$Je=y;function F(T){return T>=97&&T<=122}t.$Ke=F;function R(T){return T>=65&&T<=90}t.$Le=R;function S(T,B){return T.length===B.length&&p(T,B)===0}t.$Me=S;function I(T,B){const z=B.length;return B.length>T.length?!1:p(T,B,0,z)===0}t.$Ne=I;function q(T,B){const z=Math.min(T.length,B.length);let Z;for(Z=0;Z<z;Z++)if(T.charCodeAt(Z)!==B.charCodeAt(Z))return Z;return z}t.$Oe=q;function x(T,B){const z=Math.min(T.length,B.length);let Z;const se=T.length-1,ae=B.length-1;for(Z=0;Z<z;Z++)if(T.charCodeAt(se-Z)!==B.charCodeAt(ae-Z))return Z;return z}t.$Pe=x;function _(T){return 55296<=T&&T<=56319}t.$Qe=_;function V(T){return 56320<=T&&T<=57343}t.$Re=V;function H(T,B){return(T-55296<<10)+(B-56320)+65536}t.$Se=H;function C(T,B,z){const Z=T.charCodeAt(z);if(_(Z)&&z+1<B){const se=T.charCodeAt(z+1);if(V(se))return H(Z,se)}return Z}t.$Te=C;function J(T,B){const z=T.charCodeAt(B-1);if(V(z)&&B>1){const Z=T.charCodeAt(B-2);if(_(Z))return H(Z,z)}return z}class n{get offset(){return this.e}constructor(B,z=0){this.c=B,this.d=B.length,this.e=z}setOffset(B){this.e=B}prevCodePoint(){const B=J(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=C(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$Ue=n;class ue{get offset(){return this.c.offset}constructor(B,z=0){this.c=new n(B,z)}nextGraphemeLength(){const B=we.getInstance(),z=this.c,Z=z.offset;let se=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ae=z.offset,de=B.getGraphemeBreakType(z.nextCodePoint());if(he(se,de)){z.setOffset(ae);break}se=de}return z.offset-Z}prevGraphemeLength(){const B=we.getInstance(),z=this.c,Z=z.offset;let se=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ae=z.offset,de=B.getGraphemeBreakType(z.prevCodePoint());if(he(de,se)){z.setOffset(ae);break}se=de}return Z-z.offset}eol(){return this.c.eol()}}t.$Ve=ue;function oe(T,B){return new ue(T,B).nextGraphemeLength()}t.$We=oe;function $e(T,B){return new ue(T,B).prevGraphemeLength()}t.$Xe=$e;function ve(T,B){B>0&&V(T.charCodeAt(B))&&B--;const z=B+oe(T,B);return[z-$e(T,z),z]}t.$Ye=ve;function be(T){const B=new ue(T);let z=0;for(;!B.eol();)z++,B.nextGraphemeLength();return z}t.$Ze=be;let Ee;function Fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(T){return Ee||(Ee=Fe()),Ee.test(T)}t.$1e=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(T){return Te.test(T)}t.$2e=Se,t.$3e=/[\u2028\u2029]/;function Ie(T){return t.$3e.test(T)}t.$4e=Ie;function Re(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$5e=Re;function U(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$6e=U;function W(T,B){if(T.length<B)return T;const z=/\b/g;let Z=0;for(;z.test(T)&&!(T.length-z.lastIndex<B);)Z=z.lastIndex,z.lastIndex+=1;return T.substring(Z).replace(/^\s/,"")}t.$7e=W;const O=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,X=/\x1b\].*?\x07/g;function ee(T){return T&&(T=T.replace(O,"").replace(X,"")),T}t.$8e=ee,t.$9e=String.fromCharCode(65279);function G(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$0e=G;function Y(T){return G(T)?T.substr(1):T}t.$$e=Y;function Q(T,B){if(!T||!B||T.length<B.length)return!1;const z=B.length,Z=T.toLowerCase();let se=0,ae=-1;for(;se<z;){const de=Z.indexOf(B[se],ae+1);if(de<0)return!1;ae=de,se++}return!0}t.$_e=Q;function K(T,B=!1){return T?(B&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$af=K;function ie(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$bf=ie;function le(T,B=1){if(B===0)return"";let z=-1;do z=T.indexOf(`
`,z+1),B--;while(B>0&&z>=0);return z===-1?T:(T[z-1]==="\r"&&z--,T.substr(0,z))}t.$cf=le;function ce(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$df=ce;function ge(T){return we.getInstance().getGraphemeBreakType(T)}t.$ef=ge;function he(T,B){return T===0?B!==5&&B!==7:T===2&&B===3?!1:T===4||T===2||T===3||B===4||B===2||B===3?!0:!(T===8&&(B===8||B===9||B===11||B===12)||(T===11||T===9)&&(B===9||B===10)||(T===12||T===10)&&B===10||B===5||B===13||B===7||T===1||T===13&&B===14||T===6&&B===6)}var Me;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(t.GraphemeBreakType=Me={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=ye()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this.d,Z=z.length/3;let se=1;for(;se<=Z;)if(B<z[3*se])se=2*se;else if(B>z[3*se+1])se=2*se+1;else return z[3*se+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(T,B){if(T===0)return 0;const z=ke(T,B);if(z!==void 0)return z;const Z=new n(B,T);return Z.prevCodePoint(),Z.offset}t.$ff=Ue;function ke(T,B){const z=new n(B,T);let Z=z.prevCodePoint();for(;Ve(Z)||Z===65039||Z===8419;){if(z.offset===0)return;Z=z.prevCodePoint()}if(!U(Z))return;let se=z.offset;return se>0&&z.prevCodePoint()===8205&&(se=z.offset),se}function Ve(T){return 127995<=T&&T<=127999}var Be;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.$gf="\xA0";class De{static{this.c=new k.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$ie(B=>{function z(me){const pe=new Map;for(let Ae=0;Ae<me.length;Ae+=2)pe.set(me[Ae],me[Ae+1]);return pe}function Z(me,pe){const Ae=new Map(me);for(const[je,Oe]of pe)Ae.set(je,Oe);return Ae}function se(me,pe){if(!me)return pe;const Ae=new Map;for(const[je,Oe]of me)pe.has(je)&&Ae.set(je,Oe);return Ae}const ae=this.c.value;let de=B.filter(me=>!me.startsWith("_")&&me in ae);de.length===0&&(de=["_default"]);let Pe;for(const me of de){const pe=z(ae[me]);Pe=se(Pe,pe)}const Le=z(ae._common),Ne=Z(Le,Pe);return new De(Ne)})}static getInstance(B){return De.d.get(Array.from(B))}static{this.e=new k.$T(()=>Object.keys(De.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return De.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$hf=De;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(B){return qe.e().has(B)}static get codePoints(){return qe.e()}}t.$if=qe}),te(ne[39],re([0,1,7]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vi=t.$ui=t.$ti=t.$si=t.$ri=t.$qi=t.$pi=void 0;function k(A){return r(A,0)}t.$pi=k;function r(A,f){switch(typeof A){case"object":return A===null?c(349,f):Array.isArray(A)?l(A,f):s(A,f);case"string":return o(A,f);case"boolean":return N(A,f);case"number":return c(A,f);case"undefined":return c(937,f);default:return c(617,f)}}t.$qi=r;function c(A,f){return(f<<5)-f+A|0}t.$ri=c;function N(A,f){return c(A?433:863,f)}function o(A,f){f=c(149417,f);for(let v=0,w=A.length;v<w;v++)f=c(A.charCodeAt(v),f);return f}t.$si=o;function l(A,f){return f=c(104579,f),A.reduce((v,w)=>r(w,v),f)}function s(A,f){return f=c(181387,f),Object.keys(A).sort().reduce((v,w)=>(v=o(w,v),r(A[w],v)),f)}class h{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=r(f,this.g),this.g}}t.$ti=h;var E;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(A,f,v=32){const w=v-f,a=~((1<<w)-1);return(A<<f|(a&A)>>>w)>>>0}function g(A,f=0,v=A.byteLength,w=0){for(let a=0;a<v;a++)A[f+a]=w}function e(A,f,v="0"){for(;A.length<f;)A=v+A;return A}function $(A,f=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),f/4)}t.$ui=$;class M{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const v=f.length;if(v===0)return;const w=this.p;let a=this.r,i=this.u,u,L;for(i!==0?(u=i,L=-1,i=0):(u=f.charCodeAt(0),L=0);;){let m=u;if(D.$Qe(u))if(L+1<v){const b=f.charCodeAt(L+1);D.$Re(b)?(L++,m=D.$Se(u,b)):m=65533}else{i=u;break}else D.$Re(u)&&(m=65533);if(a=this.w(w,a,m),L++,L<v)u=f.charCodeAt(L);else break}this.r=a,this.u=i}w(f,v,w){return w<128?f[v++]=w:w<2048?(f[v++]=192|(w&1984)>>>6,f[v++]=128|(w&63)>>>0):w<65536?(f[v++]=224|(w&61440)>>>12,f[v++]=128|(w&4032)>>>6,f[v++]=128|(w&63)>>>0):(f[v++]=240|(w&1835008)>>>18,f[v++]=128|(w&258048)>>>12,f[v++]=128|(w&4032)>>>6,f[v++]=128|(w&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),$(this.h)+$(this.l)+$(this.m)+$(this.n)+$(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=M.g,v=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,d(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let w=this.h,a=this.l,i=this.m,u=this.n,L=this.o,m,b,P;for(let p=0;p<80;p++)p<20?(m=a&i|~a&u,b=1518500249):p<40?(m=a^i^u,b=1859775393):p<60?(m=a&i|a&u|i&u,b=2400959708):(m=a^i^u,b=3395469782),P=d(w,5)+m+L+b+f.getUint32(p*4,!1)&4294967295,L=u,u=i,i=d(a,30),a=w,w=P;this.h=this.h+w&4294967295,this.l=this.l+a&4294967295,this.m=this.m+i&4294967295,this.n=this.n+u&4294967295,this.o=this.o+L&4294967295}}t.$vi=M}),te(ne[25],re([0,1,35,39]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qs=t.$ps=t.$os=void 0;class r{constructor(d){this.a=d}getElements(){const d=this.a,g=new Int32Array(d.length);for(let e=0,$=d.length;e<$;e++)g[e]=d.charCodeAt(e);return g}}t.$os=r;function c(E,d,g){return new h(new r(E),new r(d)).ComputeDiff(g).changes}t.$ps=c;class N{static Assert(d,g){if(!d)throw new Error(g)}}class o{static Copy(d,g,e,$,M){for(let A=0;A<M;A++)e[$+A]=d[g+A]}static Copy2(d,g,e,$,M){for(let A=0;A<M;A++)e[$+A]=d[g+A]}}var l;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.$ns(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(d,g){this.b=Math.min(this.b,d),this.c=Math.min(this.c,g),this.d++}AddModifiedElement(d,g){this.b=Math.min(this.b,d),this.c=Math.min(this.c,g),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(d,g,e=null){this.a=e,this.b=d,this.c=g;const[$,M,A]=h.o(d),[f,v,w]=h.o(g);this.d=A&&w,this.e=$,this.f=M,this.g=f,this.h=v,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const g=d.getElements();if(h.n(g)){const e=new Int32Array(g.length);for(let $=0,M=g.length;$<M;$++)e[$]=(0,k.$si)(g[$],0);return[g,e,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}p(d,g){return this.f[d]!==this.h[g]?!1:this.d?this.e[d]===this.g[g]:!0}q(d,g){if(!this.p(d,g))return!1;const e=h.r(this.b,d),$=h.r(this.c,g);return e===$}static r(d,g){return typeof d.getStrictElement=="function"?d.getStrictElement(g):null}s(d,g){return this.f[d]!==this.f[g]?!1:this.d?this.e[d]===this.e[g]:!0}u(d,g){return this.h[d]!==this.h[g]?!1:this.d?this.g[d]===this.g[g]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,g,e,$,M){const A=[!1];let f=this.w(d,g,e,$,A);return M&&(f=this.z(f)),{quitEarly:A[0],changes:f}}w(d,g,e,$,M){for(M[0]=!1;d<=g&&e<=$&&this.p(d,e);)d++,e++;for(;g>=d&&$>=e&&this.p(g,$);)g--,$--;if(d>g||e>$){let i;return e<=$?(N.Assert(d===g+1,"originalStart should only be one more than originalEnd"),i=[new D.$ns(d,0,e,$-e+1)]):d<=g?(N.Assert(e===$+1,"modifiedStart should only be one more than modifiedEnd"),i=[new D.$ns(d,g-d+1,e,0)]):(N.Assert(d===g+1,"originalStart should only be one more than originalEnd"),N.Assert(e===$+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const A=[0],f=[0],v=this.y(d,g,e,$,A,f,M),w=A[0],a=f[0];if(v!==null)return v;if(!M[0]){const i=this.w(d,w,e,a,M);let u=[];return M[0]?u=[new D.$ns(w+1,g-(w+1)+1,a+1,$-(a+1)+1)]:u=this.w(w+1,g,a+1,$,M),this.H(i,u)}return[new D.$ns(d,g-d+1,e,$-e+1)]}x(d,g,e,$,M,A,f,v,w,a,i,u,L,m,b,P,p,y){let F=null,R=null,S=new s,I=g,q=e,x=L[0]-P[0]-$,_=-1073741824,V=this.k.length-1;do{const H=x+d;H===I||H<q&&w[H-1]<w[H+1]?(i=w[H+1],m=i-x-$,i<_&&S.MarkNextChange(),_=i,S.AddModifiedElement(i+1,m),x=H+1-d):(i=w[H-1]+1,m=i-x-$,i<_&&S.MarkNextChange(),_=i-1,S.AddOriginalElement(i,m+1),x=H-1-d),V>=0&&(w=this.k[V],d=w[0],I=1,q=w.length-1)}while(--V>=-1);if(F=S.getReverseChanges(),y[0]){let H=L[0]+1,C=P[0]+1;if(F!==null&&F.length>0){const J=F[F.length-1];H=Math.max(H,J.getOriginalEnd()),C=Math.max(C,J.getModifiedEnd())}R=[new D.$ns(H,u-H+1,C,b-C+1)]}else{S=new s,I=A,q=f,x=L[0]-P[0]-v,_=1073741824,V=p?this.m.length-1:this.m.length-2;do{const H=x+M;H===I||H<q&&a[H-1]>=a[H+1]?(i=a[H+1]-1,m=i-x-v,i>_&&S.MarkNextChange(),_=i+1,S.AddOriginalElement(i+1,m+1),x=H+1-M):(i=a[H-1],m=i-x-v,i>_&&S.MarkNextChange(),_=i,S.AddModifiedElement(i+1,m+1),x=H-1-M),V>=0&&(a=this.m[V],M=a[0],I=1,q=a.length-1)}while(--V>=-1);R=S.getChanges()}return this.H(F,R)}y(d,g,e,$,M,A,f){let v=0,w=0,a=0,i=0,u=0,L=0;d--,e--,M[0]=0,A[0]=0,this.k=[],this.m=[];const m=g-d+($-e),b=m+1,P=new Int32Array(b),p=new Int32Array(b),y=$-e,F=g-d,R=d-e,S=g-$,q=(F-y)%2===0;P[y]=d,p[F]=g,f[0]=!1;for(let x=1;x<=m/2+1;x++){let _=0,V=0;a=this.J(y-x,x,y,b),i=this.J(y+x,x,y,b);for(let C=a;C<=i;C+=2){C===a||C<i&&P[C-1]<P[C+1]?v=P[C+1]:v=P[C-1]+1,w=v-(C-y)-R;const J=v;for(;v<g&&w<$&&this.p(v+1,w+1);)v++,w++;if(P[C]=v,v+w>_+V&&(_=v,V=w),!q&&Math.abs(C-F)<=x-1&&v>=p[C])return M[0]=v,A[0]=w,J<=p[C]&&1447>0&&x<=1447+1?this.x(y,a,i,R,F,u,L,S,P,p,v,g,M,w,$,A,q,f):null}const H=(_-d+(V-e)-x)/2;if(this.a!==null&&!this.a(_,H))return f[0]=!0,M[0]=_,A[0]=V,H>0&&1447>0&&x<=1447+1?this.x(y,a,i,R,F,u,L,S,P,p,v,g,M,w,$,A,q,f):(d++,e++,[new D.$ns(d,g-d+1,e,$-e+1)]);u=this.J(F-x,x,F,b),L=this.J(F+x,x,F,b);for(let C=u;C<=L;C+=2){C===u||C<L&&p[C-1]>=p[C+1]?v=p[C+1]-1:v=p[C-1],w=v-(C-F)-S;const J=v;for(;v>d&&w>e&&this.p(v,w);)v--,w--;if(p[C]=v,q&&Math.abs(C-y)<=x&&v<=P[C])return M[0]=v,A[0]=w,J>=P[C]&&1447>0&&x<=1447+1?this.x(y,a,i,R,F,u,L,S,P,p,v,g,M,w,$,A,q,f):null}if(x<=1447){let C=new Int32Array(i-a+2);C[0]=y-a+1,o.Copy2(P,a,C,1,i-a+1),this.k.push(C),C=new Int32Array(L-u+2),C[0]=F-u+1,o.Copy2(p,u,C,1,L-u+1),this.m.push(C)}}return this.x(y,a,i,R,F,u,L,S,P,p,v,g,M,w,$,A,q,f)}z(d){for(let g=0;g<d.length;g++){const e=d[g],$=g<d.length-1?d[g+1].originalStart:this.f.length,M=g<d.length-1?d[g+1].modifiedStart:this.h.length,A=e.originalLength>0,f=e.modifiedLength>0;for(;e.originalStart+e.originalLength<$&&e.modifiedStart+e.modifiedLength<M&&(!A||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!f||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const w=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!w)break;e.originalStart++,e.modifiedStart++}const v=[null];if(g<d.length-1&&this.I(d[g],d[g+1],v)){d[g]=v[0],d.splice(g+1,1),g--;continue}}for(let g=d.length-1;g>=0;g--){const e=d[g];let $=0,M=0;if(g>0){const i=d[g-1];$=i.originalStart+i.originalLength,M=i.modifiedStart+i.modifiedLength}const A=e.originalLength>0,f=e.modifiedLength>0;let v=0,w=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const u=e.originalStart-i,L=e.modifiedStart-i;if(u<$||L<M||A&&!this.s(u,u+e.originalLength)||f&&!this.u(L,L+e.modifiedLength))break;const b=(u===$&&L===M?5:0)+this.G(u,e.originalLength,L,e.modifiedLength);b>w&&(w=b,v=i)}e.originalStart-=v,e.modifiedStart-=v;const a=[null];if(g>0&&this.I(d[g-1],d[g],a)){d[g-1]=a[0],d.splice(g,1),g++;continue}}if(this.d)for(let g=1,e=d.length;g<e;g++){const $=d[g-1],M=d[g],A=M.originalStart-$.originalStart-$.originalLength,f=$.originalStart,v=M.originalStart+M.originalLength,w=v-f,a=$.modifiedStart,i=M.modifiedStart+M.modifiedLength,u=i-a;if(A<5&&w<20&&u<20){const L=this.A(f,w,a,u,A);if(L){const[m,b]=L;(m!==$.originalStart+$.originalLength||b!==$.modifiedStart+$.modifiedLength)&&($.originalLength=m-$.originalStart,$.modifiedLength=b-$.modifiedStart,M.originalStart=m+A,M.modifiedStart=b+A,M.originalLength=v-M.originalStart,M.modifiedLength=i-M.modifiedStart)}}}return d}A(d,g,e,$,M){if(g<M||$<M)return null;const A=d+g-M+1,f=e+$-M+1;let v=0,w=0,a=0;for(let i=d;i<A;i++)for(let u=e;u<f;u++){const L=this.B(i,u,M);L>0&&L>v&&(v=L,w=i,a=u)}return v>0?[w,a]:null}B(d,g,e){let $=0;for(let M=0;M<e;M++){if(!this.p(d+M,g+M))return 0;$+=this.e[d+M].length}return $}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,g){if(this.C(d)||this.C(d-1))return!0;if(g>0){const e=d+g;if(this.C(e-1)||this.C(e))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,g){if(this.E(d)||this.E(d-1))return!0;if(g>0){const e=d+g;if(this.E(e-1)||this.E(e))return!0}return!1}G(d,g,e,$){const M=this.D(d,g)?1:0,A=this.F(e,$)?1:0;return M+A}H(d,g){const e=[];if(d.length===0||g.length===0)return g.length>0?g:d;if(this.I(d[d.length-1],g[0],e)){const $=new Array(d.length+g.length-1);return o.Copy(d,0,$,0,d.length-1),$[d.length-1]=e[0],o.Copy(g,1,$,d.length,g.length-1),$}else{const $=new Array(d.length+g.length);return o.Copy(d,0,$,0,d.length),o.Copy(g,0,$,d.length,g.length),$}}I(d,g,e){if(N.Assert(d.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),N.Assert(d.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=g.originalStart||d.modifiedStart+d.modifiedLength>=g.modifiedStart){const $=d.originalStart;let M=d.originalLength;const A=d.modifiedStart;let f=d.modifiedLength;return d.originalStart+d.originalLength>=g.originalStart&&(M=g.originalStart+g.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=g.modifiedStart&&(f=g.modifiedStart+g.modifiedLength-d.modifiedStart),e[0]=new D.$ns($,M,A,f),!0}else return e[0]=null,!1}J(d,g,e,$){if(d>=0&&d<$)return d;const M=e,A=$-e-1,f=g%2===0;if(d<0){const v=M%2===0;return f===v?0:1}else{const v=A%2===0;return f===v?$-1:$-2}}}t.$qs=h}),te(ne[26],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=void 0;function D(a){return typeof a=="string"}t.$jf=D;function k(a){return Array.isArray(a)&&a.every(i=>D(i))}t.$kf=k;function r(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.$lf=r;function c(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}t.$mf=c;function N(a){return typeof a=="number"&&!isNaN(a)}t.$nf=N;function o(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.$of=o;function l(a){return a===!0||a===!1}t.$pf=l;function s(a){return typeof a>"u"}t.$qf=s;function h(a){return!E(a)}t.$rf=h;function E(a){return s(a)||a===null}t.$sf=E;function d(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$tf=d;function g(a){if(E(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.$uf=g;function e(...a){const i=[];for(let u=0;u<a.length;u++){const L=a[u];if(E(L))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);i.push(L)}return i}t.$vf=e;const $=Object.prototype.hasOwnProperty;function M(a){if(!r(a))return!1;for(const i in a)if($.call(a,i))return!1;return!0}t.$wf=M;function A(a){return typeof a=="function"}t.$xf=A;function f(...a){return a.length>0&&a.every(A)}t.$yf=f;function v(a,i){const u=Math.min(a.length,i.length);for(let L=0;L<u;L++)w(a[L],i[L])}t.$zf=v;function w(a,i){if(D(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(A(i)){try{if(a instanceof i)return}catch{}if(!E(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Af=w}),te(ne[40],re([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=t.$Oj=t.$Nj=void 0;const k=Object.create(null);function r(o,l){if((0,D.$jf)(l)){const s=k[l];if(s===void 0)throw new Error(`${o} references an unknown codicon: ${l}`);l=s}return k[o]=l,{id:o}}function c(){return k}t.$Nj=c;function N(){return Object.values(t.$Pj)}t.$Oj=N,t.$Pj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ne[14],re([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=t.$Vm=void 0;function k(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const f=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([v,w])=>{f[v]=w&&typeof w=="object"?k(w):w}),f}t.$Vm=k;function r(A){if(!A||typeof A!="object")return A;const f=[A];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const w in v)if(c.call(v,w)){const a=v[w];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$mf)(a)&&f.push(a)}}return A}t.$Wm=r;const c=Object.prototype.hasOwnProperty;function N(A,f){return o(A,f,new Set)}t.$Xm=N;function o(A,f,v){if((0,D.$sf)(A))return A;const w=f(A);if(typeof w<"u")return w;if(Array.isArray(A)){const a=[];for(const i of A)a.push(o(i,f,v));return a}if((0,D.$lf)(A)){if(v.has(A))throw new Error("Cannot clone recursive data-structure");v.add(A);const a={};for(const i in A)c.call(A,i)&&(a[i]=o(A[i],f,v));return v.delete(A),a}return A}function l(A,f,v=!0){return(0,D.$lf)(A)?((0,D.$lf)(f)&&Object.keys(f).forEach(w=>{w in A?v&&((0,D.$lf)(A[w])&&(0,D.$lf)(f[w])?l(A[w],f[w],v):A[w]=f[w]):A[w]=f[w]}),A):f}t.$Ym=l;function s(A,f){if(A===f)return!0;if(A==null||f===null||f===void 0||typeof A!=typeof f||typeof A!="object"||Array.isArray(A)!==Array.isArray(f))return!1;let v,w;if(Array.isArray(A)){if(A.length!==f.length)return!1;for(v=0;v<A.length;v++)if(!s(A[v],f[v]))return!1}else{const a=[];for(w in A)a.push(w);a.sort();const i=[];for(w in f)i.push(w);if(i.sort(),!s(a,i))return!1;for(v=0;v<a.length;v++)if(!s(A[a[v]],f[a[v]]))return!1}return!0}t.$Zm=s;function h(A){const f=new Set;return JSON.stringify(A,(v,w)=>{if((0,D.$lf)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return w})}t.$1m=h;function E(A,f){const v=Object.create(null);return!A||!f||Object.keys(f).forEach(a=>{const i=A[a],u=f[a];s(i,u)||(v[a]=u)}),v}t.$2m=E;function d(A,f){const v=f.toLowerCase(),w=Object.keys(A).find(a=>a.toLowerCase()===v);return w?A[w]:A[f]}t.$3m=d;function g(A,f){const v=Object.create(null);for(const[w,a]of Object.entries(A))f(w,a)&&(v[w]=a);return v}t.$4m=g;function e(A){let f=[];for(;Object.prototype!==A;)f=f.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return f}t.$5m=e;function $(A){const f=[];for(const v of e(A))typeof A[v]=="function"&&f.push(v);return f}t.$6m=$;function M(A,f){const v=a=>function(){const i=Array.prototype.slice.call(arguments,0);return f(a,i)},w={};for(const a of A)w[a]=v(a);return w}t.$7m=M}),te(ne[27],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=t.$ke=t.Constants=void 0;var D;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(t.Constants=D={}));function k(c){return c<0?0:c>255?255:c|0}t.$ke=k;function r(c){return c<0?0:c>4294967295?4294967295:c|0}t.$le=r}),te(ne[28],re([0,1,27]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=t.$Hs=void 0;class k{constructor(o){const l=(0,D.$ke)(o);this.c=l,this.a=k.d(l),this.b=new Map}static d(o){const l=new Uint8Array(256);return l.fill(o),l}set(o,l){const s=(0,D.$ke)(l);o>=0&&o<256?this.a[o]=s:this.b.set(o,s)}get(o){return o>=0&&o<256?this.a[o]:this.b.get(o)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Hs=k;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class c{constructor(){this.a=new k(0)}add(o){this.a.set(o,1)}has(o){return this.a.get(o)===1}clear(){return this.a.clear()}}t.$Is=c}),te(ne[4],re([0,1,3]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=t.$rs=void 0;class k{static addRange(N,o){let l=0;for(;l<o.length&&o[l].endExclusive<N.start;)l++;let s=l;for(;s<o.length&&o[s].start<=N.endExclusive;)s++;if(l===s)o.splice(l,0,N);else{const h=Math.min(N.start,o[l].start),E=Math.max(N.endExclusive,o[s-1].endExclusive);o.splice(l,s-l,new k(h,E))}}static tryCreate(N,o){if(!(N>o))return new k(N,o)}static ofLength(N){return new k(0,N)}constructor(N,o){if(this.start=N,this.endExclusive=o,N>o)throw new D.$ab(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new k(this.start+N,this.endExclusive+N)}deltaStart(N){return new k(this.start+N,this.endExclusive)}deltaEnd(N){return new k(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new k(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const o=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);if(o<=l)return new k(o,l)}intersectsOrTouches(N){const o=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);return o<=l}slice(N){return N.slice(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new D.$ab(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new D.$ab(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const o=[];for(let l=this.start;l<this.endExclusive;l++)o.push(N(l));return o}forEach(N){for(let o=this.start;o<this.endExclusive;o++)N(o)}}t.$rs=k;class r{constructor(){this.a=[]}addRange(N){let o=0;for(;o<this.a.length&&this.a[o].endExclusive<N.start;)o++;let l=o;for(;l<this.a.length&&this.a[l].start<=N.endExclusive;)l++;if(o===l)this.a.splice(o,0,N);else{const s=Math.min(N.start,this.a[o].start),h=Math.max(N.endExclusive,this.a[l-1].endExclusive);this.a.splice(o,l-o,new k(s,h))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let o=0;for(;o<this.a.length&&this.a[o].endExclusive<=N.start;)o++;return o<this.a.length&&this.a[o].start<N.endExclusive}intersectWithRange(N){const o=new r;for(const l of this.a){const s=l.intersect(N);s&&o.addRange(s)}return o}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,o)=>N+o.length,0)}}t.$ss=r}),te(ne[5],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$js=void 0;class D{constructor(r,c){this.lineNumber=r,this.column=c}with(r=this.lineNumber,c=this.column){return r===this.lineNumber&&c===this.column?this:new D(r,c)}delta(r=0,c=0){return this.with(this.lineNumber+r,this.column+c)}equals(r){return D.equals(this,r)}static equals(r,c){return!r&&!c?!0:!!r&&!!c&&r.lineNumber===c.lineNumber&&r.column===c.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<c.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,c){return r.lineNumber<c.lineNumber?!0:c.lineNumber<r.lineNumber?!1:r.column<=c.column}static compare(r,c){const N=r.lineNumber|0,o=c.lineNumber|0;if(N===o){const l=r.column|0,s=c.column|0;return l-s}return N-o}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$js=D}),te(ne[2],re([0,1,5]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=void 0;class k{constructor(c,N,o,l){c>o||c===o&&N>l?(this.startLineNumber=o,this.startColumn=l,this.endLineNumber=c,this.endColumn=N):(this.startLineNumber=c,this.startColumn=N,this.endLineNumber=o,this.endColumn=l)}isEmpty(){return k.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return k.containsPosition(this,c)}static containsPosition(c,N){return!(N.lineNumber<c.startLineNumber||N.lineNumber>c.endLineNumber||N.lineNumber===c.startLineNumber&&N.column<c.startColumn||N.lineNumber===c.endLineNumber&&N.column>c.endColumn)}static strictContainsPosition(c,N){return!(N.lineNumber<c.startLineNumber||N.lineNumber>c.endLineNumber||N.lineNumber===c.startLineNumber&&N.column<=c.startColumn||N.lineNumber===c.endLineNumber&&N.column>=c.endColumn)}containsRange(c){return k.containsRange(this,c)}static containsRange(c,N){return!(N.startLineNumber<c.startLineNumber||N.endLineNumber<c.startLineNumber||N.startLineNumber>c.endLineNumber||N.endLineNumber>c.endLineNumber||N.startLineNumber===c.startLineNumber&&N.startColumn<c.startColumn||N.endLineNumber===c.endLineNumber&&N.endColumn>c.endColumn)}strictContainsRange(c){return k.strictContainsRange(this,c)}static strictContainsRange(c,N){return!(N.startLineNumber<c.startLineNumber||N.endLineNumber<c.startLineNumber||N.startLineNumber>c.endLineNumber||N.endLineNumber>c.endLineNumber||N.startLineNumber===c.startLineNumber&&N.startColumn<=c.startColumn||N.endLineNumber===c.endLineNumber&&N.endColumn>=c.endColumn)}plusRange(c){return k.plusRange(this,c)}static plusRange(c,N){let o,l,s,h;return N.startLineNumber<c.startLineNumber?(o=N.startLineNumber,l=N.startColumn):N.startLineNumber===c.startLineNumber?(o=N.startLineNumber,l=Math.min(N.startColumn,c.startColumn)):(o=c.startLineNumber,l=c.startColumn),N.endLineNumber>c.endLineNumber?(s=N.endLineNumber,h=N.endColumn):N.endLineNumber===c.endLineNumber?(s=N.endLineNumber,h=Math.max(N.endColumn,c.endColumn)):(s=c.endLineNumber,h=c.endColumn),new k(o,l,s,h)}intersectRanges(c){return k.intersectRanges(this,c)}static intersectRanges(c,N){let o=c.startLineNumber,l=c.startColumn,s=c.endLineNumber,h=c.endColumn;const E=N.startLineNumber,d=N.startColumn,g=N.endLineNumber,e=N.endColumn;return o<E?(o=E,l=d):o===E&&(l=Math.max(l,d)),s>g?(s=g,h=e):s===g&&(h=Math.min(h,e)),o>s||o===s&&l>h?null:new k(o,l,s,h)}equalsRange(c){return k.equalsRange(this,c)}static equalsRange(c,N){return!c&&!N?!0:!!c&&!!N&&c.startLineNumber===N.startLineNumber&&c.startColumn===N.startColumn&&c.endLineNumber===N.endLineNumber&&c.endColumn===N.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(c){return new D.$js(c.endLineNumber,c.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(c){return new D.$js(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,N){return new k(this.startLineNumber,this.startColumn,c,N)}setStartPosition(c,N){return new k(c,N,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(c){return new k(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(c){return new k(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new k(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,N=c){return new k(c.lineNumber,c.column,N.lineNumber,N.column)}static lift(c){return c?new k(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,N){return!(c.endLineNumber<N.startLineNumber||c.endLineNumber===N.startLineNumber&&c.endColumn<N.startColumn||N.endLineNumber<c.startLineNumber||N.endLineNumber===c.startLineNumber&&N.endColumn<c.startColumn)}static areIntersecting(c,N){return!(c.endLineNumber<N.startLineNumber||c.endLineNumber===N.startLineNumber&&c.endColumn<=N.startColumn||N.endLineNumber<c.startLineNumber||N.endLineNumber===c.startLineNumber&&N.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,N){if(c&&N){const s=c.startLineNumber|0,h=N.startLineNumber|0;if(s===h){const E=c.startColumn|0,d=N.startColumn|0;if(E===d){const g=c.endLineNumber|0,e=N.endLineNumber|0;if(g===e){const $=c.endColumn|0,M=N.endColumn|0;return $-M}return g-e}return E-d}return s-h}return(c?1:0)-(N?1:0)}static compareRangesUsingEnds(c,N){return c.endLineNumber===N.endLineNumber?c.endColumn===N.endColumn?c.startLineNumber===N.startLineNumber?c.startColumn-N.startColumn:c.startLineNumber-N.startLineNumber:c.endColumn-N.endColumn:c.endLineNumber-N.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.$ks=k}),te(ne[41],re([0,1,2]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class k{static insert(c,N){return{range:new D.$ks(c.lineNumber,c.column,c.lineNumber,c.column),text:N,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,N){return{range:c,text:N}}static replaceMove(c,N){return{range:c,text:N,forceMoveMarkers:!0}}}t.$ls=k}),te(ne[12],re([0,1,3,4,2,9]),function(j,t,D,k,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$us=t.$ts=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,h.startLineNumber),new N(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new o(s[0].slice());for(let E=1;E<s.length;E++)h=h.getUnion(new o(s[E].slice()));return h.ranges}static ofLength(s,h){return new N(s,s+h)}static deserialize(s){return new N(s[0],s[1])}constructor(s,h){if(s>h)throw new D.$ab(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),E=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=E)return new N(h,E)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$ks(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$ks(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)h.push(s(E));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new k.$rs(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$ts=N;class o{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,c.$ib)(this.c,d=>d.endLineNumberExclusive>=s.startLineNumber),E=(0,c.$gb)(this.c,d=>d.startLineNumber<=s.endLineNumberExclusive)+1;if(h===E)this.c.splice(h,0,s);else if(h===E-1){const d=this.c[h];this.c[h]=d.join(s)}else{const d=this.c[h].join(this.c[E-1]).join(s);this.c.splice(h,E-h,d)}}contains(s){const h=(0,c.$fb)(this.c,E=>E.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,c.$fb)(this.c,E=>E.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let E=0,d=0,g=null;for(;E<this.c.length||d<s.c.length;){let e=null;if(E<this.c.length&&d<s.c.length){const $=this.c[E],M=s.c[d];$.startLineNumber<M.startLineNumber?(e=$,E++):(e=M,d++)}else E<this.c.length?(e=this.c[E],E++):(e=s.c[d],d++);g===null?g=e:g.endLineNumberExclusive>=e.startLineNumber?g=new N(g.startLineNumber,Math.max(g.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(g),g=e)}return g!==null&&h.push(g),new o(h)}subtractFrom(s){const h=(0,c.$ib)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),E=(0,c.$gb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===E)return new o([s]);const d=[];let g=s.startLineNumber;for(let e=h;e<E;e++){const $=this.c[e];$.startLineNumber>g&&d.push(new N(g,$.startLineNumber)),g=$.endLineNumberExclusive}return g<s.endLineNumberExclusive&&d.push(new N(g,s.endLineNumberExclusive)),new o(d)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let E=0,d=0;for(;E<this.c.length&&d<s.c.length;){const g=this.c[E],e=s.c[d],$=g.intersect(e);$&&!$.isEmpty&&h.push($),g.endLineNumberExclusive<e.endLineNumberExclusive?E++:d++}return new o(h)}getWithDelta(s){return new o(this.c.map(h=>h.delta(s)))}}t.$us=o}),te(ne[42],re([0,1,5,2]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ms=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class c extends k.$ks{constructor(o,l,s,h){super(o,l,s,h),this.selectionStartLineNumber=o,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(o){return c.selectionsEqual(this,o)}static selectionsEqual(o,l){return o.selectionStartLineNumber===l.selectionStartLineNumber&&o.selectionStartColumn===l.selectionStartColumn&&o.positionLineNumber===l.positionLineNumber&&o.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(o,l){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,o,l):new c(o,l,this.startLineNumber,this.startColumn)}getPosition(){return new D.$js(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$js(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(o,l){return this.getDirection()===0?new c(o,l,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,o,l)}static fromPositions(o,l=o){return new c(o.lineNumber,o.column,l.lineNumber,l.column)}static fromRange(o,l){return l===0?new c(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):new c(o.endLineNumber,o.endColumn,o.startLineNumber,o.startColumn)}static liftSelection(o){return new c(o.selectionStartLineNumber,o.selectionStartColumn,o.positionLineNumber,o.positionColumn)}static selectionsArrEqual(o,l){if(o&&!l||!o&&l)return!1;if(!o&&!l)return!0;if(o.length!==l.length)return!1;for(let s=0,h=o.length;s<h;s++)if(!this.selectionsEqual(o[s],l[s]))return!1;return!0}static isISelection(o){return o&&typeof o.selectionStartLineNumber=="number"&&typeof o.selectionStartColumn=="number"&&typeof o.positionLineNumber=="number"&&typeof o.positionColumn=="number"}static createWithDirection(o,l,s,h,E){return E===0?new c(o,l,s,h):new c(s,h,o,l)}}t.$ms=c}),te(ne[43],re([0,1,28]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=t.$Js=t.WordCharacterClass=void 0;var k;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class r extends D.$Hs{constructor(o){super(0);for(let l=0,s=o.length;l<s;l++)this.set(o.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$Js=r;function c(N){const o={};return l=>(o.hasOwnProperty(l)||(o[l]=N(l)),o[l])}t.$Ks=c(N=>new r(N))}),te(ne[29],re([0,1,21,10,22]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zr=t.$Yr=t.$Xr=t.$Wr=t.$Vr=void 0,t.$Vr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(E=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const g of t.$Vr)E.indexOf(g)>=0||(d+="\\"+g);return d+="\\s]+)",new RegExp(d,"g")}t.$Wr=c();function N(E){let d=t.$Wr;if(E&&E instanceof RegExp)if(E.global)d=E;else{let g="g";E.ignoreCase&&(g+="i"),E.multiline&&(g+="m"),E.unicode&&(g+="u"),d=new RegExp(E.source,g)}return d.lastIndex=0,d}t.$Xr=N;const o=new r.$tc;o.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(E){const d=o.unshift(E);return(0,k.$ic)(d)}t.$Yr=l;function s(E,d,g,e,$){if($||($=D.Iterable.first(o)),g.length>$.maxLen){let w=E-$.maxLen/2;return w<0?w=0:e+=w,g=g.substring(w,E+$.maxLen/2),s(E,d,g,e,$)}const M=Date.now(),A=E-1-e;let f=-1,v=null;for(let w=1;!(Date.now()-M>=$.timeBudget);w++){const a=A-$.windowSize*w;d.lastIndex=Math.max(0,a);const i=h(d,g,A,f);if(!i&&v||(v=i,a<=0))break;f=a}if(v){const w={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return d.lastIndex=0,w}return null}t.$Zr=s;function h(E,d,g,e){let $;for(;$=E.exec(d);){const M=$.index||0;if(M<=g&&E.lastIndex>=g)return $;if(e>0&&M>e)return null}return null}}),te(ne[8],re([0,1,6,3,4]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NY=t.$MY=t.$LY=t.$KY=t.$JY=void 0;class c{static trivial(E,d){return new c([new N(r.$rs.ofLength(E.length),r.$rs.ofLength(d.length))],!1)}static trivialTimedOut(E,d){return new c([new N(r.$rs.ofLength(E.length),r.$rs.ofLength(d.length))],!0)}constructor(E,d){this.diffs=E,this.hitTimeout=d}}t.$JY=c;class N{static invert(E,d){const g=[];return(0,D.$zb)(E,(e,$)=>{g.push(N.fromOffsetPairs(e?e.getEndExclusives():o.zero,$?$.getStarts():new o(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),g}static fromOffsetPairs(E,d){return new N(new r.$rs(E.offset1,d.offset1),new r.$rs(E.offset2,d.offset2))}constructor(E,d){this.seq1Range=E,this.seq2Range=d}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new N(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new N(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new N(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new N(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const d=this.seq1Range.intersect(E.seq1Range),g=this.seq2Range.intersect(E.seq2Range);if(!(!d||!g))return new N(d,g)}getStarts(){return new o(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new o(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$KY=N;class o{static{this.zero=new o(0,0)}static{this.max=new o(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,d){this.offset1=E,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$LY=o;class l{static{this.instance=new l}isValid(){return!0}}t.$MY=l;class s{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new k.$ab("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$NY=s}),te(ne[30],re([0,1,4,8]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SY=void 0;class r{compute(s,h,E=k.$MY.instance){if(s.length===0||h.length===0)return k.$JY.trivial(s,h);const d=s,g=h;function e(u,L){for(;u<d.length&&L<g.length&&d.getElement(u)===g.getElement(L);)u++,L++;return u}let $=0;const M=new N;M.set(0,e(0,0));const A=new o;A.set(0,M.get(0)===0?null:new c(null,0,0,M.get(0)));let f=0;e:for(;;){if($++,!E.isValid())return k.$JY.trivialTimedOut(d,g);const u=-Math.min($,g.length+$%2),L=Math.min($,d.length+$%2);for(f=u;f<=L;f+=2){let m=0;const b=f===L?-1:M.get(f+1),P=f===u?-1:M.get(f-1)+1;m++;const p=Math.min(Math.max(b,P),d.length),y=p-f;if(m++,p>d.length||y>g.length)continue;const F=e(p,y);M.set(f,F);const R=p===b?A.get(f+1):A.get(f-1);if(A.set(f,F!==p?new c(R,p,y,F-p):R),M.get(f)===d.length&&M.get(f)-f===g.length)break e}}let v=A.get(f);const w=[];let a=d.length,i=g.length;for(;;){const u=v?v.x+v.length:0,L=v?v.y+v.length:0;if((u!==a||L!==i)&&w.push(new k.$KY(new D.$rs(u,a),new D.$rs(L,i))),!v)break;a=v.x,i=v.y,v=v.prev}return w.reverse(),new k.$JY(w,!1)}}t.$SY=r;class c{constructor(s,h,E,d){this.prev=s,this.x=h,this.y=E,this.length=d}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[s]=h}else{if(s>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[s]=h}}}class o{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(ne[44],re([0,1,6,4,8]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Y=t.$ZY=t.$YY=t.$XY=t.$WY=void 0;function c(e,$,M){let A=M;return A=N(e,$,A),A=o(e,$,A),A}t.$WY=c;function N(e,$,M){if(M.length===0)return M;const A=[];A.push(M[0]);for(let v=1;v<M.length;v++){const w=A[A.length-1];let a=M[v];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=a.seq1Range.start-w.seq1Range.endExclusive;let u;for(u=1;u<=i&&!(e.getElement(a.seq1Range.start-u)!==e.getElement(a.seq1Range.endExclusive-u)||$.getElement(a.seq2Range.start-u)!==$.getElement(a.seq2Range.endExclusive-u));u++);if(u--,u===i){A[A.length-1]=new r.$KY(new k.$rs(w.seq1Range.start,a.seq1Range.endExclusive-i),new k.$rs(w.seq2Range.start,a.seq2Range.endExclusive-i));continue}a=a.delta(-u)}A.push(a)}const f=[];for(let v=0;v<A.length-1;v++){const w=A[v+1];let a=A[v];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=w.seq1Range.start-a.seq1Range.endExclusive;let u;for(u=0;u<i&&!(e.getElement(a.seq1Range.start+u)!==e.getElement(a.seq1Range.endExclusive+u)||$.getElement(a.seq2Range.start+u)!==$.getElement(a.seq2Range.endExclusive+u));u++);if(u===i){A[v+1]=new r.$KY(new k.$rs(a.seq1Range.start+i,w.seq1Range.endExclusive),new k.$rs(a.seq2Range.start+i,w.seq2Range.endExclusive));continue}u>0&&(a=a.delta(u))}f.push(a)}return A.length>0&&f.push(A[A.length-1]),f}function o(e,$,M){if(!e.getBoundaryScore||!$.getBoundaryScore)return M;for(let A=0;A<M.length;A++){const f=A>0?M[A-1]:void 0,v=M[A],w=A+1<M.length?M[A+1]:void 0,a=new k.$rs(f?f.seq1Range.start+1:0,w?w.seq1Range.endExclusive-1:e.length),i=new k.$rs(f?f.seq2Range.start+1:0,w?w.seq2Range.endExclusive-1:$.length);v.seq1Range.isEmpty?M[A]=l(v,e,$,a,i):v.seq2Range.isEmpty&&(M[A]=l(v.swap(),$,e,i,a).swap())}return M}function l(e,$,M,A,f){let w=1;for(;e.seq1Range.start-w>=A.start&&e.seq2Range.start-w>=f.start&&M.isStronglyEqual(e.seq2Range.start-w,e.seq2Range.endExclusive-w)&&w<100;)w++;w--;let a=0;for(;e.seq1Range.start+a<A.endExclusive&&e.seq2Range.endExclusive+a<f.endExclusive&&M.isStronglyEqual(e.seq2Range.start+a,e.seq2Range.endExclusive+a)&&a<100;)a++;if(w===0&&a===0)return e;let i=0,u=-1;for(let L=-w;L<=a;L++){const m=e.seq2Range.start+L,b=e.seq2Range.endExclusive+L,P=e.seq1Range.start+L,p=$.getBoundaryScore(P)+M.getBoundaryScore(m)+M.getBoundaryScore(b);p>u&&(u=p,i=L)}return e.delta(i)}function s(e,$,M){const A=[];for(const f of M){const v=A[A.length-1];if(!v){A.push(f);continue}f.seq1Range.start-v.seq1Range.endExclusive<=2||f.seq2Range.start-v.seq2Range.endExclusive<=2?A[A.length-1]=new r.$KY(v.seq1Range.join(f.seq1Range),v.seq2Range.join(f.seq2Range)):A.push(f)}return A}t.$XY=s;function h(e,$,M){const A=[];let f;function v(){if(!f)return;const a=f.s1Range.length-f.deleted,i=f.s2Range.length-f.added;Math.max(f.deleted,f.added)+(f.count-1)>a&&A.push(new r.$KY(f.s1Range,f.s2Range)),f=void 0}for(const a of M){let i=function(P,p){if(!f||!f.s1Range.containsRange(P)||!f.s2Range.containsRange(p))if(f&&!(f.s1Range.endExclusive<P.start&&f.s2Range.endExclusive<p.start)){const R=k.$rs.tryCreate(f.s1Range.endExclusive,P.start),S=k.$rs.tryCreate(f.s2Range.endExclusive,p.start);f.deleted+=R?.length??0,f.added+=S?.length??0,f.s1Range=f.s1Range.join(P),f.s2Range=f.s2Range.join(p)}else v(),f={added:0,deleted:0,count:0,s1Range:P,s2Range:p};const y=P.intersect(a.seq1Range),F=p.intersect(a.seq2Range);f.count++,f.deleted+=y?.length??0,f.added+=F?.length??0};const u=e.findWordContaining(a.seq1Range.start-1),L=$.findWordContaining(a.seq2Range.start-1),m=e.findWordContaining(a.seq1Range.endExclusive),b=$.findWordContaining(a.seq2Range.endExclusive);u&&m&&L&&b&&u.equals(m)&&L.equals(b)?i(u,L):(u&&L&&i(u,L),m&&b&&i(m,b))}return v(),E(M,A)}t.$YY=h;function E(e,$){const M=[];for(;e.length>0||$.length>0;){const A=e[0],f=$[0];let v;A&&(!f||A.seq1Range.start<f.seq1Range.start)?v=e.shift():v=$.shift(),M.length>0&&M[M.length-1].seq1Range.endExclusive>=v.seq1Range.start?M[M.length-1]=M[M.length-1].join(v):M.push(v)}return M}function d(e,$,M){let A=M;if(A.length===0)return A;let f=0,v;do{v=!1;const w=[A[0]];for(let a=1;a<A.length;a++){let L=function(b,P){const p=new k.$rs(u.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(b.seq1Range.length+b.seq2Range.length>5||P.seq1Range.length+P.seq2Range.length>5)};const i=A[a],u=w[w.length-1];L(u,i)?(v=!0,w[w.length-1]=w[w.length-1].join(i)):w.push(i)}A=w}while(f++<10&&v);return A}t.$ZY=d;function g(e,$,M){let A=M;if(A.length===0)return A;let f=0,v;do{v=!1;const a=[A[0]];for(let i=1;i<A.length;i++){let m=function(P,p){const y=new k.$rs(L.seq1Range.endExclusive,u.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const R=e.getText(y).trim();if(R.length>20||R.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(P.seq1Range),I=P.seq1Range.length,q=$.countLinesIn(P.seq2Range),x=P.seq2Range.length,_=e.countLinesIn(p.seq1Range),V=p.seq1Range.length,H=$.countLinesIn(p.seq2Range),C=p.seq2Range.length,J=2*40+50;function n(ue){return Math.min(ue,J)}return Math.pow(Math.pow(n(S*40+I),1.5)+Math.pow(n(q*40+x),1.5),1.5)+Math.pow(Math.pow(n(_*40+V),1.5)+Math.pow(n(H*40+C),1.5),1.5)>(J**1.5)**1.5*1.3};const u=A[i],L=a[a.length-1];m(L,u)?(v=!0,a[a.length-1]=a[a.length-1].join(u)):a.push(u)}A=a}while(f++<10&&v);const w=[];return(0,D.$Ab)(A,(a,i,u)=>{let L=i;function m(R){return R.length>0&&R.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const b=e.extendToFullLines(i.seq1Range),P=e.getText(new k.$rs(b.start,i.seq1Range.start));m(P)&&(L=L.deltaStart(-P.length));const p=e.getText(new k.$rs(i.seq1Range.endExclusive,b.endExclusive));m(p)&&(L=L.deltaEnd(p.length));const y=r.$KY.fromOffsetPairs(a?a.getEndExclusives():r.$LY.zero,u?u.getStarts():r.$LY.max),F=L.intersect(y);w.push(F)}),w}t.$1Y=g}),te(ne[45],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VY=void 0;class D{constructor(c,N){this.a=c,this.b=N}getElement(c){return this.a[c]}get length(){return this.a.length}getBoundaryScore(c){const N=c===0?0:k(this.b[c-1]),o=c===this.b.length?0:k(this.b[c]);return 1e3-(N+o)}getText(c){return this.b.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,N){return this.b[c]===this.b[N]}}t.$VY=D;function k(r){let c=0;for(;c<r.length&&(r.charCodeAt(c)===32||r.charCodeAt(c)===9);)c++;return c}}),te(ne[15],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QY=t.$PY=t.$OY=void 0;class D{constructor(N,o){this.width=N,this.height=o,this.a=[],this.a=new Array(N*o)}get(N,o){return this.a[N+o*this.width]}set(N,o,l){this.a[N+o*this.width]=l}}t.$OY=D;function k(c){return c===32||c===9}t.$PY=k;class r{static{this.a=new Map}static b(N){let o=this.a.get(N);return o===void 0&&(o=this.a.size,this.a.set(N,o)),o}constructor(N,o,l){this.range=N,this.lines=o,this.source=l,this.d=[];let s=0;for(let h=N.startLineNumber-1;h<N.endLineNumberExclusive-1;h++){const E=o[h];for(let g=0;g<E.length;g++){s++;const e=E[g],$=r.b(e);this.d[$]=(this.d[$]||0)+1}s++;const d=r.b(`
`);this.d[d]=(this.d[d]||0)+1}this.c=s}computeSimilarity(N){let o=0;const l=Math.max(this.d.length,N.d.length);for(let s=0;s<l;s++)o+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-o/(this.c+N.c)}}t.$QY=r}),te(ne[46],re([0,1,4,8,15]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RY=void 0;class c{compute(o,l,s=k.$MY.instance,h){if(o.length===0||l.length===0)return k.$JY.trivial(o,l);const E=new r.$OY(o.length,l.length),d=new r.$OY(o.length,l.length),g=new r.$OY(o.length,l.length);for(let w=0;w<o.length;w++)for(let a=0;a<l.length;a++){if(!s.isValid())return k.$JY.trivialTimedOut(o,l);const i=w===0?0:E.get(w-1,a),u=a===0?0:E.get(w,a-1);let L;o.getElement(w)===l.getElement(a)?(w===0||a===0?L=0:L=E.get(w-1,a-1),w>0&&a>0&&d.get(w-1,a-1)===3&&(L+=g.get(w-1,a-1)),L+=h?h(w,a):1):L=-1;const m=Math.max(i,u,L);if(m===L){const b=w>0&&a>0?g.get(w-1,a-1):0;g.set(w,a,b+1),d.set(w,a,3)}else m===i?(g.set(w,a,0),d.set(w,a,1)):m===u&&(g.set(w,a,0),d.set(w,a,2));E.set(w,a,m)}const e=[];let $=o.length,M=l.length;function A(w,a){(w+1!==$||a+1!==M)&&e.push(new k.$KY(new D.$rs(w+1,$),new D.$rs(a+1,M))),$=w,M=a}let f=o.length-1,v=l.length-1;for(;f>=0&&v>=0;)d.get(f,v)===3?(A(f,v),f--,v--):d.get(f,v)===1?f--:v--;return A(-1,-1),e.reverse(),new k.$JY(e,!1)}}t.$RY=c}),te(ne[31],re([0,1,9,4,5,2,15]),function(j,t,D,k,r,c,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TY=void 0;class o{constructor(e,$,M){this.lines=e,this.considerWhitespaceChanges=M,this.b=[],this.c=[],this.d=[];let A=!1;$.start>0&&$.endExclusive>=e.length&&($=new k.$rs($.start-1,$.endExclusive),A=!0),this.lineRange=$,this.c[0]=0;for(let f=this.lineRange.start;f<this.lineRange.endExclusive;f++){let v=e[f],w=0;if(A)w=v.length,v="",A=!1;else if(!M){const a=v.trimStart();w=v.length-a.length,v=a.trimEnd()}this.d.push(w);for(let a=0;a<v.length;a++)this.b.push(v.charCodeAt(a));f<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[f-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new k.$rs(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map($=>String.fromCharCode($)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const $=d(e>0?this.b[e-1]:-1),M=d(e<this.b.length?this.b[e]:-1);if($===6&&M===7)return 0;let A=0;return $!==M&&(A+=10,$===0&&M===1&&(A+=1)),A+=E($),A+=E(M),A}translateOffset(e){if(this.lineRange.isEmpty)return new r.$js(this.lineRange.start+1,1);const $=(0,D.$gb)(this.c,M=>M<=e);return new r.$js(this.lineRange.start+$+1,e-this.c[$]+this.d[$]+1)}translateRange(e){return c.$ks.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let $=e;for(;$>0&&l(this.b[$-1]);)$--;let M=e;for(;M<this.b.length&&l(this.b[M]);)M++;return new k.$rs($,M)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,$){return this.b[e]===this.b[$]}extendToFullLines(e){const $=(0,D.$fb)(this.c,A=>A<=e.start)??0,M=(0,D.$hb)(this.c,A=>e.endExclusive<=A)??this.b.length;return new k.$rs($,M)}}t.$TY=o;function l(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}var s;(function(g){g[g.WordLower=0]="WordLower",g[g.WordUpper=1]="WordUpper",g[g.WordNumber=2]="WordNumber",g[g.End=3]="End",g[g.Other=4]="Other",g[g.Space=5]="Space",g[g.LineBreakCR=6]="LineBreakCR",g[g.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const h={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function E(g){return h[g]}function d(g){return g===10?7:g===13?6:(0,N.$PY)(g)?5:g>=97&&g<=122?0:g>=65&&g<=90?1:g>=48&&g<=57?2:g===-1?3:4}}),te(ne[32],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=t.$ys=void 0;class D{constructor(c,N,o){this.changes=c,this.moves=N,this.hitTimeout=o}}t.$ys=D;class k{constructor(c,N){this.lineRangeMapping=c,this.changes=N}flip(){return new k(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.$zs=k}),te(ne[16],re([0,1,12]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=t.$ws=t.$vs=void 0;class k{static inverse(o,l,s){const h=[];let E=1,d=1;for(const e of o){const $=new r(new D.$ts(E,e.original.startLineNumber),new D.$ts(d,e.modified.startLineNumber),void 0);$.modified.isEmpty||h.push($),E=e.original.endLineNumberExclusive,d=e.modified.endLineNumberExclusive}const g=new r(new D.$ts(E,l+1),new D.$ts(d,s+1),void 0);return g.modified.isEmpty||h.push(g),h}constructor(o,l){this.original=o,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new k(this.modified,this.original)}join(o){return new k(this.original.join(o.original),this.modified.join(o.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$vs=k;class r extends k{constructor(o,l,s){super(o,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(o=>o.flip()))}}t.$ws=r;class c{constructor(o,l){this.originalRange=o,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}t.$xs=c}),te(ne[47],re([0,1,8,16,6,9,19,12,4,31,15,30]),function(j,t,D,k,r,c,N,o,l,s,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UY=void 0;function d(f,v,w,a,i,u){let{moves:L,excludedChanges:m}=g(f,v,w,u);if(!u.isValid())return[];const b=f.filter(p=>!m.has(p)),P=e(b,a,i,v,w,u);return(0,r.$Yb)(L,P),L=M(L),L=L.filter(p=>p.original.toOffsetRange().slice(v).map(F=>F.trim()).join(`
`).length>=10),L=A(f,L),L}t.$UY=d;function g(f,v,w,a){const i=[],u=f.filter(b=>b.modified.isEmpty&&b.original.length>=3).map(b=>new h.$QY(b.original,v,b)),L=new Set(f.filter(b=>b.original.isEmpty&&b.modified.length>=3).map(b=>new h.$QY(b.modified,w,b))),m=new Set;for(const b of u){let P=-1,p;for(const y of L){const F=b.computeSimilarity(y);F>P&&(P=F,p=y)}if(P>.9&&p&&(L.delete(p),i.push(new k.$vs(b.range,p.range)),m.add(b.source),m.add(p.source)),!a.isValid())return{moves:i,excludedChanges:m}}return{moves:i,excludedChanges:m}}function e(f,v,w,a,i,u){const L=[],m=new N.$L;for(const F of f)for(let R=F.original.startLineNumber;R<F.original.endLineNumberExclusive-2;R++){const S=`${v[R-1]}:${v[R+1-1]}:${v[R+2-1]}`;m.add(S,{range:new o.$ts(R,R+3)})}const b=[];f.sort((0,r.$5b)(F=>F.modified.startLineNumber,r.$7b));for(const F of f){let R=[];for(let S=F.modified.startLineNumber;S<F.modified.endLineNumberExclusive-2;S++){const I=`${w[S-1]}:${w[S+1-1]}:${w[S+2-1]}`,q=new o.$ts(S,S+3),x=[];m.forEach(I,({range:_})=>{for(const H of R)if(H.originalLineRange.endLineNumberExclusive+1===_.endLineNumberExclusive&&H.modifiedLineRange.endLineNumberExclusive+1===q.endLineNumberExclusive){H.originalLineRange=new o.$ts(H.originalLineRange.startLineNumber,_.endLineNumberExclusive),H.modifiedLineRange=new o.$ts(H.modifiedLineRange.startLineNumber,q.endLineNumberExclusive),x.push(H);return}const V={modifiedLineRange:q,originalLineRange:_};b.push(V),x.push(V)}),R=x}if(!u.isValid())return[]}b.sort((0,r.$9b)((0,r.$5b)(F=>F.modifiedLineRange.length,r.$7b)));const P=new o.$us,p=new o.$us;for(const F of b){const R=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,S=P.subtractFrom(F.modifiedLineRange),I=p.subtractFrom(F.originalLineRange).getWithDelta(R),q=S.getIntersection(I);for(const x of q.ranges){if(x.length<3)continue;const _=x,V=x.delta(-R);L.push(new k.$vs(V,_)),P.addRange(_),p.addRange(V)}}L.sort((0,r.$5b)(F=>F.original.startLineNumber,r.$7b));const y=new c.$kb(f);for(let F=0;F<L.length;F++){const R=L[F],S=y.findLastMonotonous(J=>J.original.startLineNumber<=R.original.startLineNumber),I=(0,c.$fb)(f,J=>J.modified.startLineNumber<=R.modified.startLineNumber),q=Math.max(R.original.startLineNumber-S.original.startLineNumber,R.modified.startLineNumber-I.modified.startLineNumber),x=y.findLastMonotonous(J=>J.original.startLineNumber<R.original.endLineNumberExclusive),_=(0,c.$fb)(f,J=>J.modified.startLineNumber<R.modified.endLineNumberExclusive),V=Math.max(x.original.endLineNumberExclusive-R.original.endLineNumberExclusive,_.modified.endLineNumberExclusive-R.modified.endLineNumberExclusive);let H;for(H=0;H<q;H++){const J=R.original.startLineNumber-H-1,n=R.modified.startLineNumber-H-1;if(J>a.length||n>i.length||P.contains(n)||p.contains(J)||!$(a[J-1],i[n-1],u))break}H>0&&(p.addRange(new o.$ts(R.original.startLineNumber-H,R.original.startLineNumber)),P.addRange(new o.$ts(R.modified.startLineNumber-H,R.modified.startLineNumber)));let C;for(C=0;C<V;C++){const J=R.original.endLineNumberExclusive+C,n=R.modified.endLineNumberExclusive+C;if(J>a.length||n>i.length||P.contains(n)||p.contains(J)||!$(a[J-1],i[n-1],u))break}C>0&&(p.addRange(new o.$ts(R.original.endLineNumberExclusive,R.original.endLineNumberExclusive+C)),P.addRange(new o.$ts(R.modified.endLineNumberExclusive,R.modified.endLineNumberExclusive+C))),(H>0||C>0)&&(L[F]=new k.$vs(new o.$ts(R.original.startLineNumber-H,R.original.endLineNumberExclusive+C),new o.$ts(R.modified.startLineNumber-H,R.modified.endLineNumberExclusive+C)))}return L}function $(f,v,w){if(f.trim()===v.trim())return!0;if(f.length>300&&v.length>300)return!1;const i=new E.$SY().compute(new s.$TY([f],new l.$rs(0,1),!1),new s.$TY([v],new l.$rs(0,1),!1),w);let u=0;const L=D.$KY.invert(i.diffs,f.length);for(const p of L)p.seq1Range.forEach(y=>{(0,h.$PY)(f.charCodeAt(y))||u++});function m(p){let y=0;for(let F=0;F<f.length;F++)(0,h.$PY)(p.charCodeAt(F))||y++;return y}const b=m(f.length>v.length?f:v);return u/b>.6&&b>10}function M(f){if(f.length===0)return f;f.sort((0,r.$5b)(w=>w.original.startLineNumber,r.$7b));const v=[f[0]];for(let w=1;w<f.length;w++){const a=v[v.length-1],i=f[w],u=i.original.startLineNumber-a.original.endLineNumberExclusive,L=i.modified.startLineNumber-a.modified.endLineNumberExclusive;if(u>=0&&L>=0&&u+L<=2){v[v.length-1]=a.join(i);continue}v.push(i)}return v}function A(f,v){const w=new c.$kb(f);return v=v.filter(a=>{const i=w.findLastMonotonous(b=>b.original.endLineNumberExclusive<=a.original.startLineNumber)||new k.$vs(new o.$ts(1,1),new o.$ts(1,1)),u=a.modified.startLineNumber-i.modified.endLineNumberExclusive,L=a.original.startLineNumber-i.original.endLineNumberExclusive;return u!==L}),v}}),te(ne[48],re([0,1,6,13,12,4,2,8,46,30,47,44,32,16,31,45]),function(j,t,D,k,r,c,N,o,l,s,h,E,d,g,e,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Y=t.$3Y=t.$2Y=void 0;class M{constructor(){this.e=new l.$RY,this.f=new s.$SY}computeDiff(w,a,i){if(w.length<=1&&(0,D.$sb)(w,a,(J,n)=>J===n))return new d.$ys([],[],!1);if(w.length===1&&w[0].length===0||a.length===1&&a[0].length===0)return new d.$ys([new g.$ws(new r.$ts(1,w.length+1),new r.$ts(1,a.length+1),[new g.$xs(new N.$ks(1,1,w.length,w[0].length+1),new N.$ks(1,1,a.length,a[0].length+1))])],[],!1);const u=i.maxComputationTimeMs===0?o.$MY.instance:new o.$NY(i.maxComputationTimeMs),L=!i.ignoreTrimWhitespace,m=new Map;function b(J){let n=m.get(J);return n===void 0&&(n=m.size,m.set(J,n)),n}const P=w.map(J=>b(J.trim())),p=a.map(J=>b(J.trim())),y=new $.$VY(P,w),F=new $.$VY(p,a),R=(()=>y.length+F.length<1700?this.e.compute(y,F,u,(J,n)=>w[J]===a[n]?a[n].length===0?.1:1+Math.log(1+a[n].length):.99):this.f.compute(y,F))();let S=R.diffs,I=R.hitTimeout;S=(0,E.$WY)(y,F,S),S=(0,E.$ZY)(y,F,S);const q=[],x=J=>{if(L)for(let n=0;n<J;n++){const ue=_+n,oe=V+n;if(w[ue]!==a[oe]){const $e=this.j(w,a,new o.$KY(new c.$rs(ue,ue+1),new c.$rs(oe,oe+1)),u,L);for(const ve of $e.mappings)q.push(ve);$e.hitTimeout&&(I=!0)}}};let _=0,V=0;for(const J of S){(0,k.$xc)(()=>J.seq1Range.start-_===J.seq2Range.start-V);const n=J.seq1Range.start-_;x(n),_=J.seq1Range.endExclusive,V=J.seq2Range.endExclusive;const ue=this.j(w,a,J,u,L);ue.hitTimeout&&(I=!0);for(const oe of ue.mappings)q.push(oe)}x(w.length-_);const H=A(q,w,a);let C=[];return i.computeMoves&&(C=this.h(H,w,a,P,p,u,L)),(0,k.$xc)(()=>{function J(ue,oe){if(ue.lineNumber<1||ue.lineNumber>oe.length)return!1;const $e=oe[ue.lineNumber-1];return!(ue.column<1||ue.column>$e.length+1)}function n(ue,oe){return!(ue.startLineNumber<1||ue.startLineNumber>oe.length+1||ue.endLineNumberExclusive<1||ue.endLineNumberExclusive>oe.length+1)}for(const ue of H){if(!ue.innerChanges)return!1;for(const oe of ue.innerChanges)if(!(J(oe.modifiedRange.getStartPosition(),a)&&J(oe.modifiedRange.getEndPosition(),a)&&J(oe.originalRange.getStartPosition(),w)&&J(oe.originalRange.getEndPosition(),w)))return!1;if(!n(ue.modified,a)||!n(ue.original,w))return!1}return!0}),new d.$ys(H,C,I)}h(w,a,i,u,L,m,b){return(0,h.$UY)(w,a,i,u,L,m).map(y=>{const F=this.j(a,i,new o.$KY(y.original.toOffsetRange(),y.modified.toOffsetRange()),m,b),R=A(F.mappings,a,i,!0);return new d.$zs(y,R)})}j(w,a,i,u,L){const m=new e.$TY(w,i.seq1Range,L),b=new e.$TY(a,i.seq2Range,L),P=m.length+b.length<500?this.e.compute(m,b,u):this.f.compute(m,b,u);let p=P.diffs;return p=(0,E.$WY)(m,b,p),p=(0,E.$YY)(m,b,p),p=(0,E.$XY)(m,b,p),p=(0,E.$1Y)(m,b,p),{mappings:p.map(F=>new g.$xs(m.translateRange(F.seq1Range),b.translateRange(F.seq2Range))),hitTimeout:P.hitTimeout}}}t.$2Y=M;function A(v,w,a,i=!1){const u=[];for(const L of(0,D.$yb)(v.map(m=>f(m,w,a)),(m,b)=>m.original.overlapOrTouch(b.original)||m.modified.overlapOrTouch(b.modified))){const m=L[0],b=L[L.length-1];u.push(new g.$ws(m.original.join(b.original),m.modified.join(b.modified),L.map(P=>P.innerChanges[0])))}return(0,k.$xc)(()=>!i&&u.length>0&&u[0].original.startLineNumber!==u[0].modified.startLineNumber?!1:(0,k.$yc)(u,(L,m)=>m.original.startLineNumber-L.original.endLineNumberExclusive===m.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<m.original.startLineNumber&&L.modified.endLineNumberExclusive<m.modified.startLineNumber)),u}t.$3Y=A;function f(v,w,a){let i=0,u=0;v.modifiedRange.endColumn===1&&v.originalRange.endColumn===1&&v.originalRange.startLineNumber+i<=v.originalRange.endLineNumber&&v.modifiedRange.startLineNumber+i<=v.modifiedRange.endLineNumber&&(u=-1),v.modifiedRange.startColumn-1>=a[v.modifiedRange.startLineNumber-1].length&&v.originalRange.startColumn-1>=w[v.originalRange.startLineNumber-1].length&&v.originalRange.startLineNumber<=v.originalRange.endLineNumber+u&&v.modifiedRange.startLineNumber<=v.modifiedRange.endLineNumber+u&&(i=1);const L=new r.$ts(v.originalRange.startLineNumber+i,v.originalRange.endLineNumber+1+u),m=new r.$ts(v.modifiedRange.startLineNumber+i,v.modifiedRange.endLineNumber+1+u);return new g.$ws(L,m,[v])}t.$4Y=f}),te(ne[33],re([0,1,25,32,16,7,2,13,12]),function(j,t,D,k,r,c,N,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bs=t.$As=void 0;const s=3;class h{computeDiff(i,u,L){const b=new A(i,u,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),P=[];let p=null;for(const y of b.changes){let F;y.originalEndLineNumber===0?F=new l.$ts(y.originalStartLineNumber+1,y.originalStartLineNumber+1):F=new l.$ts(y.originalStartLineNumber,y.originalEndLineNumber+1);let R;y.modifiedEndLineNumber===0?R=new l.$ts(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):R=new l.$ts(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let S=new r.$ws(F,R,y.charChanges?.map(I=>new r.$xs(new N.$ks(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new N.$ks(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===S.modified.startLineNumber||p.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$ws(p.original.join(S.original),p.modified.join(S.modified),p.innerChanges&&S.innerChanges?p.innerChanges.concat(S.innerChanges):void 0),P.pop()),P.push(S),p=S}return(0,o.$xc)(()=>(0,o.$yc)(P,(y,F)=>F.original.startLineNumber-y.original.endLineNumberExclusive===F.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<F.original.startLineNumber&&y.modified.endLineNumberExclusive<F.modified.startLineNumber)),new k.$ys(P,[],b.quitEarly)}}t.$As=h;function E(a,i,u,L){return new D.$qs(a,i,u).ComputeDiff(L)}class d{constructor(i){const u=[],L=[];for(let m=0,b=i.length;m<b;m++)u[m]=f(i[m],1),L[m]=v(i[m],1);this.lines=i,this.a=u,this.b=L}getElements(){const i=[];for(let u=0,L=this.lines.length;u<L;u++)i[u]=this.lines[u].substring(this.a[u]-1,this.b[u]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,u,L){const m=[],b=[],P=[];let p=0;for(let y=u;y<=L;y++){const F=this.lines[y],R=i?this.a[y]:1,S=i?this.b[y]:F.length+1;for(let I=R;I<S;I++)m[p]=F.charCodeAt(I-1),b[p]=y+1,P[p]=I,p++;!i&&y<L&&(m[p]=10,b[p]=y+1,P[p]=F.length+1,p++)}return new g(m,b,P)}}class g{constructor(i,u,L){this.a=i,this.b=u,this.d=L}toString(){return"["+this.a.map((i,u)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[u]},${this.d[u]})`).join(", ")+"]"}e(i,u){if(i<0||i>=u.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,u,L,m,b,P,p,y){this.originalStartLineNumber=i,this.originalStartColumn=u,this.originalEndLineNumber=L,this.originalEndColumn=m,this.modifiedStartLineNumber=b,this.modifiedStartColumn=P,this.modifiedEndLineNumber=p,this.modifiedEndColumn=y}static createFromDiffChange(i,u,L){const m=u.getStartLineNumber(i.originalStart),b=u.getStartColumn(i.originalStart),P=u.getEndLineNumber(i.originalStart+i.originalLength-1),p=u.getEndColumn(i.originalStart+i.originalLength-1),y=L.getStartLineNumber(i.modifiedStart),F=L.getStartColumn(i.modifiedStart),R=L.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),S=L.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(m,b,P,p,y,F,R,S)}}function $(a){if(a.length<=1)return a;const i=[a[0]];let u=i[0];for(let L=1,m=a.length;L<m;L++){const b=a[L],P=b.originalStart-(u.originalStart+u.originalLength),p=b.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(P,p)<s?(u.originalLength=b.originalStart+b.originalLength-u.originalStart,u.modifiedLength=b.modifiedStart+b.modifiedLength-u.modifiedStart):(i.push(b),u=b)}return i}class M{constructor(i,u,L,m,b){this.originalStartLineNumber=i,this.originalEndLineNumber=u,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=m,this.charChanges=b}static createFromDiffResult(i,u,L,m,b,P,p){let y,F,R,S,I;if(u.originalLength===0?(y=L.getStartLineNumber(u.originalStart)-1,F=0):(y=L.getStartLineNumber(u.originalStart),F=L.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(R=m.getStartLineNumber(u.modifiedStart)-1,S=0):(R=m.getStartLineNumber(u.modifiedStart),S=m.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),P&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&b()){const q=L.createCharSequence(i,u.originalStart,u.originalStart+u.originalLength-1),x=m.createCharSequence(i,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(q.getElements().length>0&&x.getElements().length>0){let _=E(q,x,b,!0).changes;p&&(_=$(_)),I=[];for(let V=0,H=_.length;V<H;V++)I.push(e.createFromDiffChange(_[V],q,x))}}return new M(y,F,R,S,I)}}class A{constructor(i,u,L){this.a=L.shouldComputeCharChanges,this.b=L.shouldPostProcessCharChanges,this.d=L.shouldIgnoreTrimWhitespace,this.e=L.shouldMakePrettyDiff,this.f=i,this.g=u,this.h=new d(i),this.j=new d(u),this.k=w(L.maxComputationTime),this.l=w(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=E(this.h,this.j,this.k,this.e),u=i.changes,L=i.quitEarly;if(this.d){const p=[];for(let y=0,F=u.length;y<F;y++)p.push(M.createFromDiffResult(this.d,u[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:L,changes:p}}const m=[];let b=0,P=0;for(let p=-1,y=u.length;p<y;p++){const F=p+1<y?u[p+1]:null,R=F?F.originalStart:this.f.length,S=F?F.modifiedStart:this.g.length;for(;b<R&&P<S;){const I=this.f[b],q=this.g[P];if(I!==q){{let x=f(I,1),_=f(q,1);for(;x>1&&_>1;){const V=I.charCodeAt(x-2),H=q.charCodeAt(_-2);if(V!==H)break;x--,_--}(x>1||_>1)&&this.m(m,b+1,1,x,P+1,1,_)}{let x=v(I,1),_=v(q,1);const V=I.length+1,H=q.length+1;for(;x<V&&_<H;){const C=I.charCodeAt(x-1),J=I.charCodeAt(_-1);if(C!==J)break;x++,_++}(x<V||_<H)&&this.m(m,b+1,x,V,P+1,_,H)}}b++,P++}F&&(m.push(M.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),b+=F.originalLength,P+=F.modifiedLength)}return{quitEarly:L,changes:m}}m(i,u,L,m,b,P,p){if(this.n(i,u,L,m,b,P,p))return;let y;this.a&&(y=[new e(u,L,u,m,b,P,b,p)]),i.push(new M(u,u,b,b,y))}n(i,u,L,m,b,P,p){const y=i.length;if(y===0)return!1;const F=i[y-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===u&&F.modifiedEndLineNumber===b?(this.a&&F.charChanges&&F.charChanges.push(new e(u,L,u,m,b,P,b,p)),!0):F.originalEndLineNumber+1===u&&F.modifiedEndLineNumber+1===b?(F.originalEndLineNumber=u,F.modifiedEndLineNumber=b,this.a&&F.charChanges&&F.charChanges.push(new e(u,L,u,m,b,P,b,p)),!0):!1}}t.$Bs=A;function f(a,i){const u=c.$Be(a);return u===-1?i:u+1}function v(a,i){const u=c.$De(a);return u===-1?i:u+2}function w(a){if(a===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<a}}),te(ne[49],re([0,1,33,48]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Y=void 0,t.$5Y={getLegacy:()=>new D.$As,getDefault:()=>new k.$2Y}}),te(ne[50],re([0,1,34]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Y=void 0;function k(d){const g=[];for(const e of d){const $=Number(e);($||$===0&&e.replace(/\s/g,"")!=="")&&g.push($)}return g}function r(d,g,e,$){return{red:d/255,blue:e/255,green:g/255,alpha:$}}function c(d,g){const e=g.index,$=g[0].length;if(!e)return;const M=d.positionAt(e);return{startLineNumber:M.lineNumber,startColumn:M.column,endLineNumber:M.lineNumber,endColumn:M.column+$}}function N(d,g){if(!d)return;const e=D.$Os.Format.CSS.parseHex(g);if(e)return{range:d,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function o(d,g,e){if(!d||g.length!==1)return;const M=g[0].values(),A=k(M);return{range:d,color:r(A[0],A[1],A[2],e?A[3]:1)}}function l(d,g,e){if(!d||g.length!==1)return;const M=g[0].values(),A=k(M),f=new D.$Os(new D.$Ms(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:d,color:r(f.rgba.r,f.rgba.g,f.rgba.b,f.rgba.a)}}function s(d,g){return typeof d=="string"?[...d.matchAll(g)]:d.findMatches(g)}function h(d){const g=[],$=s(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if($.length>0)for(const M of $){const A=M.filter(a=>a!==void 0),f=A[1],v=A[2];if(!v)continue;let w;if(f==="rgb"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;w=o(c(d,M),s(v,a),!1)}else if(f==="rgba"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=o(c(d,M),s(v,a),!0)}else if(f==="hsl"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;w=l(c(d,M),s(v,a),!1)}else if(f==="hsla"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;w=l(c(d,M),s(v,a),!0)}else f==="#"&&(w=N(c(d,M),f+v));w&&g.push(w)}return g}function E(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:h(d)}t.$6Y=E}),te(ne[51],re([0,1,28]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FY=t.$EY=t.$DY=t.State=void 0;var k;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class r{constructor(e,$,M){const A=new Uint8Array(e*$);for(let f=0,v=e*$;f<v;f++)A[f]=M;this.a=A,this.rows=e,this.cols=$}get(e,$){return this.a[e*this.cols+$]}set(e,$,M){this.a[e*this.cols+$]=M}}class c{constructor(e){let $=0,M=0;for(let f=0,v=e.length;f<v;f++){const[w,a,i]=e[f];a>$&&($=a),w>M&&(M=w),i>M&&(M=i)}$++,M++;const A=new r(M,$,0);for(let f=0,v=e.length;f<v;f++){const[w,a,i]=e[f];A.set(w,a,i)}this.a=A,this.b=$}nextState(e,$){return $<0||$>=this.b?0:this.a.get(e,$)}}t.$DY=c;let N=null;function o(){return N===null&&(N=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var l;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function h(){if(s===null){s=new D.$Hs(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let $=0;$<g.length;$++)s.set(g.charCodeAt($),1);const e=".,;:";for(let $=0;$<e.length;$++)s.set(e.charCodeAt($),2)}return s}class E{static a(e,$,M,A,f){let v=f-1;do{const w=$.charCodeAt(v);if(e.get(w)!==2)break;v--}while(v>A);if(A>0){const w=$.charCodeAt(A-1),a=$.charCodeAt(v);(w===40&&a===41||w===91&&a===93||w===123&&a===125)&&v--}return{range:{startLineNumber:M,startColumn:A+1,endLineNumber:M,endColumn:v+2},url:$.substring(A,v+1)}}static computeLinks(e,$=o()){const M=h(),A=[];for(let f=1,v=e.getLineCount();f<=v;f++){const w=e.getLineContent(f),a=w.length;let i=0,u=0,L=0,m=1,b=!1,P=!1,p=!1,y=!1;for(;i<a;){let F=!1;const R=w.charCodeAt(i);if(m===13){let S;switch(R){case 40:b=!0,S=0;break;case 41:S=b?0:1;break;case 91:p=!0,P=!0,S=0;break;case 93:p=!1,S=P?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:L===R?S=1:L===39||L===34||L===96?S=0:S=1;break;case 42:S=L===42?1:0;break;case 124:S=L===124?1:0;break;case 32:S=p?0:1;break;default:S=M.get(R)}S===1&&(A.push(E.a(M,w,f,u,i)),F=!0)}else if(m===12){let S;R===91?(P=!0,S=0):S=M.get(R),S===1?F=!0:m=13}else m=$.nextState(m,R),m===0&&(F=!0);F&&(m=1,b=!1,P=!1,y=!1,u=i+1,L=R),i++}m===13&&A.push(E.a(M,w,f,u,a))}return A}}t.$EY=E;function d(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:E.computeLinks(g)}t.$FY=d}),te(ne[52],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GY=void 0;class D{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new D}navigateValueSet(r,c,N,o,l){if(r&&c){const s=this.a(c,l);if(s)return{range:r,value:s}}if(N&&o){const s=this.a(o,l);if(s)return{range:N,value:s}}return null}a(r,c){const N=this.b(r,c);return N!==null?N:this.d(r,c)}b(r,c){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let o=Number(r);const l=parseFloat(r);return!isNaN(o)&&!isNaN(l)&&o===l?o===0&&!c?null:(o=Math.floor(o*N),o+=c?N:-N,String(o/N)):null}d(r,c){return this.e(this.c,r,c)}e(r,c,N){let o=null;for(let l=0,s=r.length;o===null&&l<s;l++)o=this.f(r[l],c,N);return o}f(r,c,N){let o=r.indexOf(c);return o>=0?(o+=N?1:-1,o<0?o=r.length-1:o%=r.length,r[o]):null}}t.$GY=D}),te(ne[53],re([0,1,14]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gu=t.$Fu=t.$Eu=t.$Du=t.ModelConstants=t.PositionAffinity=t.$Cu=t.TrackedRangeStickiness=t.$Bu=t.$Au=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var r;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var c;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var N;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var o;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(o||(t.EndOfLinePreference=o={}));var l;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$Zm)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}t.$Au=h;class E{constructor(a,i){this._findMatchBrand=void 0,this.range=a,this.matches=i}}t.$Bu=E;var d;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(d||(t.TrackedRangeStickiness=d={}));function g(w){return w&&typeof w.read=="function"}t.$Cu=g;var e;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var $;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})($||(t.ModelConstants=$={}));class M{constructor(a,i,u,L,m,b){this.identifier=a,this.range=i,this.text=u,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=m,this._isTracked=b}}t.$Du=M;class A{constructor(a,i,u){this.regex=a,this.wordSeparators=i,this.simpleSearch=u}}t.$Eu=A;class f{constructor(a,i,u){this.reverseEdits=a,this.changes=i,this.trimAutoWhitespaceLineNumbers=u}}t.$Fu=f;function v(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}t.$Gu=v}),te(ne[54],re([0,1,6,27]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lu=t.$Ku=t.$Ju=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,k.$le)(l);const h=this.a,E=this.b,d=s.length;return d===0?!1:(this.a=new Uint32Array(h.length+d),this.a.set(h.subarray(0,l),0),this.a.set(h.subarray(l),l+d),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,k.$le)(l),s=(0,k.$le)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,k.$le)(l),s=(0,k.$le)(s);const h=this.a,E=this.b;if(l>=h.length)return!1;const d=h.length-l;return s>=d&&(s=d),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,l),0),this.a.set(h.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,k.$le)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let h=s;h<=l;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,h=this.a.length-1,E=0,d=0,g=0;for(;s<=h;)if(E=s+(h-s)/2|0,d=this.b[E],g=d-this.a[E],l<g)h=E-1;else if(l>=d)s=E+1;else break;return new N(E,l-g)}}t.$Ju=r;class c{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],h=s>0?this.d[s-1]:0;return new N(s,l-h)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,D.$Ub)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const h=this.a[l],E=l>0?this.d[l-1]:0;this.d[l]=E+h;for(let d=0;d<h;d++)this.e[E+d]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$Ku=c;class N{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$Lu=N}),te(ne[55],re([0,1,7,5,54]),function(j,t,D,k,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mu=void 0;class c{constructor(o,l,s,h){this.d=o,this.f=l,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(o){o.eol&&o.eol!==this.g&&(this.g=o.eol,this.j=null);const l=o.changes;for(const s of l)this.o(s.range),this.p(new k.$js(s.range.startLineNumber,s.range.startColumn),s.text);this.h=o.versionId,this.k=null}l(){if(!this.j){const o=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let h=0;h<l;h++)s[h]=this.f[h].length+o;this.j=new r.$Ju(s)}}n(o,l){this.f[o]=l,this.j&&this.j.setValue(o,this.f[o].length+this.g.length)}o(o){if(o.startLineNumber===o.endLineNumber){if(o.startColumn===o.endColumn)return;this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.startLineNumber-1].substring(o.endColumn-1));return}this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.endLineNumber-1].substring(o.endColumn-1)),this.f.splice(o.startLineNumber,o.endLineNumber-o.startLineNumber),this.j&&this.j.removeValues(o.startLineNumber,o.endLineNumber-o.startLineNumber)}p(o,l){if(l.length===0)return;const s=(0,D.$Ae)(l);if(s.length===1){this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+s[0]+this.f[o.lineNumber-1].substring(o.column-1));return}s[s.length-1]+=this.f[o.lineNumber-1].substring(o.column-1),this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let E=1;E<s.length;E++)this.f.splice(o.lineNumber+E-1,0,s[E]),h[E-1]=s[E].length+this.g.length;this.j&&this.j.insertValues(o.lineNumber,h)}}t.$Mu=c}),te(ne[56],re([0,1,7,43,5,2,53]),function(j,t,D,k,r,c,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oB=t.$nB=t.$mB=t.$lB=t.$kB=t.$jB=void 0;const o=999;class l{constructor(f,v,w,a){this.searchString=f,this.isRegex=v,this.matchCase=w,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=s(this.searchString):f=this.searchString.indexOf(`
`)>=0;let v=null;try{v=D.$ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!v)return null;let w=!this.isRegex&&!f;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new N.$Eu(v,this.wordSeparators?(0,k.$Ks)(this.wordSeparators):null,w?this.searchString:null)}}t.$jB=l;function s(A){if(!A||A.length===0)return!1;for(let f=0,v=A.length;f<v;f++){const w=A.charCodeAt(f);if(w===10)return!0;if(w===92){if(f++,f>=v)break;const a=A.charCodeAt(f);if(a===110||a===114||a===87)return!0}}return!1}t.$kB=s;function h(A,f,v){if(!v)return new N.$Bu(A,null);const w=[];for(let a=0,i=f.length;a<i;a++)w[a]=f[a];return new N.$Bu(A,w)}t.$lB=h;class E{constructor(f){const v=[];let w=0;for(let a=0,i=f.length;a<i;a++)f.charCodeAt(a)===10&&(v[w++]=a);this.a=v}findLineFeedCountBeforeOffset(f){const v=this.a;let w=0,a=v.length-1;if(a===-1||f<=v[0])return 0;for(;w<a;){const i=w+((a-w)/2>>0);v[i]>=f?a=i-1:v[i+1]>=f?(w=i,a=i):w=i+1}return w+1}}class d{static findMatches(f,v,w,a,i){const u=v.parseSearchRequest();return u?u.regex.multiline?this.b(f,w,new M(u.wordSeparators,u.regex),a,i):this.c(f,w,u,a,i):[]}static a(f,v,w,a,i,u){let L,m=0;a?(m=a.findLineFeedCountBeforeOffset(i),L=v+i+m):L=v+i;let b;if(a){const F=a.findLineFeedCountBeforeOffset(i+u.length)-m;b=L+u.length+F}else b=L+u.length;const P=f.getPositionAt(L),p=f.getPositionAt(b);return new c.$ks(P.lineNumber,P.column,p.lineNumber,p.column)}static b(f,v,w,a,i){const u=f.getOffsetAt(v.getStartPosition()),L=f.getValueInRange(v,1),m=f.getEOL()===`\r
`?new E(L):null,b=[];let P=0,p;for(w.reset(0);p=w.next(L);)if(b[P++]=h(this.a(f,u,L,m,p.index,p[0]),p,a),P>=i)return b;return b}static c(f,v,w,a,i){const u=[];let L=0;if(v.startLineNumber===v.endLineNumber){const b=f.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return L=this.d(w,b,v.startLineNumber,v.startColumn-1,L,u,a,i),u}const m=f.getLineContent(v.startLineNumber).substring(v.startColumn-1);L=this.d(w,m,v.startLineNumber,v.startColumn-1,L,u,a,i);for(let b=v.startLineNumber+1;b<v.endLineNumber&&L<i;b++)L=this.d(w,f.getLineContent(b),b,0,L,u,a,i);if(L<i){const b=f.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);L=this.d(w,b,v.endLineNumber,0,L,u,a,i)}return u}static d(f,v,w,a,i,u,L,m){const b=f.wordSeparators;if(!L&&f.simpleSearch){const y=f.simpleSearch,F=y.length,R=v.length;let S=-F;for(;(S=v.indexOf(y,S+F))!==-1;)if((!b||$(b,v,R,S,F))&&(u[i++]=new N.$Bu(new c.$ks(w,S+1+a,w,S+1+F+a),null),i>=m))return i;return i}const P=new M(f.wordSeparators,f.regex);let p;P.reset(0);do if(p=P.next(v),p&&(u[i++]=h(new c.$ks(w,p.index+1+a,w,p.index+1+p[0].length+a),p,L),i>=m))return i;while(p);return i}static findNextMatch(f,v,w,a){const i=v.parseSearchRequest();if(!i)return null;const u=new M(i.wordSeparators,i.regex);return i.regex.multiline?this.e(f,w,u,a):this.f(f,w,u,a)}static e(f,v,w,a){const i=new r.$js(v.lineNumber,1),u=f.getOffsetAt(i),L=f.getLineCount(),m=f.getValueInRange(new c.$ks(i.lineNumber,i.column,L,f.getLineMaxColumn(L)),1),b=f.getEOL()===`\r
`?new E(m):null;w.reset(v.column-1);const P=w.next(m);return P?h(this.a(f,u,m,b,P.index,P[0]),P,a):v.lineNumber!==1||v.column!==1?this.e(f,new r.$js(1,1),w,a):null}static f(f,v,w,a){const i=f.getLineCount(),u=v.lineNumber,L=f.getLineContent(u),m=this.g(w,L,u,v.column,a);if(m)return m;for(let b=1;b<=i;b++){const P=(u+b-1)%i,p=f.getLineContent(P+1),y=this.g(w,p,P+1,1,a);if(y)return y}return null}static g(f,v,w,a,i){f.reset(a-1);const u=f.next(v);return u?h(new c.$ks(w,u.index+1,w,u.index+1+u[0].length),u,i):null}static findPreviousMatch(f,v,w,a){const i=v.parseSearchRequest();if(!i)return null;const u=new M(i.wordSeparators,i.regex);return i.regex.multiline?this.h(f,w,u,a):this.j(f,w,u,a)}static h(f,v,w,a){const i=this.b(f,new c.$ks(1,1,v.lineNumber,v.column),w,a,10*o);if(i.length>0)return i[i.length-1];const u=f.getLineCount();return v.lineNumber!==u||v.column!==f.getLineMaxColumn(u)?this.h(f,new r.$js(u,f.getLineMaxColumn(u)),w,a):null}static j(f,v,w,a){const i=f.getLineCount(),u=v.lineNumber,L=f.getLineContent(u).substring(0,v.column-1),m=this.k(w,L,u,a);if(m)return m;for(let b=1;b<=i;b++){const P=(i+u-b-1)%i,p=f.getLineContent(P+1),y=this.k(w,p,P+1,a);if(y)return y}return null}static k(f,v,w,a){let i=null,u;for(f.reset(0);u=f.next(v);)i=h(new c.$ks(w,u.index+1,w,u.index+1+u[0].length),u,a);return i}}t.$mB=d;function g(A,f,v,w,a){if(w===0)return!0;const i=f.charCodeAt(w-1);if(A.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=f.charCodeAt(w);if(A.get(u)!==0)return!0}return!1}function e(A,f,v,w,a){if(w+a===v)return!0;const i=f.charCodeAt(w+a);if(A.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=f.charCodeAt(w+a-1);if(A.get(u)!==0)return!0}return!1}function $(A,f,v,w,a){return g(A,f,v,w,a)&&e(A,f,v,w,a)}t.$nB=$;class M{constructor(f,v){this._wordSeparators=f,this.a=v,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const v=f.length;let w;do{if(this.b+this.c===v||(w=this.a.exec(f),!w))return null;const a=w.index,i=w[0].length;if(a===this.b&&i===this.c){if(i===0){D.$Te(f,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=i,!this._wordSeparators||$(this._wordSeparators,f,v,a,i))return w}while(w);return null}}t.$oB=M}),te(ne[57],re([0,1,2,56,7,13,29]),function(j,t,D,k,r,c,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$CY=void 0;class o{static computeUnicodeHighlights(e,$,M){const A=M?M.startLineNumber:1,f=M?M.endLineNumber:e.getLineCount(),v=new h($),w=v.getCandidateCodePoints();let a;w==="allNonBasicAscii"?a=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):a=new RegExp(`${l(Array.from(w))}`,"g");const i=new k.$oB(null,a),u=[];let L=!1,m,b=0,P=0,p=0;e:for(let y=A,F=f;y<=F;y++){const R=e.getLineContent(y),S=R.length;i.reset(0);do if(m=i.next(R),m){let I=m.index,q=m.index+m[0].length;if(I>0){const H=R.charCodeAt(I-1);r.$Qe(H)&&I--}if(q+1<S){const H=R.charCodeAt(q-1);r.$Qe(H)&&q++}const x=R.substring(I,q);let _=(0,N.$Zr)(I+1,N.$Wr,R,0);_&&_.endColumn<=I+1&&(_=null);const V=v.shouldHighlightNonBasicASCII(x,_?_.word:null);if(V!==0){V===3?b++:V===2?P++:V===1?p++:(0,c.$vc)(V);const H=1e3;if(u.length>=H){L=!0;break e}u.push(new D.$ks(y,I+1,y,q+1))}}while(m)}return{ranges:u,hasMore:L,ambiguousCharacterCount:b,invisibleCharacterCount:P,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,$){const M=new h($);switch(M.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=e.codePointAt(0),v=M.ambiguousCharacters.getPrimaryConfusable(f),w=r.$hf.getLocales().filter(a=>!r.$hf.getInstance(new Set([...$.allowedLocales,a])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:w}}case 1:return{kind:2}}}}t.$CY=o;function l(g,e){return`[${r.$qe(g.map(M=>String.fromCodePoint(M)).join(""))}]`}var s;(function(g){g[g.Ambiguous=0]="Ambiguous",g[g.Invisible=1]="Invisible",g[g.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$hf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const $ of r.$if.codePoints)E(String.fromCodePoint($))||e.add($);if(this.b.ambiguousCharacters)for(const $ of this.ambiguousCharacters.getConfusableCodePoints())e.add($);for(const $ of this.a)e.delete($);return e}shouldHighlightNonBasicASCII(e,$){const M=e.codePointAt(0);if(this.a.has(M))return 0;if(this.b.nonBasicASCII)return 1;let A=!1,f=!1;if($)for(const v of $){const w=v.codePointAt(0),a=r.$2e(v);A=A||a,!a&&!this.ambiguousCharacters.isAmbiguous(w)&&!r.$if.isInvisibleCharacter(w)&&(f=!0)}return!A&&f?0:this.b.invisibleCharacters&&!E(e)&&r.$if.isInvisibleCharacter(M)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(M)?3:0}}function E(g){return g===" "||g===`
`||g==="	"}var d;(function(g){g[g.None=0]="None",g[g.NonBasicASCII=1]="NonBasicASCII",g[g.Invisible=2]="Invisible",g[g.Ambiguous=3]="Ambiguous"})(d||(d={}))}),te(ne[58],re([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D||(t.AccessibilitySupport=D={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var c;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var o;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o||(t.CompletionTriggerKind=o={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var d;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var g;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(g||(t.EditorOption=g={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var $;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})($||(t.EndOfLineSequence=$={}));var M;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(M||(t.GlyphMarginLane=M={}));var A;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(A||(t.IndentAction=A={}));var f;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(f||(t.InjectedTextCursorStops=f={}));var v;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(v||(t.InlayHintKind=v={}));var w;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(w||(t.InlineCompletionTriggerKind=w={}));var a;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(a||(t.KeyCode=a={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var u;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(u||(t.MarkerTag=u={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var b;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(b||(t.OverlayWidgetPositionPreference=b={}));var P;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var R;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(R||(t.ScrollType=R={}));var S;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(S||(t.ScrollbarVisibility=S={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var x;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(x||(t.SymbolKind=x={}));var _;(function(n){n[n.Deprecated=1]="Deprecated"})(_||(t.SymbolTag=_={}));var V;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(V||(t.TextEditorCursorBlinkingStyle=V={}));var H;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(H||(t.TextEditorCursorStyle=H={}));var C;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(t.TrackedRangeStickiness=C={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J||(t.WrappingIndent=J={}))}),te(ne[59],re([0,1,11,10]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vs=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$fd,this.onDidChange=this.c.event,this.d=null}handleChange(o){this.c.fire({changedLanguages:o,changedColorMap:!1})}register(o,l){return this.a.set(o,l),this.handleChange([o]),(0,k.$ic)(()=>{this.a.get(o)===l&&(this.a.delete(o),this.handleChange([o]))})}get(o){return this.a.get(o)||null}registerFactory(o,l){this.b.get(o)?.dispose();const s=new c(this,o,l);return this.b.set(o,s),(0,k.$ic)(()=>{const h=this.b.get(o);!h||h!==s||(this.b.delete(o),h.dispose())})}async getOrCreate(o){const l=this.get(o);if(l)return l;const s=this.b.get(o);return!s||s.isResolved?null:(await s.resolve(),this.get(o))}isResolved(o){if(this.get(o))return!0;const s=this.b.get(o);return!!(!s||s.isResolved)}setColorMap(o){this.d=o,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Vs=r;class c extends k.$kc{get isResolved(){return this.c}constructor(o,l,s){super(),this.f=o,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const o=await this.h.tokenizationSupport;this.c=!0,o&&!this.a&&this.B(this.f.register(this.g,o))}}}),te(ne[60],re([61,62]),function(j,t){return j.create("vs/base/common/platform",t)}),te(ne[17],re([0,1,60]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let k=!1,r=!1,c=!1,N=!1,o=!1,l=!1,s=!1,h=!1,E=!1,d=!1,g,e=t.$f,$=t.$f,M,A;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?f=t.$g.vscode.process:typeof process<"u"&&(f=process);const v=typeof f?.versions?.electron=="string",w=v&&f?.type==="renderer";if(typeof navigator=="object"&&!w)A=navigator.userAgent,k=A.indexOf("Windows")>=0,r=A.indexOf("Macintosh")>=0,h=(A.indexOf("Macintosh")>=0||A.indexOf("iPad")>=0||A.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=A.indexOf("Linux")>=0,d=A?.indexOf("Mobi")>=0,l=!0,g=D.getConfiguredDefaultLocale(D.localize(0,null))||t.$f,e=g,$=navigator.language;else if(typeof f=="object"){k=f.platform==="win32",r=f.platform==="darwin",c=f.platform==="linux",N=c&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,s=v,E=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$f,e=t.$f;const y=f.env.VSCODE_NLS_CONFIG;if(y)try{const F=JSON.parse(y),R=F.availableLanguages["*"];g=F.locale,$=F.osLocale,e=R||t.$f,M=F._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");var a;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(a||(t.Platform=a={}));function i(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=i;let u=0;r?u=1:k?u=3:c&&(u=2),t.$i=k,t.$j=r,t.$k=c,t.$l=N,t.$m=o,t.$n=s,t.$o=l,t.$p=l&&typeof t.$g.importScripts=="function",t.$q=h,t.$r=d,t.$s=E,t.$t=u,t.$u=A,t.$v=e;var L;(function(y){function F(){return t.$v}y.value=F;function R(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}y.isDefaultVariant=R;function S(){return t.$v==="en"}y.isDefault=S})(L||(t.Language=L={})),t.$w=g,t.$x=$,t.$y=M,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const y=[];t.$g.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let S=0,I=y.length;S<I;S++){const q=y[S];if(q.id===R.data.vscodeScheduleAsyncWork){y.splice(S,1),q.callback();return}}});let F=0;return R=>{const S=++F;y.push({id:S,callback:R}),t.$g.postMessage({vscodeScheduleAsyncWork:S},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=r||h?2:k?1:3;let b=!0,P=!1;function p(){if(!P){P=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,b=new Uint16Array(y.buffer)[0]===(2<<8)+1}return b}t.$C=p,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),te(ne[63],re([0,1,17]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.$3d=t.env=t.cwd=void 0;let k;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const r=D.$g.vscode.process;k={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$3d=k.platform,t.$4d=k.arch}),te(ne[64],re([0,1,63]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=t.sep=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=void 0;const k=65,r=97,c=90,N=122,o=46,l=47,s=92,h=58,E=63;class d extends Error{constructor(u,L,m){let b;typeof L=="string"&&L.indexOf("not ")===0?(b="must not be",L=L.replace(/^not /,"")):b="must be";const P=u.indexOf(".")!==-1?"property":"argument";let p=`The "${u}" ${P} ${b} of type ${L}`;p+=`. Received type ${typeof m}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,u){if(i===null||typeof i!="object")throw new d(u,"Object",i)}function e(i,u){if(typeof i!="string")throw new d(u,"string",i)}const $=D.$3d==="win32";function M(i){return i===l||i===s}function A(i){return i===l}function f(i){return i>=k&&i<=c||i>=r&&i<=N}function v(i,u,L,m){let b="",P=0,p=-1,y=0,F=0;for(let R=0;R<=i.length;++R){if(R<i.length)F=i.charCodeAt(R);else{if(m(F))break;F=l}if(m(F)){if(!(p===R-1||y===1))if(y===2){if(b.length<2||P!==2||b.charCodeAt(b.length-1)!==o||b.charCodeAt(b.length-2)!==o){if(b.length>2){const S=b.lastIndexOf(L);S===-1?(b="",P=0):(b=b.slice(0,S),P=b.length-1-b.lastIndexOf(L)),p=R,y=0;continue}else if(b.length!==0){b="",P=0,p=R,y=0;continue}}u&&(b+=b.length>0?`${L}..`:"..",P=2)}else b.length>0?b+=`${L}${i.slice(p+1,R)}`:b=i.slice(p+1,R),P=R-p-1;p=R,y=0}else F===o&&y!==-1?++y:y=-1}return b}function w(i,u){g(u,"pathObject");const L=u.dir||u.root,m=u.base||`${u.name||""}${u.ext||""}`;return L?L===u.root?`${L}${m}`:`${L}${i}${m}`:m}t.$5d={resolve(...i){let u="",L="",m=!1;for(let b=i.length-1;b>=-1;b--){let P;if(b>=0){if(P=i[b],e(P,"path"),P.length===0)continue}else u.length===0?P=D.cwd():(P=D.env[`=${u}`]||D.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==u.toLowerCase()&&P.charCodeAt(2)===s)&&(P=`${u}\\`));const p=P.length;let y=0,F="",R=!1;const S=P.charCodeAt(0);if(p===1)M(S)&&(y=1,R=!0);else if(M(S))if(R=!0,M(P.charCodeAt(1))){let I=2,q=I;for(;I<p&&!M(P.charCodeAt(I));)I++;if(I<p&&I!==q){const x=P.slice(q,I);for(q=I;I<p&&M(P.charCodeAt(I));)I++;if(I<p&&I!==q){for(q=I;I<p&&!M(P.charCodeAt(I));)I++;(I===p||I!==q)&&(F=`\\\\${x}\\${P.slice(q,I)}`,y=I)}}}else y=1;else f(S)&&P.charCodeAt(1)===h&&(F=P.slice(0,2),y=2,p>2&&M(P.charCodeAt(2))&&(R=!0,y=3));if(F.length>0)if(u.length>0){if(F.toLowerCase()!==u.toLowerCase())continue}else u=F;if(m){if(u.length>0)break}else if(L=`${P.slice(y)}\\${L}`,m=R,R&&u.length>0)break}return L=v(L,!m,"\\",M),m?`${u}\\${L}`:`${u}${L}`||"."},normalize(i){e(i,"path");const u=i.length;if(u===0)return".";let L=0,m,b=!1;const P=i.charCodeAt(0);if(u===1)return A(P)?"\\":i;if(M(P))if(b=!0,M(i.charCodeAt(1))){let y=2,F=y;for(;y<u&&!M(i.charCodeAt(y));)y++;if(y<u&&y!==F){const R=i.slice(F,y);for(F=y;y<u&&M(i.charCodeAt(y));)y++;if(y<u&&y!==F){for(F=y;y<u&&!M(i.charCodeAt(y));)y++;if(y===u)return`\\\\${R}\\${i.slice(F)}\\`;y!==F&&(m=`\\\\${R}\\${i.slice(F,y)}`,L=y)}}}else L=1;else f(P)&&i.charCodeAt(1)===h&&(m=i.slice(0,2),L=2,u>2&&M(i.charCodeAt(2))&&(b=!0,L=3));let p=L<u?v(i.slice(L),!b,"\\",M):"";return p.length===0&&!b&&(p="."),p.length>0&&M(i.charCodeAt(u-1))&&(p+="\\"),m===void 0?b?`\\${p}`:p:b?`${m}\\${p}`:`${m}${p}`},isAbsolute(i){e(i,"path");const u=i.length;if(u===0)return!1;const L=i.charCodeAt(0);return M(L)||u>2&&f(L)&&i.charCodeAt(1)===h&&M(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let u,L;for(let P=0;P<i.length;++P){const p=i[P];e(p,"path"),p.length>0&&(u===void 0?u=L=p:u+=`\\${p}`)}if(u===void 0)return".";let m=!0,b=0;if(typeof L=="string"&&M(L.charCodeAt(0))){++b;const P=L.length;P>1&&M(L.charCodeAt(1))&&(++b,P>2&&(M(L.charCodeAt(2))?++b:m=!1))}if(m){for(;b<u.length&&M(u.charCodeAt(b));)b++;b>=2&&(u=`\\${u.slice(b)}`)}return t.$5d.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u)return"";const L=t.$5d.resolve(i),m=t.$5d.resolve(u);if(L===m||(i=L.toLowerCase(),u=m.toLowerCase(),i===u))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===s;)b++;let P=i.length;for(;P-1>b&&i.charCodeAt(P-1)===s;)P--;const p=P-b;let y=0;for(;y<u.length&&u.charCodeAt(y)===s;)y++;let F=u.length;for(;F-1>y&&u.charCodeAt(F-1)===s;)F--;const R=F-y,S=p<R?p:R;let I=-1,q=0;for(;q<S;q++){const _=i.charCodeAt(b+q);if(_!==u.charCodeAt(y+q))break;_===s&&(I=q)}if(q!==S){if(I===-1)return m}else{if(R>S){if(u.charCodeAt(y+q)===s)return m.slice(y+q+1);if(q===2)return m.slice(y+q)}p>S&&(i.charCodeAt(b+q)===s?I=q:q===2&&(I=3)),I===-1&&(I=0)}let x="";for(q=b+I+1;q<=P;++q)(q===P||i.charCodeAt(q)===s)&&(x+=x.length===0?"..":"\\..");return y+=I,x.length>0?`${x}${m.slice(y,F)}`:(m.charCodeAt(y)===s&&++y,m.slice(y,F))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const u=t.$5d.resolve(i);if(u.length<=2)return i;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const L=u.charCodeAt(2);if(L!==E&&L!==o)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(f(u.charCodeAt(0))&&u.charCodeAt(1)===h&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return i},dirname(i){e(i,"path");const u=i.length;if(u===0)return".";let L=-1,m=0;const b=i.charCodeAt(0);if(u===1)return M(b)?i:".";if(M(b)){if(L=m=1,M(i.charCodeAt(1))){let y=2,F=y;for(;y<u&&!M(i.charCodeAt(y));)y++;if(y<u&&y!==F){for(F=y;y<u&&M(i.charCodeAt(y));)y++;if(y<u&&y!==F){for(F=y;y<u&&!M(i.charCodeAt(y));)y++;if(y===u)return i;y!==F&&(L=m=y+1)}}}}else f(b)&&i.charCodeAt(1)===h&&(L=u>2&&M(i.charCodeAt(2))?3:2,m=L);let P=-1,p=!0;for(let y=u-1;y>=m;--y)if(M(i.charCodeAt(y))){if(!p){P=y;break}}else p=!1;if(P===-1){if(L===-1)return".";P=L}return i.slice(0,P)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let L=0,m=-1,b=!0,P;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===h&&(L=2),u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let p=u.length-1,y=-1;for(P=i.length-1;P>=L;--P){const F=i.charCodeAt(P);if(M(F)){if(!b){L=P+1;break}}else y===-1&&(b=!1,y=P+1),p>=0&&(F===u.charCodeAt(p)?--p===-1&&(m=P):(p=-1,m=y))}return L===m?m=y:m===-1&&(m=i.length),i.slice(L,m)}for(P=i.length-1;P>=L;--P)if(M(i.charCodeAt(P))){if(!b){L=P+1;break}}else m===-1&&(b=!1,m=P+1);return m===-1?"":i.slice(L,m)},extname(i){e(i,"path");let u=0,L=-1,m=0,b=-1,P=!0,p=0;i.length>=2&&i.charCodeAt(1)===h&&f(i.charCodeAt(0))&&(u=m=2);for(let y=i.length-1;y>=u;--y){const F=i.charCodeAt(y);if(M(F)){if(!P){m=y+1;break}continue}b===-1&&(P=!1,b=y+1),F===o?L===-1?L=y:p!==1&&(p=1):L!==-1&&(p=-1)}return L===-1||b===-1||p===0||p===1&&L===b-1&&L===m+1?"":i.slice(L,b)},format:w.bind(null,"\\"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const L=i.length;let m=0,b=i.charCodeAt(0);if(L===1)return M(b)?(u.root=u.dir=i,u):(u.base=u.name=i,u);if(M(b)){if(m=1,M(i.charCodeAt(1))){let I=2,q=I;for(;I<L&&!M(i.charCodeAt(I));)I++;if(I<L&&I!==q){for(q=I;I<L&&M(i.charCodeAt(I));)I++;if(I<L&&I!==q){for(q=I;I<L&&!M(i.charCodeAt(I));)I++;I===L?m=I:I!==q&&(m=I+1)}}}}else if(f(b)&&i.charCodeAt(1)===h){if(L<=2)return u.root=u.dir=i,u;if(m=2,M(i.charCodeAt(2))){if(L===3)return u.root=u.dir=i,u;m=3}}m>0&&(u.root=i.slice(0,m));let P=-1,p=m,y=-1,F=!0,R=i.length-1,S=0;for(;R>=m;--R){if(b=i.charCodeAt(R),M(b)){if(!F){p=R+1;break}continue}y===-1&&(F=!1,y=R+1),b===o?P===-1?P=R:S!==1&&(S=1):P!==-1&&(S=-1)}return y!==-1&&(P===-1||S===0||S===1&&P===y-1&&P===p+1?u.base=u.name=i.slice(p,y):(u.name=i.slice(p,P),u.base=i.slice(p,y),u.ext=i.slice(P,y))),p>0&&p!==m?u.dir=i.slice(0,p-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if($){const i=/\\/g;return()=>{const u=D.cwd().replace(i,"/");return u.slice(u.indexOf("/"))}}return()=>D.cwd()})();t.$6d={resolve(...i){let u="",L=!1;for(let m=i.length-1;m>=-1&&!L;m--){const b=m>=0?i[m]:a();e(b,"path"),b.length!==0&&(u=`${b}/${u}`,L=b.charCodeAt(0)===l)}return u=v(u,!L,"/",A),L?`/${u}`:u.length>0?u:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l,L=i.charCodeAt(i.length-1)===l;return i=v(i,!u,"/",A),i.length===0?u?"/":L?"./":".":(L&&(i+="/"),u?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let u;for(let L=0;L<i.length;++L){const m=i[L];e(m,"path"),m.length>0&&(u===void 0?u=m:u+=`/${m}`)}return u===void 0?".":t.$6d.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u||(i=t.$6d.resolve(i),u=t.$6d.resolve(u),i===u))return"";const L=1,m=i.length,b=m-L,P=1,p=u.length-P,y=b<p?b:p;let F=-1,R=0;for(;R<y;R++){const I=i.charCodeAt(L+R);if(I!==u.charCodeAt(P+R))break;I===l&&(F=R)}if(R===y)if(p>y){if(u.charCodeAt(P+R)===l)return u.slice(P+R+1);if(R===0)return u.slice(P+R)}else b>y&&(i.charCodeAt(L+R)===l?F=R:R===0&&(F=0));let S="";for(R=L+F+1;R<=m;++R)(R===m||i.charCodeAt(R)===l)&&(S+=S.length===0?"..":"/..");return`${S}${u.slice(P+F)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l;let L=-1,m=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===l){if(!m){L=b;break}}else m=!1;return L===-1?u?"/":".":u&&L===1?"//":i.slice(0,L)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let L=0,m=-1,b=!0,P;if(u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let p=u.length-1,y=-1;for(P=i.length-1;P>=0;--P){const F=i.charCodeAt(P);if(F===l){if(!b){L=P+1;break}}else y===-1&&(b=!1,y=P+1),p>=0&&(F===u.charCodeAt(p)?--p===-1&&(m=P):(p=-1,m=y))}return L===m?m=y:m===-1&&(m=i.length),i.slice(L,m)}for(P=i.length-1;P>=0;--P)if(i.charCodeAt(P)===l){if(!b){L=P+1;break}}else m===-1&&(b=!1,m=P+1);return m===-1?"":i.slice(L,m)},extname(i){e(i,"path");let u=-1,L=0,m=-1,b=!0,P=0;for(let p=i.length-1;p>=0;--p){const y=i.charCodeAt(p);if(y===l){if(!b){L=p+1;break}continue}m===-1&&(b=!1,m=p+1),y===o?u===-1?u=p:P!==1&&(P=1):u!==-1&&(P=-1)}return u===-1||m===-1||P===0||P===1&&u===m-1&&u===L+1?"":i.slice(u,m)},format:w.bind(null,"/"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const L=i.charCodeAt(0)===l;let m;L?(u.root="/",m=1):m=0;let b=-1,P=0,p=-1,y=!0,F=i.length-1,R=0;for(;F>=m;--F){const S=i.charCodeAt(F);if(S===l){if(!y){P=F+1;break}continue}p===-1&&(y=!1,p=F+1),S===o?b===-1?b=F:R!==1&&(R=1):b!==-1&&(R=-1)}if(p!==-1){const S=P===0&&L?1:P;b===-1||R===0||R===1&&b===p-1&&b===P+1?u.base=u.name=i.slice(S,p):(u.name=i.slice(S,b),u.base=i.slice(S,p),u.ext=i.slice(b,p))}return P>0?u.dir=i.slice(0,P-1):L&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.$6d.win32=t.$5d.win32=t.$5d,t.$6d.posix=t.$5d.posix=t.$6d,t.$7d=$?t.$5d.normalize:t.$6d.normalize,t.$8d=$?t.$5d.isAbsolute:t.$6d.isAbsolute,t.$9d=$?t.$5d.join:t.$6d.join,t.$0d=$?t.$5d.resolve:t.$6d.resolve,t.$$d=$?t.$5d.relative:t.$6d.relative,t.$_d=$?t.$5d.dirname:t.$6d.dirname,t.$ae=$?t.$5d.basename:t.$6d.basename,t.$be=$?t.$5d.extname:t.$6d.extname,t.$ce=$?t.$5d.format:t.$6d.format,t.$de=$?t.$5d.parse:t.$6d.parse,t.$ee=$?t.$5d.toNamespacedPath:t.$6d.toNamespacedPath,t.sep=$?t.$5d.sep:t.$6d.sep,t.$ge=$?t.$5d.delimiter:t.$6d.delimiter}),te(ne[18],re([0,1,64,17]),function(j,t,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,c=/^\//,N=/^\/\//;function o(m,b){if(!m.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!r.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!c.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(m,b){return!m&&!b?"file":m}function s(m,b){switch(m){case"https":case"http":case"file":b?b[0]!==E&&(b=E+b):b=E;break}return b}const h="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(b){return b instanceof g?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,P,p,y,F,R=!1){typeof b=="object"?(this.scheme=b.scheme||h,this.authority=b.authority||h,this.path=b.path||h,this.query=b.query||h,this.fragment=b.fragment||h):(this.scheme=l(b,R),this.authority=P||h,this.path=s(this.scheme,p||h),this.query=y||h,this.fragment=F||h,o(this,R))}get fsPath(){return w(this,!1)}with(b){if(!b)return this;let{scheme:P,authority:p,path:y,query:F,fragment:R}=b;return P===void 0?P=this.scheme:P===null&&(P=h),p===void 0?p=this.authority:p===null&&(p=h),y===void 0?y=this.path:y===null&&(y=h),F===void 0?F=this.query:F===null&&(F=h),R===void 0?R=this.fragment:R===null&&(R=h),P===this.scheme&&p===this.authority&&y===this.path&&F===this.query&&R===this.fragment?this:new M(P,p,y,F,R)}static parse(b,P=!1){const p=d.exec(b);return p?new M(p[2]||h,L(p[4]||h),L(p[5]||h),L(p[7]||h),L(p[9]||h),P):new M(h,h,h,h,h)}static file(b){let P=h;if(k.$i&&(b=b.replace(/\\/g,E)),b[0]===E&&b[1]===E){const p=b.indexOf(E,2);p===-1?(P=b.substring(2),b=E):(P=b.substring(2,p),b=b.substring(p)||E)}return new M("file",P,b,h,h)}static from(b,P){return new M(b.scheme,b.authority,b.path,b.query,b.fragment,P)}static joinPath(b,...P){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return k.$i&&b.scheme==="file"?p=g.file(D.$5d.join(w(b,!0),...P)).path:p=D.$6d.join(b.path,...P),b.with({path:p})}toString(b=!1){return a(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof g)return b;{const P=new M(b);return P._formatted=b.external??null,P._fsPath=b._sep===$?b.fsPath??null:null,P}}else return b}}t.URI=g;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$Sf=e;const $=k.$i?1:void 0;class M extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(b=!1){return b?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=$),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(m,b,P){let p,y=-1;for(let F=0;F<m.length;F++){const R=m.charCodeAt(F);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||b&&R===47||P&&R===91||P&&R===93||P&&R===58)y!==-1&&(p+=encodeURIComponent(m.substring(y,F)),y=-1),p!==void 0&&(p+=m.charAt(F));else{p===void 0&&(p=m.substr(0,F));const S=A[R];S!==void 0?(y!==-1&&(p+=encodeURIComponent(m.substring(y,F)),y=-1),p+=S):y===-1&&(y=F)}}return y!==-1&&(p+=encodeURIComponent(m.substring(y))),p!==void 0?p:m}function v(m){let b;for(let P=0;P<m.length;P++){const p=m.charCodeAt(P);p===35||p===63?(b===void 0&&(b=m.substr(0,P)),b+=A[p]):b!==void 0&&(b+=m[P])}return b!==void 0?b:m}function w(m,b){let P;return m.authority&&m.path.length>1&&m.scheme==="file"?P=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?b?P=m.path.substr(1):P=m.path[1].toLowerCase()+m.path.substr(2):P=m.path,k.$i&&(P=P.replace(/\//g,"\\")),P}t.$Tf=w;function a(m,b){const P=b?v:f;let p="",{scheme:y,authority:F,path:R,query:S,fragment:I}=m;if(y&&(p+=y,p+=":"),(F||y==="file")&&(p+=E,p+=E),F){let q=F.indexOf("@");if(q!==-1){const x=F.substr(0,q);F=F.substr(q+1),q=x.lastIndexOf(":"),q===-1?p+=P(x,!1,!1):(p+=P(x.substr(0,q),!1,!1),p+=":",p+=P(x.substr(q+1),!1,!0)),p+="@"}F=F.toLowerCase(),q=F.lastIndexOf(":"),q===-1?p+=P(F,!1,!0):(p+=P(F.substr(0,q),!1,!0),p+=F.substr(q))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const q=R.charCodeAt(1);q>=65&&q<=90&&(R=`/${String.fromCharCode(q+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const q=R.charCodeAt(0);q>=65&&q<=90&&(R=`${String.fromCharCode(q+32)}:${R.substr(2)}`)}p+=P(R,!0,!1)}return S&&(p+="?",p+=P(S,!1,!1)),I&&(p+="#",p+=b?I:f(I,!1,!1)),p}function i(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+i(m.substr(3)):m}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(m){return m.match(u)?m.replace(u,b=>i(b)):m}}),te(ne[69],re([0,1,3,11,10,14,17,7]),function(j,t,D,k,r,c,N,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function h(L){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=h;var E;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class d{constructor(m,b,P,p){this.vsWorker=m,this.req=b,this.method=P,this.args=p,this.type=0}}class g{constructor(m,b,P,p){this.vsWorker=m,this.seq=b,this.res=P,this.err=p,this.type=1}}class e{constructor(m,b,P,p){this.vsWorker=m,this.req=b,this.eventName=P,this.arg=p,this.type=2}}class ${constructor(m,b,P){this.vsWorker=m,this.req=b,this.event=P,this.type=3}}class M{constructor(m,b){this.vsWorker=m,this.req=b,this.type=4}}class A{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,b){const P=String(++this.b);return new Promise((p,y)=>{this.c[P]={resolve:p,reject:y},this.o(new d(this.a,P,m,b))})}listen(m,b){let P=null;const p=new k.$fd({onWillAddFirstListener:()=>{P=String(++this.b),this.d.set(P,p),this.o(new e(this.a,P,m,b))},onDidRemoveLastListener:()=>{this.d.delete(P),this.o(new M(this.a,P)),P=null}});return p.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const b=this.c[m.seq];if(delete this.c[m.seq],m.err){let P=m.err;m.err.$isError&&(P=new Error,P.name=m.err.name,P.message=m.err.message,P.stack=m.err.stack),b.reject(P);return}b.resolve(m.res)}k(m){const b=m.req;this.g.handleMessage(m.method,m.args).then(p=>{this.o(new g(this.a,b,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,D.$1)(p.detail)),this.o(new g(this.a,b,void 0,(0,D.$1)(p)))})}l(m){const b=m.req,P=this.g.handleEvent(m.eventName,m.arg)(p=>{this.o(new $(this.a,b,p))});this.f.set(b,P)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const b=[];if(m.type===0)for(let P=0;P<m.args.length;P++)m.args[P]instanceof ArrayBuffer&&b.push(m.args[P]);else m.type===1&&m.res instanceof ArrayBuffer&&b.push(m.res);this.g.sendMessage(m,b)}}class f extends r.$kc{constructor(m,b,P){super();let p=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new A({sendMessage:(q,x)=>{this.a.postMessage(q,x)},handleMessage:(q,x)=>{if(typeof P[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(P[q].apply(P,x))}catch(_){return Promise.reject(_)}},handleEvent:(q,x)=>{if(w(q)){const _=P[q].call(P,x);if(typeof _!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return _}if(v(q)){const _=P[q];if(typeof _!="function")throw new Error(`Missing event ${q} on main thread host.`);return _}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?y=F.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const R=(0,c.$6m)(P);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(y)),b,R]);const S=(q,x)=>this.g(q,x),I=(q,x)=>this.c.listen(q,x);this.f=new Promise((q,x)=>{p=x,this.b.then(_=>{q(a(_,S,I))},_=>{x(_),this.h("Worker failed to load "+b,_)})})}getProxyObject(){return this.f}g(m,b){return new Promise((P,p)=>{this.b.then(()=>{this.c.sendMessage(m,b).then(P,p)},p)})}h(m,b){console.error(m),console.info(b)}}t.SimpleWorkerClient=f;function v(L){return L[0]==="o"&&L[1]==="n"&&o.$Le(L.charCodeAt(2))}function w(L){return/^onDynamic/.test(L)&&o.$Le(L.charCodeAt(9))}function a(L,m,b){const P=F=>function(){const R=Array.prototype.slice.call(arguments,0);return m(F,R)},p=F=>function(R){return b(F,R)},y={};for(const F of L){if(w(F)){y[F]=p(F);continue}if(v(F)){y[F]=b(F,void 0);continue}y[F]=P(F)}return y}class i{constructor(m,b){this.a=b,this.b=null,this.c=new A({sendMessage:(P,p)=>{m(P,p)},handleMessage:(P,p)=>this.d(P,p),handleEvent:(P,p)=>this.f(P,p)})}onmessage(m){this.c.handleMessage(m)}d(m,b){if(m===l)return this.g(b[0],b[1],b[2],b[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,b))}catch(P){return Promise.reject(P)}}f(m,b){if(!this.b)throw new Error("Missing requestHandler");if(w(m)){const P=this.b[m].call(this.b,b);if(typeof P!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return P}if(v(m)){const P=this.b[m];if(typeof P!="function")throw new Error(`Missing event ${m} on request handler.`);return P}throw new Error(`Malformed event name ${m}`)}g(m,b,P,p){this.c.setWorkerId(m);const R=a(p,(S,I)=>this.c.sendMessage(S,I),(S,I)=>this.c.listen(S,I));return this.a?(this.b=this.a(R),Promise.resolve((0,c.$6m)(this.b))):(b&&(typeof b.baseUrl<"u"&&delete b.baseUrl,typeof b.paths<"u"&&typeof b.paths.vs<"u"&&delete b.paths.vs,typeof b.trustedTypesPolicy!==void 0&&delete b.trustedTypesPolicy,b.catchError=!0,globalThis.require.config(b)),new Promise((S,I)=>{(globalThis.require||j)([P],x=>{if(this.b=x.create(R),!this.b){I(new Error("No RequestHandler!"));return}S((0,c.$6m)(this.b))},I)}))}}t.SimpleWorkerServer=i;function u(L){return new i(L,null)}t.create=u}),te(ne[65],re([61,62]),function(j,t){return j.create("vs/editor/common/languages",t)}),te(ne[66],re([0,1,40,18,41,2,59,65]),function(j,t,D,k,r,c,N,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$bt=t.$at=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$_s=t.$$s=t.SymbolKinds=t.SymbolTag=t.$0s=t.$9s=t.SymbolKind=t.$8s=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$7s=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$6s=t.$5s=t.$4s=void 0;class l{constructor(V,H,C){this.offset=V,this.type=H,this.language=C,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$4s=l;class s{constructor(V,H){this.tokens=V,this.endState=H,this._tokenizationResultBrand=void 0}}t.$5s=s;class h{constructor(V,H){this.tokens=V,this.endState=H,this._encodedTokenizationResultBrand=void 0}}t.$6s=h;var E;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var d;(function(_){const V=new Map;V.set(0,D.$Pj.symbolMethod),V.set(1,D.$Pj.symbolFunction),V.set(2,D.$Pj.symbolConstructor),V.set(3,D.$Pj.symbolField),V.set(4,D.$Pj.symbolVariable),V.set(5,D.$Pj.symbolClass),V.set(6,D.$Pj.symbolStruct),V.set(7,D.$Pj.symbolInterface),V.set(8,D.$Pj.symbolModule),V.set(9,D.$Pj.symbolProperty),V.set(10,D.$Pj.symbolEvent),V.set(11,D.$Pj.symbolOperator),V.set(12,D.$Pj.symbolUnit),V.set(13,D.$Pj.symbolValue),V.set(15,D.$Pj.symbolEnum),V.set(14,D.$Pj.symbolConstant),V.set(15,D.$Pj.symbolEnum),V.set(16,D.$Pj.symbolEnumMember),V.set(17,D.$Pj.symbolKeyword),V.set(27,D.$Pj.symbolSnippet),V.set(18,D.$Pj.symbolText),V.set(19,D.$Pj.symbolColor),V.set(20,D.$Pj.symbolFile),V.set(21,D.$Pj.symbolReference),V.set(22,D.$Pj.symbolCustomColor),V.set(23,D.$Pj.symbolFolder),V.set(24,D.$Pj.symbolTypeParameter),V.set(25,D.$Pj.account),V.set(26,D.$Pj.issues);function H(n){let ue=V.get(n);return ue||(console.info("No codicon found for CompletionItemKind "+n),ue=D.$Pj.symbolProperty),ue}_.toIcon=H;const C=new Map;C.set("method",0),C.set("function",1),C.set("constructor",2),C.set("field",3),C.set("variable",4),C.set("class",5),C.set("struct",6),C.set("interface",7),C.set("module",8),C.set("property",9),C.set("event",10),C.set("operator",11),C.set("unit",12),C.set("value",13),C.set("constant",14),C.set("enum",15),C.set("enum-member",16),C.set("enumMember",16),C.set("keyword",17),C.set("snippet",27),C.set("text",18),C.set("color",19),C.set("file",20),C.set("reference",21),C.set("customcolor",22),C.set("folder",23),C.set("type-parameter",24),C.set("typeParameter",24),C.set("account",25),C.set("issue",26);function J(n,ue){let oe=C.get(n);return typeof oe>"u"&&!ue&&(oe=9),oe}_.fromString=J})(d||(t.CompletionItemKinds=d={}));var g;(function(_){_[_.Deprecated=1]="Deprecated"})(g||(t.CompletionItemTag=g={}));var e;(function(_){_[_.None=0]="None",_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var $;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(t.CompletionTriggerKind=$={}));var M;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(M||(t.InlineCompletionTriggerKind=M={}));class A{constructor(V,H,C,J){this.range=V,this.text=H,this.completionKind=C,this.isSnippetText=J}equals(V){return c.$ks.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}t.$7s=A;var f;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(f||(t.CodeActionTriggerType=f={}));var v;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(v||(t.SignatureHelpTriggerKind=v={}));var w;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(w||(t.DocumentHighlightKind=w={}));function a(_){return _&&k.URI.isUri(_.uri)&&c.$ks.isIRange(_.range)&&(c.$ks.isIRange(_.originSelectionRange)||c.$ks.isIRange(_.targetSelectionRange))}t.$8s=a;var i;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$9s={[17]:(0,o.localize)(0,null),[16]:(0,o.localize)(1,null),[4]:(0,o.localize)(2,null),[13]:(0,o.localize)(3,null),[8]:(0,o.localize)(4,null),[9]:(0,o.localize)(5,null),[21]:(0,o.localize)(6,null),[23]:(0,o.localize)(7,null),[7]:(0,o.localize)(8,null),[0]:(0,o.localize)(9,null),[11]:(0,o.localize)(10,null),[10]:(0,o.localize)(11,null),[19]:(0,o.localize)(12,null),[5]:(0,o.localize)(13,null),[1]:(0,o.localize)(14,null),[2]:(0,o.localize)(15,null),[20]:(0,o.localize)(16,null),[15]:(0,o.localize)(17,null),[18]:(0,o.localize)(18,null),[24]:(0,o.localize)(19,null),[3]:(0,o.localize)(20,null),[6]:(0,o.localize)(21,null),[14]:(0,o.localize)(22,null),[22]:(0,o.localize)(23,null),[25]:(0,o.localize)(24,null),[12]:(0,o.localize)(25,null)};function u(_,V){return(0,o.localize)(26,null,_,t.$9s[V])}t.$0s=u;var L;(function(_){_[_.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var m;(function(_){const V=new Map;V.set(0,D.$Pj.symbolFile),V.set(1,D.$Pj.symbolModule),V.set(2,D.$Pj.symbolNamespace),V.set(3,D.$Pj.symbolPackage),V.set(4,D.$Pj.symbolClass),V.set(5,D.$Pj.symbolMethod),V.set(6,D.$Pj.symbolProperty),V.set(7,D.$Pj.symbolField),V.set(8,D.$Pj.symbolConstructor),V.set(9,D.$Pj.symbolEnum),V.set(10,D.$Pj.symbolInterface),V.set(11,D.$Pj.symbolFunction),V.set(12,D.$Pj.symbolVariable),V.set(13,D.$Pj.symbolConstant),V.set(14,D.$Pj.symbolString),V.set(15,D.$Pj.symbolNumber),V.set(16,D.$Pj.symbolBoolean),V.set(17,D.$Pj.symbolArray),V.set(18,D.$Pj.symbolObject),V.set(19,D.$Pj.symbolKey),V.set(20,D.$Pj.symbolNull),V.set(21,D.$Pj.symbolEnumMember),V.set(22,D.$Pj.symbolStruct),V.set(23,D.$Pj.symbolEvent),V.set(24,D.$Pj.symbolOperator),V.set(25,D.$Pj.symbolTypeParameter);function H(C){let J=V.get(C);return J||(console.info("No codicon found for SymbolKind "+C),J=D.$Pj.symbolProperty),J}_.toIcon=H})(m||(t.SymbolKinds=m={}));class b{static asEditOperation(V){return r.$ls.replace(c.$ks.lift(V.range),V.text)}}t.$$s=b;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(V){switch(V){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(V)}constructor(V){this.value=V}}t.$_s=P;var p;(function(_){function V(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}_.is=V})(p||(t.Command=p={}));var y;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var F;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(F||(t.CommentThreadState=F={}));var R;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(R||(t.CommentMode=R={}));var S;(function(_){_[_.Published=0]="Published",_[_.Draft=1]="Draft"})(S||(t.CommentState=S={}));var I;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(I||(t.InlayHintKind=I={}));class q{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$at=q,t.$bt=new N.$Vs;var x;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(x||(t.ExternalUriOpenerPriority=x={}))}),te(ne[67],re([0,1,24,11,36,18,5,2,42,66,58]),function(j,t,D,k,r,c,N,o,l,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IY=t.$HY=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,$){return(0,r.$vq)(e,$)}}t.$HY=E;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.$pd,Emitter:k.$fd,KeyCode:h.KeyCode,KeyMod:E,Position:N.$js,Range:o.$ks,Selection:l.$ms,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:c.URI,Token:s.$4s}}t.$IY=d}),te(ne[70],re([0,1,25,18,5,2,55,29,51,52,67,23,57,33,49,14,3,50]),function(j,t,D,k,r,c,N,o,l,s,h,E,d,g,e,$,M,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class f extends N.$Mu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const u=[];for(let L=0;L<this.f.length;L++){const m=this.f[L],b=this.offsetAt(new r.$js(L+1,1)),P=m.matchAll(i);for(const p of P)(p.index||p.index===0)&&(p.index=p.index+b),u.push(p)}return u}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,u){const L=(0,o.$Zr)(i.column,(0,o.$Xr)(u),this.f[i.lineNumber-1],0);return L?new c.$ks(i.lineNumber,L.startColumn,i.lineNumber,L.endColumn):null}getWordUntilPosition(i,u){const L=this.getWordAtPosition(i,u);return L?{word:this.f[i.lineNumber-1].substring(L.startColumn-1,i.column-1),startColumn:L.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const u=this.f,L=this.q.bind(this);let m=0,b="",P=0,p=[];return{*[Symbol.iterator](){for(;;)if(P<p.length){const y=b.substring(p[P].start,p[P].end);P+=1,yield y}else if(m<u.length)b=u[m],p=L(b,i),P=0,m+=1;else break}}}getLineWords(i,u){const L=this.f[i-1],m=this.q(L,u),b=[];for(const P of m)b.push({word:L.substring(P.start,P.end),startColumn:P.start+1,endColumn:P.end+1});return b}q(i,u){const L=[];let m;for(u.lastIndex=0;(m=u.exec(i))&&m[0].length!==0;)L.push({start:m.index,end:m.index+m[0].length});return L}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const u=this.g,L=i.startLineNumber-1,m=i.endLineNumber-1,b=[];b.push(this.f[L].substring(i.startColumn-1));for(let P=L+1;P<m;P++)b.push(this.f[P]);return b.push(this.f[m].substring(0,i.endColumn-1)),b.join(u)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const u=this.j.getIndexOf(i),L=this.f[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,L)}}r(i){const u=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),L=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return u.lineNumber!==i.startLineNumber||u.column!==i.startColumn||L.lineNumber!==i.endLineNumber||L.column!==i.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:L.lineNumber,endColumn:L.column}:i}s(i){if(!r.$js.isIPosition(i))throw new Error("bad position");let{lineNumber:u,column:L}=i,m=!1;if(u<1)u=1,L=1,m=!0;else if(u>this.f.length)u=this.f.length,L=this.f[u-1].length+1,m=!0;else{const b=this.f[u-1].length+1;L<1?(L=1,m=!0):L>b&&(L=b,m=!0)}return m?{lineNumber:u,column:L}:i}}class v{constructor(i,u){this.d=i,this.f=Object.create(null),this.g=u,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(u=>i.push(this.f[u])),i}acceptNewModel(i){this.f[i.url]=new f(k.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,u){if(!this.f[i])return;this.f[i].onEvents(u)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,u,L){const m=this.j(i);return m?d.$CY.computeUnicodeHighlights(m,u,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,u,L,m){const b=this.j(i),P=this.j(u);return!b||!P?null:v.l(b,P,L,m)}static l(i,u,L,m){const b=m==="advanced"?e.$5Y.getDefault():e.$5Y.getLegacy(),P=i.getLinesContent(),p=u.getLinesContent(),y=b.computeDiff(P,p,L),F=y.changes.length>0?!1:this.n(i,u);function R(S){return S.map(I=>[I.original.startLineNumber,I.original.endLineNumberExclusive,I.modified.startLineNumber,I.modified.endLineNumberExclusive,I.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:F,quitEarly:y.hitTimeout,changes:R(y.changes),moves:y.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,R(S.changes)])}}static n(i,u){const L=i.getLineCount(),m=u.getLineCount();if(L!==m)return!1;for(let b=1;b<=L;b++){const P=i.getLineContent(b),p=u.getLineContent(b);if(P!==p)return!1}return!0}async computeDirtyDiff(i,u,L){const m=this.j(i),b=this.j(u);if(!m||!b)return null;const P=m.getLinesContent(),p=b.getLinesContent();return new g.$Bs(P,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,u,L){const m=this.j(i);if(!m)return u;const b=[];let P;u=u.slice(0).sort((y,F)=>{if(y.range&&F.range)return c.$ks.compareRangesUsingStarts(y.range,F.range);const R=y.range?0:1,S=F.range?0:1;return R-S});let p=0;for(let y=1;y<u.length;y++)c.$ks.getEndPosition(u[p].range).equals(c.$ks.getStartPosition(u[y].range))?(u[p].range=c.$ks.fromPositions(c.$ks.getStartPosition(u[p].range),c.$ks.getEndPosition(u[y].range)),u[p].text+=u[y].text):(p++,u[p]=u[y]);u.length=p+1;for(let{range:y,text:F,eol:R}of u){if(typeof R=="number"&&(P=R),c.$ks.isEmpty(y)&&!F)continue;const S=m.getValueInRange(y);if(F=F.replace(/\r\n|\n|\r/g,m.eol),S===F)continue;if(Math.max(F.length,S.length)>v.o){b.push({range:y,text:F});continue}const I=(0,D.$ps)(S,F,L),q=m.offsetAt(c.$ks.lift(y).getStartPosition());for(const x of I){const _=m.positionAt(q+x.originalStart),V=m.positionAt(q+x.originalStart+x.originalLength),H={text:F.substr(x.modifiedStart,x.modifiedLength),range:{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:V.lineNumber,endColumn:V.column}};m.getValueInRange(H.range)!==H.text&&b.push(H)}}return typeof P=="number"&&b.push({eol:P,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),b}computeHumanReadableDiff(i,u,L){const m=this.j(i);if(!m)return u;const b=[];let P;u=u.slice(0).sort((p,y)=>{if(p.range&&y.range)return c.$ks.compareRangesUsingStarts(p.range,y.range);const F=p.range?0:1,R=y.range?0:1;return F-R});for(let{range:p,text:y,eol:F}of u){let _=function(H,C){return new r.$js(H.lineNumber+C.lineNumber-1,C.lineNumber===1?H.column+C.column-1:C.column)},V=function(H,C){const J=[];for(let n=C.startLineNumber;n<=C.endLineNumber;n++){const ue=H[n-1];n===C.startLineNumber&&n===C.endLineNumber?J.push(ue.substring(C.startColumn-1,C.endColumn-1)):n===C.startLineNumber?J.push(ue.substring(C.startColumn-1)):n===C.endLineNumber?J.push(ue.substring(0,C.endColumn-1)):J.push(ue)}return J};if(typeof F=="number"&&(P=F),c.$ks.isEmpty(p)&&!y)continue;const R=m.getValueInRange(p);if(y=y.replace(/\r\n|\n|\r/g,m.eol),R===y)continue;if(Math.max(y.length,R.length)>v.o){b.push({range:p,text:y});continue}const S=R.split(/\r\n|\n|\r/),I=y.split(/\r\n|\n|\r/),q=e.$5Y.getDefault().computeDiff(S,I,L),x=c.$ks.lift(p).getStartPosition();for(const H of q.changes)if(H.innerChanges)for(const C of H.innerChanges)b.push({range:c.$ks.fromPositions(_(x,C.originalRange.getStartPosition()),_(x,C.originalRange.getEndPosition())),text:V(I,C.modifiedRange).join(m.eol)});else throw new M.$ab("The experimental diff algorithm always produces inner changes")}return typeof P=="number"&&b.push({eol:P,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),b}async computeLinks(i){const u=this.j(i);return u?(0,l.$FY)(u):null}async computeDefaultDocumentColors(i){const u=this.j(i);return u?(0,A.$6Y)(u):null}static{this.p=1e4}async textualSuggest(i,u,L,m){const b=new E.$bd,P=new RegExp(L,m),p=new Set;e:for(const y of i){const F=this.j(y);if(F){for(const R of F.words(P))if(!(R===u||!isNaN(Number(R)))&&(p.add(R),p.size>v.p))break e}}return{words:Array.from(p),duration:b.elapsed()}}async computeWordRanges(i,u,L,m){const b=this.j(i);if(!b)return Object.create(null);const P=new RegExp(L,m),p=Object.create(null);for(let y=u.startLineNumber;y<u.endLineNumber;y++){const F=b.getLineWords(y,P);for(const R of F){if(!isNaN(Number(R.word)))continue;let S=p[R.word];S||(S=[],p[R.word]=S),S.push({startLineNumber:y,startColumn:R.startColumn,endLineNumber:y,endColumn:R.endColumn})}}return p}async navigateValueSet(i,u,L,m,b){const P=this.j(i);if(!P)return null;const p=new RegExp(m,b);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const y=P.getValueInRange(u),F=P.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},p);if(!F)return null;const R=P.getValueInRange(F);return s.$GY.INSTANCE.navigateValueSet(u,y,F,R,L)}loadForeignModule(i,u,L){const m=(p,y)=>this.d.fhr(p,y),P={host:(0,$.$7m)(L,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(P,u),Promise.resolve((0,$.$6m)(this.h))):new Promise((p,y)=>{j([i],F=>{this.h=F.create(P,u),p((0,$.$6m)(this.h))},y)})}fmr(i,u){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,u))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=v;function w(a){return new v(a,null)}t.create=w,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$IY)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/base/worker/workerMain.js.map
