/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(K){for(var e=[],S=0,R=K.length;S<R;S++)e[S]=te[K[S]];return e};define(te[132],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function S(b,g,$){const o=R(b,g);if(o!==-1)return b[o]}e.$db=S;function R(b,g,$=b.length-1){for(let o=$;o>=0;o--){const d=b[o];if(g(d))return o}return-1}e.$eb=R;function s(b,g){const $=M(b,g);return $===-1?void 0:b[$]}e.$fb=s;function M(b,g,$=0,o=b.length){let d=$,P=o;for(;d<P;){const h=Math.floor((d+P)/2);g(b[h])?d=h+1:P=h}return d-1}e.$gb=M;function D(b,g){const $=E(b,g);return $===b.length?void 0:b[$]}e.$hb=D;function E(b,g,$=0,o=b.length){let d=$,P=o;for(;d<P;){const h=Math.floor((d+P)/2);g(b[h])?P=h:d=h+1}return d}e.$ib=E;function u(b,g,$=0,o=b.length){const d=E(b,g,$,o);return d===b.length?-1:d}e.$jb=u;class c{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(c.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!g(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const $=M(this.e,g,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$kb=c;function m(b,g){if(b.length===0)return;let $=b[0];for(let o=1;o<b.length;o++){const d=b[o];g(d,$)>0&&($=d)}return $}e.$lb=m;function w(b,g){if(b.length===0)return;let $=b[0];for(let o=1;o<b.length;o++){const d=b[o];g(d,$)>=0&&($=d)}return $}e.$mb=w;function y(b,g){return m(b,($,o)=>-g($,o))}e.$nb=y;function f(b,g){if(b.length===0)return-1;let $=0;for(let o=1;o<b.length;o++){const d=b[o];g(d,b[$])>0&&($=o)}return $}e.$ob=f;function v(b,g){for(const $ of b){const o=g($);if(o!==void 0)return o}}e.$pb=v}),define(te[133],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function S(D,E){const u=Object.create(null);for(const c of D){const m=E(c);let w=u[m];w||(w=u[m]=[]),w.push(c)}return u}e.$I=S;function R(D,E){const u=[],c=[];for(const m of D)E.has(m)||u.push(m);for(const m of E)D.has(m)||c.push(m);return{removed:u,added:c}}e.$J=R;function s(D,E){const u=[],c=[];for(const[m,w]of D)E.has(m)||u.push(w);for(const[m,w]of E)D.has(m)||c.push(w);return{removed:u,added:c}}e.$K=s;class M{constructor(){this.a=new Map}add(E,u){let c=this.a.get(E);c||(c=new Set,this.a.set(E,c)),c.add(u)}delete(E,u){const c=this.a.get(E);c&&(c.delete(u),c.size===0&&this.a.delete(E))}forEach(E,u){const c=this.a.get(E);c&&c.forEach(u)}get(E){const u=this.a.get(E);return u||new Set}}e.$L=M}),define(te[134],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.$Ms=e.$Ls=void 0;function S(E,u){const c=Math.pow(10,u);return Math.round(E*c)/c}class R{constructor(u,c,m,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=S(Math.max(Math.min(1,w),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}e.$Ls=R;class s{constructor(u,c,m,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.l=S(Math.max(Math.min(1,m),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,m=u.g/255,w=u.b/255,y=u.a,f=Math.max(c,m,w),v=Math.min(c,m,w);let b=0,g=0;const $=(v+f)/2,o=f-v;if(o>0){switch(g=Math.min($<=.5?o/(2*$):o/(2-2*$),1),f){case c:b=(m-w)/o+(m<w?6:0);break;case m:b=(w-c)/o+2;break;case w:b=(c-m)/o+4;break}b*=60,b=Math.round(b)}return new s(b,g,$,y)}static i(u,c,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?u+(c-u)*6*m:m<1/2?c:m<2/3?u+(c-u)*(2/3-m)*6:u}static toRGBA(u){const c=u.h/360,{s:m,l:w,a:y}=u;let f,v,b;if(m===0)f=v=b=w;else{const g=w<.5?w*(1+m):w+m-w*m,$=2*w-g;f=s.i($,g,c+1/3),v=s.i($,g,c),b=s.i($,g,c-1/3)}return new R(Math.round(f*255),Math.round(v*255),Math.round(b*255),y)}}e.$Ms=s;class M{constructor(u,c,m,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.v=S(Math.max(Math.min(1,m),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,m=u.g/255,w=u.b/255,y=Math.max(c,m,w),f=Math.min(c,m,w),v=y-f,b=y===0?0:v/y;let g;return v===0?g=0:y===c?g=((m-w)/v%6+6)%6:y===m?g=(w-c)/v+2:g=(c-m)/v+4,new M(Math.round(g*60),b,y,u.a)}static toRGBA(u){const{h:c,s:m,v:w,a:y}=u,f=w*m,v=f*(1-Math.abs(c/60%2-1)),b=w-f;let[g,$,o]=[0,0,0];return c<60?(g=f,$=v):c<120?(g=v,$=f):c<180?($=f,o=v):c<240?($=v,o=f):c<300?(g=v,o=f):c<=360&&(g=f,o=v),g=Math.round((g+b)*255),$=Math.round(($+b)*255),o=Math.round((o+b)*255),new R(g,$,o,y)}}e.$Ns=M;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof R)this.rgba=u;else if(u instanceof s)this.i=u,this.rgba=s.toRGBA(u);else if(u instanceof M)this.j=u,this.rgba=M.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&R.equals(this.rgba,u.rgba)&&s.equals(this.hsla,u.hsla)&&M.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D.k(this.rgba.r),c=D.k(this.rgba.g),m=D.k(this.rgba.b),w=.2126*u+.7152*c+.0722*m;return S(w,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c>m?(c+.05)/(m+.05):(m+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c>m}isDarkerThan(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c<m}lighten(u){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:m,b:w,a:y}=this.rgba;return new D(new R(c,m,w,y*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,m=this.rgba.a,w=c.a,y=m+w*(1-m);if(y<1e-6)return D.transparent;const f=this.rgba.r*m/y+c.r*w*(1-m)/y,v=this.rgba.g*m/y+c.g*w*(1-m)/y,b=this.rgba.b*m/y+c.b*w*(1-m)/y;return new D(new R(f,v,b,y))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:m,b:w,a:y}=this.rgba;return new D(new R(u.rgba.r-y*(u.rgba.r-c),u.rgba.g-y*(u.rgba.g-m),u.rgba.b-y*(u.rgba.b-w),1))}flatten(...u){const c=u.reduceRight((m,w)=>D.o(w,m));return D.o(this,c)}static o(u,c){const m=1-u.rgba.a;return new D(new R(m*c.rgba.r+u.rgba.a*u.rgba.r,m*c.rgba.g+u.rgba.a*u.rgba.g,m*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(u,c,m){if(u.isLighterThan(c))return u;m=m||.5;const w=u.getRelativeLuminance(),y=c.getRelativeLuminance();return m=m*(y-w)/y,u.lighten(m)}static getDarkerColor(u,c,m){if(u.isDarkerThan(c))return u;m=m||.5;const w=u.getRelativeLuminance(),y=c.getRelativeLuminance();return m=m*(w-y)/w,u.darken(m)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$Os=D,function(E){let u;(function(c){let m;(function(w){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}w.formatRGB=y;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=f;function v(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}w.formatHSL=v;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=b;function g(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function $(t){return`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}`}w.formatHex=$;function o(t,l=!1){return l&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}${g(Math.round(t.rgba.a*255))}`}w.formatHexA=o;function d(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}w.format=d;function P(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const r=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),i=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),n=16*h(t.charCodeAt(5))+h(t.charCodeAt(6));return new E(new R(r,i,n,1))}if(l===9){const r=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),i=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),n=16*h(t.charCodeAt(5))+h(t.charCodeAt(6)),a=16*h(t.charCodeAt(7))+h(t.charCodeAt(8));return new E(new R(r,i,n,a/255))}if(l===4){const r=h(t.charCodeAt(1)),i=h(t.charCodeAt(2)),n=h(t.charCodeAt(3));return new E(new R(16*r+r,16*i+i,16*n+n))}if(l===5){const r=h(t.charCodeAt(1)),i=h(t.charCodeAt(2)),n=h(t.charCodeAt(3)),a=h(t.charCodeAt(4));return new E(new R(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}w.parseHex=P;function h(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=c.CSS||(c.CSS={}))})(u=E.Format||(E.Format={}))}(D||(e.$Os=D={}))}),define(te[54],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function S(D){return(E,u,c)=>{let m=null,w=null;if(typeof c.value=="function"?(m="value",w=c.value):typeof c.get=="function"&&(m="get",w=c.get),!w)throw new Error("not supported");c[m]=D(w,u)}}function R(D,E,u){let c=null,m=null;if(typeof u.value=="function"?(c="value",m=u.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",m=u.get),!m)throw new Error("not supported");const w=`$memoize$${E}`;u[c]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,y)}),this[w]}}e.$6g=R;function s(D,E,u){return S((c,m)=>{const w=`$debounce$${m}`,y=`$debounce$result$${m}`;return function(...f){this[y]||(this[y]=u?u():void 0),clearTimeout(this[w]),E&&(this[y]=E(this[y],...f),f=[this[y]]),this[w]=setTimeout(()=>{c.apply(this,f),this[y]=u?u():void 0},D)}})}e.$7g=s;function M(D,E,u){return S((c,m)=>{const w=`$throttle$timer$${m}`,y=`$throttle$result$${m}`,f=`$throttle$lastRun$${m}`,v=`$throttle$pending$${m}`;return function(...b){if(this[y]||(this[y]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...b)),this[v])return;const g=this[f]+D;g<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=u?u():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=u?u():void 0},g-Date.now()))}})}e.$8g=M}),define(te[14],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=S,e.$V=new S;function R(h){e.$V.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function s(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(h){c(h)||e.$V.onUnexpectedError(h)}e.$Y=M;function D(h){c(h)||e.$V.onUnexpectedExternalError(h)}e.$Z=D;function E(h){if(h instanceof Error){const{name:t,message:l}=h,r=h.stacktrace||h.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:d.isErrorNoTelemetry(h)}}return h}e.$1=E;const u="Canceled";function c(h){return h instanceof m?!0:h instanceof Error&&h.name===u&&h.message===u}e.$2=c;class m extends Error{constructor(){super(u),this.name=this.message}}e.$3=m;function w(){const h=new Error(u);return h.name=h.message,h}e.$4=w;function y(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$5=y;function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$6=f;class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=v;function b(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$8=b;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=g;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=$;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=o;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const l=new d;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=d;class P extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype)}}e.$ab=P}),define(te[23],ie([0,1,14,132]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(W,B=0){return W[W.length-(1+B)]}e.$qb=s;function M(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.$rb=M;function D(W,B,V=(ce,de)=>ce===de){if(W===B)return!0;if(!W||!B||W.length!==B.length)return!1;for(let ce=0,de=W.length;ce<de;ce++)if(!V(W[ce],B[ce]))return!1;return!0}e.$sb=D;function E(W,B){const V=W.length-1;B<V&&(W[B]=W[V]),W.pop()}e.$tb=E;function u(W,B,V){return c(W.length,ce=>V(W[ce],B))}e.$ub=u;function c(W,B){let V=0,ce=W-1;for(;V<=ce;){const de=(V+ce)/2|0,he=B(de);if(he<0)V=de+1;else if(he>0)ce=de-1;else return de}return-(V+1)}e.$vb=c;function m(W,B,V){if(W=W|0,W>=B.length)throw new TypeError("invalid index");const ce=B[Math.floor(B.length*Math.random())],de=[],he=[],fe=[];for(const ve of B){const be=V(ve,ce);be<0?de.push(ve):be>0?he.push(ve):fe.push(ve)}return W<de.length?m(W,de,V):W<de.length+fe.length?fe[0]:m(W-(de.length+fe.length),he,V)}e.$wb=m;function w(W,B){const V=[];let ce;for(const de of W.slice(0).sort(B))!ce||B(ce[0],de)!==0?(ce=[de],V.push(ce)):ce.push(de);return V}e.$xb=w;function*y(W,B){let V,ce;for(const de of W)ce!==void 0&&B(ce,de)?V.push(de):(V&&(yield V),V=[de]),ce=de;V&&(yield V)}e.$yb=y;function f(W,B){for(let V=0;V<=W.length;V++)B(V===0?void 0:W[V-1],V===W.length?void 0:W[V])}e.$zb=f;function v(W,B){for(let V=0;V<W.length;V++)B(V===0?void 0:W[V-1],W[V],V+1===W.length?void 0:W[V+1])}e.$Ab=v;function b(W,B,V){const ce=[];function de(ve,be,ye){if(be===0&&ye.length===0)return;const Ce=ce[ce.length-1];Ce&&Ce.start+Ce.deleteCount===ve?(Ce.deleteCount+=be,Ce.toInsert.push(...ye)):ce.push({start:ve,deleteCount:be,toInsert:ye})}let he=0,fe=0;for(;;){if(he===W.length){de(he,0,B.slice(fe));break}if(fe===B.length){de(he,W.length-he,[]);break}const ve=W[he],be=B[fe],ye=V(ve,be);ye===0?(he+=1,fe+=1):ye<0?(de(he,1,[]),he+=1):ye>0&&(de(he,0,[be]),fe+=1)}return ce}e.$Bb=b;function g(W,B,V){const ce=b(W,B,V),de=[],he=[];for(const fe of ce)de.push(...W.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:de,added:he}}e.$Cb=g;function $(W,B,V){if(V===0)return[];const ce=W.slice(0,V).sort(B);return d(W,B,ce,V,W.length),ce}e.top=$;function o(W,B,V,ce,de){return V===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const ve=W.length,be=W.slice(0,V).sort(B);for(let ye=V,Ce=Math.min(V+ce,ve);ye<ve;ye=Ce,Ce=Math.min(Ce+ce,ve)){if(ye>V&&await new Promise(je=>setTimeout(je)),de&&de.isCancellationRequested)throw new S.$3;d(W,B,be,ye,Ce)}return be})().then(he,fe)})}e.$Eb=o;function d(W,B,V,ce,de){for(const he=V.length;ce<de;ce++){const fe=W[ce];if(B(fe,V[he-1])<0){V.pop();const ve=(0,R.$ib)(V,be=>B(fe,be)<0);V.splice(ve,0,fe)}}}function P(W){return W.filter(B=>!!B)}e.$Fb=P;function h(W){let B=0;for(let V=0;V<W.length;V++)W[V]&&(W[B]=W[V],B+=1);W.length=B}e.$Gb=h;function t(W,B,V){W.splice(V,0,W.splice(B,1)[0])}e.$Hb=t;function l(W){return!Array.isArray(W)||W.length===0}e.$Ib=l;function r(W){return Array.isArray(W)&&W.length>0}e.$Jb=r;function i(W,B=V=>V){const V=new Set;return W.filter(ce=>{const de=B(ce);return V.has(de)?!1:(V.add(de),!0)})}e.$Kb=i;function n(W){const B=new Set;return V=>{const ce=W(V);return B.has(ce)?!1:(B.add(ce),!0)}}e.$Lb=n;function a(W,B){return W.length>0?W[0]:B}e.$Mb=a;function k(W,B){return W.length>0?W[W.length-1]:B}e.$Nb=k;function I(W,B,V=(ce,de)=>ce===de){let ce=0;for(let de=0,he=Math.min(W.length,B.length);de<he&&V(W[de],B[de]);de++)ce++;return ce}e.$Ob=I;function C(W){return[].concat(...W)}e.$Pb=C;function p(W,B){let V=typeof B=="number"?W:0;typeof B=="number"?V=W:(V=0,B=W);const ce=[];if(V<=B)for(let de=V;de<B;de++)ce.push(de);else for(let de=V;de>B;de--)ce.push(de);return ce}e.$Qb=p;function A(W,B,V){return W.reduce((ce,de)=>(ce[B(de)]=V?V(de):de,ce),Object.create(null))}e.$Rb=A;function L(W,B){return W.push(B),()=>U(W,B)}e.$Sb=L;function U(W,B){const V=W.indexOf(B);if(V>-1)return W.splice(V,1),B}e.$Tb=U;function q(W,B,V){const ce=W.slice(0,B),de=W.slice(B);return ce.concat(V,de)}e.$Ub=q;function se(W,B){let V;if(typeof B=="number"){let ce=B;V=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let ce=W.length-1;ce>0;ce-=1){const de=Math.floor(V()*(ce+1)),he=W[ce];W[ce]=W[de],W[de]=he}}e.$Vb=se;function x(W,B){const V=W.indexOf(B);V>-1&&(W.splice(V,1),W.unshift(B))}e.$Wb=x;function ae(W,B){const V=W.indexOf(B);V>-1&&(W.splice(V,1),W.push(B))}e.$Xb=ae;function ne(W,B){for(const V of B)W.push(V)}e.$Yb=ne;function re(W,B){return Array.isArray(W)?W.map(B):B(W)}e.$Zb=re;function Y(W){return Array.isArray(W)?W:[W]}e.$1b=Y;function J(W){return W[Math.floor(Math.random()*W.length)]}e.$2b=J;function H(W,B,V){const ce=N(W,B),de=W.length,he=V.length;W.length=de+he;for(let fe=de-1;fe>=ce;fe--)W[fe+he]=W[fe];for(let fe=0;fe<he;fe++)W[fe+ce]=V[fe]}e.$3b=H;function F(W,B,V,ce){const de=N(W,B);let he=W.splice(de,V);return he===void 0&&(he=[]),H(W,de,ce),he}e.$4b=F;function N(W,B){return B<0?Math.max(B+W.length,0):Math.min(B,W.length)}var G;(function(W){function B(he){return he<0}W.isLessThan=B;function V(he){return he<=0}W.isLessThanOrEqual=V;function ce(he){return he>0}W.isGreaterThan=ce;function de(he){return he===0}W.isNeitherLessOrGreaterThan=de,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function Z(W,B){return(V,ce)=>B(W(V),W(ce))}e.$5b=Z;function _(...W){return(B,V)=>{for(const ce of W){const de=ce(B,V);if(!G.isNeitherLessOrGreaterThan(de))return de}return G.neitherLessOrGreaterThan}}e.$6b=_;const oe=(W,B)=>W-B;e.$7b=oe;const T=(W,B)=>(0,e.$7b)(W?1:0,B?1:0);e.$8b=T;function O(W){return(B,V)=>-W(B,V)}e.$9b=O;class j{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let V=this.c;for(;V<this.g.length&&B(this.g[V]);)V++;const ce=V===this.c?null:this.g.slice(this.c,V);return this.c=V,ce}takeFromEndWhile(B){let V=this.d;for(;V>=0&&B(this.g[V]);)V--;const ce=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,ce}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const V=this.g.slice(this.c,this.c+B);return this.c+=B,V}}e.$0b=j;class z{static{this.empty=new z(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(V=>(B(V),!0))}toArray(){const B=[];return this.iterate(V=>(B.push(V),!0)),B}filter(B){return new z(V=>this.iterate(ce=>B(ce)?V(ce):!0))}map(B){return new z(V=>this.iterate(ce=>V(B(ce))))}some(B){let V=!1;return this.iterate(ce=>(V=B(ce),!V)),V}findFirst(B){let V;return this.iterate(ce=>B(ce)?(V=ce,!1):!0),V}findLast(B){let V;return this.iterate(ce=>(B(ce)&&(V=ce),!0)),V}findLastMaxBy(B){let V,ce=!0;return this.iterate(de=>((ce||G.isGreaterThan(B(de,V)))&&(ce=!1,V=de),!0)),V}}e.$$b=z}),define(te[135],ie([0,1,14]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function R(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function s(u,c="Unreachable"){throw new Error(c)}e.$vc=s;function M(u){if(!u)throw new S.$ab("Assertion Failed")}e.$wc=M;function D(u){if(!u()){debugger;u(),(0,S.$Y)(new S.$ab("Assertion Failed"))}}e.$xc=D;function E(u,c){let m=0;for(;m<u.length-1;){const w=u[m],y=u[m+1];if(!c(w,y))return!1;m++}return!0}e.$yc=E}),define(te[83],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function S(R){const s=this;let M=!1,D;return function(){return M||(M=!0,D=R.apply(s,arguments)),D}}e.$bb=S}),define(te[67],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=s;const M=Object.freeze([]);function D(){return M}R.empty=D;function*E(h){yield h}R.single=E;function u(h){return s(h)?h:E(h)}R.wrap=u;function c(h){return h||M}R.from=c;function*m(h){for(let t=h.length-1;t>=0;t--)yield h[t]}R.reverse=m;function w(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=w;function y(h){return h[Symbol.iterator]().next().value}R.first=y;function f(h,t){for(const l of h)if(t(l))return!0;return!1}R.some=f;function v(h,t){for(const l of h)if(t(l))return l}R.find=v;function*b(h,t){for(const l of h)t(l)&&(yield l)}R.filter=b;function*g(h,t){let l=0;for(const r of h)yield t(r,l++)}R.map=g;function*$(...h){for(const t of h)for(const l of t)yield l}R.concat=$;function o(h,t,l){let r=l;for(const i of h)r=t(r,i);return r}R.reduce=o;function*d(h,t,l=h.length){for(t<0&&(t+=h.length),l<0?l+=h.length:l>h.length&&(l=h.length);t<l;t++)yield h[t]}R.slice=d;function P(h,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,h];const r=h[Symbol.iterator]();for(let i=0;i<t;i++){const n=r.next();if(n.done)return[l,R.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return r}}]}R.consume=P})(S||(e.Iterable=S={}))}),define(te[44],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,l=!1){let r=0;const i=t.length;let n="",a=0,k=16,I=0;function C(x){let ae=0,ne=0;for(;ae<x;){const re=t.charCodeAt(r);if(re>=48&&re<=57)ne=ne*16+re-48;else if(re>=65&&re<=70)ne=ne*16+re-65+10;else if(re>=97&&re<=102)ne=ne*16+re-97+10;else break;r++,ae++}return ae<x&&(ne=-1),ne}function p(x){r=x,n="",a=0,k=16,I=0}function A(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return I=3,t.substring(x,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;ae=r}else I=3;return t.substring(x,ae)}function L(){let x="",ae=r;for(;;){if(r>=i){x+=t.substring(ae,r),I=2;break}const ne=t.charCodeAt(r);if(ne===34){x+=t.substring(ae,r),r++;break}if(ne===92){if(x+=t.substring(ae,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=C(4);Y>=0?x+=String.fromCharCode(Y):I=4;break}default:I=5}ae=r;continue}if(ne>=0&&ne<=31)if(u(ne)){x+=t.substring(ae,r),I=2;break}else I=6;r++}return x}function U(){if(n="",I=0,a=r,r>=i)return a=i,k=17;let x=t.charCodeAt(r);if(E(x)){do r++,n+=String.fromCharCode(x),x=t.charCodeAt(r);while(E(x));return k=15}if(u(x))return r++,n+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),k=14;switch(x){case 123:return r++,k=1;case 125:return r++,k=2;case 91:return r++,k=3;case 93:return r++,k=4;case 58:return r++,k=6;case 44:return r++,k=5;case 34:return r++,n=L(),k=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!u(t.charCodeAt(r));)r++;return n=t.substring(ae,r),k=12}if(t.charCodeAt(r+1)===42){r+=2;const ne=i-1;let re=!1;for(;r<ne;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,re=!0;break}r++}return re||(r++,I=1),n=t.substring(ae,r),k=13}return n+=String.fromCharCode(x),r++,k=16}case 45:if(n+=String.fromCharCode(x),r++,r===i||!c(t.charCodeAt(r)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),k=11;default:for(;r<i&&q(x);)r++,x=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return n+=String.fromCharCode(x),r++,k=16}}function q(x){if(E(x)||u(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:p,getPosition:()=>r,scan:l?se:U,getToken:()=>k,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>I}}e.$Jm=D;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function w(t,l){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(C,p,A,L){a.value=C,a.offset=p,a.length=A,a.type=L,a.colonOffset=void 0,n=a}try{d(t,{onObjectBegin:(C,p)=>{if(l<=C)throw i;n=void 0,k=l>C,r.push("")},onObjectProperty:(C,p,A)=>{if(l<p||(I(C,p,A,"property"),r[r.length-1]=C,l<=p+A))throw i},onObjectEnd:(C,p)=>{if(l<=C)throw i;n=void 0,r.pop()},onArrayBegin:(C,p)=>{if(l<=C)throw i;n=void 0,r.push(0)},onArrayEnd:(C,p)=>{if(l<=C)throw i;n=void 0,r.pop()},onLiteralValue:(C,p,A)=>{if(l<p||(I(C,p,A,h(C)),l<=p+A))throw i},onSeparator:(C,p,A)=>{if(l<=p)throw i;if(C===":"&&n&&n.type==="property")n.colonOffset=p,k=!1,n=void 0;else if(C===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(k=!0,r[r.length-1]=""),n=void 0}}})}catch(C){if(C!==i)throw C}return{path:r,previousNode:n,isAtPropertyKey:k,matches:C=>{let p=0;for(let A=0;p<C.length&&A<r.length;A++)if(C[p]===r[A]||C[p]==="*")p++;else if(C[p]!=="**")return!1;return p===C.length}}}e.$Km=w;function y(t,l=[],r=M.DEFAULT){let i=null,n=[];const a=[];function k(C){Array.isArray(n)?n.push(C):i!==null&&(n[i]=C)}return d(t,{onObjectBegin:()=>{const C={};k(C),a.push(n),n=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const C=[];k(C),a.push(n),n=C,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:k,onError:(C,p,A)=>{l.push({error:C,offset:p,length:A})}},r),n[0]}e.$Lm=y;function f(t,l=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(C){i.type==="property"&&(i.length=C-i.offset,i=i.parent)}function a(C){return i.children.push(C),C}d(t,{onObjectBegin:C=>{i=a({type:"object",offset:C,length:-1,parent:i,children:[]})},onObjectProperty:(C,p,A)=>{i=a({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:C,offset:p,length:A,parent:i})},onObjectEnd:(C,p)=>{i.length=C+p-i.offset,i=i.parent,n(C+p)},onArrayBegin:(C,p)=>{i=a({type:"array",offset:C,length:-1,parent:i,children:[]})},onArrayEnd:(C,p)=>{i.length=C+p-i.offset,i=i.parent,n(C+p)},onLiteralValue:(C,p,A)=>{a({type:h(C),offset:p,length:A,parent:i,value:C}),n(p+A)},onSeparator:(C,p,A)=>{i.type==="property"&&(C===":"?i.colonOffset=p:C===","&&n(p))},onError:(C,p,A)=>{l.push({error:C,offset:p,length:A})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$Mm=f;function v(t,l){if(!t)return;let r=t;for(const i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Nm=v;function b(t){if(!t.parent||!t.parent.children)return[];const l=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.$Om=b;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const l=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(l[r.children[0].value]=g(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=g;function $(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.$Qm=$;function o(t,l,r=!1){if($(t,l,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const a=o(i[n],l,r);if(a)return a}return t}}e.$Rm=o;function d(t,l,r=M.DEFAULT){const i=D(t,!1);function n(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Z){return Z?_=>Z(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=n(l.onObjectBegin),I=a(l.onObjectProperty),C=n(l.onObjectEnd),p=n(l.onArrayBegin),A=n(l.onArrayEnd),L=a(l.onLiteralValue),U=a(l.onSeparator),q=n(l.onComment),se=a(l.onError),x=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:x||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Z){case 12:case 13:x?re(10):q();break;case 16:re(1);break;case 15:case 14:break;default:return Z}}}function re(Z,_=[],oe=[]){if(se(Z),_.length+oe.length>0){let T=i.getToken();for(;T!==17;){if(_.indexOf(T)!==-1){ne();break}else if(oe.indexOf(T)!==-1)break;T=ne()}}}function Y(Z){const _=i.getTokenValue();return Z?L(_):I(_),ne(),!0}function J(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(re(2),Z=0)}catch{re(2)}L(Z);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return ne(),!0}function H(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(U(":"),ne(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function F(){k(),ne();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),U(","),ne(),i.getToken()===2&&ae)break}else Z&&re(6,[],[]);H()||re(4,[],[2,5]),Z=!0}return C(),i.getToken()!==2?re(7,[2],[]):ne(),!0}function N(){p(),ne();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),U(","),ne(),i.getToken()===4&&ae)break}else Z&&re(6,[],[]);G()||re(4,[],[4,5]),Z=!0}return A(),i.getToken()!==4?re(8,[4],[]):ne(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return F();case 10:return Y(!0);default:return J()}}return ne(),i.getToken()===17?r.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$Sm=d;function P(t,l){const r=D(t),i=[];let n,a=0,k;do switch(k=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==k&&i.push(t.substring(a,k)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$Tm=P;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=h}),define(te[136],ie([0,1,44]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=e.$ES=e.$DS=e.$CS=void 0;function R(c,m,w){let y,f,v,b,g;if(m){for(b=m.offset,g=b+m.length,v=b;v>0&&!u(c,v-1);)v--;let k=g;for(;k<c.length&&!u(c,k);)k++;f=c.substring(v,k),y=D(f,w)}else f=c,y=0,v=0,b=0,g=c.length;const $=E(w,c);let o=!1,d=0,P;w.insertSpaces?P=M(" ",w.tabSize||4):P="	";const h=(0,S.$Jm)(f,!1);let t=!1;function l(){return $+M(P,y+d)}function r(){let k=h.scan();for(o=!1;k===15||k===14;)o=o||k===14,k=h.scan();return t=k===16||h.getTokenError()!==0,k}const i=[];function n(k,I,C){!t&&I<g&&C>b&&c.substring(I,C)!==k&&i.push({offset:I,length:C-I,content:k})}let a=r();if(a!==17){const k=h.getTokenOffset()+v,I=M(P,y);n(I,v,k)}for(;a!==17;){let k=h.getTokenOffset()+h.getTokenLength()+v,I=r(),C="";for(;!o&&(I===12||I===13);){const A=h.getTokenOffset()+v;n(" ",k,A),k=h.getTokenOffset()+h.getTokenLength()+v,C=I===12?l():"",I=r()}if(I===2)a!==1&&(d--,C=l());else if(I===4)a!==3&&(d--,C=l());else{switch(a){case 3:case 1:d++,C=l();break;case 5:case 12:C=l();break;case 13:o?C=l():C=" ";break;case 6:C=" ";break;case 10:if(I===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?C=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}o&&(I===12||I===13)&&(C=l())}const p=h.getTokenOffset()+v;n(C,k,p),a=I}return i}e.$CS=R;function s(c,m){const w=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?w.replace(/\r\n|\r|\n/g,m.eol):w}e.$DS=s;function M(c,m){let w="";for(let y=0;y<m;y++)w+=c;return w}function D(c,m){let w=0,y=0;const f=m.tabSize||4;for(;w<c.length;){const v=c.charAt(w);if(v===" ")y++;else if(v==="	")y+=f;else break;w++}return Math.floor(y/f)}function E(c,m){for(let w=0;w<m.length;w++){const y=m.charAt(w);if(y==="\r")return w+1<m.length&&m.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return c&&c.eol||`
`}e.$ES=E;function u(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}e.$FS=u}),define(te[137],ie([0,1,44,136]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KS=e.$JS=e.$IS=e.$HS=e.$GS=void 0;function s(c,m,w){return M(c,m,void 0,w)}e.$GS=s;function M(c,m,w,y,f){const v=m.slice(),b=[],g=(0,S.$Mm)(c,b);let $,o;for(;v.length>0&&(o=v.pop(),$=(0,S.$Nm)(g,v),$===void 0&&w!==void 0);)typeof o=="string"?w={[o]:w}:w=[w];if($)if($.type==="object"&&typeof o=="string"&&Array.isArray($.children)){const d=(0,S.$Nm)($,[o]);if(d!==void 0)if(w===void 0){if(!d.parent)throw new Error("Malformed AST");const P=$.children.indexOf(d.parent);let h,t=d.parent.offset+d.parent.length;if(P>0){const l=$.children[P-1];h=l.offset+l.length}else h=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return D(c,{offset:h,length:t-h,content:""},y)}else return D(c,{offset:d.offset,length:d.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const P=`${JSON.stringify(o)}: ${JSON.stringify(w)}`,h=f?f($.children.map(l=>l.children[0].value)):$.children.length;let t;if(h>0){const l=$.children[h-1];t={offset:l.offset+l.length,length:0,content:","+P}}else $.children.length===0?t={offset:$.offset+1,length:0,content:P}:t={offset:$.offset+1,length:0,content:P+","};return D(c,t,y)}}else if($.type==="array"&&typeof o=="number"&&Array.isArray($.children))if(w!==void 0){const d=`${JSON.stringify(w)}`;let P;if($.children.length===0||o===0)P={offset:$.offset+1,length:0,content:$.children.length===0?d:d+","};else{const h=o===-1||o>$.children.length?$.children.length:o,t=$.children[h-1];P={offset:t.offset+t.length,length:0,content:","+d}}return D(c,P,y)}else{const d=o,P=$.children[d];let h;if($.children.length===1)h={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===d){const t=$.children[d-1],l=t.offset+t.length,r=$.offset+$.length;h={offset:l,length:r-2-l,content:""}}else h={offset:P.offset,length:$.children[d+1].offset-P.offset,content:""};return D(c,h,y)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${$.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(c,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(w)},y)}}e.$HS=M;function D(c,m,w){let y=E(c,m),f=m.offset,v=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;f>0&&!(0,R.$FS)(y,f-1);)f--;for(;v<y.length&&!(0,R.$FS)(y,v);)v++}const b=(0,R.$CS)(y,{offset:f,length:v-f},w);for(let $=b.length-1;$>=0;$--){const o=b[$];y=E(y,o),f=Math.min(f,o.offset),v=Math.max(v,o.offset+o.length),v+=o.content.length-o.length}const g=c.length-(y.length-v)-f;return[{offset:f,length:g,content:y.substring(f,v)}]}e.$IS=D;function E(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}e.$JS=E;function u(c,m){const w=m.slice(0).sort((f,v)=>{const b=f.offset-v.offset;return b===0?f.length-v.length:b});let y=c.length;for(let f=w.length-1;f>=0;f--){const v=w[f];if(v.offset+v.length<=y)c=E(c,v);else throw new Error("Overlapping edit");y=v.offset}return c}e.$KS=u}),define(te[84],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=S}),define(te[2],ie([0,1,23,133,83,67]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const D=!1;let E=null;class u{constructor(){this.b=new Map}static{this.a=0}c(p){let A=this.b.get(p);return A||(A={parent:null,source:null,isSingleton:!1,value:p,idx:u.a++},this.b.set(p,A)),A}trackDisposable(p){const A=this.c(p);A.source||(A.source=new Error().stack)}setParent(p,A){const L=this.c(p);L.parent=A}markAsDisposed(p){this.b.delete(p)}markAsSingleton(p){this.c(p).isSingleton=!0}f(p,A){const L=A.get(p);if(L)return L;const U=p.parent?this.f(this.c(p.parent),A):p;return A.set(p,U),U}getTrackedDisposables(){const p=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,p).isSingleton).map(([L])=>L).flat()}computeLeakingDisposables(p=10,A){let L;if(A)L=A;else{const ae=new Map,ne=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,ae).isSingleton);if(ne.length===0)return;const re=new Set(ne.map(Y=>Y.value));if(L=ne.filter(Y=>!(Y.parent&&re.has(Y.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function U(ae){function ne(Y,J){for(;Y.length>0&&J.some(H=>typeof H=="string"?H===Y[0]:Y[0].match(H));)Y.shift()}const re=ae.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return ne(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const q=new R.$L;for(const ae of L){const ne=U(ae);for(let re=0;re<=ne.length;re++)q.add(ne.slice(0,re).join(`
`),ae)}L.sort((0,S.$5b)(ae=>ae.idx,S.$7b));let se="",x=0;for(const ae of L.slice(0,p)){x++;const ne=U(ae),re=[];for(let Y=0;Y<ne.length;Y++){let J=ne[Y];J=`(shared with ${q.get(ne.slice(0,Y+1).join(`
`)).size}/${L.length} leaks) at ${J}`;const F=q.get(ne.slice(0,Y).join(`
`)),N=(0,R.$I)([...F].map(G=>U(G)[Y]),G=>G);delete N[ne[Y]];for(const[G,Z]of Object.entries(N))re.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${G}`);re.unshift(J)}se+=`


==================== Leaking disposable ${x}/${L.length}: ${ae.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return L.length>p&&(se+=`


... and ${L.length-p} more leaking disposables

`),{leaks:L,details:se}}}e.$_b=u;function c(C){E=C}if(e.$ac=c,D){const C="__is_disposable_tracked__";c(new class{trackDisposable(p){const A=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[C]||console.log(A)},3e3)}setParent(p,A){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsDisposed(p){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsSingleton(p){}})}function m(C){return E?.trackDisposable(C),C}e.$bc=m;function w(C){E?.markAsDisposed(C)}e.$cc=w;function y(C,p){E?.setParent(C,p)}function f(C,p){if(E)for(const A of C)E.setParent(A,p)}function v(C){return E?.markAsSingleton(C),C}e.$dc=v;function b(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$ec=b;function g(C){if(M.Iterable.is(C)){const p=[];for(const A of C)if(A)try{A.dispose()}catch(L){p.push(L)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$fc=g;function $(C){for(const p of C)b(p)&&p.dispose();return[]}e.$gc=$;function o(...C){const p=d(()=>g(C));return f(C,p),p}e.$hc=o;function d(C){const p=m({dispose:(0,s.$bb)(()=>{w(p),C()})});return p}e.$ic=d;class P{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return y(p,this),this.g?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(p),p.dispose()}}deleteAndLeak(p){p&&this.f.has(p)&&(this.f.delete(p),y(p,null))}}e.$jc=P;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new P,m(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}e.$kc=h;class t{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&y(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&y(p,null),p}}e.$lc=t;class l{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=l;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(p){let A=p;return this.unset=()=>A=void 0,this.isset=()=>A!==void 0,this.dispose=()=>{A&&(A(),A=void 0,w(this))},this}}e.$nc=r;class i{constructor(){this.a=new Map}acquire(p,...A){let L=this.a.get(p);L||(L={counter:0,object:this.b(p,...A)},this.a.set(p,L));const{object:U}=L,q=(0,s.$bb)(()=>{--L.counter===0&&(this.c(p,L.object),this.a.delete(p))});return L.counter++,{object:U,dispose:q}}}e.$oc=i;class n{constructor(p){this.a=p}async acquire(p,...A){const L=this.a.acquire(p,...A);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(U){throw L.dispose(),U}}}e.$pc=n;class a{constructor(p){this.object=p}dispose(){}}e.$qc=a;function k(C){const p=new P;try{C(p)}finally{p.dispose()}}e.$rc=k;class I{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get size(){return this.a.size}get(p){return this.a.get(p)}set(p,A,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(p)?.dispose(),this.a.set(p,A)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=I}),define(te[101],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const D=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const E=new S(M);if(this.a===S.Undefined)this.a=E,this.b=E;else if(D){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(E))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$tc=R}),define(te[33],ie([0,1]),function(K,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function M($,o,d){let P=$.get(o);return P===void 0&&(P=d,$.set(o,P)),P}e.$wi=M;function D($){const o=[];return $.forEach((d,P)=>{o.push(`${P} => ${d}`)}),`Map(${$.size}) {${o.join(", ")}}`}e.$xi=D;function E($){const o=[];return $.forEach(d=>{o.push(d)}),`Set(${$.size}) {${o.join(", ")}}`}e.$yi=E;class u{constructor(o,d){this.uri=o,this.value=d}}function c($){return Array.isArray($)}class m{static{this.a=o=>o.toString()}constructor(o,d){if(this[S]="ResourceMap",o instanceof m)this.b=new Map(o.b),this.c=d??m.a;else if(c(o)){this.b=new Map,this.c=d??m.a;for(const[P,h]of o)this.set(P,h)}else this.b=new Map,this.c=o??m.a}set(o,d){return this.b.set(this.c(o),new u(o,d)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[P,h]of this.b)o(h.value,h.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zi=m;class w{constructor(o,d){this[R]="ResourceSet",!o||typeof o=="function"?this.a=new m(o):(this.a=new m(d),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,d){this.a.forEach((P,h)=>o.call(d,h,h,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=w;var y;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,d=0){const P=this.a.get(o);if(P)return d!==0&&this.j(P,d),P.value}set(o,d,P=0){let h=this.a.get(o);if(h)h.value=d,P!==0&&this.j(h,P);else{switch(h={key:o,value:d,next:void 0,previous:void 0},P){case 0:this.h(h);break;case 1:this.g(h);break;case 2:this.h(h);break;default:this.h(h);break}this.a.set(o,h),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.a.get(o);if(d)return this.a.delete(o),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,d){const P=this.e;let h=this.b;for(;h;){if(d?o.bind(d)(h.value,h.key,this):o(h.value,h.key,this),this.e!==P)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const o=this,d=this.e;let P=this.b;const h={[Symbol.iterator](){return h},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(P){const t={value:P.key,done:!1};return P=P.next,t}else return{value:void 0,done:!0}}};return h}values(){const o=this,d=this.e;let P=this.b;const h={[Symbol.iterator](){return h},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(P){const t={value:P.value,done:!1};return P=P.next,t}else return{value:void 0,done:!0}}};return h}entries(){const o=this,d=this.e;let P=this.b;const h={[Symbol.iterator](){return h},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(P){const t={value:[P.key,P.value],done:!1};return P=P.next,t}else return{value:void 0,done:!0}}};return h}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.b,P=this.size;for(;d&&P>o;)this.a.delete(d.key),d=d.next,P--;this.b=d,this.d=P,d&&(d.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const d=o.next,P=o.previous;if(!d||!P)throw new Error("Invalid list");d.previous=P,P.next=d}o.next=void 0,o.previous=void 0,this.e++}j(o,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.b)return;const P=o.next,h=o.previous;o===this.c?(h.next=void 0,this.c=h):(P.previous=h,h.next=P),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(d===2){if(o===this.c)return;const P=o.next,h=o.previous;o===this.b?(P.previous=void 0,this.b=P):(P.previous=h,h.next=P),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((d,P)=>{o.push([P,d])}),o}fromJSON(o){this.clear();for(const[d,P]of o)this.set(d,P)}}e.$Bi=f;class v extends f{constructor(o,d=1){super(),this.k=o,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=v;class b{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let d=this.a.get(o)||0;return d===0?!1:(d--,d===0?this.a.delete(o):this.a.set(o,d),!0)}has(o){return this.a.has(o)}}e.$Di=b;class g{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[d,P]of o)this.set(d,P)}clear(){this.a.clear(),this.b.clear()}set(o,d){this.a.set(o,d),this.b.set(d,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const d=this.a.get(o);return d===void 0?!1:(this.a.delete(o),this.b.delete(d),!0)}forEach(o,d){this.a.forEach((P,h)=>{o.call(d,P,h,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=g}),define(te[85],ie([0,1,33]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const R=new S.$Ci(1e4);function s(c){return u(c,"NFC",R)}e.$hl=s;const M=new S.$Ci(1e4);function D(c){return u(c,"NFD",M)}e.$il=D;const E=/[^\u0000-\u0080]/;function u(c,m,w){if(!c)return c;const y=w.get(c);if(y)return y;let f;return E.test(c)?f=c.normalize(m):f=c,w.set(c,f),f}e.$jl=function(){const c=/[\u0300-\u036f]/g;return function(m){return D(m).replace(c,"")}}()}),define(te[138],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function S(E,u,c){return Math.min(Math.max(E,u),c)}e.$Hl=S;function R(E,u){return(u+E%u)%u}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=s;class M{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=M;class D{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=D}),function(){function K(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(u){M.push(u,Date.now())}function E(){const u=[];for(let c=0;c<M.length;c+=2)u.push({name:M[c],startTime:M[c+1]});return u}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:K)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return K[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=K,S.c=e,S.d=function(R,s,M){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:M})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)S.d(M,D,function(E){return R[E]}.bind(null,D));return M},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(K,e,S){(function(R){var s;e=K.exports=oe,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],c=0,m=c++;u[m]="0|[1-9]\\d*";var w=c++;u[w]="[0-9]+";var y=c++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;u[f]="("+u[m]+")\\.("+u[m]+")\\.("+u[m]+")";var v=c++;u[v]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var b=c++;u[b]="(?:"+u[m]+"|"+u[y]+")";var g=c++;u[g]="(?:"+u[w]+"|"+u[y]+")";var $=c++;u[$]="(?:-("+u[b]+"(?:\\."+u[b]+")*))";var o=c++;u[o]="(?:-?("+u[g]+"(?:\\."+u[g]+")*))";var d=c++;u[d]="[0-9A-Za-z-]+";var P=c++;u[P]="(?:\\+("+u[d]+"(?:\\."+u[d]+")*))";var h=c++,t="v?"+u[f]+u[$]+"?"+u[P]+"?";u[h]="^"+t+"$";var l="[v=\\s]*"+u[v]+u[o]+"?"+u[P]+"?",r=c++;u[r]="^"+l+"$";var i=c++;u[i]="((?:<|>)?=?)";var n=c++;u[n]=u[w]+"|x|X|\\*";var a=c++;u[a]=u[m]+"|x|X|\\*";var k=c++;u[k]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[$]+")?"+u[P]+"?)?)?";var I=c++;u[I]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[o]+")?"+u[P]+"?)?)?";var C=c++;u[C]="^"+u[i]+"\\s*"+u[k]+"$";var p=c++;u[p]="^"+u[i]+"\\s*"+u[I]+"$";var A=c++;u[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;u[L]="(?:~>?)";var U=c++;u[U]="(\\s*)"+u[L]+"\\s+",E[U]=new RegExp(u[U],"g");var q=c++;u[q]="^"+u[L]+u[k]+"$";var se=c++;u[se]="^"+u[L]+u[I]+"$";var x=c++;u[x]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[x]+"\\s+",E[ae]=new RegExp(u[ae],"g");var ne=c++;u[ne]="^"+u[x]+u[k]+"$";var re=c++;u[re]="^"+u[x]+u[I]+"$";var Y=c++;u[Y]="^"+u[i]+"\\s*("+l+")$|^$";var J=c++;u[J]="^"+u[i]+"\\s*("+t+")$|^$";var H=c++;u[H]="(\\s*)"+u[i]+"\\s*("+l+"|"+u[k]+")",E[H]=new RegExp(u[H],"g");var F=c++;u[F]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var N=c++;u[N]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var G=c++;u[G]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)s(Z,u[Z]),E[Z]||(E[Z]=new RegExp(u[Z]));function _(X,le){if(X instanceof oe)return X;if(typeof X!="string"||X.length>M||!(le?E[r]:E[h]).test(X))return null;try{return new oe(X,le)}catch{return null}}function oe(X,le){if(X instanceof oe){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(X,le);s("SemVer",X,le),this.loose=le;var ge=X.trim().match(le?E[r]:E[h]);if(!ge)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<D)return Re}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=_,e.valid=function(X,le){var ge=_(X,le);return ge?ge.version:null},e.clean=function(X,le){var ge=_(X.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof oe||(X=new oe(X,this.loose)),this.compareMain(X)||this.comparePre(X)},oe.prototype.compareMain=function(X){return X instanceof oe||(X=new oe(X,this.loose)),O(this.major,X.major)||O(this.minor,X.minor)||O(this.patch,X.patch)},oe.prototype.comparePre=function(X){if(X instanceof oe||(X=new oe(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Pe=X.prerelease[le];if(s("prerelease compare",le,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return O(ge,Pe)}while(++le)},oe.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new oe(X,ge).inc(le,Pe).version}catch{return null}},e.diff=function(X,le){if(B(X,le))return null;var ge=_(X),Pe=_(le);if(ge.prerelease.length||Pe.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Pe[Re])return Re},e.compareIdentifiers=O;var T=/^[0-9]+$/;function O(X,le){var ge=T.test(X),Pe=T.test(le);return ge&&Pe&&(X=+X,le=+le),ge&&!Pe?-1:Pe&&!ge?1:X<le?-1:X>le?1:0}function j(X,le,ge){return new oe(X,ge).compare(new oe(le,ge))}function z(X,le,ge){return j(X,le,ge)>0}function W(X,le,ge){return j(X,le,ge)<0}function B(X,le,ge){return j(X,le,ge)===0}function V(X,le,ge){return j(X,le,ge)!==0}function ce(X,le,ge){return j(X,le,ge)>=0}function de(X,le,ge){return j(X,le,ge)<=0}function he(X,le,ge,Pe){var Re;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),Re=X===ge;break;case"!==":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),Re=X!==ge;break;case"":case"=":case"==":Re=B(X,ge,Pe);break;case"!=":Re=V(X,ge,Pe);break;case">":Re=z(X,ge,Pe);break;case">=":Re=ce(X,ge,Pe);break;case"<":Re=W(X,ge,Pe);break;case"<=":Re=de(X,ge,Pe);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function fe(X,le){if(X instanceof fe){if(X.loose===le)return X;X=X.value}if(!(this instanceof fe))return new fe(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return O(le,X)},e.major=function(X,le){return new oe(X,le).major},e.minor=function(X,le){return new oe(X,le).minor},e.patch=function(X,le){return new oe(X,le).patch},e.compare=j,e.compareLoose=function(X,le){return j(X,le,!0)},e.rcompare=function(X,le,ge){return j(le,X,ge)},e.sort=function(X,le){return X.sort(function(ge,Pe){return e.compare(ge,Pe,le)})},e.rsort=function(X,le){return X.sort(function(ge,Pe){return e.rcompare(ge,Pe,le)})},e.gt=z,e.lt=W,e.eq=B,e.neq=V,e.gte=ce,e.lte=de,e.cmp=he,e.Comparator=fe;var ve={};function be(X,le){if(X instanceof be)return X.loose===le?X:new be(X.raw,le);if(X instanceof fe)return new be(X.value,le);if(!(this instanceof be))return new be(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function ye(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ce(X,le,ge,Pe,Re,Ue,Oe,Be,We,Q,ue,$e,ke){return((le=ye(ge)?"":ye(Pe)?">="+ge+".0.0":ye(Re)?">="+ge+"."+Pe+".0":">="+le)+" "+(Be=ye(We)?"":ye(Q)?"<"+(+We+1)+".0.0":ye(ue)?"<"+We+"."+(+Q+1)+".0":$e?"<="+We+"."+Q+"."+ue+"-"+$e:"<="+Be)).trim()}function je(X,le){for(var ge=0;ge<X.length;ge++)if(!X[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<X.length;ge++)if(s(X[ge].semver),X[ge].semver!==ve&&X[ge].semver.prerelease.length>0){var Pe=X[ge].semver;if(Pe.major===le.major&&Pe.minor===le.minor&&Pe.patch===le.patch)return!0}return!1}return!0}function me(X,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(X)}function we(X,le,ge,Pe){var Re,Ue,Oe,Be,We;switch(X=new oe(X,Pe),le=new be(le,Pe),ge){case">":Re=z,Ue=de,Oe=W,Be=">",We=">=";break;case"<":Re=W,Ue=ce,Oe=z,Be="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(X,le,Pe))return!1;for(var Q=0;Q<le.set.length;++Q){var ue=le.set[Q],$e=null,ke=null;if(ue.forEach(function(Ae){Ae.semver===ve&&(Ae=new fe(">=0.0.0")),$e=$e||Ae,ke=ke||Ae,Re(Ae.semver,$e.semver,Pe)?$e=Ae:Oe(Ae.semver,ke.semver,Pe)&&(ke=Ae)}),$e.operator===Be||$e.operator===We||(!ke.operator||ke.operator===Be)&&Ue(X,ke.semver)||ke.operator===We&&Oe(X,ke.semver))return!1}return!0}fe.prototype.parse=function(X){var le=this.loose?E[Y]:E[J],ge=X.match(le);if(!ge)throw new TypeError("Invalid comparator: "+X);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===ve||(typeof X=="string"&&(X=new oe(X,this.loose)),he(X,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(X,le){if(!(X instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(X.value,le),me(this.value,ge,le);if(X.operator==="")return ge=new be(this.value,le),me(X.semver,ge,le);var Pe=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ue=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=he(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=he(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Pe||Re||Ue&&Oe||Be||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var ge=le?E[N]:E[F];X=X.replace(ge,Ce),s("hyphen replace",X),X=X.replace(E[H],"$1$2$3"),s("comparator trim",X,E[H]),X=(X=(X=X.replace(E[U],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var Pe=le?E[Y]:E[J],Re=X.split(" ").map(function(Ue){return function(Oe,Be){return s("comp",Oe),Oe=function(We,Q){return We.trim().split(/\s+/).map(function(ue){return function($e,ke){s("caret",$e,ke);var Ae=ke?E[re]:E[ne];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe){var He;return s("caret",$e,Fe,Le,Ne,ze,qe),ye(Le)?He="":ye(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":ye(ze)?He=Le==="0"?">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+".0 <"+(+Le+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+Ne+"."+(+ze+1):">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+ze+qe+" <"+(+Le+1)+".0.0"):(s("no pr"),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+ze+" <"+Le+"."+Ne+"."+(+ze+1):">="+Le+"."+Ne+"."+ze+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+ze+" <"+(+Le+1)+".0.0"),s("caret return",He),He})}(ue,Q)}).join(" ")}(Oe,Be),s("caret",Oe),Oe=function(We,Q){return We.trim().split(/\s+/).map(function(ue){return function($e,ke){var Ae=ke?E[se]:E[q];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe){var He;return s("tilde",$e,Fe,Le,Ne,ze,qe),ye(Le)?He="":ye(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":ye(ze)?He=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+(+Ne+1)+".0"):He=">="+Le+"."+Ne+"."+ze+" <"+Le+"."+(+Ne+1)+".0",s("tilde return",He),He})}(ue,Q)}).join(" ")}(Oe,Be),s("tildes",Oe),Oe=function(We,Q){return s("replaceXRanges",We,Q),We.split(/\s+/).map(function(ue){return function($e,ke){$e=$e.trim();var Ae=ke?E[p]:E[C];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe,He){s("xRange",$e,Fe,Le,Ne,ze,qe,He);var xe=ye(Ne),Xe=xe||ye(ze),tt=Xe||ye(qe);return Le==="="&&tt&&(Le=""),xe?Fe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&tt?(Xe&&(ze=0),tt&&(qe=0),Le===">"?(Le=">=",Xe?(Ne=+Ne+1,ze=0,qe=0):tt&&(ze=+ze+1,qe=0)):Le==="<="&&(Le="<",Xe?Ne=+Ne+1:ze=+ze+1),Fe=Le+Ne+"."+ze+"."+qe):Xe?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":tt&&(Fe=">="+Ne+"."+ze+".0 <"+Ne+"."+(+ze+1)+".0"),s("xRange return",Fe),Fe})}(ue,Q)}).join(" ")}(Oe,Be),s("xrange",Oe),Oe=function(We,Q){return s("replaceStars",We,Q),We.trim().replace(E[G],"")}(Oe,Be),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Pe)})),Re=Re.map(function(Ue){return new fe(Ue,le)})},be.prototype.intersects=function(X,le){if(!(X instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return X.set.some(function(Re){return Re.every(function(Ue){return Pe.intersects(Ue,le)})})})})},e.toComparators=function(X,le){return new be(X,le).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new oe(X,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],X))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(X,le,ge){var Pe=null,Re=null;try{var Ue=new be(le,ge)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Pe&&Re.compare(Oe)!==-1||(Re=new oe(Pe=Oe,ge)))}),Pe},e.minSatisfying=function(X,le,ge){var Pe=null,Re=null;try{var Ue=new be(le,ge)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Pe&&Re.compare(Oe)!==1||(Re=new oe(Pe=Oe,ge)))}),Pe},e.validRange=function(X,le){try{return new be(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,ge){return we(X,le,"<",ge)},e.gtr=function(X,le,ge){return we(X,le,">",ge)},e.outside=we,e.prerelease=function(X,le){var ge=_(X,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(X,le,ge){return X=new be(X,ge),le=new be(le,ge),X.intersects(le)},e.coerce=function(X){if(X instanceof oe)return X;if(typeof X!="string")return null;var le=X.match(E[A]);return le==null?null:_((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(K,e){var S,R,s=K.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(g){if(S===setTimeout)return setTimeout(g,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(g,0);try{return S(g,0)}catch{try{return S.call(null,g,0)}catch{return S.call(this,g,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var u,c=[],m=!1,w=-1;function y(){m&&u&&(m=!1,u.length?c=u.concat(c):w=-1,c.length&&f())}function f(){if(!m){var g=E(y);m=!0;for(var $=c.length;$;){for(u=c,c=[];++w<$;)u&&u[w].run();w=-1,$=c.length}u=null,m=!1,function(o){if(R===clearTimeout)return clearTimeout(o);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(o);try{R(o)}catch{try{return R.call(null,o)}catch{return R.call(this,o)}}}(g)}}function v(g,$){this.fun=g,this.array=$}function b(){}s.nextTick=function(g){var $=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)$[o-1]=arguments[o];c.push(new v(g,$)),c.length!==1||m||E(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(g){return[]},s.binding=function(g){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(g){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class R{constructor(E,u,c){this.level=E,this.key=u,this.value=c,this.forward=[]}}const s=void 0;class M{constructor(E,u=2**16){this.comparator=E,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s)}has(E){return!!M.g(this,E,this.comparator)}get(E){return M.g(this,E,this.comparator)?.value}set(E,u){return M.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=M.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let c=this.e.forward[0];for(;c;)E.call(u,c.value,c.key,this),c=c.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,c){let m=E.e;for(let w=E.d-1;w>=0;w--)for(;m.forward[w]&&c(m.forward[w].key,u)<0;)m=m.forward[w];if(m=m.forward[0],m&&c(m.key,u)===0)return m}static h(E,u,c,m){const w=[];let y=E.e;for(let f=E.d-1;f>=0;f--){for(;y.forward[f]&&m(y.forward[f].key,u)<0;)y=y.forward[f];w[f]=y}if(y=y.forward[0],y&&m(y.key,u)===0)return y.value=c,!1;{const f=M.j(E);if(f>E.d){for(let v=E.d;v<f;v++)w[v]=E.e;E.d=f}y=new R(f,u,c);for(let v=0;v<f;v++)y.forward[v]=w[v].forward[v],w[v].forward[v]=y;return!0}}static j(E,u=.5){let c=1;for(;Math.random()<u&&c<E.c;)c+=1;return c}static k(E,u,c){const m=[];let w=E.e;for(let y=E.d-1;y>=0;y--){for(;w.forward[y]&&c(w.forward[y].key,u)<0;)w=w.forward[y];m[y]=w}if(w=w.forward[0],!w||c(w.key,u)!==0)return!1;for(let y=0;y<E.d&&m[y].forward[y]===w;y++)m[y].forward[y]=w.forward[y];for(;E.d>0&&E.e.forward[E.d-1]===s;)E.d-=1;return!0}}e.$or=M}),define(te[68],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=R}),define(te[3],ie([0,1,14,83,2,101,68]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const E=!1,u=!1;var c;(function(C){C.None=()=>s.$kc.None;function p(he){if(u){const{onDidAddListener:fe}=he,ve=v.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function A(he,fe){return J(he,()=>{},0,void 0,!0,void 0,fe)}C.defer=A;function L(he){return(fe,ve=null,be)=>{let ye=!1,Ce;return Ce=he(je=>{if(!ye)return Ce?Ce.dispose():ye=!0,fe.call(ve,je)},null,be),ye&&Ce.dispose(),Ce}}C.once=L;function U(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>be.call(ye,fe(je)),null,Ce),ve)}C.map=U;function q(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>{fe(je),be.call(ye,je)},null,Ce),ve)}C.forEach=q;function se(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>fe(je)&&be.call(ye,je),null,Ce),ve)}C.filter=se;function x(he){return he}C.signal=x;function ae(...he){return(fe,ve=null,be)=>{const ye=(0,s.$hc)(...he.map(Ce=>Ce(je=>fe.call(ve,je))));return Y(ye,be)}}C.any=ae;function ne(he,fe,ve,be){let ye=ve;return U(he,Ce=>(ye=fe(ye,Ce),ye),be)}C.reduce=ne;function re(he,fe){let ve;const be={onWillAddFirstListener(){ve=he(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};fe||p(be);const ye=new d(be);return fe?.add(ye),ye.event}function Y(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function J(he,fe,ve=100,be=!1,ye=!1,Ce,je){let me,we,X,le=0,ge;const Pe={leakWarningThreshold:Ce,onWillAddFirstListener(){me=he(Ue=>{le++,we=fe(we,Ue),be&&!X&&(Re.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,X=void 0,(!be||le>1)&&Re.fire(Oe),le=0},typeof ve=="number"?(clearTimeout(X),X=setTimeout(ge,ve)):X===void 0&&(X=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,me.dispose()}};je||p(Pe);const Re=new d(Pe);return je?.add(Re),Re.event}C.debounce=J;function H(he,fe=0,ve){return C.debounce(he,(be,ye)=>be?(be.push(ye),be):[ye],fe,void 0,!0,void 0,ve)}C.accumulate=H;function F(he,fe=(be,ye)=>be===ye,ve){let be=!0,ye;return se(he,Ce=>{const je=be||!fe(Ce,ye);return be=!1,ye=Ce,je},ve)}C.latch=F;function N(he,fe,ve){return[C.filter(he,fe,ve),C.filter(he,be=>!fe(be),ve)]}C.split=N;function G(he,fe=!1,ve=[],be){let ye=ve.slice(),Ce=he(we=>{ye?ye.push(we):me.fire(we)});be&&be.add(Ce);const je=()=>{ye?.forEach(we=>me.fire(we)),ye=null},me=new d({onWillAddFirstListener(){Ce||(Ce=he(we=>me.fire(we)),be&&be.add(Ce))},onDidAddFirstListener(){ye&&(fe?setTimeout(je):je())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return be&&be.add(me),me.event}C.buffer=G;function Z(he,fe){return(be,ye,Ce)=>{const je=fe(new oe);return he(function(me){const we=je.evaluate(me);we!==_&&be.call(ye,we)},void 0,Ce)}}C.chain=Z;const _=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:_),this}reduce(fe,ve){let be=ve;return this.f.push(ye=>(be=fe(be,ye),be)),this}latch(fe=(ve,be)=>ve===be){let ve=!0,be;return this.f.push(ye=>{const Ce=ve||!fe(ye,be);return ve=!1,be=ye,Ce?ye:_}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===_)break;return fe}}function T(he,fe,ve=be=>be){const be=(...me)=>je.fire(ve(...me)),ye=()=>he.on(fe,be),Ce=()=>he.removeListener(fe,be),je=new d({onWillAddFirstListener:ye,onDidRemoveLastListener:Ce});return je.event}C.fromNodeEventEmitter=T;function O(he,fe,ve=be=>be){const be=(...me)=>je.fire(ve(...me)),ye=()=>he.addEventListener(fe,be),Ce=()=>he.removeEventListener(fe,be),je=new d({onWillAddFirstListener:ye,onDidRemoveLastListener:Ce});return je.event}C.fromDOMEventEmitter=O;function j(he){return new Promise(fe=>L(he)(fe))}C.toPromise=j;function z(he){const fe=new d;return he.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}C.fromPromise=z;function W(he,fe){return fe(void 0),he(ve=>fe(ve))}C.runAndSubscribe=W;function B(he,fe){let ve=null;function be(Ce){ve?.dispose(),ve=new s.$jc,fe(Ce,ve)}be(void 0);const ye=he(Ce=>be(Ce));return(0,s.$ic)(()=>{ye.dispose(),ve?.dispose()})}C.runAndSubscribeWithStore=B;class V{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||p(be),this.emitter=new d(be),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(he,fe){return new V(he,fe).emitter.event}C.fromObservable=ce;function de(he){return fe=>{let ve=0,be=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(he.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(ye),he.reportChanges(),{dispose(){he.removeObserver(ye)}}}}C.fromObservableLight=de})(c||(e.Event=c={}));class m{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${m.f++}`,m.all.add(this)}start(p){this.g=new D.$bd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$dd=m;let w=-1;function y(C){const p=w;return w=C,{dispose(){w=p}}}e.$ed=y;class f{constructor(p,A=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=A,this.g=0}dispose(){this.f?.clear()}check(p,A){const L=this.threshold;if(L<=0||A<L)return;this.f||(this.f=new Map);const U=this.f.get(p.value)||0;if(this.f.set(p.value,U+1),this.g-=1,this.g<=0){this.g=L*.5;let q,se=0;for(const[x,ae]of this.f)(!q||se<ae)&&(q=x,se=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${se}):`),console.warn(q)}return()=>{const q=this.f.get(p.value)||0;this.f.set(p.value,q-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class g{constructor(p){this.value=p,this.id=b++}}const $=2,o=(C,p)=>{if(C instanceof g)p(C);else for(let A=0;A<C.length;A++){const L=C[A];L&&p(L)}};class d{constructor(p){this.x=0,this.f=p,this.g=w>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const p=this.t;queueMicrotask(()=>{o(p,A=>A.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,A,L)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$kc.None;if(this.m)return s.$kc.None;A&&(p=p.bind(A));const U=new g(p);let q,se;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),q=this.g.check(U.stack,this.x+1)),E&&(U.stack=se??v.create()),this.t?this.t instanceof g?(this.u??=new h,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.x++;const x=(0,s.$ic)(()=>{q?.(),this.y(U)});return L instanceof s.$jc?L.add(x):Array.isArray(L)&&L.push(x),x},this.q}y(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const A=this.t,L=A.indexOf(p);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,A[L]=void 0;const U=this.u.current===this;if(this.x*$<=A.length){let q=0;for(let se=0;se<A.length;se++)A[se]?A[q++]=A[se]:U&&(this.u.end--,q<this.u.i&&this.u.i--);A.length=q}}z(p,A){if(!p)return;const L=this.f?.onListenerError||S.$Y;if(!L){p.value(A);return}try{p.value(A)}catch(U){L(U)}}A(p){const A=p.current.t;for(;p.i<p.end;)this.z(A[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof g)this.z(this.t,p);else{const A=this.u;A.enqueue(this,p,this.t.length),this.A(A)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=d;const P=()=>new h;e.$gd=P;class h{constructor(){this.i=-1,this.end=0}enqueue(p,A,L){this.i=0,this.end=L,this.current=p,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(p,A,L){if(this.t)for(this.h||(this.h=new M.$tc),o(this.t,U=>this.h.push([U.value,p]));this.h.size>0&&!A.isCancellationRequested;){const[U,q]=this.h.shift(),se=[],x={...q,token:A,waitUntil:ae=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,U)),se.push(ae)}};try{U(x)}catch(ae){(0,S.$Y)(ae);continue}Object.freeze(se),await Promise.allSettled(se).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,S.$Y)(ne.reason)})}}}e.$hd=t;class l extends d{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new M.$tc,this.w=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.w(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.x&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$id=l;class r extends l{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$jd=r;class i extends d{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$kd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const A={event:p,listener:null};this.h.push(A),this.g&&this.m(A);const L=()=>{this.g&&this.o(A);const U=this.h.indexOf(A);this.h.splice(U,1)};return(0,s.$ic)((0,R.$bb)(L))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(A=>this.f.fire(A))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$ld=n;class a{constructor(p,A,L,U){this.f=new s.$jc;const q=this.f.add(new n),se=this.f.add(new s.$sc);function x(ae){se.set(ae,q.add(U(ae)))}for(const ae of p)x(ae);this.f.add(A(ae=>{x(ae)})),this.f.add(L(ae=>{se.deleteAndDispose(ae)})),this.event=q.event}dispose(){this.f.dispose()}}e.$md=a;class k{constructor(){this.f=[]}wrapEvent(p){return(A,L,U)=>p(q=>{const se=this.f[this.f.length-1];se?se.push(()=>A.call(L,q)):A.call(L,q)},void 0,U)}bufferEvents(p){const A=[];this.f.push(A);const L=p();return this.f.pop(),A.forEach(U=>U()),L}}e.$nd=k;class I{constructor(){this.f=!1,this.g=c.None,this.h=s.$kc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=I}),define(te[22],ie([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const R=Object.freeze(function(E,u){const c=setTimeout(E.bind(u),0);return{dispose(){clearTimeout(c)}}});var s;(function(E){function u(c){return c===E.None||c===E.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}E.isCancellationToken=u,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$pd=D}),define(te[140],ie([0,1,22]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class R{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new S.$pd,u=this.b(E.token);return this.a={promise:u,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$he=R;class s{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const u=JSON.stringify(E);return this.b!==u&&(this.b=u,this.a=this.c(E)),this.a}}e.$ie=s;class M{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const u=this.b(E);return this.a.set(E,u),u}}e.$je=M}),define(te[61],ie([0,1,14,2]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function s(P){const h=P;return h?typeof h.read=="function":!1}e.$qd=s;function M(P){const h=P;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$rd=M;function D(P){const h=P;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$sd=D;function E(P,h){return new u(P,h)}e.$td=E;class u{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,S.$Y)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let l;switch(h){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(P,h){const t=[];let l;for(;(l=P.read())!==null;)t.push(l);return h(t)}e.$ud=c;function m(P,h,t){const l=[];let r;for(;(r=P.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?h(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return P.read()}}}e.$vd=m;function w(P,h){return new Promise((t,l)=>{const r=[];y(P,{onData:i=>{h&&r.push(i)},onError:i=>{h?l(i):t(void 0)},onEnd:()=>{t(h?h(r):void 0)}})})}e.$wd=w;function y(P,h,t){P.on("error",l=>{t?.isCancellationRequested||h.onError(l)}),P.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),P.on("data",l=>{t?.isCancellationRequested||h.onData(l)})}e.$xd=y;function f(P,h){return new Promise((t,l)=>{const r=new R.$jc,i=[],n=I=>{if(i.push(I),i.length>h)return r.dispose(),P.pause(),t({stream:P,buffer:i,ended:!1})},a=I=>(r.dispose(),l(I)),k=()=>(r.dispose(),t({stream:P,buffer:i,ended:!0}));r.add((0,R.$ic)(()=>P.removeListener("error",a))),P.on("error",a),r.add((0,R.$ic)(()=>P.removeListener("end",k))),P.on("end",k),r.add((0,R.$ic)(()=>P.removeListener("data",n))),P.on("data",n)})}e.$yd=f;function v(P,h){const t=E(h);return t.end(P),t}e.$zd=v;function b(){const P=E(()=>{throw new Error("not supported")});return P.end(),P}e.$Ad=b;function g(P){let h=!1;return{read:()=>h?null:(h=!0,P)}}e.$Bd=g;function $(P,h,t){const l=E(t);return y(P,{onData:r=>l.write(h.data(r)),onError:r=>l.error(h.error?h.error(r):r),onEnd:()=>l.end()}),l}e.$Cd=$;function o(P,h,t){let l=!1;return{read:()=>{const r=h.read();return l?r:(l=!0,r!==null?t([P,r]):P)}}}e.$Dd=o;function d(P,h,t){let l=!1;const r=E(t);return y(h,{onData:i=>l?r.write(i):(l=!0,r.write(t([P,i]))),onError:i=>r.error(i),onEnd:()=>{l||(l=!0,r.write(P)),r.end()}}),r}e.$Ed=d}),define(te[17],ie([0,1,84,61]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const s=typeof Buffer<"u",M=new S.$T(()=>new Uint8Array(256));let D,E;class u{static alloc(A){return s?new u(Buffer.allocUnsafe(A)):new u(new Uint8Array(A))}static wrap(A){return s&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new u(A)}static fromString(A,L){return!(L?.dontUseNodeBuffer||!1)&&s?new u(Buffer.from(A)):(D||(D=new TextEncoder),new u(D.encode(A)))}static fromByteArray(A){const L=u.alloc(A.length);for(let U=0,q=A.length;U<q;U++)L.buffer[U]=A[U];return L}static concat(A,L){if(typeof L>"u"){L=0;for(let se=0,x=A.length;se<x;se++)L+=A[se].byteLength}const U=u.alloc(L);let q=0;for(let se=0,x=A.length;se<x;se++){const ae=A[se];U.set(ae,q),q+=ae.byteLength}return U}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=u.alloc(this.byteLength);return A.set(this),A}toString(){return s?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(A,L){return new u(this.buffer.subarray(A,L))}set(A,L){if(A instanceof u)this.buffer.set(A.buffer,L);else if(A instanceof Uint8Array)this.buffer.set(A,L);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),L);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return y(this.buffer,A)}writeUInt32BE(A,L){f(this.buffer,A,L)}readUInt32LE(A){return v(this.buffer,A)}writeUInt32LE(A,L){b(this.buffer,A,L)}readUInt8(A){return g(this.buffer,A)}writeUInt8(A,L){$(this.buffer,A,L)}indexOf(A,L=0){return c(this.buffer,A instanceof u?A.buffer:A,L)}}e.$Fd=u;function c(p,A,L=0){const U=A.byteLength,q=p.byteLength;if(U===0)return 0;if(U===1)return p.indexOf(A[0]);if(U>q-L)return-1;const se=M.value;se.fill(A.length);for(let re=0;re<A.length;re++)se[A[re]]=A.length-re-1;let x=L+A.length-1,ae=x,ne=-1;for(;x<q;)if(p[x]===A[ae]){if(ae===0){ne=x;break}x--,ae--}else x+=Math.max(A.length-ae,se[p[x]]),ae=A.length-1;return ne}e.$Gd=c;function m(p,A){return p[A+0]<<0>>>0|p[A+1]<<8>>>0}e.$Hd=m;function w(p,A,L){p[L+0]=A&255,A=A>>>8,p[L+1]=A&255}e.$Id=w;function y(p,A){return p[A]*2**24+p[A+1]*2**16+p[A+2]*2**8+p[A+3]}e.$Jd=y;function f(p,A,L){p[L+3]=A,A=A>>>8,p[L+2]=A,A=A>>>8,p[L+1]=A,A=A>>>8,p[L]=A}e.$Kd=f;function v(p,A){return p[A+0]<<0>>>0|p[A+1]<<8>>>0|p[A+2]<<16>>>0|p[A+3]<<24>>>0}e.$Ld=v;function b(p,A,L){p[L+0]=A&255,A=A>>>8,p[L+1]=A&255,A=A>>>8,p[L+2]=A&255,A=A>>>8,p[L+3]=A&255}e.$Md=b;function g(p,A){return p[A]}e.$Nd=g;function $(p,A,L){p[L]=A}e.$Od=$;function o(p){return R.$ud(p,A=>u.concat(A))}e.$Pd=o;function d(p){return R.$Bd(p)}e.$Qd=d;function P(p){return R.$wd(p,A=>u.concat(A))}e.$Rd=P;async function h(p){return p.ended?u.concat(p.buffer):u.concat([...p.buffer,await P(p.stream)])}e.$Sd=h;function t(p){return R.$zd(p,A=>u.concat(A))}e.$Td=t;function l(p){return R.$Cd(p,{data:A=>typeof A=="string"?u.fromString(A):u.wrap(A)},A=>u.concat(A))}e.$Ud=l;function r(p){return R.$td(A=>u.concat(A),p)}e.$Vd=r;function i(p,A){return R.$Dd(p,A,L=>u.concat(L))}e.$Wd=i;function n(p,A){return R.$Ed(p,A,L=>u.concat(L))}e.$Xd=n;function a(p){let A=0,L=0,U=0;const q=new Uint8Array(Math.floor(p.length/4*3)),se=ae=>{switch(L){case 3:q[U++]=A|ae,L=0;break;case 2:q[U++]=A|ae>>>2,A=ae<<6,L=3;break;case 1:q[U++]=A|ae>>>4,A=ae<<4,L=2;break;default:A=ae<<2,L=1}};for(let ae=0;ae<p.length;ae++){const ne=p.charCodeAt(ae);if(ne>=65&&ne<=90)se(ne-65);else if(ne>=97&&ne<=122)se(ne-97+26);else if(ne>=48&&ne<=57)se(ne-48+52);else if(ne===43||ne===45)se(62);else if(ne===47||ne===95)se(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${p[ae]}`)}}const x=U;for(;L>0;)se(0);return u.wrap(q).slice(0,x)}e.$Yd=a;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:p},A=!0,L=!1){const U=L?I:k;let q="";const se=p.byteLength%3;let x=0;for(;x<p.byteLength-se;x+=3){const ae=p[x+0],ne=p[x+1],re=p[x+2];q+=U[ae>>>2],q+=U[(ae<<4|ne>>>4)&63],q+=U[(ne<<2|re>>>6)&63],q+=U[re&63]}if(se===1){const ae=p[x+0];q+=U[ae>>>2],q+=U[ae<<4&63],A&&(q+="==")}else if(se===2){const ae=p[x+0],ne=p[x+1];q+=U[ae>>>2],q+=U[(ae<<4|ne>>>4)&63],q+=U[ne<<2&63],A&&(q+="=")}return q}e.$Zd=C}),define(te[26],ie([0,1,140,84]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function s(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.$me=s;const M=/{(\d+)}/g;function D(Q,...ue){return ue.length===0?Q:Q.replace(M,function($e,ke){const Ae=parseInt(ke,10);return isNaN(Ae)||Ae<0||Ae>=ue.length?$e:ue[Ae]})}e.$ne=D;const E=/{([^}]+)}/g;function u(Q,ue){return Q.replace(E,($e,ke)=>ue[ke]??$e)}e.$oe=u;function c(Q){return Q.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$pe=c;function m(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=m;function w(Q,ue){let $e=0;const ke=ue.charCodeAt(0);for(let Ae=Q.length-1;Ae>=0;Ae--)Q.charCodeAt(Ae)===ke&&$e++;return $e}e.$re=w;function y(Q,ue,$e="\u2026"){return Q.length<=ue?Q:`${Q.substr(0,ue)}${$e}`}e.$se=y;function f(Q,ue=" "){const $e=v(Q,ue);return b($e,ue)}e.$te=f;function v(Q,ue){if(!Q||!ue)return Q;const $e=ue.length;if($e===0||Q.length===0)return Q;let ke=0;for(;Q.indexOf(ue,ke)===ke;)ke=ke+$e;return Q.substring(ke)}e.$ue=v;function b(Q,ue){if(!Q||!ue)return Q;const $e=ue.length,ke=Q.length;if($e===0||ke===0)return Q;let Ae=ke,Fe=-1;for(;Fe=Q.lastIndexOf(ue,Ae-1),!(Fe===-1||Fe+$e!==Ae);){if(Fe===0)return"";Ae=Fe}return Q.substring(0,Ae)}e.$ve=b;function g(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=g;function $(Q){return Q.replace(/\*/g,"")}e.$xe=$;function o(Q,ue,$e={}){if(!Q)throw new Error("Cannot create regex from empty string");ue||(Q=m(Q)),$e.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let ke="";return $e.global&&(ke+="g"),$e.matchCase||(ke+="i"),$e.multiline&&(ke+="m"),$e.unicode&&(ke+="u"),new RegExp(Q,ke)}e.$ye=o;function d(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.$ze=d;function P(Q){return Q.split(/\r\n|\r|\n/)}e.$Ae=P;function h(Q){for(let ue=0,$e=Q.length;ue<$e;ue++){const ke=Q.charCodeAt(ue);if(ke!==32&&ke!==9)return ue}return-1}e.$Be=h;function t(Q,ue=0,$e=Q.length){for(let ke=ue;ke<$e;ke++){const Ae=Q.charCodeAt(ke);if(Ae!==32&&Ae!==9)return Q.substring(ue,ke)}return Q.substring(ue,$e)}e.$Ce=t;function l(Q,ue=Q.length-1){for(let $e=ue;$e>=0;$e--){const ke=Q.charCodeAt($e);if(ke!==32&&ke!==9)return $e}return-1}e.$De=l;function r(Q,ue,$e){const ke=[];let Ae=0;for(const Fe of Q.matchAll(ue)){if(ke.push(Q.slice(Ae,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ae=Fe.index+Fe[0].length,ke.push($e(Fe[0],...Fe.slice(1),Fe.index,Q,Fe.groups))}return ke.push(Q.slice(Ae)),Promise.all(ke).then(Fe=>Fe.join(""))}e.$Ee=r;function i(Q,ue){return Q<ue?-1:Q>ue?1:0}e.$Fe=i;function n(Q,ue,$e=0,ke=Q.length,Ae=0,Fe=ue.length){for(;$e<ke&&Ae<Fe;$e++,Ae++){const ze=Q.charCodeAt($e),qe=ue.charCodeAt(Ae);if(ze<qe)return-1;if(ze>qe)return 1}const Le=ke-$e,Ne=Fe-Ae;return Le<Ne?-1:Le>Ne?1:0}e.$Ge=n;function a(Q,ue){return k(Q,ue,0,Q.length,0,ue.length)}e.$He=a;function k(Q,ue,$e=0,ke=Q.length,Ae=0,Fe=ue.length){for(;$e<ke&&Ae<Fe;$e++,Ae++){let ze=Q.charCodeAt($e),qe=ue.charCodeAt(Ae);if(ze===qe)continue;if(ze>=128||qe>=128)return n(Q.toLowerCase(),ue.toLowerCase(),$e,ke,Ae,Fe);C(ze)&&(ze-=32),C(qe)&&(qe-=32);const He=ze-qe;if(He!==0)return He}const Le=ke-$e,Ne=Fe-Ae;return Le<Ne?-1:Le>Ne?1:0}e.$Ie=k;function I(Q){return Q>=48&&Q<=57}e.$Je=I;function C(Q){return Q>=97&&Q<=122}e.$Ke=C;function p(Q){return Q>=65&&Q<=90}e.$Le=p;function A(Q,ue){return Q.length===ue.length&&k(Q,ue)===0}e.$Me=A;function L(Q,ue){const $e=ue.length;return ue.length>Q.length?!1:k(Q,ue,0,$e)===0}e.$Ne=L;function U(Q,ue){const $e=Math.min(Q.length,ue.length);let ke;for(ke=0;ke<$e;ke++)if(Q.charCodeAt(ke)!==ue.charCodeAt(ke))return ke;return $e}e.$Oe=U;function q(Q,ue){const $e=Math.min(Q.length,ue.length);let ke;const Ae=Q.length-1,Fe=ue.length-1;for(ke=0;ke<$e;ke++)if(Q.charCodeAt(Ae-ke)!==ue.charCodeAt(Fe-ke))return ke;return $e}e.$Pe=q;function se(Q){return 55296<=Q&&Q<=56319}e.$Qe=se;function x(Q){return 56320<=Q&&Q<=57343}e.$Re=x;function ae(Q,ue){return(Q-55296<<10)+(ue-56320)+65536}e.$Se=ae;function ne(Q,ue,$e){const ke=Q.charCodeAt($e);if(se(ke)&&$e+1<ue){const Ae=Q.charCodeAt($e+1);if(x(Ae))return ae(ke,Ae)}return ke}e.$Te=ne;function re(Q,ue){const $e=Q.charCodeAt(ue-1);if(x($e)&&ue>1){const ke=Q.charCodeAt(ue-2);if(se(ke))return ae(ke,$e)}return $e}class Y{get offset(){return this.e}constructor(ue,$e=0){this.c=ue,this.d=ue.length,this.e=$e}setOffset(ue){this.e=ue}prevCodePoint(){const ue=re(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=ne(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Ue=Y;class J{get offset(){return this.c.offset}constructor(ue,$e=0){this.c=new Y(ue,$e)}nextGraphemeLength(){const ue=le.getInstance(),$e=this.c,ke=$e.offset;let Ae=ue.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Fe=$e.offset,Le=ue.getGraphemeBreakType($e.nextCodePoint());if(we(Ae,Le)){$e.setOffset(Fe);break}Ae=Le}return $e.offset-ke}prevGraphemeLength(){const ue=le.getInstance(),$e=this.c,ke=$e.offset;let Ae=ue.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Fe=$e.offset,Le=ue.getGraphemeBreakType($e.prevCodePoint());if(we(Le,Ae)){$e.setOffset(Fe);break}Ae=Le}return ke-$e.offset}eol(){return this.c.eol()}}e.$Ve=J;function H(Q,ue){return new J(Q,ue).nextGraphemeLength()}e.$We=H;function F(Q,ue){return new J(Q,ue).prevGraphemeLength()}e.$Xe=F;function N(Q,ue){ue>0&&x(Q.charCodeAt(ue))&&ue--;const $e=ue+H(Q,ue);return[$e-F(Q,$e),$e]}e.$Ye=N;function G(Q){const ue=new J(Q);let $e=0;for(;!ue.eol();)$e++,ue.nextGraphemeLength();return $e}e.$Ze=G;let Z;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Q){return Z||(Z=_()),Z.test(Q)}e.$1e=oe;const T=/^[\t\n\r\x20-\x7E]*$/;function O(Q){return T.test(Q)}e.$2e=O,e.$3e=/[\u2028\u2029]/;function j(Q){return e.$3e.test(Q)}e.$4e=j;function z(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.$5e=z;function W(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.$6e=W;function B(Q,ue){if(Q.length<ue)return Q;const $e=/\b/g;let ke=0;for(;$e.test(Q)&&!(Q.length-$e.lastIndex<ue);)ke=$e.lastIndex,$e.lastIndex+=1;return Q.substring(ke).replace(/^\s/,"")}e.$7e=B;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(Q){return Q&&(Q=Q.replace(V,"").replace(ce,"")),Q}e.$8e=de,e.$9e=String.fromCharCode(65279);function he(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.$0e=he;function fe(Q){return he(Q)?Q.substr(1):Q}e.$$e=fe;function ve(Q,ue){if(!Q||!ue||Q.length<ue.length)return!1;const $e=ue.length,ke=Q.toLowerCase();let Ae=0,Fe=-1;for(;Ae<$e;){const Le=ke.indexOf(ue[Ae],Fe+1);if(Le<0)return!1;Fe=Le,Ae++}return!0}e.$_e=ve;function be(Q,ue=!1){return Q?(ue&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.$af=be;function ye(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.$bf=ye;function Ce(Q,ue=1){if(ue===0)return"";let $e=-1;do $e=Q.indexOf(`
`,$e+1),ue--;while(ue>0&&$e>=0);return $e===-1?Q:(Q[$e-1]==="\r"&&$e--,Q.substr(0,$e))}e.$cf=Ce;function je(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.$df=je;function me(Q){return le.getInstance().getGraphemeBreakType(Q)}e.$ef=me;function we(Q,ue){return Q===0?ue!==5&&ue!==7:Q===2&&ue===3?!1:Q===4||Q===2||Q===3||ue===4||ue===2||ue===3?!0:!(Q===8&&(ue===8||ue===9||ue===11||ue===12)||(Q===11||Q===9)&&(ue===9||ue===10)||(Q===12||Q===10)&&ue===10||ue===5||ue===13||ue===7||Q===1||Q===13&&ue===14||Q===6&&ue===6)}var X;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const $e=this.d,ke=$e.length/3;let Ae=1;for(;Ae<=ke;)if(ue<$e[3*Ae])Ae=2*Ae;else if(ue>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(Q,ue){if(Q===0)return 0;const $e=Re(Q,ue);if($e!==void 0)return $e;const ke=new Y(ue,Q);return ke.prevCodePoint(),ke.offset}e.$ff=Pe;function Re(Q,ue){const $e=new Y(ue,Q);let ke=$e.prevCodePoint();for(;Ue(ke)||ke===65039||ke===8419;){if($e.offset===0)return;ke=$e.prevCodePoint()}if(!W(ke))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===8205&&(Ae=$e.offset),Ae}function Ue(Q){return 127995<=Q&&Q<=127999}var Oe;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$gf="\xA0";class Be{static{this.c=new R.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$ie(ue=>{function $e(He){const xe=new Map;for(let Xe=0;Xe<He.length;Xe+=2)xe.set(He[Xe],He[Xe+1]);return xe}function ke(He,xe){const Xe=new Map(He);for(const[tt,nt]of xe)Xe.set(tt,nt);return Xe}function Ae(He,xe){if(!He)return xe;const Xe=new Map;for(const[tt,nt]of He)xe.has(tt)&&Xe.set(tt,nt);return Xe}const Fe=this.c.value;let Le=ue.filter(He=>!He.startsWith("_")&&He in Fe);Le.length===0&&(Le=["_default"]);let Ne;for(const He of Le){const xe=$e(Fe[He]);Ne=Ae(Ne,xe)}const ze=$e(Fe._common),qe=ke(ze,Ne);return new Be(qe)})}static getInstance(ue){return Be.d.get(Array.from(ue))}static{this.e=new R.$T(()=>Object.keys(Be.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Be.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=Be;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ue){return We.e().has(ue)}static get codePoints(){return We.e()}}e.$if=We}),define(te[55],ie([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function R($){return s($,0)}e.$pi=R;function s($,o){switch(typeof $){case"object":return $===null?M(349,o):Array.isArray($)?u($,o):c($,o);case"string":return E($,o);case"boolean":return D($,o);case"number":return M($,o);case"undefined":return M(937,o);default:return M(617,o)}}e.$qi=s;function M($,o){return(o<<5)-o+$|0}e.$ri=M;function D($,o){return M($?433:863,o)}function E($,o){o=M(149417,o);for(let d=0,P=$.length;d<P;d++)o=M($.charCodeAt(d),o);return o}e.$si=E;function u($,o){return o=M(104579,o),$.reduce((d,P)=>s(P,d),o)}function c($,o){return o=M(181387,o),Object.keys($).sort().reduce((d,P)=>(d=E(P,d),s($[P],d)),o)}class m{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=s(o,this.g),this.g}}e.$ti=m;var w;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y($,o,d=32){const P=d-o,h=~((1<<P)-1);return($<<o|(h&$)>>>P)>>>0}function f($,o=0,d=$.byteLength,P=0){for(let h=0;h<d;h++)$[o+h]=P}function v($,o,d="0"){for(;$.length<o;)$=d+$;return $}function b($,o=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(d=>d.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),o/4)}e.$ui=b;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const d=o.length;if(d===0)return;const P=this.p;let h=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=o.charCodeAt(0),r=0);;){let i=l;if(S.$Qe(l))if(r+1<d){const n=o.charCodeAt(r+1);S.$Re(n)?(r++,i=S.$Se(l,n)):i=65533}else{t=l;break}else S.$Re(l)&&(i=65533);if(h=this.w(P,h,i),r++,r<d)l=o.charCodeAt(r);else break}this.r=h,this.u=t}w(o,d,P){return P<128?o[d++]=P:P<2048?(o[d++]=192|(P&1984)>>>6,o[d++]=128|(P&63)>>>0):P<65536?(o[d++]=224|(P&61440)>>>12,o[d++]=128|(P&4032)>>>6,o[d++]=128|(P&63)>>>0):(o[d++]=240|(P&1835008)>>>18,o[d++]=128|(P&258048)>>>12,o[d++]=128|(P&4032)>>>6,o[d++]=128|(P&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=g.g,d=this.q;for(let k=0;k<64;k+=4)o.setUint32(k,d.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)o.setUint32(k,y(o.getUint32(k-12,!1)^o.getUint32(k-32,!1)^o.getUint32(k-56,!1)^o.getUint32(k-64,!1),1),!1);let P=this.h,h=this.l,t=this.m,l=this.n,r=this.o,i,n,a;for(let k=0;k<80;k++)k<20?(i=h&t|~h&l,n=1518500249):k<40?(i=h^t^l,n=1859775393):k<60?(i=h&t|h&l|t&l,n=2400959708):(i=h^t^l,n=3395469782),a=y(P,5)+i+r+n+o.getUint32(k*4,!1)&4294967295,r=l,l=t,t=y(h,30),h=P,P=a;this.h=this.h+P&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$vi=g}),define(te[69],ie([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const M="error",D="warning",E="warn",u="info",c="ignore";function m(y){return y?S.$Me(M,y)?s.Error:S.$Me(D,y)||S.$Me(E,y)?s.Warning:S.$Me(u,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function w(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return u;default:return c}}s.toString=w}(R||(R={})),e.default=R}),define(te[141],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(te[56],ie([0,1,23,26]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const v=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return v-b}value(){return this.b[this.c]}}e.$Dh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,R.$Ge)(f,this.b,0,f.length,this.c,this.d):(0,R.$Ie)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=M;class D{constructor(f=!0,v=!0){this.f=f,this.g=v}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let v=f.length-1;v>=0;v--,this.c--){const b=this.b.charCodeAt(v);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,R.$Ge)(f,this.b,0,f.length,this.d,this.e):(0,R.$Ie)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=D;var E;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(E||(E={}));class u{constructor(f,v){this.f=f,this.g=v,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,R.$He)(f,this.c.scheme);if(this.d[this.e]===2)return(0,R.$He)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,R.$Fe)(f,this.c.query);if(this.d[this.e]===5)return(0,R.$Fe)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(m||(m={}));class w{static forUris(f=()=>!1,v=()=>!1){return new w(new u(f,v))}static forPaths(f=!1){return new w(new D(void 0,!f))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,v){if(v){const b=v.slice(0);(0,S.$Vb)(b);for(const g of b)this.set(g,f)}else{const b=f.slice(0);(0,S.$Vb)(b);for(const g of b)this.set(g[0],g[1])}}set(f,v){const b=this.b.reset(f);let g;this.c||(this.c=new c,this.c.segment=b.value());const $=[];for(g=this.c;;){const d=b.cmp(g.segment);if(d>0)g.left||(g.left=new c,g.left.segment=b.value()),$.push([-1,g]),g=g.left;else if(d<0)g.right||(g.right=new c,g.right.segment=b.value()),$.push([1,g]),g=g.right;else if(b.hasNext())b.next(),g.mid||(g.mid=new c,g.mid.segment=b.value()),$.push([0,g]),g=g.mid;else break}const o=g.value;g.value=v,g.key=f;for(let d=$.length-1;d>=0;d--){const P=$[d][1];P.updateHeight();const h=P.balanceFactor();if(h<-1||h>1){const t=$[d][0],l=$[d+1][0];if(t===1&&l===1)$[d][1]=P.rotateLeft();else if(t===-1&&l===-1)$[d][1]=P.rotateRight();else if(t===1&&l===-1)P.right=$[d+1][1]=$[d+1][1].rotateRight(),$[d][1]=P.rotateLeft();else if(t===-1&&l===1)P.left=$[d+1][1]=$[d+1][1].rotateLeft(),$[d][1]=P.rotateRight();else throw new Error;if(d>0)switch($[d-1][0]){case-1:$[d-1][1].left=$[d][1];break;case 1:$[d-1][1].right=$[d][1];break;case 0:$[d-1][1].mid=$[d][1];break}else this.c=$[0][1]}}return o}get(f){return this.d(f)?.value}d(f){const v=this.b.reset(f);let b=this.c;for(;b;){const g=v.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else break}return b}has(f){const v=this.d(f);return!(v?.value===void 0&&v?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,v){const b=this.b.reset(f),g=[];let $=this.c;for(;$;){const o=b.cmp($.segment);if(o>0)g.push([-1,$]),$=$.left;else if(o<0)g.push([1,$]),$=$.right;else if(b.hasNext())b.next(),g.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const o=this.f($.right);if(o.key){const{key:d,value:P,segment:h}=o;this.e(o.key,!1),$.key=d,$.value=P,$.segment=h}}else{const o=$.left??$.right;if(g.length>0){const[d,P]=g[g.length-1];switch(d){case-1:P.left=o;break;case 0:P.mid=o;break;case 1:P.right=o;break}}else this.c=o}for(let o=g.length-1;o>=0;o--){const d=g[o][1];d.updateHeight();const P=d.balanceFactor();if(P>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),g[o][1]=d.rotateLeft()):P<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),g[o][1]=d.rotateRight()),o>0)switch(g[o-1][0]){case-1:g[o-1][1].left=g[o][1];break;case 1:g[o-1][1].right=g[o][1];break;case 0:g[o-1][1].mid=g[o][1];break}else this.c=g[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const v=this.b.reset(f);let b=this.c,g;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),g=b.value||g,b=b.mid;else break}return b&&b.value||g}findSuperstr(f){return this.g(f,!1)}g(f,v){const b=this.b.reset(f);let g=this.c;for(;g;){const $=b.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else return g.mid?this.h(g.mid):v?g.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[v,b]of this)f(b,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const v=[];return this.j(f,v),v[Symbol.iterator]()}j(f,v){f&&(f.left&&this.j(f.left,v),f.value&&v.push([f.key,f.value]),f.mid&&this.j(f.mid,v),f.right&&this.j(f.right,v))}_isBalanced(){const f=v=>{if(!v)return!0;const b=v.balanceFactor();return b<-1||b>1?!1:f(v.left)&&f(v.right)};return f(this.c)}}e.$Hh=w}),define(te[12],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function S(h){return typeof h=="string"}e.$jf=S;function R(h){return Array.isArray(h)&&h.every(t=>S(t))}e.$kf=R;function s(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$lf=s;function M(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$mf=M;function D(h){return typeof h=="number"&&!isNaN(h)}e.$nf=D;function E(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$of=E;function u(h){return h===!0||h===!1}e.$pf=u;function c(h){return typeof h>"u"}e.$qf=c;function m(h){return!w(h)}e.$rf=m;function w(h){return c(h)||h===null}e.$sf=w;function y(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=y;function f(h){if(w(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$uf=f;function v(...h){const t=[];for(let l=0;l<h.length;l++){const r=h[l];if(w(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}e.$vf=v;const b=Object.prototype.hasOwnProperty;function g(h){if(!s(h))return!1;for(const t in h)if(b.call(h,t))return!1;return!0}e.$wf=g;function $(h){return typeof h=="function"}e.$xf=$;function o(...h){return h.length>0&&h.every($)}e.$yf=o;function d(h,t){const l=Math.min(h.length,t.length);for(let r=0;r<l;r++)P(h[r],t[r])}e.$zf=d;function P(h,t){if(S(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(h instanceof t)return}catch{}if(!w(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=P}),define(te[70],ie([0,1,12]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=void 0;const R=Object.create(null);function s(E,u){if((0,S.$jf)(u)){const c=R[u];if(c===void 0)throw new Error(`${E} references an unknown codicon: ${u}`);u=c}return R[E]=u,{id:E}}function M(){return R}e.$Nj=M;function D(){return Object.values(e.$Pj)}e.$Oj=D,e.$Pj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const o=Array.isArray($)?[]:{};return Object.entries($).forEach(([d,P])=>{o[d]=P&&typeof P=="object"?R(P):P}),o}e.$Vm=R;function s($){if(!$||typeof $!="object")return $;const o=[$];for(;o.length>0;){const d=o.shift();Object.freeze(d);for(const P in d)if(M.call(d,P)){const h=d[P];typeof h=="object"&&!Object.isFrozen(h)&&!(0,S.$mf)(h)&&o.push(h)}}return $}e.$Wm=s;const M=Object.prototype.hasOwnProperty;function D($,o){return E($,o,new Set)}e.$Xm=D;function E($,o,d){if((0,S.$sf)($))return $;const P=o($);if(typeof P<"u")return P;if(Array.isArray($)){const h=[];for(const t of $)h.push(E(t,o,d));return h}if((0,S.$lf)($)){if(d.has($))throw new Error("Cannot clone recursive data-structure");d.add($);const h={};for(const t in $)M.call($,t)&&(h[t]=E($[t],o,d));return d.delete($),h}return $}function u($,o,d=!0){return(0,S.$lf)($)?((0,S.$lf)(o)&&Object.keys(o).forEach(P=>{P in $?d&&((0,S.$lf)($[P])&&(0,S.$lf)(o[P])?u($[P],o[P],d):$[P]=o[P]):$[P]=o[P]}),$):o}e.$Ym=u;function c($,o){if($===o)return!0;if($==null||o===null||o===void 0||typeof $!=typeof o||typeof $!="object"||Array.isArray($)!==Array.isArray(o))return!1;let d,P;if(Array.isArray($)){if($.length!==o.length)return!1;for(d=0;d<$.length;d++)if(!c($[d],o[d]))return!1}else{const h=[];for(P in $)h.push(P);h.sort();const t=[];for(P in o)t.push(P);if(t.sort(),!c(h,t))return!1;for(d=0;d<h.length;d++)if(!c($[h[d]],o[h[d]]))return!1}return!0}e.$Zm=c;function m($){const o=new Set;return JSON.stringify($,(d,P)=>{if((0,S.$lf)(P)||Array.isArray(P)){if(o.has(P))return"[Circular]";o.add(P)}return P})}e.$1m=m;function w($,o){const d=Object.create(null);return!$||!o||Object.keys(o).forEach(h=>{const t=$[h],l=o[h];c(t,l)||(d[h]=l)}),d}e.$2m=w;function y($,o){const d=o.toLowerCase(),P=Object.keys($).find(h=>h.toLowerCase()===d);return P?$[P]:$[o]}e.$3m=y;function f($,o){const d=Object.create(null);for(const[P,h]of Object.entries($))o(P,h)&&(d[P]=h);return d}e.$4m=f;function v($){let o=[];for(;Object.prototype!==$;)o=o.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return o}e.$5m=v;function b($){const o=[];for(const d of v($))typeof $[d]=="function"&&o.push(d);return o}e.$6m=b;function g($,o){const d=h=>function(){const t=Array.prototype.slice.call(arguments,0);return o(h,t)},P={};for(const h of $)P[h]=d(h);return P}e.$7m=g}),define(te[102],ie([0,1,70]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var R;(function(D){function E(u){return u&&typeof u=="object"&&typeof u.id=="string"}D.isThemeColor=E})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$Qj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(o){const d=E.exec(o.id);if(!d)return u(S.$Pj.error);const[,P,h]=d,t=["codicon","codicon-"+P];return h&&t.push("codicon-modifier-"+h.substring(1)),t}D.asClassNameArray=u;function c(o){return u(o).join(" ")}D.asClassName=c;function m(o){return"."+u(o).join(".")}D.asCSSSelector=m;function w(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||R.isThemeColor(o.color))}D.isThemeIcon=w;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(o){const d=y.exec(o);if(!d)return;const[,P]=d;return{id:P}}D.fromString=f;function v(o){return{id:o}}D.fromId=v;function b(o,d){let P=o.id;const h=P.lastIndexOf("~");return h!==-1&&(P=P.substring(0,h)),d&&(P=`${P}~${d}`),{id:P}}D.modify=b;function g(o){const d=o.id.lastIndexOf("~");if(d!==-1)return o.id.substring(d+1)}D.getModifier=g;function $(o,d){return o.id===d.id&&o.color?.id===d.color?.id}D.isEqual=$})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$3f=R,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const M=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let u=0,c="";return c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c+="-",c+=D[M[u++]],c+=D[M[u++]],c+="-",c+=D[M[u++]],c+=D[M[u++]],c+="-",c+=D[M[u++]],c+=D[M[u++]],c+="-",c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c+=D[M[u++]],c}}()}),define(te[142],ie([0,1,71,45,83]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$US=void 0;async function M(D,E){if(await new Promise((m,w)=>{const y=R.createReadStream(D),f=S.createHash("sha1");y.pipe(f);const v=(0,s.$bb)((b,g)=>{y.removeAllListeners(),f.removeAllListeners(),b?w(b):m(g)});y.once("error",v),y.once("end",v),f.once("error",v),f.once("data",b=>v(void 0,b.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.$US=M}),define(te[143],ie([0,1,27]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const E=D.replace(/\-/g,":").toLowerCase();return!R.has(E)}function M(){const D=(0,S.networkInterfaces)();for(const E in D){const u=D[E];if(u){for(const{mac:c}of u)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=M}),define(te[86],ie([0,1,27,56,31,143]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(c){return this.a||(this.a=R.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,m=0;const w=(0,S.networkInterfaces)();for(const y in w){const f=w[y];if(f)for(const{mac:v,internal:b}of f)b||(m+=1,this.c(v.toUpperCase())&&(c+=1))}this.b=m>0?c/m:0}return this.b}};let D;async function E(c){return D||(D=(async()=>await u(c)||s.$4f())()),D}e.$Im=E;async function u(c){try{const m=await new Promise((y,f)=>{K(["crypto"],y,f)}),w=(0,M.$Gm)();return m.createHash("sha256").update(w,"utf8").digest("hex")}catch(m){c(m);return}}}),define(te[103],ie([0,1,87]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function R(E,u,c,m=1){let w=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!w)return w=!0,y(0)},c);s(E,u,m,v=>{if(!w)return w=!0,clearTimeout(f),y(v)})})}e.$6f=R;function s(E,u,c,m){if(u===0)return m(0);const w=new S.Socket;w.once("connect",()=>(D(w),s(E+c,u-1,c,m))),w.once("data",()=>{}),w.once("error",y=>(D(w),y.code!=="ECONNREFUSED"?s(E+c,u-1,c,m):m(E))),w.connect(E,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(E,u,c,m="127.0.0.1"){let w=!1,y,f=1;const v=S.createServer({pauseOnConnect:!0});function b(g,$){w||(w=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(g))}return new Promise(g=>{y=setTimeout(()=>{b(0,g)},c),v.on("listening",()=>{b(E,g)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&f<u?(E++,f++,v.listen(E,m)):b(0,g)}),v.on("close",()=>{b(0,g)}),v.listen(E,m)})}e.$8f=M;function D(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(u){console.error(u)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function S(u){const c=new Set;if(Array.isArray(u))for(const m of u)typeof m=="string"&&c.add(m);return Array.from(c)}function R(){const u=e();return u?Array.from(u):[]}function s(u){if(process.platform!=="win32")return;const c=e();if(c)if(typeof u=="string")c.add(u.toLowerCase());else for(const m of S(u))s(m)}function M(u){if(typeof u!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const w of c){if(u.indexOf(w)!==0)continue;const f=u.indexOf("\\",w.length);if(f===-1)continue;const v=u.substring(w.length,f);if(v){m=v;break}}return m}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YS=e.$XS=void 0,e.$XS="vscode:contextmenu",e.$YS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6S=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$6S=S}),define(te[38],ie([0,1,15,14]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZS=void 0;class s{constructor(){this.a=new WeakMap}on(D,E){const u=(c,...m)=>{this.b(D,c)&&E(c,...m)};return this.a.set(E,u),S.ipcMain.on(D,u),this}once(D,E){return S.ipcMain.once(D,(u,...c)=>{this.b(D,u)&&E(u,...c)}),this}handle(D,E){return S.ipcMain.handle(D,(u,...c)=>this.b(D,u)?E(u,...c):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,E){const u=this.a.get(E);return u&&(S.ipcMain.removeListener(D,u),this.a.delete(E)),this}b(D,E){if(!D||!D.startsWith("vscode:"))return(0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=E.senderFrame,c=u.url;if(!c||c==="about:blank")return!0;let m="unknown";try{m=new URL(c).host}catch{return(0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${c}'.`),!1}return m!=="vscode-app"?((0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${m}'.`),!1):u.parent!==null?((0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.$ZS=new s}),define(te[146],ie([0,1,15,38,144]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=void 0;function M(){R.$ZS.on(s.$XS,(E,u,c,m,w)=>{const y=D(E,m,c);y.popup({window:S.BrowserWindow.fromWebContents(E.sender)??void 0,x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&E.sender.send(s.$YS,u)}})})}e.$1S=M;function D(E,u,c){const m=new S.Menu;return c.forEach(w=>{let y;w.type==="separator"?y=new S.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new S.MenuItem({submenu:D(E,u,w.submenu),label:w.label}):y=new S.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(f,v,b)=>E.sender.send(u,w.id,b)}),m.append(y)}),m}}),define(te[147],ie([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const R=60,s=R*60,M=s*24,D=M*7,E=M*30,u=M*365;function c(w,y,f,v){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,S.localize)(0,null,c(new Date().getTime()+b*1e3,!1));if(!v&&b<30)return(0,S.localize)(1,null);let g;return b<R?(g=b,y?g===1?f?(0,S.localize)(2,null,g):(0,S.localize)(3,null,g):f?(0,S.localize)(4,null,g):(0,S.localize)(5,null,g):g===1?f?(0,S.localize)(6,null,g):(0,S.localize)(7,null,g):f?(0,S.localize)(8,null,g):(0,S.localize)(9,null,g)):b<s?(g=Math.floor(b/R),y?g===1?f?(0,S.localize)(10,null,g):(0,S.localize)(11,null,g):f?(0,S.localize)(12,null,g):(0,S.localize)(13,null,g):g===1?f?(0,S.localize)(14,null,g):(0,S.localize)(15,null,g):f?(0,S.localize)(16,null,g):(0,S.localize)(17,null,g)):b<M?(g=Math.floor(b/s),y?g===1?f?(0,S.localize)(18,null,g):(0,S.localize)(19,null,g):f?(0,S.localize)(20,null,g):(0,S.localize)(21,null,g):g===1?f?(0,S.localize)(22,null,g):(0,S.localize)(23,null,g):f?(0,S.localize)(24,null,g):(0,S.localize)(25,null,g)):b<D?(g=Math.floor(b/M),y?g===1?(0,S.localize)(26,null,g):(0,S.localize)(27,null,g):g===1?(0,S.localize)(28,null,g):(0,S.localize)(29,null,g)):b<E?(g=Math.floor(b/D),y?g===1?f?(0,S.localize)(30,null,g):(0,S.localize)(31,null,g):f?(0,S.localize)(32,null,g):(0,S.localize)(33,null,g):g===1?f?(0,S.localize)(34,null,g):(0,S.localize)(35,null,g):f?(0,S.localize)(36,null,g):(0,S.localize)(37,null,g)):b<u?(g=Math.floor(b/E),y?g===1?f?(0,S.localize)(38,null,g):(0,S.localize)(39,null,g):f?(0,S.localize)(40,null,g):(0,S.localize)(41,null,g):g===1?f?(0,S.localize)(42,null,g):(0,S.localize)(43,null,g):f?(0,S.localize)(44,null,g):(0,S.localize)(45,null,g)):(g=Math.floor(b/u),y?g===1?f?(0,S.localize)(46,null,g):(0,S.localize)(47,null,g):f?(0,S.localize)(48,null,g):(0,S.localize)(49,null,g):g===1?f?(0,S.localize)(50,null,g):(0,S.localize)(51,null,g):f?(0,S.localize)(52,null,g):(0,S.localize)(53,null,g))}e.$6l=c;function m(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=m}),define(te[149],ie([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,12,149]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function M(w,y){return y&&(w.stack||w.stacktrace)?s.localize(0,null,E(w),D(w.stack)||D(w.stacktrace)):E(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function E(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function u(w=null,y=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const f=S.$Fb(w),v=u(f[0],y);return f.length>1?s.localize(4,null,v,f.length):v}if(R.$jf(w))return w;if(w.detail){const f=w.detail;if(f.error)return M(f.error,y);if(f.exception)return M(f.exception,y)}return w.stack?M(w,y):w.message?w.message:s.localize(5,null)}e.$mi=u;function c(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.$ni=c;function m(w,y){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=y,f}e.$oi=m}),define(te[150],ie([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$mp=R}),define(te[152],ie([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let R=!1,s=!1,M=!1,D=!1,E=!1,u=!1,c=!1,m=!1,w=!1,y=!1,f,v=e.$f,b=e.$f,g,$;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?o=e.$g.vscode.process:typeof process<"u"&&(o=process);const d=typeof o?.versions?.electron=="string",P=d&&o?.type==="renderer";if(typeof navigator=="object"&&!P)$=navigator.userAgent,R=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,m=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,u=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$f,v=f,b=navigator.language;else if(typeof o=="object"){R=o.platform==="win32",s=o.platform==="darwin",M=o.platform==="linux",D=M&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,c=d,w=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,v=e.$f;const I=o.env.VSCODE_NLS_CONFIG;if(I)try{const C=JSON.parse(I),p=C.availableLanguages["*"];f=C.locale,b=C.osLocale,v=p||e.$f,g=C._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var h;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;s?l=1:R?l=3:M&&(l=2),e.$i=R,e.$j=s,e.$k=M,e.$l=D,e.$m=E,e.$n=c,e.$o=u,e.$p=u&&typeof e.$g.importScripts=="function",e.$q=m,e.$r=y,e.$s=w,e.$t=l,e.$u=$,e.$v=v;var r;(function(I){function C(){return e.$v}I.value=C;function p(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=p;function A(){return e.$v==="en"}I.isDefault=A})(r||(e.Language=r={})),e.$w=f,e.$x=b,e.$y=g,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let A=0,L=I.length;A<L;A++){const U=I[A];if(U.id===p.data.vscodeScheduleAsyncWork){I.splice(A,1),U.callback();return}}});let C=0;return p=>{const A=++C;I.push({id:A,callback:p}),e.$g.postMessage({vscodeScheduleAsyncWork:A},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||m?2:R?1:3;let n=!0,a=!1;function k(){if(!a){a=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=k,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let R;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.process<"u"){const s=S.$g.vscode.process;R={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$3d=R.platform,e.$4d=R.arch}),define(te[9],ie([0,1,35]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const R=65,s=97,M=90,D=122,E=46,u=47,c=92,m=58,w=63;class y extends Error{constructor(l,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=l.indexOf(".")!==-1?"property":"argument";let k=`The "${l}" ${a} ${n} of type ${r}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,l){if(t===null||typeof t!="object")throw new y(l,"Object",t)}function v(t,l){if(typeof t!="string")throw new y(l,"string",t)}const b=S.$3d==="win32";function g(t){return t===u||t===c}function $(t){return t===u}function o(t){return t>=R&&t<=M||t>=s&&t<=D}function d(t,l,r,i){let n="",a=0,k=-1,I=0,C=0;for(let p=0;p<=t.length;++p){if(p<t.length)C=t.charCodeAt(p);else{if(i(C))break;C=u}if(i(C)){if(!(k===p-1||I===1))if(I===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==E||n.charCodeAt(n.length-2)!==E){if(n.length>2){const A=n.lastIndexOf(r);A===-1?(n="",a=0):(n=n.slice(0,A),a=n.length-1-n.lastIndexOf(r)),k=p,I=0;continue}else if(n.length!==0){n="",a=0,k=p,I=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(k+1,p)}`:n=t.slice(k+1,p),a=p-k-1;k=p,I=0}else C===E&&I!==-1?++I:I=-1}return n}function P(t,l){f(l,"pathObject");const r=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${i}`:`${r}${t}${i}`:i}e.$5d={resolve(...t){let l="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],v(a,"path"),a.length===0)continue}else l.length===0?a=S.cwd():(a=S.env[`=${l}`]||S.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${l}\\`));const k=a.length;let I=0,C="",p=!1;const A=a.charCodeAt(0);if(k===1)g(A)&&(I=1,p=!0);else if(g(A))if(p=!0,g(a.charCodeAt(1))){let L=2,U=L;for(;L<k&&!g(a.charCodeAt(L));)L++;if(L<k&&L!==U){const q=a.slice(U,L);for(U=L;L<k&&g(a.charCodeAt(L));)L++;if(L<k&&L!==U){for(U=L;L<k&&!g(a.charCodeAt(L));)L++;(L===k||L!==U)&&(C=`\\\\${q}\\${a.slice(U,L)}`,I=L)}}}else I=1;else o(A)&&a.charCodeAt(1)===m&&(C=a.slice(0,2),I=2,k>2&&g(a.charCodeAt(2))&&(p=!0,I=3));if(C.length>0)if(l.length>0){if(C.toLowerCase()!==l.toLowerCase())continue}else l=C;if(i){if(l.length>0)break}else if(r=`${a.slice(I)}\\${r}`,i=p,p&&l.length>0)break}return r=d(r,!i,"\\",g),i?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){v(t,"path");const l=t.length;if(l===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(l===1)return $(a)?"\\":t;if(g(a))if(n=!0,g(t.charCodeAt(1))){let I=2,C=I;for(;I<l&&!g(t.charCodeAt(I));)I++;if(I<l&&I!==C){const p=t.slice(C,I);for(C=I;I<l&&g(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&!g(t.charCodeAt(I));)I++;if(I===l)return`\\\\${p}\\${t.slice(C)}\\`;I!==C&&(i=`\\\\${p}\\${t.slice(C,I)}`,r=I)}}}else r=1;else o(a)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),r=2,l>2&&g(t.charCodeAt(2))&&(n=!0,r=3));let k=r<l?d(t.slice(r),!n,"\\",g):"";return k.length===0&&!n&&(k="."),k.length>0&&g(t.charCodeAt(l-1))&&(k+="\\"),i===void 0?n?`\\${k}`:k:n?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){v(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return g(r)||l>2&&o(r)&&t.charCodeAt(1)===m&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let a=0;a<t.length;++a){const k=t[a];v(k,"path"),k.length>0&&(l===void 0?l=r=k:l+=`\\${k}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++n;const a=r.length;a>1&&g(r.charCodeAt(1))&&(++n,a>2&&(g(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&g(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$5d.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l)return"";const r=e.$5d.resolve(t),i=e.$5d.resolve(l);if(r===i||(t=r.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===c;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===c;)a--;const k=a-n;let I=0;for(;I<l.length&&l.charCodeAt(I)===c;)I++;let C=l.length;for(;C-1>I&&l.charCodeAt(C-1)===c;)C--;const p=C-I,A=k<p?k:p;let L=-1,U=0;for(;U<A;U++){const se=t.charCodeAt(n+U);if(se!==l.charCodeAt(I+U))break;se===c&&(L=U)}if(U!==A){if(L===-1)return i}else{if(p>A){if(l.charCodeAt(I+U)===c)return i.slice(I+U+1);if(U===2)return i.slice(I+U)}k>A&&(t.charCodeAt(n+U)===c?L=U:U===2&&(L=3)),L===-1&&(L=0)}let q="";for(U=n+L+1;U<=a;++U)(U===a||t.charCodeAt(U)===c)&&(q+=q.length===0?"..":"\\..");return I+=L,q.length>0?`${q}${i.slice(I,C)}`:(i.charCodeAt(I)===c&&++I,i.slice(I,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$5d.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===c){if(l.charCodeAt(1)===c){const r=l.charCodeAt(2);if(r!==w&&r!==E)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(o(l.charCodeAt(0))&&l.charCodeAt(1)===m&&l.charCodeAt(2)===c)return`\\\\?\\${l}`;return t},dirname(t){v(t,"path");const l=t.length;if(l===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(l===1)return g(n)?t:".";if(g(n)){if(r=i=1,g(t.charCodeAt(1))){let I=2,C=I;for(;I<l&&!g(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&g(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&!g(t.charCodeAt(I));)I++;if(I===l)return t;I!==C&&(r=i=I+1)}}}}else o(n)&&t.charCodeAt(1)===m&&(r=l>2&&g(t.charCodeAt(2))?3:2,i=r);let a=-1,k=!0;for(let I=l-1;I>=i;--I)if(g(t.charCodeAt(I))){if(!k){a=I;break}}else k=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&o(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,I=-1;for(a=t.length-1;a>=r;--a){const C=t.charCodeAt(a);if(g(C)){if(!n){r=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(C===l.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if(g(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){v(t,"path");let l=0,r=-1,i=0,n=-1,a=!0,k=0;t.length>=2&&t.charCodeAt(1)===m&&o(t.charCodeAt(0))&&(l=i=2);for(let I=t.length-1;I>=l;--I){const C=t.charCodeAt(I);if(g(C)){if(!a){i=I+1;break}continue}n===-1&&(a=!1,n=I+1),C===E?r===-1?r=I:k!==1&&(k=1):r!==-1&&(k=-1)}return r===-1||n===-1||k===0||k===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:P.bind(null,"\\"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return g(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(g(n)){if(i=1,g(t.charCodeAt(1))){let L=2,U=L;for(;L<r&&!g(t.charCodeAt(L));)L++;if(L<r&&L!==U){for(U=L;L<r&&g(t.charCodeAt(L));)L++;if(L<r&&L!==U){for(U=L;L<r&&!g(t.charCodeAt(L));)L++;L===r?i=L:L!==U&&(i=L+1)}}}}else if(o(n)&&t.charCodeAt(1)===m){if(r<=2)return l.root=l.dir=t,l;if(i=2,g(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let a=-1,k=i,I=-1,C=!0,p=t.length-1,A=0;for(;p>=i;--p){if(n=t.charCodeAt(p),g(n)){if(!C){k=p+1;break}continue}I===-1&&(C=!1,I=p+1),n===E?a===-1?a=p:A!==1&&(A=1):a!==-1&&(A=-1)}return I!==-1&&(a===-1||A===0||A===1&&a===I-1&&a===k+1?l.base=l.name=t.slice(k,I):(l.name=t.slice(k,a),l.base=t.slice(k,I),l.ext=t.slice(a,I))),k>0&&k!==i?l.dir=t.slice(0,k-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(b){const t=/\\/g;return()=>{const l=S.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>S.cwd()})();e.$6d={resolve(...t){let l="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:h();v(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===u)}return l=d(l,!r,"/",$),r?`/${l}`:l.length>0?l:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===u,r=t.charCodeAt(t.length-1)===u;return t=d(t,!l,"/",$),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const i=t[r];v(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$6d.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l||(t=e.$6d.resolve(t),l=e.$6d.resolve(l),t===l))return"";const r=1,i=t.length,n=i-r,a=1,k=l.length-a,I=n<k?n:k;let C=-1,p=0;for(;p<I;p++){const L=t.charCodeAt(r+p);if(L!==l.charCodeAt(a+p))break;L===u&&(C=p)}if(p===I)if(k>I){if(l.charCodeAt(a+p)===u)return l.slice(a+p+1);if(p===0)return l.slice(a+p)}else n>I&&(t.charCodeAt(r+p)===u?C=p:p===0&&(C=0));let A="";for(p=r+C+1;p<=i;++p)(p===i||t.charCodeAt(p)===u)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(a+C)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===u;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===u){if(!i){r=n;break}}else i=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let r=0,i=-1,n=!0,a;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,I=-1;for(a=t.length-1;a>=0;--a){const C=t.charCodeAt(a);if(C===u){if(!n){r=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(C===l.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===u){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){v(t,"path");let l=-1,r=0,i=-1,n=!0,a=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===u){if(!n){r=k+1;break}continue}i===-1&&(n=!1,i=k+1),I===E?l===-1?l=k:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||i===-1||a===0||a===1&&l===i-1&&l===r+1?"":t.slice(l,i)},format:P.bind(null,"/"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===u;let i;r?(l.root="/",i=1):i=0;let n=-1,a=0,k=-1,I=!0,C=t.length-1,p=0;for(;C>=i;--C){const A=t.charCodeAt(C);if(A===u){if(!I){a=C+1;break}continue}k===-1&&(I=!1,k=C+1),A===E?n===-1?n=C:p!==1&&(p=1):n!==-1&&(p=-1)}if(k!==-1){const A=a===0&&r?1:a;n===-1||p===0||p===1&&n===k-1&&n===a+1?l.base=l.name=t.slice(A,k):(l.name=t.slice(A,n),l.base=t.slice(A,k),l.ext=t.slice(n,k))}return a>0?l.dir=t.slice(0,a-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=b?e.$5d.normalize:e.$6d.normalize,e.$8d=b?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=b?e.$5d.join:e.$6d.join,e.$0d=b?e.$5d.resolve:e.$6d.resolve,e.$$d=b?e.$5d.relative:e.$6d.relative,e.$_d=b?e.$5d.dirname:e.$6d.dirname,e.$ae=b?e.$5d.basename:e.$6d.basename,e.$be=b?e.$5d.extname:e.$6d.extname,e.$ce=b?e.$5d.format:e.$6d.format,e.$de=b?e.$5d.parse:e.$6d.parse,e.$ee=b?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=b?e.$5d.sep:e.$6d.sep,e.$ge=b?e.$5d.delimiter:e.$6d.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function D(a){return a===47||a===92}e.$Bf=D;function E(a){return a.replace(/[\\/]/g,S.$6d.sep)}e.$Cf=E;function u(a){return a.indexOf("/")===-1&&(a=E(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Df=u;function c(a,k=S.$6d.sep){if(!a)return"";const I=a.length,C=a.charCodeAt(0);if(D(C)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let A=3;const L=A;for(;A<I&&!D(a.charCodeAt(A));A++);if(L!==A&&!D(a.charCodeAt(A+1))){for(A+=1;A<I;A++)if(D(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,k)}}return k}else if($(C)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+k:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<I;p++)if(D(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.$Ef=c;function m(a){if(!R.$i||!a||a.length<5)return!1;let k=a.charCodeAt(0);if(k!==92||(k=a.charCodeAt(1),k!==92))return!1;let I=2;const C=I;for(;I<a.length&&(k=a.charCodeAt(I),k!==92);I++);return!(C===I||(k=a.charCodeAt(I+1),isNaN(k)||k===92))}e.$Ff=m;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(a,k=R.$i){const I=k?w:y;return!(!a||a.length===0||/^\s+$/.test(a)||(I.lastIndex=0,I.test(a))||k&&f.test(a)||a==="."||a===".."||k&&a[a.length-1]==="."||k&&a.length!==a.trim().length||a.length>255)}e.$Gf=v;function b(a,k,I){const C=a===k;return!I||C?C:!a||!k?!1:(0,s.$Me)(a,k)}e.$Hf=b;function g(a,k,I,C=S.sep){if(a===k)return!0;if(!a||!k||k.length>a.length)return!1;if(I){if(!(0,s.$Ne)(a,k))return!1;if(k.length===a.length)return!0;let A=k.length;return k.charAt(k.length-1)===C&&A--,a.charAt(A)===C}return k.charAt(k.length-1)!==C&&(k+=C),a.indexOf(k)===0}e.$If=g;function $(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Jf=$;function o(a,k){return R.$i&&a.endsWith(":")&&(a+=S.sep),(0,S.$8d)(a)||(a=(0,S.$9d)(k,a)),a=(0,S.$7d)(a),R.$i?(a=(0,s.$ve)(a,S.sep),a.endsWith(":")&&(a+=S.sep)):(a=(0,s.$ve)(a,S.sep),a||(a=S.sep)),a}e.$Kf=o;function d(a){const k=(0,S.$7d)(a);return R.$i?a.length>3?!1:P(k)&&(a.length===2||k.charCodeAt(2)===92):k===S.$6d.sep}e.$Lf=d;function P(a,k=R.$i){return k?$(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Mf=P;function h(a,k=R.$i){return P(a,k)?a[0]:void 0}e.$Nf=h;function t(a,k,I){return k.length>a.length?-1:a===k?0:(I&&(a=a.toLowerCase(),k=k.toLowerCase()),a.indexOf(k))}e.$Of=t;function l(a){const k=a.split(":");let I,C,p;for(const A of k){const L=Number(A);(0,M.$nf)(L)?C===void 0?C=L:p===void 0&&(p=L):I=I?[I,A].join(":"):A}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:C!==void 0?C:void 0,column:p!==void 0?p:C!==void 0?1:void 0}}e.$Pf=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,k,I=8){let C="";for(let A=0;A<I;A++){let L;A===0&&R.$i&&!k&&(I===3||I===4)?L=i:L=r,C+=L.charAt(Math.floor(Math.random()*L.length))}let p;return k?p=`${k}-${C}`:p=C,a?(0,S.$9d)(a,p):p}e.$Qf=n}),define(te[72],ie([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(E,...u){const c=u.reduce((y,f)=>(y[f]=!0,y),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!c[y]).forEach(y=>{for(let f=0;f<m.length;f++)if(y.search(m[f])!==-1){delete E[y];break}})}e.$sl=M;function D(E){E&&(delete E.DEBUG,S.$j&&delete E.DYLD_LIBRARY_PATH,S.$k&&delete E.LD_PRELOAD)}e.$tl=D}),define(te[7],ie([0,1,9,4]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function E(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,n){return!i&&!n?"file":i}function c(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const m="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,k,I,C,p=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=u(n,p),this.authority=a||m,this.path=c(this.scheme,k||m),this.query=I||m,this.fragment=C||m,E(this,p))}get fsPath(){return P(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:k,path:I,query:C,fragment:p}=n;return a===void 0?a=this.scheme:a===null&&(a=m),k===void 0?k=this.authority:k===null&&(k=m),I===void 0?I=this.path:I===null&&(I=m),C===void 0?C=this.query:C===null&&(C=m),p===void 0?p=this.fragment:p===null&&(p=m),a===this.scheme&&k===this.authority&&I===this.path&&C===this.query&&p===this.fragment?this:new g(a,k,I,C,p)}static parse(n,a=!1){const k=y.exec(n);return k?new g(k[2]||m,r(k[4]||m),r(k[5]||m),r(k[7]||m),r(k[9]||m),a):new g(m,m,m,m,m)}static file(n){let a=m;if(R.$i&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const k=n.indexOf(w,2);k===-1?(a=n.substring(2),n=w):(a=n.substring(2,k),n=n.substring(k)||w)}return new g("file",a,n,m,m)}static from(n,a){return new g(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return R.$i&&n.scheme==="file"?k=f.file(S.$5d.join(P(n,!0),...a)).path:k=S.$6d.join(n.path,...a),n.with({path:k})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const a=new g(n);return a._formatted=n.external??null,a._fsPath=n._sep===b?n.fsPath??null:null,a}}else return n}}e.URI=f;function v(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Sf=v;const b=R.$i?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(i,n,a){let k,I=-1;for(let C=0;C<i.length;C++){const p=i.charCodeAt(C);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||n&&p===47||a&&p===91||a&&p===93||a&&p===58)I!==-1&&(k+=encodeURIComponent(i.substring(I,C)),I=-1),k!==void 0&&(k+=i.charAt(C));else{k===void 0&&(k=i.substr(0,C));const A=$[p];A!==void 0?(I!==-1&&(k+=encodeURIComponent(i.substring(I,C)),I=-1),k+=A):I===-1&&(I=C)}}return I!==-1&&(k+=encodeURIComponent(i.substring(I))),k!==void 0?k:i}function d(i){let n;for(let a=0;a<i.length;a++){const k=i.charCodeAt(a);k===35||k===63?(n===void 0&&(n=i.substr(0,a)),n+=$[k]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function P(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$Tf=P;function h(i,n){const a=n?d:o;let k="",{scheme:I,authority:C,path:p,query:A,fragment:L}=i;if(I&&(k+=I,k+=":"),(C||I==="file")&&(k+=w,k+=w),C){let U=C.indexOf("@");if(U!==-1){const q=C.substr(0,U);C=C.substr(U+1),U=q.lastIndexOf(":"),U===-1?k+=a(q,!1,!1):(k+=a(q.substr(0,U),!1,!1),k+=":",k+=a(q.substr(U+1),!1,!0)),k+="@"}C=C.toLowerCase(),U=C.lastIndexOf(":"),U===-1?k+=a(C,!1,!0):(k+=a(C.substr(0,U),!1,!0),k+=C.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}k+=a(p,!0,!1)}return A&&(k+="?",k+=a(A,!1,!1)),L&&(k+="#",k+=n?L:o(L,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(te[153],ie([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function R(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$Np=R;function s(c){const m=[];let w;try{const y=JSON.parse(c.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),w=f.__$stack),m.push(...y)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:w}}e.$Op=s;function M(c){if(typeof c!="string")return M(s(c).stack);const m=c;if(m){const w=D(m),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$Pp=M;function D(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function E(c,m){const{args:w,stack:y}=s(c),f=typeof w[0]=="string"&&w.length===1;let v=D(y);v&&(v=`(${v.trim()})`);let b=[];if(typeof w[0]=="string"?v&&f?b=[`%c[${m}] %c${w[0]} %c${v}`,u("blue"),u(""),u("grey")]:b=[`%c[${m}] %c${w[0]}`,u("blue"),u(""),...w.slice(1)]:b=[`%c[${m}]%`,u("blue"),...w],v&&!f&&b.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,b)}e.log=E;function u(c){return`color: ${c}`}}),define(te[73],ie([0,1,17,7]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function s(u){return JSON.stringify(u,D)}e.$9g=s;function M(u){let c=JSON.parse(u);return c=E(c),c}e.$0g=M;function D(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return R.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof S.$Fd||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let m=0;m<u.length;++m)u[m]=E(u[m],c+1);else for(const m in u)Object.hasOwnProperty.call(u,m)&&(u[m]=E(u[m],c+1))}return u}e.$$g=E}),define(te[13],ie([0,1,14,4,7]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var M;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${M.vscodeRemoteResource}`}set(m,w,y){this.a[m]=w,this.b[m]=y}setConnectionToken(m,w){this.c[m]=w}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(g){return S.$Y(g),m}const w=m.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[w],v=this.c[w];let b=`path=${encodeURIComponent(m.path)}`;return typeof v=="string"&&(b+=`&${e.$Vf}=${encodeURIComponent(v)}`),s.URI.from({scheme:R.$o?this.d:M.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:b})}}e.$Wf=new D,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class E{static{this.a="vscode-app"}asBrowserUri(m){const w=this.b(m,K);return this.uriToBrowserUri(w)}uriToBrowserUri(m){return m.scheme===M.vscodeRemote?e.$Wf.rewrite(m):m.scheme===M.file&&(R.$m||R.$p&&R.$g.origin===`${M.vscodeFileResource}://${E.a}`)?m.with({scheme:M.vscodeFileResource,authority:m.authority||E.a,query:null,fragment:null}):m}asFileUri(m){const w=this.b(m,K);return this.uriToFileUri(w)}uriToFileUri(m){return m.scheme===M.vscodeFileResource?m.with({scheme:M.file,authority:m.authority!==E.a?m.authority:null,query:null,fragment:null}):m}b(m,w){return s.URI.isUri(m)?m:s.URI.parse(w.toUrl(m))}}e.$2f=new E;var u;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const w="vscode-coi";function y(v){let b;typeof v=="string"?b=new URL(v).searchParams:v instanceof URL?b=v.searchParams:s.URI.isUri(v)&&(b=new URL(v.toString(!0)).searchParams);const g=b?.get(w);if(g)return m.get(g)}c.getHeadersFromQuery=y;function f(v,b,g){if(!globalThis.crossOriginIsolated)return;const $=b&&g?"3":g?"2":"1";v instanceof URLSearchParams?v.set(w,$):v[w]=$}c.addSearchParam=f})(u||(e.COI=u={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function u(f){return(0,E.$Tf)(f,!0)}e.$9f=u;class c{constructor(v){this.a=v}compare(v,b,g=!1){return v===b?0:(0,D.$Fe)(this.getComparisonKey(v,g),this.getComparisonKey(b,g))}isEqual(v,b,g=!1){return v===b?!0:!v||!b?!1:this.getComparisonKey(v,g)===this.getComparisonKey(b,g)}getComparisonKey(v,b=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,b,g=!1){if(v.scheme===b.scheme){if(v.scheme===R.Schemas.file)return S.$If(u(v),u(b),this.a(v))&&v.query===b.query&&(g||v.fragment===b.fragment);if((0,e.$ng)(v.authority,b.authority))return S.$If(v.path,b.path,this.a(v),"/")&&v.query===b.query&&(g||v.fragment===b.fragment)}return!1}joinPath(v,...b){return E.URI.joinPath(v,...b)}basenameOrAuthority(v){return(0,e.$fg)(v)||v.authority}basename(v){return s.$6d.basename(v.path)}extname(v){return s.$6d.extname(v.path)}dirname(v){if(v.path.length===0)return v;let b;return v.scheme===R.Schemas.file?b=E.URI.file(s.$_d(u(v))).path:(b=s.$6d.dirname(v.path),v.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),b="/")),v.with({path:b})}normalizePath(v){if(!v.path.length)return v;let b;return v.scheme===R.Schemas.file?b=E.URI.file(s.$7d(u(v))).path:b=s.$6d.normalize(v.path),v.with({path:b})}relativePath(v,b){if(v.scheme!==b.scheme||!(0,e.$ng)(v.authority,b.authority))return;if(v.scheme===R.Schemas.file){const o=s.$$d(u(v),u(b));return M.$i?S.$Cf(o):o}let g=v.path||"/";const $=b.path||"/";if(this.a(v)){let o=0;for(const d=Math.min(g.length,$.length);o<d&&!(g.charCodeAt(o)!==$.charCodeAt(o)&&g.charAt(o).toLowerCase()!==$.charAt(o).toLowerCase());o++);g=$.substr(0,o)+g.substr(o)}return s.$6d.relative(g,$)}resolvePath(v,b){if(v.scheme===R.Schemas.file){const g=E.URI.file(s.$0d(u(v),b));return v.with({authority:g.authority,path:g.path})}return b=S.$Df(b),v.with({path:s.$6d.resolve(v.path,b)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,b){return v===b||v!==void 0&&b!==void 0&&(0,D.$Me)(v,b)}hasTrailingPathSeparator(v,b=s.sep){if(v.scheme===R.Schemas.file){const g=u(v);return g.length>S.$Ef(g).length&&g[g.length-1]===b}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,b=s.sep){return(0,e.$og)(v,b)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,b=s.sep){let g=!1;if(v.scheme===R.Schemas.file){const $=u(v);g=$!==void 0&&$.length===S.$Ef($).length&&$[$.length-1]===b}else{b="/";const $=v.path;g=$.length===1&&$.charCodeAt($.length-1)===47}return!g&&!(0,e.$og)(v,b)?v.with({path:v.path+"/"}):v}}e.$0f=c,e.$$f=new c(()=>!1),e.$_f=new c(f=>f.scheme===R.Schemas.file?!M.$k:!0),e.$ag=new c(f=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function m(f,v){const b=[];for(let g=0;g<f.length;g++){const $=v(f[g]);f.some((o,d)=>d===g?!1:(0,e.$cg)($,v(o)))||b.push(f[g])}return b}e.$rg=m;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function v(b){const g=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[P,h]=d.split(":");P&&h&&g.set(P,h)});const o=b.path.substring(0,b.path.indexOf(";"));return o&&g.set(f.META_DATA_MIME,o),g}f.parseMetaData=v})(w||(e.DataUri=w={}));function y(f,v,b){if(v){let g=f.path;return g&&g[0]!==s.$6d.sep&&(g=s.$6d.sep+g),f.with({scheme:b,authority:v,path:g})}return f.with({scheme:b})}e.$sg=y}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function c(O){return!!O&&typeof O.then=="function"}e.$tg=c;function m(O){const j=new S.$pd,z=O(j.token),W=new Promise((B,V)=>{const ce=j.token.onCancellationRequested(()=>{ce.dispose(),j.dispose(),V(new R.$3)});Promise.resolve(z).then(de=>{ce.dispose(),j.dispose(),B(de)},de=>{ce.dispose(),j.dispose(),V(de)})});return new class{cancel(){j.cancel()}then(B,V){return W.then(B,V)}catch(B){return this.then(void 0,B)}finally(B){return W.finally(B)}}}e.$ug=m;function w(O,j,z){return new Promise((W,B)=>{const V=j.onCancellationRequested(()=>{V.dispose(),W(z)});O.then(W,B).finally(()=>V.dispose())})}e.$vg=w;function y(O,j){return new Promise((z,W)=>{const B=j.onCancellationRequested(()=>{B.dispose(),W(new R.$3)});O.then(z,W).finally(()=>B.dispose())})}e.$wg=y;async function f(O){let j=-1;const z=O.map((W,B)=>W.then(V=>(j=B,V)));try{return await Promise.race(z)}finally{O.forEach((W,B)=>{B!==j&&W.cancel()})}}e.$xg=f;function v(O,j,z){let W;const B=setTimeout(()=>{W?.(void 0),z?.()},j);return Promise.race([O.finally(()=>clearTimeout(B)),new Promise(V=>W=V)])}e.$yg=v;function b(O){return new Promise((j,z)=>{const W=O();c(W)?W.then(j,z):j(W)})}e.$zg=b;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const z=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(z,z).then(W)})}return new Promise((z,W)=>{this.b.then(z,W)})}return this.a=j(),new Promise((z,W)=>{this.a.then(B=>{this.a=null,z(B)},B=>{this.a=null,W(B)})})}dispose(){this.f=!0}}e.$Ag=g;class ${constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Bg=$;class o{constructor(){this.a=new Map}queue(j,z){const B=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(j)===B&&this.a.delete(j)});return this.a.set(j,B),B}}e.$Cg=o;const d=(O,j)=>{let z=!0;const W=setTimeout(()=>{z=!1,j()},O);return{isTriggered:()=>z,dispose:()=>{clearTimeout(W),z=!1}}},P=O=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,O())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class h{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,z=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((B,V)=>{this.d=B,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=z===u.$cd?P(W):d(z,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=h;class t{constructor(j){this.a=new h(j),this.b=new g}trigger(j,z){return this.a.trigger(()=>this.b.queue(j),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class l{constructor(){this.a=!1,this.b=new Promise((j,z)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=l;class r extends l{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Gg=r;function i(O,j){return j?new Promise((z,W)=>{const B=setTimeout(()=>{V.dispose(),z()},O),V=j.onCancellationRequested(()=>{clearTimeout(B),V.dispose(),W(new R.$3)})}):m(z=>i(O,z))}e.$Hg=i;function n(O,j=0,z){const W=setTimeout(()=>{O(),z&&B.dispose()},j),B=(0,M.$ic)(()=>{clearTimeout(W),z?.deleteAndLeak(B)});return z?.add(B),B}e.$Ig=n;function a(O){const j=[];let z=0;const W=O.length;function B(){return z<W?O[z++]():null}function V(ce){ce!=null&&j.push(ce);const de=B();return de?de.then(V):Promise.resolve(j)}return Promise.resolve(null).then(V)}e.$Jg=a;function k(O,j=W=>!!W,z=null){let W=0;const B=O.length,V=()=>{if(W>=B)return Promise.resolve(z);const ce=O[W++];return Promise.resolve(ce()).then(he=>j(he)?Promise.resolve(he):V())};return V()}e.$Kg=k;function I(O,j=W=>!!W,z=null){if(O.length===0)return Promise.resolve(z);let W=O.length;const B=()=>{W=-1;for(const V of O)V.cancel?.()};return new Promise((V,ce)=>{for(const de of O)de.then(he=>{--W>=0&&j(he)?(B(),V(he)):W===0&&V(z)}).catch(he=>{--W>=0&&(B(),ce(he))})})}e.$Lg=I;class C{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((z,W)=>{this.f.push({factory:j,c:z,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const z=j.factory();z.then(j.c,j.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=C;class p extends C{constructor(){super(1)}}e.$Ng=p;class A{constructor(){this.a=new J,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Og=A;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,z=D.$$f){const W=z.getComparisonKey(j);let B=this.a.get(W);if(!B){B=new p;const V=this.f++,ce=s.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$sc),this.d.set(V,ce),this.a.set(W,B)}return B}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=L;class U{constructor(j,z){this.a=-1,typeof j=="function"&&typeof z=="number"&&this.setIfNotSet(j,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},z)}setIfNotSet(j,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},z))}}e.$Qg=U;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,z){this.cancel(),this.a=setInterval(()=>{j()},z)}}e.$Rg=q;class se{constructor(j,z){this.b=-1,this.a=j,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=se;class x{constructor(j,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=j,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=x;class ae extends se{constructor(j,z){super(j,z),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Ug=ae;class ne extends M.$kc{constructor(j,z){super(),this.g=j,this.h=z,this.a=[],this.b=this.B(new M.$lc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of j)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=O=>{(0,E.$A)(()=>{if(j)return;const z=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$Wg=(O,j)=>{const z=requestIdleCallback(O,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(z))}}}}();class re{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(z){this.g=z}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=re;async function Y(O,j,z){let W;for(let B=0;B<z;B++)try{return await O()}catch(V){W=V,await i(j)}throw W}e.$Yg=Y;class J{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,z,W){return this.a={taskId:j,cancel:()=>W?.(),promise:z},z.then(()=>this.d(j),()=>this.d(j)),z}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let z,W;const B=new Promise((V,ce)=>{z=V,W=ce});this.b={run:j,promise:B,promiseResolve:z,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=J;class H{constructor(j,z=()=>Date.now()){this.d=j,this.f=z,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$1g=H;var F;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,z)=>{this.a=j,this.b=z})}complete(j){return new Promise(z=>{this.a(j),this.d={outcome:0,value:j},z()})}error(j){return new Promise(z=>{this.b(j),this.d={outcome:1,value:j},z()})}cancel(){return this.error(new R.$3)}}e.$2g=N;var G;(function(O){async function j(W){let B;const V=await Promise.all(W.map(ce=>ce.then(de=>de,de=>{B||(B=de)})));if(typeof B<"u")throw B;return V}O.settled=j;function z(W){return new Promise(async(B,V)=>{try{await W(B,V)}catch(ce){V(ce)}})}O.withAsyncBody=z})(G||(e.Promises=G={}));var Z;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Z||(Z={}));class _{static fromArray(j){return new _(z=>{z.emitMany(j)})}static fromPromise(j){return new _(async z=>{z.emitMany(await j)})}static fromPromises(j){return new _(async z=>{await Promise.all(j.map(async W=>z.emitOne(await W)))})}static merge(j){return new _(async z=>{await Promise.all(j.map(async W=>{for await(const B of W)z.emitOne(B)}))})}static{this.EMPTY=_.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$fd,queueMicrotask(async()=>{const z={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(z)),this.j()}catch(W){this.k(W)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,z){return new _(async W=>{for await(const B of j)W.emitOne(z(B))})}map(j){return _.map(this,j)}static filter(j,z){return new _(async W=>{for await(const B of j)z(B)&&W.emitOne(B)})}filter(j){return _.filter(this,j)}static coalesce(j){return _.filter(j,z=>!!z)}coalesce(){return _.coalesce(this)}static async toPromise(j){const z=[];for await(const W of j)z.push(W);return z}toPromise(){return _.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$3g=_;class oe extends _{constructor(j,z){super(z),this.l=j}cancel(){this.l.cancel()}}e.$4g=oe;function T(O){const j=new S.$pd,z=O(j.token);return new oe(j,async W=>{const B=j.token.onCancellationRequested(()=>{B.dispose(),j.dispose(),W.reject(new R.$3)});try{for await(const V of z){if(j.token.isCancellationRequested)return;W.emitOne(V)}B.dispose(),j.dispose()}catch(V){B.dispose(),j.dispose(),W.reject(V)}})}e.$5g=T}),define(te[104],ie([0,1,23,8,32,33,9,4,26]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function c(){return Object.create(null)}e.$mj=c,e.$nj="**",e.$oj="/";const m="[/\\\\]",w="[^/\\\\]",y=/\//g;function f(J,H){switch(J){case 0:return"";case 1:return`${w}*?`;default:return`(?:${m}|${w}+${m}${H?`|${m}${w}+`:""})*?`}}function v(J,H){if(!J)return[];const F=[];let N=!1,G=!1,Z="";for(const _ of J){switch(_){case H:if(!N&&!G){F.push(Z),Z="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}Z+=_}return Z&&F.push(Z),F}e.$pj=v;function b(J){if(!J)return"";let H="";const F=v(J,e.$oj);if(F.every(N=>N===e.$nj))H=".*";else{let N=!1;F.forEach((G,Z)=>{if(G===e.$nj){if(N)return;H+=f(2,Z===F.length-1)}else{let _=!1,oe="",T=!1,O="";for(const j of G){if(j!=="}"&&_){oe+=j;continue}if(T&&(j!=="]"||!O)){let z;j==="-"?z=j:(j==="^"||j==="!")&&!O?z="^":j===e.$oj?z="":z=(0,u.$qe)(j),O+=z;continue}switch(j){case"{":_=!0;continue;case"[":T=!0;continue;case"}":{const W=`(?:${v(oe,",").map(B=>b(B)).join("|")})`;H+=W,_=!1,oe="";break}case"]":{H+="["+O+"]",T=!1,O="";break}case"?":H+=w;continue;case"*":H+=f(1);continue;default:H+=(0,u.$qe)(j)}}Z<F.length-1&&(F[Z+1]!==e.$nj||Z+2<F.length)&&(H+=m)}N=G===e.$nj})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ci(1e4),l=function(){return!1},r=function(){return null};function i(J,H){if(!J)return r;let F;typeof J!="string"?F=J.pattern:F=J,F=F.trim();const N=`${F}_${!!H.trimForExclusions}`;let G=t.get(N);if(G)return n(G,J);let Z;return g.test(F)?G=k(F.substr(4),F):(Z=$.exec(a(F,H)))?G=I(Z[1],F):(H.trimForExclusions?d:o).test(F)?G=C(F,H):(Z=P.exec(a(F,H)))?G=p(Z[1].substr(1),F,!0):(Z=h.exec(a(F,H)))?G=p(Z[1],F,!1):G=A(F),t.set(N,G),n(G,J)}function n(J,H){if(typeof H=="string")return J;const F=function(N,G){return(0,s.$If)(N,H.base,!E.$k)?J((0,u.$ue)(N.substr(H.base.length),D.sep),G):null};return F.allBasenames=J.allBasenames,F.allPaths=J.allPaths,F.basenames=J.basenames,F.patterns=J.patterns,F}function a(J,H){return H.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function k(J,H){return function(F,N){return typeof F=="string"&&F.endsWith(J)?H:null}}function I(J,H){const F=`/${J}`,N=`\\${J}`,G=function(_,oe){return typeof _!="string"?null:oe?oe===J?H:null:_===J||_.endsWith(F)||_.endsWith(N)?H:null},Z=[J];return G.basenames=Z,G.patterns=[H],G.allBasenames=Z,G}function C(J,H){const F=re(J.slice(1,-1).split(",").map(oe=>i(oe,H)).filter(oe=>oe!==r),J),N=F.length;if(!N)return r;if(N===1)return F[0];const G=function(oe,T){for(let O=0,j=F.length;O<j;O++)if(F[O](oe,T))return J;return null},Z=F.find(oe=>!!oe.allBasenames);Z&&(G.allBasenames=Z.allBasenames);const _=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return _.length&&(G.allPaths=_),G}function p(J,H,F){const N=D.sep===D.$6d.sep,G=N?J:J.replace(y,D.sep),Z=D.sep+G,_=D.$6d.sep+J;let oe;return F?oe=function(T,O){return typeof T=="string"&&(T===G||T.endsWith(Z)||!N&&(T===J||T.endsWith(_)))?H:null}:oe=function(T,O){return typeof T=="string"&&(T===G||!N&&T===J)?H:null},oe.allPaths=[(F?"*/":"./")+J],oe}function A(J){try{const H=new RegExp(`^${b(J)}$`);return function(F){return H.lastIndex=0,typeof F=="string"&&H.test(F)?J:null}}catch{return r}}function L(J,H,F){return!J||typeof H!="string"?!1:U(J)(H,void 0,F)}e.$qj=L;function U(J,H={}){if(!J)return l;if(typeof J=="string"||q(J)){const F=i(J,H);if(F===r)return l;const N=function(G,Z){return!!F(G,Z)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return ae(J,H)}e.$rj=U;function q(J){const H=J;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$sj=q;function se(J){return J.allBasenames||[]}e.$tj=se;function x(J){return J.allPaths||[]}e.$uj=x;function ae(J,H){const F=re(Object.getOwnPropertyNames(J).map(oe=>ne(oe,J[oe],H)).filter(oe=>oe!==r)),N=F.length;if(!N)return r;if(!F.some(oe=>!!oe.requiresSiblings)){if(N===1)return F[0];const oe=function(j,z){let W;for(let B=0,V=F.length;B<V;B++){const ce=F[B](j,z);if(typeof ce=="string")return ce;(0,R.$tg)(ce)&&(W||(W=[]),W.push(ce))}return W?(async()=>{for(const B of W){const V=await B;if(typeof V=="string")return V}return null})():null},T=F.find(j=>!!j.allBasenames);T&&(oe.allBasenames=T.allBasenames);const O=F.reduce((j,z)=>z.allPaths?j.concat(z.allPaths):j,[]);return O.length&&(oe.allPaths=O),oe}const G=function(oe,T,O){let j,z;for(let W=0,B=F.length;W<B;W++){const V=F[W];V.requiresSiblings&&O&&(T||(T=(0,D.$ae)(oe)),j||(j=T.substr(0,T.length-(0,D.$be)(oe).length)));const ce=V(oe,T,j,O);if(typeof ce=="string")return ce;(0,R.$tg)(ce)&&(z||(z=[]),z.push(ce))}return z?(async()=>{for(const W of z){const B=await W;if(typeof B=="string")return B}return null})():null},Z=F.find(oe=>!!oe.allBasenames);Z&&(G.allBasenames=Z.allBasenames);const _=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return _.length&&(G.allPaths=_),G}function ne(J,H,F){if(H===!1)return r;const N=i(J,F);if(N===r)return r;if(typeof H=="boolean")return N;if(H){const G=H.when;if(typeof G=="string"){const Z=(_,oe,T,O)=>{if(!O||!N(_,oe))return null;const j=G.replace("$(basename)",()=>T),z=O(j);return(0,R.$tg)(z)?z.then(W=>W?J:null):z?J:null};return Z.requiresSiblings=!0,Z}}return N}function re(J,H){const F=J.filter(oe=>!!oe.basenames);if(F.length<2)return J;const N=F.reduce((oe,T)=>{const O=T.basenames;return O?oe.concat(O):oe},[]);let G;if(H){G=[];for(let oe=0,T=N.length;oe<T;oe++)G.push(H)}else G=F.reduce((oe,T)=>{const O=T.patterns;return O?oe.concat(O):oe},[]);const Z=function(oe,T){if(typeof oe!="string")return null;if(!T){let j;for(j=oe.length;j>0;j--){const z=oe.charCodeAt(j-1);if(z===47||z===92)break}T=oe.substr(j)}const O=N.indexOf(T);return O!==-1?G[O]:null};Z.basenames=N,Z.patterns=G,Z.allBasenames=N;const _=J.filter(oe=>!oe.basenames);return _.push(Z),_}function Y(J,H){return(0,S.$sb)(J,H,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.$vj=Y}),define(te[46],ie([0,1,23,32,9,4,19,26]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=void 0;function u(i,n){const{os:a,tildify:k,relative:I}=n;if(I){const A=c(i,I,a);if(typeof A=="string")return A}let C=i.fsPath;if(a===1&&!M.$i?C=C.replace(/\//g,"\\"):a!==1&&M.$i&&(C=C.replace(/\\/g,"/")),a!==1&&k?.userHome){const A=k.userHome.fsPath;let L;i.scheme!==k.userHome.scheme&&i.path.startsWith(s.$6d.sep)?L=k.userHome.with({path:i.path}).fsPath:L=i.fsPath,C=y(L,A,a)}return(a===1?s.$5d:s.$6d).normalize(m(C,a===1))}e.$hv=u;function c(i,n,a){const k=a===1?s.$5d:s.$6d,I=a===3?D.$$f:D.$ag,C=n.getWorkspace(),p=(0,S.$Mb)(C.folders);if(!p)return;i.scheme!==p.uri.scheme&&i.path.startsWith(s.$6d.sep)&&(i=p.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let L;if(I.isEqual(A.uri,i)?L="":L=I.relativePath(A.uri,i)??"",L&&(L=k.normalize(L)),C.folders.length>1&&!n.noPrefix){const U=A.name?A.name:I.basenameOrAuthority(A.uri);L=L?`${U} \u2022 ${L}`:U}return L}function m(i,n=M.$i){return(0,R.$Mf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$iv=m;let w=Object.create(null);function y(i,n,a=M.OS){if(a===1||!i||!n)return i;let k=w.original===n?w.normalized:void 0;k||(k=n,M.$i&&(k=(0,R.$Cf)(k)),k=`${(0,E.$ve)(k,s.$6d.sep)}${s.$6d.sep}`,w={original:n,normalized:k});let I=i;return M.$i&&(I=(0,R.$Cf)(I)),(a===3?I.startsWith(k):(0,E.$Ne)(I,k))?`~/${I.substr(k.length)}`:i}e.$jv=y;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$kv=f;const v="\u2026",b="\\\\",g="~";function $(i,n=s.sep){const a=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const C=i[I];if(C===""){a[I]=`.${n}`;continue}if(!C){a[I]=C;continue}k=!0;let p="",A=C;A.indexOf(b)===0?(p=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length)):A.indexOf(n)===0?(p=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(g)===0&&(p=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length));const L=A.split(n);for(let U=1;k&&U<=L.length;U++)for(let q=L.length-U;k&&q>=0;q--){k=!1;let se=L.slice(q,q+U).join(n);for(let x=0;!k&&x<i.length;x++)if(x!==I&&i[x]&&i[x].indexOf(se)>-1){const ae=q+U===L.length,ne=q>0&&i[x].indexOf(n)>-1?n+se:se,re=i[x].endsWith(ne);k=!ae||re}if(!k){let x="";(L[0].endsWith(":")||p!=="")&&(q===1&&(q=0,U++,se=L[0]+n+se),q>0&&(x=L[0]+n),x=p+x),q>0&&(x=x+v+n),x=x+se,q+U<L.length&&(x=x+n+v),a[I]=x}}k&&(a[I]=C)}return a}e.$lv=$;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function d(i,n=Object.create(null)){const a=[];let k=!1,I="";for(const C of i)if(C==="$"||k&&C==="{")I&&a.push({value:I,type:o.TEXT}),I="",k=!0;else if(C==="}"&&k){const p=n[I];if(typeof p=="string")p.length&&a.push({value:p,type:o.VARIABLE});else if(p){const A=a[a.length-1];(!A||A.type!==o.SEPARATOR)&&a.push({value:p.label,type:o.SEPARATOR})}I="",k=!1}else I+=C;return I&&!k&&a.push({value:I,type:o.TEXT}),a.filter((C,p)=>{if(C.type===o.SEPARATOR){const A=a[p-1],L=a[p+1];return[A,L].every(U=>U&&(U.type===o.VARIABLE||U.type===o.TEXT)&&U.value.length>0)}return!0}).map(C=>C.value).join("")}e.$mv=d;function P(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$nv=P;function h(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$ov=h;function t(i){return i.replace(/&/g,"&&")}e.$pv=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n));return{name:a.name,parentPath:a.parentPath+i.substring(n)}}}return r(i)}e.$qv=l;function r(i){const n=i.indexOf("/")!==-1?s.$6d:s.$5d,a=n.basename(i),k=n.dirname(i);return a.length?{name:a,parentPath:k}:{name:k,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function s(w){return w.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const f=this.a.transformIncoming(y);return f===y?y:s(R.URI.from(f))}transformOutgoing(y){const f=this.a.transformOutgoing(y);return f===y?y:s(R.URI.from(f))}transformOutgoingURI(y){const f=this.a.transformOutgoing(y);return f===y?y:R.URI.from(f)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Bm=M,e.$Cm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,y,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof R.URI)return y.transformOutgoing(w);for(const v in w)if(Object.hasOwnProperty.call(w,v)){const b=D(w[v],y,f+1);b!==null&&(w[v]=b)}}return null}function E(w,y){const f=D(w,y,0);return f===null?w:f}e.$Dm=E;function u(w,y,f,v){if(!w||v>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?R.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof S.$Fd)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const g=u(w[b],y,f,v+1);g!==null&&(w[b]=g)}}return null}function c(w,y){const f=u(w,y,!1,0);return f===null?w:f}e.$Em=c;function m(w,y){const f=u(w,y,!0,0);return f===null?w:f}e.$Fm=m}),define(te[21],ie([0,1,45,27,155,8,32,85,9,4,19,7]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function f(ne,re=y.UNLINK,Y){if((0,D.$Lf)(ne))throw new Error("rimraf - will refuse to recursively delete root");return re===y.UNLINK?b(ne):v(ne,Y)}async function v(ne,re=(0,D.$Qf)((0,R.tmpdir)())){try{try{await S.promises.rename(ne,re)}catch(Y){return Y.code==="ENOENT"?void 0:b(ne)}b(re).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function b(ne){return(0,s.promisify)(S.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function g(ne){if((0,D.$Lf)(ne))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function $(ne,re){return P(await(re?o(ne):(0,s.promisify)(S.readdir)(ne)))}async function o(ne){try{return await(0,s.promisify)(S.readdir)(ne,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const re=[],Y=await $(ne);for(const J of Y){let H=!1,F=!1,N=!1;try{const G=await e.Promises.lstat((0,u.$9d)(ne,J));H=G.isFile(),F=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}re.push({name:J,isFile:()=>H,isDirectory:()=>F,isSymbolicLink:()=>N})}return re}function d(ne){return P(S.readdirSync(ne))}e.readdirSync=d;function P(ne){return ne.map(re=>typeof re=="string"?c.$j?(0,E.$hl)(re):re:(re.name=c.$j?(0,E.$hl)(re.name):re.name,re))}async function h(ne){const re=await $(ne),Y=[];for(const J of re)await l.existsDirectory((0,u.$9d)(ne,J))&&Y.push(J);return Y}function t(ne,re=1e3){return new Promise(Y=>{let J=!1;const H=setInterval(()=>{J||(J=!0,S.access(ne,F=>{J=!1,F&&(clearInterval(H),Y(void 0))}))},re)})}e.whenDeleted=t;var l;(function(ne){async function re(H){let F;try{if(F=await e.Promises.lstat(H),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw G}throw N}}ne.stat=re;async function Y(H){try{const{stat:F,symbolicLink:N}=await ne.stat(H);return F.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=Y;async function J(H){try{const{stat:F,symbolicLink:N}=await ne.stat(H);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=J})(l||(e.SymlinkSupport=l={}));const r=new M.$Pg;function i(ne,re,Y){return r.queueFor(w.URI.file(ne),m.$_f).queue(()=>{const J=C(Y);return new Promise((H,F)=>k(ne,re,J,N=>N?F(N):H()))})}let n=!0;function a(ne){n=ne}e.configureFlushOnWrite=a;function k(ne,re,Y,J){if(!n)return S.writeFile(ne,re,{mode:Y.mode,flag:Y.flag},J);S.open(ne,Y.flag,Y.mode,(H,F)=>{if(H)return J(H);S.writeFile(F,re,N=>{if(N)return S.close(F,()=>J(N));S.fdatasync(F,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),a(!1)),S.close(F,Z=>J(Z))))})})}function I(ne,re,Y){const J=C(Y);if(!n)return S.writeFileSync(ne,re,{mode:J.mode,flag:J.flag});const H=S.openSync(ne,J.flag,J.mode);try{S.writeFileSync(H,re);try{S.fdatasyncSync(H)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a(!1)}}finally{S.closeSync(H)}}e.writeFileSync=I;function C(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function p(ne,re,Y=6e4){if(ne!==re)try{c.$i&&typeof Y=="number"?await A(ne,re,Date.now(),Y):await(0,s.promisify)(S.rename)(ne,re)}catch(J){if(ne.toLowerCase()!==re.toLowerCase()&&J.code==="EXDEV"||ne.endsWith("."))await L(ne,re,{preserveSymlinks:!1}),await f(ne,y.MOVE);else throw J}}async function A(ne,re,Y,J,H=0){try{return await(0,s.promisify)(S.rename)(ne,re)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-Y>=J)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${F}`),F;if(H===0){let N=!1;try{const{stat:G}=await l.stat(re);G.isFile()||(N=!0)}catch{}if(N)throw F}return await(0,M.$Hg)(Math.min(100,H*10)),A(ne,re,Y,J,H+1)}}async function L(ne,re,Y){return q(ne,re,{root:{source:ne,target:re},options:Y,handledSourcePaths:new Set})}const U=511;async function q(ne,re,Y){if(Y.handledSourcePaths.has(ne))return;Y.handledSourcePaths.add(ne);const{stat:J,symbolicLink:H}=await l.stat(ne);if(H){if(Y.options.preserveSymlinks)try{return await ae(ne,re,Y)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(H.dangling)return}return J.isDirectory()?se(ne,re,J.mode&U,Y):x(ne,re,J.mode&U)}async function se(ne,re,Y,J){await e.Promises.mkdir(re,{recursive:!0,mode:Y});const H=await $(ne);for(const F of H)await q((0,u.$9d)(ne,F),(0,u.$9d)(re,F),J)}async function x(ne,re,Y){await e.Promises.copyFile(ne,re),await e.Promises.chmod(re,Y)}async function ae(ne,re,Y){let J=await e.Promises.readlink(ne);(0,D.$If)(J,Y.root.source,!c.$k)&&(J=(0,u.$9d)(Y.root.target,J.substr(Y.root.source.length+1))),await e.Promises.symlink(J,re)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(ne,re,Y,J,H)=>new Promise((F,N)=>{S.read(ne,re,Y,J,H,(G,Z,_)=>G?N(G):F({bytesRead:Z,buffer:_}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(ne,re,Y,J,H)=>new Promise((F,N)=>{S.write(ne,re,Y,J,H,(G,Z,_)=>G?N(G):F({bytesWritten:Z,buffer:_}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return f}get rename(){return p}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function E(y){if(s.$k)return y;const f=(0,R.$_d)(y);if(y===f)return y;const v=((0,R.$ae)(y)||y).toLowerCase();try{const g=(0,D.readdirSync)(f).filter($=>$.toLowerCase()===v);if(g.length===1){const $=E(f);if($)return(0,R.$9d)($,g[0])}else if(g.length>1){const $=g.indexOf(v);if($>=0){const o=E(f);if(o)return(0,R.$9d)(o,g[$])}}}catch{}return null}e.$Up=E;async function u(y){if(s.$k)return y;const f=(0,R.$_d)(y);if(y===f)return y;const v=((0,R.$ae)(y)||y).toLowerCase();try{const g=(await D.Promises.readdir(f)).filter($=>$.toLowerCase()===v);if(g.length===1){const $=await u(f);if($)return(0,R.$9d)($,g[0])}else if(g.length>1){const $=g.indexOf(v);if($>=0){const o=await u(f);if(o)return(0,R.$9d)(o,g[$])}}}catch{}return null}e.$Vp=u;async function c(y){try{return await D.Promises.realpath(y)}catch{const v=w(y);return await D.Promises.access(v,S.constants.R_OK),v}}e.$Wp=c;function m(y){try{return S.realpathSync(y)}catch{const v=w(y);return S.accessSync(v,S.constants.R_OK),v}}e.$Xp=m;function w(y){return(0,M.$ve)((0,R.$7d)(y),R.sep)}}),define(te[106],ie([0,1,27,9,21]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class w{constructor(h,t,l){this.exePath=h,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:P=!1}={}){return P?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:P=!1,findPreview:h=!1}={}){const t=y({useAlternateBitness:P});if(!t)return null;const l=R.$9d(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const k of await s.Promises.readdir(l)){let I=-1;if(h){const p=k.indexOf("-");if(p<0)continue;const A=k.substring(0,p);if(!M.test(A)||k.substring(p+1)!=="preview")continue;I=parseInt(A,10)}else{if(!M.test(k))continue;I=parseInt(k,10)}if(I<=r)continue;const C=R.$9d(l,k,"pwsh.exe");await s.SymlinkSupport.existsFile(C)&&(i=C,r=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=h?" Preview":"";return new w(i,`PowerShell${a}${n}`,!0)}async function v({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const h=R.$9d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=P?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(h))if(t.test(r)){const i=R.$9d(h,r,"pwsh.exe");return new w(i,l)}return null}function b(){const P=R.$9d(S.homedir(),".dotnet","tools","pwsh.exe");return new w(P,".NET Core PowerShell Global Tool")}function g(){const P=R.$9d(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(P,"Windows PowerShell",!0)}async function*$(){let P=await f();P&&(yield P),P=await f({useAlternateBitness:!0}),P&&(yield P),P=await v(),P&&(yield P),P=b(),P&&(yield P),P=await f({findPreview:!0}),P&&(yield P),P=await v({findPreview:!0}),P&&(yield P),P=await f({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=g(),P&&(yield P)}async function*o(){for await(const P of $())await P.exists()&&(yield P)}e.$ql=o;async function d(){for await(const P of o())return P;return null}e.$rl=d}),define(te[88],ie([0,1,9,4,35,72,12,21]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function u(w=s.env){return w.comspec||"cmd.exe"}e.$ul=u;function c(w){let y=[],f=!1;const v=function(b){if(f){y.push(b);return}(!w.send(b,$=>{if($&&console.error($),f=!1,y.length>0){const o=y.slice(0);y=[],o.forEach(d=>v(d))}})||R.$i)&&(f=!0)};return{send:v}}e.$vl=c;var m;(function(w){async function y(f,v,b){if(S.$8d(f))return f;if(v===void 0&&(v=s.cwd()),S.$_d(f)!=="."||(b===void 0&&D.$jf(s.env.PATH)&&(b=s.env.PATH.split(S.$ge)),b===void 0||b.length===0))return S.$9d(v,f);async function $(o){if(await E.Promises.exists(o)){let d;try{d=await E.Promises.stat(o)}catch(P){P.message.startsWith("EACCES")&&(d=await E.Promises.lstat(o))}return d?!d.isDirectory():!1}return!1}for(const o of b){let d;if(S.$8d(o)?d=S.$9d(o,f):d=S.$9d(v,o,f),await $(d))return d;let P=d+".com";if(await $(P)||(P=d+".exe",await $(P)))return P}return S.$9d(v,f)}w.findExecutable=y})(m||(e.win32=m={}))}),define(te[107],ie([0,1,47,13]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function s(D){return new Promise((E,u)=>{let c;const m=new Map;function w(f,v,b,g,$){const o=m.get(v);if(f===D||o){const d={name:y(b),cmd:b,pid:f,ppid:v,load:g,mem:$};m.set(f,d),f===D&&(c=d),o&&(o.children||(o.children=[]),o.children.push(d),o.children.length>1&&(o.children=o.children.sort((P,h)=>P.pid-h.pid)))}}function y(f){const v=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,g=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,o=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(o.exec(f))return"conpty-agent";let P=d.exec(f);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?v.exec(f)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const h=/[a-zA-Z-]+\.js/g;let t="";do P=h.exec(f),P&&(t+=P+" ");while(P);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,b)=>{K(["@vscode/windows-process-tree"],v,b)}).then(v=>{v.getProcessList(D,b=>{if(!b){u(new Error(`Root process ${D} not found`));return}v.getProcessCpuUsage(b,g=>{const $=new Map;g.forEach(o=>{const d=f(o.commandLine||"");$.set(o.pid,{name:y(d),cmd:d,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),c=$.get(D),c?($.forEach(o=>{const d=$.get(o.ppid);d&&(d.children||(d.children=[]),d.children.push(o))}),$.forEach(o=>{o.children&&(o.children=o.children.sort((d,P)=>d.pid-P.pid))}),E(c)):u(new Error(`Root process ${D} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let f=function(){let v=[c];const b=[];for(;v.length;){const $=v.shift();$&&(b.push($.pid),$.children&&(v=v.concat($.children)))}let g=JSON.stringify(R.$2f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+b.join(" "),(0,S.exec)(g,{},($,o,d)=>{if($||d)u($||new Error(d.toString()));else{const P=o.toString().split(`
`);for(let h=0;h<b.length;h++){const t=m.get(b[h]);t.load=parseFloat(P[h])}if(!c){u(new Error(`Root process ${D} not found`));return}E(c)}})};(0,S.exec)("which ps",{},(v,b,g)=>{if(v||g)if(process.platform!=="linux")u(v||new Error(g.toString()));else{const $=JSON.stringify(R.$2f.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)($,{},(o,d,P)=>{o||P?u(o||new Error(P.toString())):(M(d,w),f())})}else{const $=b.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${$} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,P,h)=>{d||h&&!h.includes("screen size is bogus")?u(d||new Error(h.toString())):(M(P,w),process.platform==="linux"?f():c?E(c):u(new Error(`Root process ${D} not found`)))})}})}})}e.$sr=s;function M(D,E){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=D.toString().split(`
`);for(const m of c){const w=u.exec(m.trim());w&&w.length===6&&E(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;async function D(w,y){return w===1?R.$i?m():M.$ul(y):u(w,y)}e.$wl=D;let E=null;function u(w,y){if(R.$k&&w===2||R.$j&&w===3)return"/bin/bash";if(!E){let f;if(R.$i)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}E=f}return E}let c=null;async function m(){return c||(c=(await(0,s.$rl)()).exePath),c}});var Ee=this&&this.__decorate||function(K,e,S,R){var s=arguments.length,M=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,S,R);else for(var E=K.length-1;E>=0;E--)(D=K[E])&&(M=(s<3?D(M):s>3?D(e,S,M):D(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(te[42],ie([0,1,23,8,17,22,54,14,3,2,73,26,12]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var f;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(f||(f={}));function v(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(b||(b={}));function g(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function o(H){let F=0;for(let N=0;;N+=7){const G=H.read(1);if(F|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return F}}const d=r(0);function P(H,F){if(F===0){H.write(d);return}let N=0;for(let Z=F;Z!==0;Z=Z>>>7)N++;const G=s.$Fd.alloc(N);for(let Z=0;F!==0;Z++)G.buffer[Z]=F&127,F=F>>>7,F>0&&(G.buffer[Z]|=128);H.write(G)}class h{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}e.$_g=h;class t{constructor(){this.a=[]}get buffer(){return s.$Fd.concat(this.a)}write(F){this.a.push(F)}}e.$ah=t;var l;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(l||(l={}));function r(H){const F=s.$Fd.alloc(1);return F.writeUInt8(H,0),F}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function a(H,F){if(typeof F>"u")H.write(i.Undefined);else if(typeof F=="string"){const N=s.$Fd.fromString(F);H.write(i.String),P(H,N.byteLength),H.write(N)}else if(n&&Buffer.isBuffer(F)){const N=s.$Fd.wrap(F);H.write(i.Buffer),P(H,N.byteLength),H.write(N)}else if(F instanceof s.$Fd)H.write(i.VSBuffer),P(H,F.byteLength),H.write(F);else if(Array.isArray(F)){H.write(i.Array),P(H,F.length);for(const N of F)a(H,N)}else if(typeof F=="number"&&(F|0)===F)H.write(i.Uint),P(H,F);else{const N=s.$Fd.fromString(JSON.stringify(F));H.write(i.Object),P(H,N.byteLength),H.write(N)}}e.$bh=a;function k(H){switch(H.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return H.read(o(H)).toString();case l.Buffer:return H.read(o(H)).buffer;case l.VSBuffer:return H.read(o(H));case l.Array:{const N=o(H),G=[];for(let Z=0;Z<N;Z++)G.push(k(H));return G}case l.Object:return JSON.parse(H.read(o(H)).toString());case l.Int:return o(H)}}e.$ch=k;class I{constructor(F,N,G=null,Z=1e3){this.h=F,this.j=N,this.k=G,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const N=this.o([F.type]);this.k?.logOutgoing(N,0,1,g(F.type));return}case 201:case 202:case 204:case 203:{const N=this.o([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,g(F.type),F.data);return}}}o(F,N=void 0){const G=new t;return a(G,F),a(G,N),this.p(G.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const N=new h(F),G=k(N),Z=k(N),_=G[0];switch(_){case 100:return this.k?.logIncoming(F.byteLength,G[1],1,`${v(_)}: ${G[2]}.${G[3]}`,Z),this.s({type:_,id:G[1],channelName:G[2],name:G[3],arg:Z});case 102:return this.k?.logIncoming(F.byteLength,G[1],1,`${v(_)}: ${G[2]}.${G[3]}`,Z),this.t({type:_,id:G[1],channelName:G[2],name:G[3],arg:Z});case 101:return this.k?.logIncoming(F.byteLength,G[1],1,`${v(_)}`),this.u({type:_,id:G[1]});case 103:return this.k?.logIncoming(F.byteLength,G[1],1,`${v(_)}`),this.u({type:_,id:G[1]})}}s(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const G=new M.$pd;let Z;try{Z=N.call(this.j,F.name,F.arg,G.token)}catch(T){Z=Promise.reject(T)}const _=F.id;Z.then(T=>{this.m({id:_,data:T,type:201})},T=>{T instanceof Error?this.m({id:_,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:_,data:T,type:203})}).finally(()=>{oe.dispose(),this.d.delete(F.id)});const oe=(0,c.$ic)(()=>G.cancel());this.d.set(F.id,oe)}t(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const G=F.id,_=N.listen(this.j,F.name,F.arg)(oe=>this.m({id:G,data:oe,type:204}));this.d.set(F.id,_)}u(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}v(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:G})}w(F){const N=this.g.get(F);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$dh=I;var C;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class p{constructor(F,N=null){this.l=F,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(F){const N=this;return{call(G,Z,_){return N.a?Promise.reject(new E.$3):N.m(F,G,Z,_)},listen(G,Z){return N.a?u.Event.None:N.o(F,G,Z)}}}m(F,N,G,Z=M.CancellationToken.None){const _=this.g++,T={id:_,type:100,channelName:F,name:N,arg:G};if(Z.isCancellationRequested)return Promise.reject(new E.$3);let O;return new Promise((z,W)=>{if(Z.isCancellationRequested)return W(new E.$3);const B=()=>{const he=fe=>{switch(fe.type){case 201:this.f.delete(_),z(fe.data);break;case 202:{this.f.delete(_);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,W(ve);break}case 203:this.f.delete(_),W(fe.data);break}};this.f.set(_,he),this.p(T)};let V=null;this.b===$.Idle?B():(V=(0,R.$ug)(he=>this.u()),V.then(()=>{V=null,B()}));const ce=()=>{V?(V.cancel(),V=null):this.p({id:_,type:101}),W(new E.$3)},de=Z.onCancellationRequested(ce);O=(0,c.$hc)((0,c.$ic)(ce),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(F,N,G){const Z=this.g++,oe={id:Z,type:102,channelName:F,name:N,arg:G};let T=null;const O=new u.$fd({onWillAddFirstListener:()=>{T=(0,R.$ug)(z=>this.u()),T.then(()=>{T=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(O),this.p({id:Z,type:103}))}}),j=z=>O.fire(z.data);return this.f.set(Z,j),O.event}p(F){switch(F.type){case 100:case 102:{const N=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${v(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.q([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,v(F.type));return}}}q(F,N=void 0){const G=new t;return a(G,F),a(G,N),this.r(G.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const N=new h(F),G=k(N),Z=k(N),_=G[0];switch(_){case 200:return this.j?.logIncoming(F.byteLength,0,0,g(_)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,G[1],0,g(_),Z),this.t({type:G[0],id:G[1],data:Z})}}t(F){if(F.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$eh=p,Ee([D.$6g],p.prototype,"onDidInitializePromise",null);class A{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new u.$fd,this.onDidAddConnection=this.g.event,this.h=new u.$fd,this.onDidRemoveConnection=this.h.event,this.j=new c.$jc,this.j.add(F(({protocol:N,onDidClientDisconnect:G})=>{const Z=u.Event.once(N.onMessage);this.j.add(Z(_=>{const oe=new h(_),T=k(oe),O=new I(N,T),j=new p(N);this.a.forEach((W,B)=>O.registerChannel(B,W));const z={channelServer:O,channelClient:j,ctx:T};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{O.dispose(),j.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(F,N){const G=this;return{call(Z,_,oe){let T;if((0,y.$xf)(N)){const j=(0,S.$2b)(G.connections.filter(N));T=j?Promise.resolve(j):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,N))}else T=N.routeCall(G,Z,_);const O=T.then(j=>j.channelClient.getChannel(F));return U(O).call(Z,_,oe)},listen(Z,_){if((0,y.$xf)(N))return G.k(F,N,Z,_);const oe=N.routeEvent(G,Z,_).then(T=>T.channelClient.getChannel(F));return U(oe).listen(Z,_)}}}k(F,N,G,Z){const _=this;let oe;const T=new u.$fd({onWillAddFirstListener:()=>{oe=new c.$jc;const O=new u.$ld,j=new Map,z=B=>{const ce=B.channelClient.getChannel(F).listen(G,Z),de=O.add(ce);j.set(B,de)},W=B=>{const V=j.get(B);V&&(V.dispose(),j.delete(B))};_.connections.filter(N).forEach(z),u.Event.filter(_.onDidAddConnection,N)(z,void 0,oe),_.onDidRemoveConnection(W,void 0,oe),O.event(T.fire,T,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return T.event}registerChannel(F,N){this.a.set(F,N);for(const G of this.f)G.channelServer.registerChannel(F,N)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=A;class L{constructor(F,N,G=null){const Z=new t;a(Z,N),F.send(Z.buffer),this.a=new p(F,G),this.d=new I(F,N,G)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=L;function U(H){return{call(F,N,G){return H.then(Z=>Z.call(F,N,G))},listen(F,N){const G=new u.$od;return H.then(Z=>G.input=Z.listen(F,N)),G.event}}}e.$hh=U;function q(H){let F=!1;return{call(N,G,Z){return F?H.call(N,G,Z):(0,R.$Hg)(0).then(()=>F=!0).then(()=>H.call(N,G,Z))},listen(N,G){if(F)return H.listen(N,G);const Z=new u.$od;return(0,R.$Hg)(0).then(()=>F=!0).then(()=>Z.input=H.listen(N,G)),Z.event}}}e.$ih=q;class se{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await u.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$jh=se;var x;(function(H){function F(_,oe,T){const O=_,j=T&&T.disableMarshalling,z=new Map;for(const W in O)G(W)&&z.set(W,u.Event.buffer(O[W],!0,void 0,oe));return new class{listen(W,B,V){const ce=z.get(B);if(ce)return ce;if(Z(B)){const de=O[B];if(typeof de=="function")return de.call(O,V)}throw new E.$_(`Event not found: ${B}`)}call(W,B,V){const ce=O[B];if(typeof ce=="function"){if(!j&&Array.isArray(V))for(let de=0;de<V.length;de++)V[de]=(0,m.$$g)(V[de]);return ce.apply(O,V)}throw new E.$_(`Method not found: ${B}`)}}}H.fromService=F;function N(_,oe){const T=oe&&oe.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return oe?.properties?.has(j)?oe.properties.get(j):Z(j)?function(z){return _.listen(j,z)}:G(j)?_.listen(j):async function(...z){let W;oe&&!(0,y.$sf)(oe.context)?W=[oe.context,...z]:W=z;const B=await _.call(j,W);return T?B:(0,m.$$g)(B)};throw new E.$_(`Property not found: ${String(j)}`)}})}H.toService=N;function G(_){return _[0]==="o"&&_[1]==="n"&&w.$Le(_.charCodeAt(2))}function Z(_){return/^onDynamic/.test(_)&&w.$Le(_.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const F=H.toString();if(F!=="[object Object]")return F}return H}function re(H){return Array.isArray(H)?H.map(ne):ne(H)}function Y(H,F,N,G,Z,_,oe){oe=re(oe);const T=ae[Z],O=T[G%T.length];let j=[`%c[${H}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(j=j.concat(oe),j.push(")")):j.push(oe),console.log.apply(console,j)}class J{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,G,Z,_){this.b+=F,Y(this.d,this.b,F,N,G,Z,_)}logIncoming(F,N,G,Z,_){this.a+=F,Y(this.f,this.a,F,N,G,Z,_)}}e.$kh=J}),define(te[156],ie([0,1,17,3,42]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4S=e.$3S=void 0;class M{constructor(u){this.a=u,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",c=>S.$Fd.wrap(c.data)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$3S=M;class D extends s.$gh{constructor(u,c){const m=new M(u);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$4S=D}),define(te[109],ie([0,1,17,3,2,42]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function k(C,p){if(!n.has(C)){const A=String(++a);n.set(C,A)}return n.get(C)}function I(C,p,A,L){if(!i.enableDiagnostics)return;const U=k(C,p);if(L instanceof S.$Fd||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const q=S.$Fd.alloc(L.byteLength);q.set(L),i.records.push({timestamp:Date.now(),id:U,label:p,type:A,buff:q})}else i.records.push({timestamp:Date.now(),id:U,label:p,type:A,data:L})}i.traceSocketEvent=I})(E||(e.SocketDiagnostics=E={}));var u;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let c=null;function m(){return c||(c=S.$Fd.alloc(0)),c}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const p=this.a[0];return a&&(this.a.shift(),this.b-=n),p}if(this.a[0].byteLength>n){const p=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),p}const k=S.$Fd.alloc(n);let I=0,C=0;for(;n>0;){const p=this.a[C];if(p.byteLength>n){const A=p.slice(0,n);k.set(A,I),I+=n,a&&(this.a[C]=p.slice(n),this.b-=n),n-=n}else k.set(p,I),I+=p.byteLength,a?(this.a.shift(),this.b-=p.byteLength):C++,n-=p.byteLength}return k}}e.$lh=w;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class b{constructor(n,a,k,I){this.type=n,this.id=a,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends s.$kc{constructor(n){super(),this.f=this.B(new R.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new b(k,I,C,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.$Fd.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const k=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,k}h(){const n=S.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class o extends s.$kc{constructor(n){super(),this.f=new R.$fd,this.onMessage=this.f.event,this.g=new R.$fd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$mh=o;class d extends M.$gh{static fromSocket(n,a){return new d(new o(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,k=null){super(n,a,k),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$nh=d;class P{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$oh=P;class h{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,k=this.a;for(;k;)n[a++]=k.data,k=k.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new h(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<l.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=l.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+l.a)*1e3;let k=0;for(let I=0;I<l.a;I++)n-this.c[I]<=a&&k++;return 1-k/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new P,this.onControlMessage=this.u.event,this.v=new P,this.onMessage=this.v.event,this.w=new P,this.onDidDispose=this.w.event,this.x=new P,this.onSocketClose=this.x.event,this.y=new P,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$jc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,m());this.p.write(n)}sendResume(){const n=new b(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n);const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new b(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const k=new b(1,a,this.h,n);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(n){const a=new b(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(a>=2e4&&k>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:k});return}const C=Math.max(2e4-a,2e4-k,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,m());this.p.write(n)}}e.$ph=r}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=void 0;function u(m,w){const y=s.Event.fromNodeEventEmitter(S.$ZS,w,(v,b)=>({event:v,message:b})),f=s.Event.filter(y,({event:v})=>v.sender.id===m);return s.Event.map(f,({message:v})=>v&&R.$Fd.wrap(v))}class c extends D.$fh{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(S.$ZS,"vscode:hello",({sender:y})=>y);return s.Event.map(w,y=>{const f=y.id;c.b.get(f)?.dispose();const b=new s.$fd;c.b.set(f,(0,M.$ic)(()=>b.fire()));const g=u(f,"vscode:message"),$=s.Event.any(s.Event.signal(u(f,"vscode:disconnect")),b.event);return{protocol:new E.$6S(y,g),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$7S=c}),define(te[110],ie([0,1,38,3,31,156]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9S=e.$8S=void 0;class D extends M.$4S{constructor(c,m){super({addEventListener:(w,y)=>c.addListener(w,y),removeEventListener:(w,y)=>c.removeListener(w,y),postMessage:w=>c.postMessage(w),start:()=>c.start(),close:()=>c.close()},m)}}e.$8S=D;async function E(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$4f)();u.webContents.send("vscode:createMessageChannel",c);const m=R.Event.fromNodeEventEmitter(S.$ZS,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:w}=await R.Event.toPromise(R.Event.once(R.Event.filter(m,y=>y.nonce===c)));return w}e.$9S=E}),define(te[158],ie([0,1,47,8,17,22,153,14,3,2,37,88,72,42]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class v extends f.$dh{constructor($){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",o=>s.$Fd.wrap(Buffer.from(o,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Rp=v;class b{constructor($,o){this.i=$,this.j=o,this.c=new Set,this.g=new Map,this.h=new u.$fd,this.onDidProcessExit=this.h.event;const d=o&&o.timeout?o.timeout:6e4;this.b=new R.$Dg(d),this.d=null,this.f=null}getChannel($){const o=this;return{call(d,P,h){return o.k($,d,P,h)},listen(d,P){return o.l($,d,P)}}}k($,o,d,P=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(E.$4());this.b.cancel();const h=this.n($),t=(0,R.$ug)(i=>h.call(o,d,i)),l=P.onCancellationRequested(()=>t.cancel()),r=(0,c.$ic)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,o,d){if(!this.b)return u.Event.None;this.b.cancel();let P;const h=new u.$fd({onWillAddFirstListener:()=>{P=this.n($).listen(o,d)(h.fire,h),this.c.add(P)},onDidRemoveLastListener:()=>{this.c.delete(P),P.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],o=Object.create(null);o.env={...(0,m.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(o.env={...o.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(o.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$tl)(o.env),this.d=(0,S.fork)(this.i,$,o);const d=new u.$fd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Np)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}d.fire(s.$Fd.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,w.$vl)(this.d):this.d,t=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),l=d.event,r={send:t,onMessage:l};this.f=new f.$eh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,c.$fc)(k)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n($){let o=this.g.get($);return o||(o=this.m.getChannel($),this.g.set($,o)),o}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=b}),define(te[111],ie([0,1,8,3,2,73,12]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var E;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(y){const f=y;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Qo=u;var c;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends s.$kc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new R.$id),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new S.$Eg(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,b)=>this.w(b,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===c.Closed)return;let b=!1;(0,D.$sf)(v)?b=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const b=this.f.get(f);return(0,D.$sf)(b)?v:b}getBoolean(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:b==="true"}getNumber(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:parseInt(b,10)}getObject(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:(0,M.$0g)(b)}async set(f,v,b=!1){if(this.c===c.Closed)return;if((0,D.$sf)(v))return this.delete(f,b);const g=(0,D.$lf)(v)||Array.isArray(v)?(0,M.$9g)(v):String(v);if(this.f.get(f)!==g)return this.f.set(f,g),this.j.set(f,g),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,v=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Ro=m;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,b)=>this.a.set(b,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$So=w}),define(te[159],ie([0,1,8,3,33,9,21]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sT=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(m,w=Object.create(null)){this.g=m,this.h=w,this.c=(0,M.$ae)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,w=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(f=>w.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(m){const w=await this.f;return this.j(w,m)}j(m,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$xi)(w.insert):"0"}), delete(${w.delete?(0,s.$yi)(w.delete):"0"})`),this.t(m,()=>{const y=w.insert,f=w.delete;if(y&&y.size>0){const v=[];v.push([]);let b=0;y.forEach((g,$)=>{let o=v[b];o.length>E.b&&(b++,o=[],v.push(o)),o.push($,g)}),v.forEach(g=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,$=>$.run(g),()=>{const $=[];let o=0;return y.forEach((d,P)=>{$.push(P),o+=d.length}),`Keys: ${$.join(", ")} Length: ${o}`})})}if(f&&f.size){const v=[];v.push([]);let b=0;f.forEach(g=>{let $=v[b];$.length>E.b&&(b++,$=[],v.push($)),$.push(g)}),v.forEach(g=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,$=>$.run(g),()=>{const $=[];return f.forEach(o=>{$.push(o)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const m=await this.f;return this.q(m,"VACUUM")}async close(m){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,m)}k(m,w){return new Promise((y,f)=>{m.db.close(v=>(v&&this.o(m,`[storage ${this.c}] close(): ${v}`),this.g===E.IN_MEMORY_PATH?y():!m.isErroneous&&!m.isInMemory?this.l().then(y,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),y())):typeof w=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const g=()=>this.k(b,void 0);return this.j(b,{insert:w()}).then(()=>g(),$=>(g(),Promise.reject($)))})).then(y,f):f(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return D.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const w=await this.f,y=await this.r(w,m?"PRAGMA integrity_check":"PRAGMA quick_check"),f=m?y.integrity_check:y.quick_check;return w.isErroneous?`${f} (last error: ${w.lastError})`:w.isInMemory?`${f} (in-memory!)`:f}async n(m,w=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${w})`);try{return await this.p(m)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,S.$Hg)(E.a),this.n(m,!1);try{await D.Promises.unlink(m);try{await D.Promises.rename(this.m(m),m,!1)}catch{}return await this.p(m)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(E.IN_MEMORY_PATH)}}}o(m,w){m.isErroneous=!0,m.lastError=w,this.d.error(w)}p(m){return new Promise((w,y)=>{new Promise((f,v)=>{K(["@vscode/sqlite3"],f,v)}).then(f=>{const v={db:new(this.d.isTracing?f.verbose().Database:f.Database)(m,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(b)):y(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(v),g=>v.db.close(()=>y(g)))),isInMemory:m===E.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},y)})}q(m,w){return new Promise((y,f)=>{m.db.exec(w,v=>v?(this.o(m,`[storage ${this.c}] exec(): ${v}`),f(v)):y())})}r(m,w){return new Promise((y,f)=>{m.db.get(w,(v,b)=>v?(this.o(m,`[storage ${this.c}] get(): ${v}`),f(v)):y(b))})}s(m,w){return new Promise((y,f)=>{m.db.all(w,(v,b)=>v?(this.o(m,`[storage ${this.c}] all(): ${v}`),f(v)):y(b))})}t(m,w){return new Promise((y,f)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),w(),m.db.run("END TRANSACTION",v=>v?(this.o(m,`[storage ${this.c}] transaction(): ${v}`),f(v)):y())})})}u(m,w,y,f){const v=m.db.prepare(w),b=g=>{this.o(m,`[storage ${this.c}] prepare(): ${g} (${w}). Details: ${f()}`)};v.on("error",b),y(v),v.finalize(g=>{g&&b(g),v.removeListener("error",b)})}}e.$sT=E;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[u.a]&&(this.b=m.logTrace),m&&typeof m.logError=="function"&&(this.c=m.logError)}get isTracing(){return!!this.b}trace(m){this.b?.(m)}error(m){this.c?.(m)}}}),define(te[160],ie([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jU=e.$iU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$iU=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$jU=R}),define(te[194],ie([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.$U5b=e.$T5b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$T5b=R;function s(D){let E=[];try{Array.isArray(D.workspaces)&&(E=D.workspaces.map(u=>({workspace:{id:u.id,configPath:S.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return E}e.$U5b=s;function M(D){let E=[];try{Array.isArray(D.folders)&&(E=D.folders.map(u=>({folderUri:S.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return E}e.$V5b=M}),define(te[195],ie([0,1,14,163]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,S.$6)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const w=this.d,y=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:y};this.g.push({offset:w,lexeme:y,additionalInfo:m}),this.f.push(f)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const w=this.c.substring(this.d,this.e),y=u.b.get(w);y?this.k(y):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,w=!1,y=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(E);return}const v=this.c.charCodeAt(m);if(w)w=!1;else if(v===47&&!y){m++;break}else v===91?y=!0:v===92?w=!0:v===93&&(y=!1);m++}for(;m<this.c.length&&u.a.has(this.c.charCodeAt(m));)m++;this.e=m;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=u}),define(te[196],ie([0,1,3,2]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=void 0;class s{constructor(){this.a=new S.$fd,this.b=new S.$fd,this.c=new S.$fd,this.d=new S.$fd}static{this.ChannelName="extensionhostdebugservice"}call(E,u,c){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,u,c){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Bn=s;class M extends R.$kc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,u,c){this.b.call("attach",[E,u,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,u){this.b.call("terminate",[E,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,u){return this.b.call("openExtensionDevelopmentHostWindow",[E,u])}}e.$Cn=M}),define(te[197],ie([0,1,148,54,13,9,35,19,7]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,M.$_d)(s.$2f.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,M.$9d)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,S.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$9d)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$ig)(u.URI.file((0,M.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?u.URI.file((0,M.$9d)(f,"argv.json")):(0,E.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,M.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$0d)(f):(0,M.$7d)((0,M.$9d)(s.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,M.$0d)(f)):u.URI.file((0,M.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$0d)(f);const v=D.env.VSCODE_EXTENSIONS;if(v)return v;const b=D.env.VSCODE_PORTABLE;return b?(0,M.$9d)(b,"extensions"):(0,E.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?u.URI.parse(v):u.URI.file((0,M.$7d)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,M.$7d)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$8l.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const b=e.$8l.exec(v);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,E.$ig)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?u.URI.file((0,M.$9d)(f,"policy.json")):(0,E.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,b){this.a=f,this.b=v,this.c=b,this.editSessionId=this.args.editSessionId}}e.$9l=c,Ee([R.$6g],c.prototype,"appRoot",null),Ee([R.$6g],c.prototype,"userHome",null),Ee([R.$6g],c.prototype,"userDataPath",null),Ee([R.$6g],c.prototype,"appSettingsHome",null),Ee([R.$6g],c.prototype,"tmpDir",null),Ee([R.$6g],c.prototype,"cacheHome",null),Ee([R.$6g],c.prototype,"stateResource",null),Ee([R.$6g],c.prototype,"userRoamingDataHome",null),Ee([R.$6g],c.prototype,"userDataSyncHome",null),Ee([R.$6g],c.prototype,"sync",null),Ee([R.$6g],c.prototype,"machineSettingsResource",null),Ee([R.$6g],c.prototype,"workspaceStorageHome",null),Ee([R.$6g],c.prototype,"localHistoryHome",null),Ee([R.$6g],c.prototype,"keyboardLayoutResource",null),Ee([R.$6g],c.prototype,"argvResource",null),Ee([R.$6g],c.prototype,"isExtensionDevelopment",null),Ee([R.$6g],c.prototype,"untitledWorkspacesHome",null),Ee([R.$6g],c.prototype,"builtinExtensionsPath",null),Ee([R.$6g],c.prototype,"extensionsPath",null),Ee([R.$6g],c.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$6g],c.prototype,"extensionDevelopmentKind",null),Ee([R.$6g],c.prototype,"extensionTestsLocationURI",null),Ee([R.$6g],c.prototype,"debugExtensionHost",null),Ee([R.$6g],c.prototype,"logLevel",null),Ee([R.$6g],c.prototype,"extensionLogLevel",null),Ee([R.$6g],c.prototype,"serviceMachineIdResource",null),Ee([R.$6g],c.prototype,"disableTelemetry",null),Ee([R.$6g],c.prototype,"disableWorkspaceTrust",null),Ee([R.$6g],c.prototype,"useInMemorySecretStorage",null),Ee([R.$6g],c.prototype,"policyFile",null);function m(y,f){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,f,y.debugId,y.extensionEnvironment)}e.$0l=m;function w(y,f,v,b,g,$){const d=Number(f||y)||(b?null:v),P=d?!!f:!1;let h;if($)try{h=JSON.parse($)}catch{}return{port:d,break:P,debugId:g,env:h}}e.$$l=w}),define(te[112],ie([0,1,308,4,166]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$xl=["tunnel","serve-web"],e.$yl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(b,g,$=D){const o=b.find(a=>a.length>0&&a[0]!=="-"),d={},P=["_"],h=[],t={};let l;for(const a in g){const k=g[a];k.type==="subcommand"?a===o&&(l=k):(k.alias&&(d[a]=k.alias),k.type==="string"||k.type==="string[]"?(P.push(a),k.deprecates&&P.push(...k.deprecates)):k.type==="boolean"&&(h.push(a),k.deprecates&&h.push(...k.deprecates)),k.global&&(t[a]=k))}if(l&&o){const a=t;for(const p in l.options)a[p]=l.options[p];const k=b.filter(p=>p!==o),I=$.getSubcommandReporter?$.getSubcommandReporter(o):void 0,C=E(k,a,I);return{[o]:C,_:[]}}const r=S(b,{string:P,boolean:h,alias:d}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in g){const k=g[a];if(k.type==="subcommand")continue;k.alias&&delete n[k.alias];let I=n[a];if(k.deprecates)for(const C of k.deprecates)n.hasOwnProperty(C)&&(I||(I=n[C],I&&$.onDeprecatedOption(C,k.deprecationMessage||(0,s.localize)(37,null,a))),delete n[C]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const C=I.filter(p=>p.length>0);C.length!==I.length&&($.onEmptyValue(a),I=C.length>0?C:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),$.onMultipleValues(a,I)):!I&&!k.allowEmptyValue&&($.onEmptyValue(a),I=void 0));i[a]=I,k.deprecationMessage&&$.onDeprecatedOption(a,k.deprecationMessage)}delete n[a]}for(const a in n)$.onUnknownOption(a);return i}e.$zl=E;function u(b,g){let $="";return g.args&&(Array.isArray(g.args)?$=` <${g.args.join("> <")}>`:$=` <${g.args}>`),g.alias?`-${g.alias} --${b}${$}`:`--${b}${$}`}function c(b,g){const $=[];for(const o in b){const d=b[o],P=u(o,d);$.push([P,d.description])}return m($,g)}e.$Al=c;function m(b,g){const o=b.reduce((h,t)=>Math.max(h,t[0].length),12)+2+1;if(g-o<25)return b.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=g-o-1,P=[];for(const h of b){const t=h[0],l=y(h[1],d),r=w(o-t.length-2);P.push("  "+t+r+l[0]);for(let i=1;i<l.length;i++)P.push(w(o)+l[i])}return P}function w(b){return" ".repeat(b)}function y(b,g){const $=[];for(;b.length;){const o=b.length<g?b.length:b.lastIndexOf(" ",g),d=b.slice(0,o).trim();b=b.slice(o),$.push(d)}return $}function f(b,g,$,o,d){const P=process.stdout.isTTY&&process.stdout.columns||80,h=d?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${b} ${$}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${g} [${(0,s.localize)(40,null)}]${h}`),t.push(""),d?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(41,null,g)):t.push((0,s.localize)(42,null,g)),t.push(""));const l={},r=[];for(const i in o){const n=o[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=l[n.cat];a||(l[n.cat]=a={}),a[i]=n}}for(const i in l){const n=i,a=l[n];a&&(t.push(M[n]),t.push(...c(a,P)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...m(r.map(i=>[i.command,i.description]),P)),t.push("")),t.join(`
`)}e.$Bl=f;function v(b,g){return`${b||(0,s.localize)(44,null)}
${g||(0,s.localize)(45,null)}
${process.arch}`}e.$Cl=v}),define(te[198],ie([0,1,87,196,112]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=void 0;class M extends R.$Bn{constructor(E){super(),this.f=E}call(E,u,c){return u==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,u,c)}async g(E,u){const c=(0,s.$zl)(E,s.$yl);c.debugRenderer=u;const m=c.extensionDevelopmentPath;if(!m)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!u)return{success:!0};const y=w.win;if(!y)return{success:!0};const f=y.webContents.debugger;let v=f.isAttached()?1/0:0;const b=(0,S.createServer)(g=>{v++===0&&f.attach();let $=!1;const o=h=>{$||g.write(JSON.stringify(h)+"\0")},d=(h,t,l,r)=>o({method:t,params:l,sessionId:r});y.on("close",()=>{f.removeListener("message",d),g.end(),$=!0}),f.addListener("message",d);let P=Buffer.alloc(0);g.on("data",h=>{P=Buffer.concat([P,h]);for(let t=P.indexOf(0);t!==-1;t=P.indexOf(0)){let l;try{const r=P.slice(0,t).toString("utf8");P=P.slice(t+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(l.method,l.params,l.sessionId).then(r=>o({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>o({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),g.on("error",h=>{console.error("error on cdp pipe:",h)}),g.on("close",()=>{$=!0,--v===0&&f.detach()})});return await new Promise(g=>b.listen(0,g)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$35b=M}),define(te[62],ie([0,1,309,167,112]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=e.$Dl=void 0;function M(w,y){const f=(d,P)=>{console.warn((0,R.localize)(0,null,d,P))},v=d=>{console.warn((0,R.localize)(1,null,d))},b=(d,P)=>{console.warn((0,R.localize)(2,null,d,P))},g=d=>({onUnknownOption:P=>{s.$xl.includes(d)||console.warn((0,R.localize)(3,null,P,d))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:s.$xl.includes(d)?g:void 0}),$={onUnknownOption:d=>{console.warn((0,R.localize)(4,null,d))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:g},o=(0,s.$zl)(w,s.$yl,y?$:void 0);return o.goto&&o._.forEach(d=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,R.localize)(5,null))),o}function D(w){const y=w.findIndex(f=>!/^-/.test(f));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function E(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=D(y)||[]);const f=!m(process.env);return M(y,f)}e.$Dl=E;function u(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$El=u;function c(w,...y){const f=w.indexOf("--");return f===-1?w.push(...y):w.splice(f,0,...y),w}e.$Fl=c;function m(w){return w.VSCODE_CLI==="1"}e.$Gl=m}),function(){"use strict";function K(e,S,R){function s(D,E){const u=M(D,E),c=[u];return e.isAbsolute(u)||c.unshift(R),e.resolve(...c)}function M(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const m=D["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(S.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,27,35]),function(e,S,R){return K(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=K(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,197,199]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class M extends R.$9l{constructor(c,m){super(c,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,m.nameShort)},m)}}e.$_l=M;function D(u,c){return(0,R.$$l)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$am=D;function E(u,c){return(0,R.$$l)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$bm=E}),define(te[200],ie([0,1,45,27,32]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;function M(D){const E=(0,s.$Qf)((0,R.tmpdir)());try{return(0,S.writeFileSync)(E,""),D&&console.log(`Marker file for --wait created: ${E}`),E}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.$t7b=M}),define(te[201],ie([0,1,12,169]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function s(D,E,u,c){try{M(D,E,u,c)}catch(m){D.error(m?.message??m)}return E}e.$np=s;function M(D,E,u,c){const m=(w,y,f)=>{const v=w[y];if((0,S.$jf)(v)){const b=v,g=b.length;if(g>1&&b[0]==="%"&&b[g-1]==="%"){const $=b.substr(1,g-2);let o=u[$];o===void 0&&c&&(o=c[$]);const d=typeof o=="string"?o:o?.message,P=c?.[$],h=typeof P=="string"?P:P?.message;if(!d){h||D.warn(`[${E.name}]: ${(0,R.localize)(0,null,$)}`);return}if(f&&(y==="title"||y==="category")&&h&&h!==d){const t={value:d,original:h};w[y]=t}else w[y]=d}}else if((0,S.$lf)(v))for(const b in v)v.hasOwnProperty(b)&&(b==="commands"?m(v,b,!0):m(v,b,f));else if(Array.isArray(v))for(let b=0;b<v.length;b++)m(v,b,f)};for(const w in E)E.hasOwnProperty(w)&&m(E,w)}}),define(te[202],ie([0,1,19,69,171,203]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u($){return $=$.trim(),$==="*"||D.test($)}e.$Bo=u;function c($){if(!u($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=$.match(D);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.$Co=c;function m($){if(!$)return null;const o=$.majorBase,d=$.majorMustEqual,P=$.minorBase;let h=$.minorMustEqual;const t=$.patchBase;let l=$.patchMustEqual;$.hasCaret&&(o===0||(h=!1),l=!1);let r=0;if($.preRelease){const i=E.exec($.preRelease);if(i){const[,n,a,k]=i;r=Date.UTC(Number(n),Number(a)-1,Number(k))}}return{majorBase:o,majorMustEqual:d,minorBase:P,minorMustEqual:h,patchBase:t,patchMustEqual:l,isMinimum:$.hasGreaterEquals,notBefore:r}}e.$Do=m;function w($,o,d){let P;typeof $=="string"?P=m(c($)):P=$;let h;o instanceof Date?h=o.getTime():typeof o=="string"&&(h=new Date(o).getTime());let t;if(typeof d=="string"?t=m(c(d)):t=d,!P||!t)return!1;const l=P.majorBase,r=P.minorBase,i=P.patchBase;let n=t.majorBase,a=t.minorBase,k=t.patchBase;const I=t.notBefore;let C=t.majorMustEqual,p=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>a?!0:r<a||h&&h<I?!1:i>=k:(l===1&&n===0&&(!C||!p||!A)&&(n=1,a=0,k=0,C=!0,p=!1,A=!1),l<n?!1:l>n?!C:r<a?!1:r>a?!p:i<k?!1:i>k?!A:!(h&&h<I))}e.$Eo=w;function y($,o,d,P,h){const t=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof P.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof P.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!P.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof P.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof P.extensionDependencies<"u"&&!g(P.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof P.activationEvents<"u"){if(!g(P.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof P.main>"u"&&typeof P.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$ig)(d,P.main);(0,S.$cg)(i,d)||t.push([R.default.Warning,s.localize(10,null,i.path,d.path)])}}if(typeof P.browser<"u"){if(typeof P.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$ig)(d,P.browser);(0,S.$cg)(i,d)||t.push([R.default.Warning,s.localize(12,null,i.path,d.path)])}}if(!M.valid(P.version))return t.push([R.default.Error,s.localize(13,null)]),t;const l=[];if(!f($,o,P,h,l))for(const i of l)t.push([R.default.Error,i]);return t}e.$Fo=y;function f($,o,d,P,h){return P||typeof d.main>"u"&&typeof d.browser>"u"?!0:b($,o,d.engines.vscode,h)}e.$Go=f;function v($,o,d){return $==="*"||b(o,d,$)}e.$Ho=v;function b($,o,d,P=[]){const h=m(c(d));if(!h)return P.push(s.localize(14,null,d)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return P.push(s.localize(15,null,d)),!1}else if(!h.majorMustEqual)return P.push(s.localize(16,null,d)),!1;return w($,o,h)?!0:(P.push(s.localize(17,null,$,d)),!1)}function g($){if(!Array.isArray($))return!1;for(let o=0,d=$.length;o<d;o++)if(typeof $[o]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function s(M,D,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const m=(await D.readFile(M.serviceMachineIdResource)).value.toString();u=(0,R.$3f)(m)?m:null}catch{u=null}if(!u){u=(0,R.$4f)();try{await D.writeFile(M.serviceMachineIdResource,S.$Fd.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.$2o=s}),define(te[74],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class S{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$yh=S}),define(te[205],ie([0,1,74]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const R=[];var s;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(E,u,c){u instanceof S.$yh||(u=new S.$yh(u,[],!!c)),R.push([E,u])}e.$mr=M;function D(){return R}e.$nr=D}),define(te[206],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class S{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$4p=S;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const E=this.lookupOrInsertNode(M),u=this.lookupOrInsertNode(D);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const E of this.a.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let E=this.a.get(D);return E||(E=new S(D,M),this.a.set(D,E)),E}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,E]of this.a)M.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const E=new Set([M]),u=this.c(D,E);if(u)return u}}c(M,D){for(const[E,u]of M.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const c=this.c(u,D);if(c)return c;D.delete(E)}}}e.$5p=R}),define(te[6],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function E(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=E})(S||(e._util=S={})),e.$Ah=s("instantiationService");function R(D,E,u){E[S.DI_TARGET]===E?E[S.DI_DEPENDENCIES].push({id:D,index:u}):(E[S.DI_DEPENDENCIES]=[{id:D,index:u}],E[S.DI_TARGET]=E)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const E=function(u,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,u,m)};return E.toString=()=>D,S.serviceIds.set(D,E),E}e.$Bh=s;function M(D){return D}e.$Ch=M}),define(te[63],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=void 0,e.$W5b=(0,S.$Bh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,s.$Bh)("configurationService");function M($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof R.URI)}e.$9h=M;function D($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof R.URI)}e.$0h=D;var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=u;function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$_h=c;function m($,o){const d=Object.create(null);for(const P in $)w(d,P,$[P],o);return d}e.$ai=m;function w($,o,d,P){const h=o.split("."),t=h.pop();let l=$;for(let r=0;r<h.length;r++){const i=h[r];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:P(`Ignoring ${o} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=d}catch{P(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(l)}`)}else P(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(l)}`)}e.$bi=w;function y($,o){const d=o.split(".");f($,d)}e.$ci=y;function f($,o){const d=o.shift();if(o.length===0){delete $[d];return}if(Object.keys($).indexOf(d)!==-1){const P=$[d];typeof P=="object"&&!Array.isArray(P)&&(f(P,o),Object.keys(P).length===0&&delete $[d])}}function v($,o,d){function P(l,r){let i=l;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const h=o.split("."),t=P($,h);return typeof t>"u"?d:t}e.$di=v;function b($,o,d){Object.keys(o).forEach(P=>{P!=="__proto__"&&(P in $?S.$lf($[P])&&S.$lf(o[P])?b($[P],o[P],d):d&&($[P]=o[P]):$[P]=o[P])})}e.$ei=b;function g($){return $.replace(/[\[\]]/g,"")}e.$fi=g}),define(te[114],ie([0,1,4,26,195,6,162,14]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",S.$j),u.set("isLinux",S.$k),u.set("isWindows",S.$i),u.set("isWeb",S.$o),u.set("isMacNative",S.$j&&!S.$o),u.set("isEdge",S.$G),u.set("isFirefox",S.$E),u.set("isChrome",S.$D),u.set("isSafari",S.$F);function c(T,O){if(u.get(T)!==void 0)throw(0,E.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(T,O)}e.$Gi=c;const m=Object.prototype.hasOwnProperty;var w;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),v=(0,D.localize)(1,null),b=(0,D.localize)(2,null),g=(0,D.localize)(3,null),$=(0,D.localize)(4,null),o=(0,D.localize)(5,null),d=(0,D.localize)(6,null),P=(0,D.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const z=this.D(),W=z.type===17?o:void 0;throw this.h.push({message:$,offset:z.offset,lexeme:s.$Fi.getLexeme(z),additionalInfo:W}),h.c}return j}catch(j){if(j!==h.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,g),j?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,g),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const B=W.lexeme,V=B.lastIndexOf("/"),ce=V===B.length-1?void 0:this.w(B.substring(V+1));let de;try{de=new RegExp(B.substring(1,V),ce)}catch{throw this.B("REGEX",W)}return ne.create(j,de)}switch(W.type){case 10:case 19:{const B=[W.lexeme];this.z();let V=this.D(),ce=0;for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--}if(ce<0)break;B.push(s.$Fi.getLexeme(V)),this.z(),V=this.D()}const de=B.join(""),he=de.lastIndexOf("/"),fe=he===de.length-1?void 0:this.w(de.substring(he+1));let ve;try{ve=new RegExp(de.substring(1,he),fe)}catch{throw this.B("REGEX",W)}return t.regex(j,ve)}case 18:{const B=W.lexeme;this.z();let V=null;if(!(0,R.$me)(B)){const ce=B.indexOf("/"),de=B.lastIndexOf("/");if(ce!==de&&ce>=0){const he=B.slice(ce+1,de),fe=B[de+1]==="i"?"i":"";try{V=new RegExp(he,fe)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return ne.create(j,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const W=this.u();return t.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(j,W);switch(W){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(j,W);switch(W){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,W)}}case 5:return this.z(),x.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),q.create(j,this.u());case 8:return this.z(),se.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:d,offset:O.offset,lexeme:"",additionalInfo:P}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,z){const W=(0,D.localize)(8,null,O,s.$Fi.getLexeme(j)),B=j.offset,V=s.$Fi.getLexeme(j);return this.h.push({message:W,offset:B,lexeme:V,additionalInfo:z}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=h;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return k.create(O)}static equals(O,j){return I.create(O,j)}static notEquals(O,j){return A.create(O,j)}static regex(O,j){return ne.create(O,j)}static in(O,j){return C.create(O,j)}static notIn(O,j){return p.create(O,j)}static not(O){return L.create(O)}static and(...O){return J.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,j){return q.create(O,j)}static greaterEquals(O,j){return se.create(O,j)}static smaller(O,j){return x.create(O,j)}static smallerEquals(O,j){return ae.create(O,j)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ii=t;function l(T){const O=new h({regexParsingWithErrorRecovery:!1});return T.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,D.localize)(9,null,z.additionalInfo):(0,D.localize)(10,null),offset:z.offset,length:z.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Ji=l;function r(T,O){const j=T?T.substituteConstants():void 0,z=O?O.substituteConstants():void 0;return!j&&!z?!0:!j||!z?!1:j.equals(z)}e.$Ki=r;function i(T,O){return T.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$Li=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Mi=a;class k{static create(O,j=null){const z=u.get(O);return typeof z=="boolean"?z?a.INSTANCE:n.INSTANCE:new k(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=u.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ni=k;class I{static create(O,j,z=null){if(typeof j=="boolean")return j?k.create(O,z):L.create(O,z);const W=u.get(O);return typeof W=="boolean"?j===(W?"true":"false")?a.INSTANCE:n.INSTANCE:new I(O,j,z)}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=u.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Oi=I;class C{static create(O,j){return new C(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),z=O.getValue(this.d);return Array.isArray(j)?j.includes(z):typeof z=="string"&&typeof j=="object"&&j!==null?m.call(j,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Pi=C;class p{static create(O,j){return new p(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=C.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=p;class A{static create(O,j,z=null){if(typeof j=="boolean")return j?L.create(O,z):k.create(O,z);const W=u.get(O);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:a.INSTANCE:new A(O,j,z)}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=u.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=A;class L{static create(O,j=null){const z=u.get(O);return typeof z=="boolean"?z?n.INSTANCE:a.INSTANCE:new L(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=u.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Si=L;function U(T,O){if(typeof T=="string"){const j=parseFloat(T);isNaN(j)||(T=j)}return typeof T=="string"||typeof T=="number"?O(T):n.INSTANCE}class q{static create(O,j,z=null){return U(j,W=>new q(O,W,z))}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ti=q;class se{static create(O,j,z=null){return U(j,W=>new se(O,W,z))}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Ui=se;class x{static create(O,j,z=null){return U(j,W=>new x(O,W,z))}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Vi=x;class ae{static create(O,j,z=null){return U(j,W=>new ae(O,W,z))}constructor(O,j,z){this.c=O,this.d=j,this.f=z,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Wi=ae;class ne{static create(O,j){return new ne(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",z=O.f?O.f.source:"";return j<z?-1:j>z?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",z=O.f?O.f.source:"";return this.d===O.d&&j===z}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Xi=ne;class re{static create(O){return new re(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new re(this.c.map(O))}negate(){return this.c}}e.$Yi=re;function Y(T){let O=null;for(let j=0,z=T.length;j<z;j++){const W=T[j].substituteConstants();if(T[j]!==W&&O===null){O=[];for(let B=0;B<j;B++)O[B]=T[B]}O!==null&&(O[j]=W)}return O===null?T:O}class J{static create(O,j,z){return J.d(O,j,z)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,z=this.expr.length;j<z;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:J.create(O,this.c,!1)}evaluate(O){for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,z){const W=[];let B=!1;for(const V of O)if(V){if(V.type===1){B=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&B)return a.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const ce=W.pop(),de=W.length===0,he=H.create(V.expr.map(fe=>J.create([fe,ce],null,z)),null,de);he&&(W.push(he),W.sort(i))}if(W.length===1)return W[0];if(z){for(let V=0;V<W.length;V++)for(let ce=V+1;ce<W.length;ce++)if(W[V].negate().equals(W[ce]))return n.INSTANCE;if(W.length===1)return W[0]}return new J(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new J(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=H.create(O,this,!0)}return this.c}}e.$Zi=J;class H{static create(O,j,z){return H.d(O,j,z)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,z=this.expr.length;j<z;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,z=this.expr.length;j<z;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let j=0,z=this.expr.length;j<z;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,z){let W=[],B=!1;if(O){for(let V=0,ce=O.length;V<ce;V++){const de=O[V];if(de){if(de.type===0){B=!0;continue}if(de.type===1)return a.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&B)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(z){for(let V=0;V<W.length;V++)for(let ce=V+1;ce<W.length;ce++)if(W[V].negate().equals(W[ce]))return a.INSTANCE;if(W.length===1)return W[0]}return new H(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new H(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),z=O.shift(),W=[];for(const B of oe(j))for(const V of oe(z))W.push(J.create([B,V],null,!1));O.unshift(H.create(W,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$1i=H;class F extends k{static{this.d=[]}static all(){return F.d.values()}constructor(O,j,z){super(O,null),this.f=j,typeof z=="object"?F.d.push({...z,key:O}):z!==!0&&F.d.push({key:O,description:z,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return I.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$2i=F,e.$3i=(0,M.$Bh)("contextKeyService");function N(T,O){return T<O?-1:T>O?1:0}function G(T,O,j,z){return T<j?-1:T>j?1:O<z?-1:O>z?1:0}function Z(T,O){if(T.type===0||O.type===1)return!0;if(T.type===9)return O.type===9?_(T.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(Z(T,j))return!0;return!1}if(T.type===6){if(O.type===6)return _(O.expr,T.expr);for(const j of T.expr)if(Z(j,O))return!0;return!1}return T.equals(O)}e.$4i=Z;function _(T,O){let j=0,z=0;for(;j<T.length&&z<O.length;){const W=T[j].cmp(O[z]);if(W<0)return!1;W===0&&j++,z++}return j===T.length}function oe(T){return T.type===9?T.expr:[T]}}),define(te[90],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.ID=void 0,e.ID="diagnosticsService",e.$gm=(0,S.$Bh)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.$hm=R;class s{async getPerformanceInfo(D,E){return{}}async getSystemInfo(D,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,E){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$im=s}),define(te[91],ie([0,1,19,69,164,6,46,4,37]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.ConfirmResult=e.$tv=e.$sv=e.$rv=void 0,e.$rv=(0,M.$Bh)("dialogService");var c;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(c||(c={}));class m{a(g){return this.d(g,c.Confirmation)}b(g){return this.d(g,c.Prompt)}c(g){return this.d(g,c.Input)}d(g,$){const o=[];switch($){case c.Confirmation:{const d=g;d.primaryButton?o.push(d.primaryButton):o.push((0,s.localize)(0,null)),d.cancelButton?o.push(d.cancelButton):o.push((0,s.localize)(1,null));break}case c.Prompt:{const d=g;Array.isArray(d.buttons)&&d.buttons.length>0&&o.push(...d.buttons.map(P=>P.label)),d.cancelButton&&(d.cancelButton===!0?o.push((0,s.localize)(2,null)):typeof d.cancelButton=="string"?o.push(d.cancelButton):d.cancelButton.label?o.push(d.cancelButton.label):o.push((0,s.localize)(3,null))),o.length===0&&o.push((0,s.localize)(4,null));break}case c.Input:{const d=g;d.primaryButton?o.push(d.primaryButton):o.push((0,s.localize)(5,null)),d.cancelButton?o.push(d.cancelButton):o.push((0,s.localize)(6,null));break}}return o}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===R.default.Info?"info":g===R.default.Error?"error":g===R.default.Warning?"warning":"none"}async f(g,$,o){const d=[...g.buttons??[]];return g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&d.push(g.cancelButton),{result:await d[$]?.run({checkboxChecked:o}),checkboxChecked:o}}}e.$sv=m,e.$tv=(0,M.$Bh)("fileDialogService");var w;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function f(b){const g=[];return g.push(...b.slice(0,y).map($=>typeof $=="string"?$:(0,S.$fg)($))),b.length>y&&(b.length-y===1?g.push((0,s.localize)(7,null)):g.push((0,s.localize)(8,null,b.length-y))),g.push(""),g.join(`
`)}e.$uv=f;function v(b,g){const $=(0,u.$Vm)(b);let o=($.buttons??[]).map(t=>(0,D.$ov)(t)),d=(b.buttons||[]).map((t,l)=>l),P=0,h=$.cancelId??o.length-1;if(o.length>1){const t=typeof h=="number"?o[h]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&o.length>1&&h!==1){o.splice(h,1),o.splice(1,0,t);const l=d[h];d.splice(h,1),d.splice(1,0,l),h=1}E.$k&&o.length>1&&(o=o.reverse(),d=d.reverse(),P=o.length-1,typeof t=="string"&&(h=P-1))}else if(E.$i&&typeof t=="string"&&o.length>1&&h!==o.length-1){o.splice(h,1),o.push(t);const l=d[h];d.splice(h,1),d.push(l),h=o.length-1}}return $.buttons=o,$.defaultId=P,$.cancelId=h,$.noLink=!0,$.title=$.title||g.nameLong,{options:$,buttonIndeces:d}}e.$vv=v}),define(te[115],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JT=e.$IT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$HT=e.$GT=void 0,e.$GT=(0,S.$Bh)("encryptionService"),e.$HT=(0,S.$Bh)("encryptionMainService");var R;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnome="gnome",E.gnomeKeyring="gnome-keyring",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}e.$IT=M;function D(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}e.$JT=D}),define(te[36],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,S.$Bh)("environmentService"),e.$Jh=(0,S.$Ch)(e.$Ih)}),define(te[116],ie([0,1,168,6]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function s(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=s;function M(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=M;function D(o,d){switch(o){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=D;function E(o,d){return d==="web"&&!o.includes("web")}e.$Vn=E;function u(o,d,P){return E(d,P)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===P?!0:c(P).includes(o)}e.$Wn=u;function c(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=c;function m(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Yn=m;var w;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var y;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var f;(function(o){o.Install="install",o.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Zn=(0,R.$Bh)("extensionGalleryService");var b;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var g;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class $ extends Error{constructor(d,P){super(d),this.code=P,this.name=P}}e.$1n=$,e.$2n=(0,R.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,R.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,R.$Bh)("IExtensionTipsService"),e.$7n=(0,S.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,S.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blb=void 0,e.$blb=(0,S.$Bh)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=e.$f6b=void 0,e.$f6b=(0,S.$Bh)("extensionHostStarter"),e.$g6b="extensionHostStarter"}),define(te[209],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AXb=e.$zXb=void 0,e.$zXb=(0,S.$Bh)("externalTerminal"),e.$AXb="Terminal.app"}),define(te[210],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=void 0,e.$i6b=(0,S.$Bh)("externalTerminal")}),define(te[211],ie([0,1,47,13,9,4,72,21,88,172,209]),function(K,e,S,R,s,M,D,E,u,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=e.$j6b=void 0;const w=c.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{static{this.b="cmd.exe"}openTerminal(P,h){return this.spawnTerminal(S,P,u.$ul(),h)}spawnTerminal(P,h,t,l){const r=h.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$ae(r,".exe").toLowerCase();if(i==="cmder")return P.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((a,k)=>{const I=g(process),C=P.spawn(t,n,{cwd:l,env:I});C.on("error",k),C.on("exit",()=>a())})}runInTerminal(P,h,t,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,a)=>{const k=`"${h} - ${w}"`,I=`""${t.join('" "')}" & pause"`,C=Object.assign({},g(process),l);Object.keys(C).filter(q=>C[q]===null).forEach(q=>delete C[q]);const p={cwd:h,env:C,windowsVerbatimArguments:!0};let A,L;s.$ae(i,".exe")==="wt"?(A=i,L=["-d",".",f.b,"/c",I]):(A=f.b,L=["/c","start",k,"/wait",i,"/c",I]),S.spawn(A,L,p).on("error",q=>{a($(q))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const P=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${P?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$j6b=f;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(P,h){return this.spawnTerminal(S,P,h)}runInTerminal(P,h,t,l,r){const i=r.osxExec||m.$AXb;return new Promise((n,a)=>{if(i===m.$AXb||i==="iTerm.app"){const k=i===m.$AXb?"TerminalHelper":"iTermHelper",C=[R.$2f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",P||w,"-w",h];for(const L of t)C.push("-a"),C.push(L);if(l){const L=Object.assign({},g(process),l);for(const U in L){const q=L[U];q===null?(C.push("-u"),C.push(U)):(C.push("-e"),C.push(`${U}=${q}`))}}let p="";const A=S.spawn(v.b,C);A.on("error",L=>{a($(L))}),A.stderr.on("data",L=>{p+=L.toString()}),A.on("exit",L=>{if(L===0)n(void 0);else if(p){const U=p.split(`
`,1);a(new Error(U[0]))}else a(new Error(c.localize(1,null,k,L)))})}else a(new Error(c.localize(2,null,i)))})}spawnTerminal(P,h,t){const l=h.osxExec||m.$AXb;return new Promise((r,i)=>{const n=["-a",l];t&&n.push(t);const a=g(process),k=P.spawn("/usr/bin/open",n,{cwd:t,env:a});k.on("error",i),k.on("exit",()=>r())})}}e.$k6b=v;class b extends y{static{this.b=c.localize(3,null)}openTerminal(P,h){return this.spawnTerminal(S,P,h)}runInTerminal(P,h,t,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{const k=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const C=`${o(t)}; echo; read -p "${b.b}" -n1;`;k.push(`''${C}''`);const p=Object.assign({},g(process),l);Object.keys(p).filter(q=>p[q]===null).forEach(q=>delete p[q]);const A={cwd:h,env:p};let L="";const U=S.spawn(I,k,A);U.on("error",q=>{a($(q))}),U.stderr.on("data",q=>{L+=q.toString()}),U.on("exit",q=>{if(q===0)n(void 0);else if(L){const se=L.split(`
`,1);a(new Error(se[0]))}else a(new Error(c.localize(4,null,I,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.$k)b.d=Promise.resolve("xterm");else{const P=await E.Promises.exists("/etc/debian_version");b.d=new Promise(h=>{P?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return b.d}spawnTerminal(P,h,t){const l=h.linuxExec?Promise.resolve(h.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(n=>{const a=g(process),k=P.spawn(n,[],{cwd:t,env:a});k.on("error",i),k.on("exit",()=>r())})})}}e.$l6b=b;function g(d){const P={...d.env};return(0,D.$sl)(P),P}function $(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(c.localize(5,null,d.path)):d}function o(d){let P="";for(const h of d)h.indexOf(" ")>=0?P+='"'+h+'"':P+=h,P+=" ";return P}}),define(te[16],ie([0,1,56,9,26,12,7,174,6,4,13]),function(K,e,S,R,s,M,D,E,u,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,u.$Bh)("fileService");function w(N){return N.create===!0}e.$7j=w;var y;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var f;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var v;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function b(N){return!!(N.capabilities&2)}e.$8j=b;function g(N){return!!(N.capabilities&8)}e.$9j=g;function $(N){return!!(N.capabilities&131072)}e.$0j=$;function o(N){return!!(N.capabilities&4)}e.$$j=o;function d(N){return!!(N.capabilities&16)}e.$_j=d;function P(N){return b(N)?!!(N.capabilities&16384):!1}e.$ak=P;function h(N){return b(N)?!!(N.capabilities&32768):!1}e.$bk=h;function t(N){return!!(N.capabilities&65536)}e.$ck=t;function l(N){return!!(N.capabilities&2048)}e.$dk=l;var r;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(G,Z){const _=new i(G.toString(),Z);return k(_,Z),_}constructor(G,Z){super(G),this.code=Z}}e.$ek=i;function n(N,G){return i.create(N,G)}e.$fk=n;function a(N){return N||n((0,E.localize)(0,null),r.Unknown)}e.$gk=a;function k(N,G){return N.name=G?`${G} (FileSystemError)`:"FileSystemError",N}e.$hk=k;function I(N){if(!N)return r.Unknown;if(N instanceof i)return N.code;const G=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!G)return r.Unknown;switch(G[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$ik=I;function C(N){if(N instanceof se)return N.fileOperationResult;switch(I(N)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$jk=C;var p;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(p||(e.FileOperation=p={}));class A{constructor(G,Z,_){this.resource=G,this.operation=Z,this.target=_}isOperation(G){return this.operation===G}}e.$kk=A;var L;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class U{constructor(G,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const _=new Map;for(const oe of G){const T=_.get(oe.type);switch(T?T.push([oe.resource,oe]):_.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,T]of _)switch(oe){case 1:this.a=S.$Hh.forUris(()=>Z),this.a.fill(T);break;case 0:this.b=S.$Hh.forUris(()=>Z),this.b.fill(T);break;case 2:this.c=S.$Hh.forUris(()=>Z),this.c.fill(T);break}}contains(G,...Z){return this.d(G,{includeChildren:!1},...Z)}affects(G,...Z){return this.d(G,{includeChildren:!0},...Z)}d(G,Z,..._){if(!G)return!1;const oe=_.length>0;return!!((!oe||_.includes(1))&&(this.a?.get(G)||Z.includeChildren&&this.a?.findSuperstr(G))||(!oe||_.includes(0))&&(this.b?.get(G)||Z.includeChildren&&this.b?.findSuperstr(G))||(!oe||_.includes(2))&&(this.c?.findSubstr(G)||Z.includeChildren&&this.c?.findSuperstr(G)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=U;function q(N,G,Z){return!N||!G||N===G||G.length>N.length?!1:(G.charAt(G.length-1)!==R.sep&&(G+=R.sep),Z?(0,s.$Ne)(N,G):N.indexOf(G)===0)}e.$mk=q;class se extends Error{constructor(G,Z,_){super(G),this.fileOperationResult=Z,this.options=_}}e.$nk=se;class x extends se{constructor(G,Z,_,oe){super(G,Z,oe),this.fileOperationResult=Z,this.size=_}}e.$ok=x;class ae extends se{constructor(G,Z,_){super(G,2,_),this.stat=Z}}e.$pk=ae;var ne;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$xk="";function Y(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$yk=Y;async function J(N,G){if(!G.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(Z=>{const _=G.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===N.scheme&&oe.added&&(_.dispose(),Z())})})}e.$zk=J;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(G){return(0,M.$nf)(G)||(G=0),G<H.KB?(0,E.localize)(1,null,G.toFixed(0)):G<H.MB?(0,E.localize)(2,null,(G/H.KB).toFixed(2)):G<H.GB?(0,E.localize)(3,null,(G/H.MB).toFixed(2)):G<H.TB?(0,E.localize)(4,null,(G/H.GB).toFixed(2)):(0,E.localize)(5,null,(G/H.TB).toFixed(2))}}e.$Ak=H;function F(N){const G=typeof N=="string"||N?.scheme===m.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===m.Schemas.file?1024*H.MB:G?10*H.MB:c.$o?50*H.MB:1024*H.MB}e.$Bk=F}),define(te[212],ie([0,1,17,49,14,3,2,61,7,31,16]),function(K,e,S,R,s,M,D,E,u,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=void 0,e.$_M="localFilesystem";class w extends D.$kc{constructor(f,v){super(),this.a=f,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$fd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.h=(0,c.$4f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,v){const{buffer:b}=await this.a.call("readFile",[f,v]);return b}readFileStream(f,v,b){const g=(0,E.$td)(o=>S.$Fd.concat(o.map(d=>S.$Fd.wrap(d))).buffer),$=new D.$jc;return $.add(this.a.listen("readFileStream",[f,v])(o=>{if(o instanceof S.$Fd)g.write(o.buffer);else{if(o==="end")g.end();else{let d;if(o instanceof Error)d=o;else{const P=o;d=(0,m.$fk)(P.message??(0,R.$mi)(P),P.code??m.FileSystemProviderErrorCode.Unknown)}g.error(d),g.end()}$.dispose()}})),$.add(b.onCancellationRequested(()=>{g.error((0,s.$4)()),g.end(),$.dispose()})),g}writeFile(f,v,b){return this.a.call("writeFile",[f,S.$Fd.wrap(v),b])}open(f,v){return this.a.call("open",[f,v])}close(f){return this.a.call("close",[f])}async read(f,v,b,g,$){const[o,d]=await this.a.call("read",[f,v,$]);return b.set(o.buffer.slice(0,d),g),d}write(f,v,b,g,$){return this.a.call("write",[f,v,S.$Fd.wrap(b),g,$])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,v){return this.a.call("delete",[f,v])}rename(f,v,b){return this.a.call("rename",[f,v,b])}copy(f,v,b){return this.a.call("copy",[f,v,b])}cloneFile(f,v){return this.a.call("cloneFile",[f,v])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const v=f;this.f.fire(v.map(b=>({resource:u.URI.revive(b.resource),type:b.type})))}else{const v=f;this.g.fire(v)}}))}watch(f,v){const b=(0,c.$4f)();return this.a.call("watch",[this.h,b,f,v]),(0,D.$ic)(()=>this.a.call("unwatch",[this.h,b]))}}e.$aN=w}),define(te[117],ie([0,1,17,14,175,16]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(m,w,y,f,v,b){let g;try{await E(m,w,y,f,v,b)}catch($){g=$}finally{g&&v.errorTransformer&&(g=v.errorTransformer(g)),typeof g<"u"&&y.error(g),y.end()}}e.$Cp=D;async function E(m,w,y,f,v,b){u(b);const g=await m.open(w,{create:!1});try{u(b);let $=0,o=0,d=v&&typeof v.length=="number"?v.length:void 0,P=S.$Fd.alloc(Math.min(v.bufferSize,typeof d=="number"?d:v.bufferSize)),h=v&&typeof v.position=="number"?v.position:0,t=0;do o=await m.read(g,h,P.buffer,t,P.byteLength-t),h+=o,t+=o,$+=o,typeof d=="number"&&(d-=o),t===P.byteLength&&(await y.write(f(P)),P=S.$Fd.alloc(Math.min(v.bufferSize,typeof d=="number"?d:v.bufferSize)),t=0);while(o>0&&(typeof d!="number"||d>0)&&u(b)&&c($,v));if(t>0){let l=t;typeof d=="number"&&(l=Math.min(t,d)),y.write(f(P.slice(0,l)))}}catch($){throw(0,M.$gk)($)}finally{await m.close(g)}}function u(m){if(m.isCancellationRequested)throw(0,R.$4)();return!0}function c(m,w){if(typeof w?.limits?.size=="number"&&m>w.limits.size)throw(0,M.$fk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[75],ie([0,1,104,2,9,4,7,16]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function u($){return $.recursive===!0}e.$Ep=u;class c extends R.$kc{static{this.a=5}constructor(o,d,P,h){super(),this.h=o,this.j=d,this.m=P,this.n=h,this.c=this.B(new R.$lc),this.f=void 0,this.g=0}s(){const o=new R.$jc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(d=>this.h(d))),o.add(this.b.onDidLogMessage(d=>this.j(d))),o.add(this.b.onDidError(d=>this.t(d)))}t(o){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=c;class m extends c{constructor(o,d,P){super(o,d,P,{type:"node.js",restartOnError:!1})}}e.$Gp=m;class w extends c{constructor(o,d,P){super(o,d,P,{type:"universal",restartOnError:!0})}}e.$Hp=w;function y($){return $.map(o=>({type:o.type,resource:D.URI.file(o.path)}))}e.$Ip=y;function f($){const o=new g;for(const d of $)o.processEvent(d);return o.coalesce()}e.$Jp=f;function v($,o){return typeof o=="string"&&!o.startsWith(S.$nj)&&!(0,s.$8d)(o)?{base:$,pattern:o}:o}e.$Kp=v;function b($,o){const d=[];for(const P of o)d.push((0,S.$rj)(v($,P)));return d}e.$Lp=b;class g{constructor(){this.a=new Set,this.b=new Map}c(o){return M.$k?o.path:o.path.toLowerCase()}processEvent(o){const d=this.b.get(this.c(o));let P=!1;if(d){const h=d.type,t=o.type;d.path!==o.path&&(o.type===2||o.type===1)?P=!0:h===1&&t===2?(this.b.delete(this.c(o)),this.a.delete(d)):h===2&&t===1?d.type=0:h===1&&t===0||(d.type=t)}else P=!0;P&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],d=[];return Array.from(this.a).filter(P=>P.type!==2?(o.push(P),!1):!0).sort((P,h)=>P.path.length-h.path.length).filter(P=>d.some(h=>(0,E.$mk)(P.path,h,!M.$k))?!1:(d.push(P.path),!0)).concat(o)}}}),define(te[213],ie([0,1,45,8,22,32,2,85,9,4,105,21,75]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class f extends D.$kc{static{this.a=100}static{this.b=75}constructor(g,$,o,d){super(),this.m=g,this.n=$,this.r=o,this.s=d,this.c=this.B(new R.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},P=>this.n(P))),this.f=this.B(new R.$Ug(P=>this.z(P),f.b)),this.g=(0,y.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Lp)(this.m.path,this.m.includes):void 0,this.j=new s.$pd,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const $=await w.Promises.stat(g);this.B(await this.w(g,$.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let $=g.path;try{$=await w.Promises.realpath(g.path),g.path===$&&($=await(0,m.$Vp)(g.path)??g.path),g.path!==$&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${$})`)}catch{}return $}async w(g,$){if(c.$j&&(0,M.$If)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$kc.None;const o=new s.$pd(this.j.token),d=new D.$jc;try{const P=(0,u.$ae)(g),h=(0,S.watch)(g);d.add((0,D.$ic)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${g}'`);const t=new Set;if($)try{for(const r of await w.Promises.readdir(g))t.add(r)}catch(r){this.D(r)}const l=new Map;d.add((0,D.$ic)(()=>{for(const[,r]of l)r.dispose();l.clear()})),h.on("error",(r,i)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),h.on("change",(r,i)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),c.$j&&(n=(0,E.$hl)(n))),!(!n||r!=="change"&&r!=="rename"))if($)if(r==="rename"){l.get(n)?.dispose();const a=setTimeout(async()=>{if(l.delete(n),n===P&&!await w.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,u.$9d)(g,n));if(o.token.isCancellationRequested)return;let I;k?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.y({path:(0,u.$9d)(this.m.path,n),type:I})},f.a);l.set(n,(0,D.$ic)(()=>clearTimeout(a)))}else{let a;t.has(n)?a=0:(a=1,t.add(n)),this.y({path:(0,u.$9d)(this.m.path,n),type:a})}else if(r==="rename"||n!==P){const a=setTimeout(async()=>{const k=await w.Promises.exists(g);o.token.isCancellationRequested||(k?(this.y({path:this.m.path,type:0},!0),d.add(await this.w(g,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);d.clear(),d.add((0,D.$ic)(()=>clearTimeout(a)))}else this.y({path:this.m.path,type:0},!0)})}catch(P){await w.Promises.exists(g)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${P.toString()})`)}return(0,D.$ic)(()=>{o.dispose(!0),d.dispose()})}y(g,$=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!$&&this.g.some(o=>o(g.path))?this.s&&this.G(` >> ignored (excluded) ${g.path}`):!$&&this.h&&this.h.length>0&&!this.h.some(o=>o(g.path))?this.s&&this.G(` >> ignored (not included) ${g.path}`):this.f.work(g))}z(g){const $=(0,y.$Jp)(g);if($.length>0){if(this.s)for(const d of $)this.G(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work($)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${$[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${$.length}, most recent change: ${$[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(c.$k)return w.Promises.exists(g);try{const $=(0,u.$ae)(g);return(await w.Promises.readdir((0,u.$_d)(g))).some(d=>d===$)}catch($){return this.G($),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=f;async function v(b,g,$,o,d=512){const P=await w.Promises.open(b,"r"),h=Buffer.allocUnsafe(d),t=new s.$pd(o);let l,r=!1;const i={path:b,excludes:[],recursive:!1},n=new f(i,a=>{(async()=>{for(const{type:k}of a)if(k===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await w.Promises.read(P,h,0,d,null);if(!I||t.token.isCancellationRequested)break;g(h.slice(0,I))}}catch(I){l=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,$(),new Promise((a,k)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await w.Promises.close(P)}catch(I){l=new Error(I)}l?k(l):a()})})}e.$Zp=v}),define(te[214],ie([0,1,3,104,2,4,213]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class E extends s.$kc{constructor(){super(...arguments),this.a=this.B(new S.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$fd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(c){const m=this.j(c),w=m.filter(f=>{const v=this.c.get(f.path);return v?!(0,R.$vj)(v.request.excludes,f.excludes)||!(0,R.$vj)(v.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!m.find(v=>v.path===f.path&&(0,R.$vj)(v.excludes,f.excludes)&&(0,R.$vj)(v.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.m(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of w)this.g(f)}g(c){const m=new D.$Yp(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:c,instance:m};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const m=this.c.get(c);m&&(this.c.delete(c),m.instance.dispose())}j(c){const m=new Map;for(const w of c){const y=M.$k?w.path:w.path.toLowerCase();m.set(y,w)}return Array.from(m.values())}async setVerboseLogging(c){this.f=c;for(const[,m]of this.c)m.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$1p=E}),define(te[215],ie([0,1,75,214]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class s extends S.$Gp{constructor(D,E,u){super(D,E,u),this.s()}r(D){return D.add(new R.$1p)}}e.$2p=s}),define(te[216],ie([0,1,13,42,158,75]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class D extends M.$Hp{constructor(u,c,m){super(u,c,m),this.s()}r(u){const c=u.add(new s.$Sp(S.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:m,signal:w})=>this.t(`terminated by itself with code ${m}, signal: ${w}`))),R.ProxyChannel.toService((0,R.$ih)(c.getChannel("watcher")))}}e.$Tp=D}),define(te[92],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class S{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$zh=S}),define(te[217],ie([0,1,8,14,2,74,206,6,92,101]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const m=!1;class w extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class y{constructor(g=new u.$zh,$=!1,o,d=m){this.f=g,this.g=$,this.h=o,this.i=d,this.o=new Set,this.f.set(E.$Ah,this),this._globalGraph=d?o?._globalGraph??new D.$5p(P=>P):void 0}createChild(g){return new y(g,this.g,this,this.i)}invokeFunction(g,...$){const o=v.traceInvocation(this.i,g);let d=!1;try{return g({get:h=>{if(d)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(h,o);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...$)}finally{d=!0,o.stop()}}createInstance(g,...$){let o,d;return g instanceof M.$yh?(o=v.traceCreation(this.i,g.ctor),d=this.j(g.ctor,g.staticArguments.concat($),o)):(o=v.traceCreation(this.i,g),d=this.j(g,$,o)),o.stop(),d}j(g,$=[],o){const d=E._util.getServiceDependencies(g).sort((t,l)=>t.index-l.index),P=[];for(const t of d){const l=this.m(t.id,o);l||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),P.push(l)}const h=d.length>0?d[0].index:$.length;if($.length!==h){console.trace(`[createInstance] First service dependency of ${g.name} at position ${h+1} conflicts with ${$.length} static arguments`);const t=h-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,h)}return Reflect.construct(g,$.concat(P))}k(g,$){if(this.f.get(g)instanceof M.$yh)this.f.set(g,$);else if(this.h)this.h.k(g,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const $=this.f.get(g);return!$&&this.h?this.h.l(g):$}m(g,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const o=this.l(g);return o instanceof M.$yh?this.q(g,o,$.branch(g,!0)):($.branch(g,!1),o)}q(g,$,o){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,$,o)}finally{this.o.delete(g)}}r(g,$,o){const d=new D.$5p(t=>t.id.toString());let P=0;const h=[{id:g,desc:$,_trace:o}];for(;h.length;){const t=h.pop();if(d.lookupOrInsertNode(t),P++>1e3)throw new w(d);for(const l of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof M.$yh){const i={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};d.insertEdge(t,i),h.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new w(d);break}for(const{data:l}of t){if(this.l(l.id)instanceof M.$yh){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}d.removeNode(l)}}return this.l(g)}s(g,$,o=[],d,P){if(this.f.get(g)instanceof M.$yh)return this.t(g,$,o,d,P);if(this.h)return this.h.s(g,$,o,d,P);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(g,$,o=[],d,P){if(d){const h=new y(void 0,this.g,this,this.i);h.c=String(g);const t=new Map,l=new S.$Xg(()=>{const r=h.j($,o,P);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const k of n)a.apply(r,k)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new c.$tc,t.set(i,k)),(C,p,A)=>{const L=k.push([C,p,A]);return(0,s.$ic)(L)}}if(i in r)return r[i];const n=l.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return l.value[i]=n,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,o,P)}u(g,$){if($&&console.warn(g),this.g)throw new Error(g)}}e.$6p=y;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,$){return g?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,$){return g?new v(1,$.name):v.c}static{this.f=0}constructor(g,$){this.type=g,this.name=$,this.g=Date.now(),this.h=[]}branch(g,$){const o=new v(3,g.toString());return this.h.push([g,$,o]),o}stop(){const g=Date.now()-this.g;v.f+=g;let $=!1;function o(P,h){const t=[],l=new Array(P+1).join("	");for(const[r,i,n]of h.h)if(i&&n){$=!0,t.push(`${l}CREATES -> ${r}`);const a=o(P+1,n);a&&t.push(a)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||$)&&v.all.add(d.join(`
`))}}e.$7p=v}),define(te[218],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$ytb=(0,S.$Bh)("issueService")}),define(te[5],ie([0,1,49,3,55,2,33,4,19,12,7,114,6]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,y.$Bh)("logService"),e.$6i=(0,y.$Bh)("loggerService");function f(){return new Date().toISOString()}function v(C){return(0,c.$nf)(C)}e.$7i=v;var b;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$8i=b.Info;function g(C,p,A){switch(p){case b.Trace:C.trace(A);break;case b.Debug:C.debug(A);break;case b.Info:C.info(A);break;case b.Warning:C.warn(A);break;case b.Error:C.error(A);break;case b.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=g;function $(C,p=!1){let A="";for(let L=0;L<C.length;L++){let U=C[L];if(U instanceof Error&&(U=(0,S.$mi)(U,p)),typeof U=="object")try{U=JSON.stringify(U)}catch{}A+=(L>0?" ":"")+U}return A}class o extends M.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new R.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==b.Off&&this.b<=p}}e.$0i=o;class d extends o{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...A){this.f(b.Trace)&&this.g(b.Trace,$([p,...A],!0))}debug(p,...A){this.f(b.Debug)&&this.g(b.Debug,$([p,...A]))}info(p,...A){this.f(b.Info)&&this.g(b.Info,$([p,...A]))}warn(p,...A){this.f(b.Warning)&&this.g(b.Warning,$([p,...A]))}error(p,...A){if(this.f(b.Error))if(p instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=p.stack,this.g(b.Error,$(L))}else this.g(b.Error,$([p,...A]))}flush(){}}e.$$i=d;class P extends o{constructor(p=e.$8i){super(),this.setLevel(p),this.g=!E.$i}trace(p,...A){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}debug(p,...A){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}info(p,...A){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}warn(p,...A){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...A):console.warn(`[main ${f()}]`,p,...A))}error(p,...A){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...A):console.error(`[main ${f()}]`,p,...A))}dispose(){}flush(){}}e.$_i=P;class h extends o{constructor(p=e.$8i,A=!0){super(),this.g=A,this.setLevel(p)}trace(p,...A){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...A):console.log(p,...A))}debug(p,...A){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...A):console.log(p,...A))}info(p,...A){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...A):console.log(p,...A))}warn(p,...A){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...A):console.log(p,...A))}error(p,...A){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...A):console.error(p,...A))}dispose(){}flush(){}}e.$aj=h;class t extends o{constructor(p,A=e.$8i){super(),this.g=p,this.setLevel(A)}trace(p,...A){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(p),...A])}debug(p,...A){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(p),...A])}info(p,...A){this.f(b.Info)&&this.g.log(b.Info,[this.h(p),...A])}warn(p,...A){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(p),...A])}error(p,...A){this.f(b.Error)&&this.g.log(b.Error,[this.h(p),...A])}h(p){return typeof p=="string"?p:(0,S.$mi)(p,this.f(b.Trace))}dispose(){}flush(){}}e.$bj=t;class l extends o{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const A of this.g)A.setLevel(p);super.setLevel(p)}trace(p,...A){for(const L of this.g)L.trace(p,...A)}debug(p,...A){for(const L of this.g)L.debug(p,...A)}info(p,...A){for(const L of this.g)L.info(p,...A)}warn(p,...A){for(const L of this.g)L.warn(p,...A)}error(p,...A){for(const L of this.g)L.error(p,...A)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$cj=l;class r extends M.$kc{constructor(p,A,L){if(super(),this.h=p,this.j=A,this.b=new D.$zi,this.c=this.B(new R.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$fd),this.onDidChangeVisibility=this.g.event,L)for(const U of L)this.b.set(U.resource,{logger:void 0,info:U})}m(p){return(0,c.$jf)(p)?[...this.b.values()].find(A=>A.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,A){const L=this.n(p),U=(0,c.$jf)(p)?p:A?.id??(0,s.$pi)(L.toString()).toString(16);let q=this.b.get(L)?.logger;const se=A?.logLevel==="always"?b.Trace:A?.logLevel;q||(q=this.s(L,se??this.getLogLevel(L)??this.h,{...A,id:U}));const x={logger:q,info:{resource:L,id:U,logLevel:se,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(x.info),this.b.set(L,x),q}n(p){return(0,c.$jf)(p)?(0,u.$ig)(this.j,`${p}.log`):p}setLogLevel(p,A){if(m.URI.isUri(p)){const L=p,U=A,q=this.b.get(L);q&&U!==q.info.logLevel&&(q.info.logLevel=U===this.h?void 0:U,q.logger?.setLevel(U),this.b.set(q.info.resource,q),this.f.fire([L,U]))}else{this.h=p;for(const[L,U]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,A){const L=this.m(p);L&&A!==!L.info.hidden&&(L.info.hidden=!A,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,A]))}getLogLevel(p){let A;return p&&(A=this.b.get(p)?.info.logLevel),A??this.h}registerLogger(p){const A=this.b.get(p.resource);A?A.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const A=this.b.get(p);A&&(A.logger&&A.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$fd().event}setLevel(p){}getLevel(){return b.Info}trace(p,...A){}debug(p,...A){}info(p,...A){}warn(p,...A){}error(p,...A){}critical(p,...A){}dispose(){}flush(){}}e.$ej=i;class n extends i{}e.$fj=n;function a(C){if(C.verbose)return b.Trace;if(typeof C.logLevel=="string"){const p=I(C.logLevel.toLowerCase());if(p!==void 0)return p}return e.$8i}e.$gj=a;function k(C){switch(C){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$hj=k;function I(C){switch(C){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$ij=I,e.$jj=new w.$2i("logLevel",k(b.Info))});var ee=this&&this.__param||function(K,e){return function(S,R){e(S,R,K)}};define(te[219],ie([0,1,15,4,5]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=void 0;const M=S.safeStorage;let D=class{constructor(u){this.a=u,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(u){let c;try{if(c=JSON.parse(u),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const m=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=M.decryptString(m);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(m){throw this.a.error(m),m}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const u=M.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$d6b=D,e.$d6b=D=Ee([ee(0,s.$5i)],D)}),define(te[220],ie([0,1,23,8,14,3,2,9,75,5]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class m extends D.$kc{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new M.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Eg(0)),this.w=[],this.y=this.B(new R.$Eg(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(y,f):this.z(y,f)}n(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive},b=(0,S.$Sb)(this.j,v);return this.r(),(0,D.$ic)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$Y)(y))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$Ip)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,u.$Ep)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,u.$Ep)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:!1},b=(0,S.$Sb)(this.w,v);return this.C(),(0,D.$ic)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$Y)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,u.$Ip)(y)),y=>this.G(y),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,E.$7d)(y.fsPath)}}e.$Mp=m}),define(te[221],ie([0,1,23,8,17,22,3,55,67,2,56,13,64,19,61,173,16,117,5,14]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let P=class extends c.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new R.$Pg)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const r=new c.$jc;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),r.add(l.onDidChangeFile(i=>this.X.fire(new g.$lk(i,!this.S(l))))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,c.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,c.$fc)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(r){l.push(r)}}),!this.h.has(t)&&await R.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return u.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,f.$mg)(t))throw new g.$nk((0,b.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const r=new d.$_;throw r.message=(0,b.localize)(1,null,t.toString()),r}return l}async m(t){const l=await this.j(t);if((0,g.$$j)(l)||(0,g.$8j)(l)||(0,g.$_j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const l=await this.j(t);if((0,g.$$j)(l)||(0,g.$8j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.s(t,l)}catch(r){throw(0,g.$ik)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.$nk((0,b.localize)(2,null,this.rb(t)),1):(0,g.$gk)(r)}}async s(t,l){const r=await this.j(t),i=this.S(r),n=l?.resolveTo,a=l?.resolveSingleChildDescendants,k=l?.resolveMetadata,I=await r.stat(t);let C;return this.t(r,t,I,void 0,!!k,(p,A)=>(C||(C=m.$Hh.forUris(()=>!i),C.set(t,!0),n&&C.fill(!0,n)),C.get(p.resource)||C.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?A===1:!1))}async t(t,l,r,i,n,a){const{providerExtUri:k}=this.R(t),I={resource:l,name:k.basename(l),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&g.FilePermission.Locked),etag:(0,g.$yk)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&a(I,i)){try{const C=await t.readdir(l),p=await R.Promises.settled(C.map(async([A,L])=>{try{const U=k.joinPath(l,A),q=n?await t.stat(U):{type:L};return await this.t(t,U,q,C.length,n,a)}catch(U){return this.b.trace(U),null}}));I.children=(0,S.$Fb)(p)}catch(C){this.b.trace(C),I.children=[]}return I}return I}async resolveAll(t){return R.Promises.settled(t.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),r=await l.stat(t);return this.t(l,t,r,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.u(t,l)}catch(r){return r}return!0}async u(t,l){if(!l?.overwrite&&await this.exists(t))throw new g.$nk((0,b.localize)(3,null,this.rb(t)),3,l)}async createFile(t,l=s.$Fd.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,l);return this.r.fire(new g.$kk(t,0,i)),i}async writeFile(t,l,r){const i=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(i);let a=r;if((0,g.$bk)(i)&&!a?.atomic){const k=i.enforceAtomicWriteFile?.(t);k&&(a={...r,atomic:k})}try{await this.w(i,t,a)||await this.U(i,n.dirname(t));let I;if((0,g.$8j)(i)&&!(l instanceof s.$Fd))if((0,v.$rd)(l)){const C=await(0,v.$yd)(l,3);C.ended?I=s.$Fd.concat(C.buffer):I=C}else I=(0,v.$vd)(l,C=>s.$Fd.concat(C),3);else I=l;if(!(0,g.$$j)(i)||(0,g.$8j)(i)&&I instanceof s.$Fd||(0,g.$8j)(i)&&(0,g.$bk)(i)&&a?.atomic)await this.gb(i,t,a,I);else{const C=I instanceof s.$Fd?(0,s.$Qd)(I):I;a?.atomic!==!1&&a?.atomic?.postfix?await this.bb(i,t,(0,f.$ig)((0,f.$hg)(t),`${(0,f.$fg)(t)}${a.atomic.postfix}`),a,C):await this.cb(i,t,a,C)}this.r.fire(new g.$kk(t,4))}catch(k){throw new g.$nk((0,b.localize)(4,null,this.rb(t),(0,g.$gk)(k).toString()),(0,g.$jk)(k),a)}return this.resolve(t,{resolveMetadata:!0})}async w(t,l,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.rb(l)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.rb(l)));if(i)throw new Error((0,b.localize)(7,null,this.rb(l)))}let a;try{a=await t.stat(l)}catch{return}if(a.type&g.FileType.Directory)throw new g.$nk((0,b.localize)(8,null,this.rb(l)),0,r);if(this.qb(l,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.$xk&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,g.$yk)({mtime:r.mtime,size:a.size}))throw new g.$nk((0,b.localize)(9,null),3,r);return a}async readFile(t,l,r){const i=await this.m(t);return l?.atomic?this.z(i,t,l,r):this.C(i,t,l,r)}async z(t,l,r,i){return new Promise((n,a)=>{this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{try{const k=await this.C(t,l,r,i);n(k)}catch(k){a(k)}})})}async C(t,l,r,i){const n=await this.D(t,l,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Rd)(n.value)}}async readFileStream(t,l,r){const i=await this.m(t);return this.D(i,t,l,r)}async D(t,l,r,i){const n=new M.$pd(i);let a=r;(0,g.$ak)(t)&&t.enforceAtomicReadFile?.(l)&&(a={...r,atomic:!0});const k=this.J(l,a).then(C=>C,C=>{throw n.dispose(!0),C});let I;try{return typeof a?.etag=="string"&&a.etag!==g.$xk&&await k,a?.atomic&&(0,g.$ak)(t)||!((0,g.$$j)(t)||(0,g.$_j)(t))||(0,g.$8j)(t)&&a?.preferUnbuffered?I=this.I(t,l,a):(0,g.$_j)(t)?I=this.G(t,l,n.token,a):I=this.H(t,l,n.token,a),I.on("end",()=>n.dispose()),I.on("error",()=>n.dispose()),{...await k,value:I}}catch(C){throw I&&await(0,v.$wd)(I),this.F(C,l,a)}}F(t,l,r){const i=(0,b.localize)(10,null,this.rb(l),(0,g.$gk)(t).toString());return t instanceof g.$pk?new g.$pk(i,t.stat,r):t instanceof g.$ok?new g.$ok(i,t.fileOperationResult,t.size,t.options):new g.$nk(i,(0,g.$jk)(t),r)}G(t,l,r,i=Object.create(null)){const n=t.readFileStream(l,i,r);return(0,v.$Cd)(n,{data:a=>a instanceof s.$Fd?a:s.$Fd.wrap(a),error:a=>this.F(a,l,i)},a=>s.$Fd.concat(a))}H(t,l,r,i=Object.create(null)){const n=(0,s.$Vd)();return(0,$.$Cp)(t,l,n,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,l,i)},r),n}I(t,l,r){const i=(0,v.$td)(n=>s.$Fd.concat(n));return(async()=>{try{let n;r?.atomic&&(0,g.$ak)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(l,n.byteLength,r),i.end(s.$Fd.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,l){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new g.$nk((0,b.localize)(11,null,this.rb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==g.$xk&&l.etag===r.etag)throw new g.$pk((0,b.localize)(12,null),r,l);return this.L(t,r.size,l),r}L(t,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new g.$ok((0,b.localize)(13,null,this.rb(t)),7,l,r)}async canMove(t,l,r){return this.M(t,l,"move",r)}async canCopy(t,l,r){return this.M(t,l,"copy",r)}async M(t,l,r,i){if(t.toString()!==l.toString())try{const n=r==="move"?this.pb(await this.n(t),t):await this.m(t),a=this.pb(await this.n(l),l);await this.Q(n,t,a,l,r,i)}catch(n){return n}return!0}async move(t,l,r){const i=this.pb(await this.n(t),t),n=this.pb(await this.n(l),l),a=await this.N(i,t,n,l,"move",!!r),k=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new g.$kk(t,a==="move"?2:3,k)),k}async copy(t,l,r){const i=await this.m(t),n=this.pb(await this.n(l),l),a=await this.N(i,t,n,l,"copy",!!r),k=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new g.$kk(t,a==="copy"?3:2,k)),k}async N(t,l,r,i,n,a){if(l.toString()===i.toString())return n;const{exists:k,isSameResourceWithDifferentPathCase:I}=await this.Q(t,l,r,i,n,a);if(k&&!I&&a&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,g.$9j)(t))await t.copy(l,i,{overwrite:a});else{const C=await this.resolve(l);C.isDirectory?await this.P(t,C,r,i):await this.O(t,l,r,i)}return n}else return t===r?(await t.rename(l,i,{overwrite:a}),n):(await this.N(t,l,r,i,"copy",a),await this.del(l,{recursive:!0}),"copy")}async O(t,l,r,i){if((0,g.$$j)(t)&&(0,g.$$j)(r))return this.ib(t,l,r,i);if((0,g.$$j)(t)&&(0,g.$8j)(r))return this.ob(t,l,r,i);if((0,g.$8j)(t)&&(0,g.$$j)(r))return this.mb(t,l,r,i);if((0,g.$8j)(t)&&(0,g.$8j)(r))return this.kb(t,l,r,i)}async P(t,l,r,i){await r.mkdir(i),Array.isArray(l.children)&&await R.Promises.settled(l.children.map(async n=>{const a=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,a):this.O(t,n.resource,r,a)}))}async Q(t,l,r,i,n,a){let k=!1;if(t===r){const{providerExtUri:C,isPathCaseSensitive:p}=this.R(t);if(p||(k=C.isEqual(l,i)),k&&n==="copy")throw new Error((0,b.localize)(14,null,this.rb(l),this.rb(i)));if(!k&&C.isEqualOrParent(i,l))throw new Error((0,b.localize)(15,null,this.rb(l),this.rb(i)))}const I=await this.exists(i);if(I&&!k){if(!a)throw new g.$nk((0,b.localize)(16,null,this.rb(l),this.rb(i)),4);if(t===r){const{providerExtUri:C}=this.R(t);if(C.isEqualOrParent(l,i))throw new Error((0,b.localize)(17,null,this.rb(l),this.rb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:k}}R(t){const l=this.S(t);return{providerExtUri:l?f.$$f:f.$ag,isPathCaseSensitive:l}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.pb(await this.j(t),t);await this.U(l,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$kk(t,0,r)),r}async U(t,l){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&g.FileType.Directory))throw new Error((0,b.localize)(18,null,this.rb(l)));break}catch(n){if((0,g.$ik)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(l)),l=i.dirname(l)}for(let n=r.length-1;n>=0;n--){l=i.joinPath(l,r[n]);try{await t.mkdir(l)}catch(a){if((0,g.$ik)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,l){try{await this.W(t,l)}catch(r){return r}return!0}async W(t,l){const r=this.pb(await this.j(t),t),i=!!l?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,b.localize)(19,null,this.rb(t)));const n=l?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,b.localize)(20,null,this.rb(t)));if(i&&n)throw new Error((0,b.localize)(21,null,this.rb(t)));let a;try{a=await r.stat(t)}catch{}if(a)this.qb(t,a);else throw new g.$nk((0,b.localize)(22,null,this.rb(t)),1);if(!!!l?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,b.localize)(23,null,this.rb(t)))}return r}async del(t,l){const r=await this.W(t,l);let i=l;if((0,g.$ck)(r)&&!i?.atomic){const I=r.enforceAtomicDelete?.(t);I&&(i={...l,atomic:I})}const n=!!i?.useTrash,a=!!i?.recursive,k=i?.atomic??!1;await r.delete(t,{recursive:a,useTrash:n,atomic:k}),this.r.fire(new g.$kk(t,1))}async cloneFile(t,l){const r=await this.j(t),i=this.pb(await this.n(l),l);if(r===i&&this.R(r).providerExtUri.isEqual(t,l))return;if(r===i&&(0,g.$0j)(r))return r.cloneFile(t,l);await this.U(i,this.R(i).providerExtUri.dirname(l));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,g.$9j)(r)?n.queue(()=>r.copy(t,l,{overwrite:!0})):n.queue(()=>this.O(r,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const r=new c.$jc;let i=!1,n=()=>{i=!0};return r.add((0,c.$ic)(()=>n())),(async()=>{try{const a=await this.$(t,l);i?(0,c.$fc)(a):n=()=>(0,c.$fc)(a)}catch(a){this.b.error(a)}})(),r}async $(t,l){const r=await this.j(t),i=(0,E.$pi)([this.R(r).providerExtUri.getComparisonKey(t),l]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,l)},this.Z.set(i,n)),n.count+=1,(0,c.$ic)(()=>{n&&(n.count--,n.count===0&&((0,c.$fc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$fc)(t.disposable);this.Z.clear()}async bb(t,l,r,i,n){await this.cb(t,r,i,n);try{await t.rename(r,l,{overwrite:!0})}catch(a){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async cb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,v.$rd)(i)||(0,v.$sd)(i)?await this.db(t,n,i):await this.eb(t,n,i)}catch(a){throw(0,g.$gk)(a)}finally{await t.close(n)}})}async db(t,l,r){let i=0,n;if((0,v.$sd)(r)){if(r.buffer.length>0){const a=s.$Fd.concat(r.buffer);await this.fb(t,l,a,a.byteLength,i,0),i+=a.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((a,k)=>{(0,v.$xd)(n,{onData:async I=>{n.pause();try{await this.fb(t,l,I,I.byteLength,i,0)}catch(C){return k(C)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>k(I),onEnd:()=>a()})})}async eb(t,l,r){let i=0,n;for(;(n=r.read())!==null;)await this.fb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async fb(t,l,r,i,n,a){let k=0;for(;k<i;){const I=await t.write(l,n+k,r.buffer,a+k,i-k);k+=I}}async gb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(()=>this.hb(t,l,r,i))}async hb(t,l,r,i){let n;i instanceof s.$Fd?n=i:(0,v.$rd)(i)?n=await(0,s.$Rd)(i):(0,v.$sd)(i)?n=await(0,s.$Sd)(i):n=(0,s.$Pd)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async ib(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.jb(t,l,r,i))}async jb(t,l,r,i){let n,a;try{n=await t.open(l,{create:!1}),a=await r.open(i,{create:!0,unlock:!1});const k=s.$Fd.alloc(this.a);let I=0,C=0,p=0;do p=await t.read(n,I,k.buffer,C,k.byteLength-C),await this.fb(r,a,k,p,I,C),I+=p,C+=p,C===k.byteLength&&(C=0);while(p>0)}catch(k){throw(0,g.$gk)(k)}finally{await R.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async kb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.lb(t,l,r,i))}async lb(t,l,r,i){return r.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.nb(t,l,r,i))}async nb(t,l,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(l);await this.fb(r,n,s.$Fd.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.$gk)(a)}finally{await r.close(n)}}async ob(t,l,r,i){const n=await(0,s.$Rd)(this.H(t,l,M.CancellationToken.None));await this.gb(r,i,void 0,n)}pb(t,l){if(t.capabilities&2048)throw new g.$nk((0,b.localize)(24,null,this.rb(l)),6);return t}qb(t,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.$nk((0,b.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=P,e.$Dp=P=Ee([ee(0,o.$5i)],P)}),define(te[93],ie([0,1,45,310,8,33,17,3,32,2,9,4,19,61,21,177,16,117,220,49,216,215]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(l){console.error(`Error enabling graceful-fs: ${(0,d.$mi)(l)}`)}})();class t extends o.$Mp{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new M.$zi(n=>y.$_f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,w.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await v.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let k;a.isSymbolicLink()?k=(await this.stat((0,y.$ig)(r,a.name))).type:k=this.M(a),n.push([a.name,k])}catch(k){this.a.trace(k)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=g.FileType.Unknown:r.isFile()?n=g.FileType.File:r.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$Fg;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await v.Promises.readFile(a)}catch(a){throw this.eb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,f.$td)(k=>D.$Fd.concat(k.map(I=>D.$Fd.wrap(I))).buffer);return(0,$.$Cp)(this,r,a,k=>k.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,y.$ig)((0,y.$hg)(r),`${(0,y.$fg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,a){await this.R(i,n,a);try{await this.rename(i,r,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}async R(r,i,n){let a;try{const k=this.H(r);if(!n.create||!n.overwrite){if(await v.Promises.exists(k)){if(!n.overwrite)throw(0,g.$fk)((0,b.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$fk)((0,b.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(k){throw await this.fb(r,k)}finally{typeof a=="number"&&await this.close(a)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i){const n=this.H(r);let a;(0,g.$7j)(i)&&(a=await this.O(r));let k;try{if((0,g.$7j)(i)&&i.unlock)try{const{stat:C}=await v.SymlinkSupport.stat(n);C.mode&128||await v.Promises.chmod(n,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let I;if((0,g.$7j)(i)){if(w.$i)try{await v.Promises.truncate(n,0),I="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}I||(I="w")}else I="r";k=await v.Promises.open(n,I)}catch(I){throw a?.dispose(),(0,g.$7j)(i)?await this.fb(r,I):this.eb(I)}if(this.S.set(k,0),(0,g.$7j)(i)&&this.W.set(k,r),a){const I=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${n})`),this.U.set(k,a),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${n})`),I.dispose())}return k}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await v.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,k){const I=this.Y(r,i);let C=null;try{C=(await v.Promises.read(r,n,a,k,I)).bytesRead}catch(p){throw this.eb(p)}finally{this.Z(r,I,C)}return C}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const a=this.S.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,a+n):this.S.delete(r)))}async write(r,i,n,a,k){return(0,s.$Yg)(()=>this.$(r,i,n,a,k),100,3)}async $(r,i,n,a,k){const I=this.Y(r,i);let C=null;try{C=(await v.Promises.write(r,n,a,k,I)).bytesWritten}catch(p){throw await this.fb(this.W.get(r),p)}finally{this.Z(r,I,C)}return C}async mkdir(r){try{await v.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,m.$9d)((0,m.$_d)(n),`${(0,m.$ae)(n)}${i.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,a)}else try{await v.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let k=!1;try{const{stat:I,symbolicLink:C}=await v.SymlinkSupport.stat(n);k=I.isDirectory()&&!C}catch{}if(k)await v.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.eb(n)}}async rename(r,i,n){const a=this.H(r),k=this.H(i);if(a!==k)try{await this.ab(r,i,"move",n.overwrite),await v.Promises.rename(a,k)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(2,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async copy(r,i,n){const a=this.H(r),k=this.H(i);if(a!==k)try{await this.ab(r,i,"copy",n.overwrite),await v.Promises.copy(a,k,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(3,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async ab(r,i,n,a){const k=this.H(r),I=this.H(i);let C=!1;if(!!(this.capabilities&1024)||(C=(0,u.$Hf)(k,I,!0)),C){if(n==="copy")throw(0,g.$fk)((0,b.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const A=await this.L(r);if(!A)throw(0,g.$fk)((0,b.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!a)throw(0,g.$fk)((0,b.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);A.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const a=this.H(r),k=this.H(i),I=!!(this.capabilities&1024);if((0,u.$Hf)(a,k,!I))return;const C=new c.$jc;try{const[p,A]=await Promise.all([this.O(r),this.O(i)]);C.add(p),C.add(A),n&&await v.Promises.mkdir((0,m.$_d)(k),{recursive:!0}),await v.Promises.copyFile(a,k)}catch(p){if(p.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(p)}finally{C.dispose()}}t(r,i,n){return new P.$Tp(a=>r(a),a=>i(a),n)}F(r,i,n){return new h.$2p(a=>r(a),a=>i(a),n)}eb(r){if(r instanceof g.$ek)return r;let i=r,n;switch(r.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$fk)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await v.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,g.$fk)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$3p=t}),define(te[222],ie([0,1,3,93,2,17,61,22]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;class u extends s.$kc{constructor(w,y){super(),this.a=w,this.b=y,this.F=new Map,this.G=new Map}call(w,y,f){const v=this.c(w);switch(y){case"stat":return this.g(v,f[0]);case"readdir":return this.h(v,f[0]);case"open":return this.r(v,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(v,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(v,f[0],f[1],f[2]);case"rename":return this.z(v,f[0],f[1],f[2]);case"copy":return this.C(v,f[0],f[1],f[2]);case"cloneFile":return this.D(v,f[0],f[1]);case"mkdir":return this.w(v,f[0]);case"delete":return this.y(v,f[0],f[1]);case"watch":return this.I(v,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,f){const v=this.c(w);switch(y){case"fileChange":return this.H(v,f[0]);case"readFileStream":return this.m(v,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(w,y){const f=this.f(w,y,!0);return this.a.stat(f)}h(w,y){const f=this.f(w,y);return this.a.readdir(f)}async j(w,y,f){const v=this.f(w,y,!0),b=await this.a.readFile(v,f);return M.$Fd.wrap(b)}m(w,y,f){const v=this.f(w,y,!0),b=new E.$pd,g=new S.$fd({onDidRemoveLastListener:()=>{b.cancel()}}),$=this.a.readFileStream(v,f,b.token);return(0,D.$xd)($,{onData:o=>g.fire(M.$Fd.wrap(o)),onError:o=>g.fire(o),onEnd:()=>{g.fire("end"),g.dispose(),b.dispose()}}),g.event}n(w,y,f,v){const b=this.f(w,y);return this.a.writeFile(b,f.buffer,v)}r(w,y,f){const v=this.f(w,y,!0);return this.a.open(v,f)}s(w){return this.a.close(w)}async t(w,y,f){const v=M.$Fd.alloc(f),b=0,g=await this.a.read(w,y,v.buffer,b,f);return[v,g]}u(w,y,f,v,b){return this.a.write(w,y,f.buffer,v,b)}w(w,y){const f=this.f(w,y);return this.a.mkdir(f)}y(w,y,f){const v=this.f(w,y);return this.a.delete(v,f)}z(w,y,f,v){const b=this.f(w,y),g=this.f(w,f);return this.a.rename(b,g,v)}C(w,y,f,v){const b=this.f(w,y),g=this.f(w,f);return this.a.copy(b,g,v)}D(w,y,f){const v=this.f(w,y),b=this.f(w,f);return this.a.cloneFile(v,b)}H(w,y){const f=new S.$fd({onWillAddFirstListener:()=>{this.F.set(y,this.L(w,f))},onDidRemoveLastListener:()=>{(0,s.$fc)(this.F.get(y)),this.F.delete(y)}});return f.event}async I(w,y,f,v,b){const g=this.F.get(y);if(g){const $=this.f(w,v),o=g.watch(f,$,b);this.G.set(y+f,o)}}async J(w,y){const f=w+y,v=this.G.get(f);v&&((0,s.$fc)(v),this.G.delete(f))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$yr=u;class c extends s.$kc{constructor(w,y,f,v){super(),this.c=w,this.f=f,this.g=v,this.a=new Map,this.b=this.B(new R.$3p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(w){const y=this.B(new S.$fd);this.B(y.event(f=>{w.fire(f.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>w.fire(f)))}j(w){}m(w){}watch(w,y,f){const v=this.m(this.g);return Array.isArray(v)&&(f.excludes=[...f.excludes,...v]),this.a.set(w,this.b.watch(y,f)),(0,s.$ic)(()=>{(0,s.$fc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$zr=c}),define(te[223],ie([0,1,15,176,4,7,16,9,222,154]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;class m extends u.$yr{constructor(f,v,b){super(f,v),this.M=b}c(f){return c.$Cm}f(f,v){return M.URI.revive(v)}async y(f,v,b){if(!b.useTrash)return super.y(f,v,b);const g=this.f(f,v),$=(0,E.$7d)(g.fsPath);try{await S.shell.trashItem($)}catch{throw(0,D.$fk)(s.$i?(0,R.localize)(0,null,(0,E.$ae)($)):(0,R.localize)(1,null,(0,E.$ae)($)),D.FileSystemProviderErrorCode.Unknown)}}L(f,v){return new w(f,v,this.b,this.M)}}e.$m6b=m;class w extends u.$zr{watch(f,v,b){if(b.recursive)throw(0,D.$fk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,v,b)}}}),define(te[224],ie([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=void 0;class R extends S.$$i{constructor(M=S.$8i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:E}of this.m)(0,S.log)(M,D,E);this.m=[]}g(M,D){this.n?(0,S.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$m3b=R}),define(te[225],ie([0,1,7,3,5,2]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=void 0;class D extends s.$dj{constructor(w,y,f,v,b){super(y,f,v),this.r=w,this.t=b,this.B(b.listen("onDidChangeLogLevel",w)(g=>{(0,s.$7i)(g)?super.setLogLevel(g):super.setLogLevel(S.URI.revive(g[0]),g[1])})),this.B(b.listen("onDidChangeVisibility",w)(([g,$])=>super.setVisibility(S.URI.revive(g),$))),this.B(b.listen("onDidChangeLoggers",w)(({added:g,removed:$})=>{for(const o of g)super.registerLogger({...o,resource:S.URI.revive(o.resource)});for(const o of $)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new s.$bj({log:(w,y)=>{this.t.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,y){super.setLogLevel(w,y),this.t.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.t.call("setVisibility",[this.n(w),y])}s(w,y,f){return new E(this.t,w,y,f,this.r)}static setLogLevel(w,y,f){return w.call("setLogLevel",[y,f])}}e.$1q=D;class E extends s.$$i{constructor(w,y,f,v,b){super(v?.logLevel==="always"),this.r=w,this.s=y,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[y,v,b]).then(()=>{this.u(this.n),this.m=!0})}g(w,y){const f=[[w,y]];this.m?this.u(f):this.n.push(...f)}u(w){this.r.call("log",[this.s,w])}}class u{constructor(w,y){this.a=w,this.b=y}listen(w,y){const f=this.b(w);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(b=>this.c(b,f)),removed:[...v.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,v=>[f.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$7i)(v)?v:[f.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,f){const v=this.b(w);switch(y){case"setLogLevel":return(0,s.$7i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,v)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.$2q=u;class c extends M.$kc{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(f=>y.call("setLogLevel",[f]))),y.call("getRegisteredLoggers").then(f=>{for(const v of f)w.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([f,v])=>w.setVisibility(S.URI.revive(f),v))),this.B(y.listen("onDidChangeLoggers")(({added:f,removed:v})=>{for(const b of f)w.registerLogger({...b,resource:S.URI.revive(b.resource)});for(const b of v)w.deregisterLogger(b.resource)}))}}e.$3q=c}),define(te[226],ie([0,1,2,5]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class s extends S.$kc{constructor(D,E=[]){super(),this.a=new R.$cj([D,...E]),this.B(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...E){this.a.trace(D,...E)}debug(D,...E){this.a.debug(D,...E)}info(D,...E){this.a.info(D,...E)}warn(D,...E){this.a.warn(D,...E)}error(D,...E){this.a.error(D,...E)}flush(){this.a.flush()}}e.$rN=s}),define(te[227],ie([0,1,33,7,5]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;class M{constructor(E){this.b=E,this.a=new S.$zi}listen(E,u,c){switch(u){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(E,u,c){switch(u){case"createLogger":this.c(R.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(R.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$7i)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(R.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:R.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(c[0]))}throw new Error(`Call not found: ${u}`)}c(E,u,c){this.a.set(E,this.b.createLogger(E,u,c))}d(E,u){let c=console.log;switch(E){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...u)}e(E,u){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[m,w]of u)(0,s.log)(c,m,w)}}e.$k7b=M}),define(te[228],ie([0,1,16,5]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function M(c,m,w,y,f){try{const v=await new Promise((g,$)=>{K(["@vscode/spdlog"],g,$)});v.setFlushOn(s.Trace);const b=await v.createAsyncRotatingLogger(c,m,w,y);return f?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(v){console.error(v)}return null}function D(c,m,w){switch(m){case R.LogLevel.Trace:c.trace(w);break;case R.LogLevel.Debug:c.debug(w);break;case R.LogLevel.Info:c.info(w);break;case R.LogLevel.Warning:c.warn(w);break;case R.LogLevel.Error:c.error(w);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function E(c,m){switch(m){case R.LogLevel.Trace:c.setLevel(s.Trace);break;case R.LogLevel.Debug:c.setLevel(s.Debug);break;case R.LogLevel.Info:c.setLevel(s.Info);break;case R.LogLevel.Warning:c.setLevel(s.Warning);break;case R.LogLevel.Error:c.setLevel(s.Error);break;case R.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class u extends R.$$i{constructor(m,w,y,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(m,w,y,f),this.B(this.onDidChangeLogLevel(b=>{this.r&&E(this.r,b)}))}async s(m,w,y,f){const v=y?6:1,b=30/v*S.$Ak.MB,g=await M(m,w,b,v,f);if(g){this.r=g,E(this.r,this.getLevel());for(const{level:$,message:o}of this.m)D(this.r,$,o);this.m=[]}}g(m,w){this.r?D(this.r,m,w):this.getLevel()<=m&&this.m.push({level:m,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$gN=u}),define(te[229],ie([0,1,31,5,228]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;class M extends R.$dj{s(E,u,c){return new s.$gN((0,S.$4f)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$hN=M}),define(te[65],ie([0,1,33,3,6,5,229]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=void 0,e.$K6b=(0,s.$Ch)(M.$6i);class E extends D.$hN{constructor(){super(...arguments),this.u=new S.$zi}createLogger(c,m,w){w!==void 0&&this.u.set(this.n(c),w);try{return super.createLogger(c,m)}catch(y){throw this.u.delete(this.n(c)),y}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const w of super.getRegisteredLoggers())c===this.u.get(w.resource)&&m.push(w);return m}getOnDidChangeLogLevelEvent(c){return R.Event.filter(this.onDidChangeLogLevel,m=>(0,M.$7i)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return R.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(y=>this.w(y.resource,c)),removed:[...m.removed].filter(y=>this.w(y.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,w]of this.u)w===c&&this.deregisterLogger(m)}w(c,m){const w=this.u.get(c);return w===void 0||w===m}dispose(){super.dispose(),this.u.clear()}}e.$L6b=E}),define(te[230],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=e.$B6b=void 0;function S(D){return D.submenu!==void 0}e.$B6b=S;function R(D){return D.id==="vscode.menubar.separator"}e.$C6b=R;function s(D){return D.uri!==void 0}e.$D6b=s;function M(D){return!S(D)&&!R(D)&&!s(D)}e.$E6b=M}),define(te[39],ie([0,1,3,67,2,6]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,M.$Bh)("policy");class D extends s.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(w,[y,f])=>({...w,[y]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[m,w])=>({...c,[m]:{definition:w,value:this.g.get(m)}}),{})}}e.$$m=D;class E{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=E}),define(te[231],ie([0,1,8,3,67,12,16,5,39]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;function c(w,y){const f=[];for(const v of new Set(s.Iterable.concat(w.keys(),y.keys())))w.get(v)!==y.get(v)&&f.push(v);return f}let m=class extends u.$$m{constructor(y,f,v){super(),this.m=y,this.n=f,this.s=v,this.c=this.B(new S.$Eg(500));const b=R.Event.filter(f.onDidFilesChange,g=>g.affects(y));this.B(f.watch(y)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,M.$lf)(v))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(v))this.f[b]&&y.set(b,v[b])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return y}async w(){const y=await this.u(),f=c(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};e.$C7b=m,e.$C7b=m=Ee([ee(1,D.$6j),ee(2,E.$5i)],m)}),define(te[232],ie([0,1,3,2,39]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=void 0;class M{constructor(u){this.b=u,this.a=new R.$jc}listen(u,c){switch(c){case"onDidChange":return S.Event.map(this.b.onDidChange,m=>m.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(u,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$d7b=M;class D extends s.$$m{constructor(u,c){super(),this.a=c;for(const m in u){const{definition:w,value:y}=u[m];this.f[m]=w,y!==void 0&&this.g.set(m,y)}this.a.listen("onDidChange")(m=>{for(const w in m){const y=m[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(m))})}async j(u){const c=await this.a.call("updatePolicyDefinitions",u);for(const m in c)this.g.set(m,c[m])}}e.$e7b=D}),define(te[233],ie([0,1,39,8,311,2,5]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;let E=class extends S.$$m{constructor(c,m){super(),this.m=c,this.n=m,this.a=new R.$Ag,this.b=this.B(new M.$lc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((m,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,y=>{this.t(y),m()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const w=c[m];w===void 0?this.g.delete(m):this.g.set(m,w)}this.h.fire(Object.keys(c))}};e.$B7b=E,e.$B7b=E=Ee([ee(0,D.$5i)],E)}),define(te[76],ie([0,1,4,35]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.context<"u"){const M=S.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,S.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(te[234],ie([0,1,71,5,24]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=void 0;let M=class{constructor(E,u){this.b=E,this.c=u,this.a=new Map}async isExtensionUrlTrusted(E,u){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(u);if(!c)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,m,w]=c;let y=this.a.get(E);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[E],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.a.set(E,[...y])}const f=Buffer.from(decodeURIComponent(w),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const v=f.slice(0,6),b=f.readUIntBE(0,6),g=Date.now()-b;if(g<0||g>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const $=f.slice(6),o=S.createVerify("SHA256");o.write(v),o.write(Buffer.from(m)),o.end();for(let d=0;d<y.length;d++){let P=y[d];if(P!==null){if(typeof P=="string")try{P=S.createPublicKey({key:Buffer.from(P,"base64"),format:"der",type:"spki"}),y[d]=P}catch(h){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${E}:`,h),y[d]=null;continue}if(o.verify(P,$))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};e.$e6b=M,e.$e6b=M=Ee([ee(0,s.$kj),ee(1,R.$5i)],M)}),define(te[235],ie([0,1,8,5]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;let s=class{constructor(D,E,u){this.a=D,this.b=E,this.c=u}async inspect(D){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Hg)(D);const u=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$r6b=s,e.$r6b=s=Ee([ee(2,R.$5i)],s)}),define(te[77],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=void 0,e.$u6b=(0,S.$Bh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class s{constructor(){this.a=new Map}add(D,E){S.ok(R.$jf(D)),S.ok(R.$lf(E)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,E)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$8m=new s}),define(te[236],ie([0,1,3,43]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function s(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this.b=new S.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[s(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;R.$8m.add(e.$9m.JSONContribution,D)}),define(te[57],ie([0,1,23,3,12,161,18,236,43]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var c;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$an={Configuration:"base.contributions.configuration"};var m;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const w=u.$8m.as(E.$9m.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$fd,this.onDidSchemaChange=this.i.event,this.j=new R.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(l.add(a),e.$kn.test(a)){const k=this.a.get(a),I=k?.valuesSources??new Map;if(n)for(const L of Object.keys(i[a]))I.set(L,n);const C={...k?.value||{},...i[a]};this.a.set(a,{source:n,value:C,valuesSources:I});const p=(0,D.$fi)(a),A={type:"object",default:C,description:M.localize(1,null,p),$ref:e.$hn,defaultDefaultValue:C,source:s.$jf(n)?void 0:n,defaultValueSource:n};r.push(...b(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:i[a],source:n});const k=this.d[a];k&&(this.w(a,k),this.r(a,k))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),k=s.$jf(i)?i:i?.id,I=s.$jf(a?.source)?a?.source:a?.source?.id;if(k===I)if(l.add(n),this.a.delete(n),e.$kn.test(n))delete this.d[n],delete this.b.properties[n];else{const C=this.d[n];C&&(this.w(n,C),this.r(n,C))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,l){const r=i=>{if(i.properties)for(const n in i.properties){l.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,i,n=3,a){n=s.$sf(t.scope)?n:t.scope;const k=t.properties;if(k)for(const C in k){const p=k[C];if(l&&d(C,p)){delete k[C];continue}if(p.source=r,p.defaultDefaultValue=k[C].default,this.w(C,p),e.$kn.test(C)?p.scope=void 0:(p.scope=s.$sf(p.scope)?n:p.scope,p.restricted=s.$sf(p.restricted)?!!i?.includes(C):p.restricted),k[C].hasOwnProperty("included")&&!k[C].included){this.f[C]=k[C],delete k[C];continue}else this.d[C]=k[C],k[C].policy?.name&&this.e.set(k[C].policy.name,C);!k[C].deprecationMessage&&k[C].markdownDeprecationMessage&&(k[C].deprecationMessage=k[C].markdownDeprecationMessage),a.add(C)}const I=t.allOf;if(I)for(const C of I)this.p(C,l,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$bn.properties[t]=l,l.scope){case 1:e.$cn.properties[t]=l;break;case 2:e.$dn.properties[t]=l;break;case 6:e.$en.properties[t]=l;break;case 3:e.$fn.properties[t]=l;break;case 4:e.$gn.properties[t]=l;break;case 5:e.$gn.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$bn.properties[t],l.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$hn};this.w(l,r),e.$bn.properties[l]=r,e.$cn.properties[l]=r,e.$dn.properties[l]=r,e.$en.properties[l]=r,e.$fn.properties[l]=r,e.$gn.properties[l]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$qf(i)&&(i=l.defaultDefaultValue,n=void 0),s.$qf(i)&&(i=$(l.type)),l.default=i,l.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$jn=`^(${f})+$`,e.$kn=new RegExp(e.$jn);function b(h){const t=[];if(e.$kn.test(h)){let l=v.exec(h);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=v.exec(h)}}return(0,S.$Kb)(t)}e.$ln=b;function g(h){return h.reduce((t,l)=>`${t}[${l}]`,"")}e.$mn=g;function $(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=$;const o=new y;u.$8m.add(e.$an.Configuration,o);function d(h,t){return h.trim()?e.$kn.test(h)?M.localize(7,null,h):o.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):t.policy?.name&&o.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,h,t.policy?.name,o.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$on=d;function P(){const h=[],t=o.getConfigurationProperties();for(const l of Object.keys(t))h.push([l,t[l].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$pn=P}),define(te[118],ie([0,1,23,3,44,2,33,37,12,7,18,57,43]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function f(l){return Object.isFrozen(l)?l:E.$Wm(l)}class v{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof v)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,m.$di)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,k=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:k}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,m.$di)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$Vm(this.contents),n=E.$Vm(this.overrides),a=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const I of r)if(k.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const C of I.overrides){const[p]=n.filter(A=>S.$sb(A.identifiers,C.identifiers));p?(this.h(p.contents,C.contents),p.keys.push(...C.keys),p.keys=S.$Kb(p.keys)):n.push(E.$Vm(C))}for(const C of I.keys)a.indexOf(C)===-1&&a.push(C)}return new v(i,a,n,k.every(I=>I instanceof v)?void 0:k)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of S.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[a];const I=i[a];I&&(typeof k=="object"&&typeof I=="object"?(k=E.$Vm(k),this.h(k,I)):k=I),n[a]=k}return new v(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&u.$lf(r[n])&&u.$lf(i[n])){this.h(r[n],i[n]);continue}r[n]=E.$Vm(i[n])}}i(r){let i=null,n=null;const a=k=>{k&&(n?this.h(n,k):n=E.$Vm(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===r?i=k.contents:k.identifiers.includes(r)&&a(k.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,m.$ci)(this.contents,r),w.$kn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$sb(n.identifiers,(0,w.$ln)(r))),1))}j(r,i,n){(0,m.$bi)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),w.$kn.test(r)&&this.overrides.push({identifiers:(0,w.$ln)(r),keys:Object.keys(this.contents[r]),contents:(0,m.$ai)(this.contents[r],a=>console.error(a))})}}e.$qn=v;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!u.$sf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:k,restricted:I,hasExcludedProperties:C}=this.h(r,i);this.b=new v(n,a,k,C?[r]:void 0),this.c=I||[]}g(r){let i={},n=null,a=[];const k=[],I=[];function C(A){Array.isArray(a)?a.push(A):n!==null&&(a[n]=A)}const p={onObjectBegin:()=>{const A={};C(A),k.push(a),a=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{a=k.pop()},onArrayBegin:()=>{const A=[];C(A),k.push(a),a=A,n=null},onArrayEnd:()=>{a=k.pop()},onLiteralValue:C,onError:(A,L,U)=>{I.push({error:A,offset:L,length:U})}};if(r)try{s.$Sm(r,p),i=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(r,i){const n=y.$8m.as(w.$an.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const k=(0,m.$ai)(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),I=Object.keys(r),C=this.j(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:k,keys:I,overrides:C,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let k=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:k};const I={},C=[];for(const p in r)if(w.$kn.test(p)&&n){const A=this.i(r[p],i,!1,a);I[p]=A.raw,k=k||A.hasExcludedProperties,C.push(...A.restricted)}else{const A=i[p],L=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&C.push(p),!a.exclude?.includes(p)&&(a.include?.includes(p)||(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&!(a.skipRestricted&&A?.restricted))?I[p]=r[p]:k=!0}return{raw:I,restricted:C,hasExcludedProperties:k}}j(r,i){const n=[];for(const a of Object.keys(r))if(w.$kn.test(a)){const k={};for(const I in r[a])k[I]=r[a][I];n.push({identifiers:(0,w.$ln)(a),keys:Object.keys(k),contents:(0,m.$ai)(k,i)})}return n}}e.$rn=b;class g extends M.$kc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new R.$fd),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=g;class ${constructor(r,i,n,a,k,I,C,p,A,L,U,q,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=k,this.f=I,this.g=C,this.h=p,this.i=A,this.j=L,this.k=U,this.l=q,this.m=se}get value(){return f(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class o{constructor(r,i,n,a,k=new v,I=new v,C=new D.$zi,p=new v,A=new D.$zi){this.c=r,this.d=i,this.f=n,this.g=a,this.h=k,this.i=I,this.j=C,this.l=p,this.m=A,this.a=null,this.b=new D.$zi,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new v,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.q(r,i,n),k=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,C=new Set;for(const p of a.overrides)for(const A of p.identifiers)a.getOverrideValue(r,A)!==void 0&&C.add(A);return new $(r,i,a.getValue(r),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,k||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:k,removed:I}=h(this.c,r);i=[...a,...k,...I]}for(const a of i)for(const k of(0,w.$ln)(a)){const I=this.c.getKeysForOverrideIdentifier(k),C=r.getKeysForOverrideIdentifier(k),p=[...C.filter(A=>I.indexOf(A)===-1),...I.filter(A=>C.indexOf(A)===-1),...I.filter(A=>!E.$Zm(this.c.override(k).getValue(A),r.override(k).getValue(A)))];n.push([k,p])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=h(this.d,r),k=[...i,...n,...a];return k.length&&this.updatePolicyConfiguration(r),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=h(this.applicationConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:k}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=h(this.localUserConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=h(this.remoteUserConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:k}=h(this.workspaceConfiguration,r),I=[...i,...n,...a];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:k}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:a,updated:k,removed:I,overrides:C}=h(n,i),p=[...a,...k,...I];return(p.length||!n)&&this.updateFolderConfiguration(r,i),{keys:p,overrides:C}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:k,overrides:I}=h(i,void 0);return{keys:[...n,...a,...k],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let a=this.r(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}r({resource:r},i){let n=this.s();if(i&&r){const a=i.getFolder(r);a&&(n=this.t(a.uri)||n);const k=this.m.get(r);k&&(n=n.merge(k))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:k}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:k}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),a=this.x(r.application),k=this.x(r.user),I=this.x(r.workspace),C=r.folders.reduce((p,A)=>(p.set(c.URI.revive(A[0]),this.x(A[1])),p),new D.$zi);return new o(i,n,a,k,new v,I,C,new v,new D.$zi)}static x(r){return new v(r.contents,r.keys,r.overrides)}}e.$tn=o;function d(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const a of l)a.keys.forEach(k=>r.add(k)),a.overrides.forEach(([k,I])=>{const C=(0,D.$wi)(i,k,new Set);I.forEach(p=>C.add(p))});const n=[];return i.forEach((a,k)=>n.push([k,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$un=d;class P{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const I of k)this.affectedKeys.add(I);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=o.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const k=a+n.length;if(k>=this.d.length)return!1;const I=this.d.charCodeAt(k);if(I!==this.b&&I!==this.c)return!1;if(i){const C=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,p=this.g.getValue(r,i,this.h);return!E.$Zm(C,p)}return!0}}e.$vn=P;function h(l,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,l?.rawConfiguration),k=[],I=l?.getAllOverrideIdentifiers()||[],C=r?.getAllOverrideIdentifiers()||[];if(r){const p=C.filter(A=>!I.includes(A));for(const A of p)k.push([A,r.getKeysForOverrideIdentifier(A)])}if(l){const p=I.filter(A=>!C.includes(A));for(const A of p)k.push([A,l.getKeysForOverrideIdentifier(A)])}if(r&&l){for(const p of I)if(C.includes(p)){const A=t({contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)},{contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)});k.push([p,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:a,overrides:k}}function t(l,r){const i=l?r?l.keys.filter(k=>r.keys.indexOf(k)===-1):[...l.keys]:[],n=r?l?r.keys.filter(k=>l.keys.indexOf(k)===-1):[...r.keys]:[],a=[];if(l&&r){for(const k of r.keys)if(l.keys.indexOf(k)!==-1){const I=(0,m.$di)(r.contents,k),C=(0,m.$di)(l.contents,k);E.$Zm(I,C)||a.push(k)}}return{added:i,removed:n,updated:a}}}),define(te[237],ie([0,1,23,3,2,37,12,118,57,5,39,43]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class y extends s.$kc{constructor(){super(...arguments),this.a=this.B(new R.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$8m.as(u.$an.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:$})=>this.c(Array.from(g),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,$){this.h(g,w.$8m.as(u.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new E.$qn;const g=w.$8m.as(u.$an.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,$){const o=this.f();for(const d of g){const P=o[d],h=$[d];P!==void 0?this.b.addValue(d,P):h?this.b.addValue(d,h.default):this.b.removeValue(d)}}}e.$wn=y;class f{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$qn}async initialize(){return this.configurationModel}}e.$xn=f;let v=class extends s.$kc{get configurationModel(){return this.b}constructor(g,$,o){super(),this.c=g,this.f=$,this.g=o,this.a=this.B(new R.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const $={},o=[],d=w.$8m.as(u.$an.Configuration).getConfigurationProperties();for(const P of g){const h=d[P];if(!h){o.push(P);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}o.push(P),$[h.policy.name]={type:h.type}}}return(0,D.$wf)($)||await this.f.updatePolicyDefinitions($),o}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const $=w.$8m.as(u.$an.Configuration).getPolicyConfigurations(),o=(0,S.$Fb)(g.map(d=>$.get(d)));this.m(o,!0)}m(g,$){this.g.trace("PolicyConfiguration#update",g);const o=w.$8m.as(u.$an.Configuration).getConfigurationProperties(),d=[],P=this.b.isEmpty();for(const h of g){const t=o[h]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(P?l!==void 0:!(0,M.$Zm)(this.b.getValue(h),l))&&d.push([h,l])}else this.b.getValue(h)!==void 0&&d.push([h,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const h=this.b;this.b=new E.$qn;for(const t of h.keys)this.b.setValue(t,h.getValue(t));for(const[t,l]of d)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);$&&this.a.fire(this.b)}}};e.$yn=v,e.$yn=v=Ee([ee(1,m.$0m),ee(2,c.$5i)],v)}),define(te[238],ie([0,1,8,3,2,19,18,118,237,39]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class m extends s.$kc{constructor(y,f,v,b){super(),this.j=y,this.h=this.B(new R.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$wn),this.c=v instanceof c.$_m?new u.$xn:this.B(new u.$yn(this.b,v,b)),this.f=this.B(new E.$sn(this.j,{},M.$_f,f)),this.a=new E.$tn(this.b.configurationModel,this.c.configurationModel,new E.$qn,new E.$qn),this.g=this.B(new S.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:$})=>this.n(g,$))),this.B(this.c.onDidChangeConfiguration(g=>this.r(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$tn(y,f,new E.$qn,v)}getConfigurationData(){return this.a.toData()}getValue(y,f){const v=typeof y=="string"?y:void 0,b=(0,D.$9h)(y)?y:(0,D.$9h)(f)?f:{};return this.a.getValue(v,b,void 0)}updateValue(y,f,v,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const f=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,f,2)}n(y,f){const v=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(y,f);this.s(b,v,7)}r(y){const f=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,f,7)}s(y,f,v){const b=new E.$vn(y,{data:f},this.a);b.source=v,b.sourceConfig=this.t(v),this.h.fire(b)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=m}),define(te[239],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=e.$p7b=void 0,e.$p7b="request",e.$q7b="remoteResourceHandler";class S{async routeCall(s,M,D){if(M!==e.$p7b)throw new Error(`Call not found: ${M}`);const E=D[0];if(E?.authority){const u=s.connections.find(c=>c.ctx===E.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$r7b=S}),define(te[240],ie([0,1,14,6]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,R.$Bh)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=M;class D{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=D;var E;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class u extends S.$_{static isNotAvailable(w){return w instanceof u&&w._code===E.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof u&&w._code===E.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof u&&w._code===E.NoResolverFound}static isInvalidAuthority(w){return w instanceof u&&w._code===E.InvalidAuthority}static isHandled(w){return w instanceof u&&w.isHandled}constructor(w,y=E.Unknown,f){super(w),this._message=w,this._code=y,this._detail=f,this.isHandled=y===E.NotAvailable&&f===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Mk=u;function c(m){const w=m.indexOf("+");return w===-1?m:m.substring(0,w)}e.$Nk=c}),define(te[58],ie([0,1,13]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function R(c){return c.scheme===S.Schemas.vscodeRemote?c.authority:void 0}e.$Ok=R;function s(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.$Pk=s;function M(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Qk=M;function D(c){const{host:m,port:w}=u(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:w}}e.$Rk=D;function E(c,m){let{host:w,port:y}=u(c);return typeof y>"u"&&(y=m),{host:w,port:y}}e.$Sk=E;function u(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(te[119],ie([0,1,26,6,58]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Tl=M,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var E;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,$){if(typeof g>"u"||g===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof g=="string"||typeof $=="string"){const o=typeof g=="string"?g:g.value,d=typeof $=="string"?$:$.value;return S.$Me(o,d)}return g._lower===$._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Vl=u;class c{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const $ of g)this.add($)}add(g){this.c.add(u.toKey(g))}delete(g){return this.c.delete(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}}e.$Wl=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(u.toKey(g))}get(g){return this.c.get(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}set(g,$){this.c.set(u.toKey(g),$)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=m;function w(b){return y(b)}e.$Yl=w;function y(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$Zl=y;function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$1l=f;function v(b,g){if(g){const $=`onResolveRemoteAuthority:${(0,s.$Pk)(g)}`;return!!b.activationEvents?.includes($)}return!1}e.$2l=v,e.$3l=(0,R.$Bh)("IBuiltinExtensionsScannerService")}),define(te[241],ie([0,1,8,17,22,14,3,2,64,68,31,109,240,58]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const v=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function g(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(T){const O=new s.$pd;return setTimeout(()=>O.cancel(),T),O.token}function o(T,O){if(T.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$pd;return T.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class d{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new E.$jc,this.promise=new Promise((j,z)=>{this.f=j,this.g=z}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function P(T,O){const j=new d(O);return j.registerDisposable(T.onControlMessage(z=>{const W=JSON.parse(z.toString()),B=F(W);B?j.reject(B):j.resolve(W)})),j.promise}function h(T,O,j,z,W,B,V,ce){const de=new d(ce),he=c.$bd.create(!1);return T.info(`Creating a socket (${V})...`),u.mark(`code/willCreateSocket/${B}`),O.connect(j,z,W,V).then(fe=>{de.didTimeout?(u.mark(`code/didCreateSocketError/${B}`),T.info(`Creating a socket (${V}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(u.mark(`code/didCreateSocketOK/${B}`),T.info(`Creating a socket (${V}) was successful after ${he.elapsed()} ms.`),de.resolve(fe))},fe=>{u.mark(`code/didCreateSocketError/${B}`),T.info(`Creating a socket (${V}) returned an error after ${he.elapsed()} ms.`),T.error(fe),de.reject(fe)}),de.promise}function t(T,O){const j=new d(O);return T.then(z=>{j.didTimeout||j.resolve(z)},z=>{j.didTimeout||j.reject(z)}),j.promise}async function l(T,O,j,z){const W=_(T,O);T.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let B;try{B=await h(T.logService,T.remoteSocketFactoryService,T.connectTo,(0,f.$Qk)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,g(O),`renderer-${g(O)}-${T.reconnectionToken}`,z)}catch(fe){throw T.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),T.logService.error(fe),fe}T.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,ce;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(B,null),V=T.reconnectionProtocol,ce=!1):(V=new w.$ph({socket:B}),ce=!0),T.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const de=await t(T.signService.createNewMessage((0,m.$4f)()),z),he={type:"auth",auth:T.connectionToken||"00000000000000000000",data:de.data};V.sendControl(R.$Fd.fromString(JSON.stringify(he)));try{const fe=await P(V,o(z,$(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(T.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(T.signService.validate(de,fe.signedData),z)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const be=await t(T.signService.sign(fe.data),z),ye={type:"connectionType",commit:T.commit,signedData:be,desiredConnectionType:O};return j&&(ye.args=j),T.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(R.$Fd.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(T.logService.error(`${W} the handshake timed out. Error:`),T.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${W} received error control message when negotiating connection. Error:`),T.logService.error(fe)),ce&&H(V),fe}}async function r(T,O,j,z){const W=Date.now(),B=_(T,O),{protocol:V,ownsProtocol:ce}=await l(T,O,j,z),de=new d(z);return de.registerDisposable(V.onControlMessage(he=>{const fe=JSON.parse(he.toString()),ve=F(fe);ve?(T.logService.error(`${B} received error control message when negotiating connection. Error:`),T.logService.error(ve),ce&&H(V),de.reject(ve)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${oe(W)}!`),de.resolve({protocol:V,firstMessage:fe}))})),de.promise}async function i(T,O){const{protocol:j}=await r(T,1,void 0,O);return{protocol:j}}async function n(T,O,j){const{protocol:z,firstMessage:W}=await r(T,2,O,j),B=W&&W.debugPort;return{protocol:z,debugPort:B}}async function a(T,O,j){const z=Date.now(),W=_(T,3),{protocol:B}=await l(T,3,O,j);return T.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(z)}!`),B}async function k(T,O,j){const{connectTo:z,connectionToken:W}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,connectTo:z,connectionToken:W,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:T.remoteSocketFactoryService,signService:T.signService,logService:T.logService}}async function I(T,O,j){return p(T,async z=>{const{protocol:W}=await i(z,s.CancellationToken.None);return new Y(T,O,j,z.reconnectionToken,W)})}e.$Xk=I;async function C(T,O){return p(T,async j=>{const{protocol:z,debugPort:W}=await n(j,O,s.CancellationToken.None);return new J(T,O,j.reconnectionToken,z,W)})}e.$Yk=C;async function p(T,O){for(let z=1;;z++)try{const W=(0,m.$4f)(),B=await k(T,W,null);return await O(B)}catch(W){if(z<5)T.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(W);else throw T.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(W),re.triggerPermanentFailure(0,0,y.$Mk.isHandled(W)),W}}async function A(T,O,j){const z=await k(T,(0,m.$4f)(),null);return await a(z,{host:O,port:j},s.CancellationToken.None)}e.$Zk=A;function L(T){return(0,S.$ug)(O=>new Promise((j,z)=>{const W=setTimeout(j,T*1e3);O.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var U;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class q{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$1k=q;class se{constructor(O,j,z,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=z,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$2k=se;class x{constructor(O,j,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=z,this.type=2}}e.$3k=x;class ae{constructor(O,j,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=z,this.type=4}}e.$4k=ae;class ne{constructor(O,j,z,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=z,this.handled=W,this.type=3}}e.$5k=ne;class re extends E.$kc{static triggerPermanentFailure(O,j,z){this._permanentFailure=!0,this.f=O,this.g=j,this.h=z,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||re._permanentFailure}constructor(O,j,z,W,B){super(),this.t=O,this.u=j,this.reconnectionToken=z,this.protocol=W,this.w=B,this.m=this.B(new D.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const ce=Z(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(V=>{const ce=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),re.j.push(this),this.B((0,E.$ic)(()=>{const V=re.j.indexOf(this);V>=0&&re.j.splice(V,1)})),this.n&&this.D(re.f,re.g,re.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const W=z<j.length?j[z]:j[j.length-1];try{if(W>0){const V=L(W);this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.u.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${O} resolving connection...`);const B=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${B.connectTo}...`),await this.G(B,$(v)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(y.$Mk.isTemporarilyNotAvailable(B)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,M.$2)(B)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof y.$Mk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,y.$Mk.isHandled(B));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(O,j,z){this.w?re.triggerPermanentFailure(O,j,z):this.D(O,j,z)}D(O,j,z){this.m.fire(new ne(this.reconnectionToken,O,j,z)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=re;class Y extends re{constructor(O,j,z,W,B){super(1,O,W,B,!0),this.client=this.B(new w.$nh(B,{remoteAuthority:j,clientId:z},O.ipcLogger))}async G(O,j){await i(O,j)}}e.$7k=Y;class J extends re{constructor(O,j,z,W,B){super(2,O,z,W,!1),this.H=j,this.debugPort=B}async G(O,j){await n(O,this.H,j)}}e.$8k=J;function H(T){try{T.acceptDisconnect();const O=T.getSocket();T.dispose(),O.dispose()}catch(O){(0,M.$Y)(O)}}function F(T){if(T&&T.type==="error"){const O=new Error(`Connection error: ${T.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(T,O){for(;T.length<O;)T+=" ";return T}function G(T,O){return`[remote-connection][${N(g(T),13)}][${O.substr(0,5)}\u2026]`}function Z(T,O,j){return`${G(T,O)}[${j?"reconnect":"initial"}]`}function _(T,O){return`${Z(O,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.connectTo}]`}function oe(T){return`${Date.now()-T} ms`}}),define(te[242],ie([0,1,2,6]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,R.$Bh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,E){return this.a[D]??=[],this.a[D].push(E),(0,S.$ic)(()=>{const u=this.a[D]?.indexOf(E);typeof u=="number"&&u>=0&&this.a[D]?.splice(u,1)})}b(D){return(this.a[D.type]||[]).find(u=>u.supports(D))}connect(D,E,u,c){const m=this.b(D);if(!m)throw new Error(`No socket factory found for ${D}`);return m.connect(D,E,u,c)}}e.$Uk=s}),define(te[243],ie([0,1,27,47,21,113]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;let D;async function E(f=!1){return(D===void 0||f)&&(D=u()),D}e.$q6b=E;async function u(){const f=c();if(f===void 0)return!1;if(f>=22e3){const v=w();if(v)return new Promise(b=>{R.execFile(v,["--status"],g=>b(!g))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function c(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(f)return parseInt(f[3])}function m(f){const v=process.env.SystemRoot;if(v){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,b?"Sysnative":"System32",f)}}function w(){return m("wsl.exe")}function y(){return m("lxss\\LxssManager.dll")}}),define(te[50],ie([0,1,17,14,2,181,57,6,5,43]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,E.$Bh)("requestService");class m{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class w extends s.$kc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,M.localize)(0,null),when:u.$jj.isEqualTo((0,u.$hj)(u.LogLevel.Trace)).serialize()})}async c(h,t,l){const r=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new m(t.headers??{}));try{const i=await l();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$8)(i)),i}}}e.$Jo=w;function y(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.$Ko=y;function f(P){return P.res.statusCode===204}e.$Lo=f;async function v(P){return f(P)?null:(await(0,S.$Rd)(P.stream)).toString()}e.$Mo=v;async function b(P){if(!y(P))throw new Error("Server returned "+P.res.statusCode);return v(P)}e.$No=b;async function g(P){if(!y(P))throw new Error("Server returned "+P.res.statusCode);if(f(P))return null;const t=(await(0,S.$Rd)(P.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Oo=g;function $(P){d(P)}e.$Po=$;let o;function d(P){const h=c.$8m.as(D.$an.Configuration),t=o;o={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},h.updateConfigurations({add:[o],remove:t?[t]:[]})}d(1)}),define(te[244],ie([0,1,17,22]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class s{constructor(E){this.a=E}listen(E,u){throw new Error("Invalid listen")}call(E,u,c,m=R.CancellationToken.None){switch(u){case"request":return this.a.request(c[0],m).then(async({res:w,stream:y})=>{const f=await(0,S.$Rd)(y);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.$Lq=s;class M{constructor(E){this.a=E}async request(E,u){const[c,m]=await this.a.call("request",[E],u);return{res:c,stream:(0,S.$Td)(m)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}}e.$Mq=M}),define(te[245],ie([0,1,246,12]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;function s(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(D,E,u={}){const c=(0,S.parse)(D),m=u.proxyUrl||s(c,E);if(!m)return null;const w=(0,S.parse)(m);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,R.$pf)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,v)=>{K(["http-proxy-agent"],f,v)}))(y):new(await new Promise((f,v)=>{K(["https-proxy-agent"],f,v)}))(y)}e.$Nq=M}),define(te[247],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=e.$N6b=e.$M6b=void 0,e.$M6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$N6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$O6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,182,22,49,14,4,31,108,62,8,138]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=void 0;let v;async function b($,o,d,P){return d["force-disable-user-env"]?(o.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(o.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Gl)(P)&&!d["force-user-env"]?(o.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Gl)(P)?o.trace("resolveShellEnv(): running (--force-user-env)"):o.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(h,t)=>{const l=new M.$pd;let r=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,f.$Hl)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{h(await g(o,l.token))}catch(a){!(0,E.$2)(a)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$mi)(a)))):h({})}finally{clearTimeout(n),l.dispose()}})),v)}e.$Ml=b;async function g($,o){const d=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",d);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",P);const h=(0,c.$4f)().replace(/-/g,"").substr(0,12),t=new RegExp(h+"({.*})"+h),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",l);const r=await(0,m.$wl)(u.OS,l);return $.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(o.isCancellationRequested)return n(new E.$3);const a=(0,R.$ae)(r);let k,I;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(k=`& '${process.execPath}' ${C} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,I=["-Login","-Command"]):a==="nu"?(k=`^'${process.execPath}' ${C} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${C} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,a==="tcsh"||a==="csh"?I=["-ic"]:I=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const p=(0,S.spawn)(r,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});o.onCancellationRequested(()=>(p.kill(),n(new E.$3))),p.on("error",U=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,D.$mi)(U)),n(U)});const A=[];p.stdout.on("data",U=>A.push(U));const L=[];p.stderr.on("data",U=>L.push(U)),p.on("close",(U,q)=>{const se=Buffer.concat(A).toString("utf8");$.trace("getUnixShellEnvironment#raw",se);const x=Buffer.concat(L).toString("utf8");if(x.trim()&&$.trace("getUnixShellEnvironment#stderr",x),U||q)return n(new Error((0,s.localize)(2,null,U,q)));const ae=t.exec(se),ne=ae?ae[1]:"{}";try{const re=JSON.parse(ne);d?re.ELECTRON_RUN_AS_NODE=d:delete re.ELECTRON_RUN_AS_NODE,P?re.ELECTRON_NO_ATTACH_CONSOLE=P:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){$.error("getUnixShellEnvironment#errorCaught",(0,D.$mi)(re)),n(re)}})})}}),define(te[248],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N2b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(S.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$N2b=S}),define(te[95],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,S.$Bh)(e.$Vk)}),define(te[249],ie([0,1,248]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;class R extends S.$N2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>K(["vsda"],M,D))}}e.$A7b=R}),define(te[34],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.$iN=void 0,e.$iN=(0,S.$Bh)("stateReadService"),e.$jN=(0,S.$Bh)("stateService")}),define(te[120],ie([0,1,8,17,2,12,36,16,5]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.$kN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends s.$kc{constructor(v,b,g,$){super(),this.h=v,this.j=g,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new S.$Eg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,b){const g=this.a[v];return(0,M.$sf)(g)?b:g}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:g,data:$}of v)this.a[g]!==$&&((0,M.$sf)($)?(0,M.$qf)(this.a[g])||(this.a[g]=void 0,b=!0):(this.a[g]=$,b=!0));b&&this.r()}removeItem(v){(0,M.$qf)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,R.$Fd.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(b){this.j.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$kN=m;let w=class extends s.$kc{constructor(v,b,g,$){super(),this.a=this.B(new m(b.stateResource,v,g,$))}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};e.$lN=w,e.$lN=w=Ee([ee(1,D.$Ih),ee(2,u.$5i),ee(3,E.$6j)],w);class y extends w{setItem(v,b){this.a.setItem(v,b)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$mN=y}),define(te[121],ie([0,1,4,35,31]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function M(u){if(S.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,c,m,w,y,f,v,b){const g=Object.create(null);g["common.machineId"]=f,g.sessionID=(0,s.$4f)()+Date.now(),g.commitHash=w,g.version=y,g["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$t),g["common.nodePlatform"]=R.$3d,g["common.nodeArch"]=m,g["common.product"]=b||"desktop",v&&(g["common.msftInternal"]=v);let $=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const d=M(c);return d&&(g["common.platformDetail"]=d),g}e.$0n=D;function E(u){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return u.some(w=>m===w)}e.$$n=E}),define(te[25],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,S.$Bh)("telemetryService"),e.$0k=(0,S.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[250],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;const g=new Map;async function $(t,l){const r=`${t}::${l.join(":")}`,i=g.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,k=new Map,I=2e4;function C(A,L,U,q){const se=L.substring(A.length+1);return R.Promises.withAsyncBody(async x=>{let ae;try{ae=await m.Promises.readdir(L,{withFileTypes:!0})}catch{x();return}if(q.count>=I){q.count+=ae.length,q.maxReached=!0,x();return}let ne=ae.length;if(ne===0){x();return}let re=ae;q.count+ae.length>I&&(q.maxReached=!0,ne=I-q.count,re=ae.slice(0,ne)),q.count+=ae.length;for(const Y of re)if(Y.isDirectory()){if(U.includes(Y.name)||await C(A,(0,D.$9d)(L,Y.name),U,q),--ne===0){x();return}}else{const J=Y.name.lastIndexOf(".");if(J>=0){const H=Y.name.substring(J+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(se)!==!1&&H.filePattern.test(Y.name)&&k.set(H.tag,(k.get(H.tag)??0)+1);if(--ne===0){x();return}}})}const p=R.Promises.withAsyncBody(async A=>{const L={count:0,maxReached:!1};await C(t,t,l,L);const U=await P(t);A({configFiles:o(k),fileTypes:o(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:U})});return g.set(r,p),p}e.$tr=$;function o(t){return Array.from(t.entries(),([l,r])=>({name:l,count:r})).sort((l,r)=>r.count-l.count)}function d(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(S.freemem()/f.$Ak.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Hm.value()*100)}%`},l=S.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$ur=d;async function P(t){try{const l=new Map,r=(0,D.$9d)(t,".vscode","launch.json"),i=await m.Promises.readFile(r),n=[],a=(0,s.$Lm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Um)(a)==="object"&&a.configurations)for(const k of a.configurations){const I=k.type;I&&(l.has(I)?l.set(I,l.get(I)+1):l.set(I,1))}return o(l)}catch{return[]}}e.$vr=P;let h=class{constructor(l,r){this.c=l,this.d=r}f(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}g(l){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(S.freemem()/f.$Ak.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(c.$Hm.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,w.$sr)(l.mainPID),this.k(l)]).then(async i=>{let[n,a]=i,k=this.m(l,n);return r.forEach(I=>{if((0,y.$hm)(I))k+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(k+=`

Remote: ${I.hostName}`,I.processes&&(k+=`
${this.m(l,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const C of Object.keys(I.workspaceMetadata)){const p=I.workspaceMetadata[C];let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${C}): ${A}`,a+=this.h(p)}}}),{processInfo:k,workspaceInfo:a}})}async getSystemInfo(l,r){const{memory:i,vmHint:n,os:a,cpus:k}=d(),I={os:a,memory:i,cpus:k,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(I.load=`${S.loadavg().map(C=>Math.round(C)).join(", ")}`),E.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(l,r){const i=[];return(0,w.$sr)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),r.forEach(a=>{if((0,y.$hm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(l,a.processes)),a.workspaceMetadata)for(const k of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[k];let C=`${I.fileCount} files`;I.maxFilesReached&&(C=`more than ${C}`),i.push(`Folder (${k}): ${C}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const r=[];let n=0;const a=(p,A)=>{const L=` ${p}(${A})`;n+L.length>60?(r.push(k),k="|                 ",n=k.length):n+=L.length,k+=L};let k="|      File types:";const I=10,C=l.fileTypes.length>I?I:l.fileTypes.length;for(let p=0;p<C;p++){const A=l.fileTypes[p];a(A.name,A.count)}if(r.push(k),l.configFiles.length>=0&&(k="|      Conf files:",n=0,l.configFiles.forEach(p=>{a(p.name,p.count)}),r.push(k)),l.launchConfigFiles.length>0){let p="|      Launch Configs:";l.launchConfigFiles.forEach(A=>{const L=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;p+=L}),r.push(p)}return r.join(`
`)}j(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const r=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const k=u.URI.revive(a);if(k.scheme===M.Schemas.file){const I=k.fsPath;i.push($(I,["node_modules",".git"]).then(C=>{let p=`${C.fileCount} files`;C.maxFilesReached&&(p=`more than ${p}`),r.push(`|    Folder (${(0,D.$ae)(I)}): ${p}`),r.push(this.h(C))}).catch(C=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${C.toString()})`)}))}else r.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,r){const i=new Map;l.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),l.pidToNames.forEach(({pid:a,name:k})=>i.set(a,k));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(l.mainPID,i,n,r,0),n.join(`
`)}n(l,r,i,n,a){const k=a===0;let I;k?I=n.pid===l?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?I=r.get(n.pid):I=`${"  ".repeat(a)} ${n.name}`;const C=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(C/f.$Ak.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(p=>this.n(l,r,i,p,a+1))}async getWorkspaceFileExtensions(l){const r=new Set;for(const{uri:i}of l.folders){const n=u.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await $(a,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=u.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})}),a.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})}),a.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$wr=h,e.$wr=h=Ee([ee(0,b.$9k),ee(1,v.$kj)],h)}),define(te[251],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0;class S{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:E,data:u}){return this.b.forEach(c=>c.log(E,u)),Promise.resolve(null)}}e.$R6b=S;class R{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$S6b=R}),define(te[51],ie([0,1,37,12,3,18,58,121,25]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$_n=c;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=m,e.$bo=new m;class w{async publicLog(n,a,k){}async publicLogError(n,a,k){}}e.$co=w,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(k,I)=>{const C=k?new Set([...k.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:C}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$$h)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$go=y;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$ho=f;function v(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$io=v;function b(i){const n=i.getValue(u.$dl),a=i.getValue(u.$el);if(i.getValue(u.$fl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=b;function g(i){const n={},a={},k={};d(i,k);for(let I in k){I=I.length>150?I.substr(I.length-149):I;const C=k[I];typeof C=="number"?a[I]=C:typeof C=="boolean"?a[I]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${C.length}`),n[I]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[I]=C)}return{properties:n,measurements:a}}e.$ko=g;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(i){if(!i)return"none";const n=(0,D.$Pk)(i);return $.has(n)?n:"other"}e.$lo=o;function d(i,n,a=0,k){if(i)for(const I of Object.getOwnPropertyNames(i)){const C=i[I],p=k?k+I:I;Array.isArray(C)?n[p]=(0,S.$1m)(C):C instanceof Date?n[p]=C.toISOString():(0,R.$lf)(C)?a<2?d(C,n,a+1,p+"."):n[p]=(0,S.$1m)(C):n[p]=C}}function P(i,n){const a=i.msftInternalDomains||[],k=n.getValue("telemetry.internalTesting");return(0,E.$$n)(a)||k}e.$mo=P;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$no=h;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const k=[];for(const A of n)for(;;){const L=A.exec(i);if(!L)break;k.push([L.index,A.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(a="";;){const A=C.exec(i);if(!A)break;const L=k.some(([U,q])=>A.index<q&&U<C.lastIndex);!I.test(A[0])&&!L&&(a+=i.substring(p,A.index)+"<REDACTED: user-file-path>",p=C.lastIndex)}return p<i.length&&(a+=i.substr(p)),a}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function r(i,n){return(0,S.$Xm)(i,a=>{if(a instanceof c||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let k=a.replaceAll("%20"," ");k=t(k,n);for(const I of n)k=k.replace(I,"");return k=l(k),k}})}e.$oo=r}),define(te[122],ie([0,1,26,116,119,4,7,14,35,51]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$He)(r.id,i.id)===0}e.$po=m;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,a)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$qo=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const i=f.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.$ro=v;function b(r,i){return`${r}.${i}`}e.$so=b;function g(r){return r.toLowerCase()}e.$to=g;function $(r,i){return g(b(r??s.$Rl,i))}e.$uo=$;function o(r,i){const n=[],a=k=>{for(const I of n)if(I.some(C=>m(i(C),i(k))))return I;return null};for(const k of r){const I=a(k);I?I.push(k):n.push([k])}return n}e.$vo=o;function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$wo=d;function P(r){return{id:new c.$_n(r.identifier.id),name:new c.$_n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$xo=P,e.$yo=new s.$Vl("pprice.better-merge");function h(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const k=a.shift();if(k&&n.every(I=>!m(I.identifier,{id:k}))){const I=r.filter(C=>m(C.identifier,{id:k}));I.length===1&&(n.push(I[0]),a.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$zo=h;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,E.$8)(k))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,i){const n=await t(r,i),a=(0,R.$Un)(n?"alpine":M.$t,u.$4d);return i.debug("ComputeTargetPlatform:",a),a}e.$Ao=l}),define(te[252],ie([0,1,204,51]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function s(M,D,E,u,c,m,w){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,R.$ho)(D,E)&&(0,R.$jo)(u)===3){const f=await(0,S.$2o)(E,c,m);y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=w.machineId||f}return y}e.$3o=s}),define(te[253],ie([0,1,2,37,4,26,183,18,57,76,24,43,25,51]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,o,d){this.k=o,this.l=d,this.d={},this.i=new S.$jc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this.f)this.j.push(new RegExp((0,M.$qe)(P),"gi")),P.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$qe)(P.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(P=>{(P.affectsConfiguration(y.$dl)||P.affectsConfiguration(y.$fl)||P.affectsConfiguration(y.$el))&&this.m()}))}setExperimentProperty($,o){this.d[$]=o}m(){let $=(0,f.$jo)(this.k);const o=this.l.enabledTelemetryLevels;if(o){this.h=this.sendErrorTelemetry?o.error:!1;const d=o.usage?3:o.error?2:0;$=Math.min($,d)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,o,d){this.g<o||(d=(0,R.$Ym)(d,this.d),d=(0,f.$oo)(d,this.j),d=(0,R.$Ym)(d,this.c),this.b.forEach(P=>P.log($,d)))}publicLog($,o){this.n($,3,o)}publicLog2($,o){this.publicLog($,o)}publicLogError($,o){this.h&&this.n($,2,o)}publicLogError2($,o){this.publicLogError($,o)}};e.$Qq=v,e.$Qq=v=Ee([ee(1,E.$8h),ee(2,m.$kj)],v);function b(){const g=(0,D.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),o=s.$o?"":(0,D.localize)(3,null),d=(0,D.localize)(4,null),P=(0,D.localize)(5,null),h=(0,D.localize)(6,null),t=(0,D.localize)(7,null),l=`
|       | ${d} | ${P} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${g} ${$} ${o}

&nbsp;

${t}
${l}

&nbsp;

${r}
`}w.$8m.as(u.$an.Configuration).registerConfiguration({id:y.$cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$8m.as(u.$an.Configuration).registerConfiguration({id:y.$cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$fl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[254],ie([0,1,4,86,25]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;async function M(D,E){let u=D.getItem(s.$bl);return(typeof u!="string"||S.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,R.$Im)(E.error.bind(E))),u}e.$i7b=M}),define(te[255],ie([0,1,25,254]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;async function s(M,D){const E=await(0,R.$i7b)(M,D);return M.setItem(S.$bl,E),E}e.$j7b=s}),define(te[123],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(te[256],ie([0,1,4,123]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((w,y)=>{this.d(w,y);const f=w.map.entries();let v=f.next();for(;!v.done;){const b=v.value[1],g=v.value[0];let $=this.a.get(g);if($||($=[],this.a.set(g,$)),$.length>0&&$[0].type===R.EnvironmentVariableMutatorType.Replace){v=f.next();continue}const o={extensionIdentifier:y,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};o.scope||delete o.scope,$.unshift(o),v=f.next()}})}async applyToProcessEnvironment(m,w,y){let f;S.$i&&(f={},Object.keys(m).forEach(v=>f[v.toLowerCase()]=v));for(const[v,b]of this.getVariableMap(w)){const g=S.$i&&f[v.toLowerCase()]||v;for(const $ of b){const o=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case R.EnvironmentVariableMutatorType.Append:m[g]=(m[g]||"")+o;break;case R.EnvironmentVariableMutatorType.Prepend:m[g]=o+(m[g]||"");break;case R.EnvironmentVariableMutatorType.Replace:m[g]=o;break}if($.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${s.get($.type)}`;m[d]=(m[d]?m[d]+":":"")+v+"="+this.c(o)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,w){const y=new Map,f=new Map,v=new Map;if(m.getVariableMap(w).forEach((b,g)=>{const $=this.getVariableMap(w).get(g),o=E(b,$);o&&y.set(g,o)}),this.getVariableMap(w).forEach((b,g)=>{const $=m.getVariableMap(w).get(g),o=E(b,$);o&&v.set(g,o)}),this.getVariableMap(w).forEach((b,g)=>{const $=m.getVariableMap(w).get(g),o=u(b,$);o&&f.set(g,o)}),!(y.size===0&&f.size===0&&v.size===0))return{added:y,changed:f,removed:v}}getVariableMap(m){const w=new Map;for(const y of this.a.values()){const f=y.filter(v=>D(v,m));f.length>0&&w.set(f[0].variable,f)}return w}getDescriptionMap(m){const w=new Map;for(const y of this.b.values()){const f=y.filter(v=>D(v,m,!0));for(const v of f)w.set(v.extensionIdentifier,v.description)}return w}d(m,w){if(!m.descriptionMap)return;const y=m.descriptionMap.entries();let f=y.next();for(;!f.done;){const v=f.value[1],b=f.value[0];let g=this.b.get(b);g||(g=[],this.b.set(b,g));const $={extensionIdentifier:w,scope:v.scope,description:v.description};$.scope||delete $.scope,g.push($),f=y.next()}}}e.$gr=M;function D(c,m,w=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):w?m===c.scope:!0}function E(c,m){if(!m)return c;const w=new Set;m.forEach(f=>w.add(f.extensionIdentifier));const y=[];return c.forEach(f=>{w.has(f.extensionIdentifier)||y.push(f)}),y.length===0?void 0:y}function u(c,m){if(!m)return;const w=new Map;m.forEach(f=>w.set(f.extensionIdentifier,f));const y=[];return c.forEach(f=>{const v=w.get(f.extensionIdentifier);v&&(f.type!==v.type||f.value!==v.value||f.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(te[257],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function S(u){return[...u.entries()]}e.$ar=S;function R(u){return u?[...u.entries()]:[]}e.$br=R;function s(u){return new Map(u)}e.$cr=s;function M(u){return new Map(u??[])}e.$dr=M;function D(u){return Array.from(u.entries()).map(c=>[c[0],S(c[1].map),R(c[1].descriptionMap)])}e.$er=D;function E(u){return new Map(u.map(c=>[c[0],{map:s(c[1]),descriptionMap:M(c[2])}]))}e.$fr=E}),define(te[258],ie([0,1,8,22,3,2,5]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let E=class extends M.$kc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$fd),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$ic)(()=>{for(const w of this.f.values())(0,M.$fc)(w)}))}createRequest(c){return new Promise((m,w)=>{const y=++this.a;this.c.set(y,m),this.g.fire({requestId:y,...c});const f=new R.$pd;(0,S.$Hg)(this.b,f.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$ic)(()=>f.cancel())])})}acceptReply(c,m){const w=this.c.get(c);w?(this.c.delete(c),(0,M.$fc)(this.f.get(c)||[]),this.f.delete(c),w(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$4q=E,e.$4q=E=Ee([ee(1,D.$5i)],E)}),define(te[124],ie([0,1,6,114,43]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Wq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Vq=void 0,e.$Vq=new R.$2i("terminalTabFocusMode",!1,!0);var M;(function(h){h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var E;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(E||(e.PosixShellType=E={}));var u;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(u||(e.WindowsShellType=u={}));var c;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var w;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$Wq=(0,S.$Bh)("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var f;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var v;(function(h){h.TerminalView="view",h.Editor="editor"})(v||(e.TerminalLocationString=v={}));var b;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var g;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var $;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var o;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var d;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$Xq={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$8m.add(e.$Xq.Backend,new P),e.$Yq=(0,S.$Bh)("localPtyService"),e.$Zq=(0,S.$Bh)("terminalLogService")}),define(te[259],ie([0,1,70,7,185,102]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=e.$5q=void 0;function D(y,f){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(b=>({name:b.profileName,description:E(b)}))),f&&v.push(...f.map(b=>({name:b.title,description:u(b)}))),{values:v.map(b=>b.name),markdownDescriptions:v.map(b=>b.description)}}e.$5q=D;function E(y){let f=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Pj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?f+=`
- args: "${y.args}"`:f+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(f+=`
- overrideName: ${y.overrideName}`),y.color&&(f+=`
- color: ${y.color}`),y.env&&(f+=`
- env: ${JSON.stringify(y.env)}`),f}function u(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Pj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function c(y,f){if(!y&&!f)return!0;if(typeof y=="string"&&typeof f=="string")return y===f;if(Array.isArray(y)&&Array.isArray(f)){if(y.length!==f.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==f[v])return!1;return!0}return!1}e.$6q=c;function m(y,f){if(!y&&!f)return!0;if(!y||!f)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(f))return y.id===f.id&&y.color===f.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof f=="object"&&"light"in f&&"dark"in f){const v=y,b=f;if((R.URI.isUri(v.light)||w(v.light))&&(R.URI.isUri(v.dark)||w(v.dark))&&(R.URI.isUri(b.light)||w(b.light))&&(R.URI.isUri(b.dark)||w(b.dark)))return v.light.path===b.light.path&&v.dark.path===b.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(f)||w(y)||w(f)){const v=y,b=f;return v.path===b.path&&v.scheme===b.scheme}return!1}e.$7q=m;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$8q=w}),define(te[260],ie([0,1,70,4,184,57,43,259]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=e.$0q=e.$9q=void 0,e.$9q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$0q={type:"string",enum:Array.from((0,S.$Oj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,S.$Oj)(),g=>`$(${g.id})`)};const u={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$0q},color:{description:(0,s.localize)(3,null),...e.$9q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function w(g){const $=g===2?"linux":g===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)(g),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...u}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...u}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...u}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){D.$8m.as(M.$an.Configuration).registerConfiguration(y),b()}e.$$q=f;let v;function b(g,$){const o=D.$8m.as(M.$an.Configuration);let d;g&&(d=(0,E.$5q)(g?.profiles,$));const P=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?d?.values:void 0,markdownEnumDescriptions:g?.os===3?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?d?.values:void 0,markdownEnumDescriptions:g?.os===2?d?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?d?.values:void 0,markdownEnumDescriptions:g?.os===1?d?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[v],remove:P?[P]:[]})}e.$_q=b}),define(te[261],ie([0,1,27,13,37,9,4,35,26,12,21,123,257,256]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=void 0;function v(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$hr=v;async function b(i,n,a,k=E.env,I=m.Promises.exists){if(M.$8d(i))return await I(i)?i:void 0;if(n===void 0&&(n=E.cwd()),M.$_d(i)!=="."){const L=M.$9d(n,i);return await I(L)?L:void 0}const p=(0,s.$3m)(k,"PATH");if(a===void 0&&(0,c.$jf)(p)&&(a=p.split(M.$ge)),a===void 0||a.length===0){const L=M.$9d(n,i);return await I(L)?L:void 0}for(const L of a){let U;if(M.$8d(L)?U=M.$9d(L,i):U=M.$9d(n,L,i),await I(U))return U;if(D.$i){let q=U+".com";if(await I(q)||(q=U+".exe",await I(q)))return q}}const A=M.$9d(n,i);return await I(A)?A:void 0}e.$ir=b;function g(i,n,a,k,I){const C=D.$i&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||C)return;const p=i.args,A=E.$3d==="win32"?M.$ae(i.executable).toLowerCase():M.$ae(i.executable),L=M.$_d(R.$2f.asFileUri("").fsPath);let U;const q={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(q.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!p||l(p)?U=d.get(o.WindowsPwsh):t(p)&&(U=d.get(o.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,u.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:q}):void 0;k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!p||p.length===0?U=d.get(o.Bash):r(p)&&(q.VSCODE_SHELL_LOGIN="1",$(n,q),U=d.get(o.Bash)),U?(U=[...U],U[U.length-1]=(0,u.$ne)(U[U.length-1],L),{newArgs:U,envMixin:q}):void 0;case"fish":{const se=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${se}:${x}`,$(n,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!p||l(p)?U=d.get(o.Pwsh):t(p)&&(U=d.get(o.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,u.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:q}):void 0;case"zsh":{if(!p||p.length===0?U=d.get(o.Zsh):r(p)?(U=d.get(o.ZshLogin),$(n,q)):(p===d.get(o.Zsh)||p===d.get(o.ZshLogin))&&(U=p),!U)return;U=[...U],U[U.length-1]=(0,u.$ne)(U[U.length-1],L);let se;try{se=S.userInfo().username}catch{se="unknown"}const x=M.$9d(S.tmpdir(),`${se}-${I.applicationName}-zsh`);q.ZDOTDIR=x;const ae=a?.ZDOTDIR??S.homedir()??"~";q.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$9d(x,".zshrc")}),ne.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$9d(x,".zprofile")}),ne.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$9d(x,".zshenv")}),ne.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$9d(x,".zlogin")}),{newArgs:U,envMixin:q,filesToCopy:ne}}}k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$jr=g;function $(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,y.$fr)(i.environmentVariableCollections),I=new f.$gr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),C=[];if(I)for(const p of I)p.type===w.EnvironmentVariableMutatorType.Prepend&&C.push(p.value);C.length>0&&(n.VSCODE_PATH_PREFIX=C.join(""))}}var o;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(o||(o={}));const d=new Map;d.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(o.Zsh,["-i"]),d.set(o.ZshLogin,["-il"]),d.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],h=["-nol","-nologo"];function t(i){return typeof i=="string"?P.includes(i.toLowerCase()):i.length===1&&P.includes(i[0].toLowerCase())||i.length===2&&(P.includes(i[0].toLowerCase())||P.includes(i[1].toLowerCase()))&&(h.includes(i[0].toLowerCase())||h.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?h.includes(i.toLowerCase()):i.length===0||i?.length===1&&h.includes(i[0].toLowerCase())}function r(i){return i==="string"&&P.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&P.includes(i[0].toLowerCase())}}),define(te[262],ie([0,1,47,70,9,4,12,21,106,261,113]),function(K,e,S,R,s,M,D,E,u,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;let w,y=!0;function f(n,a,k,I,C=process.env,p,A,L,U){return p=p||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},M.$i?v(k,p,C,A,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:I.getValue("terminal.integrated.defaultProfile.windows"),U,L):l(p,A,k,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,L,C)}e.$kr=f;async function v(n,a,k,I,C,p,A,L,U){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let x=!1;(0,c.$hr)()>=16299&&(x=!0),await o(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:R.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:R.$Pj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Pj.terminalBash,isAutoDetected:!0});const re=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",re],requiresPath:process.env.CMDER_ROOT?re:{path:re,isUnsafe:!0},isAutoDetected:!0})}r(p,ae);const ne=await b(ae.entries(),A,a,k,I,U);if(n&&C)try{const re=await h(`${se}\\${x?"wsl":"bash"}.exe`,A);for(const Y of re)(!p||!(Y.profileName in p))&&ne.push(Y)}catch{y&&(I?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return ne}async function b(n,a,k,I=process.env,C,p){const A=[];for(const[L,U]of n)A.push(g(L,U,a,k,I,C,p));return(await Promise.all(A)).filter(L=>!!L)}async function g(n,a,k,I,C=process.env,p,A){if(a===null)return;let L,U,q;if("source"in a&&!("path"in a)){const ne=w?.get(a.source);if(!ne)return;L=ne.paths,U=a.args||ne.args,a.icon?q=$(a.icon):ne.icon&&(q=ne.icon)}else L=Array.isArray(a.path)?a.path:[a.path],U=M.$i||Array.isArray(a.args)?a.args:void 0,q=$(a.icon);let se;if(A){const ne=L.map(Y=>typeof Y=="string"?Y:Y.path),re=await A(ne);se=new Array(L.length);for(let Y=0;Y<L.length;Y++)typeof L[Y]=="string"?se[Y]=re[Y]:se[Y]={path:re[Y],isUnsafe:!0}}else se=L.slice();let x;if(a.requiresPath){let ne;if((0,D.$jf)(a.requiresPath)?ne=a.requiresPath:(ne=a.requiresPath.path,a.requiresPath.isUnsafe&&(x=ne)),!await I.existsFile(ne))return}const ae=await i(n,k,se,I,C,U,a.env,a.overrideName,a.isAutoDetected,x);if(!ae){p?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=a.isAutoDetected,ae.icon=q,ae.color=a.color,ae}function $(n){return typeof n=="string"?{id:n}:n}async function o(n){if(w&&!n)return;const[a,k]=await Promise.all([d(),n||P()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:k,icon:R.$Pj.terminalPowershell})}async function d(){const n=new Set,a=await(0,c.$ir)("git.exe");if(a){const C=(0,m.dirname)(a);n.add((0,m.resolve)(C,"../.."))}function k(C,p){p&&C.add(p)}k(n,process.env.ProgramW6432),k(n,process.env.ProgramFiles),k(n,process.env["ProgramFiles(X86)"]),k(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const C of n)I.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function P(){const n=[];for await(const a of(0,u.$ql)())n.push(a.exePath);return n}async function h(n,a){const k=[],I=await new Promise((A,L)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,q)=>{if(U)return L("Problem occurred when getting wsl distros");A(q)})});if(!I)return[];const C=new RegExp(/[\r?\n]/),p=I.split(C).filter(A=>A.trim().length>0&&A!=="");for(const A of p){if(A===""||A.startsWith("docker-desktop"))continue;const L=`${A} (WSL)`,U={profileName:L,path:n,args:["-d",`${A}`],isDefault:L===a,icon:t(A),isAutoDetected:!1};k.push(U)}return k}function t(n){return n.includes("Ubuntu")?R.$Pj.terminalUbuntu:n.includes("Debian")?R.$Pj.terminalDebian:R.$Pj.terminalLinux}async function l(n,a,k,I,C,p,A,L){const U=new Map;if(k){const q=(await n.readFile("/etc/shells")).toString(),se=(p||q.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),x=new Map;for(const ae of se){let ne=(0,s.$ae)(ae),re=x.get(ne)||0;re++,re>1&&(ne=`${ne} (${re})`),x.set(ne,re),U.set(ne,{path:ae,isAutoDetected:!0})}}return r(I,U),await b(U.entries(),C,n,L,a,A)}function r(n,a){if(n)for(const[k,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?a.delete(k):(I.icon=I.icon||a.get(k)?.icon,a.set(k,I))}async function i(n,a,k,I,C,p,A,L,U,q){if(k.length===0)return Promise.resolve(void 0);const se=k.shift();if(se==="")return i(n,a,k,I,C,p,A,L,U);const x=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ne={profileName:n,path:ae,args:p,env:A,overrideName:L,isAutoDetected:U,isDefault:n===a,isUnsafePath:x,requiresUnsafePath:q};if((0,s.$ae)(ae)===ae){const Y=C.PATH?C.PATH.split(s.$ge):void 0,J=await(0,c.$ir)(ae,void 0,Y,void 0,I.existsFile);return J?(ne.path=J,ne.isFromPath=!0,ne):i(n,a,k,I,C,p)}return await I.existsFile((0,s.$7d)(ae))?ne:i(n,a,k,I,C,p,A,L,U)}}),define(te[263],ie([0,1,3,2,4,42,18,5,225,94,258,124,260,262,108,68]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;var g;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let $=class extends R.$kc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,P,h,t){super(),this.M=d,this.N=P,this.O=h,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$fd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$fd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$fd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$fd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$fd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$fd),this.onProcessData=this.D.event,this.F=this.B(new S.$fd),this.onProcessReady=this.F.event,this.G=this.B(new S.$fd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$fd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$fd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$fd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$fd),this.onProcessExit=this.L.event,(0,y.$$q)(),this.B(this.M),this.B((0,R.$ic)(()=>this.W())),this.j=this.B(new m.$4q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,c.$Ml)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),P=d.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(P.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(l=>{this.u.fire(l.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=M.ProxyChannel.toService(P.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.D.fire(l))),this.B(t.onProcessReady(l=>this.F.fire(l))),this.B(t.onProcessExit(l=>this.L.fire(l))),this.B(t.onDidChangeProperty(l=>this.J.fire(l))),this.B(t.onProcessReplay(l=>this.G.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.H.fire(l))),this.B(t.onDidRequestDetach(l=>this.I.fire(l))),this.B(new u.$3q(this.P,P.getChannel(w.TerminalIpcChannels.Logger))),this.a=d,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[d,t]}async createProcess(d,P,h,t,l,r,i,n,a,k,I){const C=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),p=await this.f.createProcess(d,P,h,t,l,r,i,n,a,k,I);return clearTimeout(C),p}updateTitle(d,P,h){return this.f.updateTitle(d,P,h)}updateIcon(d,P,h,t){return this.f.updateIcon(d,P,h,t)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,P){return this.f.detachFromProcess(d,P)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,P){return this.f.shutdown(d,P)}input(d,P){return this.f.input(d,P)}processBinary(d,P){return this.f.processBinary(d,P)}resize(d,P,h){return this.f.resize(d,P,h)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,P){return this.f.acknowledgeDataEvent(d,P)}setUnicodeVersion(d,P){return this.f.setUnicodeVersion(d,P)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new b.$bd,P=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...P]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,P){return this.f.installAutoReply(d,P)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,v.$wl)(d??s.OS,process.env)}async getProfiles(d,P,h,t=!1){const l=await this.S();return(0,f.$kr)(P,h,t,this.N,l,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,P){return this.f.getWslPath(d,P)}getRevivedPtyNewId(d,P){return this.f.getRevivedPtyNewId(d,P)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,P){return this.f.requestDetachInstance(d,P)}async acceptDetachInstanceReply(d,P){return this.f.acceptDetachInstanceReply(d,P)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,P,h){return this.f.reviveTerminalProcesses(d,P,h)}async refreshProperty(d,P){return this.f.refreshProperty(d,P)}async updateProperty(d,P,h){return this.f.updateProperty(d,P,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,P){return this.j.createRequest({workspaceId:d,originalText:P})}async acceptPtyHostResolvedVariables(d,P){this.j.acceptReply(d,P)}};e.$lr=$,e.$lr=$=Ee([ee(1,D.$8h),ee(2,E.$5i),ee(3,E.$6i)],$)}),define(te[78],ie([0,1,15,3,2,4,18,6,34]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=void 0;const c="#FFFFFF",m="#1E1E1E",w="#000000",y="#FFFFFF",f="theme",v="themeBackground",b="windowSplash";e.$o6b=(0,E.$Bh)("themeMainService");let g=class extends s.$kc{constructor(o,d){super(),this.b=o,this.c=d,this.a=this.B(new R.$fd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const o=this.getColorScheme();if(o.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return o.dark?w:y;let d=this.b.getItem(v,null);if(!d)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":d=c;break;case"hc-black":d=w;break;case"hc-light":d=y;break;default:d=m}return M.$j&&d.toUpperCase()===m&&(d="#171717"),d}saveWindowSplash(o,d){this.b.setItems([{key:f,data:d.baseTheme},{key:v,data:d.colorInfo.background},{key:b,data:d}]),typeof o=="number"&&this.f(o,d)}f(o,d){for(const P of S.BrowserWindow.getAllWindows())if(P.id===o){P.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$p6b=g,e.$p6b=g=Ee([ee(0,u.$jN),ee(1,D.$8h)],g)}),define(te[125],ie([0,1,3,18,6,5]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProvidedOnAutoForward=e.$2u=e.TunnelPrivacyId=e.TunnelProtocol=e.$1u=e.$Zu=void 0,e.$Zu=(0,s.$Bh)("tunnelService"),e.$1u=(0,s.$Bh)("sharedTunnelsService");var D;(function(g){g.Http="http",g.Https="https"})(D||(e.TunnelProtocol=D={}));var E;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(E||(e.TunnelPrivacyId=E={}));function u(g){return!!g.forwardPort}e.$2u=u;var c;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function m(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if($)return{address:$[1],port:+$[2]}}e.$3u=m,e.$4u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(g){return e.$4u.indexOf(g)>=0}e.$5u=w,e.$6u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(g){return e.$6u.indexOf(g)>=0}e.$7u=y;function f(g,$,o,d){if(o===1)return!1;if(o===2&&y($)){const P=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(P?.length===4&&parseInt(P[1])>=18)return!1}return g<1024}e.$8u=f;class v{constructor($,o,d){this.remoteAddress=$,this.localAddress=o,this.b=d,this.a=new S.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$9u=v;let b=class{constructor($,o){this.j=$,this.k=o,this.a=new S.$fd,this.onTunnelOpened=this.a.event,this.b=new S.$fd,this.onTunnelClosed=this.b.event,this.c=new S.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],o=Array.from(this.e.values());for(const d of o){const P=Array.from(d.values());for(const h of P){const t=await h.value;t&&typeof t!="string"&&$.push(t)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:o}of $.values())await o.then(d=>typeof d!="string"?d?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,o,d,P,h){this.p($,o,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:o,localAddress:d,privacy:P,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,o){(y($)||w($))&&($=e.$4u[0]);const d=this.r($,o);if(d)return++d.refcount,d.value}openTunnel($,o,d,P,h,t=!1,l,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${d} on local port ${h}.`);const i=this.f??$;if(!i)return;if(o||(o="localhost"),P||(P=this.l),this.f&&this.i.has(d)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,o,d,P,h,t,l,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(o,d),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(o,d);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(a);return(a.tunnelRemoteHost!==o||a.tunnelRemotePort!==d)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&a.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const o=this.e.get($.tunnelRemoteHost);if(o){const d=o.get($.tunnelRemotePort);d&&(d.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,d))}}}}async o($,o,d){if(d.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${o}.`);const P=d.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(o),P}}async closeTunnel($,o){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${o} `);const d=this.e.get($);if(d&&d.has(o)){const P=d.get(o);P.refcount=0,await this.o($,o,P)}}p($,o,d){this.e.has($)||this.e.set($,new Map),this.e.get($).set(o,{refcount:1,value:d})}async q($,o){const d=this.e.get($);if(d){const P=d.get(o),h=P?await P.value:void 0;(!h||typeof h=="string")&&d.delete(o),d.size===0&&this.e.delete($)}}r($,o){const d=[$];w($)?(d.push(...e.$4u),d.push(...e.$6u)):y($)&&d.push(...e.$6u);const P=d.map(h=>this.e.get(h));for(const h of P){const t=h?.get(o);if(t)return t}}canTunnel($){return!!m($)}t($,o,d,P,h,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${d} on local port ${P}.`);const r=d;this.i.add(r);const i=P===void 0?d:P,n={elevationRequired:h?this.isPortPrivileged(i):!1},a={remoteAddress:{host:o,port:d},localAddressPort:P,privacy:t,public:t?t!==E.Private:void 0,protocol:l},k=$.forwardPort(a,n);return k?(this.p(o,d,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),k}};e.$0u=b,e.$0u=b=Ee([ee(0,M.$5i),ee(1,R.$8h)],b)}),define(te[48],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZT=e.$YT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$YT={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,E)=>({type:"idle",updateType:D,error:E}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$ZT=(0,S.$Bh)("updateService")}),define(te[264],ie([0,1,4,186,57,43]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$8m.as(s.$an.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[265],ie([0,1,3,48]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0;class s{constructor(E){this.a=E}listen(E,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${u}`)}}e.$T6b=s;class M{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new S.$fd,this.onStateChange=this.a.event,this.b=R.$YT.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$U6b=M}),define(te[40],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,S.$Bh)("IUriIdentityService")}),define(te[266],ie([0,1,40,205,16,19,139,3,2]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class c{static{this._clock=0}constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(y){this.g=y,this.c=new u.$jc,this.f=2**16;const f=new Map,v=b=>{let g=f.get(b.scheme);return g===void 0&&(g=y.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,g)),g};this.c.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new M.$0f(v),this.d=new D.$or((b,g)=>this.extUri.compare(b,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$jg)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,b)=>v[1].time<b[1].time?1:v[1].time>b[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$pr=m,e.$pr=m=Ee([ee(0,s.$6j)],m),(0,R.$mr)(S.$Ck,m,1)}),define(te[126],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NT=void 0,e.$NT=(0,S.$Bh)("urlService")}),define(te[267],ie([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=e.$26b=void 0;class R{constructor(E){this.a=E}listen(E,u){throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"handleURL":return this.a.handleURL(S.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${u}`)}}e.$26b=R;class s{constructor(E){this.a=E}handleURL(E,u){return this.a.call("handleURL",[E.toJSON(),u])}}e.$36b=s;class M{constructor(E,u){this.a=E,this.b=u}async routeCall(E,u,c,m){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(c)&&c.length>0){const w=S.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const f=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,w.toString(!0));const v=new RegExp(`window:${f}`),b=E.connections.find(g=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",g.ctx),v.test(g.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,u,c,m)}routeEvent(E,u){throw new Error(`Event not found: ${u}`)}}e.$46b=M}),define(te[268],ie([0,1,8,2,7,24]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PT=e.$OT=void 0;class D extends R.$kc{constructor(){super(...arguments),this.a=new Set}open(c,m){const w=[...this.a.values()];return(0,S.$Kg)(w.map(y=>()=>y.handleURL(c,m)),void 0,!1).then(y=>y||!1)}registerHandler(c){return this.a.add(c),(0,R.$ic)(()=>this.a.delete(c))}}e.$OT=D;let E=class extends D{constructor(c){super(),this.b=c}create(c){let{authority:m,path:w,query:y,fragment:f}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:m,path:w,query:y,fragment:f})}};e.$PT=E,e.$PT=E=Ee([ee(0,M.$kj)],E)}),define(te[269],ie([0,1,15,8,3,2,4,7]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;class u extends M.$kc{constructor(m,w,y,f,v,b){if(super(),this.c=w,this.f=b,this.a=[],this.b=0,m&&(b.trace("ElectronURLListener initialUrisToHandle:",m.map(o=>o.originalUrl)),this.a=m),D.$i){const o=f.isBuilt?[]:[`"${f.appRoot}"`];o.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,o)}const g=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(o,d)=>({event:o,url:d})),({event:o,url:d})=>(o.preventDefault(),d));this.B(g(o=>{const d=this.g(o);d&&this.c.open(d,{originalUrl:o})})),y.getWindows().filter(o=>o.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return E.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const w of this.a)await this.c.open(w.uri,{originalUrl:w.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),m.push(w));m.length!==0&&(this.a=m,(0,R.$Ig)(()=>this.h(),500,this.q))}}e.$56b=u}),define(te[270],ie([0,1,3,2,16,56,33]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;class E extends R.$kc{constructor(c,m,w,y,f,v){super(),this.f=c,this.g=m,this.h=w,this.j=y,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$fd),this.onDidChangeFile=this.a.event,this.b=M.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Ai(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,w,y,f){return this.g.read(c,m,w,y,f)}write(c,m,w,y,f){return this.g.write(c,m,w,y,f)}watch(c,m){this.b.set(c,c);const w=this.g.watch(this.t(c),m);return(0,R.$ic)(()=>{this.b.delete(c),w.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,w){return this.g.rename(this.t(c),this.t(m),w)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,w){return this.g.readFileStream(this.t(c),m,w)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,w){return this.g.writeFile(this.t(c),m,w)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,w){if((0,s.$9j)(this.g))return this.g.copy(this.t(c),this.t(m),w);throw new Error("copy not supported")}cloneFile(c,m){if((0,s.$0j)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const w of c){if(w.resource.scheme!==this.f)continue;const y=this.u(w.resource);this.b.findSubstr(y)&&m.push({resource:y,type:w.type})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$D7b=E}),define(te[271],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0,e.$l7b="utilityProcessWorker"}),define(te[272],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0,e.$66b=(0,S.$Bh)("webviewManagerService")}),define(te[273],ie([0,1,15,2,13,7]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0;class D extends R.$kc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,u)}b(u,c){try{const m=M.URI.parse(u.url),w=D.a.get(m.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,f=s.$2f.asFileUri(y);return c({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$76b=D}),define(te[79],ie([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=void 0,e.$RC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(m){return!!m.workspaceUri}e.$SC=R;function s(m){return!!m.folderUri}e.$TC=s;function M(m){return!!m.fileUri}e.$UC=M;function D(m){const w=E(m),y=m.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||S.$j&&S.$m?"classic":y}e.$VC=D;function E(m){if(S.$o)return"custom";const w=m.getValue("window");if(w){if(S.$j&&w.nativeTabs===!0||S.$j&&w.nativeFullScreen===!1)return"native";const v=w.titleBarStyle;if(v==="native"||v==="custom")return v}return S.$k?"native":"custom"}e.$WC=E;function u(m){return!(!S.$i||S.$o||E(m)==="native")}e.$XC=u;function c(m=0){return Math.pow(1.2,m)}e.$YC=c}),define(te[127],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$C5b=e.UnloadReason=e.LoadReason=void 0;var S;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(E=1){return{width:1024,height:768,mode:E}};e.$C5b=s;var M;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[30],ie([0,1,6]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$R5b=void 0,e.$R5b=(0,S.$Bh)("windowsMainService");var R;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(R||(e.OpenContext=R={}))}),define(te[274],ie([0,1,15,23,4,7,21,18,62,6,5,126,30]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.ID=void 0,e.ID="launchMainService",e.$z6b=(0,c.$Bh)(e.ID);let f=class{constructor(b,g,$,o){this.a=b,this.b=g,this.c=$,this.d=o}async start(b,g){this.a.trace("Received data from other instance: ",b,g),s.$j&&S.app.focus({steal:!0});const $=this.e(b);if($.length){let o=Promise.resolve();if(this.b.getWindowCount()===0){const d=(0,R.$Mb)(await this.b.openEmptyWindow({context:4}));d&&(o=d.ready())}o.then(()=>{for(const{uri:d,originalUrl:P}of $)this.c.open(d,{originalUrl:P})})}else return this.f(b,g)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,R.$Fb)(b._urls.map(g=>{try{return{uri:M.URI.parse(g),originalUrl:g}}catch{return null}})):[]}async f(b,g){const $=(0,u.$Gl)(g)?0:4;let o=[];const d=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,P=b.remote||void 0,h={context:$,cli:b,userEnv:g,waitMarkerFileURI:d,remoteAuthority:P,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,h);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||h.forceProfile||h.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)o=await this.b.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,h),o=[l]):o=await this.b.open({...h,forceEmpty:!0})}}else o=await this.b.open({...h,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(d&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,D.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$A6b=f,e.$A6b=f=Ee([ee(0,m.$5i),ee(1,y.$R5b),ee(2,w.$NT),ee(3,E.$8h)],f)}),define(te[275],ie([0,1,15,3,2,273,30]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;let E=class extends s.$kc{constructor(c){super(),this.b=c,this.a=this.B(new R.$fd),this.onFoundInFrame=this.a.event,this.B(new M.$76b)}async setIgnoreMenuShortcuts(c,m){let w;if(typeof c.windowId=="number"){const{windowId:y}=c,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);w=f.win.webContents}else{const{webContentsId:y}=c;if(w=S.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,w,y){const v=this.c(c,m);if(typeof v.findInFrame=="function"){v.findInFrame(w,{findNext:y.findNext,forward:y.forward});const b=(g,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",b))};v.on("found-in-frame",b)}}async stopFindInFrame(c,m,w){const f=this.c(c,m);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(c,m){const w=this.b.getWindowById(c.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${c}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===m);if(!y)throw new Error(`Unknown frame: ${m}`);return y}};e.$86b=E,e.$86b=E=Ee([ee(0,D.$R5b)],E)}),define(te[276],ie([0,1,8,3,2]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;class M extends s.$kc{constructor({onDidOpenWindow:E,onDidFocusWindow:u,getActiveWindowId:c}){super(),this.a=this.B(new s.$jc),R.Event.latch(R.Event.any(E,u))(this.f,this,this.a),this.b=(0,S.$ug)(()=>c()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$b7b=M}),define(te[29],ie([0,1,190,9,56,19,7,6,13]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,E.$Bh)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Lh=c;function m(i){return typeof i?.id=="string"&&!c(i)&&!y(i)}e.$Mh=m,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$ae)(i)}:n?e.$Nh:e.$Oh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Ph=w;function y(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$Qh=y;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$Rh=f;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Sh=b;function g(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Th=g;class ${constructor(n,a,k,I,C){this.h=n,this.j=k,this.k=I,this.l=C,this.c=s.$Hh.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Hh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=$;class o{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=o;function d(i){return new o({uri:i,index:0,name:(0,M.$eg)(i)},{uri:i.toString()})}e.$Wh=d,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,S.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function P(i,n){return M.$_f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$2h=P;function h(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$3h=h,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$4h}e.$5h=t;function l(i,n){return!P(i,n)&&!h(i)}e.$6h=l;function r(i){return(typeof i=="string"?(0,R.$be)(i):(0,M.$gg)(i))===e.$Yh}e.$7h=r}),define(te[59],ie([0,1,15,8,55,46,2,85,4,21,165,91,6,5,24,29]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.$45b=void 0,e.$45b=(0,y.$Bh)("dialogMainService");let g=class{constructor(o,d){this.d=o,this.e=d,this.a=new Map,this.b=new Map,this.c=new R.$Ng}pickFileFolder(o,d){return this.f({...o,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},d)}pickFolder(o,d){return this.f({...o,pickFolders:!0,title:(0,m.localize)(1,null)},d)}pickFile(o,d){return this.f({...o,pickFiles:!0,title:(0,m.localize)(2,null)},d)}pickWorkspace(o,d){const P=(0,m.localize)(3,null),h=(0,M.$ov)((0,m.localize)(4,null)),t=b.$Zh;return this.f({...o,pickFiles:!0,title:P,filters:t,buttonLabel:h},d)}async f(o,d){const P={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters,defaultPath:o.defaultPath};(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(P.properties=void 0,o.pickFiles&&o.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$j&&P.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(P,(d||S.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}g(o){if(o){let d=this.b.get(o.id);return d||(d=new R.$Ng,this.b.set(o.id,d)),d}else return this.c}showMessageBox(o,d){return this.g(d).queue(async()=>{const{options:P,buttonIndeces:h}=(0,w.$vv)(o,this.e);let t;return d?t=await S.dialog.showMessageBox(d,P):t=await S.dialog.showMessageBox(P),{response:h[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(o,d){const P=this.j(o,d);if(!P)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(d).queue(async()=>{let h;return d?h=await S.dialog.showSaveDialog(d,o):h=await S.dialog.showSaveDialog(o),h.filePath=this.h(h.filePath),h})}finally{(0,D.$fc)(P)}}h(o){return o&&u.$j&&(o=(0,E.$hl)(o)),o}i(o){return o.map(d=>this.h(d))}async showOpenDialog(o,d){o.defaultPath&&(await c.Promises.exists(o.defaultPath)||(o.defaultPath=void 0));const P=this.j(o,d);if(!P)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(d).queue(async()=>{let h;return d?h=await S.dialog.showOpenDialog(d,o):h=await S.dialog.showOpenDialog(o),h.filePaths=this.i(h.filePaths),h})}finally{(0,D.$fc)(P)}}j(o,d){if(!d)return D.$kc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",o);let P=this.a.get(d.id);P||(P=new Set,this.a.set(d.id,P));const h=(0,s.$pi)(o);if(!P.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",o),P.add(h),(0,D.$ic)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",o),P?.delete(h),P?.size===0&&this.a.delete(d.id)})}};e.$55b=g,e.$55b=g=Ee([ee(0,f.$5i),ee(1,v.$kj)],g)}),define(te[277],ie([0,1,3,2,73,29]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=void 0;class D extends R.$kc{static{this.a=100}constructor(u,c){super(),this.f=u,this.g=c,this.b=this.B(new S.$fd),this.c=new Map,this.h(c.applicationStorage,this.b)}h(u,c){this.B(S.Event.debounce(u.onDidChangeStorage,(m,w)=>(m?m.push(w):m=[w],m),D.a)(m=>{m.length&&c.fire(this.j(m,u))}))}j(u,c){const m=new Map,w=new Set;return u.forEach(y=>{const f=c.get(y.key);typeof f=="string"?m.set(y.key,f):w.add(y.key)}),{changed:Array.from(m.entries()),deleted:Array.from(w.values())}}listen(u,c,m){switch(c){case"onDidChangeStorage":{const w=m.profile?(0,s.$$g)(m.profile):void 0;if(!w)return this.b.event;let y=this.c.get(w.id);return y||(y=this.B(new S.$fd),this.h(this.g.profileStorage(w),y),this.c.set(w.id,y)),y.event}}throw new Error(`Event not found: ${c}`)}async call(u,c,m){const w=m.profile?(0,s.$$g)(m.profile):void 0,y=(0,M.$Rh)(m.workspace),f=await this.m(w,y);switch(c){case"getItems":return Array.from(f.items.entries());case"updateItems":{const v=m;if(v.insert)for(const[b,g]of v.insert)f.set(b,g);v.delete?.forEach(b=>f.delete(b));break}case"optimize":return f.optimize();case"isUsed":{const v=m.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${c}`)}}async m(u,c){let m;c?m=this.g.workspaceStorage(c):u?m=this.g.profileStorage(u):m=this.g.applicationStorage;try{await m.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":u?"profile":"application"} storage due to ${w}`)}return m}}e.$Q6b=D}),define(te[41],ie([0,1,55,3,2,19,7,187,36,16,6,5,29,33,40,8,31,26,12]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function P(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Dk=P,e.$Ek=(0,m.$Bh)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Fk=h;function t(i,n,a,k,I,C){return{id:i,name:n,location:a,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:C&&I?.useDefaultFlags?.globalState?C.globalStorageHome:(0,M.$ig)(a,"globalStorage"),settingsResource:C&&I?.useDefaultFlags?.settings?C.settingsResource:(0,M.$ig)(a,"settings.json"),keybindingsResource:C&&I?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,M.$ig)(a,"keybindings.json"),tasksResource:C&&I?.useDefaultFlags?.tasks?C.tasksResource:(0,M.$ig)(a,"tasks.json"),snippetsHome:C&&I?.useDefaultFlags?.snippets?C.snippetsHome:(0,M.$ig)(a,"snippets"),extensionsResource:C&&I?.useDefaultFlags?.extensions?C.extensionsResource:(0,M.$ig)(a,"extensions.json"),cacheHome:(0,M.$ig)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Gk=t;let l=class extends s.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,k,I){super(),this.t=n,this.u=a,this.w=k,this.y=I,this.f=!0,this.h=this.B(new R.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zi,emptyWindows:new Map},this.profilesHome=(0,M.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,o.$jf)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}a.push(t((0,M.$fg)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},n))}}catch(C){this.y.error(C)}const k=new f.$zi,I=new Map;if(a.length)try{const C=this.Q();if(C.workspaces)for(const[p,A]of Object.entries(C.workspaces)){const L=D.URI.parse(p),U=a.find(q=>q.id===A);U&&k.set(L,U)}if(C.emptyWindows)for(const[p,A]of Object.entries(C.emptyWindows)){const L=a.find(U=>U.id===A);L&&I.set(p,L)}}catch(C){this.y.error(C)}this.z={profiles:a,workspaces:k,emptyWindows:I}}return this.z}D(){const n=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",k=new RegExp(`${(0,$.$qe)(a)}\\s(\\d+)`);let I=0;for(const p of this.profiles){const A=k.exec(p.name),L=A?parseInt(A[1]):0;I=L>I?L:I}const C=`${a} ${I+1}`;return this.createProfile((0,S.$pi)((0,g.$4f)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,a,k){return this.createProfile((0,S.$pi)((0,g.$4f)()).toString(16),n,a,k)}async createProfile(n,a,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(n,a,k);return I&&await this.setProfileForWorkspace(I,C),C}async F(n,a,k){if(!(0,o.$jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(a);return I||(I=(async()=>{try{const C=this.profiles.find(L=>L.name===a||L.id===n);if(C)return C;const p=t(n,a,(0,M.$ig)(this.profilesHome,n),this.g,k,this.defaultProfile);await this.u.createFolder(p.location);const A=[];return this.j.fire({profile:p,join(L){A.push(L)}}),await b.Promises.settled(A),this.I([p],[],[]),p}finally{this.r.delete(a)}})(),this.r.set(a,I)),I}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===n.id);if(!k)throw new Error(`Profile '${n.name}' does not exist`);return k=t(k.id,a.name??k.name,k.location,this.g,{shortName:a.shortName??k.shortName,icon:a.icon===null?void 0:a.icon??k.icon,transient:a.transient??k.isTransient,useDefaultFlags:a.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(I=>I.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const k=[];this.m.fire({profile:a,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(I){(0,c.$jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,k)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,y.$Lh)(n)?n.uri:(0,y.$Qh)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,k){const I=[...this.profiles,...n],C=[];this.s.profiles=[];for(let p of I)p.isDefault||a.some(A=>p.id===A.id)||(p=k.find(A=>p.id===A.id)??p,p.isTransient?this.s.profiles.push(p):C.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(C),this.z=void 0,this.J(n,a,k)}J(n,a,k){this.h.fire({added:n,removed:a,updated:k,all:this.profiles})}L(n,a,k){k=a?.isTransient?!0:k,k||this.L(n,void 0,!0);const I=this.G(n),C=k?this.s:this.C;D.URI.isUri(I)?(C.workspaces.delete(I),a&&C.workspaces.set(I,a)):(C.emptyWindows.delete(I),a&&C.emptyWindows.set(I,a)),k||this.M()}M(){const n={};for(const[k,I]of this.C.workspaces.entries())n[k.toString()]=I.id;const a={};for(const[k,I]of this.C.emptyWindows.entries())a[k.toString()]=I.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},k=this.D();if(n.workspaces)for(const[C,p]of Object.entries(n.workspaces)){const A=D.URI.parse(p);a[C]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}const I={};if(n.emptyWindows)for(const[C,p]of Object.entries(n.emptyWindows)){const A=D.URI.parse(p);I[C]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:I}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Hk=l,e.$Hk=l=Ee([ee(0,u.$Ih),ee(1,c.$6j),ee(2,v.$Ck),ee(3,w.$5i)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ik=r}),define(te[80],ie([0,1,8,17,2,3,33,7,116,122,16,6,5,41,40,12,14,25]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var o;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(o||(e.ExtensionsProfileScanningErrorCode=o={}));class d extends Error{constructor(r,i){super(r),this.code=i}}e.$jp=d,e.$kp=(0,w.$Bh)("IExtensionsProfileScannerService");let P=class extends s.$kc{constructor(r,i,n,a,k,I){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=k,this.t=I,this.b=this.B(new M.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zi}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,k=>{const I=[];for(const C of k)r.some(([p])=>(0,c.$po)(p.identifier,C.identifier)&&p.manifest.version!==C.version)?n.push(C):I.push(C);for(const[C,p]of r){const A=I.findIndex(U=>(0,c.$po)(U.identifier,C.identifier)&&U.version===C.manifest.version),L={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p};A===-1?(a.push(L),I.push(L)):I.splice(A,1,L)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(k){throw a.length&&this.c.fire({extensions:a,error:k,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:k,profileLocation:i}),k}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const k=[];for(const I of a){const C=r.find(([p])=>(0,c.$po)(p.identifier,I.identifier)&&p.manifest.version===I.version);C&&(I.metadata={...I.metadata,...C[1]},n.push(I)),k.push(I)}return k}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const k=[];for(const I of a)(0,c.$po)(I.identifier,r.identifier)?n.push(I):k.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],k;try{const I=await this.m.readFile(r);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,m.$jk)(I)!==1)throw I;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&n?.bailOutWhenFileNotFound)throw new d((0,g.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(k){Array.isArray(k)||this.w(r);let I=!1;for(const C of k){h(C)||this.w(r);let p;if((0,b.$jf)(C.relativeLocation)&&C.relativeLocation)p=this.z(C.relativeLocation);else if((0,b.$jf)(C.location))p=this.z(C.location),I=!0,C.relativeLocation=C.location,C.location=p.toJSON();else{p=E.URI.revive(C.location);const A=this.y(p);A&&(I=!0,C.relativeLocation=A)}a.push({identifier:C.identifier,location:p,version:C.version,metadata:C.metadata})}I&&await this.m.writeFile(r,R.$Fd.fromString(JSON.stringify(k)))}if(i){a=i(a);const I=a.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(r,R.$Fd.fromString(JSON.stringify(I)))}return a})}w(r){const i=new d(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(k){if((0,m.$jk)(k)===1)return;throw k}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const k=JSON.parse(n);Array.isArray(k)&&k.every(I=>h(I))?a=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$Fd.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,m.$jk)(k)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(r)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$Ng,this.h.set(r,i)),i}};e.$lp=P,e.$lp=P=Ee([ee(1,m.$6j),ee(2,f.$Ek),ee(3,v.$Ck),ee(4,$.$9k),ee(5,y.$5i)],P);function h(l){return(0,b.$lf)(l)&&(0,u.$Yn)(l.identifier)&&(t(l.location)||(0,b.$jf)(l.location)&&l.location)&&((0,b.$qf)(l.relativeLocation)||(0,b.$jf)(l.relativeLocation))&&l.version&&(0,b.$jf)(l.version)}function t(l){return l?(0,b.$jf)(l.path)&&(0,b.$jf)(l.scheme):!1}}),define(te[128],ie([0,1,23,8,37,17,14,44,151,2,13,9,4,19,203,69,12,7,170,36,122,119,202,16,6,5,24,3,73,80,41,40,201]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var L;(function(re){function Y(J,H){if(J===H)return!0;const F=Object.keys(J),N=new Set;for(const G of Object.keys(H))N.add(G);if(F.length!==N.size)return!1;for(const G of F){if(J[G]!==H[G])return!1;N.delete(G)}return N.size===0}re.equals=Y})(L||(e.Translations=L={})),e.$op=(0,r.$Bh)("IExtensionsScannerService");let U=class extends c.$kc{constructor(Y,J,H,F,N,G,Z,_,oe,T,O,j){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=J,this.r=H,this.s=F,this.t=N,this.u=G,this.w=Z,this.y=_,this.z=oe,this.C=T,this.D=O,this.F=j,this.g=this.B(new a.$fd),this.onDidChangeCache=this.g.event,this.h=(0,f.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,P.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(Y,J,H){const[F,N]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(J)]),G=H?await this.scanExtensionsUnderDevelopment(Y,[...F,...N]):[];return this.L(F,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const J=[];J.push(this.M(!!Y.useCache,Y.language)),J.push(this.N(Y.language,!!Y.checkControlFile));const[H,F]=await Promise.all(J);return this.J([...H,...F],0,Y,!1)}async scanUserExtensions(Y){const J=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const H=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(J,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,H),N=Y.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(F)}catch(Z){if(Z instanceof I.$jp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(F);else throw Z}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===m.Schemas.file).map(async F=>{const N=await this.P(F,!1,1,!0,Y.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(Z=>(Z.type=J.find(_=>(0,P.$po)(_.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,N)))}))).flat();return this.J(H,"development",Y,!0)}return[]}async scanExistingExtension(Y,J,H){const F=await this.P(Y,!1,J,!0,H.language,!0,void 0),N=await this.n.scanExtension(F);return!N||!H.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Y,J,H){const F=await this.P(Y,!1,J,!0,H.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(F);return this.J(N,J,H,!0)}async scanMetadata(Y){const J=(0,f.$ig)(Y,"package.json"),H=(await this.w.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Y,J){const H=(0,f.$ig)(Y,"package.json"),F=(await this.w.readFile(H)).value.toString(),N=JSON.parse(F);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,N.__metadata={...N.__metadata,...J},await this.w.writeFile((0,f.$ig)(Y,"package.json"),M.$Fd.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof I.$jp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$Fd.fromString(JSON.stringify([])))}catch(J){(0,l.$jk)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,J,H,F){return H.includeAllVersions||(Y=this.L(J===0?Y:void 0,J===1?Y:void 0,J==="development"?Y:void 0,await this.getTargetPlatform(),F)),H.includeInvalid||(Y=Y.filter(N=>N.isValid)),Y.sort((N,G)=>{const Z=w.$ae(N.location.fsPath),_=w.$ae(G.location.fsPath);return Z<_?-1:Z>_?1:0})}L(Y,J,H,F,N){const G=(_,oe,T)=>{if(_.isValid&&!oe.isValid)return!1;if(_.isValid===oe.isValid){if(N&&v.gt(_.manifest.version,oe.manifest.version))return this.y.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(v.eq(_.manifest.version,oe.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${oe.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===F)return this.y.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return T?this.y.warn(`Overwriting user extension ${_.location.path} with ${oe.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${oe.location.path}.`),!0},Z=new h.$Xl;return Y?.forEach(_=>{const oe=Z.get(_.identifier.id);(!oe||G(oe,_,!1))&&Z.set(_.identifier.id,_)}),J?.forEach(_=>{const oe=Z.get(_.identifier.id);if(!oe&&Y&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!oe||G(oe,_,!1))&&Z.set(_.identifier.id,_)}),H?.forEach(_=>{const oe=Z.get(_.identifier.id);(!oe||G(oe,_,!0))&&Z.set(_.identifier.id,_),Z.set(_.identifier.id,_)}),[...Z.values()]}async M(Y,J){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),N=await(Y&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",N.length),N}async N(Y,J){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const F=J?await this.O():{},N=[],G=$.URI.file(w.$7d(w.$9d(m.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of H){const oe=F[_.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":N.push((0,f.$ig)(G,_.name));break;default:N.push($.URI.file(oe));break}}const Z=await Promise.all(N.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,Y,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,S.$Fb)(Z)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,J,H,F,N,G,Z){const _=await this.f(N??y.$v),oe=await this.Q(Y),T=J&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=T?await this.Q(T):void 0;return new q(Y,oe,T,O,J,Z,H,F,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,_)}async Q(Y){try{const J=await this.w.stat(Y);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$pp=U,e.$pp=U=Ee([ee(4,C.$Ek),ee(5,I.$kp),ee(6,l.$6j),ee(7,i.$5i),ee(8,d.$Ih),ee(9,n.$kj),ee(10,p.$Ck),ee(11,r.$Ah)],U);class q{constructor(Y,J,H,F,N,G,Z,_,oe,T,O,j,z,W,B){this.location=Y,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=F,this.profile=N,this.profileScanOptions=G,this.type=Z,this.excludeObsolete=_,this.validate=oe,this.productVersion=T,this.productDate=O,this.productCommit=j,this.devMode=z,this.language=W,this.translations=B}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,J){return(0,f.$bg)(Y.location,J.location)&&Y.mtime===J.mtime&&(0,f.$bg)(Y.applicationExtensionslocation,J.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&Y.profile===J.profile&&s.$Zm(Y.profileScanOptions,J.profileScanOptions)&&Y.type===J.type&&Y.excludeObsolete===J.excludeObsolete&&Y.validate===J.validate&&Y.productVersion===J.productVersion&&Y.productDate===J.productDate&&Y.productCommit===J.productCommit&&Y.devMode===J.devMode&&Y.language===J.language&&L.equals(Y.translations,J.translations)}}e.$qp=q;let se=class extends c.$kc{constructor(Y,J,H,F,N){super(),this.f=Y,this.g=J,this.h=H,this.j=F,this.m=N}async scanExtensions(Y){const J=Y.profile?await this.r(Y):await this.n(Y);let H={};if(Y.excludeObsolete&&Y.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(F)}catch{}return(0,g.$wf)(H)?J:J.filter(F=>!H[P.$qo.create(F).toString()])}async n(Y){const J=await this.j.resolve(Y.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async F=>{if(!F.isDirectory||Y.type===1&&(0,f.$fg)(F.resource).indexOf(".")===0)return null;const N=new q(F.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(N)}));return(0,S.$Fb)(H).sort((F,N)=>F.location.path<N.location.path?-1:1)}async r(Y){let J=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){J=J.filter(F=>!F.metadata?.isApplicationScoped);const H=await this.s(Y.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,Y);J.push(...H)}return J}async s(Y,J,H){const F=await this.g.scanProfileExtensions(Y,H.profileScanOptions);if(!F.length)return[];const N=await Promise.all(F.map(async G=>{if(J(G)){const Z=new q(G.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(Z,G.metadata)}return null}));return(0,S.$Fb)(N)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,f.$ig)(Y.location,"package.json"))){const J=await this.scanExtension(Y);return J?[J]:[]}else return await this.scanExtensions(Y)}catch(J){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,D.$8)(J)),[]}}async scanExtension(Y,J){try{let H=await this.scanExtensionManifest(Y.location);if(H){H.publisher||(H.publisher=h.$Rl),J=J??H.__metadata,delete H.__metadata;const F=(0,P.$uo)(H.publisher,H.name),N=J?.id?{id:F,uuid:J.id}:{id:F},G=J?.isSystem?0:Y.type,Z=G===0||!!J?.isBuiltin;H=await this.t(Y.location,H,q.createNlsConfiguration(Y));const _={type:G,identifier:N,manifest:H,location:Y.location,isBuiltin:Z,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return Y.validate?this.validate(_,Y):_}}catch(H){Y.type!==0&&this.m.error(H)}return null}validate(Y,J){let H=!0;const F=(0,t.$Fo)(J.productVersion,J.productDate,J.location,Y.manifest,Y.isBuiltin);for(const[N,G]of F)N===b.default.Error&&(H=!1,this.m.error(this.z(J.location,G)));return Y.isValid=H,Y.validations=F,Y}async scanExtensionManifest(Y){const J=(0,f.$ig)(Y,"package.json");let H;try{H=(await this.j.readFile(J)).value.toString()}catch(N){return(0,l.$jk)(N)!==1&&this.m.error(this.z(Y,(0,o.localize)(0,null,J.path,N.message))),null}let F;try{F=JSON.parse(H)}catch{const G=[];(0,E.$Lm)(H,G);for(const Z of G)this.m.error(this.z(Y,(0,o.localize)(1,null,J.path,Z.offset,Z.length,(0,u.$mp)(Z.error))));return null}return(0,E.$Um)(F)!=="object"?(this.m.error(this.z(Y,(0,o.localize)(2,null,J.path))),null):F}async t(Y,J,H){const F=await this.u(Y,J,H);if(F)try{const N=[],G=await this.w(F.default,N);if(N.length>0)return N.forEach(_=>{this.m.error(this.z(Y,(0,o.localize)(3,null,F.default?.path,(0,u.$mp)(_.error))))}),J;if((0,E.$Um)(F)!=="object")return this.m.error(this.z(Y,(0,o.localize)(4,null,F.default?.path))),J;const Z=F.values||Object.create(null);return(0,A.$np)(this.m,J,Z,G)}catch{}return J}async u(Y,J,H){const F=(0,f.$ig)(Y,"package.nls.json"),N=(oe,T)=>{T.forEach(O=>{this.m.error(this.z(Y,(0,o.localize)(5,null,oe?.path,(0,u.$mp)(O.error))))})},G=oe=>{this.m.error(this.z(Y,(0,o.localize)(6,null,oe?.path)))},Z=`${J.publisher}.${J.name}`,_=H.translations[Z];if(_)try{const oe=$.URI.file(_),T=(await this.j.readFile(oe)).value.toString(),O=[],j=(0,E.$Lm)(T,O);return O.length>0?(N(oe,O),{values:void 0,default:F}):(0,E.$Um)(j)!=="object"?(G(oe),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let T;try{T=await this.y(Y,H)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const O=(await this.j.readFile(T.localized)).value.toString(),j=[],z=(0,E.$Lm)(O,j);return j.length>0?(N(T.localized,j),{values:void 0,default:T.original}):(0,E.$Um)(z)!=="object"?(G(T.localized),{values:void 0,default:T.original}):{values:z,default:T.original}}catch{return{values:void 0,default:T.original}}}}async w(Y,J){if(Y)try{const H=(await this.j.readFile(Y)).value.toString();return(0,E.$Lm)(H,J)}catch{}}y(Y,J){return new Promise((H,F)=>{const N=G=>{const Z=(0,f.$ig)(Y,`package.nls.${G}.json`);this.j.exists(Z).then(_=>{_&&H({localized:Z,original:(0,f.$ig)(Y,"package.nls.json")});const oe=G.lastIndexOf("-");oe===-1?H({localized:(0,f.$ig)(Y,"package.nls.json"),original:null}):(G=G.substring(0,oe),N(G))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,f.$ig)(Y,"package.nls.json"),original:null});N(J.language)})}z(Y,J){return`[${Y.path}]: ${J}`}};se=Ee([ee(1,I.$kp),ee(2,p.$Ck),ee(3,l.$6j),ee(4,i.$5i)],se);let x=class extends se{constructor(Y,J,H,F,N,G,Z){super(J,F,N,G,Z),this.G=Y,this.H=H,this.D=this.B(new R.$Eg(3e3)),this.F=this.B(new a.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const J=this.M(Y),H=await this.I(J);if(this.C=Y,H&&H.input&&q.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),H.result.map(N=>(N.location=$.URI.revive(N.location),N));const F=await super.scanExtensions(Y);return await this.J(J,{input:Y,result:F}),F}async I(Y){try{const J=await this.j.readFile(Y),H=JSON.parse(J.value.toString());return{result:H.result,input:(0,k.$$g)(H.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",Y.path,(0,D.$8)(J))}return null}async J(Y,J){try{await this.j.writeFile(Y,M.$Fd.fromString(JSON.stringify(J)))}catch(H){this.m.debug("Error while writing the extension cache file:",Y.path,(0,D.$8)(H))}}async L(){if(!this.C)return;const Y=this.M(this.C),J=await this.I(Y);if(!J)return;const H=J.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Zm(F,H))try{this.m.info("Invalidating Cache",H,F),await this.j.del(Y),this.F.fire()}catch(N){this.m.error(N)}}M(Y){const J=this.N(Y);return this.h.extUri.joinPath(J.cacheHome,Y.type===0?h.$Ql:h.$Pl)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(Y.location,J.extensionsResource))??this.G:this.H.defaultProfile}};x=Ee([ee(2,C.$Ek),ee(3,I.$kp),ee(4,p.$Ck),ee(5,l.$6j),ee(6,i.$5i)],x);function ae(re,Y){const J=(0,P.$so)(re.manifest.publisher,re.manifest.name);return{id:J,identifier:new h.$Vl(J),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:Y,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$rp=ae;class ne extends U{constructor(Y,J,H,F,N,G,Z,_,oe,T,O,j){super(Y,J,(0,f.$ig)(H,".vscode-oss-dev","extensions","control.json"),F,N,G,Z,_,oe,T,O,j),this.R=(async()=>{if(y.$y)try{const z=await this.w.readFile($.URI.file(y.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.R}}e.$sp=ne}),define(te[278],ie([0,1,5,41,40,25,80,16,36,7]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=void 0;let m=class extends D.$lp{constructor(y,f,v,b,g,$){super(c.URI.file(y.extensionsPath),f,v,b,g,$)}};e.$qN=m,e.$qN=m=Ee([ee(0,u.$Jh),ee(1,E.$6j),ee(2,R.$Ek),ee(3,s.$Ck),ee(4,M.$9k),ee(5,S.$5i)],m)}),define(te[279],ie([0,1,7,36,80,128,16,6,5,24,40,41]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let y=class extends M.$sp{constructor(v,b,g,$,o,d,P,h){super(S.URI.file(o.builtinExtensionsPath),S.URI.file(o.extensionsPath),o.userHome,v.defaultProfile,v,b,g,$,o,d,P,h)}};e.$f7b=y,e.$f7b=y=Ee([ee(0,w.$Ek),ee(1,s.$kp),ee(2,D.$6j),ee(3,u.$5i),ee(4,R.$Jh),ee(5,c.$kj),ee(6,m.$Ck),ee(7,E.$Ah)],y)}),define(te[280],ie([0,1,15,2,13,9,4,56,7,31,38,36,5,41]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;let v=class extends R.$kc{constructor(g,$,o){super(),this.c=g,this.f=o,this.a=E.$Hh.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(g.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:g}=S.session;g.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,o)=>this.j($,o)),g.protocol.interceptFileProtocol(s.Schemas.file,($,o)=>this.h($,o)),this.B((0,R.$ic)(()=>{g.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(g){const $=(0,M.$7d)(g);return this.a.get($)?R.$kc.None:(this.a.set($,!0),(0,R.$ic)(()=>this.a.delete($)))}h(g,$){const o=u.URI.parse(g.url);return this.f.error(`Refused to load resource ${o.fsPath} from ${s.Schemas.file}: protocol (original URL: ${g.url})`),$({error:-3})}j(g,$){const o=this.m(g);let d;return this.c.crossOriginIsolated&&((0,M.$ae)(o)==="workbench.html"||(0,M.$ae)(o)==="workbench-dev.html"?d=s.COI.CoopAndCoep:d=s.COI.getHeadersFromQuery(g.url)),this.a.findSubstr(o)?$({path:o,headers:d}):this.b.has((0,M.$be)(o).toLowerCase())?$({path:o}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${o} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),$({error:-3}))}m(g){const $=u.URI.parse(g.url),o=s.$2f.uriToFileUri($);return(0,M.$7d)(o.fsPath)}createIPCObjectUrl(){let g;const $=u.URI.from({scheme:"vscode",path:(0,c.$4f)()}),o=$.toString(),d=async()=>g;return m.$ZS.handle(o,d),this.f.trace(`IPC Object URL: Registered new channel ${o}.`),{resource:$,update:P=>g=P,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${o}.`),m.$ZS.removeHandler(o)}}}};e.$u7b=v,e.$u7b=v=Ee([ee(0,w.$Jh),ee(1,f.$Ek),ee(2,y.$5i)],v)}),define(te[96],ie([0,1,8,3,2,64,12,111,6,41]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,u.$Bh)("storageService");var m;(function(o){o[o.NONE=0]="NONE",o[o.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var w;(function(o){o[o.APPLICATION=-1]="APPLICATION",o[o.PROFILE=0]="PROFILE",o[o.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(o){o[o.USER=0]="USER",o[o.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function f(o){const d=o.get(e.$Uo);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$Wo=f;class v extends s.$kc{static{this.a=60*1e3}constructor(d={flushInterval:v.a}){super(),this.m=d,this.b=this.B(new R.$id),this.c=this.B(new R.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,P,h){return R.Event.filter(this.b.event,t=>t.scope===d&&(P===void 0||t.key===P),h)}n(){this.j.value=(0,S.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,P){const{key:h,external:t}=P;if(h===e.$Uo){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:h,target:this.J(d)[h],external:t})}w(d){this.f.fire({reason:d})}get(d,P,h){return this.P(P)?.get(d,h)}getBoolean(d,P,h){return this.P(P)?.getBoolean(d,h)}getNumber(d,P,h){return this.P(P)?.getNumber(d,h)}getObject(d,P,h){return this.P(P)?.getObject(d,h)}storeAll(d,P){this.y(()=>{for(const h of d)this.store(h.key,h.value,h.scope,h.target,P)})}store(d,P,h,t,l=!1){if((0,D.$sf)(P)){this.remove(d,h,l);return}this.y(()=>{this.z(d,h,t),this.P(h)?.set(d,P,l)})}remove(d,P,h=!1){this.y(()=>{this.z(d,P,void 0),this.P(P)?.delete(d,h)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,P){const h=[],t=this.J(d);for(const l of Object.keys(t))t[l]===P&&h.push(l);return h}z(d,P,h,t=!1){const l=this.J(P);typeof h=="number"?l[d]!==h&&(l[d]=h,this.P(P)?.set(e.$Uo,JSON.stringify(l),t)):typeof l[d]=="number"&&(delete l[d],this.P(P)?.set(e.$Uo,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const P=this.P(d);return P?f(P):Object.create(null)}isNew(d){return this.getBoolean(e.$To,d)===!0}async flush(d=m.NONE){this.f.fire({reason:d});const P=this.P(-1),h=this.P(0),t=this.P(1);switch(d){case m.NONE:await S.Promises.settled([P?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await S.Promises.settled([P?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,P=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return $(d,P,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,P){return this.w(m.NONE),(0,c.$Dk)(d)?this.R(d,P):this.S(d,P)}M(d,P){return!(d.id===P.id||b(P)&&b(d))}N(d,P,h){this.y(()=>{const t=new Set;for(const[l,r]of d)t.add(l),P.get(l)!==r&&this.u(h,{key:l,external:!0});for(const[l]of P.items)t.has(l)||this.u(h,{key:l,external:!0})})}}e.$Xo=v;function b(o){return o.isDefault||!!o.useDefaultFlags?.globalState}e.$Yo=b;class g extends v{constructor(){super(),this.U=this.B(new E.$Ro(new E.$So,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Ro(new E.$So,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Ro(new E.$So,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Zo=g;async function $(o,d,P,h,t,l){const r=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,n=new Map;o.forEach((L,U)=>{i.set(U,L),n.set(U,r(L))});const a=new Map,k=new Map;d.forEach((L,U)=>{a.set(U,L),k.set(U,r(L))});const I=new Map,C=new Map;P.forEach((L,U)=>{I.set(U,L),C.set(U,r(L))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const p=[];if(i.forEach((L,U)=>{p.push({key:U,value:L})}),console.table(p),console.groupEnd(),console.log(n),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];a.forEach((U,q)=>{L.push({key:q,value:U})}),console.table(L),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${l})`);const A=[];I.forEach((L,U)=>{A.push({key:U,value:L})}),console.table(A),console.groupEnd(),console.log(C)}e.$1o=$}),define(te[281],ie([0,1,23,8,3,2,9,68,7,21,111,159,5,96,25,29,13]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=e.$J5b=e.$I5b=e.$H5b=void 0;class $ extends M.$kc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$fd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$fd),this.onDidCloseStorage=this.c.event,this.f=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$2g,this.whenInit=this.h.p,this.j=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===m.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(f.$To);i===void 0?r.set(f.$To,!0):i&&r.set(f.$To,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=m.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$bd(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([a,k])=>({key:a,length:k.length})),(a,k)=>k.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=m.StorageState.Closed,await this.f.close()}}class o extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$9d)(this.z.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,o.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new m.$Ro(new w.$sT(this.path??w.$sT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class d extends o{constructor(r,i,n,a){super(r,i,n,a)}}e.$H5b=d;class P extends o{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(v.$_k,void 0)===void 0&&r.set(v.$_k,new Date().toUTCString());const n=r.get(v.$$k,void 0),a=new Date().toUTCString();r.set(v.$al,typeof n>"u"?null:n),r.set(v.$$k,a)}}e.$I5b=P;class h extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id,h.y)}constructor(r,i,n,a,k){super(n,k),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new m.$Ro(new w.$sT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:i?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$sT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id),i=(0,D.$9d)(r,h.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,b.$Lh)(this.C)?i={folder:this.C.uri.toString()}:(0,b.$Qh)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$9d)(r,h.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$J5b=h;class t extends ${get path(){}async t(){return new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$K5b=t}),define(te[282],ie([0,1,3,2,96]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class M extends R.$kc{constructor(E,u,c){super(),this.b=E,this.c=u,this.f=c;const m=this.B(new R.$lc);this.a=this.B(new S.$fd({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new R.$jc;return E.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,c)=>(u?u.push(c.key):u=[c.key],u),100)(u=>this.h(u))),E.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(u,c)=>{u||(u=new Map);let m=u.get(c.profile.id);return m||u.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),u},100)(u=>this.j(u))),E}h(E){const u=E.includes(s.$Uo)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(m=>m!==s.$Uo),E.length){const m=(0,s.$Wo)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(w=>({key:w,scope:0,target:m[w]}))})}this.m(u,c)}j(E){const u=[],c=new Map;for(const[m,w]of E.entries()){w.keys.includes(s.$Uo)&&u.push(w.profile);const y=w.keys.filter(f=>f!==s.$Uo);if(y.length){const f=(0,s.$Wo)(w.storage.storage);c.set(m,{profile:w.profile,changes:y.map(v=>({key:v,scope:0,target:f[v]}))})}}this.m(u,[...c.values()])}m(E,u){(E.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:E})}listen(E,u,c){switch(u){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${u}`)}async call(E,u){throw new Error(`Call not found: ${u}`)}}e.$h7b=M}),define(te[283],ie([0,1,7,36,16,5,34,40,41,12,120]),function(K,e,S,R,s,M,D,E,u,c,m){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=void 0;let f=class extends u.$Hk{static{w=this}static{this.a="profileAssociationsMigration"}constructor($,o,d,P,h){super(d,P,o,h),this.U=$,this.W=d}O(){return this.U.getItem(w.b,[]).map(o=>({...o,location:(0,c.$jf)(o.location)?this.w.extUri.joinPath(this.profilesHome,o.location):S.URI.revive(o.location)}))}Q(){const $=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$nN=f,e.$nN=f=w=Ee([ee(0,D.$iN),ee(1,E.$Ck),ee(2,R.$Jh),ee(3,s.$6j),ee(4,M.$5i)],f);let v=y=class extends f{constructor($,o,d,P,h){super($,o,d,P,h),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(o=>({...o,location:this.w.extUri.basename(o.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",o=this.$.getItem($,void 0);if(o){this.$.removeItem($);const P=o.reduce((h,{workspace:t,profile:l})=>(h[S.URI.revive(t).toString()]=S.URI.revive(l).toString(),h),{});this.$.setItem(y.c,{workspaces:P})}const d=super.Q();return this.$.getItem(y.a,!1)||(this.R(d),this.$.setItem(y.a,!0)),d}};e.$oN=v,e.$oN=v=y=Ee([ee(0,D.$jN),ee(1,E.$Ck),ee(2,R.$Jh),ee(3,s.$6j),ee(4,M.$5i)],v);let b=class extends v{constructor($,o,d,P){super(new m.$mN(0,o,P,d),$,o,d,P)}async init(){return await this.$.init(),super.init()}};e.$pN=b,e.$pN=b=Ee([ee(0,E.$Ck),ee(1,R.$Jh),ee(2,s.$6j),ee(3,M.$5i)],b)}),define(te[52],ie([0,1,36,16,6,5,40,41,283,34]),function(K,e,S,R,s,M,D,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=e.$L5b=void 0,e.$L5b=(0,s.$Ch)(E.$Ek);let m=class extends u.$oN{constructor(y,f,v,b,g){super(y,f,v,b,g)}getAssociatedEmptyWindows(){const y=[];for(const f of this.C.emptyWindows.keys())y.push({id:f});return y}};e.$M5b=m,e.$M5b=m=Ee([ee(0,c.$jN),ee(1,D.$Ck),ee(2,S.$Jh),ee(3,R.$6j),ee(4,M.$5i)],m)}),define(te[129],ie([0,1,19,7,29]),function(K,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$85b=e.$75b=e.$65b=void 0;async function M(u,c,m){for(const y of u){const f=y.openedWorkspace;if((0,s.$Qh)(f)){const v=await m(f);if(v){if(v.folders.some(b=>S.$_f.isEqualOrParent(c,b.uri)))return y}else if(S.$_f.isEqualOrParent(c,f.configPath))return y}}const w=u.filter(y=>(0,s.$Lh)(y.openedWorkspace)&&S.$_f.isEqualOrParent(c,y.openedWorkspace.uri));if(w.length)return w.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$65b=M;function D(u,c){for(const m of u)if((0,s.$Qh)(m.openedWorkspace)&&S.$_f.isEqual(m.openedWorkspace.configPath,c)||(0,s.$Lh)(m.openedWorkspace)&&S.$_f.isEqual(m.openedWorkspace.uri,c))return m}e.$75b=D;function E(u,c){const m=w=>c.some(y=>S.$_f.isEqual(R.URI.file(y),R.URI.file(w)));for(const w of u)if(w.config?.extensionDevelopmentPath?.some(y=>m(y)))return w}e.$85b=E}),define(te[97],ie([0,1,32,44,137,46,13,9,4,19,7,6,58,29]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tU=e.$sU=e.$rU=e.$qU=e.$pU=e.$oU=e.$nU=e.$mU=e.$lU=e.$kU=void 0,e.$kU=(0,w.$Bh)("workspacesService");function v(C){return C.hasOwnProperty("workspace")}e.$lU=v;function b(C){return C.hasOwnProperty("folderUri")}e.$mU=b;function g(C){return C.hasOwnProperty("fileUri")}e.$nU=g;function $(C){return o(C)||d(C)}e.$oU=$;function o(C){const p=C;return typeof p?.path=="string"&&(!p.name||typeof p.name=="string")}function d(C){const p=C;return typeof p?.uri=="string"&&(!p.name||typeof p.name=="string")}function P(C,p,A,L,U){if(C.scheme!==L.scheme)return{name:A,uri:C.toString(!0)};let q=p?void 0:U.relativePath(L,C);if(q!==void 0)q.length===0?q=".":u.$i&&(q=h(q));else if(C.scheme===D.Schemas.file)q=C.fsPath,u.$i&&(q=h(q));else if(U.isEqualAuthority(C.authority,L.authority))q=C.path;else return{name:A,uri:C.toString(!0)};return{name:A,path:q}}e.$pU=P;function h(C){return C=(0,M.$iv)(C),(0,S.$Ff)(C)||(C=(0,S.$Cf)(C)),C}function t(C,p,A){const L=[],U=new Set,q=A.dirname(p);for(const se of C){let x;if(o(se))se.path&&(x=A.resolvePath(q,se.path));else if(d(se))try{x=m.URI.parse(se.uri),x.path[0]!==E.$6d.sep&&(x=x.with({path:E.$6d.sep+x.path}))}catch(ae){console.warn(ae)}if(x){const ae=A.getComparisonKey(x);if(!U.has(ae)){U.add(ae);const ne=se.name||A.basenameOrAuthority(x);L.push(new f.$Vh({uri:x,name:ne,index:L.length},se))}}}return L}e.$qU=t;function l(C,p,A,L,U){const q=r(p,C),se=U.dirname(p),x=U.dirname(L),ae=[];for(const J of q.folders){const H=o(J)?U.resolvePath(se,J.path):m.URI.parse(J.uri);let F;A?F=!1:F=!o(J)||(0,E.$8d)(J.path),ae.push(P(H,F,J.name,x,U))}const ne={insertSpaces:!1,tabSize:4,eol:u.$k||u.$j?`
`:`\r
`},re=s.$HS(C,["folders"],ae,ne);let Y=s.$KS(C,re);return(0,c.$ng)(q.remoteAuthority,(0,y.$Ok)(L))&&(Y=s.$KS(Y,s.$GS(Y,["remoteAuthority"],ne))),Y}e.$rU=l;function r(C,p){const A=R.$Lm(p);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(L=>$(L));else throw new Error(`${C} looks like an invalid workspace file.`);return A}function i(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function n(C){return typeof C.folderUri=="string"}function a(C){return typeof C.fileUri=="string"}function k(C,p){const A={workspaces:[],files:[]};if(C){const L=function(q,se){for(let x=0;x<q.length;x++)try{se(q[x],x)}catch(ae){p.warn(`Error restoring recent entry ${JSON.stringify(q[x])}: ${ae.toString()}. Skip entry.`)}},U=C;Array.isArray(U.entries)&&L(U.entries,q=>{const se=q.label,x=q.remoteAuthority;i(q)?A.workspaces.push({label:se,remoteAuthority:x,workspace:{id:q.workspace.id,configPath:m.URI.parse(q.workspace.configPath)}}):n(q)?A.workspaces.push({label:se,remoteAuthority:x,folderUri:m.URI.parse(q.folderUri)}):a(q)&&A.files.push({label:se,remoteAuthority:x,fileUri:m.URI.parse(q.fileUri)})})}return A}e.$sU=k;function I(C){const p={entries:[]};for(const A of C.workspaces)b(A)?p.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):p.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of C.files)p.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return p}e.$tU=I}),define(te[98],ie([0,1,71,13,4,19]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=e.$Y5b=e.$X5b=void 0,e.$X5b=128/4;function D(c){function m(){let w=c.scheme===R.Schemas.file?(0,M.$9f)(c):c.toString();return s.$k||(w=w.toLowerCase()),(0,S.createHash)("md5").update(w).digest("hex")}return{id:m(),configPath:c}}e.$Y5b=D;function E(c,m){function w(){if(c.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let f;return s.$k?f=m.ino:s.$j?f=m.birthtime.getTime():s.$i&&(typeof m.birthtimeMs=="number"?f=Math.floor(m.birthtimeMs):f=m.birthtime.getTime()),(0,S.createHash)("md5").update(c.fsPath).update(f?String(f):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:c}}e.$Z5b=E;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$15b=u}),define(te[99],ie([0,1,71,87,27,284,17,14,3,2,9,4,31,42,109]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class b{traceSocketEvent(p,A){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,A)}constructor(p,A=""){this.f=!0,this.debugLabel=A,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,E.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const A=L=>{this.traceSocketEvent("read",L),p(D.$Fd.wrap(L))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(p){const A=L=>{p({type:0,hadError:L,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(p){const A=()=>{p()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,E.$Y)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,E.$Y)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$qh=b;var g;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var $;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})($||($={}));class o extends c.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,A){this.socket.traceSocketEvent(p,A)}constructor(p,A,L,U){super(),this.f=this.B(new u.$fd),this.g=this.B(new u.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:L?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new d(this,A,L,U,this.f,(q,se)=>this.m(q,se))),this.B(this.a.onError(q=>{console.error(q),(0,E.$Y)(q),this.g.fire({type:0,hadError:!0,error:q})})),this.b=new v.$lh,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let A=0;for(;A<p.byteLength;)this.a.writeMessage(p.slice(A,Math.min(A+262144,p.byteLength))),A+=262144}m(p,A){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let L=2;p.byteLength<126?L+=0:p.byteLength<2**16?L+=2:L+=8;const U=D.$Fd.alloc(L);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),p.byteLength<126)U.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(p.byteLength>>>8&255,++q),U.writeUInt8(p.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(p.byteLength>>>24&255,++q),U.writeUInt8(p.byteLength>>>16&255,++q),U.writeUInt8(p.byteLength>>>8&255,++q),U.writeUInt8(p.byteLength>>>0&255,++q)}this.socket.write(D.$Fd.concat([U,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),L=A.readUInt8(0),U=(L&128)>>>7,q=(L&64)>>>6,se=A.readUInt8(1),x=(se&128)>>>7,ae=se&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),L=A.readUInt8(1),U=(L&128)>>>7;let q=L&127,se=1;q===126?q=A.readUInt8(++se)*2**8+A.readUInt8(++se):q===127&&(q=A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*0+A.readUInt8(++se)*2**24+A.readUInt8(++se)*2**16+A.readUInt8(++se)*2**8+A.readUInt8(++se));let x=0;U&&(x=A.readUInt8(++se)*2**24+A.readUInt8(++se)*2**16+A.readUInt8(++se)*2**8+A.readUInt8(++se)),this.j.state=3,this.j.readLen=q,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(A,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=o;class d extends c.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Fd.alloc(0)}constructor(p,A,L,U,q,se){super(),this.n=p,this.r=q,this.s=se,this.a=this.B(new u.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new P(this.n,U,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(p){this.g.push(p),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const p=this.g.shift();if(this.f){const A=await this.w(this.f,p);this.s(A,!0)}else this.s(p,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,A){return new Promise((L,U)=>{p.write(A),p.flush(q=>L(q))})}acceptFrame(p,A,L){this.h.push({data:p,isCompressed:A,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const A=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,A,L){return new Promise((U,q)=>{p.write(A),L&&p.write(D.$Fd.fromByteArray([0,0,255,255])),p.flush(se=>U(se))})}}class P extends c.$kc{get recordedInflateBytes(){return this.j?D.$Fd.concat(this.f):D.$Fd.alloc(0)}constructor(p,A,L,U){super(),this.h=p,this.j=A,this.a=this.B(new u.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",q=>{this.h.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent("zlibInflateData",q),this.g.push(D.$Fd.wrap(q))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=D.$Fd.concat(this.g);this.g.length=0,p(A)})}}class h extends c.$kc{constructor(p,A){super(),this.g=p,this.a=this.B(new u.$fd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(D.$Fd.wrap(L))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=D.$Fd.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),p(A)})}}function t(C,p){if(p===0)return;const A=C.byteLength>>>2;for(let ae=0;ae<A;ae++){const ne=C.readUInt32BE(ae*4);C.writeUInt32BE(ne^p,ae*4)}const L=A*4,U=C.byteLength-L,q=p>>>24&255,se=p>>>16&255,x=p>>>8&255;U>=1&&C.writeUInt8(C.readUInt8(L)^q,L),U>=2&&C.writeUInt8(C.readUInt8(L+1)^se,L+1),U>=3&&C.writeUInt8(C.readUInt8(L+2)^x,L+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const C=(0,y.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const p=process.platform!=="darwin"&&e.$sh?e.$sh:(0,s.tmpdir)(),A=(0,m.$9d)(p,`vscode-ipc-${C}.sock`);return n(A),A}e.$th=r;function i(C,p,A){const L=(0,S.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${A}-${p}-sock`;const U=A.substr(0,4),q=p.substr(0,6),se=L.substr(0,8);let x;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?x=(0,m.$9d)(e.$sh,`vscode-${se}-${U}-${q}.sock`):x=(0,m.$9d)(C,`${U}-${q}.sock`),n(x),x}e.$uh=i;function n(C){const p=l[w.$t];typeof p=="number"&&C.length>=p&&console.warn(`WARNING: IPC handle "${C}" is longer than ${p} chars, try a shorter --user-data-dir`)}class a extends f.$fh{static b(p){const A=u.Event.fromNodeEventEmitter(p,"connection");return u.Event.map(A,L=>({protocol:new v.$mh(new b(L,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(L,"close"))}))}constructor(p){super(a.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=a;function k(C){return new Promise((p,A)=>{const L=(0,R.createServer)();L.on("error",A),L.listen(C,()=>{L.removeListener("error",A),p(new a(L))})})}e.$wh=k;function I(C,p){return new Promise((A,L)=>{const U=(0,R.createConnection)(C,()=>{U.removeListener("error",L),A(v.$nh.fromSocket(new b(U,`ipc-client${p}`),p))});U.once("error",L)})}e.$xh=I}),define(te[28],ie([0,1,54,9,4,99,36,89,6]),function(K,e,S,R,s,M,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=e.$D5b=void 0,e.$D5b=(0,u.$Ch)(D.$Ih);class c extends E.$_l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$9d)(this.userDataPath,"clp")}get backupHome(){return(0,R.$9d)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$uh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$9d)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$k)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$E5b=c,Ee([S.$6g],c.prototype,"cachedLanguagesPath",null),Ee([S.$6g],c.prototype,"backupHome",null),Ee([S.$6g],c.prototype,"mainIPCHandle",null),Ee([S.$6g],c.prototype,"mainLockfile",null),Ee([S.$6g],c.prototype,"disableUpdates",null),Ee([S.$6g],c.prototype,"crossOriginIsolated",null),Ee([S.$6g],c.prototype,"codeCachePath",null),Ee([S.$6g],c.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,71,32,13,9,4,19,21,194,18,28,34,16,5,193,29,98]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=void 0;let d=class{static{o=this}static{this.a="backupWorkspaces"}constructor(h,t,l,r){this.j=h,this.k=t,this.l=l,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$_f,this.i={isEqual:(i,n)=>(0,R.$Hf)(i,n,!D.$k)}}async initialize(){const h=this.m.getItem(o.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(h.emptyWindows),this.d=await this.u((0,c.$U5b)(h)),this.e=await this.v((0,c.$V5b)(h)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$rk.OFF}q(){return this.s()===f.$rk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$rk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,t){this.d.some(r=>h.workspace.id===r.workspace.id)||(this.d.push(h),this.C());const l=(0,M.$9d)(this.c,h.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(h,t){if(await u.Promises.exists(h)&&await this.z(h),await u.Promises.exists(t))try{await u.Promises.rename(t,h,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(h){return this.e.some(t=>this.h.isEqual(h.folderUri,t.folderUri))||(this.e.push(h),this.C()),(0,M.$9d)(this.c,this.D(h))}registerEmptyWindowBackup(h){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,h.backupFolder))||(this.g.push(h),this.C()),(0,M.$9d)(this.c,h.backupFolder)}async u(h){if(!Array.isArray(h))return[];const t=new Set,l=[];for(const r of h){const i=r.workspace;if(!(0,g.$Qh)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$9d)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?l.push(r):await this.z(n):await this.x(n)}}return l}async v(h){if(!Array.isArray(h))return[];const t=[],l=new Set;for(const r of h){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const a=(0,M.$9d)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await u.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(h){if(!Array.isArray(h))return[];const t=[],l=new Set;for(const r of h){const i=r.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,M.$9d)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(h){try{await u.Promises.rm(h,u.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let h=(0,$.$15b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,h.id));)h=(0,$.$15b)();return{backupFolder:h.id}}async z(h){const t=this.y(),l=(0,M.$9d)(this.c,t.backupFolder);try{await u.Promises.rename(h,l,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const h=[];for(const t of this.d)await this.A(t)&&h.push(t);for(const t of this.e)await this.A(t)&&h.push(t);return h}A(h){let t;return(0,c.$T5b)(h)?t=(0,M.$9d)(this.c,h.backupFolder):(0,b.$iU)(h)?t=(0,M.$9d)(this.c,this.D(h)):t=(0,M.$9d)(this.c,h.workspace.id),this.B(t)}async B(h){try{const t=await u.Promises.readdir(h);for(const l of t)try{if((await u.Promises.readdir((0,M.$9d)(h,l))).length>0)return!0}catch{}}catch{}return!1}C(){const h={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return l&&(r.remoteAuthority=l),r}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const r={folderUri:t.toString()};return l&&(r.remoteAuthority=l),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const r={backupFolder:t};return l&&(r.remoteAuthority=l),r})};this.m.setItem(o.a,h)}D(h){const t=h.folderUri;let l;return t.scheme===s.Schemas.file?l=D.$k?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,S.createHash)("md5").update(l).digest("hex")}};e.$25b=d,e.$25b=d=o=Ee([ee(0,w.$D5b),ee(1,m.$8h),ee(2,v.$5i),ee(3,y.$jN)],d)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.LifecycleMainPhase=e.ShutdownReason=e.$F5b=void 0,e.$F5b=(0,m.$Bh)("lifecycleMainService");var b;(function(o){o[o.QUIT=1]="QUIT",o[o.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var g;(function(o){o[o.Starting=1]="Starting",o[o.Ready=2]="Ready",o[o.AfterWindowOpen=3]="AfterWindowOpen",o[o.Eventually=4]="Eventually"})(g||(e.LifecycleMainPhase=g={}));let $=class extends D.$kc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(d,P,h){super(),this.F=d,this.G=P,this.H=h,this.c=this.B(new M.$fd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$fd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$fd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$fd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const d=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",d);const P=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&S.app.quit()};S.app.addListener("window-all-closed",P),S.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",d),S.app.removeListener("window-all-closed",P),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(d){if(this.y)return this.y;const P=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:d,join(t,l){P.trace(`Lifecycle#onWillShutdown - begin '${t}'`),h.push(l.finally(()=>{P.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(h)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===d)return;this.S(`lifecycle (main): phase changed (value: ${d})`),this.n=d;const P=this.C.get(this.n);P&&(P.open(),this.C.delete(this.n))}async when(d){if(d<=this.n)return;let P=this.C.get(d);P||(P=new s.$Fg,this.C.set(d,P)),await P.wait()}registerWindow(d){const P=new D.$jc;this.t++,P.add(d.onWillLoad(t=>this.g.fire({window:d,workspace:t.workspace,reason:t.reason})));const h=(0,c.$uf)(d.win);h.on("close",t=>{const l=d.id;if(this.r.has(l)){this.r.delete(l);return}this.S(`Lifecycle#window.on('close') - window ID ${d.id}`),t.preventDefault(),this.unload(d,1).then(r=>{if(r){this.r.delete(l);return}this.r.add(l),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire(d),d.close()})}),h.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.t--,P.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}async reload(d,P){await this.unload(d,3)||d.reload(P)}unload(d,P){const h=this.z.get(d.id);if(h)return h;const t=this.M(d,P).finally(()=>{this.z.delete(d.id)});return this.z.set(d.id,t),t}async M(d,P){if(!d.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${d.id}`);const h=this.j?2:P,t=await this.P(d,h);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.N(t)):(await this.Q(d,h),!1)}N(d){return d?(this.O(!0),this.j=!1,!0):!1}O(d){this.w&&(this.w(d),this.w=void 0,this.u=void 0)}P(d,P){return new Promise(h=>{const t=this.s++,l=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$ZS.once(l,()=>{h(!1)}),R.$ZS.once(r,()=>{h(!0)}),d.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:P})})}Q(d,P){return new Promise(h=>{const l=`vscode:reply${this.s++}`;R.$ZS.once(l,()=>h()),d.send("vscode:onWillUnload",{replyChannel:l,reason:P})})}quit(d){return this.R(d).then(P=>{if(!P&&d)try{if(E.$i){const h=(0,u.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return P})}R(d){return this.S(`Lifecycle#quit() - begin (willRestart: ${d})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(d&&this.G.setItem(v.b,!0),this.u=new Promise(P=>{this.w=P,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(d){this.H.args["enable-smoke-test-driver"]?this.F.info(d):this.F.trace(d)}setRelaunchHandler(d){this.D=d}async relaunch(d){this.S("Lifecycle#relaunch()");const P=process.argv.slice(1);if(d?.addArgs&&P.push(...d.addArgs),d?.removeArgs)for(const l of d.removeArgs){const r=P.indexOf(l);r>=0&&P.splice(r,1)}const h=()=>{this.D?.handleRelaunch(d)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:P}))};S.app.once("quit",h),await this.quit(!0)&&S.app.removeListener("quit",h)}async kill(d){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Hg)(1e3),(async()=>{for(const P of S.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let h;P.webContents&&!P.webContents.isDestroyed()?h=new Promise(t=>P.once("closed",t)):h=Promise.resolve(),P.destroy(),await h}})()]),S.app.exit(d)}};e.$G5b=$,e.$G5b=$=v=Ee([ee(0,w.$5i),ee(1,y.$jN),ee(2,f.$D5b)],$)}),define(te[286],ie([0,1,4,3,2,6,20]),function(K,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=e.$w6b=void 0,e.$w6b=(0,M.$Bh)("keyboardLayoutMainService");let E=class extends s.$kc{constructor(m){super(),this.a=this.B(new R.$fd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((w,y)=>{K(["native-keymap"],w,y)});this.c=u(m),S.$s||m.onDidChangeKeyboardLayout(()=>{this.c=u(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$x6b=E,e.$x6b=E=Ee([ee(0,D.$F5b)],E);function u(c){const m=c.getKeyMap(),w=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:w}}}),define(te[287],ie([0,1,246,8,17,14,12,18,36,94,5,50,245,284]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;let v=class extends w.$Jo{constructor(o,d,P,h){super(h),this.m=o,this.n=d,this.r=P,this.s(),this.B(o.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const o=this.m.getValue("http");this.f=o?.proxy,this.g=!!o?.proxyStrictSSL,this.h=o?.proxyAuthorization}async request(o,d){const{f:P,g:h}=this;let t;try{t=await(0,c.$Ml)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$8)(i)))}const l={...process.env,...t},r=o.agent?o.agent:await(0,y.$Nq)(o.url||"",l,{proxyUrl:P,strictSSL:h});return o.agent=r,o.strictSSL=h,this.h&&(o.headers={...o.headers||{},"Proxy-Authorization":this.h}),this.c(o.isChromiumNetwork?"electron":"node",o,()=>g(o,d))}async resolveProxy(o){}};e.$Oq=v,e.$Oq=v=Ee([ee(0,E.$8h),ee(1,u.$Jh),ee(2,m.$5i),ee(3,m.$6i)],v);async function b($){return((0,S.parse)($.url).protocol==="https:"?await new Promise((P,h)=>{K(["https"],P,h)}):await new Promise((P,h)=>{K(["http"],P,h)})).request}async function g($,o){return R.Promises.withAsyncBody(async(d,P)=>{const h=(0,S.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await b($),l={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,D.$pf)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(l.auth=$.user+":"+$.password);const r=t(l,i=>{const n=(0,D.$nf)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...$,url:i.headers.location,followRedirects:n-1},o).then(d,P);else{let a=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,f.createGunzip)())),d({res:i,stream:(0,s.$Ud)(a)})}});r.on("error",P),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),o.onCancellationRequested(()=>{r.abort(),P(new M.$3)})})}e.$Pq=g}),define(te[288],ie([0,1,15,287]),function(K,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;function s(D){return S.net.request}class M extends R.$Oq{request(E,u){return super.request({...E||{},getRawRequest:s,isChromiumNetwork:!0},u)}}e.$z7b=M}),define(te[81],ie([0,1,7,3,2,36,16,6,20,5,96,281,41,52,40,13]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=e.$O5b=e.$N5b=void 0,e.$N5b=(0,E.$Bh)("storageMainService");let g=class extends s.$kc{constructor(d,P,h,t,l,r){super(),this.c=d,this.f=P,this.g=h,this.h=t,this.j=l,this.m=r,this.a=void 0,this.b=this.B(new R.$fd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this.B(this.h.onWillShutdown(d=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.t)d.join("profileStorage",P.close());for(const[,P]of this.w)d.join("workspaceStorage",P.close())})),this.B(this.g.onWillCreateProfile(d=>{d.join((async()=>{await this.j.exists(d.profile.globalStorageHome)||await this.j.createFolder(d.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(d=>{const P=this.t.get(d.profile.id);P&&d.join(P.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const d=new w.$I5b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(d.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),d}profileStorage(d){if((0,m.$Yo)(d))return this.applicationStorage;let P=this.t.get(d.id);if(!P){this.c.trace(`StorageMainService: creating profile storage (${d.name})`),P=this.B(this.u(d)),this.t.set(d.id,P);const h=this.B(P.onDidChangeStorage(t=>this.b.fire({...t,storage:P,profile:d})));this.B(R.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${d.name})`),this.t.delete(d.id),h.dispose()}))}return P}u(d){return this.a===2?new w.$K5b(this.c,this.j):new w.$H5b(d,this.n(),this.c,this.j)}workspaceStorage(d){let P=this.w.get(d.id);return P||(this.c.trace(`StorageMainService: creating workspace storage (${d.id})`),P=this.B(this.y(d)),this.w.set(d.id,P),this.B(R.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${d.id})`),this.w.delete(d.id)}))),P}y(d){return this.a===2?new w.$K5b(this.c,this.j):new w.$J5b(d,this.n(),this.c,this.f,this.j)}isUsed(d){const P=S.URI.file(d);for(const h of[this.applicationStorage,...this.t.values(),...this.w.values()])if(h.path&&this.m.extUri.isEqualOrParent(S.URI.file(h.path),P))return!0;return!1}};e.$O5b=g,e.$O5b=g=Ee([ee(0,c.$5i),ee(1,M.$Ih),ee(2,f.$L5b),ee(3,u.$F5b),ee(4,D.$6j),ee(5,v.$Ck)],g),e.$P5b=(0,E.$Bh)("applicationStorageMainService");let $=class extends m.$Xo{constructor(d,P){super(),this.s=d,this.U=P,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(d){if(d===-1)return this.U.applicationStorage.storage}Q(d){if(d===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Q5b=$,e.$Q5b=$=Ee([ee(0,y.$Ek),ee(1,e.$N5b)],$)}),define(te[289],ie([0,1,15,22,3,55,2,31,115,5,81,30]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let f=class extends D.$kc{constructor(b,g,$,o){super(),this.g=b,this.h=g,this.j=$,this.m=o,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(S.app,"login",(g,$,o,d,P)=>({event:g,webContents:$,req:o,authInfo:d,callback:P}));this.B(b(this.r,this))}async r({event:b,authInfo:g,req:$,callback:o}){if(!g.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let d;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(g);try{d=await this.b}finally{this.b=void 0}}o(d?.username,d?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.t(b);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const g=String((0,M.$pi)({scheme:b.scheme,host:b.host,port:b.port}));let $,o;try{const t=this.m.get(this.a+g,-1);if(t){const l=JSON.parse(await this.j.decrypt(t));$=l.username,o=l.password}}catch(t){this.g.error(t)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof o=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:o};const d=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!d){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const P={authInfo:b,username:this.f?.username??$,password:this.f?.password??o,replyChannel:`vscode:proxyAuthResponse:${(0,E.$4f)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,P),this.c=y.LoginDialogShown;const h=await new Promise(t=>{const l=async(r,i,n)=>{if(i===P.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",l),n){const a={username:n.username,password:n.password};try{if(n.remember){const k=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+g,k,-1,1)}else this.m.remove(this.a+g,-1)}catch(k){this.g.error(k)}t({username:a.username,password:a.password})}else t(void 0)};d.win?.webContents.on("ipc-message",l)});return this.f=h,h}};e.$S5b=f,e.$S5b=f=Ee([ee(0,c.$5i),ee(1,w.$R5b),ee(2,u.$HT),ee(3,m.$P5b)],f)}),define(te[290],ie([0,1,87,27,103,99,8,2,4,18,5,24,241,242,95,125,17]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=e.$w7b=e.$v7b=void 0;async function $(t,l,r,i,n){let a;for(let k=3;k&&(a?.dispose(),a=await new o(t,l,r,i,n).waitForReady(),!(n&&s.$7f[n]||!s.$7f[a.tunnelLocalPort]));k--);return a}class o extends E.$kc{constructor(l,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=S.createServer(),this.c=new D.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,b.$7u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$8f)(l,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(l){l.pause();const r=(0,b.$5u)(this.tunnelRemoteHost)||(0,b.$7u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,y.$Zk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),n instanceof M.$qh?n.socket.destroy():n.end()}),n instanceof M.$qh?this.t(l,n):this.s(l,n),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),n.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(i=>l.write(i.buffer)),l.on("data",i=>r.write(g.$Fd.wrap(i))),l.resume()}t(l,r){const i=r.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$v7b=o;let d=class extends b.$0u{constructor(l,r,i,n,a){super(r,a),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,b.$8u)(l,this.l,u.OS,R.release())}s(l,r,i,n,a,k,I,C){const p=this.r(r,i);if(p)return++p.refcount,p.value;if((0,b.$2u)(l))return this.t(l,r,i,a,k,I,C);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const A={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=$(A,n,r,i,a);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,L),L}}};e.$w7b=d,e.$w7b=d=Ee([ee(0,f.$Tk),ee(1,m.$5i),ee(2,v.$Wk),ee(3,w.$kj),ee(4,c.$8h)],d);let P=class extends d{constructor(l,r,i,n,a){super(l,r,i,n,a)}};e.$x7b=P,e.$x7b=P=Ee([ee(0,f.$Tk),ee(1,m.$5i),ee(2,v.$Wk),ee(3,w.$kj),ee(4,c.$8h)],P);let h=class extends E.$kc{constructor(l,r,i,n,a){super(),this.b=l,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(l,r,i,n,a,k,I,C,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${k}.`),!this.a.has(l)){const A=new P(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(l,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,i,n,a,k,I,C,p)}};e.$y7b=h,e.$y7b=h=Ee([ee(0,f.$Tk),ee(1,m.$5i),ee(2,w.$kj),ee(3,v.$Wk),ee(4,c.$8h)],h)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,50,48]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=void 0;function y(v,b,g){return`${g.updateUrl}/api/update/${v}/${b}/${g.commit}`}e.$V6b=y;let f=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,g,$,o,d,P){this.f=b,this.g=g,this.h=$,this.i=o,this.j=d,this.k=P,this.b=w.$YT.Uninitialized,this.c=new s.$fd,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$YT.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$YT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$YT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),g=this.m(b);if(!g){this.d(w.$YT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(g),!this.a){this.d(w.$YT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$YT.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,S.$Hg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(g){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(g);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$W6b=f,e.$W6b=f=Ee([ee(0,E.$F5b),ee(1,M.$8h),ee(2,D.$D5b),ee(3,m.$Io),ee(4,u.$5i),ee(5,c.$kj)],f)}),define(te[291],ie([0,1,15,54,3,2,18,28,20,5,24,50,25,48,100]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;let b=class extends v.$W6b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",($,o)=>o)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",($,o,d)=>({url:o,version:d,productVersion:d}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",($,o,d,P)=>({releaseNotes:o,version:d,productVersion:d,date:P}))}constructor($,o,d,P,h,t,l){super($,o,P,h,t,l),this.z=d,this.u=new M.$jc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const o=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(f.$YT.Idle(1,o))}s($){let o;this.k.darwinUniversalAssetId?o=this.k.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,v.$V6b)(o,$,this.k);try{S.autoUpdater.setFeedURL({url:d})}catch(P){this.j.error("Failed to set update feed URL",P);return}return d}t($){this.d(f.$YT.CheckingForUpdates($)),S.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(f.$YT.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$YT.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$YT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$X6b=b,Ee([R.$6g],b.prototype,"v",null),Ee([R.$6g],b.prototype,"w",null),Ee([R.$6g],b.prototype,"x",null),Ee([R.$6g],b.prototype,"y",null),e.$X6b=b=Ee([ee(0,u.$F5b),ee(1,D.$8h),ee(2,y.$9k),ee(3,E.$D5b),ee(4,w.$Io),ee(5,c.$5i),ee(6,m.$kj)],b)}),define(te[292],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;let y=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,g,$){if(this.f=b,this.g=$,this.a=w.$YT.Uninitialized,this.b=new M.$fd,this.onStateChange=this.b.event,g.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$YT.Idle(this.k())),this.h(30*1e3).then(void 0,o=>this.g.error(o))}h(b=60*60*1e3){return(0,s.$Hg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};y=Ee([ee(0,u.$F5b),ee(1,E.$D5b),ee(2,c.$5i)],y);let f=class extends y{constructor(b,g,$,o,d,P){super($,o,d),this.o=b,this.p=g,this.q=P;const h=(0,R.watch)(D.$_d(this.o)),t=M.Event.fromNodeEventEmitter(h,"change",(n,a)=>a),l=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(l,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),h.close()})}m(){this.d(w.$YT.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(w.$YT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$YT.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$YT.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$ae(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise(($,o)=>(0,R.realpath)(`${D.$_d(this.o)}/current`,(d,P)=>d?o(d):$(P))),g=D.$ae(b);return this.p!==g}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Z6b=f,e.$Z6b=f=Ee([ee(2,u.$F5b),ee(3,E.$D5b),ee(4,c.$5i),ee(5,m.$9k)],f)}),define(te[293],ie([0,1,2,20,52,29,8,30]),function(K,e,S,R,s,M,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;let u=class extends S.$kc{constructor(m,w,y){super(),this.a=w,this.b=y,this.B(m.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(m.onBeforeCloseWindow(f=>this.c(f))),this.B(new D.$Sg(()=>this.g(),30*1e3)).schedule()}async c(m){const w=this.f(m),y=this.a.getProfileForWorkspace(w);y?.isTransient&&(this.a.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,M.$Ph)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const w=this.b.getWindows().map(y=>this.f(y));for(const y of m)w.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$g7b=u,e.$g7b=u=Ee([ee(0,R.$F5b),ee(1,s.$L5b),ee(2,E.$R5b)],u)}),define(te[60],ie([0,1,15,2,3,5,312,8,13,30,69,25,20,72,37,4,130]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=e.$$5b=void 0;function o(h){return typeof h.responseWindowId=="number"}let d=class extends R.$kc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,l,r){super(),this.t=t,this.u=l,this.w=r,this.c=String(++$.a),this.f=this.B(new s.$fd),this.onStdout=this.f.event,this.g=this.B(new s.$fd),this.onStderr=this.g.event,this.h=this.B(new s.$fd),this.onMessage=this.h.event,this.j=this.B(new s.$fd),this.onExit=this.j.event,this.m=this.B(new s.$fd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,l){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,l){case m.default.Error:this.t.error(r);break;case m.default.Warning:this.t.warn(r);break;case m.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const l=this.C(t);return l&&t.payload&&this.postMessage(t.payload),l}C(t){if(!this.z())return!1;this.s=t;const l=`${this.s.type}-${this.c}`,r=u.$2f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],a=this.s.allowLoadingUnsignedLibraries,k=this.s.forceAllocationsToV8Sandbox,I="pipe",C=this.D(t);return this.y("creating new...",m.default.Info),this.n=S.utilityProcess.fork(r,i,{serviceName:l,env:C,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:k,stdio:I}),this.F(this.n,this.s,l),!0}D(t){const l=t.env?{...t.env}:{...(0,v.$Vm)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.$i&&((0,g.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,g.getUNCHostAllowlist)().join("\\")),(0,f.$tl)(l);for(const r of Object.keys(l))l[r]=String(l[r]);return l}F(t,l,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:o(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.y("successfully created",m.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,m.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,m.default.Error),this.u.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,l){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),l())}))}postMessage(t,l){this.n&&this.n.postMessage(t,l)}connect(t){const{port1:l,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),l}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",m.default.Info),this.n.kill()?(this.y("successfully killed the process",m.default.Info),this.G()):this.y("unable to kill the process",m.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,E.$Hg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$$5b=d,e.$$5b=d=$=Ee([ee(0,M.$5i),ee(1,w.$9k),ee(2,y.$F5b)],d);let P=class extends d{constructor(t,l,r,i){super(t,r,i),this.H=l}start(t){const l=this.H.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.C(t))return!1;this.I(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$_5b=P,e.$_5b=P=Ee([ee(0,M.$5i),ee(1,c.$R5b),ee(2,w.$9k),ee(3,y.$F5b)],P)}),define(te[294],ie([0,1,14,5,20,8,60,30,25]),function(K,e,S,R,s,M,D,E,u){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;let m=class{static{c=this}static{this.a=0}constructor(y,f,v,b){this.d=y,this.f=f,this.g=v,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const f=this.b.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,S.$4)();const y=String(++c.a),f=new D.$_5b(this.d,this.g,this.h,this.f);return this.b.set(y,f),f.onExit(({pid:v,code:b,signal:g})=>{this.d.info(`Extension host with pid ${v} exited with code: ${b}, signal: ${g}.`),setTimeout(()=>{f.dispose(),this.b.delete(y)})}),{id:y}}async start(y,f){if(this.c)throw(0,S.$4)();this.i(y).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,S.$4)();const f=this.b.get(y);return f?f.enableInspectPort():!1}async kill(y){if(this.c)throw(0,S.$4)();const f=this.b.get(y);f&&f.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const f=[];for(const[,v]of this.b)f.push(v.waitForExit(y));return M.Promises.settled(f).then(()=>{})}};e.$h6b=m,e.$h6b=m=c=Ee([ee(0,R.$5i),ee(1,s.$F5b),ee(2,E.$R5b),ee(3,u.$9k)],m)}),define(te[295],ie([0,1,38,8,2,28,20,5,41,39,65,60,51,89,12,247,24]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=void 0;let $=class extends s.$kc{constructor(d,P,h,t,l,r,i,n){super(),this.c=d,this.f=P,this.g=h,this.h=t,this.j=l,this.m=r,this.n=i,this.r=n,this.a=new R.$Fg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$ZS.on(b.$N6b.request,(d,P)=>this.t(d,P,b.$N6b.response)),S.$ZS.on(b.$O6b.request,(d,P)=>this.t(d,P,b.$O6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(d,P,h){this.j.trace(`[SharedProcess] onWindowConnection for: ${h}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(h);if(d.sender.isDestroyed())return t.close();d.sender.postMessage(h,P,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$M6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const d=new R.$2g;this.b?this.b.once(b.$M6b.initDone,()=>d.complete()):S.$ZS.once(b.$M6b.initDone,()=>d.complete()),await d.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const d=new R.$2g;this.b?this.b.once(b.$M6b.ipcReady,()=>d.complete()):S.$ZS.once(b.$M6b.ipcReady,()=>d.complete()),await d.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$$5b(this.j,y.$bo,this.h));const d=(0,f.$bm)(this.f.args,this.f.isBuilt);let P;d.port&&(P=["--nolazy"],d.break?P.push(`--inspect-brk=${d.port}`):P.push(`--inspect=${d.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:P,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(d){return await this.z,(0,v.$uf)(this.b).connect(d)}};e.$P6b=$,e.$P6b=$=Ee([ee(1,M.$D5b),ee(2,u.$Ek),ee(3,D.$F5b),ee(4,E.$5i),ee(5,m.$K6b),ee(6,c.$0m),ee(7,g.$kj)],$)}),define(te[296],ie([0,1,28,89,20,5,51,60,110,38,2,3,37,18,13]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;let b=class extends m.$kc{constructor($,o,d,P,h){super(),this.f=$,this.g=o,this.h=d,this.j=P,this.m=h,this.a=void 0,this.b=new w.$fd,this.onRequestConnection=this.b.event,this.c=new w.$fd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$ZS.on("vscode:createPtyHostMessageChannel",(t,l)=>this.r(t,l)),this.B((0,m.$ic)(()=>{c.$ZS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$$5b(this.m,D.$bo,this.j);const $=(0,R.$am)(this.h.args,this.h.isBuilt),o=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:o,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const d=this.a.connect(),P=new u.$8S(d,"ptyHost"),h=new m.$jc;return h.add(P),h.add((0,m.$ic)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:P,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$Vm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},o=this.g.getValue("terminal.integrated.developer.ptyHost.latency");o&&typeof o=="number"&&($.VSCODE_LATENCY=String(o));const d=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return d&&typeof d=="number"&&($.VSCODE_STARTUP_DELAY=String(d)),this.h.restoreSnapExportedVariables(),$}r($,o){this.b.fire();const d=this.a.connect();if($.sender.isDestroyed()){d.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",o,[d])}};e.$o7b=b,e.$o7b=b=Ee([ee(1,f.$8h),ee(2,S.$D5b),ee(3,s.$F5b),ee(4,M.$5i)],b)}),define(te[297],ie([0,1,2,6,5,30,60,25,55,3,8,20]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=e.$m7b=void 0,e.$m7b=(0,R.$Bh)("utilityProcessWorker");let y=class extends S.$kc{constructor(b,g,$,o){super(),this.b=b,this.c=g,this.f=$,this.g=o,this.a=new Map}async createWorker(b){const g=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${g})`);const $=this.h(b);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${g})`),this.disposeWorker(b));const o=new f(this.b,this.c,this.f,this.g,b);if(!o.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,o);const d=new m.$2g;return c.Event.once(o.onDidTerminate)(P=>{P.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.a.delete($),d.complete({reason:P})}),d.p}h(b){return(0,u.$pi)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const g=this.h(b),$=this.a.get(g);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),$.kill(),this.a.delete(g))}};e.$n7b=y,e.$n7b=y=Ee([ee(0,s.$5i),ee(1,M.$R5b),ee(2,E.$9k),ee(3,w.$F5b)],y);let f=class extends S.$kc{constructor(b,g,$,o,d){super(),this.c=b,this.f=g,this.g=$,this.h=o,this.j=d,this.a=this.B(new c.$fd),this.onDidTerminate=this.a.event,this.b=new D.$_5b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const g=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:g,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=Ee([ee(0,s.$5i),ee(1,M.$R5b),ee(2,E.$9k),ee(3,w.$F5b)],f)}),define(te[298],ie([0,1,15,2,4,19,7,18,20,5,34,30,127,29]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=e.$06b=void 0;let b=class extends R.$kc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(h,t,l,r,i){super(),this.g=h,this.h=t,this.j=l,this.m=r,this.n=i,this.b=g(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(h=>this.u(h)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.u(h))}s(){this.f=!0,this.t()}t(){const h=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&h.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.w(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(h.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const r=o(t);this.h.setItem(v.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(h){if(this.j.quitRequested)return;const t=this.w(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(l=>{const r=(0,f.$Qh)(h.openedWorkspace)&&l.workspace?.id===h.openedWorkspace.id,i=(0,f.$Lh)(h.openedWorkspace)&&l.folderUri&&M.$_f.isEqual(l.folderUri,h.openedWorkspace.uri);(r||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(h){return{windowId:h.id,workspace:(0,f.$Qh)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,f.$Lh)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const t=this.z(h),l=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||l?.restoreFullscreen),r||(t.mode=1)}return t}z(h){const t=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=h.workspace;if((0,f.$Qh)(k)){const C=this.state.openedWindows.filter(p=>p.workspace&&p.workspace.id===k.id).map(p=>p.uiState);if(C.length)return C[0]}if((0,f.$Lh)(k)){const C=this.state.openedWindows.filter(p=>p.folderUri&&M.$_f.isEqual(p.folderUri,k.uri)).map(p=>p.uiState);if(C.length)return C[0]}else if(h.backupPath){const C=this.state.openedWindows.filter(p=>p.backupPath===h.backupPath).map(p=>p.uiState);if(C.length)return C[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let l;const r=S.screen.getAllDisplays();if(r.length===1)l=r[0];else{if(s.$j){const k=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(k)}!l&&t&&(l=S.screen.getDisplayMatching(t.getBounds())),l||(l=S.screen.getPrimaryDisplay()||r[0])}let i=(0,y.$C5b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===3?i.mode=3:i=k,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===h.x||l.y===h.y);)h.x+=30,h.y+=30;return h}};e.$06b=b,e.$06b=b=v=Ee([ee(0,w.$R5b),ee(1,m.$jN),ee(2,u.$F5b),ee(3,c.$5i),ee(4,E.$8h)],b);function g(P){const h={openedWindows:[]},t=P||{openedWindows:[]};return t.lastActiveWindow&&(h.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(h.openedWindows=t.openedWindows.map(l=>$(l))),h}e.$$6b=g;function $(P){const h={uiState:P.uiState};return P.backupPath&&(h.backupPath=P.backupPath),P.remoteAuthority&&(h.remoteAuthority=P.remoteAuthority),P.folder&&(h.folderUri=D.URI.parse(P.folder)),P.workspaceIdentifier&&(h.workspace={id:P.workspaceIdentifier.id,configPath:D.URI.parse(P.workspaceIdentifier.configURIPath)}),h}function o(P){return{lastActiveWindow:P.lastActiveWindow&&d(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&d(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(h=>d(h))}}e.$_6b=o;function d(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(te[53],ie([0,1,15,3,44,2,13,9,19,21,192,63,59,28,6,5,52,129,29,97,98]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=void 0,e.$95b=(0,v.$Bh)("workspacesManagementMainService");let h=class extends M.$kc{constructor(l,r,i,n,a){super(),this.g=l,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new R.$fd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$fd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await c.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,u.$ig)(this.c,r,o.$1h));for(const r of l){const i=(0,P.$Y5b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.r(l,r=>c.Promises.readFile(r,"utf8"))}r(l,r){if(this.s(l)&&l.scheme===D.Schemas.file)try{const i=r(l.fsPath);return i instanceof Promise?i.then(n=>this.t(l,n),n=>{}):this.t(l,i)}catch{return}}s(l){return(0,o.$2h)(l,this.g)||(0,o.$7h)(l)}t(l,r){try{const i=this.u(l,r),n=(0,P.$Y5b)(l);return{id:n.id,configPath:n.configPath,folders:(0,d.$qU)(i.folders,n.configPath,u.$_f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(l,r){const i=(0,s.$Lm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,d.$oU)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,r){const{workspace:i,storedWorkspace:n}=this.w(l,r),a=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$_d)(a),{recursive:!0}),await c.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(l=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,u.$ig)(this.c,i),a=(0,u.$ig)(n,o.$1h),k=[];for(const I of l)k.push((0,d.$pU)(I.uri,!0,I.name,n,u.$_f));return{workspace:(0,P.$Y5b)(a),storedWorkspace:{folders:k,remoteAuthority:r}}}async getWorkspaceIdentifier(l){return(0,P.$Y5b)(l)}isUntitledWorkspace(l){return(0,o.$2h)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.y(l),this.j.isEnabled()&&this.j.unsetWorkspace(l),this.a.fire(l))}async y(l){const r=(0,u.$9f)(l.configPath);try{await c.Promises.rm((0,E.$_d)(r));const i=(0,E.$9d)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,l.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$9d)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,r,i){if(!l||!l.win||!l.isReady||!await this.z(l,r,i))return;const a=await this.C(l,(0,P.$Y5b)(i));if(a)return this.b.fire({window:l,workspace:a.workspace}),a}async z(l,r,i){return i?(0,o.$Qh)(l.openedWorkspace)&&u.$_f.isEqual(l.openedWorkspace.configPath,i)?!1:(0,$.$75b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,u.$fg)(i)),detail:(0,m.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(l,r){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority})),(0,o.$Qh)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=r,l.config.backupPath=i,{workspace:r,backupPath:i}}};e.$05b=h,e.$05b=h=Ee([ee(0,f.$D5b),ee(1,b.$5i),ee(2,g.$L5b),ee(3,w.$W5b),ee(4,y.$45b)],h)}),define(te[131],ie([0,1,15,38,22,6,30,29,53,12,5,60]),function(K,e,S,R,s,M,D,E,u,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$b6b=(0,M.$Bh)(e.ID);let y=class{constructor(v,b,g){this.a=v,this.b=b,this.c=g}async getRemoteDiagnostics(v){const b=this.a.getWindows();return(await Promise.all(b.map(async $=>{const o=$.remoteAuthority;if(!o)return;const d=`vscode:getDiagnosticInfoResponse${$.id}`,P={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(h=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:d,args:P}),R.$ZS.once(d,(t,l)=>{l||h({hostName:o,errorMessage:`Unable to resolve connection to '${o}'.`}),h(l)}),setTimeout(()=>{h({hostName:o,errorMessage:`Connection to '${o}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const g of S.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(g.id);$?v.push(await this.d($)):v.push(this.e(g))}const b=[];for(const{pid:g,name:$}of w.$$5b.getAll())b.push({pid:g,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:b,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const b=await this.f(v),g=(0,c.$uf)(v.win);return this.e(g,b,v.remoteAuthority)}e(v,b=[],g){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:b,remoteAuthority:g}}async f(v){const b=[],g=v.openedWorkspace;if((0,E.$Lh)(g))b.push(g.uri);else if((0,E.$Qh)(g)){const $=await this.b.resolveLocalWorkspace(g.configPath);$&&$.folders.forEach(d=>{b.push(d.uri)})}return b}};e.$c6b=y,e.$c6b=y=Ee([ee(0,D.$R5b),ee(1,u.$95b),ee(2,m.$5i)],y)}),define(te[66],ie([0,1,47,15,27,155,54,3,2,13,9,4,7,105,86,21,103,180,59,28,6,20,5,24,78,30,29,53,17,243,235]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=e.$s6b=void 0,e.$s6b=(0,P.$Bh)("nativeHostMainService");let p=class extends u.$kc{constructor(L,U,q,se,x,ae,ne,re){super(),this.a=L,this.b=U,this.c=q,this.f=se,this.g=x,this.h=ae,this.j=ne,this.m=re,this.onDidOpenWindow=E.Event.map(this.a.onDidOpenWindow,Y=>Y.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Y,x:J,y:H})=>({windowId:Y.id,x:J,y:H})),({windowId:Y})=>!!this.a.getWindowById(Y)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(Y,J)=>J.id),Y=>!!this.a.getWindowById(Y)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(Y,J)=>J.id),Y=>!!this.a.getWindowById(Y)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(Y,J)=>J.id),Y=>!!this.a.getWindowById(Y)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),E.Event.filter(E.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(Y,J)=>J.id),Y=>!!this.a.getWindowById(Y))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new E.$fd),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(Y,J,H)=>H),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),E.Event.fromNodeEventEmitter(R.screen,"display-added"),E.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$Ph)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const U=R.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(L,U,q){return Array.isArray(U)?this.r(L,U,q):this.s(L,U)}async r(L,U,q=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:U,cli:this.f.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async s(L,U){await this.a.openEmptyWindow({context:5,contextWindowId:L},U)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const U=this.C(L);return U?.win?U.win.isMaximized():!1}async maximizeWindow(L){const U=this.C(L);U?.win&&U.win.maximize()}async unmaximizeWindow(L){const U=this.C(L);U?.win&&U.win.unmaximize()}async minimizeWindow(L){const U=this.C(L);U?.win&&U.win.minimize()}async updateWindowControls(L,U){const q=this.C(L);q&&q.updateWindowControls(U)}async focusWindow(L,U){U&&typeof U.windowId=="number"&&(L=U.windowId),this.C(L)?.focus({force:U?.force??!1})}async setMinimumSize(L,U,q){const se=this.C(L);if(se?.win){const[x,ae]=se.win.getSize(),[ne,re]=se.win.getMinimumSize(),[Y,J]=[U??ne,q??re],[H,F]=[Math.max(x,Y),Math.max(ae,J)];(ne!==Y||re!==J)&&se.win.setMinimumSize(Y,J),(x!==H||ae!==F)&&se.win.setSize(H,F)}}async saveWindowSplash(L,U){this.j.saveWindowSplash(L,U)}async installShellCommand(L){const{source:U,target:q}=await this.t();try{const{symbolicLink:se}=await b.SymlinkSupport.stat(U);if(se&&!se.dangling){const x=await(0,f.$Wp)(U);if(q===x)return}await b.Promises.unlink(U)}catch(se){if(se.code!=="ENOENT")throw se}try{await b.Promises.symlink(q,U)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:x}=await this.showMessageBox(L,{type:"info",message:(0,$.localize)(0,null,this.h.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(x===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ae)}catch{throw new Error((0,$.localize)(3,null,U))}}}async uninstallShellCommand(L){const{source:U}=await this.t();try{await b.Promises.unlink(U)}catch(q){switch(q.code){case"EACCES":{const{response:se}=await this.showMessageBox(L,{type:"info",message:(0,$.localize)(4,null,this.h.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(se===0)try{const x=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(x)}catch{throw new Error((0,$.localize)(7,null,U))}break}case"ENOENT":break;default:throw q}}}async t(){const L=(0,m.$0d)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(L))throw new Error((0,$.localize)(8,null,L));return{source:U,target:L}}async showMessageBox(L,U){return this.b.showMessageBox(U,this.u(L))}async showSaveDialog(L,U){return this.b.showSaveDialog(U,this.u(L))}async showOpenDialog(L,U){return this.b.showOpenDialog(U,this.u(L))}u(L){const U=this.C(L);if(U?.win)return U.win}async pickFileFolderAndOpen(L,U){const q=await this.b.pickFileFolder(U);q&&await this.w(await Promise.all(q.map(async se=>await b.SymlinkSupport.existsDirectory(se)?{folderUri:y.URI.file(se)}:{fileUri:y.URI.file(se)})),U,L)}async pickFolderAndOpen(L,U){const q=await this.b.pickFolder(U);q&&await this.w(q.map(se=>({folderUri:y.URI.file(se)})),U,L)}async pickFileAndOpen(L,U){const q=await this.b.pickFile(U);q&&await this.w(q.map(se=>({fileUri:y.URI.file(se)})),U,L)}async pickWorkspaceAndOpen(L,U){const q=await this.b.pickWorkspace(U);q&&await this.w(q.map(se=>({workspaceUri:y.URI.file(se)})),U,L)}async w(L,U,q){await this.a.open({context:3,contextWindowId:q,cli:this.f.args,urisToOpen:L,forceNewWindow:U.forceNewWindow})}async showItemInFolder(L,U){R.shell.showItemInFolder(U)}async setRepresentedFilename(L,U){this.C(L)?.setRepresentedFilename(U)}async setDocumentEdited(L,U){this.C(L)?.setDocumentEdited(U)}async openExternal(L,U){return this.f.unsetSnapExportedVariables(),R.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,U){return R.shell.trashItem(U)}async isAdmin(){let L;return w.$i?L=(await new Promise((U,q)=>{K(["native-is-elevated"],U,q)}))():L=process.getuid?.()===0,L}async writeElevated(L,U,q,se){const x=await new Promise((ae,ne)=>{K(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const re=[`"${this.z}"`];se?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${U.fsPath}"`,`"${q.fsPath}"`);const Y={name:this.h.nameLong.replace("-",""),icns:w.$j&&this.f.isBuilt?(0,m.$9d)((0,m.$_d)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};x.exec(re.join(" "),Y,(J,H,F)=>{H&&this.g.trace(`[sudo-prompt] received stdout: ${H}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),J?ne(J):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.$k||w.$i?!1:R.app.runningUnderARM64Translation}get z(){return w.$i?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.bat"):w.$k?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,m.$9d)(this.f.appRoot,"bin","code"):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Hm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$i&&(0,I.$q6b)()}async killProcess(L,U,q){process.kill(U,q)}async readClipboardText(L,U){return R.clipboard.readText(U)}async writeClipboardText(L,U,q){return R.clipboard.writeText(U,q)}async readClipboardFindText(L){return R.clipboard.readFindText()}async writeClipboardFindText(L,U){return R.clipboard.writeFindText(U)}async writeClipboardBuffer(L,U,q,se){return R.clipboard.writeBuffer(U,Buffer.from(q.buffer),se)}async readClipboardBuffer(L,U){return k.$Fd.wrap(R.clipboard.readBuffer(U))}async hasClipboard(L,U,q){return R.clipboard.has(U,q)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,U){this.C(L)?.updateTouchBar(U)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,U){return this.c.relaunch(U)}async reload(L,U){const q=this.C(L);if(q){if((0,n.$Qh)(q.openedWorkspace)){const se=q.openedWorkspace.configPath;if(se.scheme===c.Schemas.file&&(await this.m.resolveLocalWorkspace(se))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.c.reload(q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,U){const q=this.C(U);if(q?.win)return q.win.close()}async quit(L){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(L,U){await this.c.kill(U)}async resolveProxy(L,U){return this.C(L)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(L,U,q,se,x=1){return(0,g.$6f)(U,q,se,x)}async openDevTools(L,U){const q=this.C(L);q?.win&&q.win.webContents.openDevTools(U)}async toggleDevTools(L){const U=this.C(L);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(L,U){const q=this.C(L);q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&q.win.webContents.sendInputEvent(U)}async profileRenderer(L,U,q){const se=this.C(L);if(!se||!se.win)throw new Error;return await new C.$r6b(se.win,U,this.g).inspect(q)}async windowsGetStringRegKey(L,U,q,se){if(!w.$i)return;const x=await new Promise((ae,ne)=>{K(["@vscode/windows-registry"],ae,ne)});try{return x.GetStringRegKey(U,q,se)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$t6b=p,Ee([D.$6g],p.prototype,"z",null),e.$t6b=p=Ee([ee(0,i.$R5b),ee(1,o.$45b),ee(2,h.$F5b),ee(3,d.$D5b),ee(4,t.$5i),ee(5,l.$kj),ee(6,r.$o6b),ee(7,a.$95b)],p)}),define(te[299],ie([0,1,15,38,27,2,13,4,107,178,90,131,59,28,5,66,76,24,77,79,32,34,60,22,7,30,8]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$v6b=void 0;const k="issue.processExplorerWindowState";let I=class{static{a=this}static{this.a="#1E1E1E"}constructor(A,L,U,q,se,x,ae,ne,re,Y,J){this.g=A,this.h=L,this.i=U,this.j=q,this.k=se,this.l=x,this.m=ae,this.n=ne,this.o=re,this.p=Y,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){R.$ZS.on("vscode:listProcesses",async A=>{const L=[];try{L.push({name:(0,c.localize)(0,null),rootProcess:await(0,u.$sr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,m.$hm)(q)?L.push({name:q.hostName,rootProcess:q}):q.processes&&L.push({name:q.hostName,rootProcess:q.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(A,"vscode:listProcessesResponse",L)}),R.$ZS.on("vscode:workbenchCommand",(A,L)=>{const{id:U,from:q,args:se}=L;let x;switch(q){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${q}`)}x?.webContents.send("vscode:runAction",{id:U,from:q,args:se})}),R.$ZS.on("vscode:closeProcessExplorer",A=>{this.d?.close()}),R.$ZS.on("vscode:pidToNameRequest",async A=>{const L=await this.k.getMainDiagnostics(),U=[];for(const q of L.windows)U.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:se}of t.$$5b.getAll())U.push([q,se]);this.t(A,"vscode:pidToNameResponse",U)})}async openReporter(A){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),q=this.v(this.c,700,800);this.b=this.u(q,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:A,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:g.default}),this.b.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(A){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),q=this.p.getItem(k,void 0),se=C(q)?q:this.v(this.f,800,500);this.d=this.u(se,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:A,product:g.default}),this.d.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const x=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const re={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(k,re)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const A=await S.contentTracing.stopRecording(`${(0,P.$Qf)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,A),buttons:[(0,c.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(A,L)}async $getSystemInfo(){const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(A,L)}async $getPerformanceInfo(){try{const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(A,L)}catch(A){throw this.i.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(A){this.i.error(A)}}async $showConfirmCloseDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);A===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return A===0}return!1}async $getIssueReporterUri(A){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(q,se)=>{const x=new l.$pd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:U,extensionId:A}),R.$ZS.once(U,(ae,ne)=>{q(r.URI.parse(ne))});try{await(0,n.$Hg)(5e3),x.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{R.$ZS.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(A){A.isMinimized()&&A.restore(),A.focus()}t(A,L,...U){A.sender.isDestroyed()||A.sender.send(L,...U)}u(A,L,U,q){const se=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:U.title,backgroundColor:U.backgroundColor||a.a,webPreferences:{preload:D.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,d.$YC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}v(A,L,U){let q;const se=S.screen.getAllDisplays();if(se.length===1)q=se[0];else{if(E.$j){const ne=S.screen.getCursorScreenPoint();q=S.screen.getDisplayNearestPoint(ne)}!q&&A&&(q=S.screen.getDisplayMatching(A.getBounds())),q||(q=S.screen.getPrimaryDisplay()||se[0])}const x=q.bounds,ae={width:L,height:U,x:x.x+x.width/2-L/2,y:x.y+x.height/2-U/2};return x.width>0&&x.height>0&&(ae.x<x.x&&(ae.x=x.x),ae.y<x.y&&(ae.y=x.y),ae.x>x.x+x.width&&(ae.x=x.x),ae.y>x.y+x.height&&(ae.y=x.y),ae.width>x.width&&(ae.width=x.width),ae.height>x.height&&(ae.height=x.height)),ae}};e.$v6b=I,e.$v6b=I=a=Ee([ee(1,f.$D5b),ee(2,v.$5i),ee(3,m.$gm),ee(4,w.$b6b),ee(5,y.$45b),ee(6,b.$s6b),ee(7,o.$u6b),ee(8,$.$kj),ee(9,h.$jN),ee(10,i.$R5b)],I);function C(p){return typeof p!="object"||p===null?!1:"x"in p&&"y"in p&&"width"in p&&"height"in p}}),define(te[300],ie([0,1,22,18,28,20,5,66,24,50,25,48,100]),function(K,e,S,R,s,M,D,E,u,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;let f=class extends y.$W6b{constructor(b,g,$,o,d,P,h,t){super(b,g,o,d,P,t),this.e=$,this.u=h}s(b){return(0,y.$V6b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(w.$YT.CheckingForUpdates(b)),this.i.request({url:this.a},S.CancellationToken.None).then(c.$Oo).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(w.$YT.Idle(1))):this.d(w.$YT.AvailableForDownload(g))}).then(void 0,g=>{this.j.error(g),this.e.publicLog2("update:notAvailable",{explicit:!!b});const $=b?g.message||g:void 0;this.d(w.$YT.Idle(1,$))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(w.$YT.Idle(1))}};e.$Y6b=f,e.$Y6b=f=Ee([ee(0,M.$F5b),ee(1,R.$8h),ee(2,m.$9k),ee(3,s.$D5b),ee(4,c.$Io),ee(5,D.$5i),ee(6,E.$s6b),ee(7,u.$kj)],f)}),define(te[301],ie([0,1,47,45,27,8,22,54,9,7,142,21,18,28,16,20,5,66,24,50,25,48,100]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=void 0;async function l(a,k=1e3){for(;!a();)await(0,M.$Hg)(k)}let r;function i(){return typeof r>"u"&&(r=R.existsSync(u.$9d(u.$_d(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$W6b{get cachePath(){const k=u.$9d((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,I,C,p,A,L,U,q,se){super(k,I,p,A,L,se),this.u=C,this.v=U,this.w=q,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$YT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(k){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$V6b)(I,k,this.k)}t(k){this.a&&(this.d(h.$YT.CheckingForUpdates(k)),this.i.request({url:this.a},D.CancellationToken.None).then(d.$Oo).then(I=>{const C=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!k}),this.d(h.$YT.Idle(C)),Promise.resolve(null)):C===1?(this.d(h.$YT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(h.$YT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(p=>w.Promises.exists(p).then(A=>{if(A)return Promise.resolve(p);const L=I.url,U=I.hash,q=`${p}.tmp`;return this.i.request({url:L},D.CancellationToken.None).then(se=>this.v.writeFile(c.URI.file(q),se.stream)).then(U?()=>(0,m.$US)(q,I.hash):()=>{}).then(()=>w.Promises.rename(q,p,!1)).then(()=>p)})).then(p=>{const A=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:p},A?this.k.target==="user"?this.p():this.d(h.$YT.Downloaded(I)):this.d(h.$YT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!k});const C=k?I.message||I:void 0;this.d(h.$YT.Idle(i(),C))}))}async o(k){k.update.url&&this.w.openExternal(void 0,k.update.url),this.d(h.$YT.Idle(i()))}async B(k){const I=await this.cachePath;return u.$9d(I,`CodeSetup-${this.k.quality}-${k}.exe`)}async C(k=null){const I=k?L=>!new RegExp(`${this.k.quality}-${k}\\.exe$`).test(L):()=>!0,C=await this.cachePath,A=(await w.Promises.readdir(C)).filter(I).map(async L=>{try{await w.Promises.unlink(u.$9d(C,L))}catch{}});await Promise.all(A)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const k=this.state.update;this.d(h.$YT.Updating(k));const I=await this.cachePath;this.e.updateFilePath=u.$9d(I,`CodeSetup-${this.k.quality}-${k.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$YT.Idle(i()))});const p=`${this.k.win32MutexName}-ready`,A=await new Promise((L,U)=>{K(["@vscode/windows-mutex"],L,U)});l(()=>A.isActive(p)).then(()=>this.d(h.$YT.Ready(k)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown"};this.d(h.$YT.Downloading(C)),this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(h.$YT.Downloaded(C)):this.d(h.$YT.Ready(C))}};e.$16b=n,Ee([E.$6g],n.prototype,"cachePath",null),e.$16b=n=Ee([ee(0,b.$F5b),ee(1,y.$8h),ee(2,P.$9k),ee(3,f.$D5b),ee(4,d.$Io),ee(5,g.$5i),ee(6,v.$6j),ee(7,$.$s6b),ee(8,o.$kj)],n)}),define(te[302],ie([0,1,15,8,22,49,3,2,13,9,64,4,7,188,63,18,59,28,62,16,20,5,24,77,252,81,25,102,78,79,30,29,53,127,134,39,34,52,65,23]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C,p,A,L,U,q,se,x,ae,ne){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;var Y;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(Y||(Y={}));let J=class extends E.$kc{static{re=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,p.$Ph)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,N,G,Z,_,oe,T,O,j,z,W,B,V,ce,de,he,fe,ve,be,ye){super(),this.N=N,this.O=G,this.P=Z,this.Q=_,this.R=oe,this.S=T,this.U=O,this.W=j,this.X=z,this.Y=W,this.Z=B,this.$=V,this.ab=ce,this.bb=de,this.db=he,this.eb=fe,this.fb=ve,this.gb=be,this.hb=ye,this.b=this.B(new D.$fd),this.onWillLoad=this.b.event,this.c=this.B(new D.$fd),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$fd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$fd),this.onDidClose=this.g.event,this.h=this.B(new D.$fd),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ce,je]=this.sb(F.state);this.s=Ce,this.N.trace("window#ctor: using window state",Ce);const me=this.s.mode===0||this.s.mode===3,we=this.X.getValue("window"),X={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:I.$RC.WIDTH,minHeight:I.$RC.HEIGHT,show:!me,title:this.eb.nameLong,webPreferences:{preload:u.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$YC)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};w.$k?X.icon=(0,c.$9d)(this.P.appRoot,"resources/linux/code.png"):w.$i&&!this.P.isBuilt&&(X.icon=(0,c.$9d)(this.P.appRoot,"resources/win32/code_150x150.png")),w.$j&&!this.zb()&&(X.fullscreenable=!1),w.$j&&(X.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(X.acceptFirstMouse=!1));const le=w.$j&&we?.nativeTabs===!0;le&&(X.tabbingIdentifier=this.eb.nameShort);const ge=(0,I.$WC)(this.X)==="custom";if(ge&&(X.titleBarStyle="hidden",w.$j||(X.frame=!1),(0,I.$XC)(this.X))){const Pe=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Re=U.$Os.fromHex(Pe).isDarker()?"#FFFFFF":"#000000";X.titleBarOverlay={height:29,color:Pe,symbolColor:Re},this.D=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(X),(0,m.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,w.$j&&ge&&this.m.setSheetOffset(22),ge&&(w.$i&&(0,I.$XC)(this.X)||w.$j)){const Pe=this.hb.getItem(re.a);Pe&&this.updateWindowControls({height:Pe})}w.$i&&ge&&this.m.hookWindowMessage(278,()=>{const[Re,Ue]=this.m.getPosition(),Oe=S.screen.getCursorScreenPoint(),Be=Oe.x-Re,We=Oe.y-Ue;return(()=>!(Be>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:Be,y:We})),0}),(w.$j||w.$i)&&je&&(!le||S.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),me&&((0,m.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){w.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return w.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){w.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return w.$j?this.m.isDocumentEdited():!!this.C}focus(F){w.$j&&F?.force&&S.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){G.dispose(),Z.dispose(),F()}const G=this.onDidClose(()=>N()),Z=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.mb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,Z)=>this.mb(3,{reason:Z,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),S.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),S.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,G)=>{const Z=await this.lb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,Z)})})}lb(){return this.kb||(this.kb=(0,r.$3o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,N){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:Z}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.m);if(G!==2){const _=G===0;await this.nb(_,Z)}}else if(F===2){let G;N?G=(0,f.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,f.localize)(6,null);const{response:Z,checkboxChecked:_}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:G,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.m),oe=Z===0;await this.nb(oe,_)}break}}async nb(F,N){const G=this.r?.workspace;if(N&&G)try{const Z=this.W.workspaceStorage(G);await Z.init(),Z.delete("memento/workbench.parts.editor"),await Z.close()}catch(Z){this.N.error(Z)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let Z,_;(0,p.$Lh)(G)?Z={folderUri:G.uri}:(0,p.$Qh)(G)?Z={workspaceUri:G.configPath}:_=!0,(0,ne.$Mb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:_,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||G!==this.I)){this.H=N,this.I=G;const Z=N||"",_=G?`${G},<local>`:"<local>";this.N.trace(`Setting proxy to '${Z}', bypassing '${_}'`),this.m.webContents.session.setProxy({proxyRules:Z,proxyBypassRules:_,pacScript:""})}}}addTabbedWindow(F){w.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,N),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(u.$2f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new R.$Sg(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:N.isReload?3:G?2:1})}qb(F,N){const G=(this.r??this.L)?.userEnv;if(G){const Z=(0,o.$Gl)(G)&&!(0,o.$Gl)(F.userEnv),_=this.isExtensionDevelopmentHost;(Z||_)&&(F.userEnv={...G,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.J.update(F)}async reload(F){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,p.$Qh)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===u.Schemas.file&&!await this.S.exists(N))return}else if((0,p.$Lh)(F.workspace)){const N=F.workspace.uri;if(N.scheme===u.Schemas.file&&!await this.S.exists(N))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,L.$C5b)();if(this.isFullScreen){let G;try{G=S.screen.getDisplayMatching(this.getBounds())}catch{}const Z=(0,L.$C5b)();return{mode:3,display:G?G.id:void 0,width:this.s.width||Z.width,height:this.s.height||Z.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let N;if(!w.$j&&this.m.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),F.x=G.x,F.y=G.y,F.width=G.width,F.height=G.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(re.a,F.height),w.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(w.$j&&F.height!==void 0){const N=(F.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(F){(0,m.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const G=S.screen.getAllDisplays();N=G.length>1,F=this.tb(F,G)}catch(G){this.N.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,L.$C5b)(),N]}tb(F,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const _=this.ub(N[0]);if(_){let oe=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!_||(F.x<_.x&&(F.x=_.x),F.y<_.y&&(F.y=_.y))};this.N.trace("window#validateWindowState: 1 monitor working area",_),oe(),F.width>_.width&&(F.width=_.width),F.height>_.height&&(F.height=_.height),F.x>_.x+_.width-128&&(F.x=_.x+_.width-F.width),F.y>_.y+_.height-128&&(F.y=_.y+_.height-F.height),oe()}return F}if(F.display&&F.mode===3){const _=N.find(oe=>oe.id===F.display);if(_&&typeof _.bounds?.x=="number"&&typeof _.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,L.$C5b)(3);return oe.x=_.bounds.x,oe.y=_.bounds.y,oe}}let G,Z;try{G=S.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Z=this.ub(G)}catch{}if(G&&Z&&F.x+F.width>Z.x&&F.y+F.height>Z.y&&F.x<Z.x+Z.width&&F.y<Z.y+Z.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Z),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this.m.getPosition(),[G,Z]=this.m.getSize();return{x:F,y:N,width:G,height:Z}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return w.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){w.$j&&(this.u=F,this.w=new R.$2g,Promise.race([this.w.p,(0,R.$Hg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,I.$VC)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,N=!0){w.$j||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const N=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,N,...G){this.isReady?this.send(F,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...G)})}send(F,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...N)}catch(G){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,M.$mi)(G)}`)}}}updateTouchBar(F){w.$j&&this.G.forEach((N,G)=>{const Z=F[G];N.segments=this.Fb(Z)})}Db(){if(w.$j){for(let F=0;F<10;F++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new S.TouchBar({items:this.G}))}}Eb(F=[]){const N=this.Fb(F),G=new S.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:Z=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:G.segments[Z].id,from:"touchbar"})}});return G}Fb(F=[]){return F.map(G=>{let Z;G.icon&&!a.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===u.Schemas.file&&(Z=S.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),Z.isEmpty()&&(Z=void 0));let _;return typeof G.title=="string"?_=G.title:_=G.title.value,{id:G.id,label:Z?void 0:_,icon:Z}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$96b=J,e.$96b=J=re=Ee([ee(1,h.$5i),ee(2,ae.$K6b),ee(3,$.$D5b),ee(4,q.$0m),ee(5,x.$L5b),ee(6,d.$6j),ee(7,i.$P5b),ee(8,i.$N5b),ee(9,b.$8h),ee(10,k.$o6b),ee(11,A.$95b),ee(12,v.$W5b),ee(13,n.$9k),ee(14,g.$45b),ee(15,P.$F5b),ee(16,t.$kj),ee(17,l.$u6b),ee(18,C.$R5b),ee(19,se.$jN)],J)}),define(te[82],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,81,97,29,53,33]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=e.$F6b=void 0,e.$F6b=(0,v.$Bh)("workspacesHistoryMainService");let l=class extends E.$kc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,a,k){super(),this.f=i,this.g=n,this.h=a,this.j=k,this.c=this.B(new M.$fd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Eg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],a=[];for(const I of i)if((0,o.$lU)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.u(n,I.workspace)&&n.push(I);else if((0,o.$mU)(I))this.w(n,I.folderUri)||n.push(I);else{const C=this.y(a,I.fileUri),p=I.fileUri.scheme===u.Schemas.file&&t.F.indexOf((0,m.$fg)(I.fileUri))>=0;!C&&!p&&(a.push(I),c.$i&&I.fileUri.scheme===u.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const k=await this.n({workspaces:n,files:a});n=k.workspaces,a=k.files,n.length>t.a&&(n.length=t.a),a.length>t.a&&(a.length=t.a),await this.s({workspaces:n,files:a}),this.c.fire(),c.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=C=>{const p=this.t(C);for(const A of i)if(m.$_f.isEqual(A,p))return!1;return!0},a=await this.getRecentlyOpened(),k=a.workspaces.filter(n),I=a.files.filter(n);(k.length!==a.workspaces.length||I.length!==a.files.length)&&(await this.s({files:I,workspaces:k}),this.c.fire(),c.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new h.$zi(I=>m.$_f.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.t(I),I);const a=new h.$zi(I=>m.$_f.getComparisonKey(I));if(i?.files)for(const I of i.files)a.set(this.t(I),I);const k=await this.r();for(const I of k.workspaces){const C=n.get(this.t(I));C?C.label=C.label??I.label:n.set(this.t(I),I)}for(const I of k.files){const C=a.get(this.t(I));C?C.label=C.label??I.label:a.set(this.t(I),I)}return{workspaces:[...n.values()],files:[...a.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,o.$sU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,o.$tU)(i)),-1,1)}t(i){return(0,o.$mU)(i)?i.folderUri:(0,o.$nU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(a=>(0,o.$lU)(a)&&a.workspace.id===n.id)}w(i,n){return!!i.find(a=>(0,o.$mU)(a)&&m.$_f.isEqual(a.folderUri,n))}y(i,n){return!!i.find(a=>m.$_f.isEqual(a.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){c.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!c.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of S.app.getJumpListSettings().removedItems){const C=I.args;if(C){const p=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);p&&n.push(w.URI.parse(p[2]))}}await this.removeRecentlyOpened(n);let a=!1;const k=(0,R.$Fb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(I=>{const C=(0,o.$lU)(I)?I.workspace:I.folderUri,{title:p,description:A}=this.J(C,I.label);let L;return w.URI.isUri(C)?L=`--folder-uri "${C.toString()}"`:(a=!0,L=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:p.substr(0,255),description:A.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&i.push({type:"custom",name:a?(0,f.localize)(2,null):(0,f.localize)(3,null),items:k})}i.push({type:"recent"});try{const n=S.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,D.$qv)(n).name,description:n};if(w.URI.isUri(i))return{title:(0,m.$fg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let a=(0,m.$fg)(i.configPath);return a.endsWith(d.$Xh)&&(a=a.substr(0,a.length-d.$Xh.length-1)),{title:(0,f.localize)(5,null,a),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,D.$iv)(i.fsPath):i.toString()}async M(){if(!c.$j)return;S.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let a=0;for(let I=0;I<i.workspaces.length&&a<t.z;I++){const C=this.t(i.workspaces[I]);if(C.scheme===u.Schemas.file){const p=(0,m.$9f)(C);await y.Promises.exists(p)&&(n.push(p),a++)}}const k=[];for(let I=0;I<i.files.length&&a<t.C;I++){const C=this.t(i.files[I]);if(C.scheme===u.Schemas.file){const p=(0,m.$9f)(C);if(t.F.includes((0,m.$fg)(C))||n.includes(p))continue;await y.Promises.exists(p)&&(k.push(p),a++)}}k.reverse().forEach(I=>S.app.addRecentDocument(I)),n.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$G6b=l,e.$G6b=l=t=Ee([ee(0,g.$5i),ee(1,P.$95b),ee(2,b.$F5b),ee(3,$.$P5b)],l)}),define(te[303],ie([0,1,15,8,22,46,4,7,179,18,28,20,5,230,66,24,34,25,48,79,30,82]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;const l="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(a,k,I,C,p,A,L,U,q,se,x){this.n=a,this.o=k,this.p=I,this.q=C,this.r=p,this.s=A,this.t=L,this.u=U,this.v=q,this.w=se,this.x=x,this.m=Object.create(null),this.g=new R.$Sg(()=>this.E(),0),this.h=new R.$Sg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,d.$WC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(t.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(A,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(A,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(A,L,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(A,L,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(A,L,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.youTubeUrl;a&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(a,"openYouTubeUrl"));const k=this.x.requestFeatureUrl;k&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(k,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const C=this.x.licenseUrl;C&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$v){const A=C.indexOf("?")>0?"&":"?";this.Z(`${C}${A}lang=${D.$v}`,"openLicenseUrl")}else this.Z(C,"openLicenseUrl")});const p=this.x.privacyStatementUrl;p&&C&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(p,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!D.$j)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,k){this.k=a.menus,this.l=a.keybindings,this.t.setItem(t.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){D.$j&&(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){D.$j&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=S.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(D.$j?new S.Menu:null);return}const k=new S.Menu;let I;if(D.$j){const p=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:p}),this.I(p),k.append(I)}if(D.$j&&!this.c){this.c=!0;const p=new S.Menu;p.append(new S.MenuItem({label:this.ab(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(p)}if(this.K("File")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(1,null)),submenu:p});this.M(p,"File"),k.append(A)}if(this.K("Edit")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(2,null)),submenu:p});this.M(p,"Edit"),k.append(A)}if(this.K("Selection")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(3,null)),submenu:p});this.M(p,"Selection"),k.append(A)}if(this.K("View")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(4,null)),submenu:p});this.M(p,"View"),k.append(A)}if(this.K("Go")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(5,null)),submenu:p});this.M(p,"Go"),k.append(A)}if(this.K("Run")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(6,null)),submenu:p});this.M(p,"Run"),k.append(A)}if(this.K("Terminal")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(7,null)),submenu:p});this.M(p,"Terminal"),k.append(A)}let C;if(this.K("Window")){const p=new S.Menu;C=new S.MenuItem({label:this.ab(u.localize(8,null)),submenu:p,role:"window"}),this.S(p)}if(C&&k.append(C),this.K("Help")){const p=new S.Menu,A=new S.MenuItem({label:this.ab(u.localize(9,null)),submenu:p,role:"help"});this.M(p,"Help"),k.append(A)}k.items&&k.items.length>0?S.Menu.setApplicationMenu(k):S.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const k=this.U(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let C;if(this.K("Preferences")){const ae=new S.Menu;this.M(ae,"Preferences"),C=new S.MenuItem({label:this.ab(u.localize(11,null)),submenu:ae})}const p=new S.Menu,A=new S.MenuItem({label:u.localize(12,null),role:"services",submenu:p}),L=new S.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new S.MenuItem({label:u.localize(15,null),role:"unhide"}),se=new S.MenuItem(this.Y("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(ae,ne,re)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Y?.isMinimized())&&await this.J(re)&&this.w.quit(void 0)}})),x=[k];x.push(...I),C&&x.push(i(),C),x.push(i(),A,i(),L,U,q,i(),se),x.forEach(ae=>a.append(ae))}async J(a){if(this.p.getWindowCount()===0)return!0;const k=this.o.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.Q(a)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return I===0}return!0}K(a){if(!D.$j&&(0,d.$WC)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,k){k.forEach(I=>{if((0,f.$C6b)(I))a.append(i());else if((0,f.$B6b)(I)){const C=new S.Menu,p=new S.MenuItem({label:this.ab(I.label),submenu:C});this.L(C,I.submenu.items),a.append(p)}else(0,f.$D6b)(I)?a.append(this.O(I)):(0,f.$E6b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(a),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?a.append(new S.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):a.append(this.U(I.label,I.id,!1,I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(a,k){this.k&&this.k[k]&&this.L(a,this.k[k].items)}N(a){const k=this.T();k.length&&(k.forEach(I=>a.append(I)),a.append(i()))}O(a){const k=E.URI.revive(a.uri),I=a.id,C=I==="openRecentFile"?{fileUri:k}:I==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new S.MenuItem(this.Y(I,{label:a.label,click:async(p,A,L)=>{const U=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[C],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([k])}},!1))}P(a){return!!(a&&(!D.$j&&(a.ctrlKey||a.shiftKey)||D.$j&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,k,I){const C={label:this.ab(a),role:I,enabled:!0};return new S.MenuItem(this.X(k,C))}S(a){const k=new S.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),C=new S.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),p=this.U(u.localize(23,null),"workbench.action.switchWindow"),A=[];this.C&&(A.push(i()),A.push(this.U(u.localize(24,null),"workbench.action.newWindowTab")),A.push(this.R(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.R(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.R(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.R(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,I,i(),p,...A,i(),C].forEach(L=>a.append(L))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(u.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(u.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(u.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(a,k,I,C){const p=this.ab(a),A=typeof k=="function"?k:(x,ae,ne)=>{const re=x?x.userSettingsLabel:null;let Y=k;Array.isArray(k)&&(Y=this.P(ne)?k[1]:k[0]),re&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:re}):this.W({type:"commandId",commandId:Y})},L=typeof I=="boolean"?I:this.p.getWindowCount()>0,U=typeof C=="boolean"?C:!1,q={label:p,click:A,enabled:L};U&&(q.type="checkbox",q.checked=U);let se;return typeof k=="string"?se=k:Array.isArray(k)&&(se=k[0]),D.$j&&(se==="editor.action.clipboardCutAction"?q.role="cut":se==="editor.action.clipboardCopyAction"?q.role="copy":se==="editor.action.clipboardPasteAction"&&(q.role="paste"),se==="undo"?q.click=this.V(A,{inDevTools:x=>x.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?q.click=this.V(A,{inDevTools:x=>x.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(q.click=this.V(A,{inDevTools:x=>x.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(se,q))}V(a,k){return(I,C,p)=>{const A=S.BrowserWindow.getFocusedWindow();if(!A)return k.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return k.inDevTools(A.webContents.devToolsWebContents);a(I,C||A,p)}}W(a){let k=S.BrowserWindow.getFocusedWindow();if(!k){const C=this.p.getLastActiveWindow();C?.isMinimized()&&(k=C.win)}const I=k?this.p.getWindowById(k.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",a),D.$j&&!this.q.isBuilt&&!I.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const C={id:a.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,C)}else{const C={userSettingsLabel:a.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,C)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,k){const I=typeof a=="string"?this.l[a]:void 0;if(I?.label){if(I.isNative!==!1)k.accelerator=I.label,k.userSettingsLabel=I.userSettingsLabel;else if(typeof k.label=="string"){const C=k.label.indexOf("[");C>=0?k.label=`${k.label.substr(0,C)} [${I.label}]`:k.label=`${k.label} [${I.label}]`}}else k.accelerator=void 0;return k}Y(a,k,I=!k.accelerator){I&&(k=this.X(a,k));const C=k.click;return k.click=(p,A,L)=>{this.$(a),C?.(p,A,L)},k}Z(a,k){this.w.openExternal(void 0,a),this.$(k)}$(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:l})}ab(a){return(0,M.$nv)(a,!this.B)}};e.$H6b=r,e.$H6b=r=t=Ee([ee(0,o.$ZT),ee(1,c.$8h),ee(2,P.$R5b),ee(3,m.$D5b),ee(4,$.$9k),ee(5,h.$F6b),ee(6,g.$jN),ee(7,w.$F5b),ee(8,y.$5i),ee(9,v.$s6b),ee(10,b.$kj)],r);function i(){return new S.MenuItem({type:"separator"})}}),define(te[304],ie([0,1,6,20,5,303]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=e.$I6b=void 0,e.$I6b=(0,S.$Bh)("menubarMainService");let D=class{constructor(u,c,m){this.b=u,this.c=c,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$H6b)}async updateMenubar(u,c){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(c,u)}};e.$J6b=D,e.$J6b=D=Ee([ee(0,S.$Ah),ee(1,R.$F5b),ee(2,s.$5i)],D)}),define(te[305],ie([0,1,15,21,130,27,23,22,3,32,46,2,13,9,64,4,35,19,12,7,189,63,18,59,28,16,6,20,5,76,77,58,34,79,302,129,298,29,98,82,53,78,39,52,65]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C,p,A,L,U,q,se,x,ae,ne,re,Y,J,H,F){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;function G(oe){return(0,x.$Qh)(oe?.workspace)}function Z(oe){return(0,x.$Lh)(oe?.workspace)}let _=class extends w.$kc{static{N=this}static{this.a=[]}constructor(T,O,j,z,W,B,V,ce,de,he,fe,ve,be,ye,Ce,je,me,we){super(),this.m=T,this.n=O,this.r=j,this.s=z,this.t=W,this.u=B,this.w=V,this.z=ce,this.C=de,this.D=he,this.F=fe,this.G=ve,this.H=be,this.I=ye,this.J=Ce,this.L=je,this.M=me,this.N=we,this.b=this.B(new u.$fd),this.onDidOpenWindow=this.b.event,this.c=this.B(new u.$fd),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new u.$fd),this.onDidDestroyWindow=this.f.event,this.g=this.B(new u.$fd),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new u.$fd),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.$06b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(T=>this.c.fire(T.window))),this.B(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const O=new w.$jc;if(O.add(u.Event.any(T.onDidClose,T.onDidDestroy)(()=>O.dispose())),T.config.extensionDevelopmentPath)for(const j of T.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(j));T.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,O){const j=this.w.args,z=O?.remoteAuthority||void 0,W=!0,B=O?.forceReuseWindow,V=!B;return this.open({...T,cli:j,forceEmpty:W,forceNewWindow:V,forceReuseWindow:B,remoteAuthority:z})}openExistingWindow(T,O){T.focus(),this.P(O,[T])}async open(T){this.r.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const O=[],j=[],z=[],W=[],B=[];let V,ce=0;const de=await this.X(T);this.r.trace("windowsManager#open pathsToOpen",de);for(const ye of de)Z(ye)?T.addMode?O.push(ye):j.push(ye):G(ye)?z.push(ye):ye.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),V.filesToOpenOrCreate.push(ye)):ye.backupPath?B.push({backupFolder:(0,f.$ae)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):ce++;T.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),T.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&T.waitMarkerFileURI&&(V.filesToWait={paths:(0,D.$Fb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(W.push(...this.H.getUntitledWorkspaces()),z.push(...W),B.push(...this.D.getEmptyWindowBackups())):B.length=0;const{windows:he,filesOpenedInWindow:fe}=await this.Q(T,z,j,B,ce,V,O);if(this.r.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${j.length}, emptyToRestore: ${B.length}, emptyToOpen: ${ce})`),he.length>1)if(fe)fe.focus();else{const ye=this.j.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Ce=!0,je=!0;if(ye){const me=he.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ce=!1,je=!1)}if(Ce)for(let me=he.length-1;me>=0;me--){const we=he[me];if(!(we.openedWorkspace&&W.some(X=>we.openedWorkspace&&X.workspace.id===we.openedWorkspace.id)||we.backupPath&&B.some(X=>we.backupPath&&X.backupFolder===(0,f.$ae)(we.backupPath)))){we.focus(),je=!1;break}}je&&he[he.length-1].focus()}const ve=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!he.some(ye=>ye.isExtensionDevelopmentHost)&&!ve&&!be&&!T.noRecentEntry){const ye=[];for(const Ce of de)G(Ce)&&!Ce.transient?ye.push({label:Ce.label,workspace:Ce.workspace,remoteAuthority:Ce.remoteAuthority}):Z(Ce)?ye.push({label:Ce.label,folderUri:Ce.workspace.uri,remoteAuthority:Ce.remoteAuthority}):Ce.fileUri&&ye.push({label:Ce.label,fileUri:Ce.fileUri,remoteAuthority:Ce.remoteAuthority});this.G.addRecentlyOpened(ye)}return this.P(T,he),he}P(T,O){const j=T.waitMarkerFileURI;T.context===0&&j&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(j)}catch{}})()}async Q(T,O,j,z,W,B,V){const ce=[];let de;function he(me,we){ce.push(me),we&&(de=me,B=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ve}=this.ib(T);if(!T.initialStartup&&V.length>0){const me=V[0].remoteAuthority,we=this.nb(me);we&&he(this.S(we,V.map(X=>X.workspace.uri)))}const be=j.length+O.length+z.length;if(B&&be===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],we=this.getWindows().filter(le=>B&&(0,$.$ng)(le.remoteAuthority,B.remoteAuthority));let X;me?.fileUri&&!ve&&((T.context===4||T.context===0||T.context===1)&&(X=await(0,q.$65b)(we,me.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),X||(X=this.ob(we))),X?(0,x.$Qh)(X.openedWorkspace)?O.push({workspace:X.openedWorkspace,remoteAuthority:X.remoteAuthority}):(0,x.$Lh)(X.openedWorkspace)?j.push({workspace:X.openedWorkspace,remoteAuthority:X.remoteAuthority}):he(this.R(T,X,B),!0):he(await this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile}),!0)}const ye=(0,D.$Kb)(O,me=>me.workspace.id);if(ye.length>0){const me=(0,D.$Fb)(ye.map(we=>(0,q.$75b)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],X=(0,$.$ng)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;he(this.R(T,we,X),!!X),fe=!0}for(const we of ye){if(me.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const X=we.remoteAuthority,le=(0,$.$ng)(B?.remoteAuthority,X)?B:void 0;he(await this.W(T,we,fe,le),!!le),fe=!0}}const Ce=(0,D.$Kb)(j,me=>$.$_f.getComparisonKey(me.workspace.uri));if(Ce.length>0){const me=(0,D.$Fb)(Ce.map(we=>(0,q.$75b)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],X=(0,$.$ng)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;he(this.R(T,we,X),!!X),fe=!0}for(const we of Ce){if(me.some(ge=>(0,x.$Lh)(ge.openedWorkspace)&&$.$_f.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const X=we.remoteAuthority,le=(0,$.$ng)(B?.remoteAuthority,X)?B:void 0;he(await this.W(T,we,fe,le),!!le),fe=!0}}const je=(0,D.$Kb)(z,me=>me.backupFolder);if(je.length>0)for(const me of je){const we=me.remoteAuthority,X=(0,$.$ng)(B?.remoteAuthority,we)?B:void 0;he(await this.U(T,!0,we,X,me),!!X),fe=!0}if(ce.length===0||B){B&&!W&&W++;const me=B?B.remoteAuthority:T.remoteAuthority;for(let we=0;we<W;we++)he(await this.U(T,fe,me,B),!!B),fe=!0}return{windows:(0,D.$Kb)(ce),filesOpenedInWindow:de}}R(T,O,j){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),O.focus();const z={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",E.CancellationToken.None,z),O}S(T,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),T.focus();const j={foldersToAdd:O};return T.sendWhenReady("vscode:addFolders",E.CancellationToken.None,j),T}U(T,O,j,z,W){this.r.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:j,filesToOpen:z,forceNewWindow:O});let B;return!O&&typeof T.contextWindowId=="number"&&(B=this.getWindowById(T.contextWindowId)),this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:z,windowToUse:B,emptyWindowBackupInfo:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}W(T,O,j,z,W){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:z}),!j&&!W&&typeof T.contextWindowId=="number"&&(W=this.getWindowById(T.contextWindowId)),this.jb({workspace:O.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:z,windowToUse:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}async X(T){let O,j=!1,z=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(O=await this.Y(T),j=!0):T.forceEmpty?O=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(O=await this.Z(T.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),z=!0),!T.addMode&&j){const W=O.filter(B=>Z(B));if(W.length>1){const B=W[0].remoteAuthority;if(W.every(V=>(0,$.$ng)(V.remoteAuthority,B))){const V=await this.H.createUntitledWorkspace(W.map(ce=>({uri:ce.workspace.uri})));O.push({workspace:V,remoteAuthority:B}),O=O.filter(ce=>!Z(ce))}}}if(T.initialStartup&&!z&&this.F.getValue("window")?.restoreWindows==="preserve"){const W=await this.ab();O.unshift(...W.filter(B=>G(B)||Z(B)||B.backupPath))}return O}async Y(T){const O={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority},j=await Promise.all((0,D.$Fb)(T.urisToOpen||[]).map(async z=>{const W=await this.cb(z,O);if(W)return W.label=z.label,W;const B=this.eb(z);this.J.showMessageBox({type:"info",buttons:[(0,P.localize)(0,null)],message:B.scheme===y.Schemas.file?(0,P.localize)(1,null):(0,P.localize)(2,null),detail:B.scheme===y.Schemas.file?(0,P.localize)(3,null,(0,m.$hv)(B,{os:b.OS,tildify:this.w})):(0,P.localize)(4,null,B.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Fb)(j)}async Z(T){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:T.diff&&T._.length===2||T.merge&&T._.length===4},z=T["folder-uri"];if(z){const V=await Promise.all(z.map(ce=>{const de=this.$(ce);if(de)return this.cb({folderUri:de},j)}));O.push(...(0,D.$Fb)(V))}const W=T["file-uri"];if(W){const V=await Promise.all(W.map(ce=>{const de=this.$(ce);if(de)return this.cb((0,x.$7h)(ce)?{workspaceUri:de}:{fileUri:de},j)}));O.push(...(0,D.$Fb)(V))}const B=await Promise.all(T._.map(V=>j.remoteAuthority?this.hb(V,j):this.fb(V,j)));return O.push(...(0,D.$Fb)(B)),O}$(T){try{const O=d.URI.parse(T);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${T}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${T}, ${O.message}`)}}async ab(){const T=this.bb();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];T!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const j=await Promise.all(O.map(async z=>{if(z.workspace){const W=await this.cb({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(G(W))return W}else if(z.folderUri){const W=await this.cb({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(Z(W))return W}else if(T!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.$Fb)(j)}}}bb(){let T;return this.C.wasRestarted?T="all":(T=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}async cb(T,O=Object.create(null)){const j=this.eb(T);return j.scheme===y.Schemas.file?((0,L.$UC)(T)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(j.fsPath,O)):this.db(T,O)}db(T,O){let j=this.eb(T);const z=(0,p.$Ok)(j)||O.remoteAuthority;if(j=(0,$.$pg)((0,$.$jg)(j)),(0,L.$UC)(T)){if(O.gotoLineMode){const{path:W,line:B,column:V}=(0,c.$Pf)(j.path);return{fileUri:j.with({path:W}),options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0},remoteAuthority:z}}return{fileUri:j,remoteAuthority:z}}else if((0,L.$SC)(T))return{workspace:(0,ae.$Y5b)(j),remoteAuthority:z};return{workspace:(0,ae.$Z5b)(j),remoteAuthority:z}}eb(T){return(0,L.$SC)(T)?T.workspaceUri:(0,L.$TC)(T)?T.folderUri:T.fileUri}async fb(T,O,j){let z,W;O.gotoLineMode&&({path:T,line:z,column:W}=(0,c.$Pf)(T)),T=(0,c.$Kf)((0,f.$7d)(T),(0,g.cwd)());try{const B=await R.Promises.stat(T);if(B.isFile()){if(!O.forceOpenWorkspaceAsFile){const V=await this.H.resolveLocalWorkspace(d.URI.file(T));if(V)return V.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:i.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:d.URI.file(T),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:W||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,ae.$Z5b)(d.URI.file(T),B),type:i.FileType.Directory,exists:!0};if(!b.$i&&T==="/dev/null")return{fileUri:d.URI.file(T),type:i.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!j)return this.gb(T,O);const V=d.URI.file(T);if(this.G.removeRecentlyOpened([V]),O.ignoreFileNotFound)return{fileUri:V,type:i.FileType.File,exists:!1}}}async gb(T,O){const j=d.URI.file(T),{response:z,checkboxChecked:W}=await this.J.showMessageBox({type:"warning",buttons:[(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],message:(0,P.localize)(8,null,j.authority),detail:(0,P.localize)(9,null,(0,m.$hv)(j,{os:b.OS,tildify:this.w})),checkboxLabel:(0,P.localize)(10,null,j.authority),cancelId:1});if(z===0)return(0,s.addUNCHostToAllowlist)(j.authority),W&&this.B(u.Event.once(this.onDidOpenWindow)(B=>{B.sendWhenReady("vscode:configureAllowedUNCHost",E.CancellationToken.None,j.authority)})),this.fb(T,O,!0);if(z===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(T,O)}hb(T,O){const j=T.charCodeAt(0),z=O.remoteAuthority;let W,B;O.gotoLineMode&&({path:T,line:W,column:B}=(0,c.$Pf)(T)),j!==47&&((0,c.$Jf)(j)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,c.$Cf)(T)),T=`/${T}`);const V=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:z,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,x.$7h)(T))return O.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:B||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.$Y5b)(V),remoteAuthority:z};if(O.gotoLineMode||f.$6d.basename(T).indexOf(".")!==-1)return{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:B||1}:void 0},remoteAuthority:z}}return{workspace:(0,ae.$Z5b)(V),remoteAuthority:z}}ib(T){const O=this.F.getValue("window"),j=O?.openFoldersInNewWindow||"default",z=O?.openFilesInNewWindow||"off";let W=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(j==="on"||j==="off")&&(W=j==="on");let B=!1;return T.forceNewWindow||T.forceReuseWindow?B=!!T.forceNewWindow&&!T.forceReuseWindow:(b.$j?T.context===1&&(B=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!T.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(B=z==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(T,O){const j=(0,q.$85b)(this.getWindows(),T);if(j)return this.C.reload(j,O.cli),j.focus(),[j];let z=O.cli["folder-uri"]||[],W=O.cli["file-uri"]||[],B=O.cli._;if(!B.length&&!z.length&&!W.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,he=de?.workspace??de?.folderUri;he&&(d.URI.isUri(he)?he.scheme===y.Schemas.file?B=[he.fsPath]:z=[he.toString()]:he.configPath.scheme===y.Schemas.file?B=[(0,$.$9f)(he.configPath)]:W=[he.configPath.toString()])}let V=O.remoteAuthority;for(const de of T)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=d.URI.parse(de),fe=(0,p.$Ok)(he);fe&&(V?(0,$.$ng)(fe,V)||this.r.error("more than one extension development path authority"):V=fe)}B=B.filter(de=>{const he=d.URI.file(de);return(0,q.$75b)(this.getWindows(),he)?!1:(0,$.$ng)((0,p.$Ok)(he),V)}),z=z.filter(de=>{const he=this.$(de);return he&&(0,q.$75b)(this.getWindows(),he)?!1:he?(0,$.$ng)((0,p.$Ok)(he),V):!1}),W=W.filter(de=>{const he=this.$(de);return he&&(0,q.$75b)(this.getWindows(),he)?!1:he?(0,$.$ng)((0,p.$Ok)(he),V):!1}),O.cli._=B,O.cli["folder-uri"]=z,O.cli["file-uri"]=W;const ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!B.length&&!z.length&&!W.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:V,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ce)}async jb(T){const O=this.F.getValue("window"),j=this.getLastActiveWindow(),z=j?.profile??this.z.defaultProfile;let W;!T.forceNewWindow&&!T.forceNewTabbedWindow&&(W=T.windowToUse||j,W&&W.focus());const B={...this.w.args,...T.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,f.$9d)(this.w.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:z},homeDir:this.w.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.n,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToMerge:T.filesToOpen?.filesToMerge,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:y.Schemas.file}).fsPath,product:I.default,isInitialStartup:T.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(W){const V=W.config;!B.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=V.extensionDevelopmentPath,B.extensionDevelopmentKind=V.extensionDevelopmentKind,B["enable-proposed-api"]=V["enable-proposed-api"],B.verbose=V.verbose,B["inspect-extensions"]=V["inspect-extensions"],B["inspect-brk-extensions"]=V["inspect-brk-extensions"],B.debugId=V.debugId,B.extensionEnvironment=V.extensionEnvironment,B["extensions-dir"]=V["extensions-dir"],B["disable-extensions"]=V["disable-extensions"]),B.loggers={global:B.loggers.global,window:V?.loggers.window??B.loggers.window}}else{const V=this.j.getNewWindowState(B);(0,v.mark)("code/willCreateCodeWindow");const ce=W=this.I.createInstance(U.$96b,{state:V,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),N.a.push(ce),this.b.fire(ce),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),u.Event.once(ce.onDidSignalReady)(()=>this.c.fire(ce)),u.Event.once(ce.onDidClose)(()=>this.mb(ce)),u.Event.once(ce.onDidDestroy)(()=>this.f.fire(ce)),ce.onDidTriggerSystemContextMenu(({x:he,y:fe})=>this.h.fire({window:ce,x:he,y:fe}));const de=(0,o.$uf)(ce.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.C.reload(ce)),this.C.registerWindow(ce)}return B.windowId=W.id,W.isReady?this.C.unload(W,4).then(async V=>{V||await this.kb(W,B,T,z)}):await this.kb(W,B,T,z),W}async kb(T,O,j,z){if(O.extensionDevelopmentPath||((0,x.$Qh)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,x.$Lh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,ae.$15b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const W=O.workspace??(0,x.$Ph)(O.backupPath,!1),B=this.lb(j,W,z),V=B instanceof Promise?await B:B;O.profiles.profile=V,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(W,V)}T.load(O)}lb(T,O,j){return T.forceProfile?this.z.profiles.find(z=>z.name===T.forceProfile)??this.z.createNamedProfile(T.forceProfile):T.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??j}mb(T){const O=N.a.indexOf(T);N.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=S.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(T){return this.ob(this.getWindows().filter(O=>(0,$.$ng)(O.remoteAuthority,T)))}ob(T){const O=Math.max.apply(Math,T.map(j=>j.lastFocusTime));return T.find(j=>j.lastFocusTime===O)}sendToFocused(T,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(T,E.CancellationToken.None,...O)}sendToAll(T,O,j){for(const z of this.getWindows())j&&j.indexOf(z.id)>=0||z.sendWhenReady(T,E.CancellationToken.None,O)}getWindows(){return N.a}getWindowCount(){return N.a.length}getWindowById(T){const O=this.getWindows().filter(j=>j.id===T);return(0,D.$Mb)(O)}getWindowByWebContents(T){const O=S.BrowserWindow.fromWebContents(T);if(O)return this.getWindowById(O.id)}};e.$a7b=_,e.$a7b=_=N=Ee([ee(2,k.$5i),ee(3,F.$K6b),ee(4,A.$jN),ee(5,J.$0m),ee(6,r.$D5b),ee(7,H.$L5b),ee(8,a.$F5b),ee(9,h.$W5b),ee(10,t.$8h),ee(11,ne.$F6b),ee(12,re.$95b),ee(13,n.$Ah),ee(14,l.$45b),ee(15,i.$6j),ee(16,C.$u6b),ee(17,Y.$o6b)],_)}),define(te[306],ie([0,1,63,30,82,53]),function(K,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;let D=class{constructor(u,c,m,w){this.a=u,this.b=c,this.c=m,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,c){const m=this.b.getWindowById(u);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(u,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(u,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(u,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(u,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$c7b=D,e.$c7b=D=Ee([ee(0,M.$95b),ee(1,R.$R5b),ee(2,s.$F6b),ee(3,S.$W5b)],D)}),define(te[307],ie([0,1,15,130,38,27,17,49,14,32,3,44,46,2,13,9,4,12,7,31,146,42,157,110,289,160,63,285,18,198,90,131,59,115,219,28,62,94,207,234,208,294,210,211,212,16,223,93,74,6,92,218,299,286,274,20,5,304,66,24,58,295,95,34,277,81,121,25,251,253,51,48,265,291,300,292,301,126,267,268,269,272,275,30,305,276,29,97,82,306,53,39,232,52,244,50,80,128,279,293,282,8,255,278,227,65,91,297,271,23,124,296,263,239,84]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C,p,A,L,U,q,se,x,ae,ne,re,Y,J,H,F,N,G,Z,_,oe,T,O,j,z,W,B,V,ce,de,he,fe,ve,be,ye,Ce,je,me,we,X,le,ge,Pe,Re,Ue,Oe,Be,We,Q,ue,$e,ke,Ae,Fe,Le,Ne,ze,qe,He,xe,Xe,tt,nt,$t,rt,mt,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,Ct,at,Dt,ht,ct,At,Rt,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=void 0;let ut=class extends f.$kc{constructor(Ie,Se,pe,Me,De,Te,Ke,Qe,Ze,Ge,Ve,Ye){super(),this.c=Ie,this.f=Se,this.g=pe,this.h=Me,this.j=De,this.m=Te,this.n=Ke,this.s=Qe,this.t=Ze,this.u=Ge,this.w=Ve,this.y=Ye,this.z(),this.C()}z(){const Ie=Ge=>Ge?.startsWith(`${v.Schemas.vscodeWebview}://`),Se=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Ye,Je)=>Ie(Je.requestingUrl)?Ye(pe.has(Ve)):Je.isMainFrame&&Je.securityOrigin==="vscode-file://vscode-app/"?Ye(Se.has(Ve)):Ye(!1)),S.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Ye,Je)=>Ie(Je.requestingUrl)?pe.has(Ve):Je.isMainFrame&&Je.securityOrigin==="vscode-file://vscode-app/"?Se.has(Ve):!1);const Me=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),De=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Te=Ge=>Ge.resourceType==="xhr"||De(Ge.frame),Ke=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Ye=S.BrowserWindow.getAllWindows();for(const Je of Ye)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Qe=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Ye=Ve.frame;if(!Ye||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&Ye.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Ye=o.URI.parse(Ge.url);return Ye.scheme===v.Schemas.vscodeWebview&&!Qe(Ye,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Ye.scheme===v.Schemas.vscodeFileResource&&!Ke(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Ye.path.endsWith(".svg")&&!Me.has(Ye.scheme)?Ve({cancel:!Te(Ge)}):Ve({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Ye=Ge.responseHeaders,Je=Ye["content-type"]||Ye["Content-Type"];if(Je&&Array.isArray(Je)){const it=o.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Me.has(it.scheme))return Ye["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ye});if(!it.path.endsWith(v.Schemas.vscodeRemoteResource)&&Je.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(Ge)})}return Ve({cancel:!1})});const Ze=S.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.m.codeCachePath&&Ze.setCodeCachePath((0,b.$9d)(this.m.codeCachePath,"chrome")),g.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,u.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,u.$X)(pe)||(0,u.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,u.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,P.$1S)(),S.app.on("accessibility-support-changed",(pe,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),S.app.on("activate",async(pe,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(pe,Me)=>{Me.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Me.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Ie=[],Se;S.app.on("open-file",(pe,Me)=>{this.h.trace("app#open-file: ",Me),pe.preventDefault(),Ie.push((0,qe.$7h)(Me)?{workspaceUri:o.URI.file(Me)}:{fileUri:o.URI.file(Me)}),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Se=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$ZS.handle("vscode:fetchShellEnv",pe=>{const Me=this.a?.getWindowByWebContents(pe.sender);let De,Te;return Me?.config?(De=Me.config,Te={...process.env,...Me.config.userEnv}):(De=this.m.args,Te=process.env),this.U(De,Te,!1)}),s.$ZS.handle("vscode:writeNlsFile",(pe,Me,De)=>{const Te=this.D([Me]);if(!Te||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Te,D.$Fd.fromString(De))}),s.$ZS.handle("vscode:readNlsFile",async(pe,...Me)=>{const De=this.D(Me);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(De)).value.toString()}),s.$ZS.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$ZS.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$ZS.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(Ie){let Se;for(const pe of Ie)typeof pe=="string"&&(typeof Se!="string"?Se=pe:Se=(0,b.$9d)(Se,pe));if(!(typeof Se!="string"||!(0,b.$8d)(Se)||!(0,c.$If)(Se,this.m.cachedLanguagesPath,!g.$k)))return o.URI.file(Se)}F(Ie){if(Ie){const Se={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.h.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.h.error(Ie.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const Ie=this.w.win32AppUserModelId;g.$i&&Ie&&S.app.setAppUserModelId(Ie);try{g.$j&&this.s.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ze){this.h.error(Ze)}const Se=new t.$7S;this.n.onWillShutdown(Ze=>{Ze.reason===2&&Se.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$j7b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Me,sharedProcessClient:De}=this.N(pe),Te=await this.O(pe,Me);this.B(Te.createInstance(r.$S5b)),this.B(Te.createInstance(vt.$g7b)),Te.invokeFunction(Ze=>this.P(Ze,Se,De));const Ke=Te.invokeFunction(Ze=>this.G(Ze,Se));this.H(Se),this.n.phase=2,await Te.invokeFunction(Ze=>this.Q(Ze,Ke)),this.n.phase=3,this.R(),this.B(new ot.$Sg(()=>{this.B((0,ot.$Wg)(()=>this.n.phase=4,2500))},2500)).schedule()}G(Ie,Se){const pe=this.a=Ie.get(Le.$R5b),Me=Ie.get(Q.$NT),De=this.b=Ie.get(de.$s6b),Te=this;Me.registerHandler({async handleURL(Ye,Je){return Te.M(pe,Me,Ye,Je)}});const Ke=this.B(new ze.$b7b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Qe=new h.$jh(Ye=>Ke.getActiveClientId().then(Je=>Ye===Je)),Ze=new ue.$46b(Qe,this.h),Ge=Se.getChannel("urlHandler",Ze);Me.registerHandler(new ue.$36b(Ge));const Ve=this.I();return this.B(new ke.$56b(Ve?.urls,Me,pe,this.m,this.w,this.h)),Ve}H(Ie){const Se=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>Ie.getChannel(lt.$q7b,new lt.$r7b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Me,De)=>{const Te=o.URI.parse(Me.url);if(!Te.authority.startsWith("window:"))return De(Se());pe.value.call(lt.$p7b,[Te]).then(Ke=>De({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),De({statusCode:500,data:String(Ke)})})})}I(){const Ie=this.m.args["open-url"]?this.m.args._urls||[]:[];Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Ie.length+Se.length===0)return;const pe=[];return{urls:[...Ie,...Se].map(De=>{try{return{uri:o.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.J(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Te=this.L(De.uri);return Te?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Te),pe.push(Te),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:pe}}J(Ie){if(Ie.authority===v.Schemas.file&&g.$i){const{options:Se,buttonIndeces:pe}=(0,Ct.$vv)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,y.$hv)(Ie,{os:g.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[S.dialog.showMessageBoxSync(Se)]===1)return!0}return!1}L(Ie){if(Ie.path){if(Ie.authority===v.Schemas.file){const Se=o.URI.file(Ie.fsPath);return(0,qe.$7h)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(Ie.authority===v.Schemas.vscodeRemote){const Se=Ie.path.indexOf(b.$6d.sep,1);if(Se!==-1){const pe=Ie.path.substring(1,Se),Me=Ie.path.substring(Se);let De=Ie.query;const Te=new URLSearchParams(Ie.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),De=Te.toString());const Ke=o.URI.from({scheme:v.Schemas.vscodeRemote,authority:pe,path:Me,query:De,fragment:Ie.fragment});return(0,qe.$7h)(Me)?{workspaceUri:Ke}:/:[\d]+$/.test(Me)?{fileUri:Ke}:{folderUri:Ke}}}}}async M(Ie,Se,pe,Me){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:o.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let De=!1;const Te=new URLSearchParams(pe.query);Te.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Te.delete("windowId"),pe=pe.with({query:Te.toString()}),De=!0):g.$j&&Ie.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),De=!0);const Ke=Te.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Te.delete("continueOn"),pe=pe.with({query:Te.toString()}),this.m.continueOn=Ke??void 0);const Qe=this.L(pe);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,pe.toString(!0)),(0,ht.$Mb)(await Ie.open({context:5,cli:{...this.m.args},urisToOpen:[Qe],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Mb)(await Ie.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.$Ok)(pe)}))?.ready(),Se.open(pe,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}N(Ie){const Se=this.B(this.g.createInstance(ve.$P6b,Ie)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Se.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$8S(De,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),pe))(),sharedProcessClient:pe}}async O(Ie,Se){const pe=new T.$zh;switch(process.platform){case"win32":pe.set(Pe.$ZT,new _.$yh(We.$16b));break;case"linux":g.$l?pe.set(Pe.$ZT,new _.$yh(Be.$Z6b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Pe.$ZT,new _.$yh(Oe.$Y6b));break;case"darwin":pe.set(Pe.$ZT,new _.$yh(Ue.$X6b));break}pe.set(Le.$R5b,new _.$yh(Ne.$a7b,[Ie,this.f],!1));const Me=new A.$55b(this.h,this.w);pe.set(A.$45b,Me),pe.set(W.$z6b,new _.$yh(W.$A6b,void 0,!1)),pe.set(p.$b6b,new _.$yh(p.$c6b,void 0,!1)),pe.set(C.$gm,h.ProxyChannel.toService((0,h.$hh)(Se.then(Ze=>Ze.getChannel("diagnostics"))))),pe.set(O.$ytb,new _.$yh(j.$v6b,[this.f])),pe.set(L.$HT,new _.$yh(U.$d6b)),pe.set(z.$w6b,new _.$yh(z.$x6b)),pe.set(de.$s6b,new _.$yh(de.$t6b,void 0,!1)),pe.set(Ae.$66b,new _.$yh(Fe.$86b)),pe.set(ce.$I6b,new _.$yh(ce.$J6b)),pe.set(ae.$blb,new _.$yh(ne.$e6b)),pe.set(re.$f6b,new _.$yh(Y.$h6b)),pe.set(je.$N5b,new _.$yh(je.$O5b)),pe.set(je.$P5b,new _.$yh(je.$Q5b));const De=new At.$o7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Te=new Rt.$lr(De,this.s,this.h,this.j);pe.set(ct.$Yq,Te),g.$i?pe.set(J.$i6b,new _.$yh(H.$j6b)):g.$j?pe.set(J.$i6b,new _.$yh(H.$k6b)):g.$k&&pe.set(J.$i6b,new _.$yh(H.$l6b));const Ke=new a.$25b(this.m,this.s,this.h,this.t);pe.set(n.$W5b,Ke);const Qe=new tt.$05b(this.m,this.h,this.y,Ke,Me);if(pe.set(tt.$95b,Qe),pe.set(He.$kU,new _.$yh(Xe.$c7b,void 0,!1)),pe.set(xe.$F6b,new _.$yh(xe.$G6b,void 0,!1)),pe.set(Q.$NT,new _.$yh($e.$PT,void 0,!1)),(0,ge.$ho)(this.w,this.m)){const Ze=(0,ge.$mo)(this.w,this.s),Ge=(0,h.$hh)(Se.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new X.$S6b(Ge),Ye=(0,me.$0n)((0,M.release)(),(0,M.hostname)(),process.arch,this.w.commit,this.w.version,Ie,Ze),Je=(0,ge.$no)(this.m),it={appenders:[Ve],commonProperties:Ye,piiPaths:Je,sendErrorTelemetry:!0};pe.set(we.$9k,new _.$yh(le.$Qq,[it],!1))}else pe.set(we.$9k,ge.$bo);return pe.set(bt.$kp,new _.$yh(St.$qN,void 0,!0)),pe.set(pt.$op,new _.$yh(yt.$f7b,void 0,!0)),pe.set(at.$m7b,new _.$yh(at.$n7b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Qe.initialize()]),this.g.createChild(pe)}P(Ie,Se,pe){const Me=this.B(new f.$jc),De=h.ProxyChannel.fromService(Ie.get(W.$z6b),Me,{disableMarshalling:!0});this.c.registerChannel("launch",De);const Te=h.ProxyChannel.fromService(Ie.get(p.$b6b),Me,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Te);const Ke=new $t.$d7b(Ie.get(nt.$0m));Se.registerChannel("policy",Ke),pe.then(et=>et.registerChannel("policy",Ke));const Qe=this.u.getProvider(v.Schemas.file);(0,$.$tf)(Qe instanceof Z.$3p);const Ze=new G.$m6b(Qe,this.h,this.m);Se.registerChannel(F.$_M,Ze),pe.then(et=>et.registerChannel(F.$_M,Ze));const Ge=h.ProxyChannel.fromService(Ie.get(rt.$L5b),Me);Se.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new mt.$Lq(Ie.get(wt.$Io));pe.then(et=>et.registerChannel("request",Ve));const Ye=new Re.$T6b(Ie.get(Pe.$ZT));Se.registerChannel("update",Ye);const Je=h.ProxyChannel.fromService(Ie.get(O.$ytb),Me);Se.registerChannel("issue",Je);const it=h.ProxyChannel.fromService(Ie.get(L.$HT),Me);Se.registerChannel("encryption",it);const _e=h.ProxyChannel.fromService(Ie.get(be.$Wk),Me);Se.registerChannel("sign",_e);const st=h.ProxyChannel.fromService(Ie.get(z.$w6b),Me);Se.registerChannel("keyboardLayout",st),this.b=Ie.get(de.$s6b);const ft=h.ProxyChannel.fromService(this.b,Me);Se.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Mt=h.ProxyChannel.fromService(Ie.get(He.$kU),Me);Se.registerChannel("workspaces",Mt);const Lt=h.ProxyChannel.fromService(Ie.get(ce.$I6b),Me);Se.registerChannel("menubar",Lt);const jt=h.ProxyChannel.fromService(Ie.get(Q.$NT),Me);Se.registerChannel("url",jt);const Ft=h.ProxyChannel.fromService(Ie.get(ae.$blb),Me);Se.registerChannel("extensionUrlTrust",Ft);const Ut=h.ProxyChannel.fromService(Ie.get(Ae.$66b),Me);Se.registerChannel("webview",Ut);const dt=this.B(new Ce.$Q6b(this.h,Ie.get(je.$N5b)));Se.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Nt=this.B(new kt.$h7b(Ie.get(je.$N5b),Ie.get(rt.$L5b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=h.ProxyChannel.fromService(Ie.get(ct.$Yq),Me);Se.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=h.ProxyChannel.fromService(Ie.get(J.$i6b),Me);Se.registerChannel("externalTerminal",Wt);const gt=new Pt.$k7b(Ie.get(It.$K6b));Se.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const Bt=new I.$35b(Ie.get(Le.$R5b));Se.registerChannel("extensionhostdebugservice",Bt);const zt=h.ProxyChannel.fromService(Ie.get(re.$f6b),Me);Se.registerChannel(re.$g6b,zt);const qt=h.ProxyChannel.fromService(Ie.get(at.$m7b),Me);Se.registerChannel(Dt.$l7b,qt)}async Q(Ie,Se){const pe=this.a=Ie.get(Le.$R5b),Me=(0,se.$Gl)(process.env)?0:4,De=this.m.args;if(Se){if(Se.openables.length>0)return pe.open({context:Me,cli:De,urisToOpen:Se.openables,gotoLineMode:!0,initialStartup:!0});if(Se.urls.length>0)for(const _e of Se.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,Ke=De._.length,Qe=!!De["folder-uri"],Ze=!!De["file-uri"],Ge=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?o.URI.file(De.waitMarkerFilePath):void 0,Ye=De.remote||void 0,Je=De.profile,it=De["profile-temp"];if(!Ke&&!Qe&&!Ze){if(De["new-window"]||Je||it)return pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ye,forceProfile:Je,forceTempProfile:it});if(Te.length)return pe.open({context:1,cli:De,urisToOpen:Te.map(_e=>(0,qe.$7h)(_e)?{workspaceUri:o.URI.file(_e)}:{fileUri:o.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Me,cli:De,forceNewWindow:De["new-window"]||!Ke&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:Je,forceTempProfile:it})}R(){this.S(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Ie,Se)=>{Se({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.U(this.m.args,process.env,!0),this.W(),g.$j&&S.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const Ie=this.w.win32MutexName;if(g.$i&&Ie)try{const Se=await new Promise((Me,De)=>{K(["@vscode/windows-mutex"],Me,De)}),pe=new Se.Mutex(Ie);m.Event.once(this.n.onWillShutdown)(()=>pe.release())}catch(Se){this.h.error(Se)}}async U(Ie,Se,pe){try{return await(0,x.$Ml)(this.s,this.h,Ie,Se)}catch(Me){const De=(0,E.$mi)(Me);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async W(){try{const Se=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,w.$Tm)(Se)),De=(0,ge.$jo)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.$4f)()}"`,"}"],Ke=Se.substring(0,Se.length-2).concat(`,
`,Te.join(`
`));await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Ke))}else{const Te=Se.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Te!==Se&&await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Te))}}catch(Ie){this.h.error(Ie)}}};e.$s7b=ut,e.$s7b=ut=Ee([ee(2,oe.$Ah),ee(3,V.$5i),ee(4,V.$6i),ee(5,q.$D5b),ee(6,B.$F5b),ee(7,k.$8h),ee(8,ye.$jN),ee(9,N.$6j),ee(10,he.$kj),ee(11,rt.$L5b)],ut)}),define(te[313],ie([0,1,15,45,7,23,8,49,14,32,3,46,13,9,64,4,35,26,21,42,99,307,10,18,238,250,28,62,200,16,221,93,74,217,92,20,224,5,76,24,77,280,125,290,50,288,95,249,34,51,78,52,39,233,231,2,40,266,65,226,91,120,270,264]),function(K,e,S,R,s,M,D,E,u,c,m,w,y,f,v,b,g,$,o,d,P,h,t,l,r,i,n,a,k,I,C,p,A,L,U,q,se,x,ae,ne,re,Y,J,H,F,N,G,Z,_,oe,T,O,j,z,W,B,V,ce,de,he,fe,ve,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(me){console.error(me.message),S.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,we,X,le,ge,Pe,Re,Ue]=this.b();try{try{await this.d(X,Ue,le,ge,Re)}catch(Oe){throw this.f(X,Re,Oe),Oe}await me.invokeFunction(async Oe=>{const Be=Oe.get(x.$5i),We=Oe.get(q.$F5b),Q=Oe.get(I.$6j),ue=Oe.get(x.$6i),$e=await this.e(Be,X,We,me,Re,!0);return o.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ke=>{Be.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Pe.logger=ue.createLogger("main",{name:(0,t.localize)(0,null)}),m.Event.once(We.onWillShutdown)(ke=>{Q.dispose(),le.dispose(),ke.join("instanceLockfile",o.Promises.unlink(X.mainLockfile).catch(()=>{}))}),me.createInstance(h.$s7b,$e,we).startup()})}catch(Oe){me.invokeFunction(this.i,Oe)}}b(){const me=new U.$zh,we=new B.$jc;process.once("exit",()=>we.dispose());const X={_serviceBrand:void 0,...ae.default};me.set(ne.$kj,X);const le=new n.$E5b(this.j(),X),ge=this.c(le);me.set(n.$D5b,le);const Pe=new de.$L6b((0,x.$gj)(le),le.logsHome);me.set(de.$K6b,Pe);const Re=new se.$m3b(Pe.getLogLevel()),Ue=we.add(new he.$rN(Re,[new x.$_i(Pe.getLogLevel())]));me.set(x.$5i,Ue);const Oe=new C.$Dp(Ue);me.set(I.$6j,Oe);const Be=new p.$3p(Ue);Oe.registerProvider(y.Schemas.file,Be);const We=new ce.$pr(Oe);me.set(V.$Ck,We);const Q=new ve.$mN(1,le,Ue,Oe);me.set(_.$iN,Q),me.set(_.$jN,Q);const ue=new O.$M5b(Q,We,le,Oe,Ue);me.set(O.$L5b,ue),Oe.registerProvider(y.Schemas.vscodeUserData,new be.$D7b(y.Schemas.file,Be,y.Schemas.vscodeUserData,ue,We,Ue));const $e=b.$i&&X.win32RegValueName?we.add(new z.$B7b(Ue,X.win32RegValueName)):le.policyFile?we.add(new W.$C7b(le.policyFile,Oe,Ue)):new j.$_m;me.set(j.$0m,$e);const ke=new r.$zn(ue.defaultProfile.settingsResource,Oe,$e,Ue);return me.set(l.$8h,ke),me.set(q.$F5b,new A.$yh(q.$G5b,void 0,!1)),me.set(F.$Io,new A.$yh(N.$z7b,void 0,!0)),me.set(T.$o6b,new A.$yh(T.$p6b)),me.set(G.$Wk,new A.$yh(Z.$A7b,void 0,!1)),me.set(J.$Zu,new A.$yh(H.$x7b)),me.set(re.$u6b,new Y.$u7b(le,ue,Ue)),[new L.$6p(me,!0),ge,le,ke,Q,Re,X,ue]}c(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(we[X]=le)}),Object.assign(process.env,we),we}async d(me,we,X,le,ge){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,me.backupHome].map(Pe=>Pe?o.Promises.mkdir(Pe,{recursive:!0}):void 0)),le.init(),X.initialize()]),we.init()}async e(me,we,X,le,ge,Pe){let Re;try{(0,v.mark)("code/willStartMainServer"),Re=await(0,P.$wh)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),m.Event.once(X.onWillShutdown)(()=>Re.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(we,ge,Ue),Ue;let Oe;try{Oe=await(0,P.$xh)(we.mainIPCHandle,"main")}catch(ue){if(!Pe||b.$i||ue.code!=="ECONNREFUSED")throw ue.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),ue;try{(0,R.unlinkSync)(we.mainIPCHandle)}catch($e){throw me.warn("Could not delete obsolete instance handle",$e),$e}return this.e(me,we,X,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ue=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw me.error(ue),Oe.dispose(),new Error(ue)}let Be;!we.args.wait&&!we.args.status&&(Be=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const We=d.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Q=d.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const ue=new i.$wr(oe.$bo,ge),$e=await Q.getMainDiagnostics(),ke=await Q.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await ue.getDiagnostics($e,ke);throw console.log(Ae),new u.$$});throw b.$i&&await this.h(We,me),me.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new u.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new u.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f(me,we,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,M.$Fb)([me.userDataPath,me.extensionsPath,P.$sh]).map(ge=>(0,w.$hv)(s.URI.file(ge),{os:b.OS,tildify:me}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$mi)(X),le.join(`
`)),we)}}g(me,we,X){S.dialog.showMessageBoxSync((0,fe.$vv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:me,detail:we},X).options)}async h(me,we){if(b.$i){const X=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,ge)=>{K(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(X)}catch(le){we.error(le)}}}i(me,we){const X=me.get(x.$5i),le=me.get(q.$F5b);let ge=0;we&&(we.isExpected?we.message&&X.trace(we.message):(ge=1,we.stack?X.error(we.stack):X.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const me=this.k((0,a.$Dl)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,k.$t7b)(me.verbose);we&&((0,a.$Fl)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.l(me._,me.goto);me._=we}return me}l(me,we){const X=(0,g.cwd)(),le=me.map(Re=>{let Ue=String(Re),Oe;we&&(Oe=(0,c.$Pf)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(X,Ue));const Be=(0,c.$Kf)(Ue,X),We=(0,f.$ae)(Be);return We&&!(0,c.$Gf)(We)?null:we&&Oe?(Oe.path=Be,this.n(Oe)):Be}),ge=b.$i||b.$j,Pe=(0,M.$Kb)(le,Re=>Re&&ge?Re.toLowerCase():Re||"");return(0,M.$Fb)(Pe)}m(me,we){return b.$i&&(we=(0,$.$ve)(we,'"')),we=(0,$.$te)((0,$.$te)(we," "),"	"),b.$i&&(we=(0,f.$0d)(me,we),we=(0,$.$ve)(we,".")),we}n(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/code/electron-main/main.js.map
