/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(le){for(var t=[],y=0,N=le.length;y<N;y++)t[y]=be[le[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Yt,getPrototypeOf:Xt,getOwnPropertyDescriptor:Zt}=Object;let{freeze:tt,seal:at,create:Jt}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,y,N){return t.apply(y,N)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),Nt||(Nt=function(t,y){return new t(...y)});const ei=rt(Array.prototype.forEach),zt=rt(Array.prototype.pop),mt=rt(Array.prototype.push),Dt=rt(String.prototype.toLowerCase),Ot=rt(String.prototype.toString),ti=rt(String.prototype.match),ht=rt(String.prototype.replace),ii=rt(String.prototype.indexOf),ni=rt(String.prototype.trim),st=rt(RegExp.prototype.test),bt=si(TypeError);function rt(le){return function(t){for(var y=arguments.length,N=new Array(y>1?y-1:0),n=1;n<y;n++)N[n-1]=arguments[n];return Ft(le,t,N)}}function si(le){return function(){for(var t=arguments.length,y=new Array(t),N=0;N<t;N++)y[N]=arguments[N];return Nt(le,y)}}function Be(le,t,y){var N;y=(N=y)!==null&&N!==void 0?N:Dt,jt&&jt(le,null);let n=t.length;for(;n--;){let W=t[n];if(typeof W=="string"){const v=y(W);v!==W&&(Yt(t)||(t[n]=v),W=v)}le[W]=!0}return le}function dt(le){const t=Jt(null);for(const[y,N]of Bt(le))t[y]=N;return t}function yt(le,t){for(;le!==null;){const N=Zt(le,t);if(N){if(N.get)return rt(N.get);if(typeof N.value=="function")return rt(N.value)}le=Xt(le)}function y(N){return console.warn("fallback value for",N),null}return y}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ri=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Tt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),oi=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),Wt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),li=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),ai=at(/<%[\w\W]*|[\w\W]*%>/gm),hi=at(/\${[\w\W]*}/gm),ui=at(/^data-[\-\w.\u00B7-\uFFFF]/),ci=at(/^aria-[\-\w]+$/),qt=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),fi=at(/^(?:\w+script|data):/i),di=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=at(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:li,ERB_EXPR:ai,TMPLIT_EXPR:hi,DATA_ATTR:ui,ARIA_ATTR:ci,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:fi,ATTR_WHITESPACE:di,DOCTYPE_NAME:Vt});const gi=()=>typeof window>"u"?null:window,mi=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const n="data-tt-policy-suffix";y&&y.hasAttribute(n)&&(N=y.getAttribute(n));const W="dompurify"+(N?"#"+N:"");try{return t.createPolicy(W,{createHTML(v){return v},createScriptURL(v){return v}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Kt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:gi();const t=Le=>Kt(Le);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const y=le.document,N=y.currentScript;let{document:n}=le;const{DocumentFragment:W,HTMLTemplateElement:v,Node:w,Element:o,NodeFilter:u,NamedNodeMap:c=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:L,DOMParser:s,trustedTypes:a}=le,e=o.prototype,l=yt(e,"cloneNode"),r=yt(e,"nextSibling"),m=yt(e,"childNodes"),i=yt(e,"parentNode");if(typeof v=="function"){const Le=n.createElement("template");Le.content&&Le.content.ownerDocument&&(n=Le.content.ownerDocument)}let d,$="";const{implementation:f,createNodeIterator:h,createDocumentFragment:F,getElementsByTagName:M}=n,{importNode:I}=y;let b={};t.isSupported=typeof Bt=="function"&&typeof i=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:D,ERB_EXPR:j,TMPLIT_EXPR:H,DATA_ATTR:B,ARIA_ATTR:E,IS_SCRIPT_OR_DATA:z,ATTR_WHITESPACE:X}=xt;let{IS_ALLOWED_URI:ie}=xt,ue=null;const ae=Be({},[...Ht,...Pt,...Lt,...Tt,...Ut]);let oe=null;const re=Be({},[...Wt,...It,..._t,...Et]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ce=null,Fe=null,Me=!0,fe=!0,ne=!1,Q=!0,V=!1,ee=!1,J=!1,S=!1,x=!1,g=!1,p=!1,q=!0,T=!1;const O="user-content-";let P=!0,_=!1,C={},R=null;const A=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let k=null;const U=Be({},["audio","video","img","source","image","track"]);let K=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Ne=we,Ee=!1,ve=null;const Te=Be({},[se,me,we],Ot);let Pe;const We=["application/xhtml+xml","text/html"],je="text/html";let Ie,Ke=null;const Z=n.createElement("form"),he=function(ce){return ce instanceof RegExp||ce instanceof Function},pe=function(ce){if(!(Ke&&Ke===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=dt(ce),Pe=We.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Pe=je:Pe=ce.PARSER_MEDIA_TYPE,Ie=Pe==="application/xhtml+xml"?Ot:Dt,ue="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS,Ie):ae,oe="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR,Ie):re,ve="ALLOWED_NAMESPACES"in ce?Be({},ce.ALLOWED_NAMESPACES,Ot):Te,K="ADD_URI_SAFE_ATTR"in ce?Be(dt(te),ce.ADD_URI_SAFE_ATTR,Ie):te,k="ADD_DATA_URI_TAGS"in ce?Be(dt(U),ce.ADD_DATA_URI_TAGS,Ie):U,R="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS,Ie):A,Ce="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS,Ie):{},Fe="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR,Ie):{},C="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Me=ce.ALLOW_ARIA_ATTR!==!1,fe=ce.ALLOW_DATA_ATTR!==!1,ne=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,Q=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,V=ce.SAFE_FOR_TEMPLATES||!1,ee=ce.WHOLE_DOCUMENT||!1,x=ce.RETURN_DOM||!1,g=ce.RETURN_DOM_FRAGMENT||!1,p=ce.RETURN_TRUSTED_TYPE||!1,S=ce.FORCE_BODY||!1,q=ce.SANITIZE_DOM!==!1,T=ce.SANITIZE_NAMED_PROPS||!1,P=ce.KEEP_CONTENT!==!1,_=ce.IN_PLACE||!1,ie=ce.ALLOWED_URI_REGEXP||qt,Ne=ce.NAMESPACE||we,ge=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&he(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&he(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),V&&(fe=!1),g&&(x=!0),C&&(ue=Be({},[...Ut]),oe=[],C.html===!0&&(Be(ue,Ht),Be(oe,Wt)),C.svg===!0&&(Be(ue,Pt),Be(oe,It),Be(oe,Et)),C.svgFilters===!0&&(Be(ue,Lt),Be(oe,It),Be(oe,Et)),C.mathMl===!0&&(Be(ue,Tt),Be(oe,_t),Be(oe,Et))),ce.ADD_TAGS&&(ue===ae&&(ue=dt(ue)),Be(ue,ce.ADD_TAGS,Ie)),ce.ADD_ATTR&&(oe===re&&(oe=dt(oe)),Be(oe,ce.ADD_ATTR,Ie)),ce.ADD_URI_SAFE_ATTR&&Be(K,ce.ADD_URI_SAFE_ATTR,Ie),ce.FORBID_CONTENTS&&(R===A&&(R=dt(R)),Be(R,ce.FORBID_CONTENTS,Ie)),P&&(ue["#text"]=!0),ee&&Be(ue,["html","head","body"]),ue.table&&(Be(ue,["tbody"]),delete Ce.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');d=ce.TRUSTED_TYPES_POLICY,$=d.createHTML("")}else d===void 0&&(d=mi(a,N)),d!==null&&typeof $=="string"&&($=d.createHTML(""));tt&&tt(ce),Ke=ce}},De=Be({},["mi","mo","mn","ms","mtext"]),ke=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),ze=Be({},Pt);Be(ze,Lt),Be(ze,ri);const Xe=Be({},Tt);Be(Xe,oi);const Ye=function(ce){let ye=i(ce);(!ye||!ye.tagName)&&(ye={namespaceURI:Ne,tagName:"template"});const Oe=Dt(ce.tagName),Ue=Dt(ye.tagName);return ve[ce.namespaceURI]?ce.namespaceURI===me?ye.namespaceURI===we?Oe==="svg":ye.namespaceURI===se?Oe==="svg"&&(Ue==="annotation-xml"||De[Ue]):!!ze[Oe]:ce.namespaceURI===se?ye.namespaceURI===we?Oe==="math":ye.namespaceURI===me?Oe==="math"&&ke[Ue]:!!Xe[Oe]:ce.namespaceURI===we?ye.namespaceURI===me&&!ke[Ue]||ye.namespaceURI===se&&!De[Ue]?!1:!Xe[Oe]&&(Re[Oe]||!ze[Oe]):!!(Pe==="application/xhtml+xml"&&ve[ce.namespaceURI]):!1},Ve=function(ce){mt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},_e=function(ce,ye){try{mt(t.removed,{attribute:ye.getAttributeNode(ce),from:ye})}catch{mt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ce),ce==="is"&&!oe[ce])if(x||g)try{Ve(ye)}catch{}else try{ye.setAttribute(ce,"")}catch{}},et=function(ce){let ye,Oe;if(S)ce="<remove></remove>"+ce;else{const nt=ti(ce,/^[\r\n\t ]+/);Oe=nt&&nt[0]}Pe==="application/xhtml+xml"&&Ne===we&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const Ue=d?d.createHTML(ce):ce;if(Ne===we)try{ye=new s().parseFromString(Ue,Pe)}catch{}if(!ye||!ye.documentElement){ye=f.createDocument(Ne,"template",null);try{ye.documentElement.innerHTML=Ee?$:Ue}catch{}}const Ge=ye.body||ye.documentElement;return ce&&Oe&&Ge.insertBefore(n.createTextNode(Oe),Ge.childNodes[0]||null),Ne===we?M.call(ye,ee?"html":"body")[0]:ee?ye.documentElement:Ge},it=function(ce){return h.call(ce.ownerDocument||ce,ce,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},ft=function(ce){return ce instanceof L&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof c)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ct=function(ce){return typeof w=="object"?ce instanceof w:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ut=function(ce,ye,Oe){b[ce]&&ei(b[ce],Ue=>{Ue.call(t,ye,Oe,Ke)})},$t=function(ce){let ye;if(ut("beforeSanitizeElements",ce,null),ft(ce))return Ve(ce),!0;const Oe=Ie(ce.nodeName);if(ut("uponSanitizeElement",ce,{tagName:Oe,allowedTags:ue}),ce.hasChildNodes()&&!ct(ce.firstElementChild)&&(!ct(ce.content)||!ct(ce.content.firstElementChild))&&st(/<[/\w]/g,ce.innerHTML)&&st(/<[/\w]/g,ce.textContent))return Ve(ce),!0;if(!ue[Oe]||Ce[Oe]){if(!Ce[Oe]&&At(Oe)&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,Oe)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Oe)))return!1;if(P&&!R[Oe]){const Ue=i(ce)||ce.parentNode,Ge=m(ce)||ce.childNodes;if(Ge&&Ue){const nt=Ge.length;for(let xe=nt-1;xe>=0;--xe)Ue.insertBefore(l(Ge[xe],!0),r(ce))}}return Ve(ce),!0}return ce instanceof o&&!Ye(ce)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&st(/<\/no(script|embed|frames)/i,ce.innerHTML)?(Ve(ce),!0):(V&&ce.nodeType===3&&(ye=ce.textContent,ye=ht(ye,D," "),ye=ht(ye,j," "),ye=ht(ye,H," "),ce.textContent!==ye&&(mt(t.removed,{element:ce.cloneNode()}),ce.textContent=ye)),ut("afterSanitizeElements",ce,null),!1)},pt=function(ce,ye,Oe){if(q&&(ye==="id"||ye==="name")&&(Oe in n||Oe in Z))return!1;if(!(fe&&!Fe[ye]&&st(B,ye))){if(!(Me&&st(E,ye))){if(!oe[ye]||Fe[ye]){if(!(At(ce)&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,ce)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ce))&&(ge.attributeNameCheck instanceof RegExp&&st(ge.attributeNameCheck,ye)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(ye))||ye==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,Oe)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Oe))))return!1}else if(!K[ye]){if(!st(ie,ht(Oe,X,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ce!=="script"&&ii(Oe,"data:")===0&&k[ce])){if(!(ne&&!st(z,ht(Oe,X,"")))){if(Oe)return!1}}}}}}return!0},At=function(ce){return ce.indexOf("-")>0},kt=function(ce){let ye,Oe,Ue,Ge;ut("beforeSanitizeAttributes",ce,null);const{attributes:nt}=ce;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:oe};for(Ge=nt.length;Ge--;){ye=nt[Ge];const{name:ot,namespaceURI:wt}=ye;if(Oe=ot==="value"?ye.value:ni(ye.value),Ue=Ie(ot),xe.attrName=Ue,xe.attrValue=Oe,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ut("uponSanitizeAttribute",ce,xe),Oe=xe.attrValue,xe.forceKeepAttr||(_e(ot,ce),!xe.keepAttr))continue;if(!Q&&st(/\/>/i,Oe)){_e(ot,ce);continue}V&&(Oe=ht(Oe,D," "),Oe=ht(Oe,j," "),Oe=ht(Oe,H," "));const St=Ie(ce.nodeName);if(pt(St,Ue,Oe)){if(T&&(Ue==="id"||Ue==="name")&&(_e(ot,ce),Oe=O+Oe),d&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!wt)switch(a.getAttributeType(St,Ue)){case"TrustedHTML":{Oe=d.createHTML(Oe);break}case"TrustedScriptURL":{Oe=d.createScriptURL(Oe);break}}try{wt?ce.setAttributeNS(wt,ot,Oe):ce.setAttribute(ot,Oe),zt(t.removed)}catch{}}}ut("afterSanitizeAttributes",ce,null)},Mt=function Le(ce){let ye;const Oe=it(ce);for(ut("beforeSanitizeShadowDOM",ce,null);ye=Oe.nextNode();)ut("uponSanitizeShadowNode",ye,null),!$t(ye)&&(ye.content instanceof W&&Le(ye.content),kt(ye));ut("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Le){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Oe,Ue,Ge;if(Ee=!Le,Ee&&(Le="<!-->"),typeof Le!="string"&&!ct(Le))if(typeof Le.toString=="function"){if(Le=Le.toString(),typeof Le!="string")throw bt("dirty is not a string, aborting")}else throw bt("toString is not a function");if(!t.isSupported)return Le;if(J||pe(ce),t.removed=[],typeof Le=="string"&&(_=!1),_){if(Le.nodeName){const ot=Ie(Le.nodeName);if(!ue[ot]||Ce[ot])throw bt("root node is forbidden and cannot be sanitized in-place")}}else if(Le instanceof w)ye=et("<!---->"),Oe=ye.ownerDocument.importNode(Le,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?ye=Oe:ye.appendChild(Oe);else{if(!x&&!V&&!ee&&Le.indexOf("<")===-1)return d&&p?d.createHTML(Le):Le;if(ye=et(Le),!ye)return x?null:p?$:""}ye&&S&&Ve(ye.firstChild);const nt=it(_?Le:ye);for(;Ue=nt.nextNode();)$t(Ue)||(Ue.content instanceof W&&Mt(Ue.content),kt(Ue));if(_)return Le;if(x){if(g)for(Ge=F.call(ye.ownerDocument);ye.firstChild;)Ge.appendChild(ye.firstChild);else Ge=ye;return(oe.shadowroot||oe.shadowrootmode)&&(Ge=I.call(y,Ge,!0)),Ge}let xe=ee?ye.outerHTML:ye.innerHTML;return ee&&ue["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),V&&(xe=ht(xe,D," "),xe=ht(xe,j," "),xe=ht(xe,H," ")),d&&p?d.createHTML(xe):xe},t.setConfig=function(Le){pe(Le),J=!0},t.clearConfig=function(){Ke=null,J=!1},t.isValidAttribute=function(Le,ce,ye){Ke||pe({});const Oe=Ie(Le),Ue=Ie(ce);return pt(Oe,Ue,ye)},t.addHook=function(Le,ce){typeof ce=="function"&&(b[Le]=b[Le]||[],mt(b[Le],ce))},t.removeHook=function(Le){if(b[Le])return zt(b[Le])},t.removeHooks=function(Le){b[Le]&&(b[Le]=[])},t.removeAllHooks=function(){b={}},t}var bi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return bi}),define(be[39],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LP=t.$KP=void 0;class y{constructor(v){this.domNode=v,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(v){const w=N(v);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(v){const w=N(v);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(v){const w=N(v);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(v){const w=N(v);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(v){const w=N(v);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(v){const w=N(v);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(v){const w=N(v);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(v){const w=N(v);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(v){const w=N(v);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(v){const w=N(v);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(v){const w=N(v);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(v){this.l!==v&&(this.l=v,this.domNode.style.fontFamily=this.l)}setFontWeight(v){this.m!==v&&(this.m=v,this.domNode.style.fontWeight=this.m)}setFontSize(v){const w=N(v);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(v){this.o!==v&&(this.o=v,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(v){this.p!==v&&(this.p=v,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(v){this.q!==v&&(this.q=v,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(v){this.r!==v&&(this.r=v,this.domNode.style.textDecoration=this.r)}setLineHeight(v){const w=N(v);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(v){const w=N(v);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(v){this.u!==v&&(this.u=v,this.domNode.className=this.u)}toggleClassName(v,w){this.domNode.classList.toggle(v,w),this.u=this.domNode.className}setDisplay(v){this.v!==v&&(this.v=v,this.domNode.style.display=this.v)}setPosition(v){this.w!==v&&(this.w=v,this.domNode.style.position=this.w)}setVisibility(v){this.x!==v&&(this.x=v,this.domNode.style.visibility=this.x)}setColor(v){this.y!==v&&(this.y=v,this.domNode.style.color=this.y)}setBackgroundColor(v){this.z!==v&&(this.z=v,this.domNode.style.backgroundColor=this.z)}setLayerHinting(v){this.A!==v&&(this.A=v,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(v){this.C!==v&&(this.C=v,this.domNode.style.boxShadow=v)}setContain(v){this.B!==v&&(this.B=v,this.domNode.style.contain=this.B)}setAttribute(v,w){this.domNode.setAttribute(v,w)}removeAttribute(v){this.domNode.removeAttribute(v)}appendChild(v){this.domNode.appendChild(v.domNode)}removeChild(v){this.domNode.removeChild(v.domNode)}}t.$KP=y;function N(W){return typeof W=="number"?`${W}px`:W}function n(W){return new y(W)}t.$LP=n}),define(be[67],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iO=t.$hO=void 0;let y=!1,N=null;function n(o){if(!o.parent||o.parent===o)return null;try{const u=o.location,c=o.parent.location;if(u.origin!=="null"&&c.origin!=="null"&&u.origin!==c.origin)return y=!0,null}catch{return y=!0,null}return o.parent}class W{static getSameOriginWindowChain(){if(!N){N=[];let u=window,c;do c=n(u),c?N.push({window:u,iframeElement:u.frameElement||null}):N.push({window:u,iframeElement:null}),u=c;while(u)}return N.slice(0)}static hasDifferentOriginAncestor(){return N||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(u,c){if(!c||u===c)return{top:0,left:0};let L=0,s=0;const a=this.getSameOriginWindowChain();for(const e of a){if(L+=e.window.scrollY,s+=e.window.scrollX,e.window===c||!e.iframeElement)break;const l=e.iframeElement.getBoundingClientRect();L+=l.top,s+=l.left}return{top:L,left:s}}}t.$hO=W;async function v(o,u){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const c=JSON.stringify({parentOrigin:o,salt:u}),s=new TextEncoder().encode(c),a=await crypto.subtle.digest("sha-256",s);return w(a)}t.$iO=v;function w(o){const c=Array.from(new Uint8Array(o)).map(L=>L.toString(16).padStart(2,"0")).join("");return BigInt(`0x${c}`).toString(32).padStart(52,"0")}}),define(be[68],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=t.$hQ=t.$gQ=t.ListDragOverEffect=void 0;var y;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$gQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class N extends Error{constructor(v,w){super(`ListError [${v}] ${w}`)}}t.$hQ=N;class n{constructor(){this.c=new WeakMap}getHeight(v){return this.c.get(v)??this.d(v)}setDynamicHeight(v,w){w>0&&this.c.set(v,w)}}t.$iQ=n}),define(be[69],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fQ=void 0;class y{constructor(n){this.a=n}splice(n,W,v){this.a.forEach(w=>w.splice(n,W,v))}}t.$fQ=y}),define(be[40],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QP=void 0;const y=20;class N{constructor(W,v,w,o,u,c){this.a=Math.round(v),this.b=Math.round(w),this.c=Math.round(W),this.d=o,this.e=u,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const v=Math.round(W);return this.d!==v?(this.d=v,this.m(),!0):!1}setScrollSize(W){const v=Math.round(W);return this.e!==v?(this.e=v,this.m(),!0):!1}setScrollPosition(W){const v=Math.round(W);return this.f!==v?(this.f=v,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,v,w,o,u){const c=Math.max(0,w-W),L=Math.max(0,c-2*v),s=o>0&&o>w;if(!s)return{computedAvailableSize:Math.round(c),computedIsNeeded:s,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(w*L/o))),e=(L-a)/(o-w),l=u*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(l)}}m(){const W=N.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const v=W-this.c-this.i/2;return Math.round(v/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const v=W-this.c;let w=this.f;return v<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const v=this.k+W;return Math.round(v/this.j)}}t.$QP=N}),define(be[24],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=t.$bS=t.$aS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(o){o[o.Hidden=0]="Hidden",o[o.Visible=1]="Visible",o[o.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var N;(function(o){o[o.Expanded=0]="Expanded",o[o.Collapsed=1]="Collapsed",o[o.PreserveOrExpanded=2]="PreserveOrExpanded",o[o.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Twistie=1]="Twistie",o[o.Element=2]="Element",o[o.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var W;(function(o){o[o.Down=0]="Down",o[o.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.$aS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(o=!1){return{accept:!0,bubble:0,autoExpand:o}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(o=!1){return{accept:!0,bubble:0,effect:0,autoExpand:o}}};class v extends Error{constructor(u,c){super(`TreeError [${u}] ${c}`)}}t.$bS=v;class w{constructor(u){this.a=u,this.b=new WeakMap}map(u){let c=this.b.get(u);return c||(c=this.a(u),this.b.set(u,c)),c}}t.$cS=w}),define(be[70],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function y(l,r,m){const i=N(l,r);if(i!==-1)return l[i]}t.$db=y;function N(l,r,m=l.length-1){for(let i=m;i>=0;i--){const d=l[i];if(r(d))return i}return-1}t.$eb=N;function n(l,r){const m=W(l,r);return m===-1?void 0:l[m]}t.$fb=n;function W(l,r,m=0,i=l.length){let d=m,$=i;for(;d<$;){const f=Math.floor((d+$)/2);r(l[f])?d=f+1:$=f}return d-1}t.$gb=W;function v(l,r){const m=w(l,r);return m===l.length?void 0:l[m]}t.$hb=v;function w(l,r,m=0,i=l.length){let d=m,$=i;for(;d<$;){const f=Math.floor((d+$)/2);r(l[f])?$=f:d=f+1}return d}t.$ib=w;function o(l,r,m=0,i=l.length){const d=w(l,r,m,i);return d===l.length?-1:d}t.$jb=o;class u{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(u.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!r(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const m=W(this.e,r,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$kb=u;function c(l,r){if(l.length===0)return;let m=l[0];for(let i=1;i<l.length;i++){const d=l[i];r(d,m)>0&&(m=d)}return m}t.$lb=c;function L(l,r){if(l.length===0)return;let m=l[0];for(let i=1;i<l.length;i++){const d=l[i];r(d,m)>=0&&(m=d)}return m}t.$mb=L;function s(l,r){return c(l,(m,i)=>-r(m,i))}t.$nb=s;function a(l,r){if(l.length===0)return-1;let m=0;for(let i=1;i<l.length;i++){const d=l[i];r(d,l[m])>0&&(m=i)}return m}t.$ob=a;function e(l,r){for(const m of l){const i=r(m);if(i!==void 0)return i}}t.$pb=e}),define(be[41],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function y(v,w){const o=Object.create(null);for(const u of v){const c=w(u);let L=o[c];L||(L=o[c]=[]),L.push(u)}return o}t.$I=y;function N(v,w){const o=[],u=[];for(const c of v)w.has(c)||o.push(c);for(const c of w)v.has(c)||u.push(c);return{removed:o,added:u}}t.$J=N;function n(v,w){const o=[],u=[];for(const[c,L]of v)w.has(c)||o.push(L);for(const[c,L]of w)v.has(c)||u.push(L);return{removed:o,added:u}}t.$K=n;class W{constructor(){this.a=new Map}add(w,o){let u=this.a.get(w);u||(u=new Set,this.a.set(w,u)),u.add(o)}delete(w,o){const u=this.a.get(w);u&&(u.delete(o),u.size===0&&this.a.delete(w))}forEach(w,o){const u=this.a.get(w);u&&u.forEach(o)}get(w){const o=this.a.get(w);return o||new Set}}t.$L=W}),define(be[71],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=t.$Ms=t.$Ls=void 0;function y(w,o){const u=Math.pow(10,o);return Math.round(w*u)/u}class N{constructor(o,u,c,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=y(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.r===u.r&&o.g===u.g&&o.b===u.b&&o.a===u.a}}t.$Ls=N;class n{constructor(o,u,c,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.l=y(Math.max(Math.min(1,c),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.h===u.h&&o.s===u.s&&o.l===u.l&&o.a===u.a}static fromRGBA(o){const u=o.r/255,c=o.g/255,L=o.b/255,s=o.a,a=Math.max(u,c,L),e=Math.min(u,c,L);let l=0,r=0;const m=(e+a)/2,i=a-e;if(i>0){switch(r=Math.min(m<=.5?i/(2*m):i/(2-2*m),1),a){case u:l=(c-L)/i+(c<L?6:0);break;case c:l=(L-u)/i+2;break;case L:l=(u-c)/i+4;break}l*=60,l=Math.round(l)}return new n(l,r,m,s)}static i(o,u,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?o+(u-o)*6*c:c<1/2?u:c<2/3?o+(u-o)*(2/3-c)*6:o}static toRGBA(o){const u=o.h/360,{s:c,l:L,a:s}=o;let a,e,l;if(c===0)a=e=l=L;else{const r=L<.5?L*(1+c):L+c-L*c,m=2*L-r;a=n.i(m,r,u+1/3),e=n.i(m,r,u),l=n.i(m,r,u-1/3)}return new N(Math.round(a*255),Math.round(e*255),Math.round(l*255),s)}}t.$Ms=n;class W{constructor(o,u,c,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.v=y(Math.max(Math.min(1,c),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.h===u.h&&o.s===u.s&&o.v===u.v&&o.a===u.a}static fromRGBA(o){const u=o.r/255,c=o.g/255,L=o.b/255,s=Math.max(u,c,L),a=Math.min(u,c,L),e=s-a,l=s===0?0:e/s;let r;return e===0?r=0:s===u?r=((c-L)/e%6+6)%6:s===c?r=(L-u)/e+2:r=(u-c)/e+4,new W(Math.round(r*60),l,s,o.a)}static toRGBA(o){const{h:u,s:c,v:L,a:s}=o,a=L*c,e=a*(1-Math.abs(u/60%2-1)),l=L-a;let[r,m,i]=[0,0,0];return u<60?(r=a,m=e):u<120?(r=e,m=a):u<180?(m=a,i=e):u<240?(m=e,i=a):u<300?(r=e,i=a):u<=360&&(r=a,i=e),r=Math.round((r+l)*255),m=Math.round((m+l)*255),i=Math.round((i+l)*255),new N(r,m,i,s)}}t.$Ns=W;class v{static fromHex(o){return v.Format.CSS.parseHex(o)||v.red}static equals(o,u){return!o&&!u?!0:!o||!u?!1:o.equals(u)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof N)this.rgba=o;else if(o instanceof n)this.i=o,this.rgba=n.toRGBA(o);else if(o instanceof W)this.j=o,this.rgba=W.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&N.equals(this.rgba,o.rgba)&&n.equals(this.hsla,o.hsla)&&W.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=v.k(this.rgba.r),u=v.k(this.rgba.g),c=v.k(this.rgba.b),L=.2126*o+.7152*u+.0722*c;return y(L,4)}static k(o){const u=o/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(o){const u=this.getRelativeLuminance(),c=o.getRelativeLuminance();return u>c?(u+.05)/(c+.05):(c+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const u=this.getRelativeLuminance(),c=o.getRelativeLuminance();return u>c}isDarkerThan(o){const u=this.getRelativeLuminance(),c=o.getRelativeLuminance();return u<c}lighten(o){return new v(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new v(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:u,g:c,b:L,a:s}=this.rgba;return new v(new N(u,c,L,s*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(o){const u=o.rgba,c=this.rgba.a,L=u.a,s=c+L*(1-c);if(s<1e-6)return v.transparent;const a=this.rgba.r*c/s+u.r*L*(1-c)/s,e=this.rgba.g*c/s+u.g*L*(1-c)/s,l=this.rgba.b*c/s+u.b*L*(1-c)/s;return new v(new N(a,e,l,s))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:u,g:c,b:L,a:s}=this.rgba;return new v(new N(o.rgba.r-s*(o.rgba.r-u),o.rgba.g-s*(o.rgba.g-c),o.rgba.b-s*(o.rgba.b-L),1))}flatten(...o){const u=o.reduceRight((c,L)=>v.o(L,c));return v.o(this,u)}static o(o,u){const c=1-o.rgba.a;return new v(new N(c*u.rgba.r+o.rgba.a*o.rgba.r,c*u.rgba.g+o.rgba.a*o.rgba.g,c*u.rgba.b+o.rgba.a*o.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(o,u,c){if(o.isLighterThan(u))return o;c=c||.5;const L=o.getRelativeLuminance(),s=u.getRelativeLuminance();return c=c*(s-L)/s,o.lighten(c)}static getDarkerColor(o,u,c){if(o.isDarkerThan(u))return o;c=c||.5;const L=o.getRelativeLuminance(),s=u.getRelativeLuminance();return c=c*(L-s)/L,o.darken(c)}static{this.white=new v(new N(255,255,255,1))}static{this.black=new v(new N(0,0,0,1))}static{this.red=new v(new N(255,0,0,1))}static{this.blue=new v(new N(0,0,255,1))}static{this.green=new v(new N(0,255,0,1))}static{this.cyan=new v(new N(0,255,255,1))}static{this.lightgrey=new v(new N(211,211,211,1))}static{this.transparent=new v(new N(0,0,0,0))}}t.$Os=v,function(w){let o;(function(u){let c;(function(L){function s(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:w.Format.CSS.formatRGBA(h)}L.formatRGB=s;function a(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}L.formatRGBA=a;function e(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(h)}L.formatHSL=e;function l(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}L.formatHSLA=l;function r(h){const F=h.toString(16);return F.length!==2?"0"+F:F}function m(h){return`#${r(h.rgba.r)}${r(h.rgba.g)}${r(h.rgba.b)}`}L.formatHex=m;function i(h,F=!1){return F&&h.rgba.a===1?w.Format.CSS.formatHex(h):`#${r(h.rgba.r)}${r(h.rgba.g)}${r(h.rgba.b)}${r(Math.round(h.rgba.a*255))}`}L.formatHexA=i;function d(h){return h.isOpaque()?w.Format.CSS.formatHex(h):w.Format.CSS.formatRGBA(h)}L.format=d;function $(h){const F=h.length;if(F===0||h.charCodeAt(0)!==35)return null;if(F===7){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),I=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),b=16*f(h.charCodeAt(5))+f(h.charCodeAt(6));return new w(new N(M,I,b,1))}if(F===9){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),I=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),b=16*f(h.charCodeAt(5))+f(h.charCodeAt(6)),D=16*f(h.charCodeAt(7))+f(h.charCodeAt(8));return new w(new N(M,I,b,D/255))}if(F===4){const M=f(h.charCodeAt(1)),I=f(h.charCodeAt(2)),b=f(h.charCodeAt(3));return new w(new N(16*M+M,16*I+I,16*b+b))}if(F===5){const M=f(h.charCodeAt(1)),I=f(h.charCodeAt(2)),b=f(h.charCodeAt(3)),D=f(h.charCodeAt(4));return new w(new N(16*M+M,16*I+I,16*b+b,(16*D+D)/255))}return null}L.parseHex=$;function f(h){switch(h){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=u.CSS||(u.CSS={}))})(o=w.Format||(w.Format={}))}(v||(t.$Os=v={}))}),define(be[25],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8g=t.$7g=t.$6g=void 0;function y(v){return(w,o,u)=>{let c=null,L=null;if(typeof u.value=="function"?(c="value",L=u.value):typeof u.get=="function"&&(c="get",L=u.get),!L)throw new Error("not supported");u[c]=v(L,o)}}function N(v,w,o){let u=null,c=null;if(typeof o.value=="function"?(u="value",c=o.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(u="get",c=o.get),!c)throw new Error("not supported");const L=`$memoize$${w}`;o[u]=function(...s){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,s)}),this[L]}}t.$6g=N;function n(v,w,o){return y((u,c)=>{const L=`$debounce$${c}`,s=`$debounce$result$${c}`;return function(...a){this[s]||(this[s]=o?o():void 0),clearTimeout(this[L]),w&&(this[s]=w(this[s],...a),a=[this[s]]),this[L]=setTimeout(()=>{u.apply(this,a),this[s]=o?o():void 0},v)}})}t.$7g=n;function W(v,w,o){return y((u,c)=>{const L=`$throttle$timer$${c}`,s=`$throttle$result$${c}`,a=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...l){if(this[s]||(this[s]=o?o():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),w&&(this[s]=w(this[s],...l)),this[e])return;const r=this[a]+v;r<=Date.now()?(this[a]=Date.now(),u.apply(this,[this[s]]),this[s]=o?o():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),u.apply(this,[this[s]]),this[s]=o?o():void 0},r-Date.now()))}})}t.$8g=W}),define(be[72],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=void 0;class y{constructor(n,W,v,w){this.originalStart=n,this.originalLength=W,this.modifiedStart=v,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ns=y}),define(be[6],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class y{constructor(){this.b=[],this.a=function(h){setTimeout(()=>{throw h.stack?d.isErrorNoTelemetry(h)?new d(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.b.push(h),()=>{this.d(h)}}c(h){this.b.forEach(F=>{F(h)})}d(h){this.b.splice(this.b.indexOf(h),1)}setUnexpectedErrorHandler(h){this.a=h}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(h){this.a(h),this.c(h)}onUnexpectedExternalError(h){this.a(h)}}t.$U=y,t.$V=new y;function N(f){t.$V.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=N;function n(f){if(!f||typeof f!="object")return!1;const h=f;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}t.$X=n;function W(f){u(f)||t.$V.onUnexpectedError(f)}t.$Y=W;function v(f){u(f)||t.$V.onUnexpectedExternalError(f)}t.$Z=v;function w(f){if(f instanceof Error){const{name:h,message:F}=f,M=f.stacktrace||f.stack;return{$isError:!0,name:h,message:F,stack:M,noTelemetry:d.isErrorNoTelemetry(f)}}return f}t.$1=w;const o="Canceled";function u(f){return f instanceof c?!0:f instanceof Error&&f.name===o&&f.message===o}t.$2=u;class c extends Error{constructor(){super(o),this.name=this.message}}t.$3=c;function L(){const f=new Error(o);return f.name=f.message,f}t.$4=L;function s(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$5=s;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$6=a;class e extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function l(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$8=l;class r extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.$9=r;class m extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.$0=m;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=i;class d extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof d)return h;const F=new d;return F.message=h.message,F.stack=h.stack,F}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.$_=d;class $ extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}t.$ab=$}),define(be[11],$e([1,0,6,70]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.CompareResult=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.top=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function n(T,O=0){return T[T.length-(1+O)]}t.$qb=n;function W(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.$rb=W;function v(T,O,P=(_,C)=>_===C){if(T===O)return!0;if(!T||!O||T.length!==O.length)return!1;for(let _=0,C=T.length;_<C;_++)if(!P(T[_],O[_]))return!1;return!0}t.$sb=v;function w(T,O){const P=T.length-1;O<P&&(T[O]=T[P]),T.pop()}t.$tb=w;function o(T,O,P){return u(T.length,_=>P(T[_],O))}t.$ub=o;function u(T,O){let P=0,_=T-1;for(;P<=_;){const C=(P+_)/2|0,R=O(C);if(R<0)P=C+1;else if(R>0)_=C-1;else return C}return-(P+1)}t.$vb=u;function c(T,O,P){if(T=T|0,T>=O.length)throw new TypeError("invalid index");const _=O[Math.floor(O.length*Math.random())],C=[],R=[],A=[];for(const k of O){const U=P(k,_);U<0?C.push(k):U>0?R.push(k):A.push(k)}return T<C.length?c(T,C,P):T<C.length+A.length?A[0]:c(T-(C.length+A.length),R,P)}t.$wb=c;function L(T,O){const P=[];let _;for(const C of T.slice(0).sort(O))!_||O(_[0],C)!==0?(_=[C],P.push(_)):_.push(C);return P}t.$xb=L;function*s(T,O){let P,_;for(const C of T)_!==void 0&&O(_,C)?P.push(C):(P&&(yield P),P=[C]),_=C;P&&(yield P)}t.$yb=s;function a(T,O){for(let P=0;P<=T.length;P++)O(P===0?void 0:T[P-1],P===T.length?void 0:T[P])}t.$zb=a;function e(T,O){for(let P=0;P<T.length;P++)O(P===0?void 0:T[P-1],T[P],P+1===T.length?void 0:T[P+1])}t.$Ab=e;function l(T,O,P){const _=[];function C(k,U,K){if(U===0&&K.length===0)return;const te=_[_.length-1];te&&te.start+te.deleteCount===k?(te.deleteCount+=U,te.toInsert.push(...K)):_.push({start:k,deleteCount:U,toInsert:K})}let R=0,A=0;for(;;){if(R===T.length){C(R,0,O.slice(A));break}if(A===O.length){C(R,T.length-R,[]);break}const k=T[R],U=O[A],K=P(k,U);K===0?(R+=1,A+=1):K<0?(C(R,1,[]),R+=1):K>0&&(C(R,0,[U]),A+=1)}return _}t.$Bb=l;function r(T,O,P){const _=l(T,O,P),C=[],R=[];for(const A of _)C.push(...T.slice(A.start,A.start+A.deleteCount)),R.push(...A.toInsert);return{removed:C,added:R}}t.$Cb=r;function m(T,O,P){if(P===0)return[];const _=T.slice(0,P).sort(O);return d(T,O,_,P,T.length),_}t.top=m;function i(T,O,P,_,C){return P===0?Promise.resolve([]):new Promise((R,A)=>{(async()=>{const k=T.length,U=T.slice(0,P).sort(O);for(let K=P,te=Math.min(P+_,k);K<k;K=te,te=Math.min(te+_,k)){if(K>P&&await new Promise(se=>setTimeout(se)),C&&C.isCancellationRequested)throw new y.$3;d(T,O,U,K,te)}return U})().then(R,A)})}t.$Eb=i;function d(T,O,P,_,C){for(const R=P.length;_<C;_++){const A=T[_];if(O(A,P[R-1])<0){P.pop();const k=(0,N.$ib)(P,U=>O(A,U)<0);P.splice(k,0,A)}}}function $(T){return T.filter(O=>!!O)}t.$Fb=$;function f(T){let O=0;for(let P=0;P<T.length;P++)T[P]&&(T[O]=T[P],O+=1);T.length=O}t.$Gb=f;function h(T,O,P){T.splice(P,0,T.splice(O,1)[0])}t.$Hb=h;function F(T){return!Array.isArray(T)||T.length===0}t.$Ib=F;function M(T){return Array.isArray(T)&&T.length>0}t.$Jb=M;function I(T,O=P=>P){const P=new Set;return T.filter(_=>{const C=O(_);return P.has(C)?!1:(P.add(C),!0)})}t.$Kb=I;function b(T){const O=new Set;return P=>{const _=T(P);return O.has(_)?!1:(O.add(_),!0)}}t.$Lb=b;function D(T,O){return T.length>0?T[0]:O}t.$Mb=D;function j(T,O){return T.length>0?T[T.length-1]:O}t.$Nb=j;function H(T,O,P=(_,C)=>_===C){let _=0;for(let C=0,R=Math.min(T.length,O.length);C<R&&P(T[C],O[C]);C++)_++;return _}t.$Ob=H;function B(T){return[].concat(...T)}t.$Pb=B;function E(T,O){let P=typeof O=="number"?T:0;typeof O=="number"?P=T:(P=0,O=T);const _=[];if(P<=O)for(let C=P;C<O;C++)_.push(C);else for(let C=P;C>O;C--)_.push(C);return _}t.$Qb=E;function z(T,O,P){return T.reduce((_,C)=>(_[O(C)]=P?P(C):C,_),Object.create(null))}t.$Rb=z;function X(T,O){return T.push(O),()=>ie(T,O)}t.$Sb=X;function ie(T,O){const P=T.indexOf(O);if(P>-1)return T.splice(P,1),O}t.$Tb=ie;function ue(T,O,P){const _=T.slice(0,O),C=T.slice(O);return _.concat(P,C)}t.$Ub=ue;function ae(T,O){let P;if(typeof O=="number"){let _=O;P=()=>{const C=Math.sin(_++)*179426549;return C-Math.floor(C)}}else P=Math.random;for(let _=T.length-1;_>0;_-=1){const C=Math.floor(P()*(_+1)),R=T[_];T[_]=T[C],T[C]=R}}t.$Vb=ae;function oe(T,O){const P=T.indexOf(O);P>-1&&(T.splice(P,1),T.unshift(O))}t.$Wb=oe;function re(T,O){const P=T.indexOf(O);P>-1&&(T.splice(P,1),T.push(O))}t.$Xb=re;function ge(T,O){for(const P of O)T.push(P)}t.$Yb=ge;function Ce(T,O){return Array.isArray(T)?T.map(O):O(T)}t.$Zb=Ce;function Fe(T){return Array.isArray(T)?T:[T]}t.$1b=Fe;function Me(T){return T[Math.floor(Math.random()*T.length)]}t.$2b=Me;function fe(T,O,P){const _=Q(T,O),C=T.length,R=P.length;T.length=C+R;for(let A=C-1;A>=_;A--)T[A+R]=T[A];for(let A=0;A<R;A++)T[A+_]=P[A]}t.$3b=fe;function ne(T,O,P,_){const C=Q(T,O);let R=T.splice(C,P);return R===void 0&&(R=[]),fe(T,C,_),R}t.$4b=ne;function Q(T,O){return O<0?Math.max(O+T.length,0):Math.min(O,T.length)}var V;(function(T){function O(R){return R<0}T.isLessThan=O;function P(R){return R<=0}T.isLessThanOrEqual=P;function _(R){return R>0}T.isGreaterThan=_;function C(R){return R===0}T.isNeitherLessOrGreaterThan=C,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(V||(t.CompareResult=V={}));function ee(T,O){return(P,_)=>O(T(P),T(_))}t.$5b=ee;function J(...T){return(O,P)=>{for(const _ of T){const C=_(O,P);if(!V.isNeitherLessOrGreaterThan(C))return C}return V.neitherLessOrGreaterThan}}t.$6b=J;const S=(T,O)=>T-O;t.$7b=S;const x=(T,O)=>(0,t.$7b)(T?1:0,O?1:0);t.$8b=x;function g(T){return(O,P)=>-T(O,P)}t.$9b=g;class p{constructor(O){this.g=O,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(O){let P=this.c;for(;P<this.g.length&&O(this.g[P]);)P++;const _=P===this.c?null:this.g.slice(this.c,P);return this.c=P,_}takeFromEndWhile(O){let P=this.d;for(;P>=0&&O(this.g[P]);)P--;const _=P===this.d?null:this.g.slice(P+1,this.d+1);return this.d=P,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const O=this.g[this.c];return this.c++,O}removeLast(){const O=this.g[this.d];return this.d--,O}takeCount(O){const P=this.g.slice(this.c,this.c+O);return this.c+=O,P}}t.$0b=p;class q{static{this.empty=new q(O=>{})}constructor(O){this.iterate=O}forEach(O){this.iterate(P=>(O(P),!0))}toArray(){const O=[];return this.iterate(P=>(O.push(P),!0)),O}filter(O){return new q(P=>this.iterate(_=>O(_)?P(_):!0))}map(O){return new q(P=>this.iterate(_=>P(O(_))))}some(O){let P=!1;return this.iterate(_=>(P=O(_),!P)),P}findFirst(O){let P;return this.iterate(_=>O(_)?(P=_,!1):!0),P}findLast(O){let P;return this.iterate(_=>(O(_)&&(P=_),!0)),P}findLastMaxBy(O){let P,_=!0;return this.iterate(C=>((_||V.isGreaterThan(O(C,P)))&&(_=!1,P=C),!0)),P}}t.$$b=q}),define(be[73],$e([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yc=t.$xc=t.$wc=t.$vc=t.ok=void 0;function N(o,u){if(!o)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=N;function n(o,u="Unreachable"){throw new Error(u)}t.$vc=n;function W(o){if(!o)throw new y.$ab("Assertion Failed")}t.$wc=W;function v(o){if(!o()){debugger;o(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}t.$xc=v;function w(o,u){let c=0;for(;c<o.length-1;){const L=o[c],s=o[c+1];if(!u(L,s))return!1;c++}return!0}t.$yc=w}),define(be[42],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function y(N){const n=this;let W=!1,v;return function(){return W||(W=!0,v=N.apply(n,arguments)),v}}t.$bb=y}),define(be[74],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aM=t.$_L=void 0;class y{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$_L=y,t.$aM=new y("id#")}),define(be[26],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(N){function n(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}N.is=n;const W=Object.freeze([]);function v(){return W}N.empty=v;function*w(f){yield f}N.single=w;function o(f){return n(f)?f:w(f)}N.wrap=o;function u(f){return f||W}N.from=u;function*c(f){for(let h=f.length-1;h>=0;h--)yield f[h]}N.reverse=c;function L(f){return!f||f[Symbol.iterator]().next().done===!0}N.isEmpty=L;function s(f){return f[Symbol.iterator]().next().value}N.first=s;function a(f,h){for(const F of f)if(h(F))return!0;return!1}N.some=a;function e(f,h){for(const F of f)if(h(F))return F}N.find=e;function*l(f,h){for(const F of f)h(F)&&(yield F)}N.filter=l;function*r(f,h){let F=0;for(const M of f)yield h(M,F++)}N.map=r;function*m(...f){for(const h of f)for(const F of h)yield F}N.concat=m;function i(f,h,F){let M=F;for(const I of f)M=h(M,I);return M}N.reduce=i;function*d(f,h,F=f.length){for(h<0&&(h+=f.length),F<0?F+=f.length:F>f.length&&(F=f.length);h<F;h++)yield f[h]}N.slice=d;function $(f,h=Number.POSITIVE_INFINITY){const F=[];if(h===0)return[F,f];const M=f[Symbol.iterator]();for(let I=0;I<h;I++){const b=M.next();if(b.done)return[F,N.empty()];F.push(b.value)}return[F,{[Symbol.iterator](){return M}}]}N.consume=$})(y||(t.Iterable=y={}))}),define(be[43],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vq=t.KeyMod=t.KeyCodeUtils=t.$uq=t.$tq=t.$sq=t.$rq=t.$qq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,r){this._keyCodeToStr[l]=r,this._strToKeyCode[r.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||0}}const W=new n,v=new n,w=new n;t.$qq=new Array(230),t.$rq={};const o=[],u=Object.create(null),c=Object.create(null);t.$sq={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>u[e]||0,toString:e=>o[e]||"None"},t.$tq=[],t.$uq=[];for(let e=0;e<=193;e++)t.$tq[e]=-1;for(let e=0;e<=132;e++)t.$uq[e]=-1;(function(){const e="",l=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],m=[];for(const i of l){const[d,$,f,h,F,M,I,b,D]=i;if(m[$]||(m[$]=!0,o[$]=f,u[f]=$,c[f.toLowerCase()]=$,d&&(t.$tq[$]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(t.$uq[h]=$))),!r[h]){if(r[h]=!0,!F)throw new Error(`String representation missing for key code ${h} around scan code ${f}`);W.define(h,F),v.define(h,b||F),w.define(h,D||b||F)}M&&(t.$qq[M]=h),I&&(t.$rq[I]=h)}t.$uq[3]=46})();var L;(function(e){function l(f){return W.keyCodeToStr(f)}e.toString=l;function r(f){return W.strToKeyCode(f)}e.fromString=r;function m(f){return v.keyCodeToStr(f)}e.toUserSettingsUS=m;function i(f){return w.keyCodeToStr(f)}e.toUserSettingsGeneral=i;function d(f){return v.strToKeyCode(f)||w.strToKeyCode(f)}e.fromUserSettings=d;function $(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(f)}e.toElectronAccelerator=$})(L||(t.KeyCodeUtils=L={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,l){const r=(l&65535)<<16>>>0;return(e|r)>>>0}t.$vq=a}),define(be[75],$e([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cq=t.$Bq=t.$Aq=t.$zq=t.$yq=t.$xq=t.$wq=void 0;var N;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(N||(N={}));function n(L,s){if(typeof L=="number"){if(L===0)return null;const a=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new o([W(a,s),W(e,s)]):new o([W(a,s)])}else{const a=[];for(let e=0;e<L.length;e++)a.push(W(L[e],s));return new o(a)}}t.$wq=n;function W(L,s){const a=!!(L&2048),e=!!(L&256),l=s===2?e:a,r=!!(L&1024),m=!!(L&512),i=s===2?a:e,d=L&255;return new v(l,r,m,i,d)}t.$xq=W;class v{constructor(s,a,e,l,r){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=l,this.keyCode=r}equals(s){return s instanceof v&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`K${s}${a}${e}${l}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new o([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$yq=v;class w{constructor(s,a,e,l,r){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=l,this.scanCode=r}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",l=this.metaKey?"1":"0";return`S${s}${a}${e}${l}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$zq=w;class o{constructor(s){if(s.length===0)throw(0,y.$5)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Aq=o;class u{constructor(s,a,e,l,r,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=l,this.keyLabel=r,this.keyAriaLabel=m}}t.$Bq=u;class c{}t.$Cq=c}),define(be[30],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class y{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=y}),define(be[2],$e([1,0,11,41,42,26]),function(le,t,y,N,n,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=void 0;const v=!1;let w=null;class o{constructor(){this.b=new Map}static{this.a=0}c(E){let z=this.b.get(E);return z||(z={parent:null,source:null,isSingleton:!1,value:E,idx:o.a++},this.b.set(E,z)),z}trackDisposable(E){const z=this.c(E);z.source||(z.source=new Error().stack)}setParent(E,z){const X=this.c(E);X.parent=z}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,z){const X=z.get(E);if(X)return X;const ie=E.parent?this.f(this.c(E.parent),z):E;return z.set(E,ie),ie}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,E).isSingleton).map(([X])=>X).flat()}computeLeakingDisposables(E=10,z){let X;if(z)X=z;else{const re=new Map,ge=[...this.b.values()].filter(Fe=>Fe.source!==null&&!this.f(Fe,re).isSingleton);if(ge.length===0)return;const Ce=new Set(ge.map(Fe=>Fe.value));if(X=ge.filter(Fe=>!(Fe.parent&&Ce.has(Fe.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function ie(re){function ge(Fe,Me){for(;Fe.length>0&&Me.some(fe=>typeof fe=="string"?fe===Fe[0]:Fe[0].match(fe));)Fe.shift()}const Ce=re.source.split(`
`).map(Fe=>Fe.trim().replace("at ","")).filter(Fe=>Fe!=="");return ge(Ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ce.reverse()}const ue=new N.$L;for(const re of X){const ge=ie(re);for(let Ce=0;Ce<=ge.length;Ce++)ue.add(ge.slice(0,Ce).join(`
`),re)}X.sort((0,y.$5b)(re=>re.idx,y.$7b));let ae="",oe=0;for(const re of X.slice(0,E)){oe++;const ge=ie(re),Ce=[];for(let Fe=0;Fe<ge.length;Fe++){let Me=ge[Fe];Me=`(shared with ${ue.get(ge.slice(0,Fe+1).join(`
`)).size}/${X.length} leaks) at ${Me}`;const ne=ue.get(ge.slice(0,Fe).join(`
`)),Q=(0,N.$I)([...ne].map(V=>ie(V)[Fe]),V=>V);delete Q[ge[Fe]];for(const[V,ee]of Object.entries(Q))Ce.unshift(`    - stacktraces of ${ee.length} other leaks continue with ${V}`);Ce.unshift(Me)}ae+=`


==================== Leaking disposable ${oe}/${X.length}: ${re.value.constructor.name} ====================
${Ce.join(`
`)}
============================================================

`}return X.length>E&&(ae+=`


... and ${X.length-E} more leaking disposables

`),{leaks:X,details:ae}}}t.$_b=o;function u(B){w=B}if(t.$ac=u,v){const B="__is_disposable_tracked__";u(new class{trackDisposable(E){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[B]||console.log(z)},3e3)}setParent(E,z){if(E&&E!==f.None)try{E[B]=!0}catch{}}markAsDisposed(E){if(E&&E!==f.None)try{E[B]=!0}catch{}}markAsSingleton(E){}})}function c(B){return w?.trackDisposable(B),B}t.$bc=c;function L(B){w?.markAsDisposed(B)}t.$cc=L;function s(B,E){w?.setParent(B,E)}function a(B,E){if(w)for(const z of B)w.setParent(z,E)}function e(B){return w?.markAsSingleton(B),B}t.$dc=e;function l(B){return typeof B.dispose=="function"&&B.dispose.length===0}t.$ec=l;function r(B){if(W.Iterable.is(B)){const E=[];for(const z of B)if(z)try{z.dispose()}catch(X){E.push(X)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(B)?[]:B}else if(B)return B.dispose(),B}t.$fc=r;function m(B){for(const E of B)l(E)&&E.dispose();return[]}t.$gc=m;function i(...B){const E=d(()=>r(B));return a(B,E),E}t.$hc=i;function d(B){const E=c({dispose:(0,n.$bb)(()=>{L(E),B()})});return E}t.$ic=d;class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,c(this)}dispose(){this.g||(L(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return s(E,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),s(E,null))}}t.$jc=$;class f{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,c(this),s(this.q,this)}dispose(){L(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}t.$kc=f;class h{constructor(){this.b=!1,c(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&s(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,L(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&s(E,null),E}}t.$lc=h;class F{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$mc=F;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,c(this)}set(E){let z=E;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,L(this))},this}}t.$nc=M;class I{constructor(){this.a=new Map}acquire(E,...z){let X=this.a.get(E);X||(X={counter:0,object:this.b(E,...z)},this.a.set(E,X));const{object:ie}=X,ue=(0,n.$bb)(()=>{--X.counter===0&&(this.c(E,X.object),this.a.delete(E))});return X.counter++,{object:ie,dispose:ue}}}t.$oc=I;class b{constructor(E){this.a=E}async acquire(E,...z){const X=this.a.acquire(E,...z);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(ie){throw X.dispose(),ie}}}t.$pc=b;class D{constructor(E){this.object=E}dispose(){}}t.$qc=D;function j(B){const E=new $;try{B(E)}finally{E.dispose()}}t.$rc=j;class H{constructor(){this.a=new Map,this.b=!1,c(this)}dispose(){L(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,z,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(E)?.dispose(),this.a.set(E,z)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$sc=H}),define(be[44],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=void 0;class y{static{this.Undefined=new y(void 0)}constructor(W){this.element=W,this.next=y.Undefined,this.prev=y.Undefined}}class N{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let W=this.a;for(;W!==y.Undefined;){const v=W.next;W.prev=y.Undefined,W.next=y.Undefined,W=v}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,v){const w=new y(W);if(this.a===y.Undefined)this.a=w,this.b=w;else if(v){const u=this.b;this.b=w,w.prev=u,u.next=w}else{const u=this.a;this.a=w,w.next=u,u.prev=w}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(w))}}shift(){if(this.a!==y.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==y.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==y.Undefined&&W.next!==y.Undefined){const v=W.prev;v.next=W.next,W.next.prev=v}else W.prev===y.Undefined&&W.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):W.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):W.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==y.Undefined;)yield W.element,W=W.next}}t.$tc=N}),define(be[76],$e([1,0]),function(le,t){"use strict";var y,N,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ei=t.$Di=t.$Ci=t.$Bi=t.Touch=t.$Ai=t.$zi=t.$yi=t.$xi=t.$wi=void 0;function W(m,i,d){let $=m.get(i);return $===void 0&&($=d,m.set(i,$)),$}t.$wi=W;function v(m){const i=[];return m.forEach((d,$)=>{i.push(`${$} => ${d}`)}),`Map(${m.size}) {${i.join(", ")}}`}t.$xi=v;function w(m){const i=[];return m.forEach(d=>{i.push(d)}),`Set(${m.size}) {${i.join(", ")}}`}t.$yi=w;class o{constructor(i,d){this.uri=i,this.value=d}}function u(m){return Array.isArray(m)}class c{static{this.a=i=>i.toString()}constructor(i,d){if(this[y]="ResourceMap",i instanceof c)this.b=new Map(i.b),this.c=d??c.a;else if(u(i)){this.b=new Map,this.c=d??c.a;for(const[$,f]of i)this.set($,f)}else this.b=new Map,this.c=i??c.a}set(i,d){return this.b.set(this.c(i),new o(i,d)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,d){typeof d<"u"&&(i=i.bind(d));for(const[$,f]of this.b)i(f.value,f.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}t.$zi=c;class L{constructor(i,d){this[N]="ResourceSet",!i||typeof i=="function"?this.a=new c(i):(this.a=new c(d),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,d){this.a.forEach(($,f)=>i.call(d,f,f,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ai=L;var s;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,d=0){const $=this.a.get(i);if($)return d!==0&&this.j($,d),$.value}set(i,d,$=0){let f=this.a.get(i);if(f)f.value=d,$!==0&&this.j(f,$);else{switch(f={key:i,value:d,next:void 0,previous:void 0},$){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(i,f),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const d=this.a.get(i);if(d)return this.a.delete(i),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,d){const $=this.e;let f=this.b;for(;f;){if(d?i.bind(d)(f.value,f.key,this):i(f.value,f.key,this),this.e!==$)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const i=this,d=this.e;let $=this.b;const f={[Symbol.iterator](){return f},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if($){const h={value:$.key,done:!1};return $=$.next,h}else return{value:void 0,done:!0}}};return f}values(){const i=this,d=this.e;let $=this.b;const f={[Symbol.iterator](){return f},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if($){const h={value:$.value,done:!1};return $=$.next,h}else return{value:void 0,done:!0}}};return f}entries(){const i=this,d=this.e;let $=this.b;const f={[Symbol.iterator](){return f},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if($){const h={value:[$.key,$.value],done:!1};return $=$.next,h}else return{value:void 0,done:!0}}};return f}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let d=this.b,$=this.size;for(;d&&$>i;)this.a.delete(d.key),d=d.next,$--;this.b=d,this.d=$,d&&(d.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const d=i.next,$=i.previous;if(!d||!$)throw new Error("Invalid list");d.previous=$,$.next=d}i.next=void 0,i.previous=void 0,this.e++}j(i,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(i===this.b)return;const $=i.next,f=i.previous;i===this.c?(f.next=void 0,this.c=f):($.previous=f,f.next=$),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(d===2){if(i===this.c)return;const $=i.next,f=i.previous;i===this.b?($.previous=void 0,this.b=$):($.previous=f,f.next=$),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((d,$)=>{i.push([$,d])}),i}fromJSON(i){this.clear();for(const[d,$]of i)this.set(d,$)}}t.$Bi=a;class e extends a{constructor(i,d=1){super(),this.k=i,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,d=2){return super.get(i,d)}peek(i){return super.get(i,0)}set(i,d){return super.set(i,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Ci=e;class l{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let d=this.a.get(i)||0;return d===0?!1:(d--,d===0?this.a.delete(i):this.a.set(i,d),!0)}has(i){return this.a.has(i)}}t.$Di=l;class r{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[d,$]of i)this.set(d,$)}clear(){this.a.clear(),this.b.clear()}set(i,d){this.a.set(i,d),this.b.set(d,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const d=this.a.get(i);return d===void 0?!1:(this.a.delete(i),this.b.delete(d),!0)}forEach(i,d){this.a.forEach(($,f)=>{i.call(d,$,f,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ei=r}),function(le,t){typeof define=="function"&&define.amd?define(be[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t(O,P){for(var _=0;_<P.length;_++){var C=P[_];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(O,C.key,C)}}function y(O,P,_){return P&&t(O.prototype,P),_&&t(O,_),Object.defineProperty(O,"prototype",{writable:!1}),O}function N(O,P){if(O){if(typeof O=="string")return n(O,P);var _=Object.prototype.toString.call(O).slice(8,-1);if(_==="Object"&&O.constructor&&(_=O.constructor.name),_==="Map"||_==="Set")return Array.from(O);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return n(O,P)}}function n(O,P){(P==null||P>O.length)&&(P=O.length);for(var _=0,C=new Array(P);_<P;_++)C[_]=O[_];return C}function W(O,P){var _=typeof Symbol<"u"&&O[Symbol.iterator]||O["@@iterator"];if(_)return(_=_.call(O)).next.bind(_);if(Array.isArray(O)||(_=N(O))||P&&O&&typeof O.length=="number"){_&&(O=_);var C=0;return function(){return C>=O.length?{done:!0}:{done:!1,value:O[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function v(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=v();function w(O){le.defaults=O}var o=/[&<>"']/,u=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(P){return s[P]};function e(O,P){if(P){if(o.test(O))return O.replace(u,a)}else if(c.test(O))return O.replace(L,a);return O}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(O){return O.replace(l,function(P,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var m=/(^|[^\[])\^/g;function i(O,P){O=typeof O=="string"?O:O.source,P=P||"";var _={replace:function(R,A){return A=A.source||A,A=A.replace(m,"$1"),O=O.replace(R,A),_},getRegex:function(){return new RegExp(O,P)}};return _}var d=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(O,P,_){if(O){var C;try{C=decodeURIComponent(r(_)).replace(d,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}P&&!$.test(_)&&(_=b(P,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var h={},F=/^[^:]+:\/*[^/]*$/,M=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(O,P){h[" "+O]||(F.test(O)?h[" "+O]=O+"/":h[" "+O]=B(O,"/",!0)),O=h[" "+O];var _=O.indexOf(":")===-1;return P.substring(0,2)==="//"?_?P:O.replace(M,"$1")+P:P.charAt(0)==="/"?_?P:O.replace(I,"$1")+P:O+P}var D={exec:function(){}};function j(O){for(var P=1,_,C;P<arguments.length;P++){_=arguments[P];for(C in _)Object.prototype.hasOwnProperty.call(_,C)&&(O[C]=_[C])}return O}function H(O,P){var _=O.replace(/\|/g,function(A,k,U){for(var K=!1,te=k;--te>=0&&U[te]==="\\";)K=!K;return K?"|":" |"}),C=_.split(/ \|/),R=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>P)C.splice(P);else for(;C.length<P;)C.push("");for(;R<C.length;R++)C[R]=C[R].trim().replace(/\\\|/g,"|");return C}function B(O,P,_){var C=O.length;if(C===0)return"";for(var R=0;R<C;){var A=O.charAt(C-R-1);if(A===P&&!_)R++;else if(A!==P&&_)R++;else break}return O.slice(0,C-R)}function E(O,P){if(O.indexOf(P[1])===-1)return-1;for(var _=O.length,C=0,R=0;R<_;R++)if(O[R]==="\\")R++;else if(O[R]===P[0])C++;else if(O[R]===P[1]&&(C--,C<0))return R;return-1}function z(O){O&&O.sanitize&&!O.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function X(O,P){if(P<1)return"";for(var _="";P>1;)P&1&&(_+=O),P>>=1,O+=O;return _+O}function ie(O,P,_,C){var R=P.href,A=P.title?e(P.title):null,k=O[1].replace(/\\([\[\]])/g,"$1");if(O[0].charAt(0)!=="!"){C.state.inLink=!0;var U={type:"link",raw:_,href:R,title:A,text:k,tokens:C.inlineTokens(k)};return C.state.inLink=!1,U}return{type:"image",raw:_,href:R,title:A,text:e(k)}}function ue(O,P){var _=O.match(/^(\s+)(?:```)/);if(_===null)return P;var C=_[1];return P.split(`
`).map(function(R){var A=R.match(/^\s+/);if(A===null)return R;var k=A[0];return k.length>=C.length?R.slice(C.length):R}).join(`
`)}var ae=function(){function O(_){this.options=_||le.defaults}var P=O.prototype;return P.space=function(C){var R=this.rules.block.newline.exec(C);if(R&&R[0].length>0)return{type:"space",raw:R[0]}},P.code=function(C){var R=this.rules.block.code.exec(C);if(R){var A=R[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:R[0],codeBlockStyle:"indented",text:this.options.pedantic?A:B(A,`
`)}}},P.fences=function(C){var R=this.rules.block.fences.exec(C);if(R){var A=R[0],k=ue(A,R[3]||"");return{type:"code",raw:A,lang:R[2]?R[2].trim():R[2],text:k}}},P.heading=function(C){var R=this.rules.block.heading.exec(C);if(R){var A=R[2].trim();if(/#$/.test(A)){var k=B(A,"#");(this.options.pedantic||!k||/ $/.test(k))&&(A=k.trim())}return{type:"heading",raw:R[0],depth:R[1].length,text:A,tokens:this.lexer.inline(A)}}},P.hr=function(C){var R=this.rules.block.hr.exec(C);if(R)return{type:"hr",raw:R[0]}},P.blockquote=function(C){var R=this.rules.block.blockquote.exec(C);if(R){var A=R[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:R[0],tokens:this.lexer.blockTokens(A,[]),text:A}}},P.list=function(C){var R=this.rules.block.list.exec(C);if(R){var A,k,U,K,te,se,me,we,Ne,Ee,ve,Te,Pe=R[1].trim(),We=Pe.length>1,je={type:"list",raw:"",ordered:We,start:We?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=We?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=We?Pe:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Te=!1,!(!(R=Ie.exec(C))||this.rules.block.hr.test(C)));){if(A=R[0],C=C.substring(A.length),we=R[2].split(`
`,1)[0],Ne=C.split(`
`,1)[0],this.options.pedantic?(K=2,ve=we.trimLeft()):(K=R[2].search(/[^ ]/),K=K>4?1:K,ve=we.slice(K),K+=R[1].length),se=!1,!we&&/^ *$/.test(Ne)&&(A+=Ne+`
`,C=C.substring(Ne.length+1),Te=!0),!Te)for(var Ke=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");C&&(Ee=C.split(`
`,1)[0],we=Ee,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(we)||pe.test(we)||Ke.test(we)||Z.test(C)));){if(we.search(/[^ ]/)>=K||!we.trim())ve+=`
`+we.slice(K);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),A+=Ee+`
`,C=C.substring(Ee.length+1)}je.loose||(me?je.loose=!0:/\n *\n *$/.test(A)&&(me=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(ve),k&&(U=k[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:A,task:!!k,checked:U,loose:!1,text:ve}),je.raw+=A}je.items[je.items.length-1].raw=A.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var ke=je.items[te].tokens.filter(function(ze){return ze.type==="space"}),Re=ke.every(function(ze){for(var Xe=ze.raw.split(""),Ye=0,Ve=W(Xe),_e;!(_e=Ve()).done;){var et=_e.value;if(et===`
`&&(Ye+=1),Ye>1)return!0}return!1});!je.loose&&ke.length&&Re&&(je.loose=!0,je.items[te].loose=!0)}return je}},P.html=function(C){var R=this.rules.block.html.exec(C);if(R){var A={type:"html",raw:R[0],pre:!this.options.sanitizer&&(R[1]==="pre"||R[1]==="script"||R[1]==="style"),text:R[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]);A.type="paragraph",A.text=k,A.tokens=this.lexer.inline(k)}return A}},P.def=function(C){var R=this.rules.block.def.exec(C);if(R){R[3]&&(R[3]=R[3].substring(1,R[3].length-1));var A=R[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:A,raw:R[0],href:R[2],title:R[3]}}},P.table=function(C){var R=this.rules.block.table.exec(C);if(R){var A={type:"table",header:H(R[1]).map(function(me){return{text:me}}),align:R[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:R[3]&&R[3].trim()?R[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(A.header.length===A.align.length){A.raw=R[0];var k=A.align.length,U,K,te,se;for(U=0;U<k;U++)/^ *-+: *$/.test(A.align[U])?A.align[U]="right":/^ *:-+: *$/.test(A.align[U])?A.align[U]="center":/^ *:-+ *$/.test(A.align[U])?A.align[U]="left":A.align[U]=null;for(k=A.rows.length,U=0;U<k;U++)A.rows[U]=H(A.rows[U],A.header.length).map(function(me){return{text:me}});for(k=A.header.length,K=0;K<k;K++)A.header[K].tokens=this.lexer.inline(A.header[K].text);for(k=A.rows.length,K=0;K<k;K++)for(se=A.rows[K],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return A}}},P.lheading=function(C){var R=this.rules.block.lheading.exec(C);if(R)return{type:"heading",raw:R[0],depth:R[2].charAt(0)==="="?1:2,text:R[1],tokens:this.lexer.inline(R[1])}},P.paragraph=function(C){var R=this.rules.block.paragraph.exec(C);if(R){var A=R[1].charAt(R[1].length-1)===`
`?R[1].slice(0,-1):R[1];return{type:"paragraph",raw:R[0],text:A,tokens:this.lexer.inline(A)}}},P.text=function(C){var R=this.rules.block.text.exec(C);if(R)return{type:"text",raw:R[0],text:R[0],tokens:this.lexer.inline(R[0])}},P.escape=function(C){var R=this.rules.inline.escape.exec(C);if(R)return{type:"escape",raw:R[0],text:e(R[1])}},P.tag=function(C){var R=this.rules.inline.tag.exec(C);if(R)return!this.lexer.state.inLink&&/^<a /i.test(R[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(R[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(R[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(R[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:R[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]}},P.link=function(C){var R=this.rules.inline.link.exec(C);if(R){var A=R[2].trim();if(!this.options.pedantic&&/^</.test(A)){if(!/>$/.test(A))return;var k=B(A.slice(0,-1),"\\");if((A.length-k.length)%2===0)return}else{var U=E(R[2],"()");if(U>-1){var K=R[0].indexOf("!")===0?5:4,te=K+R[1].length+U;R[2]=R[2].substring(0,U),R[0]=R[0].substring(0,te).trim(),R[3]=""}}var se=R[2],me="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],me=we[3])}else me=R[3]?R[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(A)?se=se.slice(1):se=se.slice(1,-1)),ie(R,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},R[0],this.lexer)}},P.reflink=function(C,R){var A;if((A=this.rules.inline.reflink.exec(C))||(A=this.rules.inline.nolink.exec(C))){var k=(A[2]||A[1]).replace(/\s+/g," ");if(k=R[k.toLowerCase()],!k||!k.href){var U=A[0].charAt(0);return{type:"text",raw:U,text:U}}return ie(A,k,A[0],this.lexer)}},P.emStrong=function(C,R,A){A===void 0&&(A="");var k=this.rules.inline.emStrong.lDelim.exec(C);if(k&&!(k[3]&&A.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=k[1]||k[2]||"";if(!U||U&&(A===""||this.rules.inline.punctuation.exec(A))){var K=k[0].length-1,te,se,me=K,we=0,Ne=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,R=R.slice(-1*C.length+K);(k=Ne.exec(R))!=null;)if(te=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!te){if(se=te.length,k[3]||k[4]){me+=se;continue}else if((k[5]||k[6])&&K%3&&!((K+se)%3)){we+=se;continue}if(me-=se,!(me>0)){if(se=Math.min(se,se+me+we),Math.min(K,se)%2){var Ee=C.slice(1,K+k.index+se);return{type:"em",raw:C.slice(0,K+k.index+se+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=C.slice(2,K+k.index+se-1);return{type:"strong",raw:C.slice(0,K+k.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},P.codespan=function(C){var R=this.rules.inline.code.exec(C);if(R){var A=R[2].replace(/\n/g," "),k=/[^ ]/.test(A),U=/^ /.test(A)&&/ $/.test(A);return k&&U&&(A=A.substring(1,A.length-1)),A=e(A,!0),{type:"codespan",raw:R[0],text:A}}},P.br=function(C){var R=this.rules.inline.br.exec(C);if(R)return{type:"br",raw:R[0]}},P.del=function(C){var R=this.rules.inline.del.exec(C);if(R)return{type:"del",raw:R[0],text:R[2],tokens:this.lexer.inlineTokens(R[2])}},P.autolink=function(C,R){var A=this.rules.inline.autolink.exec(C);if(A){var k,U;return A[2]==="@"?(k=e(this.options.mangle?R(A[1]):A[1]),U="mailto:"+k):(k=e(A[1]),U=k),{type:"link",raw:A[0],text:k,href:U,tokens:[{type:"text",raw:k,text:k}]}}},P.url=function(C,R){var A;if(A=this.rules.inline.url.exec(C)){var k,U;if(A[2]==="@")k=e(this.options.mangle?R(A[0]):A[0]),U="mailto:"+k;else{var K;do K=A[0],A[0]=this.rules.inline._backpedal.exec(A[0])[0];while(K!==A[0]);k=e(A[0]),A[1]==="www."?U="http://"+k:U=k}return{type:"link",raw:A[0],text:k,href:U,tokens:[{type:"text",raw:k,text:k}]}}},P.inlineText=function(C,R){var A=this.rules.inline.text.exec(C);if(A){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(A[0]):e(A[0]):A[0]:k=e(this.options.smartypants?R(A[0]):A[0]),{type:"text",raw:A[0],text:k}}},O}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=i(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=i(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=i(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=i(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=i(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=i(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=j({},oe),oe.gfm=j({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=i(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=i(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=j({},oe.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:i(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=i(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=i(oe._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=i(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=i(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=i(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=i(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=i(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=i(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=i(re.reflink).replace("label",re._label).replace("ref",oe._label).getRegex(),re.nolink=i(re.nolink).replace("ref",oe._label).getRegex(),re.reflinkSearch=i(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=j({},re),re.pedantic=j({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=j({},re.normal,{escape:i(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=i(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=j({},re.gfm,{br:i(re.br).replace("{2,}","*").getRegex(),text:i(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(O){return O.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(O){var P="",_,C,R=O.length;for(_=0;_<R;_++)C=O.charCodeAt(_),Math.random()>.5&&(C="x"+C.toString(16)),P+="&#"+C+";";return P}var Fe=function(){function O(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||le.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:oe.normal,inline:re.normal};this.options.pedantic?(C.block=oe.pedantic,C.inline=re.pedantic):this.options.gfm&&(C.block=oe.gfm,this.options.breaks?C.inline=re.breaks:C.inline=re.gfm),this.tokenizer.rules=C}O.lex=function(C,R){var A=new O(R);return A.lex(C)},O.lexInline=function(C,R){var A=new O(R);return A.inlineTokens(C)};var P=O.prototype;return P.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var R;R=this.inlineQueue.shift();)this.inlineTokens(R.src,R.tokens);return this.tokens},P.blockTokens=function(C,R){var A=this;R===void 0&&(R=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(me,we,Ne){return we+"    ".repeat(Ne.length)});for(var k,U,K,te;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(k=me.call({lexer:A},C,R))?(C=C.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.space(C)){C=C.substring(k.raw.length),k.raw.length===1&&R.length>0?R[R.length-1].raw+=`
`:R.push(k);continue}if(k=this.tokenizer.code(C)){C=C.substring(k.raw.length),U=R[R.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+k.raw,U.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):R.push(k);continue}if(k=this.tokenizer.fences(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.heading(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.hr(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.blockquote(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.list(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.html(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.def(C)){C=C.substring(k.raw.length),U=R[R.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+k.raw,U.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.lheading(C)){C=C.substring(k.raw.length),R.push(k);continue}if(K=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,we=C.slice(1),Ne=void 0;A.options.extensions.startBlock.forEach(function(Ee){Ne=Ee.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(me=Math.min(me,Ne))}),me<1/0&&me>=0&&(K=C.substring(0,me+1))}(),this.state.top&&(k=this.tokenizer.paragraph(K))){U=R[R.length-1],te&&U.type==="paragraph"?(U.raw+=`
`+k.raw,U.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):R.push(k),te=K.length!==C.length,C=C.substring(k.raw.length);continue}if(k=this.tokenizer.text(C)){C=C.substring(k.raw.length),U=R[R.length-1],U&&U.type==="text"?(U.raw+=`
`+k.raw,U.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):R.push(k);continue}if(C){var se="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,R},P.inline=function(C,R){return R===void 0&&(R=[]),this.inlineQueue.push({src:C,tokens:R}),R},P.inlineTokens=function(C,R){var A=this;R===void 0&&(R=[]);var k,U,K,te=C,se,me,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ne.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+X("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+X("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(me||(we=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(k=ve.call({lexer:A},C,R))?(C=C.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.escape(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.tag(C)){C=C.substring(k.raw.length),U=R[R.length-1],U&&k.type==="text"&&U.type==="text"?(U.raw+=k.raw,U.text+=k.text):R.push(k);continue}if(k=this.tokenizer.link(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(k.raw.length),U=R[R.length-1],U&&k.type==="text"&&U.type==="text"?(U.raw+=k.raw,U.text+=k.text):R.push(k);continue}if(k=this.tokenizer.emStrong(C,te,we)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.codespan(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.br(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.del(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.autolink(C,Ce)){C=C.substring(k.raw.length),R.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(C,Ce))){C=C.substring(k.raw.length),R.push(k);continue}if(K=C,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Te=C.slice(1),Pe=void 0;A.options.extensions.startInline.forEach(function(We){Pe=We.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(ve=Math.min(ve,Pe))}),ve<1/0&&ve>=0&&(K=C.substring(0,ve+1))}(),k=this.tokenizer.inlineText(K,ge)){C=C.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(we=k.raw.slice(-1)),me=!0,U=R[R.length-1],U&&U.type==="text"?(U.raw+=k.raw,U.text+=k.text):R.push(k);continue}if(C){var Ee="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return R},y(O,null,[{key:"rules",get:function(){return{block:oe,inline:re}}}]),O}(),Me=function(){function O(_){this.options=_||le.defaults}var P=O.prototype;return P.code=function(C,R,A){var k=(R||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(C,k);U!=null&&U!==C&&(A=!0,C=U)}return C=C.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+e(k,!0)+'">'+(A?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(A?C:e(C,!0))+`</code></pre>
`},P.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},P.html=function(C){return C},P.heading=function(C,R,A,k){if(this.options.headerIds){var U=this.options.headerPrefix+k.slug(A);return"<h"+R+' id="'+U+'">'+C+"</h"+R+`>
`}return"<h"+R+">"+C+"</h"+R+`>
`},P.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},P.list=function(C,R,A){var k=R?"ol":"ul",U=R&&A!==1?' start="'+A+'"':"";return"<"+k+U+`>
`+C+"</"+k+`>
`},P.listitem=function(C){return"<li>"+C+`</li>
`},P.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},P.paragraph=function(C){return"<p>"+C+`</p>
`},P.table=function(C,R){return R&&(R="<tbody>"+R+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+R+`</table>
`},P.tablerow=function(C){return`<tr>
`+C+`</tr>
`},P.tablecell=function(C,R){var A=R.header?"th":"td",k=R.align?"<"+A+' align="'+R.align+'">':"<"+A+">";return k+C+("</"+A+`>
`)},P.strong=function(C){return"<strong>"+C+"</strong>"},P.em=function(C){return"<em>"+C+"</em>"},P.codespan=function(C){return"<code>"+C+"</code>"},P.br=function(){return this.options.xhtml?"<br/>":"<br>"},P.del=function(C){return"<del>"+C+"</del>"},P.link=function(C,R,A){if(C=f(this.options.sanitize,this.options.baseUrl,C),C===null)return A;var k='<a href="'+e(C)+'"';return R&&(k+=' title="'+R+'"'),k+=">"+A+"</a>",k},P.image=function(C,R,A){if(C=f(this.options.sanitize,this.options.baseUrl,C),C===null)return A;var k='<img src="'+C+'" alt="'+A+'"';return R&&(k+=' title="'+R+'"'),k+=this.options.xhtml?"/>":">",k},P.text=function(C){return C},O}(),fe=function(){function O(){}var P=O.prototype;return P.strong=function(C){return C},P.em=function(C){return C},P.codespan=function(C){return C},P.del=function(C){return C},P.html=function(C){return C},P.text=function(C){return C},P.link=function(C,R,A){return""+A},P.image=function(C,R,A){return""+A},P.br=function(){return""},O}(),ne=function(){function O(){this.seen={}}var P=O.prototype;return P.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},P.getNextSafeSlug=function(C,R){var A=C,k=0;if(this.seen.hasOwnProperty(A)){k=this.seen[C];do k++,A=C+"-"+k;while(this.seen.hasOwnProperty(A))}return R||(this.seen[C]=k,this.seen[A]=0),A},P.slug=function(C,R){R===void 0&&(R={});var A=this.serialize(C);return this.getNextSafeSlug(A,R.dryrun)},O}(),Q=function(){function O(_){this.options=_||le.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new ne}O.parse=function(C,R){var A=new O(R);return A.parse(C)},O.parseInline=function(C,R){var A=new O(R);return A.parseInline(C)};var P=O.prototype;return P.parse=function(C,R){R===void 0&&(R=!0);var A="",k,U,K,te,se,me,we,Ne,Ee,ve,Te,Pe,We,je,Ie,Ke,Z,he,pe,De=C.length;for(k=0;k<De;k++){if(ve=C[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){A+=pe||"";continue}switch(ve.type){case"space":continue;case"hr":{A+=this.renderer.hr();continue}case"heading":{A+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,r(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{A+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",we="",te=ve.header.length,U=0;U<te;U++)we+=this.renderer.tablecell(this.parseInline(ve.header[U].tokens),{header:!0,align:ve.align[U]});for(Ne+=this.renderer.tablerow(we),Ee="",te=ve.rows.length,U=0;U<te;U++){for(me=ve.rows[U],we="",se=me.length,K=0;K<se;K++)we+=this.renderer.tablecell(this.parseInline(me[K].tokens),{header:!1,align:ve.align[K]});Ee+=this.renderer.tablerow(we)}A+=this.renderer.table(Ne,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),A+=this.renderer.blockquote(Ee);continue}case"list":{for(Te=ve.ordered,Pe=ve.start,We=ve.loose,te=ve.items.length,Ee="",U=0;U<te;U++)Ie=ve.items[U],Ke=Ie.checked,Z=Ie.task,je="",Ie.task&&(he=this.renderer.checkbox(Ke),We?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=he+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=he+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:he}):je+=he),je+=this.parse(Ie.tokens,We),Ee+=this.renderer.listitem(je,Z,Ke);A+=this.renderer.list(Ee,Te,Pe);continue}case"html":{A+=this.renderer.html(ve.text);continue}case"paragraph":{A+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;k+1<De&&C[k+1].type==="text";)ve=C[++k],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);A+=R?this.renderer.paragraph(Ee):Ee;continue}default:{var ke='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return A},P.parseInline=function(C,R){R=R||this.renderer;var A="",k,U,K,te=C.length;for(k=0;k<te;k++){if(U=C[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(K=this.options.extensions.renderers[U.type].call({parser:this},U),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){A+=K||"";continue}switch(U.type){case"escape":{A+=R.text(U.text);break}case"html":{A+=R.html(U.text);break}case"link":{A+=R.link(U.href,U.title,this.parseInline(U.tokens,R));break}case"image":{A+=R.image(U.href,U.title,U.text);break}case"strong":{A+=R.strong(this.parseInline(U.tokens,R));break}case"em":{A+=R.em(this.parseInline(U.tokens,R));break}case"codespan":{A+=R.codespan(U.text);break}case"br":{A+=R.br();break}case"del":{A+=R.del(this.parseInline(U.tokens,R));break}case"text":{A+=R.text(U.text);break}default:{var se='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return A},O}();function V(O,P,_){if(typeof O>"u"||O===null)throw new Error("marked(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");if(typeof P=="function"&&(_=P,P=null),P=j({},V.defaults,P||{}),z(P),_){var C=P.highlight,R;try{R=Fe.lex(O,P)}catch(te){return _(te)}var A=function(se){var me;if(!se)try{P.walkTokens&&V.walkTokens(R,P.walkTokens),me=Q.parse(R,P)}catch(we){se=we}return P.highlight=C,se?_(se):_(null,me)};if(!C||C.length<3||(delete P.highlight,!R.length))return A();var k=0;V.walkTokens(R,function(te){te.type==="code"&&(k++,setTimeout(function(){C(te.text,te.lang,function(se,me){if(se)return A(se);me!=null&&me!==te.text&&(te.text=me,te.escaped=!0),k--,k===0&&A()})},0))}),k===0&&A();return}function U(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,P.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var K=Fe.lex(O,P);if(P.walkTokens){if(P.async)return Promise.all(V.walkTokens(K,P.walkTokens)).then(function(){return Q.parse(K,P)}).catch(U);V.walkTokens(K,P.walkTokens)}return Q.parse(K,P)}catch(te){U(te)}}V.options=V.setOptions=function(O){return j(V.defaults,O),w(V.defaults),V},V.getDefaults=v,V.defaults=le.defaults,V.use=function(){for(var O=arguments.length,P=new Array(O),_=0;_<O;_++)P[_]=arguments[_];var C=j.apply(void 0,[{}].concat(P)),R=V.defaults.extensions||{renderers:{},childTokens:{}},A;P.forEach(function(k){if(k.extensions&&(A=!0,k.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var te=R.renderers?R.renderers[K.name]:null;te?R.renderers[K.name]=function(){for(var se=arguments.length,me=new Array(se),we=0;we<se;we++)me[we]=arguments[we];var Ne=K.renderer.apply(this,me);return Ne===!1&&(Ne=te.apply(this,me)),Ne}:R.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");R[K.level]?R[K.level].unshift(K.tokenizer):R[K.level]=[K.tokenizer],K.start&&(K.level==="block"?R.startBlock?R.startBlock.push(K.start):R.startBlock=[K.start]:K.level==="inline"&&(R.startInline?R.startInline.push(K.start):R.startInline=[K.start]))}K.childTokens&&(R.childTokens[K.name]=K.childTokens)})),k.renderer&&function(){var K=V.defaults.renderer||new Me,te=function(we){var Ne=K[we];K[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Pe=k.renderer[we].apply(K,ve);return Pe===!1&&(Pe=Ne.apply(K,ve)),Pe}};for(var se in k.renderer)te(se);C.renderer=K}(),k.tokenizer&&function(){var K=V.defaults.tokenizer||new ae,te=function(we){var Ne=K[we];K[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Pe=k.tokenizer[we].apply(K,ve);return Pe===!1&&(Pe=Ne.apply(K,ve)),Pe}};for(var se in k.tokenizer)te(se);C.tokenizer=K}(),k.walkTokens){var U=V.defaults.walkTokens;C.walkTokens=function(K){var te=[];return te.push(k.walkTokens.call(this,K)),U&&(te=te.concat(U.call(this,K))),te}}A&&(C.extensions=R),V.setOptions(C)})},V.walkTokens=function(O,P){for(var _=[],C=function(){var U=A.value;switch(_=_.concat(P.call(V,U)),U.type){case"table":{for(var K=W(U.header),te;!(te=K()).done;){var se=te.value;_=_.concat(V.walkTokens(se.tokens,P))}for(var me=W(U.rows),we;!(we=me()).done;)for(var Ne=we.value,Ee=W(Ne),ve;!(ve=Ee()).done;){var Te=ve.value;_=_.concat(V.walkTokens(Te.tokens,P))}break}case"list":{_=_.concat(V.walkTokens(U.items,P));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[U.type]?V.defaults.extensions.childTokens[U.type].forEach(function(Pe){_=_.concat(V.walkTokens(U[Pe],P))}):U.tokens&&(_=_.concat(V.walkTokens(U.tokens,P)))}},R=W(O),A;!(A=R()).done;)C();return _},V.parseInline=function(O,P){if(typeof O>"u"||O===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");P=j({},V.defaults,P||{}),z(P);try{var _=Fe.lexInline(O,P);return P.walkTokens&&V.walkTokens(_,P.walkTokens),Q.parseInline(_,P)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,P.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},V.Parser=Q,V.parser=Q.parse,V.Renderer=Me,V.TextRenderer=fe,V.Lexer=Fe,V.lexer=Fe.lex,V.Tokenizer=ae,V.Slugger=ne,V.parse=V;var ee=V.options,J=V.setOptions,S=V.use,x=V.walkTokens,g=V.parseInline,p=V,q=Q.parse,T=Fe.lex;le.Lexer=Fe,le.Parser=Q,le.Renderer=Me,le.Slugger=ne,le.TextRenderer=fe,le.Tokenizer=ae,le.getDefaults=v,le.lexer=T,le.marked=V,le.options=ee,le.parse=p,le.parseInline=g,le.parser=q,le.setOptions=J,le.use=S,le.walkTokens=x,Object.defineProperty(le,"__esModule",{value:!0})}),define(be[78],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=void 0;class y{constructor(n,W=0,v=n.length,w=W-1){this.a=n,this.b=W,this.c=v,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$tR=y}),define(be[79],$e([1,0,78]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=t.$uR=void 0;class N{constructor(v=[],w=10){this.h(v),this.b=w,this.d()}getHistory(){return this.j}add(v){this.a.delete(v),this.a.add(v),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(v){return this.a.has(v)}clear(){this.h([]),this.d()}d(){this.f();const v=this.j;this.c=new y.$tR(v,0,v.length,v.length)}f(){const v=this.j;v.length>this.b&&this.h(v.slice(v.length-this.b))}g(){const v=this.c.current();return v?this.j.indexOf(v):-1}h(v){this.a=new Set;for(const w of v)this.a.add(w)}get j(){const v=[];return this.a.forEach(w=>v.push(w)),v}}t.$uR=N;class n{get size(){return this.f}constructor(v,w=10){if(this.g=w,v.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:v[0],previous:void 0,next:void 0},this.a=new Set([v[0]]);for(let o=1;o<v.length;o++)this.add(v[o])}add(v){const w={value:v,previous:this.c,next:void 0};for(this.c.next=w,this.c=w,this.d=this.c,this.f++,this.a.has(v)?this.h(v):this.a.add(v);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(v){if(this.c.value===v)return v;const w=this.c.value;return this.a.delete(w),this.c.value=v,this.a.has(v)?this.h(v):this.a.add(v),w}prepend(v){if(this.f===this.g||this.a.has(v))return;const w={value:v,previous:void 0,next:this.b};this.b.previous=w,this.b=w,this.f++,this.a.add(v)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(v){return this.a.has(v)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let v=this.b;for(;v;)yield v.value,v=v.next}h(v){let w=this.b;for(;w!==this.c;)w.value===v&&(w===this.b?(this.b=this.b.next,this.b.previous=void 0):(w.previous.next=w.next,w.next.previous=w.previous),this.f--),w=w.next}}t.$vR=n}),define(be[45],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ll=t.$Kl=t.$Jl=t.rot=t.$Hl=void 0;function y(w,o,u){return Math.min(Math.max(w,o),u)}t.$Hl=y;function N(w,o){return(o+w%o)%o}t.rot=N;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$Jl=n;class W{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Kl=W;class v{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const u=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Ll=v}),define(be[46],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(N){function n(o,u){if(o.start>=u.end||u.start>=o.end)return{start:0,end:0};const c=Math.max(o.start,u.start),L=Math.min(o.end,u.end);return L-c<=0?{start:0,end:0}:{start:c,end:L}}N.intersect=n;function W(o){return o.end-o.start<=0}N.isEmpty=W;function v(o,u){return!W(n(o,u))}N.intersects=v;function w(o,u){const c=[],L={start:o.start,end:Math.min(u.start,o.end)},s={start:Math.max(u.end,o.start),end:o.end};return W(L)||c.push(L),W(s)||c.push(s),c}N.relativeComplement=w})(y||(t.Range=y={}))}),define(be[80],$e([1,0,46]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=t.$lQ=t.$kQ=t.$jQ=void 0;function N(o,u){const c=[];for(const L of u){if(o.start>=L.range.end)continue;if(o.end<L.range.start)break;const s=y.Range.intersect(o,L.range);y.Range.isEmpty(s)||c.push({range:s,size:L.size})}return c}t.$jQ=N;function n({start:o,end:u},c){return{start:o+c,end:u+c}}t.$kQ=n;function W(o){const u=[];let c=null;for(const L of o){const s=L.range.start,a=L.range.end,e=L.size;if(c&&e===c.size){c.range.end=a;continue}c={range:{start:s,end:a},size:e},u.push(c)}return u}t.$lQ=W;function v(...o){return W(o.reduce((u,c)=>u.concat(c),[]))}class w{get paddingTop(){return this.c}set paddingTop(u){this.b=this.b+u-this.c,this.c=u}constructor(u){this.a=[],this.b=0,this.c=0,this.c=u??0,this.b=this.c}splice(u,c,L=[]){const s=L.length-c,a=N({start:0,end:u},this.a),e=N({start:u+c,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:n(r.range,s),size:r.size})),l=L.map((r,m)=>({range:{start:u+m,end:u+m+1},size:r.size}));this.a=v(a,l,e),this.b=this.c+this.a.reduce((r,m)=>r+m.size*(m.range.end-m.range.start),0)}get count(){const u=this.a.length;return u?this.a[u-1].range.end:0}get size(){return this.b}indexAt(u){if(u<0)return-1;if(u<this.c)return 0;let c=0,L=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a*s.size;if(u<e)return c+Math.floor((u-L)/s.size);c+=a,L=e}return c}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let c=0,L=0;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a;if(u<e)return this.c+c+(u-L)*s.size;c+=a*s.size,L=e}return-1}}t.$mQ=w}),define(be[81],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(W){return new N(W)}constructor(W){this.c=y&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$bd=N}),define(be[3],$e([1,0,6,42,2,44,81]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=t.$nd=t.$md=t.$ld=t.$kd=t.$jd=t.$id=t.$hd=t.$gd=t.$fd=t.$ed=t.$dd=t.Event=void 0;const w=!1,o=!1;var u;(function(B){B.None=()=>n.$kc.None;function E(R){if(o){const{onDidAddListener:A}=R,k=e.create();let U=0;R.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),A?.()}}}function z(R,A){return Me(R,()=>{},0,void 0,!0,void 0,A)}B.defer=z;function X(R){return(A,k=null,U)=>{let K=!1,te;return te=R(se=>{if(!K)return te?te.dispose():K=!0,A.call(k,se)},null,U),K&&te.dispose(),te}}B.once=X;function ie(R,A,k){return Ce((U,K=null,te)=>R(se=>U.call(K,A(se)),null,te),k)}B.map=ie;function ue(R,A,k){return Ce((U,K=null,te)=>R(se=>{A(se),U.call(K,se)},null,te),k)}B.forEach=ue;function ae(R,A,k){return Ce((U,K=null,te)=>R(se=>A(se)&&U.call(K,se),null,te),k)}B.filter=ae;function oe(R){return R}B.signal=oe;function re(...R){return(A,k=null,U)=>{const K=(0,n.$hc)(...R.map(te=>te(se=>A.call(k,se))));return Fe(K,U)}}B.any=re;function ge(R,A,k,U){let K=k;return ie(R,te=>(K=A(K,te),K),U)}B.reduce=ge;function Ce(R,A){let k;const U={onWillAddFirstListener(){k=R(K.fire,K)},onDidRemoveLastListener(){k?.dispose()}};A||E(U);const K=new d(U);return A?.add(K),K.event}function Fe(R,A){return A instanceof Array?A.push(R):A&&A.add(R),R}function Me(R,A,k=100,U=!1,K=!1,te,se){let me,we,Ne,Ee=0,ve;const Te={leakWarningThreshold:te,onWillAddFirstListener(){me=R(We=>{Ee++,we=A(we,We),U&&!Ne&&(Pe.fire(we),we=void 0),ve=()=>{const je=we;we=void 0,Ne=void 0,(!U||Ee>1)&&Pe.fire(je),Ee=0},typeof k=="number"?(clearTimeout(Ne),Ne=setTimeout(ve,k)):Ne===void 0&&(Ne=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&Ee>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,me.dispose()}};se||E(Te);const Pe=new d(Te);return se?.add(Pe),Pe.event}B.debounce=Me;function fe(R,A=0,k){return B.debounce(R,(U,K)=>U?(U.push(K),U):[K],A,void 0,!0,void 0,k)}B.accumulate=fe;function ne(R,A=(U,K)=>U===K,k){let U=!0,K;return ae(R,te=>{const se=U||!A(te,K);return U=!1,K=te,se},k)}B.latch=ne;function Q(R,A,k){return[B.filter(R,A,k),B.filter(R,U=>!A(U),k)]}B.split=Q;function V(R,A=!1,k=[],U){let K=k.slice(),te=R(we=>{K?K.push(we):me.fire(we)});U&&U.add(te);const se=()=>{K?.forEach(we=>me.fire(we)),K=null},me=new d({onWillAddFirstListener(){te||(te=R(we=>me.fire(we)),U&&U.add(te))},onDidAddFirstListener(){K&&(A?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return U&&U.add(me),me.event}B.buffer=V;function ee(R,A){return(U,K,te)=>{const se=A(new S);return R(function(me){const we=se.evaluate(me);we!==J&&U.call(K,we)},void 0,te)}}B.chain=ee;const J=Symbol("HaltChainable");class S{constructor(){this.f=[]}map(A){return this.f.push(A),this}forEach(A){return this.f.push(k=>(A(k),k)),this}filter(A){return this.f.push(k=>A(k)?k:J),this}reduce(A,k){let U=k;return this.f.push(K=>(U=A(U,K),U)),this}latch(A=(k,U)=>k===U){let k=!0,U;return this.f.push(K=>{const te=k||!A(K,U);return k=!1,U=K,te?K:J}),this}evaluate(A){for(const k of this.f)if(A=k(A),A===J)break;return A}}function x(R,A,k=U=>U){const U=(...me)=>se.fire(k(...me)),K=()=>R.on(A,U),te=()=>R.removeListener(A,U),se=new d({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}B.fromNodeEventEmitter=x;function g(R,A,k=U=>U){const U=(...me)=>se.fire(k(...me)),K=()=>R.addEventListener(A,U),te=()=>R.removeEventListener(A,U),se=new d({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}B.fromDOMEventEmitter=g;function p(R){return new Promise(A=>X(R)(A))}B.toPromise=p;function q(R){const A=new d;return R.then(k=>{A.fire(k)},()=>{A.fire(void 0)}).finally(()=>{A.dispose()}),A.event}B.fromPromise=q;function T(R,A){return A(void 0),R(k=>A(k))}B.runAndSubscribe=T;function O(R,A){let k=null;function U(te){k?.dispose(),k=new n.$jc,A(te,k)}U(void 0);const K=R(te=>U(te));return(0,n.$ic)(()=>{K.dispose(),k?.dispose()})}B.runAndSubscribeWithStore=O;class P{constructor(A,k){this._observable=A,this.f=0,this.g=!1;const U={onWillAddFirstListener:()=>{A.addObserver(this)},onDidRemoveLastListener:()=>{A.removeObserver(this)}};k||E(U),this.emitter=new d(U),k&&k.add(this.emitter)}beginUpdate(A){this.f++}handlePossibleChange(A){}handleChange(A,k){this.g=!0}endUpdate(A){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(R,A){return new P(R,A).emitter.event}B.fromObservable=_;function C(R){return A=>{let k=0,U=!1;const K={beginUpdate(){k++},endUpdate(){k--,k===0&&(R.reportChanges(),U&&(U=!1,A()))},handlePossibleChange(){},handleChange(){U=!0}};return R.addObserver(K),R.reportChanges(),{dispose(){R.removeObserver(K)}}}}B.fromObservableLight=C})(u||(t.Event=u={}));class c{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${c.f++}`,c.all.add(this)}start(E){this.g=new v.$bd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}t.$dd=c;let L=-1;function s(B){const E=L;return L=B,{dispose(){L=E}}}t.$ed=s;class a{constructor(E,z=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=z,this.g=0}dispose(){this.f?.clear()}check(E,z){const X=this.threshold;if(X<=0||z<X)return;this.f||(this.f=new Map);const ie=this.f.get(E.value)||0;if(this.f.set(E.value,ie+1),this.g-=1,this.g<=0){this.g=X*.5;let ue,ae=0;for(const[oe,re]of this.f)(!ue||ae<re)&&(ue=oe,ae=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ae}):`),console.warn(ue)}return()=>{const ue=this.f.get(E.value)||0;this.f.set(E.value,ue-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class r{constructor(E){this.value=E,this.id=l++}}const m=2,i=(B,E)=>{if(B instanceof r)E(B);else for(let z=0;z<B.length;z++){const X=B[z];X&&E(X)}};class d{constructor(E){this.x=0,this.f=E,this.g=L>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new c(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const E=this.t;queueMicrotask(()=>{i(E,z=>z.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,z,X)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$kc.None;if(this.m)return n.$kc.None;z&&(E=E.bind(z));const ie=new r(E);let ue,ae;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(ie.stack=e.create(),ue=this.g.check(ie.stack,this.x+1)),w&&(ie.stack=ae??e.create()),this.t?this.t instanceof r?(this.u??=new f,this.t=[this.t,ie]):this.t.push(ie):(this.f?.onWillAddFirstListener?.(this),this.t=ie,this.f?.onDidAddFirstListener?.(this)),this.x++;const oe=(0,n.$ic)(()=>{ue?.(),this.y(ie)});return X instanceof n.$jc?X.add(oe):Array.isArray(X)&&X.push(oe),oe},this.q}y(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const z=this.t,X=z.indexOf(E);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,z[X]=void 0;const ie=this.u.current===this;if(this.x*m<=z.length){let ue=0;for(let ae=0;ae<z.length;ae++)z[ae]?z[ue++]=z[ae]:ie&&(this.u.end--,ue<this.u.i&&this.u.i--);z.length=ue}}z(E,z){if(!E)return;const X=this.f?.onListenerError||y.$Y;if(!X){E.value(z);return}try{E.value(z)}catch(ie){X(ie)}}A(E){const z=E.current.t;for(;E.i<E.end;)this.z(z[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof r)this.z(this.t,E);else{const z=this.u;z.enqueue(this,E,this.t.length),this.A(z)}this.j?.stop()}hasListeners(){return this.x>0}}t.$fd=d;const $=()=>new f;t.$gd=$;class f{constructor(){this.i=-1,this.end=0}enqueue(E,z,X){this.i=0,this.end=X,this.current=E,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends d{async fireAsync(E,z,X){if(this.t)for(this.h||(this.h=new W.$tc),i(this.t,ie=>this.h.push([ie.value,E]));this.h.size>0&&!z.isCancellationRequested;){const[ie,ue]=this.h.shift(),ae=[],oe={...ue,token:z,waitUntil:re=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");X&&(re=X(re,ie)),ae.push(re)}};try{ie(oe)}catch(re){(0,y.$Y)(re);continue}Object.freeze(ae),await Promise.allSettled(ae).then(re=>{for(const ge of re)ge.status==="rejected"&&(0,y.$Y)(ge.reason)})}}}t.$hd=h;class F extends d{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new W.$tc,this.w=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.w(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.x&&(this.h!==0?this.s.push(E):super.fire(E))}}t.$id=F;class M extends F{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}t.$jd=M;class I extends d{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}t.$kd=I;class b{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const z={event:E,listener:null};this.h.push(z),this.g&&this.m(z);const X=()=>{this.g&&this.o(z);const ie=this.h.indexOf(z);this.h.splice(ie,1)};return(0,n.$ic)((0,N.$bb)(X))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(z=>this.f.fire(z))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}t.$ld=b;class D{constructor(E,z,X,ie){this.f=new n.$jc;const ue=this.f.add(new b),ae=this.f.add(new n.$sc);function oe(re){ae.set(re,ue.add(ie(re)))}for(const re of E)oe(re);this.f.add(z(re=>{oe(re)})),this.f.add(X(re=>{ae.deleteAndDispose(re)})),this.event=ue.event}dispose(){this.f.dispose()}}t.$md=D;class j{constructor(){this.f=[]}wrapEvent(E){return(z,X,ie)=>E(ue=>{const ae=this.f[this.f.length-1];ae?ae.push(()=>z.call(X,ue)):z.call(X,ue)},void 0,ie)}bufferEvents(E){const z=[];this.f.push(z);const X=E();return this.f.pop(),z.forEach(ie=>ie()),X}}t.$nd=j;class H{constructor(){this.f=!1,this.g=u.None,this.h=n.$kc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$od=H}),define(be[16],$e([1,0,3,2]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fO=t.$eO=t.$dO=t.$cO=t.$bO=t.$aO=t.$_N=t.$$N=t.$0N=t.$9N=t.$8N=t.$7N=t.$6N=t.$5N=t.$4N=t.$3N=t.$2N=t.$1N=void 0;class n{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$fd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new n}getZoomLevel(){return this.a}setZoomLevel($){this.a!==$&&(this.a=$)}getZoomFactor(){return this.b}setZoomFactor($){this.b=$}setFullscreen($){this.c!==$&&(this.c=$,this.d.fire())}isFullscreen(){return this.c}}class W extends N.$kc{constructor(){super(),this.a=this.B(new y.$fd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f($){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),$&&this.a.fire()}}class v extends N.$kc{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$fd),this.onDidChange=this.a.event,this.b=this.c();const $=this.B(new W);this.B($.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const $=document.createElement("canvas").getContext("2d"),f=window.devicePixelRatio||1,h=$.webkitBackingStorePixelRatio||$.mozBackingStorePixelRatio||$.msBackingStorePixelRatio||$.oBackingStorePixelRatio||$.backingStorePixelRatio||1;return f/h}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,N.$dc)(new v)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function o(d,$){typeof d=="string"&&(d=window.matchMedia(d)),d.addEventListener("change",$)}t.$1N=o,t.$2N=new w;function u(d){n.INSTANCE.setZoomLevel(d)}t.$3N=u;function c(){return n.INSTANCE.getZoomLevel()}t.$4N=c;function L(){return n.INSTANCE.getZoomFactor()}t.$5N=L;function s(d){n.INSTANCE.setZoomFactor(d)}t.$6N=s;function a(d){n.INSTANCE.setFullscreen(d)}t.$7N=a;function e(){return n.INSTANCE.isFullscreen()}t.$8N=e,t.$9N=n.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$0N=l.indexOf("Firefox")>=0,t.$$N=l.indexOf("AppleWebKit")>=0,t.$_N=l.indexOf("Chrome")>=0,t.$aO=!t.$_N&&l.indexOf("Safari")>=0,t.$bO=!t.$_N&&!t.$aO&&t.$$N,t.$cO=l.indexOf("Electron/")>=0,t.$dO=l.indexOf("Android")>=0;let r=!1;if(window.matchMedia){const d=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),$=window.matchMedia("(display-mode: fullscreen)");r=d.matches,o(d,({matches:f})=>{r&&$.matches||(r=f)})}function m(){return r}t.$eO=m;function i(){return navigator?.windowControlsOverlay?.visible}t.$fO=i}),define(be[21],$e([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bQ=void 0;class N{get event(){return this.a.event}constructor(W,v,w){const o=u=>this.a.fire(u);this.a=new y.$fd({onWillAddFirstListener:()=>W.addEventListener(v,o,w),onDidRemoveLastListener:()=>W.removeEventListener(v,o,w)})}dispose(){this.a.dispose()}}t.$bQ=N}),define(be[27],$e([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pd=t.CancellationToken=void 0;const N=Object.freeze(function(w,o){const u=setTimeout(w.bind(o),0);return{dispose(){clearTimeout(u)}}});var n;(function(w){function o(u){return u===w.None||u===w.Cancelled||u instanceof W?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}w.isCancellationToken=o,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(n||(t.CancellationToken=n={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new y.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=n.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=n.None}}t.$pd=v}),define(be[82],$e([1,0,27]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$je=t.$ie=t.$he=void 0;class N{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new y.$pd,o=this.b(w.token);return this.a={promise:o,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.$he=N;class n{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const o=JSON.stringify(w);return this.b!==o&&(this.b=o,this.a=this.c(w)),this.a}}t.$ie=n;class W{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const o=this.b(w);return this.a.set(w,o),o}}t.$je=W}),define(be[47],$e([1,0,3,2]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pr=t.$Or=t.$Nr=t.$Mr=t.ScrollbarVisibility=void 0;var n;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class W{constructor(e,l,r,m,i,d,$){this.c=e,this._scrollStateBrand=void 0,this.c&&(l=l|0,r=r|0,m=m|0,i=i|0,d=d|0,$=$|0),this.rawScrollLeft=m,this.rawScrollTop=$,l<0&&(l=0),m+l>r&&(m=r-l),m<0&&(m=0),i<0&&(i=0),$+i>d&&($=d-i),$<0&&($=0),this.width=l,this.scrollWidth=r,this.scrollLeft=m,this.height=i,this.scrollHeight=d,this.scrollTop=$}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,l){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,l?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,l?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,l){const r=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,i=this.scrollLeft!==e.scrollLeft,d=this.height!==e.height,$=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:l,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:m,scrollLeftChanged:i,heightChanged:d,scrollHeightChanged:$,scrollTopChanged:f}}}t.$Mr=W;class v extends N.$kc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$fd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,l){const r=this.g.withScrollDimensions(e,l);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const l=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(l,!1)}setScrollPositionSmooth(e,l){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let m;l?m=new c(this.h.from,r,this.h.startTime,this.h.duration):m=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=m}else{const r=this.g.withScrollPosition(e);this.h=c.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),l=this.g.withScrollPosition(e);if(this.n(l,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,l){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,l)))}}t.$Nr=v;class w{constructor(e,l,r){this.scrollLeft=e,this.scrollTop=l,this.isDone=r}}t.$Or=w;function o(a,e){const l=e-a;return function(r){return a+l*s(r)}}function u(a,e,l){return function(r){return r<l?a(r/l):e((r-l)/(1-l))}}class c{constructor(e,l,r,m){this.from=e,this.to=l,this.duration=m,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,l,r){if(Math.abs(e-l)>2.5*r){let i,d;return e<l?(i=e+.75*r,d=l-.75*r):(i=e-.75*r,d=l+.75*r),u(o(e,i),o(d,l),.33)}return o(e,l)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const l=(e-this.startTime)/this.duration;if(l<1){const r=this.c(l),m=this.d(l);return new w(r,m,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,l,r){return c.start(e,l,r)}static start(e,l,r){r=r+10;const m=Date.now()-10;return new c(e,l,m,r)}}t.$Pr=c;function L(a){return Math.pow(a,3)}function s(a){return 1-L(1-a)}}),define(be[83],$e([1,0,6,2]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=void 0;function n($){const f=$;return f?typeof f.read=="function":!1}t.$qd=n;function W($){const f=$;return f?[f.on,f.pause,f.resume,f.destroy].every(h=>typeof h=="function"):!1}t.$rd=W;function v($){const f=$;return f?W(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$sd=v;function w($,f){return new o($,f)}t.$td=w;class o{constructor(f,h){this.e=f,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(h=>h(f))}h(f){this.c.error.length===0?(0,y.$Y)(f):this.c.error.slice(0).forEach(h=>h(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,h){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(f,h){if(this.a.destroyed)return;let F;switch(f){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const M=F.indexOf(h);M>=0&&F.splice(M,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u($,f){const h=[];let F;for(;(F=$.read())!==null;)h.push(F);return f(h)}t.$ud=u;function c($,f,h){const F=[];let M;for(;(M=$.read())!==null&&F.length<h;)F.push(M);return M===null&&F.length>0?f(F):{read:()=>{if(F.length>0)return F.shift();if(typeof M<"u"){const I=M;return M=void 0,I}return $.read()}}}t.$vd=c;function L($,f){return new Promise((h,F)=>{const M=[];s($,{onData:I=>{f&&M.push(I)},onError:I=>{f?F(I):h(void 0)},onEnd:()=>{h(f?f(M):void 0)}})})}t.$wd=L;function s($,f,h){$.on("error",F=>{h?.isCancellationRequested||f.onError(F)}),$.on("end",()=>{h?.isCancellationRequested||f.onEnd()}),$.on("data",F=>{h?.isCancellationRequested||f.onData(F)})}t.$xd=s;function a($,f){return new Promise((h,F)=>{const M=new N.$jc,I=[],b=H=>{if(I.push(H),I.length>f)return M.dispose(),$.pause(),h({stream:$,buffer:I,ended:!1})},D=H=>(M.dispose(),F(H)),j=()=>(M.dispose(),h({stream:$,buffer:I,ended:!0}));M.add((0,N.$ic)(()=>$.removeListener("error",D))),$.on("error",D),M.add((0,N.$ic)(()=>$.removeListener("end",j))),$.on("end",j),M.add((0,N.$ic)(()=>$.removeListener("data",b))),$.on("data",b)})}t.$yd=a;function e($,f){const h=w(f);return h.end($),h}t.$zd=e;function l(){const $=w(()=>{throw new Error("not supported")});return $.end(),$}t.$Ad=l;function r($){let f=!1;return{read:()=>f?null:(f=!0,$)}}t.$Bd=r;function m($,f,h){const F=w(h);return s($,{onData:M=>F.write(f.data(M)),onError:M=>F.error(f.error?f.error(M):M),onEnd:()=>F.end()}),F}t.$Cd=m;function i($,f,h){let F=!1;return{read:()=>{const M=f.read();return F?M:(F=!0,M!==null?h([$,M]):$)}}}t.$Dd=i;function d($,f,h){let F=!1;const M=w(h);return s(f,{onData:I=>F?M.write(I):(F=!0,M.write(h([$,I]))),onError:I=>M.error(I),onEnd:()=>{F||(F=!0,M.write($)),M.end()}}),M}t.$Ed=d}),define(be[31],$e([1,0,30,83]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=void 0;const n=typeof Buffer<"u",W=new y.$T(()=>new Uint8Array(256));let v,w;class o{static alloc(z){return n?new o(Buffer.allocUnsafe(z)):new o(new Uint8Array(z))}static wrap(z){return n&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new o(z)}static fromString(z,X){return!(X?.dontUseNodeBuffer||!1)&&n?new o(Buffer.from(z)):(v||(v=new TextEncoder),new o(v.encode(z)))}static fromByteArray(z){const X=o.alloc(z.length);for(let ie=0,ue=z.length;ie<ue;ie++)X.buffer[ie]=z[ie];return X}static concat(z,X){if(typeof X>"u"){X=0;for(let ae=0,oe=z.length;ae<oe;ae++)X+=z[ae].byteLength}const ie=o.alloc(X);let ue=0;for(let ae=0,oe=z.length;ae<oe;ae++){const re=z[ae];ie.set(re,ue),ue+=re.byteLength}return ie}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=o.alloc(this.byteLength);return z.set(this),z}toString(){return n?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(z,X){return new o(this.buffer.subarray(z,X))}set(z,X){if(z instanceof o)this.buffer.set(z.buffer,X);else if(z instanceof Uint8Array)this.buffer.set(z,X);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),X);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),X);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return s(this.buffer,z)}writeUInt32BE(z,X){a(this.buffer,z,X)}readUInt32LE(z){return e(this.buffer,z)}writeUInt32LE(z,X){l(this.buffer,z,X)}readUInt8(z){return r(this.buffer,z)}writeUInt8(z,X){m(this.buffer,z,X)}indexOf(z,X=0){return u(this.buffer,z instanceof o?z.buffer:z,X)}}t.$Fd=o;function u(E,z,X=0){const ie=z.byteLength,ue=E.byteLength;if(ie===0)return 0;if(ie===1)return E.indexOf(z[0]);if(ie>ue-X)return-1;const ae=W.value;ae.fill(z.length);for(let Ce=0;Ce<z.length;Ce++)ae[z[Ce]]=z.length-Ce-1;let oe=X+z.length-1,re=oe,ge=-1;for(;oe<ue;)if(E[oe]===z[re]){if(re===0){ge=oe;break}oe--,re--}else oe+=Math.max(z.length-re,ae[E[oe]]),re=z.length-1;return ge}t.$Gd=u;function c(E,z){return E[z+0]<<0>>>0|E[z+1]<<8>>>0}t.$Hd=c;function L(E,z,X){E[X+0]=z&255,z=z>>>8,E[X+1]=z&255}t.$Id=L;function s(E,z){return E[z]*2**24+E[z+1]*2**16+E[z+2]*2**8+E[z+3]}t.$Jd=s;function a(E,z,X){E[X+3]=z,z=z>>>8,E[X+2]=z,z=z>>>8,E[X+1]=z,z=z>>>8,E[X]=z}t.$Kd=a;function e(E,z){return E[z+0]<<0>>>0|E[z+1]<<8>>>0|E[z+2]<<16>>>0|E[z+3]<<24>>>0}t.$Ld=e;function l(E,z,X){E[X+0]=z&255,z=z>>>8,E[X+1]=z&255,z=z>>>8,E[X+2]=z&255,z=z>>>8,E[X+3]=z&255}t.$Md=l;function r(E,z){return E[z]}t.$Nd=r;function m(E,z,X){E[X]=z}t.$Od=m;function i(E){return N.$ud(E,z=>o.concat(z))}t.$Pd=i;function d(E){return N.$Bd(E)}t.$Qd=d;function $(E){return N.$wd(E,z=>o.concat(z))}t.$Rd=$;async function f(E){return E.ended?o.concat(E.buffer):o.concat([...E.buffer,await $(E.stream)])}t.$Sd=f;function h(E){return N.$zd(E,z=>o.concat(z))}t.$Td=h;function F(E){return N.$Cd(E,{data:z=>typeof z=="string"?o.fromString(z):o.wrap(z)},z=>o.concat(z))}t.$Ud=F;function M(E){return N.$td(z=>o.concat(z),E)}t.$Vd=M;function I(E,z){return N.$Dd(E,z,X=>o.concat(X))}t.$Wd=I;function b(E,z){return N.$Ed(E,z,X=>o.concat(X))}t.$Xd=b;function D(E){let z=0,X=0,ie=0;const ue=new Uint8Array(Math.floor(E.length/4*3)),ae=re=>{switch(X){case 3:ue[ie++]=z|re,X=0;break;case 2:ue[ie++]=z|re>>>2,z=re<<6,X=3;break;case 1:ue[ie++]=z|re>>>4,z=re<<4,X=2;break;default:z=re<<2,X=1}};for(let re=0;re<E.length;re++){const ge=E.charCodeAt(re);if(ge>=65&&ge<=90)ae(ge-65);else if(ge>=97&&ge<=122)ae(ge-97+26);else if(ge>=48&&ge<=57)ae(ge-48+52);else if(ge===43||ge===45)ae(62);else if(ge===47||ge===95)ae(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${E[re]}`)}}const oe=ie;for(;X>0;)ae(0);return o.wrap(ue).slice(0,oe)}t.$Yd=D;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:E},z=!0,X=!1){const ie=X?H:j;let ue="";const ae=E.byteLength%3;let oe=0;for(;oe<E.byteLength-ae;oe+=3){const re=E[oe+0],ge=E[oe+1],Ce=E[oe+2];ue+=ie[re>>>2],ue+=ie[(re<<4|ge>>>4)&63],ue+=ie[(ge<<2|Ce>>>6)&63],ue+=ie[Ce&63]}if(ae===1){const re=E[oe+0];ue+=ie[re>>>2],ue+=ie[re<<4&63],z&&(ue+="==")}else if(ae===2){const re=E[oe+0],ge=E[oe+1];ue+=ie[re>>>2],ue+=ie[(re<<4|ge>>>4)&63],ue+=ie[ge<<2&63],z&&(ue+="=")}return ue}t.$Zd=B}),define(be[12],$e([1,0,82,30]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$if=t.$hf=t.$gf=t.$ff=t.GraphemeBreakType=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=void 0;function n(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$me=n;const W=/{(\d+)}/g;function v(Z,...he){return he.length===0?Z:Z.replace(W,function(pe,De){const ke=parseInt(De,10);return isNaN(ke)||ke<0||ke>=he.length?pe:he[ke]})}t.$ne=v;const w=/{([^}]+)}/g;function o(Z,he){return Z.replace(w,(pe,De)=>he[De]??pe)}t.$oe=o;function u(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$pe=u;function c(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$qe=c;function L(Z,he){let pe=0;const De=he.charCodeAt(0);for(let ke=Z.length-1;ke>=0;ke--)Z.charCodeAt(ke)===De&&pe++;return pe}t.$re=L;function s(Z,he,pe="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${pe}`}t.$se=s;function a(Z,he=" "){const pe=e(Z,he);return l(pe,he)}t.$te=a;function e(Z,he){if(!Z||!he)return Z;const pe=he.length;if(pe===0||Z.length===0)return Z;let De=0;for(;Z.indexOf(he,De)===De;)De=De+pe;return Z.substring(De)}t.$ue=e;function l(Z,he){if(!Z||!he)return Z;const pe=he.length,De=Z.length;if(pe===0||De===0)return Z;let ke=De,Re=-1;for(;Re=Z.lastIndexOf(he,ke-1),!(Re===-1||Re+pe!==ke);){if(Re===0)return"";ke=Re}return Z.substring(0,ke)}t.$ve=l;function r(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$we=r;function m(Z){return Z.replace(/\*/g,"")}t.$xe=m;function i(Z,he,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=c(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Z,De)}t.$ye=i;function d(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$ze=d;function $(Z){return Z.split(/\r\n|\r|\n/)}t.$Ae=$;function f(Z){for(let he=0,pe=Z.length;he<pe;he++){const De=Z.charCodeAt(he);if(De!==32&&De!==9)return he}return-1}t.$Be=f;function h(Z,he=0,pe=Z.length){for(let De=he;De<pe;De++){const ke=Z.charCodeAt(De);if(ke!==32&&ke!==9)return Z.substring(he,De)}return Z.substring(he,pe)}t.$Ce=h;function F(Z,he=Z.length-1){for(let pe=he;pe>=0;pe--){const De=Z.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}t.$De=F;function M(Z,he,pe){const De=[];let ke=0;for(const Re of Z.matchAll(he)){if(De.push(Z.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,De.push(pe(Re[0],...Re.slice(1),Re.index,Z,Re.groups))}return De.push(Z.slice(ke)),Promise.all(De).then(Re=>Re.join(""))}t.$Ee=M;function I(Z,he){return Z<he?-1:Z>he?1:0}t.$Fe=I;function b(Z,he,pe=0,De=Z.length,ke=0,Re=he.length){for(;pe<De&&ke<Re;pe++,ke++){const Ye=Z.charCodeAt(pe),Ve=he.charCodeAt(ke);if(Ye<Ve)return-1;if(Ye>Ve)return 1}const ze=De-pe,Xe=Re-ke;return ze<Xe?-1:ze>Xe?1:0}t.$Ge=b;function D(Z,he){return j(Z,he,0,Z.length,0,he.length)}t.$He=D;function j(Z,he,pe=0,De=Z.length,ke=0,Re=he.length){for(;pe<De&&ke<Re;pe++,ke++){let Ye=Z.charCodeAt(pe),Ve=he.charCodeAt(ke);if(Ye===Ve)continue;if(Ye>=128||Ve>=128)return b(Z.toLowerCase(),he.toLowerCase(),pe,De,ke,Re);B(Ye)&&(Ye-=32),B(Ve)&&(Ve-=32);const _e=Ye-Ve;if(_e!==0)return _e}const ze=De-pe,Xe=Re-ke;return ze<Xe?-1:ze>Xe?1:0}t.$Ie=j;function H(Z){return Z>=48&&Z<=57}t.$Je=H;function B(Z){return Z>=97&&Z<=122}t.$Ke=B;function E(Z){return Z>=65&&Z<=90}t.$Le=E;function z(Z,he){return Z.length===he.length&&j(Z,he)===0}t.$Me=z;function X(Z,he){const pe=he.length;return he.length>Z.length?!1:j(Z,he,0,pe)===0}t.$Ne=X;function ie(Z,he){const pe=Math.min(Z.length,he.length);let De;for(De=0;De<pe;De++)if(Z.charCodeAt(De)!==he.charCodeAt(De))return De;return pe}t.$Oe=ie;function ue(Z,he){const pe=Math.min(Z.length,he.length);let De;const ke=Z.length-1,Re=he.length-1;for(De=0;De<pe;De++)if(Z.charCodeAt(ke-De)!==he.charCodeAt(Re-De))return De;return pe}t.$Pe=ue;function ae(Z){return 55296<=Z&&Z<=56319}t.$Qe=ae;function oe(Z){return 56320<=Z&&Z<=57343}t.$Re=oe;function re(Z,he){return(Z-55296<<10)+(he-56320)+65536}t.$Se=re;function ge(Z,he,pe){const De=Z.charCodeAt(pe);if(ae(De)&&pe+1<he){const ke=Z.charCodeAt(pe+1);if(oe(ke))return re(De,ke)}return De}t.$Te=ge;function Ce(Z,he){const pe=Z.charCodeAt(he-1);if(oe(pe)&&he>1){const De=Z.charCodeAt(he-2);if(ae(De))return re(De,pe)}return pe}class Fe{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=Ce(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=ge(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$Ue=Fe;class Me{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new Fe(he,pe)}nextGraphemeLength(){const he=Ee.getInstance(),pe=this.c,De=pe.offset;let ke=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,ze=he.getGraphemeBreakType(pe.nextCodePoint());if(we(ke,ze)){pe.setOffset(Re);break}ke=ze}return pe.offset-De}prevGraphemeLength(){const he=Ee.getInstance(),pe=this.c,De=pe.offset;let ke=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,ze=he.getGraphemeBreakType(pe.prevCodePoint());if(we(ze,ke)){pe.setOffset(Re);break}ke=ze}return De-pe.offset}eol(){return this.c.eol()}}t.$Ve=Me;function fe(Z,he){return new Me(Z,he).nextGraphemeLength()}t.$We=fe;function ne(Z,he){return new Me(Z,he).prevGraphemeLength()}t.$Xe=ne;function Q(Z,he){he>0&&oe(Z.charCodeAt(he))&&he--;const pe=he+fe(Z,he);return[pe-ne(Z,pe),pe]}t.$Ye=Q;function V(Z){const he=new Me(Z);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}t.$Ze=V;let ee;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(Z){return ee||(ee=J()),ee.test(Z)}t.$1e=S;const x=/^[\t\n\r\x20-\x7E]*$/;function g(Z){return x.test(Z)}t.$2e=g,t.$3e=/[\u2028\u2029]/;function p(Z){return t.$3e.test(Z)}t.$4e=p;function q(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$5e=q;function T(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$6e=T;function O(Z,he){if(Z.length<he)return Z;const pe=/\b/g;let De=0;for(;pe.test(Z)&&!(Z.length-pe.lastIndex<he);)De=pe.lastIndex,pe.lastIndex+=1;return Z.substring(De).replace(/^\s/,"")}t.$7e=O;const P=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,_=/\x1b\].*?\x07/g;function C(Z){return Z&&(Z=Z.replace(P,"").replace(_,"")),Z}t.$8e=C,t.$9e=String.fromCharCode(65279);function R(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$0e=R;function A(Z){return R(Z)?Z.substr(1):Z}t.$$e=A;function k(Z,he){if(!Z||!he||Z.length<he.length)return!1;const pe=he.length,De=Z.toLowerCase();let ke=0,Re=-1;for(;ke<pe;){const ze=De.indexOf(he[ke],Re+1);if(ze<0)return!1;Re=ze,ke++}return!0}t.$_e=k;function U(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$af=U;function K(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$bf=K;function te(Z,he=1){if(he===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}t.$cf=te;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$df=se;function me(Z){return Ee.getInstance().getGraphemeBreakType(Z)}t.$ef=me;function we(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var Ne;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const pe=this.d,De=pe.length/3;let ke=1;for(;ke<=De;)if(he<pe[3*ke])ke=2*ke;else if(he>pe[3*ke+1])ke=2*ke+1;else return pe[3*ke+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Z,he){if(Z===0)return 0;const pe=Pe(Z,he);if(pe!==void 0)return pe;const De=new Fe(he,Z);return De.prevCodePoint(),De.offset}t.$ff=Te;function Pe(Z,he){const pe=new Fe(he,Z);let De=pe.prevCodePoint();for(;We(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!T(De))return;let ke=pe.offset;return ke>0&&pe.prevCodePoint()===8205&&(ke=pe.offset),ke}function We(Z){return 127995<=Z&&Z<=127999}var je;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$gf="\xA0";class Ie{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$ie(he=>{function pe(_e){const et=new Map;for(let it=0;it<_e.length;it+=2)et.set(_e[it],_e[it+1]);return et}function De(_e,et){const it=new Map(_e);for(const[ft,ct]of et)it.set(ft,ct);return it}function ke(_e,et){if(!_e)return et;const it=new Map;for(const[ft,ct]of _e)et.has(ft)&&it.set(ft,ct);return it}const Re=this.c.value;let ze=he.filter(_e=>!_e.startsWith("_")&&_e in Re);ze.length===0&&(ze=["_default"]);let Xe;for(const _e of ze){const et=pe(Re[_e]);Xe=ke(Xe,et)}const Ye=pe(Re._common),Ve=De(Ye,Xe);return new Ie(Ve)})}static getInstance(he){return Ie.d.get(Array.from(he))}static{this.e=new N.$T(()=>Object.keys(Ie.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Ie.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$hf=Ie;class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(he){return Ke.e().has(he)}static get codePoints(){return Ke.e()}}t.$if=Ke}),define(be[32],$e([1,0,76,12]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.FuzzyScore=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$Aj=t.$zj=t.$yj=t.$xj=t.or=void 0;function n(...A){return function(k,U){for(let K=0,te=A.length;K<te;K++){const se=A[K](k,U);if(se)return se}return null}}t.or=n,t.$xj=W.bind(void 0,!1),t.$yj=W.bind(void 0,!0);function W(A,k,U){if(!U||U.length<k.length)return null;let K;return A?K=N.$Ne(U,k):K=U.indexOf(k)===0,K?k.length>0?[{start:0,end:k.length}]:[]:null}function v(A,k){const U=k.toLowerCase().indexOf(A.toLowerCase());return U===-1?null:[{start:U,end:U+A.length}]}t.$zj=v;function w(A,k){return o(A.toLowerCase(),k.toLowerCase(),0,0)}t.$Aj=w;function o(A,k,U,K){if(U===A.length)return[];if(K===k.length)return null;if(A[U]===k[K]){let te=null;return(te=o(A,k,U+1,K+1))?m({start:K,end:K+1},te):null}return o(A,k,U,K+1)}function u(A){return 97<=A&&A<=122}function c(A){return 65<=A&&A<=90}t.$Bj=c;function L(A){return 48<=A&&A<=57}function s(A){return A===32||A===9||A===10||A===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>a.add(A.charCodeAt(0)));function e(A){return s(A)||a.has(A)}function l(A,k){return A===k||e(A)&&e(k)}function r(A){return u(A)||c(A)||L(A)}function m(A,k){return k.length===0?k=[A]:A.end===k[0].start?k[0].start=A.start:k.unshift(A),k}function i(A,k){for(let U=k;U<A.length;U++){const K=A.charCodeAt(U);if(c(K)||L(K)||U>0&&!r(A.charCodeAt(U-1)))return U}return A.length}function d(A,k,U,K){if(U===A.length)return[];if(K===k.length)return null;if(A[U]!==k[K].toLowerCase())return null;{let te=null,se=K+1;for(te=d(A,k,U+1,K+1);!te&&(se=i(k,se))<k.length;)te=d(A,k,U+1,se),se++;return te===null?null:m({start:K,end:K+1},te)}}function $(A){let k=0,U=0,K=0,te=0,se=0;for(let ve=0;ve<A.length;ve++)se=A.charCodeAt(ve),c(se)&&k++,u(se)&&U++,r(se)&&K++,L(se)&&te++;const me=k/A.length,we=U/A.length,Ne=K/A.length,Ee=te/A.length;return{upperPercent:me,lowerPercent:we,alphaPercent:Ne,numericPercent:Ee}}function f(A){const{upperPercent:k,lowerPercent:U}=A;return U===0&&k>.6}function h(A){const{upperPercent:k,lowerPercent:U,alphaPercent:K,numericPercent:te}=A;return U>.2&&k<.8&&K>.6&&te<.2}function F(A){let k=0,U=0,K=0,te=0;for(let se=0;se<A.length;se++)K=A.charCodeAt(se),c(K)&&k++,u(K)&&U++,s(K)&&te++;return(k===0||U===0)&&te===0?A.length<=30:k<=5}function M(A,k){if(!k||(k=k.trim(),k.length===0)||!F(A)||k.length>60)return null;const U=$(k);if(!h(U)){if(!f(U))return null;k=k.toLowerCase()}let K=null,te=0;for(A=A.toLowerCase();te<k.length&&(K=d(A,k,0,te))===null;)te=i(k,te+1);return K}t.$Cj=M;function I(A,k,U=!1){if(!k||k.length===0)return null;let K=null,te=0;for(A=A.toLowerCase(),k=k.toLowerCase();te<k.length&&(K=b(A,k,0,te,U))===null;)te=D(k,te+1);return K}t.$Dj=I;function b(A,k,U,K,te){if(U===A.length)return[];if(K===k.length)return null;if(l(A.charCodeAt(U),k.charCodeAt(K))){let se=null,me=K+1;if(se=b(A,k,U+1,K+1,te),!te)for(;!se&&(me=D(k,me))<k.length;)se=b(A,k,U+1,me,te),me++;return se?A.charCodeAt(U)!==k.charCodeAt(K)?se:m({start:K,end:K+1},se):null}else return null}function D(A,k){for(let U=k;U<A.length;U++)if(e(A.charCodeAt(U))||U>0&&e(A.charCodeAt(U-1)))return U;return A.length}const j=n(t.$yj,M,v),H=n(t.$yj,M,w),B=new y.$Ci(1e4);function E(A,k,U=!1){if(typeof A!="string"||typeof k!="string")return null;let K=B.get(A);K||(K=new RegExp(N.$we(A),"i"),B.set(A,K));const te=K.exec(k);return te?[{start:te.index,end:te.index+te[0].length}]:U?H(A,k):j(A,k)}t.$Ej=E;function z(A,k){const U=q(A,A.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?ie(U):null}t.$Fj=z;function X(A,k,U,K,te,se){const me=Math.min(13,A.length);for(;U<me;U++){const we=q(A,k,U,K,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Gj=X;function ie(A){if(typeof A>"u")return[];const k=[],U=A[1];for(let K=A.length-1;K>1;K--){const te=A[K]+U,se=k[k.length-1];se&&se.end===te?se.end=te+1:k.push({start:te,end:te+1})}return k}t.$Hj=ie;const ue=128;function ae(){const A=[],k=[];for(let U=0;U<=ue;U++)k[U]=0;for(let U=0;U<=ue;U++)A.push(k.slice(0));return A}function oe(A){const k=[];for(let U=0;U<=A;U++)k[U]=0;return k}const re=oe(2*ue),ge=oe(2*ue),Ce=ae(),Fe=ae(),Me=ae(),fe=!1;function ne(A,k,U,K,te){function se(we,Ne,Ee=" "){for(;we.length<Ne;)we=Ee+we;return we}let me=` |   |${K.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=U;we++)we===0?me+=" |":me+=`${k[we-1]}|`,me+=A[we].slice(0,te+1).map(Ne=>se(Ne.toString(),3)).join("|")+`
`;return me}function Q(A,k,U,K){A=A.substr(k),U=U.substr(K),console.log(ne(Fe,A,A.length,U,U.length)),console.log(ne(Me,A,A.length,U,U.length)),console.log(ne(Ce,A,A.length,U,U.length))}function V(A,k){if(k<0||k>=A.length)return!1;const U=A.codePointAt(k);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!N.$6e(U)}}function ee(A,k){if(k<0||k>=A.length)return!1;switch(A.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function J(A,k,U){return k[A]!==U[A]}function S(A,k,U,K,te,se,me=!1){for(;k<U&&te<se;)A[k]===K[te]&&(me&&(re[k]=te),k+=1),te+=1;return k===U}t.$Ij=S;var x;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(x||(x={}));var g;(function(A){A.Default=[-100,0];function k(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}A.isDefault=k})(g||(t.FuzzyScore=g={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(k,U){this.firstMatchCanBeWeak=k,this.boostFullMatch=U}}t.$Jj=p;function q(A,k,U,K,te,se,me=p.default){const we=A.length>ue?ue:A.length,Ne=K.length>ue?ue:K.length;if(U>=we||se>=Ne||we-U>Ne-se||!S(k,U,we,te,se,Ne,!0))return;T(we,Ne,U,se,k,te);let Ee=1,ve=1,Te=U,Pe=se;const We=[!1];for(Ee=1,Te=U;Te<we;Ee++,Te++){const he=re[Te],pe=ge[Te],De=Te+1<we?ge[Te+1]:Ne;for(ve=he-se+1,Pe=he;Pe<De;ve++,Pe++){let ke=Number.MIN_SAFE_INTEGER,Re=!1;Pe<=pe&&(ke=O(A,k,Te,U,K,te,Pe,Ne,se,Ce[Ee-1][ve-1]===0,We));let ze=0;ke!==Number.MAX_SAFE_INTEGER&&(Re=!0,ze=ke+Fe[Ee-1][ve-1]);const Xe=Pe>he,Ye=Xe?Fe[Ee][ve-1]+(Ce[Ee][ve-1]>0?-5:0):0,Ve=Pe>he+1&&Ce[Ee][ve-1]>0,_e=Ve?Fe[Ee][ve-2]+(Ce[Ee][ve-2]>0?-5:0):0;if(Ve&&(!Xe||_e>=Ye)&&(!Re||_e>=ze))Fe[Ee][ve]=_e,Me[Ee][ve]=3,Ce[Ee][ve]=0;else if(Xe&&(!Re||Ye>=ze))Fe[Ee][ve]=Ye,Me[Ee][ve]=2,Ce[Ee][ve]=0;else if(Re)Fe[Ee][ve]=ze,Me[Ee][ve]=1,Ce[Ee][ve]=Ce[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&Q(A,U,K,se),!We[0]&&!me.firstMatchCanBeWeak)return;Ee--,ve--;const je=[Fe[Ee][ve],se];let Ie=0,Ke=0;for(;Ee>=1;){let he=ve;do{const pe=Me[Ee][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Ie>1&&k[U+Ee-1]===te[se+ve-1]&&!J(he+se-1,K,te)&&Ie+1>Ce[Ee][he]&&(he=ve),he===ve?Ie++:Ie=1,Ke||(Ke=he),Ee--,ve=he-1,je.push(ve)}Ne===we&&me.boostFullMatch&&(je[0]+=2);const Z=Ke-we;return je[0]-=Z,je}t.$Kj=q;function T(A,k,U,K,te,se){let me=A-1,we=k-1;for(;me>=U&&we>=K;)te[me]===se[we]&&(ge[me]=we,me--),we--}function O(A,k,U,K,te,se,me,we,Ne,Ee,ve){if(k[U]!==se[me])return Number.MIN_SAFE_INTEGER;let Te=1,Pe=!1;return me===U-K?Te=A[U]===te[me]?7:5:J(me,te,se)&&(me===0||!J(me-1,te,se))?(Te=A[U]===te[me]?7:5,Pe=!0):V(se,me)&&(me===0||!V(se,me-1))?Te=5:(V(se,me-1)||ee(se,me-1))&&(Te=5,Pe=!0),Te>1&&U===K&&(ve[0]=!0),Pe||(Pe=J(me,te,se)||V(se,me-1)||ee(se,me-1)),U===K?me>Ne&&(Te-=Pe?3:5):Ee?Te+=Pe?2:0:Te+=Pe?0:1,me+1===we&&(Te-=Pe?3:5),Te}function P(A,k,U,K,te,se,me){return C(A,k,U,K,te,se,!0,me)}t.$Lj=P;function _(A,k,U,K,te,se,me){return C(A,k,U,K,te,se,!1,me)}t.$Mj=_;function C(A,k,U,K,te,se,me,we){let Ne=q(A,k,U,K,te,se,we);if(Ne&&!me)return Ne;if(A.length>=3){const Ee=Math.min(7,A.length-1);for(let ve=U+1;ve<Ee;ve++){const Te=R(A,ve);if(Te){const Pe=q(Te,Te.toLowerCase(),U,K,te,se,we);Pe&&(Pe[0]-=3,(!Ne||Pe[0]>Ne[0])&&(Ne=Pe))}}}return Ne}function R(A,k){if(k+1>=A.length)return;const U=A[k],K=A[k+1];if(U!==K)return A.slice(0,k)+K+U+A.slice(k+2)}}),define(be[84],$e([1,0,12]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vi=t.$ui=t.$ti=t.$si=t.$ri=t.$qi=t.$pi=void 0;function N(m){return n(m,0)}t.$pi=N;function n(m,i){switch(typeof m){case"object":return m===null?W(349,i):Array.isArray(m)?o(m,i):u(m,i);case"string":return w(m,i);case"boolean":return v(m,i);case"number":return W(m,i);case"undefined":return W(937,i);default:return W(617,i)}}t.$qi=n;function W(m,i){return(i<<5)-i+m|0}t.$ri=W;function v(m,i){return W(m?433:863,i)}function w(m,i){i=W(149417,i);for(let d=0,$=m.length;d<$;d++)i=W(m.charCodeAt(d),i);return i}t.$si=w;function o(m,i){return i=W(104579,i),m.reduce((d,$)=>n($,d),i)}function u(m,i){return i=W(181387,i),Object.keys(m).sort().reduce((d,$)=>(d=w($,d),n(m[$],d)),i)}class c{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=n(i,this.g),this.g}}t.$ti=c;var L;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function s(m,i,d=32){const $=d-i,f=~((1<<$)-1);return(m<<i|(f&m)>>>$)>>>0}function a(m,i=0,d=m.byteLength,$=0){for(let f=0;f<d;f++)m[i+f]=$}function e(m,i,d="0"){for(;m.length<i;)m=d+m;return m}function l(m,i=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),i/4)}t.$ui=l;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const d=i.length;if(d===0)return;const $=this.p;let f=this.r,h=this.u,F,M;for(h!==0?(F=h,M=-1,h=0):(F=i.charCodeAt(0),M=0);;){let I=F;if(y.$Qe(F))if(M+1<d){const b=i.charCodeAt(M+1);y.$Re(b)?(M++,I=y.$Se(F,b)):I=65533}else{h=F;break}else y.$Re(F)&&(I=65533);if(f=this.w($,f,I),M++,M<d)F=i.charCodeAt(M);else break}this.r=f,this.u=h}w(i,d,$){return $<128?i[d++]=$:$<2048?(i[d++]=192|($&1984)>>>6,i[d++]=128|($&63)>>>0):$<65536?(i[d++]=224|($&61440)>>>12,i[d++]=128|($&4032)>>>6,i[d++]=128|($&63)>>>0):(i[d++]=240|($&1835008)>>>18,i[d++]=128|($&258048)>>>12,i[d++]=128|($&4032)>>>6,i[d++]=128|($&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=r.g,d=this.q;for(let j=0;j<64;j+=4)i.setUint32(j,d.getUint32(j,!1),!1);for(let j=64;j<320;j+=4)i.setUint32(j,s(i.getUint32(j-12,!1)^i.getUint32(j-32,!1)^i.getUint32(j-56,!1)^i.getUint32(j-64,!1),1),!1);let $=this.h,f=this.l,h=this.m,F=this.n,M=this.o,I,b,D;for(let j=0;j<80;j++)j<20?(I=f&h|~f&F,b=1518500249):j<40?(I=f^h^F,b=1859775393):j<60?(I=f&h|f&F|h&F,b=2400959708):(I=f^h^F,b=3395469782),D=s($,5)+I+M+b+i.getUint32(j*4,!1)&4294967295,M=F,F=h,h=s(f,30),f=$,$=D;this.h=this.h+$&4294967295,this.l=this.l+f&4294967295,this.m=this.m+h&4294967295,this.n=this.n+F&4294967295,this.o=this.o+M&4294967295}}t.$vi=r}),define(be[85],$e([1,0,72,84]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qs=t.$ps=t.$os=void 0;class n{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,l=s.length;e<l;e++)a[e]=s.charCodeAt(e);return a}}t.$os=n;function W(L,s,a){return new c(new n(L),new n(s)).ComputeDiff(a).changes}t.$ps=W;class v{static Assert(s,a){if(!s)throw new Error(a)}}class w{static Copy(s,a,e,l,r){for(let m=0;m<r;m++)e[l+m]=s[a+m]}static Copy2(s,a,e,l,r){for(let m=0;m<r;m++)e[l+m]=s[a+m]}}var o;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ns(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[l,r,m]=c.o(s),[i,d,$]=c.o(a);this.d=m&&$,this.e=l,this.f=r,this.g=i,this.h=d,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(c.n(a)){const e=new Int32Array(a.length);for(let l=0,r=a.length;l<r;l++)e[l]=(0,N.$si)(a[l],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=c.r(this.b,s),l=c.r(this.c,a);return e===l}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,l,r){const m=[!1];let i=this.w(s,a,e,l,m);return r&&(i=this.z(i)),{quitEarly:m[0],changes:i}}w(s,a,e,l,r){for(r[0]=!1;s<=a&&e<=l&&this.p(s,e);)s++,e++;for(;a>=s&&l>=e&&this.p(a,l);)a--,l--;if(s>a||e>l){let h;return e<=l?(v.Assert(s===a+1,"originalStart should only be one more than originalEnd"),h=[new y.$ns(s,0,e,l-e+1)]):s<=a?(v.Assert(e===l+1,"modifiedStart should only be one more than modifiedEnd"),h=[new y.$ns(s,a-s+1,e,0)]):(v.Assert(s===a+1,"originalStart should only be one more than originalEnd"),v.Assert(e===l+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const m=[0],i=[0],d=this.y(s,a,e,l,m,i,r),$=m[0],f=i[0];if(d!==null)return d;if(!r[0]){const h=this.w(s,$,e,f,r);let F=[];return r[0]?F=[new y.$ns($+1,a-($+1)+1,f+1,l-(f+1)+1)]:F=this.w($+1,a,f+1,l,r),this.H(h,F)}return[new y.$ns(s,a-s+1,e,l-e+1)]}x(s,a,e,l,r,m,i,d,$,f,h,F,M,I,b,D,j,H){let B=null,E=null,z=new u,X=a,ie=e,ue=M[0]-D[0]-l,ae=-1073741824,oe=this.k.length-1;do{const re=ue+s;re===X||re<ie&&$[re-1]<$[re+1]?(h=$[re+1],I=h-ue-l,h<ae&&z.MarkNextChange(),ae=h,z.AddModifiedElement(h+1,I),ue=re+1-s):(h=$[re-1]+1,I=h-ue-l,h<ae&&z.MarkNextChange(),ae=h-1,z.AddOriginalElement(h,I+1),ue=re-1-s),oe>=0&&($=this.k[oe],s=$[0],X=1,ie=$.length-1)}while(--oe>=-1);if(B=z.getReverseChanges(),H[0]){let re=M[0]+1,ge=D[0]+1;if(B!==null&&B.length>0){const Ce=B[B.length-1];re=Math.max(re,Ce.getOriginalEnd()),ge=Math.max(ge,Ce.getModifiedEnd())}E=[new y.$ns(re,F-re+1,ge,b-ge+1)]}else{z=new u,X=m,ie=i,ue=M[0]-D[0]-d,ae=1073741824,oe=j?this.m.length-1:this.m.length-2;do{const re=ue+r;re===X||re<ie&&f[re-1]>=f[re+1]?(h=f[re+1]-1,I=h-ue-d,h>ae&&z.MarkNextChange(),ae=h+1,z.AddOriginalElement(h+1,I+1),ue=re+1-r):(h=f[re-1],I=h-ue-d,h>ae&&z.MarkNextChange(),ae=h,z.AddModifiedElement(h+1,I+1),ue=re-1-r),oe>=0&&(f=this.m[oe],r=f[0],X=1,ie=f.length-1)}while(--oe>=-1);E=z.getChanges()}return this.H(B,E)}y(s,a,e,l,r,m,i){let d=0,$=0,f=0,h=0,F=0,M=0;s--,e--,r[0]=0,m[0]=0,this.k=[],this.m=[];const I=a-s+(l-e),b=I+1,D=new Int32Array(b),j=new Int32Array(b),H=l-e,B=a-s,E=s-e,z=a-l,ie=(B-H)%2===0;D[H]=s,j[B]=a,i[0]=!1;for(let ue=1;ue<=I/2+1;ue++){let ae=0,oe=0;f=this.J(H-ue,ue,H,b),h=this.J(H+ue,ue,H,b);for(let ge=f;ge<=h;ge+=2){ge===f||ge<h&&D[ge-1]<D[ge+1]?d=D[ge+1]:d=D[ge-1]+1,$=d-(ge-H)-E;const Ce=d;for(;d<a&&$<l&&this.p(d+1,$+1);)d++,$++;if(D[ge]=d,d+$>ae+oe&&(ae=d,oe=$),!ie&&Math.abs(ge-B)<=ue-1&&d>=j[ge])return r[0]=d,m[0]=$,Ce<=j[ge]&&1447>0&&ue<=1447+1?this.x(H,f,h,E,B,F,M,z,D,j,d,a,r,$,l,m,ie,i):null}const re=(ae-s+(oe-e)-ue)/2;if(this.a!==null&&!this.a(ae,re))return i[0]=!0,r[0]=ae,m[0]=oe,re>0&&1447>0&&ue<=1447+1?this.x(H,f,h,E,B,F,M,z,D,j,d,a,r,$,l,m,ie,i):(s++,e++,[new y.$ns(s,a-s+1,e,l-e+1)]);F=this.J(B-ue,ue,B,b),M=this.J(B+ue,ue,B,b);for(let ge=F;ge<=M;ge+=2){ge===F||ge<M&&j[ge-1]>=j[ge+1]?d=j[ge+1]-1:d=j[ge-1],$=d-(ge-B)-z;const Ce=d;for(;d>s&&$>e&&this.p(d,$);)d--,$--;if(j[ge]=d,ie&&Math.abs(ge-H)<=ue&&d<=D[ge])return r[0]=d,m[0]=$,Ce>=D[ge]&&1447>0&&ue<=1447+1?this.x(H,f,h,E,B,F,M,z,D,j,d,a,r,$,l,m,ie,i):null}if(ue<=1447){let ge=new Int32Array(h-f+2);ge[0]=H-f+1,w.Copy2(D,f,ge,1,h-f+1),this.k.push(ge),ge=new Int32Array(M-F+2),ge[0]=B-F+1,w.Copy2(j,F,ge,1,M-F+1),this.m.push(ge)}}return this.x(H,f,h,E,B,F,M,z,D,j,d,a,r,$,l,m,ie,i)}z(s){for(let a=0;a<s.length;a++){const e=s[a],l=a<s.length-1?s[a+1].originalStart:this.f.length,r=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,i=e.modifiedLength>0;for(;e.originalStart+e.originalLength<l&&e.modifiedStart+e.modifiedLength<r&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!i||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const $=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!$)break;e.originalStart++,e.modifiedStart++}const d=[null];if(a<s.length-1&&this.I(s[a],s[a+1],d)){s[a]=d[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let l=0,r=0;if(a>0){const h=s[a-1];l=h.originalStart+h.originalLength,r=h.modifiedStart+h.modifiedLength}const m=e.originalLength>0,i=e.modifiedLength>0;let d=0,$=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let h=1;;h++){const F=e.originalStart-h,M=e.modifiedStart-h;if(F<l||M<r||m&&!this.s(F,F+e.originalLength)||i&&!this.u(M,M+e.modifiedLength))break;const b=(F===l&&M===r?5:0)+this.G(F,e.originalLength,M,e.modifiedLength);b>$&&($=b,d=h)}e.originalStart-=d,e.modifiedStart-=d;const f=[null];if(a>0&&this.I(s[a-1],s[a],f)){s[a-1]=f[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const l=s[a-1],r=s[a],m=r.originalStart-l.originalStart-l.originalLength,i=l.originalStart,d=r.originalStart+r.originalLength,$=d-i,f=l.modifiedStart,h=r.modifiedStart+r.modifiedLength,F=h-f;if(m<5&&$<20&&F<20){const M=this.A(i,$,f,F,m);if(M){const[I,b]=M;(I!==l.originalStart+l.originalLength||b!==l.modifiedStart+l.modifiedLength)&&(l.originalLength=I-l.originalStart,l.modifiedLength=b-l.modifiedStart,r.originalStart=I+m,r.modifiedStart=b+m,r.originalLength=d-r.originalStart,r.modifiedLength=h-r.modifiedStart)}}}return s}A(s,a,e,l,r){if(a<r||l<r)return null;const m=s+a-r+1,i=e+l-r+1;let d=0,$=0,f=0;for(let h=s;h<m;h++)for(let F=e;F<i;F++){const M=this.B(h,F,r);M>0&&M>d&&(d=M,$=h,f=F)}return d>0?[$,f]:null}B(s,a,e){let l=0;for(let r=0;r<e;r++){if(!this.p(s+r,a+r))return 0;l+=this.e[s+r].length}return l}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,l){const r=this.D(s,a)?1:0,m=this.F(e,l)?1:0;return r+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const l=new Array(s.length+a.length-1);return w.Copy(s,0,l,0,s.length-1),l[s.length-1]=e[0],w.Copy(a,1,l,s.length,a.length-1),l}else{const l=new Array(s.length+a.length);return w.Copy(s,0,l,0,s.length),w.Copy(a,0,l,s.length,a.length),l}}I(s,a,e){if(v.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),v.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const l=s.originalStart;let r=s.originalLength;const m=s.modifiedStart;let i=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(r=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(i=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new y.$ns(l,r,m,i),!0}else return e[0]=null,!1}J(s,a,e,l){if(s>=0&&s<l)return s;const r=e,m=l-e-1,i=a%2===0;if(s<0){const d=r%2===0;return i===d?0:1}else{const d=m%2===0;return i===d?l-1:l-2}}}t.$qs=c}),define(be[48],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cd=void 0,t.$cd=Symbol("MicrotaskDelay")}),define(be[86],$e([1,0,11,12]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=void 0;class n{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),l=this.b.charCodeAt(this.c);return e-l}value(){return this.b[this.c]}}t.$Dh=n;class W{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,N.$Ge)(a,this.b,0,a.length,this.c,this.d):(0,N.$Ie)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Eh=W;class v{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const l=this.b.charCodeAt(e);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,N.$Ge)(a,this.b,0,a.length,this.d,this.e):(0,N.$Ie)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Fh=v;var w;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(w||(w={}));class o{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new v(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,N.$He)(a,this.c.scheme);if(this.d[this.e]===2)return(0,N.$He)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,N.$Fe)(a,this.c.query);if(this.d[this.e]===5)return(0,N.$Fe)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Gh=o;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(c||(c={}));class L{static forUris(a=()=>!1,e=()=>!1){return new L(new o(a,e))}static forPaths(a=!1){return new L(new v(void 0,!a))}static forStrings(){return new L(new n)}static forConfigKeys(){return new L(new W)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const l=e.slice(0);(0,y.$Vb)(l);for(const r of l)this.set(r,a)}else{const l=a.slice(0);(0,y.$Vb)(l);for(const r of l)this.set(r[0],r[1])}}set(a,e){const l=this.b.reset(a);let r;this.c||(this.c=new u,this.c.segment=l.value());const m=[];for(r=this.c;;){const d=l.cmp(r.segment);if(d>0)r.left||(r.left=new u,r.left.segment=l.value()),m.push([-1,r]),r=r.left;else if(d<0)r.right||(r.right=new u,r.right.segment=l.value()),m.push([1,r]),r=r.right;else if(l.hasNext())l.next(),r.mid||(r.mid=new u,r.mid.segment=l.value()),m.push([0,r]),r=r.mid;else break}const i=r.value;r.value=e,r.key=a;for(let d=m.length-1;d>=0;d--){const $=m[d][1];$.updateHeight();const f=$.balanceFactor();if(f<-1||f>1){const h=m[d][0],F=m[d+1][0];if(h===1&&F===1)m[d][1]=$.rotateLeft();else if(h===-1&&F===-1)m[d][1]=$.rotateRight();else if(h===1&&F===-1)$.right=m[d+1][1]=m[d+1][1].rotateRight(),m[d][1]=$.rotateLeft();else if(h===-1&&F===1)$.left=m[d+1][1]=m[d+1][1].rotateLeft(),m[d][1]=$.rotateRight();else throw new Error;if(d>0)switch(m[d-1][0]){case-1:m[d-1][1].left=m[d][1];break;case 1:m[d-1][1].right=m[d][1];break;case 0:m[d-1][1].mid=m[d][1];break}else this.c=m[0][1]}}return i}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let l=this.c;for(;l;){const r=e.cmp(l.segment);if(r>0)l=l.left;else if(r<0)l=l.right;else if(e.hasNext())e.next(),l=l.mid;else break}return l}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const l=this.b.reset(a),r=[];let m=this.c;for(;m;){const i=l.cmp(m.segment);if(i>0)r.push([-1,m]),m=m.left;else if(i<0)r.push([1,m]),m=m.right;else if(l.hasNext())l.next(),r.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const i=this.f(m.right);if(i.key){const{key:d,value:$,segment:f}=i;this.e(i.key,!1),m.key=d,m.value=$,m.segment=f}}else{const i=m.left??m.right;if(r.length>0){const[d,$]=r[r.length-1];switch(d){case-1:$.left=i;break;case 0:$.mid=i;break;case 1:$.right=i;break}}else this.c=i}for(let i=r.length-1;i>=0;i--){const d=r[i][1];d.updateHeight();const $=d.balanceFactor();if($>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),r[i][1]=d.rotateLeft()):$<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),r[i][1]=d.rotateRight()),i>0)switch(r[i-1][0]){case-1:r[i-1][1].left=r[i][1];break;case 1:r[i-1][1].right=r[i][1];break;case 0:r[i-1][1].mid=r[i][1];break}else this.c=r[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let l=this.c,r;for(;l;){const m=e.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(e.hasNext())e.next(),r=l.value||r,l=l.mid;else break}return l&&l.value||r}findSuperstr(a){return this.g(a,!1)}g(a,e){const l=this.b.reset(a);let r=this.c;for(;r;){const m=l.cmp(r.segment);if(m>0)r=r.left;else if(m<0)r=r.right;else if(l.hasNext())l.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,l]of this)a(l,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const l=e.balanceFactor();return l<-1||l>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Hh=L}),define(be[7],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=void 0;function y(f){return typeof f=="string"}t.$jf=y;function N(f){return Array.isArray(f)&&f.every(h=>y(h))}t.$kf=N;function n(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$lf=n;function W(f){const h=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof h}t.$mf=W;function v(f){return typeof f=="number"&&!isNaN(f)}t.$nf=v;function w(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$of=w;function o(f){return f===!0||f===!1}t.$pf=o;function u(f){return typeof f>"u"}t.$qf=u;function c(f){return!L(f)}t.$rf=c;function L(f){return u(f)||f===null}t.$sf=L;function s(f,h){if(!f)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}t.$tf=s;function a(f){if(L(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$uf=a;function e(...f){const h=[];for(let F=0;F<f.length;F++){const M=f[F];if(L(M))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);h.push(M)}return h}t.$vf=e;const l=Object.prototype.hasOwnProperty;function r(f){if(!n(f))return!1;for(const h in f)if(l.call(f,h))return!1;return!0}t.$wf=r;function m(f){return typeof f=="function"}t.$xf=m;function i(...f){return f.length>0&&f.every(m)}t.$yf=i;function d(f,h){const F=Math.min(f.length,h.length);for(let M=0;M<F;M++)$(f[M],h[M])}t.$zf=d;function $(f,h){if(y(h)){if(typeof f!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(m(h)){try{if(f instanceof h)return}catch{}if(!L(f)&&f.constructor===h||h.length===1&&h.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Af=$}),define(be[17],$e([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=t.$Oj=t.$Nj=void 0;const N=Object.create(null);function n(w,o){if((0,y.$jf)(o)){const u=N[o];if(u===void 0)throw new Error(`${w} references an unknown codicon: ${o}`);o=u}return N[w]=o,{id:w}}function W(){return N}t.$Nj=W;function v(){return Object.values(t.$Pj)}t.$Oj=v,t.$Pj={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[49],$e([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=t.$Vm=void 0;function N(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const i=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([d,$])=>{i[d]=$&&typeof $=="object"?N($):$}),i}t.$Vm=N;function n(m){if(!m||typeof m!="object")return m;const i=[m];for(;i.length>0;){const d=i.shift();Object.freeze(d);for(const $ in d)if(W.call(d,$)){const f=d[$];typeof f=="object"&&!Object.isFrozen(f)&&!(0,y.$mf)(f)&&i.push(f)}}return m}t.$Wm=n;const W=Object.prototype.hasOwnProperty;function v(m,i){return w(m,i,new Set)}t.$Xm=v;function w(m,i,d){if((0,y.$sf)(m))return m;const $=i(m);if(typeof $<"u")return $;if(Array.isArray(m)){const f=[];for(const h of m)f.push(w(h,i,d));return f}if((0,y.$lf)(m)){if(d.has(m))throw new Error("Cannot clone recursive data-structure");d.add(m);const f={};for(const h in m)W.call(m,h)&&(f[h]=w(m[h],i,d));return d.delete(m),f}return m}function o(m,i,d=!0){return(0,y.$lf)(m)?((0,y.$lf)(i)&&Object.keys(i).forEach($=>{$ in m?d&&((0,y.$lf)(m[$])&&(0,y.$lf)(i[$])?o(m[$],i[$],d):m[$]=i[$]):m[$]=i[$]}),m):i}t.$Ym=o;function u(m,i){if(m===i)return!0;if(m==null||i===null||i===void 0||typeof m!=typeof i||typeof m!="object"||Array.isArray(m)!==Array.isArray(i))return!1;let d,$;if(Array.isArray(m)){if(m.length!==i.length)return!1;for(d=0;d<m.length;d++)if(!u(m[d],i[d]))return!1}else{const f=[];for($ in m)f.push($);f.sort();const h=[];for($ in i)h.push($);if(h.sort(),!u(f,h))return!1;for(d=0;d<f.length;d++)if(!u(m[f[d]],i[f[d]]))return!1}return!0}t.$Zm=u;function c(m){const i=new Set;return JSON.stringify(m,(d,$)=>{if((0,y.$lf)($)||Array.isArray($)){if(i.has($))return"[Circular]";i.add($)}return $})}t.$1m=c;function L(m,i){const d=Object.create(null);return!m||!i||Object.keys(i).forEach(f=>{const h=m[f],F=i[f];u(h,F)||(d[f]=F)}),d}t.$2m=L;function s(m,i){const d=i.toLowerCase(),$=Object.keys(m).find(f=>f.toLowerCase()===d);return $?m[$]:m[i]}t.$3m=s;function a(m,i){const d=Object.create(null);for(const[$,f]of Object.entries(m))i($,f)&&(d[$]=f);return d}t.$4m=a;function e(m){let i=[];for(;Object.prototype!==m;)i=i.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return i}t.$5m=e;function l(m){const i=[];for(const d of e(m))typeof m[d]=="function"&&i.push(d);return i}t.$6m=l;function r(m,i){const d=f=>function(){const h=Array.prototype.slice.call(arguments,0);return i(f,h)},$={};for(const f of m)$[f]=d(f);return $}t.$7m=r}),define(be[18],$e([1,0,17]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Qj=t.ThemeColor=void 0;var N;(function(v){function w(o){return o&&typeof o=="object"&&typeof o.id=="string"}v.isThemeColor=w})(N||(t.ThemeColor=N={}));function n(v){return{id:v}}t.$Qj=n;var W;(function(v){v.iconNameSegment="[A-Za-z0-9]+",v.iconNameExpression="[A-Za-z0-9-]+",v.iconModifierExpression="~[A-Za-z]+",v.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${v.iconNameExpression})(${v.iconModifierExpression})?$`);function o(i){const d=w.exec(i.id);if(!d)return o(y.$Pj.error);const[,$,f]=d,h=["codicon","codicon-"+$];return f&&h.push("codicon-modifier-"+f.substring(1)),h}v.asClassNameArray=o;function u(i){return o(i).join(" ")}v.asClassName=u;function c(i){return"."+o(i).join(".")}v.asCSSSelector=c;function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}v.isThemeIcon=L;const s=new RegExp(`^\\$\\((${v.iconNameExpression}(?:${v.iconModifierExpression})?)\\)$`);function a(i){const d=s.exec(i);if(!d)return;const[,$]=d;return{id:$}}v.fromString=a;function e(i){return{id:i}}v.fromId=e;function l(i,d){let $=i.id;const f=$.lastIndexOf("~");return f!==-1&&($=$.substring(0,f)),d&&($=`${$}~${d}`),{id:$}}v.modify=l;function r(i){const d=i.id.lastIndexOf("~");if(d!==-1)return i.id.substring(d+1)}v.getModifier=r;function m(i,d){return i.id===d.id&&i.color?.id===d.color?.id}v.isEqual=m})(W||(t.ThemeIcon=W={}))}),define(be[33],$e([1,0,32,12,18]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=void 0;const W="$(",v=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${v.source}`,"g");function o(m){return m.replace(w,(i,d)=>d?i:`\\${i}`)}t.$Rj=o;const u=new RegExp(`\\\\${v.source}`,"g");function c(m){return m.replace(u,i=>`\\${i}`)}t.$Sj=c;const L=new RegExp(`(\\s)?(\\\\)?${v.source}(\\s)?`,"g");function s(m){return m.indexOf(W)===-1?m:m.replace(L,(i,d,$,f)=>$?i:d||f||"")}t.$Tj=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(i,d)=>` ${d} `).trim():""}t.$Uj=a;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(m){e.lastIndex=0;let i="";const d=[];let $=0;for(;;){const f=e.lastIndex,h=e.exec(m),F=m.substring(f,h?.index);if(F.length>0){i+=F;for(let M=0;M<F.length;M++)d.push($)}if(!h)break;$+=h[0].length}return{text:i,iconOffsets:d}}t.$Vj=l;function r(m,i,d=!1){const{text:$,iconOffsets:f}=i;if(!f||f.length===0)return(0,y.$Ej)(m,$,d);const h=(0,N.$ue)($," "),F=$.length-h.length,M=(0,y.$Ej)(m,h,d);if(M)for(const I of M){const b=f[I.start+F]+F;I.start+=b,I.end+=b}return M}t.$Wj=r}),define(be[87],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YS=t.$XS=void 0,t.$XS="vscode:contextmenu",t.$YS="vscode:onCloseContextMenu"}),define(be[88],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=void 0;class y{constructor(n,W){this.a=n,this.onMessage=W}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$6S=y}),define(be[50],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([1,0,90,91]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],$e([13,10]),function(le,t){return le.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],$e([13,10]),function(le,t){return le.create("vs/base/common/actions",t)}),define(be[34],$e([1,0,3,2,109]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$li=t.$ki=t.$ji=t.$ii=t.$hi=t.$gi=void 0;class W extends N.$kc{constructor(s,a="",e="",l=!0,r){super(),this.h=this.B(new y.$fd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=l,this.C=r}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$gi=W;class v extends N.$kc{constructor(){super(...arguments),this.f=this.B(new y.$fd),this.onWillRun=this.f.event,this.m=this.B(new y.$fd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(l){e=l}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$hi=v;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new w,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$ii=w;class o{get actions(){return this.a}constructor(s,a,e,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=l,this.a=e}async run(){}}t.$ji=o;class u extends W{static{this.ID="vs.actions.empty"}constructor(){super(u.ID,n.localize(0,null),void 0,!1)}}t.$ki=u;function c(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...s)=>L.run(),tooltip:L.label}}t.$li=c}),define(be[110],$e([13,10]),function(le,t){return le.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,110]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let N=!1,n=!1,W=!1,v=!1,w=!1,o=!1,u=!1,c=!1,L=!1,s=!1,a,e=t.$f,l=t.$f,r,m;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let i;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?i=t.$g.vscode.process:typeof process<"u"&&(i=process);const d=typeof i?.versions?.electron=="string",$=d&&i?.type==="renderer";if(typeof navigator=="object"&&!$)m=navigator.userAgent,N=m.indexOf("Windows")>=0,n=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,o=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$f,e=a,l=navigator.language;else if(typeof i=="object"){N=i.platform==="win32",n=i.platform==="darwin",W=i.platform==="linux",v=W&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,u=d,L=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$f,e=t.$f;const H=i.env.VSCODE_NLS_CONFIG;if(H)try{const B=JSON.parse(H),E=B.availableLanguages["*"];a=B.locale,l=B.osLocale,e=E||t.$f,r=B._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var f;(function(H){H[H.Web=0]="Web",H[H.Mac=1]="Mac",H[H.Linux=2]="Linux",H[H.Windows=3]="Windows"})(f||(t.Platform=f={}));function h(H){switch(H){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=h;let F=0;n?F=1:N?F=3:W&&(F=2),t.$i=N,t.$j=n,t.$k=W,t.$l=v,t.$m=w,t.$n=u,t.$o=o,t.$p=o&&typeof t.$g.importScripts=="function",t.$q=c,t.$r=s,t.$s=L,t.$t=F,t.$u=m,t.$v=e;var M;(function(H){function B(){return t.$v}H.value=B;function E(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}H.isDefaultVariant=E;function z(){return t.$v==="en"}H.isDefault=z})(M||(t.Language=M={})),t.$w=a,t.$x=l,t.$y=r,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const H=[];t.$g.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let z=0,X=H.length;z<X;z++){const ie=H[z];if(ie.id===E.data.vscodeScheduleAsyncWork){H.splice(z,1),ie.callback();return}}});let B=0;return E=>{const z=++B;H.push({id:z,callback:E}),t.$g.postMessage({vscodeScheduleAsyncWork:z},"*")}}return H=>setTimeout(H)})();var I;(function(H){H[H.Windows=1]="Windows",H[H.Macintosh=2]="Macintosh",H[H.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=n||c?2:N?1:3;let b=!0,D=!1;function j(){if(!D){D=!0;const H=new Uint8Array(2);H[0]=1,H[1]=2,b=new Uint16Array(H.buffer)[0]===(2<<8)+1}return b}t.$C=j,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),define(be[111],$e([1,0,16,5]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gO=t.KeyboardSupport=void 0;var n;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(n||(t.KeyboardSupport=n={})),t.$gO={clipboard:{writeText:N.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:N.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>N.$m||y.$eO()?0:navigator.keyboard||y.$aO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,43,75,5]),function(le,t,y,N,n,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oO=t.$nO=t.$mO=void 0;function v(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(r)}const l=e.keyCode;if(l===3)return 7;if(y.$0N)switch(l){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(y.$$N){if(W.$j&&l===93)return 57;if(!W.$j&&l===92)return 57}return N.$qq[l]||0}const w=W.$j?256:2048,o=512,u=1024,c=W.$j?2048:256;function L(e){const l=[];return e.ctrlKey&&l.push("ctrl"),e.shiftKey&&l.push("shift"),e.altKey&&l.push("alt"),e.metaKey&&l.push("meta"),`modifiers: [${l.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$mO=L;function s(e){const l=[];return e.ctrlKey&&l.push("ctrl"),e.shiftKey&&l.push("shift"),e.altKey&&l.push("alt"),e.metaKey&&l.push("meta"),`modifiers: [${l.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}t.$nO=s;class a{constructor(l){this._standardKeyboardEventBrand=!0;const r=l;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState("AltGraph"),this.keyCode=v(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(l){return this.a===l}c(){let l=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(l=this.keyCode);let r=0;return this.ctrlKey&&(r|=w),this.altKey&&(r|=o),this.shiftKey&&(r|=u),this.metaKey&&(r|=c),r|=l,r}d(){let l=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(l=this.keyCode),new n.$yq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,l)}}t.$oO=a}),define(be[19],$e([1,0,16,67,5]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lO=t.$kO=t.$jO=void 0;class W{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=u.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const c=N.$hO.getPositionOfChildWindowRelativeToAncestorWindow(window,u.view);this.posx-=c.left,this.posy-=c.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$jO=W;class v extends W{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.$kO=v;class w{constructor(u,c=0,L=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=L,this.deltaX=c,u){const s=u,a=u;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$0N&&!n.$j?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof s.wheelDeltaX<"u")y.$aO&&n.$i?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$0N&&!n.$j?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$lO=w}),define(be[112],$e([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.$3d=t.env=t.cwd=void 0;let N;if(typeof y.$g.vscode<"u"&&typeof y.$g.vscode.process<"u"){const n=y.$g.vscode.process;N={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$3d=N.platform,t.$4d=N.arch}),define(be[22],$e([1,0,112]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=t.sep=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=void 0;const N=65,n=97,W=90,v=122,w=46,o=47,u=92,c=58,L=63;class s extends Error{constructor(F,M,I){let b;typeof M=="string"&&M.indexOf("not ")===0?(b="must not be",M=M.replace(/^not /,"")):b="must be";const D=F.indexOf(".")!==-1?"property":"argument";let j=`The "${F}" ${D} ${b} of type ${M}`;j+=`. Received type ${typeof I}`,super(j),this.code="ERR_INVALID_ARG_TYPE"}}function a(h,F){if(h===null||typeof h!="object")throw new s(F,"Object",h)}function e(h,F){if(typeof h!="string")throw new s(F,"string",h)}const l=y.$3d==="win32";function r(h){return h===o||h===u}function m(h){return h===o}function i(h){return h>=N&&h<=W||h>=n&&h<=v}function d(h,F,M,I){let b="",D=0,j=-1,H=0,B=0;for(let E=0;E<=h.length;++E){if(E<h.length)B=h.charCodeAt(E);else{if(I(B))break;B=o}if(I(B)){if(!(j===E-1||H===1))if(H===2){if(b.length<2||D!==2||b.charCodeAt(b.length-1)!==w||b.charCodeAt(b.length-2)!==w){if(b.length>2){const z=b.lastIndexOf(M);z===-1?(b="",D=0):(b=b.slice(0,z),D=b.length-1-b.lastIndexOf(M)),j=E,H=0;continue}else if(b.length!==0){b="",D=0,j=E,H=0;continue}}F&&(b+=b.length>0?`${M}..`:"..",D=2)}else b.length>0?b+=`${M}${h.slice(j+1,E)}`:b=h.slice(j+1,E),D=E-j-1;j=E,H=0}else B===w&&H!==-1?++H:H=-1}return b}function $(h,F){a(F,"pathObject");const M=F.dir||F.root,I=F.base||`${F.name||""}${F.ext||""}`;return M?M===F.root?`${M}${I}`:`${M}${h}${I}`:I}t.$5d={resolve(...h){let F="",M="",I=!1;for(let b=h.length-1;b>=-1;b--){let D;if(b>=0){if(D=h[b],e(D,"path"),D.length===0)continue}else F.length===0?D=y.cwd():(D=y.env[`=${F}`]||y.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==F.toLowerCase()&&D.charCodeAt(2)===u)&&(D=`${F}\\`));const j=D.length;let H=0,B="",E=!1;const z=D.charCodeAt(0);if(j===1)r(z)&&(H=1,E=!0);else if(r(z))if(E=!0,r(D.charCodeAt(1))){let X=2,ie=X;for(;X<j&&!r(D.charCodeAt(X));)X++;if(X<j&&X!==ie){const ue=D.slice(ie,X);for(ie=X;X<j&&r(D.charCodeAt(X));)X++;if(X<j&&X!==ie){for(ie=X;X<j&&!r(D.charCodeAt(X));)X++;(X===j||X!==ie)&&(B=`\\\\${ue}\\${D.slice(ie,X)}`,H=X)}}}else H=1;else i(z)&&D.charCodeAt(1)===c&&(B=D.slice(0,2),H=2,j>2&&r(D.charCodeAt(2))&&(E=!0,H=3));if(B.length>0)if(F.length>0){if(B.toLowerCase()!==F.toLowerCase())continue}else F=B;if(I){if(F.length>0)break}else if(M=`${D.slice(H)}\\${M}`,I=E,E&&F.length>0)break}return M=d(M,!I,"\\",r),I?`${F}\\${M}`:`${F}${M}`||"."},normalize(h){e(h,"path");const F=h.length;if(F===0)return".";let M=0,I,b=!1;const D=h.charCodeAt(0);if(F===1)return m(D)?"\\":h;if(r(D))if(b=!0,r(h.charCodeAt(1))){let H=2,B=H;for(;H<F&&!r(h.charCodeAt(H));)H++;if(H<F&&H!==B){const E=h.slice(B,H);for(B=H;H<F&&r(h.charCodeAt(H));)H++;if(H<F&&H!==B){for(B=H;H<F&&!r(h.charCodeAt(H));)H++;if(H===F)return`\\\\${E}\\${h.slice(B)}\\`;H!==B&&(I=`\\\\${E}\\${h.slice(B,H)}`,M=H)}}}else M=1;else i(D)&&h.charCodeAt(1)===c&&(I=h.slice(0,2),M=2,F>2&&r(h.charCodeAt(2))&&(b=!0,M=3));let j=M<F?d(h.slice(M),!b,"\\",r):"";return j.length===0&&!b&&(j="."),j.length>0&&r(h.charCodeAt(F-1))&&(j+="\\"),I===void 0?b?`\\${j}`:j:b?`${I}\\${j}`:`${I}${j}`},isAbsolute(h){e(h,"path");const F=h.length;if(F===0)return!1;const M=h.charCodeAt(0);return r(M)||F>2&&i(M)&&h.charCodeAt(1)===c&&r(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let F,M;for(let D=0;D<h.length;++D){const j=h[D];e(j,"path"),j.length>0&&(F===void 0?F=M=j:F+=`\\${j}`)}if(F===void 0)return".";let I=!0,b=0;if(typeof M=="string"&&r(M.charCodeAt(0))){++b;const D=M.length;D>1&&r(M.charCodeAt(1))&&(++b,D>2&&(r(M.charCodeAt(2))?++b:I=!1))}if(I){for(;b<F.length&&r(F.charCodeAt(b));)b++;b>=2&&(F=`\\${F.slice(b)}`)}return t.$5d.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F)return"";const M=t.$5d.resolve(h),I=t.$5d.resolve(F);if(M===I||(h=M.toLowerCase(),F=I.toLowerCase(),h===F))return"";let b=0;for(;b<h.length&&h.charCodeAt(b)===u;)b++;let D=h.length;for(;D-1>b&&h.charCodeAt(D-1)===u;)D--;const j=D-b;let H=0;for(;H<F.length&&F.charCodeAt(H)===u;)H++;let B=F.length;for(;B-1>H&&F.charCodeAt(B-1)===u;)B--;const E=B-H,z=j<E?j:E;let X=-1,ie=0;for(;ie<z;ie++){const ae=h.charCodeAt(b+ie);if(ae!==F.charCodeAt(H+ie))break;ae===u&&(X=ie)}if(ie!==z){if(X===-1)return I}else{if(E>z){if(F.charCodeAt(H+ie)===u)return I.slice(H+ie+1);if(ie===2)return I.slice(H+ie)}j>z&&(h.charCodeAt(b+ie)===u?X=ie:ie===2&&(X=3)),X===-1&&(X=0)}let ue="";for(ie=b+X+1;ie<=D;++ie)(ie===D||h.charCodeAt(ie)===u)&&(ue+=ue.length===0?"..":"\\..");return H+=X,ue.length>0?`${ue}${I.slice(H,B)}`:(I.charCodeAt(H)===u&&++H,I.slice(H,B))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const F=t.$5d.resolve(h);if(F.length<=2)return h;if(F.charCodeAt(0)===u){if(F.charCodeAt(1)===u){const M=F.charCodeAt(2);if(M!==L&&M!==w)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(i(F.charCodeAt(0))&&F.charCodeAt(1)===c&&F.charCodeAt(2)===u)return`\\\\?\\${F}`;return h},dirname(h){e(h,"path");const F=h.length;if(F===0)return".";let M=-1,I=0;const b=h.charCodeAt(0);if(F===1)return r(b)?h:".";if(r(b)){if(M=I=1,r(h.charCodeAt(1))){let H=2,B=H;for(;H<F&&!r(h.charCodeAt(H));)H++;if(H<F&&H!==B){for(B=H;H<F&&r(h.charCodeAt(H));)H++;if(H<F&&H!==B){for(B=H;H<F&&!r(h.charCodeAt(H));)H++;if(H===F)return h;H!==B&&(M=I=H+1)}}}}else i(b)&&h.charCodeAt(1)===c&&(M=F>2&&r(h.charCodeAt(2))?3:2,I=M);let D=-1,j=!0;for(let H=F-1;H>=I;--H)if(r(h.charCodeAt(H))){if(!j){D=H;break}}else j=!1;if(D===-1){if(M===-1)return".";D=M}return h.slice(0,D)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,I=-1,b=!0,D;if(h.length>=2&&i(h.charCodeAt(0))&&h.charCodeAt(1)===c&&(M=2),F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let j=F.length-1,H=-1;for(D=h.length-1;D>=M;--D){const B=h.charCodeAt(D);if(r(B)){if(!b){M=D+1;break}}else H===-1&&(b=!1,H=D+1),j>=0&&(B===F.charCodeAt(j)?--j===-1&&(I=D):(j=-1,I=H))}return M===I?I=H:I===-1&&(I=h.length),h.slice(M,I)}for(D=h.length-1;D>=M;--D)if(r(h.charCodeAt(D))){if(!b){M=D+1;break}}else I===-1&&(b=!1,I=D+1);return I===-1?"":h.slice(M,I)},extname(h){e(h,"path");let F=0,M=-1,I=0,b=-1,D=!0,j=0;h.length>=2&&h.charCodeAt(1)===c&&i(h.charCodeAt(0))&&(F=I=2);for(let H=h.length-1;H>=F;--H){const B=h.charCodeAt(H);if(r(B)){if(!D){I=H+1;break}continue}b===-1&&(D=!1,b=H+1),B===w?M===-1?M=H:j!==1&&(j=1):M!==-1&&(j=-1)}return M===-1||b===-1||j===0||j===1&&M===b-1&&M===I+1?"":h.slice(M,b)},format:$.bind(null,"\\"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.length;let I=0,b=h.charCodeAt(0);if(M===1)return r(b)?(F.root=F.dir=h,F):(F.base=F.name=h,F);if(r(b)){if(I=1,r(h.charCodeAt(1))){let X=2,ie=X;for(;X<M&&!r(h.charCodeAt(X));)X++;if(X<M&&X!==ie){for(ie=X;X<M&&r(h.charCodeAt(X));)X++;if(X<M&&X!==ie){for(ie=X;X<M&&!r(h.charCodeAt(X));)X++;X===M?I=X:X!==ie&&(I=X+1)}}}}else if(i(b)&&h.charCodeAt(1)===c){if(M<=2)return F.root=F.dir=h,F;if(I=2,r(h.charCodeAt(2))){if(M===3)return F.root=F.dir=h,F;I=3}}I>0&&(F.root=h.slice(0,I));let D=-1,j=I,H=-1,B=!0,E=h.length-1,z=0;for(;E>=I;--E){if(b=h.charCodeAt(E),r(b)){if(!B){j=E+1;break}continue}H===-1&&(B=!1,H=E+1),b===w?D===-1?D=E:z!==1&&(z=1):D!==-1&&(z=-1)}return H!==-1&&(D===-1||z===0||z===1&&D===H-1&&D===j+1?F.base=F.name=h.slice(j,H):(F.name=h.slice(j,D),F.base=h.slice(j,H),F.ext=h.slice(D,H))),j>0&&j!==I?F.dir=h.slice(0,j-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(l){const h=/\\/g;return()=>{const F=y.cwd().replace(h,"/");return F.slice(F.indexOf("/"))}}return()=>y.cwd()})();t.$6d={resolve(...h){let F="",M=!1;for(let I=h.length-1;I>=-1&&!M;I--){const b=I>=0?h[I]:f();e(b,"path"),b.length!==0&&(F=`${b}/${F}`,M=b.charCodeAt(0)===o)}return F=d(F,!M,"/",m),M?`/${F}`:F.length>0?F:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===o,M=h.charCodeAt(h.length-1)===o;return h=d(h,!F,"/",m),h.length===0?F?"/":M?"./":".":(M&&(h+="/"),F?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===o},join(...h){if(h.length===0)return".";let F;for(let M=0;M<h.length;++M){const I=h[M];e(I,"path"),I.length>0&&(F===void 0?F=I:F+=`/${I}`)}return F===void 0?".":t.$6d.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F||(h=t.$6d.resolve(h),F=t.$6d.resolve(F),h===F))return"";const M=1,I=h.length,b=I-M,D=1,j=F.length-D,H=b<j?b:j;let B=-1,E=0;for(;E<H;E++){const X=h.charCodeAt(M+E);if(X!==F.charCodeAt(D+E))break;X===o&&(B=E)}if(E===H)if(j>H){if(F.charCodeAt(D+E)===o)return F.slice(D+E+1);if(E===0)return F.slice(D+E)}else b>H&&(h.charCodeAt(M+E)===o?B=E:E===0&&(B=0));let z="";for(E=M+B+1;E<=I;++E)(E===I||h.charCodeAt(E)===o)&&(z+=z.length===0?"..":"/..");return`${z}${F.slice(D+B)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===o;let M=-1,I=!0;for(let b=h.length-1;b>=1;--b)if(h.charCodeAt(b)===o){if(!I){M=b;break}}else I=!1;return M===-1?F?"/":".":F&&M===1?"//":h.slice(0,M)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,I=-1,b=!0,D;if(F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let j=F.length-1,H=-1;for(D=h.length-1;D>=0;--D){const B=h.charCodeAt(D);if(B===o){if(!b){M=D+1;break}}else H===-1&&(b=!1,H=D+1),j>=0&&(B===F.charCodeAt(j)?--j===-1&&(I=D):(j=-1,I=H))}return M===I?I=H:I===-1&&(I=h.length),h.slice(M,I)}for(D=h.length-1;D>=0;--D)if(h.charCodeAt(D)===o){if(!b){M=D+1;break}}else I===-1&&(b=!1,I=D+1);return I===-1?"":h.slice(M,I)},extname(h){e(h,"path");let F=-1,M=0,I=-1,b=!0,D=0;for(let j=h.length-1;j>=0;--j){const H=h.charCodeAt(j);if(H===o){if(!b){M=j+1;break}continue}I===-1&&(b=!1,I=j+1),H===w?F===-1?F=j:D!==1&&(D=1):F!==-1&&(D=-1)}return F===-1||I===-1||D===0||D===1&&F===I-1&&F===M+1?"":h.slice(F,I)},format:$.bind(null,"/"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.charCodeAt(0)===o;let I;M?(F.root="/",I=1):I=0;let b=-1,D=0,j=-1,H=!0,B=h.length-1,E=0;for(;B>=I;--B){const z=h.charCodeAt(B);if(z===o){if(!H){D=B+1;break}continue}j===-1&&(H=!1,j=B+1),z===w?b===-1?b=B:E!==1&&(E=1):b!==-1&&(E=-1)}if(j!==-1){const z=D===0&&M?1:D;b===-1||E===0||E===1&&b===j-1&&b===D+1?F.base=F.name=h.slice(z,j):(F.name=h.slice(z,b),F.base=h.slice(z,j),F.ext=h.slice(b,j))}return D>0?F.dir=h.slice(0,D-1):M&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$6d.win32=t.$5d.win32=t.$5d,t.$6d.posix=t.$5d.posix=t.$6d,t.$7d=l?t.$5d.normalize:t.$6d.normalize,t.$8d=l?t.$5d.isAbsolute:t.$6d.isAbsolute,t.$9d=l?t.$5d.join:t.$6d.join,t.$0d=l?t.$5d.resolve:t.$6d.resolve,t.$$d=l?t.$5d.relative:t.$6d.relative,t.$_d=l?t.$5d.dirname:t.$6d.dirname,t.$ae=l?t.$5d.basename:t.$6d.basename,t.$be=l?t.$5d.extname:t.$6d.extname,t.$ce=l?t.$5d.format:t.$6d.format,t.$de=l?t.$5d.parse:t.$6d.parse,t.$ee=l?t.$5d.toNamespacedPath:t.$6d.toNamespacedPath,t.sep=l?t.$5d.sep:t.$6d.sep,t.$ge=l?t.$5d.delimiter:t.$6d.delimiter}),define(be[113],$e([1,0,22,5,12,7]),function(le,t,y,N,n,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=void 0;function v(D){return D===47||D===92}t.$Bf=v;function w(D){return D.replace(/[\\/]/g,y.$6d.sep)}t.$Cf=w;function o(D){return D.indexOf("/")===-1&&(D=w(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}t.$Df=o;function u(D,j=y.$6d.sep){if(!D)return"";const H=D.length,B=D.charCodeAt(0);if(v(B)){if(v(D.charCodeAt(1))&&!v(D.charCodeAt(2))){let z=3;const X=z;for(;z<H&&!v(D.charCodeAt(z));z++);if(X!==z&&!v(D.charCodeAt(z+1))){for(z+=1;z<H;z++)if(v(D.charCodeAt(z)))return D.slice(0,z+1).replace(/[\\/]/g,j)}}return j}else if(m(B)&&D.charCodeAt(1)===58)return v(D.charCodeAt(2))?D.slice(0,2)+j:D.slice(0,2);let E=D.indexOf("://");if(E!==-1){for(E+=3;E<H;E++)if(v(D.charCodeAt(E)))return D.slice(0,E+1)}return""}t.$Ef=u;function c(D){if(!N.$i||!D||D.length<5)return!1;let j=D.charCodeAt(0);if(j!==92||(j=D.charCodeAt(1),j!==92))return!1;let H=2;const B=H;for(;H<D.length&&(j=D.charCodeAt(H),j!==92);H++);return!(B===H||(j=D.charCodeAt(H+1),isNaN(j)||j===92))}t.$Ff=c;const L=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(D,j=N.$i){const H=j?L:s;return!(!D||D.length===0||/^\s+$/.test(D)||(H.lastIndex=0,H.test(D))||j&&a.test(D)||D==="."||D===".."||j&&D[D.length-1]==="."||j&&D.length!==D.trim().length||D.length>255)}t.$Gf=e;function l(D,j,H){const B=D===j;return!H||B?B:!D||!j?!1:(0,n.$Me)(D,j)}t.$Hf=l;function r(D,j,H,B=y.sep){if(D===j)return!0;if(!D||!j||j.length>D.length)return!1;if(H){if(!(0,n.$Ne)(D,j))return!1;if(j.length===D.length)return!0;let z=j.length;return j.charAt(j.length-1)===B&&z--,D.charAt(z)===B}return j.charAt(j.length-1)!==B&&(j+=B),D.indexOf(j)===0}t.$If=r;function m(D){return D>=65&&D<=90||D>=97&&D<=122}t.$Jf=m;function i(D,j){return N.$i&&D.endsWith(":")&&(D+=y.sep),(0,y.$8d)(D)||(D=(0,y.$9d)(j,D)),D=(0,y.$7d)(D),N.$i?(D=(0,n.$ve)(D,y.sep),D.endsWith(":")&&(D+=y.sep)):(D=(0,n.$ve)(D,y.sep),D||(D=y.sep)),D}t.$Kf=i;function d(D){const j=(0,y.$7d)(D);return N.$i?D.length>3?!1:$(j)&&(D.length===2||j.charCodeAt(2)===92):j===y.$6d.sep}t.$Lf=d;function $(D,j=N.$i){return j?m(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}t.$Mf=$;function f(D,j=N.$i){return $(D,j)?D[0]:void 0}t.$Nf=f;function h(D,j,H){return j.length>D.length?-1:D===j?0:(H&&(D=D.toLowerCase(),j=j.toLowerCase()),D.indexOf(j))}t.$Of=h;function F(D){const j=D.split(":");let H,B,E;for(const z of j){const X=Number(z);(0,W.$nf)(X)?B===void 0?B=X:E===void 0&&(E=X):H=H?[H,z].join(":"):z}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:B!==void 0?B:void 0,column:E!==void 0?E:B!==void 0?1:void 0}}t.$Pf=F;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(D,j,H=8){let B="";for(let z=0;z<H;z++){let X;z===0&&N.$i&&!j&&(H===3||H===4)?X=I:X=M,B+=X.charAt(Math.floor(Math.random()*X.length))}let E;return j?E=`${j}-${B}`:E=B,D?(0,y.$9d)(D,E):E}t.$Qf=b}),define(be[114],$e([1,0,22]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lr=t.$Kr=t.$Jr=t.$Ir=t.$Hr=void 0,t.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(c){const L=(0,y.$be)(c),s=N[L.toLowerCase()];return s!==void 0?s:v(c)}t.$Ir=W;function v(c){const L=(0,y.$be)(c);return n[L.toLowerCase()]}t.$Jr=v;function w(c){for(const L in n)if(n[L]===c)return L}t.$Kr=w;const o=/^(.+)\/(.+?)(;.+)?$/;function u(c,L){const s=o.exec(c);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:L?void 0:c}t.$Lr=u}),define(be[15],$e([1,0,22,5]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,W=/^\//,v=/^\/\//;function w(I,b){if(!I.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${I.authority}", path: "${I.path}", query: "${I.query}", fragment: "${I.fragment}"}`);if(I.scheme&&!n.test(I.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(I.path){if(I.authority){if(!W.test(I.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(I.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(I,b){return!I&&!b?"file":I}function u(I,b){switch(I){case"https":case"http":case"file":b?b[0]!==L&&(b=L+b):b=L;break}return b}const c="",L="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(b){return b instanceof a?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,D,j,H,B,E=!1){typeof b=="object"?(this.scheme=b.scheme||c,this.authority=b.authority||c,this.path=b.path||c,this.query=b.query||c,this.fragment=b.fragment||c):(this.scheme=o(b,E),this.authority=D||c,this.path=u(this.scheme,j||c),this.query=H||c,this.fragment=B||c,w(this,E))}get fsPath(){return $(this,!1)}with(b){if(!b)return this;let{scheme:D,authority:j,path:H,query:B,fragment:E}=b;return D===void 0?D=this.scheme:D===null&&(D=c),j===void 0?j=this.authority:j===null&&(j=c),H===void 0?H=this.path:H===null&&(H=c),B===void 0?B=this.query:B===null&&(B=c),E===void 0?E=this.fragment:E===null&&(E=c),D===this.scheme&&j===this.authority&&H===this.path&&B===this.query&&E===this.fragment?this:new r(D,j,H,B,E)}static parse(b,D=!1){const j=s.exec(b);return j?new r(j[2]||c,M(j[4]||c),M(j[5]||c),M(j[7]||c),M(j[9]||c),D):new r(c,c,c,c,c)}static file(b){let D=c;if(N.$i&&(b=b.replace(/\\/g,L)),b[0]===L&&b[1]===L){const j=b.indexOf(L,2);j===-1?(D=b.substring(2),b=L):(D=b.substring(2,j),b=b.substring(j)||L)}return new r("file",D,b,c,c)}static from(b,D){return new r(b.scheme,b.authority,b.path,b.query,b.fragment,D)}static joinPath(b,...D){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return N.$i&&b.scheme==="file"?j=a.file(y.$5d.join($(b,!0),...D)).path:j=y.$6d.join(b.path,...D),b.with({path:j})}toString(b=!1){return f(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof a)return b;{const D=new r(b);return D._formatted=b.external??null,D._fsPath=b._sep===l?b.fsPath??null:null,D}}else return b}}t.URI=a;function e(I){return!I||typeof I!="object"?!1:typeof I.scheme=="string"&&(typeof I.authority=="string"||typeof I.authority>"u")&&(typeof I.path=="string"||typeof I.path>"u")&&(typeof I.query=="string"||typeof I.query>"u")&&(typeof I.fragment=="string"||typeof I.fragment>"u")}t.$Sf=e;const l=N.$i?1:void 0;class r extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(b=!1){return b?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=l),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(I,b,D){let j,H=-1;for(let B=0;B<I.length;B++){const E=I.charCodeAt(B);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||b&&E===47||D&&E===91||D&&E===93||D&&E===58)H!==-1&&(j+=encodeURIComponent(I.substring(H,B)),H=-1),j!==void 0&&(j+=I.charAt(B));else{j===void 0&&(j=I.substr(0,B));const z=m[E];z!==void 0?(H!==-1&&(j+=encodeURIComponent(I.substring(H,B)),H=-1),j+=z):H===-1&&(H=B)}}return H!==-1&&(j+=encodeURIComponent(I.substring(H))),j!==void 0?j:I}function d(I){let b;for(let D=0;D<I.length;D++){const j=I.charCodeAt(D);j===35||j===63?(b===void 0&&(b=I.substr(0,D)),b+=m[j]):b!==void 0&&(b+=I[D])}return b!==void 0?b:I}function $(I,b){let D;return I.authority&&I.path.length>1&&I.scheme==="file"?D=`//${I.authority}${I.path}`:I.path.charCodeAt(0)===47&&(I.path.charCodeAt(1)>=65&&I.path.charCodeAt(1)<=90||I.path.charCodeAt(1)>=97&&I.path.charCodeAt(1)<=122)&&I.path.charCodeAt(2)===58?b?D=I.path.substr(1):D=I.path[1].toLowerCase()+I.path.substr(2):D=I.path,N.$i&&(D=D.replace(/\//g,"\\")),D}t.$Tf=$;function f(I,b){const D=b?d:i;let j="",{scheme:H,authority:B,path:E,query:z,fragment:X}=I;if(H&&(j+=H,j+=":"),(B||H==="file")&&(j+=L,j+=L),B){let ie=B.indexOf("@");if(ie!==-1){const ue=B.substr(0,ie);B=B.substr(ie+1),ie=ue.lastIndexOf(":"),ie===-1?j+=D(ue,!1,!1):(j+=D(ue.substr(0,ie),!1,!1),j+=":",j+=D(ue.substr(ie+1),!1,!0)),j+="@"}B=B.toLowerCase(),ie=B.lastIndexOf(":"),ie===-1?j+=D(B,!1,!0):(j+=D(B.substr(0,ie),!1,!0),j+=B.substr(ie))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const ie=E.charCodeAt(1);ie>=65&&ie<=90&&(E=`/${String.fromCharCode(ie+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const ie=E.charCodeAt(0);ie>=65&&ie<=90&&(E=`${String.fromCharCode(ie+32)}:${E.substr(2)}`)}j+=D(E,!0,!1)}return z&&(j+="?",j+=D(z,!1,!1)),X&&(j+="#",j+=b?X:i(X,!1,!1)),j}function h(I){try{return decodeURIComponent(I)}catch{return I.length>3?I.substr(0,3)+h(I.substr(3)):I}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function M(I){return I.match(F)?I.replace(F,b=>h(b)):I}}),define(be[51],$e([1,0,31,15]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$g=t.$0g=t.$9g=void 0;function n(o){return JSON.stringify(o,v)}t.$9g=n;function W(o){let u=JSON.parse(o);return u=w(u),u}t.$0g=W;function v(o,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function w(o,u=0){if(!o||u>200)return o;if(typeof o=="object"){switch(o.$mid){case 1:return N.URI.revive(o);case 2:return new RegExp(o.source,o.flags);case 17:return new Date(o.source)}if(o instanceof y.$Fd||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let c=0;c<o.length;++c)o[c]=w(o[c],u+1);else for(const c in o)Object.hasOwnProperty.call(o,c)&&(o[c]=w(o[c],u+1))}return o}t.$$g=w}),define(be[28],$e([1,0,6,5,15]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.Schemas=void 0;var W;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(W||(t.Schemas=W={})),t.$Uf="vscode-tkn",t.$Vf="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${W.vscodeRemoteResource}`}set(c,L,s){this.a[c]=L,this.b[c]=s}setConnectionToken(c,L){this.c[c]=L}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(r){return y.$Y(r),c}const L=c.authority;let s=this.a[L];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[L],e=this.c[L];let l=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(l+=`&${t.$Vf}=${encodeURIComponent(e)}`),n.URI.from({scheme:N.$o?this.d:W.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:l})}}t.$Wf=new v,t.$Xf="vs/../../extensions",t.$Yf="vs/../../node_modules",t.$Zf="vs/../../node_modules.asar",t.$1f="vs/../../node_modules.asar.unpacked";class w{static{this.a="vscode-app"}asBrowserUri(c){const L=this.b(c,le);return this.uriToBrowserUri(L)}uriToBrowserUri(c){return c.scheme===W.vscodeRemote?t.$Wf.rewrite(c):c.scheme===W.file&&(N.$m||N.$p&&N.$g.origin===`${W.vscodeFileResource}://${w.a}`)?c.with({scheme:W.vscodeFileResource,authority:c.authority||w.a,query:null,fragment:null}):c}asFileUri(c){const L=this.b(c,le);return this.uriToFileUri(L)}uriToFileUri(c){return c.scheme===W.vscodeFileResource?c.with({scheme:W.file,authority:c.authority!==w.a?c.authority:null,query:null,fragment:null}):c}b(c,L){return n.URI.isUri(c)?c:n.URI.parse(L.toUrl(c))}}t.$2f=new w;var o;(function(u){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(c.get("3"));const L="vscode-coi";function s(e){let l;typeof e=="string"?l=new URL(e).searchParams:e instanceof URL?l=e.searchParams:n.URI.isUri(e)&&(l=new URL(e.toString(!0)).searchParams);const r=l?.get(L);if(r)return c.get(r)}u.getHeadersFromQuery=s;function a(e,l,r){if(!globalThis.crossOriginIsolated)return;const m=l&&r?"3":r?"2":"1";e instanceof URLSearchParams?e.set(L,m):e[L]=m}u.addSearchParam=a})(o||(t.COI=o={}))}),define(be[35],$e([1,0,113,28,22,5,12,15]),function(le,t,y,N,n,W,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sg=t.DataUri=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=void 0;function o(a){return(0,w.$Tf)(a,!0)}t.$9f=o;class u{constructor(e){this.a=e}compare(e,l,r=!1){return e===l?0:(0,v.$Fe)(this.getComparisonKey(e,r),this.getComparisonKey(l,r))}isEqual(e,l,r=!1){return e===l?!0:!e||!l?!1:this.getComparisonKey(e,r)===this.getComparisonKey(l,r)}getComparisonKey(e,l=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,l,r=!1){if(e.scheme===l.scheme){if(e.scheme===N.Schemas.file)return y.$If(o(e),o(l),this.a(e))&&e.query===l.query&&(r||e.fragment===l.fragment);if((0,t.$ng)(e.authority,l.authority))return y.$If(e.path,l.path,this.a(e),"/")&&e.query===l.query&&(r||e.fragment===l.fragment)}return!1}joinPath(e,...l){return w.URI.joinPath(e,...l)}basenameOrAuthority(e){return(0,t.$fg)(e)||e.authority}basename(e){return n.$6d.basename(e.path)}extname(e){return n.$6d.extname(e.path)}dirname(e){if(e.path.length===0)return e;let l;return e.scheme===N.Schemas.file?l=w.URI.file(n.$_d(o(e))).path:(l=n.$6d.dirname(e.path),e.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),l="/")),e.with({path:l})}normalizePath(e){if(!e.path.length)return e;let l;return e.scheme===N.Schemas.file?l=w.URI.file(n.$7d(o(e))).path:l=n.$6d.normalize(e.path),e.with({path:l})}relativePath(e,l){if(e.scheme!==l.scheme||!(0,t.$ng)(e.authority,l.authority))return;if(e.scheme===N.Schemas.file){const i=n.$$d(o(e),o(l));return W.$i?y.$Cf(i):i}let r=e.path||"/";const m=l.path||"/";if(this.a(e)){let i=0;for(const d=Math.min(r.length,m.length);i<d&&!(r.charCodeAt(i)!==m.charCodeAt(i)&&r.charAt(i).toLowerCase()!==m.charAt(i).toLowerCase());i++);r=m.substr(0,i)+r.substr(i)}return n.$6d.relative(r,m)}resolvePath(e,l){if(e.scheme===N.Schemas.file){const r=w.URI.file(n.$0d(o(e),l));return e.with({authority:r.authority,path:r.path})}return l=y.$Df(l),e.with({path:n.$6d.resolve(e.path,l)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,l){return e===l||e!==void 0&&l!==void 0&&(0,v.$Me)(e,l)}hasTrailingPathSeparator(e,l=n.sep){if(e.scheme===N.Schemas.file){const r=o(e);return r.length>y.$Ef(r).length&&r[r.length-1]===l}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,l=n.sep){return(0,t.$og)(e,l)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,l=n.sep){let r=!1;if(e.scheme===N.Schemas.file){const m=o(e);r=m!==void 0&&m.length===y.$Ef(m).length&&m[m.length-1]===l}else{l="/";const m=e.path;r=m.length===1&&m.charCodeAt(m.length-1)===47}return!r&&!(0,t.$og)(e,l)?e.with({path:e.path+"/"}):e}}t.$0f=u,t.$$f=new u(()=>!1),t.$_f=new u(a=>a.scheme===N.Schemas.file?!W.$k:!0),t.$ag=new u(a=>!0),t.$bg=t.$$f.isEqual.bind(t.$$f),t.$cg=t.$$f.isEqualOrParent.bind(t.$$f),t.$dg=t.$$f.getComparisonKey.bind(t.$$f),t.$eg=t.$$f.basenameOrAuthority.bind(t.$$f),t.$fg=t.$$f.basename.bind(t.$$f),t.$gg=t.$$f.extname.bind(t.$$f),t.$hg=t.$$f.dirname.bind(t.$$f),t.$ig=t.$$f.joinPath.bind(t.$$f),t.$jg=t.$$f.normalizePath.bind(t.$$f),t.$kg=t.$$f.relativePath.bind(t.$$f),t.$lg=t.$$f.resolvePath.bind(t.$$f),t.$mg=t.$$f.isAbsolutePath.bind(t.$$f),t.$ng=t.$$f.isEqualAuthority.bind(t.$$f),t.$og=t.$$f.hasTrailingPathSeparator.bind(t.$$f),t.$pg=t.$$f.removeTrailingPathSeparator.bind(t.$$f),t.$qg=t.$$f.addTrailingPathSeparator.bind(t.$$f);function c(a,e){const l=[];for(let r=0;r<a.length;r++){const m=e(a[r]);a.some((i,d)=>d===r?!1:(0,t.$cg)(m,e(i)))||l.push(a[r])}return l}t.$rg=c;var L;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(l){const r=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(d=>{const[$,f]=d.split(":");$&&f&&r.set($,f)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&r.set(a.META_DATA_MIME,i),r}a.parseMetaData=e})(L||(t.DataUri=L={}));function s(a,e,l){if(e){let r=a.path;return r&&r[0]!==n.$6d.sep&&(r=n.$6d.sep+r),a.with({scheme:l,authority:e,path:r})}return a.with({scheme:l})}t.$sg=s}),define(be[9],$e([1,0,27,6,3,2,35,5,48]),function(le,t,y,N,n,W,v,w,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5g=t.$4g=t.$3g=t.Promises=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=void 0;function u(g){return!!g&&typeof g.then=="function"}t.$tg=u;function c(g){const p=new y.$pd,q=g(p.token),T=new Promise((O,P)=>{const _=p.token.onCancellationRequested(()=>{_.dispose(),p.dispose(),P(new N.$3)});Promise.resolve(q).then(C=>{_.dispose(),p.dispose(),O(C)},C=>{_.dispose(),p.dispose(),P(C)})});return new class{cancel(){p.cancel()}then(O,P){return T.then(O,P)}catch(O){return this.then(void 0,O)}finally(O){return T.finally(O)}}}t.$ug=c;function L(g,p,q){return new Promise((T,O)=>{const P=p.onCancellationRequested(()=>{P.dispose(),T(q)});g.then(T,O).finally(()=>P.dispose())})}t.$vg=L;function s(g,p){return new Promise((q,T)=>{const O=p.onCancellationRequested(()=>{O.dispose(),T(new N.$3)});g.then(q,T).finally(()=>O.dispose())})}t.$wg=s;async function a(g){let p=-1;const q=g.map((T,O)=>T.then(P=>(p=O,P)));try{return await Promise.race(q)}finally{g.forEach((T,O)=>{O!==p&&T.cancel()})}}t.$xg=a;function e(g,p,q){let T;const O=setTimeout(()=>{T?.(void 0),q?.()},p);return Promise.race([g.finally(()=>clearTimeout(O)),new Promise(P=>T=P)])}t.$yg=e;function l(g){return new Promise((p,q)=>{const T=g();u(T)?T.then(p,q):p(T)})}t.$zg=l;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const q=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(q,q).then(T)})}return new Promise((q,T)=>{this.b.then(q,T)})}return this.a=p(),new Promise((q,T)=>{this.a.then(O=>{this.a=null,q(O)},O=>{this.a=null,T(O)})})}dispose(){this.f=!0}}t.$Ag=r;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Bg=m;class i{constructor(){this.a=new Map}queue(p,q){const O=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(p)===O&&this.a.delete(p)});return this.a.set(p,O),O}}t.$Cg=i;const d=(g,p)=>{let q=!0;const T=setTimeout(()=>{q=!1,p()},g);return{isTriggered:()=>q,dispose:()=>{clearTimeout(T),q=!1}}},$=g=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,g())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class f{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,q=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((O,P)=>{this.d=O,this.f=P}).then(()=>{if(this.b=null,this.d=null,this.g){const O=this.g;return this.g=null,O()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=q===o.$cd?$(T):d(q,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Dg=f;class h{constructor(p){this.a=new f(p),this.b=new r}trigger(p,q){return this.a.trigger(()=>this.b.queue(p),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Eg=h;class F{constructor(){this.a=!1,this.b=new Promise((p,q)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Fg=F;class M extends F{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Gg=M;function I(g,p){return p?new Promise((q,T)=>{const O=setTimeout(()=>{P.dispose(),q()},g),P=p.onCancellationRequested(()=>{clearTimeout(O),P.dispose(),T(new N.$3)})}):c(q=>I(g,q))}t.$Hg=I;function b(g,p=0,q){const T=setTimeout(()=>{g(),q&&O.dispose()},p),O=(0,W.$ic)(()=>{clearTimeout(T),q?.deleteAndLeak(O)});return q?.add(O),O}t.$Ig=b;function D(g){const p=[];let q=0;const T=g.length;function O(){return q<T?g[q++]():null}function P(_){_!=null&&p.push(_);const C=O();return C?C.then(P):Promise.resolve(p)}return Promise.resolve(null).then(P)}t.$Jg=D;function j(g,p=T=>!!T,q=null){let T=0;const O=g.length,P=()=>{if(T>=O)return Promise.resolve(q);const _=g[T++];return Promise.resolve(_()).then(R=>p(R)?Promise.resolve(R):P())};return P()}t.$Kg=j;function H(g,p=T=>!!T,q=null){if(g.length===0)return Promise.resolve(q);let T=g.length;const O=()=>{T=-1;for(const P of g)P.cancel?.()};return new Promise((P,_)=>{for(const C of g)C.then(R=>{--T>=0&&p(R)?(O(),P(R)):T===0&&P(q)}).catch(R=>{--T>=0&&(O(),_(R))})})}t.$Lg=H;class B{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new n.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((q,T)=>{this.f.push({factory:p,c:q,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const q=p.factory();q.then(p.c,p.e),q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Mg=B;class E extends B{constructor(){super(1)}}t.$Ng=E;class z{constructor(){this.a=new Me,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$Og=z;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Q;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,q=v.$$f){const T=q.getComparisonKey(p);let O=this.a.get(T);if(!O){O=new E;const P=this.f++,_=n.Event.once(O.onDrained)(()=>{O?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(P),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$sc),this.d.set(P,_),this.a.set(T,O)}return O}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Pg=X;class ie{constructor(p,q){this.a=-1,typeof p=="function"&&typeof q=="number"&&this.setIfNotSet(p,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},q)}setIfNotSet(p,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},q))}}t.$Qg=ie;class ue{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,q){this.cancel(),this.a=setInterval(()=>{p()},q)}}t.$Rg=ue;class ae{constructor(p,q){this.b=-1,this.a=p,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Sg=ae;class oe{constructor(p,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=p,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Tg=oe;class re extends ae{constructor(p,q){super(p,q),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$Ug=re;class ge extends W.$kc{constructor(p,q){super(),this.g=p,this.h=q,this.a=[],this.b=this.B(new W.$lc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of p)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Vg=ge,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$Wg=g=>{(0,w.$A)(()=>{if(p)return;const q=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$Wg=(g,p)=>{const q=requestIdleCallback(g,typeof p=="number"?{timeout:p}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(q))}}}}();class Ce{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(q){this.g=q}finally{this.d=!0}},this.b=(0,t.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$Xg=Ce;async function Fe(g,p,q){let T;for(let O=0;O<q;O++)try{return await g()}catch(P){T=P,await I(p)}throw T}t.$Yg=Fe;class Me{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,q,T){return this.a={taskId:p,cancel:()=>T?.(),promise:q},q.then(()=>this.d(p),()=>this.d(p)),q}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let q,T;const O=new Promise((P,_)=>{q=P,T=_});this.b={run:p,promise:O,promiseResolve:q,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Zg=Me;class fe{constructor(p,q=()=>Date.now()){this.d=p,this.f=q,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$1g=fe;var ne;(function(g){g[g.Resolved=0]="Resolved",g[g.Rejected=1]="Rejected"})(ne||(ne={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,q)=>{this.a=p,this.b=q})}complete(p){return new Promise(q=>{this.a(p),this.d={outcome:0,value:p},q()})}error(p){return new Promise(q=>{this.b(p),this.d={outcome:1,value:p},q()})}cancel(){return this.error(new N.$3)}}t.$2g=Q;var V;(function(g){async function p(T){let O;const P=await Promise.all(T.map(_=>_.then(C=>C,C=>{O||(O=C)})));if(typeof O<"u")throw O;return P}g.settled=p;function q(T){return new Promise(async(O,P)=>{try{await T(O,P)}catch(_){P(_)}})}g.withAsyncBody=q})(V||(t.Promises=V={}));var ee;(function(g){g[g.Initial=0]="Initial",g[g.DoneOK=1]="DoneOK",g[g.DoneError=2]="DoneError"})(ee||(ee={}));class J{static fromArray(p){return new J(q=>{q.emitMany(p)})}static fromPromise(p){return new J(async q=>{q.emitMany(await p)})}static fromPromises(p){return new J(async q=>{await Promise.all(p.map(async T=>q.emitOne(await T)))})}static merge(p){return new J(async q=>{await Promise.all(p.map(async T=>{for await(const O of T)q.emitOne(O)}))})}static{this.EMPTY=J.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new n.$fd,queueMicrotask(async()=>{const q={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(p(q)),this.j()}catch(T){this.k(T)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(p,q){return new J(async T=>{for await(const O of p)T.emitOne(q(O))})}map(p){return J.map(this,p)}static filter(p,q){return new J(async T=>{for await(const O of p)q(O)&&T.emitOne(O)})}filter(p){return J.filter(this,p)}static coalesce(p){return J.filter(p,q=>!!q)}coalesce(){return J.coalesce(this)}static async toPromise(p){const q=[];for await(const T of p)q.push(T);return q}toPromise(){return J.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$3g=J;class S extends J{constructor(p,q){super(q),this.l=p}cancel(){this.l.cancel()}}t.$4g=S;function x(g){const p=new y.$pd,q=g(p.token);return new S(p,async T=>{const O=p.token.onCancellationRequested(()=>{O.dispose(),p.dispose(),T.reject(new N.$3)});try{for await(const P of q){if(p.token.isCancellationRequested)return;T.emitOne(P)}O.dispose(),p.dispose()}catch(P){O.dispose(),p.dispose(),T.reject(P)}})}t.$5g=x}),define(be[4],$e([1,0,16,111,14,19,9,6,3,115,2,28,5,15]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.DetectedFullscreenMode=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$=t.Namespace=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.onDidCreateWindow=t.getWindows=t.registerWindow=void 0,e=function(){const Y=[],G=new o.$fd;return{onDidCreateWindow:G.event,registerWindow(de){Y.push(de);const Ae=new c.$jc;return Ae.add((0,c.$ic)(()=>{const Se=Y.indexOf(de);Se!==-1&&Y.splice(Se,1)})),G.fire({window:de,disposableStore:Ae}),Ae},getWindows(){return Y}}}(),t.registerWindow=e.registerWindow,t.getWindows=e.getWindows,t.onDidCreateWindow=e.onDidCreateWindow;function l(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.$qO=l;function r(Y){return Y?.isConnected??!1}t.$rO=r;class m{constructor(G,de,Ae,Se){this.f=G,this.g=de,this.d=Ae,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function i(Y,G,de,Ae){return new m(Y,G,de,Ae)}t.$sO=i;function d(Y){return function(G){return Y(new W.$jO(G))}}function $(Y){return function(G){return Y(new n.$oO(G))}}const f=function(G,de,Ae,Se){let qe=Ae;return de==="click"||de==="mousedown"?qe=d(Ae):(de==="keydown"||de==="keypress"||de==="keyup")&&(qe=$(Ae)),i(G,de,qe,Se)};t.$tO=f;const h=function(G,de,Ae){const Se=d(de);return M(G,Se,Ae)};t.$uO=h;const F=function(G,de,Ae){const Se=d(de);return b(G,Se,Ae)};t.$vO=F;function M(Y,G,de){return i(Y,s.$q&&N.$gO.pointerEvents?t.$8O.POINTER_DOWN:t.$8O.MOUSE_DOWN,G,de)}t.$wO=M;function I(Y,G,de){return i(Y,s.$q&&N.$gO.pointerEvents?t.$8O.POINTER_MOVE:t.$8O.MOUSE_MOVE,G,de)}t.$xO=I;function b(Y,G,de){return i(Y,s.$q&&N.$gO.pointerEvents?t.$8O.POINTER_UP:t.$8O.MOUSE_UP,G,de)}t.$yO=b;class D{constructor(G,de=0){this.d=G,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,w.$Y)(G)}}static sort(G,de){return de.priority-G.priority}}(function(){let Y=[],G=null,de=!1,Ae=!1;const Se=()=>{for(de=!1,G=Y,Y=[],Ae=!0;G.length>0;)G.sort(D.sort),G.shift().execute();Ae=!1};t.$AO=(qe,He=0)=>{const Je=new D(qe,He);return Y.push(Je),de||(de=!0,requestAnimationFrame(Se)),Je},t.$zO=(qe,He)=>{if(Ae){const Je=new D(qe,He);return G.push(Je),Je}else return(0,t.$AO)(qe,He)}})();function j(Y){return(0,t.$AO)(Y,1e4)}t.$BO=j;function H(Y){return(0,t.$AO)(Y,-1e4)}t.$CO=H;const B=8,E=function(Y,G){return G};class z extends c.$kc{constructor(G,de,Ae,Se=E,qe=B){super();let He=null,Je=0;const lt=this.B(new v.$Qg),Ze=()=>{Je=new Date().getTime(),Ae(He),He=null};this.B(i(G,de,vt=>{He=Se(He,vt);const Ct=new Date().getTime()-Je;Ct>=qe?(lt.cancel(),Ze()):lt.setIfNotSet(Ze,qe-Ct)}))}}function X(Y,G,de,Ae,Se){return new z(Y,G,de,Ae,Se)}t.$DO=X;function ie(Y){return Y.ownerDocument.defaultView.getComputedStyle(Y,null)}t.$EO=ie;function ue(Y){const G=Y.ownerDocument,de=G.defaultView?.window;if(Y!==G.body)return new oe(Y.clientWidth,Y.clientHeight);if(s.$q&&de?.visualViewport)return new oe(de.visualViewport.width,de.visualViewport.height);if(de?.innerWidth&&de.innerHeight)return new oe(de.innerWidth,de.innerHeight);if(G.body&&G.body.clientWidth&&G.body.clientHeight)return new oe(G.body.clientWidth,G.body.clientHeight);if(G.documentElement&&G.documentElement.clientWidth&&G.documentElement.clientHeight)return new oe(G.documentElement.clientWidth,G.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$FO=ue;class ae{static d(G,de){return parseFloat(de)||0}static f(G,de,Ae){const Se=ie(G),qe=Se?Se.getPropertyValue(de):"0";return ae.d(G,qe)}static getBorderLeftWidth(G){return ae.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ae.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ae.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ae.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ae.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ae.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return ae.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ae.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ae.f(G,"margin-left","marginLeft")}static getMarginTop(G){return ae.f(G,"margin-top","marginTop")}static getMarginRight(G){return ae.f(G,"margin-right","marginRight")}static getMarginBottom(G){return ae.f(G,"margin-bottom","marginBottom")}}class oe{static{this.None=new oe(0,0)}constructor(G,de){this.width=G,this.height=de}with(G=this.width,de=this.height){return G!==this.width||de!==this.height?new oe(G,de):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof oe?G:new oe(G.width,G.height)}static equals(G,de){return G===de?!0:!G||!de?!1:G.width===de.width&&G.height===de.height}}t.$GO=oe;function re(Y){let G=Y.offsetParent,de=Y.offsetTop,Ae=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==Y.ownerDocument.body&&Y!==Y.ownerDocument.documentElement;){de-=Y.scrollTop;const Se=_(Y)?null:ie(Y);Se&&(Ae-=Se.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ae+=ae.getBorderLeftWidth(Y),de+=ae.getBorderTopWidth(Y),de+=Y.offsetTop,Ae+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ae,top:de}}t.$HO=re;function ge(Y,G,de){typeof G=="number"&&(Y.style.width=`${G}px`),typeof de=="number"&&(Y.style.height=`${de}px`)}t.$IO=ge;function Ce(Y,G,de,Ae,Se,qe="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof de=="number"&&(Y.style.right=`${de}px`),typeof Ae=="number"&&(Y.style.bottom=`${Ae}px`),typeof Se=="number"&&(Y.style.left=`${Se}px`),Y.style.position=qe}t.$JO=Ce;function Fe(Y){const G=Y.getBoundingClientRect();return{left:G.left+(Y.ownerDocument.defaultView?.scrollX??0),top:G.top+(Y.ownerDocument.defaultView?.scrollY??0),width:G.width,height:G.height}}t.$KO=Fe;function Me(Y){let G=Y,de=1;do{const Ae=ie(G).zoom;Ae!=null&&Ae!=="1"&&(de*=Ae),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return de}t.$LO=Me;function fe(Y){const G=ae.getMarginLeft(Y)+ae.getMarginRight(Y);return Y.offsetWidth+G}t.$MO=fe;function ne(Y){const G=ae.getBorderLeftWidth(Y)+ae.getBorderRightWidth(Y),de=ae.getPaddingLeft(Y)+ae.getPaddingRight(Y);return Y.offsetWidth-G-de}t.$NO=ne;function Q(Y){const G=ae.getMarginLeft(Y)+ae.getMarginRight(Y);return Y.scrollWidth+G}t.$OO=Q;function V(Y){const G=ae.getBorderTopWidth(Y)+ae.getBorderBottomWidth(Y),de=ae.getPaddingTop(Y)+ae.getPaddingBottom(Y);return Y.offsetHeight-G-de}t.$PO=V;function ee(Y){const G=ae.getMarginTop(Y)+ae.getMarginBottom(Y);return Y.offsetHeight+G}t.$QO=ee;function J(Y,G){if(Y===null)return 0;const de=re(Y),Ae=re(G);return de.left-Ae.left}function S(Y,G){const de=G.map(Se=>Math.max(Q(Se),fe(Se))+J(Se,Y)||0);return Math.max(...de)}t.$RO=S;function x(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.$SO=x;const g="parentFlowToElementId";function p(Y,G){Y.dataset[g]=G.id}t.$TO=p;function q(Y){const G=Y.dataset[g];return typeof G=="string"?Y.ownerDocument.getElementById(G):null}function T(Y,G){let de=Y;for(;de;){if(de===G)return!0;if(de instanceof HTMLElement){const Ae=q(de);if(Ae){de=Ae;continue}}de=de.parentNode}return!1}t.$UO=T;function O(Y,G,de){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(de){if(typeof de=="string"){if(Y.classList.contains(de))return null}else if(Y===de)return null}Y=Y.parentNode}return null}t.$VO=O;function P(Y,G,de){return!!O(Y,G,de)}t.$WO=P;function _(Y){return Y&&!!Y.host&&!!Y.mode}t.$XO=_;function C(Y){return!!R(Y)}t.$YO=C;function R(Y){for(;Y.parentNode;){if(Y===Y.ownerDocument?.body)return null;Y=Y.parentNode}return _(Y)?Y:null}t.$ZO=R;function A(){let Y=k().activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.$1O=A;function k(){return[document,...(0,t.getWindows)().map(G=>G.document)].find(G=>G.hasFocus())??document}t.$2O=k;function U(Y=document.getElementsByTagName("head")[0],G){const de=document.createElement("style");return de.type="text/css",de.media="screen",G?.(de),Y.appendChild(de),de}t.$3O=U;function K(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.$4O=K;let te=null;function se(){return te||(te=U()),te}function me(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function we(Y,G,de=se()){!de||!G||de.sheet.insertRule(Y+"{"+G+"}",0)}t.$5O=we;function Ne(Y,G=se()){if(!G)return;const de=me(G),Ae=[];for(let Se=0;Se<de.length;Se++)de[Se].selectorText.indexOf(Y)!==-1&&Ae.push(Se);for(let Se=Ae.length-1;Se>=0;Se--)G.sheet.deleteRule(Ae[Se])}t.$6O=Ne;function Ee(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.$7O=Ee,t.$8O={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$$N?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$$N?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$$N?"webkitAnimationIteration":"animationiteration"};function ve(Y){const G=Y;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$9O=ve,t.$0O={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Te(Y){const G=[];for(let de=0;Y&&Y.nodeType===Y.ELEMENT_NODE;de++)G[de]=Y.scrollTop,Y=Y.parentNode;return G}t.$$O=Te;function Pe(Y,G){for(let de=0;Y&&Y.nodeType===Y.ELEMENT_NODE;de++)Y.scrollTop!==G[de]&&(Y.scrollTop=G[de]),Y=Y.parentNode}t.$_O=Pe;class We extends c.$kc{static m(G){if(Ee(G)){const de=R(G),Ae=de?de.activeElement:G.ownerDocument.activeElement;return x(Ae,G)}else return x(window.document.activeElement,window.document)}constructor(G){super(),this.f=this.B(new o.$fd),this.onDidFocus=this.f.event,this.g=this.B(new o.$fd),this.onDidBlur=this.g.event;let de=We.m(G),Ae=!1;const Se=()=>{Ae=!1,de||(de=!0,this.f.fire())},qe=()=>{de&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,de=!1,this.g.fire())},0))};this.j=()=>{We.m(G)!==de&&(de?qe():Se())},this.B(i(G,t.$8O.FOCUS,Se,!0)),this.B(i(G,t.$8O.BLUR,qe,!0)),G instanceof HTMLElement&&(this.B(i(G,t.$8O.FOCUS_IN,()=>this.j())),this.B(i(G,t.$8O.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function je(Y){return new We(Y)}t.$aP=je;function Ie(Y,G){return Y.after(G),G}t.$bP=Ie;function Ke(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.$cP=Ke;function Z(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.$dP=Z;function he(Y,...G){Y.innerText="",Ke(Y,...G)}t.$eP=he;const pe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var De;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(De||(t.Namespace=De={}));function ke(Y,G,de,...Ae){const Se=pe.exec(G);if(!Se)throw new Error("Bad use of emmet");const qe=Se[1]||"div";let He;return Y!==De.HTML?He=document.createElementNS(Y,qe):He=document.createElement(qe),Se[3]&&(He.id=Se[3]),Se[4]&&(He.className=Se[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Je,lt])=>{typeof lt>"u"||(/^on\w+$/.test(Je)?He[Je]=lt:Je==="selected"?lt&&He.setAttribute(Je,"true"):He.setAttribute(Je,lt))}),He.append(...Ae),He}function Re(Y,G,...de){return ke(De.HTML,Y,G,...de)}t.$=Re,Re.SVG=function(Y,G,...de){return ke(De.SVG,Y,G,...de)};function ze(Y,G){const de=[];return Y.forEach((Ae,Se)=>{Se>0&&(G instanceof Node?de.push(G.cloneNode()):de.push(document.createTextNode(G))),de.push(Ae)}),de}t.$gP=ze;function Xe(Y,...G){Y?Ye(...G):Ve(...G)}t.$hP=Xe;function Ye(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.$iP=Ye;function Ve(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.$jP=Ve;function _e(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function et(Y){!Y||!Y.hasAttribute("tabIndex")||(Y.ownerDocument.activeElement===Y&&_e(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.$kP=et;function it(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.$lP=it;function ft(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.$mP=ft;function ct(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.$nP=ct;function ut(Y){window.open(Y,"_blank","noopener")}t.$oP=ut;const $t=780,pt=640;function At(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-$t/2),de=Math.floor(window.screenTop+window.innerHeight/2-pt/2);window.open(Y,"_blank",`width=${$t},height=${pt},top=${de},left=${G}`)}t.$pP=At;function kt(Y,G=!0){const de=window.open();return de?(G&&(de.opener=null),de.location.href=Y,!0):!1}t.$qP=kt;function Mt(Y){const G=()=>{Y(),de=(0,t.$AO)(G)};let de=(0,t.$AO)(G);return(0,c.$ic)(()=>de.dispose())}t.$rP=Mt,L.$Wf.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Le(Y){return Y?`url('${L.$2f.uriToBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$sP=Le;function ce(Y){return`'${Y.replace(/'/g,"%27")}'`}t.$tP=ce;function ye(Y,G){if(Y!==void 0){const de=Y.match(/^\s*var\((.+)\)$/);if(de){const Ae=de[1].split(",",2);return Ae.length===2&&(G=ye(Ae[1].trim(),G)),`var(${Ae[0]}, ${G})`}return Y}return G}t.$uP=ye;function Oe(Y,G){let de;if(a.URI.isUri(Y))de=Y.toString(!0);else{const Se=new Blob([Y]);de=URL.createObjectURL(Se),setTimeout(()=>URL.revokeObjectURL(de))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=G,Ae.href=de,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.$vP=Oe;function Ue(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,o.Event.once(o.Event.fromDOMEventEmitter(G,"input"))(()=>{Y(G.files??void 0)}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.$wP=Ue;var Ge;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(Ge||(t.DetectedFullscreenMode=Ge={}));function nt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:Ge.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:Ge.BROWSER,guess:!1}:(s.$j||s.$k)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:Ge.BROWSER,guess:!0}:null}t.$xP=nt;function xe(Y,G=!1){const de=document.createElement("a");return u.addHook("afterSanitizeAttributes",Ae=>{for(const Se of["href","src"])if(Ae.hasAttribute(Se)){const qe=Ae.getAttribute(Se);if(Se==="href"&&qe.startsWith("#"))continue;if(de.href=qe,!Y.includes(de.protocol.replace(/:$/,""))){if(G&&Se==="src"&&de.href.startsWith("data:"))continue;Ae.removeAttribute(Se)}}}),(0,c.$ic)(()=>{u.removeHook("afterSanitizeAttributes")})}t.$yP=xe;const ot=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$zP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const wt=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function St(Y,G){const de=xe(ot);try{const Ae=u.sanitize(G,wt);Y.innerHTML=Ae}finally{de.dispose()}}t.$AP=St;function Qt(Y){const G=new Uint16Array(Y.length);for(let Se=0;Se<G.length;Se++)G[Se]=Y.charCodeAt(Se);let de="";const Ae=new Uint8Array(G.buffer);for(let Se=0;Se<Ae.length;Se++)de+=String.fromCharCode(Ae[Se]);return de}function pi(Y){return btoa(Qt(Y))}t.$BP=pi;class gt extends o.$fd{constructor(){super(),this.s=new c.$jc,this.B={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(i(window,"keydown",G=>{if(G.defaultPrevented)return;const de=new n.$oO(G);if(!(de.keyCode===6&&G.repeat)){if(G.altKey&&!this.B.altKey)this.B.lastKeyPressed="alt";else if(G.ctrlKey&&!this.B.ctrlKey)this.B.lastKeyPressed="ctrl";else if(G.metaKey&&!this.B.metaKey)this.B.lastKeyPressed="meta";else if(G.shiftKey&&!this.B.shiftKey)this.B.lastKeyPressed="shift";else if(de.keyCode!==6)this.B.lastKeyPressed=void 0;else return;this.B.altKey=G.altKey,this.B.ctrlKey=G.ctrlKey,this.B.metaKey=G.metaKey,this.B.shiftKey=G.shiftKey,this.B.lastKeyPressed&&(this.B.event=G,this.fire(this.B))}},!0)),this.s.add(i(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this.B.altKey?this.B.lastKeyReleased="alt":!G.ctrlKey&&this.B.ctrlKey?this.B.lastKeyReleased="ctrl":!G.metaKey&&this.B.metaKey?this.B.lastKeyReleased="meta":!G.shiftKey&&this.B.shiftKey?this.B.lastKeyReleased="shift":this.B.lastKeyReleased=void 0,this.B.lastKeyPressed!==this.B.lastKeyReleased&&(this.B.lastKeyPressed=void 0),this.B.altKey=G.altKey,this.B.ctrlKey=G.ctrlKey,this.B.metaKey=G.metaKey,this.B.shiftKey=G.shiftKey,this.B.lastKeyReleased&&(this.B.event=G,this.fire(this.B)))},!0)),this.s.add(i(document.body,"mousedown",()=>{this.B.lastKeyPressed=void 0},!0)),this.s.add(i(document.body,"mouseup",()=>{this.B.lastKeyPressed=void 0},!0)),this.s.add(i(document.body,"mousemove",G=>{G.buttons&&(this.B.lastKeyPressed=void 0)},!0)),this.s.add(i(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.B}get isModifierPressed(){return this.B.altKey||this.B.ctrlKey||this.B.metaKey||this.B.shiftKey}resetKeyStatus(){this.D(),this.fire(this.B)}D(){this.B={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return gt.C||(gt.C=new gt),gt.C}dispose(){super.dispose(),this.s.dispose()}}t.$CP=gt;function wi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.$DP=wi;class vi extends c.$kc{constructor(G,de){super(),this.j=G,this.m=de,this.f=0,this.g=0,this.n()}n(){this.B(i(this.j,t.$8O.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter(G)})),this.B(i(this.j,t.$8O.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(i(this.j,t.$8O.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(G))})),this.B(i(this.j,t.$8O.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd(G)})),this.B(i(this.j,t.$8O.DROP,G=>{this.f=0,this.g=0,this.m.onDrop(G)}))}}t.$EP=vi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(Y,...G){let de,Ae;Array.isArray(G[0])?(de={},Ae=G[0]):(de=G[0]||{},Ae=G[1]);const Se=Di.exec(Y);if(!Se||!Se.groups)throw new Error("Bad use of h");const qe=Se.groups.tag||"div",He=document.createElement(qe);Se.groups.id&&(He.id=Se.groups.id);const Je=[];if(Se.groups.class)for(const Ze of Se.groups.class.split("."))Ze!==""&&Je.push(Ze);if(de.className!==void 0)for(const Ze of de.className.split("."))Ze!==""&&Je.push(Ze);Je.length>0&&(He.className=Je.join(" "));const lt={};if(Se.groups.name&&(lt[Se.groups.name]=He),Ae)for(const Ze of Ae)Ze instanceof HTMLElement?He.appendChild(Ze):typeof Ze=="string"?He.append(Ze):"root"in Ze&&(Object.assign(lt,Ze),He.appendChild(Ze.root));for(const[Ze,vt]of Object.entries(de))if(Ze!=="className")if(Ze==="style")for(const[Ct,Rt]of Object.entries(vt))He.style.setProperty(Gt(Ct),typeof Rt=="number"?Rt+"px":""+Rt);else Ze==="tabIndex"?He.tabIndex=vt:He.setAttribute(Gt(Ze),vt.toString());return lt.root=He,lt}t.h=yi;function Gt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(be[52],$e([1,0,4,2,114]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IP=t.$HP=t.$GP=void 0;class W extends N.$kc{constructor(o,u){super(),this.B((0,y.$sO)(o,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{u(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.B((0,y.$sO)(o,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$GP=W,t.$HP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$Hr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function v(w,o,u,c,L){const s=document.createElement("div");s.className=u,s.textContent=o,L&&(s.style.color=L),c&&(s.style.background=c),w.dataTransfer&&(document.body.appendChild(s),w.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>document.body.removeChild(s),0))}t.$IP=v}),define(be[53],$e([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=t.$_P=t.$$P=void 0;function N(s,a={}){const e=W(a);return e.textContent=s,e}t.$$P=N;function n(s,a={}){const e=W(a);return o(e,u(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$_P=n;function W(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$aQ=W;class v{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(w||(w={}));function o(s,a,e,l){let r;if(a.type===2)r=document.createTextNode(a.content||"");else if(a.type===3)r=document.createElement("b");else if(a.type===4)r=document.createElement("i");else if(a.type===7&&l)r=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(y.$tO(m,"click",i=>{e.callback(String(a.index),i)})),r=m}else a.type===8?r=document.createElement("br"):a.type===1&&(r=s);r&&s!==r&&s.appendChild(r),r&&Array.isArray(a.children)&&a.children.forEach(m=>{o(r,m,e,l)})}function u(s,a){const e={type:1,children:[]};let l=0,r=e;const m=[],i=new v(s);for(;!i.eos();){let d=i.next();const $=d==="\\"&&L(i.peek(),a)!==0;if($&&(d=i.next()),!$&&c(d,a)&&d===i.peek()){i.advance(),r.type===2&&(r=m.pop());const f=L(d,a);if(r.type===f||r.type===5&&f===6)r=m.pop();else{const h={type:f,children:[]};f===5&&(h.index=l,l++),r.children.push(h),m.push(r),r=h}}else if(d===`
`)r.type===2&&(r=m.pop()),r.children.push({type:8});else if(r.type!==2){const f={type:2,content:d};r.children.push(f),m.push(r),r=f}else r.content+=d}return r.type===2&&(r=m.pop()),m.length,e}function c(s,a){return L(s,a)!==0}function L(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[54],$e([1,0,4,2]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MP=void 0;class n{constructor(){this.a=new N.$jc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(v,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const o=this.c;this.c=null,v&&o&&o(w)}isMonitoring(){return!!this.b}startMonitoring(v,w,o,u,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=u,this.c=c;let L=v;try{v.setPointerCapture(w),this.a.add((0,N.$ic)(()=>{try{v.releasePointerCapture(w)}catch{}}))}catch{L=window}this.a.add(y.$sO(L,y.$8O.POINTER_MOVE,s=>{if(s.buttons!==o){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(y.$sO(L,y.$8O.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$MP=n});var Qe=this&&this.__decorate||function(le,t,y,N){var n=arguments.length,W=n<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,y):N,v;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(le,t,y,N);else for(var w=le.length-1;w>=0;w--)(v=le[w])&&(W=(n<3?v(W):n>3?v(t,y,W):v(t,y))||W);return n>3&&W&&Object.defineProperty(t,y,W),W};define(be[23],$e([1,0,4,11,25,2,44]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JP=t.EventType=void 0;var w;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class o extends W.$kc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new v.$tc,this.h=new v.$tc,this.m={},this.j=null,this.n=0,this.B(y.$sO(document,"touchstart",c=>this.s(c),{passive:!1})),this.B(y.$sO(document,"touchend",c=>this.u(c))),this.B(y.$sO(document,"touchmove",c=>this.D(c),{passive:!1}))}static addTarget(c){if(!o.isTouchDevice())return W.$kc.None;o.b||(o.b=(0,W.$dc)(new o));const L=o.b.g.push(c);return(0,W.$ic)(L)}static ignoreTarget(c){if(!o.isTouchDevice())return W.$kc.None;o.b||(o.b=(0,W.$dc)(new o));const L=o.b.h.push(c);return(0,W.$ic)(L)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(c){const L=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let s=0,a=c.targetTouches.length;s<a;s++){const e=c.targetTouches.item(s);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:L,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[L],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const l=this.w(w.Start,e.target);l.pageX=e.pageX,l.pageY=e.pageY,this.z(l)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}u(c){const L=Date.now(),s=Object.keys(this.m).length;for(let a=0,e=c.changedTouches.length;a<e;a++){const l=c.changedTouches.item(a);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("move of an UNKNOWN touch",l);continue}const r=this.m[l.identifier],m=Date.now()-r.initialTimeStamp;if(m<o.c&&Math.abs(r.initialPageX-N.$qb(r.rollingPageX))<30&&Math.abs(r.initialPageY-N.$qb(r.rollingPageY))<30){const i=this.w(w.Tap,r.initialTarget);i.pageX=N.$qb(r.rollingPageX),i.pageY=N.$qb(r.rollingPageY),this.z(i)}else if(m>=o.c&&Math.abs(r.initialPageX-N.$qb(r.rollingPageX))<30&&Math.abs(r.initialPageY-N.$qb(r.rollingPageY))<30){const i=this.w(w.Contextmenu,r.initialTarget);i.pageX=N.$qb(r.rollingPageX),i.pageY=N.$qb(r.rollingPageY),this.z(i)}else if(s===1){const i=N.$qb(r.rollingPageX),d=N.$qb(r.rollingPageY),$=N.$qb(r.rollingTimestamps)-r.rollingTimestamps[0],f=i-r.rollingPageX[0],h=d-r.rollingPageY[0],F=[...this.g].filter(M=>r.initialTarget instanceof Node&&M.contains(r.initialTarget));this.C(F,L,Math.abs(f)/$,f>0?1:-1,i,Math.abs(h)/$,h>0?1:-1,d)}this.z(this.w(w.End,r.initialTarget)),delete this.m[l.identifier]}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}w(c,L){const s=document.createEvent("CustomEvent");return s.initEvent(c,!1,!0),s.initialTarget=L,s.tapCount=0,s}z(c){if(c.type===w.Tap){const L=new Date().getTime();let s=0;L-this.n>o.r?s=1:s=2,this.n=L,c.tapCount=s}else(c.type===w.Change||c.type===w.Contextmenu)&&(this.n=0);if(c.initialTarget instanceof Node){for(const L of this.h)if(L.contains(c.initialTarget))return;for(const L of this.g)L.contains(c.initialTarget)&&(L.dispatchEvent(c),this.f=!0)}}C(c,L,s,a,e,l,r,m){this.j=y.$AO(()=>{const i=Date.now(),d=i-L;let $=0,f=0,h=!0;s+=o.a*d,l+=o.a*d,s>0&&(h=!1,$=a*s*d),l>0&&(h=!1,f=r*l*d);const F=this.w(w.Change);F.translationX=$,F.translationY=f,c.forEach(M=>M.dispatchEvent(F)),h||this.C(c,i,s,a,e+$,l,r,m+f)})}D(c){const L=Date.now();for(let s=0,a=c.changedTouches.length;s<a;s++){const e=c.changedTouches.item(s);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const l=this.m[e.identifier],r=this.w(w.Change,l.initialTarget);r.translationX=e.pageX-N.$qb(l.rollingPageX),r.translationY=e.pageY-N.$qb(l.rollingPageY),r.pageX=e.pageX,r.pageY=e.pageY,this.z(r),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(e.pageX),l.rollingPageY.push(e.pageY),l.rollingTimestamps.push(L)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}t.$JP=o,Qe([n.$6g],o,"isTouchDevice",null)}),define(be[55],$e([1,0,4,89]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eQ=t.$dQ=t.$cQ=void 0;const N=2e4;let n,W,v,w,o;function u(a){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),n.appendChild(r),r};W=e(),v=e();const l=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),n.appendChild(r),r};w=l(),o=l(),a.appendChild(n)}t.$cQ=u;function c(a){n&&(W.textContent!==a?(y.$qO(v),s(W,a)):(y.$qO(W),s(v,a)))}t.$dQ=c;function L(a){n&&(w.textContent!==a?(y.$qO(o),s(w,a)):(y.$qO(w),s(o,a)))}t.$eQ=L;function s(a,e){y.$qO(a),e.length>N&&(e=e.substr(0,N)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[116],$e([1,0,4,18]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=t.$CQ=void 0;const n=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(w){const o=new Array;let u,c=0,L=0;for(;(u=n.exec(w))!==null;){L=u.index||0,c<L&&o.push(w.substring(c,L)),c=(u.index||0)+u[0].length;const[,s,a]=u;o.push(s?`$(${a})`:v({id:a}))}return c<w.length&&o.push(w.substring(c)),o}t.$CQ=W;function v(w){const o=y.$("span");return o.classList.add(...N.ThemeIcon.asClassNameArray(w)),o}t.$DQ=v}),define(be[117],$e([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nQ=void 0;function N(W){try{W.parentElement?.removeChild(W)}catch{}}class n{constructor(v){this.d=v,this.a=new Map,this.b=new Set,this.c=!1}alloc(v){let w=this.h(v).pop(),o=!1;if(w)o=this.b.has(w.domNode),o&&this.b.delete(w.domNode);else{const u=(0,y.$)(".monaco-list-row"),L=this.i(v).renderTemplate(u);w={domNode:u,templateId:v,templateData:L}}return{row:w,isReusingConnectedDomNode:o}}release(v){v&&this.f(v)}transact(v){if(this.c)throw new Error("Already in transaction");this.c=!0;try{v()}finally{for(const w of this.b)this.g(w);this.b.clear(),this.c=!1}}f(v){const{domNode:w,templateId:o}=v;w&&(this.c?this.b.add(w):this.g(w)),this.h(o).push(v)}g(v){v.classList.remove("scrolling"),N(v)}h(v){let w=this.a.get(v);return w||(w=[],this.a.set(v,w)),w}dispose(){this.a.forEach((v,w)=>{for(const o of v)this.i(w).disposeTemplate(o.templateData),o.templateData=null}),this.a.clear(),this.b.clear()}i(v){const w=this.d.get(v);if(!w)throw new Error(`No renderer found for ${v}`);return w}}t.$nQ=n}),define(be[118],$e([1,0,9,2]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RP=void 0;class n extends N.$kc{constructor(v,w,o){super(),this.a=v,this.b=w,this.c=o,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$Qg)}setVisibility(v){this.a!==v&&(this.a=v,this.s())}setShouldBeVisible(v){this.g=v,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const v=this.r();this.h!==v&&(this.h=v,this.ensureVisibility())}setIsNeeded(v){this.j!==v&&(this.j=v,this.ensureVisibility())}setDomNode(v){this.f=v,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(v){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(v?" fade":"")))}}t.$RP=n}),define(be[119],$e([1,0,4,23,11,3,2,5]),function(le,t,y,N,n,W,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=void 0;class o extends v.$kc{constructor(c,L,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$fd),this.h=s,this.j(),this.setOptions(c,L)}j(){this.B(N.$JP.addTarget(this.a)),[N.EventType.Tap].forEach(c=>{this.B(y.$sO(this.a,c,L=>{this.a.focus()}))}),this.B(y.$tO(this.a,"click",c=>{y.$0O.stop(c,!0)})),this.B(y.$tO(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.B(y.$tO(this.a,"keydown",c=>{let L=!1;w.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(L=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(L=!0),L&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,L){(!this.c||!n.$sb(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),L!==void 0&&this.select(L)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(c,L,s){const a=document.createElement("option");return a.value=c,a.text=c,a.disabled=!!s,a}}t.$KQ=o}),define(be[56],$e([1,0,24,11,9,48,85,3,26]),function(le,t,y,N,n,W,v,w,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fS=t.$eS=t.$dS=void 0;function u(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$dS=u;function c(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$eS=c;function L(a){return typeof a.collapsible=="boolean"}class s{constructor(e,l,r,m={}){this.o=e,this.p=l,this.rootRef=[],this.d=new w.$nd,this.f=new w.$fd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new w.$fd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new w.$fd,this.onDidSplice=this.l.event,this.m=new n.$Dg(W.$cd),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,l,r=o.Iterable.empty(),m={}){if(e.length===0)throw new y.$bS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,l,r,m):this.s(e,l,r,m)}q(e,l,r,m=o.Iterable.empty(),i,d=i.diffDepth??0){const{parentNode:$}=this.G(l);if(!$.lastDiffIds)return this.s(l,r,m,i);const f=[...m],h=l[l.length-1],F=new v.$qs({getElements:()=>$.lastDiffIds},{getElements:()=>[...$.children.slice(0,h),...f,...$.children.slice(h+r)].map(j=>e.getId(j.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return $.lastDiffIds=void 0,this.s(l,r,f,i);const M=l.slice(0,-1),I=(j,H,B)=>{if(d>0)for(let E=0;E<B;E++)j--,H--,this.q(e,[...M,j,0],Number.MAX_SAFE_INTEGER,f[H].children,i,d-1)};let b=Math.min($.children.length,h+r),D=f.length;for(const j of F.changes.sort((H,B)=>B.originalStart-H.originalStart))I(b,D,b-(j.originalStart+j.originalLength)),b=j.originalStart,D=j.modifiedStart-h,this.s([...M,b],j.originalLength,o.Iterable.slice(f,D,D+j.modifiedLength),i);I(b,D,b)}s(e,l,r=o.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:i,diffIdentityProvider:d}){const{parentNode:$,listIndex:f,revealed:h,visible:F}=this.G(e),M=[],I=o.Iterable.map(r,ae=>this.w(ae,$,$.visible?1:0,h,M,m)),b=e[e.length-1],D=$.children.length>0;let j=0;for(let ae=b;ae>=0&&ae<$.children.length;ae--){const oe=$.children[ae];if(oe.visible){j=oe.visibleChildIndex;break}}const H=[];let B=0,E=0;for(const ae of I)H.push(ae),E+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=j+B++);const z=(0,N.$4b)($.children,b,l,H);d?$.lastDiffIds?(0,N.$4b)($.lastDiffIds,b,l,H.map(ae=>d.getId(ae.element).toString())):$.lastDiffIds=$.children.map(ae=>d.getId(ae.element).toString()):$.lastDiffIds=void 0;let X=0;for(const ae of z)ae.visible&&X++;if(X!==0)for(let ae=b+H.length;ae<$.children.length;ae++){const oe=$.children[ae];oe.visible&&(oe.visibleChildIndex-=X)}if($.visibleChildrenCount+=B-X,h&&F){const ae=z.reduce((oe,re)=>oe+(re.visible?re.renderNodeCount:0),0);this.B($,E-ae),this.p.splice(f,ae,M)}if(z.length>0&&i){const ae=oe=>{i(oe),oe.children.forEach(ae)};z.forEach(ae)}this.l.fire({insertedNodes:H,deletedNodes:z});const ie=$.children.length>0;D!==ie&&this.setCollapsible(e.slice(0,-1),ie);let ue=$;for(;ue;){if(ue.visibility===2){this.m.trigger(()=>this.refilter());break}ue=ue.parent}}rerender(e){if(e.length===0)throw new y.$bS(this.o,"Invalid tree location");const{node:l,listIndex:r,revealed:m}=this.F(e);l.visible&&m&&this.p.splice(r,1,[l])}updateElementHeight(e,l){if(e.length===0)throw new y.$bS(this.o,"Invalid tree location");const{listIndex:r}=this.F(e);this.p.updateElementHeight(r,l)}has(e){return this.D(e)}getListIndex(e){const{listIndex:l,visible:r,revealed:m}=this.F(e);return r&&m?l:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,l){const r=this.E(e);typeof l>"u"&&(l=!r.collapsible);const m={collapsible:l};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,l,r){const m=this.E(e);typeof l>"u"&&(l=!m.collapsed);const i={collapsed:l,recursive:r||!1};return this.d.bufferEvents(()=>this.t(e,i))}t(e,l){const{node:r,listIndex:m,revealed:i}=this.F(e),d=this.u(r,m,i,l);if(r!==this.c&&this.k&&d&&!L(l)&&r.collapsible&&!r.collapsed&&!l.recursive){let $=-1;for(let f=0;f<r.children.length;f++)if(r.children[f].visible)if($>-1){$=-1;break}else $=f;$>-1&&this.t([...e,$],l)}return d}u(e,l,r,m){const i=this.v(e,m,!1);if(!r||!e.visible||!i)return i;const d=e.renderNodeCount,$=this.x(e),f=d-(l===-1?0:1);return this.p.splice(l+1,f,$.slice(1)),i}v(e,l,r){let m;if(e===this.c?m=!1:(L(l)?(m=e.collapsible!==l.collapsible,e.collapsible=l.collapsible):e.collapsible?(m=e.collapsed!==l.collapsed,e.collapsed=l.collapsed):m=!1,m&&this.f.fire({node:e,deep:r})),!L(l)&&l.recursive)for(const i of e.children)m=this.v(i,l,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let l=this.E(e);for(;l.parent;)l=l.parent,e=e.slice(0,e.length-1),l.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,l=this.z(this.c);this.p.splice(0,e,l),this.m.cancel()}w(e,l,r,m,i,d){const $={parent:l,element:e.element,children:[],depth:l.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C($,r);$.visibility=f,m&&i.push($);const h=e.children||o.Iterable.empty(),F=m&&f!==0&&!$.collapsed;let M=0,I=1;for(const b of h){const D=this.w(b,$,f,F,i,d);$.children.push(D),I+=D.renderNodeCount,D.visible&&(D.visibleChildIndex=M++)}return $.collapsible=$.collapsible||$.children.length>0,$.visibleChildrenCount=M,$.visible=f===2?M>0:f===1,$.visible?$.collapsed||($.renderNodeCount=I):($.renderNodeCount=0,m&&i.pop()),d?.($),$}x(e){const l=e.renderNodeCount,r=[];return this.y(e,r),this.B(e.parent,r.length-l),r}y(e,l){if(e.visible===!1)return 0;if(l.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.y(r,l);return this.g.fire(e),e.renderNodeCount}z(e){const l=e.renderNodeCount,r=[];return this.A(e,e.visible?1:0,r),this.B(e.parent,r.length-l),r}A(e,l,r,m=!0){let i;if(e!==this.c){if(i=this.C(e,l),i===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&r.push(e)}const d=r.length;e.renderNodeCount=e===this.c?0:1;let $=!1;if(!e.collapsed||i!==0){let f=0;for(const h of e.children)$=this.A(h,i,r,m&&!e.collapsed)||$,h.visible&&(h.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=i===2?$:i===1,e.visibility=i),e.visible?e.collapsed||(e.renderNodeCount+=r.length-d):(e.renderNodeCount=0,m&&r.pop()),this.g.fire(e),e.visible}B(e,l){if(l!==0)for(;e;)e.renderNodeCount+=l,this.g.fire(e),e=e.parent}C(e,l){const r=this.j?this.j.filter(e.element,l):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):u(r)?(e.filterData=r.data,c(r.visibility)):(e.filterData=void 0,c(r))}D(e,l=this.c){if(!e||e.length===0)return!0;const[r,...m]=e;return r<0||r>l.children.length?!1:this.D(m,l.children[r])}E(e,l=this.c){if(!e||e.length===0)return l;const[r,...m]=e;if(r<0||r>l.children.length)throw new y.$bS(this.o,"Invalid tree location");return this.E(m,l.children[r])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:l,listIndex:r,revealed:m,visible:i}=this.G(e),d=e[e.length-1];if(d<0||d>l.children.length)throw new y.$bS(this.o,"Invalid tree location");const $=l.children[d];return{node:$,listIndex:r,revealed:m,visible:i&&$.visible}}G(e,l=this.c,r=0,m=!0,i=!0){const[d,...$]=e;if(d<0||d>l.children.length)throw new y.$bS(this.o,"Invalid tree location");for(let f=0;f<d;f++)r+=l.children[f].renderNodeCount;return m=m&&!l.collapsed,i=i&&l.visible,$.length===0?{parentNode:l,listIndex:r,revealed:m,visible:i}:this.G($,l.children[d],r+1,m,i)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const l=[];let r=e;for(;r.parent;)l.push(r.parent.children.indexOf(r)),r=r.parent;return l.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$rb)(e)[0]}getFirstElementChild(e){const l=this.E(e);if(l.children.length!==0)return l.children[0].element}getLastElementAncestor(e=[]){const l=this.E(e);if(l.children.length!==0)return this.H(l)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$fS=s}),define(be[120],$e([1,0,56,24,26]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=void 0;class W{get size(){return this.d.size}constructor(w,o,u={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$fS(w,o,null,u),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,u.sorter&&(this.j={compare(c,L){return u.sorter.compare(c.element,L.element)}}),this.h=u.identityProvider}setChildren(w,o=n.Iterable.empty(),u={}){const c=this.o(w);this.l(c,this.m(o),u)}l(w,o=n.Iterable.empty(),u){const c=new Set,L=new Set,s=e=>{if(e.element===null)return;const l=e;if(c.add(l.element),this.d.set(l.element,l),this.h){const r=this.h.getId(l.element).toString();L.add(r),this.f.set(r,l)}u.onDidCreateNode?.(l)},a=e=>{if(e.element===null)return;const l=e;if(c.has(l.element)||this.d.delete(l.element),this.h){const r=this.h.getId(l.element).toString();L.has(r)||this.f.delete(r)}u.onDidDeleteNode?.(l)};this.c.splice([...w,0],Number.MAX_VALUE,o,{...u,onDidCreateNode:s,onDidDeleteNode:a})}m(w=n.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),n.Iterable.map(w,o=>{let u=this.d.get(o.element);if(!u&&this.h){const s=this.h.getId(o.element).toString();u=this.f.get(s)}if(!u){let s;return typeof o.collapsed>"u"?s=void 0:o.collapsed===N.ObjectTreeElementCollapseState.Collapsed||o.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:o.collapsed===N.ObjectTreeElementCollapseState.Expanded||o.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!o.collapsed,{...o,children:this.m(o.children),collapsed:s}}const c=typeof o.collapsible=="boolean"?o.collapsible:u.collapsible;let L;return typeof o.collapsed>"u"||o.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||o.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?L=u.collapsed:o.collapsed===N.ObjectTreeElementCollapseState.Collapsed?L=!0:o.collapsed===N.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!o.collapsed,{...o,collapsible:c,collapsed:L,children:this.m(o.children)}})}rerender(w){const o=this.o(w);this.c.rerender(o)}updateElementHeight(w,o){const u=this.o(w);this.c.updateElementHeight(u,o)}resort(w=null,o=!0){if(!this.j)return;const u=this.o(w),c=this.c.getNode(u);this.l(u,this.n(c,o),{})}n(w,o,u=!0){let c=[...w.children];return(o||u)&&(c=c.sort(this.j.compare.bind(this.j))),n.Iterable.map(c,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,o,!1)}))}getFirstElementChild(w=null){const o=this.o(w);return this.c.getFirstElementChild(o)}getLastElementAncestor(w=null){const o=this.o(w);return this.c.getLastElementAncestor(o)}has(w){return this.d.has(w)}getListIndex(w){const o=this.o(w);return this.c.getListIndex(o)}getListRenderCount(w){const o=this.o(w);return this.c.getListRenderCount(o)}isCollapsible(w){const o=this.o(w);return this.c.isCollapsible(o)}setCollapsible(w,o){const u=this.o(w);return this.c.setCollapsible(u,o)}isCollapsed(w){const o=this.o(w);return this.c.isCollapsed(o)}setCollapsed(w,o,u){const c=this.o(w);return this.c.setCollapsed(c,o,u)}expandTo(w){const o=this.o(w);this.c.expandTo(o)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const o=this.d.get(w);if(!o)throw new N.$bS(this.k,`Tree element not found: ${w}`);return o}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new N.$bS(this.k,"Invalid getParentNodeLocation call");const o=this.d.get(w);if(!o)throw new N.$bS(this.k,`Tree element not found: ${w}`);const u=this.c.getNodeLocation(o),c=this.c.getParentNodeLocation(u);return this.c.getNode(c).element}o(w){if(w===null)return[];const o=this.d.get(w);if(!o)throw new N.$bS(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(o)}}t.$lS=W}),define(be[20],$e([1,0,4,14,19,23,2]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NP=void 0;class w extends v.$kc{f(u,c){this.B(y.$sO(u,y.$8O.CLICK,L=>c(new n.$jO(L))))}j(u,c){this.B(y.$sO(u,y.$8O.MOUSE_DOWN,L=>c(new n.$jO(L))))}m(u,c){this.B(y.$sO(u,y.$8O.MOUSE_OVER,L=>c(new n.$jO(L))))}u(u,c){this.B(y.$sO(u,y.$8O.MOUSE_LEAVE,L=>c(new n.$jO(L))))}z(u,c){this.B(y.$sO(u,y.$8O.KEY_DOWN,L=>c(new N.$oO(L))))}C(u,c){this.B(y.$sO(u,y.$8O.KEY_UP,L=>c(new N.$oO(L))))}D(u,c){this.B(y.$sO(u,y.$8O.INPUT,c))}F(u,c){this.B(y.$sO(u,y.$8O.BLUR,c))}G(u,c){this.B(y.$sO(u,y.$8O.FOCUS,c))}H(u,c){this.B(y.$sO(u,y.$8O.CHANGE,c))}I(u){return W.$JP.ignoreTarget(u)}}t.$NP=w}),define(be[36],$e([1,0,54,20,9,18,4]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PP=t.$OP=void 0,t.$OP=11;class w extends N.$NP{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$OP+"px",this.domNode.style.height=t.$OP+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new y.$MP),this.B(v.$tO(this.bgDomNode,v.$8O.POINTER_DOWN,c=>this.h(c))),this.B(v.$tO(this.domNode,v.$8O.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new n.$Rg),this.c=this.B(new n.$Qg)}h(u){if(!u.target||!(u.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.$PP=w}),define(be[57],$e([1,0,4,39,54,36,118,20,5]),function(le,t,y,N,n,W,v,w,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SP=void 0;const u=140;class c extends w.$NP{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new v.$RP(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$MP),this.s=!0,this.domNode=(0,N.$LP)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$sO(this.domNode.domNode,y.$8O.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new W.$PP(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,l){this.slider=(0,N.$LP)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof l=="number"&&this.slider.setHeight(l),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$sO(this.slider.domNode,y.$8O.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),l=a+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U(s);e<=r&&r<=l?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const r=y.$KO(this.domNode.domNode);a=s.pageX-r.left,e=s.pageY-r.top}const l=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(l):this.h.getDesiredScrollPositionFromOffset(l)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),l=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,r=>{const m=this.W(r),i=Math.abs(m-e);if(o.$i&&i>u){this.P(l.getScrollPosition());return}const $=this.U(r)-a;this.P(l.getDesiredScrollPositionFromDelta($))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$SP=c}),define(be[121],$e([1,0,19,57,36,40,17]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TP=void 0;class w extends N.$SP{constructor(u,c,L){const s=u.getScrollDimensions(),a=u.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:L,scrollbarState:new W.$QP(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-n.$OP)/2,l=(c.horizontalScrollbarSize-n.$OP)/2;this.t({className:"scra",icon:v.$Pj.scrollbarButtonLeft,top:l,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$lO(null,1,0))}),this.t({className:"scra",icon:v.$Pj.scrollbarButtonRight,top:l,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$lO(null,-1,0))})}this.w(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}R(u,c){this.slider.setWidth(u),this.slider.setLeft(c)}Q(u,c){this.domNode.setWidth(u),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this.s=this.J(u.scrollWidth)||this.s,this.s=this.L(u.scrollLeft)||this.s,this.s=this.y(u.width)||this.s,this.s}S(u,c){return u}U(u){return u.pageX}W(u){return u.pageY}X(u){this.slider.setHeight(u)}writeScrollPosition(u,c){u.scrollLeft=c}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.n.setVisibility(u.horizontal),this.c=u.scrollByPage}}t.$TP=w}),define(be[122],$e([1,0,19,57,36,40,17]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UP=void 0;class w extends N.$SP{constructor(u,c,L){const s=u.getScrollDimensions(),a=u.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:L,scrollbarState:new W.$QP(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-n.$OP)/2,l=(c.verticalScrollbarSize-n.$OP)/2;this.t({className:"scra",icon:v.$Pj.scrollbarButtonUp,top:e,left:l,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$lO(null,0,1))}),this.t({className:"scra",icon:v.$Pj.scrollbarButtonDown,top:void 0,left:l,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$lO(null,0,-1))})}this.w(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}R(u,c){this.slider.setHeight(u),this.slider.setTop(c)}Q(u,c){this.domNode.setWidth(c),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this.s=this.J(u.scrollHeight)||this.s,this.s=this.L(u.scrollTop)||this.s,this.s=this.y(u.height)||this.s,this.s}S(u,c){return c}U(u){return u.pageY}W(u){return u.pageX}X(u){this.slider.setWidth(u)}writeScrollPosition(u,c){u.scrollTop=c}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(u.vertical),this.c=u.scrollByPage}}t.$UP=w}),define(be[58],$e([1,0,16,4,39,19,121,122,20,9,3,2,5,47,96]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=void 0;const e=500,l=50,r=!0;class m{constructor(I,b,D){this.timestamp=I,this.deltaX=b,this.deltaY=D,this.score=0}}class i{static{this.INSTANCE=new i}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,b=0,D=1,j=this.d;do{const H=j===this.c?I:Math.pow(2,-D);if(I-=H,b+=this.b[j].score*H,j===this.c)break;j=(this.a+j-1)%this.a,D++}while(!0);return b<=.5}acceptStandardWheelEvent(I){const b=window.devicePixelRatio/(0,y.$5N)();s.$i||s.$k?this.accept(Date.now(),I.deltaX/b,I.deltaY/b):this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,b,D){const j=new m(I,b,D);j.score=this.f(j),this.c===-1&&this.d===-1?(this.b[0]=j,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=j)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let b=.5;const D=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(b+=.25),Math.min(Math.max(b,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}t.$VP=i;class d extends o.$NP{get options(){return this.a}constructor(I,b,D){super(),this.O=this.B(new c.$fd),this.onScroll=this.O.event,this.P=this.B(new c.$fd),this.onWillScroll=this.P.event,I.style.overflow="hidden",this.a=F(b),this.b=D,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const j={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new w.$UP(this.b,this.a,j)),this.g=this.B(new v.$TP(this.b,this.a,j)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$LP)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$LP)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$LP)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new u.$Qg),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$fc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,s.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(I){this.N=I}delegateScrollFromMouseWheelEvent(I){this.R(new W.$lO(I))}Q(I){if(this.w.length>0!==I&&(this.w=(0,L.$fc)(this.w),I)){const D=j=>{this.R(new W.$lO(j))};this.w.push(N.$sO(this.t,N.$8O.MOUSE_WHEEL,D,{passive:!1}))}}R(I){if(I.browserEvent?.defaultPrevented)return;const b=i.INSTANCE;r&&b.acceptStandardWheelEvent(I);let D=!1;if(I.deltaY||I.deltaX){let H=I.deltaY*this.a.mouseWheelScrollSensitivity,B=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&B+H===0?B=H=0:Math.abs(H)>=Math.abs(B)?B=0:H=0),this.a.flipAxes&&([H,B]=[B,H]);const E=!s.$j&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||E)&&!B&&(B=H,H=0),I.browserEvent&&I.browserEvent.altKey&&(B=B*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const z=this.b.getFutureScrollPosition();let X={};if(H){const ie=l*H,ue=z.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(X,ue)}if(B){const ie=l*B,ue=z.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(X,ue)}X=this.b.validateScrollPosition(X),(z.scrollLeft!==X.scrollLeft||z.scrollTop!==X.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&b.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(X):this.b.setScrollPositionNow(X),D=!0)}let j=D;!j&&this.a.alwaysConsumeMouseWheel&&(j=!0),!j&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(j=!0),j&&(I.preventDefault(),I.stopPropagation())}S(I){this.M=this.g.onDidScroll(I)||this.M,this.M=this.c.onDidScroll(I)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),b=I.scrollTop>0,D=I.scrollLeft>0,j=D?" left":"",H=b?" top":"",B=D||b?" top-left-corner":"";this.n.setClassName(`shadow${j}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${B}${H}${j}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(I){this.J=!1,this.ab()}Z(I){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$WP=d;class $ extends d{constructor(I,b){b=b||{},b.mouseWheelSmoothScroll=!1;const D=new a.$Nr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>N.$AO(j)});super(I,b,D),this.B(D)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$XP=$;class f extends d{constructor(I,b,D){super(I,b,D)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$YP=f;class h extends d{constructor(I,b){b=b||{},b.mouseWheelSmoothScroll=!1;const D=new a.$Nr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:j=>N.$AO(j)});super(I,b,D),this.B(D),this.cb=I,this.B(this.onScroll(j=>{j.scrollTopChanged&&(this.cb.scrollTop=j.scrollTop),j.scrollLeftChanged&&(this.cb.scrollLeft=j.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$ZP=h;function F(M){const I={lazyRender:typeof M.lazyRender<"u"?M.lazyRender:!1,className:typeof M.className<"u"?M.className:"",useShadows:typeof M.useShadows<"u"?M.useShadows:!0,handleMouseWheel:typeof M.handleMouseWheel<"u"?M.handleMouseWheel:!0,flipAxes:typeof M.flipAxes<"u"?M.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof M.consumeMouseWheelIfScrollbarIsNeeded<"u"?M.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof M.alwaysConsumeMouseWheel<"u"?M.alwaysConsumeMouseWheel:!1,scrollYToX:typeof M.scrollYToX<"u"?M.scrollYToX:!1,mouseWheelScrollSensitivity:typeof M.mouseWheelScrollSensitivity<"u"?M.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof M.fastScrollSensitivity<"u"?M.fastScrollSensitivity:5,scrollPredominantAxis:typeof M.scrollPredominantAxis<"u"?M.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof M.mouseWheelSmoothScroll<"u"?M.mouseWheelSmoothScroll:!0,arrowSize:typeof M.arrowSize<"u"?M.arrowSize:11,listenOnDomNode:typeof M.listenOnDomNode<"u"?M.listenOnDomNode:null,horizontal:typeof M.horizontal<"u"?M.horizontal:1,horizontalScrollbarSize:typeof M.horizontalScrollbarSize<"u"?M.horizontalScrollbarSize:10,horizontalSliderSize:typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:0,horizontalHasArrows:typeof M.horizontalHasArrows<"u"?M.horizontalHasArrows:!1,vertical:typeof M.vertical<"u"?M.vertical:1,verticalScrollbarSize:typeof M.verticalScrollbarSize<"u"?M.verticalScrollbarSize:10,verticalHasArrows:typeof M.verticalHasArrows<"u"?M.verticalHasArrows:!1,verticalSliderSize:typeof M.verticalSliderSize<"u"?M.verticalSliderSize:0,scrollByPage:typeof M.scrollByPage<"u"?M.scrollByPage:!1};return I.horizontalSliderSize=typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof M.verticalSliderSize<"u"?M.verticalSliderSize:I.verticalScrollbarSize,s.$j&&(I.className+=" mac"),I}}),define(be[59],$e([1,0,52,4,21,23,58,11,9,25,3,2,46,47,80,117,6]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a,e,l,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rQ=t.$qQ=t.$pQ=t.$oQ=void 0;const m={CurrentDragAndDropData:void 0},i={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(I){return[I]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(b){this.d=b}constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$oQ=d;class ${constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$pQ=$;class f{constructor(){this.types=[],this.files=[]}update(b){if(b.types&&this.types.splice(0,this.types.length,...b.types),b.files){this.files.splice(0,this.files.length);for(let D=0;D<b.files.length;D++){const j=b.files.item(D);j&&(j.size||j.type)&&this.files.push(j)}}}getData(){return{types:this.types,files:this.files}}}t.$qQ=f;function h(I,b){return Array.isArray(I)&&Array.isArray(b)?(0,w.$sb)(I,b):I===b}class F{constructor(b){b?.getSetSize?this.getSetSize=b.getSetSize.bind(b):this.getSetSize=(D,j,H)=>H,b?.getPosInSet?this.getPosInSet=b.getPosInSet.bind(b):this.getPosInSet=(D,j)=>j+1,b?.getRole?this.getRole=b.getRole.bind(b):this.getRole=D=>"listitem",b?.isChecked?this.isChecked=b.isChecked.bind(b):this.isChecked=D=>{}}}class M{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(b){if(b!==this.O){if(b&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=b,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const D of this.d)this.Y(D);this.V(),this.q.setScrollDimensions({width:(0,N.$NO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(b,D,j,H=i){if(this.Q=D,this.domId=`list_id_${++M.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new o.$Dg(50),this.v=!1,this.x=L.$kc.None,this.y=0,this.G=!1,this.J=L.$kc.None,this.K=L.$kc.None,this.L=new L.$jc,this.M=new c.$fd,this.N=new c.$fd,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=c.Event.latch(this.N.event,void 0,this.L),this.O=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$mQ(H.paddingTop??0);for(const E of j)this.j.set(E.templateId,E);this.h=this.L.add(new l.$nQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.O=H.horizontalScrolling??i.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new F(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??i.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(W.$JP.addTarget(this.o)),this.p=this.L.add(new a.$Nr({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:E=>(0,N.$AO)(E)})),this.q=this.L.add(new v.$YP(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??i.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??i.verticalScrollMode,useShadows:H.useShadows??i.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),b.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,N.$sO)(this.o,W.EventType.Change,E=>this.hb(E))),this.L.add((0,N.$sO)(this.q.getDomNode(),"scroll",E=>E.target.scrollTop=0)),this.L.add((0,N.$sO)(this.domNode,"dragover",E=>this.jb(this.fb(E)))),this.L.add((0,N.$sO)(this.domNode,"drop",E=>this.lb(this.fb(E)))),this.L.add((0,N.$sO)(this.domNode,"dragleave",E=>this.kb(this.fb(E)))),this.L.add((0,N.$sO)(this.domNode,"dragend",E=>this.mb(E))),this.z=H.setRowLineHeight??i.setRowLineHeight,this.A=H.setRowHeight??i.setRowHeight,this.B=H.supportDynamicHeights??i.supportDynamicHeights,this.F=H.dnd??this.L.add(i.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(b){b.paddingBottom!==void 0&&(this.C=b.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),b.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(b.smoothScrolling?125:0),b.horizontalScrolling!==void 0&&(this.P=b.horizontalScrolling);let D;if(b.scrollByPage!==void 0&&(D={...D??{},scrollByPage:b.scrollByPage}),b.mouseWheelScrollSensitivity!==void 0&&(D={...D??{},mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity}),b.fastScrollSensitivity!==void 0&&(D={...D??{},fastScrollSensitivity:b.fastScrollSensitivity}),D&&this.q.updateOptions(D),b.paddingTop!==void 0&&b.paddingTop!==this.g.paddingTop){const j=this.sb(this.k,this.m),H=b.paddingTop-this.g.paddingTop;this.g.paddingTop=b.paddingTop,this.W(j,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(b){this.q.delegateScrollFromMouseWheelEvent(b)}delegateVerticalScrollbarPointerDown(b){this.q.delegateVerticalScrollbarPointerDown(b)}updateElementHeight(b,D,j){if(b<0||b>=this.d.length)return;const H=this.d[b].size;if(typeof D>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[b].lastDynamicHeightWidth=void 0,D=H+this.ub(b)}if(H===D)return;const B=this.sb(this.k,this.m);let E=0;b<B.start||j!==null&&j>b&&j<=B.end?E=D-H:E=0,this.g.splice(b,1,[{size:D}]),this.d[b].size=D,this.W(B,Math.max(0,this.k+E),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(b,D,j=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(b,D,j)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(b,D,j=[]){const H=this.sb(this.k,this.m),B={start:b,end:b+D},E=s.Range.intersect(H,B),z=new Map;for(let ee=E.end-1;ee>=E.start;ee--){const J=this.d[ee];if(J.dragStartDisposable.dispose(),J.checkedDisposable.dispose(),J.row){let S=z.get(J.templateId);S||(S=[],z.set(J.templateId,S));const x=this.j.get(J.templateId);x&&x.disposeElement&&x.disposeElement(J.element,ee,J.row.templateData,J.size),S.push(J.row)}J.row=null}const X={start:b+D,end:this.d.length},ie=s.Range.intersect(X,H),ue=s.Range.relativeComplement(X,H),ae=j.map(ee=>({id:String(this.f++),element:ee,templateId:this.Q.getTemplateId(ee),size:this.Q.getHeight(ee),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$kc.None,checkedDisposable:L.$kc.None}));let oe;b===0&&D>=this.d.length?(this.g=new e.$mQ(this.g.paddingTop),this.g.splice(0,0,ae),oe=this.d,this.d=ae):(this.g.splice(b,D,ae),oe=this.d.splice(b,D,...ae));const re=j.length-D,ge=this.sb(this.k,this.m),Ce=(0,e.$kQ)(ie,re),Fe=s.Range.intersect(ge,Ce);for(let ee=Fe.start;ee<Fe.end;ee++)this.Z(this.d[ee],ee);const Me=s.Range.relativeComplement(Ce,ge);for(const ee of Me)for(let J=ee.start;J<ee.end;J++)this.ab(J);const fe=ue.map(ee=>(0,e.$kQ)(ee,re)),Q=[{start:b,end:b+j.length},...fe].map(ee=>s.Range.intersect(ge,ee)),V=this.vb(Q);for(const ee of Q)for(let J=ee.start;J<ee.end;J++){const S=this.d[J],g=z.get(S.templateId)?.pop();this.X(J,V,g)}for(const ee of z.values())for(const J of ee)this.h.release(J);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),oe.map(ee=>ee.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$AO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let b=0;for(const D of this.d)typeof D.width<"u"&&(b=Math.max(b,D.width));this.E=b,this.q.setScrollDimensions({scrollWidth:b===0?0:b+10}),this.N.fire(this.E)}updateWidth(b){if(!this.P||typeof this.E>"u")return;const D=this.d[b];this.Y(D),typeof D.width<"u"&&D.width>this.E&&(this.E=D.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const b of this.d)b.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const b=this.sb(this.k,this.m),D=this.g.positionAt(b.start),j=this.g.positionAt(b.start+1);return j!==-1&&(j-D)/2+D<this.scrollTop?b.start+1:b.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(b){return this.d[b].element}indexOf(b){return this.d.findIndex(D=>D.element===b)}domElement(b){const D=this.d[b].row;return D&&D.domNode}elementHeight(b){return this.d[b].size}elementTop(b){return this.g.positionAt(b)}indexAt(b){return this.g.indexAt(b)}indexAfter(b){return this.g.indexAfter(b)}layout(b,D){const j={height:typeof b=="number"?b:(0,N.$PO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,j.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(j),typeof D<"u"&&(this.n=D,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof D=="number"?D:(0,N.$NO)(this.domNode)})}W(b,D,j,H,B,E=!1){const z=this.sb(D,j),X=s.Range.relativeComplement(z,b),ie=s.Range.relativeComplement(b,z),ue=this.vb(X);if(E){const ae=s.Range.intersect(b,z);for(let oe=ae.start;oe<ae.end;oe++)this.Z(this.d[oe],oe)}this.h.transact(()=>{for(const ae of ie)for(let oe=ae.start;oe<ae.end;oe++)this.ab(oe);for(const ae of X)for(let oe=ae.start;oe<ae.end;oe++)this.X(oe,ue)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${D}px`,this.P&&B!==void 0&&(this.o.style.width=`${Math.max(B,this.n)}px`),this.k=D,this.m=j}X(b,D,j){const H=this.d[b];let B=!1;if(!H.row)if(j)H.row=j;else{const ue=this.h.alloc(H.templateId);H.row=ue.row,B=ue.isReusingConnectedDomNode}const E=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",E);const z=this.D.isChecked(H.element);if(typeof z=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!z));else if(z){const ue=ae=>H.row.domNode.setAttribute("aria-checked",String(!!ae));ue(z.value),H.checkedDisposable=z.onDidChange(ue)}(B||!H.row.domNode.parentElement)&&(D?this.o.insertBefore(H.row.domNode,D):this.o.appendChild(H.row.domNode)),this.Z(H,b);const X=this.j.get(H.templateId);if(!X)throw new Error(`No renderer found for template id ${H.templateId}`);X?.renderElement(H.element,b,H.row.templateData,H.size);const ie=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!ie,ie&&(H.dragStartDisposable=(0,N.$sO)(H.row.domNode,"dragstart",ue=>this.ib(H.element,ie,ue))),this.P&&(this.Y(H),this.U())}Y(b){if(!b.row||!b.row.domNode)return;b.row.domNode.style.width="fit-content",b.width=(0,N.$NO)(b.row.domNode);const D=window.getComputedStyle(b.row.domNode);D.paddingLeft&&(b.width+=parseFloat(D.paddingLeft)),D.paddingRight&&(b.width+=parseFloat(D.paddingRight)),b.row.domNode.style.width=""}Z(b,D){b.row.domNode.style.top=`${this.elementTop(D)}px`,this.A&&(b.row.domNode.style.height=`${b.size}px`),this.z&&(b.row.domNode.style.lineHeight=`${b.size}px`),b.row.domNode.setAttribute("data-index",`${D}`),b.row.domNode.setAttribute("data-last-element",D===this.length-1?"true":"false"),b.row.domNode.setAttribute("data-parity",D%2===0?"even":"odd"),b.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(b.element,D,this.length))),b.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(b.element,D))),b.row.domNode.setAttribute("id",this.getElementDomId(D)),b.row.domNode.classList.toggle("drop-target",b.dropTarget)}ab(b){const D=this.d[b];if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const j=this.j.get(D.templateId);j&&j.disposeElement&&j.disposeElement(D.element,b,D.row.templateData,D.size),this.h.release(D.row),D.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(b,D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:b,reuseAnimation:D})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(b){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:b})}get scrollTop(){return this.getScrollTop()}set scrollTop(b){this.setScrollTop(b)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"click")).event,b=>this.bb(b),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"dblclick")).event,b=>this.bb(b),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new n.$bQ(this.domNode,"auxclick")).event,b=>this.bb(b),this.L),b=>b.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"mouseup")).event,b=>this.bb(b),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"mousedown")).event,b=>this.bb(b),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"mouseover")).event,b=>this.bb(b),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"mousemove")).event,b=>this.bb(b),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"mouseout")).event,b=>this.bb(b),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new n.$bQ(this.domNode,"contextmenu")).event,b=>this.bb(b),this.L),c.Event.map(this.L.add(new n.$bQ(this.domNode,W.EventType.Contextmenu)).event,b=>this.eb(b),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new n.$bQ(this.domNode,"touchstart")).event,b=>this.db(b),this.L)}get onTap(){return c.Event.map(this.L.add(new n.$bQ(this.o,W.EventType.Tap)).event,b=>this.eb(b),this.L)}bb(b){const D=this.rb(b.target||null),j=typeof D>"u"?void 0:this.d[D],H=j&&j.element;return{browserEvent:b,index:D,element:H}}db(b){const D=this.rb(b.target||null),j=typeof D>"u"?void 0:this.d[D],H=j&&j.element;return{browserEvent:b,index:D,element:H}}eb(b){const D=this.rb(b.initialTarget||null),j=typeof D>"u"?void 0:this.d[D],H=j&&j.element;return{browserEvent:b,index:D,element:H}}fb(b){const D=this.rb(b.target||null),j=typeof D>"u"?void 0:this.d[D],H=j&&j.element;return{browserEvent:b,index:D,element:H}}gb(b){try{const D=this.sb(this.k,this.m);this.W(D,b.scrollTop,b.height,b.scrollLeft,b.scrollWidth),this.B&&this.tb(b.scrollTop,b.height,b.inSmoothScrolling)}catch(D){throw console.error("Got bad scroll event:",b),D}}hb(b){b.preventDefault(),b.stopPropagation(),this.scrollTop-=b.translationY}ib(b,D,j){if(!j.dataTransfer)return;const H=this.F.getDragElements(b);if(j.dataTransfer.effectAllowed="copyMove",j.dataTransfer.setData(y.$HP.TEXT,D),j.dataTransfer.setDragImage){let B;this.F.getDragLabel&&(B=this.F.getDragLabel(H,j)),typeof B>"u"&&(B=String(H.length));const E=(0,N.$)(".monaco-drag-image");E.textContent=B;const X=(ie=>{for(;ie&&!ie.classList.contains("monaco-workbench");)ie=ie.parentElement;return ie||document.body})(this.domNode);X.appendChild(E),j.dataTransfer.setDragImage(E,-10,-10),setTimeout(()=>X.removeChild(E),0)}this.domNode.classList.add("dragging"),this.H=new d(H),m.CurrentDragAndDropData=new $(H),this.F.onDragStart?.(this.H,j)}jb(b){if(b.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(b.browserEvent),!b.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!b.browserEvent.dataTransfer.types)return!1;this.H=new f}const D=this.F.onDragOver(this.H,b.element,b.index,b.browserEvent);if(this.G=typeof D=="boolean"?D:D.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;b.browserEvent.dataTransfer.dropEffect=typeof D!="boolean"&&D.effect===0?"copy":"move";let j;if(typeof D!="boolean"&&D.feedback?j=D.feedback:typeof b.index>"u"?j=[-1]:j=[b.index],j=(0,w.$Kb)(j).filter(H=>H>=-1&&H<this.length).sort((H,B)=>H-B),j=j[0]===-1?[-1]:j,h(this.I,j))return!0;if(this.I=j,this.J.dispose(),j[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$ic)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const H of j){const B=this.d[H];B.dropTarget=!0,B.row?.domNode.classList.add("drop-target")}this.J=(0,L.$ic)(()=>{for(const H of j){const B=this.d[H];B.dropTarget=!1,B.row?.domNode.classList.remove("drop-target")}})}return!0}kb(b){this.K.dispose(),this.K=(0,o.$Ig)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,b.element,b.index,b.browserEvent)}lb(b){if(!this.G)return;const D=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!D||!b.browserEvent.dataTransfer)&&(b.browserEvent.preventDefault(),D.update(b.browserEvent.dataTransfer),this.F.drop(D,b.element,b.index,b.browserEvent))}mb(b){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(b)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$kc.None}ob(b){if(!this.w){const D=(0,N.$HO)(this.domNode).top;this.w=(0,N.$rP)(this.pb.bind(this,D))}this.x.dispose(),this.x=(0,o.$Ig)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=b.pageY}pb(b){if(this.y===void 0)return;const D=this.y-b,j=this.renderHeight-35;D<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(D-35))):D>j&&(this.scrollTop+=Math.min(14,Math.floor(.3*(D-j))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(b){const D=this.q.getDomNode();let j=b;for(;j instanceof HTMLElement&&j!==this.o&&D.contains(j);){const H=j.getAttribute("data-index");if(H){const B=Number(H);if(!isNaN(B))return B}j=j.parentElement}}sb(b,D){return{start:this.g.indexAt(b),end:this.g.indexAfter(b+D-1)}}tb(b,D,j){const H=this.sb(b,D);let B,E;b===this.elementTop(H.start)?(B=H.start,E=0):H.end-H.start>1&&(B=H.start+1,E=this.elementTop(B)-b);let z=0;for(;;){const X=this.sb(b,D);let ie=!1;for(let ue=X.start;ue<X.end;ue++){const ae=this.ub(ue);ae!==0&&this.g.splice(ue,1,[this.d[ue]]),z+=ae,ie=ie||ae!==0}if(!ie){z!==0&&this.S();const ue=s.Range.relativeComplement(H,X);for(const oe of ue)for(let re=oe.start;re<oe.end;re++)this.d[re].row&&this.ab(re);const ae=s.Range.relativeComplement(X,H);for(const oe of ae)for(let re=oe.start;re<oe.end;re++){const ge=re+1,Ce=ge<this.d.length?this.d[ge].row:null,Fe=Ce?Ce.domNode:null;this.X(re,Fe)}for(let oe=X.start;oe<X.end;oe++)this.d[oe].row&&this.Z(this.d[oe],oe);if(typeof B=="number"){const oe=this.p.getFutureScrollPosition().scrollTop-b,re=this.elementTop(B)-E+oe;this.setScrollTop(re,j)}this.M.fire(this.contentHeight);return}}}ub(b){const D=this.d[b];if(this.Q.getDynamicHeight){const E=this.Q.getDynamicHeight(D.element);if(E!==null){const z=D.size;return D.size=E,D.lastDynamicHeightWidth=this.n,E-z}}if(!D.hasDynamicHeight||D.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(D.element))return 0;const j=D.size;if(D.row)return D.row.domNode.style.height="",D.size=D.row.domNode.offsetHeight,D.lastDynamicHeightWidth=this.n,D.size-j;const{row:H}=this.h.alloc(D.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const B=this.j.get(D.templateId);if(!B)throw new r.$ab("Missing renderer for templateId: "+D.templateId);return B.renderElement(D.element,b,H.templateData,void 0),D.size=H.domNode.offsetHeight,B.disposeElement?.(D.element,b,H.templateData,void 0),this.Q.setDynamicHeight?.(D.element,D.size),D.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),D.size-j}vb(b){const D=b[b.length-1];if(!D)return null;const j=this.d[D.end];return!j||!j.row?null:j.row.domNode}getElementDomId(b){return`${this.domId}_${b}`}dispose(){for(const b of this.d)if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const D=this.j.get(b.row.templateId);D&&(D.disposeElement?.(b.element,-1,b.row.templateData,void 0),D.disposeTemplate(b.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$rQ=M,Qe([u.$6g],M.prototype,"onMouseClick",null),Qe([u.$6g],M.prototype,"onMouseDblClick",null),Qe([u.$6g],M.prototype,"onMouseMiddleClick",null),Qe([u.$6g],M.prototype,"onMouseUp",null),Qe([u.$6g],M.prototype,"onMouseDown",null),Qe([u.$6g],M.prototype,"onMouseOver",null),Qe([u.$6g],M.prototype,"onMouseMove",null),Qe([u.$6g],M.prototype,"onMouseOut",null),Qe([u.$6g],M.prototype,"onContextMenu",null),Qe([u.$6g],M.prototype,"onTouchStart",null),Qe([u.$6g],M.prototype,"onTap",null)}),define(be[37],$e([1,0,4,21,14,23,55,69,11,9,71,25,3,32,2,45,5,7,68,59,19,95]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a,e,l,r,m,i,d,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.TypeNavigationMode=t.$uQ=t.$tQ=t.$sQ=void 0;class f{constructor(S){this.d=S,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(S){return S}renderElement(S,x,g){const p=this.c.findIndex(q=>q.templateData===g);if(p>=0){const q=this.c[p];this.d.unrender(g),q.index=x}else{const q={index:x,templateData:g};this.c.push(q)}this.d.renderIndex(x,g)}splice(S,x,g){const p=[];for(const q of this.c)q.index<S?p.push(q):q.index>=S+x&&p.push({index:q.index+g-x,templateData:q.templateData});this.c=p}renderIndexes(S){for(const{index:x,templateData:g}of this.c)S.indexOf(x)>-1&&this.d.renderIndex(x,g)}disposeTemplate(S){const x=this.c.findIndex(g=>g.templateData===S);x<0||this.c.splice(x,1)}}class h{get name(){return this.h}get renderer(){return new f(this)}constructor(S){this.h=S,this.c=0,this.d=[],this.f=[],this.g=new s.$fd,this.onChange=this.g.event}splice(S,x,g){x=Math.max(0,Math.min(x,this.c-S));const p=g.length-x,q=S+x,T=[];let O=0;for(;O<this.f.length&&this.f[O]<S;)T.push(this.f[O++]);for(let _=0;_<g.length;_++)g[_]&&T.push(_+S);for(;O<this.f.length&&this.f[O]>=q;)T.push(this.f[O++]+p);const P=this.c+p;if(this.f.length>0&&T.length===0&&P>0){const _=this.f.find(C=>C>=S)??P-1;T.push(Math.min(_,P-1))}this.renderer.splice(S,x,g.length),this.k(T,T),this.c=P}renderIndex(S,x){x.classList.toggle(this.h,this.contains(S))}unrender(S){S.classList.remove(this.h)}set(S,x){return this.k(S,[...S].sort(fe),x)}k(S,x,g){const p=this.d,q=this.f;this.d=S,this.f=x;const T=Fe(q,S);return this.renderer.renderIndexes(T),this.g.fire({indexes:S,browserEvent:g}),p}get(){return this.d}contains(S){return(0,o.$ub)(this.f,S,fe)>=0}dispose(){(0,e.$fc)(this.g)}}Qe([L.$6g],h.prototype,"renderer",null);class F extends h{constructor(S){super("selected"),this.l=S}renderIndex(S,x){super.renderIndex(S,x),this.l&&(this.contains(S)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class M{constructor(S,x,g){this.c=S,this.d=x,this.f=g}splice(S,x,g){if(!this.f)return this.c.splice(S,x,new Array(g.length).fill(!1));const p=this.c.get().map(O=>this.f.getId(this.d.element(O)).toString());if(p.length===0)return this.c.splice(S,x,new Array(g.length).fill(!1));const q=new Set(p),T=g.map(O=>q.has(this.f.getId(O).toString()));this.c.splice(S,x,T)}}function I(J){return J.tagName==="INPUT"||J.tagName==="TEXTAREA"}t.$sQ=I;function b(J){return J.classList.contains("monaco-editor")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:b(J.parentElement)}t.$tQ=b;function D(J){return J.tagName==="A"&&J.classList.contains("monaco-button")||J.tagName==="DIV"&&J.classList.contains("monaco-button-dropdown")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:D(J.parentElement)}t.$uQ=D;class j{get g(){return s.Event.chain(this.c.add(new N.$bQ(this.k.domNode,"keydown")).event,S=>S.filter(x=>!I(x.target)).map(x=>new n.$oO(x)))}constructor(S,x,g){this.h=S,this.k=x,this.c=new e.$jc,this.d=new e.$jc,this.f=g.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(r.$j?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.f=S.multipleSelectionSupport)}l(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection(this.h.getFocus(),S.browserEvent)}o(S){S.preventDefault(),S.stopPropagation(),this.h.focusPrevious(1,!1,S.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}p(S){S.preventDefault(),S.stopPropagation(),this.h.focusNext(1,!1,S.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}q(S){S.preventDefault(),S.stopPropagation(),this.h.focusPreviousPage(S.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}s(S){S.preventDefault(),S.stopPropagation(),this.h.focusNextPage(S.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}t(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection((0,o.$Qb)(this.h.length),S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(S){this.h.getSelection().length&&(S.preventDefault(),S.stopPropagation(),this.h.setSelection([],S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Qe([L.$6g],j.prototype,"g",null);var H;(function(J){J[J.Automatic=0]="Automatic",J[J.Trigger=1]="Trigger"})(H||(t.TypeNavigationMode=H={}));var B;(function(J){J[J.Idle=0]="Idle",J[J.Typing=1]="Typing"})(B||(B={})),t.$vQ=new class{mightProducePrintableCharacter(J){return J.ctrlKey||J.metaKey||J.altKey?!1:J.keyCode>=31&&J.keyCode<=56||J.keyCode>=21&&J.keyCode<=30||J.keyCode>=98&&J.keyCode<=107||J.keyCode>=85&&J.keyCode<=95}};class E{constructor(S,x,g,p,q){this.o=S,this.p=x,this.q=g,this.s=p,this.t=q,this.c=!1,this.d=B.Idle,this.f=H.Automatic,this.g=!1,this.h=-1,this.k=new e.$jc,this.l=new e.$jc,this.updateOptions(S.options)}updateOptions(S){S.typeNavigationEnabled??!0?this.u():this.v(),this.f=S.typeNavigationMode??H.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let S=!1;const x=s.Event.chain(this.k.add(new N.$bQ(this.p.domNode,"keydown")).event,q=>q.filter(T=>!I(T.target)).filter(()=>this.f===H.Automatic||this.g).map(T=>new n.$oO(T)).filter(T=>S||this.s(T)).filter(T=>this.t.mightProducePrintableCharacter(T)).forEach(T=>y.$0O.stop(T,!0)).map(T=>T.browserEvent.key)),g=s.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(x,g),(q,T)=>T===null?null:(q||"")+T,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),x(()=>S=!0,void 0,this.k),g(()=>S=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const S=this.o.getFocus();if(S.length>0&&S[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(S[0]));x&&(0,v.$dQ)(x)}this.h=-1}x(S){if(!S){this.d=B.Idle,this.g=!1;return}const x=this.o.getFocus(),g=x.length>0?x[0]:0,p=this.d===B.Idle?1:0;this.d=B.Typing;for(let q=0;q<this.o.length;q++){const T=(g+q+p)%this.o.length,O=this.q.getKeyboardNavigationLabel(this.p.element(T)),P=O&&O.toString();if(this.o.options.typeNavigationEnabled){if(typeof P<"u"){if((0,a.$yj)(S,P)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}const _=(0,a.$Fj)(S,P);if(_&&_[0].end-_[0].start>1&&_.length===1){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}else if(typeof P>"u"||(0,a.$yj)(S,P)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class z{constructor(S,x){this.d=S,this.f=x,this.c=new e.$jc;const g=s.Event.chain(this.c.add(new N.$bQ(x.domNode,"keydown")).event,q=>q.filter(T=>!I(T.target)).map(T=>new n.$oO(T)));s.Event.chain(g,q=>q.filter(T=>T.keyCode===2&&!T.ctrlKey&&!T.metaKey&&!T.shiftKey&&!T.altKey))(this.g,this,this.c)}g(S){if(S.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const g=this.f.domElement(x[0]);if(!g)return;const p=g.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const q=window.getComputedStyle(p);q.visibility==="hidden"||q.display==="none"||(S.preventDefault(),S.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function X(J){return r.$j?J.browserEvent.metaKey:J.browserEvent.ctrlKey}t.$wQ=X;function ie(J){return J.browserEvent.shiftKey}t.$xQ=ie;function ue(J){return J instanceof MouseEvent&&J.button===2}const ae={isSelectionSingleChangeEvent:X,isSelectionRangeChangeEvent:ie};class oe{constructor(S){this.k=S,this.f=new e.$jc,this.g=new s.$fd,this.onPointer=this.g.event,S.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ae),this.d=typeof S.options.mouseSupport>"u"||!!S.options.mouseSupport,this.d&&(S.onMouseDown(this.s,this,this.f),S.onContextMenu(this.t,this,this.f),S.onMouseDblClick(this.v,this,this.f),S.onTouchStart(this.s,this,this.f),this.f.add(W.$JP.addTarget(S.getHTMLElement()))),s.Event.any(S.onMouseClick,S.onMouseMiddleClick,S.onTap)(this.u,this,this.f)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.c=void 0,S.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ae))}o(S){return this.c?this.c.isSelectionSingleChangeEvent(S):!1}p(S){return this.c?this.c.isSelectionRangeChangeEvent(S):!1}q(S){return this.o(S)||this.p(S)}s(S){b(S.browserEvent.target)||document.activeElement!==S.browserEvent.target&&this.k.domFocus()}t(S){if(I(S.browserEvent.target)||b(S.browserEvent.target))return;const x=typeof S.index>"u"?[]:[S.index];this.k.setFocus(x,S.browserEvent)}u(S){if(!this.d||I(S.browserEvent.target)||b(S.browserEvent.target)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const x=S.index;if(typeof x>"u"){this.k.setFocus([],S.browserEvent),this.k.setSelection([],S.browserEvent),this.k.setAnchor(void 0);return}if(this.q(S))return this.w(S);this.k.setFocus([x],S.browserEvent),this.k.setAnchor(x),ue(S.browserEvent)||this.k.setSelection([x],S.browserEvent),this.g.fire(S)}v(S){if(I(S.browserEvent.target)||b(S.browserEvent.target)||this.q(S)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const x=this.k.getFocus();this.k.setSelection(x,S.browserEvent)}w(S){const x=S.index;let g=this.k.getAnchor();if(this.p(S)){typeof g>"u"&&(g=this.k.getFocus()[0]??x,this.k.setAnchor(g));const p=Math.min(g,x),q=Math.max(g,x),T=(0,o.$Qb)(p,q+1),O=this.k.getSelection(),P=Ce(Fe(O,[g]),g);if(P.length===0)return;const _=Fe(T,Me(O,P));this.k.setSelection(_,S.browserEvent),this.k.setFocus([x],S.browserEvent)}else if(this.o(S)){const p=this.k.getSelection(),q=p.filter(T=>T!==x);this.k.setFocus([x]),this.k.setAnchor(x),p.length===q.length?this.k.setSelection([...q,x],S.browserEvent):this.k.setSelection(q,S.browserEvent)}}dispose(){this.f.dispose()}}t.$yQ=oe;class re{constructor(S,x){this.c=S,this.d=x}style(S){const x=this.d&&`.${this.d}`,g=[];S.listBackground&&g.push(`.monaco-list${x} .monaco-list-rows { background: ${S.listBackground}; }`),S.listFocusBackground&&(g.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),g.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&(g.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),g.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listActiveSelectionIconForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${S.listActiveSelectionIconForeground}; }`),S.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${S.listFocusAndSelectionBackground}; }
			`),S.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${S.listFocusAndSelectionForeground}; }
			`),S.listInactiveFocusForeground&&(g.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${S.listInactiveFocusForeground}; }`),g.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${S.listInactiveFocusForeground}; }`)),S.listInactiveSelectionIconForeground&&g.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${S.listInactiveSelectionIconForeground}; }`),S.listInactiveFocusBackground&&(g.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${S.listInactiveFocusBackground}; }`),g.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${S.listInactiveFocusBackground}; }`)),S.listInactiveSelectionBackground&&(g.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${S.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${S.listInactiveSelectionBackground}; }`)),S.listInactiveSelectionForeground&&g.push(`.monaco-list${x} .monaco-list-row.selected { color: ${S.listInactiveSelectionForeground}; }`),S.listHoverBackground&&g.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&g.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${S.listHoverForeground}; }`);const p=(0,y.$uP)(S.listFocusAndSelectionOutline,(0,y.$uP)(S.listSelectionOutline,S.listFocusOutline??""));p&&g.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),S.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
			`);const q=(0,y.$uP)(S.listSelectionOutline,S.listInactiveFocusOutline??"");q&&g.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${q}; outline-offset: -1px; }`),S.listSelectionOutline&&g.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${S.listSelectionOutline}; outline-offset: -1px; }`),S.listInactiveFocusOutline&&g.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${S.listInactiveFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&g.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.listDropBackground&&g.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${S.listDropBackground} !important; color: inherit !important; }
			`),S.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${S.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),S.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${S.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$zQ=re,t.$AQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:c.$Os.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:c.$Os.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:c.$Os.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ge={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Ce(J,S){const x=J.indexOf(S);if(x===-1)return[];const g=[];let p=x-1;for(;p>=0&&J[p]===S-(x-p);)g.push(J[p--]);for(g.reverse(),p=x;p<J.length&&J[p]===S+(p-x);)g.push(J[p++]);return g}function Fe(J,S){const x=[];let g=0,p=0;for(;g<J.length||p<S.length;)if(g>=J.length)x.push(S[p++]);else if(p>=S.length)x.push(J[g++]);else if(J[g]===S[p]){x.push(J[g]),g++,p++;continue}else J[g]<S[p]?x.push(J[g++]):x.push(S[p++]);return x}function Me(J,S){const x=[];let g=0,p=0;for(;g<J.length||p<S.length;)if(g>=J.length)x.push(S[p++]);else if(p>=S.length)x.push(J[g++]);else if(J[g]===S[p]){g++,p++;continue}else J[g]<S[p]?x.push(J[g++]):p++;return x}const fe=(J,S)=>J-S;class ne{constructor(S,x){this.c=S,this.d=x}get templateId(){return this.c}renderTemplate(S){return this.d.map(x=>x.renderTemplate(S))}renderElement(S,x,g,p){let q=0;for(const T of this.d)T.renderElement(S,x,g[q++],p)}disposeElement(S,x,g,p){let q=0;for(const T of this.d)T.disposeElement?.(S,x,g[q],p),q+=1}disposeTemplate(S){let x=0;for(const g of this.d)g.disposeTemplate(S[x++])}}class Q{constructor(S){this.c=S,this.templateId="a18n"}renderTemplate(S){return S}renderElement(S,x,g){const p=this.c.getAriaLabel(S);p?g.setAttribute("aria-label",p):g.removeAttribute("aria-label");const q=this.c.getAriaLevel&&this.c.getAriaLevel(S);typeof q=="number"?g.setAttribute("aria-level",`${q}`):g.removeAttribute("aria-level")}disposeTemplate(S){}}class V{constructor(S,x){this.c=S,this.d=x}getDragElements(S){const x=this.c.getSelectedElements();return x.indexOf(S)>-1?x:[S]}getDragURI(S){return this.d.getDragURI(S)}getDragLabel(S,x){if(this.d.getDragLabel)return this.d.getDragLabel(S,x)}onDragStart(S,x){this.d.onDragStart?.(S,x)}onDragOver(S,x,g,p){return this.d.onDragOver(S,x,g,p)}onDragLeave(S,x,g,p){this.d.onDragLeave?.(S,x,g,p)}onDragEnd(S){this.d.onDragEnd?.(S)}drop(S,x,g,p){this.d.drop(S,x,g,p)}dispose(){this.d.dispose()}}class ee{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),S=>this.G(S),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),S=>this.G(S),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let S=!1;const x=s.Event.chain(this.y.add(new N.$bQ(this.k.domNode,"keydown")).event,q=>q.map(T=>new n.$oO(T)).filter(T=>S=T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$0O.stop(T,!0)).filter(()=>!1)),g=s.Event.chain(this.y.add(new N.$bQ(this.k.domNode,"keyup")).event,q=>q.forEach(()=>S=!1).map(T=>new n.$oO(T)).filter(T=>T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$0O.stop(T,!0)).map(({browserEvent:T})=>{const O=this.getFocus(),P=O.length?O[0]:void 0,_=typeof P<"u"?this.k.element(P):void 0,C=typeof P<"u"?this.k.domElement(P):this.k.domNode;return{index:P,element:_,anchor:C,browserEvent:T}})),p=s.Event.chain(this.k.onContextMenu,q=>q.filter(T=>!S).map(({element:T,index:O,browserEvent:P})=>({element:T,index:O,anchor:new $.$jO(P),browserEvent:P})));return s.Event.any(x,g,p)}get onKeyDown(){return this.y.add(new N.$bQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$bQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$bQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new N.$bQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new N.$bQ(this.k.domNode,"blur",!0)).event)}constructor(S,x,g,p,q=ge){this.A=S,this.B=q,this.c=new h("focused"),this.f=new h("anchor"),this.g=new s.$nd,this.x="",this.y=new e.$jc,this.z=new s.$fd,this.onDidDispose=this.z.event;const T=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(T!=="listbox");const O=[this.c.renderer,this.d.renderer];this.u=q.accessibilityProvider,this.u&&(O.push(new Q(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(_=>new ne(_.templateId,[...O,_]));const P={...q,dnd:q.dnd&&new V(this,q.dnd)};if(this.k=this.C(x,g,p,P),this.k.domNode.setAttribute("role",T),q.styleController)this.q=q.styleController(this.k.domId);else{const _=(0,y.$3O)(this.k.domNode);this.q=new re(_,this.k.domId)}if(this.o=new w.$fQ([new M(this.c,this.k,q.identityProvider),new M(this.d,this.k,q.identityProvider),new M(this.f,this.k,q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new z(this,this.k)),(typeof q.keyboardSupport!="boolean"||q.keyboardSupport)&&(this.v=new j(this,this.k,q),this.y.add(this.v)),q.keyboardNavigationLabelProvider){const _=q.keyboardNavigationDelegate||t.$vQ;this.t=new E(this,this.k,q.keyboardNavigationLabelProvider,q.keyboardNavigationEventFilter??(()=>!0),_),this.y.add(this.t)}this.w=this.D(q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(S,x,g,p){return new d.$rQ(S,x,g,p)}D(S){return new oe(this)}updateOptions(S={}){this.B={...this.B,...S},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(S),this.v?.updateOptions(S),this.k.updateOptions(S)}get options(){return this.B}splice(S,x,g=[]){if(S<0||S>this.k.length)throw new i.$hQ(this.A,`Invalid start index: ${S}`);if(x<0)throw new i.$hQ(this.A,`Invalid delete count: ${x}`);x===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(S,x,g))}updateWidth(S){this.k.updateWidth(S)}updateElementHeight(S,x){this.k.updateElementHeight(S,x,null)}rerender(){this.k.rerender()}element(S){return this.k.element(S)}indexOf(S){return this.k.indexOf(S)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(S){this.k.setScrollTop(S)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(S){this.k.setScrollLeft(S)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(S){this.x=S,this.k.domNode.setAttribute("aria-label",S)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(S,x){this.k.layout(S,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(S,x){for(const g of S)if(g<0||g>=this.length)throw new i.$hQ(this.A,`Invalid index ${g}`);this.d.set(S,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(S=>this.k.element(S))}setAnchor(S){if(typeof S>"u"){this.f.set([]);return}if(S<0||S>=this.length)throw new i.$hQ(this.A,`Invalid index ${S}`);this.f.set([S])}getAnchor(){return(0,o.$Mb)(this.f.get(),void 0)}getAnchorElement(){const S=this.getAnchor();return typeof S>"u"?void 0:this.element(S)}setFocus(S,x){for(const g of S)if(g<0||g>=this.length)throw new i.$hQ(this.A,`Invalid index ${g}`);this.c.set(S,x)}focusNext(S=1,x=!1,g,p){if(this.length===0)return;const q=this.c.get(),T=this.E(q.length>0?q[0]+S:0,x,p);T>-1&&this.setFocus([T],g)}focusPrevious(S=1,x=!1,g,p){if(this.length===0)return;const q=this.c.get(),T=this.F(q.length>0?q[0]-S:0,x,p);T>-1&&this.setFocus([T],g)}async focusNextPage(S,x){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const p=this.getFocus()[0];if(p!==g&&(p===void 0||g>p)){const q=this.F(g,!1,x);q>-1&&p!==q?this.setFocus([q],S):this.setFocus([g],S)}else{const q=this.k.getScrollTop();let T=q+this.k.renderHeight;g>p&&(T-=this.k.elementHeight(g)),this.k.setScrollTop(T),this.k.getScrollTop()!==q&&(this.setFocus([]),await(0,u.$Hg)(0),await this.focusNextPage(S,x))}}async focusPreviousPage(S,x){let g;const p=this.k.getScrollTop();p===0?g=this.k.indexAt(p):g=this.k.indexAfter(p-1);const q=this.getFocus()[0];if(q!==g&&(q===void 0||q>=g)){const T=this.E(g,!1,x);T>-1&&q!==T?this.setFocus([T],S):this.setFocus([g],S)}else{const T=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,u.$Hg)(0),await this.focusPreviousPage(S,x))}}focusLast(S,x){if(this.length===0)return;const g=this.F(this.length-1,!1,x);g>-1&&this.setFocus([g],S)}focusFirst(S,x){this.focusNth(0,S,x)}focusNth(S,x,g){if(this.length===0)return;const p=this.E(S,!1,g);p>-1&&this.setFocus([p],x)}E(S,x=!1,g){for(let p=0;p<this.length;p++){if(S>=this.length&&!x)return-1;if(S=S%this.length,!g||g(this.element(S)))return S;S++}return-1}F(S,x=!1,g){for(let p=0;p<this.length;p++){if(S<0&&!x)return-1;if(S=(this.length+S%this.length)%this.length,!g||g(this.element(S)))return S;S--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(S=>this.k.element(S))}reveal(S,x){if(S<0||S>=this.length)throw new i.$hQ(this.A,`Invalid index ${S}`);const g=this.k.getScrollTop(),p=this.k.elementTop(S),q=this.k.elementHeight(S);if((0,m.$nf)(x)){const T=q-this.k.renderHeight;this.k.setScrollTop(T*(0,l.$Hl)(x,0,1)+p)}else{const T=p+q,O=g+this.k.renderHeight;p<g&&T>=O||(p<g||T>=O&&q>=this.k.renderHeight?this.k.setScrollTop(p):T>=O&&this.k.setScrollTop(T-this.k.renderHeight))}}getRelativeTop(S){if(S<0||S>=this.length)throw new i.$hQ(this.A,`Invalid index ${S}`);const x=this.k.getScrollTop(),g=this.k.elementTop(S),p=this.k.elementHeight(S);if(g<x||g+p>x+this.k.renderHeight)return null;const q=p-this.k.renderHeight;return Math.abs((x-g)/q)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(S){return this.k.getElementDomId(S)}style(S){this.q.style(S)}G({indexes:S,browserEvent:x}){return{indexes:S,elements:S.map(g=>this.k.element(g)),browserEvent:x}}H(){const S=this.c.get();this.k.domNode.classList.toggle("element-focused",S.length>0),this.I()}I(){const S=this.c.get();if(S.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(S[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(S[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const S=this.d.get();this.k.domNode.classList.toggle("selection-none",S.length===0),this.k.domNode.classList.toggle("selection-single",S.length===1),this.k.domNode.classList.toggle("selection-multiple",S.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$BQ=ee,Qe([L.$6g],ee.prototype,"onDidChangeFocus",null),Qe([L.$6g],ee.prototype,"onDidChangeSelection",null),Qe([L.$6g],ee.prototype,"onContextMenu",null),Qe([L.$6g],ee.prototype,"onKeyDown",null),Qe([L.$6g],ee.prototype,"onKeyUp",null),Qe([L.$6g],ee.prototype,"onKeyPress",null),Qe([L.$6g],ee.prototype,"onDidFocus",null),Qe([L.$6g],ee.prototype,"onDidBlur",null)}),define(be[60],$e([1,0,6,33,35,12,15]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class o{constructor(m="",i=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$5)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(m,i=0){return this.value+=s(this.supportThemeIcons?(0,N.$Rj)(m):m).replace(/([ \t]+)/g,(d,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,i){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(m,i,d){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(m),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(m,i){const d=new RegExp((0,W.$qe)(i),"g");return m.replace(d,($,f)=>m.charAt(f-1)!=="\\"?`\\${$}`:$)}}t.$Xj=o;function u(r){return c(r)?!r.value:Array.isArray(r)?r.every(u):!0}t.$Yj=u;function c(r){return r instanceof o?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}t.$Zj=c;function L(r,m){return r===m?!0:!r||!m?!1:r.value===m.value&&r.isTrusted===m.isTrusted&&r.supportThemeIcons===m.supportThemeIcons&&r.supportHtml===m.supportHtml&&(r.baseUri===m.baseUri||!!r.baseUri&&!!m.baseUri&&(0,n.$bg)(v.URI.from(r.baseUri),v.URI.from(m.baseUri)))}t.$1j=L;function s(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$2j=s;function a(r){return r.replace(/"/g,"&quot;")}t.$3j=a;function e(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$4j=e;function l(r){const m=[],i=r.split("|").map($=>$.trim());r=i[0];const d=i[1];if(d){const $=/height=(\d+)/.exec(d),f=/width=(\d+)/.exec(d),h=$?$[1]:"",F=f?f[1]:"",M=isFinite(parseInt(F)),I=isFinite(parseInt(h));M&&m.push(`width="${F}"`),I&&m.push(`height="${h}"`)}return{href:r,dimensions:m}}t.$5j=l}),define(be[123],$e([1,0,4,115,21,53,14,19,116,6,3,60,33,74,30,2,77,51,28,49,35,12,15]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a,e,l,r,m,i,d,$,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=void 0;const F=Object.freeze({image:(V,ee,J)=>{let S=[],x=[];return V&&({href:V,dimensions:S}=(0,L.$5j)(V),x.push(`src="${(0,L.$3j)(V)}"`)),J&&x.push(`alt="${(0,L.$3j)(J)}"`),ee&&x.push(`title="${(0,L.$3j)(ee)}"`),S.length&&(x=x.concat(S)),"<img "+x.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,ee,J)=>typeof V!="string"?"":(V===J&&(J=(0,L.$4j)(J)),ee=typeof ee=="string"?(0,L.$3j)((0,L.$4j)(ee)):"",V=(0,L.$4j)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${ee||V}">${J}</a>`)});function M(V,ee={},J={}){const S=new l.$jc;let x=!1;const g=(0,W.$aQ)(ee),p=function(k){let U;try{U=(0,m.$0g)(decodeURIComponent(k))}catch{}return U?(U=(0,d.$Xm)(U,K=>{if(V.uris&&V.uris[K])return h.URI.revive(V.uris[K])}),encodeURIComponent(JSON.stringify(U))):k},q=function(k,U){const K=V.uris&&V.uris[k];let te=h.URI.revive(K);return U?k.startsWith(i.Schemas.data+":")?k:(te||(te=h.URI.parse(k)),i.$2f.uriToBrowserUri(te).toString(!0)):!te||h.URI.parse(k).toString()===te.toString()?k:(te.query&&(te=te.with({query:p(te.query)})),te.toString())},T=new r.marked.Renderer;T.image=F.image,T.link=F.link,T.paragraph=F.paragraph;const O=[],P=[];if(ee.codeBlockRendererSync?T.code=(k,U)=>{const K=a.$aM.nextId(),te=ee.codeBlockRendererSync(I(U),k);return P.push([K,te]),`<div class="code" data-code="${K}">${(0,f.$pe)(k)}</div>`}:ee.codeBlockRenderer&&(T.code=(k,U)=>{const K=a.$aM.nextId(),te=ee.codeBlockRenderer(I(U),k);return O.push(te.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,f.$pe)(k)}</div>`}),ee.actionHandler){const k=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let me=se.dataset.href;me&&(V.baseUri&&(me=b(h.URI.from(V.baseUri),me)),ee.actionHandler.callback(me,te))}catch(me){(0,u.$Y)(me)}finally{te.preventDefault()}},U=ee.actionHandler.disposables.add(new n.$bQ(g,"click")),K=ee.actionHandler.disposables.add(new n.$bQ(g,"auxclick"));ee.actionHandler.disposables.add(c.Event.any(U.event,K.event)(te=>{const se=new w.$jO(te);!se.leftButton&&!se.middleButton||k(se)})),ee.actionHandler.disposables.add(y.$sO(g,"keydown",te=>{const se=new v.$oO(te);!se.equals(10)&&!se.equals(3)||k(se)}))}V.supportHtml||(J.sanitizer=k=>(V.isTrusted?k.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?k:"",J.sanitize=!0,J.silent=!0),J.renderer=T;let _=V.value??"";_.length>1e5&&(_=`${_.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(_=(0,s.$Sj)(_));let C;if(ee.fillInIncompleteTokens){const k={...r.marked.defaults,...J},U=r.marked.lexer(_,k),K=ue(U);C=r.marked.parser(K,k)}else C=r.marked.parse(_,J);V.supportThemeIcons&&(C=(0,o.$CQ)(C).map(U=>typeof U=="string"?U:U.outerHTML).join(""));const A=new DOMParser().parseFromString(D(V,C),"text/html");if(A.body.querySelectorAll("img").forEach(k=>{const U=k.getAttribute("src");if(U){let K=U;try{V.baseUri&&(K=b(h.URI.from(V.baseUri),K))}catch{}k.src=q(K,!0)}}),A.body.querySelectorAll("a").forEach(k=>{const U=k.getAttribute("href");if(k.setAttribute("href",""),!U||/^data:|javascript:/i.test(U)||/^command:/i.test(U)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(U))k.replaceWith(...k.childNodes);else{let K=q(U,!1);V.baseUri&&(K=b(h.URI.from(V.baseUri),U)),k.dataset.href=K}}),g.innerHTML=D(V,A.body.innerHTML),O.length>0)Promise.all(O).then(k=>{if(x)return;const U=new Map(k),K=g.querySelectorAll("div[data-code]");for(const te of K){const se=U.get(te.dataset.code??"");se&&y.$eP(te,se)}ee.asyncRenderCallback?.()});else if(P.length>0){const k=new Map(P),U=g.querySelectorAll("div[data-code]");for(const K of U){const te=k.get(K.dataset.code??"");te&&y.$eP(K,te)}}if(ee.asyncRenderCallback)for(const k of g.getElementsByTagName("img")){const U=S.add(y.$sO(k,"load",()=>{U.dispose(),ee.asyncRenderCallback()}))}return{element:g,dispose:()=>{x=!0,S.dispose()}}}t.$EQ=M;function I(V){if(!V)return"";const ee=V.split(/[\s+|:|,|\{|\?]/,1);return ee.length?ee[0]:V}function b(V,ee){return/^\w[\w\d+.-]*:/.test(ee)?ee:V.path.endsWith("/")?(0,$.$lg)(V,ee).toString():(0,$.$lg)((0,$.$hg)(V),ee).toString()}function D(V,ee){const{config:J,allowedSchemes:S}=j(V);N.addHook("uponSanitizeAttribute",(g,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(g.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const x=y.$yP(S);try{return N.sanitize(ee,{...J,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),x.dispose()}}t.$FQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function j(V){const ee=[i.Schemas.http,i.Schemas.https,i.Schemas.mailto,i.Schemas.data,i.Schemas.file,i.Schemas.vscodeFileResource,i.Schemas.vscodeRemote,i.Schemas.vscodeRemoteResource];return V.isTrusted&&ee.push(i.Schemas.command),{config:{ALLOWED_TAGS:[...y.$zP],ALLOWED_ATTR:t.$FQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ee}}function H(V){return typeof V=="string"?V:B(V)}t.$GQ=H;function B(V){let ee=V.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`);const J=r.marked.parse(ee,{renderer:z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,S=>E.get(S)??S);return D({isTrusted:!1},J).toString()}t.$HQ=B;const E=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),z=new e.$T(()=>{const V=new r.marked.Renderer;return V.code=ee=>ee,V.blockquote=ee=>ee,V.html=ee=>"",V.heading=(ee,J,S)=>ee+`
`,V.hr=()=>"",V.list=(ee,J)=>ee,V.listitem=ee=>ee+`
`,V.paragraph=ee=>ee+`
`,V.table=(ee,J)=>ee+J+`
`,V.tablerow=ee=>ee,V.tablecell=(ee,J)=>ee+" ",V.strong=ee=>ee,V.em=ee=>ee,V.codespan=ee=>ee,V.br=()=>`
`,V.del=ee=>ee,V.image=(ee,J,S)=>"",V.text=ee=>ee,V.link=(ee,J,S)=>S,V});function X(V){let ee="";return V.forEach(J=>{ee+=J.raw}),ee}function ie(V){for(const ee of V.tokens)if(ee.type==="text"){const J=ee.raw.split(`
`),S=J[J.length-1];if(S.includes("`"))return oe(V);if(S.includes("**"))return Me(V);if(S.match(/\*\w/))return re(V);if(S.match(/(^|\s)__\w/))return fe(V);if(S.match(/(^|\s)_\w/))return ge(V);if(S.match(/(^|\s)\[.*\]\(\w*/))return Ce(V);if(S.match(/(^|\s)\[\w/))return Fe(V)}}function ue(V){let ee,J;for(ee=0;ee<V.length;ee++){const S=V[ee];if(S.type==="paragraph"&&S.raw.match(/(\n|^)```/)){J=ae(V.slice(ee));break}if(S.type==="paragraph"&&S.raw.match(/(\n|^)\|/)){J=Q(V.slice(ee));break}if(ee===V.length-1&&S.type==="paragraph"){const x=ie(S);if(x){J=[x];break}}}if(J){const S=[...V.slice(0,ee),...J];return S.links=V.links,S}return V}t.$IQ=ue;function ae(V){const ee=X(V);return r.marked.lexer(ee+"\n```")}function oe(V){return ne(V,"`")}function re(V){return ne(V,"*")}function ge(V){return ne(V,"_")}function Ce(V){return ne(V,")")}function Fe(V){return ne(V,"](about:blank)")}function Me(V){return ne(V,"**")}function fe(V){return ne(V,"__")}function ne(V,ee){const J=X(Array.isArray(V)?V:[V]);return r.marked.lexer(J+ee)[0]}function Q(V){const ee=X(V),J=ee.split(`
`);let S,x=!1;for(let g=0;g<J.length;g++){const p=J[g].trim();if(typeof S>"u"&&p.match(/^\s*\|/)){const q=p.match(/(\|[^\|]+)(?=\||$)/g);q&&(S=q.length)}else if(typeof S=="number")if(p.match(/^\s*\|/)){if(g!==J.length-1)return;x=!0}else return}if(typeof S=="number"&&S>0){const g=x?J.slice(0,-1).join(`
`):ee,p=!!g.match(/\|\s*$/),q=g+(p?"":"|")+`
|${" --- |".repeat(S)}`;return r.marked.lexer(q)}}}),define(be[124],$e([1,0,4,9,27,60,33,2,7,105]),function(le,t,y,N,n,W,v,w,o,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5P=t.$4P=void 0;function c(a,e){(0,o.$jf)(e)?a.title=(0,v.$Tj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$4P=c;class L{constructor(e,l,r){this.c=e,this.d=l,this.f=r}async update(e,l,r){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,o.$jf)(e)||e instanceof HTMLElement)m=e;else if(!(0,o.$xf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,u.localize)(0,null),l),this.b=new n.$pd;const i=this.b.token;if(m=await e.markdown(i),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||i.isCancellationRequested)return}this.g(m,l,r)}g(e,l,r){const m=this.a;if(this.h(e)){const i={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...r};this.a=this.c.showHover(i,l)}m?.dispose()}h(e){return e?(0,W.$Zj)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,l,r){let m,i;const d=(M,I)=>{const b=i!==void 0;M&&(i?.dispose(),i=void 0),I&&(m?.dispose(),m=void 0),b&&a.onDidHideHover?.()},$=(M,I,b)=>new N.$Qg(async()=>{(!i||i.isDisposed)&&(i=new L(a,b||e,M>0),await i.update(l,I,r))},M),f=()=>{if(m)return;const M=new w.$jc,I=j=>d(!1,j.fromElement===e);M.add(y.$sO(e,y.$8O.MOUSE_LEAVE,I,!0));const b=()=>d(!0,!0);M.add(y.$sO(e,y.$8O.MOUSE_DOWN,b,!0));const D={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const j=H=>{D.x=H.x+10,H.target instanceof HTMLElement&&H.target.classList.contains("action-label")&&d(!0,!0)};M.add(y.$sO(e,y.$8O.MOUSE_MOVE,j,!0))}M.add($(a.delay,!1,D)),m=M},h=y.$sO(e,y.$8O.MOUSE_OVER,f,!0);return{show:M=>{d(!1,!0),$(0,M)},hide:()=>{d(!0,!0)},update:async(M,I)=>{l=M,await i?.update(l,void 0,I)},dispose:()=>{h.dispose(),d(!0,!0)}}}t.$5P=s}),define(be[125],$e([1,0,4,21,14,123,37,11,3,43,2,5,107,98]),function(le,t,y,N,n,W,v,w,o,u,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=void 0;const a=y.$,e="selectOption.entry.template";class l{get templateId(){return e}renderTemplate(i){const d=Object.create(null);return d.root=i,d.text=y.$cP(i,a(".option-text")),d.detail=y.$cP(i,a(".option-detail")),d.decoratorRight=y.$cP(i,a(".option-decorator-right")),d}renderElement(i,d,$){const f=$,h=i.text,F=i.detail,M=i.decoratorRight,I=i.isDisabled;f.text.textContent=h,f.detail.textContent=F||"",f.decoratorRight.innerText=M||"",I?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(i){}}class r extends c.$kc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(i,d,$,f,h){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=h||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=r.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new o.$fd,this.B(this.r),this.O(),this.N($),this.n=d||0,i&&this.setOptions(i,d),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(i){this.u=i,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$cP(this.w,a(".select-box-details-pane"));const d=y.$cP(this.w,a(".select-box-dropdown-container-width-control")),$=y.$cP(d,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$cP($,this.D),this.G=0,this.y=y.$3O(this.w),this.w.setAttribute("draggable","true"),this.B(y.$sO(this.w,y.$8O.DRAG_START,f=>{y.$0O.stop(f,!0)}))}O(){this.B(y.$tO(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$sO(this.h,y.$8O.CLICK,d=>{y.$0O.stop(d),this.f?this.X(!0):this.W()})),this.B(y.$sO(this.h,y.$8O.MOUSE_DOWN,d=>{y.$0O.stop(d)}));let i;this.B(y.$sO(this.h,"touchstart",d=>{i=this.f})),this.B(y.$sO(this.h,"touchend",d=>{y.$0O.stop(d),i?this.X(!0):this.W()})),this.B(y.$sO(this.h,y.$8O.KEY_DOWN,d=>{const $=new n.$oO(d);let f=!1;L.$j?($.keyCode===18||$.keyCode===16||$.keyCode===10||$.keyCode===3)&&(f=!0):($.keyCode===18&&$.altKey||$.keyCode===16&&$.altKey||$.keyCode===10||$.keyCode===3)&&(f=!0),f&&(this.W(),y.$0O.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(i,d){w.$sb(this.m,i)||(this.m=i,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach(($,f)=>{this.h.add(this.U($.text,f,$.isDisabled)),typeof $.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(i){i>=0&&i<this.m.length?this.n=i:i>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(i){this.g.ariaLabel=i,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(i){this.h.tabIndex=i?0:-1}render(i){this.j=i,i.classList.add("select-container"),i.appendChild(this.h),this.R()}Q(){const i=[];this.s.listFocusBackground&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(i.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),i.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),i.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(i.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),i.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&i.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),i.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),i.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=i.join(`
`)}R(){const i=this.s.selectBackground??"",d=this.s.selectForeground??"",$=this.s.selectBorder??"";this.h.style.backgroundColor=i,this.h.style.color=d,this.h.style.borderColor=$}S(){const i=this.s.selectBackground??"",d=y.$uP(this.s.selectListBackground,i);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const $=this.s.focusBorder??"";this.w.style.outlineColor=$,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(i,d,$){const f=document.createElement("option");return f.value=i,f.text=i,f.disabled=!!$,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:i=>this.Y(i,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:i=>this.Y(i),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(i){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),i&&this.h.focus(),this.u.hideContextView())}Y(i,d){return i.appendChild(this.w),this.ab(d),{dispose:()=>{try{i.removeChild(this.w)}catch{}}}}Z(){let i=0;return this.m.forEach((d,$)=>{this.hb($),this.I.offsetHeight>i&&(i=this.I.offsetHeight)}),i}ab(i){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=y.$KO(this.h),$=getComputedStyle(this.h),f=parseFloat($.getPropertyValue("--dropdown-padding-top"))+parseFloat($.getPropertyValue("--dropdown-padding-bottom")),h=window.innerHeight-d.top-d.height-(this.g.minBottomMargin||0),F=d.top-r.b,M=this.h.offsetWidth,I=this.bb(this.D),b=Math.max(I,Math.round(M)).toString()+"px";this.w.style.width=b,this.z.getHTMLElement().style.height="",this.z.layout();let D=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const j=this.H?this.L:0,H=D+f+j,B=Math.floor((h-f-j)/this.getHeight()),E=Math.floor((F-f-j)/this.getHeight());if(i)return d.top+d.height>window.innerHeight-22||d.top<r.b||B<1&&E<1?!1:(B<r.c&&E>B&&this.m.length>B?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(d.top+d.height>window.innerHeight-22||d.top<r.b||this.G===0&&B<1||this.G===1&&E<1)return this.X(!0),!1;if(this.G===0){if(this.f&&B+E<1)return this.X(!0),!1;H>h&&(D=B*this.getHeight())}else H>F&&(D=E*this.getHeight());return this.z.layout(D),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=D+f+"px",this.w.style.height=""):this.w.style.height=D+f+"px",this.hb(this.n),this.w.style.width=b,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(i){let d=0;if(i){let $=0,f=0;this.m.forEach((h,F)=>{const M=h.detail?h.detail.length:0,I=h.decoratorRight?h.decoratorRight.length:0,b=h.text.length+M+I;b>f&&($=F,f=b)}),i.textContent=this.m[$].text+(this.m[$].decoratorRight?this.m[$].decoratorRight+" ":""),d=y.$MO(i)}return d}cb(i){if(this.z)return;this.C=y.$cP(i,a(".select-box-dropdown-list-container")),this.t=new l,this.z=new v.$BQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let h=f.text;return f.detail&&(h+=`. ${f.detail}`),f.decoratorRight&&(h+=`. ${f.decoratorRight}`),f.description&&(h+=`. ${f.description}`),h},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new N.$bQ(this.C,"keydown")),$=o.Event.chain(d.event,f=>f.filter(()=>this.z.length>0).map(h=>new n.$oO(h)));this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===3))(this.jb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===2))(this.jb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===9))(this.ib,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===16))(this.lb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===18))(this.kb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===12))(this.nb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===11))(this.mb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===14))(this.ob,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode===13))(this.pb,this)),this.B(o.Event.chain($,f=>f.filter(h=>h.keyCode>=21&&h.keyCode<=56||h.keyCode>=85&&h.keyCode<=113))(this.qb,this)),this.B(y.$sO(this.z.getHTMLElement(),y.$8O.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(y.$sO(this.w,y.$8O.FOCUS_OUT,f=>{!this.f||y.$SO(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(i){if(!this.z.length)return;y.$0O.stop(i);const d=i.target;if(!d||d.classList.contains("slider"))return;const $=d.closest(".monaco-list-row");if(!$)return;const f=Number($.getAttribute("data-index")),h=$.classList.contains("option-disabled");f>=0&&f<this.m.length&&!h&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(i,d){const $=h=>{for(let F=0;F<h.childNodes.length;F++){const M=h.childNodes.item(F);(M.tagName&&M.tagName.toLowerCase())==="img"?h.removeChild(M):$(M)}},f=(0,W.$EQ)({value:i,supportThemeIcons:!0},{actionHandler:d});return f.element.classList.add("select-box-description-markdown"),$(f.element),f.element}gb(i){!this.f||!this.H||this.hb(i.indexes[0])}hb(i){this.I.innerText="";const d=this.m[i],$=d?.description??"",f=d?.descriptionIsMarkdown??!1;if($){if(f){const h=d.descriptionMarkdownActionHandler;this.I.appendChild(this.fb($,h))}else this.I.innerText=$;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(i){y.$0O.stop(i),this.select(this.F),this.X(!0)}jb(i){y.$0O.stop(i),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(i){if(this.n<this.m.length-1){y.$0O.stop(i,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(i){this.n>0&&(y.$0O.stop(i,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(i){y.$0O.stop(i),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(i){y.$0O.stop(i),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(i){y.$0O.stop(i),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(i){y.$0O.stop(i),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(i){const d=u.KeyCodeUtils.toString(i.keyCode);let $=-1;for(let f=0;f<this.m.length-1;f++)if($=(f+this.n+1)%this.m.length,this.m[$].text.charAt(0).toUpperCase()===d&&!this.m[$].isDisabled){this.select($),this.z.setFocus([$]),this.z.reveal(this.z.getFocus()[0]),y.$0O.stop(i);break}}dispose(){this.X(!1),super.dispose()}}t.$JQ=r}),define(be[126],$e([1,0,37,125,119,20,5,97]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MQ=t.$LQ=void 0,t.$LQ={...y.$AQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends W.$NP{constructor(u,c,L,s,a){super(),v.$j&&!a?.useCustomDrawn?this.a=new n.$KQ(u,c,s,a):this.a=new N.$JQ(u,c,L,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(u,c){this.a.setOptions(u,c)}select(u){this.a.select(u)}setAriaLabel(u){this.a.setAriaLabel(u)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(u){this.a.setFocusable(u)}render(u){this.a.render(u)}}t.$MQ=w}),define(be[61],$e([1,0,16,52,4,23,124,126,34,2,5,7,102,50]),function(le,t,y,N,n,W,v,w,o,u,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=void 0;class a extends u.$kc{get action(){return this._action}constructor(m,i,d={}){super(),this.m=d,this._context=m||this,this._action=i,i instanceof o.$gi&&this.B(i.onDidChange($=>{this.element&&this.t($)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new o.$hi)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const i=this.element=m;this.B(W.$JP.addTarget(m));const d=this.m&&this.m.draggable;d&&(m.draggable=!0,y.$0N&&this.B((0,n.$sO)(m,n.$8O.DRAG_START,$=>$.dataTransfer?.setData(N.$HP.TEXT,this._action.label)))),this.B((0,n.$sO)(i,W.EventType.Tap,$=>this.onClick($,!0))),this.B((0,n.$sO)(i,n.$8O.MOUSE_DOWN,$=>{d||n.$0O.stop($,!0),this._action.enabled&&$.button===0&&i.classList.add("active")})),c.$j&&this.B((0,n.$sO)(i,n.$8O.CONTEXT_MENU,$=>{$.button===0&&$.ctrlKey===!0&&this.onClick($)})),this.B((0,n.$sO)(i,n.$8O.CLICK,$=>{n.$0O.stop($,!0),this.m&&this.m.isMenu||this.onClick($)})),this.B((0,n.$sO)(i,n.$8O.DBLCLICK,$=>{n.$0O.stop($,!0)})),[n.$8O.MOUSE_UP,n.$8O.MOUSE_OUT].forEach($=>{this.B((0,n.$sO)(i,$,f=>{n.$0O.stop(f),i.classList.remove("active")}))})}onClick(m,i=!1){n.$0O.stop(m,!0);const d=L.$sf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:i}:this._context;this.actionRunner.run(this._action,d)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,v.$5P)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$RQ=a;class e extends a{constructor(m,i,d){super(m,i,d),this.m=d,this.m.icon=d.icon!==void 0?d.icon:!1,this.m.label=d.label!==void 0?d.label:!0,this.J=""}render(m){super.render(m),this.element&&(this.H=(0,n.$cP)(this.element,(0,n.$)("a.action-label"))),this.H&&this.H.setAttribute("role",this.L()),this.m.label&&this.m.keybinding&&this.element&&((0,n.$cP)(this.element,(0,n.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===o.$ii.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$SQ=e;class l extends a{constructor(m,i,d,$,f,h,F){super(m,i),this.b=new w.$MQ(d,$,f,h,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,i){this.b.setOptions(m,i)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,i){this.actionRunner.run(this._action,this.r(m,i))}r(m,i){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$TQ=l}),define(be[62],$e([1,0,4,14,61,34,3,2,7,50]),function(le,t,y,N,n,W,v,w,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7P=t.$6P=t.ActionsOrientation=void 0;var u;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(u||(t.ActionsOrientation=u={}));class c extends w.$kc{constructor(a,e={}){super(),this.g=this.B(new w.$jc),this.r=this.B(new w.$sc),this.w=!1,this.y=!0,this.C=this.B(new v.$fd),this.onDidBlur=this.C.event,this.D=this.B(new v.$fd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new v.$fd),this.onDidRun=this.G.event,this.H=this.B(new v.$fd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new W.$hi,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let l,r;switch(this.m){case 0:l=[15],r=[17];break;case 1:l=[16],r=[18],this.domNode.className+=" vertical";break}this.B(y.$sO(this.domNode,y.$8O.KEY_DOWN,m=>{const i=new N.$oO(m);let d=!0;const $=typeof this.t=="number"?this.viewItems[this.t]:void 0;l&&(i.equals(l[0])||i.equals(l[1]))?d=this.P():r&&(i.equals(r[0])||i.equals(r[1]))?d=this.O():i.equals(9)&&this.F?this.D.fire():i.equals(14)?d=this.M():i.equals(13)?d=this.N():i.equals(2)&&$ instanceof n.$RQ&&$.trapsArrowNavigation?d=this.O():this.J(i)?this.n.keyDown?this.R(i):this.w=!0:d=!1,d&&(i.preventDefault(),i.stopPropagation())})),this.B(y.$sO(this.domNode,y.$8O.KEY_UP,m=>{const i=new N.$oO(m);this.J(i)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(i)),i.preventDefault(),i.stopPropagation()):(i.equals(2)||i.equals(1026))&&this.L()})),this.u=this.B(y.$aP(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$1O()===this.domNode||!y.$SO(y.$1O(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(l=>l instanceof n.$RQ&&l.isEnabled());e instanceof n.$RQ&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$RQ&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(l=>{e=e||a.equals(l)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(y.$SO(y.$1O(),e)){this.t=a;break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const l=Array.isArray(a)?a:[a];let r=o.$nf(e.index)?e.index:null;l.forEach(m=>{const i=document.createElement("li");i.className="action-item",i.setAttribute("role","presentation");let d;const $={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(d=this.b.actionViewItemProvider(m,$)),d||(d=new n.$SQ(this.context,m,$)),this.b.allowContextMenu||this.r.set(d,y.$sO(i,y.$8O.CONTEXT_MENU,f=>{y.$0O.stop(f,!0)})),d.actionRunner=this.f,d.setActionContext(this.context),d.render(i),this.y&&d instanceof n.$RQ&&this.viewItems.length===0&&d.setFocusable(!0),r===null||r<0||r>=this.z.children.length?(this.z.appendChild(i),this.viewItems.push(d)):(this.z.insertBefore(i,this.z.children[r]),this.viewItems.splice(r,0,d),r++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,w.$fc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,w.$fc)(this.viewItems),this.r.clearAndDisposeAll(),y.$qO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,l;if(a===void 0?e=!0:typeof a=="number"?l=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const r=this.viewItems.findIndex(m=>m.isEnabled());this.t=r===-1?void 0:r,this.Q(void 0,void 0,!0)}else l!==void 0&&(this.t=l),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let l;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,l=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!l.isEnabled()||l.action.id===W.$ii.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let l;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}l=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!l.isEnabled()||l.action.id===W.$ii.ID));return this.Q(!0),!0}Q(a,e,l=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const r=this.t!==void 0&&this.viewItems[this.t];if(r){let m=!0;o.$xf(r.focus)||(m=!1),this.b.focusOnlyEnabledItems&&o.$xf(r.isEnabled)&&!r.isEnabled()&&(m=!1),r.action.id===W.$ii.ID&&(m=!1),m?(l||this.s!==this.t)&&(r.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$RQ){const l=e._context===null||e._context===void 0?a:e._context;this.run(e._action,l)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,w.$fc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$6P=c;function L(s){if(!s.length)return s;let a=-1;for(let l=0;l<s.length;l++)if(s[l].id!==W.$ii.ID){a=l;break}if(a===-1)return[];s=s.slice(a);for(let l=s.length-1;l>=0&&s[l].id===W.$ii.ID;l--)s.splice(l,1);let e=!1;for(let l=s.length-1;l>=0;l--){const r=s[l].id===W.$ii.ID;r&&!e?s.splice(l,1):r?r&&(e=!1):e=!0}return s}t.$7P=L}),define(be[63],$e([1,0,4,21,53,62,55,58,20,3,79,49,106,94]),function(le,t,y,N,n,W,v,w,o,u,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=t.MessageType=void 0;const a=y.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$wR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends o.$NP{constructor(i,d,$){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new u.$fd),this.onDidChange=this.O.event,this.P=this.B(new u.$fd),this.onDidHeightChange=this.P.event,this.a=d,this.g=$,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$cP(i,a(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",h=y.$cP(this.element,a(".ibwrapper"));if(this.b=y.$cP(h,a(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$cP(h,a("div.mirror")),this.y.innerText="\xA0",this.N=new w.$XP(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$cP(i,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(I=>this.b.scrollTop=I.scrollTop));const F=this.B(new N.$bQ(document,"selectionchange")),M=u.Event.filter(F.event,()=>document.getSelection()?.anchorNode===h);this.B(M(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new W.$6P(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(i){this.n=i,this.b.setAttribute("placeholder",i)}setTooltip(i){this.r=i,this.b.title=i}setAriaLabel(i){this.s=i,i?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(i){this.b.value!==i&&(this.b.value=i,this.Y())}get step(){return this.b.step}set step(i){this.b.step=i}get height(){return typeof this.J=="number"?this.J:y.$QO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(i=null){this.b.select(),i&&(this.b.setSelectionRange(i.start,i.end),i.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(i){i?this.enable():this.disable()}get width(){return y.$MO(this.b)}set width(i){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const $=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;d=$+f}this.b.style.width=i-d+"px"}else this.b.style.width=i+"px";this.y&&(this.y.style.width=i+"px")}set paddingRight(i){this.b.style.width=`calc(100% - ${i}px)`,this.y&&(this.y.style.paddingRight=i+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const i=this.L,d=this.J,$=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:i,height:d}),this.N.setScrollPosition({scrollTop:$})}showMessage(i,d){if(this.w==="open"&&(0,L.$Zm)(this.h,i))return;this.h=i,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(i.type));const $=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$uP($.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let i=null;return this.t&&(i=this.t(this.value),i?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(i)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),i?.type}stylesForType(i){const d=this.g.inputBoxStyles;switch(i){case 1:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case 2:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}U(i){switch(i){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let i;const d=()=>i.style.width=y.$MO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;i=y.$cP(f,a(".monaco-inputbox-container")),d();const h={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,n.$_P)(this.h.content,h):(0,n.$$P)(this.h.content,h);F.classList.add(this.U(this.h.type));const M=this.stylesForType(this.h.type);return F.style.backgroundColor=M.background??"",F.style.color=M.foreground??"",F.style.border=M.border?`1px solid ${M.border}`:"",y.$cP(i,F),null},onHide:()=>{this.w="closed"},layout:d});let $;this.h.type===3?$=s.localize(0,null,this.h.content):this.h.type===2?$=s.localize(1,null,this.h.content):$=s.localize(2,null,this.h.content),v.$dQ($),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const i=this.value,$=i.charCodeAt(i.length-1)===10?" ":"";(i+$).replace(/\u000c/g,"")?this.y.textContent=i+$:this.y.innerText="\xA0",this.layout()}ab(){const i=this.g.inputBoxStyles,d=i.inputBackground??"",$=i.inputForeground??"",f=i.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=$,this.b.style.backgroundColor="inherit",this.b.style.color=$,this.element.style.border=`1px solid ${y.$uP(f,"transparent")}`}layout(){if(!this.y)return;const i=this.L;this.L=y.$QO(this.y),i!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(i){const d=this.inputElement,$=d.selectionStart,f=d.selectionEnd,h=d.value;$!==null&&f!==null&&(this.value=h.substr(0,$)+i+h.substr(f),d.setSelectionRange($+1,$+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$xR=l;class r extends l{constructor(i,d,$){const f=s.localize(3,null),h=` or \u21C5 ${f}`,F=` (\u21C5 ${f})`;super(i,d,$),this.db=this.B(new u.$fd),this.onDidFocus=this.db.event,this.eb=this.B(new u.$fd),this.onDidBlur=this.eb.event,this.bb=new c.$uR($.history,100);const M=()=>{if($.showHistoryHint&&$.showHistoryHint()&&!this.n.endsWith(h)&&!this.n.endsWith(F)&&this.bb.getHistory().length){const I=this.n.endsWith(")")?h:F,b=this.n+I;$.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=b:this.setPlaceHolder(b)}};this.cb=new MutationObserver((I,b)=>{I.forEach(D=>{D.target.textContent||M()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>M()),this.F(this.b,()=>{const I=b=>{if(this.n.endsWith(b)){const D=this.n.slice(0,this.n.length-b.length);return $.showPlaceholderOnFocus?this.n=D:this.setPlaceHolder(D),!0}else return!1};I(F)||I(h)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(i){this.value&&(i||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(i){const d=this.getHistory();this.clearHistory(),i.forEach($=>{this.bb.add($)}),d.forEach($=>{this.bb.add($)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let i=this.jb();i&&(i=i===this.value?this.jb():i),this.value=i??"",v.$eQ(this.value?this.value:s.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let i=this.ib();i&&(i=i===this.value?this.ib():i),i&&(this.value=i,v.$eQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let i=this.bb.current();return i||(i=this.bb.last(),this.bb.next()),i}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$yR=r}),define(be[64],$e([1,0,61,20,17,18,3,99]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=t.$PQ=t.$OQ=t.$NQ=void 0,t.$NQ={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends y.$RQ{constructor(L,s,a){super(L,s,a),this.a=this.B(new o({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(L){this.element=L,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(L){this.a.domNode.tabIndex=L?0:-1}}t.$OQ=w;class o extends N.$NP{constructor(L){super(),this.a=this.B(new v.$fd),this.onChange=this.a.event,this.b=this.B(new v.$fd),this.onKeyDown=this.b.event,this.c=L,this.s=this.c.isChecked;const s=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,s.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&s.push(...this.c.actionClassName.split(" ")),this.s&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...s),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(L){this.s=L,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(L){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=L,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(L){this.domNode.title=L,this.domNode.setAttribute("aria-label",L)}}t.$PQ=o;class u extends N.$NP{constructor(L,s,a){super(),this.c=L,this.g=s,this.a=new o({title:this.c,isChecked:this.g,icon:n.$Pj.check,actionClassName:"monaco-checkbox",...t.$NQ}),this.domNode=this.a.domNode,this.b=a,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(L){this.a.checked=L,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$QQ=u}),define(be[127],$e([1,0,64,17,104]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LR=t.$KR=t.$JR=void 0;const W=n.localize(0,null),v=n.localize(1,null),w=n.localize(2,null);class o extends y.$PQ{constructor(s){super({icon:N.$Pj.caseSensitive,title:W+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$JR=o;class u extends y.$PQ{constructor(s){super({icon:N.$Pj.wholeWord,title:v+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$KR=u;class c extends y.$PQ{constructor(s){super({icon:N.$Pj.regex,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$LR=c}),define(be[128],$e([1,0,4,127,63,20,3,103,2,93]),function(le,t,y,N,n,W,v,w,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MR=void 0;const u=w.localize(0,null);class c extends W.$NP{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new o.$lc),this.N=[],this.O=this.B(new v.$fd),this.onDidOptionChange=this.O.event,this.P=this.B(new v.$fd),this.onKeyDown=this.P.event,this.Q=this.B(new v.$fd),this.onMouseDown=this.Q.event,this.R=this.B(new v.$fd),this.onInput=this.R.event,this.S=this.B(new v.$fd),this.onKeyUp=this.S.event,this.U=this.B(new v.$fd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new v.$fd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||u,this.h=!!e.showCommonFindToggles;const l=e.appendCaseSensitiveLabel||"",r=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",i=e.history||[],d=!!e.flexibleHeight,$=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$yR(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:i,showHistoryHint:e.showHistoryHint,flexibleHeight:d,flexibleWidth:$,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new N.$LR({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new N.$KR({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$JR({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const h=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const M=h.indexOf(document.activeElement);if(M>=0){let I=-1;F.equals(17)?I=(M+1)%h.length:F.equals(15)&&(M===0?I=h.length-1:I=M-1),F.equals(9)?(h[M].blur(),this.inputBox.focus()):I>=0&&h[I].focus(),y.$0O.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(y.$sO(this.inputBox.inputElement,"compositionstart",h=>{this.s=!0})),this.B(y.$sO(this.inputBox.inputElement,"compositionend",h=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,h=>this.P.fire(h)),this.C(this.inputBox.inputElement,h=>this.S.fire(h)),this.D(this.inputBox.inputElement,h=>this.R.fire()),this.j(this.inputBox.inputElement,h=>this.Q.fire(h))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new o.$jc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$MR=c}),define(be[129],$e([1,0,4,21,14,62,128,63,59,37,64,56,24,34,11,9,17,18,41,3,32,2,45,7,108,100]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a,e,l,r,m,i,d,$,f,h,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kS=t.TreeFindMatchType=t.TreeFindMode=t.$jS=t.$iS=t.RenderIndentGuides=t.$hS=t.$gS=void 0;class I extends o.$oQ{set context(g){this.c.context=g}get context(){return this.c.context}constructor(g){super(g.elements.map(p=>p.element)),this.c=g}}function b(x){return x instanceof o.$oQ?new I(x):x}class D{constructor(g,p){this.d=g,this.f=p,this.b=f.$kc.None,this.c=new f.$jc}getDragURI(g){return this.f.getDragURI(g.element)}getDragLabel(g,p){if(this.f.getDragLabel)return this.f.getDragLabel(g.map(q=>q.element),p)}onDragStart(g,p){this.f.onDragStart?.(b(g),p)}onDragOver(g,p,q,T,O=!0){const P=this.f.onDragOver(b(g),p&&p.element,q,T),_=this.a!==p;if(_&&(this.b.dispose(),this.a=p),typeof p>"u")return P;if(_&&typeof P!="boolean"&&P.autoExpand&&(this.b=(0,l.$Ig)(()=>{const U=this.d(),K=U.getNodeLocation(p);U.isCollapsed(K)&&U.setCollapsed(K,!1),this.a=void 0},500,this.c)),typeof P=="boolean"||!P.accept||typeof P.bubble>"u"||P.feedback){if(!O){const U=typeof P=="boolean"?P:P.accept,K=typeof P=="boolean"?void 0:P.effect;return{accept:U,effect:K,feedback:[q]}}return P}if(P.bubble===1){const U=this.d(),K=U.getNodeLocation(p),te=U.getParentNodeLocation(K),se=U.getNode(te),me=te&&U.getListIndex(te);return this.onDragOver(g,se,me,T,!1)}const C=this.d(),R=C.getNodeLocation(p),A=C.getListIndex(R),k=C.getListRenderCount(R);return{...P,feedback:(0,e.$Qb)(A,A+k)}}drop(g,p,q,T){this.b.dispose(),this.a=void 0,this.f.drop(b(g),p&&p.element,q,T)}onDragEnd(g){this.f.onDragEnd?.(g)}dispose(){this.c.dispose(),this.f.dispose()}}function j(x,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(p){return g.identityProvider.getId(p.element)}},dnd:g.dnd&&new D(x,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return g.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return g.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(p){const q=x(),T=q.getNodeLocation(p),O=q.getParentNodeLocation(T);return q.getNode(O).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?p=>g.accessibilityProvider.isChecked(p.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?p=>g.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return g.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?p=>g.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(p=>g.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class H{constructor(g){this.a=g}getHeight(g){return this.a.getHeight(g.element)}getTemplateId(g){return this.a.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(g.element)}setDynamicHeight(g,p){this.a.setDynamicHeight?.(g.element,p)}}t.$gS=H;class B{static lift(g){return g instanceof B?g:new B(g)}static empty(g=0){return new B({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const p of g.expanded)this.expanded[p]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$hS=B;var E;(function(x){x.None="none",x.OnHover="onHover",x.Always="always"})(E||(t.RenderIndentGuides=E={}));class z{get elements(){return this.b}constructor(g,p=[]){this.b=p,this.a=new f.$jc,this.onDidChange=d.Event.forEach(g,q=>this.b=q,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(g,p,q,T,O,P={}){this.o=g,this.p=p,this.q=T,this.s=O,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$kc.None,this.m=new f.$jc,this.templateId=g.templateId,this.updateOptions(P),d.Event.map(q,_=>_.node)(this.u,this,this.m),g.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(g={}){if(typeof g.indent<"u"){const p=(0,h.$Hl)(g.indent,0,40);if(p!==this.d){this.d=p;for(const[q,T]of this.c)this.v(q,T)}}if(typeof g.renderIndentGuides<"u"){const p=g.renderIndentGuides!==E.None;if(p!==this.g){this.g=p;for(const[q,T]of this.c)this.w(q,T);if(this.k.dispose(),p){const q=new f.$jc;this.q.onDidChange(this.x,this,q),this.k=q,this.x(this.q.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.f=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const p=(0,y.$cP)(g,(0,y.$)(".monaco-tl-row")),q=(0,y.$cP)(p,(0,y.$)(".monaco-tl-indent")),T=(0,y.$cP)(p,(0,y.$)(".monaco-tl-twistie")),O=(0,y.$cP)(p,(0,y.$)(".monaco-tl-contents")),P=this.o.renderTemplate(O);return{container:g,indent:q,twistie:T,indentGuidesDisposable:f.$kc.None,templateData:P}}renderElement(g,p,q,T){this.c.set(g,q),this.b.set(g.element,g),this.v(g,q),this.o.renderElement(g,p,q.templateData,T)}disposeElement(g,p,q,T){q.indentGuidesDisposable.dispose(),this.o.disposeElement?.(g,p,q.templateData,T),typeof T=="number"&&(this.c.delete(g),this.b.delete(g.element))}disposeTemplate(g){this.o.disposeTemplate(g.templateData)}t(g){const p=this.b.get(g);p&&this.u(p)}u(g){const p=this.c.get(g);p&&(this.x(this.q.elements),this.v(g,p))}v(g,p){const q=X.a+(g.depth-1)*this.d;p.twistie.style.paddingLeft=`${q}px`,p.indent.style.width=`${q+this.d-16}px`,g.collapsible?p.container.setAttribute("aria-expanded",String(!g.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(r.$Pj.treeItemExpanded));let T=!1;this.o.renderTwistie&&(T=this.o.renderTwistie(g.element,p.twistie)),g.collapsible&&(!this.f||g.visibleChildrenCount>0)?(T||p.twistie.classList.add(...m.ThemeIcon.asClassNameArray(r.$Pj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",g.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(g,p)}w(g,p){if((0,y.$qO)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const q=new f.$jc,T=this.p();for(;;){const O=T.getNodeLocation(g),P=T.getParentNodeLocation(O);if(!P)break;const _=T.getNode(P),C=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&C.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(C):p.indent.insertBefore(C,p.indent.firstElementChild),this.s.add(_,C),q.add((0,f.$ic)(()=>this.s.delete(_,C))),g=_}p.indentGuidesDisposable=q}x(g){if(!this.g)return;const p=new Set,q=this.p();g.forEach(T=>{const O=q.getNodeLocation(T);try{const P=q.getParentNodeLocation(O);T.collapsible&&T.children.length>0&&!T.collapsed?p.add(T):P&&p.add(q.getNode(P))}catch{}}),this.j.forEach(T=>{p.has(T)||this.s.forEach(T,O=>O.classList.remove("active"))}),p.forEach(T=>{this.j.has(T)||this.s.forEach(T,O=>O.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$fc)(this.m)}}class ie{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(g){this.c=g,this.d=g.toLowerCase()}constructor(g,p,q){this.g=g,this.j=p,this.k=q,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$jc,g.onWillRefilter(this.m,this,this.f)}filter(g,p){let q=1;if(this.k){const P=this.k.filter(g,p);if(typeof P=="boolean"?q=P?1:0:(0,L.$dS)(P)?q=(0,L.$eS)(P.visibility):q=P,q===0)return!1}if(this.a++,!this.c)return this.b++,{data:$.FuzzyScore.Default,visibility:q};const T=this.j.getKeyboardNavigationLabel(g),O=Array.isArray(T)?T:[T];for(const P of O){const _=P&&P.toString();if(typeof _>"u")return{data:$.FuzzyScore.Default,visibility:q};let C;if(this.g.findMatchType===ge.Contiguous){const R=_.toLowerCase().indexOf(this.d);if(R>-1){C=[Number.MAX_SAFE_INTEGER,0];for(let A=this.d.length;A>0;A--)C.push(R+A-1)}}else C=(0,$.$Kj)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(C)return this.b++,O.length===1?{data:C,visibility:q}:{data:{label:_,score:C},visibility:q}}return this.g.findMode===re.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(g):2:{data:$.FuzzyScore.Default,visibility:q}}m(){this.a=0,this.b=0}dispose(){(0,f.$fc)(this.f)}}class ue extends c.$PQ{constructor(g){super({icon:r.$Pj.listFilter,title:(0,M.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$iS=ue;class ae extends c.$PQ{constructor(g){super({icon:r.$Pj.searchFuzzy,title:(0,M.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$jS=ae;const oe={inputBoxStyles:w.$wR,toggleStyles:c.$NQ,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var re;(function(x){x[x.Highlight=0]="Highlight",x[x.Filter=1]="Filter"})(re||(t.TreeFindMode=re={}));var ge;(function(x){x[x.Fuzzy=0]="Fuzzy",x[x.Contiguous=1]="Contiguous"})(ge||(t.TreeFindMatchType=ge={}));class Ce extends f.$kc{set mode(g){this.b.checked=g===re.Filter,this.f.inputBox.setPlaceHolder(g===re.Filter?(0,M.localize)(2,null):(0,M.localize)(3,null))}set matchType(g){this.c.checked=g===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(g){this.f.inputBox.value=g}constructor(g,p,q,T,O,P){super(),this.t=p,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new d.$fd,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.a.root),this.B((0,f.$ic)(()=>g.removeChild(this.a.root)));const _=P?.styles??oe;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new ue({..._.toggleStyles,isChecked:T===re.Filter})),this.c=this.B(new ae({..._.toggleStyles,isChecked:O===ge.Fuzzy})),this.onDidChangeMode=d.Event.map(this.b.onChange,()=>this.b.checked?re.Filter:re.Highlight,this.q),this.onDidChangeMatchType=d.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new v.$MR(this.a.findInput,q,{label:(0,M.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:P?.history})),this.g=this.B(new W.$6P(this.a.actionbar)),this.mode=T;const C=this.B(new N.$bQ(this.f.inputBox.inputElement,"keydown")),R=d.Event.chain(C.event,K=>K.map(te=>new n.$oO(te)));this.B(R(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const A=this.B(new a.$gi("close",(0,M.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(A,{icon:!0,label:!1});const k=this.B(new N.$bQ(this.a.grab,"mousedown"));this.B(k.event(K=>{const te=new f.$jc,se=te.add(new N.$bQ(window,"mousemove")),me=te.add(new N.$bQ(window,"mouseup")),we=this.m,Ne=K.pageX,Ee=this.s,ve=K.pageY;this.a.grab.classList.add("grabbing");const Te=this.a.root.style.transition;this.a.root.style.transition="unset";const Pe=We=>{const je=We.pageX-Ne;this.m=we-je;const Ie=We.pageY-ve;this.s=Ee+Ie,this.layout()};te.add(se.event(Pe)),te.add(me.event(We=>{Pe(We),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Te,te.dispose()}))}));const U=d.Event.chain(this.B(new N.$bQ(this.a.grab,"keydown")).event,K=>K.map(te=>new n.$oO(te)));this.B(U(K=>{let te,se;if(K.keyCode===15?te=Number.POSITIVE_INFINITY:K.keyCode===17?te=0:K.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(K.preventDefault(),K.stopPropagation(),this.m=te,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.s=se;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(g=this.j){this.j=g,this.m=(0,h.$Hl)(this.m,0,Math.max(0,g-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,h.$Hl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(g){this.f.showMessage(g)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,l.$Hg)(300),super.dispose()}}class Fe{get pattern(){return this.b}get mode(){return this.d}set mode(g){g!==this.d&&(this.d=g,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(g))}get matchType(){return this.f}set matchType(g){g!==this.f&&(this.f=g,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(g))}constructor(g,p,q,T,O,P={}){this.t=g,this.u=q,this.v=T,this.w=O,this.x=P,this.b="",this.c="",this.j=0,this.k=new d.$fd,this.onDidChangeMode=this.k.event,this.m=new d.$fd,this.onDidChangeMatchType=this.m.event,this.o=new d.$fd,this.onDidChangePattern=this.o.event,this.p=new d.$fd,this.onDidChangeOpenState=this.p.event,this.q=new f.$jc,this.s=new f.$jc,this.d=g.options.defaultFindMode??re.Highlight,this.f=g.options.defaultFindMatchType??ge.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(g=>this.mode=g,void 0,this.q),this.g.onDidChangeMatchType(g=>this.matchType=g,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(g){this.b=g,this.o.fire(g),this.v.pattern=g,this.t.refilter(),g&&this.t.focusNext(0,!0,void 0,q=>!$.FuzzyScore.isDefault(q.filterData));const p=this.t.getFocus();if(p.length>0){const q=p[0];this.t.getRelativeTop(q)===null&&this.t.reveal(q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const g=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&g?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,M.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(g){return!this.g||!this.pattern||this.d===re.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!$.FuzzyScore.isDefault(g.filterData)}layout(g){this.j=g,this.g?.layout(g)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(x){let g=s.TreeMouseEventTarget.Unknown;return(0,y.$WO)(x.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=s.TreeMouseEventTarget.Twistie:(0,y.$WO)(x.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=s.TreeMouseEventTarget.Element:(0,y.$WO)(x.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=s.TreeMouseEventTarget.Filter),{browserEvent:x.browserEvent,element:x.element?x.element.element:null,target:g}}function fe(x){return{element:x.element?x.element.element:null,browserEvent:x.browserEvent,anchor:x.anchor}}function ne(x,g){g(x),x.children.forEach(p=>ne(p,g))}class Q{get f(){return this.d||(this.d=this.m()),this.d}constructor(g,p){this.g=g,this.j=p,this.a=[],this.c=new d.$fd,this.onDidChange=this.c.event}set(g,p){!p?.__forceEvent&&(0,e.$sb)(this.a,g)||this.k(g,!1,p)}k(g,p,q){if(this.a=[...g],this.b=void 0,this.d=void 0,!p){const T=this;this.c.fire({get elements(){return T.get()},browserEvent:q})}}get(){return this.b||(this.b=this.a.map(g=>g.element)),[...this.b]}getNodes(){return this.a}has(g){return this.f.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:p}){if(!this.j){const C=this.m(),R=A=>C.delete(A);p.forEach(A=>ne(A,R)),this.set([...C.values()]);return}const q=new Set,T=C=>q.add(this.j.getId(C.element).toString());p.forEach(C=>ne(C,T));const O=new Map,P=C=>O.set(this.j.getId(C.element).toString(),C);g.forEach(C=>ne(C,P));const _=[];for(const C of this.a){const R=this.j.getId(C.element).toString();if(!q.has(R))_.push(C);else{const k=O.get(R);k&&k.visible&&_.push(k)}}if(this.a.length>0&&_.length===0){const C=this.g();C&&_.push(C)}this.k(_,!0)}m(){const g=new Set;for(const p of this.a)g.add(p);return g}}class V extends u.$yQ{constructor(g,p){super(g),this.x=p}u(g){if((0,u.$uQ)(g.browserEvent.target)||(0,u.$sQ)(g.browserEvent.target)||(0,u.$tQ)(g.browserEvent.target)||g.browserEvent.isHandledByList)return;const p=g.element;if(!p)return super.u(g);if(this.p(g)||this.o(g))return super.u(g);const q=g.browserEvent.target,T=q.classList.contains("monaco-tl-twistie")||q.classList.contains("monaco-icon-label")&&q.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let O=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?O=this.x.expandOnlyOnTwistieClick(p.element):O=!!this.x.expandOnlyOnTwistieClick,O&&!T&&g.browserEvent.detail!==2)return super.u(g);if(!this.x.expandOnDoubleClick&&g.browserEvent.detail===2)return super.u(g);if(p.collapsible){const P=this.x.getNodeLocation(p),_=g.browserEvent.altKey;if(this.x.setFocus([P]),this.x.toggleCollapsed(P,_),O&&T){g.browserEvent.isHandledByList=!0;return}}super.u(g)}v(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||g.browserEvent.isHandledByList||super.v(g)}}class ee extends u.$BQ{constructor(g,p,q,T,O,P,_,C){super(g,p,q,T,C),this.p=O,this.s=P,this.K=_}D(g){return new V(this,g.tree)}splice(g,p,q=[]){if(super.splice(g,p,q),q.length===0)return;const T=[],O=[];let P;q.forEach((_,C)=>{this.p.has(_)&&T.push(g+C),this.s.has(_)&&O.push(g+C),this.K.has(_)&&(P=g+C)}),T.length>0&&super.setFocus((0,e.$Kb)([...super.getFocus(),...T])),O.length>0&&super.setSelection((0,e.$Kb)([...super.getSelection(),...O])),typeof P=="number"&&super.setAnchor(P)}setFocus(g,p,q=!1){super.setFocus(g,p),q||this.p.set(g.map(T=>this.element(T)),p)}setSelection(g,p,q=!1){super.setSelection(g,p),q||this.s.set(g.map(T=>this.element(T)),p)}setAnchor(g,p=!1){super.setAnchor(g),p||(typeof g>"u"?this.K.set([]):this.K.set([this.element(g)]))}}class J{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return d.Event.map(this.j.onMouseClick,Me)}get onMouseDblClick(){return d.Event.filter(d.Event.map(this.j.onMouseDblClick,Me),g=>g.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return d.Event.map(this.j.onContextMenu,fe)}get onTap(){return d.Event.map(this.j.onTap,Me)}get onPointer(){return d.Event.map(this.j.onPointer,Me)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return d.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??re.Highlight}set findMode(g){this.x&&(this.x.mode=g)}get findMatchType(){return this.x?.matchType??ge.Fuzzy}set findMatchType(g){this.x&&(this.x.matchType=g)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:d.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(g,p,q,T,O={}){this.D=g,this.E=O,this.w=new d.$nd,this.onDidChangeFindOpenState=d.Event.None,this.A=new f.$jc,this.B=new d.$fd,this.onWillRefilter=this.B.event,this.C=new d.$fd,this.onDidUpdateOptions=this.C.event;const P=new H(q),_=new d.$od,C=new d.$od,R=this.A.add(new z(C.event)),A=new i.$L;this.k=T.map(se=>new X(se,()=>this.o,_.event,R,A,O));for(const se of this.k)this.A.add(se);let k;O.keyboardNavigationLabelProvider&&(k=new ie(this,O.keyboardNavigationLabelProvider,O.filter),O={...O,filter:k},this.A.add(k)),this.p=new Q(()=>this.j.getFocusedElements()[0],O.identityProvider),this.q=new Q(()=>this.j.getSelectedElements()[0],O.identityProvider),this.u=new Q(()=>this.j.getAnchorElement(),O.identityProvider),this.j=new ee(g,p,P,this.k,this.p,this.q,this.u,{...j(()=>this.o,O),tree:this}),this.o=this.I(g,this.j,O),_.input=this.o.onDidChangeCollapseState;const U=d.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);U(()=>null,null,this.A);const K=this.A.add(new d.$fd),te=this.A.add(new l.$Dg(0));if(this.A.add(d.Event.any(U,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const me of this.p.getNodes())se.add(me);for(const me of this.q.getNodes())se.add(me);K.fire([...se.values()])})})),C.input=K.event,O.keyboardSupport!==!1){const se=d.Event.chain(this.j.onKeyDown,me=>me.filter(we=>!(0,u.$sQ)(we.target)).map(we=>new n.$oO(we)));d.Event.chain(se,me=>me.filter(we=>we.keyCode===15))(this.F,this,this.A),d.Event.chain(se,me=>me.filter(we=>we.keyCode===17))(this.G,this,this.A),d.Event.chain(se,me=>me.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((O.findWidgetEnabled??!0)&&O.keyboardNavigationLabelProvider&&O.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Fe(this,this.o,this.j,k,O.contextViewProvider,se),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=d.Event.None,this.onDidChangeFindMatchType=d.Event.None;this.z=(0,y.$3O)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===E.Always)}updateOptions(g={}){this.E={...this.E,...g};for(const p of this.k)p.updateOptions(g);this.j.updateOptions(this.E),this.x?.updateOptions(g),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===E.Always)}get options(){return this.E}updateWidth(g){const p=this.o.getListIndex(g);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(g){this.j.scrollTop=g}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(g){this.j.scrollLeft=g}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const g=this.j.firstVisibleIndex;return g<0||g>=this.j.length?void 0:this.j.element(g).element}get lastVisibleElement(){const g=this.j.lastVisibleIndex;return this.j.element(g).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(g){this.j.ariaLabel=g}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,p){this.j.layout(g,p),(0,F.$nf)(p)&&this.x?.layout(p)}style(g){const p=`.${this.j.domId}`,q=[];g.treeIndentGuidesStroke&&(q.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),q.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.z.textContent=q.join(`
`),this.j.style(g)}getParentElement(g){const p=this.o.getParentNodeLocation(g);return this.o.getNode(p).element}getFirstElementChild(g){return this.o.getFirstElementChild(g)}getNode(g){return this.o.getNode(g)}getNodeLocation(g){return this.o.getNodeLocation(g)}collapse(g,p=!1){return this.o.setCollapsed(g,!0,p)}expand(g,p=!1){return this.o.setCollapsed(g,!1,p)}toggleCollapsed(g,p=!1){return this.o.setCollapsed(g,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(g){return this.o.isCollapsible(g)}setCollapsible(g,p){return this.o.setCollapsible(g,p)}isCollapsed(g){return this.o.isCollapsed(g)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(g){if(typeof g>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(g);this.u.set([p]);const q=this.o.getListIndex(g);q>-1&&this.j.setAnchor(q,!0)}getAnchor(){return(0,e.$Mb)(this.u.get(),void 0)}setSelection(g,p){const q=g.map(O=>this.o.getNode(O));this.q.set(q,p);const T=g.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setSelection(T,p,!0)}getSelection(){return this.q.get()}setFocus(g,p){const q=g.map(O=>this.o.getNode(O));this.p.set(q,p);const T=g.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setFocus(T,p,!0)}focusNext(g=1,p=!1,q,T=this.y){this.j.focusNext(g,p,q,T)}focusPrevious(g=1,p=!1,q,T=this.y){this.j.focusPrevious(g,p,q,T)}focusNextPage(g,p=this.y){return this.j.focusNextPage(g,p)}focusPreviousPage(g,p=this.y){return this.j.focusPreviousPage(g,p)}focusLast(g,p=this.y){this.j.focusLast(g,p)}focusFirst(g,p=this.y){this.j.focusFirst(g,p)}getFocus(){return this.p.get()}reveal(g,p){this.o.expandTo(g);const q=this.o.getListIndex(g);q!==-1&&this.j.reveal(q,p)}getRelativeTop(g){const p=this.o.getListIndex(g);return p===-1?null:this.j.getRelativeTop(p)}getViewState(g=this.options.identityProvider){if(!g)throw new s.$bS(this.D,"Can't get tree view state without an identity provider");const p=P=>g.getId(P).toString(),q=B.empty(this.scrollTop);for(const P of this.getFocus())q.focus.add(p(P));for(const P of this.getSelection())q.selection.add(p(P));const T=this.o.getNode(),O=[T];for(;O.length>0;){const P=O.shift();P!==T&&P.collapsible&&(q.expanded[p(P.element)]=P.collapsed?0:1),O.push(...P.children)}return q}F(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q);if(!this.o.setCollapsed(T,!0)){const P=this.o.getParentNodeLocation(T);if(!P)return;const _=this.o.getListIndex(P);this.j.reveal(_),this.j.setFocus([_])}}G(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q);if(!this.o.setCollapsed(T,!1)){if(!q.children.some(C=>C.visible))return;const[P]=this.j.getFocus(),_=P+1;this.j.reveal(_),this.j.setFocus([_])}}H(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const q=p[0],T=this.o.getNodeLocation(q),O=g.browserEvent.altKey;this.o.setCollapsed(T,void 0,O)}navigate(g){return new S(this.j,this.o,g)}dispose(){(0,f.$fc)(this.A),this.j.dispose()}}t.$kS=J;class S{constructor(g,p,q){this.b=g,this.c=p,q?this.a=this.c.getListIndex(q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],$e([1,0,129,120,24,26]),function(le,t,y,N,n,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vS=void 0;class v extends y.$kS{constructor(o,u,c,L,s,a={}){super(o,u,c,L,a),this.f=o,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(o,u){if(u&&!this.c)throw new n.$bS(this.f,"Can't restore tree view state without an identity provider");if(this.b=o,!o){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!u){this.m(o);return}const c=[],L=[],s=e=>{const l=this.c.getId(e).toString();return!u.expanded[l]},a=e=>{const l=this.c.getId(e.element).toString();u.focus.has(l)&&c.push(e.element),u.selection.has(l)&&L.push(e.element)};this.m(o,s,a),this.setFocus(c),this.setSelection(L),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(o=this.b){if(typeof this.b>"u")throw new n.$bS(this.f,"Tree input not set");let u;this.c&&(u=c=>{const L=this.c.getId(c).toString(),s=this.d.get(L);if(s)return s.collapsed}),this.m(o,u)}resort(o=this.b,u=!0){this.o.resort(o===this.b?null:o,u)}refresh(o){if(o===void 0){this.j.rerender();return}this.o.rerender(o)}m(o,u,c){let L;if(this.c){const s=new Set,a=c;c=e=>{const l=this.c.getId(e.element).toString();s.add(l),this.d.set(l,e),a?.(e)},L=e=>{const l=this.c.getId(e.element).toString();s.has(l)||this.d.delete(l)}}this.o.setChildren(o===this.b?null:o,this.s(o,u).elements,{onDidCreateNode:c,onDidDeleteNode:L})}s(o,u){const c=[...this.g.getChildren(o)];return{elements:W.Iterable.map(c,s=>{const{elements:a,size:e}=this.s(s,u),l=this.g.hasChildren?this.g.hasChildren(s):void 0,r=e===0?void 0:u&&u(s);return{element:s,children:a,collapsible:l,collapsed:r}}),size:c.length}}I(o,u,c){return new N.$lS(o,u,c)}}t.$vS=v}),define(be[65],$e([1,0,11,9,31,27,25,6,3,2,51,12,7]),function(le,t,y,N,n,W,v,w,o,u,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kh=t.ProxyChannel=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.RequestInitiator=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=void 0;var a;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(a||(a={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(l||(l={}));function r(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(m||(m={}));function i(fe){let ne=0;for(let Q=0;;Q+=7){const V=fe.read(1);if(ne|=(V.buffer[0]&127)<<Q,!(V.buffer[0]&128))return ne}}const d=M(0);function $(fe,ne){if(ne===0){fe.write(d);return}let Q=0;for(let ee=ne;ee!==0;ee=ee>>>7)Q++;const V=n.$Fd.alloc(Q);for(let ee=0;ne!==0;ee++)V.buffer[ee]=ne&127,ne=ne>>>7,ne>0&&(V.buffer[ee]|=128);fe.write(V)}class f{constructor(ne){this.b=ne,this.a=0}read(ne){const Q=this.b.slice(this.a,this.a+ne);return this.a+=Q.byteLength,Q}}t.$_g=f;class h{constructor(){this.a=[]}get buffer(){return n.$Fd.concat(this.a)}write(ne){this.a.push(ne)}}t.$ah=h;var F;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(F||(F={}));function M(fe){const ne=n.$Fd.alloc(1);return ne.writeUInt8(fe,0),ne}const I={Undefined:M(F.Undefined),String:M(F.String),Buffer:M(F.Buffer),VSBuffer:M(F.VSBuffer),Array:M(F.Array),Object:M(F.Object),Uint:M(F.Int)},b=typeof Buffer<"u";function D(fe,ne){if(typeof ne>"u")fe.write(I.Undefined);else if(typeof ne=="string"){const Q=n.$Fd.fromString(ne);fe.write(I.String),$(fe,Q.byteLength),fe.write(Q)}else if(b&&Buffer.isBuffer(ne)){const Q=n.$Fd.wrap(ne);fe.write(I.Buffer),$(fe,Q.byteLength),fe.write(Q)}else if(ne instanceof n.$Fd)fe.write(I.VSBuffer),$(fe,ne.byteLength),fe.write(ne);else if(Array.isArray(ne)){fe.write(I.Array),$(fe,ne.length);for(const Q of ne)D(fe,Q)}else if(typeof ne=="number"&&(ne|0)===ne)fe.write(I.Uint),$(fe,ne);else{const Q=n.$Fd.fromString(JSON.stringify(ne));fe.write(I.Object),$(fe,Q.byteLength),fe.write(Q)}}t.$bh=D;function j(fe){switch(fe.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return fe.read(i(fe)).toString();case F.Buffer:return fe.read(i(fe)).buffer;case F.VSBuffer:return fe.read(i(fe));case F.Array:{const Q=i(fe),V=[];for(let ee=0;ee<Q;ee++)V.push(j(fe));return V}case F.Object:return JSON.parse(fe.read(i(fe)).toString());case F.Int:return i(fe)}}t.$ch=j;class H{constructor(ne,Q,V=null,ee=1e3){this.h=ne,this.j=Q,this.k=V,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(ne,Q){this.b.set(ne,Q),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const Q=this.o([ne.type]);this.k?.logOutgoing(Q,0,1,r(ne.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(Q,ne.id,1,r(ne.type),ne.data);return}}}o(ne,Q=void 0){const V=new h;return D(V,ne),D(V,Q),this.p(V.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const Q=new f(ne),V=j(Q),ee=j(Q),J=V[0];switch(J){case 100:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}: ${V[2]}.${V[3]}`,ee),this.s({type:J,id:V[1],channelName:V[2],name:V[3],arg:ee});case 102:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}: ${V[2]}.${V[3]}`,ee),this.t({type:J,id:V[1],channelName:V[2],name:V[3],arg:ee});case 101:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}`),this.u({type:J,id:V[1]});case 103:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(J)}`),this.u({type:J,id:V[1]})}}s(ne){const Q=this.b.get(ne.channelName);if(!Q){this.v(ne);return}const V=new W.$pd;let ee;try{ee=Q.call(this.j,ne.name,ne.arg,V.token)}catch(x){ee=Promise.reject(x)}const J=ne.id;ee.then(x=>{this.m({id:J,data:x,type:201})},x=>{x instanceof Error?this.m({id:J,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:J,data:x,type:203})}).finally(()=>{S.dispose(),this.d.delete(ne.id)});const S=(0,u.$ic)(()=>V.cancel());this.d.set(ne.id,S)}t(ne){const Q=this.b.get(ne.channelName);if(!Q){this.v(ne);return}const V=ne.id,J=Q.listen(this.j,ne.name,ne.arg)(S=>this.m({id:V,data:S,type:204}));this.d.set(ne.id,J)}u(ne){const Q=this.d.get(ne.id);Q&&(Q.dispose(),this.d.delete(ne.id))}v(ne){let Q=this.g.get(ne.channelName);Q||(Q=[],this.g.set(ne.channelName,Q));const V=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:ne,timeoutTimer:V})}w(ne){const Q=this.g.get(ne);if(Q){for(const V of Q)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$fc)(this.d.values()),this.d.clear()}}t.$dh=H;var B;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(B||(t.RequestInitiator=B={}));class E{constructor(ne,Q=null){this.l=ne,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new o.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=Q}getChannel(ne){const Q=this;return{call(V,ee,J){return Q.a?Promise.reject(new w.$3):Q.m(ne,V,ee,J)},listen(V,ee){return Q.a?o.Event.None:Q.o(ne,V,ee)}}}m(ne,Q,V,ee=W.CancellationToken.None){const J=this.g++,x={id:J,type:100,channelName:ne,name:Q,arg:V};if(ee.isCancellationRequested)return Promise.reject(new w.$3);let g;return new Promise((q,T)=>{if(ee.isCancellationRequested)return T(new w.$3);const O=()=>{const R=A=>{switch(A.type){case 201:this.f.delete(J),q(A.data);break;case 202:{this.f.delete(J);const k=new Error(A.data.message);k.stack=Array.isArray(A.data.stack)?A.data.stack.join(`
`):A.data.stack,k.name=A.data.name,T(k);break}case 203:this.f.delete(J),T(A.data);break}};this.f.set(J,R),this.p(x)};let P=null;this.b===m.Idle?O():(P=(0,N.$ug)(R=>this.u()),P.then(()=>{P=null,O()}));const _=()=>{P?(P.cancel(),P=null):this.p({id:J,type:101}),T(new w.$3)},C=ee.onCancellationRequested(_);g=(0,u.$hc)((0,u.$ic)(_),C),this.d.add(g)}).finally(()=>{g.dispose(),this.d.delete(g)})}o(ne,Q,V){const ee=this.g++,S={id:ee,type:102,channelName:ne,name:Q,arg:V};let x=null;const g=new o.$fd({onWillAddFirstListener:()=>{x=(0,N.$ug)(q=>this.u()),x.then(()=>{x=null,this.d.add(g),this.p(S)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(g),this.p({id:ee,type:103}))}}),p=q=>g.fire(q.data);return this.f.set(ee,p),g.event}p(ne){switch(ne.type){case 100:case 102:{const Q=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(Q,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const Q=this.q([ne.type,ne.id]);this.j?.logOutgoing(Q,ne.id,0,e(ne.type));return}}}q(ne,Q=void 0){const V=new h;return D(V,ne),D(V,Q),this.r(V.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const Q=new f(ne),V=j(Q),ee=j(Q),J=V[0];switch(J){case 200:return this.j?.logIncoming(ne.byteLength,0,0,r(J)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,V[1],0,r(J),ee),this.t({type:V[0],id:V[1],data:ee})}}t(ne){if(ne.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return o.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$fc)(this.d.values()),this.d.clear()}}t.$eh=E,Qe([v.$6g],E.prototype,"onDidInitializePromise",null);class z{get connections(){const ne=[];return this.f.forEach(Q=>ne.push(Q)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new o.$fd,this.onDidAddConnection=this.g.event,this.h=new o.$fd,this.onDidRemoveConnection=this.h.event,this.j=new u.$jc,this.j.add(ne(({protocol:Q,onDidClientDisconnect:V})=>{const ee=o.Event.once(Q.onMessage);this.j.add(ee(J=>{const S=new f(J),x=j(S),g=new H(Q,x),p=new E(Q);this.a.forEach((T,O)=>g.registerChannel(O,T));const q={channelServer:g,channelClient:p,ctx:x};this.f.add(q),this.g.fire(q),this.j.add(V(()=>{g.dispose(),p.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(ne,Q){const V=this;return{call(ee,J,S){let x;if((0,s.$xf)(Q)){const p=(0,y.$2b)(V.connections.filter(Q));x=p?Promise.resolve(p):o.Event.toPromise(o.Event.filter(V.onDidAddConnection,Q))}else x=Q.routeCall(V,ee,J);const g=x.then(p=>p.channelClient.getChannel(ne));return ie(g).call(ee,J,S)},listen(ee,J){if((0,s.$xf)(Q))return V.k(ne,Q,ee,J);const S=Q.routeEvent(V,ee,J).then(x=>x.channelClient.getChannel(ne));return ie(S).listen(ee,J)}}}k(ne,Q,V,ee){const J=this;let S;const x=new o.$fd({onWillAddFirstListener:()=>{S=new u.$jc;const g=new o.$ld,p=new Map,q=O=>{const _=O.channelClient.getChannel(ne).listen(V,ee),C=g.add(_);p.set(O,C)},T=O=>{const P=p.get(O);P&&(P.dispose(),p.delete(O))};J.connections.filter(Q).forEach(q),o.Event.filter(J.onDidAddConnection,Q)(q,void 0,S),J.onDidRemoveConnection(T,void 0,S),g.event(x.fire,x,S),S.add(g)},onDidRemoveLastListener:()=>{S?.dispose(),S=void 0}});return x.event}registerChannel(ne,Q){this.a.set(ne,Q);for(const V of this.f)V.channelServer.registerChannel(ne,Q)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$fh=z;class X{constructor(ne,Q,V=null){const ee=new h;D(ee,Q),ne.send(ee.buffer),this.a=new E(ne,V),this.d=new H(ne,Q,V)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,Q){this.d.registerChannel(ne,Q)}dispose(){this.a.dispose(),this.d.dispose()}}t.$gh=X;function ie(fe){return{call(ne,Q,V){return fe.then(ee=>ee.call(ne,Q,V))},listen(ne,Q){const V=new o.$od;return fe.then(ee=>V.input=ee.listen(ne,Q)),V.event}}}t.$hh=ie;function ue(fe){let ne=!1;return{call(Q,V,ee){return ne?fe.call(Q,V,ee):(0,N.$Hg)(0).then(()=>ne=!0).then(()=>fe.call(Q,V,ee))},listen(Q,V){if(ne)return fe.listen(Q,V);const ee=new o.$od;return(0,N.$Hg)(0).then(()=>ne=!0).then(()=>ee.input=fe.listen(Q,V)),ee.event}}}t.$ih=ue;class ae{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const Q of ne.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await o.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$jh=ae;var oe;(function(fe){function ne(J,S,x){const g=J,p=x&&x.disableMarshalling,q=new Map;for(const T in g)V(T)&&q.set(T,o.Event.buffer(g[T],!0,void 0,S));return new class{listen(T,O,P){const _=q.get(O);if(_)return _;if(ee(O)){const C=g[O];if(typeof C=="function")return C.call(g,P)}throw new w.$_(`Event not found: ${O}`)}call(T,O,P){const _=g[O];if(typeof _=="function"){if(!p&&Array.isArray(P))for(let C=0;C<P.length;C++)P[C]=(0,c.$$g)(P[C]);return _.apply(g,P)}throw new w.$_(`Method not found: ${O}`)}}}fe.fromService=ne;function Q(J,S){const x=S&&S.disableMarshalling;return new Proxy({},{get(g,p){if(typeof p=="string")return S?.properties?.has(p)?S.properties.get(p):ee(p)?function(q){return J.listen(p,q)}:V(p)?J.listen(p):async function(...q){let T;S&&!(0,s.$sf)(S.context)?T=[S.context,...q]:T=q;const O=await J.call(p,T);return x?O:(0,c.$$g)(O)};throw new w.$_(`Property not found: ${String(p)}`)}})}fe.toService=Q;function V(J){return J[0]==="o"&&J[1]==="n"&&L.$Le(J.charCodeAt(2))}function ee(J){return/^onDynamic/.test(J)&&L.$Le(J.charCodeAt(9))}})(oe||(t.ProxyChannel=oe={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const ne=fe.toString();if(ne!=="[object Object]")return ne}return fe}function Ce(fe){return Array.isArray(fe)?fe.map(ge):ge(fe)}function Fe(fe,ne,Q,V,ee,J,S){S=Ce(S);const x=re[ee],g=x[V%x.length];let p=[`%c[${fe}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(J)?(p=p.concat(S),p.push(")")):p.push(S),console.log.apply(console,p)}class Me{constructor(ne,Q){this.d=ne,this.f=Q,this.a=0,this.b=0}logOutgoing(ne,Q,V,ee,J){this.b+=ne,Fe(this.d,this.b,ne,Q,V,ee,J)}logIncoming(ne,Q,V,ee,J){this.a+=ne,Fe(this.f,this.a,ne,Q,V,ee,J)}}t.$kh=Me}),define(be[29],$e([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=void 0,t.$M=y.$g.vscode.ipcRenderer,t.$N=y.$g.vscode.ipcMessagePort,t.$O=y.$g.vscode.webFrame,t.$P=y.$g.vscode.process,t.$Q=y.$g.vscode.context}),define(be[131],$e([1,0,87,29]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=void 0;let n=0;function W(w,o,u){const c=[],L=n++,s=`vscode:onContextMenu${L}`,a=(e,l,r)=>{c[l].click?.(r)};N.$M.once(s,a),N.$M.once(y.$YS,(e,l)=>{l===L&&(N.$M.removeListener(s,a),u?.())}),N.$M.send(y.$XS,L,w.map(e=>v(e,c)),s,o)}t.$2S=W;function v(w,o){const u={id:o.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return o.push(w),Array.isArray(w.submenu)&&(u.submenu=w.submenu.map(c=>v(c,o))),u}}),define(be[132],$e([1,0,31,3,65,88,29]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=void 0;class w extends n.$gh{static f(){const u=N.Event.fromNodeEventEmitter(v.$M,"vscode:message",(c,L)=>y.$Fd.wrap(L));return v.$M.send("vscode:hello"),new W.$6S(v.$M,u)}constructor(u){const c=w.f();super(c,u),this.b=c}dispose(){this.b.disconnect()}}t.$0S=w}),define(be[133],$e([13,10]),function(le,t){return le.create("vs/platform/files/common/files",t)}),define(be[134],$e([13,10]),function(le,t){return le.create("vs/platform/theme/common/iconRegistry",t)}),define(be[38],$e([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ch=t.$Bh=t.$Ah=t._util=void 0;var y;(function(v){v.serviceIds=new Map,v.DI_TARGET="$di$target",v.DI_DEPENDENCIES="$di$dependencies";function w(o){return o[v.DI_DEPENDENCIES]||[]}v.getServiceDependencies=w})(y||(t._util=y={})),t.$Ah=n("instantiationService");function N(v,w,o){w[y.DI_TARGET]===w?w[y.DI_DEPENDENCIES].push({id:v,index:o}):(w[y.DI_DEPENDENCIES]=[{id:v,index:o}],w[y.DI_TARGET]=w)}function n(v){if(y.serviceIds.has(v))return y.serviceIds.get(v);const w=function(o,u,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(w,o,c)};return w.toString=()=>v,y.serviceIds.set(v,w),w}t.$Bh=n;function W(v){return v}t.$Ch=W}),define(be[135],$e([1,0,38]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$im=t.$hm=t.$gm=t.ID=void 0,t.ID="diagnosticsService",t.$gm=(0,y.$Bh)(t.ID);function N(W){return!!W.hostName&&!!W.errorMessage}t.$hm=N;class n{async getPerformanceInfo(v,w){return{}}async getSystemInfo(v,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(v,w){return""}async getWorkspaceFileExtensions(v){return{extensions:[]}}async reportWorkspaceStats(v){}}t.$im=n}),define(be[136],$e([1,0,86,22,12,7,15,133,38,5,28]),function(le,t,y,N,n,W,v,w,o,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.FileKind=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.FileOperationResult=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.FileChangeType=t.$kk=t.FileOperation=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.FileSystemProviderErrorCode=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$7j=t.$6j=void 0,t.$6j=(0,o.$Bh)("fileService");function L(Q){return Q.create===!0}t.$7j=L;var s;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(s||(t.FileType=s={}));var a;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(a||(t.FilePermission=a={}));var e;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function l(Q){return!!(Q.capabilities&2)}t.$8j=l;function r(Q){return!!(Q.capabilities&8)}t.$9j=r;function m(Q){return!!(Q.capabilities&131072)}t.$0j=m;function i(Q){return!!(Q.capabilities&4)}t.$$j=i;function d(Q){return!!(Q.capabilities&16)}t.$_j=d;function $(Q){return l(Q)?!!(Q.capabilities&16384):!1}t.$ak=$;function f(Q){return l(Q)?!!(Q.capabilities&32768):!1}t.$bk=f;function h(Q){return!!(Q.capabilities&65536)}t.$ck=h;function F(Q){return!!(Q.capabilities&2048)}t.$dk=F;var M;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(M||(t.FileSystemProviderErrorCode=M={}));class I extends Error{static create(V,ee){const J=new I(V.toString(),ee);return j(J,ee),J}constructor(V,ee){super(V),this.code=ee}}t.$ek=I;function b(Q,V){return I.create(Q,V)}t.$fk=b;function D(Q){return Q||b((0,w.localize)(0,null),M.Unknown)}t.$gk=D;function j(Q,V){return Q.name=V?`${V} (FileSystemError)`:"FileSystemError",Q}t.$hk=j;function H(Q){if(!Q)return M.Unknown;if(Q instanceof I)return Q.code;const V=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!V)return M.Unknown;switch(V[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}t.$ik=H;function B(Q){if(Q instanceof ae)return Q.fileOperationResult;switch(H(Q)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 9;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileTooLarge:return 7;default:return 10}}t.$jk=B;var E;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(E||(t.FileOperation=E={}));class z{constructor(V,ee,J){this.resource=V,this.operation=ee,this.target=J}isOperation(V){return this.operation===V}}t.$kk=z;var X;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class ie{constructor(V,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const J=new Map;for(const S of V){const x=J.get(S.type);switch(x?x.push([S.resource,S]):J.set(S.type,[[S.resource,S]]),S.type){case 1:this.rawAdded.push(S.resource);break;case 0:this.rawUpdated.push(S.resource);break;case 2:this.rawDeleted.push(S.resource);break}}for(const[S,x]of J)switch(S){case 1:this.a=y.$Hh.forUris(()=>ee),this.a.fill(x);break;case 0:this.b=y.$Hh.forUris(()=>ee),this.b.fill(x);break;case 2:this.c=y.$Hh.forUris(()=>ee),this.c.fill(x);break}}contains(V,...ee){return this.d(V,{includeChildren:!1},...ee)}affects(V,...ee){return this.d(V,{includeChildren:!0},...ee)}d(V,ee,...J){if(!V)return!1;const S=J.length>0;return!!((!S||J.includes(1))&&(this.a?.get(V)||ee.includeChildren&&this.a?.findSuperstr(V))||(!S||J.includes(0))&&(this.b?.get(V)||ee.includeChildren&&this.b?.findSuperstr(V))||(!S||J.includes(2))&&(this.c?.findSubstr(V)||ee.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.$lk=ie;function ue(Q,V,ee){return!Q||!V||Q===V||V.length>Q.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),ee?(0,n.$Ne)(Q,V):Q.indexOf(V)===0)}t.$mk=ue;class ae extends Error{constructor(V,ee,J){super(V),this.fileOperationResult=ee,this.options=J}}t.$nk=ae;class oe extends ae{constructor(V,ee,J,S){super(V,ee,S),this.fileOperationResult=ee,this.size=J}}t.$ok=oe;class re extends ae{constructor(V,ee,J){super(V,2,J),this.stat=ee}}t.$pk=re;var ge;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(t.FileOperationResult=ge={})),t.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$sk="files.associations",t.$tk="files.exclude",t.$uk="files.readonlyInclude",t.$vk="files.readonlyExclude",t.$wk="files.readonlyFromPermissions";var Ce;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ce||(t.FileKind=Ce={})),t.$xk="";function Fe(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}t.$yk=Fe;async function Me(Q,V){if(!V.hasProvider(v.URI.from({scheme:Q.scheme})))return new Promise(ee=>{const J=V.onDidChangeFileSystemProviderRegistrations(S=>{S.scheme===Q.scheme&&S.added&&(J.dispose(),ee())})})}t.$zk=Me;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(V){return(0,W.$nf)(V)||(V=0),V<fe.KB?(0,w.localize)(1,null,V.toFixed(0)):V<fe.MB?(0,w.localize)(2,null,(V/fe.KB).toFixed(2)):V<fe.GB?(0,w.localize)(3,null,(V/fe.MB).toFixed(2)):V<fe.TB?(0,w.localize)(4,null,(V/fe.GB).toFixed(2)):(0,w.localize)(5,null,(V/fe.TB).toFixed(2))}}t.$Ak=fe;function ne(Q){const V=typeof Q=="string"||Q?.scheme===c.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===c.Schemas.file?1024*fe.MB:V?10*fe.MB:u.$o?50*fe.MB:1024*fe.MB}t.$Bk=ne}),define(be[137],$e([1,0,38]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F7b=t.$E7b=void 0,t.$E7b=(0,y.$Bh)("mainProcessService");class N{constructor(W,v){this.a=W,this.b=v}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,v){this.a.registerChannel(W,v)}}t.$F7b=N}),define(be[138],$e([1,0,2,132]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G7b=void 0;class n extends y.$kc{constructor(v){super(),this.a=this.B(new N.$0S(`window:${v}`))}getChannel(v){return this.a.getChannel(v)}registerChannel(v,w){this.a.registerChannel(v,w)}}t.$G7b=n});var $i=this&&this.__param||function(le,t){return function(y,N){t(y,N,le)}};define(be[139],$e([1,0,65,137]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H7b=void 0;let n=class{constructor(v,w){return this.windowId=v,y.ProxyChannel.toService(w.getChannel("nativeHost"),{context:v,properties:(()=>{const o=new Map;return o.set("windowId",v),o})()})}};t.$H7b=n,t.$H7b=n=Qe([$i(1,N.$E7b)],n)}),define(be[66],$e([1,0,73,7]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8m=void 0;class n{constructor(){this.a=new Map}add(v,w){y.ok(N.$jf(v)),y.ok(N.$lf(w)),y.ok(!this.a.has(v),"There is already an extension with this id"),this.a.set(v,w)}knows(v){return this.a.has(v)}as(v){return this.a.get(v)||null}}t.$8m=new n}),define(be[140],$e([1,0,3,66]),function(le,t,y,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9m=void 0,t.$9m={JSONContribution:"base.contributions.json"};function n(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class W{constructor(){this.b=new y.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,u){this.a[n(o)]=u,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}}const v=new W;N.$8m.add(t.$9m.JSONContribution,v)}),define(be[141],$e([1,0,9,17,18,3,7,15,134,140,66]),function(le,t,y,N,n,W,v,w,o,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3v=t.$2v=t.$1v=t.$Zv=t.$Yv=t.$Xv=t.$Wv=t.$Vv=t.IconFontDefinition=t.IconContribution=t.$Uv=void 0,t.$Uv={IconContribution:"base.contributions.icons"};var L;(function($){function f(h,F){let M=h.defaults;for(;n.ThemeIcon.isThemeIcon(M);){const I=e.getIcon(M.id);if(!I)return;M=I.defaults}return M}$.getDefinition=f})(L||(t.IconContribution=L={}));var s;(function($){function f(F){return{weight:F.weight,style:F.style,src:F.src.map(M=>({format:M.format,location:M.location.toString()}))}}$.toJSONObject=f;function h(F){const M=I=>(0,v.$jf)(I)?I:void 0;if(F&&Array.isArray(F.src)&&F.src.every(I=>(0,v.$jf)(I.format)&&(0,v.$jf)(I.location)))return{weight:M(F.weight),style:M(F.style),src:F.src.map(I=>({format:I.format,location:w.URI.parse(I.location)}))}}$.fromJSONObject=h})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new W.$fd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(0,null)},fontCharacter:{type:"string",description:(0,o.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,h,F,M){const I=this.b[f];if(I){if(F&&!I.description){I.description=F,this.d.properties[f].markdownDescription=`${F} $(${f})`;const j=this.e.enum.indexOf(f);j!==-1&&(this.e.enumDescriptions[j]=F),this.a.fire()}return I}const b={id:f,description:F,defaults:h,deprecationMessage:M};this.b[f]=b;const D={$ref:"#/definitions/icons"};return M&&(D.deprecationMessage=M),F&&(D.markdownDescription=`${F}: $(${f})`),this.d.properties[f]=D,this.e.enum.push(f),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const h=this.e.enum.indexOf(f);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,h){const F=this.f[f];return F||(this.f[f]=h,this.a.fire(),h)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(I,b)=>I.id.localeCompare(b.id),h=I=>{for(;n.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.b).map(I=>this.b[I]);for(const I of M.filter(b=>!!b.description).sort(f))F.push(`|<i class="${h(I)}"></i>|${I.id}|${n.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const I of M.filter(b=>!n.ThemeIcon.isThemeIcon(b.defaults)).sort(f))F.push(`|<i class="${h(I)}"></i>|${I.id}|`);return F.join(`
`)}}const e=new a;c.$8m.add(t.$Uv.IconContribution,e);function l($,f,h,F){return e.registerIcon($,f,h,F)}t.$Vv=l;function r(){return e}t.$Wv=r;function m(){const $=(0,N.$Nj)();for(const f in $){const h="\\"+$[f].toString(16);e.registerIcon(f,{fontCharacter:h})}}m(),t.$Xv="vscode://schemas/icons";const i=c.$8m.as(u.$9m.JSONContribution);i.registerSchema(t.$Xv,e.getIconSchema());const d=new y.$Sg(()=>i.notifySchemaChanged(t.$Xv),200);e.onDidChange(()=>{d.isScheduled()||d.schedule()}),t.$Yv=l("widget-close",N.$Pj.close,(0,o.localize)(2,null)),t.$Zv=l("goto-previous-location",N.$Pj.arrowUp,(0,o.localize)(3,null)),t.$1v=l("goto-next-location",N.$Pj.arrowDown,(0,o.localize)(4,null)),t.$2v=n.ThemeIcon.modify(N.$Pj.sync,"spin"),t.$3v=n.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(be[142],$e([1,0,4,3,2,18,141]),function(le,t,y,N,n,W,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mzb=t.$Lzb=void 0;function w(u){const c=new n.$jc,L=c.add(new N.$fd),s=(0,v.$Wv)();return c.add(s.onDidChange(()=>L.fire())),u&&c.add(u.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>c.dispose(),onDidChange:L.event,getCSS(){const a=u?u.getProductIconTheme():new o,e={},l=m=>{const i=a.getIcon(m);if(!i)return;const d=i.font;return d?(e[d.id]=d.definition,`.codicon-${m.id}:before { content: '${i.fontCharacter}'; font-family: ${(0,y.$tP)(d.id)}; }`):`.codicon-${m.id}:before { content: '${i.fontCharacter}'; }`},r=[];for(const m of s.getIcons()){const i=l(m);i&&r.push(i)}for(const m in e){const i=e[m],d=i.weight?`font-weight: ${i.weight};`:"",$=i.style?`font-style: ${i.style};`:"",f=i.src.map(h=>`${(0,y.$sP)(h.location)} format('${h.format}')`).join(", ");r.push(`@font-face { src: ${f}; font-family: ${(0,y.$tP)(m)};${d}${$} font-display: block; }`)}return r.join(`
`)}}}t.$Lzb=w;class o{getIcon(c){const L=(0,v.$Wv)();let s=c.defaults;for(;W.ThemeIcon.isThemeIcon(s);){const a=L.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$Mzb=o}),define(be[143],$e([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YC=t.$XC=t.$WC=t.$VC=t.$UC=t.$TC=t.$SC=t.$RC=void 0,t.$RC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(c){return!!c.workspaceUri}t.$SC=N;function n(c){return!!c.folderUri}t.$TC=n;function W(c){return!!c.fileUri}t.$UC=W;function v(c){const L=w(c),s=c.getValue("window.menuBarVisibility");return s==="default"||L==="native"&&s==="compact"||y.$j&&y.$m?"classic":s}t.$VC=v;function w(c){if(y.$o)return"custom";const L=c.getValue("window");if(L){if(y.$j&&L.nativeTabs===!0||y.$j&&L.nativeFullScreen===!1)return"native";const e=L.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$k?"native":"custom"}t.$WC=w;function o(c){return!(!y.$i||y.$o||w(c)==="native")}t.$XC=o;function u(c=0){return Math.pow(1.2,c)}t.$YC=u}),define(be[144],$e([1,0,16,29,143]),function(le,t,y,N,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L7b=t.$K7b=t.$J7b=void 0;function W(o){N.$O.setZoomLevel(o),(0,y.$6N)((0,n.$YC)(o)),(0,y.$3N)(o)}t.$J7b=W;function v(){W((0,y.$4N)()+1)}t.$K7b=v;function w(){W((0,y.$4N)()-1)}t.$L7b=w}),define(be[145],$e([1,0,10,4,130,9,131,29,135,136,138,139,142,144,14,101,92]),function(le,t,y,N,n,W,v,w,o,u,c,L,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,r=/\s--inspect-port=(?<port>\d+)/;class m{getHeight(B){return 22}getTemplateId(B){return I(B)?"process":F(B)?"machine":(0,o.$hm)(B)?"error":M(B)?"header":""}}class i{hasChildren(B){return(0,o.$hm)(B)?!1:I(B)?!!B.children?.length:!0}getChildren(B){return I(B)?B.children?B.children:[]:(0,o.$hm)(B)?[]:M(B)?B.processRoots.length>1?B.processRoots:[B.processRoots[0].rootProcess]:F(B)?[B.rootProcess]:[B.processes]}}class d{constructor(){this.templateId="header"}renderTemplate(B){const E=(0,N.$cP)(B,(0,N.$)(".row")),z=(0,N.$cP)(E,(0,N.$)(".nameLabel")),X=(0,N.$cP)(E,(0,N.$)(".cpu")),ie=(0,N.$cP)(E,(0,N.$)(".memory")),ue=(0,N.$cP)(E,(0,N.$)(".pid"));return{name:z,CPU:X,memory:ie,PID:ue}}renderElement(B,E,z,X){z.name.textContent=(0,y.localize)(0,null),z.CPU.textContent=(0,y.localize)(1,null),z.PID.textContent=(0,y.localize)(2,null),z.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(B){}}class ${constructor(){this.templateId="machine"}renderTemplate(B){const E=Object.create(null),z=(0,N.$cP)(B,(0,N.$)(".row"));return E.name=(0,N.$cP)(z,(0,N.$)(".nameLabel")),E}renderElement(B,E,z,X){z.name.textContent=B.element.name}disposeTemplate(B){}}class f{constructor(){this.templateId="error"}renderTemplate(B){const E=Object.create(null),z=(0,N.$cP)(B,(0,N.$)(".row"));return E.name=(0,N.$cP)(z,(0,N.$)(".nameLabel")),E}renderElement(B,E,z,X){z.name.textContent=B.element.errorMessage}disposeTemplate(B){}}class h{constructor(B,E,z){this.a=B,this.b=E,this.c=z,this.templateId="process"}renderTemplate(B){const E=(0,N.$cP)(B,(0,N.$)(".row")),z=(0,N.$cP)(E,(0,N.$)(".nameLabel")),X=(0,N.$cP)(E,(0,N.$)(".cpu")),ie=(0,N.$cP)(E,(0,N.$)(".memory")),ue=(0,N.$cP)(E,(0,N.$)(".pid"));return{name:z,CPU:X,PID:ue,memory:ie}}renderElement(B,E,z,X){const{element:ie}=B,ue=ie.pid.toFixed(0);let ae=ie.name;this.c.has(ie.pid)&&(ae=this.c.get(ie.pid)),z.name.textContent=ae,z.name.title=ie.cmd,z.CPU.textContent=ie.load.toFixed(0),z.PID.textContent=ue,z.PID.parentElement.id=`pid-${ue}`;const oe=this.a==="win32"?ie.mem:this.b*(ie.mem/100);z.memory.textContent=(oe/u.$Ak.MB).toFixed(0)}disposeTemplate(B){}}function F(H){return!!H.name&&!!H.rootProcess}function M(H){return!!H.processRoots}function I(H){return!!H.pid}class b{constructor(B,E){this.f=E,this.b=new Map;const z=new c.$G7b(B);this.c=new L.$H7b(B,z),this.k(E.styles),this.g(E),w.$M.on("vscode:pidToNameResponse",(X,ie)=>{this.b=new Map;for(const[ue,ae]of ie)this.b.set(ue,ae)}),w.$M.on("vscode:listProcessesResponse",async(X,ie)=>{ie.forEach((ue,ae)=>{I(ue.rootProcess)&&(ue.rootProcess.name=ae===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ie}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ie),this.m(0)}),this.a=Date.now(),w.$M.send("vscode:pidToNameRequest"),w.$M.send("vscode:listProcesses")}g(B){document.onkeydown=E=>{const z=B.platform==="darwin"?E.metaKey:E.ctrlKey;z&&E.keyCode===87&&(E.stopPropagation(),E.preventDefault(),w.$M.send("vscode:closeProcessExplorer")),z&&E.keyCode===187&&(0,a.$K7b)(),z&&E.keyCode===189&&(0,a.$L7b)()}}async h(B){const E=document.getElementById("process-list");if(!E)return;const{totalmem:z}=await this.c.getOSStatistics(),X=[new h(this.f.platform,z,this.b),new d,new $,new f];this.d=new n.$vS("processExplorer",E,new m,X,new i,{identityProvider:{getId:ie=>I(ie)?ie.pid.toString():(0,o.$hm)(ie)?ie.hostName:M(ie)?"processes":F(ie)?ie.name:"header"}}),this.d.setInput({processes:{processRoots:B}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ie=>{const ue=new e.$oO(ie);if(ue.keyCode===35&&ue.altKey){const ae=this.n();Promise.all(ae.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ie=>{I(ie.element)&&this.l(ie.element,!0)}),E.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{E.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(B){const E=l.exec(B);return E&&E.groups.port!=="0"||B.indexOf("node ")>=0||B.indexOf("node.exe")>=0}j(B){const E={type:"node",request:"attach",name:`process ${B.pid}`};let z=l.exec(B.cmd);z?E.port=Number(z.groups.port):E.processId=String(B.pid),z=r.exec(B.cmd),z&&(E.port=Number(z.groups.port)),w.$M.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[E]})}k(B){const E=(0,N.$3O)(),z=[];B.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${B.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${B.listFocusBackground}; }`)),B.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${B.listFocusForeground}; }`),B.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${B.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${B.listActiveSelectionBackground}; }`)),B.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${B.listActiveSelectionForeground}; }`),B.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${B.listHoverBackground}; }`),B.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${B.listHoverForeground}; }`),B.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${B.listFocusOutline}; outline-offset: -1px; }`),B.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${B.listHoverOutline}; outline-offset: -1px; }`),B.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${B.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),B.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${B.scrollbarSliderBackgroundColor};
				}
			`),B.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${B.scrollbarSliderHoverBackgroundColor};
				}
			`),B.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${B.scrollbarSliderActiveBackgroundColor};
				}
			`),E.textContent=z.join(`
`),B.color&&(document.body.style.color=B.color)}l(B,E){const z=[],X=Number(B.pid);E&&(z.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),z.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,y.localize)(6,null),click:()=>{const ie=this.n();ie?.includes(X)||(ie.length=0,ie.push(X));const ue=ie?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(ue){const ae=ue.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(ae.join(`
`))}}}),z.push({label:(0,y.localize)(7,null),click:()=>{const ie=document.getElementById("process-list");ie&&this.c.writeClipboardText(ie.innerText)}}),B&&E&&this.i(B.cmd)&&(z.push({type:"separator"}),z.push({label:(0,y.localize)(8,null),click:()=>{this.j(B)}})),(0,v.$2S)(z)}m(B){setTimeout(()=>{const E=Date.now(),z=B+E-this.a;this.a=E,z>1e3?(w.$M.send("vscode:pidToNameRequest"),w.$M.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(B=>{if(!(!B||!("pid"in B)))return B.pid}).filter(B=>!!B)}}function D(){const H=(0,N.$3O)();H.id="codiconStyles";const B=(0,s.$Lzb)(void 0);function E(){H.textContent=B.getCSS()}const z=new W.$Sg(E,0);B.onDidChange(()=>z.schedule()),z.schedule()}function j(H){const B=H.data.platform==="win32"?"windows":H.data.platform==="linux"?"linux":"mac";document.body.classList.add(B),D(),(0,a.$J7b)(H.data.zoomLevel),new b(H.windowId,H.data)}t.startup=j})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
