/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const R=new Map,A=new Map,N=new Map,y=new Map;function u(d,E){d.has(E.detail)||d.set(E.detail,-E.timestamp)}function c(d,E){const w=d.get(E.detail);w&&(w>=0||d.set(E.detail,w+E.timestamp))}let v=[];typeof J=="function"&&typeof J.getStats=="function"&&(v=J.getStats().slice(0).sort((d,E)=>d.timestamp-E.timestamp));for(const d of v)switch(d.type){case 10:u(R,d);break;case 11:case 12:c(R,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(N,d);break;case 34:c(N,d);break;case 31:u(y,d);break;case 32:c(y,d);break}let O=0;N.forEach(d=>O+=d);function g(d){const E=[];return d.forEach((w,$)=>E.push([$,w])),E}return{amdLoad:g(R),amdInvoke:g(A),nodeRequire:g(N),nodeEval:g(y),nodeRequireTotal:O}}static toMarkdownTable(R,A){let N="";const y=[];return R.forEach((u,c)=>{y[c]=u.length}),A.forEach(u=>{u.forEach((c,v)=>{typeof c>"u"&&(c=u[v]="-");const O=c.toString().length;y[v]=Math.max(O,y[v])})}),R.forEach((u,c)=>{N+=`| ${u+" ".repeat(y[c]-u.toString().length)} `}),N+=`|
`,R.forEach((u,c)=>{N+=`| ${"-".repeat(y[c])} `}),N+=`|
`,A.forEach(u=>{u.forEach((c,v)=>{typeof c<"u"&&(N+=`| ${c+" ".repeat(y[v]-c.toString().length)} `)}),N+=`|
`}),N}}e.$S=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function L(N){return(y,u,c)=>{let v=null,O=null;if(typeof c.value=="function"?(v="value",O=c.value):typeof c.get=="function"&&(v="get",O=c.get),!O)throw new Error("not supported");c[v]=N(O,u)}}function D(N,y,u){let c=null,v=null;if(typeof u.value=="function"?(c="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",v=u.get),!v)throw new Error("not supported");const O=`$memoize$${y}`;u[c]=function(...g){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,g)}),this[O]}}e.$6g=D;function R(N,y,u){return L((c,v)=>{const O=`$debounce$${v}`,g=`$debounce$result$${v}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[O]),y&&(this[g]=y(this[g],...d),d=[this[g]]),this[O]=setTimeout(()=>{c.apply(this,d),this[g]=u?u():void 0},N)}})}e.$7g=R;function A(N,y,u){return L((c,v)=>{const O=`$throttle$timer$${v}`,g=`$throttle$result$${v}`,d=`$throttle$lastRun$${v}`,E=`$throttle$pending$${v}`;return function(...w){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[g]=y(this[g],...w)),this[E])return;const $=this[d]+N;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[E]=!0,this[O]=setTimeout(()=>{this[E]=!1,this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$8g=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function D(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(u,c="Unreachable"){throw new Error(c)}e.$vc=R;function A(u){if(!u)throw new L.$ab("Assertion Failed")}e.$wc=A;function N(u){if(!u()){debugger;u(),(0,L.$Y)(new L.$ab("Assertion Failed"))}}e.$xc=N;function y(u,c){let v=0;for(;v<u.length-1;){const O=u[v],g=u[v+1];if(!c(O,g))return!1;v++}return!0}e.$yc=y}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(t,a=!1){let i=0;const s=t.length;let n="",r=0,l=16,P=0;function b(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function S(te){i=te,n="",r=0,l=16,P=0}function j(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return P=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else P=3;return t.substring(te,ae)}function H(){let te="",ae=i;for(;;){if(i>=s){te+=t.substring(ae,i),P=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=s){P=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=b(4);q>=0?te+=String.fromCharCode(q):P=4;break}default:P=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),P=2;break}else P=6;i++}return te}function x(){if(n="",P=0,r=i,i>=s)return r=s,l=17;let te=t.charCodeAt(i);if(y(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(y(te));return l=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=H(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const le=s-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,P=1),n=t.substring(ae,i),l=13}return n+=String.fromCharCode(te),i++,l=16}case 45:if(n+=String.fromCharCode(te),i++,i===s||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),l=11;default:for(;i<s&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(n=t.substring(r,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),i++,l=16}}function _(te){if(y(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:S,getPosition:()=>i,scan:a?ue:x,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>P}}e.$Jm=N;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function O(t,a){const i=[],s=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(b,S,j,H){r.value=b,r.offset=S,r.length=j,r.type=H,r.colonOffset=void 0,n=r}try{I(t,{onObjectBegin:(b,S)=>{if(a<=b)throw s;n=void 0,l=a>b,i.push("")},onObjectProperty:(b,S,j)=>{if(a<S||(P(b,S,j,"property"),i[i.length-1]=b,a<=S+j))throw s},onObjectEnd:(b,S)=>{if(a<=b)throw s;n=void 0,i.pop()},onArrayBegin:(b,S)=>{if(a<=b)throw s;n=void 0,i.push(0)},onArrayEnd:(b,S)=>{if(a<=b)throw s;n=void 0,i.pop()},onLiteralValue:(b,S,j)=>{if(a<S||(P(b,S,j,k(b)),a<=S+j))throw s},onSeparator:(b,S,j)=>{if(a<=S)throw s;if(b===":"&&n&&n.type==="property")n.colonOffset=S,l=!1,n=void 0;else if(b===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(b){if(b!==s)throw b}return{path:i,previousNode:n,isAtPropertyKey:l,matches:b=>{let S=0;for(let j=0;S<b.length&&j<i.length;j++)if(b[S]===i[j]||b[S]==="*")S++;else if(b[S]!=="**")return!1;return S===b.length}}}e.$Km=O;function g(t,a=[],i=A.DEFAULT){let s=null,n=[];const r=[];function l(b){Array.isArray(n)?n.push(b):s!==null&&(n[s]=b)}return I(t,{onObjectBegin:()=>{const b={};l(b),r.push(n),n=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const b=[];l(b),r.push(n),n=b,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(b,S,j)=>{a.push({error:b,offset:S,length:j})}},i),n[0]}e.$Lm=g;function d(t,a=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function r(b){return s.children.push(b),b}I(t,{onObjectBegin:b=>{s=r({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,S,j)=>{s=r({type:"property",offset:S,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:S,length:j,parent:s})},onObjectEnd:(b,S)=>{s.length=b+S-s.offset,s=s.parent,n(b+S)},onArrayBegin:(b,S)=>{s=r({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,S)=>{s.length=b+S-s.offset,s=s.parent,n(b+S)},onLiteralValue:(b,S,j)=>{r({type:k(b),offset:S,length:j,parent:s,value:b}),n(S+j)},onSeparator:(b,S,j)=>{s.type==="property"&&(b===":"?s.colonOffset=S:b===","&&n(S))},onError:(b,S,j)=>{a.push({error:b,offset:S,length:j})}},i);const P=s.children[0];return P&&delete P.parent,P}e.$Mm=d;function E(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===s){i=r.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$Nm=E;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Om=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=$(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Qm=h;function f(t,a,i=!1){if(h(t,a,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=a;n++){const r=f(s[n],a,i);if(r)return r}return t}}e.$Rm=f;function I(t,a,i=A.DEFAULT){const s=N(t,!1);function n(Y){return Y?()=>Y(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(Y){return Y?K=>Y(K,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=n(a.onObjectBegin),P=r(a.onObjectProperty),b=n(a.onObjectEnd),S=n(a.onArrayBegin),j=n(a.onArrayEnd),H=r(a.onLiteralValue),x=r(a.onSeparator),_=n(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const Y=s.scan();switch(s.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Y){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return Y}}}function ie(Y,K=[],U=[]){if(ue(Y),K.length+U.length>0){let z=s.getToken();for(;z!==17;){if(K.indexOf(z)!==-1){le();break}else if(U.indexOf(z)!==-1)break;z=le()}}}function q(Y){const K=s.getTokenValue();return Y?H(K):P(K),le(),!0}function G(){switch(s.getToken()){case 11:{let Y=0;try{Y=JSON.parse(s.getTokenValue()),typeof Y!="number"&&(ie(2),Y=0)}catch{ie(2)}H(Y);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function T(){return s.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),s.getToken()===6?(x(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function C(){l(),le();let Y=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Y||ie(4,[],[]),x(","),le(),s.getToken()===2&&ae)break}else Y&&ie(6,[],[]);T()||ie(4,[],[2,5]),Y=!0}return b(),s.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){S(),le();let Y=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Y||ie(4,[],[]),x(","),le(),s.getToken()===4&&ae)break}else Y&&ie(6,[],[]);X()||ie(4,[],[4,5]),Y=!0}return j(),s.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(s.getToken()){case 3:return B();case 1:return C();case 10:return q(!0);default:return G()}}return le(),s.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(s.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Sm=I;function p(t,a){const i=N(t),s=[];let n,r=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:r!==l&&s.push(t.substring(r,l)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(n!==17);return s.join("")}e.$Tm=p;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=k}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function L(y,u,c){return Math.min(Math.max(y,u),c)}e.$Hl=L;function D(y,u){return(u+y%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=A;class N{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=N}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function N(u){A.push(u,Date.now())}function y(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:N,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(R+N.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var N in D)L.d(A,N,function(y){return D[y]}.bind(null,N));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=U,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],c=0,v=c++;u[v]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var E=c++;u[E]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var w=c++;u[w]="(?:"+u[v]+"|"+u[g]+")";var $=c++;u[$]="(?:"+u[O]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var k=c++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[k]="^"+t+"$";var a="[v=\\s]*"+u[E]+u[f]+"?"+u[p]+"?",i=c++;u[i]="^"+a+"$";var s=c++;u[s]="((?:<|>)?=?)";var n=c++;u[n]=u[O]+"|x|X|\\*";var r=c++;u[r]=u[v]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var b=c++;u[b]="^"+u[s]+"\\s*"+u[l]+"$";var S=c++;u[S]="^"+u[s]+"\\s*"+u[P]+"$";var j=c++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;u[H]="(?:~>?)";var x=c++;u[x]="(\\s*)"+u[H]+"\\s+",y[x]=new RegExp(u[x],"g");var _=c++;u[_]="^"+u[H]+u[l]+"$";var ue=c++;u[ue]="^"+u[H]+u[P]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",y[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[P]+"$";var q=c++;u[q]="^"+u[s]+"\\s*("+a+")$|^$";var G=c++;u[G]="^"+u[s]+"\\s*("+t+")$|^$";var T=c++;u[T]="(\\s*)"+u[s]+"\\s*("+a+"|"+u[l]+")",y[T]=new RegExp(u[T],"g");var C=c++;u[C]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)R(Y,u[Y]),y[Y]||(y[Y]=new RegExp(u[Y]));function K(V,Q){if(V instanceof U)return V;if(typeof V!="string"||V.length>A||!(Q?y[i]:y[k]).test(V))return null;try{return new U(V,Q)}catch{return null}}function U(V,Q){if(V instanceof U){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(V,Q);R("SemVer",V,Q),this.loose=Q;var ee=V.trim().match(Q?y[i]:y[k]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<N)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Q){var ee=K(V,Q);return ee?ee.version:null},e.clean=function(V,Q){var ee=K(V.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),o(this.major,V.major)||o(this.minor,V.minor)||o(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],me=V.prerelease[Q];if(R("prerelease compare",Q,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return o(ee,me)}while(++Q)},U.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new U(V,ee).inc(Q,me).version}catch{return null}},e.diff=function(V,Q){if(Z(V,Q))return null;var ee=K(V),me=K(Q);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(V,Q){var ee=z.test(V),me=z.test(Q);return ee&&me&&(V=+V,Q=+Q),ee&&!me?-1:me&&!ee?1:V<Q?-1:V>Q?1:0}function m(V,Q,ee){return new U(V,ee).compare(new U(Q,ee))}function F(V,Q,ee){return m(V,Q,ee)>0}function M(V,Q,ee){return m(V,Q,ee)<0}function Z(V,Q,ee){return m(V,Q,ee)===0}function W(V,Q,ee){return m(V,Q,ee)!==0}function ce(V,Q,ee){return m(V,Q,ee)>=0}function oe(V,Q,ee){return m(V,Q,ee)<=0}function pe(V,Q,ee,me){var ye;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Z(V,ee,me);break;case"!=":ye=W(V,ee,me);break;case">":ye=F(V,ee,me);break;case">=":ye=ce(V,ee,me);break;case"<":ye=M(V,ee,me);break;case"<=":ye=oe(V,ee,me);break;default:throw new TypeError("Invalid operator: "+Q)}return ye}function de(V,Q){if(V instanceof de){if(V.loose===Q)return V;V=V.value}if(!(this instanceof de))return new de(V,Q);R("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Q){return o(Q,V)},e.major=function(V,Q){return new U(V,Q).major},e.minor=function(V,Q){return new U(V,Q).minor},e.patch=function(V,Q){return new U(V,Q).patch},e.compare=m,e.compareLoose=function(V,Q){return m(V,Q,!0)},e.rcompare=function(V,Q,ee){return m(Q,V,ee)},e.sort=function(V,Q){return V.sort(function(ee,me){return e.compare(ee,me,Q)})},e.rsort=function(V,Q){return V.sort(function(ee,me){return e.rcompare(ee,me,Q)})},e.gt=F,e.lt=M,e.eq=Z,e.neq=W,e.gte=ce,e.lte=oe,e.cmp=pe,e.Comparator=de;var ge={};function fe(V,Q){if(V instanceof fe)return V.loose===Q?V:new fe(V.raw,Q);if(V instanceof de)return new fe(V.value,Q);if(!(this instanceof fe))return new fe(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Q,ee,me,ye,je,ke,Le,Ie,Ae,Ue,Oe,Ne){return((Q=he(ee)?"":he(me)?">="+ee+".0.0":he(ye)?">="+ee+"."+me+".0":">="+Q)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ue+"-"+Oe:"<="+Le)).trim()}function be(V,Q){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var me=V[ee].semver;if(me.major===Q.major&&me.minor===Q.minor&&me.patch===Q.patch)return!0}return!1}return!0}function Se(V,Q,ee){try{Q=new fe(Q,ee)}catch{return!1}return Q.test(V)}function Fe(V,Q,ee,me){var ye,je,ke,Le,Ie;switch(V=new U(V,me),Q=new fe(Q,me),ee){case">":ye=F,je=oe,ke=M,Le=">",Ie=">=";break;case"<":ye=M,je=ce,ke=F,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,Q,me))return!1;for(var Ae=0;Ae<Q.set.length;++Ae){var Ue=Q.set[Ae],Oe=null,Ne=null;if(Ue.forEach(function(De){De.semver===ge&&(De=new de(">=0.0.0")),Oe=Oe||De,Ne=Ne||De,ye(De.semver,Oe.semver,me)?Oe=De:ke(De.semver,Ne.semver,me)&&(Ne=De)}),Oe.operator===Le||Oe.operator===Ie||(!Ne.operator||Ne.operator===Le)&&je(V,Ne.semver)||Ne.operator===Ie&&ke(V,Ne.semver))return!1}return!0}de.prototype.parse=function(V){var Q=this.loose?y[q]:y[G],ee=V.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new U(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Q){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Q),Se(this.value,ee,Q);if(V.operator==="")return ee=new fe(this.value,Q),Se(V.semver,ee,Q);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),je=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=pe(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||je&&ke||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),R("range",V,Q);var ee=Q?y[B]:y[C];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(y[T],"$1$2$3"),R("comparator trim",V,y[T]),V=(V=(V=V.replace(y[x],"$1~")).replace(y[ae],"$1^")).split(/\s+/).join(" ");var me=Q?y[q]:y[G],ye=V.split(" ").map(function(je){return function(ke,Le){return R("comp",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){R("caret",Oe,Ne);var De=Ne?y[ie]:y[le];return Oe.replace(De,function(Ce,ve,Ee,Pe,Re){var ze;return R("caret",Oe,Ce,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Ue,Ae)}).join(" ")}(ke,Le),R("caret",ke),ke=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){var De=Ne?y[ue]:y[_];return Oe.replace(De,function(Ce,ve,Ee,Pe,Re){var ze;return R("tilde",Oe,Ce,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Ue,Ae)}).join(" ")}(ke,Le),R("tildes",ke),ke=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ne){Oe=Oe.trim();var De=Ne?y[S]:y[b];return Oe.replace(De,function(Ce,ve,Ee,Pe,Re,ze){R("xRange",Oe,Ce,ve,Ee,Pe,Re,ze);var qe=he(Ee),Me=qe||he(Pe),Te=Me||he(Re);return ve==="="&&Te&&(ve=""),qe?Ce=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Me&&(Pe=0),Te&&(Re=0),ve===">"?(ve=">=",Me?(Ee=+Ee+1,Pe=0,Re=0):Te&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Me?Ee=+Ee+1:Pe=+Pe+1),Ce=ve+Ee+"."+Pe+"."+Re):Me?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ce=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ce),Ce})}(Ue,Ae)}).join(" ")}(ke,Le),R("xrange",ke),ke=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(y[X],"")}(ke,Le),R("stars",ke),ke}(je,Q)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(je){return!!je.match(me)})),ye=ye.map(function(je){return new de(je,Q)})},fe.prototype.intersects=function(V,Q){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return V.set.some(function(ye){return ye.every(function(je){return me.intersects(je,Q)})})})})},e.toComparators=function(V,Q){return new fe(V,Q).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(be(this.set[Q],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(ke){je.test(ke)&&(me&&ye.compare(ke)!==-1||(ye=new U(me=ke,ee)))}),me},e.minSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(ke){je.test(ke)&&(me&&ye.compare(ke)!==1||(ye=new U(me=ke,ee)))}),me},e.validRange=function(V,Q){try{return new fe(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,ee){return Fe(V,Q,"<",ee)},e.gtr=function(V,Q,ee){return Fe(V,Q,">",ee)},e.outside=Fe,e.prerelease=function(V,Q){var ee=K(V,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Q,ee){return V=new fe(V,ee),Q=new fe(Q,ee),V.intersects(Q)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var Q=V.match(y[j]);return Q==null?null:K((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function y($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:N}catch{D=N}})();var u,c=[],v=!1,O=-1;function g(){v&&u&&(v=!1,u.length?c=u.concat(c):O=-1,c.length&&d())}function d(){if(!v){var $=y(g);v=!0;for(var h=c.length;h;){for(u=c,c=[];++O<h;)u&&u[O].run();O=-1,h=c.length}u=null,v=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===N||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function E($,h){this.fun=$,this.array=h}function w(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new E($,h)),c.length!==1||v||y(d)},E.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class D{constructor(y,u,c){this.level=y,this.key=u,this.value=c,this.forward=[]}}const R=void 0;class A{constructor(y,u=2**16){this.comparator=y,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R)}has(y){return!!A.g(this,y,this.comparator)}get(y){return A.g(this,y,this.comparator)?.value}set(y,u){return A.h(this,y,u,this.comparator)&&(this.f+=1),this}delete(y){const u=A.k(this,y,this.comparator);return u&&(this.f-=1),u}forEach(y,u){let c=this.e.forward[0];for(;c;)y.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this.e.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this.e.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this.e.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this.e.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static g(y,u,c){let v=y.e;for(let O=y.d-1;O>=0;O--)for(;v.forward[O]&&c(v.forward[O].key,u)<0;)v=v.forward[O];if(v=v.forward[0],v&&c(v.key,u)===0)return v}static h(y,u,c,v){const O=[];let g=y.e;for(let d=y.d-1;d>=0;d--){for(;g.forward[d]&&v(g.forward[d].key,u)<0;)g=g.forward[d];O[d]=g}if(g=g.forward[0],g&&v(g.key,u)===0)return g.value=c,!1;{const d=A.j(y);if(d>y.d){for(let E=y.d;E<d;E++)O[E]=y.e;y.d=d}g=new D(d,u,c);for(let E=0;E<d;E++)g.forward[E]=O[E].forward[E],O[E].forward[E]=g;return!0}}static j(y,u=.5){let c=1;for(;Math.random()<u&&c<y.c;)c+=1;return c}static k(y,u,c){const v=[];let O=y.e;for(let g=y.d-1;g>=0;g--){for(;O.forward[g]&&c(O.forward[g].key,u)<0;)O=O.forward[g];v[g]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let g=0;g<y.d&&v[g].forward[g]===O;g++)v[g].forward[g]=O.forward[g];for(;y.d>0&&y.e.forward[y.d-1]===R;)y.d-=1;return!0}}e.$or=A}),define(ne[45],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function R(p){const k=p;return k?typeof k.read=="function":!1}e.$qd=R;function A(p){const k=p;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.$rd=A;function N(p){const k=p;return k?A(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$sd=N;function y(p,k){return new u(p,k)}e.$td=y;class u{constructor(k,t){this.e=k,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(t=>t(k))}h(k){this.c.error.length===0?(0,L.$Y)(k):this.c.error.slice(0).forEach(t=>t(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,t){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(k,t){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,k){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return k(t)}e.$ud=c;function v(p,k,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return p.read()}}}e.$vd=v;function O(p,k){return new Promise((t,a)=>{const i=[];g(p,{onData:s=>{k&&i.push(s)},onError:s=>{k?a(s):t(void 0)},onEnd:()=>{t(k?k(i):void 0)}})})}e.$wd=O;function g(p,k,t){p.on("error",a=>{t?.isCancellationRequested||k.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||k.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||k.onData(a)})}e.$xd=g;function d(p,k){return new Promise((t,a)=>{const i=new D.$jc,s=[],n=P=>{if(s.push(P),s.length>k)return i.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=P=>(i.dispose(),a(P)),l=()=>(i.dispose(),t({stream:p,buffer:s,ended:!0}));i.add((0,D.$ic)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,D.$ic)(()=>p.removeListener("end",l))),p.on("end",l),i.add((0,D.$ic)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$yd=d;function E(p,k){const t=y(k);return t.end(p),t}e.$zd=E;function w(){const p=y(()=>{throw new Error("not supported")});return p.end(),p}e.$Ad=w;function $(p){let k=!1;return{read:()=>k?null:(k=!0,p)}}e.$Bd=$;function h(p,k,t){const a=y(t);return g(p,{onData:i=>a.write(k.data(i)),onError:i=>a.error(k.error?k.error(i):i),onEnd:()=>a.end()}),a}e.$Cd=h;function f(p,k,t){let a=!1;return{read:()=>{const i=k.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$Dd=f;function I(p,k,t){let a=!1;const i=y(t);return g(k,{onData:s=>a?i.write(s):(a=!0,i.write(t([p,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$Ed=I}),define(ne[14],re([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const R=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let N,y;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(N||(N=new TextEncoder),new u(N.encode(j)))}static fromByteArray(j){const H=u.alloc(j.length);for(let x=0,_=j.length;x<_;x++)H.buffer[x]=j[x];return H}static concat(j,H){if(typeof H>"u"){H=0;for(let ue=0,te=j.length;ue<te;ue++)H+=j[ue].byteLength}const x=u.alloc(H);let _=0;for(let ue=0,te=j.length;ue<te;ue++){const ae=j[ue];x.set(ae,_),_+=ae.byteLength}return x}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(j,H){return new u(this.buffer.subarray(j,H))}set(j,H){if(j instanceof u)this.buffer.set(j.buffer,H);else if(j instanceof Uint8Array)this.buffer.set(j,H);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),H);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return g(this.buffer,j)}writeUInt32BE(j,H){d(this.buffer,j,H)}readUInt32LE(j){return E(this.buffer,j)}writeUInt32LE(j,H){w(this.buffer,j,H)}readUInt8(j){return $(this.buffer,j)}writeUInt8(j,H){h(this.buffer,j,H)}indexOf(j,H=0){return c(this.buffer,j instanceof u?j.buffer:j,H)}}e.$Fd=u;function c(S,j,H=0){const x=j.byteLength,_=S.byteLength;if(x===0)return 0;if(x===1)return S.indexOf(j[0]);if(x>_-H)return-1;const ue=A.value;ue.fill(j.length);for(let ie=0;ie<j.length;ie++)ue[j[ie]]=j.length-ie-1;let te=H+j.length-1,ae=te,le=-1;for(;te<_;)if(S[te]===j[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(j.length-ae,ue[S[te]]),ae=j.length-1;return le}e.$Gd=c;function v(S,j){return S[j+0]<<0>>>0|S[j+1]<<8>>>0}e.$Hd=v;function O(S,j,H){S[H+0]=j&255,j=j>>>8,S[H+1]=j&255}e.$Id=O;function g(S,j){return S[j]*2**24+S[j+1]*2**16+S[j+2]*2**8+S[j+3]}e.$Jd=g;function d(S,j,H){S[H+3]=j,j=j>>>8,S[H+2]=j,j=j>>>8,S[H+1]=j,j=j>>>8,S[H]=j}e.$Kd=d;function E(S,j){return S[j+0]<<0>>>0|S[j+1]<<8>>>0|S[j+2]<<16>>>0|S[j+3]<<24>>>0}e.$Ld=E;function w(S,j,H){S[H+0]=j&255,j=j>>>8,S[H+1]=j&255,j=j>>>8,S[H+2]=j&255,j=j>>>8,S[H+3]=j&255}e.$Md=w;function $(S,j){return S[j]}e.$Nd=$;function h(S,j,H){S[H]=j}e.$Od=h;function f(S){return D.$ud(S,j=>u.concat(j))}e.$Pd=f;function I(S){return D.$Bd(S)}e.$Qd=I;function p(S){return D.$wd(S,j=>u.concat(j))}e.$Rd=p;async function k(S){return S.ended?u.concat(S.buffer):u.concat([...S.buffer,await p(S.stream)])}e.$Sd=k;function t(S){return D.$zd(S,j=>u.concat(j))}e.$Td=t;function a(S){return D.$Cd(S,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Ud=a;function i(S){return D.$td(j=>u.concat(j),S)}e.$Vd=i;function s(S,j){return D.$Dd(S,j,H=>u.concat(H))}e.$Wd=s;function n(S,j){return D.$Ed(S,j,H=>u.concat(H))}e.$Xd=n;function r(S){let j=0,H=0,x=0;const _=new Uint8Array(Math.floor(S.length/4*3)),ue=ae=>{switch(H){case 3:_[x++]=j|ae,H=0;break;case 2:_[x++]=j|ae>>>2,j=ae<<6,H=3;break;case 1:_[x++]=j|ae>>>4,j=ae<<4,H=2;break;default:j=ae<<2,H=1}};for(let ae=0;ae<S.length;ae++){const le=S.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ae]}`)}}const te=x;for(;H>0;)ue(0);return u.wrap(_).slice(0,te)}e.$Yd=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:S},j=!0,H=!1){const x=H?P:l;let _="";const ue=S.byteLength%3;let te=0;for(;te<S.byteLength-ue;te+=3){const ae=S[te+0],le=S[te+1],ie=S[te+2];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[(le<<2|ie>>>6)&63],_+=x[ie&63]}if(ue===1){const ae=S[te+0];_+=x[ae>>>2],_+=x[ae<<4&63],j&&(_+="==")}else if(ue===2){const ae=S[te+0],le=S[te+1];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[le<<2&63],j&&(_+="=")}return _}e.$Zd=b}),define(ne[41],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function D(h){return R(h,0)}e.$pi=D;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return y(h,f);case"boolean":return N(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$qi=R;function A(h,f){return(f<<5)-f+h|0}e.$ri=A;function N(h,f){return A(h?433:863,f)}function y(h,f){f=A(149417,f);for(let I=0,p=h.length;I<p;I++)f=A(h.charCodeAt(I),f);return f}e.$si=y;function u(h,f){return f=A(104579,f),h.reduce((I,p)=>R(p,I),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=y(p,I),R(h[p],I)),f)}class v{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$ti=v;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function g(h,f,I=32){const p=I-f,k=~((1<<p)-1);return(h<<f|(k&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let k=0;k<I;k++)h[f+k]=p}function E(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):E((h>>>0).toString(16),f/4)}e.$ui=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let k=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let s=a;if(L.$Qe(a))if(i+1<I){const n=f.charCodeAt(i+1);L.$Re(n)?(i++,s=L.$Se(a,n)):s=65533}else{t=a;break}else L.$Re(a)&&(s=65533);if(k=this.w(p,k,s),i++,i<I)a=f.charCodeAt(i);else break}this.r=k,this.u=t}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,g(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,k=this.l,t=this.m,a=this.n,i=this.o,s,n,r;for(let l=0;l<80;l++)l<20?(s=k&t|~k&a,n=1518500249):l<40?(s=k^t^a,n=1859775393):l<60?(s=k&t|k&a|t&a,n=2400959708):(s=k^t^a,n=3395469782),r=g(p,5)+s+i+n+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=g(k,30),k=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+k&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$vi=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",N="warning",y="warn",u="info",c="ignore";function v(g){return g?L.$Me(A,g)?R.Error:L.$Me(N,g)||L.$Me(y,g)?R.Warning:L.$Me(u,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=v;function O(g){switch(g){case R.Error:return A;case R.Warning:return N;case R.Info:return u;default:return c}}R.toString=O}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?D(p):p}),f}e.$Vm=D;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(A.call(I,p)){const k=I[p];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.$mf)(k)&&f.push(k)}}return h}e.$Wm=R;const A=Object.prototype.hasOwnProperty;function N(h,f){return y(h,f,new Set)}e.$Xm=N;function y(h,f,I){if((0,L.$sf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const k=[];for(const t of h)k.push(y(t,f,I));return k}if((0,L.$lf)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const k={};for(const t in h)A.call(h,t)&&(k[t]=y(h[t],f,I));return I.delete(h),k}return h}function u(h,f,I=!0){return(0,L.$lf)(h)?((0,L.$lf)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$lf)(h[p])&&(0,L.$lf)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$Ym=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const k=[];for(p in h)k.push(p);k.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!c(k,t))return!1;for(I=0;I<k.length;I++)if(!c(h[k[I]],f[k[I]]))return!1}return!0}e.$Zm=c;function v(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$lf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$1m=v;function O(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(k=>{const t=h[k],a=f[k];c(t,a)||(I[k]=a)}),I}e.$2m=O;function g(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(k=>k.toLowerCase()===I);return p?h[p]:h[f]}e.$3m=g;function d(h,f){const I=Object.create(null);for(const[p,k]of Object.entries(h))f(p,k)&&(I[p]=k);return I}e.$4m=d;function E(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$5m=E;function w(h){const f=[];for(const I of E(h))typeof h[I]=="function"&&f.push(I);return f}e.$6m=w;function $(h,f){const I=k=>function(){const t=Array.prototype.slice.call(arguments,0);return f(k,t)},p={};for(const k of h)p[k]=I(k);return p}e.$7m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$3f=D,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const A=new Uint8Array(16),N=[];for(let y=0;y<256;y++)N.push(y.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c+="-",c+=N[A[u++]],c+=N[A[u++]],c+="-",c+=N[A[u++]],c+=N[A[u++]],c+="-",c+=N[A[u++]],c+=N[A[u++]],c+="-",c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c+=N[A[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const y=N.replace(/\-/g,":").toLowerCase();return!D.has(y)}function A(){const N=(0,L.networkInterfaces)();for(const y in N){const u=N[y];if(u){for(const{mac:c}of u)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(c){return this.a||(this.a=D.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,v=0;const O=(0,L.networkInterfaces)();for(const g in O){const d=O[g];if(d)for(const{mac:E,internal:w}of d)w||(v+=1,this.c(E.toUpperCase())&&(c+=1))}this.b=v>0?c/v:0}return this.b}};let N;async function y(c){return N||(N=(async()=>await u(c)||R.$4f())()),N}e.$Im=y;async function u(c){try{const v=await new Promise((g,d)=>{J(["crypto"],g,d)}),O=(0,A.$Gm)();return v.createHash("sha256").update(O,"utf8").digest("hex")}catch(v){c(v);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const D=60,R=D*60,A=R*24,N=A*7,y=A*30,u=A*365;function c(O,g,d,E){typeof O!="number"&&(O=O.getTime());const w=Math.round((new Date().getTime()-O)/1e3);if(w<-30)return(0,L.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!E&&w<30)return(0,L.localize)(1,null);let $;return w<D?($=w,g?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):w<R?($=Math.floor(w/D),g?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):w<A?($=Math.floor(w/R),g?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):w<N?($=Math.floor(w/A),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):w<y?($=Math.floor(w/N),g?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):w<u?($=Math.floor(w/y),g?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(w/u),g?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$6l=c;function v(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=v}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function A(O,g){return g&&(O.stack||O.stacktrace)?R.localize(0,null,y(O),N(O.stack)||N(O.stacktrace)):y(O)}function N(O){return Array.isArray(O)?O.join(`
`):O}function y(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,g=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const d=L.$Fb(O),E=u(d[0],g);return d.length>1?R.localize(4,null,E,d.length):E}if(D.$jf(O))return O;if(O.detail){const d=O.detail;if(d.error)return A(d.error,g);if(d.exception)return A(d.exception,g)}return O.stack?A(O,g):O.message?O.message:R.localize(5,null)}e.$mi=u;function c(O){const g=O;return g instanceof Error&&Array.isArray(g.actions)}e.$ni=c;function v(O,g){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=g,d}e.$oi=v}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$mp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var D;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(y,...u){const c=u.reduce((g,d)=>(g[d]=!0,g),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(g=>!c[g]).forEach(g=>{for(let d=0;d<v.length;d++)if(g.search(v[d])!==-1){delete y[g];break}})}e.$sl=A;function N(y){y&&(delete y.DEBUG,L.$j&&delete y.DYLD_LIBRARY_PATH,L.$k&&delete y.LD_PRELOAD)}e.$tl=N}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function D(c){const v=c;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.$Np=D;function R(c){const v=[];let O;try{const g=JSON.parse(c.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),O=d.__$stack),v.push(...g)}catch{v.push("Unable to log remote console arguments",c.arguments)}return{args:v,stack:O}}e.$Op=R;function A(c){if(typeof c!="string")return A(R(c).stack);const v=c;if(v){const O=N(v),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Pp=A;function N(c){if(!c)return c;const v=c.indexOf(`
`);return v===-1?c:c.substring(0,v)}function y(c,v){const{args:O,stack:g}=R(c),d=typeof O[0]=="string"&&O.length===1;let E=N(g);E&&(E=`(${E.trim()})`);let w=[];if(typeof O[0]=="string"?E&&d?w=[`%c[${v}] %c${O[0]} %c${E}`,u("blue"),u(""),u("grey")]:w=[`%c[${v}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:w=[`%c[${v}]%`,u("blue"),...O],E&&!d&&w.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=y;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function R(u){return JSON.stringify(u,N)}e.$9g=R;function A(u){let c=JSON.parse(u);return c=y(c),c}e.$0g=A;function N(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function y(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$Fd||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let v=0;v<u.length;++v)u[v]=y(u[v],c+1);else for(const v in u)Object.hasOwnProperty.call(u,v)&&(u[v]=y(u[v],c+1))}return u}e.$$g=y}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class N{constructor(g,d,E){this.id=g,this.dependencies=d,this.callback=E}}class y{static{this.INSTANCE=new y}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,E)=>{typeof g!="string"&&(E=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(E=d,d=null),this.c.push(new N(g,d,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,E)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),E(I)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((d,E)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(w){E(w)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new E.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function v(O,g,d){if(L.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const E=`${O}/${g}`;if(u.has(E))return u.get(E);let w;if(/^\w[\w\d+.-]*:\/\//.test(E))w=E;else{const I=`${d&&!R.$o?D.$Zf:D.$Yf}/${E}`;w=D.$2f.asBrowserUri(I).toString(!0)}const $=y.INSTANCE.load(w);return u.set(E,$),$}else return await new Promise((E,w)=>{J([O],E,w)})}e.$cC=v}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class O{constructor(k,t,a){this.exePath=k,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:k=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const a=D.$9d(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const l of await R.Promises.readdir(a)){let P=-1;if(k){const S=l.indexOf("-");if(S<0)continue;const j=l.substring(0,S);if(!A.test(j)||l.substring(S+1)!=="preview")continue;P=parseInt(j,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const b=D.$9d(a,l,"pwsh.exe");await R.SymlinkSupport.existsFile(b)&&(s=b,i=P)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",r=k?" Preview":"";return new O(s,`PowerShell${r}${n}`,!0)}async function E({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const k=D.$9d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(k))if(t.test(i)){const s=D.$9d(k,i,"pwsh.exe");return new O(s,a)}return null}function w(){const p=D.$9d(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$9d(process.env.windir,c===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await E(),p&&(yield p),p=w(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await E({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$ql=f;async function I(){for await(const p of f())return p;return null}e.$rl=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$ul=u;function c(O){let g=[],d=!1;const E=function(w){if(d){g.push(w);return}(!O.send(w,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(I=>E(I))}})||D.$i)&&(d=!0)};return{send:E}}e.$vl=c;var v;(function(O){async function g(d,E,w){if(L.$8d(d))return d;if(E===void 0&&(E=R.cwd()),L.$_d(d)!=="."||(w===void 0&&N.$jf(R.env.PATH)&&(w=R.env.PATH.split(L.$ge)),w===void 0||w.length===0))return L.$9d(E,d);async function h(f){if(await y.Promises.exists(f)){let I;try{I=await y.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await y.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of w){let I;if(L.$8d(f)?I=L.$9d(f,d):I=L.$9d(E,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$9d(E,d)}O.findExecutable=g})(v||(e.win32=v={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;async function N(O,g){return O===1?D.$i?v():A.$ul(g):u(O,g)}e.$wl=N;let y=null;function u(O,g){if(D.$k&&O===2||D.$j&&O===3)return"/bin/bash";if(!y){let d;if(D.$i)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let c=null;async function v(){return c||(c=(await(0,R.$rl)()).exePath),c}});var $e=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var y=J.length-1;y>=0;y--)(N=J[y])&&(A=(R<3?N(A):R>3?N(e,L,A):N(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,R,A,N,y,u,c,v,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let C=0;for(let B=0;;B+=7){const X=T.read(1);if(C|=(X.buffer[0]&127)<<B,!(X.buffer[0]&128))return C}}const I=i(0);function p(T,C){if(C===0){T.write(I);return}let B=0;for(let Y=C;Y!==0;Y=Y>>>7)B++;const X=R.$Fd.alloc(B);for(let Y=0;C!==0;Y++)X.buffer[Y]=C&127,C=C>>>7,C>0&&(X.buffer[Y]|=128);T.write(X)}class k{constructor(C){this.b=C,this.a=0}read(C){const B=this.b.slice(this.a,this.a+C);return this.a+=B.byteLength,B}}e.$_g=k;class t{constructor(){this.a=[]}get buffer(){return R.$Fd.concat(this.a)}write(C){this.a.push(C)}}e.$ah=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const C=R.$Fd.alloc(1);return C.writeUInt8(T,0),C}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function r(T,C){if(typeof C>"u")T.write(s.Undefined);else if(typeof C=="string"){const B=R.$Fd.fromString(C);T.write(s.String),p(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(C)){const B=R.$Fd.wrap(C);T.write(s.Buffer),p(T,B.byteLength),T.write(B)}else if(C instanceof R.$Fd)T.write(s.VSBuffer),p(T,C.byteLength),T.write(C);else if(Array.isArray(C)){T.write(s.Array),p(T,C.length);for(const B of C)r(T,B)}else if(typeof C=="number"&&(C|0)===C)T.write(s.Uint),p(T,C);else{const B=R.$Fd.fromString(JSON.stringify(C));T.write(s.Object),p(T,B.byteLength),T.write(B)}}e.$bh=r;function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const B=f(T),X=[];for(let Y=0;Y<B;Y++)X.push(l(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$ch=l;class P{constructor(C,B,X=null,Y=1e3){this.h=C,this.j=B,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(C,B){this.b.set(C,B),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const B=this.o([C.type]);this.k?.logOutgoing(B,0,1,$(C.type));return}case 201:case 202:case 204:case 203:{const B=this.o([C.type,C.id],C.data);this.k?.logOutgoing(B,C.id,1,$(C.type),C.data);return}}}o(C,B=void 0){const X=new t;return r(X,C),r(X,B),this.p(X.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const B=new k(C),X=l(B),Y=l(B),K=X[0];switch(K){case 100:return this.k?.logIncoming(C.byteLength,X[1],1,`${E(K)}: ${X[2]}.${X[3]}`,Y),this.s({type:K,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(C.byteLength,X[1],1,`${E(K)}: ${X[2]}.${X[3]}`,Y),this.t({type:K,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(C.byteLength,X[1],1,`${E(K)}`),this.u({type:K,id:X[1]});case 103:return this.k?.logIncoming(C.byteLength,X[1],1,`${E(K)}`),this.u({type:K,id:X[1]})}}s(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const X=new A.$pd;let Y;try{Y=B.call(this.j,C.name,C.arg,X.token)}catch(z){Y=Promise.reject(z)}const K=C.id;Y.then(z=>{this.m({id:K,data:z,type:201})},z=>{z instanceof Error?this.m({id:K,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:K,data:z,type:203})}).finally(()=>{U.dispose(),this.d.delete(C.id)});const U=(0,c.$ic)(()=>X.cancel());this.d.set(C.id,U)}t(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const X=C.id,K=B.listen(this.j,C.name,C.arg)(U=>this.m({id:X,data:U,type:204}));this.d.set(C.id,K)}u(C){const B=this.d.get(C.id);B&&(B.dispose(),this.d.delete(C.id))}v(C){let B=this.g.get(C.channelName);B||(B=[],this.g.set(C.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:C,timeoutTimer:X})}w(C){const B=this.g.get(C);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$dh=P;var b;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class S{constructor(C,B=null){this.l=C,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=B}getChannel(C){const B=this;return{call(X,Y,K){return B.a?Promise.reject(new y.$3):B.m(C,X,Y,K)},listen(X,Y){return B.a?u.Event.None:B.o(C,X,Y)}}}m(C,B,X,Y=A.CancellationToken.None){const K=this.g++,z={id:K,type:100,channelName:C,name:B,arg:X};if(Y.isCancellationRequested)return Promise.reject(new y.$3);let o;return new Promise((F,M)=>{if(Y.isCancellationRequested)return M(new y.$3);const Z=()=>{const pe=de=>{switch(de.type){case 201:this.f.delete(K),F(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,M(ge);break}case 203:this.f.delete(K),M(de.data);break}};this.f.set(K,pe),this.p(z)};let W=null;this.b===h.Idle?Z():(W=(0,D.$ug)(pe=>this.u()),W.then(()=>{W=null,Z()}));const ce=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),M(new y.$3)},oe=Y.onCancellationRequested(ce);o=(0,c.$hc)((0,c.$ic)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(C,B,X){const Y=this.g++,U={id:Y,type:102,channelName:C,name:B,arg:X};let z=null;const o=new u.$fd({onWillAddFirstListener:()=>{z=(0,D.$ug)(F=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(U)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:Y,type:103}))}}),m=F=>o.fire(F.data);return this.f.set(Y,m),o.event}p(C){switch(C.type){case 100:case 102:{const B=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(B,C.id,0,`${E(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const B=this.q([C.type,C.id]);this.j?.logOutgoing(B,C.id,0,E(C.type));return}}}q(C,B=void 0){const X=new t;return r(X,C),r(X,B),this.r(X.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const B=new k(C),X=l(B),Y=l(B),K=X[0];switch(K){case 200:return this.j?.logIncoming(C.byteLength,0,0,$(K)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,X[1],0,$(K),Y),this.t({type:X[0],id:X[1],data:Y})}}t(C){if(C.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$eh=S,$e([N.$6g],S.prototype,"onDidInitializePromise",null);class j{get connections(){const C=[];return this.f.forEach(B=>C.push(B)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new u.$fd,this.onDidAddConnection=this.g.event,this.h=new u.$fd,this.onDidRemoveConnection=this.h.event,this.j=new c.$jc,this.j.add(C(({protocol:B,onDidClientDisconnect:X})=>{const Y=u.Event.once(B.onMessage);this.j.add(Y(K=>{const U=new k(K),z=l(U),o=new P(B,z),m=new S(B);this.a.forEach((M,Z)=>o.registerChannel(Z,M));const F={channelServer:o,channelClient:m,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(X(()=>{o.dispose(),m.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(C,B){const X=this;return{call(Y,K,U){let z;if((0,g.$xf)(B)){const m=(0,L.$2b)(X.connections.filter(B));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,B))}else z=B.routeCall(X,Y,K);const o=z.then(m=>m.channelClient.getChannel(C));return x(o).call(Y,K,U)},listen(Y,K){if((0,g.$xf)(B))return X.k(C,B,Y,K);const U=B.routeEvent(X,Y,K).then(z=>z.channelClient.getChannel(C));return x(U).listen(Y,K)}}}k(C,B,X,Y){const K=this;let U;const z=new u.$fd({onWillAddFirstListener:()=>{U=new c.$jc;const o=new u.$ld,m=new Map,F=Z=>{const ce=Z.channelClient.getChannel(C).listen(X,Y),oe=o.add(ce);m.set(Z,oe)},M=Z=>{const W=m.get(Z);W&&(W.dispose(),m.delete(Z))};K.connections.filter(B).forEach(F),u.Event.filter(K.onDidAddConnection,B)(F,void 0,U),K.onDidRemoveConnection(M,void 0,U),o.event(z.fire,z,U),U.add(o)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return z.event}registerChannel(C,B){this.a.set(C,B);for(const X of this.f)X.channelServer.registerChannel(C,B)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=j;class H{constructor(C,B,X=null){const Y=new t;r(Y,B),C.send(Y.buffer),this.a=new S(C,X),this.d=new P(C,B,X)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,B){this.d.registerChannel(C,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=H;function x(T){return{call(C,B,X){return T.then(Y=>Y.call(C,B,X))},listen(C,B){const X=new u.$od;return T.then(Y=>X.input=Y.listen(C,B)),X.event}}}e.$hh=x;function _(T){let C=!1;return{call(B,X,Y){return C?T.call(B,X,Y):(0,D.$Hg)(0).then(()=>C=!0).then(()=>T.call(B,X,Y))},listen(B,X){if(C)return T.listen(B,X);const Y=new u.$od;return(0,D.$Hg)(0).then(()=>C=!0).then(()=>Y.input=T.listen(B,X)),Y.event}}}e.$ih=_;class ue{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const B of C.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$jh=ue;var te;(function(T){function C(K,U,z){const o=K,m=z&&z.disableMarshalling,F=new Map;for(const M in o)X(M)&&F.set(M,u.Event.buffer(o[M],!0,void 0,U));return new class{listen(M,Z,W){const ce=F.get(Z);if(ce)return ce;if(Y(Z)){const oe=o[Z];if(typeof oe=="function")return oe.call(o,W)}throw new y.$_(`Event not found: ${Z}`)}call(M,Z,W){const ce=o[Z];if(typeof ce=="function"){if(!m&&Array.isArray(W))for(let oe=0;oe<W.length;oe++)W[oe]=(0,v.$$g)(W[oe]);return ce.apply(o,W)}throw new y.$_(`Method not found: ${Z}`)}}}T.fromService=C;function B(K,U){const z=U&&U.disableMarshalling;return new Proxy({},{get(o,m){if(typeof m=="string")return U?.properties?.has(m)?U.properties.get(m):Y(m)?function(F){return K.listen(m,F)}:X(m)?K.listen(m):async function(...F){let M;U&&!(0,g.$sf)(U.context)?M=[U.context,...F]:M=F;const Z=await K.call(m,M);return z?Z:(0,v.$$g)(Z)};throw new y.$_(`Property not found: ${String(m)}`)}})}T.toService=B;function X(K){return K[0]==="o"&&K[1]==="n"&&O.$Le(K.charCodeAt(2))}function Y(K){return/^onDynamic/.test(K)&&O.$Le(K.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const C=T.toString();if(C!=="[object Object]")return C}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,C,B,X,Y,K,U){U=ie(U);const z=ae[Y],o=z[X%z.length];let m=[`%c[${T}]%c[${String(C).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(K)?(m=m.concat(U),m.push(")")):m.push(U),console.log.apply(console,m)}class G{constructor(C,B){this.d=C,this.f=B,this.a=0,this.b=0}logOutgoing(C,B,X,Y,K){this.b+=C,q(this.d,this.b,C,B,X,Y,K)}logIncoming(C,B,X,Y,K){this.a+=C,q(this.f,this.a,C,B,X,Y,K)}}e.$kh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class E extends d.$dh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$Fd.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Rp=E;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$fd,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new D.$Dg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,k){return f.k(h,I,p,k)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(y.$4());this.b.cancel();const k=this.n(h),t=(0,D.$ug)(s=>k.call(f,I,s)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,c.$ic)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const k=new u.$fd({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(k.fire,k),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,v.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$tl)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$fd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$Np)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(R.$Fd.wrap(Buffer.from(n,"base64")))});const k=this.j.useQueue?(0,O.$vl)(this.d):this.d,t=n=>this.d&&this.d.connected&&k.send(n.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new d.$eh(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",s),this.c.forEach(l=>(0,c.$fc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var y;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(y||(e.StorageHint=y={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Qo=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class v extends R.$kc{static{this.a=100}constructor(d,E=Object.create(null)){super(),this.r=d,this.s=E,this.b=this.B(new D.$id),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Eg(v.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((E,w)=>this.w(w,E)),d.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(d,E){if(this.c===c.Closed)return;let w=!1;(0,N.$sf)(E)?w=this.f.delete(d):this.f.get(d)!==E&&(this.f.set(d,E),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==y.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,E){const w=this.f.get(d);return(0,N.$sf)(w)?E:w}getBoolean(d,E){const w=this.get(d);return(0,N.$sf)(w)?E:w==="true"}getNumber(d,E){const w=this.get(d);return(0,N.$sf)(w)?E:parseInt(w,10)}getObject(d,E){const w=this.get(d);return(0,N.$sf)(w)?E:(0,A.$0g)(w)}async set(d,E,w=!1){if(this.c===c.Closed)return;if((0,N.$sf)(E))return this.delete(d,w);const $=(0,N.$lf)(E)||Array.isArray(E)?(0,A.$9g)(E):String(E);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,E=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===y.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===y.STORAGE_IN_MEMORY}}e.$Ro=v;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((E,w)=>this.a.set(w,E)),d.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$So=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const N=(0,D.localize)(3,null),y=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const O=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:O,lexeme:g,additionalInfo:v}),this.f.push(d)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const O=this.c.substring(this.d,this.e),g=u.b.get(O);g?this.k(g):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,O=!1,g=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(y);return}const E=this.c.charCodeAt(v);if(O)O=!1;else if(E===47&&!g){v++;break}else E===91?g=!0:E===92?O=!0:E===93&&(g=!1);v++}for(;v<this.c.length&&u.a.has(this.c.charCodeAt(v));)v++;this.e=v;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$_d)(R.$2f.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$9d)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,y.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$9d)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.$ig)(u.URI.file((0,A.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$9d)(d,"argv.json")):(0,y.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$0d)(d):(0,A.$7d)((0,A.$9d)(R.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$0d)(d)):u.URI.file((0,A.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$0d)(d);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const w=N.env.VSCODE_PORTABLE;return w?(0,A.$9d)(w,"extensions"):(0,y.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(E=>/^[^:/?#]+?:\/\//.test(E)?u.URI.parse(E):u.URI.file((0,A.$7d)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$7d)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$8l.test(d))}get extensionLogLevel(){const d=[];for(const E of this.args.log||[]){const w=e.$8l.exec(E);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,y.$ig)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$9d)(d,"policy.json")):(0,y.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,E,w){this.a=d,this.b=E,this.c=w,this.editSessionId=this.args.editSessionId}}e.$9l=c,$e([D.$6g],c.prototype,"appRoot",null),$e([D.$6g],c.prototype,"userHome",null),$e([D.$6g],c.prototype,"userDataPath",null),$e([D.$6g],c.prototype,"appSettingsHome",null),$e([D.$6g],c.prototype,"tmpDir",null),$e([D.$6g],c.prototype,"cacheHome",null),$e([D.$6g],c.prototype,"stateResource",null),$e([D.$6g],c.prototype,"userRoamingDataHome",null),$e([D.$6g],c.prototype,"userDataSyncHome",null),$e([D.$6g],c.prototype,"sync",null),$e([D.$6g],c.prototype,"machineSettingsResource",null),$e([D.$6g],c.prototype,"workspaceStorageHome",null),$e([D.$6g],c.prototype,"localHistoryHome",null),$e([D.$6g],c.prototype,"keyboardLayoutResource",null),$e([D.$6g],c.prototype,"argvResource",null),$e([D.$6g],c.prototype,"isExtensionDevelopment",null),$e([D.$6g],c.prototype,"untitledWorkspacesHome",null),$e([D.$6g],c.prototype,"builtinExtensionsPath",null),$e([D.$6g],c.prototype,"extensionsPath",null),$e([D.$6g],c.prototype,"extensionDevelopmentLocationURI",null),$e([D.$6g],c.prototype,"extensionDevelopmentKind",null),$e([D.$6g],c.prototype,"extensionTestsLocationURI",null),$e([D.$6g],c.prototype,"debugExtensionHost",null),$e([D.$6g],c.prototype,"logLevel",null),$e([D.$6g],c.prototype,"extensionLogLevel",null),$e([D.$6g],c.prototype,"serviceMachineIdResource",null),$e([D.$6g],c.prototype,"disableTelemetry",null),$e([D.$6g],c.prototype,"disableWorkspaceTrust",null),$e([D.$6g],c.prototype,"useInMemorySecretStorage",null),$e([D.$6g],c.prototype,"policyFile",null);function v(g,d){return O(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$0l=v;function O(g,d,E,w,$,h){const I=Number(d||g)||(w?null:E),p=I?!!d:!1;let k;if(h)try{k=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:k}}e.$$l=O}),function(){"use strict";function J(e,L,D){function R(N,y){const u=A(N,y),c=[u];return e.isAbsolute(u)||c.unshift(D),e.resolve(...c)}function A(N,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,y);const v=N["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,y)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class A extends D.$9l{constructor(c,v){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,v.nameShort)},v)}}e.$_l=A;function N(u,c){return(0,D.$$l)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$am=N;function y(u,c){return(0,D.$$l)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$bm=y}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function R(N,y,u,c){try{A(N,y,u,c)}catch(v){N.error(v?.message??v)}return y}e.$np=R;function A(N,y,u,c){const v=(O,g,d)=>{const E=O[g];if((0,L.$jf)(E)){const w=E,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],k=typeof p=="string"?p:p?.message;if(!I){k||N.warn(`[${y.name}]: ${(0,D.localize)(0,null,h)}`);return}if(d&&(g==="title"||g==="category")&&k&&k!==I){const t={value:I,original:k};O[g]=t}else O[g]=I}}else if((0,L.$lf)(E))for(const w in E)E.hasOwnProperty(w)&&(w==="commands"?v(E,w,!0):v(E,w,d));else if(Array.isArray(E))for(let w=0;w<E.length;w++)v(E,w,d)};for(const O in y)y.hasOwnProperty(O)&&v(y,O)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||N.test(h)}e.$Bo=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(N);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Co=c;function v(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let k=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(k=!1),a=!1);let i=0;if(h.preRelease){const s=y.exec(h.preRelease);if(s){const[,n,r,l]=s;i=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:k,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Do=v;function O(h,f,I){let p;typeof h=="string"?p=v(c(h)):p=h;let k;f instanceof Date?k=f.getTime():typeof f=="string"&&(k=new Date(f).getTime());let t;if(typeof I=="string"?t=v(c(I)):t=I,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,s=p.patchBase;let n=t.majorBase,r=t.minorBase,l=t.patchBase;const P=t.notBefore;let b=t.majorMustEqual,S=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>r?!0:i<r||k&&k<P?!1:s>=l:(a===1&&n===0&&(!b||!S||!j)&&(n=1,r=0,l=0,b=!0,S=!1,j=!1),a<n?!1:a>n?!b:i<r?!1:i>r?!S:s<l?!1:s>l?!j:!(k&&k<P))}e.$Eo=O;function g(h,f,I,p,k){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([D.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,R.localize(9,null,"main")]),t;{const s=(0,L.$ig)(I,p.main);(0,L.$cg)(s,I)||t.push([D.default.Warning,R.localize(10,null,s.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,R.localize(11,null,"browser")]),t;{const s=(0,L.$ig)(I,p.browser);(0,L.$cg)(s,I)||t.push([D.default.Warning,R.localize(12,null,s.path,I.path)])}}if(!A.valid(p.version))return t.push([D.default.Error,R.localize(13,null)]),t;const a=[];if(!d(h,f,p,k,a))for(const s of a)t.push([D.default.Error,s]);return t}e.$Fo=g;function d(h,f,I,p,k){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:w(h,f,I.engines.vscode,k)}e.$Go=d;function E(h,f,I){return h==="*"||w(f,I,h)}e.$Ho=E;function w(h,f,I,p=[]){const k=v(c(I));if(!k)return p.push(R.localize(14,null,I)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return p.push(R.localize(15,null,I)),!1}else if(!k.majorMustEqual)return p.push(R.localize(16,null,I)),!1;return O(h,f,k)?!0:(p.push(R.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function R(A,N,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const v=(await N.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$3f)(v)?v:null}catch{u=null}if(!u){u=(0,D.$4f)();try{await N.writeFile(A.serviceMachineIdResource,L.$Fd.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.$2o=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class L{constructor(R,A=[],N=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$yh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const D=[];var R;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(y,u,c){u instanceof L.$yh||(u=new L.$yh(u,[],!!c)),D.push([y,u])}e.$mr=A;function N(){return D}e.$nr=N}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$4p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const y=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(N);y.outgoing.set(u.key,u),u.incoming.set(y.key,y)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const y of this.a.values())y.outgoing.delete(N),y.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let y=this.a.get(N);return y||(y=new L(N,A),this.a.set(N,y)),y}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,y]of this.a)A.push(`${N}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const y=new Set([A]),u=this.c(N,y);if(u)return u}}c(A,N){for(const[y,u]of A.outgoing){if(N.has(y))return[...N,y].join(" -> ");N.add(y);const c=this.c(u,N);if(c)return c;N.delete(y)}}}e.$5p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,R.$Bh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$9h=A;function N(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$0h=N;var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(y||(e.ConfigurationTarget=y={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$_h=c;function v(h,f){const I=Object.create(null);for(const p in h)O(I,p,h[p],f);return I}e.$ai=v;function O(h,f,I,p){const k=f.split("."),t=k.pop();let a=h;for(let i=0;i<k.length;i++){const s=k[i];let n=a[s];switch(typeof n){case"undefined":n=a[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${k.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=I}catch{p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$bi=O;function g(h,f){const I=f.split(".");d(h,I)}e.$ci=g;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function E(h,f,I){function p(a,i){let s=a;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const k=f.split("."),t=p(h,k);return typeof t>"u"?I:t}e.$di=E;function w(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$lf(h[p])&&L.$lf(f[p])?w(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$ei=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$fi=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$G),u.set("isFirefox",L.$E),u.set("isChrome",L.$D),u.set("isSafari",L.$F);function c(z,o){if(u.get(z)!==void 0)throw(0,y.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Gi=c;const v=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const g={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),E=(0,N.localize)(1,null),w=(0,N.localize)(2,null),$=(0,N.localize)(3,null),h=(0,N.localize)(4,null),f=(0,N.localize)(5,null),I=(0,N.localize)(6,null),p=(0,N.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=g){this.k=o,this.d=new R.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const F=this.D(),M=F.type===17?f:void 0;throw this.h.push({message:h,offset:F.offset,lexeme:R.$Fi.getLexeme(F),additionalInfo:M}),k.c}return m}catch(m){if(m!==k.c)throw m;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const m=this.o();o.push(m)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const m=this.s();o.push(m)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=o.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const Z=M.lexeme,W=Z.lastIndexOf("/"),ce=W===Z.length-1?void 0:this.w(Z.substring(W+1));let oe;try{oe=new RegExp(Z.substring(1,W),ce)}catch{throw this.B("REGEX",M)}return le.create(m,oe)}switch(M.type){case 10:case 19:{const Z=[M.lexeme];this.z();let W=this.D(),ce=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?ce++:M.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?ce++:M.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Z.push(R.$Fi.getLexeme(W)),this.z(),W=this.D()}const oe=Z.join(""),pe=oe.lastIndexOf("/"),de=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let ge;try{ge=new RegExp(oe.substring(1,pe),de)}catch{throw this.B("REGEX",M)}return t.regex(m,ge)}case 18:{const Z=M.lexeme;this.z();let W=null;if(!(0,D.$me)(Z)){const ce=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(ce!==oe&&ce>=0){const pe=Z.slice(ce+1,oe),de=Z[oe+1]==="i"?"i":"";try{W=new RegExp(pe,de)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const M=this.u();return t.notIn(m,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return t.equals(m,M);switch(M){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return t.notEquals(m,M);switch(M){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,M)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:I,offset:o.offset,lexeme:"",additionalInfo:p}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,m){if(this.C(o))return this.z();throw this.B(m,this.D())}B(o,m,F){const M=(0,N.localize)(8,null,o,R.$Fi.getLexeme(m)),Z=m.offset,W=R.$Fi.getLexeme(m);return this.h.push({message:M,offset:Z,lexeme:W,additionalInfo:F}),k.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=k;class t{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(o){return l.create(o)}static equals(o,m){return P.create(o,m)}static notEquals(o,m){return j.create(o,m)}static regex(o,m){return le.create(o,m)}static in(o,m){return b.create(o,m)}static notIn(o,m){return S.create(o,m)}static not(o){return H.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,m){return _.create(o,m)}static greaterEquals(o,m){return ue.create(o,m)}static smaller(o,m){return te.create(o,m)}static smallerEquals(o,m){return ae.create(o,m)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Ii=t;function a(z){const o=new k({regexParsingWithErrorRecovery:!1});return z.map(m=>(o.parse(m),o.lexingErrors.length>0?o.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,N.localize)(9,null,F.additionalInfo):(0,N.localize)(10,null),offset:F.offset,length:F.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Ji=a;function i(z,o){const m=z?z.substituteConstants():void 0,F=o?o.substituteConstants():void 0;return!m&&!F?!0:!m||!F?!1:m.equals(F)}e.$Ki=i;function s(z,o){return z.cmp(o)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Li=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return n.INSTANCE}}e.$Mi=r;class l{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?r.INSTANCE:n.INSTANCE:new l(o,m)}constructor(o,m){this.key=o,this.c=m,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:B(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:n.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Ni=l;class P{static create(o,m,F=null){if(typeof m=="boolean")return m?l.create(o,F):H.create(o,F);const M=u.get(o);return typeof M=="boolean"?m===(M?"true":"false")?r.INSTANCE:n.INSTANCE:new P(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Oi=P;class b{static create(o,m){return new b(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.f),F=o.getValue(this.d);return Array.isArray(m)?m.includes(F):typeof F=="string"&&typeof m=="object"&&m!==null?v.call(m,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Pi=b;class S{static create(o,m){return new S(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=11,this.c=b.create(o,m)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=S;class j{static create(o,m,F=null){if(typeof m=="boolean")return m?H.create(o,F):l.create(o,F);const M=u.get(o);return typeof M=="boolean"?m===(M?"true":"false")?n.INSTANCE:r.INSTANCE:new j(o,m,F)}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ri=j;class H{static create(o,m=null){const F=u.get(o);return typeof F=="boolean"?F?n.INSTANCE:r.INSTANCE:new H(o,m)}constructor(o,m){this.c=o,this.d=m,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:B(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?n.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Si=H;function x(z,o){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?o(z):n.INSTANCE}class _{static create(o,m,F=null){return x(m,M=>new _(o,M,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ti=_;class ue{static create(o,m,F=null){return x(m,M=>new ue(o,M,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Ui=ue;class te{static create(o,m,F=null){return x(m,M=>new te(o,M,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Vi=te;class ae{static create(o,m,F=null){return x(m,M=>new ae(o,M,F))}constructor(o,m,F){this.c=o,this.d=m,this.f=F,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Wi=ae;class le{static create(o,m){return new le(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return m<F?-1:m>F?1:0}equals(o){if(o.type===this.type){const m=this.f?this.f.source:"",F=o.f?o.f.source:"";return this.d===o.d&&m===F}return!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Xi=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$Yi=ie;function q(z){let o=null;for(let m=0,F=z.length;m<F;m++){const M=z[m].substituteConstants();if(z[m]!==M&&o===null){o=[];for(let Z=0;Z<m;Z++)o[Z]=z[Z]}o!==null&&(o[m]=M)}return o===null?z:o}class G{static create(o,m,F){return G.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const M=s(this.expr[m],o.expr[m]);if(M!==0)return M}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].evaluate(o))return!1;return!0}static d(o,m,F){const M=[];let Z=!1;for(const W of o)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&Z)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(s);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const ce=M.pop(),oe=M.length===0,pe=T.create(W.expr.map(de=>G.create([de,ce],null,F)),null,oe);pe&&(M.push(pe),M.sort(s))}if(M.length===1)return M[0];if(F){for(let W=0;W<M.length;W++)for(let ce=W+1;ce<M.length;ce++)if(M[W].negate().equals(M[ce]))return n.INSTANCE;if(M.length===1)return M[0]}return new G(M,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new G(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());this.c=T.create(o,this,!0)}return this.c}}e.$Zi=G;class T{static create(o,m,F){return T.d(o,m,F)}constructor(o,m){this.expr=o,this.c=m,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,F=this.expr.length;m<F;m++){const M=s(this.expr[m],o.expr[m]);if(M!==0)return M}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,F=this.expr.length;m<F;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let m=0,F=this.expr.length;m<F;m++)if(this.expr[m].evaluate(o))return!0;return!1}static d(o,m,F){let M=[],Z=!1;if(o){for(let W=0,ce=o.length;W<ce;W++){const oe=o[W];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){M=M.concat(oe.expr);continue}M.push(oe)}}if(M.length===0&&Z)return n.INSTANCE;M.sort(s)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(F){for(let W=0;W<M.length;W++)for(let ce=W+1;ce<M.length;ce++)if(M[W].negate().equals(M[ce]))return r.INSTANCE;if(M.length===1)return M[0]}return new T(M,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new T(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());for(;o.length>1;){const m=o.shift(),F=o.shift(),M=[];for(const Z of U(m))for(const W of U(F))M.push(G.create([Z,W],null,!1));o.unshift(T.create(M,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$1i=T;class C extends l{static{this.d=[]}static all(){return C.d.values()}constructor(o,m,F){super(o,null),this.f=m,typeof F=="object"?C.d.push({...F,key:o}):F!==!0&&C.d.push({key:o,description:F,type:m!=null?typeof m:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return P.create(this.key,o)}notEqualsTo(o){return j.create(this.key,o)}}e.$2i=C,e.$3i=(0,A.$Bh)("contextKeyService");function B(z,o){return z<o?-1:z>o?1:0}function X(z,o,m,F){return z<m?-1:z>m?1:o<F?-1:o>F?1:0}function Y(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?K(z.expr,o.expr):!1;if(o.type===9){for(const m of o.expr)if(Y(z,m))return!0;return!1}if(z.type===6){if(o.type===6)return K(o.expr,z.expr);for(const m of z.expr)if(Y(m,o))return!0;return!1}return z.equals(o)}e.$4i=Y;function K(z,o){let m=0,F=0;for(;m<z.length&&F<o.length;){const M=z[m].cmp(o[F]);if(M<0)return!1;M===0&&m++,F++}return m===z.length}function U(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$Dn=(0,L.$Bh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,L.$Bh)("environmentService"),e.$Jh=(0,L.$Ch)(e.$Ih)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=A;function N(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=N;function y(f,I){return I==="web"&&!f.includes("web")}e.$Vn=y;function u(f,I,p){return y(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$Wn=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=c;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Yn=v;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Zn=(0,D.$Bh)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$1n=h,e.$2n=(0,D.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,D.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,D.$Bh)("IExtensionTipsService"),e.$7n=(0,L.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=void 0,e.$7o=(0,L.$Bh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,N)=>J(["node-vsce-sign"],async y=>A(y),N))),this.a}async verify(A,N,y){let u;try{u=await this.b()}catch{return!1}return u.verify(A,N,y)}}e.$8o=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function N(v,O,g,d,E,w){let $;try{await y(v,O,g,d,E,w)}catch(h){$=h}finally{$&&E.errorTransformer&&($=E.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Cp=N;async function y(v,O,g,d,E,w){u(w);const $=await v.open(O,{create:!1});try{u(w);let h=0,f=0,I=E&&typeof E.length=="number"?E.length:void 0,p=L.$Fd.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),k=E&&typeof E.position=="number"?E.position:0,t=0;do f=await v.read($,k,p.buffer,t,p.byteLength-t),k+=f,t+=f,h+=f,typeof I=="number"&&(I-=f),t===p.byteLength&&(await g.write(d(p)),p=L.$Fd.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),t=0);while(f>0&&(typeof I!="number"||I>0)&&u(w)&&c(h,E));if(t>0){let a=t;typeof I=="number"&&(a=Math.min(t,I)),g.write(d(p.slice(0,a)))}}catch(h){throw(0,A.$gk)(h)}finally{await v.close($)}}function u(v){if(v.isCancellationRequested)throw(0,D.$4)();return!0}function c(v,O){if(typeof O?.limits?.size=="number"&&v>O.limits.size)throw(0,A.$fk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class y extends R.$kc{constructor(){super(...arguments),this.a=this.B(new L.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$fd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const v=this.j(c),O=v.filter(d=>{const E=this.c.get(d.path);return E?!(0,D.$vj)(E.request.excludes,d.excludes)||!(0,D.$vj)(E.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!v.find(E=>E.path===d.path&&(0,D.$vj)(E.excludes,d.excludes)&&(0,D.$vj)(E.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.m(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of O)this.g(d)}g(c){const v=new N.$Yp(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),O={request:c,instance:v};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const v=this.c.get(c);v&&(this.c.delete(c),v.instance.dispose())}j(c){const v=new Map;for(const O of c){const g=A.$k?O.path:O.path.toLowerCase();v.set(g,O)}return Array.from(v.values())}async setVerboseLogging(c){this.f=c;for(const[,v]of this.c)v.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,v){return v?`[File Watcher (node.js)] ${c} (path: ${v.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$1p=y}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class R extends L.$Gp{constructor(N,y,u){super(N,y,u),this.s()}r(N){return N.add(new D.$1p)}}e.$2p=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class N extends A.$Hp{constructor(u,c,v){super(u,c,v),this.s()}r(u){const c=u.add(new R.$Sp(L.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:v,signal:O})=>this.t(`terminated by itself with code ${v}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$ih)(c.getChannel("watcher")))}}e.$Tp=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,N]of R)this.set(A,N)}set(R,A){const N=this.a.get(R);return this.a.set(R,A),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$zh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const v=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$zh,h=!1,f,I=v){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(y.$Ah,this),this._globalGraph=I?f?._globalGraph??new N.$5p(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=E.traceInvocation(this.i,$);let I=!1;try{return $({get:k=>{if(I)throw(0,D.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(k,f);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof A.$yh?(f=E.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=E.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=y._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of I){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const k=I.length>0?I[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${$.name} at position ${k+1} conflicts with ${h.length} static arguments`);const t=k-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,k)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$yh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$yh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new N.$5p(t=>t.id.toString());let p=0;const k=[{id:$,desc:h,_trace:f}];for(;k.length;){const t=k.pop();if(I.lookupOrInsertNode(t),p++>1e3)throw new O(I);for(const a of y._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$yh){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};I.insertEdge(t,s),k.push(s)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$yh){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}I.removeNode(a)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof A.$yh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const k=new g(void 0,this.g,this,this.i);k.c=String($);const t=new Map,a=new L.$Xg(()=>{const i=k.j(h,f,p);for(const[s,n]of t){const r=i[s];if(typeof r=="function")for(const l of n)r.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let l=t.get(s);return l||(l=new c.$tc,t.set(s,l)),(b,S,j)=>{const H=l.push([b,S,j]);return(0,R.$ic)(H)}}if(s in i)return i[s];const n=a.value;let r=n[s];return typeof r!="function"||(r=r.bind(n),i[s]=r),r},set(i,s,n){return a.value[s]=n,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$6p=g;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new E(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation($,h){return $?new E(1,h.name):E.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new E(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;E.f+=$;let h=!1;function f(p,k){const t=[],a=new Array(p+1).join("	");for(const[i,s,n]of k.h)if(s&&n){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,n);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];($>2||h)&&E.all.add(I.join(`
`))}}e.$7p=E});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=void 0;function u(v){return v.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Hq=u,e.$Iq=(0,y.$Bh)("languagePackService");let c=class extends D.$kc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$pd;setTimeout(()=>O.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const E=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return E.push(this.f("en","English")),E}f(O,g,d){const E=g??O;let w;if(E!==O&&(w=`(${O})`),O.toLowerCase()===R.$v.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),d?.installCount){w??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:O,label:E,description:w}}};e.$Jq=c,e.$Jq=c=$e([se(0,N.$Zn)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,R,A,N,y,u,c,v,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,g.$Bh)("logService"),e.$6i=(0,g.$Bh)("loggerService");function d(){return new Date().toISOString()}function E(b){return(0,c.$nf)(b)}e.$7i=E;var w;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8i=w.Info;function $(b,S,j){switch(S){case w.Trace:b.trace(j);break;case w.Debug:b.debug(j);break;case w.Info:b.info(j);break;case w.Warning:b.warn(j);break;case w.Error:b.error(j);break;case w.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=$;function h(b,S=!1){let j="";for(let H=0;H<b.length;H++){let x=b[H];if(x instanceof Error&&(x=(0,L.$mi)(x,S)),typeof x=="object")try{x=JSON.stringify(x)}catch{}j+=(H>0?" ":"")+x}return j}class f extends A.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new D.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==w.Off&&this.b<=S}}e.$0i=f;class I extends f{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...j){this.f(w.Trace)&&this.g(w.Trace,h([S,...j],!0))}debug(S,...j){this.f(w.Debug)&&this.g(w.Debug,h([S,...j]))}info(S,...j){this.f(w.Info)&&this.g(w.Info,h([S,...j]))}warn(S,...j){this.f(w.Warning)&&this.g(w.Warning,h([S,...j]))}error(S,...j){if(this.f(w.Error))if(S instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=S.stack,this.g(w.Error,h(H))}else this.g(w.Error,h([S,...j]))}flush(){}}e.$$i=I;class p extends f{constructor(S=e.$8i){super(),this.setLevel(S),this.g=!y.$i}trace(S,...j){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,S,...j):console.log(`[main ${d()}]`,S,...j))}debug(S,...j){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,S,...j):console.log(`[main ${d()}]`,S,...j))}info(S,...j){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,S,...j):console.log(`[main ${d()}]`,S,...j))}warn(S,...j){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,S,...j):console.warn(`[main ${d()}]`,S,...j))}error(S,...j){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,S,...j):console.error(`[main ${d()}]`,S,...j))}dispose(){}flush(){}}e.$_i=p;class k extends f{constructor(S=e.$8i,j=!0){super(),this.g=j,this.setLevel(S)}trace(S,...j){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...j):console.log(S,...j))}debug(S,...j){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...j):console.log(S,...j))}info(S,...j){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...j):console.log(S,...j))}warn(S,...j){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...j):console.log(S,...j))}error(S,...j){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...j):console.error(S,...j))}dispose(){}flush(){}}e.$aj=k;class t extends f{constructor(S,j=e.$8i){super(),this.g=S,this.setLevel(j)}trace(S,...j){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(S),...j])}debug(S,...j){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(S),...j])}info(S,...j){this.f(w.Info)&&this.g.log(w.Info,[this.h(S),...j])}warn(S,...j){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(S),...j])}error(S,...j){this.f(w.Error)&&this.g.log(w.Error,[this.h(S),...j])}h(S){return typeof S=="string"?S:(0,L.$mi)(S,this.f(w.Trace))}dispose(){}flush(){}}e.$bj=t;class a extends f{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const j of this.g)j.setLevel(S);super.setLevel(S)}trace(S,...j){for(const H of this.g)H.trace(S,...j)}debug(S,...j){for(const H of this.g)H.debug(S,...j)}info(S,...j){for(const H of this.g)H.info(S,...j)}warn(S,...j){for(const H of this.g)H.warn(S,...j)}error(S,...j){for(const H of this.g)H.error(S,...j)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.$cj=a;class i extends A.$kc{constructor(S,j,H){if(super(),this.h=S,this.j=j,this.b=new N.$zi,this.c=this.B(new D.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeVisibility=this.g.event,H)for(const x of H)this.b.set(x.resource,{logger:void 0,info:x})}m(S){return(0,c.$jf)(S)?[...this.b.values()].find(j=>j.info.id===S):this.b.get(S)}getLogger(S){return this.m(S)?.logger}createLogger(S,j){const H=this.n(S),x=(0,c.$jf)(S)?S:j?.id??(0,R.$pi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const ue=j?.logLevel==="always"?w.Trace:j?.logLevel;_||(_=this.s(H,ue??this.getLogLevel(H)??this.h,{...j,id:x}));const te={logger:_,info:{resource:H,id:x,logLevel:ue,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(te.info),this.b.set(H,te),_}n(S){return(0,c.$jf)(S)?(0,u.$ig)(this.j,`${S}.log`):S}setLogLevel(S,j){if(v.URI.isUri(S)){const H=S,x=j,_=this.b.get(H);_&&x!==_.info.logLevel&&(_.info.logLevel=x===this.h?void 0:x,_.logger?.setLevel(x),this.b.set(_.info.resource,_),this.f.fire([H,x]))}else{this.h=S;for(const[H,x]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,j){const H=this.m(S);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(S){let j;return S&&(j=this.b.get(S)?.info.logLevel),j??this.h}registerLogger(S){const j=this.b.get(S.resource);j?j.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const j=this.b.get(S);j&&(j.logger&&j.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=i;class s{constructor(){this.onDidChangeLogLevel=new D.$fd().event}setLevel(S){}getLevel(){return w.Info}trace(S,...j){}debug(S,...j){}info(S,...j){}warn(S,...j){}error(S,...j){}critical(S,...j){}dispose(){}flush(){}}e.$ej=s;class n extends s{}e.$fj=n;function r(b){if(b.verbose)return w.Trace;if(typeof b.logLevel=="string"){const S=P(b.logLevel.toLowerCase());if(S!==void 0)return S}return e.$8i}e.$gj=r;function l(b){switch(b){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$hj=l;function P(b){switch(b){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ij=P,e.$jj=new O.$2i("logLevel",l(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class v extends N.$kc{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new A.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Eg(0)),this.w=[],this.y=this.B(new D.$Eg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(g,d):this.z(g,d)}n(g,d){const E={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,L.$Sb)(this.j,E);return this.r(),(0,N.$ic)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,R.$Y)(g))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Ip)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Ep)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Ep)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,d){const E={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,L.$Sb)(this.w,E);return this.C(),(0,N.$ic)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,R.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Ip)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,y.$7d)(g.fsPath)}}e.$Mp=v}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let p=class extends c.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new N.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$Pg)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new c.$jc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.X.fire(new $.$lk(s,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.Y.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$fc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.$mg)(t))throw new $.$nk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$_;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$$j)(a)||(0,$.$8j)(a)||(0,$.$_j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$$j)(a)||(0,$.$8j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$ik)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$nk((0,w.localize)(2,null,this.rb(t)),1):(0,$.$gk)(i)}}async s(t,a){const i=await this.j(t),s=this.S(i),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,P=await i.stat(t);let b;return this.t(i,t,P,void 0,!!l,(S,j)=>(b||(b=v.$Hh.forUris(()=>!s),b.set(t,!0),n&&b.fill(!0,n)),b.get(S.resource)||b.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&r?j===1:!1))}async t(t,a,i,s,n,r){const{providerExtUri:l}=this.R(t),P={resource:a,name:l.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$yk)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&r(P,s)){try{const b=await t.readdir(a),S=await D.Promises.settled(b.map(async([j,H])=>{try{const x=l.joinPath(a,j),_=n?await t.stat(x):{type:H};return await this.t(t,x,_,b.length,n,r)}catch(x){return this.b.trace(x),null}}));P.children=(0,L.$Fb)(S)}catch(b){this.b.trace(b),P.children=[]}return P}return P}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$nk((0,w.localize)(3,null,this.rb(t)),3,a)}async createFile(t,a=R.$Fd.fromString(""),i){await this.u(t,i);const s=await this.writeFile(t,a);return this.r.fire(new $.$kk(t,0,s)),s}async writeFile(t,a,i){const s=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(s);let r=i;if((0,$.$bk)(s)&&!r?.atomic){const l=s.enforceAtomicWriteFile?.(t);l&&(r={...i,atomic:l})}try{await this.w(s,t,r)||await this.U(s,n.dirname(t));let P;if((0,$.$8j)(s)&&!(a instanceof R.$Fd))if((0,E.$rd)(a)){const b=await(0,E.$yd)(a,3);b.ended?P=R.$Fd.concat(b.buffer):P=b}else P=(0,E.$vd)(a,b=>R.$Fd.concat(b),3);else P=a;if(!(0,$.$$j)(s)||(0,$.$8j)(s)&&P instanceof R.$Fd||(0,$.$8j)(s)&&(0,$.$bk)(s)&&r?.atomic)await this.gb(s,t,r,P);else{const b=P instanceof R.$Fd?(0,R.$Qd)(P):P;r?.atomic!==!1&&r?.atomic?.postfix?await this.bb(s,t,(0,d.$ig)((0,d.$hg)(t),`${(0,d.$fg)(t)}${r.atomic.postfix}`),r,b):await this.cb(s,t,r,b)}this.r.fire(new $.$kk(t,4))}catch(l){throw new $.$nk((0,w.localize)(4,null,this.rb(t),(0,$.$gk)(l).toString()),(0,$.$jk)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(a)));if(s)throw new Error((0,w.localize)(7,null,this.rb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$nk((0,w.localize)(8,null,this.rb(a)),0,i);if(this.qb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$xk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$yk)({mtime:i.mtime,size:r.size}))throw new $.$nk((0,w.localize)(9,null),3,i);return r}async readFile(t,a,i){const s=await this.m(t);return a?.atomic?this.z(s,t,a,i):this.C(s,t,a,i)}async z(t,a,i,s){return new Promise((n,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const l=await this.C(t,a,i,s);n(l)}catch(l){r(l)}})})}async C(t,a,i,s){const n=await this.D(t,a,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,R.$Rd)(n.value)}}async readFileStream(t,a,i){const s=await this.m(t);return this.D(s,t,a,i)}async D(t,a,i,s){const n=new A.$pd(s);let r=i;(0,$.$ak)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...i,atomic:!0});const l=this.J(a,r).then(b=>b,b=>{throw n.dispose(!0),b});let P;try{return typeof r?.etag=="string"&&r.etag!==$.$xk&&await l,r?.atomic&&(0,$.$ak)(t)||!((0,$.$$j)(t)||(0,$.$_j)(t))||(0,$.$8j)(t)&&r?.preferUnbuffered?P=this.I(t,a,r):(0,$.$_j)(t)?P=this.G(t,a,n.token,r):P=this.H(t,a,n.token,r),P.on("end",()=>n.dispose()),P.on("error",()=>n.dispose()),{...await l,value:P}}catch(b){throw P&&await(0,E.$wd)(P),this.F(b,a,r)}}F(t,a,i){const s=(0,w.localize)(10,null,this.rb(a),(0,$.$gk)(t).toString());return t instanceof $.$pk?new $.$pk(s,t.stat,i):t instanceof $.$ok?new $.$ok(s,t.fileOperationResult,t.size,t.options):new $.$nk(s,(0,$.$jk)(t),i)}G(t,a,i,s=Object.create(null)){const n=t.readFileStream(a,s,i);return(0,E.$Cd)(n,{data:r=>r instanceof R.$Fd?r:R.$Fd.wrap(r),error:r=>this.F(r,a,s)},r=>R.$Fd.concat(r))}H(t,a,i,s=Object.create(null)){const n=(0,R.$Vd)();return(0,h.$Cp)(t,a,n,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,a,s)},i),n}I(t,a,i){const s=(0,E.$td)(n=>R.$Fd.concat(n));return(async()=>{try{let n;i?.atomic&&(0,$.$ak)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.L(a,n.byteLength,i),s.end(R.$Fd.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$nk((0,w.localize)(11,null,this.rb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$xk&&a.etag===i.etag)throw new $.$pk((0,w.localize)(12,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$ok((0,w.localize)(13,null,this.rb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,s){if(t.toString()!==a.toString())try{const n=i==="move"?this.pb(await this.n(t),t):await this.m(t),r=this.pb(await this.n(a),a);await this.Q(n,t,r,a,i,s)}catch(n){return n}return!0}async move(t,a,i){const s=this.pb(await this.n(t),t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,r==="move"?2:3,l)),l}async copy(t,a,i){const s=await this.m(t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,r==="copy"?3:2,l)),l}async N(t,a,i,s,n,r){if(a.toString()===s.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:P}=await this.Q(t,a,i,s,n,r);if(l&&!P&&r&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,$.$9j)(t))await t.copy(a,s,{overwrite:r});else{const b=await this.resolve(a);b.isDirectory?await this.P(t,b,i,s):await this.O(t,a,i,s)}return n}else return t===i?(await t.rename(a,s,{overwrite:r}),n):(await this.N(t,a,i,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,s){if((0,$.$$j)(t)&&(0,$.$$j)(i))return this.ib(t,a,i,s);if((0,$.$$j)(t)&&(0,$.$8j)(i))return this.ob(t,a,i,s);if((0,$.$8j)(t)&&(0,$.$$j)(i))return this.mb(t,a,i,s);if((0,$.$8j)(t)&&(0,$.$8j)(i))return this.kb(t,a,i,s)}async P(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async n=>{const r=this.R(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),i,r):this.O(t,n.resource,i,r)}))}async Q(t,a,i,s,n,r){let l=!1;if(t===i){const{providerExtUri:b,isPathCaseSensitive:S}=this.R(t);if(S||(l=b.isEqual(a,s)),l&&n==="copy")throw new Error((0,w.localize)(14,null,this.rb(a),this.rb(s)));if(!l&&b.isEqualOrParent(s,a))throw new Error((0,w.localize)(15,null,this.rb(a),this.rb(s)))}const P=await this.exists(s);if(P&&!l){if(!r)throw new $.$nk((0,w.localize)(16,null,this.rb(a),this.rb(s)),4);if(t===i){const{providerExtUri:b}=this.R(t);if(b.isEqualOrParent(a,s))throw new Error((0,w.localize)(17,null,this.rb(a),this.rb(s)))}}return{exists:P,isSameResourceWithDifferentPathCase:l}}R(t){const a=this.S(t);return{providerExtUri:a?d.$$f:d.$ag,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.pb(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$kk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:s}=this.R(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(a)));break}catch(n){if((0,$.$ik)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(a)),a=s.dirname(a)}for(let n=i.length-1;n>=0;n--){a=s.joinPath(a,i[n]);try{await t.mkdir(a)}catch(r){if((0,$.$ik)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.pb(await this.j(t),t),s=!!a?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const n=a?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(s&&n)throw new Error((0,w.localize)(21,null,this.rb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.qb(t,r);else throw new $.$nk((0,w.localize)(22,null,this.rb(t)),1);if(!!!a?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return i}async del(t,a){const i=await this.W(t,a);let s=a;if((0,$.$ck)(i)&&!s?.atomic){const P=i.enforceAtomicDelete?.(t);P&&(s={...a,atomic:P})}const n=!!s?.useTrash,r=!!s?.recursive,l=s?.atomic??!1;await i.delete(t,{recursive:r,useTrash:n,atomic:l}),this.r.fire(new $.$kk(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.pb(await this.n(a),a);if(i===s&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,$.$0j)(i))return i.cloneFile(t,a);await this.U(s,this.R(s).providerExtUri.dirname(a));const n=this.ab.queueFor(t,this.R(i).providerExtUri);return i===s&&(0,$.$9j)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.O(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$jc;let s=!1,n=()=>{s=!0};return i.add((0,c.$ic)(()=>n())),(async()=>{try{const r=await this.$(t,a);s?(0,c.$fc)(r):n=()=>(0,c.$fc)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),s=(0,y.$pi)([this.R(i).providerExtUri.getComparisonKey(t),a]);let n=this.Z.get(s);return n||(n={count:0,disposable:i.watch(t,a)},this.Z.set(s,n)),n.count+=1,(0,c.$ic)(()=>{n&&(n.count--,n.count===0&&((0,c.$fc)(n.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$fc)(t.disposable);this.Z.clear()}async bb(t,a,i,s,n){await this.cb(t,i,s,n);try{await t.rename(i,a,{overwrite:!0})}catch(r){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,E.$rd)(s)||(0,E.$sd)(s)?await this.db(t,n,s):await this.eb(t,n,s)}catch(r){throw(0,$.$gk)(r)}finally{await t.close(n)}})}async db(t,a,i){let s=0,n;if((0,E.$sd)(i)){if(i.buffer.length>0){const r=R.$Fd.concat(i.buffer);await this.fb(t,a,r,r.byteLength,s,0),s+=r.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((r,l)=>{(0,E.$xd)(n,{onData:async P=>{n.pause();try{await this.fb(t,a,P,P.byteLength,s,0)}catch(b){return l(b)}s+=P.byteLength,setTimeout(()=>n.resume())},onError:P=>l(P),onEnd:()=>r()})})}async eb(t,a,i){let s=0,n;for(;(n=i.read())!==null;)await this.fb(t,a,n,n.byteLength,s,0),s+=n.byteLength}async fb(t,a,i,s,n,r){let l=0;for(;l<s;){const P=await t.write(a,n+l,i.buffer,r+l,s-l);l+=P}}async gb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){let n;s instanceof R.$Fd?n=s:(0,E.$rd)(s)?n=await(0,R.$Rd)(s):(0,E.$sd)(s)?n=await(0,R.$Sd)(s):n=(0,R.$Pd)(s),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async ib(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){let n,r;try{n=await t.open(a,{create:!1}),r=await i.open(s,{create:!0,unlock:!1});const l=R.$Fd.alloc(this.a);let P=0,b=0,S=0;do S=await t.read(n,P,l.buffer,b,l.byteLength-b),await this.fb(i,r,l,S,P,b),P+=S,b+=S,b===l.byteLength&&(b=0);while(S>0)}catch(l){throw(0,$.$gk)(l)}finally{await D.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async kb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.lb(t,a,i,s))}async lb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.nb(t,a,i,s))}async nb(t,a,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.fb(i,n,R.$Fd.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$gk)(r)}finally{await i.close(n)}}async ob(t,a,i,s){const n=await(0,R.$Rd)(this.H(t,a,A.CancellationToken.None));await this.gb(i,s,void 0,n)}pb(t,a){if(t.capabilities&2048)throw new $.$nk((0,w.localize)(24,null,this.rb(a)),6);return t}qb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$nk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===O.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=p,e.$Dp=p=$e([se(0,f.$5i)],p)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,I.$mi)(a)}`)}})();class t extends f.$Mp{static{this.I=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=y.Event.None,this.N=new A.$zi(n=>g.$_f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,O.$k&&(this.J|=1024)),this.J}async stat(i){try{const{stat:s,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(i));return{type:this.M(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await E.Promises.readdir(this.H(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$ig)(i,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(s){throw this.eb(s)}}M(i,s){let n;return s?.dangling?n=$.FileType.Unknown:i.isFile()?n=$.FileType.File:i.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,s&&(n|=$.FileType.SymbolicLink),n}async O(i){const s=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const r=new R.$Fg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,c.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),n=await this.O(i));const r=this.H(i);return await E.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{n?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,s,n){const r=(0,d.$td)(l=>N.$Fd.concat(l.map(P=>N.$Fd.wrap(P))).buffer);return(0,h.$Cp)(this,i,r,l=>l.buffer,{...s,bufferSize:256*1024},n),r}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(i,(0,g.$ig)((0,g.$hg)(i),`${(0,g.$fg)(i)}${n.atomic.postfix}`),s,n):this.R(i,s,n)}async Q(i,s,n,r){await this.R(s,n,r);try{await this.rename(s,i,{overwrite:!0})}catch(l){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async R(i,s,n){let r;try{const l=this.H(i);if(!n.create||!n.overwrite){if(await E.Promises.exists(l)){if(!n.overwrite)throw(0,$.$fk)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$fk)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(l){throw await this.fb(i,l)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(i){t.X=i}async open(i,s){const n=this.H(i);let r;(0,$.$7j)(s)&&(r=await this.O(i));let l;try{if((0,$.$7j)(s)&&s.unlock)try{const{stat:b}=await E.SymlinkSupport.stat(n);b.mode&128||await E.Promises.chmod(n,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let P;if((0,$.$7j)(s)){if(O.$i)try{await E.Promises.truncate(n,0),P="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}P||(P="w")}else P="r";l=await E.Promises.open(n,P)}catch(P){throw r?.dispose(),(0,$.$7j)(s)?await this.fb(i,P):this.eb(P)}if(this.S.set(l,0),(0,$.$7j)(s)&&this.W.set(l,i),r){const P=this.U.get(l);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${n})`),this.U.set(l,r),P&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${n})`),P.dispose())}return l}async close(i){const s=this.U.get(i);try{if(this.S.delete(i),this.W.delete(i)&&t.X)try{await E.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(i)}catch(n){throw this.eb(n)}finally{s&&(this.U.get(i)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.U.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,r,l){const P=this.Y(i,s);let b=null;try{b=(await E.Promises.read(i,n,r,l,P)).bytesRead}catch(S){throw this.eb(S)}finally{this.Z(i,P,b)}return b}Y(i,s){return s===this.S.get(i)?null:s}Z(i,s,n){const r=this.S.get(i);typeof r=="number"&&(typeof s=="number"||(typeof n=="number"?this.S.set(i,r+n):this.S.delete(i)))}async write(i,s,n,r,l){return(0,R.$Yg)(()=>this.$(i,s,n,r,l),100,3)}async $(i,s,n,r,l){const P=this.Y(i,s);let b=null;try{b=(await E.Promises.write(i,n,r,l,P)).bytesWritten}catch(S){throw await this.fb(this.W.get(i),S)}finally{this.Z(i,P,b)}return b}async mkdir(i){try{await E.Promises.mkdir(this.H(i))}catch(s){throw this.eb(s)}}async delete(i,s){try{const n=this.H(i);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,v.$9d)((0,v.$_d)(n),`${(0,v.$ae)(n)}${s.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:b}=await E.SymlinkSupport.stat(n);l=P.isDirectory()&&!b}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.eb(n)}}async rename(i,s,n){const r=this.H(i),l=this.H(s);if(r!==l)try{await this.ab(i,s,"move",n.overwrite),await E.Promises.rename(r,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(2,null,(0,v.$ae)(r),(0,v.$ae)((0,v.$_d)(l)),P.toString()))),this.eb(P)}}async copy(i,s,n){const r=this.H(i),l=this.H(s);if(r!==l)try{await this.ab(i,s,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(3,null,(0,v.$ae)(r),(0,v.$ae)((0,v.$_d)(l)),P.toString()))),this.eb(P)}}async ab(i,s,n,r){const l=this.H(i),P=this.H(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,u.$Hf)(l,P,!0)),b){if(n==="copy")throw(0,$.$fk)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.L(i);if(!j)throw(0,$.$fk)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(s);if(H){if(!r)throw(0,$.$fk)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);j.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.bb(i,s,!1)}async bb(i,s,n){const r=this.H(i),l=this.H(s),P=!!(this.capabilities&1024);if((0,u.$Hf)(r,l,!P))return;const b=new c.$jc;try{const[S,j]=await Promise.all([this.O(i),this.O(s)]);b.add(S),b.add(j),n&&await E.Promises.mkdir((0,v.$_d)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(S){if(S.code==="ENOENT"&&!n)return this.bb(i,s,!0);throw this.eb(S)}finally{b.dispose()}}t(i,s,n){return new p.$Tp(r=>i(r),r=>s(r),n)}F(i,s,n){return new k.$2p(r=>i(r),r=>s(r),n)}eb(i){if(i instanceof $.$ek)return i;let s=i,n;switch(i.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$fk)(s,n)}async fb(i,s){let n=this.eb(s);if(i&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(i));r.mode&128||(n=(0,$.$fk)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$3p=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class R extends L.$kc{constructor(N,y=[]){super(),this.a=new D.$cj([N,...y]),this.B(N.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...y){this.a.trace(N,...y)}debug(N,...y){this.a.debug(N,...y)}info(N,...y){this.a.info(N,...y)}warn(N,...y){this.a.warn(N,...y)}error(N,...y){this.a.error(N,...y)}flush(){this.a.flush()}}e.$rN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,v,O,g,d){try{const E=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});E.setFlushOn(R.Trace);const w=await E.createAsyncRotatingLogger(c,v,O,g);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(E){console.error(E)}return null}function N(c,v,O){switch(v){case D.LogLevel.Trace:c.trace(O);break;case D.LogLevel.Debug:c.debug(O);break;case D.LogLevel.Info:c.info(O);break;case D.LogLevel.Warning:c.warn(O);break;case D.LogLevel.Error:c.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function y(c,v){switch(v){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class u extends D.$$i{constructor(v,O,g,d,E){super(),this.m=[],this.setLevel(E),this.n=this.s(v,O,g,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&y(this.r,w)}))}async s(v,O,g,d){const E=g?6:1,w=30/E*L.$Ak.MB,$=await A(v,O,w,E,d);if($){this.r=$,y(this.r,this.getLevel());for(const{level:h,message:f}of this.m)N(this.r,h,f);this.m=[]}}g(v,O){this.r?N(this.r,v,O):this.getLevel()<=v&&this.m.push({level:v,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$gN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;class A extends D.$dj{s(y,u,c){return new R.$gN((0,L.$4f)(),y.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$hN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,A.$Bh)("policy");class N extends R.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const v=Object.keys(this.f).length;return this.f={...c,...this.f},v!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(O,[g,d])=>({...O,[g]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[v,O])=>({...c,[v]:{definition:O,value:this.g.get(v)}}),{})}}e.$$m=N;class y{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=y}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;function c(O,g){const d=[];for(const E of new Set(R.Iterable.concat(O.keys(),g.keys())))O.get(E)!==g.get(E)&&d.push(E);return d}let v=class extends u.$$m{constructor(g,d,E){super(),this.m=g,this.n=d,this.s=E,this.c=this.B(new L.$Eg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const d=await this.n.readFile(this.m),E=JSON.parse(d.value.toString());if(!(0,A.$lf)(E))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(E))this.f[w]&&g.set(w,E[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return g}async w(){const g=await this.u(),d=c(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$C7b=v,e.$C7b=v=$e([se(1,N.$6j),se(2,y.$5i)],v)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;let y=class extends L.$$m{constructor(c,v){super(),this.m=c,this.n=v,this.a=new D.$Ag,this.b=this.B(new A.$lc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((v,O)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,g=>{this.t(g),v()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),O(g)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const v in c){const O=c[v];O===void 0?this.g.delete(v):this.g.set(v,O)}this.h.fire(Object.keys(c))}};e.$B7b=y,e.$B7b=y=$e([se(0,N.$5i)],y)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,L.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class R{constructor(){this.a=new Map}add(N,y){L.ok(D.$jf(N)),L.ok(D.$lf(y)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,y)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$8m=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this.b=new L.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[R(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;D.$8m.add(e.$9m.JSONContribution,N)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var c;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$an={Configuration:"base.contributions.configuration"};var v;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const O=u.$8m.as(y.$9m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new D.$fd,this.onDidSchemaChange=this.i.event,this.j=new D.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),O.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:n}of t)for(const r in s)if(a.add(r),e.$kn.test(r)){const l=this.a.get(r),P=l?.valuesSources??new Map;if(n)for(const H of Object.keys(s[r]))P.set(H,n);const b={...l?.value||{},...s[r]};this.a.set(r,{source:n,value:b,valuesSources:P});const S=(0,N.$fi)(r),j={type:"object",default:b,description:A.localize(1,null,S),$ref:e.$hn,defaultDefaultValue:b,source:R.$jf(n)?void 0:n,defaultValueSource:n};i.push(...w(r)),this.d[r]=j,this.b.properties[r]=j}else{this.a.set(r,{value:s[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const n in i){const r=this.a.get(n),l=R.$jf(s)?s:s?.id,P=R.$jf(r?.source)?r?.source:r?.source?.id;if(l===P)if(a.add(n),this.a.delete(n),e.$kn.test(n))delete this.d[n],delete this.b.properties[n];else{const b=this.d[n];b&&(this.w(n,b),this.r(n,b))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const n in s.properties){a.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,i,s,n=3,r){n=R.$sf(t.scope)?n:t.scope;const l=t.properties;if(l)for(const b in l){const S=l[b];if(a&&I(b,S)){delete l[b];continue}if(S.source=i,S.defaultDefaultValue=l[b].default,this.w(b,S),e.$kn.test(b)?S.scope=void 0:(S.scope=R.$sf(S.scope)?n:S.scope,S.restricted=R.$sf(S.restricted)?!!s?.includes(b):S.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.f[b]=l[b],delete l[b];continue}else this.d[b]=l[b],l[b].policy?.name&&this.e.set(l[b].policy.name,b);!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),r.add(b)}const P=t.allOf;if(P)for(const b of P)this.p(b,a,i,s,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const r in s)this.r(r,s[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$bn.properties[t]=a,a.scope){case 1:e.$cn.properties[t]=a;break;case 2:e.$dn.properties[t]=a;break;case 6:e.$en.properties[t]=a;break;case 3:e.$fn.properties[t]=a;break;case 4:e.$gn.properties[t]=a;break;case 5:e.$gn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$bn.properties[t],a.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$hn};this.w(a,i),e.$bn.properties[a]=i,e.$cn.properties[a]=i,e.$dn.properties[a]=i,e.$en.properties[a]=i,e.$fn.properties[a]=i,e.$gn.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,n=i?.source;R.$qf(s)&&(s=a.defaultDefaultValue,n=void 0),R.$qf(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",E=new RegExp(d,"g");e.$jn=`^(${d})+$`,e.$kn=new RegExp(e.$jn);function w(k){const t=[];if(e.$kn.test(k)){let a=E.exec(k);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=E.exec(k)}}return(0,L.$Kb)(t)}e.$ln=w;function $(k){return k.reduce((t,a)=>`${t}[${a}]`,"")}e.$mn=$;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=h;const f=new g;u.$8m.add(e.$an.Configuration,f);function I(k,t){return k.trim()?e.$kn.test(k)?A.localize(7,null,k):f.getConfigurationProperties()[k]!==void 0?A.localize(8,null,k):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,k,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$on=I;function p(){const k=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))k.push([a,t[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$pn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,R,A,N,y,u,c,v,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function d(a){return Object.isFrozen(a)?a:y.$Wm(a)}class E{constructor(i={},s=[],n=[],r){this.b=i,this.c=s,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof E)return s;const n=new w("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,v.$di)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),r=s?this.rawConfiguration.getOverrideValue(i,s):void 0,l=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:r,merged:l}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,v.$di)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return L.$Kb(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return L.$Kb(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=y.$Vm(this.contents),n=y.$Vm(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of i)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(s,P.contents);for(const b of P.overrides){const[S]=n.filter(j=>L.$sb(j.identifiers,b.identifiers));S?(this.h(S.contents,b.contents),S.keys.push(...b.keys),S.keys=L.$Kb(S.keys)):n.push(y.$Vm(b))}for(const b of P.keys)r.indexOf(b)===-1&&r.push(b)}return new E(s,r,n,l.every(P=>P instanceof E)?void 0:l)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const r of L.$Kb([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[r];const P=s[r];P&&(typeof l=="object"&&typeof P=="object"?(l=y.$Vm(l),this.h(l,P)):l=P),n[r]=l}return new E(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$lf(i[n])&&u.$lf(s[n])){this.h(i[n],s[n]);continue}i[n]=y.$Vm(s[n])}}i(i){let s=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=y.$Vm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?s=l.contents:l.identifiers.includes(i)&&r(l.contents);return r(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,v.$ci)(this.contents,i),O.$kn.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>L.$sb(n.identifiers,(0,O.$ln)(i))),1))}j(i,s,n){(0,v.$bi)(this.contents,i,s,r=>console.error(r)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),O.$kn.test(i)&&this.overrides.push({identifiers:(0,O.$ln)(i),keys:Object.keys(this.contents[i]),contents:(0,v.$ai)(this.contents[i],r=>console.error(r))})}}e.$qn=E;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$sf(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:r,overrides:l,restricted:P,hasExcludedProperties:b}=this.h(i,s);this.b=new E(n,r,l,b?[i]:void 0),this.c=P||[]}g(i){let s={},n=null,r=[];const l=[],P=[];function b(j){Array.isArray(r)?r.push(j):n!==null&&(r[n]=j)}const S={onObjectBegin:()=>{const j={};b(j),l.push(r),r=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const j=[];b(j),l.push(r),r=j,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:b,onError:(j,H,x)=>{P.push({error:j,offset:H,length:x})}};if(i)try{R.$Sm(i,S),s=r[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return s}h(i,s){const n=g.$8m.as(O.$an.Configuration).getConfigurationProperties(),r=this.i(i,n,!0,s);i=r.raw;const l=(0,v.$ai)(i,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),P=Object.keys(i),b=this.j(i,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:P,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,s,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const P={},b=[];for(const S in i)if(O.$kn.test(S)&&n){const j=this.i(i[S],s,!1,r);P[S]=j.raw,l=l||j.hasExcludedProperties,b.push(...j.restricted)}else{const j=s[S],H=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&b.push(S),!r.exclude?.includes(S)&&(r.include?.includes(S)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&j?.restricted))?P[S]=i[S]:l=!0}return{raw:P,restricted:b,hasExcludedProperties:l}}j(i,s){const n=[];for(const r of Object.keys(i))if(O.$kn.test(r)){const l={};for(const P in i[r])l[P]=i[r][P];n.push({identifiers:(0,O.$ln)(r),keys:Object.keys(l),contents:(0,v.$ai)(l,s)})}return n}}e.$rn=w;class $ extends A.$kc{constructor(i,s,n,r){super(),this.c=i,this.f=s,this.g=r,this.b=this.B(new D.$fd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=$;class h{constructor(i,s,n,r,l,P,b,S,j,H,x,_,ue){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=P,this.g=b,this.h=S,this.i=j,this.j=H,this.k=x,this.l=_,this.m=ue}get value(){return d(this.c)}n(i,s,n){const r=i.inspect(s,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,n,r,l=new E,P=new E,b=new N.$zi,S=new E,j=new N.$zi){this.c=i,this.d=s,this.f=n,this.g=r,this.h=l,this.i=P,this.j=b,this.l=S,this.m=j,this.a=null,this.b=new N.$zi,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,s===void 0?r.removeValue(i):r.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const r=this.q(i,s,n),l=this.u(s.resource,n),P=s.resource?this.m.get(s.resource)||this.l:this.l,b=new Set;for(const S of r.overrides)for(const j of S.identifiers)r.getOverrideValue(i,j)!==void 0&&b.add(j);return new h(i,s,r.getValue(i),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,P)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:r,updated:l,removed:P}=k(this.c,i);s=[...r,...l,...P]}for(const r of s)for(const l of(0,O.$ln)(r)){const P=this.c.getKeysForOverrideIdentifier(l),b=i.getKeysForOverrideIdentifier(l),S=[...b.filter(j=>P.indexOf(j)===-1),...P.filter(j=>b.indexOf(j)===-1),...P.filter(j=>!y.$Zm(this.c.override(l).getValue(j),i.override(l).getValue(j)))];n.push([l,S])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:r}=k(this.d,i),l=[...s,...n,...r];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:r,overrides:l}=k(this.applicationConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:l}=k(this.localUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:l}=k(this.remoteUserConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:r,overrides:l}=k(this.workspaceConfiguration,i),P=[...s,...n,...r];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:r,updated:l,removed:P,overrides:b}=k(n,s),S=[...r,...l,...P];return(S.length||!n)&&this.updateFolderConfiguration(i,s),{keys:S,overrides:b}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:l,overrides:P}=k(s,void 0);return{keys:[...n,...r,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let r=this.r(s,n);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},s){let n=this.s();if(s&&i){const r=s.getFolder(i);r&&(n=this.t(r.uri)||n);const l=this.m.get(i);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),r=this.j.get(i);r?(s=n.merge(r),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:r,keys:l}=this.j.get(s);return i.push([s,{contents:n,overrides:r,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),r=this.x(i.application),l=this.x(i.user),P=this.x(i.workspace),b=i.folders.reduce((S,j)=>(S.set(c.URI.revive(j[0]),this.x(j[1])),S),new N.$zi);return new f(s,n,r,l,new E,P,b,new E,new N.$zi)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.$tn=f;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const r of a)r.keys.forEach(l=>i.add(l)),r.overrides.forEach(([l,P])=>{const b=(0,N.$wi)(s,l,new Set);P.forEach(S=>b.add(S))});const n=[];return s.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.$un=I;class p{constructor(i,s,n,r){this.change=i,this.f=s,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,S=this.g.getValue(i,s,this.h);return!y.$Zm(b,S)}return!0}}e.$vn=p;function k(a,i){const{added:s,removed:n,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],P=a?.getAllOverrideIdentifiers()||[],b=i?.getAllOverrideIdentifiers()||[];if(i){const S=b.filter(j=>!P.includes(j));for(const j of S)l.push([j,i.getKeysForOverrideIdentifier(j)])}if(a){const S=P.filter(j=>!b.includes(j));for(const j of S)l.push([j,a.getKeysForOverrideIdentifier(j)])}if(i&&a){for(const S of P)if(b.includes(S)){const j=t({contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)},{contents:i.getOverrideValue(void 0,S)||{},keys:i.getKeysForOverrideIdentifier(S)});l.push([S,[...j.added,...j.removed,...j.updated]])}}return{added:s,removed:n,updated:r,overrides:l}}function t(a,i){const s=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],n=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],r=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const P=(0,v.$di)(i.contents,l),b=(0,v.$di)(a.contents,l);y.$Zm(P,b)||r.push(l)}}return{added:s,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,R,A,N,y,u,c,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class g extends R.$kc{constructor(){super(...arguments),this.a=this.B(new D.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new y.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$8m.as(u.$an.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$8m.as(u.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new y.$qn;const $=O.$8m.as(u.$an.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],k=h[I];p!==void 0?this.b.addValue(I,p):k?this.b.addValue(I,k.default):this.b.removeValue(I)}}}e.$wn=g;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new y.$qn}async initialize(){return this.configurationModel}}e.$xn=d;let E=class extends R.$kc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new y.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=O.$8m.as(u.$an.Configuration).getConfigurationProperties();for(const p of $){const k=I[p];if(!k){f.push(p);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}f.push(p),h[k.policy.name]={type:k.type}}}return(0,N.$wf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$8m.as(u.$an.Configuration).getPolicyConfigurations(),f=(0,L.$Fb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$8m.as(u.$an.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const k of $){const t=f[k]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.$Zm)(this.b.getValue(k),a))&&I.push([k,a])}else this.b.getValue(k)!==void 0&&I.push([k,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const k=this.b;this.b=new y.$qn;for(const t of k.keys)this.b.setValue(t,k.getValue(t));for(const[t,a]of I)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$yn=E,e.$yn=E=$e([se(1,v.$0m),se(2,c.$5i)],E)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class v extends R.$kc{constructor(g,d,E,w){super(),this.j=g,this.h=this.B(new D.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$wn),this.c=E instanceof c.$_m?new u.$xn:this.B(new u.$yn(this.b,E,w)),this.f=this.B(new y.$sn(this.j,{},A.$_f,d)),this.a=new y.$tn(this.b.configurationModel,this.c.configurationModel,new y.$qn,new y.$qn),this.g=this.B(new L.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$tn(g,d,new y.$qn,E)}getConfigurationData(){return this.a.toData()}getValue(g,d){const E=typeof g=="string"?g:void 0,w=(0,N.$9h)(g)?g:(0,N.$9h)(d)?d:{};return this.a.getValue(E,w,void 0)}updateValue(g,d,E,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const d=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(E,d,2)}n(g,d){const E=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,d);this.s(w,E,7)}r(g){const d=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(g);this.s(E,d,7)}s(g,d,E){const w=new y.$vn(g,{data:d},this.a);w.source=E,w.sourceConfig=this.t(E),this.h.fire(w)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=v}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Ok=D;function R(c){if(!c)return;const v=c.indexOf("+");return v<0?c:c.substr(0,v)}e.$Pk=R;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Qk=A;function N(c){const{host:v,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:O}}e.$Rk=N;function y(c,v){let{host:O,port:g}=u(c);return typeof g>"u"&&(g=v),{host:O,port:g}}e.$Sk=y;function u(c){const v=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Tl=A,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(N||(e.ExtensionType=N={}));var y;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(y||(e.TargetPlatform=y={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$Me(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Vl=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Wl=c;class v{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=v;function O(w){return g(w)}e.$Yl=O;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Zl=g;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$1l=d;function E(w,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Pk)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$2l=E,e.$3l=(0,D.$Bh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;class A extends L.$kc{constructor(y,u,c,v,O){super(),this.a=y,this.b=u,this.c=c,this.f=O,this.B(v.onDidInstallExtensions(g=>this.g(g))),this.B(v.onDidUninstallExtension(g=>this.h(g)))}g(y){for(const u of y)u.local&&this.invalidate(u.profileLocation)}h(y){y.error||this.invalidate(y.profileLocation)}async invalidate(y){if(y)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,y)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(y){try{await this.b.del(this.c.extUri.joinPath(y.cacheHome,D.$Pl))}catch(u){(0,R.$jk)(u)!==1&&this.f.error(u)}}}e.$wp=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,y.$Bh)("requestService");class v{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?k[t]="*****":k[t]=this.b[t];this.a=k}return this.a}}class O extends R.$kc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,A.localize)(0,null),when:u.$jj.isEqualTo((0,u.$hj)(u.LogLevel.Trace)).serialize()})}async c(k,t,a){const i=`${k} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new v(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,D.$8)(s)),s}}}e.$Jo=O;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Ko=g;function d(p){return p.res.statusCode===204}e.$Lo=d;async function E(p){return d(p)?null:(await(0,L.$Rd)(p.stream)).toString()}e.$Mo=E;async function w(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.$No=w;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$Rd)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Oo=$;function h(p){I(p)}e.$Po=h;let f;function I(p){const k=c.$8m.as(N.$an.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},k.updateConfigurations({add:[f],remove:t?[t]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0;let N=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,v=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},g=await this.a.request(O,v);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const d=await(0,A.$No)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$GN=N,e.$GN=N=$e([se(0,A.$Io),se(1,R.$6j)],N)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;function R(N,y){return N.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:N.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function A(N,y,u={}){const c=(0,L.parse)(N),v=u.proxyUrl||R(c,y);if(!v)return null;const O=(0,L.parse)(v);if(!/^https?:$/.test(O.protocol||""))return null;const g={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.$pf)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,E)=>{J(["http-proxy-agent"],d,E)}))(g):new(await new Promise((d,E)=>{J(["https-proxy-agent"],d,E)}))(g)}e.$Nq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=void 0;let E;async function w(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Gl)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Gl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=g.Promises.withAsyncBody(async(k,t)=>{const a=new A.$pd;let i=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,d.$Hl)(s,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{k(await $(f,a.token))}catch(r){!(0,y.$2)(r)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.$mi)(r)))):k({})}finally{clearTimeout(n),a.dispose()}})),E)}e.$Ml=w;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const k=(0,c.$4f)().replace(/-/g,"").substr(0,12),t=new RegExp(k+"({.*})"+k),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,v.$wl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(f.isCancellationRequested)return n(new y.$3);const r=(0,D.$ae)(i);let l,P;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${b} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,P=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${b} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${b} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const S=(0,L.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(S.kill(),n(new y.$3))),S.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,N.$mi)(x)),n(x)});const j=[];S.stdout.on("data",x=>j.push(x));const H=[];S.stderr.on("data",x=>H.push(x)),S.on("close",(x,_)=>{const ue=Buffer.concat(j).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),x||_)return n(new Error((0,R.localize)(2,null,x,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),s(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,N.$mi)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.$iN=void 0,e.$iN=(0,L.$Bh)("stateReadService"),e.$jN=(0,L.$Bh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=e.$kN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class v extends R.$kc{constructor(E,w,$,h){super(),this.h=E,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new L.$Eg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.j.error(E)}}getItem(E,w){const $=this.a[E];return(0,A.$sf)($)?w:$}setItem(E,w){this.setItems([{key:E,data:w}])}setItems(E){let w=!1;for(const{key:$,data:h}of E)this.a[$]!==h&&((0,A.$sf)(h)?(0,A.$qf)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(E){(0,A.$qf)(this.a[E])||(this.a[E]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.m.writeFile(this.h,D.$Fd.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$kN=v;let O=class extends R.$kc{constructor(E,w,$,h){super(),this.a=this.B(new v(w.stateResource,E,$,h))}async init(){await this.a.init()}getItem(E,w){return this.a.getItem(E,w)}};e.$lN=O,e.$lN=O=$e([se(1,N.$Ih),se(2,u.$5i),se(3,y.$6j)],O);class g extends O{setItem(E,w){this.a.setItem(E,w)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$mN=g}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function A(u){if(L.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function N(u,c,v,O,g,d,E,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$4f)()+Date.now(),$.commitHash=O,$.version=g,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$h)(L.$t),$["common.nodePlatform"]=D.$3d,$["common.nodeArch"]=v,$["common.product"]=w||"desktop",E&&($["common.msftInternal"]=E);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$l&&($["common.snap"]="true");const I=A(c);return I&&($["common.platformDetail"]=I),$}e.$0n=N;function y(u){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const v=c.toLowerCase();return u.some(O=>v===O)}e.$$n=y}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,L.$Bh)("telemetryService"),e.$0k=(0,L.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$_n=c;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=v,e.$bo=new v;class O{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$co=O,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,P)=>{const b=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:b}},1e3,!0)(l=>{l.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.$$h)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$go=g;function d(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$ho=d;function E(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$io=E;function w(s){const n=s.getValue(u.$dl),r=s.getValue(u.$el);if(s.getValue(u.$fl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=w;function $(s){const n={},r={},l={};I(s,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const b=l[P];typeof b=="number"?r[P]=b:typeof b=="boolean"?r[P]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${b.length}`),n[P]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(n[P]=b)}return{properties:n,measurements:r}}e.$ko=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(s){if(!s)return"none";const n=(0,N.$Pk)(s);return h.has(n)?n:"other"}e.$lo=f;function I(s,n,r=0,l){if(s)for(const P of Object.getOwnPropertyNames(s)){const b=s[P],S=l?l+P:P;Array.isArray(b)?n[S]=(0,L.$1m)(b):b instanceof Date?n[S]=b.toISOString():(0,D.$lf)(b)?r<2?I(b,n,r+1,S+"."):n[S]=(0,L.$1m)(b):n[S]=b}}function p(s,n){const r=s.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,y.$$n)(r)||l}e.$mo=p;function k(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$no=k;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const l=[];for(const j of n)for(;;){const H=j.exec(s);if(!H)break;l.push([H.index,j.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(r="";;){const j=b.exec(s);if(!j)break;const H=l.some(([x,_])=>j.index<_&&x<b.lastIndex);!P.test(j[0])&&!H&&(r+=s.substring(S,j.index)+"<REDACTED: user-file-path>",S=b.lastIndex)}return S<s.length&&(r+=s.substr(S)),r}function a(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function i(s,n){return(0,L.$Xm)(s,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=t(l,n);for(const P of n)l=l.replace(P,"");return l=a(l),l}})}e.$oo=i}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function v(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,L.$He)(i.id,s.id)===0}e.$po=v;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const n=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,n,r)}static parse(s){const n=O.exec(s);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?v(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$qo=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const s=d.exec(i);return s&&s[1]?[$(s[1]),s[2]]:[$(i),void 0]}e.$ro=E;function w(i,s){return`${i}.${s}`}e.$so=w;function $(i){return i.toLowerCase()}e.$to=$;function h(i,s){return $(w(i??R.$Rl,s))}e.$uo=h;function f(i,s){const n=[],r=l=>{for(const P of n)if(P.some(b=>v(s(b),s(l))))return P;return null};for(const l of i){const P=r(l);P?P.push(l):n.push([l])}return n}e.$vo=f;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$wo=I;function p(i){return{id:new c.$_n(i.identifier.id),name:new c.$_n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$xo=p,e.$yo=new R.$Vl("pprice.better-merge");function k(i,s){const n=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(P=>!v(P.identifier,{id:l}))){const P=i.filter(b=>v(b.identifier,{id:l}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$zo=k;async function t(i,s){if(!A.$k)return!1;let n;try{n=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){s.debug("Error while getting the os-release file.",(0,y.$8)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const n=await t(i,s),r=(0,D.$Un)(n?"alpine":A.$t,u.$4d);return s.debug("ComputeTargetPlatform:",r),r}e.$Ao=a}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,R,A,N,y,u,c,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function E($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const k=O.$Ul.map(a=>a.toLowerCase());if(f&&f!==""){if(k.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),k.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(E(a.manifest,h)))}async installExtensions(h,f,I,p){const k=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const s=(r,l,P)=>{i.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof y.URI)a.push({vsix:r,installOptions:I});else{const[l,P]=(0,v.$ro)(r);s(l,P,!1)}for(const r of f)if(r instanceof y.URI)a.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,v.$ro)(r);s(l,P,!0)}const n=await this.b.getInstalled(1,I.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:l})=>{try{const P=await this.g(r,l,p,n);P&&t.push(P)}catch(P){this.a.error(P),k.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:l})=>{const P=n.find(b=>(0,v.$po)(b.identifier,{id:r}));if(P){if(!p&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(l&&P.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async l=>{const P=r.get(l.id.toLowerCase());if(P)try{const b=await this.j(l,P,n);b&&t.push(b)}catch(b){this.a.error(b.message||b.stack||b),k.push(l.id)}else this.a.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),k.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$8)(t))),t}if(k.length)throw new Error((0,u.localize)(8,null,k.join(", ")))}async g(h,f,I,p){const k=await this.b.getManifest(h);if(!k)throw new Error("Invalid vsix");if(await this.l(k,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$fg)(h))),k}catch(a){if((0,D.$2)(a))return this.a.info((0,u.localize)(10,null,(0,A.$fg)(h))),null;throw a}return null}async h(h){const f=new Map,I=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),k=[];for(const t of h)c.$Nn.test(t.id)&&k.push({...t,preRelease:I});if(k.length){const t=await this.d.getExtensions(k,{targetPlatform:p},L.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:I},p,k){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const a=k.find(i=>(0,v.$po)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,D.$2)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,I,p){if(!f){const k={id:(0,v.$uo)(h.publisher,h.name)},t=p.find(a=>(0,v.$po)(k,a.identifier)&&(0,N.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async t=>{if(t instanceof y.URI){const a=await this.b.getManifest(t);return E(a)}return t},k=[];for(const t of h){const a=await p(t),s=(await this.b.getInstalled(void 0,I)).filter(n=>(0,v.$po)(n.identifier,{id:a}));if(!s.length)throw new Error(`${this.m(a)}
${d}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const n of s)await this.b.uninstall(n,{profileLocation:I}),k.push(n);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$9o=w,e.$9o=w=$e([se(1,c.$2n),se(2,c.$Zn)],w)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class y extends D.$kc{constructor(c,v,O,g,d,E,w){super(),this.f=c,this.g=v,this.h=O,this.j=g,this.m=d,this.n=E,this.r=w,this.a=this.B(new L.$fd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$sc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(v=>(this.c.set(v.id,(0,D.$hc)(this.n.watch(this.m.extUri.dirname(v.extensionsResource)),this.n.watch(v.extensionsResource))),this.G(v.extensionsResource))))}catch(v){throw this.r.error(v),v}}async w(c){for(const v of c.extensions)this.I(this.L(v.identifier,v.version),c.profileLocation)}async y(c){for(const v of c.extensions){const O=this.L(v.identifier,v.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const v of c.extensions)this.J(this.L(v.identifier,v.version),c.profileLocation)}async C(c){const v=[],O=[];for(const g of c.extensions){const d=this.L(g.identifier,g.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),O.push(this.f.scanInstalledExtensionAtLocation(g.location).then(E=>{E?v.push(E):this.r.info("Extension not found at the location",g.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(O),v.length&&await this.H(v)}catch(g){this.r.error(g)}}D(c){for(const v of this.h.profiles)c.contains(v.extensionsResource,0,1)&&this.F(v.extensionsResource)}async F(c){const v=[],O=[],g=await this.j.scanProfileExtensions(c),d=new Set,E=new Set;for(const[w,$]of this.b)$.has(c)&&E.add(w);for(const w of g){const $=this.L(w.identifier,w.version);d.add($),E.has($)||(v.push(w.identifier),this.I($,c))}for(const w of E)if(!d.has(w)){const $=this.M(w);$&&(O.push($.identifier),this.J(w,c))}(v.length||O.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const v=await this.j.scanProfileExtensions(c);for(const O of v)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,v){let O=this.b.get(c);O||this.b.set(c,O=new R.$Ai(g=>this.m.extUri.getComparisonKey(g))),O.add(v)}J(c,v){const O=this.b.get(c);O&&O.delete(v),O?.size||this.b.delete(c)}L(c,v){return`${N.$Vl.toKey(c.id)}@${v}`}M(c){const[v,O]=(0,A.$ro)(c);return O?{identifier:{id:v},version:O}:void 0}}e.$xp=y}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function R(A,N,y,u,c,v,O){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,D.$ho)(N,y)&&(0,D.$jo)(u)===3){const d=await(0,L.$2o)(y,c,v);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=O.machineId||d}return g}e.$3o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;let w=class extends d.$Jq{constructor(I,p,k,t){super(k),this.h=I,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(I,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[I];return a?E.URI.file(a):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(k=>{const t=I[k];return{...this.f(k,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((k,t)=>k.label.localeCompare(t.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(k=>p[k]&&p[k].extensions.some(t=>(0,O.$po)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(p);return!(0,D.$sb)(Object.keys(I),Object.keys(k))}};e.$Kq=w,e.$Kq=w=$e([se(0,v.$2n),se(1,c.$Jh),se(2,v.$Zn),se(3,g.$5i)],w);let $=class extends A.$kc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,y.$9d)(I.userDataPath,"languagepacks.json"),this.g=new R.$Ng}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(k=>delete p[k]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const k of p)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(I,k);Object.keys(I).forEach(k=>this.r(I[k]))}n(I,p){const k=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===N.Schemas.file&&h(a)){let i=I[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},I[a.languageId]=i);const s=i.extensions.filter(n=>(0,O.$po)(n.extensionIdentifier,k))[0];s?s.version=p.manifest.version:i.extensions.push({extensionIdentifier:k,version:p.manifest.version});for(const n of a.translations)i.translations[n.id]=(0,y.$9d)(p.location.fsPath,n.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const k of I.extensions)p.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(p=I(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,k=>this.j.error(k))})}};$=$e([se(0,c.$Jh),se(1,g.$5i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",y="https://mobile.events.data.microsoft.com/ping";async function u(v,O,g){const d=await(0,L.$cC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$cC)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,$=new E.PostChannel,h={instrumentationKey:v,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class c{constructor(O,g,d,E,w){this.e=O,this.f=g,this.g=d,this.h=w,this.c=N,this.d=y,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{O(g)},g=>{(0,D.$Y)(g),console.error(g)})}}log(O,g){if(!this.a)return;g=(0,R.$Ym)(g,this.g),g=(0,A.$ko)(g);const d=this.f+"/"+O;try{this.i(E=>{E.pluginVersionString=g?.properties.version??"Unknown",E.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$eN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$jc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$qe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$qe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$dl)||p.affectsConfiguration(g.$fl)||p.affectsConfiguration(g.$el))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$jo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,D.$Ym)(I,this.d),I=(0,d.$oo)(I,this.j),I=(0,D.$Ym)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Qq=E,e.$Qq=E=$e([se(1,y.$8h),se(2,v.$kj)],E);function w(){const $=(0,N.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$o?"":(0,N.localize)(3,null),I=(0,N.localize)(4,null),p=(0,N.localize)(5,null),k=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${I} | ${p} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}O.$8m.as(u.$an.Configuration).registerConfiguration({id:g.$cl,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[g.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$8m.as(u.$an.Configuration).registerConfiguration({id:g.$cl,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[g.$fl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${g.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;async function N(v,O){const g=await O.request(v,D.CancellationToken.None),d=(await(0,L.$Rd)(g.stream)).toString(),E=g.res.statusCode??200;return{headers:g.res.headers,statusCode:E,responseData:d}}async function y(v){const O={method:v.type,headers:v.headers};return new Promise((d,E)=>{const w=R.request(v.url??"",O,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){E(h)})});w.write(v.data,$=>{$&&E($)}),w.end()})}async function u(v,O,g){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),E={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const w=v?await N(E,v):await y(E);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class c extends A.$eN{constructor(O,g,d,E,w){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(g,d,E,w,$)}}e.$fN=c}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;async function R(A,N){const y=Object.create(null),u=(v,O)=>{const g=JSON.parse(v);y[O]=g};if(N){const v=[],O=await D.Promises.readdir(N);for(const d of O)try{(await D.Promises.stat((0,L.$9d)(N,d))).isDirectory()&&v.push(d)}catch{}const g=[];for(const d of v)(await D.Promises.readdir((0,L.$9d)(N,d))).filter(w=>w==="telemetry.json").length===1&&g.push(d);for(const d of g){const E=(await D.Promises.readFile((0,L.$9d)(N,d,"telemetry.json"))).toString();u(E,d)}}let c=(await D.Promises.readFile((0,L.$9d)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$9d)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(y,null,4)}e.$Z7b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;async function A(N,y){let u=N.getItem(R.$bl);return(typeof u!="string"||L.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Im)(y.error.bind(y))),u}e.$i7b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,L.$Bh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let v=class{constructor(g){this.g=g,this.c=new u.$jc,this.f=2**16;const d=new Map,E=w=>{let $=d.get(w.scheme);return $===void 0&&($=g.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(y.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new A.$0f(E),this.d=new N.$or((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$jg)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((E,w)=>E[1].time<w[1].time?1:E[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let E=0;E<d;E++)this.d.set(g[E][0],g[E][1].touch())}};e.$pr=v,e.$pr=v=$e([se(0,R.$6j)],v),(0,D.$mr)(L.$Ck,v,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;class y extends D.$kc{constructor(c,v,O,g,d,E){super(),this.f=c,this.g=v,this.h=O,this.j=g,this.m=d,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$fd),this.onDidChangeFile=this.a.event,this.b=A.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new N.$Ai(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,v){return this.g.open(this.t(c),v)}close(c){return this.g.close(c)}read(c,v,O,g,d){return this.g.read(c,v,O,g,d)}write(c,v,O,g,d){return this.g.write(c,v,O,g,d)}watch(c,v){this.b.set(c,c);const O=this.g.watch(this.t(c),v);return(0,D.$ic)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,v,O){return this.g.rename(this.t(c),this.t(v),O)}readFile(c,v){return this.g.readFile(this.t(c),v)}readFileStream(c,v,O){return this.g.readFileStream(this.t(c),v,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,v,O){return this.g.writeFile(this.t(c),v,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,v){return this.g.delete(this.t(c),v)}copy(c,v,O){if((0,R.$9j)(this.g))return this.g.copy(this.t(c),this.t(v),O);throw new Error("copy not supported")}cloneFile(c,v){if((0,R.$0j)(this.g))return this.g.cloneFile(this.t(c),this.t(v));throw new Error("clone not supported")}s(c){const v=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const g=this.u(O.resource);this.b.findSubstr(g)&&v.push({resource:g,type:O.type})}v.length&&(this.n.debug("User data changed"),this.a.fire(v))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$D7b=y}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,y.$Bh)("contextService");function c(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$Lh=c;function v(s){return typeof s?.id=="string"&&!c(s)&&!g(s)}e.$Mh=v,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function O(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,D.$ae)(s)}:n?e.$Nh:e.$Oh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Ph=O;function g(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$Qh=g;function d(s){const n=s;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Rh=d;var E;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function w(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Sh=w;function $(s){const n=s;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Th=$;class h{constructor(n,r,l,P,b){this.h=n,this.j=l,this.k=P,this.l=b,this.c=R.$Hh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Hh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=f;function I(s){return new f({uri:s,index:0,name:(0,A.$eg)(s)},{uri:s.toString()})}e.$Wh=I,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,L.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function p(s,n){return A.$_f.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$2h=p;function k(s){let n;return N.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$3h=k,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$4h}e.$5h=t;function a(s,n){return!p(s,n)&&!k(s)}e.$6h=a;function i(s){return(typeof s=="string"?(0,D.$be)(s):(0,A.$gg)(s))===e.$Yh}e.$7h=i}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var I;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Dk=p,e.$Ek=(0,v.$Bh)("IUserDataProfilesService");function k(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:N.URI.revive(s.location).with({scheme:n}),globalStorageHome:N.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Fk=k;function t(s,n,r,l,P,b){return{id:s,name:n,location:r,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:b&&P?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$ig)(r,"globalStorage"),settingsResource:b&&P?.useDefaultFlags?.settings?b.settingsResource:(0,A.$ig)(r,"settings.json"),keybindingsResource:b&&P?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$ig)(r,"keybindings.json"),tasksResource:b&&P?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$ig)(r,"tasks.json"),snippetsHome:b&&P?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$ig)(r,"snippets"),extensionsResource:b&&P?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$ig)(r,"extensions.json"),cacheHome:(0,A.$ig)(l,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Gk=t;let a=class extends R.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,P){super(),this.t=n,this.u=r,this.w=l,this.y=P,this.f=!0,this.h=this.B(new D.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zi,emptyWindows:new Map},this.profilesHome=(0,A.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,f.$jf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(t((0,A.$fg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},n))}}catch(b){this.y.error(b)}const l=new d.$zi,P=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[S,j]of Object.entries(b.workspaces)){const H=N.URI.parse(S),x=r.find(_=>_.id===j);x&&l.set(H,x)}if(b.emptyWindows)for(const[S,j]of Object.entries(b.emptyWindows)){const H=r.find(x=>x.id===j);H&&P.set(S,H)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:l,emptyWindows:P}}return this.z}D(){const n=t("__default__profile__",(0,y.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,h.$qe)(r)}\\s(\\d+)`);let P=0;for(const S of this.profiles){const j=l.exec(S.name),H=j?parseInt(j[1]):0;P=H>P?H:P}const b=`${r} ${P+1}`;return this.createProfile((0,L.$pi)((0,$.$4f)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$pi)((0,$.$4f)()).toString(16),n,r,l)}async createProfile(n,r,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(n,r,l);return P&&await this.setProfileForWorkspace(P,b),b}async F(n,r,l){if(!(0,f.$jf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const b=this.profiles.find(H=>H.name===r||H.id===n);if(b)return b;const S=t(n,r,(0,A.$ig)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(S.location);const j=[];return this.j.fire({profile:S,join(H){j.push(H)}}),await w.Promises.settled(j),this.I([S],[],[]),S}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,c.$jk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return N.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,g.$Lh)(n)?n.uri:(0,g.$Qh)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const P=[...this.profiles,...n],b=[];this.s.profiles=[];for(let S of P)S.isDefault||r.some(j=>S.id===j.id)||(S=l.find(j=>S.id===j.id)??S,S.isTransient?this.s.profiles.push(S):b.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.P(b),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const P=this.G(n),b=l?this.s:this.C;N.URI.isUri(P)?(b.workspaces.delete(P),r&&b.workspaces.set(P,r)):(b.emptyWindows.delete(P),r&&b.emptyWindows.set(P,r)),l||this.M()}M(){const n={};for(const[l,P]of this.C.workspaces.entries())n[l.toString()]=P.id;const r={};for(const[l,P]of this.C.emptyWindows.entries())r[l.toString()]=P.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[b,S]of Object.entries(n.workspaces)){const j=N.URI.parse(S);r[b]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const P={};if(n.emptyWindows)for(const[b,S]of Object.entries(n.emptyWindows)){const j=N.URI.parse(S);P[b]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Hk=a,e.$Hk=a=$e([se(0,u.$Ih),se(1,c.$6j),se(2,E.$Ck),se(3,O.$5i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ik=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=void 0;let p=class extends y.$kc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,P,b,S){super(),this.z=n,this.C=r,this.D=l,this.F=P,this.G=b,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$fd),this.s=this.B(new N.$fd),this.t=this.B(new N.$fd),this.u=this.B(new N.$fd),this.w=this.B(new N.$fd),this.y=[],this.B((0,y.$ic)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,g.$Wn)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:b})=>(0,d.$po)(b,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new g.$1n(O.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:P,options:b})=>{try{const S=await this.O(P,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);l.push({...S,options:b})}catch(S){r.push({identifier:P.identifier,operation:2,source:P,error:S})}})),l.length&&r.push(...await this.I(l));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!v.URI.isUri(P.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,d.$xo)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$Yl)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const b=(await this.getInstalled(1,P.extensionsResource)).find(S=>(0,d.$po)(S.identifier,n.identifier));b?this.w.fire(b):this.u.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const P=await this.J(l);r.push(...P)}catch(P){r.push({identifier:{id:(0,d.$uo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l}){const P=l.isApplicationScoped||l.isBuiltin||(0,E.$Yl)(n),b={...l,installOnlyNewlyAddedFromExtensionPack:v.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},S=te=>`${d.$qo.create(te).toString()}${b.profileLocation?`-${b.profileLocation.toString()}`:""}`;if(!v.URI.isUri(r)){const te=this.j.get(S(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const j=[],H=[],x=[],_=this.Z(n,r,b);v.URI.isUri(r)||this.j.set(S(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:b.profileLocation}),this.F.info("Installing extension:",_.identifier.id),j.push({task:_,manifest:n});let ue=!1;try{if(b.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,n,!!b.installOnlyNewlyAddedFromExtensionPack,!!b.installPreReleaseVersion,b.profileLocation),le=await this.getInstalled(void 0,b.profileLocation),ie={...b,donotIncludePackAndDependencies:!0,context:{...b.context,[g.$Rn]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Kb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(B=>(0,d.$po)({id:B},_.identifier));const T=S(q),C=this.j.get(T);if(C){if(this.L(_,C.task)){const B=C.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,_.identifier.id),C.waitingTasks.push(_),H.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,X=>X.some(Y=>(0,d.$po)(Y.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,_.identifier.id),!X.find(K=>(0,d.$po)(K.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$po)(B,q.identifier))){const B=this.Z(G,q,ie);this.j.set(T,{task:B,waitingTasks:[_]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:b.profileLocation}),this.F.info("Installing extension:",B.identifier.id,_.identifier.id),j.push({task:B,manifest:G})}}}catch(ae){if(v.URI.isUri(_.source))(0,L.$Jb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,L.$Jb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=j.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,b,R.CancellationToken.None))),!v.URI.isUri(ie.source)){const T=ie.operation===3,C=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$xo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:C}),u.$o&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}x.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw v.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$xo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),x.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),x}catch(te){if(j.forEach(({task:ae})=>ae.cancel()),x.length)try{const ae=await Promise.allSettled(x.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:b.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=x[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$8)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$8)(ae),x.map(({identifier:le})=>le.id))}return j.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:b.context,profileLocation:b.profileLocation,error:te}))}finally{for(const{task:te}of j)te.source&&!v.URI.isUri(te.source)&&this.j.delete(S(te.source))}}L(n,r){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===n&&(P.includes(r)||P.some(b=>this.L(b,r)))||l===r&&P[0]&&!this.L(n,P[0]))return!1;return!0}async M(n){const r=[],l=[],P=await Promise.allSettled(n);for(const b of P)b.status==="fulfilled"?r.push(b.value):l.push(b.reason);if(l.length)throw k(l);return r}async N(n,r,l,P,b){if(!this.z.isEnabled())return[];const S=await this.getInstalled(void 0,b),j=[],H=[],x=async(_,ue)=>{j.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?S.find(ie=>(0,d.$po)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$po)({id:q},{id:ie}))||ae.every(q=>!(0,d.$po)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>j.every(q=>!(0,d.$po)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:P})),R.CancellationToken.None);for(const q of ie){if(j.find(C=>(0,d.$po)(C,q.identifier)))continue;const G=te.some(C=>(0,d.$po)({id:C},q.identifier));let T;try{T=await this.O(q,!1,P)}catch(C){if(G)throw C;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$8)(C));continue}H.push({gallery:T.extension,manifest:T.manifest}),await x(T.extension.identifier,T.manifest)}}}};return await x(n,r),H}async O(n,r,l){let P;const b=await this.getExtensionsControlManifest();if(b.malicious.some(H=>(0,d.$po)(n.identifier,H)))throw new g.$1n(O.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const S=b.deprecated[n.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!P)throw new g.$1n(O.localize(2,null,n.identifier.id,S.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new g.$1n(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,g.$Sn)(H)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(n,r,l),!P)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new g.$1n(O.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$1n(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const j=await this.z.getManifest(P,R.CancellationToken.None);if(j===null)throw new g.$1n(`Missing manifest for extension ${P.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(j.version!==P.version)throw new g.$1n(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:j}}async P(n,r,l){const P=await this.getTargetPlatform();let b=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(b=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(n,l,P)&&(b=n),b||(r?b=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},R.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(n,l,P)),b}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,b=this.m.get(P(n.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),b.waitUntilTaskIsFinished();const S=_=>{const ue=this.$(_,l);return this.m.set(P(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),ue},j=(_,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$wo)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],x=[];try{H.push(S(n));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,_);for(const te of ue)this.m.has(P(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(S(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),_,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}j(ue.extension)}catch(te){const ae=te instanceof g.$1n?te:new g.$1n((0,A.$8)(te),g.ExtensionManagementErrorCode.Internal);throw j(ue.extension,ae),ae}finally{x.push(ue)}}))}catch(_){const ue=_ instanceof g.$1n?_:new g.$1n((0,A.$8)(_),g.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}x.includes(te)||j(te.extension,ue)}throw ue}finally{for(const _ of H)this.m.delete(P(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,l){for(const P of n){const b=this.W(P,r);if(b.length){const S=b.filter(j=>!n.some(H=>(0,d.$po)(H.identifier,j.identifier)));if(S.length)throw new Error(this.S(P,S,l))}}}S(n,r,l){return l===n?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const b=r.filter(j=>!j.isBuiltin&&P.some(H=>(0,d.$po)({id:H},j.identifier))),S=[];for(const j of b)S.push(...this.U(j,r,l));return[...b,...S]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,d.$po)({id:P},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$fp=p,e.$fp=p=$e([se(0,g.$Zn),se(1,h.$9k),se(2,f.$Ck),se(3,w.$5i),se(4,$.$kj),se(5,I.$Ek)],p);function k(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$gp=k;function t(s){if(s instanceof g.$1n)return s;const n=new g.$1n(s.message,g.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$hp=t;function a(s,n,{extensionData:r,verificationStatus:l,duration:P,error:b,durationSinceUpdate:S}){let j,H;(0,c.$rf)(l)&&(l===!0?l="Verified":(l===!1||(j=g.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),b&&(b instanceof g.$1n?(j=b.code,b.code===g.ExtensionManagementErrorCode.Signature&&(H=b.message)):j=g.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...r,verificationStatus:l,success:!b,duration:P,errorcode:j,errorcodeDetail:H,durationSinceUpdate:S})}class i{constructor(){this.d=new D.$Fg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$ug)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$ug)(n=>new Promise((r,l)=>{const P=n.onCancellationRequested(()=>{P.dispose(),l(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$ip=i}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(i,s){super(i),this.code=s}}e.$jp=I,e.$kp=(0,O.$Bh)("IExtensionsProfileScannerService");let p=class extends R.$kc{constructor(i,s,n,r,l,P){super(),this.j=i,this.m=s,this.n=n,this.r=r,this.s=l,this.t=P,this.b=this.B(new A.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zi}scanProfileExtensions(i,s){return this.u(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],r=[];try{return await this.u(s,l=>{const P=[];for(const b of l)i.some(([S])=>(0,c.$po)(S.identifier,b.identifier)&&S.manifest.version!==b.version)?n.push(b):P.push(b);for(const[b,S]of i){const j=P.findIndex(x=>(0,c.$po)(x.identifier,b.identifier)&&x.version===b.manifest.version),H={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:S};j===-1?(r.push(H),P.push(H)):P.splice(j,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),P}),r.length&&this.c.fire({extensions:r,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:s}),l}}async updateMetadata(i,s){const n=[];return await this.u(s,r=>{const l=[];for(const P of r){const b=i.find(([S])=>(0,c.$po)(S.identifier,P.identifier)&&S.manifest.version===P.version);b&&(P.metadata={...P.metadata,...b[1]},n.push(P)),l.push(P)}return l}),n}async removeExtensionFromProfile(i,s){const n=[];try{await this.u(s,r=>{const l=[];for(const P of r)(0,c.$po)(P.identifier,i.identifier)?n.push(P):l.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:s}),l}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:s}),r}}async u(i,s,n){return this.F(i).queue(async()=>{let r=[],l;try{const P=await this.m.readFile(i);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,v.$jk)(P)!==1)throw P;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,$.$8)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(i);let P=!1;for(const b of l){k(b)||this.w(i);let S;if((0,w.$jf)(b.relativeLocation)&&b.relativeLocation)S=this.z(b.relativeLocation);else if((0,w.$jf)(b.location))S=this.z(b.location),P=!0,b.relativeLocation=b.location,b.location=S.toJSON();else{S=y.URI.revive(b.location);const j=this.y(S);j&&(P=!0,b.relativeLocation=j)}r.push({identifier:b.identifier,location:S,version:b.version,metadata:b.metadata})}P&&await this.m.writeFile(i,D.$Fd.fromString(JSON.stringify(l)))}if(s){r=s(r);const P=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(i,D.$Fd.fromString(JSON.stringify(P)))}return r})}w(i){const s=new I(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(i)).value.toString()}catch(l){if((0,v.$jk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(P=>k(P))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$Fd.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,v.$jk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(i)}catch(l){(0,v.$jk)(l)!==1&&this.t.error(l)}try{await this.m.del(s)}catch(l){(0,v.$jk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(i){let s=this.h.get(i);return s||(s=new L.$Ng,this.h.set(i,s)),s}};e.$lp=p,e.$lp=p=$e([se(1,v.$6j),se(2,d.$Ek),se(3,E.$Ck),se(4,h.$9k),se(5,g.$5i)],p);function k(a){return(0,w.$lf)(a)&&(0,u.$Yn)(a.identifier)&&(t(a.location)||(0,w.$jf)(a.location)&&a.location)&&((0,w.$qf)(a.relativeLocation)||(0,w.$jf)(a.relativeLocation))&&a.version&&(0,w.$jf)(a.version)}function t(a){return a?(0,w.$jf)(a.path)&&(0,w.$jf)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I,p,k,t,a,i,s,n,r,l,P,b,S,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var H;(function(ie){function q(G,T){if(G===T)return!0;const C=Object.keys(G),B=new Set;for(const X of Object.keys(T))B.add(X);if(C.length!==B.size)return!1;for(const X of C){if(G[X]!==T[X])return!1;B.delete(X)}return B.size===0}ie.equals=q})(H||(e.Translations=H={})),e.$op=(0,i.$Bh)("IExtensionsScannerService");let x=class extends c.$kc{constructor(q,G,T,C,B,X,Y,K,U,z,o,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=C,this.t=B,this.u=X,this.w=Y,this.y=K,this.z=U,this.C=z,this.D=o,this.F=m,this.g=this.B(new r.$fd),this.onDidChangeCache=this.g.event,this.h=(0,d.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[C,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(q,[...C,...B]):[];return this.L(C,B,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,C]=await Promise.all(G);return this.J([...T,...C],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let X;try{X=await B.scanExtensions(C)}catch(Y){if(Y instanceof P.$jp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await B.scanExtensions(C);else throw Y}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===v.Schemas.file).map(async C=>{const B=await this.P(C,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Y=>(Y.type=G.find(K=>(0,p.$po)(K.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const C=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanExtension(C);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,T){const C=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(C);return this.J(B,G,T,!0)}async scanMetadata(q){const G=(0,d.$ig)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$ig)(q,"package.json"),C=(await this.w.readFile(T)).value.toString(),B=JSON.parse(C);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,B.__metadata={...B.__metadata,...G},await this.w.writeFile((0,d.$ig)(q,"package.json"),A.$Fd.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$jp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Fd.fromString(JSON.stringify([])))}catch(G){(0,a.$jk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$8)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,C){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),C)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,X)=>{const Y=O.$ae(B.location.fsPath),K=O.$ae(X.location.fsPath);return Y<K?-1:Y>K?1:0})}L(q,G,T,C,B){const X=(K,U,z)=>{if(K.isValid&&!U.isValid)return!1;if(K.isValid===U.isValid){if(B&&E.gt(K.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,U.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===C)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${K.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${U.location.path}.`),!0},Y=new k.$Xl;return q?.forEach(K=>{const U=Y.get(K.identifier.id);(!U||X(U,K,!1))&&Y.set(K.identifier.id,K)}),G?.forEach(K=>{const U=Y.get(K.identifier.id);if(!U&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!U||X(U,K,!1))&&Y.set(K.identifier.id,K)}),T?.forEach(K=>{const U=Y.get(K.identifier.id);(!U||X(U,K,!0))&&Y.set(K.identifier.id,K),Y.set(K.identifier.id,K)}),[...Y.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const C=G?await this.O():{},B=[],X=h.URI.file(O.$7d(O.$9d(v.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const U=C[K.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":B.push((0,d.$ig)(X,K.name));break;default:B.push(h.URI.file(U));break}}const Y=await Promise.all(B.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Fb)(Y)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,C,B,X,Y){const K=await this.f(B??g.$v),U=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(q,U,z,o,G,Y,T,C,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,K)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$pp=x,e.$pp=x=$e([se(4,b.$Ek),se(5,P.$kp),se(6,a.$6j),se(7,s.$5i),se(8,I.$Ih),se(9,n.$kj),se(10,S.$Ck),se(11,i.$Ah)],x);class _{constructor(q,G,T,C,B,X,Y,K,U,z,o,m,F,M,Z){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=C,this.profile=B,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=K,this.validate=U,this.productVersion=z,this.productDate=o,this.productCommit=m,this.devMode=F,this.language=M,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$bg)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$bg)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&R.$Zm(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&H.equals(q.translations,G.translations)}}e.$qp=_;let ue=class extends c.$kc{constructor(q,G,T,C,B){super(),this.f=q,this.g=G,this.h=T,this.j=C,this.m=B}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(C)}catch{}return(0,$.$wf)(T)?G:G.filter(C=>!T[p.$qo.create(C).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async C=>{if(!C.isDirectory||q.type===1&&(0,d.$fg)(C.resource).indexOf(".")===0)return null;const B=new _(C.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Fb)(T).sort((C,B)=>C.location.path<B.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(C=>!C.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const C=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!C.length)return[];const B=await Promise.all(C.map(async X=>{if(G(X)){const Y=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,L.$Fb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$ig)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,N.$8)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=k.$Rl),G=G??T.__metadata,delete T.__metadata;const C=(0,p.$uo)(T.publisher,T.name),B=G?.id?{id:C,uuid:G.id}:{id:C},X=G?.isSystem?0:q.type,Y=X===0||!!G?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const K={type:X,identifier:B,manifest:T,location:q.location,isBuiltin:Y,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const C=(0,t.$Fo)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,X]of C)B===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return q.isValid=T,q.validations=C,q}async scanExtensionManifest(q){const G=(0,d.$ig)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(B){return(0,a.$jk)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,B.message))),null}let C;try{C=JSON.parse(T)}catch{const X=[];(0,y.$Lm)(T,X);for(const Y of X)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,Y.offset,Y.length,(0,u.$mp)(Y.error))));return null}return(0,y.$Um)(C)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):C}async t(q,G,T){const C=await this.u(q,G,T);if(C)try{const B=[],X=await this.w(C.default,B);if(B.length>0)return B.forEach(K=>{this.m.error(this.z(q,(0,f.localize)(3,null,C.default?.path,(0,u.$mp)(K.error))))}),G;if((0,y.$Um)(C)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,C.default?.path))),G;const Y=C.values||Object.create(null);return(0,j.$np)(this.m,G,Y,X)}catch{}return G}async u(q,G,T){const C=(0,d.$ig)(q,"package.nls.json"),B=(U,z)=>{z.forEach(o=>{this.m.error(this.z(q,(0,f.localize)(5,null,U?.path,(0,u.$mp)(o.error))))})},X=U=>{this.m.error(this.z(q,(0,f.localize)(6,null,U?.path)))},Y=`${G.publisher}.${G.name}`,K=T.translations[Y];if(K)try{const U=h.URI.file(K),z=(await this.j.readFile(U)).value.toString(),o=[],m=(0,y.$Lm)(z,o);return o.length>0?(B(U,o),{values:void 0,default:C}):(0,y.$Um)(m)!=="object"?(X(U),{values:void 0,default:C}):{values:m.contents?m.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),m=[],F=(0,y.$Lm)(o,m);return m.length>0?(B(z.localized,m),{values:void 0,default:z.original}):(0,y.$Um)(F)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,y.$Lm)(T,G)}catch{}}y(q,G){return new Promise((T,C)=>{const B=X=>{const Y=(0,d.$ig)(q,`package.nls.${X}.json`);this.j.exists(Y).then(K=>{K&&T({localized:Y,original:(0,d.$ig)(q,"package.nls.json")});const U=X.lastIndexOf("-");U===-1?T({localized:(0,d.$ig)(q,"package.nls.json"),original:null}):(X=X.substring(0,U),B(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$ig)(q,"package.nls.json"),original:null});B(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=$e([se(1,P.$kp),se(2,S.$Ck),se(3,a.$6j),se(4,s.$5i)],ue);let te=class extends ue{constructor(q,G,T,C,B,X,Y){super(G,C,B,X,Y),this.G=q,this.H=T,this.D=this.B(new D.$Eg(3e3)),this.F=this.B(new r.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const C=await super.scanExtensions(q);return await this.J(G,{input:q,result:C}),C}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$$g)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,N.$8)(G))}return null}async J(q,G){try{await this.j.writeFile(q,A.$Fd.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,N.$8)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Zm(C,T))try{this.m.info("Invalidating Cache",T,C),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?k.$Ql:k.$Pl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([se(2,b.$Ek),se(3,P.$kp),se(4,S.$Ck),se(5,a.$6j),se(6,s.$5i)],te);function ae(ie,q){const G=(0,p.$so)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new k.$Vl(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$rp=ae;class le extends x{constructor(q,G,T,C,B,X,Y,K,U,z,o,m){super(q,G,(0,d.$ig)(T,".vscode-oss-dev","extensions","control.json"),C,B,X,Y,K,U,z,o,m),this.R=(async()=>{if(g.$y)try{const F=await this.w.readFile(h.URI.file(g.$y));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$sp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,R,A,N,y,u,c,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let g=class extends N.$kc{constructor(E,w){super(),this.b=E,this.f=w,this.a=new D.$Mg(5)}async postUninstall(E){const w=this.g(E,"uninstall");w&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(E))}catch($){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error($)}}g(E,w){const $=`vscode:${w}`;if(E.location.scheme===y.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[$]=="string"){const h=E.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${$} should be a node script`),null):{script:(0,u.$9d)(E.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(E,w,$,h,f){return new Promise((I,p)=>{const k=this.j(E,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):I(void 0)};k.on("error",i=>{a((0,R.$mi)(i)||"Unknown")}),k.on("exit",(i,s)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,k.kill(),p("timed out")},5e3))})}j(E,w,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(E,[`--type=extension-post-${w}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(I.stdout,"data"),k=A.Event.fromNodeEventEmitter(I.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),k(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(k,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),I}m(E){return(0,u.$9d)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$up=g,e.$up=g=$e([se(0,O.$Ek),se(1,v.$5i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=void 0;let v=class extends N.$lp{constructor(g,d,E,w,$,h){super(c.URI.file(g.extensionsPath),d,E,w,$,h)}};e.$qN=v,e.$qN=v=$e([se(0,u.$Jh),se(1,y.$6j),se(2,D.$Ek),se(3,R.$Ck),se(4,A.$9k),se(5,L.$5i)],v)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,R,A,N,y,u,c,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let g=class extends A.$sp{constructor(E,w,$,h,f,I,p,k){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,E.defaultProfile,E,w,$,h,f,I,p,k)}};e.$f7b=g,e.$f7b=g=$e([se(0,O.$Ek),se(1,R.$kp),se(2,N.$6j),se(3,u.$5i),se(4,D.$Jh),se(5,c.$kj),se(6,v.$Ck),se(7,y.$Ah)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,u.$Bh)("storageService");var v;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const I=f.get(e.$Uo);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$Wo=d;class E extends R.$kc{static{this.a=60*1e3}constructor(I={flushInterval:E.a}){super(),this.m=I,this.b=this.B(new D.$id),this.c=this.B(new D.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,k){return D.Event.filter(this.b.event,t=>t.scope===I&&(p===void 0||t.key===p),k)}n(){this.j.value=(0,L.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:k,external:t}=p;if(k===e.$Uo){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:k,target:this.J(I)[k],external:t})}w(I){this.f.fire({reason:I})}get(I,p,k){return this.P(p)?.get(I,k)}getBoolean(I,p,k){return this.P(p)?.getBoolean(I,k)}getNumber(I,p,k){return this.P(p)?.getNumber(I,k)}getObject(I,p,k){return this.P(p)?.getObject(I,k)}storeAll(I,p){this.y(()=>{for(const k of I)this.store(k.key,k.value,k.scope,k.target,p)})}store(I,p,k,t,a=!1){if((0,N.$sf)(p)){this.remove(I,k,a);return}this.y(()=>{this.z(I,k,t),this.P(k)?.set(I,p,a)})}remove(I,p,k=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,k)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const k=[],t=this.J(I);for(const a of Object.keys(t))t[a]===p&&k.push(a);return k}z(I,p,k,t=!1){const a=this.J(p);typeof k=="number"?a[I]!==k&&(a[I]=k,this.P(p)?.set(e.$Uo,JSON.stringify(a),t)):typeof a[I]=="number"&&(delete a[I],this.P(p)?.set(e.$Uo,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$To,I)===!0}async flush(I=v.NONE){this.f.fire({reason:I});const p=this.P(-1),k=this.P(0),t=this.P(1);switch(I){case v.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return h(I,p,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(v.NONE),(0,c.$Dk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||w(p)&&w(I))}N(I,p,k){this.y(()=>{const t=new Set;for(const[a,i]of I)t.add(a),p.get(a)!==i&&this.u(k,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(k,{key:a,external:!0})})}}e.$Xo=E;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Yo=w;class $ extends E{constructor(){super(),this.U=this.B(new y.$Ro(new y.$So,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new y.$Ro(new y.$So,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new y.$Ro(new y.$So,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$Zo=$;async function h(f,I,p,k,t,a){const i=H=>{try{return JSON.parse(H)}catch{return H}},s=new Map,n=new Map;f.forEach((H,x)=>{s.set(x,H),n.set(x,i(H))});const r=new Map,l=new Map;I.forEach((H,x)=>{r.set(x,H),l.set(x,i(H))});const P=new Map,b=new Map;p.forEach((H,x)=>{P.set(x,H),b.set(x,i(H))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const S=[];if(s.forEach((H,x)=>{S.push({key:x,value:H})}),console.table(S),console.groupEnd(),console.log(n),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const H=[];r.forEach((x,_)=>{H.push({key:_,value:x})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const j=[];P.forEach((H,x)=>{j.push({key:x,value:H})}),console.table(j),console.groupEnd(),console.log(b)}e.$1o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=void 0;const t=A.$o?"web":(0,O.$Un)(A.$t,N.$4d),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...o){return String(o.reduce((m,F)=>m|F,0))}var n;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class S{constructor(m=b){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,F=this.d.pageSize){return new S({...this.d,pageNumber:m,pageSize:F})}withFilter(m,...F){const M=[...this.d.criteria,...F.length?F.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new S({...this.d,criteria:M})}withSortBy(m){return new S({...this.d,sortBy:m})}withSortOrder(m){return new S({...this.d,sortOrder:m})}withFlags(...m){return new S({...this.d,flags:m.reduce((F,M)=>F|M,0)})}withAssetTypes(...m){return new S({...this.d,assetTypes:m})}withSource(m){return new S({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:F,pageSize:M,sortBy:Z,sortOrder:W,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:F,pageSize:M,sortBy:Z,sortOrder:W}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(o,m){const F=(o||[]).filter(M=>M.statisticName===m)[0];return F?F.value:0}function H(o){const m="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(M=>M.assetType.indexOf(m)===0).reduce((M,Z)=>{const W=ue(o,Z.assetType);return W&&M.push([Z.assetType.substring(m.length),W]),M},[])}function x(o){if(o.properties){const m=o.properties.filter(Z=>Z.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=m.filter(Z=>F.test(Z.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,m){return o.files.filter(M=>M.assetType===m)[0]?{uri:`${o.assetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,m){const F=o.properties?o.properties.filter(Z=>Z.key===m):[],M=F.length>0&&F[0].value;return M?M.split(",").map(Z=>(0,g.$to)(Z)):[]}function ae(o){const m=o.properties?o.properties.filter(F=>F.key===l.Engine):[];return m.length>0&&m[0].value||""}function le(o){const m=o.properties?o.properties.filter(F=>F.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(o){const m=o.properties?o.properties.filter(M=>M.key===l.LocalizedLanguages):[],F=m.length>0&&m[0].value||"";return F?F.split(","):[]}function q(o){return o.properties?.find(m=>m.key===l.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,O.$Tn)(o.targetPlatform):"undefined"}function C(o){const m=(0,L.$Kb)(o.versions.map(T)),F=!!o.tags?.includes(O.$On),M=m.indexOf("web");return F?M===-1&&m.push("web"):M!==-1&&m.splice(M,1),m}function B(o,m){const F=(0,O.$Xn)(m);for(let M=0;M<o.length;M++){const Z=o[M];if(Z.version===o[M-1]?.version){let W=M;const ce=T(Z);if(ce===m)for(;W>0&&o[W-1].version===Z.version;)W--;else if(F.includes(ce))for(;W>0&&o[W-1].version===Z.version&&T(o[W-1])!==m;)W--;W!==M&&(o.splice(M,1),o.splice(W,0,Z))}}return o}e.$4o=B;function X(o,m,F){o.telemetryData={index:m,querySource:F,queryActivityId:o.queryContext?.[a]}}function Y(o,m,F,M){const Z=o.versions[0],W={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:x(m),download:_(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,g.$uo)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:m.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:o.shortDescription||"",installCount:j(o.statistics,"install"),rating:j(o.statistics,"averagerating"),ratingCount:j(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:F,assets:W,properties:{dependencies:te(m,l.Dependency),extensionPack:te(m,l.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Z),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!W.signature,queryContext:M}}let K=class{constructor(m,F,M,Z,W,ce,oe,pe){this.k=F,this.l=M,this.n=Z,this.o=W,this.q=ce,this.u=oe,this.w=pe;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$3o)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,F,M){const Z=D.CancellationToken.isCancellationToken(F)?{}:F,W=D.CancellationToken.isCancellationToken(F)?F:M,ce=[],oe=[],pe=[],de=[];let ge=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new S().withPage(1,m.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??t,includePreRelease:pe,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>X(we,be,Z.source)),he}async getCompatibleExtension(m,F,M){if((0,O.$Vn)(m.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(m,F,M))return m;const Z=new S().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:M,compatible:!0,includePreRelease:F},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,F,M){if(!(0,O.$Wn)(m.properties.targetPlatform,m.allTargetPlatforms,M)||!F&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const W=await this.getManifest(m,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,d.$Ho)(Z,this.u.version,this.u.date)}async y(m,F,M,Z,W){if(!(0,O.$Wn)(T(m),Z,W)||F!=="any"&&le(m)!==(F==="prerelease"))return!1;if(M)try{const ce=await this.E(m);if(!(0,d.$Ho)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$8)(ce)),!1}return!0}async query(m,F){let M=m.text||"";const Z=m.pageSize??50;let W=new S().withPage(1,Z);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),W=W.withFilter(n.SearchText,M)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,Se)=>X(be,(ge.pageNumber-1)*ge.pageSize+Se,m.source)),{extensions:he,total:we}},{extensions:oe,total:pe}=await ce(W,F),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await ce(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:pe,pageSize:W.pageSize,getPage:de}}async z(m,F,M){const Z=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),F.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:ce,context:oe}=await this.B(m,M);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,F,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$uo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,y.$pf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,g.$po)(Fe,we))?.includePreRelease;if(F.compatible&&(0,O.$Vn)(C(he),F.targetPlatform))continue;const Se=await this.A(he,F,oe);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==F.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new k.$bd,he=new S().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,F,M);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Se=ge.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,F,M){const Z={id:(0,g.$uo)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=F.versions?.find(de=>(0,g.$po)(de,Z))?.version,ce=(0,y.$pf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,g.$po)(de,Z))?.includePreRelease,oe=C(m),pe=B(m.versions,F.targetPlatform);if(F.compatible&&(0,O.$Vn)(oe,F.targetPlatform))return null;for(let de=0;de<pe.length;de++){const ge=pe[de];if(!(W&&ge.version!==W)){if(await this.y(ge,ce?"any":"release",F.compatible,oe,F.targetPlatform))return Y(m,ge,oe,M);if(W&&ge.version===W)return null}}return W||F.compatible?null:Y(m,m.versions[0],oe)}async B(m,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(i.Unpublished));const M=await this.j,Z=JSON.stringify(m.raw),W={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ce=new k.$bd;let oe,pe,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Oo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw pe=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Ko)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,R.$2)(pe)?"canceled":(0,R.$8)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,F,M,Z){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${F}/version/${M}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${F}/${M}/stats?statType=${Z}`),ce=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:W,headers:pe},D.CancellationToken.None)}catch{}}async download(m,F,M){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,g.$xo)(m),W=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=M===2?"install":M===3?"update":"",pe=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[a]?{[a]:m.queryContext[a]}:void 0,ge=await this.D(pe,de?{headers:de}:void 0);await this.q.writeFile(F,ge.stream),ce(new Date().getTime()-W)}async downloadSignatureArchive(m,F){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const M=await this.D(m.assets.signature);await this.q.writeFile(F,M.stream)}async getReadme(m,F){if(m.assets.readme){const M=await this.D(m.assets.readme,{},F);return await(0,h.$No)(M)||""}return""}async getManifest(m,F){if(m.assets.manifest){const M=await this.D(m.assets.manifest,{},F),Z=await(0,h.$No)(M);return Z?JSON.parse(Z):null}return null}async C(m,F){const M=ue(m,r.Manifest);if(!M)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(M,{headers:Z});return await(0,h.$Oo)(W)}async getCoreTranslation(m,F){const M=m.assets.coreTranslations.filter(Z=>Z[0]===F.toUpperCase())[0];if(M){const Z=await this.D(M[1]),W=await(0,h.$No)(Z);return W?JSON.parse(W):null}return null}async getChangelog(m,F){if(m.assets.changelog){const M=await this.D(m.assets.changelog,{},F);return await(0,h.$No)(M)||""}return""}async getAllCompatibleVersions(m,F,M){let Z=new S().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(n.ExtensionId,m.identifier.uuid):Z=Z.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Z,D.CancellationToken.None);if(!W.length)return[];const ce=C(W[0]);if((0,O.$Vn)(ce,M))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,F?"any":"release",!0,ce,M)&&oe.push(ge)}catch{}}));const pe=[],de=new Set;for(const ge of B(oe,M))de.has(ge.version)||(de.add(ge.version),pe.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return pe}async D(m,F={},M=D.CancellationToken.None){const Z=await this.j,W={type:"GET"},ce={...Z,...F.headers||{}};F={...F,...W,headers:ce};const oe=m.uri,pe=m.fallbackUri,de={...F,url:oe};try{const ge=await this.k.request(de,M);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$No)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$2)(ge))throw ge;const fe=(0,R.$8)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...F,url:pe};return this.k.request(he,M)}}async E(m){let F=ae(m);if(!F){const M=await this.C(m,D.CancellationToken.None);if(!M)throw new Error("Manifest was not found");F=M.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.$Oo)(m),M=[],Z={},W=[];if(F){for(const ce of F.malicious)M.push({id:ce});if(F.migrateToPreRelease)for(const[ce,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,d.$Ho)(oe.engine,this.u.version,this.u.date))&&(Z[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,oe]of Object.entries(F.deprecated))oe&&(Z[ce.toLowerCase()]=(0,y.$pf)(oe)?{}:oe);if(F.search)for(const ce of F.search)W.push(ce)}return{malicious:M,deprecated:Z,search:W}}};K=$e([se(1,h.$Io),se(2,w.$5i),se(3,v.$Ih),se(4,p.$9k),se(5,E.$6j),se(6,$.$kj),se(7,c.$8h)],K);let U=class extends K{constructor(m,F,M,Z,W,ce,oe,pe){super(m,F,M,Z,W,ce,oe,pe)}};e.$5o=U,e.$5o=U=$e([se(0,I.$Vo),se(1,h.$Io),se(2,w.$5i),se(3,v.$Ih),se(4,p.$9k),se(5,E.$6j),se(6,$.$kj),se(7,c.$8h)],U);let z=class extends K{constructor(m,F,M,Z,W,ce,oe){super(void 0,m,F,M,Z,W,ce,oe)}};e.$6o=z,e.$6o=z=$e([se(0,h.$Io),se(1,w.$5i),se(2,v.$Ih),se(3,p.$9k),se(4,E.$6j),se(5,$.$kj),se(6,c.$8h)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,A,N,y,u,c,v){"use strict";var O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=void 0;let d=class extends u.$Hk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,k){super(I,p,f,k),this.U=h,this.W=I}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,c.$jf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$nN=d,e.$nN=d=O=$e([se(0,N.$iN),se(1,y.$Ck),se(2,D.$Jh),se(3,R.$6j),se(4,A.$5i)],d);let E=g=class extends d{constructor(h,f,I,p,k){super(h,f,I,p,k),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((k,{workspace:t,profile:a})=>(k[L.URI.revive(t).toString()]=L.URI.revive(a).toString(),k),{});this.$.setItem(g.c,{workspaces:p})}const I=super.Q();return this.$.getItem(g.a,!1)||(this.R(I),this.$.setItem(g.a,!0)),I}};e.$oN=E,e.$oN=E=g=$e([se(0,N.$jN),se(1,y.$Ck),se(2,D.$Jh),se(3,R.$6j),se(4,A.$5i)],E);let w=class extends E{constructor(h,f,I,p){super(new v.$mN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$pN=w,e.$pN=w=$e([se(0,y.$Ck),se(1,D.$Jh),se(2,R.$6j),se(3,A.$5i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,A,N,y,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.zip=e.$bp=e.$ap=void 0,e.$ap="end of central directory record signature not found";const v=new RegExp(e.$ap);class O extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$bp=O;function g(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function d(t){if(t instanceof O)return t;let a;return v.test(t.message)&&(a="CorruptZip"),new O(a,t)}function E(t,a,i,s,n,r){const l=R.$_d(a),P=R.$9d(s,l);if(!P.startsWith(s))return Promise.reject(new Error(y.localize(0,null,a)));const b=R.$9d(s,a);let S;return r.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((j,H)=>{if(!r.isCancellationRequested)try{S=(0,L.createWriteStream)(b,{mode:i}),S.once("close",()=>j()),S.once("error",H),t.once("error",H),t.pipe(S)}catch(x){H(x)}}))}function w(t,a,i,s){let n=(0,D.$ug)(()=>Promise.resolve()),r=0;const l=s.onCancellationRequested(()=>{n.cancel(),t.close()});return new Promise((P,b)=>{const S=new D.$Bg,j=H=>{H.isCancellationRequested||(r++,t.readEntry())};t.once("error",b),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===r?P():b(new O("Incomplete",new Error(y.localize(1,null,r,t.entryCount))))},b)),t.readEntry(),t.on("entry",H=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(H.fileName)){j(s);return}const x=H.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const te=R.$9d(a,x);n=(0,D.$ug)(ae=>N.Promises.mkdir(te,{recursive:!0}).then(()=>j(ae)).then(void 0,b));return}const _=h(t,H),ue=g(H);n=(0,D.$ug)(te=>S.queue(()=>_.then(ae=>E(ae,x,ue,a,i,te).then(()=>j(te)))).then(null,b))})}).finally(()=>l.dispose())}function $(t,a=!1){return new Promise((i,s)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(n,r)=>{n?s(d(n)):i((0,A.$uf)(r))})})}function h(t,a){return new Promise((i,s)=>{t.openReadStream(a,(n,r)=>{n?s(d(n)):i((0,A.$uf)(r))})})}function f(t,a){return new Promise((i,s)=>{const n=new c.ZipFile;a.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(t);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>i(t))})}e.zip=f;function I(t,a,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(l=>N.Promises.rm(a).then(()=>l))),r.then(l=>w(l,a,{sourcePathRegex:n},s))}e.$dp=I;function p(t,a){return $(t).then(i=>new Promise((s,n)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(l=>s(l),l=>n(l))}),i.once("close",()=>n(new Error(y.localize(2,null,a))))}))}function k(t,a){return p(t,a).then(i=>new Promise((s,n)=>{const r=[];i.once("error",n),i.on("data",l=>r.push(l)),i.on("end",()=>s(Buffer.concat(r)))}))}e.$ep=k}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;let p=class extends R.$kc{static{I=this}static{this.c=".sigzip"}constructor(t,a,i,s,n,r){super(),this.h=a,this.j=i,this.m=s,this.n=n,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const s=(0,N.$ig)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,r=>this.j.download(t,r,a))}catch(r){throw new E.$1n(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.t(t)){const r=await this.u(t);try{n=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const P=l;if(n=P.code,P.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$1n(O.$ap,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$pf)(a)?a:!0}async u(t){await this.g;const a=(0,N.$ig)(this.extensionsDownloadDir,`${this.z(t)}${I.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const s=(0,N.$ig)(this.extensionsDownloadDir,`.${(0,c.$4f)()}`);await this.h.exists(s)||await i(s);try{await v.Promises.rename(s.fsPath,a.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,D.$8)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],s=[];for(const l of t.children)if(l.name.endsWith(I.c))s.push(l.resource);else{const P=w.$qo.parse(l.name);P&&i.push([P,l])}const n=(0,w.$vo)(i,([l])=>l),r=[];for(const l of n)l.sort((P,b)=>y.rcompare(P[0].version,b[0].version)),a.push(...l.slice(1).map(P=>P[1].resource)),r.push(l[0][1]);r.sort((l,P)=>l.mtime-P.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),a.push(...s),await L.Promises.settled(a.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$qo.create(t).toString().toLowerCase():(0,c.$4f)()}};e.$tp=p,e.$tp=p=I=$e([se(0,d.$Jh),se(1,h.$6j),se(2,E.$Zn),se(3,g.$8h),se(4,$.$7o),se(5,f.$5i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function R(A){return(0,L.$ep)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$vp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I,p,k,t,a,i,s,n,r,l,P,b,S,j,H,x,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$yp=(0,_.$Ch)(i.$2n);const q=".vsctmp";let G=class extends a.$fp{constructor(U,z,o,m,F,M,Z,W,ce,oe,pe,de){super(U,z,pe,o,oe,de),this.fb=F,this.gb=M,this.hb=Z,this.ib=ce,this.eb=new Map,this.rb=new v.$Ai;const ge=this.B(W.createInstance(P.$up));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new S.$wp(de,ce,pe,this,this.F)),this.db=this.B(W.createInstance(l.$tp));const fe=this.B(new j.$xp(this,this.fb,de,M,pe,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Ao)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const z=await this.pb(U),o=await(0,I.zip)((0,d.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)()).fsPath,z);return $.URI.file(o)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:z,cleanup:o}=await this.lb(U),m=g.$0d(z.fsPath);try{return await(0,b.$vp)(m)}finally{await o()}}getInstalled(U,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,z={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:o,cleanup:m}=await this.lb(U);try{const F=await(0,b.$vp)(g.$0d(o.fsPath)),M=(0,s.$uo)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$Ho)(F.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:F,extension:o,options:z}])).find(({identifier:ce})=>(0,s.$po)(ce,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,a.$hp)(new Error(`Unknown error while installing extension ${M}`))}finally{await m()}}async installFromLocation(U,z){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const o=await this.bb.scanUserExtensionAtLocation(U);if(!o)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(U,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,z.toString(),o.toString());const m=(await this.bb.scanExtensions(1,z)).filter(F=>U.some(M=>(0,s.$po)(M,F.identifier)));if(m.length){const F=await Promise.all(m.map(M=>this.bb.scanMetadata(M,z)));await this.ub(m.map((M,Z)=>[M,F[Z]]),o),this.F.info("Successfully installed extensions",m.map(M=>M.identifier.id),o.toString())}return m}async updateMetadata(U,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,U=await this.bb.updateMetadata(U,z,o),this.cb.invalidate(o),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(m){throw new Error(p.localize(3,null,(0,A.$mi)(m)))}return this.installFromGallery(o)}ab(U,z,o,m){return this.bb.copyExtension(U,z,o,m)}copyExtensions(U,z){return this.bb.copyExtensions(U,z)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,z,o){const{location:m}=await this.db.download(U,z,!o);return m}async lb(U){if(U.scheme===O.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const z=(0,d.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)());return await this.hb.download(U,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,z,o){if($.URI.isUri(z))return new X(U,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=s.$qo.create(z).toString();let F=this.eb.get(m);return F||(this.eb.set(m,F=new B(U,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),F}$(U,z){return new Y(U,z.profileLocation,this.gb)}async pb(U){const z=async m=>{let F=await f.Promises.readdir(m);F=F.map(W=>g.$9d(m,W));const M=await Promise.all(F.map(W=>f.Promises.stat(W)));let Z=Promise.resolve([]);return M.forEach((W,ce)=>{const oe=F[ce];W.isFile()&&(Z=Z.then(pe=>[...pe,oe])),W.isDirectory()&&(Z=Z.then(pe=>z(oe).then(de=>[...pe,...de])))}),Z};return(await z(U.location.fsPath)).map(m=>({path:`extension/${g.$$d(U.location.fsPath,m)}`,localPath:m}))}async qb({added:U,removed:z}){if(z)for(const o of z.extensions)this.F.info("Extensions removed from another source",o.id,z.profileLocation.toString()),this.u.fire({identifier:o,profileLocation:z.profileLocation});if(U){const m=(await this.bb.scanExtensions(1,U.profileLocation)).filter(F=>U.extensions.some(M=>(0,s.$po)(M,F.identifier)));this.s.fire(m.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,U.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of U.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of U.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(o);m&&m.installedTimestamp===void 0&&(this.rb.add(o),z.push(m))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(U,z){const o=U.map(m=>m[0]);await this.vb(o),await this.gb.addExtensionsToProfile(U,z),this.s.fire(o.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(U){const z=await this.bb.getUninstalledExtensions();for(const o of U){const m=s.$qo.create(o);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$zp=G,e.$zp=G=$e([se(0,i.$Zn),se(1,ae.$9k),se(2,ue.$5i),se(3,t.$Jh),se(4,r.$op),se(5,n.$kp),se(6,k.$Dn),se(7,_.$Ah),se(8,x.$6j),se(9,te.$kj),se(10,le.$Ck),se(11,ie.$Ek)],G);let T=class extends c.$kc{constructor(U,z,o,m,F,M){super(),this.j=U,this.m=z,this.n=o,this.s=m,this.t=F,this.u=M,this.h=this.B(new y.$fd),this.onExtract=this.h.event,this.c=(0,d.$ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Ng}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,z){const o={includeInvalid:!0,profileLocation:z};let m=[];return U===null||U===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):U===1&&m.push(...await this.n.scanUserExtensions(o)),m=U!==null?m.filter(F=>F.type===U):m,Promise.all(m.map(F=>this.F(F)))}async scanAllUserExtensions(U){const z=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(U){try{const z=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(U,z,o,m,F){const M=U.toString(),Z=$.URI.file(g.$9d(this.n.userExtensionsLocation.fsPath,`.${(0,h.$4f)()}`)),W=$.URI.file(g.$9d(this.n.userExtensionsLocation.fsPath,M));let ce=await this.m.exists(W);if(ce&&m){try{await this.y(U.id,W,"removeExisting")}catch{throw new i.$1n(p.localize(4,null,W.fsPath,U.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,I.$dp)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${W}:`,U.id)}catch(oe){let pe=i.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$bp&&(oe.type==="CorruptZip"?pe=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(pe=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$1n(oe.message,pe)}await this.n.updateMetadata(Z,o);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,N.$8)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(W)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(U,z){return z?(await this.w(U,z))?.metadata:this.n.scanMetadata(U.location)}async w(U,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,s.$po)(m.identifier,U.identifier))}async updateMetadata(U,z,o){return o?await this.s.updateMetadata([[U,z]],o):await this.n.updateMetadata(U.location,z),this.D(U.location,U.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const z=U.map(o=>s.$qo.create(o));await this.z(o=>z.forEach(m=>{o[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(U){await this.z(z=>delete z[U.toString()])}async removeExtension(U,z){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,z)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(z=>delete z[s.$qo.create(U).toString()])}async copyExtension(U,z,o,m){const F=await this.w(U,z),M=await this.w(U,o);return m={...F?.metadata,...m},M?await this.s.updateMetadata([[U,{...M.metadata,...m}]],o):await this.s.addExtensionsToProfile([[U,m]],o),this.D(U.location,U.type,o)}async copyExtensions(U,z){const o=await this.scanExtensions(1,U),m=await Promise.all(o.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,U)]));await this.s.addExtensionsToProfile(m,z)}async y(U,z,o){this.u.trace(`Deleting ${o} extension from disk`,U,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$pi)((0,h.$4f)()).toString(16)}${q}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,U,z.fsPath)}async z(U){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,x.$jk)(m)!==1)throw m}let o={};if(z)try{o=JSON.parse(z)}catch{}return U&&(U(o),Object.keys(o).length?await this.m.writeFile(this.c,D.$Fd.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(U,z){try{await f.Promises.rename(U,z,2*60*1e3)}catch(o){throw new i.$1n(o.message||p.localize(5,null,U,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(U,z,o){if(o){const F=(await this.n.scanUserExtensions({profileLocation:o})).find(M=>this.t.extUri.isEqual(M.location,U));if(F)return this.F(F)}else{const m=await this.n.scanExistingExtension(U,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,U.path))}async F(U){const z=await this.m.resolve(U.location);let o,m;return z.children&&(o=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,m=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:o,changelogUrl:m,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const F of z)U[s.$qo.create(F).toString()]||o.add(F.identifier.id.toLowerCase());try{const F=(0,s.$vo)(z,M=>M.identifier);await L.Promises.settled(F.map(async M=>{const Z=M.sort((W,ce)=>E.rcompare(W.manifest.version,ce.manifest.version))[0];o.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(F){this.u.error(F)}const m=z.filter(F=>F.metadata&&U[s.$qo.create(F).toString()]);await Promise.allSettled(m.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,x.$jk)(z)!==1&&this.u.error(z);return}if(U?.children)try{await Promise.allSettled(U.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,x.$jk)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$Ap=T,e.$Ap=T=$e([se(1,x.$6j),se(2,r.$op),se(3,n.$kp),se(4,le.$Ck),se(5,ue.$5i)],T);class C extends a.$ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$qf)(this.options.operation)?this.l:this.options.operation}constructor(U,z,o,m,F,M,Z,W,ce){super(),this.identifier=U,this.source=z,this.options=o,this.m=m,this.n=F,this.o=M,this.p=Z,this.q=W,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[z,o]=await this.x(U);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:U,key:z,metadata:o},m,F){let M=await this.v(z);return M||(this.s.trace("Extracting extension...",z.id),M=await this.m.extractUserExtension(z,U,o,m,F),this.s.info("Extracting extension completed.",z.id)),M}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(m=>s.$qo.create(m).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class B extends C{constructor(U,z,o,m,F,M,Z,W,ce,oe){super(z.identifier,z,o,F,M,Z,W,ce,oe),this.y=z,this.z=m}async x(U){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,s.$po)(Z.identifier,this.y.identifier));o&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$pf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,m),m];const{location:F,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:s.$qo.create(this.y),metadata:m},!1,U),m]}catch(Z){try{await this.z.delete(F)}catch(W){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,N.$8)(W))}throw Z}}async B(U){try{await(0,b.$vp)(U)}catch(z){throw new i.$1n((0,a.$gp)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$Bp=B;class X extends C{constructor(U,z,o,m,F,M,Z,W,ce,oe){super({id:(0,s.$uo)(U.publisher,U.name)},z,o,F,M,Z,W,ce,oe),this.y=U,this.z=z,this.A=m}async h(U){const z=await super.h(U);return this.D(z,U),z}async x(U){const z=new s.$qo(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.$po)(this.identifier,Z.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new s.$qo(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$0d(this.z.fsPath),key:z,metadata:F},!0,U),F]}async D(U,z){try{let[o]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:U.identifier.id}],z)),o){const m={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,m,this.options.profileLocation)}}catch{}}}class Y extends a.$ip{constructor(U,z,o){super(),this.extension=U,this.j=z,this.k=o}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;let E=class extends O.$Jo{constructor(f,I,p,k){super(k),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:k}=this;let t;try{t=await(0,c.$Ml)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$8)(s)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,g.$Nq)(f.url||"",a,{proxyUrl:p,strictSSL:k});return f.agent=i,f.strictSSL=k,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Oq=E,e.$Oq=E=$e([se(0,y.$8h),se(1,u.$Jh),se(2,v.$5i),se(3,v.$6i)],E);async function w(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,k)=>{J(["https"],p,k)}):await new Promise((p,k)=>{J(["http"],p,k)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(I,p)=>{const k=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:k.hostname,port:k.port?parseInt(k.port):k.protocol==="https:"?443:80,protocol:k.protocol,path:k.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,N.$pf)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,s=>{const n=(0,N.$nf)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)$({...h,url:s.headers.location,followRedirects:n-1},f).then(I,p);else{let r=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,d.createGunzip)())),I({res:s,stream:(0,R.$Ud)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$3)})})}e.$Pq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,A,N,y,u,c,v,O,g,d,E,w,$,h,f,I,p,k,t,a,i,s,n,r,l,P,b,S,j,H,x,_,ue,te,ae,le,ie,q,G,T,C,B,X,Y,K,U,z,o,m,F,M,Z,W,ce,oe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$kc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(_.$5i),Fe=be.get(r.$6j),V=be.get(h.$Jh),Q=be.get(m.$Ek);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Fe,Q,he),await Promise.all(we.map(ee=>{(0,D.$yg)(ee.flush(),1e3)}))})}async f(){const he=new j.$zh,we={_serviceBrand:void 0,...le.default};he.set(ie.$kj,we);const be=new f.$_l(this.b,we);he.set(h.$Jh,be),await Promise.all([be.appSettingsHome.with({scheme:y.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?g.Promises.mkdir(De,{recursive:!0}):void 0));const Se=new ce.$hN((0,_.$gj)(be),be.logsHome);he.set(_.$6i,Se);const Fe=this.B(Se.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];Se.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$aj(Se.getLogLevel()));const Q=this.B(new W.$rN(Fe,V));he.set(_.$5i,Q);const ee=this.B(new l.$Dp(Q));he.set(r.$6j,ee);const me=this.B(new P.$3p(Q));ee.registerProvider(y.Schemas.file,me);const ye=new o.$pr(ee);he.set(z.$Ck,ye);const je=new T.$lN(1,be,Q,ee),ke=new F.$nN(je,ye,be,ee,Q);he.set(m.$Ek,ke),ee.registerProvider(y.Schemas.vscodeUserData,new pe.$D7b(y.Schemas.file,me,y.Schemas.vscodeUserData,ke,ye,Q));const Le=c.$i&&we.win32RegValueName?this.B(new ae.$B7b(Q,we.win32RegValueName)):be.policyFile?this.B(new ue.$C7b(be.policyFile,ee,Q)):new te.$_m;he.set(te.$0m,Le);const Ie=this.B(new E.$zn(ke.defaultProfile.settingsResource,ee,Le,Q));he.set(d.$8h,Ie),await Promise.all([je.init(),Ie.initialize()]);let Ae;try{Ae=await(0,M.$i7b)(je,Q)}catch(De){De.code!=="ENOENT"&&Q.error(De)}ke.init(),he.set(z.$Ck,new o.$pr(ee));const Ue=new G.$Oq(Ie,be,Q,Se);he.set(q.$Io,Ue),he.set(w.$Dn,new b.$yh($.$GN,void 0,!0)),he.set(a.$kp,new b.$yh(Z.$qN,void 0,!0)),he.set(i.$op,new b.$yh(n.$f7b,void 0,!0)),he.set(k.$7o,new b.$yh(k.$8o,void 0,!0)),he.set(s.$yp,new b.$yh(s.$zp,void 0,!0)),he.set(p.$Zn,new b.$yh(I.$6o,void 0,!0)),he.set(H.$Iq,new b.$yh(x.$Kq,void 0,!1));const Oe=[],Ne=(0,Y.$mo)(we,Ie);if((0,Y.$ho)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new K.$fN(Ue,Ne,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,C.$0n)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ne),piiPaths:(0,Y.$no)(be)};he.set(B.$9k,new b.$yh(X.$Qq,[De],!1))}else he.set(B.$9k,Y.$bo);return[new S.$6p(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$mi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$X)(we)||(0,A.$Y)(we)}),process.on("unhandledRejection",we=>(0,A.$Y)(we))}async h(he,we,be,Se){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Q=>Q.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(t.$9o,new _.$aj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$Z7b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$8d)(we)?we:(0,u.$9d)((0,v.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/code/node/cliProcessMain.js.map
