/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],O=0,N=te.length;O<N;O++)e[O]=oe[te[O]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class O{static get(){const A=new Map,L=new Map,D=new Map,I=new Map;function S(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function f(l,g){const w=l.get(g.detail);w&&(w>=0||l.set(g.detail,w+g.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of P)switch(l.type){case 10:S(A,l);break;case 11:case 12:f(A,l);break;case 21:S(L,l);break;case 22:f(L,l);break;case 33:S(D,l);break;case 34:f(D,l);break;case 31:S(I,l);break;case 32:f(I,l);break}let E=0;D.forEach(l=>E+=l);function b(l){const g=[];return l.forEach((w,d)=>g.push([d,w])),g}return{amdLoad:b(A),amdInvoke:b(L),nodeRequire:b(D),nodeEval:b(I),nodeRequireTotal:E}}static toMarkdownTable(A,L){let D="";const I=[];return A.forEach((S,f)=>{I[f]=S.length}),L.forEach(S=>{S.forEach((f,P)=>{typeof f>"u"&&(f=S[P]="-");const E=f.toString().length;I[P]=Math.max(E,I[P])})}),A.forEach((S,f)=>{D+=`| ${S+" ".repeat(I[f]-S.toString().length)} `}),D+=`|
`,A.forEach((S,f)=>{D+=`| ${"-".repeat(I[f])} `}),D+=`|
`,L.forEach(S=>{S.forEach((f,P)=>{typeof f<"u"&&(D+=`| ${f+" ".repeat(I[P]-f.toString().length)} `)}),D+=`|
`}),D}}e.$S=O}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function O(w,d,h){const o=N(w,d);if(o!==-1)return w[o]}e.$db=O;function N(w,d,h=w.length-1){for(let o=h;o>=0;o--){const $=w[o];if(d($))return o}return-1}e.$eb=N;function A(w,d){const h=L(w,d);return h===-1?void 0:w[h]}e.$fb=A;function L(w,d,h=0,o=w.length){let $=h,y=o;for(;$<y;){const C=Math.floor(($+y)/2);d(w[C])?$=C+1:y=C}return $-1}e.$gb=L;function D(w,d){const h=I(w,d);return h===w.length?void 0:w[h]}e.$hb=D;function I(w,d,h=0,o=w.length){let $=h,y=o;for(;$<y;){const C=Math.floor(($+y)/2);d(w[C])?y=C:$=C+1}return $}e.$ib=I;function S(w,d,h=0,o=w.length){const $=I(w,d,h,o);return $===w.length?-1:$}e.$jb=S;class f{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(f.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!d(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const h=L(this.e,d,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$kb=f;function P(w,d){if(w.length===0)return;let h=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,h)>0&&(h=$)}return h}e.$lb=P;function E(w,d){if(w.length===0)return;let h=w[0];for(let o=1;o<w.length;o++){const $=w[o];d($,h)>=0&&(h=$)}return h}e.$mb=E;function b(w,d){return P(w,(h,o)=>-d(h,o))}e.$nb=b;function l(w,d){if(w.length===0)return-1;let h=0;for(let o=1;o<w.length;o++){const $=w[o];d($,w[h])>0&&(h=o)}return h}e.$ob=l;function g(w,d){for(const h of w){const o=d(h);if(o!==void 0)return o}}e.$pb=g}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function O(D,I){const S=Object.create(null);for(const f of D){const P=I(f);let E=S[P];E||(E=S[P]=[]),E.push(f)}return S}e.$I=O;function N(D,I){const S=[],f=[];for(const P of D)I.has(P)||S.push(P);for(const P of I)D.has(P)||f.push(P);return{removed:S,added:f}}e.$J=N;function A(D,I){const S=[],f=[];for(const[P,E]of D)I.has(P)||S.push(E);for(const[P,E]of I)D.has(P)||f.push(E);return{removed:S,added:f}}e.$K=A;class L{constructor(){this.a=new Map}add(I,S){let f=this.a.get(I);f||(f=new Set,this.a.set(I,f)),f.add(S)}delete(I,S){const f=this.a.get(I);f&&(f.delete(S),f.size===0&&this.a.delete(I))}forEach(I,S){const f=this.a.get(I);f&&f.forEach(S)}get(I){const S=this.a.get(I);return S||new Set}}e.$L=L}),define(oe[83],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function O(D){return(I,S,f)=>{let P=null,E=null;if(typeof f.value=="function"?(P="value",E=f.value):typeof f.get=="function"&&(P="get",E=f.get),!E)throw new Error("not supported");f[P]=D(E,S)}}function N(D,I,S){let f=null,P=null;if(typeof S.value=="function"?(f="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(f="get",P=S.get),!P)throw new Error("not supported");const E=`$memoize$${I}`;S[f]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,b)}),this[E]}}e.$6g=N;function A(D,I,S){return O((f,P)=>{const E=`$debounce$${P}`,b=`$debounce$result$${P}`;return function(...l){this[b]||(this[b]=S?S():void 0),clearTimeout(this[E]),I&&(this[b]=I(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{f.apply(this,l),this[b]=S?S():void 0},D)}})}e.$7g=A;function L(D,I,S){return O((f,P)=>{const E=`$throttle$timer$${P}`,b=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...w){if(this[b]||(this[b]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[b]=I(this[b],...w)),this[g])return;const d=this[l]+D;d<=Date.now()?(this[l]=Date.now(),f.apply(this,[this[b]]),this[b]=S?S():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),f.apply(this,[this[b]]),this[b]=S?S():void 0},d-Date.now()))}})}e.$8g=L}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class O{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=O,e.$V=new O;function N(C){e.$V.setUnexpectedErrorHandler(C)}e.setUnexpectedErrorHandler=N;function A(C){if(!C||typeof C!="object")return!1;const t=C;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=A;function L(C){f(C)||e.$V.onUnexpectedError(C)}e.$Y=L;function D(C){f(C)||e.$V.onUnexpectedExternalError(C)}e.$Z=D;function I(C){if(C instanceof Error){const{name:t,message:c}=C,n=C.stacktrace||C.stack;return{$isError:!0,name:t,message:c,stack:n,noTelemetry:$.isErrorNoTelemetry(C)}}return C}e.$1=I;const S="Canceled";function f(C){return C instanceof P?!0:C instanceof Error&&C.name===S&&C.message===S}e.$2=f;class P extends Error{constructor(){super(S),this.name=this.message}}e.$3=P;function E(){const C=new Error(S);return C.name=C.message,C}e.$4=E;function b(C){return C?new Error(`Illegal argument: ${C}`):new Error("Illegal argument")}e.$5=b;function l(C){return C?new Error(`Illegal state: ${C}`):new Error("Illegal state")}e.$6=l;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=g;function w(C){return C?C.message?C.message:C.stack?C.stack.split(`
`)[0]:String(C):"Error"}e.$8=w;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=d;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=h;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=o;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const c=new $;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=$;class y extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$ab=y}),define(oe[18],ae([0,1,8,125]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function A(M,J=0){return M[M.length-(1+J)]}e.$qb=A;function L(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$rb=L;function D(M,J,Z=(se,le)=>se===le){if(M===J)return!0;if(!M||!J||M.length!==J.length)return!1;for(let se=0,le=M.length;se<le;se++)if(!Z(M[se],J[se]))return!1;return!0}e.$sb=D;function I(M,J){const Z=M.length-1;J<Z&&(M[J]=M[Z]),M.pop()}e.$tb=I;function S(M,J,Z){return f(M.length,se=>Z(M[se],J))}e.$ub=S;function f(M,J){let Z=0,se=M-1;for(;Z<=se;){const le=(Z+se)/2|0,ue=J(le);if(ue<0)Z=le+1;else if(ue>0)se=le-1;else return le}return-(Z+1)}e.$vb=f;function P(M,J,Z){if(M=M|0,M>=J.length)throw new TypeError("invalid index");const se=J[Math.floor(J.length*Math.random())],le=[],ue=[],he=[];for(const $e of J){const de=Z($e,se);de<0?le.push($e):de>0?ue.push($e):he.push($e)}return M<le.length?P(M,le,Z):M<le.length+he.length?he[0]:P(M-(le.length+he.length),ue,Z)}e.$wb=P;function E(M,J){const Z=[];let se;for(const le of M.slice(0).sort(J))!se||J(se[0],le)!==0?(se=[le],Z.push(se)):se.push(le);return Z}e.$xb=E;function*b(M,J){let Z,se;for(const le of M)se!==void 0&&J(se,le)?Z.push(le):(Z&&(yield Z),Z=[le]),se=le;Z&&(yield Z)}e.$yb=b;function l(M,J){for(let Z=0;Z<=M.length;Z++)J(Z===0?void 0:M[Z-1],Z===M.length?void 0:M[Z])}e.$zb=l;function g(M,J){for(let Z=0;Z<M.length;Z++)J(Z===0?void 0:M[Z-1],M[Z],Z+1===M.length?void 0:M[Z+1])}e.$Ab=g;function w(M,J,Z){const se=[];function le($e,de,we){if(de===0&&we.length===0)return;const ve=se[se.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=de,ve.toInsert.push(...we)):se.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===M.length){le(ue,0,J.slice(he));break}if(he===J.length){le(ue,M.length-ue,[]);break}const $e=M[ue],de=J[he],we=Z($e,de);we===0?(ue+=1,he+=1):we<0?(le(ue,1,[]),ue+=1):we>0&&(le(ue,0,[de]),he+=1)}return se}e.$Bb=w;function d(M,J,Z){const se=w(M,J,Z),le=[],ue=[];for(const he of se)le.push(...M.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:le,added:ue}}e.$Cb=d;function h(M,J,Z){if(Z===0)return[];const se=M.slice(0,Z).sort(J);return $(M,J,se,Z,M.length),se}e.top=h;function o(M,J,Z,se,le){return Z===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=M.length,de=M.slice(0,Z).sort(J);for(let we=Z,ve=Math.min(Z+se,$e);we<$e;we=ve,ve=Math.min(ve+se,$e)){if(we>Z&&await new Promise(Ie=>setTimeout(Ie)),le&&le.isCancellationRequested)throw new O.$3;$(M,J,de,we,ve)}return de})().then(ue,he)})}e.$Eb=o;function $(M,J,Z,se,le){for(const ue=Z.length;se<le;se++){const he=M[se];if(J(he,Z[ue-1])<0){Z.pop();const $e=(0,N.$ib)(Z,de=>J(he,de)<0);Z.splice($e,0,he)}}}function y(M){return M.filter(J=>!!J)}e.$Fb=y;function C(M){let J=0;for(let Z=0;Z<M.length;Z++)M[Z]&&(M[J]=M[Z],J+=1);M.length=J}e.$Gb=C;function t(M,J,Z){M.splice(Z,0,M.splice(J,1)[0])}e.$Hb=t;function c(M){return!Array.isArray(M)||M.length===0}e.$Ib=c;function n(M){return Array.isArray(M)&&M.length>0}e.$Jb=n;function s(M,J=Z=>Z){const Z=new Set;return M.filter(se=>{const le=J(se);return Z.has(le)?!1:(Z.add(le),!0)})}e.$Kb=s;function i(M){const J=new Set;return Z=>{const se=M(Z);return J.has(se)?!1:(J.add(se),!0)}}e.$Lb=i;function r(M,J){return M.length>0?M[0]:J}e.$Mb=r;function a(M,J){return M.length>0?M[M.length-1]:J}e.$Nb=a;function p(M,J,Z=(se,le)=>se===le){let se=0;for(let le=0,ue=Math.min(M.length,J.length);le<ue&&Z(M[le],J[le]);le++)se++;return se}e.$Ob=p;function m(M){return[].concat(...M)}e.$Pb=m;function u(M,J){let Z=typeof J=="number"?M:0;typeof J=="number"?Z=M:(Z=0,J=M);const se=[];if(Z<=J)for(let le=Z;le<J;le++)se.push(le);else for(let le=Z;le>J;le--)se.push(le);return se}e.$Qb=u;function v(M,J,Z){return M.reduce((se,le)=>(se[J(le)]=Z?Z(le):le,se),Object.create(null))}e.$Rb=v;function j(M,J){return M.push(J),()=>F(M,J)}e.$Sb=j;function F(M,J){const Z=M.indexOf(J);if(Z>-1)return M.splice(Z,1),J}e.$Tb=F;function T(M,J,Z){const se=M.slice(0,J),le=M.slice(J);return se.concat(Z,le)}e.$Ub=T;function z(M,J){let Z;if(typeof J=="number"){let se=J;Z=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let se=M.length-1;se>0;se-=1){const le=Math.floor(Z()*(se+1)),ue=M[se];M[se]=M[le],M[le]=ue}}e.$Vb=z;function U(M,J){const Z=M.indexOf(J);Z>-1&&(M.splice(Z,1),M.unshift(J))}e.$Wb=U;function _(M,J){const Z=M.indexOf(J);Z>-1&&(M.splice(Z,1),M.push(J))}e.$Xb=_;function K(M,J){for(const Z of J)M.push(Z)}e.$Yb=K;function X(M,J){return Array.isArray(M)?M.map(J):J(M)}e.$Zb=X;function H(M){return Array.isArray(M)?M:[M]}e.$1b=H;function x(M){return M[Math.floor(Math.random()*M.length)]}e.$2b=x;function G(M,J,Z){const se=W(M,J),le=M.length,ue=Z.length;M.length=le+ue;for(let he=le-1;he>=se;he--)M[he+ue]=M[he];for(let he=0;he<ue;he++)M[he+se]=Z[he]}e.$3b=G;function V(M,J,Z,se){const le=W(M,J);let ue=M.splice(le,Z);return ue===void 0&&(ue=[]),G(M,le,se),ue}e.$4b=V;function W(M,J){return J<0?Math.max(J+M.length,0):Math.min(J,M.length)}var ee;(function(M){function J(ue){return ue<0}M.isLessThan=J;function Z(ue){return ue<=0}M.isLessThanOrEqual=Z;function se(ue){return ue>0}M.isGreaterThan=se;function le(ue){return ue===0}M.isNeitherLessOrGreaterThan=le,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(M,J){return(Z,se)=>J(M(Z),M(se))}e.$5b=ne;function re(...M){return(J,Z)=>{for(const se of M){const le=se(J,Z);if(!ee.isNeitherLessOrGreaterThan(le))return le}return ee.neitherLessOrGreaterThan}}e.$6b=re;const Q=(M,J)=>M-J;e.$7b=Q;const q=(M,J)=>(0,e.$7b)(M?1:0,J?1:0);e.$8b=q;function k(M){return(J,Z)=>-M(J,Z)}e.$9b=k;class R{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let Z=this.c;for(;Z<this.g.length&&J(this.g[Z]);)Z++;const se=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,se}takeFromEndWhile(J){let Z=this.d;for(;Z>=0&&J(this.g[Z]);)Z--;const se=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,se}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const Z=this.g.slice(this.c,this.c+J);return this.c+=J,Z}}e.$0b=R;class B{static{this.empty=new B(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(Z=>(J(Z),!0))}toArray(){const J=[];return this.iterate(Z=>(J.push(Z),!0)),J}filter(J){return new B(Z=>this.iterate(se=>J(se)?Z(se):!0))}map(J){return new B(Z=>this.iterate(se=>Z(J(se))))}some(J){let Z=!1;return this.iterate(se=>(Z=J(se),!Z)),Z}findFirst(J){let Z;return this.iterate(se=>J(se)?(Z=se,!1):!0),Z}findLast(J){let Z;return this.iterate(se=>(J(se)&&(Z=se),!0)),Z}findLastMaxBy(J){let Z,se=!0;return this.iterate(le=>((se||ee.isGreaterThan(J(le,Z)))&&(se=!1,Z=le),!0)),Z}}e.$$b=B}),define(oe[127],ae([0,1,8]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function N(S,f){if(!S)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}e.ok=N;function A(S,f="Unreachable"){throw new Error(f)}e.$vc=A;function L(S){if(!S)throw new O.$ab("Assertion Failed")}e.$wc=L;function D(S){if(!S()){debugger;S(),(0,O.$Y)(new O.$ab("Assertion Failed"))}}e.$xc=D;function I(S,f){let P=0;for(;P<S.length-1;){const E=S[P],b=S[P+1];if(!f(E,b))return!1;P++}return!0}e.$yc=I}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function O(N){const A=this;let L=!1,D;return function(){return L||(L=!0,D=N.apply(A,arguments)),D}}e.$bb=O}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(N){function A(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}N.is=A;const L=Object.freeze([]);function D(){return L}N.empty=D;function*I(C){yield C}N.single=I;function S(C){return A(C)?C:I(C)}N.wrap=S;function f(C){return C||L}N.from=f;function*P(C){for(let t=C.length-1;t>=0;t--)yield C[t]}N.reverse=P;function E(C){return!C||C[Symbol.iterator]().next().done===!0}N.isEmpty=E;function b(C){return C[Symbol.iterator]().next().value}N.first=b;function l(C,t){for(const c of C)if(t(c))return!0;return!1}N.some=l;function g(C,t){for(const c of C)if(t(c))return c}N.find=g;function*w(C,t){for(const c of C)t(c)&&(yield c)}N.filter=w;function*d(C,t){let c=0;for(const n of C)yield t(n,c++)}N.map=d;function*h(...C){for(const t of C)for(const c of t)yield c}N.concat=h;function o(C,t,c){let n=c;for(const s of C)n=t(n,s);return n}N.reduce=o;function*$(C,t,c=C.length){for(t<0&&(t+=C.length),c<0?c+=C.length:c>C.length&&(c=C.length);t<c;t++)yield C[t]}N.slice=$;function y(C,t=Number.POSITIVE_INFINITY){const c=[];if(t===0)return[c,C];const n=C[Symbol.iterator]();for(let s=0;s<t;s++){const i=n.next();if(i.done)return[c,N.empty()];c.push(i.value)}return[c,{[Symbol.iterator](){return n}}]}N.consume=y})(O||(e.Iterable=O={}))}),define(oe[34],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function D(t,c=!1){let n=0;const s=t.length;let i="",r=0,a=16,p=0;function m(U){let _=0,K=0;for(;_<U;){const X=t.charCodeAt(n);if(X>=48&&X<=57)K=K*16+X-48;else if(X>=65&&X<=70)K=K*16+X-65+10;else if(X>=97&&X<=102)K=K*16+X-97+10;else break;n++,_++}return _<U&&(K=-1),K}function u(U){n=U,i="",r=0,a=16,p=0}function v(){const U=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return p=3,t.substring(U,n);let _=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;_=n}else p=3;return t.substring(U,_)}function j(){let U="",_=n;for(;;){if(n>=s){U+=t.substring(_,n),p=2;break}const K=t.charCodeAt(n);if(K===34){U+=t.substring(_,n),n++;break}if(K===92){if(U+=t.substring(_,n),n++,n>=s){p=2;break}switch(t.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const H=m(4);H>=0?U+=String.fromCharCode(H):p=4;break}default:p=5}_=n;continue}if(K>=0&&K<=31)if(S(K)){U+=t.substring(_,n),p=2;break}else p=6;n++}return U}function F(){if(i="",p=0,r=n,n>=s)return r=s,a=17;let U=t.charCodeAt(n);if(I(U)){do n++,i+=String.fromCharCode(U),U=t.charCodeAt(n);while(I(U));return a=15}if(S(U))return n++,i+=String.fromCharCode(U),U===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=j(),a=10;case 47:{const _=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(t.charCodeAt(n));)n++;return i=t.substring(_,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const K=s-1;let X=!1;for(;n<K;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,p=1),i=t.substring(_,n),a=13}return i+=String.fromCharCode(U),n++,a=16}case 45:if(i+=String.fromCharCode(U),n++,n===s||!f(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=v(),a=11;default:for(;n<s&&T(U);)n++,U=t.charCodeAt(n);if(r!==n){switch(i=t.substring(r,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(U),n++,a=16}}function T(U){if(I(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:u,getPosition:()=>n,scan:c?z:F,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>p}}e.$Jm=D;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,c){const n=[],s=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function p(m,u,v,j){r.value=m,r.offset=u,r.length=v,r.type=j,r.colonOffset=void 0,i=r}try{$(t,{onObjectBegin:(m,u)=>{if(c<=m)throw s;i=void 0,a=c>m,n.push("")},onObjectProperty:(m,u,v)=>{if(c<u||(p(m,u,v,"property"),n[n.length-1]=m,c<=u+v))throw s},onObjectEnd:(m,u)=>{if(c<=m)throw s;i=void 0,n.pop()},onArrayBegin:(m,u)=>{if(c<=m)throw s;i=void 0,n.push(0)},onArrayEnd:(m,u)=>{if(c<=m)throw s;i=void 0,n.pop()},onLiteralValue:(m,u,v)=>{if(c<u||(p(m,u,v,C(m)),c<=u+v))throw s},onSeparator:(m,u,v)=>{if(c<=u)throw s;if(m===":"&&i&&i.type==="property")i.colonOffset=u,a=!1,i=void 0;else if(m===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(m){if(m!==s)throw m}return{path:n,previousNode:i,isAtPropertyKey:a,matches:m=>{let u=0;for(let v=0;u<m.length&&v<n.length;v++)if(m[u]===n[v]||m[u]==="*")u++;else if(m[u]!=="**")return!1;return u===m.length}}}e.$Km=E;function b(t,c=[],n=L.DEFAULT){let s=null,i=[];const r=[];function a(m){Array.isArray(i)?i.push(m):s!==null&&(i[s]=m)}return $(t,{onObjectBegin:()=>{const m={};a(m),r.push(i),i=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const m=[];a(m),r.push(i),i=m,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(m,u,v)=>{c.push({error:m,offset:u,length:v})}},n),i[0]}e.$Lm=b;function l(t,c=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function r(m){return s.children.push(m),m}$(t,{onObjectBegin:m=>{s=r({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,u,v)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:u,length:v,parent:s})},onObjectEnd:(m,u)=>{s.length=m+u-s.offset,s=s.parent,i(m+u)},onArrayBegin:(m,u)=>{s=r({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,u)=>{s.length=m+u-s.offset,s=s.parent,i(m+u)},onLiteralValue:(m,u,v)=>{r({type:C(m),offset:u,length:v,parent:s,value:m}),i(u+v)},onSeparator:(m,u,v)=>{s.type==="property"&&(m===":"?s.colonOffset=u:m===","&&i(u))},onError:(m,u,v)=>{c.push({error:m,offset:u,length:v})}},n);const p=s.children[0];return p&&delete p.parent,p}e.$Mm=l;function g(t,c){if(!t)return;let n=t;for(const s of c)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.$Nm=g;function w(t){if(!t.parent||!t.parent.children)return[];const c=w(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;c.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&c.push(n)}return c}e.$Om=w;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const c=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(c[n.children[0].value]=d(s))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=d;function h(t,c,n=!1){return c>=t.offset&&c<t.offset+t.length||n&&c===t.offset+t.length}e.$Qm=h;function o(t,c,n=!1){if(h(t,c,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=c;i++){const r=o(s[i],c,n);if(r)return r}return t}}e.$Rm=o;function $(t,c,n=L.DEFAULT){const s=D(t,!1);function i(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?re=>ne(re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(c.onObjectBegin),p=r(c.onObjectProperty),m=i(c.onObjectEnd),u=i(c.onArrayBegin),v=i(c.onArrayEnd),j=r(c.onLiteralValue),F=r(c.onSeparator),T=i(c.onComment),z=r(c.onError),U=n&&n.disallowComments,_=n&&n.allowTrailingComma;function K(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:U||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ne){case 12:case 13:U?X(10):T();break;case 16:X(1);break;case 15:case 14:break;default:return ne}}}function X(ne,re=[],Q=[]){if(z(ne),re.length+Q.length>0){let q=s.getToken();for(;q!==17;){if(re.indexOf(q)!==-1){K();break}else if(Q.indexOf(q)!==-1)break;q=K()}}}function H(ne){const re=s.getTokenValue();return ne?j(re):p(re),K(),!0}function x(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(X(2),ne=0)}catch{X(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return K(),!0}function G(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(F(":"),K(),ee()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){a(),K();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||X(4,[],[]),F(","),K(),s.getToken()===2&&_)break}else ne&&X(6,[],[]);G()||X(4,[],[2,5]),ne=!0}return m(),s.getToken()!==2?X(7,[2],[]):K(),!0}function W(){u(),K();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||X(4,[],[]),F(","),K(),s.getToken()===4&&_)break}else ne&&X(6,[],[]);ee()||X(4,[],[4,5]),ne=!0}return v(),s.getToken()!==4?X(8,[4],[]):K(),!0}function ee(){switch(s.getToken()){case 3:return W();case 1:return V();case 10:return H(!0);default:return x()}}return K(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):ee()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$Sm=$;function y(t,c){const n=D(t),s=[];let i,r=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:r!==a&&s.push(t.substring(r,a)),c!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,c)),r=n.getPosition();break}while(i!==17);return s.join("")}e.$Tm=y;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=C}),define(oe[41],ae([0,1,34]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=e.$ES=e.$DS=e.$CS=void 0;function N(f,P,E){let b,l,g,w,d;if(P){for(w=P.offset,d=w+P.length,g=w;g>0&&!S(f,g-1);)g--;let a=d;for(;a<f.length&&!S(f,a);)a++;l=f.substring(g,a),b=D(l,E)}else l=f,b=0,g=0,w=0,d=f.length;const h=I(E,f);let o=!1,$=0,y;E.insertSpaces?y=L(" ",E.tabSize||4):y="	";const C=(0,O.$Jm)(l,!1);let t=!1;function c(){return h+L(y,b+$)}function n(){let a=C.scan();for(o=!1;a===15||a===14;)o=o||a===14,a=C.scan();return t=a===16||C.getTokenError()!==0,a}const s=[];function i(a,p,m){!t&&p<d&&m>w&&f.substring(p,m)!==a&&s.push({offset:p,length:m-p,content:a})}let r=n();if(r!==17){const a=C.getTokenOffset()+g,p=L(y,b);i(p,g,a)}for(;r!==17;){let a=C.getTokenOffset()+C.getTokenLength()+g,p=n(),m="";for(;!o&&(p===12||p===13);){const v=C.getTokenOffset()+g;i(" ",a,v),a=C.getTokenOffset()+C.getTokenLength()+g,m=p===12?c():"",p=n()}if(p===2)r!==1&&($--,m=c());else if(p===4)r!==3&&($--,m=c());else{switch(r){case 3:case 1:$++,m=c();break;case 5:case 12:m=c();break;case 13:o?m=c():m=" ";break;case 6:m=" ";break;case 10:if(p===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?m=" ":p!==5&&p!==17&&(t=!0);break;case 16:t=!0;break}o&&(p===12||p===13)&&(m=c())}const u=C.getTokenOffset()+g;i(m,a,u),r=p}return s}e.$CS=N;function A(f,P){const E=JSON.stringify(f,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$DS=A;function L(f,P){let E="";for(let b=0;b<P;b++)E+=f;return E}function D(f,P){let E=0,b=0;const l=P.tabSize||4;for(;E<f.length;){const g=f.charAt(E);if(g===" ")b++;else if(g==="	")b+=l;else break;E++}return Math.floor(b/l)}function I(f,P){for(let E=0;E<P.length;E++){const b=P.charAt(E);if(b==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return f&&f.eol||`
`}e.$ES=I;function S(f,P){return`\r
`.indexOf(f.charAt(P))!==-1}e.$FS=S}),define(oe[85],ae([0,1,34,41]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KS=e.$JS=e.$IS=e.$HS=e.$GS=void 0;function A(f,P,E){return L(f,P,void 0,E)}e.$GS=A;function L(f,P,E,b,l){const g=P.slice(),w=[],d=(0,O.$Mm)(f,w);let h,o;for(;g.length>0&&(o=g.pop(),h=(0,O.$Nm)(d,g),h===void 0&&E!==void 0);)typeof o=="string"?E={[o]:E}:E=[E];if(h)if(h.type==="object"&&typeof o=="string"&&Array.isArray(h.children)){const $=(0,O.$Nm)(h,[o]);if($!==void 0)if(E===void 0){if(!$.parent)throw new Error("Malformed AST");const y=h.children.indexOf($.parent);let C,t=$.parent.offset+$.parent.length;if(y>0){const c=h.children[y-1];C=c.offset+c.length}else C=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return D(f,{offset:C,length:t-C,content:""},b)}else return D(f,{offset:$.offset,length:$.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const y=`${JSON.stringify(o)}: ${JSON.stringify(E)}`,C=l?l(h.children.map(c=>c.children[0].value)):h.children.length;let t;if(C>0){const c=h.children[C-1];t={offset:c.offset+c.length,length:0,content:","+y}}else h.children.length===0?t={offset:h.offset+1,length:0,content:y}:t={offset:h.offset+1,length:0,content:y+","};return D(f,t,b)}}else if(h.type==="array"&&typeof o=="number"&&Array.isArray(h.children))if(E!==void 0){const $=`${JSON.stringify(E)}`;let y;if(h.children.length===0||o===0)y={offset:h.offset+1,length:0,content:h.children.length===0?$:$+","};else{const C=o===-1||o>h.children.length?h.children.length:o,t=h.children[C-1];y={offset:t.offset+t.length,length:0,content:","+$}}return D(f,y,b)}else{const $=o,y=h.children[$];let C;if(h.children.length===1)C={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===$){const t=h.children[$-1],c=t.offset+t.length,n=h.offset+h.length;C={offset:c,length:n-2-c,content:""}}else C={offset:y.offset,length:h.children[$+1].offset-y.offset,content:""};return D(f,C,b)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(f,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(E)},b)}}e.$HS=L;function D(f,P,E){let b=I(f,P),l=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,N.$FS)(b,l-1);)l--;for(;g<b.length&&!(0,N.$FS)(b,g);)g++}const w=(0,N.$CS)(b,{offset:l,length:g-l},E);for(let h=w.length-1;h>=0;h--){const o=w[h];b=I(b,o),l=Math.min(l,o.offset),g=Math.max(g,o.offset+o.length),g+=o.content.length-o.length}const d=f.length-(b.length-g)-l;return[{offset:l,length:d,content:b.substring(l,g)}]}e.$IS=D;function I(f,P){return f.substring(0,P.offset)+P.content+f.substring(P.offset+P.length)}e.$JS=I;function S(f,P){const E=P.slice(0).sort((l,g)=>{const w=l.offset-g.offset;return w===0?l.length-g.length:w});let b=f.length;for(let l=E.length-1;l>=0;l--){const g=E[l];if(g.offset+g.length<=b)f=I(f,g);else throw new Error("Overlapping edit");b=g.offset}return f}e.$KS=S}),define(oe[86],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class O{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=O}),define(oe[2],ae([0,1,18,126,84,59]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const D=!1;let I=null;class S{constructor(){this.b=new Map}static{this.a=0}c(u){let v=this.b.get(u);return v||(v={parent:null,source:null,isSingleton:!1,value:u,idx:S.a++},this.b.set(u,v)),v}trackDisposable(u){const v=this.c(u);v.source||(v.source=new Error().stack)}setParent(u,v){const j=this.c(u);j.parent=v}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,v){const j=v.get(u);if(j)return j;const F=u.parent?this.f(this.c(u.parent),v):u;return v.set(u,F),F}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,u).isSingleton).map(([j])=>j).flat()}computeLeakingDisposables(u=10,v){let j;if(v)j=v;else{const _=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,_).isSingleton);if(K.length===0)return;const X=new Set(K.map(H=>H.value));if(j=K.filter(H=>!(H.parent&&X.has(H.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function F(_){function K(H,x){for(;H.length>0&&x.some(G=>typeof G=="string"?G===H[0]:H[0].match(G));)H.shift()}const X=_.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const T=new N.$L;for(const _ of j){const K=F(_);for(let X=0;X<=K.length;X++)T.add(K.slice(0,X).join(`
`),_)}j.sort((0,O.$5b)(_=>_.idx,O.$7b));let z="",U=0;for(const _ of j.slice(0,u)){U++;const K=F(_),X=[];for(let H=0;H<K.length;H++){let x=K[H];x=`(shared with ${T.get(K.slice(0,H+1).join(`
`)).size}/${j.length} leaks) at ${x}`;const V=T.get(K.slice(0,H).join(`
`)),W=(0,N.$I)([...V].map(ee=>F(ee)[H]),ee=>ee);delete W[K[H]];for(const[ee,ne]of Object.entries(W))X.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ee}`);X.unshift(x)}z+=`


==================== Leaking disposable ${U}/${j.length}: ${_.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return j.length>u&&(z+=`


... and ${j.length-u} more leaking disposables

`),{leaks:j,details:z}}}e.$_b=S;function f(m){I=m}if(e.$ac=f,D){const m="__is_disposable_tracked__";f(new class{trackDisposable(u){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[m]||console.log(v)},3e3)}setParent(u,v){if(u&&u!==C.None)try{u[m]=!0}catch{}}markAsDisposed(u){if(u&&u!==C.None)try{u[m]=!0}catch{}}markAsSingleton(u){}})}function P(m){return I?.trackDisposable(m),m}e.$bc=P;function E(m){I?.markAsDisposed(m)}e.$cc=E;function b(m,u){I?.setParent(m,u)}function l(m,u){if(I)for(const v of m)I.setParent(v,u)}function g(m){return I?.markAsSingleton(m),m}e.$dc=g;function w(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.$ec=w;function d(m){if(L.Iterable.is(m)){const u=[];for(const v of m)if(v)try{v.dispose()}catch(j){u.push(j)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.$fc=d;function h(m){for(const u of m)w(u)&&u.dispose();return[]}e.$gc=h;function o(...m){const u=$(()=>d(m));return l(m,u),u}e.$hc=o;function $(m){const u=P({dispose:(0,A.$bb)(()=>{E(u),m()})});return u}e.$ic=$;class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return b(u,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}delete(u){if(u){if(u===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(u),u.dispose()}}deleteAndLeak(u){u&&this.f.has(u)&&(this.f.delete(u),b(u,null))}}e.$jc=y;class C{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new y,P(this),b(this.q,this)}dispose(){E(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$kc=C;class t{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&b(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&b(u,null),u}}e.$lc=t;class c{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=c;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let v=u;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,E(this))},this}}e.$nc=n;class s{constructor(){this.a=new Map}acquire(u,...v){let j=this.a.get(u);j||(j={counter:0,object:this.b(u,...v)},this.a.set(u,j));const{object:F}=j,T=(0,A.$bb)(()=>{--j.counter===0&&(this.c(u,j.object),this.a.delete(u))});return j.counter++,{object:F,dispose:T}}}e.$oc=s;class i{constructor(u){this.a=u}async acquire(u,...v){const j=this.a.acquire(u,...v);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(F){throw j.dispose(),F}}}e.$pc=i;class r{constructor(u){this.object=u}dispose(){}}e.$qc=r;function a(m){const u=new y;try{m(u)}finally{u.dispose()}}e.$rc=a;class p{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,v,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(u)?.dispose(),this.a.set(u,v)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=p}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class N{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const D=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=D}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,D){const I=new O(L);if(this.a===O.Undefined)this.a=I,this.b=I;else if(D){const f=this.b;this.b=I,I.prev=f,f.next=I}else{const f=this.a;this.a=I,I.next=f,f.prev=I}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(I))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const D=L.prev;D.next=L.next,L.next.prev=D}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$tc=N}),define(oe[35],ae([0,1]),function(te,e){"use strict";var O,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function L(h,o,$){let y=h.get(o);return y===void 0&&(y=$,h.set(o,y)),y}e.$wi=L;function D(h){const o=[];return h.forEach(($,y)=>{o.push(`${y} => ${$}`)}),`Map(${h.size}) {${o.join(", ")}}`}e.$xi=D;function I(h){const o=[];return h.forEach($=>{o.push($)}),`Set(${h.size}) {${o.join(", ")}}`}e.$yi=I;class S{constructor(o,$){this.uri=o,this.value=$}}function f(h){return Array.isArray(h)}class P{static{this.a=o=>o.toString()}constructor(o,$){if(this[O]="ResourceMap",o instanceof P)this.b=new Map(o.b),this.c=$??P.a;else if(f(o)){this.b=new Map,this.c=$??P.a;for(const[y,C]of o)this.set(y,C)}else this.b=new Map,this.c=o??P.a}set(o,$){return this.b.set(this.c(o),new S(o,$)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,$){typeof $<"u"&&(o=o.bind($));for(const[y,C]of this.b)o(C.value,C.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zi=P;class E{constructor(o,$){this[N]="ResourceSet",!o||typeof o=="function"?this.a=new P(o):(this.a=new P($),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,$){this.a.forEach((y,C)=>o.call($,C,C,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=E;var b;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,$=0){const y=this.a.get(o);if(y)return $!==0&&this.j(y,$),y.value}set(o,$,y=0){let C=this.a.get(o);if(C)C.value=$,y!==0&&this.j(C,y);else{switch(C={key:o,value:$,next:void 0,previous:void 0},y){case 0:this.h(C);break;case 1:this.g(C);break;case 2:this.h(C);break;default:this.h(C);break}this.a.set(o,C),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const $=this.a.get(o);if($)return this.a.delete(o),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,$){const y=this.e;let C=this.b;for(;C;){if($?o.bind($)(C.value,C.key,this):o(C.value,C.key,this),this.e!==y)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const t={value:y.key,done:!1};return y=y.next,t}else return{value:void 0,done:!0}}};return C}values(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const t={value:y.value,done:!1};return y=y.next,t}else return{value:void 0,done:!0}}};return C}entries(){const o=this,$=this.e;let y=this.b;const C={[Symbol.iterator](){return C},next(){if(o.e!==$)throw new Error("LinkedMap got modified during iteration.");if(y){const t={value:[y.key,y.value],done:!1};return y=y.next,t}else return{value:void 0,done:!0}}};return C}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let $=this.b,y=this.size;for(;$&&y>o;)this.a.delete($.key),$=$.next,y--;this.b=$,this.d=y,$&&($.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const $=o.next,y=o.previous;if(!$||!y)throw new Error("Invalid list");$.previous=y,y.next=$}o.next=void 0,o.previous=void 0,this.e++}j(o,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(o===this.b)return;const y=o.next,C=o.previous;o===this.c?(C.next=void 0,this.c=C):(y.previous=C,C.next=y),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if($===2){if(o===this.c)return;const y=o.next,C=o.previous;o===this.b?(y.previous=void 0,this.b=y):(y.previous=C,C.next=y),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach(($,y)=>{o.push([y,$])}),o}fromJSON(o){this.clear();for(const[$,y]of o)this.set($,y)}}e.$Bi=l;class g extends l{constructor(o,$=1){super(),this.k=o,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,$=2){return super.get(o,$)}peek(o){return super.get(o,0)}set(o,$){return super.set(o,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=g;class w{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let $=this.a.get(o)||0;return $===0?!1:($--,$===0?this.a.delete(o):this.a.set(o,$),!0)}has(o){return this.a.has(o)}}e.$Di=w;class d{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[$,y]of o)this.set($,y)}clear(){this.a.clear(),this.b.clear()}set(o,$){this.a.set(o,$),this.b.set($,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const $=this.a.get(o);return $===void 0?!1:(this.a.delete(o),this.b.delete($),!0)}forEach(o,$){this.a.forEach((y,C)=>{o.call($,y,C,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=d}),define(oe[88],ae([0,1,35]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const N=new O.$Ci(1e4);function A(f){return S(f,"NFC",N)}e.$hl=A;const L=new O.$Ci(1e4);function D(f){return S(f,"NFD",L)}e.$il=D;const I=/[^\u0000-\u0080]/;function S(f,P,E){if(!f)return f;const b=E.get(f);if(b)return b;let l;return I.test(f)?l=f.normalize(P):l=f,E.set(f,l),l}e.$jl=function(){const f=/[\u0300-\u036f]/g;return function(P){return D(P).replace(f,"")}}()}),function(){function te(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function D(S){L.push(S,Date.now())}function I(){const S=[];for(let f=0;f<L.length;f+=2)S.push({name:L[f],startTime:L[f+1]});return S}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(A+D.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function O(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=O(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var N in O)(typeof exports=="object"?exports:te)[N]=O[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function O(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return te[N].call(A.exports,A,A.exports,O),A.l=!0,A.exports}return O.m=te,O.c=e,O.d=function(N,A,L){O.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:L})},O.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},O.t=function(N,A){if(1&A&&(N=O(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var D in N)O.d(L,D,function(I){return N[I]}.bind(null,D));return L},O.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return O.d(A,"a",A),A},O.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},O.p="",O(O.s=0)}([function(te,e,O){(function(N){var A;e=te.exports=Q,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],S=e.src=[],f=0,P=f++;S[P]="0|[1-9]\\d*";var E=f++;S[E]="[0-9]+";var b=f++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=f++;S[l]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var g=f++;S[g]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var w=f++;S[w]="(?:"+S[P]+"|"+S[b]+")";var d=f++;S[d]="(?:"+S[E]+"|"+S[b]+")";var h=f++;S[h]="(?:-("+S[w]+"(?:\\."+S[w]+")*))";var o=f++;S[o]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var $=f++;S[$]="[0-9A-Za-z-]+";var y=f++;S[y]="(?:\\+("+S[$]+"(?:\\."+S[$]+")*))";var C=f++,t="v?"+S[l]+S[h]+"?"+S[y]+"?";S[C]="^"+t+"$";var c="[v=\\s]*"+S[g]+S[o]+"?"+S[y]+"?",n=f++;S[n]="^"+c+"$";var s=f++;S[s]="((?:<|>)?=?)";var i=f++;S[i]=S[E]+"|x|X|\\*";var r=f++;S[r]=S[P]+"|x|X|\\*";var a=f++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[h]+")?"+S[y]+"?)?)?";var p=f++;S[p]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[o]+")?"+S[y]+"?)?)?";var m=f++;S[m]="^"+S[s]+"\\s*"+S[a]+"$";var u=f++;S[u]="^"+S[s]+"\\s*"+S[p]+"$";var v=f++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=f++;S[j]="(?:~>?)";var F=f++;S[F]="(\\s*)"+S[j]+"\\s+",I[F]=new RegExp(S[F],"g");var T=f++;S[T]="^"+S[j]+S[a]+"$";var z=f++;S[z]="^"+S[j]+S[p]+"$";var U=f++;S[U]="(?:\\^)";var _=f++;S[_]="(\\s*)"+S[U]+"\\s+",I[_]=new RegExp(S[_],"g");var K=f++;S[K]="^"+S[U]+S[a]+"$";var X=f++;S[X]="^"+S[U]+S[p]+"$";var H=f++;S[H]="^"+S[s]+"\\s*("+c+")$|^$";var x=f++;S[x]="^"+S[s]+"\\s*("+t+")$|^$";var G=f++;S[G]="(\\s*)"+S[s]+"\\s*("+c+"|"+S[a]+")",I[G]=new RegExp(S[G],"g");var V=f++;S[V]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var W=f++;S[W]="^\\s*("+S[p]+")\\s+-\\s+("+S[p]+")\\s*$";var ee=f++;S[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)A(ne,S[ne]),I[ne]||(I[ne]=new RegExp(S[ne]));function re(ce,ge){if(ce instanceof Q)return ce;if(typeof ce!="string"||ce.length>L||!(ge?I[n]:I[C]).test(ce))return null;try{return new Q(ce,ge)}catch{return null}}function Q(ce,ge){if(ce instanceof Q){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(ce,ge);A("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?I[n]:I[C]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<D)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(ce,ge){var be=re(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=re(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(ce){return A("SemVer.compare",this.version,this.loose,ce),ce instanceof Q||(ce=new Q(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Q.prototype.compareMain=function(ce){return ce instanceof Q||(ce=new Q(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},Q.prototype.comparePre=function(ce){if(ce instanceof Q||(ce=new Q(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=ce.prerelease[ge];if(A("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return k(be,Se)}while(++ge)},Q.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Q(ce,be).inc(ge,Se).version}catch{return null}},e.diff=function(ce,ge){if(J(ce,ge))return null;var be=re(ce),Se=re(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=k;var q=/^[0-9]+$/;function k(ce,ge){var be=q.test(ce),Se=q.test(ge);return be&&Se&&(ce=+ce,ge=+ge),be&&!Se?-1:Se&&!be?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,be){return new Q(ce,be).compare(new Q(ge,be))}function B(ce,ge,be){return R(ce,ge,be)>0}function M(ce,ge,be){return R(ce,ge,be)<0}function J(ce,ge,be){return R(ce,ge,be)===0}function Z(ce,ge,be){return R(ce,ge,be)!==0}function se(ce,ge,be){return R(ce,ge,be)>=0}function le(ce,ge,be){return R(ce,ge,be)<=0}function ue(ce,ge,be,Se){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=J(ce,be,Se);break;case"!=":Pe=Z(ce,be,Se);break;case">":Pe=B(ce,be,Se);break;case">=":Pe=se(ce,be,Se);break;case"<":Pe=M(ce,be,Se);break;case"<=":Pe=le(ce,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(ce,ge){if(ce instanceof he){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof he))return new he(ce,ge);A("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ce,ge){return k(ge,ce)},e.major=function(ce,ge){return new Q(ce,ge).major},e.minor=function(ce,ge){return new Q(ce,ge).minor},e.patch=function(ce,ge){return new Q(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,be){return R(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=B,e.lt=M,e.eq=J,e.neq=Z,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=he;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof he)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function ve(ce,ge,be,Se,Pe,ze,De,Be,Me,ie,fe,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(Be=we(Me)?"":we(ie)?"<"+(+Me+1)+".0.0":we(fe)?"<"+Me+"."+(+ie+1)+".0":me?"<="+Me+"."+ie+"."+fe+"-"+me:"<="+Be)).trim()}function Ie(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(A(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var Se=ce[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Le(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,Se){var Pe,ze,De,Be,Me;switch(ce=new Q(ce,Se),ge=new de(ge,Se),be){case">":Pe=B,ze=le,De=M,Be=">",Me=">=";break;case"<":Pe=M,ze=se,De=B,Be="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(ce,ge,Se))return!1;for(var ie=0;ie<ge.set.length;++ie){var fe=ge.set[ie],me=null,pe=null;if(fe.forEach(function(ke){ke.semver===$e&&(ke=new he(">=0.0.0")),me=me||ke,pe=pe||ke,Pe(ke.semver,me.semver,Se)?me=ke:De(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===Be||me.operator===Me||(!pe.operator||pe.operator===Be)&&ze(ce,pe.semver)||pe.operator===Me&&De(ce,pe.semver))return!1}return!0}he.prototype.parse=function(ce){var ge=this.loose?I[H]:I[x],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Q(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(ce){return A("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new Q(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ce,ge){if(!(ce instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Le(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Le(ce.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),ze=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Be=ue(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=ue(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Se||Pe||ze&&De||Be||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),A("range",ce,ge);var be=ge?I[W]:I[V];ce=ce.replace(be,ve),A("hyphen replace",ce),ce=ce.replace(I[G],"$1$2$3"),A("comparator trim",ce,I[G]),ce=(ce=(ce=ce.replace(I[F],"$1~")).replace(I[_],"$1^")).split(/\s+/).join(" ");var Se=ge?I[H]:I[x],Pe=ce.split(" ").map(function(ze){return function(De,Be){return A("comp",De),De=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){A("caret",me,pe);var ke=pe?I[X]:I[K];return me.replace(ke,function(Re,Ce,Oe,je,Ae){var Ne;return A("caret",me,Re,Ce,Oe,je,Ae),we(Ce)?Ne="":we(Oe)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(je)?Ne=Ce==="0"?">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+".0 <"+(+Ce+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+Oe+"."+(+je+1):">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+je+Ae+" <"+(+Ce+1)+".0.0"):(A("no pr"),Ne=Ce==="0"?Oe==="0"?">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+Oe+"."+(+je+1):">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+(+Oe+1)+".0":">="+Ce+"."+Oe+"."+je+" <"+(+Ce+1)+".0.0"),A("caret return",Ne),Ne})}(fe,ie)}).join(" ")}(De,Be),A("caret",De),De=function(Me,ie){return Me.trim().split(/\s+/).map(function(fe){return function(me,pe){var ke=pe?I[z]:I[T];return me.replace(ke,function(Re,Ce,Oe,je,Ae){var Ne;return A("tilde",me,Re,Ce,Oe,je,Ae),we(Ce)?Ne="":we(Oe)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(je)?Ne=">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=">="+Ce+"."+Oe+"."+je+Ae+" <"+Ce+"."+(+Oe+1)+".0"):Ne=">="+Ce+"."+Oe+"."+je+" <"+Ce+"."+(+Oe+1)+".0",A("tilde return",Ne),Ne})}(fe,ie)}).join(" ")}(De,Be),A("tildes",De),De=function(Me,ie){return A("replaceXRanges",Me,ie),Me.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var ke=pe?I[u]:I[m];return me.replace(ke,function(Re,Ce,Oe,je,Ae,Ne){A("xRange",me,Re,Ce,Oe,je,Ae,Ne);var qe=we(Oe),Ue=qe||we(je),Ve=Ue||we(Ae);return Ce==="="&&Ve&&(Ce=""),qe?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(Ue&&(je=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",Ue?(Oe=+Oe+1,je=0,Ae=0):Ve&&(je=+je+1,Ae=0)):Ce==="<="&&(Ce="<",Ue?Oe=+Oe+1:je=+je+1),Re=Ce+Oe+"."+je+"."+Ae):Ue?Re=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ve&&(Re=">="+Oe+"."+je+".0 <"+Oe+"."+(+je+1)+".0"),A("xRange return",Re),Re})}(fe,ie)}).join(" ")}(De,Be),A("xrange",De),De=function(Me,ie){return A("replaceStars",Me,ie),Me.trim().replace(I[ee],"")}(De,Be),A("stars",De),De}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(Se)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return ce.set.some(function(Pe){return Pe.every(function(ze){return Se.intersects(ze,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Q(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ce))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(De){ze.test(De)&&(Se&&Pe.compare(De)!==-1||(Pe=new Q(Se=De,be)))}),Se},e.minSatisfying=function(ce,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(De){ze.test(De)&&(Se&&Pe.compare(De)!==1||(Pe=new Q(Se=De,be)))}),Se},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=re(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof Q)return ce;if(typeof ce!="string")return null;var ge=ce.match(I[v]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(te,e){var O,N,A=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(d){if(O===setTimeout)return setTimeout(d,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(d,0);try{return O(d,0)}catch{try{return O.call(null,d,0)}catch{return O.call(this,d,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{N=typeof clearTimeout=="function"?clearTimeout:D}catch{N=D}})();var S,f=[],P=!1,E=-1;function b(){P&&S&&(P=!1,S.length?f=S.concat(f):E=-1,f.length&&l())}function l(){if(!P){var d=I(b);P=!0;for(var h=f.length;h;){for(S=f,f=[];++E<h;)S&&S[E].run();E=-1,h=f.length}S=null,P=!1,function(o){if(N===clearTimeout)return clearTimeout(o);if((N===D||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(o);try{N(o)}catch{try{return N.call(null,o)}catch{return N.call(this,o)}}}(d)}}function g(d,h){this.fun=d,this.array=h}function w(){}A.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var o=1;o<arguments.length;o++)h[o-1]=arguments[o];f.push(new g(d,h)),f.length!==1||P||I(l)},g.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=w,A.addListener=w,A.once=w,A.off=w,A.removeListener=w,A.removeAllListeners=w,A.emit=w,A.prependListener=w,A.prependOnceListener=w,A.listeners=function(d){return[]},A.binding=function(d){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(d){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class N{constructor(I,S,f){this.level=I,this.key=S,this.value=f,this.forward=[]}}const A=void 0;class L{constructor(I,S=2**16){this.comparator=I,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A)}has(I){return!!L.g(this,I,this.comparator)}get(I){return L.g(this,I,this.comparator)?.value}set(I,S){return L.h(this,I,S,this.comparator)&&(this.f+=1),this}delete(I){const S=L.k(this,I,this.comparator);return S&&(this.f-=1),S}forEach(I,S){let f=this.e.forward[0];for(;f;)I.call(S,f.value,f.key,this),f=f.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",S=this.e.forward[0];for(;S;)I+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return I}static g(I,S,f){let P=I.e;for(let E=I.d-1;E>=0;E--)for(;P.forward[E]&&f(P.forward[E].key,S)<0;)P=P.forward[E];if(P=P.forward[0],P&&f(P.key,S)===0)return P}static h(I,S,f,P){const E=[];let b=I.e;for(let l=I.d-1;l>=0;l--){for(;b.forward[l]&&P(b.forward[l].key,S)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&P(b.key,S)===0)return b.value=f,!1;{const l=L.j(I);if(l>I.d){for(let g=I.d;g<l;g++)E[g]=I.e;I.d=l}b=new N(l,S,f);for(let g=0;g<l;g++)b.forward[g]=E[g].forward[g],E[g].forward[g]=b;return!0}}static j(I,S=.5){let f=1;for(;Math.random()<S&&f<I.c;)f+=1;return f}static k(I,S,f){const P=[];let E=I.e;for(let b=I.d-1;b>=0;b--){for(;E.forward[b]&&f(E.forward[b].key,S)<0;)E=E.forward[b];P[b]=E}if(E=E.forward[0],!E||f(E.key,S)!==0)return!1;for(let b=0;b<I.d&&P[b].forward[b]===E;b++)P[b].forward[b]=E.forward[b];for(;I.d>0&&I.e.forward[I.d-1]===A;)I.d-=1;return!0}}e.$or=L}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=N}),define(oe[3],ae([0,1,8,84,2,87,60]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const I=!1,S=!1;var f;(function(m){m.None=()=>A.$kc.None;function u(ue){if(S){const{onDidAddListener:he}=ue,$e=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function v(ue,he){return x(ue,()=>{},0,void 0,!0,void 0,he)}m.defer=v;function j(ue){return(he,$e=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call($e,Ie)},null,de),we&&ve.dispose(),ve}}m.once=j;function F(ue,he,$e){return X((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),$e)}m.map=F;function T(ue,he,$e){return X((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),$e)}m.forEach=T;function z(ue,he,$e){return X((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),$e)}m.filter=z;function U(ue){return ue}m.signal=U;function _(...ue){return(he,$e=null,de)=>{const we=(0,A.$hc)(...ue.map(ve=>ve(Ie=>he.call($e,Ie))));return H(we,de)}}m.any=_;function K(ue,he,$e,de){let we=$e;return F(ue,ve=>(we=he(we,ve),we),de)}m.reduce=K;function X(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||u(de);const we=new $(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function x(ue,he,$e=100,de=!1,we=!1,ve,Ie){let Le,Te,ce,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Le=ue(ze=>{ge++,Te=he(Te,ze),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const De=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(De),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||u(Se);const Pe=new $(Se);return Ie?.add(Pe),Pe.event}m.debounce=x;function G(ue,he=0,$e){return m.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}m.accumulate=G;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return z(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},$e)}m.latch=V;function W(ue,he,$e){return[m.filter(ue,he,$e),m.filter(ue,de=>!he(de),$e)]}m.split=W;function ee(ue,he=!1,$e=[],de){let we=$e.slice(),ve=ue(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(ve);const Ie=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new $({onWillAddFirstListener(){ve||(ve=ue(Te=>Le.fire(Te)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Le),Le.event}m.buffer=ee;function ne(ue,he){return(de,we,ve)=>{const Ie=he(new Q);return ue(function(Le){const Te=Ie.evaluate(Le);Te!==re&&de.call(we,Te)},void 0,ve)}}m.chain=ne;const re=Symbol("HaltChainable");class Q{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:re),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ve=$e||!he(we,de);return $e=!1,de=we,ve?we:re}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===re)break;return he}}function q(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromNodeEventEmitter=q;function k(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new $({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromDOMEventEmitter=k;function R(ue){return new Promise(he=>j(ue)(he))}m.toPromise=R;function B(ue){const he=new $;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}m.fromPromise=B;function M(ue,he){return he(void 0),ue($e=>he($e))}m.runAndSubscribe=M;function J(ue,he){let $e=null;function de(ve){$e?.dispose(),$e=new A.$jc,he(ve,$e)}de(void 0);const we=ue(ve=>de(ve));return(0,A.$ic)(()=>{we.dispose(),$e?.dispose()})}m.runAndSubscribeWithStore=J;class Z{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||u(de),this.emitter=new $(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function se(ue,he){return new Z(ue,he).emitter.event}m.fromObservable=se;function le(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}m.fromObservableLight=le})(f||(e.Event=f={}));class P{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P.f++}`,P.all.add(this)}start(u){this.g=new D.$bd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$dd=P;let E=-1;function b(m){const u=E;return E=m,{dispose(){E=u}}}e.$ed=b;class l{constructor(u,v=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=v,this.g=0}dispose(){this.f?.clear()}check(u,v){const j=this.threshold;if(j<=0||v<j)return;this.f||(this.f=new Map);const F=this.f.get(u.value)||0;if(this.f.set(u.value,F+1),this.g-=1,this.g<=0){this.g=j*.5;let T,z=0;for(const[U,_]of this.f)(!T||z<_)&&(T=U,z=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${z}):`),console.warn(T)}return()=>{const T=this.f.get(u.value)||0;this.f.set(u.value,T-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class d{constructor(u){this.value=u,this.id=w++}}const h=2,o=(m,u)=>{if(m instanceof d)u(m);else for(let v=0;v<m.length;v++){const j=m[v];j&&u(j)}};class ${constructor(u){this.x=0,this.f=u,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const u=this.t;queueMicrotask(()=>{o(u,v=>v.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,v,j)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$kc.None;if(this.m)return A.$kc.None;v&&(u=u.bind(v));const F=new d(u);let T,z;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),T=this.g.check(F.stack,this.x+1)),I&&(F.stack=z??g.create()),this.t?this.t instanceof d?(this.u??=new C,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.x++;const U=(0,A.$ic)(()=>{T?.(),this.y(F)});return j instanceof A.$jc?j.add(U):Array.isArray(j)&&j.push(U),U},this.q}y(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const v=this.t,j=v.indexOf(u);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,v[j]=void 0;const F=this.u.current===this;if(this.x*h<=v.length){let T=0;for(let z=0;z<v.length;z++)v[z]?v[T++]=v[z]:F&&(this.u.end--,T<this.u.i&&this.u.i--);v.length=T}}z(u,v){if(!u)return;const j=this.f?.onListenerError||O.$Y;if(!j){u.value(v);return}try{u.value(v)}catch(F){j(F)}}A(u){const v=u.current.t;for(;u.i<u.end;)this.z(v[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof d)this.z(this.t,u);else{const v=this.u;v.enqueue(this,u,this.t.length),this.A(v)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=$;const y=()=>new C;e.$gd=y;class C{constructor(){this.i=-1,this.end=0}enqueue(u,v,j){this.i=0,this.end=j,this.current=u,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends ${async fireAsync(u,v,j){if(this.t)for(this.h||(this.h=new L.$tc),o(this.t,F=>this.h.push([F.value,u]));this.h.size>0&&!v.isCancellationRequested;){const[F,T]=this.h.shift(),z=[],U={...T,token:v,waitUntil:_=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");j&&(_=j(_,F)),z.push(_)}};try{F(U)}catch(_){(0,O.$Y)(_);continue}Object.freeze(z),await Promise.allSettled(z).then(_=>{for(const K of _)K.status==="rejected"&&(0,O.$Y)(K.reason)})}}}e.$hd=t;class c extends ${get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new L.$tc,this.w=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.w(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.x&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$id=c;class n extends c{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$jd=n;class s extends ${constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$kd=s;class i{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const v={event:u,listener:null};this.h.push(v),this.g&&this.m(v);const j=()=>{this.g&&this.o(v);const F=this.h.indexOf(v);this.h.splice(F,1)};return(0,A.$ic)((0,N.$bb)(j))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(v=>this.f.fire(v))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$ld=i;class r{constructor(u,v,j,F){this.f=new A.$jc;const T=this.f.add(new i),z=this.f.add(new A.$sc);function U(_){z.set(_,T.add(F(_)))}for(const _ of u)U(_);this.f.add(v(_=>{U(_)})),this.f.add(j(_=>{z.deleteAndDispose(_)})),this.event=T.event}dispose(){this.f.dispose()}}e.$md=r;class a{constructor(){this.f=[]}wrapEvent(u){return(v,j,F)=>u(T=>{const z=this.f[this.f.length-1];z?z.push(()=>v.call(j,T)):v.call(j,T)},void 0,F)}bufferEvents(u){const v=[];this.f.push(v);const j=u();return this.f.pop(),v.forEach(F=>F()),j}}e.$nd=a;class p{constructor(){this.f=!1,this.g=f.None,this.h=A.$kc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=p}),define(oe[26],ae([0,1,3]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const N=Object.freeze(function(I,S){const f=setTimeout(I.bind(S),0);return{dispose(){clearTimeout(f)}}});var A;(function(I){function S(f){return f===I.None||f===I.Cancelled||f instanceof L?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=S,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new O.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=A.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=A.None}}e.$pd=D}),define(oe[129],ae([0,1,26]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new O.$pd,S=this.b(I.token);return this.a={promise:S,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$he=N;class A{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const S=JSON.stringify(I);return this.b!==S&&(this.b=S,this.a=this.c(I)),this.a}}e.$ie=A;class L{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const S=this.b(I);return this.a.set(I,S),S}}e.$je=L}),define(oe[46],ae([0,1,8,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function A(y){const C=y;return C?typeof C.read=="function":!1}e.$qd=A;function L(y){const C=y;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.$rd=L;function D(y){const C=y;return C?L(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$sd=D;function I(y,C){return new S(y,C)}e.$td=I;class S{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,O.$Y)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let c;switch(C){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const n=c.indexOf(t);n>=0&&c.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(y,C){const t=[];let c;for(;(c=y.read())!==null;)t.push(c);return C(t)}e.$ud=f;function P(y,C,t){const c=[];let n;for(;(n=y.read())!==null&&c.length<t;)c.push(n);return n===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return y.read()}}}e.$vd=P;function E(y,C){return new Promise((t,c)=>{const n=[];b(y,{onData:s=>{C&&n.push(s)},onError:s=>{C?c(s):t(void 0)},onEnd:()=>{t(C?C(n):void 0)}})})}e.$wd=E;function b(y,C,t){y.on("error",c=>{t?.isCancellationRequested||C.onError(c)}),y.on("end",()=>{t?.isCancellationRequested||C.onEnd()}),y.on("data",c=>{t?.isCancellationRequested||C.onData(c)})}e.$xd=b;function l(y,C){return new Promise((t,c)=>{const n=new N.$jc,s=[],i=p=>{if(s.push(p),s.length>C)return n.dispose(),y.pause(),t({stream:y,buffer:s,ended:!1})},r=p=>(n.dispose(),c(p)),a=()=>(n.dispose(),t({stream:y,buffer:s,ended:!0}));n.add((0,N.$ic)(()=>y.removeListener("error",r))),y.on("error",r),n.add((0,N.$ic)(()=>y.removeListener("end",a))),y.on("end",a),n.add((0,N.$ic)(()=>y.removeListener("data",i))),y.on("data",i)})}e.$yd=l;function g(y,C){const t=I(C);return t.end(y),t}e.$zd=g;function w(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}e.$Ad=w;function d(y){let C=!1;return{read:()=>C?null:(C=!0,y)}}e.$Bd=d;function h(y,C,t){const c=I(t);return b(y,{onData:n=>c.write(C.data(n)),onError:n=>c.error(C.error?C.error(n):n),onEnd:()=>c.end()}),c}e.$Cd=h;function o(y,C,t){let c=!1;return{read:()=>{const n=C.read();return c?n:(c=!0,n!==null?t([y,n]):y)}}}e.$Dd=o;function $(y,C,t){let c=!1;const n=I(t);return b(C,{onData:s=>c?n.write(s):(c=!0,n.write(t([y,s]))),onError:s=>n.error(s),onEnd:()=>{c||(c=!0,n.write(y)),n.end()}}),n}e.$Ed=$}),define(oe[15],ae([0,1,86,46]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const A=typeof Buffer<"u",L=new O.$T(()=>new Uint8Array(256));let D,I;class S{static alloc(v){return A?new S(Buffer.allocUnsafe(v)):new S(new Uint8Array(v))}static wrap(v){return A&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new S(v)}static fromString(v,j){return!(j?.dontUseNodeBuffer||!1)&&A?new S(Buffer.from(v)):(D||(D=new TextEncoder),new S(D.encode(v)))}static fromByteArray(v){const j=S.alloc(v.length);for(let F=0,T=v.length;F<T;F++)j.buffer[F]=v[F];return j}static concat(v,j){if(typeof j>"u"){j=0;for(let z=0,U=v.length;z<U;z++)j+=v[z].byteLength}const F=S.alloc(j);let T=0;for(let z=0,U=v.length;z<U;z++){const _=v[z];F.set(_,T),T+=_.byteLength}return F}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=S.alloc(this.byteLength);return v.set(this),v}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(v,j){return new S(this.buffer.subarray(v,j))}set(v,j){if(v instanceof S)this.buffer.set(v.buffer,j);else if(v instanceof Uint8Array)this.buffer.set(v,j);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),j);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return b(this.buffer,v)}writeUInt32BE(v,j){l(this.buffer,v,j)}readUInt32LE(v){return g(this.buffer,v)}writeUInt32LE(v,j){w(this.buffer,v,j)}readUInt8(v){return d(this.buffer,v)}writeUInt8(v,j){h(this.buffer,v,j)}indexOf(v,j=0){return f(this.buffer,v instanceof S?v.buffer:v,j)}}e.$Fd=S;function f(u,v,j=0){const F=v.byteLength,T=u.byteLength;if(F===0)return 0;if(F===1)return u.indexOf(v[0]);if(F>T-j)return-1;const z=L.value;z.fill(v.length);for(let X=0;X<v.length;X++)z[v[X]]=v.length-X-1;let U=j+v.length-1,_=U,K=-1;for(;U<T;)if(u[U]===v[_]){if(_===0){K=U;break}U--,_--}else U+=Math.max(v.length-_,z[u[U]]),_=v.length-1;return K}e.$Gd=f;function P(u,v){return u[v+0]<<0>>>0|u[v+1]<<8>>>0}e.$Hd=P;function E(u,v,j){u[j+0]=v&255,v=v>>>8,u[j+1]=v&255}e.$Id=E;function b(u,v){return u[v]*2**24+u[v+1]*2**16+u[v+2]*2**8+u[v+3]}e.$Jd=b;function l(u,v,j){u[j+3]=v,v=v>>>8,u[j+2]=v,v=v>>>8,u[j+1]=v,v=v>>>8,u[j]=v}e.$Kd=l;function g(u,v){return u[v+0]<<0>>>0|u[v+1]<<8>>>0|u[v+2]<<16>>>0|u[v+3]<<24>>>0}e.$Ld=g;function w(u,v,j){u[j+0]=v&255,v=v>>>8,u[j+1]=v&255,v=v>>>8,u[j+2]=v&255,v=v>>>8,u[j+3]=v&255}e.$Md=w;function d(u,v){return u[v]}e.$Nd=d;function h(u,v,j){u[j]=v}e.$Od=h;function o(u){return N.$ud(u,v=>S.concat(v))}e.$Pd=o;function $(u){return N.$Bd(u)}e.$Qd=$;function y(u){return N.$wd(u,v=>S.concat(v))}e.$Rd=y;async function C(u){return u.ended?S.concat(u.buffer):S.concat([...u.buffer,await y(u.stream)])}e.$Sd=C;function t(u){return N.$zd(u,v=>S.concat(v))}e.$Td=t;function c(u){return N.$Cd(u,{data:v=>typeof v=="string"?S.fromString(v):S.wrap(v)},v=>S.concat(v))}e.$Ud=c;function n(u){return N.$td(v=>S.concat(v),u)}e.$Vd=n;function s(u,v){return N.$Dd(u,v,j=>S.concat(j))}e.$Wd=s;function i(u,v){return N.$Ed(u,v,j=>S.concat(j))}e.$Xd=i;function r(u){let v=0,j=0,F=0;const T=new Uint8Array(Math.floor(u.length/4*3)),z=_=>{switch(j){case 3:T[F++]=v|_,j=0;break;case 2:T[F++]=v|_>>>2,v=_<<6,j=3;break;case 1:T[F++]=v|_>>>4,v=_<<4,j=2;break;default:v=_<<2,j=1}};for(let _=0;_<u.length;_++){const K=u.charCodeAt(_);if(K>=65&&K<=90)z(K-65);else if(K>=97&&K<=122)z(K-97+26);else if(K>=48&&K<=57)z(K-48+52);else if(K===43||K===45)z(62);else if(K===47||K===95)z(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${u[_]}`)}}const U=F;for(;j>0;)z(0);return S.wrap(T).slice(0,U)}e.$Yd=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:u},v=!0,j=!1){const F=j?p:a;let T="";const z=u.byteLength%3;let U=0;for(;U<u.byteLength-z;U+=3){const _=u[U+0],K=u[U+1],X=u[U+2];T+=F[_>>>2],T+=F[(_<<4|K>>>4)&63],T+=F[(K<<2|X>>>6)&63],T+=F[X&63]}if(z===1){const _=u[U+0];T+=F[_>>>2],T+=F[_<<4&63],v&&(T+="==")}else if(z===2){const _=u[U+0],K=u[U+1];T+=F[_>>>2],T+=F[(_<<4|K>>>4)&63],T+=F[K<<2&63],v&&(T+="=")}return T}e.$Zd=m}),define(oe[27],ae([0,1,129,86]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$me=A;const L=/{(\d+)}/g;function D(ie,...fe){return fe.length===0?ie:ie.replace(L,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$ne=D;const I=/{([^}]+)}/g;function S(ie,fe){return ie.replace(I,(me,pe)=>fe[pe]??me)}e.$oe=S;function f(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$pe=f;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=P;function E(ie,fe){let me=0;const pe=fe.charCodeAt(0);for(let ke=ie.length-1;ke>=0;ke--)ie.charCodeAt(ke)===pe&&me++;return me}e.$re=E;function b(ie,fe,me="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${me}`}e.$se=b;function l(ie,fe=" "){const me=g(ie,fe);return w(me,fe)}e.$te=l;function g(ie,fe){if(!ie||!fe)return ie;const me=fe.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(fe,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$ue=g;function w(ie,fe){if(!ie||!fe)return ie;const me=fe.length,pe=ie.length;if(me===0||pe===0)return ie;let ke=pe,Re=-1;for(;Re=ie.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return ie.substring(0,ke)}e.$ve=w;function d(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=d;function h(ie){return ie.replace(/\*/g,"")}e.$xe=h;function o(ie,fe,me={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=P(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$ye=o;function $(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$ze=$;function y(ie){return ie.split(/\r\n|\r|\n/)}e.$Ae=y;function C(ie){for(let fe=0,me=ie.length;fe<me;fe++){const pe=ie.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Be=C;function t(ie,fe=0,me=ie.length){for(let pe=fe;pe<me;pe++){const ke=ie.charCodeAt(pe);if(ke!==32&&ke!==9)return ie.substring(fe,pe)}return ie.substring(fe,me)}e.$Ce=t;function c(ie,fe=ie.length-1){for(let me=fe;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$De=c;function n(ie,fe,me){const pe=[];let ke=0;for(const Re of ie.matchAll(fe)){if(pe.push(ie.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(ke)),Promise.all(pe).then(Re=>Re.join(""))}e.$Ee=n;function s(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Fe=s;function i(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){const je=ie.charCodeAt(me),Ae=fe.charCodeAt(ke);if(je<Ae)return-1;if(je>Ae)return 1}const Ce=pe-me,Oe=Re-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$Ge=i;function r(ie,fe){return a(ie,fe,0,ie.length,0,fe.length)}e.$He=r;function a(ie,fe,me=0,pe=ie.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){let je=ie.charCodeAt(me),Ae=fe.charCodeAt(ke);if(je===Ae)continue;if(je>=128||Ae>=128)return i(ie.toLowerCase(),fe.toLowerCase(),me,pe,ke,Re);m(je)&&(je-=32),m(Ae)&&(Ae-=32);const Ne=je-Ae;if(Ne!==0)return Ne}const Ce=pe-me,Oe=Re-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$Ie=a;function p(ie){return ie>=48&&ie<=57}e.$Je=p;function m(ie){return ie>=97&&ie<=122}e.$Ke=m;function u(ie){return ie>=65&&ie<=90}e.$Le=u;function v(ie,fe){return ie.length===fe.length&&a(ie,fe)===0}e.$Me=v;function j(ie,fe){const me=fe.length;return fe.length>ie.length?!1:a(ie,fe,0,me)===0}e.$Ne=j;function F(ie,fe){const me=Math.min(ie.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$Oe=F;function T(ie,fe){const me=Math.min(ie.length,fe.length);let pe;const ke=ie.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(ke-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$Pe=T;function z(ie){return 55296<=ie&&ie<=56319}e.$Qe=z;function U(ie){return 56320<=ie&&ie<=57343}e.$Re=U;function _(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$Se=_;function K(ie,fe,me){const pe=ie.charCodeAt(me);if(z(pe)&&me+1<fe){const ke=ie.charCodeAt(me+1);if(U(ke))return _(pe,ke)}return pe}e.$Te=K;function X(ie,fe){const me=ie.charCodeAt(fe-1);if(U(me)&&fe>1){const pe=ie.charCodeAt(fe-2);if(z(pe))return _(pe,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=X(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Ue=H;class x{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,ke)){me.setOffset(Re);break}ke=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Ve=x;function G(ie,fe){return new x(ie,fe).nextGraphemeLength()}e.$We=G;function V(ie,fe){return new x(ie,fe).prevGraphemeLength()}e.$Xe=V;function W(ie,fe){fe>0&&U(ie.charCodeAt(fe))&&fe--;const me=fe+G(ie,fe);return[me-V(ie,me),me]}e.$Ye=W;function ee(ie){const fe=new x(ie);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$Ze=ee;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(ie){return ne||(ne=re()),ne.test(ie)}e.$1e=Q;const q=/^[\t\n\r\x20-\x7E]*$/;function k(ie){return q.test(ie)}e.$2e=k,e.$3e=/[\u2028\u2029]/;function R(ie){return e.$3e.test(ie)}e.$4e=R;function B(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$5e=B;function M(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$6e=M;function J(ie,fe){if(ie.length<fe)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$7e=J;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(Z,"").replace(se,"")),ie}e.$8e=le,e.$9e=String.fromCharCode(65279);function ue(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$0e=ue;function he(ie){return ue(ie)?ie.substr(1):ie}e.$$e=he;function $e(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const me=fe.length,pe=ie.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=pe.indexOf(fe[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$_e=$e;function de(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$af=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$bf=we;function ve(ie,fe=1){if(fe===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$cf=ve;function Ie(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$df=Ie;function Le(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$ef=Le;function Te(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(ie,fe){if(ie===0)return 0;const me=Pe(ie,fe);if(me!==void 0)return me;const pe=new H(fe,ie);return pe.prevCodePoint(),pe.offset}e.$ff=Se;function Pe(ie,fe){const me=new H(fe,ie);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(ie){return 127995<=ie&&ie<=127999}var De;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={})),e.$gf="\xA0";class Be{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$ie(fe=>{function me(Ne){const qe=new Map;for(let Ue=0;Ue<Ne.length;Ue+=2)qe.set(Ne[Ue],Ne[Ue+1]);return qe}function pe(Ne,qe){const Ue=new Map(Ne);for(const[Ve,xe]of qe)Ue.set(Ve,xe);return Ue}function ke(Ne,qe){if(!Ne)return qe;const Ue=new Map;for(const[Ve,xe]of Ne)qe.has(Ve)&&Ue.set(Ve,xe);return Ue}const Re=this.c.value;let Ce=fe.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Oe;for(const Ne of Ce){const qe=me(Re[Ne]);Oe=ke(Oe,qe)}const je=me(Re._common),Ae=pe(je,Oe);return new Be(Ae)})}static getInstance(fe){return Be.d.get(Array.from(fe))}static{this.e=new N.$T(()=>Object.keys(Be.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Be.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=Be;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(fe){return Me.e().has(fe)}static get codePoints(){return Me.e()}}e.$if=Me}),define(oe[51],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function N(h){return A(h,0)}e.$pi=N;function A(h,o){switch(typeof h){case"object":return h===null?L(349,o):Array.isArray(h)?S(h,o):f(h,o);case"string":return I(h,o);case"boolean":return D(h,o);case"number":return L(h,o);case"undefined":return L(937,o);default:return L(617,o)}}e.$qi=A;function L(h,o){return(o<<5)-o+h|0}e.$ri=L;function D(h,o){return L(h?433:863,o)}function I(h,o){o=L(149417,o);for(let $=0,y=h.length;$<y;$++)o=L(h.charCodeAt($),o);return o}e.$si=I;function S(h,o){return o=L(104579,o),h.reduce(($,y)=>A(y,$),o)}function f(h,o){return o=L(181387,o),Object.keys(h).sort().reduce(($,y)=>($=I(y,$),A(h[y],$)),o)}class P{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=A(o,this.g),this.g}}e.$ti=P;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(h,o,$=32){const y=$-o,C=~((1<<y)-1);return(h<<o|(C&h)>>>y)>>>0}function l(h,o=0,$=h.byteLength,y=0){for(let C=0;C<$;C++)h[o+C]=y}function g(h,o,$="0"){for(;h.length<o;)h=$+h;return h}function w(h,o=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map($=>$.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),o/4)}e.$ui=w;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const $=o.length;if($===0)return;const y=this.p;let C=this.r,t=this.u,c,n;for(t!==0?(c=t,n=-1,t=0):(c=o.charCodeAt(0),n=0);;){let s=c;if(O.$Qe(c))if(n+1<$){const i=o.charCodeAt(n+1);O.$Re(i)?(n++,s=O.$Se(c,i)):s=65533}else{t=c;break}else O.$Re(c)&&(s=65533);if(C=this.w(y,C,s),n++,n<$)c=o.charCodeAt(n);else break}this.r=C,this.u=t}w(o,$,y){return y<128?o[$++]=y:y<2048?(o[$++]=192|(y&1984)>>>6,o[$++]=128|(y&63)>>>0):y<65536?(o[$++]=224|(y&61440)>>>12,o[$++]=128|(y&4032)>>>6,o[$++]=128|(y&63)>>>0):(o[$++]=240|(y&1835008)>>>18,o[$++]=128|(y&258048)>>>12,o[$++]=128|(y&4032)>>>6,o[$++]=128|(y&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=d.g,$=this.q;for(let a=0;a<64;a+=4)o.setUint32(a,$.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)o.setUint32(a,b(o.getUint32(a-12,!1)^o.getUint32(a-32,!1)^o.getUint32(a-56,!1)^o.getUint32(a-64,!1),1),!1);let y=this.h,C=this.l,t=this.m,c=this.n,n=this.o,s,i,r;for(let a=0;a<80;a++)a<20?(s=C&t|~C&c,i=1518500249):a<40?(s=C^t^c,i=1859775393):a<60?(s=C&t|C&c|t&c,i=2400959708):(s=C^t^c,i=3395469782),r=b(y,5)+s+n+i+o.getUint32(a*4,!1)&4294967295,n=c,c=t,t=b(C,30),C=y,y=r;this.h=this.h+y&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+n&4294967295}}e.$vi=d}),define(oe[89],ae([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const L="error",D="warning",I="warn",S="info",f="ignore";function P(b){return b?O.$Me(L,b)?A.Error:O.$Me(D,b)||O.$Me(I,b)?A.Warning:O.$Me(S,b)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function E(b){switch(b){case A.Error:return L;case A.Warning:return D;case A.Info:return S;default:return f}}A.toString=E}(N||(N={})),e.default=N}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),w=this.b.charCodeAt(this.c);return g-w}value(){return this.b[this.c]}}e.$Dh=A;class L{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Ge)(l,this.b,0,l.length,this.c,this.d):(0,N.$Ie)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=L;class D{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const w=this.b.charCodeAt(g);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Ge)(l,this.b,0,l.length,this.d,this.e):(0,N.$Ie)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=D;var I;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(I||(I={}));class S{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,N.$He)(l,this.c.scheme);if(this.d[this.e]===2)return(0,N.$He)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,N.$Fe)(l,this.c.query);if(this.d[this.e]===5)return(0,N.$Fe)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=S;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(P||(P={}));class E{static forUris(l=()=>!1,g=()=>!1){return new E(new S(l,g))}static forPaths(l=!1){return new E(new D(void 0,!l))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new L)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const w=g.slice(0);(0,O.$Vb)(w);for(const d of w)this.set(d,l)}else{const w=l.slice(0);(0,O.$Vb)(w);for(const d of w)this.set(d[0],d[1])}}set(l,g){const w=this.b.reset(l);let d;this.c||(this.c=new f,this.c.segment=w.value());const h=[];for(d=this.c;;){const $=w.cmp(d.segment);if($>0)d.left||(d.left=new f,d.left.segment=w.value()),h.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new f,d.right.segment=w.value()),h.push([1,d]),d=d.right;else if(w.hasNext())w.next(),d.mid||(d.mid=new f,d.mid.segment=w.value()),h.push([0,d]),d=d.mid;else break}const o=d.value;d.value=g,d.key=l;for(let $=h.length-1;$>=0;$--){const y=h[$][1];y.updateHeight();const C=y.balanceFactor();if(C<-1||C>1){const t=h[$][0],c=h[$+1][0];if(t===1&&c===1)h[$][1]=y.rotateLeft();else if(t===-1&&c===-1)h[$][1]=y.rotateRight();else if(t===1&&c===-1)y.right=h[$+1][1]=h[$+1][1].rotateRight(),h[$][1]=y.rotateLeft();else if(t===-1&&c===1)y.left=h[$+1][1]=h[$+1][1].rotateLeft(),h[$][1]=y.rotateRight();else throw new Error;if($>0)switch(h[$-1][0]){case-1:h[$-1][1].left=h[$][1];break;case 1:h[$-1][1].right=h[$][1];break;case 0:h[$-1][1].mid=h[$][1];break}else this.c=h[0][1]}}return o}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let w=this.c;for(;w;){const d=g.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(g.hasNext())g.next(),w=w.mid;else break}return w}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const w=this.b.reset(l),d=[];let h=this.c;for(;h;){const o=w.cmp(h.segment);if(o>0)d.push([-1,h]),h=h.left;else if(o<0)d.push([1,h]),h=h.right;else if(w.hasNext())w.next(),d.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const o=this.f(h.right);if(o.key){const{key:$,value:y,segment:C}=o;this.e(o.key,!1),h.key=$,h.value=y,h.segment=C}}else{const o=h.left??h.right;if(d.length>0){const[$,y]=d[d.length-1];switch($){case-1:y.left=o;break;case 0:y.mid=o;break;case 1:y.right=o;break}}else this.c=o}for(let o=d.length-1;o>=0;o--){const $=d[o][1];$.updateHeight();const y=$.balanceFactor();if(y>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[o][1]=$.rotateLeft()):y<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[o][1]=$.rotateRight()),o>0)switch(d[o-1][0]){case-1:d[o-1][1].left=d[o][1];break;case 1:d[o-1][1].right=d[o][1];break;case 0:d[o-1][1].mid=d[o][1];break}else this.c=d[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let w=this.c,d;for(;w;){const h=g.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(g.hasNext())g.next(),d=w.value||d,w=w.mid;else break}return w&&w.value||d}findSuperstr(l){return this.g(l,!1)}g(l,g){const w=this.b.reset(l);let d=this.c;for(;d;){const h=w.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this.h(d.mid):g?d.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,w]of this)l(w,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const w=g.balanceFactor();return w<-1||w>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Hh=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function O(C){return typeof C=="string"}e.$jf=O;function N(C){return Array.isArray(C)&&C.every(t=>O(t))}e.$kf=N;function A(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}e.$lf=A;function L(C){const t=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof t}e.$mf=L;function D(C){return typeof C=="number"&&!isNaN(C)}e.$nf=D;function I(C){return!!C&&typeof C[Symbol.iterator]=="function"}e.$of=I;function S(C){return C===!0||C===!1}e.$pf=S;function f(C){return typeof C>"u"}e.$qf=f;function P(C){return!E(C)}e.$rf=P;function E(C){return f(C)||C===null}e.$sf=E;function b(C,t){if(!C)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=b;function l(C){if(E(C))throw new Error("Assertion Failed: argument is undefined or null");return C}e.$uf=l;function g(...C){const t=[];for(let c=0;c<C.length;c++){const n=C[c];if(E(n))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(n)}return t}e.$vf=g;const w=Object.prototype.hasOwnProperty;function d(C){if(!A(C))return!1;for(const t in C)if(w.call(C,t))return!1;return!0}e.$wf=d;function h(C){return typeof C=="function"}e.$xf=h;function o(...C){return C.length>0&&C.every(h)}e.$yf=o;function $(C,t){const c=Math.min(C.length,t.length);for(let n=0;n<c;n++)y(C[n],t[n])}e.$zf=$;function y(C,t){if(O(t)){if(typeof C!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(C instanceof t)return}catch{}if(!E(C)&&C.constructor===t||t.length===1&&t.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=y}),define(oe[30],ae([0,1,12]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const o=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([$,y])=>{o[$]=y&&typeof y=="object"?N(y):y}),o}e.$Vm=N;function A(h){if(!h||typeof h!="object")return h;const o=[h];for(;o.length>0;){const $=o.shift();Object.freeze($);for(const y in $)if(L.call($,y)){const C=$[y];typeof C=="object"&&!Object.isFrozen(C)&&!(0,O.$mf)(C)&&o.push(C)}}return h}e.$Wm=A;const L=Object.prototype.hasOwnProperty;function D(h,o){return I(h,o,new Set)}e.$Xm=D;function I(h,o,$){if((0,O.$sf)(h))return h;const y=o(h);if(typeof y<"u")return y;if(Array.isArray(h)){const C=[];for(const t of h)C.push(I(t,o,$));return C}if((0,O.$lf)(h)){if($.has(h))throw new Error("Cannot clone recursive data-structure");$.add(h);const C={};for(const t in h)L.call(h,t)&&(C[t]=I(h[t],o,$));return $.delete(h),C}return h}function S(h,o,$=!0){return(0,O.$lf)(h)?((0,O.$lf)(o)&&Object.keys(o).forEach(y=>{y in h?$&&((0,O.$lf)(h[y])&&(0,O.$lf)(o[y])?S(h[y],o[y],$):h[y]=o[y]):h[y]=o[y]}),h):o}e.$Ym=S;function f(h,o){if(h===o)return!0;if(h==null||o===null||o===void 0||typeof h!=typeof o||typeof h!="object"||Array.isArray(h)!==Array.isArray(o))return!1;let $,y;if(Array.isArray(h)){if(h.length!==o.length)return!1;for($=0;$<h.length;$++)if(!f(h[$],o[$]))return!1}else{const C=[];for(y in h)C.push(y);C.sort();const t=[];for(y in o)t.push(y);if(t.sort(),!f(C,t))return!1;for($=0;$<C.length;$++)if(!f(h[C[$]],o[C[$]]))return!1}return!0}e.$Zm=f;function P(h){const o=new Set;return JSON.stringify(h,($,y)=>{if((0,O.$lf)(y)||Array.isArray(y)){if(o.has(y))return"[Circular]";o.add(y)}return y})}e.$1m=P;function E(h,o){const $=Object.create(null);return!h||!o||Object.keys(o).forEach(C=>{const t=h[C],c=o[C];f(t,c)||($[C]=c)}),$}e.$2m=E;function b(h,o){const $=o.toLowerCase(),y=Object.keys(h).find(C=>C.toLowerCase()===$);return y?h[y]:h[o]}e.$3m=b;function l(h,o){const $=Object.create(null);for(const[y,C]of Object.entries(h))o(y,C)&&($[y]=C);return $}e.$4m=l;function g(h){let o=[];for(;Object.prototype!==h;)o=o.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return o}e.$5m=g;function w(h){const o=[];for(const $ of g(h))typeof h[$]=="function"&&o.push($);return o}e.$6m=w;function d(h,o){const $=C=>function(){const t=Array.prototype.slice.call(arguments,0);return o(C,t)},y={};for(const C of h)y[C]=$(C);return y}e.$7m=d}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return O.test(A)}e.$3f=N,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let S=0;S<I.length;S++)I[S]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,f="";return f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f+="-",f+=D[L[S++]],f+=D[L[S++]],f+="-",f+=D[L[S++]],f+=D[L[S++]],f+="-",f+=D[L[S++]],f+=D[L[S++]],f+="-",f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f+=D[L[S++]],f}}()}),define(oe[131],ae([0,1,36]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const I=D.replace(/\-/g,":").toLowerCase();return!N.has(I)}function L(){const D=(0,O.networkInterfaces)();for(const I in D){const S=D[I];if(S){for(const{mac:f}of S)if(A(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=L}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(f){return this.a||(this.a=N.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(f)}value(){if(this.b===void 0){let f=0,P=0;const E=(0,O.networkInterfaces)();for(const b in E){const l=E[b];if(l)for(const{mac:g,internal:w}of l)w||(P+=1,this.c(g.toUpperCase())&&(f+=1))}this.b=P>0?f/P:0}return this.b}};let D;async function I(f){return D||(D=(async()=>await S(f)||A.$4f())()),D}e.$Im=I;async function S(f){try{const P=await new Promise((b,l)=>{te(["crypto"],b,l)}),E=(0,L.$Gm)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){f(P);return}}}),define(oe[133],ae([0,1,268,15]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=void 0;class A extends O.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const I=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(D,I,S){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let f=0;for(;f<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,f):(0,N.$Gd)(this.a,this.b,f);if(P===-1)break;this.push(this.a.slice(f,P+this.c)),f=P+this.c}this.a=f===this.a.length?void 0:this.a.slice(f),S()}_flush(D){this.a&&this.push(this.a),D()}}e.$VS=A}),define(oe[134],ae([0,1,61]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function N(I,S,f,P=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},f);A(I,S,P,g=>{if(!E)return E=!0,clearTimeout(l),b(g)})})}e.$6f=N;function A(I,S,f,P){if(S===0)return P(0);const E=new O.Socket;E.once("connect",()=>(D(E),A(I+f,S-1,f,P))),E.once("data",()=>{}),E.once("error",b=>(D(E),b.code!=="ECONNREFUSED"?A(I+f,S-1,f,P):P(I))),E.connect(I,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,S,f,P="127.0.0.1"){let E=!1,b,l=1;const g=O.createServer({pauseOnConnect:!0});function w(d,h){E||(E=!0,g.removeAllListeners(),g.close(),b&&clearTimeout(b),h(d))}return new Promise(d=>{b=setTimeout(()=>{w(0,d)},f),g.on("listening",()=>{w(I,d)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&l<S?(I++,l++,g.listen(I,P)):w(0,d)}),g.on("close",()=>{w(0,d)}),g.listen(I,P)})}e.$8f=L;function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(S){console.error(S)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=void 0;function O(N){return!!N.parentPort}e.$_S=O}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[62],ae([0,1,136]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const N=60,A=N*60,L=A*24,D=L*7,I=L*30,S=L*365;function f(E,b,l,g){typeof E!="number"&&(E=E.getTime());const w=Math.round((new Date().getTime()-E)/1e3);if(w<-30)return(0,O.localize)(0,null,f(new Date().getTime()+w*1e3,!1));if(!g&&w<30)return(0,O.localize)(1,null);let d;return w<N?(d=w,b?d===1?l?(0,O.localize)(2,null,d):(0,O.localize)(3,null,d):l?(0,O.localize)(4,null,d):(0,O.localize)(5,null,d):d===1?l?(0,O.localize)(6,null,d):(0,O.localize)(7,null,d):l?(0,O.localize)(8,null,d):(0,O.localize)(9,null,d)):w<A?(d=Math.floor(w/N),b?d===1?l?(0,O.localize)(10,null,d):(0,O.localize)(11,null,d):l?(0,O.localize)(12,null,d):(0,O.localize)(13,null,d):d===1?l?(0,O.localize)(14,null,d):(0,O.localize)(15,null,d):l?(0,O.localize)(16,null,d):(0,O.localize)(17,null,d)):w<L?(d=Math.floor(w/A),b?d===1?l?(0,O.localize)(18,null,d):(0,O.localize)(19,null,d):l?(0,O.localize)(20,null,d):(0,O.localize)(21,null,d):d===1?l?(0,O.localize)(22,null,d):(0,O.localize)(23,null,d):l?(0,O.localize)(24,null,d):(0,O.localize)(25,null,d)):w<D?(d=Math.floor(w/L),b?d===1?(0,O.localize)(26,null,d):(0,O.localize)(27,null,d):d===1?(0,O.localize)(28,null,d):(0,O.localize)(29,null,d)):w<I?(d=Math.floor(w/D),b?d===1?l?(0,O.localize)(30,null,d):(0,O.localize)(31,null,d):l?(0,O.localize)(32,null,d):(0,O.localize)(33,null,d):d===1?l?(0,O.localize)(34,null,d):(0,O.localize)(35,null,d):l?(0,O.localize)(36,null,d):(0,O.localize)(37,null,d)):w<S?(d=Math.floor(w/I),b?d===1?l?(0,O.localize)(38,null,d):(0,O.localize)(39,null,d):l?(0,O.localize)(40,null,d):(0,O.localize)(41,null,d):d===1?l?(0,O.localize)(42,null,d):(0,O.localize)(43,null,d):l?(0,O.localize)(44,null,d):(0,O.localize)(45,null,d)):(d=Math.floor(w/S),b?d===1?l?(0,O.localize)(46,null,d):(0,O.localize)(47,null,d):l?(0,O.localize)(48,null,d):(0,O.localize)(49,null,d):d===1?l?(0,O.localize)(50,null,d):(0,O.localize)(51,null,d):l?(0,O.localize)(52,null,d):(0,O.localize)(53,null,d))}e.$6l=f;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=P}),define(oe[137],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,137]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function L(E,b){return b&&(E.stack||E.stacktrace)?A.localize(0,null,I(E),D(E.stack)||D(E.stacktrace)):I(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function S(E=null,b=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const l=O.$Fb(E),g=S(l[0],b);return l.length>1?A.localize(4,null,g,l.length):g}if(N.$jf(E))return E;if(E.detail){const l=E.detail;if(l.error)return L(l.error,b);if(l.exception)return L(l.exception,b)}return E.stack?L(E,b):E.message?E.message:A.localize(5,null)}e.$mi=S;function f(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$ni=f;function P(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$oi=P}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function N(A){switch(A){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$mp=N}),define(oe[140],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,A=!1,L=!1,D=!1,I=!1,S=!1,f=!1,P=!1,E=!1,b=!1,l,g=e.$f,w=e.$f,d,h;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?o=e.$g.vscode.process:typeof process<"u"&&(o=process);const $=typeof o?.versions?.electron=="string",y=$&&o?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,N=h.indexOf("Windows")>=0,A=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,S=!0,l=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$f,g=l,w=navigator.language;else if(typeof o=="object"){N=o.platform==="win32",A=o.platform==="darwin",L=o.platform==="linux",D=L&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,f=$,E=!!o.env.CI||!!o.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$f,g=e.$f;const p=o.env.VSCODE_NLS_CONFIG;if(p)try{const m=JSON.parse(p),u=m.availableLanguages["*"];l=m.locale,w=m.osLocale,g=u||e.$f,d=m._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var C;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(C||(e.Platform=C={}));function t(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let c=0;A?c=1:N?c=3:L&&(c=2),e.$i=N,e.$j=A,e.$k=L,e.$l=D,e.$m=I,e.$n=f,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=b,e.$s=E,e.$t=c,e.$u=h,e.$v=g;var n;(function(p){function m(){return e.$v}p.value=m;function u(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}p.isDefaultVariant=u;function v(){return e.$v==="en"}p.isDefault=v})(n||(e.Language=n={})),e.$w=l,e.$x=w,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const p=[];e.$g.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let v=0,j=p.length;v<j;v++){const F=p[v];if(F.id===u.data.vscodeScheduleAsyncWork){p.splice(v,1),F.callback();return}}});let m=0;return u=>{const v=++m;p.push({id:v,callback:u}),e.$g.postMessage({vscodeScheduleAsyncWork:v},"*")}}return p=>setTimeout(p)})();var s;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=A||P?2:N?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,i=new Uint16Array(p.buffer)[0]===(2<<8)+1}return i}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let N;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.process<"u"){const A=O.$g.vscode.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$3d=N.platform,e.$4d=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const N=65,A=97,L=90,D=122,I=46,S=47,f=92,P=58,E=63;class b extends Error{constructor(c,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const r=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${r} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,c){if(t===null||typeof t!="object")throw new b(c,"Object",t)}function g(t,c){if(typeof t!="string")throw new b(c,"string",t)}const w=O.$3d==="win32";function d(t){return t===S||t===f}function h(t){return t===S}function o(t){return t>=N&&t<=L||t>=A&&t<=D}function $(t,c,n,s){let i="",r=0,a=-1,p=0,m=0;for(let u=0;u<=t.length;++u){if(u<t.length)m=t.charCodeAt(u);else{if(s(m))break;m=S}if(s(m)){if(!(a===u-1||p===1))if(p===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const v=i.lastIndexOf(n);v===-1?(i="",r=0):(i=i.slice(0,v),r=i.length-1-i.lastIndexOf(n)),a=u,p=0;continue}else if(i.length!==0){i="",r=0,a=u,p=0;continue}}c&&(i+=i.length>0?`${n}..`:"..",r=2)}else i.length>0?i+=`${n}${t.slice(a+1,u)}`:i=t.slice(a+1,u),r=u-a-1;a=u,p=0}else m===I&&p!==-1?++p:p=-1}return i}function y(t,c){l(c,"pathObject");const n=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return n?n===c.root?`${n}${s}`:`${n}${t}${s}`:s}e.$5d={resolve(...t){let c="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],g(r,"path"),r.length===0)continue}else c.length===0?r=O.cwd():(r=O.env[`=${c}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${c}\\`));const a=r.length;let p=0,m="",u=!1;const v=r.charCodeAt(0);if(a===1)d(v)&&(p=1,u=!0);else if(d(v))if(u=!0,d(r.charCodeAt(1))){let j=2,F=j;for(;j<a&&!d(r.charCodeAt(j));)j++;if(j<a&&j!==F){const T=r.slice(F,j);for(F=j;j<a&&d(r.charCodeAt(j));)j++;if(j<a&&j!==F){for(F=j;j<a&&!d(r.charCodeAt(j));)j++;(j===a||j!==F)&&(m=`\\\\${T}\\${r.slice(F,j)}`,p=j)}}}else p=1;else o(v)&&r.charCodeAt(1)===P&&(m=r.slice(0,2),p=2,a>2&&d(r.charCodeAt(2))&&(u=!0,p=3));if(m.length>0)if(c.length>0){if(m.toLowerCase()!==c.toLowerCase())continue}else c=m;if(s){if(c.length>0)break}else if(n=`${r.slice(p)}\\${n}`,s=u,u&&c.length>0)break}return n=$(n,!s,"\\",d),s?`${c}\\${n}`:`${c}${n}`||"."},normalize(t){g(t,"path");const c=t.length;if(c===0)return".";let n=0,s,i=!1;const r=t.charCodeAt(0);if(c===1)return h(r)?"\\":t;if(d(r))if(i=!0,d(t.charCodeAt(1))){let p=2,m=p;for(;p<c&&!d(t.charCodeAt(p));)p++;if(p<c&&p!==m){const u=t.slice(m,p);for(m=p;p<c&&d(t.charCodeAt(p));)p++;if(p<c&&p!==m){for(m=p;p<c&&!d(t.charCodeAt(p));)p++;if(p===c)return`\\\\${u}\\${t.slice(m)}\\`;p!==m&&(s=`\\\\${u}\\${t.slice(m,p)}`,n=p)}}}else n=1;else o(r)&&t.charCodeAt(1)===P&&(s=t.slice(0,2),n=2,c>2&&d(t.charCodeAt(2))&&(i=!0,n=3));let a=n<c?$(t.slice(n),!i,"\\",d):"";return a.length===0&&!i&&(a="."),a.length>0&&d(t.charCodeAt(c-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){g(t,"path");const c=t.length;if(c===0)return!1;const n=t.charCodeAt(0);return d(n)||c>2&&o(n)&&t.charCodeAt(1)===P&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,n;for(let r=0;r<t.length;++r){const a=t[r];g(a,"path"),a.length>0&&(c===void 0?c=n=a:c+=`\\${a}`)}if(c===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&d(n.charCodeAt(0))){++i;const r=n.length;r>1&&d(n.charCodeAt(1))&&(++i,r>2&&(d(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<c.length&&d(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.$5d.normalize(c)},relative(t,c){if(g(t,"from"),g(c,"to"),t===c)return"";const n=e.$5d.resolve(t),s=e.$5d.resolve(c);if(n===s||(t=n.toLowerCase(),c=s.toLowerCase(),t===c))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===f;)r--;const a=r-i;let p=0;for(;p<c.length&&c.charCodeAt(p)===f;)p++;let m=c.length;for(;m-1>p&&c.charCodeAt(m-1)===f;)m--;const u=m-p,v=a<u?a:u;let j=-1,F=0;for(;F<v;F++){const z=t.charCodeAt(i+F);if(z!==c.charCodeAt(p+F))break;z===f&&(j=F)}if(F!==v){if(j===-1)return s}else{if(u>v){if(c.charCodeAt(p+F)===f)return s.slice(p+F+1);if(F===2)return s.slice(p+F)}a>v&&(t.charCodeAt(i+F)===f?j=F:F===2&&(j=3)),j===-1&&(j=0)}let T="";for(F=i+j+1;F<=r;++F)(F===r||t.charCodeAt(F)===f)&&(T+=T.length===0?"..":"\\..");return p+=j,T.length>0?`${T}${s.slice(p,m)}`:(s.charCodeAt(p)===f&&++p,s.slice(p,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$5d.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===f){if(c.charCodeAt(1)===f){const n=c.charCodeAt(2);if(n!==E&&n!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(o(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===f)return`\\\\?\\${c}`;return t},dirname(t){g(t,"path");const c=t.length;if(c===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(c===1)return d(i)?t:".";if(d(i)){if(n=s=1,d(t.charCodeAt(1))){let p=2,m=p;for(;p<c&&!d(t.charCodeAt(p));)p++;if(p<c&&p!==m){for(m=p;p<c&&d(t.charCodeAt(p));)p++;if(p<c&&p!==m){for(m=p;p<c&&!d(t.charCodeAt(p));)p++;if(p===c)return t;p!==m&&(n=s=p+1)}}}}else o(i)&&t.charCodeAt(1)===P&&(n=c>2&&d(t.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let p=c-1;p>=s;--p)if(d(t.charCodeAt(p))){if(!a){r=p;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return t.slice(0,r)},basename(t,c){c!==void 0&&g(c,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(t.length>=2&&o(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(n=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,p=-1;for(r=t.length-1;r>=n;--r){const m=t.charCodeAt(r);if(d(m)){if(!i){n=r+1;break}}else p===-1&&(i=!1,p=r+1),a>=0&&(m===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=p))}return n===s?s=p:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=n;--r)if(d(t.charCodeAt(r))){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let c=0,n=-1,s=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===P&&o(t.charCodeAt(0))&&(c=s=2);for(let p=t.length-1;p>=c;--p){const m=t.charCodeAt(p);if(d(m)){if(!r){s=p+1;break}continue}i===-1&&(r=!1,i=p+1),m===I?n===-1?n=p:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:y.bind(null,"\\"),parse(t){g(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return d(i)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(d(i)){if(s=1,d(t.charCodeAt(1))){let j=2,F=j;for(;j<n&&!d(t.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&d(t.charCodeAt(j));)j++;if(j<n&&j!==F){for(F=j;j<n&&!d(t.charCodeAt(j));)j++;j===n?s=j:j!==F&&(s=j+1)}}}}else if(o(i)&&t.charCodeAt(1)===P){if(n<=2)return c.root=c.dir=t,c;if(s=2,d(t.charCodeAt(2))){if(n===3)return c.root=c.dir=t,c;s=3}}s>0&&(c.root=t.slice(0,s));let r=-1,a=s,p=-1,m=!0,u=t.length-1,v=0;for(;u>=s;--u){if(i=t.charCodeAt(u),d(i)){if(!m){a=u+1;break}continue}p===-1&&(m=!1,p=u+1),i===I?r===-1?r=u:v!==1&&(v=1):r!==-1&&(v=-1)}return p!==-1&&(r===-1||v===0||v===1&&r===p-1&&r===a+1?c.base=c.name=t.slice(a,p):(c.name=t.slice(a,r),c.base=t.slice(a,p),c.ext=t.slice(r,p))),a>0&&a!==s?c.dir=t.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(w){const t=/\\/g;return()=>{const c=O.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>O.cwd()})();e.$6d={resolve(...t){let c="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:C();g(i,"path"),i.length!==0&&(c=`${i}/${c}`,n=i.charCodeAt(0)===S)}return c=$(c,!n,"/",h),n?`/${c}`:c.length>0?c:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===S,n=t.charCodeAt(t.length-1)===S;return t=$(t,!c,"/",h),t.length===0?c?"/":n?"./":".":(n&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let c;for(let n=0;n<t.length;++n){const s=t[n];g(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.$6d.normalize(c)},relative(t,c){if(g(t,"from"),g(c,"to"),t===c||(t=e.$6d.resolve(t),c=e.$6d.resolve(c),t===c))return"";const n=1,s=t.length,i=s-n,r=1,a=c.length-r,p=i<a?i:a;let m=-1,u=0;for(;u<p;u++){const j=t.charCodeAt(n+u);if(j!==c.charCodeAt(r+u))break;j===S&&(m=u)}if(u===p)if(a>p){if(c.charCodeAt(r+u)===S)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else i>p&&(t.charCodeAt(n+u)===S?m=u:u===0&&(m=0));let v="";for(u=n+m+1;u<=s;++u)(u===s||t.charCodeAt(u)===S)&&(v+=v.length===0?"..":"/..");return`${v}${c.slice(r+m)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===S;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===S){if(!s){n=i;break}}else s=!1;return n===-1?c?"/":".":c&&n===1?"//":t.slice(0,n)},basename(t,c){c!==void 0&&g(c,"ext"),g(t,"path");let n=0,s=-1,i=!0,r;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,p=-1;for(r=t.length-1;r>=0;--r){const m=t.charCodeAt(r);if(m===S){if(!i){n=r+1;break}}else p===-1&&(i=!1,p=r+1),a>=0&&(m===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=p))}return n===s?s=p:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===S){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){g(t,"path");let c=-1,n=0,s=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const p=t.charCodeAt(a);if(p===S){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),p===I?c===-1?c=a:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||s===-1||r===0||r===1&&c===s-1&&c===n+1?"":t.slice(c,s)},format:y.bind(null,"/"),parse(t){g(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const n=t.charCodeAt(0)===S;let s;n?(c.root="/",s=1):s=0;let i=-1,r=0,a=-1,p=!0,m=t.length-1,u=0;for(;m>=s;--m){const v=t.charCodeAt(m);if(v===S){if(!p){r=m+1;break}continue}a===-1&&(p=!1,a=m+1),v===I?i===-1?i=m:u!==1&&(u=1):i!==-1&&(u=-1)}if(a!==-1){const v=r===0&&n?1:r;i===-1||u===0||u===1&&i===a-1&&i===r+1?c.base=c.name=t.slice(v,a):(c.name=t.slice(v,i),c.base=t.slice(v,a),c.ext=t.slice(i,a))}return r>0?c.dir=t.slice(0,r-1):n&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=w?e.$5d.normalize:e.$6d.normalize,e.$8d=w?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=w?e.$5d.join:e.$6d.join,e.$0d=w?e.$5d.resolve:e.$6d.resolve,e.$$d=w?e.$5d.relative:e.$6d.relative,e.$_d=w?e.$5d.dirname:e.$6d.dirname,e.$ae=w?e.$5d.basename:e.$6d.basename,e.$be=w?e.$5d.extname:e.$6d.extname,e.$ce=w?e.$5d.format:e.$6d.format,e.$de=w?e.$5d.parse:e.$6d.parse,e.$ee=w?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=w?e.$5d.sep:e.$6d.sep,e.$ge=w?e.$5d.delimiter:e.$6d.delimiter}),define(oe[48],ae([0,1,16,6,27,12]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function D(r){return r===47||r===92}e.$Bf=D;function I(r){return r.replace(/[\\/]/g,O.$6d.sep)}e.$Cf=I;function S(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Df=S;function f(r,a=O.$6d.sep){if(!r)return"";const p=r.length,m=r.charCodeAt(0);if(D(m)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let v=3;const j=v;for(;v<p&&!D(r.charCodeAt(v));v++);if(j!==v&&!D(r.charCodeAt(v+1))){for(v+=1;v<p;v++)if(D(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,a)}}return a}else if(h(m)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<p;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Ef=f;function P(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let p=2;const m=p;for(;p<r.length&&(a=r.charCodeAt(p),a!==92);p++);return!(m===p||(a=r.charCodeAt(p+1),isNaN(a)||a===92))}e.$Ff=P;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=N.$i){const p=a?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||a&&l.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Gf=g;function w(r,a,p){const m=r===a;return!p||m?m:!r||!a?!1:(0,A.$Me)(r,a)}e.$Hf=w;function d(r,a,p,m=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(p){if(!(0,A.$Ne)(r,a))return!1;if(a.length===r.length)return!0;let v=a.length;return a.charAt(a.length-1)===m&&v--,r.charAt(v)===m}return a.charAt(a.length-1)!==m&&(a+=m),r.indexOf(a)===0}e.$If=d;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Jf=h;function o(r,a){return N.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$8d)(r)||(r=(0,O.$9d)(a,r)),r=(0,O.$7d)(r),N.$i?(r=(0,A.$ve)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,A.$ve)(r,O.sep),r||(r=O.sep)),r}e.$Kf=o;function $(r){const a=(0,O.$7d)(r);return N.$i?r.length>3?!1:y(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$6d.sep}e.$Lf=$;function y(r,a=N.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Mf=y;function C(r,a=N.$i){return y(r,a)?r[0]:void 0}e.$Nf=C;function t(r,a,p){return a.length>r.length?-1:r===a?0:(p&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Of=t;function c(r){const a=r.split(":");let p,m,u;for(const v of a){const j=Number(v);(0,L.$nf)(j)?m===void 0?m=j:u===void 0&&(u=j):p=p?[p,v].join(":"):v}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:m!==void 0?m:void 0,column:u!==void 0?u:m!==void 0?1:void 0}}e.$Pf=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,p=8){let m="";for(let v=0;v<p;v++){let j;v===0&&N.$i&&!a&&(p===3||p===4)?j=s:j=n,m+=j.charAt(Math.floor(Math.random()*j.length))}let u;return a?u=`${a}-${m}`:u=m,r?(0,O.$9d)(r,u):u}e.$Qf=i}),define(oe[141],ae([0,1,16]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const E=(0,O.$be)(P),b=N[E.toLowerCase()];return b!==void 0?b:D(P)}e.$Ir=L;function D(P){const E=(0,O.$be)(P);return A[E.toLowerCase()]}e.$Jr=D;function I(P){for(const E in A)if(A[E]===P)return E}e.$Kr=I;const S=/^(.+)\/(.+?)(;.+)?$/;function f(P,E){const b=S.exec(P);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:P}e.$Lr=f}),define(oe[90],ae([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(I,...S){const f=S.reduce((b,l)=>(b[l]=!0,b),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(b=>!f[b]).forEach(b=>{for(let l=0;l<P.length;l++)if(b.search(P[l])!==-1){delete I[b];break}})}e.$sl=L;function D(I){I&&(delete I.DEBUG,O.$j&&delete I.DYLD_LIBRARY_PATH,O.$k&&delete I.LD_PRELOAD)}e.$tl=D}),define(oe[10],ae([0,1,16,6]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,D=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const P="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(i){return i instanceof l?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,p,m,u=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=S(i,u),this.authority=r||P,this.path=f(this.scheme,a||P),this.query=p||P,this.fragment=m||P,I(this,u))}get fsPath(){return y(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:p,query:m,fragment:u}=i;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),p===void 0?p=this.path:p===null&&(p=P),m===void 0?m=this.query:m===null&&(m=P),u===void 0?u=this.fragment:u===null&&(u=P),r===this.scheme&&a===this.authority&&p===this.path&&m===this.query&&u===this.fragment?this:new d(r,a,p,m,u)}static parse(i,r=!1){const a=b.exec(i);return a?new d(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new d(P,P,P,P,P)}static file(i){let r=P;if(N.$i&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const a=i.indexOf(E,2);a===-1?(r=i.substring(2),i=E):(r=i.substring(2,a),i=i.substring(a)||E)}return new d("file",r,i,P,P)}static from(i,r){return new d(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=l.file(O.$5d.join(y(i,!0),...r)).path:a=O.$6d.join(i.path,...r),i.with({path:a})}toString(i=!1){return C(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof l)return i;{const r=new d(i);return r._formatted=i.external??null,r._fsPath=i._sep===w?i.fsPath??null:null,r}}else return i}}e.URI=l;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Sf=g;const w=N.$i?1:void 0;class d extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(i=!1){return i?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(s,i,r){let a,p=-1;for(let m=0;m<s.length;m++){const u=s.charCodeAt(m);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||i&&u===47||r&&u===91||r&&u===93||r&&u===58)p!==-1&&(a+=encodeURIComponent(s.substring(p,m)),p=-1),a!==void 0&&(a+=s.charAt(m));else{a===void 0&&(a=s.substr(0,m));const v=h[u];v!==void 0?(p!==-1&&(a+=encodeURIComponent(s.substring(p,m)),p=-1),a+=v):p===-1&&(p=m)}}return p!==-1&&(a+=encodeURIComponent(s.substring(p))),a!==void 0?a:s}function $(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=h[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function y(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Tf=y;function C(s,i){const r=i?$:o;let a="",{scheme:p,authority:m,path:u,query:v,fragment:j}=s;if(p&&(a+=p,a+=":"),(m||p==="file")&&(a+=E,a+=E),m){let F=m.indexOf("@");if(F!==-1){const T=m.substr(0,F);m=m.substr(F+1),F=T.lastIndexOf(":"),F===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,F),!1,!1),a+=":",a+=r(T.substr(F+1),!1,!0)),a+="@"}m=m.toLowerCase(),F=m.lastIndexOf(":"),F===-1?a+=r(m,!1,!0):(a+=r(m.substr(0,F),!1,!0),a+=m.substr(F))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const F=u.charCodeAt(1);F>=65&&F<=90&&(u=`/${String.fromCharCode(F+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const F=u.charCodeAt(0);F>=65&&F<=90&&(u=`${String.fromCharCode(F+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return v&&(a+="?",a+=r(v,!1,!1)),j&&(a+="#",a+=i?j:o(j,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(c)?s.replace(c,i=>t(i)):s}}),define(oe[142],ae([0,1,10]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function N(f){const P=f;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Np=N;function A(f){const P=[];let E;try{const b=JSON.parse(f.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),P.push(...b)}catch{P.push("Unable to log remote console arguments",f.arguments)}return{args:P,stack:E}}e.$Op=A;function L(f){if(typeof f!="string")return L(A(f).stack);const P=f;if(P){const E=D(P),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:O.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$Pp=L;function D(f){if(!f)return f;const P=f.indexOf(`
`);return P===-1?f:f.substring(0,P)}function I(f,P){const{args:E,stack:b}=A(f),l=typeof E[0]=="string"&&E.length===1;let g=D(b);g&&(g=`(${g.trim()})`);let w=[];if(typeof E[0]=="string"?g&&l?w=[`%c[${P}] %c${E[0]} %c${g}`,S("blue"),S(""),S("grey")]:w=[`%c[${P}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:w=[`%c[${P}]%`,S("blue"),...E],g&&!l&&w.push(g),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,w)}e.log=I;function S(f){return`color: ${f}`}}),define(oe[63],ae([0,1,15,10]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function A(S){return JSON.stringify(S,D)}e.$9g=A;function L(S){let f=JSON.parse(S);return f=I(f),f}e.$0g=L;function D(S,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function I(S,f=0){if(!S||f>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof O.$Fd||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=I(S[P],f+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=I(S[P],f+1))}return S}e.$$g=I}),define(oe[23],ae([0,1,8,6,10]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,E,b){this.a[P]=E,this.b[P]=b}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(d){return O.$Y(d),P}const E=P.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],g=this.c[E];let w=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(w+=`&${e.$Vf}=${encodeURIComponent(g)}`),A.URI.from({scheme:N.$o?this.d:L.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:w})}}e.$Wf=new D,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class I{static{this.a="vscode-app"}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Wf.rewrite(P):P.scheme===L.file&&(N.$m||N.$p&&N.$g.origin===`${L.vscodeFileResource}://${I.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||I.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==I.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return A.URI.isUri(P)?P:A.URI.parse(E.toUrl(P))}}e.$2f=new I;var S;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function b(g){let w;typeof g=="string"?w=new URL(g).searchParams:g instanceof URL?w=g.searchParams:A.URI.isUri(g)&&(w=new URL(g.toString(!0)).searchParams);const d=w?.get(E);if(d)return P.get(d)}f.getHeadersFromQuery=b;function l(g,w,d){if(!globalThis.crossOriginIsolated)return;const h=w&&d?"3":d?"2":"1";g instanceof URLSearchParams?g.set(E,h):g[E]=h}f.addSearchParam=l})(S||(e.COI=S={}))}),define(oe[143],ae([0,1,124,23,6,10]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class D{constructor(b,l,g){this.id=b,this.dependencies=l,this.callback=g}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,g)=>{typeof b!="string"&&(g=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this.c.push(new D(b,l,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,g)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const d=()=>{w.removeEventListener("load",h),w.removeEventListener("error",o)},h=$=>{d(),l(this.c.pop())},o=$=>{d(),g($)};w.addEventListener("load",h),w.addEventListener("error",o),this.f&&(b=this.f.createScriptURL(b)),w.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(w)})}i(b){return new Promise((l,g)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(w){g(w)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,d=L.URI.parse(b).fsPath,h=l.readFileSync(d).toString(),o=w.wrap(h.replace(/^#!.*/,""));return new g.Script(o).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function P(E,b,l){if(O.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[E]&&(E=f[E]);const g=`${E}/${b}`;if(S.has(g))return S.get(g);let w;if(/^\w[\w\d+.-]*:\/\//.test(g))w=g;else{const $=`${l&&!A.$o?N.$Zf:N.$Yf}/${g}`;w=N.$2f.asBrowserUri($).toString(!0)}const d=I.INSTANCE.load(w);return S.set(g,d),d}else return await new Promise((g,w)=>{te([E],g,w)})}e.$cC=P}),define(oe[21],ae([0,1,48,23,16,6,27,10]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function S(l){return(0,I.$Tf)(l,!0)}e.$9f=S;class f{constructor(g){this.a=g}compare(g,w,d=!1){return g===w?0:(0,D.$Fe)(this.getComparisonKey(g,d),this.getComparisonKey(w,d))}isEqual(g,w,d=!1){return g===w?!0:!g||!w?!1:this.getComparisonKey(g,d)===this.getComparisonKey(w,d)}getComparisonKey(g,w=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,w,d=!1){if(g.scheme===w.scheme){if(g.scheme===N.Schemas.file)return O.$If(S(g),S(w),this.a(g))&&g.query===w.query&&(d||g.fragment===w.fragment);if((0,e.$ng)(g.authority,w.authority))return O.$If(g.path,w.path,this.a(g),"/")&&g.query===w.query&&(d||g.fragment===w.fragment)}return!1}joinPath(g,...w){return I.URI.joinPath(g,...w)}basenameOrAuthority(g){return(0,e.$fg)(g)||g.authority}basename(g){return A.$6d.basename(g.path)}extname(g){return A.$6d.extname(g.path)}dirname(g){if(g.path.length===0)return g;let w;return g.scheme===N.Schemas.file?w=I.URI.file(A.$_d(S(g))).path:(w=A.$6d.dirname(g.path),g.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),w="/")),g.with({path:w})}normalizePath(g){if(!g.path.length)return g;let w;return g.scheme===N.Schemas.file?w=I.URI.file(A.$7d(S(g))).path:w=A.$6d.normalize(g.path),g.with({path:w})}relativePath(g,w){if(g.scheme!==w.scheme||!(0,e.$ng)(g.authority,w.authority))return;if(g.scheme===N.Schemas.file){const o=A.$$d(S(g),S(w));return L.$i?O.$Cf(o):o}let d=g.path||"/";const h=w.path||"/";if(this.a(g)){let o=0;for(const $=Math.min(d.length,h.length);o<$&&!(d.charCodeAt(o)!==h.charCodeAt(o)&&d.charAt(o).toLowerCase()!==h.charAt(o).toLowerCase());o++);d=h.substr(0,o)+d.substr(o)}return A.$6d.relative(d,h)}resolvePath(g,w){if(g.scheme===N.Schemas.file){const d=I.URI.file(A.$0d(S(g),w));return g.with({authority:d.authority,path:d.path})}return w=O.$Df(w),g.with({path:A.$6d.resolve(g.path,w)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,w){return g===w||g!==void 0&&w!==void 0&&(0,D.$Me)(g,w)}hasTrailingPathSeparator(g,w=A.sep){if(g.scheme===N.Schemas.file){const d=S(g);return d.length>O.$Ef(d).length&&d[d.length-1]===w}else{const d=g.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,w=A.sep){return(0,e.$og)(g,w)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,w=A.sep){let d=!1;if(g.scheme===N.Schemas.file){const h=S(g);d=h!==void 0&&h.length===O.$Ef(h).length&&h[h.length-1]===w}else{w="/";const h=g.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.$og)(g,w)?g.with({path:g.path+"/"}):g}}e.$0f=f,e.$$f=new f(()=>!1),e.$_f=new f(l=>l.scheme===N.Schemas.file?!L.$k:!0),e.$ag=new f(l=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function P(l,g){const w=[];for(let d=0;d<l.length;d++){const h=g(l[d]);l.some((o,$)=>$===d?!1:(0,e.$cg)(h,g(o)))||w.push(l[d])}return w}e.$rg=P;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(w){const d=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach($=>{const[y,C]=$.split(":");y&&C&&d.set(y,C)});const o=w.path.substring(0,w.path.indexOf(";"));return o&&d.set(l.META_DATA_MIME,o),d}l.parseMetaData=g})(E||(e.DataUri=E={}));function b(l,g,w){if(g){let d=l.path;return d&&d[0]!==A.$6d.sep&&(d=A.$6d.sep+d),l.with({scheme:w,authority:g,path:d})}return l.with({scheme:w})}e.$sg=b}),define(oe[5],ae([0,1,26,8,3,2,21,6,130]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function f(k){return!!k&&typeof k.then=="function"}e.$tg=f;function P(k){const R=new O.$pd,B=k(R.token),M=new Promise((J,Z)=>{const se=R.token.onCancellationRequested(()=>{se.dispose(),R.dispose(),Z(new N.$3)});Promise.resolve(B).then(le=>{se.dispose(),R.dispose(),J(le)},le=>{se.dispose(),R.dispose(),Z(le)})});return new class{cancel(){R.cancel()}then(J,Z){return M.then(J,Z)}catch(J){return this.then(void 0,J)}finally(J){return M.finally(J)}}}e.$ug=P;function E(k,R,B){return new Promise((M,J)=>{const Z=R.onCancellationRequested(()=>{Z.dispose(),M(B)});k.then(M,J).finally(()=>Z.dispose())})}e.$vg=E;function b(k,R){return new Promise((B,M)=>{const J=R.onCancellationRequested(()=>{J.dispose(),M(new N.$3)});k.then(B,M).finally(()=>J.dispose())})}e.$wg=b;async function l(k){let R=-1;const B=k.map((M,J)=>M.then(Z=>(R=J,Z)));try{return await Promise.race(B)}finally{k.forEach((M,J)=>{J!==R&&M.cancel()})}}e.$xg=l;function g(k,R,B){let M;const J=setTimeout(()=>{M?.(void 0),B?.()},R);return Promise.race([k.finally(()=>clearTimeout(J)),new Promise(Z=>M=Z)])}e.$yg=g;function w(k){return new Promise((R,B)=>{const M=k();f(M)?M.then(R,B):R(M)})}e.$zg=w;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const B=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(B,B).then(M)})}return new Promise((B,M)=>{this.b.then(B,M)})}return this.a=R(),new Promise((B,M)=>{this.a.then(J=>{this.a=null,B(J)},J=>{this.a=null,M(J)})})}dispose(){this.f=!0}}e.$Ag=d;class h{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$Bg=h;class o{constructor(){this.a=new Map}queue(R,B){const J=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(R)===J&&this.a.delete(R)});return this.a.set(R,J),J}}e.$Cg=o;const $=(k,R)=>{let B=!0;const M=setTimeout(()=>{B=!1,R()},k);return{isTriggered:()=>B,dispose:()=>{clearTimeout(M),B=!1}}},y=k=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,k())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class C{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,B=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((J,Z)=>{this.d=J,this.f=Z}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=B===S.$cd?y(M):$(B,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=C;class t{constructor(R){this.a=new C(R),this.b=new d}trigger(R,B){return this.a.trigger(()=>this.b.queue(R),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class c{constructor(){this.a=!1,this.b=new Promise((R,B)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=c;class n extends c{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$Gg=n;function s(k,R){return R?new Promise((B,M)=>{const J=setTimeout(()=>{Z.dispose(),B()},k),Z=R.onCancellationRequested(()=>{clearTimeout(J),Z.dispose(),M(new N.$3)})}):P(B=>s(k,B))}e.$Hg=s;function i(k,R=0,B){const M=setTimeout(()=>{k(),B&&J.dispose()},R),J=(0,L.$ic)(()=>{clearTimeout(M),B?.deleteAndLeak(J)});return B?.add(J),J}e.$Ig=i;function r(k){const R=[];let B=0;const M=k.length;function J(){return B<M?k[B++]():null}function Z(se){se!=null&&R.push(se);const le=J();return le?le.then(Z):Promise.resolve(R)}return Promise.resolve(null).then(Z)}e.$Jg=r;function a(k,R=M=>!!M,B=null){let M=0;const J=k.length,Z=()=>{if(M>=J)return Promise.resolve(B);const se=k[M++];return Promise.resolve(se()).then(ue=>R(ue)?Promise.resolve(ue):Z())};return Z()}e.$Kg=a;function p(k,R=M=>!!M,B=null){if(k.length===0)return Promise.resolve(B);let M=k.length;const J=()=>{M=-1;for(const Z of k)Z.cancel?.()};return new Promise((Z,se)=>{for(const le of k)le.then(ue=>{--M>=0&&R(ue)?(J(),Z(ue)):M===0&&Z(B)}).catch(ue=>{--M>=0&&(J(),se(ue))})})}e.$Lg=p;class m{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new A.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((B,M)=>{this.f.push({factory:R,c:B,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const B=R.factory();B.then(R.c,R.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=m;class u extends m{constructor(){super(1)}}e.$Ng=u;class v{constructor(){this.a=new x,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$Og=v;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new W;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,B=D.$$f){const M=B.getComparisonKey(R);let J=this.a.get(M);if(!J){J=new u;const Z=this.f++,se=A.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$sc),this.d.set(Z,se),this.a.set(M,J)}return J}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=j;class F{constructor(R,B){this.a=-1,typeof R=="function"&&typeof B=="number"&&this.setIfNotSet(R,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},B)}setIfNotSet(R,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},B))}}e.$Qg=F;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,B){this.cancel(),this.a=setInterval(()=>{R()},B)}}e.$Rg=T;class z{constructor(R,B){this.b=-1,this.a=R,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=z;class U{constructor(R,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=R,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=U;class _ extends z{constructor(R,B){super(R,B),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$Ug=_;class K extends L.$kc{constructor(R,B){super(),this.g=R,this.h=B,this.a=[],this.b=this.B(new L.$lc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of R)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=k=>{(0,I.$A)(()=>{if(R)return;const B=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$Wg=(k,R)=>{const B=requestIdleCallback(k,typeof R=="number"?{timeout:R}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(B))}}}}();class X{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=X;async function H(k,R,B){let M;for(let J=0;J<B;J++)try{return await k()}catch(Z){M=Z,await s(R)}throw M}e.$Yg=H;class x{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,B,M){return this.a={taskId:R,cancel:()=>M?.(),promise:B},B.then(()=>this.d(R),()=>this.d(R)),B}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{let B,M;const J=new Promise((Z,se)=>{B=Z,M=se});this.b={run:R,promise:J,promiseResolve:B,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=x;class G{constructor(R,B=()=>Date.now()){this.d=R,this.f=B,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$1g=G;var V;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(V||(V={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,B)=>{this.a=R,this.b=B})}complete(R){return new Promise(B=>{this.a(R),this.d={outcome:0,value:R},B()})}error(R){return new Promise(B=>{this.b(R),this.d={outcome:1,value:R},B()})}cancel(){return this.error(new N.$3)}}e.$2g=W;var ee;(function(k){async function R(M){let J;const Z=await Promise.all(M.map(se=>se.then(le=>le,le=>{J||(J=le)})));if(typeof J<"u")throw J;return Z}k.settled=R;function B(M){return new Promise(async(J,Z)=>{try{await M(J,Z)}catch(se){Z(se)}})}k.withAsyncBody=B})(ee||(e.Promises=ee={}));var ne;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(ne||(ne={}));class re{static fromArray(R){return new re(B=>{B.emitMany(R)})}static fromPromise(R){return new re(async B=>{B.emitMany(await R)})}static fromPromises(R){return new re(async B=>{await Promise.all(R.map(async M=>B.emitOne(await M)))})}static merge(R){return new re(async B=>{await Promise.all(R.map(async M=>{for await(const J of M)B.emitOne(J)}))})}static{this.EMPTY=re.fromArray([])}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new A.$fd,queueMicrotask(async()=>{const B={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(R(B)),this.j()}catch(M){this.k(M)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(R,B){return new re(async M=>{for await(const J of R)M.emitOne(B(J))})}map(R){return re.map(this,R)}static filter(R,B){return new re(async M=>{for await(const J of R)B(J)&&M.emitOne(J)})}filter(R){return re.filter(this,R)}static coalesce(R){return re.filter(R,B=>!!B)}coalesce(){return re.coalesce(this)}static async toPromise(R){const B=[];for await(const M of R)B.push(M);return B}toPromise(){return re.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$3g=re;class Q extends re{constructor(R,B){super(B),this.l=R}cancel(){this.l.cancel()}}e.$4g=Q;function q(k){const R=new O.$pd,B=k(R.token);return new Q(R,async M=>{const J=R.token.onCancellationRequested(()=>{J.dispose(),R.dispose(),M.reject(new N.$3)});try{for await(const Z of B){if(R.token.isCancellationRequested)return;M.emitOne(Z)}J.dispose(),R.dispose()}catch(Z){J.dispose(),R.dispose(),M.reject(Z)}})}e.$5g=q}),define(oe[91],ae([0,1,18,5,48,35,16,6,27]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function f(){return Object.create(null)}e.$mj=f,e.$nj="**",e.$oj="/";const P="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(x,G){switch(x){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${G?`|${P}${E}+`:""})*?`}}function g(x,G){if(!x)return[];const V=[];let W=!1,ee=!1,ne="";for(const re of x){switch(re){case G:if(!W&&!ee){V.push(ne),ne="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=re}return ne&&V.push(ne),V}e.$pj=g;function w(x){if(!x)return"";let G="";const V=g(x,e.$oj);if(V.every(W=>W===e.$nj))G=".*";else{let W=!1;V.forEach((ee,ne)=>{if(ee===e.$nj){if(W)return;G+=l(2,ne===V.length-1)}else{let re=!1,Q="",q=!1,k="";for(const R of ee){if(R!=="}"&&re){Q+=R;continue}if(q&&(R!=="]"||!k)){let B;R==="-"?B=R:(R==="^"||R==="!")&&!k?B="^":R===e.$oj?B="":B=(0,S.$qe)(R),k+=B;continue}switch(R){case"{":re=!0;continue;case"[":q=!0;continue;case"}":{const M=`(?:${g(Q,",").map(J=>w(J)).join("|")})`;G+=M,re=!1,Q="";break}case"]":{G+="["+k+"]",q=!1,k="";break}case"?":G+=E;continue;case"*":G+=l(1);continue;default:G+=(0,S.$qe)(R)}}ne<V.length-1&&(V[ne+1]!==e.$nj||ne+2<V.length)&&(G+=P)}W=ee===e.$nj})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Ci(1e4),c=function(){return!1},n=function(){return null};function s(x,G){if(!x)return n;let V;typeof x!="string"?V=x.pattern:V=x,V=V.trim();const W=`${V}_${!!G.trimForExclusions}`;let ee=t.get(W);if(ee)return i(ee,x);let ne;return d.test(V)?ee=a(V.substr(4),V):(ne=h.exec(r(V,G)))?ee=p(ne[1],V):(G.trimForExclusions?$:o).test(V)?ee=m(V,G):(ne=y.exec(r(V,G)))?ee=u(ne[1].substr(1),V,!0):(ne=C.exec(r(V,G)))?ee=u(ne[1],V,!1):ee=v(V),t.set(W,ee),i(ee,x)}function i(x,G){if(typeof G=="string")return x;const V=function(W,ee){return(0,A.$If)(W,G.base,!I.$k)?x((0,S.$ue)(W.substr(G.base.length),D.sep),ee):null};return V.allBasenames=x.allBasenames,V.allPaths=x.allPaths,V.basenames=x.basenames,V.patterns=x.patterns,V}function r(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function a(x,G){return function(V,W){return typeof V=="string"&&V.endsWith(x)?G:null}}function p(x,G){const V=`/${x}`,W=`\\${x}`,ee=function(re,Q){return typeof re!="string"?null:Q?Q===x?G:null:re===x||re.endsWith(V)||re.endsWith(W)?G:null},ne=[x];return ee.basenames=ne,ee.patterns=[G],ee.allBasenames=ne,ee}function m(x,G){const V=X(x.slice(1,-1).split(",").map(Q=>s(Q,G)).filter(Q=>Q!==n),x),W=V.length;if(!W)return n;if(W===1)return V[0];const ee=function(Q,q){for(let k=0,R=V.length;k<R;k++)if(V[k](Q,q))return x;return null},ne=V.find(Q=>!!Q.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return re.length&&(ee.allPaths=re),ee}function u(x,G,V){const W=D.sep===D.$6d.sep,ee=W?x:x.replace(b,D.sep),ne=D.sep+ee,re=D.$6d.sep+x;let Q;return V?Q=function(q,k){return typeof q=="string"&&(q===ee||q.endsWith(ne)||!W&&(q===x||q.endsWith(re)))?G:null}:Q=function(q,k){return typeof q=="string"&&(q===ee||!W&&q===x)?G:null},Q.allPaths=[(V?"*/":"./")+x],Q}function v(x){try{const G=new RegExp(`^${w(x)}$`);return function(V){return G.lastIndex=0,typeof V=="string"&&G.test(V)?x:null}}catch{return n}}function j(x,G,V){return!x||typeof G!="string"?!1:F(x)(G,void 0,V)}e.$qj=j;function F(x,G={}){if(!x)return c;if(typeof x=="string"||T(x)){const V=s(x,G);if(V===n)return c;const W=function(ee,ne){return!!V(ee,ne)};return V.allBasenames&&(W.allBasenames=V.allBasenames),V.allPaths&&(W.allPaths=V.allPaths),W}return _(x,G)}e.$rj=F;function T(x){const G=x;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$sj=T;function z(x){return x.allBasenames||[]}e.$tj=z;function U(x){return x.allPaths||[]}e.$uj=U;function _(x,G){const V=X(Object.getOwnPropertyNames(x).map(Q=>K(Q,x[Q],G)).filter(Q=>Q!==n)),W=V.length;if(!W)return n;if(!V.some(Q=>!!Q.requiresSiblings)){if(W===1)return V[0];const Q=function(R,B){let M;for(let J=0,Z=V.length;J<Z;J++){const se=V[J](R,B);if(typeof se=="string")return se;(0,N.$tg)(se)&&(M||(M=[]),M.push(se))}return M?(async()=>{for(const J of M){const Z=await J;if(typeof Z=="string")return Z}return null})():null},q=V.find(R=>!!R.allBasenames);q&&(Q.allBasenames=q.allBasenames);const k=V.reduce((R,B)=>B.allPaths?R.concat(B.allPaths):R,[]);return k.length&&(Q.allPaths=k),Q}const ee=function(Q,q,k){let R,B;for(let M=0,J=V.length;M<J;M++){const Z=V[M];Z.requiresSiblings&&k&&(q||(q=(0,D.$ae)(Q)),R||(R=q.substr(0,q.length-(0,D.$be)(Q).length)));const se=Z(Q,q,R,k);if(typeof se=="string")return se;(0,N.$tg)(se)&&(B||(B=[]),B.push(se))}return B?(async()=>{for(const M of B){const J=await M;if(typeof J=="string")return J}return null})():null},ne=V.find(Q=>!!Q.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const re=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return re.length&&(ee.allPaths=re),ee}function K(x,G,V){if(G===!1)return n;const W=s(x,V);if(W===n)return n;if(typeof G=="boolean")return W;if(G){const ee=G.when;if(typeof ee=="string"){const ne=(re,Q,q,k)=>{if(!k||!W(re,Q))return null;const R=ee.replace("$(basename)",()=>q),B=k(R);return(0,N.$tg)(B)?B.then(M=>M?x:null):B?x:null};return ne.requiresSiblings=!0,ne}}return W}function X(x,G){const V=x.filter(Q=>!!Q.basenames);if(V.length<2)return x;const W=V.reduce((Q,q)=>{const k=q.basenames;return k?Q.concat(k):Q},[]);let ee;if(G){ee=[];for(let Q=0,q=W.length;Q<q;Q++)ee.push(G)}else ee=V.reduce((Q,q)=>{const k=q.patterns;return k?Q.concat(k):Q},[]);const ne=function(Q,q){if(typeof Q!="string")return null;if(!q){let R;for(R=Q.length;R>0;R--){const B=Q.charCodeAt(R-1);if(B===47||B===92)break}q=Q.substr(R)}const k=W.indexOf(q);return k!==-1?ee[k]:null};ne.basenames=W,ne.patterns=ee,ne.allBasenames=W;const re=x.filter(Q=>!Q.basenames);return re.push(ne),re}function H(x,G){return(0,O.$sb)(x,G,(V,W)=>typeof V=="string"&&typeof W=="string"?V===W:typeof V!="string"&&typeof W!="string"?V.base===W.base&&V.pattern===W.pattern:!1)}e.$vj=H}),define(oe[92],ae([0,1,15,10]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function A(E){return E.toJSON()}class L{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:A(N.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:A(N.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:N.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Bm=L,e.$Cm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return b.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const w=D(E[g],b,l+1);w!==null&&(E[g]=w)}}return null}function I(E,b){const l=D(E,b,0);return l===null?E:l}e.$Dm=I;function S(E,b,l,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?N.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof O.$Fd)return null;for(const w in E)if(Object.hasOwnProperty.call(E,w)){const d=S(E[w],b,l,g+1);d!==null&&(E[w]=d)}}return null}function f(E,b){const l=S(E,b,!1,0);return l===null?E:l}e.$Em=f;function P(E,b){const l=S(E,b,!0,0);return l===null?E:l}e.$Fm=P}),define(oe[31],ae([0,1,52,36,269,5,48,88,16,6,21,10]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(K,X=b.UNLINK,H){if((0,D.$Lf)(K))throw new Error("rimraf - will refuse to recursively delete root");return X===b.UNLINK?w(K):g(K,H)}async function g(K,X=(0,D.$Qf)((0,N.tmpdir)())){try{try{await O.promises.rename(K,X)}catch(H){return H.code==="ENOENT"?void 0:w(K)}w(X).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function w(K){return(0,A.promisify)(O.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function d(K){if((0,D.$Lf)(K))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(K,X){return y(await(X?o(K):(0,A.promisify)(O.readdir)(K)))}async function o(K){try{return await(0,A.promisify)(O.readdir)(K,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const X=[],H=await h(K);for(const x of H){let G=!1,V=!1,W=!1;try{const ee=await e.Promises.lstat((0,S.$9d)(K,x));G=ee.isFile(),V=ee.isDirectory(),W=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}X.push({name:x,isFile:()=>G,isDirectory:()=>V,isSymbolicLink:()=>W})}return X}function $(K){return y(O.readdirSync(K))}e.readdirSync=$;function y(K){return K.map(X=>typeof X=="string"?f.$j?(0,I.$hl)(X):X:(X.name=f.$j?(0,I.$hl)(X.name):X.name,X))}async function C(K){const X=await h(K),H=[];for(const x of X)await c.existsDirectory((0,S.$9d)(K,x))&&H.push(x);return H}function t(K,X=1e3){return new Promise(H=>{let x=!1;const G=setInterval(()=>{x||(x=!0,O.access(K,V=>{x=!1,V&&(clearInterval(G),H(void 0))}))},X)})}e.whenDeleted=t;var c;(function(K){async function X(G){let V;try{if(V=await e.Promises.lstat(G),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(f.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ee}throw W}}K.stat=X;async function H(G){try{const{stat:V,symbolicLink:W}=await K.stat(G);return V.isFile()&&W?.dangling!==!0}catch{}return!1}K.existsFile=H;async function x(G){try{const{stat:V,symbolicLink:W}=await K.stat(G);return V.isDirectory()&&W?.dangling!==!0}catch{}return!1}K.existsDirectory=x})(c||(e.SymlinkSupport=c={}));const n=new L.$Pg;function s(K,X,H){return n.queueFor(E.URI.file(K),P.$_f).queue(()=>{const x=m(H);return new Promise((G,V)=>a(K,X,x,W=>W?V(W):G()))})}let i=!0;function r(K){i=K}e.configureFlushOnWrite=r;function a(K,X,H,x){if(!i)return O.writeFile(K,X,{mode:H.mode,flag:H.flag},x);O.open(K,H.flag,H.mode,(G,V)=>{if(G)return x(G);O.writeFile(V,X,W=>{if(W)return O.close(V,()=>x(W));O.fdatasync(V,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),O.close(V,ne=>x(ne))))})})}function p(K,X,H){const x=m(H);if(!i)return O.writeFileSync(K,X,{mode:x.mode,flag:x.flag});const G=O.openSync(K,x.flag,x.mode);try{O.writeFileSync(G,X);try{O.fdatasyncSync(G)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(G)}}e.writeFileSync=p;function m(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function u(K,X,H=6e4){if(K!==X)try{f.$i&&typeof H=="number"?await v(K,X,Date.now(),H):await(0,A.promisify)(O.rename)(K,X)}catch(x){if(K.toLowerCase()!==X.toLowerCase()&&x.code==="EXDEV"||K.endsWith("."))await j(K,X,{preserveSymlinks:!1}),await l(K,b.MOVE);else throw x}}async function v(K,X,H,x,G=0){try{return await(0,A.promisify)(O.rename)(K,X)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=x)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${V}`),V;if(G===0){let W=!1;try{const{stat:ee}=await c.stat(X);ee.isFile()||(W=!0)}catch{}if(W)throw V}return await(0,L.$Hg)(Math.min(100,G*10)),v(K,X,H,x,G+1)}}async function j(K,X,H){return T(K,X,{root:{source:K,target:X},options:H,handledSourcePaths:new Set})}const F=511;async function T(K,X,H){if(H.handledSourcePaths.has(K))return;H.handledSourcePaths.add(K);const{stat:x,symbolicLink:G}=await c.stat(K);if(G){if(H.options.preserveSymlinks)try{return await _(K,X,H)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(G.dangling)return}return x.isDirectory()?z(K,X,x.mode&F,H):U(K,X,x.mode&F)}async function z(K,X,H,x){await e.Promises.mkdir(X,{recursive:!0,mode:H});const G=await h(K);for(const V of G)await T((0,S.$9d)(K,V),(0,S.$9d)(X,V),x)}async function U(K,X,H){await e.Promises.copyFile(K,X),await e.Promises.chmod(X,H)}async function _(K,X,H){let x=await e.Promises.readlink(K);(0,D.$If)(x,H.root.source,!f.$k)&&(x=(0,S.$9d)(H.root.target,x.substr(H.root.source.length+1))),await e.Promises.symlink(x,X)}e.Promises=new class{get access(){return(0,A.promisify)(O.access)}get stat(){return(0,A.promisify)(O.stat)}get lstat(){return(0,A.promisify)(O.lstat)}get utimes(){return(0,A.promisify)(O.utimes)}get read(){return(K,X,H,x,G)=>new Promise((V,W)=>{O.read(K,X,H,x,G,(ee,ne,re)=>ee?W(ee):V({bytesRead:ne,buffer:re}))})}get readFile(){return(0,A.promisify)(O.readFile)}get write(){return(K,X,H,x,G)=>new Promise((V,W)=>{O.write(K,X,H,x,G,(ee,ne,re)=>ee?W(ee):V({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,A.promisify)(O.appendFile)}get fdatasync(){return(0,A.promisify)(O.fdatasync)}get truncate(){return(0,A.promisify)(O.truncate)}get copyFile(){return(0,A.promisify)(O.copyFile)}get open(){return(0,A.promisify)(O.open)}get close(){return(0,A.promisify)(O.close)}get symlink(){return(0,A.promisify)(O.symlink)}get readlink(){return(0,A.promisify)(O.readlink)}get chmod(){return(0,A.promisify)(O.chmod)}get mkdir(){return(0,A.promisify)(O.mkdir)}get unlink(){return(0,A.promisify)(O.unlink)}get rmdir(){return(0,A.promisify)(O.rmdir)}get realpath(){return(0,A.promisify)(O.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return C}get writeFile(){return s}get rm(){return l}get rename(){return u}get copy(){return j}}}),define(oe[144],ae([0,1,52,16,6,27,31]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function I(b){if(A.$k)return b;const l=(0,N.$_d)(b);if(b===l)return b;const g=((0,N.$ae)(b)||b).toLowerCase();try{const d=(0,D.readdirSync)(l).filter(h=>h.toLowerCase()===g);if(d.length===1){const h=I(l);if(h)return(0,N.$9d)(h,d[0])}else if(d.length>1){const h=d.indexOf(g);if(h>=0){const o=I(l);if(o)return(0,N.$9d)(o,d[h])}}}catch{}return null}e.$Up=I;async function S(b){if(A.$k)return b;const l=(0,N.$_d)(b);if(b===l)return b;const g=((0,N.$ae)(b)||b).toLowerCase();try{const d=(await D.Promises.readdir(l)).filter(h=>h.toLowerCase()===g);if(d.length===1){const h=await S(l);if(h)return(0,N.$9d)(h,d[0])}else if(d.length>1){const h=d.indexOf(g);if(h>=0){const o=await S(l);if(o)return(0,N.$9d)(o,d[h])}}}catch{}return null}e.$Vp=S;async function f(b){try{return await D.Promises.realpath(b)}catch{const g=E(b);return await D.Promises.access(g,O.constants.R_OK),g}}e.$Wp=f;function P(b){try{return O.realpathSync(b)}catch{const g=E(b);return O.accessSync(g,O.constants.R_OK),g}}e.$Xp=P;function E(b){return(0,L.$ve)((0,N.$7d)(b),N.sep)}}),define(oe[145],ae([0,1,16,6,37,90,12,31]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(E=A.env){return E.comspec||"cmd.exe"}e.$ul=S;function f(E){let b=[],l=!1;const g=function(w){if(l){b.push(w);return}(!E.send(w,h=>{if(h&&console.error(h),l=!1,b.length>0){const o=b.slice(0);b=[],o.forEach($=>g($))}})||N.$i)&&(l=!0)};return{send:g}}e.$vl=f;var P;(function(E){async function b(l,g,w){if(O.$8d(l))return l;if(g===void 0&&(g=A.cwd()),O.$_d(l)!=="."||(w===void 0&&D.$jf(A.env.PATH)&&(w=A.env.PATH.split(O.$ge)),w===void 0||w.length===0))return O.$9d(g,l);async function h(o){if(await I.Promises.exists(o)){let $;try{$=await I.Promises.stat(o)}catch(y){y.message.startsWith("EACCES")&&($=await I.Promises.lstat(o))}return $?!$.isDirectory():!1}return!1}for(const o of w){let $;if(O.$8d(o)?$=O.$9d(o,l):$=O.$9d(g,o,l),await h($))return $;let y=$+".com";if(await h(y)||(y=$+".exe",await h(y)))return y}return O.$9d(g,l)}E.findExecutable=b})(P||(e.win32=P={}))}),define(oe[146],ae([0,1,64,23]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function A(D){return new Promise((I,S)=>{let f;const P=new Map;function E(l,g,w,d,h){const o=P.get(g);if(l===D||o){const $={name:b(w),cmd:w,pid:l,ppid:g,load:d,mem:h};P.set(l,$),l===D&&(f=$),o&&(o.children||(o.children=[]),o.children.push($),o.children.length>1&&(o.children=o.children.sort((y,C)=>y.pid-C.pid)))}}function b(l){const g=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,o=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(l))return"electron-crash-reporter";if(h.exec(l))return"winpty-agent";if(o.exec(l))return"conpty-agent";let y=$.exec(l);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?g.exec(l)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const C=/[a-zA-Z-]+\.js/g;let t="";do y=C.exec(l),y&&(t+=y+" ");while(y);return t&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,w)=>{te(["@vscode/windows-process-tree"],g,w)}).then(g=>{g.getProcessList(D,w=>{if(!w){S(new Error(`Root process ${D} not found`));return}g.getProcessCpuUsage(w,d=>{const h=new Map;d.forEach(o=>{const $=l(o.commandLine||"");h.set(o.pid,{name:b($),cmd:$,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),f=h.get(D),f?(h.forEach(o=>{const $=h.get(o.ppid);$&&($.children||($.children=[]),$.children.push(o))}),h.forEach(o=>{o.children&&(o.children=o.children.sort(($,y)=>$.pid-y.pid))}),I(f)):S(new Error(`Root process ${D} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let l=function(){let g=[f];const w=[];for(;g.length;){const h=g.shift();h&&(w.push(h.pid),h.children&&(g=g.concat(h.children)))}let d=JSON.stringify(N.$2f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+w.join(" "),(0,O.exec)(d,{},(h,o,$)=>{if(h||$)S(h||new Error($.toString()));else{const y=o.toString().split(`
`);for(let C=0;C<w.length;C++){const t=P.get(w[C]);t.load=parseFloat(y[C])}if(!f){S(new Error(`Root process ${D} not found`));return}I(f)}})};(0,O.exec)("which ps",{},(g,w,d)=>{if(g||d)if(process.platform!=="linux")S(g||new Error(d.toString()));else{const h=JSON.stringify(N.$2f.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(h,{},(o,$,y)=>{o||y?S(o||new Error(y.toString())):(L($,E),l())})}else{const h=w.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${h} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,y,C)=>{$||C&&!C.includes("screen size is bogus")?S($||new Error(C.toString())):(L(y,E),process.platform==="linux"?l():f?I(f):S(new Error(`Root process ${D} not found`)))})}})}})}e.$sr=A;function L(D,I){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=D.toString().split(`
`);for(const P of f){const E=S.exec(P.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,O,N){var A=arguments.length,L=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,O):N,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,O,N);else for(var I=te.length-1;I>=0;I--)(D=te[I])&&(L=(A<3?D(L):A>3?D(e,O,L):D(e,O))||L);return A>3&&L&&Object.defineProperty(e,O,L),L};define(oe[42],ae([0,1,18,5,15,26,83,8,3,2,63,27,12]),function(te,e,O,N,A,L,D,I,S,f,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var l;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(l||(l={}));function g(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function d(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));function o(G){let V=0;for(let W=0;;W+=7){const ee=G.read(1);if(V|=(ee.buffer[0]&127)<<W,!(ee.buffer[0]&128))return V}}const $=n(0);function y(G,V){if(V===0){G.write($);return}let W=0;for(let ne=V;ne!==0;ne=ne>>>7)W++;const ee=A.$Fd.alloc(W);for(let ne=0;V!==0;ne++)ee.buffer[ne]=V&127,V=V>>>7,V>0&&(ee.buffer[ne]|=128);G.write(ee)}class C{constructor(V){this.b=V,this.a=0}read(V){const W=this.b.slice(this.a,this.a+V);return this.a+=W.byteLength,W}}e.$_g=C;class t{constructor(){this.a=[]}get buffer(){return A.$Fd.concat(this.a)}write(V){this.a.push(V)}}e.$ah=t;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function n(G){const V=A.$Fd.alloc(1);return V.writeUInt8(G,0),V}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object),Uint:n(c.Int)},i=typeof Buffer<"u";function r(G,V){if(typeof V>"u")G.write(s.Undefined);else if(typeof V=="string"){const W=A.$Fd.fromString(V);G.write(s.String),y(G,W.byteLength),G.write(W)}else if(i&&Buffer.isBuffer(V)){const W=A.$Fd.wrap(V);G.write(s.Buffer),y(G,W.byteLength),G.write(W)}else if(V instanceof A.$Fd)G.write(s.VSBuffer),y(G,V.byteLength),G.write(V);else if(Array.isArray(V)){G.write(s.Array),y(G,V.length);for(const W of V)r(G,W)}else if(typeof V=="number"&&(V|0)===V)G.write(s.Uint),y(G,V);else{const W=A.$Fd.fromString(JSON.stringify(V));G.write(s.Object),y(G,W.byteLength),G.write(W)}}e.$bh=r;function a(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(o(G)).toString();case c.Buffer:return G.read(o(G)).buffer;case c.VSBuffer:return G.read(o(G));case c.Array:{const W=o(G),ee=[];for(let ne=0;ne<W;ne++)ee.push(a(G));return ee}case c.Object:return JSON.parse(G.read(o(G)).toString());case c.Int:return o(G)}}e.$ch=a;class p{constructor(V,W,ee=null,ne=1e3){this.h=V,this.j=W,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(V,W){this.b.set(V,W),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const W=this.o([V.type]);this.k?.logOutgoing(W,0,1,d(V.type));return}case 201:case 202:case 204:case 203:{const W=this.o([V.type,V.id],V.data);this.k?.logOutgoing(W,V.id,1,d(V.type),V.data);return}}}o(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const W=new C(V),ee=a(W),ne=a(W),re=ee[0];switch(re){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${g(re)}`),this.u({type:re,id:ee[1]})}}s(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=new L.$pd;let ne;try{ne=W.call(this.j,V.name,V.arg,ee.token)}catch(q){ne=Promise.reject(q)}const re=V.id;ne.then(q=>{this.m({id:re,data:q,type:201})},q=>{q instanceof Error?this.m({id:re,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:re,data:q,type:203})}).finally(()=>{Q.dispose(),this.d.delete(V.id)});const Q=(0,f.$ic)(()=>ee.cancel());this.d.set(V.id,Q)}t(V){const W=this.b.get(V.channelName);if(!W){this.v(V);return}const ee=V.id,re=W.listen(this.j,V.name,V.arg)(Q=>this.m({id:ee,data:Q,type:204}));this.d.set(V.id,re)}u(V){const W=this.d.get(V.id);W&&(W.dispose(),this.d.delete(V.id))}v(V){let W=this.g.get(V.channelName);W||(W=[],this.g.set(V.channelName,W));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:V,timeoutTimer:ee})}w(V){const W=this.g.get(V);if(W){for(const ee of W)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$fc)(this.d.values()),this.d.clear()}}e.$dh=p;var m;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class u{constructor(V,W=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=W}getChannel(V){const W=this;return{call(ee,ne,re){return W.a?Promise.reject(new I.$3):W.m(V,ee,ne,re)},listen(ee,ne){return W.a?S.Event.None:W.o(V,ee,ne)}}}m(V,W,ee,ne=L.CancellationToken.None){const re=this.g++,q={id:re,type:100,channelName:V,name:W,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new I.$3);let k;return new Promise((B,M)=>{if(ne.isCancellationRequested)return M(new I.$3);const J=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(re),B(he.data);break;case 202:{this.f.delete(re);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,M($e);break}case 203:this.f.delete(re),M(he.data);break}};this.f.set(re,ue),this.p(q)};let Z=null;this.b===h.Idle?J():(Z=(0,N.$ug)(ue=>this.u()),Z.then(()=>{Z=null,J()}));const se=()=>{Z?(Z.cancel(),Z=null):this.p({id:re,type:101}),M(new I.$3)},le=ne.onCancellationRequested(se);k=(0,f.$hc)((0,f.$ic)(se),le),this.d.add(k)}).finally(()=>{k.dispose(),this.d.delete(k)})}o(V,W,ee){const ne=this.g++,Q={id:ne,type:102,channelName:V,name:W,arg:ee};let q=null;const k=new S.$fd({onWillAddFirstListener:()=>{q=(0,N.$ug)(B=>this.u()),q.then(()=>{q=null,this.d.add(k),this.p(Q)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(k),this.p({id:ne,type:103}))}}),R=B=>k.fire(B.data);return this.f.set(ne,R),k.event}p(V){switch(V.type){case 100:case 102:{const W=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(W,V.id,0,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const W=this.q([V.type,V.id]);this.j?.logOutgoing(W,V.id,0,g(V.type));return}}}q(V,W=void 0){const ee=new t;return r(ee,V),r(ee,W),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const W=new C(V),ee=a(W),ne=a(W),re=ee[0];switch(re){case 200:return this.j?.logIncoming(V.byteLength,0,0,d(re)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,d(re),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$fc)(this.d.values()),this.d.clear()}}e.$eh=u,ye([D.$6g],u.prototype,"onDidInitializePromise",null);class v{get connections(){const V=[];return this.f.forEach(W=>V.push(W)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new S.$fd,this.onDidAddConnection=this.g.event,this.h=new S.$fd,this.onDidRemoveConnection=this.h.event,this.j=new f.$jc,this.j.add(V(({protocol:W,onDidClientDisconnect:ee})=>{const ne=S.Event.once(W.onMessage);this.j.add(ne(re=>{const Q=new C(re),q=a(Q),k=new p(W,q),R=new u(W);this.a.forEach((M,J)=>k.registerChannel(J,M));const B={channelServer:k,channelClient:R,ctx:q};this.f.add(B),this.g.fire(B),this.j.add(ee(()=>{k.dispose(),R.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,W){const ee=this;return{call(ne,re,Q){let q;if((0,b.$xf)(W)){const R=(0,O.$2b)(ee.connections.filter(W));q=R?Promise.resolve(R):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,W))}else q=W.routeCall(ee,ne,re);const k=q.then(R=>R.channelClient.getChannel(V));return F(k).call(ne,re,Q)},listen(ne,re){if((0,b.$xf)(W))return ee.k(V,W,ne,re);const Q=W.routeEvent(ee,ne,re).then(q=>q.channelClient.getChannel(V));return F(Q).listen(ne,re)}}}k(V,W,ee,ne){const re=this;let Q;const q=new S.$fd({onWillAddFirstListener:()=>{Q=new f.$jc;const k=new S.$ld,R=new Map,B=J=>{const se=J.channelClient.getChannel(V).listen(ee,ne),le=k.add(se);R.set(J,le)},M=J=>{const Z=R.get(J);Z&&(Z.dispose(),R.delete(J))};re.connections.filter(W).forEach(B),S.Event.filter(re.onDidAddConnection,W)(B,void 0,Q),re.onDidRemoveConnection(M,void 0,Q),k.event(q.fire,q,Q),Q.add(k)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return q.event}registerChannel(V,W){this.a.set(V,W);for(const ee of this.f)ee.channelServer.registerChannel(V,W)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=v;class j{constructor(V,W,ee=null){const ne=new t;r(ne,W),V.send(ne.buffer),this.a=new u(V,ee),this.d=new p(V,W,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,W){this.d.registerChannel(V,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=j;function F(G){return{call(V,W,ee){return G.then(ne=>ne.call(V,W,ee))},listen(V,W){const ee=new S.$od;return G.then(ne=>ee.input=ne.listen(V,W)),ee.event}}}e.$hh=F;function T(G){let V=!1;return{call(W,ee,ne){return V?G.call(W,ee,ne):(0,N.$Hg)(0).then(()=>V=!0).then(()=>G.call(W,ee,ne))},listen(W,ee){if(V)return G.listen(W,ee);const ne=new S.$od;return(0,N.$Hg)(0).then(()=>V=!0).then(()=>ne.input=G.listen(W,ee)),ne.event}}}e.$ih=T;class z{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const W of V.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await S.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$jh=z;var U;(function(G){function V(re,Q,q){const k=re,R=q&&q.disableMarshalling,B=new Map;for(const M in k)ee(M)&&B.set(M,S.Event.buffer(k[M],!0,void 0,Q));return new class{listen(M,J,Z){const se=B.get(J);if(se)return se;if(ne(J)){const le=k[J];if(typeof le=="function")return le.call(k,Z)}throw new I.$_(`Event not found: ${J}`)}call(M,J,Z){const se=k[J];if(typeof se=="function"){if(!R&&Array.isArray(Z))for(let le=0;le<Z.length;le++)Z[le]=(0,P.$$g)(Z[le]);return se.apply(k,Z)}throw new I.$_(`Method not found: ${J}`)}}}G.fromService=V;function W(re,Q){const q=Q&&Q.disableMarshalling;return new Proxy({},{get(k,R){if(typeof R=="string")return Q?.properties?.has(R)?Q.properties.get(R):ne(R)?function(B){return re.listen(R,B)}:ee(R)?re.listen(R):async function(...B){let M;Q&&!(0,b.$sf)(Q.context)?M=[Q.context,...B]:M=B;const J=await re.call(R,M);return q?J:(0,P.$$g)(J)};throw new I.$_(`Property not found: ${String(R)}`)}})}G.toService=W;function ee(re){return re[0]==="o"&&re[1]==="n"&&E.$Le(re.charCodeAt(2))}function ne(re){return/^onDynamic/.test(re)&&E.$Le(re.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const V=G.toString();if(V!=="[object Object]")return V}return G}function X(G){return Array.isArray(G)?G.map(K):K(G)}function H(G,V,W,ee,ne,re,Q){Q=X(Q);const q=_[ne],k=q[ee%q.length];let R=[`%c[${G}]%c[${String(V).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(re)?(R=R.concat(Q),R.push(")")):R.push(Q),console.log.apply(console,R)}class x{constructor(V,W){this.d=V,this.f=W,this.a=0,this.b=0}logOutgoing(V,W,ee,ne,re){this.b+=V,H(this.d,this.b,V,W,ee,ne,re)}logIncoming(V,W,ee,ne,re){this.a+=V,H(this.f,this.a,V,W,ee,ne,re)}}e.$kh=x}),define(oe[65],ae([0,1,15,3,2,42]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let r=0;function a(m,u){if(!i.has(m)){const v=String(++r);i.set(m,v)}return i.get(m)}function p(m,u,v,j){if(!s.enableDiagnostics)return;const F=a(m,u);if(j instanceof O.$Fd||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const T=O.$Fd.alloc(j.byteLength);T.set(j),s.records.push({timestamp:Date.now(),id:F,label:u,type:v,buff:T})}else s.records.push({timestamp:Date.now(),id:F,label:u,type:v,data:j})}s.traceSocketEvent=p})(I||(e.SocketDiagnostics=I={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let f=null;function P(){return f||(f=O.$Fd.alloc(0)),f}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const u=this.a[0];return r&&(this.a.shift(),this.b-=i),u}if(this.a[0].byteLength>i){const u=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),u}const a=O.$Fd.alloc(i);let p=0,m=0;for(;i>0;){const u=this.a[m];if(u.byteLength>i){const v=u.slice(0,i);a.set(v,p),p+=i,r&&(this.a[m]=u.slice(i),this.b-=i),i-=i}else a.set(u,p),p+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):m++,i-=u.byteLength}return a}}e.$lh=E;var b;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class w{constructor(i,r,a,p){this.type=i,this.id=r,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends A.$kc{constructor(i){super(),this.f=this.B(new N.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,p=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new w(a,p,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$Fd.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const a=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,a}h(){const i=O.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class o extends A.$kc{constructor(i){super(),this.f=new N.$fd,this.onMessage=this.f.event,this.g=new N.$fd,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new w(1,0,0,i))}}e.$mh=o;class $ extends L.$gh{static fromSocket(i,r){return new $(new o(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$nh=$;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$oh=y;class C{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,a=this.a;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new C(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<c.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+c.a)*1e3;let a=0;for(let p=0;p<c.a;p++)i-this.c[p]<=r&&a++;return 1-a/c.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??c.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$jc,this.o=i.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new w(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new w(7,0,0,P());this.p.write(i)}sendResume(){const i=new w(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new A.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new w(3,0,this.h,P());this.p.write(i);const r=this.b.toArray();for(let a=0,p=r.length;a<p;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new w(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,p=r.length;a<p;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const a=new w(1,r,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const r=new w(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,p=Date.now()-this.n;if(r>=2e4&&a>=2e4&&p>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const m=Math.max(2e4-r,2e4-a,2e4-p,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new w(3,0,this.h,P());this.p.write(i)}D(){this.h=this.g;const i=new w(9,0,this.h,P());this.p.write(i)}}e.$ph=n}),define(oe[93],ae([0,1,64,5,15,26,142,8,3,2,30,145,90,42]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class g extends l.$dh{constructor(h){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",o=>A.$Fd.wrap(Buffer.from(o,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Rp=g;class w{constructor(h,o){this.i=h,this.j=o,this.c=new Set,this.g=new Map,this.h=new S.$fd,this.onDidProcessExit=this.h.event;const $=o&&o.timeout?o.timeout:6e4;this.b=new N.$Dg($),this.d=null,this.f=null}getChannel(h){const o=this;return{call($,y,C){return o.k(h,$,y,C)},listen($,y){return o.l(h,$,y)}}}k(h,o,$,y=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$4());this.b.cancel();const C=this.n(h),t=(0,N.$ug)(s=>C.call(o,$,s)),c=y.onCancellationRequested(()=>t.cancel()),n=(0,f.$ic)(()=>t.cancel());return this.c.add(n),t.finally(()=>{c.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,o,$){if(!this.b)return S.Event.None;this.b.cancel();let y;const C=new S.$fd({onWillAddFirstListener:()=>{y=this.n(h).listen(o,$)(C.fire,C),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],o=Object.create(null);o.env={...(0,P.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(o.env={...o.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(o.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,b.$tl)(o.env),this.d=(0,O.fork)(this.i,h,o);const $=new S.$fd;S.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,D.$Np)(i)){(0,D.log)(i,`IPC Library: ${this.j.serverName}`);return}$.fire(A.$Fd.wrap(Buffer.from(i,"base64")))});const C=this.j.useQueue?(0,E.$vl)(this.d):this.d,t=i=>this.d&&this.d.connected&&C.send(i.buffer.toString("base64")),c=$.event,n={send:t,onMessage:c};this.f=new l.$eh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,f.$fc)(a)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(h){let o=this.g.get(h);return o||(o=this.m.getChannel(h),this.g.set(h,o)),o}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=w}),define(oe[147],ae([0,1,135,15,42,3,12,18]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bT=e.$aT=void 0;class S{constructor(b){this.a=b,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",l=>N.$Fd.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class f extends A.$fh{static b(b){(0,D.$tf)((0,O.$_S)(process),"Electron Utility Process");const l=new L.$fd;return process.parentPort.on("message",g=>{if(b?.handledClientConnection(g))return;const w=(0,I.$Mb)(g.ports);w&&l.fire(w)}),L.Event.map(l.event,g=>({protocol:new S(g),onDidClientDisconnect:L.Event.fromNodeEventEmitter(g,"close")}))}constructor(b){super(f.b(b))}}e.$aT=f;function P(E,b,l){const g=w=>{w.data===b&&(E.removeListener("message",g),l())};E.on("message",g)}e.$bT=P}),define(oe[66],ae([0,1,5,3,2,63,12]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var I;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function S(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$Qo=S;var f;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(f||(e.StorageState=f={}));class P extends A.$kc{static{this.a=100}constructor(l,g=Object.create(null)){super(),this.r=l,this.s=g,this.b=this.B(new N.$id),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=this.B(new O.$Eg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((g,w)=>this.w(w,g)),l.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(l,g){if(this.c===f.Closed)return;let w=!1;(0,D.$sf)(g)?w=this.f.delete(l):this.f.get(l)!==g&&(this.f.set(l,g),w=!0),w&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,g){const w=this.f.get(l);return(0,D.$sf)(w)?g:w}getBoolean(l,g){const w=this.get(l);return(0,D.$sf)(w)?g:w==="true"}getNumber(l,g){const w=this.get(l);return(0,D.$sf)(w)?g:parseInt(w,10)}getObject(l,g){const w=this.get(l);return(0,D.$sf)(w)?g:(0,L.$0g)(w)}async set(l,g,w=!1){if(this.c===f.Closed)return;if((0,D.$sf)(g))return this.delete(l,w);const d=(0,D.$lf)(g)||Array.isArray(g)?(0,L.$9g)(g):String(g);if(this.f.get(l)!==d)return this.f.set(l,d),this.j.set(l,d),this.h.delete(l),this.b.fire({key:l,external:w}),this.D()}async delete(l,g=!1){if(!(this.c===f.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:g}),this.D()}async optimize(){if(this.c!==f.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=f.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Ro=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((g,w)=>this.a.set(w,g)),l.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$So=E}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var A;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...f){switch(f.length){case 1:return(0,N.localize)(0,null,f[0]);case 2:return(0,N.localize)(1,null,f[0],f[1]);case 3:return(0,N.localize)(2,null,f[0],f[1],f[2]);default:return}}const D=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),b=S.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,b=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(I);return}const g=this.c.charCodeAt(P);if(E)E=!1;else if(g===47&&!b){P++;break}else g===91?b=!0:g===92?E=!0:g===93&&(b=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=S}),define(oe[180],ae([0,1,62,83,23,16,37,21,10]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class f{get appRoot(){return(0,L.$_d)(A.$2f.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,L.$9d)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,I.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,O.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$9d)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$ig)(S.URI.file((0,L.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$9d)(l,"argv.json")):(0,I.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,L.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.$0d)(l):(0,L.$7d)((0,L.$9d)(A.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,L.$0d)(l)):S.URI.file((0,L.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.$0d)(l);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const w=D.env.VSCODE_PORTABLE;return w?(0,L.$9d)(w,"extensions"):(0,I.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(g=>/^[^:/?#]+?:\/\//.test(g)?S.URI.parse(g):S.URI.file((0,L.$7d)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,L.$7d)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$8l.test(l))}get extensionLogLevel(){const l=[];for(const g of this.args.log||[]){const w=e.$8l.exec(g);w&&w[1]&&w[2]&&l.push([w[1],w[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.$ig)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$9d)(l,"policy.json")):(0,I.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,g,w){this.a=l,this.b=g,this.c=w,this.editSessionId=this.args.editSessionId}}e.$9l=f,ye([N.$6g],f.prototype,"appRoot",null),ye([N.$6g],f.prototype,"userHome",null),ye([N.$6g],f.prototype,"userDataPath",null),ye([N.$6g],f.prototype,"appSettingsHome",null),ye([N.$6g],f.prototype,"tmpDir",null),ye([N.$6g],f.prototype,"cacheHome",null),ye([N.$6g],f.prototype,"stateResource",null),ye([N.$6g],f.prototype,"userRoamingDataHome",null),ye([N.$6g],f.prototype,"userDataSyncHome",null),ye([N.$6g],f.prototype,"sync",null),ye([N.$6g],f.prototype,"machineSettingsResource",null),ye([N.$6g],f.prototype,"workspaceStorageHome",null),ye([N.$6g],f.prototype,"localHistoryHome",null),ye([N.$6g],f.prototype,"keyboardLayoutResource",null),ye([N.$6g],f.prototype,"argvResource",null),ye([N.$6g],f.prototype,"isExtensionDevelopment",null),ye([N.$6g],f.prototype,"untitledWorkspacesHome",null),ye([N.$6g],f.prototype,"builtinExtensionsPath",null),ye([N.$6g],f.prototype,"extensionsPath",null),ye([N.$6g],f.prototype,"extensionDevelopmentLocationURI",null),ye([N.$6g],f.prototype,"extensionDevelopmentKind",null),ye([N.$6g],f.prototype,"extensionTestsLocationURI",null),ye([N.$6g],f.prototype,"debugExtensionHost",null),ye([N.$6g],f.prototype,"logLevel",null),ye([N.$6g],f.prototype,"extensionLogLevel",null),ye([N.$6g],f.prototype,"serviceMachineIdResource",null),ye([N.$6g],f.prototype,"disableTelemetry",null),ye([N.$6g],f.prototype,"disableWorkspaceTrust",null),ye([N.$6g],f.prototype,"useInMemorySecretStorage",null),ye([N.$6g],f.prototype,"policyFile",null);function P(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$0l=P;function E(b,l,g,w,d,h){const $=Number(l||b)||(w?null:g),y=$?!!l:!1;let C;if(h)try{C=JSON.parse(h)}catch{}return{port:$,break:y,debugId:d,env:C}}e.$$l=E}),function(){"use strict";function te(e,O,N){function A(D,I){const S=L(D,I),f=[S];return e.isAbsolute(S)||f.unshift(N),e.resolve(...f)}function L(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,I);const P=D["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(E,"AppData","Roaming")}break;case"darwin":f=e.join(O.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,I)}return{getUserDataPath:A}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,O,N){return te(e,O,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=te(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class L extends N.$9l{constructor(f,P){super(f,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,A.getUserDataPath)(f,P.nameShort)},P)}}e.$_l=L;function D(S,f){return(0,N.$$l)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,f,S.extensionEnvironment)}e.$am=D;function I(S,f){return(0,N.$$l)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,f,S.extensionEnvironment)}e.$bm=I}),define(oe[183],ae([0,1,12,154]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function A(D,I,S,f){try{L(D,I,S,f)}catch(P){D.error(P?.message??P)}return I}e.$np=A;function L(D,I,S,f){const P=(E,b,l)=>{const g=E[b];if((0,O.$jf)(g)){const w=g,d=w.length;if(d>1&&w[0]==="%"&&w[d-1]==="%"){const h=w.substr(1,d-2);let o=S[h];o===void 0&&f&&(o=f[h]);const $=typeof o=="string"?o:o?.message,y=f?.[h],C=typeof y=="string"?y:y?.message;if(!$){C||D.warn(`[${I.name}]: ${(0,N.localize)(0,null,h)}`);return}if(l&&(b==="title"||b==="category")&&C&&C!==$){const t={value:$,original:C};E[b]=t}else E[b]=$}}else if((0,O.$lf)(g))for(const w in g)g.hasOwnProperty(w)&&(w==="commands"?P(g,w,!0):P(g,w,l));else if(Array.isArray(g))for(let w=0;w<g.length;w++)P(g,w,l)};for(const E in I)I.hasOwnProperty(E)&&P(I,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.$x8b=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$x8b=O;class N{constructor(L){this.a=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,I){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${D}`)}}e.$y8b=N}),define(oe[67],ae([0,1,21,89,158,53]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||D.test(h)}e.$Bo=S;function f(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=h.match(D);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}e.$Co=f;function P(h){if(!h)return null;const o=h.majorBase,$=h.majorMustEqual,y=h.minorBase;let C=h.minorMustEqual;const t=h.patchBase;let c=h.patchMustEqual;h.hasCaret&&(o===0||(C=!1),c=!1);let n=0;if(h.preRelease){const s=I.exec(h.preRelease);if(s){const[,i,r,a]=s;n=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:o,majorMustEqual:$,minorBase:y,minorMustEqual:C,patchBase:t,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:n}}e.$Do=P;function E(h,o,$){let y;typeof h=="string"?y=P(f(h)):y=h;let C;o instanceof Date?C=o.getTime():typeof o=="string"&&(C=new Date(o).getTime());let t;if(typeof $=="string"?t=P(f($)):t=$,!y||!t)return!1;const c=y.majorBase,n=y.minorBase,s=y.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const p=t.notBefore;let m=t.majorMustEqual,u=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?c>i?!0:c<i?!1:n>r?!0:n<r||C&&C<p?!1:s>=a:(c===1&&i===0&&(!m||!u||!v)&&(i=1,r=0,a=0,m=!0,u=!1,v=!1),c<i?!1:c>i?!m:n<r?!1:n>r?!u:s<a?!1:s>a?!v:!(C&&C<p))}e.$Eo=E;function b(h,o,$,y,C){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([N.default.Error,A.localize(0,null)]),t;if(typeof y.name!="string")return t.push([N.default.Error,A.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([N.default.Error,A.localize(2,null,"version")]),t;if(!y.engines)return t.push([N.default.Error,A.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([N.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!d(y.extensionDependencies))return t.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!d(y.activationEvents))return t.push([N.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([N.default.Error,A.localize(9,null,"main")]),t;{const s=(0,O.$ig)($,y.main);(0,O.$cg)(s,$)||t.push([N.default.Warning,A.localize(10,null,s.path,$.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([N.default.Error,A.localize(11,null,"browser")]),t;{const s=(0,O.$ig)($,y.browser);(0,O.$cg)(s,$)||t.push([N.default.Warning,A.localize(12,null,s.path,$.path)])}}if(!L.valid(y.version))return t.push([N.default.Error,A.localize(13,null)]),t;const c=[];if(!l(h,o,y,C,c))for(const s of c)t.push([N.default.Error,s]);return t}e.$Fo=b;function l(h,o,$,y,C){return y||typeof $.main>"u"&&typeof $.browser>"u"?!0:w(h,o,$.engines.vscode,C)}e.$Go=l;function g(h,o,$){return h==="*"||w(o,$,h)}e.$Ho=g;function w(h,o,$,y=[]){const C=P(f($));if(!C)return y.push(A.localize(14,null,$)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return y.push(A.localize(15,null,$)),!1}else if(!C.majorMustEqual)return y.push(A.localize(16,null,$)),!1;return E(h,o,C)?!0:(y.push(A.localize(17,null,h,$)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let o=0,$=h.length;o<$;o++)if(typeof h[o]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function A(L,D,I){let S=I&&I.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await D.readFile(L.serviceMachineIdResource)).value.toString();S=(0,N.$3f)(P)?P:null}catch{S=null}if(!S){S=(0,N.$4f)();try{await D.writeFile(L.serviceMachineIdResource,O.$Fd.fromString(S))}catch{}}return I?.store("storage.serviceMachineId",S,-1,1),S}e.$2o=A}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class O{constructor(A,L=[],D=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.$yh=O}),define(oe[185],ae([0,1,68]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const N=[];var A;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(I,S,f){S instanceof O.$yh||(S=new O.$yh(S,[],!!f)),N.push([I,S])}e.$mr=L;function D(){return N}e.$nr=D}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class O{constructor(L,D){this.key=L,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$4p=O;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const D of this.a.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const I=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(D);I.outgoing.set(S.key,S),S.incoming.set(I.key,I)}removeNode(L){const D=this.b(L);this.a.delete(D);for(const I of this.a.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(L){const D=this.b(L);let I=this.a.get(D);return I||(I=new O(D,L),this.a.set(D,I)),I}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[D,I]of this.a)L.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this.a){const I=new Set([L]),S=this.c(D,I);if(S)return S}}c(L,D){for(const[I,S]of L.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const f=this.c(S,D);if(f)return f;D.delete(I)}}}e.$5p=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var O;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(O||(e._util=O={})),e.$Ah=A("instantiationService");function N(D,I,S){I[O.DI_TARGET]===I?I[O.DI_DEPENDENCIES].push({id:D,index:S}):(I[O.DI_DEPENDENCIES]=[{id:D,index:S}],I[O.DI_TARGET]=I)}function A(D){if(O.serviceIds.has(D))return O.serviceIds.get(D);const I=function(S,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,S,P)};return I.toString=()=>D,O.serviceIds.set(D,I),I}e.$Bh=A;function L(D){return D}e.$Ch=L}),define(oe[187],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0,e.$77b=(0,O.$Bh)("checksumService")}),define(oe[19],ae([0,1,12,10,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,A.$Bh)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$9h=L;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$0h=D;var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=S;function f(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$_h=f;function P(h,o){const $=Object.create(null);for(const y in h)E($,y,h[y],o);return $}e.$ai=P;function E(h,o,$,y){const C=o.split("."),t=C.pop();let c=h;for(let n=0;n<C.length;n++){const s=C[n];let i=c[s];switch(typeof i){case"undefined":i=c[s]=Object.create(null);break;case"object":break;default:y(`Ignoring ${o} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}c=i}if(typeof c=="object"&&c!==null)try{c[t]=$}catch{y(`Ignoring ${o} as ${C.join(".")} is ${JSON.stringify(c)}`)}else y(`Ignoring ${o} as ${C.join(".")} is ${JSON.stringify(c)}`)}e.$bi=E;function b(h,o){const $=o.split(".");l(h,$)}e.$ci=b;function l(h,o){const $=o.shift();if(o.length===0){delete h[$];return}if(Object.keys(h).indexOf($)!==-1){const y=h[$];typeof y=="object"&&!Array.isArray(y)&&(l(y,o),Object.keys(y).length===0&&delete h[$])}}function g(h,o,$){function y(c,n){let s=c;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const C=o.split("."),t=y(h,C);return typeof t>"u"?$:t}e.$di=g;function w(h,o,$){Object.keys(o).forEach(y=>{y!=="__proto__"&&(y in h?O.$lf(h[y])&&O.$lf(o[y])?w(h[y],o[y],$):$&&(h[y]=o[y]):h[y]=o[y])})}e.$ei=w;function d(h){return h.replace(/[\[\]]/g,"")}e.$fi=d}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",O.$j),S.set("isLinux",O.$k),S.set("isWindows",O.$i),S.set("isWeb",O.$o),S.set("isMacNative",O.$j&&!O.$o),S.set("isEdge",O.$G),S.set("isFirefox",O.$E),S.set("isChrome",O.$D),S.set("isSafari",O.$F);function f(q,k){if(S.get(q)!==void 0)throw(0,I.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,k)}e.$Gi=f;const P=Object.prototype.hasOwnProperty;var E;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),g=(0,D.localize)(1,null),w=(0,D.localize)(2,null),d=(0,D.localize)(3,null),h=(0,D.localize)(4,null),o=(0,D.localize)(5,null),$=(0,D.localize)(6,null),y=(0,D.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=b){this.k=k,this.d=new A.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const R=this.l();if(!this.E()){const B=this.D(),M=B.type===17?o:void 0;throw this.h.push({message:h,offset:B.offset,lexeme:A.$Fi.getLexeme(B),additionalInfo:M}),C.c}return R}catch(R){if(R!==C.c)throw R;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const R=this.o();k.push(R)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const R=this.s();k.push(R)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const R=this.l();return this.A(1,d),R?.negate()}case 17:return this.z(),j.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const R=this.l();return this.A(1,d),R}case 17:{const R=k.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const J=M.lexeme,Z=J.lastIndexOf("/"),se=Z===J.length-1?void 0:this.w(J.substring(Z+1));let le;try{le=new RegExp(J.substring(1,Z),se)}catch{throw this.B("REGEX",M)}return K.create(R,le)}switch(M.type){case 10:case 19:{const J=[M.lexeme];this.z();let Z=this.D(),se=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let de=0;de<Z.lexeme.length;de++)Z.lexeme.charCodeAt(de)===40?se++:M.lexeme.charCodeAt(de)===41&&se--}if(se<0)break;J.push(A.$Fi.getLexeme(Z)),this.z(),Z=this.D()}const le=J.join(""),ue=le.lastIndexOf("/"),he=ue===le.length-1?void 0:this.w(le.substring(ue+1));let $e;try{$e=new RegExp(le.substring(1,ue),he)}catch{throw this.B("REGEX",M)}return t.regex(R,$e)}case 18:{const J=M.lexeme;this.z();let Z=null;if(!(0,N.$me)(J)){const se=J.indexOf("/"),le=J.lastIndexOf("/");if(se!==le&&se>=0){const ue=J.slice(se+1,le),he=J[le+1]==="i"?"i":"";try{Z=new RegExp(ue,he)}catch{throw this.B("REGEX",M)}}}if(Z===null)throw this.B("REGEX",M);return K.create(R,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const M=this.u();return t.notIn(R,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return t.equals(R,M);switch(M){case"true":return t.has(R);case"false":return t.not(R);default:return t.equals(R,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return t.notEquals(R,M);switch(M){case"true":return t.not(R);case"false":return t.has(R);default:return t.notEquals(R,M)}}case 5:return this.z(),U.create(R,this.u());case 6:return this.z(),_.create(R,this.u());case 7:return this.z(),T.create(R,this.u());case 8:return this.z(),z.create(R,this.u());case 13:return this.z(),t.in(R,this.u());default:return t.has(R)}}case 20:throw this.h.push({message:$,offset:k.offset,lexeme:"",additionalInfo:y}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,R){if(this.C(k))return this.z();throw this.B(R,this.D())}B(k,R,B){const M=(0,D.localize)(8,null,k,A.$Fi.getLexeme(R)),J=R.offset,Z=A.$Fi.getLexeme(R);return this.h.push({message:M,offset:J,lexeme:Z,additionalInfo:B}),C.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=C;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(k){return a.create(k)}static equals(k,R){return p.create(k,R)}static notEquals(k,R){return v.create(k,R)}static regex(k,R){return K.create(k,R)}static in(k,R){return m.create(k,R)}static notIn(k,R){return u.create(k,R)}static not(k){return j.create(k)}static and(...k){return x.create(k,null,!0)}static or(...k){return G.create(k,null,!0)}static greater(k,R){return T.create(k,R)}static greaterEquals(k,R){return z.create(k,R)}static smaller(k,R){return U.create(k,R)}static smallerEquals(k,R){return _.create(k,R)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$Ii=t;function c(q){const k=new C({regexParsingWithErrorRecovery:!1});return q.map(R=>(k.parse(R),k.lexingErrors.length>0?k.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,D.localize)(9,null,B.additionalInfo):(0,D.localize)(10,null),offset:B.offset,length:B.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Ji=c;function n(q,k){const R=q?q.substituteConstants():void 0,B=k?k.substituteConstants():void 0;return!R&&!B?!0:!R||!B?!1:R.equals(B)}e.$Ki=n;function s(q,k){return q.cmp(k)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$Li=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return i.INSTANCE}}e.$Mi=r;class a{static create(k,R=null){const B=S.get(k);return typeof B=="boolean"?B?r.INSTANCE:i.INSTANCE:new a(k,R)}constructor(k,R){this.key=k,this.c=R,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:W(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=S.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:i.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ni=a;class p{static create(k,R,B=null){if(typeof R=="boolean")return R?a.create(k,B):j.create(k,B);const M=S.get(k);return typeof M=="boolean"?R===(M?"true":"false")?r.INSTANCE:i.INSTANCE:new p(k,R,B)}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?r.INSTANCE:i.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Oi=p;class m{static create(k,R){return new m(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.f),B=k.getValue(this.d);return Array.isArray(R)?R.includes(B):typeof B=="string"&&typeof R=="object"&&R!==null?P.call(R,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Pi=m;class u{static create(k,R){return new u(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=11,this.c=m.create(k,R)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=u;class v{static create(k,R,B=null){if(typeof R=="boolean")return R?j.create(k,B):a.create(k,B);const M=S.get(k);return typeof M=="boolean"?R===(M?"true":"false")?i.INSTANCE:r.INSTANCE:new v(k,R,B)}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?i.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Ri=v;class j{static create(k,R=null){const B=S.get(k);return typeof B=="boolean"?B?i.INSTANCE:r.INSTANCE:new j(k,R)}constructor(k,R){this.c=k,this.d=R,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:W(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=S.get(this.c);return typeof k=="boolean"?k?i.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Si=j;function F(q,k){if(typeof q=="string"){const R=parseFloat(q);isNaN(R)||(q=R)}return typeof q=="string"||typeof q=="number"?k(q):i.INSTANCE}class T{static create(k,R,B=null){return F(R,M=>new T(k,M,B))}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Ti=T;class z{static create(k,R,B=null){return F(R,M=>new z(k,M,B))}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ui=z;class U{static create(k,R,B=null){return F(R,M=>new U(k,M,B))}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=U;class _{static create(k,R,B=null){return F(R,M=>new _(k,M,B))}constructor(k,R,B){this.c=k,this.d=R,this.f=B,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Wi=_;class K{static create(k,R){return new K(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const R=this.f?this.f.source:"",B=k.f?k.f.source:"";return R<B?-1:R>B?1:0}equals(k){if(k.type===this.type){const R=this.f?this.f.source:"",B=k.f?k.f.source:"";return this.d===k.d&&R===B}return!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Xi=K;class X{static create(k){return new X(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new X(this.c.map(k))}negate(){return this.c}}e.$Yi=X;function H(q){let k=null;for(let R=0,B=q.length;R<B;R++){const M=q[R].substituteConstants();if(q[R]!==M&&k===null){k=[];for(let J=0;J<R;J++)k[J]=q[J]}k!==null&&(k[R]=M)}return k===null?q:k}class x{static create(k,R,B){return x.d(k,R,B)}constructor(k,R){this.expr=k,this.c=R,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const M=s(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:x.create(k,this.c,!1)}evaluate(k){for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].evaluate(k))return!1;return!0}static d(k,R,B){const M=[];let J=!1;for(const Z of k)if(Z){if(Z.type===1){J=!0;continue}if(Z.type===0)return i.INSTANCE;if(Z.type===6){M.push(...Z.expr);continue}M.push(Z)}if(M.length===0&&J)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(s);for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];for(;M.length>1;){const Z=M[M.length-1];if(Z.type!==9)break;M.pop();const se=M.pop(),le=M.length===0,ue=G.create(Z.expr.map(he=>x.create([he,se],null,B)),null,le);ue&&(M.push(ue),M.sort(s))}if(M.length===1)return M[0];if(B){for(let Z=0;Z<M.length;Z++)for(let se=Z+1;se<M.length;se++)if(M[Z].negate().equals(M[se]))return i.INSTANCE;if(M.length===1)return M[0]}return new x(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new x(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());this.c=G.create(k,this,!0)}return this.c}}e.$Zi=x;class G{static create(k,R,B){return G.d(k,R,B)}constructor(k,R){this.expr=k,this.c=R,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const M=s(this.expr[R],k.expr[R]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:G.create(k,this.c,!1)}evaluate(k){for(let R=0,B=this.expr.length;R<B;R++)if(this.expr[R].evaluate(k))return!0;return!1}static d(k,R,B){let M=[],J=!1;if(k){for(let Z=0,se=k.length;Z<se;Z++){const le=k[Z];if(le){if(le.type===0){J=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){M=M.concat(le.expr);continue}M.push(le)}}if(M.length===0&&J)return i.INSTANCE;M.sort(s)}if(M.length!==0){if(M.length===1)return M[0];for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];if(B){for(let Z=0;Z<M.length;Z++)for(let se=Z+1;se<M.length;se++)if(M[Z].negate().equals(M[se]))return r.INSTANCE;if(M.length===1)return M[0]}return new G(M,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new G(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());for(;k.length>1;){const R=k.shift(),B=k.shift(),M=[];for(const J of Q(R))for(const Z of Q(B))M.push(x.create([J,Z],null,!1));k.unshift(G.create(M,null,!1))}this.c=G.create(k,this,!0)}return this.c}}e.$1i=G;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(k,R,B){super(k,null),this.f=R,typeof B=="object"?V.d.push({...B,key:k}):B!==!0&&V.d.push({key:k,description:B,type:R!=null?typeof R:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return p.create(this.key,k)}notEqualsTo(k){return v.create(this.key,k)}}e.$2i=V,e.$3i=(0,L.$Bh)("contextKeyService");function W(q,k){return q<k?-1:q>k?1:0}function ee(q,k,R,B){return q<R?-1:q>R?1:k<B?-1:k>B?1:0}function ne(q,k){if(q.type===0||k.type===1)return!0;if(q.type===9)return k.type===9?re(q.expr,k.expr):!1;if(k.type===9){for(const R of k.expr)if(ne(q,R))return!0;return!1}if(q.type===6){if(k.type===6)return re(k.expr,q.expr);for(const R of q.expr)if(ne(R,k))return!0;return!1}return q.equals(k)}e.$4i=ne;function re(q,k){let R=0,B=0;for(;R<q.length&&B<k.length;){const M=q[R].cmp(k[B]);if(M<0)return!1;M===0&&R++,B++}return R===q.length}function Q(q){return q.type===9?q.expr:[q]}}),define(oe[95],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.ID=void 0,e.ID="diagnosticsService",e.$gm=(0,O.$Bh)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}e.$hm=N;class A{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$im=A}),define(oe[96],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$Dn=(0,O.$Bh)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,O.$Bh)("environmentService"),e.$Jh=(0,O.$Ch)(e.$Ih)}),define(oe[29],ae([0,1,153,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function A(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=A;function L(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=L;function D(o,$){switch(o){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=D;function I(o,$){return $==="web"&&!o.includes("web")}e.$Vn=I;function S(o,$,y){return I($,y)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===y?!0:f(y).includes(o)}e.$Wn=S;function f(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=f;function P(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Yn=P;var E;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var g;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$Zn=(0,N.$Bh)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var d;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class h extends Error{constructor($,y){super($),this.code=y,this.name=y}}e.$1n=h,e.$2n=(0,N.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,N.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,N.$Bh)("IExtensionTipsService"),e.$7n=(0,O.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,O.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,10,92,29]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=void 0;function S(d,h){return d?L.URI.revive(h?h.transformIncoming(d):d):void 0}function f(d,h){return h?h.transformOutgoingURI(d):d}function P(d,h){h=h||D.$Cm;const o=d.manifest;return{...(0,D.$Fm)({...d,manifest:void 0},h),manifest:o}}function E(d,h){return d?.profileLocation?(0,D.$Fm)(d,h??D.$Cm):d}function b(d,h){return h?(0,A.$Xm)(d,o=>o instanceof L.URI?h.transformOutgoingURI(o):void 0):d}class l{constructor(h,o){this.a=h,this.b=o,this.onInstallExtension=O.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,o){const $=this.b(h);switch(o){case"onInstallExtension":return O.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?f(y.profileLocation,$):y.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,y=>y.map(C=>({...C,local:C.local?b(C.local,$):C.local,profileLocation:C.profileLocation?f(C.profileLocation,$):C.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?f(y.profileLocation,$):y.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?f(y.profileLocation,$):y.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,y=>b(y,$))}throw new Error("Invalid listen")}async call(h,o,$){const y=this.b(h);switch(o){case"zip":{const C=P($[0],y),t=await this.a.zip(C);return f(t,y)}case"unzip":return this.a.unzip(S($[0],y));case"install":return this.a.install(S($[0],y),E($[1],y));case"installFromLocation":return this.a.installFromLocation(S($[0],y),S($[1],y));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile($[0],S($[1],y),S($[2],y));case"getManifest":return this.a.getManifest(S($[0],y));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall($[0]);case"installFromGallery":return this.a.installFromGallery($[0],E($[1],y));case"installGalleryExtensions":{const C=$[0];return this.a.installGalleryExtensions(C.map(({extension:t,options:c})=>({extension:t,options:E(c,y)??{}})))}case"uninstall":return this.a.uninstall(P($[0],y),E($[1],y));case"reinstallFromGallery":return this.a.reinstallFromGallery(P($[0],y));case"getInstalled":return(await this.a.getInstalled($[0],S($[1],y))).map(t=>b(t,y));case"toggleAppliationScope":{const C=await this.a.toggleAppliationScope(P($[0],y),S($[1],y));return b(C,y)}case"copyExtensions":return this.a.copyExtensions(S($[0],y),S($[1],y));case"updateMetadata":{const C=await this.a.updateMetadata(P($[0],y),$[1],S($[2],y));return b(C,y)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download($[0],$[1],$[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$0o=l;class g extends N.$kc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new O.$fd),this.f=this.B(new O.$fd),this.g=this.B(new O.$fd),this.h=this.B(new O.$fd),this.j=this.B(new O.$fd),this.B(this.m.listen("onInstallExtension")(o=>this.n(this.c,{...o,source:this.r(o.source)?L.URI.revive(o.source):o.source,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(o=>this.n(this.f,o.map($=>({...$,local:$.local?P($.local,null):$.local,source:this.r($.source)?L.URI.revive($.source):$.source,profileLocation:L.URI.revive($.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(o=>this.n(this.g,{...o,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(o=>this.n(this.h,{...o,profileLocation:L.URI.revive(o.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(o=>this.j.fire(P(o,null))))}n(h,o){h.fire(o)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const o=await this.getTargetPlatform();return h.allTargetPlatforms.some($=>(0,I.$Wn)($,h.allTargetPlatforms,o))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(o=>L.URI.revive(o)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,o){return Promise.resolve(this.m.call("install",[h,o])).then($=>P($,null))}installFromLocation(h,o){return Promise.resolve(this.m.call("installFromLocation",[h,o])).then($=>P($,null))}async installExtensionsFromProfile(h,o,$){return(await this.m.call("installExtensionsFromProfile",[h,o,$])).map(C=>P(C,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,o){return Promise.resolve(this.m.call("installFromGallery",[h,o])).then($=>P($,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map($=>({...$,local:$.local?P($.local,null):$.local,source:this.r($.source)?L.URI.revive($.source):$.source,profileLocation:L.URI.revive($.profileLocation)}))}uninstall(h,o){return Promise.resolve(this.m.call("uninstall",[h,o]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(o=>P(o,null))}getInstalled(h=null,o){return Promise.resolve(this.m.call("getInstalled",[h,o])).then($=>$.map(y=>P(y,null)))}updateMetadata(h,o,$){return Promise.resolve(this.m.call("updateMetadata",[h,o,$])).then(y=>P(y,null))}toggleAppliationScope(h,o){return this.m.call("toggleAppliationScope",[h,o]).then($=>P($,null))}copyExtensions(h,o){return this.m.call("copyExtensions",[h,o])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,o,$){const y=await this.m.call("download",[h,o,$]);return L.URI.revive(y)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$$o=g;class w{constructor(h){this.a=h}listen(h,o){throw new Error("Invalid listen")}call(h,o,$){switch(o){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive($[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$_o=w}),define(oe[97],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=void 0,e.$7o=(0,O.$Bh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,D)=>te(["node-vsce-sign"],async I=>L(I),D))),this.a}async verify(L,D,I){let S;try{S=await this.b()}catch{return!1}return S.verify(L,D,I)}}e.$8o=N}),define(oe[98],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ub=e.RecommendationsNotificationResult=e.$9Ub=e.RecommendationSource=void 0;var N;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$9Ub=A;var L;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$0Ub=(0,O.$Bh)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,160,4,6,23]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,S.$Bh)("fileService");function E(W){return W.create===!0}e.$7j=E;var b;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var l;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(W){return!!(W.capabilities&2)}e.$8j=w;function d(W){return!!(W.capabilities&8)}e.$9j=d;function h(W){return!!(W.capabilities&131072)}e.$0j=h;function o(W){return!!(W.capabilities&4)}e.$$j=o;function $(W){return!!(W.capabilities&16)}e.$_j=$;function y(W){return w(W)?!!(W.capabilities&16384):!1}e.$ak=y;function C(W){return w(W)?!!(W.capabilities&32768):!1}e.$bk=C;function t(W){return!!(W.capabilities&65536)}e.$ck=t;function c(W){return!!(W.capabilities&2048)}e.$dk=c;var n;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const re=new s(ee.toString(),ne);return a(re,ne),re}constructor(ee,ne){super(ee),this.code=ne}}e.$ek=s;function i(W,ee){return s.create(W,ee)}e.$fk=i;function r(W){return W||i((0,I.localize)(0,null),n.Unknown)}e.$gk=r;function a(W,ee){return W.name=ee?`${ee} (FileSystemError)`:"FileSystemError",W}e.$hk=a;function p(W){if(!W)return n.Unknown;if(W instanceof s)return W.code;const ee=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ik=p;function m(W){if(W instanceof z)return W.fileOperationResult;switch(p(W)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$jk=m;var u;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class v{constructor(ee,ne,re){this.resource=ee,this.operation=ne,this.target=re}isOperation(ee){return this.operation===ee}}e.$kk=v;var j;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const Q of ee){const q=re.get(Q.type);switch(q?q.push([Q.resource,Q]):re.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,q]of re)switch(Q){case 1:this.a=O.$Hh.forUris(()=>ne),this.a.fill(q);break;case 0:this.b=O.$Hh.forUris(()=>ne),this.b.fill(q);break;case 2:this.c=O.$Hh.forUris(()=>ne),this.c.fill(q);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...re){if(!ee)return!1;const Q=re.length>0;return!!((!Q||re.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!Q||re.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!Q||re.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=F;function T(W,ee,ne){return!W||!ee||W===ee||ee.length>W.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,A.$Ne)(W,ee):W.indexOf(ee)===0)}e.$mk=T;class z extends Error{constructor(ee,ne,re){super(ee),this.fileOperationResult=ne,this.options=re}}e.$nk=z;class U extends z{constructor(ee,ne,re,Q){super(ee,ne,Q),this.fileOperationResult=ne,this.size=re}}e.$ok=U;class _ extends z{constructor(ee,ne,re){super(ee,2,re),this.stat=ne}}e.$pk=_;var K;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var X;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$xk="";function H(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.$yk=H;async function x(W,ee){if(!ee.hasProvider(D.URI.from({scheme:W.scheme})))return new Promise(ne=>{const re=ee.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===W.scheme&&Q.added&&(re.dispose(),ne())})})}e.$zk=x;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(ee){return(0,L.$nf)(ee)||(ee=0),ee<G.KB?(0,I.localize)(1,null,ee.toFixed(0)):ee<G.MB?(0,I.localize)(2,null,(ee/G.KB).toFixed(2)):ee<G.GB?(0,I.localize)(3,null,(ee/G.MB).toFixed(2)):ee<G.TB?(0,I.localize)(4,null,(ee/G.GB).toFixed(2)):(0,I.localize)(5,null,(ee/G.TB).toFixed(2))}}e.$Ak=G;function V(W){const ee=typeof W=="string"||W?.scheme===P.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===P.Schemas.file?1024*G.MB:ee?10*G.MB:f.$o?50*G.MB:1024*G.MB}e.$Bk=V});var Y=this&&this.__param||function(te,e){return function(O,N){e(O,N,te)}};define(oe[189],ae([0,1,69,46,11]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0;let L=class{constructor(I){this.a=I}async checksum(I){const S=(await this.a.readFileStream(I)).value;return new Promise((f,P)=>{const E=(0,O.createHash)("md5");(0,N.$xd)(S,{onData:b=>E.update(b.buffer),onError:b=>P(b),onEnd:()=>f(E.digest("base64").replace(/=+$/,""))})})}};e.$87b=L,e.$87b=L=ye([Y(0,A.$6j)],L)}),define(oe[190],ae([0,1,15,38,8,3,2,46,10,32,11]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=void 0,e.$_M="localFilesystem";class E extends D.$kc{constructor(l,g){super(),this.a=l,this.b=g,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$fd),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.h=(0,f.$4f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,g){const{buffer:w}=await this.a.call("readFile",[l,g]);return w}readFileStream(l,g,w){const d=(0,I.$td)(o=>O.$Fd.concat(o.map($=>O.$Fd.wrap($))).buffer),h=new D.$jc;return h.add(this.a.listen("readFileStream",[l,g])(o=>{if(o instanceof O.$Fd)d.write(o.buffer);else{if(o==="end")d.end();else{let $;if(o instanceof Error)$=o;else{const y=o;$=(0,P.$fk)(y.message??(0,N.$mi)(y),y.code??P.FileSystemProviderErrorCode.Unknown)}d.error($),d.end()}h.dispose()}})),h.add(w.onCancellationRequested(()=>{d.error((0,A.$4)()),d.end(),h.dispose()})),d}writeFile(l,g,w){return this.a.call("writeFile",[l,O.$Fd.wrap(g),w])}open(l,g){return this.a.call("open",[l,g])}close(l){return this.a.call("close",[l])}async read(l,g,w,d,h){const[o,$]=await this.a.call("read",[l,g,h]);return w.set(o.buffer.slice(0,$),d),$}write(l,g,w,d,h){return this.a.call("write",[l,g,O.$Fd.wrap(w),d,h])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,g){return this.a.call("delete",[l,g])}rename(l,g,w){return this.a.call("rename",[l,g,w])}copy(l,g,w){return this.a.call("copy",[l,g,w])}cloneFile(l,g){return this.a.call("cloneFile",[l,g])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const g=l;this.f.fire(g.map(w=>({resource:S.URI.revive(w.resource),type:w.type})))}else{const g=l;this.g.fire(g)}}))}watch(l,g){const w=(0,f.$4f)();return this.a.call("watch",[this.h,w,l,g]),(0,D.$ic)(()=>this.a.call("unwatch",[this.h,w]))}}e.$aN=E}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(P,E,b,l,g,w){let d;try{await I(P,E,b,l,g,w)}catch(h){d=h}finally{d&&g.errorTransformer&&(d=g.errorTransformer(d)),typeof d<"u"&&b.error(d),b.end()}}e.$Cp=D;async function I(P,E,b,l,g,w){S(w);const d=await P.open(E,{create:!1});try{S(w);let h=0,o=0,$=g&&typeof g.length=="number"?g.length:void 0,y=O.$Fd.alloc(Math.min(g.bufferSize,typeof $=="number"?$:g.bufferSize)),C=g&&typeof g.position=="number"?g.position:0,t=0;do o=await P.read(d,C,y.buffer,t,y.byteLength-t),C+=o,t+=o,h+=o,typeof $=="number"&&($-=o),t===y.byteLength&&(await b.write(l(y)),y=O.$Fd.alloc(Math.min(g.bufferSize,typeof $=="number"?$:g.bufferSize)),t=0);while(o>0&&(typeof $!="number"||$>0)&&S(w)&&f(h,g));if(t>0){let c=t;typeof $=="number"&&(c=Math.min(t,$)),b.write(l(y.slice(0,c)))}}catch(h){throw(0,L.$gk)(h)}finally{await P.close(d)}}function S(P){if(P.isCancellationRequested)throw(0,N.$4)();return!0}function f(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,L.$fk)((0,A.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,91,2,16,6,10,11]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function S(h){return h.recursive===!0}e.$Ep=S;class f extends N.$kc{static{this.a=5}constructor(o,$,y,C){super(),this.h=o,this.j=$,this.m=y,this.n=C,this.c=this.B(new N.$lc),this.f=void 0,this.g=0}s(){const o=new N.$jc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile($=>this.h($))),o.add(this.b.onDidLogMessage($=>this.j($))),o.add(this.b.onDidError($=>this.t($)))}t(o){this.n.restartOnError?this.g<f.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=f;class P extends f{constructor(o,$,y){super(o,$,y,{type:"node.js",restartOnError:!1})}}e.$Gp=P;class E extends f{constructor(o,$,y){super(o,$,y,{type:"universal",restartOnError:!0})}}e.$Hp=E;function b(h){return h.map(o=>({type:o.type,resource:D.URI.file(o.path)}))}e.$Ip=b;function l(h){const o=new d;for(const $ of h)o.processEvent($);return o.coalesce()}e.$Jp=l;function g(h,o){return typeof o=="string"&&!o.startsWith(O.$nj)&&!(0,A.$8d)(o)?{base:h,pattern:o}:o}e.$Kp=g;function w(h,o){const $=[];for(const y of o)$.push((0,O.$rj)(g(h,y)));return $}e.$Lp=w;class d{constructor(){this.a=new Set,this.b=new Map}c(o){return L.$k?o.path:o.path.toLowerCase()}processEvent(o){const $=this.b.get(this.c(o));let y=!1;if($){const C=$.type,t=o.type;$.path!==o.path&&(o.type===2||o.type===1)?y=!0:C===1&&t===2?(this.b.delete(this.c(o)),this.a.delete($)):C===2&&t===1?$.type=0:C===1&&t===0||($.type=t)}else y=!0;y&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],$=[];return Array.from(this.a).filter(y=>y.type!==2?(o.push(y),!1):!0).sort((y,C)=>y.path.length-C.path.length).filter(y=>$.some(C=>(0,I.$mk)(y.path,C,!L.$k))?!1:($.push(y.path),!0)).concat(o)}}}),define(oe[191],ae([0,1,52,5,26,48,2,88,16,6,144,31,54]),function(te,e,O,N,A,L,D,I,S,f,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class l extends D.$kc{static{this.a=100}static{this.b=75}constructor(d,h,o,$){super(),this.m=d,this.n=h,this.r=o,this.s=$,this.c=this.B(new N.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.n(y))),this.f=this.B(new N.$Ug(y=>this.z(y),l.b)),this.g=(0,b.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,b.$Lp)(this.m.path,this.m.includes):void 0,this.j=new A.$pd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await E.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await E.Promises.realpath(d.path),d.path===h&&(h=await(0,P.$Vp)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(f.$j&&(0,L.$If)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$kc.None;const o=new A.$pd(this.j.token),$=new D.$jc;try{const y=(0,S.$ae)(d),C=(0,O.watch)(d);$.add((0,D.$ic)(()=>{C.removeAllListeners(),C.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(h)try{for(const n of await E.Promises.readdir(d))t.add(n)}catch(n){this.D(n)}const c=new Map;$.add((0,D.$ic)(()=>{for(const[,n]of c)n.dispose();c.clear()})),C.on("error",(n,s)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),C.on("change",(n,s)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${n}"] ${s}`);let i="";if(s&&(i=s.toString(),f.$j&&(i=(0,I.$hl)(i))),!(!i||n!=="change"&&n!=="rename"))if(h)if(n==="rename"){c.get(i)?.dispose();const r=setTimeout(async()=>{if(c.delete(i),i===y&&!await E.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.C((0,S.$9d)(d,i));if(o.token.isCancellationRequested)return;let p;a?t.has(i)?p=0:(p=1,t.add(i)):(t.delete(i),p=2),this.y({path:(0,S.$9d)(this.m.path,i),type:p})},l.a);c.set(i,(0,D.$ic)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.y({path:(0,S.$9d)(this.m.path,i),type:r})}else if(n==="rename"||i!==y){const r=setTimeout(async()=>{const a=await E.Promises.exists(d);o.token.isCancellationRequested||(a?(this.y({path:this.m.path,type:0},!0),$.add(await this.w(d,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},l.a);$.clear(),$.add((0,D.$ic)(()=>clearTimeout(r)))}else this.y({path:this.m.path,type:0},!0)})}catch(y){await E.Promises.exists(d)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${y.toString()})`)}return(0,D.$ic)(()=>{o.dispose(!0),$.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!h&&this.g.some(o=>o(d.path))?this.s&&this.G(` >> ignored (excluded) ${d.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(o=>o(d.path))?this.s&&this.G(` >> ignored (not included) ${d.path}`):this.f.work(d))}z(d){const h=(0,b.$Jp)(d);if(h.length>0){if(this.s)for(const $ of h)this.G(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(f.$k)return E.Promises.exists(d);try{const h=(0,S.$ae)(d);return(await E.Promises.readdir((0,S.$_d)(d))).some($=>$===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=l;async function g(w,d,h,o,$=512){const y=await E.Promises.open(w,"r"),C=Buffer.allocUnsafe($),t=new A.$pd(o);let c,n=!1;const s={path:w,excludes:[],recursive:!1},i=new l(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:p}=await E.Promises.read(y,C,0,$,null);if(!p||t.token.isCancellationRequested)break;d(C.slice(0,p))}}catch(p){c=new Error(p),t.dispose(!0)}finally{n=!1}}})()});return await i.ready,h(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await E.Promises.close(y)}catch(p){c=new Error(p)}c?a(c):r()})})}e.$Zp=g}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class I extends A.$kc{constructor(){super(...arguments),this.a=this.B(new O.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$fd),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(f){const P=this.j(f),E=P.filter(l=>{const g=this.c.get(l.path);return g?!(0,N.$vj)(g.request.excludes,l.excludes)||!(0,N.$vj)(g.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!P.find(g=>g.path===l.path&&(0,N.$vj)(g.excludes,l.excludes)&&(0,N.$vj)(g.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(f){const P=new D.$Yp(f,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:f,instance:P};this.c.set(f.path,E)}async stop(){for(const[f]of this.c)this.h(f);this.c.clear()}h(f){const P=this.c.get(f);P&&(this.c.delete(f),P.instance.dispose())}j(f){const P=new Map;for(const E of f){const b=L.$k?E.path:E.path.toLowerCase();P.set(b,E)}return Array.from(P.values())}async setVerboseLogging(f){this.f=f;for(const[,P]of this.c)P.instance.setVerboseLogging(f)}m(f){this.f&&this.b.fire({type:"trace",message:this.n(f)})}n(f,P){return P?`[File Watcher (node.js)] ${f} (path: ${P.request.path})`:`[File Watcher (node.js)] ${f}`}}e.$1p=I}),define(oe[193],ae([0,1,54,192]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class A extends O.$Gp{constructor(D,I,S){super(D,I,S),this.s()}r(D){return D.add(new N.$1p)}}e.$2p=A}),define(oe[194],ae([0,1,23,42,93,54]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class D extends L.$Hp{constructor(S,f,P){super(S,f,P),this.s()}r(S){const f=S.add(new A.$Sp(O.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(f.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$ih)(f.getChannel("watcher")))}}e.$Tp=D}),define(oe[70],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class O{constructor(...A){this.a=new Map;for(const[L,D]of A)this.set(L,D)}set(A,L){const D=this.a.get(A);return this.a.set(A,L),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$zh=O}),define(oe[195],ae([0,1,5,8,2,68,186,4,70,87]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const P=!1;class E extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class b{constructor(d=new S.$zh,h=!1,o,$=P){this.f=d,this.g=h,this.h=o,this.i=$,this.o=new Set,this.f.set(I.$Ah,this),this._globalGraph=$?o?._globalGraph??new D.$5p(y=>y):void 0}createChild(d){return new b(d,this.g,this,this.i)}invokeFunction(d,...h){const o=g.traceInvocation(this.i,d);let $=!1;try{return d({get:C=>{if($)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(C,o);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...h)}finally{$=!0,o.stop()}}createInstance(d,...h){let o,$;return d instanceof L.$yh?(o=g.traceCreation(this.i,d.ctor),$=this.j(d.ctor,d.staticArguments.concat(h),o)):(o=g.traceCreation(this.i,d),$=this.j(d,h,o)),o.stop(),$}j(d,h=[],o){const $=I._util.getServiceDependencies(d).sort((t,c)=>t.index-c.index),y=[];for(const t of $){const c=this.m(t.id,o);c||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(c)}const C=$.length>0?$[0].index:h.length;if(h.length!==C){console.trace(`[createInstance] First service dependency of ${d.name} at position ${C+1} conflicts with ${h.length} static arguments`);const t=C-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,C)}return Reflect.construct(d,h.concat(y))}k(d,h){if(this.f.get(d)instanceof L.$yh)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const o=this.l(d);return o instanceof L.$yh?this.q(d,o,h.branch(d,!0)):(h.branch(d,!1),o)}q(d,h,o){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,o)}finally{this.o.delete(d)}}r(d,h,o){const $=new D.$5p(t=>t.id.toString());let y=0;const C=[{id:d,desc:h,_trace:o}];for(;C.length;){const t=C.pop();if($.lookupOrInsertNode(t),y++>1e3)throw new E($);for(const c of I._util.getServiceDependencies(t.desc.ctor)){const n=this.l(c.id);if(n||this.u(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),n instanceof L.$yh){const s={id:c.id,desc:n,_trace:t._trace.branch(c.id,!0)};$.insertEdge(t,s),C.push(s)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new E($);break}for(const{data:c}of t){if(this.l(c.id)instanceof L.$yh){const s=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,s)}$.removeNode(c)}}return this.l(d)}s(d,h,o=[],$,y){if(this.f.get(d)instanceof L.$yh)return this.t(d,h,o,$,y);if(this.h)return this.h.s(d,h,o,$,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,o=[],$,y){if($){const C=new b(void 0,this.g,this,this.i);C.c=String(d);const t=new Map,c=new O.$Xg(()=>{const n=C.j(h,o,y);for(const[s,i]of t){const r=n[s];if(typeof r=="function")for(const a of i)r.apply(n,a)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=t.get(s);return a||(a=new f.$tc,t.set(s,a)),(m,u,v)=>{const j=a.push([m,u,v]);return(0,A.$ic)(j)}}if(s in n)return n[s];const i=c.value;let r=i[s];return typeof r!="function"||(r=r.bind(i),n[s]=r),r},set(n,s,i){return c.value[s]=i,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,o,y)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.$6p=b;var l;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(l||(l={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,h){return d?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(d,h){return d?new g(1,h.name):g.c}static{this.f=0}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const o=new g(3,d.toString());return this.h.push([d,h,o]),o}stop(){const d=Date.now()-this.g;g.f+=d;let h=!1;function o(y,C){const t=[],c=new Array(y+1).join("	");for(const[n,s,i]of C.h)if(s&&i){h=!0,t.push(`${c}CREATES -> ${n}`);const r=o(y+1,i);r&&t.push(r)}else t.push(`${c}uses -> ${n}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${o(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(d>2||h)&&g.all.add($.join(`
`))}}e.$7p=g}),define(oe[71],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=e.$E7b=void 0,e.$E7b=(0,O.$Bh)("mainProcessService");class N{constructor(L,D){this.a=L,this.b=D}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,D){this.a.registerChannel(L,D)}}e.$F7b=N}),define(oe[72],ae([0,1,26,2,6,163,29,4]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=void 0;function S(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Hq=S,e.$Iq=(0,I.$Bh)("languagePackService");let f=class extends N.$kc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new O.$pd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=b.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some(d=>d.startsWith("lp-"))).map(w=>{const d=w.properties.localizedLanguages?.[0],h=S(w);return{...this.f(h,d,w),extensionId:w.identifier.id,galleryExtension:w}});return g.push(this.f("en","English")),g}f(E,b,l){const g=b??E;let w;if(g!==E&&(w=`(${E})`),E.toLowerCase()===A.$v.toLowerCase()&&(w??="",w+=(0,L.localize)(0,null)),l?.installCount){w??="";const d=l.installCount;let h;d>1e6?h=`${Math.floor(d/1e5)/10}M`:d>1e3?h=`${Math.floor(d/1e3)}K`:h=String(d),w+=` $(cloud-download) ${h}`}return{id:E,label:g,description:w}}};e.$Jq=f,e.$Jq=f=ye([Y(0,D.$Zn)],f)}),define(oe[196],ae([0,1,2,72]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=void 0;let A=class extends O.$kc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$47b=A,e.$47b=A=ye([Y(0,N.$Iq)],A)}),define(oe[7],ae([0,1,38,3,51,2,35,6,21,12,10,94,4]),function(te,e,O,N,A,L,D,I,S,f,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,b.$Bh)("logService"),e.$6i=(0,b.$Bh)("loggerService");function l(){return new Date().toISOString()}function g(m){return(0,f.$nf)(m)}e.$7i=g;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8i=w.Info;function d(m,u,v){switch(u){case w.Trace:m.trace(v);break;case w.Debug:m.debug(v);break;case w.Info:m.info(v);break;case w.Warning:m.warn(v);break;case w.Error:m.error(v);break;case w.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=d;function h(m,u=!1){let v="";for(let j=0;j<m.length;j++){let F=m[j];if(F instanceof Error&&(F=(0,O.$mi)(F,u)),typeof F=="object")try{F=JSON.stringify(F)}catch{}v+=(j>0?" ":"")+F}return v}class o extends L.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new N.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==w.Off&&this.b<=u}}e.$0i=o;class $ extends o{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...v){this.f(w.Trace)&&this.g(w.Trace,h([u,...v],!0))}debug(u,...v){this.f(w.Debug)&&this.g(w.Debug,h([u,...v]))}info(u,...v){this.f(w.Info)&&this.g(w.Info,h([u,...v]))}warn(u,...v){this.f(w.Warning)&&this.g(w.Warning,h([u,...v]))}error(u,...v){if(this.f(w.Error))if(u instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=u.stack,this.g(w.Error,h(j))}else this.g(w.Error,h([u,...v]))}flush(){}}e.$$i=$;class y extends o{constructor(u=e.$8i){super(),this.setLevel(u),this.g=!I.$i}trace(u,...v){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...v):console.log(`[main ${l()}]`,u,...v))}debug(u,...v){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...v):console.log(`[main ${l()}]`,u,...v))}info(u,...v){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...v):console.log(`[main ${l()}]`,u,...v))}warn(u,...v){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...v):console.warn(`[main ${l()}]`,u,...v))}error(u,...v){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...v):console.error(`[main ${l()}]`,u,...v))}dispose(){}flush(){}}e.$_i=y;class C extends o{constructor(u=e.$8i,v=!0){super(),this.g=v,this.setLevel(u)}trace(u,...v){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...v):console.log(u,...v))}debug(u,...v){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...v):console.log(u,...v))}info(u,...v){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...v):console.log(u,...v))}warn(u,...v){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...v):console.log(u,...v))}error(u,...v){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...v):console.error(u,...v))}dispose(){}flush(){}}e.$aj=C;class t extends o{constructor(u,v=e.$8i){super(),this.g=u,this.setLevel(v)}trace(u,...v){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(u),...v])}debug(u,...v){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(u),...v])}info(u,...v){this.f(w.Info)&&this.g.log(w.Info,[this.h(u),...v])}warn(u,...v){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(u),...v])}error(u,...v){this.f(w.Error)&&this.g.log(w.Error,[this.h(u),...v])}h(u){return typeof u=="string"?u:(0,O.$mi)(u,this.f(w.Trace))}dispose(){}flush(){}}e.$bj=t;class c extends o{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const v of this.g)v.setLevel(u);super.setLevel(u)}trace(u,...v){for(const j of this.g)j.trace(u,...v)}debug(u,...v){for(const j of this.g)j.debug(u,...v)}info(u,...v){for(const j of this.g)j.info(u,...v)}warn(u,...v){for(const j of this.g)j.warn(u,...v)}error(u,...v){for(const j of this.g)j.error(u,...v)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$cj=c;class n extends L.$kc{constructor(u,v,j){if(super(),this.h=u,this.j=v,this.b=new D.$zi,this.c=this.B(new N.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$fd),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(u){return(0,f.$jf)(u)?[...this.b.values()].find(v=>v.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,v){const j=this.n(u),F=(0,f.$jf)(u)?u:v?.id??(0,A.$pi)(j.toString()).toString(16);let T=this.b.get(j)?.logger;const z=v?.logLevel==="always"?w.Trace:v?.logLevel;T||(T=this.s(j,z??this.getLogLevel(j)??this.h,{...v,id:F}));const U={logger:T,info:{resource:j,id:F,logLevel:z,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(U.info),this.b.set(j,U),T}n(u){return(0,f.$jf)(u)?(0,S.$ig)(this.j,`${u}.log`):u}setLogLevel(u,v){if(P.URI.isUri(u)){const j=u,F=v,T=this.b.get(j);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([j,F]))}else{this.h=u;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,v){const j=this.m(u);j&&v!==!j.info.hidden&&(j.info.hidden=!v,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,v]))}getLogLevel(u){let v;return u&&(v=this.b.get(u)?.info.logLevel),v??this.h}registerLogger(u){const v=this.b.get(u.resource);v?v.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const v=this.b.get(u);v&&(v.logger&&v.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=n;class s{constructor(){this.onDidChangeLogLevel=new N.$fd().event}setLevel(u){}getLevel(){return w.Info}trace(u,...v){}debug(u,...v){}info(u,...v){}warn(u,...v){}error(u,...v){}critical(u,...v){}dispose(){}flush(){}}e.$ej=s;class i extends s{}e.$fj=i;function r(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const u=p(m.logLevel.toLowerCase());if(u!==void 0)return u}return e.$8i}e.$gj=r;function a(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$hj=a;function p(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ij=p,e.$jj=new E.$2i("logLevel",a(w.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,21,31,14,7]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;let E=class extends A.$kc{constructor(l,g){super(),this.a=l,this.b=g,this.B(new O.$Sg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,I.$fg)(this.a.logsHome),g=(0,I.$hg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,h=(await S.Promises.readdir(g)).filter($=>/^\d{8}T\d{6}$/.test($)).sort().filter($=>$!==l),o=h.slice(0,Math.max(0,h.length-9));o.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${o.join(", ")}'`),await Promise.all(o.map($=>S.Promises.rm((0,D.$9d)(g,$)))))}catch(l){(0,N.$Y)(l)}}};e.$57b=E,e.$57b=E=ye([Y(0,f.$Ih),Y(1,P.$5i)],E)}),define(oe[198],ae([0,1,18,5,8,3,2,16,54,7]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class P extends D.$kc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new L.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Eg(0)),this.w=[],this.y=this.B(new N.$Eg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive},w=(0,O.$Sb)(this.j,g);return this.r(),(0,D.$ic)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,A.$Y)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Ip)(l)),l=>this.G(l),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,S.$Ep)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,S.$Ep)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1},w=(0,O.$Sb)(this.w,g);return this.C(),(0,D.$ic)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,A.$Y)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,S.$Ip)(b)),b=>this.G(b),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,I.$7d)(b.fsPath)}}e.$Mp=P}),define(oe[199],ae([0,1,18,5,15,26,3,51,59,2,47,23,100,21,46,159,11,99,7,8]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let y=class extends f.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$Pg)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const n=new f.$jc;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),n.add(c.onDidChangeFile(s=>this.X.fire(new d.$lk(s,!this.S(c))))),typeof c.onDidWatchError=="function"&&n.add(c.onDidWatchError(s=>this.Y.fire(new Error(s)))),n.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,f.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,f.$fc)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(n){c.push(n)}}),!this.h.has(t)&&await N.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return S.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,l.$mg)(t))throw new d.$nk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const n=new $.$_;throw n.message=(0,w.localize)(1,null,t.toString()),n}return c}async m(t){const c=await this.j(t);if((0,d.$$j)(c)||(0,d.$8j)(c)||(0,d.$_j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const c=await this.j(t);if((0,d.$$j)(c)||(0,d.$8j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.s(t,c)}catch(n){throw(0,d.$ik)(n)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nk((0,w.localize)(2,null,this.rb(t)),1):(0,d.$gk)(n)}}async s(t,c){const n=await this.j(t),s=this.S(n),i=c?.resolveTo,r=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,p=await n.stat(t);let m;return this.t(n,t,p,void 0,!!a,(u,v)=>(m||(m=P.$Hh.forUris(()=>!s),m.set(t,!0),i&&m.fill(!0,i)),m.get(u.resource)||m.findSuperstr(u.resource.with({query:null,fragment:null}))?!0:u.isDirectory&&r?v===1:!1))}async t(t,c,n,s,i,r){const{providerExtUri:a}=this.R(t),p={resource:c,name:a.basename(c),isFile:(n.type&d.FileType.File)!==0,isDirectory:(n.type&d.FileType.Directory)!==0,isSymbolicLink:(n.type&d.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yk)({mtime:n.mtime,size:n.size}),children:void 0};if(p.isDirectory&&r(p,s)){try{const m=await t.readdir(c),u=await N.Promises.settled(m.map(async([v,j])=>{try{const F=a.joinPath(c,v),T=i?await t.stat(F):{type:j};return await this.t(t,F,T,m.length,i,r)}catch(F){return this.b.trace(F),null}}));p.children=(0,O.$Fb)(u)}catch(m){this.b.trace(m),p.children=[]}return p}return p}async resolveAll(t){return N.Promises.settled(t.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),n=await c.stat(t);return this.t(c,t,n,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.u(t,c)}catch(n){return n}return!0}async u(t,c){if(!c?.overwrite&&await this.exists(t))throw new d.$nk((0,w.localize)(3,null,this.rb(t)),3,c)}async createFile(t,c=A.$Fd.fromString(""),n){await this.u(t,n);const s=await this.writeFile(t,c);return this.r.fire(new d.$kk(t,0,s)),s}async writeFile(t,c,n){const s=this.pb(await this.n(t),t),{providerExtUri:i}=this.R(s);let r=n;if((0,d.$bk)(s)&&!r?.atomic){const a=s.enforceAtomicWriteFile?.(t);a&&(r={...n,atomic:a})}try{await this.w(s,t,r)||await this.U(s,i.dirname(t));let p;if((0,d.$8j)(s)&&!(c instanceof A.$Fd))if((0,g.$rd)(c)){const m=await(0,g.$yd)(c,3);m.ended?p=A.$Fd.concat(m.buffer):p=m}else p=(0,g.$vd)(c,m=>A.$Fd.concat(m),3);else p=c;if(!(0,d.$$j)(s)||(0,d.$8j)(s)&&p instanceof A.$Fd||(0,d.$8j)(s)&&(0,d.$bk)(s)&&r?.atomic)await this.gb(s,t,r,p);else{const m=p instanceof A.$Fd?(0,A.$Qd)(p):p;r?.atomic!==!1&&r?.atomic?.postfix?await this.bb(s,t,(0,l.$ig)((0,l.$hg)(t),`${(0,l.$fg)(t)}${r.atomic.postfix}`),r,m):await this.cb(s,t,r,m)}this.r.fire(new d.$kk(t,4))}catch(a){throw new d.$nk((0,w.localize)(4,null,this.rb(t),(0,d.$gk)(a).toString()),(0,d.$jk)(a),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,c,n){const s=!!n?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(c)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(c)));if(s)throw new Error((0,w.localize)(7,null,this.rb(c)))}let r;try{r=await t.stat(c)}catch{return}if(r.type&d.FileType.Directory)throw new d.$nk((0,w.localize)(8,null,this.rb(c)),0,n);if(this.qb(c,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==d.$xk&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,d.$yk)({mtime:n.mtime,size:r.size}))throw new d.$nk((0,w.localize)(9,null),3,n);return r}async readFile(t,c,n){const s=await this.m(t);return c?.atomic?this.z(s,t,c,n):this.C(s,t,c,n)}async z(t,c,n,s){return new Promise((i,r)=>{this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{try{const a=await this.C(t,c,n,s);i(a)}catch(a){r(a)}})})}async C(t,c,n,s){const i=await this.D(t,c,{...n,preferUnbuffered:!0},s);return{...i,value:await(0,A.$Rd)(i.value)}}async readFileStream(t,c,n){const s=await this.m(t);return this.D(s,t,c,n)}async D(t,c,n,s){const i=new L.$pd(s);let r=n;(0,d.$ak)(t)&&t.enforceAtomicReadFile?.(c)&&(r={...n,atomic:!0});const a=this.J(c,r).then(m=>m,m=>{throw i.dispose(!0),m});let p;try{return typeof r?.etag=="string"&&r.etag!==d.$xk&&await a,r?.atomic&&(0,d.$ak)(t)||!((0,d.$$j)(t)||(0,d.$_j)(t))||(0,d.$8j)(t)&&r?.preferUnbuffered?p=this.I(t,c,r):(0,d.$_j)(t)?p=this.G(t,c,i.token,r):p=this.H(t,c,i.token,r),p.on("end",()=>i.dispose()),p.on("error",()=>i.dispose()),{...await a,value:p}}catch(m){throw p&&await(0,g.$wd)(p),this.F(m,c,r)}}F(t,c,n){const s=(0,w.localize)(10,null,this.rb(c),(0,d.$gk)(t).toString());return t instanceof d.$pk?new d.$pk(s,t.stat,n):t instanceof d.$ok?new d.$ok(s,t.fileOperationResult,t.size,t.options):new d.$nk(s,(0,d.$jk)(t),n)}G(t,c,n,s=Object.create(null)){const i=t.readFileStream(c,s,n);return(0,g.$Cd)(i,{data:r=>r instanceof A.$Fd?r:A.$Fd.wrap(r),error:r=>this.F(r,c,s)},r=>A.$Fd.concat(r))}H(t,c,n,s=Object.create(null)){const i=(0,A.$Vd)();return(0,h.$Cp)(t,c,i,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,c,s)},n),i}I(t,c,n){const s=(0,g.$td)(i=>A.$Fd.concat(i));return(async()=>{try{let i;n?.atomic&&(0,d.$ak)(t)?i=await t.readFile(c,{atomic:!0}):i=await t.readFile(c),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.L(c,i.byteLength,n),s.end(A.$Fd.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async J(t,c){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new d.$nk((0,w.localize)(11,null,this.rb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==d.$xk&&c.etag===n.etag)throw new d.$pk((0,w.localize)(12,null),n,c);return this.L(t,n.size,c),n}L(t,c,n){if(typeof n?.limits?.size=="number"&&c>n.limits.size)throw new d.$ok((0,w.localize)(13,null,this.rb(t)),7,c,n)}async canMove(t,c,n){return this.M(t,c,"move",n)}async canCopy(t,c,n){return this.M(t,c,"copy",n)}async M(t,c,n,s){if(t.toString()!==c.toString())try{const i=n==="move"?this.pb(await this.n(t),t):await this.m(t),r=this.pb(await this.n(c),c);await this.Q(i,t,r,c,n,s)}catch(i){return i}return!0}async move(t,c,n){const s=this.pb(await this.n(t),t),i=this.pb(await this.n(c),c),r=await this.N(s,t,i,c,"move",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,r==="move"?2:3,a)),a}async copy(t,c,n){const s=await this.m(t),i=this.pb(await this.n(c),c),r=await this.N(s,t,i,c,"copy",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,r==="copy"?3:2,a)),a}async N(t,c,n,s,i,r){if(c.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:p}=await this.Q(t,c,n,s,i,r);if(a&&!p&&r&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),i==="copy"){if(t===n&&(0,d.$9j)(t))await t.copy(c,s,{overwrite:r});else{const m=await this.resolve(c);m.isDirectory?await this.P(t,m,n,s):await this.O(t,c,n,s)}return i}else return t===n?(await t.rename(c,s,{overwrite:r}),i):(await this.N(t,c,n,s,"copy",r),await this.del(c,{recursive:!0}),"copy")}async O(t,c,n,s){if((0,d.$$j)(t)&&(0,d.$$j)(n))return this.ib(t,c,n,s);if((0,d.$$j)(t)&&(0,d.$8j)(n))return this.ob(t,c,n,s);if((0,d.$8j)(t)&&(0,d.$$j)(n))return this.mb(t,c,n,s);if((0,d.$8j)(t)&&(0,d.$8j)(n))return this.kb(t,c,n,s)}async P(t,c,n,s){await n.mkdir(s),Array.isArray(c.children)&&await N.Promises.settled(c.children.map(async i=>{const r=this.R(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.P(t,await this.resolve(i.resource),n,r):this.O(t,i.resource,n,r)}))}async Q(t,c,n,s,i,r){let a=!1;if(t===n){const{providerExtUri:m,isPathCaseSensitive:u}=this.R(t);if(u||(a=m.isEqual(c,s)),a&&i==="copy")throw new Error((0,w.localize)(14,null,this.rb(c),this.rb(s)));if(!a&&m.isEqualOrParent(s,c))throw new Error((0,w.localize)(15,null,this.rb(c),this.rb(s)))}const p=await this.exists(s);if(p&&!a){if(!r)throw new d.$nk((0,w.localize)(16,null,this.rb(c),this.rb(s)),4);if(t===n){const{providerExtUri:m}=this.R(t);if(m.isEqualOrParent(c,s))throw new Error((0,w.localize)(17,null,this.rb(c),this.rb(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:a}}R(t){const c=this.S(t);return{providerExtUri:c?l.$$f:l.$ag,isPathCaseSensitive:c}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.pb(await this.j(t),t);await this.U(c,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,0,n)),n}async U(t,c){const n=[],{providerExtUri:s}=this.R(t);for(;!s.isEqual(c,s.dirname(c));)try{if(!((await t.stat(c)).type&d.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(c)));break}catch(i){if((0,d.$ik)(i)!==d.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(c)),c=s.dirname(c)}for(let i=n.length-1;i>=0;i--){c=s.joinPath(c,n[i]);try{await t.mkdir(c)}catch(r){if((0,d.$ik)(r)!==d.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,c){try{await this.W(t,c)}catch(n){return n}return!0}async W(t,c){const n=this.pb(await this.j(t),t),s=!!c?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const i=c?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(s&&i)throw new Error((0,w.localize)(21,null,this.rb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.qb(t,r);else throw new d.$nk((0,w.localize)(22,null,this.rb(t)),1);if(!!!c?.recursive){const p=await this.resolve(t);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return n}async del(t,c){const n=await this.W(t,c);let s=c;if((0,d.$ck)(n)&&!s?.atomic){const p=n.enforceAtomicDelete?.(t);p&&(s={...c,atomic:p})}const i=!!s?.useTrash,r=!!s?.recursive,a=s?.atomic??!1;await n.delete(t,{recursive:r,useTrash:i,atomic:a}),this.r.fire(new d.$kk(t,1))}async cloneFile(t,c){const n=await this.j(t),s=this.pb(await this.n(c),c);if(n===s&&this.R(n).providerExtUri.isEqual(t,c))return;if(n===s&&(0,d.$0j)(n))return n.cloneFile(t,c);await this.U(s,this.R(s).providerExtUri.dirname(c));const i=this.ab.queueFor(t,this.R(n).providerExtUri);return n===s&&(0,d.$9j)(n)?i.queue(()=>n.copy(t,c,{overwrite:!0})):i.queue(()=>this.O(n,t,s,c))}watch(t,c={recursive:!1,excludes:[]}){const n=new f.$jc;let s=!1,i=()=>{s=!0};return n.add((0,f.$ic)(()=>i())),(async()=>{try{const r=await this.$(t,c);s?(0,f.$fc)(r):i=()=>(0,f.$fc)(r)}catch(r){this.b.error(r)}})(),n}async $(t,c){const n=await this.j(t),s=(0,I.$pi)([this.R(n).providerExtUri.getComparisonKey(t),c]);let i=this.Z.get(s);return i||(i={count:0,disposable:n.watch(t,c)},this.Z.set(s,i)),i.count+=1,(0,f.$ic)(()=>{i&&(i.count--,i.count===0&&((0,f.$fc)(i.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,f.$fc)(t.disposable);this.Z.clear()}async bb(t,c,n,s,i){await this.cb(t,n,s,i);try{await t.rename(n,c,{overwrite:!0})}catch(r){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(t,c,n,s){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{const i=await t.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,g.$rd)(s)||(0,g.$sd)(s)?await this.db(t,i,s):await this.eb(t,i,s)}catch(r){throw(0,d.$gk)(r)}finally{await t.close(i)}})}async db(t,c,n){let s=0,i;if((0,g.$sd)(n)){if(n.buffer.length>0){const r=A.$Fd.concat(n.buffer);await this.fb(t,c,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((r,a)=>{(0,g.$xd)(i,{onData:async p=>{i.pause();try{await this.fb(t,c,p,p.byteLength,s,0)}catch(m){return a(m)}s+=p.byteLength,setTimeout(()=>i.resume())},onError:p=>a(p),onEnd:()=>r()})})}async eb(t,c,n){let s=0,i;for(;(i=n.read())!==null;)await this.fb(t,c,i,i.byteLength,s,0),s+=i.byteLength}async fb(t,c,n,s,i,r){let a=0;for(;a<s;){const p=await t.write(c,i+a,n.buffer,r+a,s-a);a+=p}}async gb(t,c,n,s){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(()=>this.hb(t,c,n,s))}async hb(t,c,n,s){let i;s instanceof A.$Fd?i=s:(0,g.$rd)(s)?i=await(0,A.$Rd)(s):(0,g.$sd)(s)?i=await(0,A.$Sd)(s):i=(0,A.$Pd)(s),await t.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async ib(t,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.jb(t,c,n,s))}async jb(t,c,n,s){let i,r;try{i=await t.open(c,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=A.$Fd.alloc(this.a);let p=0,m=0,u=0;do u=await t.read(i,p,a.buffer,m,a.byteLength-m),await this.fb(n,r,a,u,p,m),p+=u,m+=u,m===a.byteLength&&(m=0);while(u>0)}catch(a){throw(0,d.$gk)(a)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async kb(t,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.lb(t,c,n,s))}async lb(t,c,n,s){return n.writeFile(s,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.nb(t,c,n,s))}async nb(t,c,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(c);await this.fb(n,i,A.$Fd.wrap(r),r.byteLength,0,0)}catch(r){throw(0,d.$gk)(r)}finally{await n.close(i)}}async ob(t,c,n,s){const i=await(0,A.$Rd)(this.H(t,c,L.CancellationToken.None));await this.gb(n,s,void 0,i)}pb(t,c){if(t.capabilities&2048)throw new d.$nk((0,w.localize)(24,null,this.rb(c)),6);return t}qb(t,c){if((c.permissions??0)&d.FilePermission.Readonly)throw new d.$nk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=y,e.$Dp=y=ye([Y(0,o.$5i)],y)}),define(oe[200],ae([0,1,52,271,5,35,15,3,48,2,16,6,21,46,31,162,11,99,198,38,194,193]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,N.gracefulify)(O)}catch(c){console.error(`Error enabling graceful-fs: ${(0,$.$mi)(c)}`)}})();class t extends o.$Mp{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.N=new L.$zi(i=>b.$_f.getComparisonKey(i)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:i}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:d.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,b.$ig)(n,r.name))).type:a=this.M(r),i.push([r.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.eb(s)}}M(n,s){let i;return s?.dangling?i=d.FileType.Unknown:n.isFile()?i=d.FileType.File:n.isDirectory()?i=d.FileType.Directory:i=d.FileType.Unknown,s&&(i|=d.FileType.SymbolicLink),i}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const r=new A.$Fg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),i=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{i?.dispose()}}P(n){t.I&&this.a.trace(n)}readFileStream(n,s,i){const r=(0,l.$td)(a=>D.$Fd.concat(a.map(p=>D.$Fd.wrap(p))).buffer);return(0,h.$Cp)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},i),r}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.Q(n,(0,b.$ig)((0,b.$hg)(n),`${(0,b.$fg)(n)}${i.atomic.postfix}`),s,i):this.R(n,s,i)}async Q(n,s,i,r){await this.R(s,i,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async R(n,s,i){let r;try{const a=this.H(n);if(!i.create||!i.overwrite){if(await g.Promises.exists(a)){if(!i.overwrite)throw(0,d.$fk)((0,w.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,d.$fk)((0,w.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:i.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.fb(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(n){t.X=n}async open(n,s){const i=this.H(n);let r;(0,d.$7j)(s)&&(r=await this.O(n));let a;try{if((0,d.$7j)(s)&&s.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(i);m.mode&128||await g.Promises.chmod(i,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let p;if((0,d.$7j)(s)){if(E.$i)try{await g.Promises.truncate(i,0),p="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}p||(p="w")}else p="r";a=await g.Promises.open(i,p)}catch(p){throw r?.dispose(),(0,d.$7j)(s)?await this.fb(n,p):this.eb(p)}if(this.S.set(a,0),(0,d.$7j)(s)&&this.W.set(a,n),r){const p=this.U.get(a);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.U.set(a,r),p&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),p.dispose())}return a}async close(n){const s=this.U.get(n);try{if(this.S.delete(n),this.W.delete(n)&&t.X)try{await g.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(n)}catch(i){throw this.eb(i)}finally{s&&(this.U.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.U.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,r,a){const p=this.Y(n,s);let m=null;try{m=(await g.Promises.read(n,i,r,a,p)).bytesRead}catch(u){throw this.eb(u)}finally{this.Z(n,p,m)}return m}Y(n,s){return s===this.S.get(n)?null:s}Z(n,s,i){const r=this.S.get(n);typeof r=="number"&&(typeof s=="number"||(typeof i=="number"?this.S.set(n,r+i):this.S.delete(n)))}async write(n,s,i,r,a){return(0,A.$Yg)(()=>this.$(n,s,i,r,a),100,3)}async $(n,s,i,r,a){const p=this.Y(n,s);let m=null;try{m=(await g.Promises.write(n,i,r,a,p)).bytesWritten}catch(u){throw await this.fb(this.W.get(n),u)}finally{this.Z(n,p,m)}return m}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(s){throw this.eb(s)}}async delete(n,s){try{const i=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.$9d)((0,P.$_d)(i),`${(0,P.$ae)(i)}${s.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:p,symbolicLink:m}=await g.SymlinkSupport.stat(i);a=p.isDirectory()&&!m}catch{}if(a)await g.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.eb(i)}}async rename(n,s,i){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"move",i.overwrite),await g.Promises.rename(r,a)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(2,null,(0,P.$ae)(r),(0,P.$ae)((0,P.$_d)(a)),p.toString()))),this.eb(p)}}async copy(n,s,i){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"copy",i.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(3,null,(0,P.$ae)(r),(0,P.$ae)((0,P.$_d)(a)),p.toString()))),this.eb(p)}}async ab(n,s,i,r){const a=this.H(n),p=this.H(s);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$Hf)(a,p,!0)),m){if(i==="copy")throw(0,d.$fk)((0,w.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const v=await this.L(n);if(!v)throw(0,d.$fk)((0,w.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(s);if(j){if(!r)throw(0,d.$fk)((0,w.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);v.type&d.FileType.File&&j.type&d.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.bb(n,s,!1)}async bb(n,s,i){const r=this.H(n),a=this.H(s),p=!!(this.capabilities&1024);if((0,S.$Hf)(r,a,!p))return;const m=new f.$jc;try{const[u,v]=await Promise.all([this.O(n),this.O(s)]);m.add(u),m.add(v),i&&await g.Promises.mkdir((0,P.$_d)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!i)return this.bb(n,s,!0);throw this.eb(u)}finally{m.dispose()}}t(n,s,i){return new y.$Tp(r=>n(r),r=>s(r),i)}F(n,s,i){return new C.$2p(r=>n(r),r=>s(r),i)}eb(n){if(n instanceof d.$ek)return n;let s=n,i;switch(n.code){case"ENOENT":i=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=d.FileSystemProviderErrorCode.Unknown;break;default:i=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fk)(s,i)}async fb(n,s){let i=this.eb(s);if(n&&i.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(i=(0,d.$fk)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$3p=t}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=void 0,e.$u8b=(0,A.$Bh)("sharedProcessLifecycleService");let D=class extends N.$kc{constructor(S){super(),this.b=S,this.a=this.B(new O.$fd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$v8b=D,e.$v8b=D=ye([Y(0,L.$5i)],D)}),define(oe[201],ae([0,1,10,3,7,2]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=void 0;class D extends A.$dj{constructor(E,b,l,g,w){super(b,l,g),this.r=E,this.t=w,this.B(w.listen("onDidChangeLogLevel",E)(d=>{(0,A.$7i)(d)?super.setLogLevel(d):super.setLogLevel(O.URI.revive(d[0]),d[1])})),this.B(w.listen("onDidChangeVisibility",E)(([d,h])=>super.setVisibility(O.URI.revive(d),h))),this.B(w.listen("onDidChangeLoggers",E)(({added:d,removed:h})=>{for(const o of d)super.registerLogger({...o,resource:O.URI.revive(o.resource)});for(const o of h)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new A.$bj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new I(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$1q=D;class I extends A.$$i{constructor(E,b,l,g,w){super(g?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,g,w]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(w=>this.c(w,l)),removed:[...g.removed].map(w=>this.c(w,l))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[l.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,A.$7i)(g)?g:[l.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const g=this.b(E);switch(b){case"setLogLevel":return(0,A.$7i)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(O.URI.revive(g.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,g)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$2q=S;class f extends L.$kc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const g of l)E.registerLogger({...g,resource:O.URI.revive(g.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,g])=>E.setVisibility(O.URI.revive(l),g))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:g})=>{for(const w of l)E.registerLogger({...w,resource:O.URI.revive(w.resource)});for(const w of g)E.deregisterLogger(w.resource)}))}}e.$3q=f}),define(oe[202],ae([0,1,2,7]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class A extends O.$kc{constructor(D,I=[]){super(),this.a=new N.$cj([D,...I]),this.B(D.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...I){this.a.trace(D,...I)}debug(D,...I){this.a.debug(D,...I)}info(D,...I){this.a.info(D,...I)}warn(D,...I){this.a.warn(D,...I)}error(D,...I){this.a.error(D,...I)}flush(){this.a.flush()}}e.$rN=A}),define(oe[55],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0,e.$n6b=(0,O.$Bh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,L.$Bh)("policy");class D extends A.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const P=Object.keys(this.f).length;return this.f={...f,...this.f},P!==Object.keys(this.f).length&&await this.j(f),N.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(f,[P,E])=>({...f,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$$m=D;class I{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=I}),define(oe[203],ae([0,1,3,2,56]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=void 0;class L{constructor(S){this.b=S,this.a=new N.$jc}listen(S,f){switch(f){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(S,f,P){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.$d7b=L;class D extends A.$$m{constructor(S,f){super(),this.a=f;for(const P in S){const{definition:E,value:b}=S[P];this.f[P]=E,b!==void 0&&this.g.set(P,b)}this.a.listen("onDidChange")(P=>{for(const E in P){const b=P[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(P))})}async j(S){const f=await this.a.call("updatePolicyDefinitions",S);for(const P in f)this.g.set(P,f[P])}}e.$e7b=D}),define(oe[102],ae([0,1,6,37]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.context<"u"){const L=O.$g.vscode.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[24],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,O.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;let f=class extends A.$kc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new O.$Sg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,L.$_d)(E),g=(0,L.$ae)(E),w=await D.Promises.readdir(l);await Promise.all(w.map(async d=>{if(d===g)return;const h=(0,L.$9d)(l,d),o=await D.Promises.stat(h);if(o.isDirectory()&&b-o.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),D.Promises.rm(h)}))}catch(b){(0,N.$Y)(b)}}};e.$27b=f,e.$27b=f=ye([Y(1,S.$kj),Y(2,I.$5i)],f)}),define(oe[205],ae([0,1,5,8,2,16,31,14,7,24]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37b=void 0;let P=class extends A.$kc{constructor(b,l,g){super(),this.b=b,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$Sg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await D.Promises.readFile((0,L.$9d)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const o of Object.keys(l)){const $=l[o];b[`${$.hash}.${o}`]=!0}const g=(0,L.$9d)(this.b.userDataPath,"clp");if(!await D.Promises.exists(g))return;const d=await D.Promises.readdir(g);for(const o of d){if(b[o]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${o}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${o}`),await D.Promises.rm((0,L.$9d)(g,o))}const h=Date.now();for(const o of Object.keys(b)){const $=(0,L.$9d)(g,o),y=await D.Promises.readdir($);for(const C of y){if(C==="tcf.json")continue;const t=(0,L.$9d)($,C),c=await D.Promises.stat(t);c.isDirectory()&&h-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$9d)(o,C)}`),await D.Promises.rm(t))}}}catch(b){(0,N.$Y)(b)}}};e.$37b=P,e.$37b=P=ye([Y(0,I.$Jh),Y(1,S.$5i),Y(2,f.$kj)],P)}),define(oe[206],ae([0,1,16,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$JE=void 0,e.$JE=(0,N.$Bh)("IV8InspectProfilingService");var A;(function(L){function D(S){return!!(S.samples&&S.timeDeltas)}L.isValidProfile=D;function I(S,f="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,O.$8d)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.$9d)(f,(0,O.$ae)(P.callFrame.url)));return S}L.rewriteAbsolutePaths=I})(A||(e.Utils=A={}))}),define(oe[207],ae([0,1,32]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const I=await(await new Promise((f,P)=>{te(["v8-inspect-profiler"],f,P)})).startProfiling({port:L.port,checkForPaused:!0}),S=(0,O.$4f)();return this.a.set(S,I),S}async stopProfiling(L){const D=this.a.get(L);if(!D)throw new Error(`UNKNOWN session '${L}'`);const I=await D.stop();return this.a.delete(L),I.profile}}e.$k8b=N}),define(oe[40],ae([0,1,127,12]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class A{constructor(){this.a=new Map}add(D,I){O.ok(N.$jf(D)),O.ok(N.$lf(I)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,I)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$8m=new A}),define(oe[103],ae([0,1,3,40]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this.b=new O.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,f){this.a[A(S)]=f,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new L;N.$8m.add(e.$9m.JSONContribution,D)}),define(oe[49],ae([0,1,18,3,12,149,19,103,40]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var f;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$an={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const E=S.$8m.as(I.$9m.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$fd,this.onDidSchemaChange=this.i.event,this.j=new N.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const n=new Set;this.n(t,c,n),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const c=new Set;this.o(t,c),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const n=new Set;this.o(c,n),this.n(t,!1,n),E.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const n=[];for(const{overrides:s,source:i}of t)for(const r in s)if(c.add(r),e.$kn.test(r)){const a=this.a.get(r),p=a?.valuesSources??new Map;if(i)for(const j of Object.keys(s[r]))p.set(j,i);const m={...a?.value||{},...s[r]};this.a.set(r,{source:i,value:m,valuesSources:p});const u=(0,D.$fi)(r),v={type:"object",default:m,description:L.localize(1,null,u),$ref:e.$hn,defaultDefaultValue:m,source:A.$jf(i)?void 0:i,defaultValueSource:i};n.push(...w(r)),this.d[r]=v,this.b.properties[r]=v}else{this.a.set(r,{value:s[r],source:i});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:n,source:s}of t)for(const i in n){const r=this.a.get(i),a=A.$jf(s)?s:s?.id,p=A.$jf(r?.source)?r?.source:r?.source?.id;if(a===p)if(c.add(i),this.a.delete(i),e.$kn.test(i))delete this.d[i],delete this.b.properties[i];else{const m=this.d[i];m&&(this.w(i,m),this.r(i,m))}}this.u()}deltaConfiguration(t){let c=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,n){t.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,c){const n=s=>{if(s.properties)for(const i in s.properties){c.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,c=!0,n,s,i=3,r){i=A.$sf(t.scope)?i:t.scope;const a=t.properties;if(a)for(const m in a){const u=a[m];if(c&&$(m,u)){delete a[m];continue}if(u.source=n,u.defaultDefaultValue=a[m].default,this.w(m,u),e.$kn.test(m)?u.scope=void 0:(u.scope=A.$sf(u.scope)?i:u.scope,u.restricted=A.$sf(u.restricted)?!!s?.includes(m):u.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.f[m]=a[m],delete a[m];continue}else this.d[m]=a[m],a[m].policy?.name&&this.e.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),r.add(m)}const p=t.allOf;if(p)for(const m of p)this.p(m,c,n,s,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$bn.properties[t]=c,c.scope){case 1:e.$cn.properties[t]=c;break;case 2:e.$dn.properties[t]=c;break;case 6:e.$en.properties[t]=c;break;case 3:e.$fn.properties[t]=c;break;case 4:e.$gn.properties[t]=c;break;case 5:e.$gn.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$bn.properties[t],c.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$hn};this.w(c,n),e.$bn.properties[c]=n,e.$cn.properties[c]=n,e.$dn.properties[c]=n,e.$en.properties[c]=n,e.$fn.properties[c]=n,e.$gn.properties[c]=n}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,c){const n=this.a.get(t);let s=n?.value,i=n?.source;A.$qf(s)&&(s=c.defaultDefaultValue,i=void 0),A.$qf(s)&&(s=h(c.type)),c.default=s,c.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.$jn=`^(${l})+$`,e.$kn=new RegExp(e.$jn);function w(C){const t=[];if(e.$kn.test(C)){let c=g.exec(C);for(;c?.length;){const n=c[1].trim();n&&t.push(n),c=g.exec(C)}}return(0,O.$Kb)(t)}e.$ln=w;function d(C){return C.reduce((t,c)=>`${t}[${c}]`,"")}e.$mn=d;function h(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=h;const o=new b;S.$8m.add(e.$an.Configuration,o);function $(C,t){return C.trim()?e.$kn.test(C)?L.localize(7,null,C):o.getConfigurationProperties()[C]!==void 0?L.localize(8,null,C):t.policy?.name&&o.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,C,t.policy?.name,o.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$on=$;function y(){const C=[],t=o.getConfigurationProperties();for(const c of Object.keys(t))C.push([c,t[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$pn=y}),define(oe[73],ae([0,1,18,3,34,2,35,30,12,10,19,49,40]),function(te,e,O,N,A,L,D,I,S,f,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function l(c){return Object.isFrozen(c)?c:I.$Wm(c)}class g{constructor(n={},s=[],i=[],r){this.b=n,this.c=s,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof g)return s;const i=new w("");return i.parseRaw(s),i.configurationModel});this.f=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$di)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:r,merged:a}}getOverrideValue(n,s){const i=this.i(s);return i?n?(0,P.$di)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return O.$Kb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Kb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=I.$Vm(this.contents),i=I.$Vm(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const p of n)if(a.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.h(s,p.contents);for(const m of p.overrides){const[u]=i.filter(v=>O.$sb(v.identifiers,m.identifiers));u?(this.h(u.contents,m.contents),u.keys.push(...m.keys),u.keys=O.$Kb(u.keys)):i.push(I.$Vm(m))}for(const m of p.keys)r.indexOf(m)===-1&&r.push(m)}return new g(s,r,i,a.every(p=>p instanceof g)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of O.$Kb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const p=s[r];p&&(typeof a=="object"&&typeof p=="object"?(a=I.$Vm(a),this.h(a,p)):a=p),i[r]=a}return new g(i,this.keys,this.overrides)}h(n,s){for(const i of Object.keys(s)){if(i in n&&S.$lf(n[i])&&S.$lf(s[i])){this.h(n[i],s[i]);continue}n[i]=I.$Vm(s[i])}}i(n){let s=null,i=null;const r=a=>{a&&(i?this.h(i,a):i=I.$Vm(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.$ci)(this.contents,n),E.$kn.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>O.$sb(i.identifiers,(0,E.$ln)(n))),1))}j(n,s,i){(0,P.$bi)(this.contents,n,s,r=>console.error(r)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.$kn.test(n)&&this.overrides.push({identifiers:(0,E.$ln)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$ai)(this.contents[n],r=>console.error(r))})}}e.$qn=g;class w{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$sf(n)){const i=this.g(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:r,overrides:a,restricted:p,hasExcludedProperties:m}=this.h(n,s);this.b=new g(i,r,a,m?[n]:void 0),this.c=p||[]}g(n){let s={},i=null,r=[];const a=[],p=[];function m(v){Array.isArray(r)?r.push(v):i!==null&&(r[i]=v)}const u={onObjectBegin:()=>{const v={};m(v),a.push(r),r=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const v=[];m(v),a.push(r),r=v,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(v,j,F)=>{p.push({error:v,offset:j,length:F})}};if(n)try{A.$Sm(n,u),s=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}h(n,s){const i=b.$8m.as(E.$an.Configuration).getConfigurationProperties(),r=this.i(n,i,!0,s);n=r.raw;const a=(0,P.$ai)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),p=Object.keys(n),m=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:p,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const p={},m=[];for(const u in n)if(E.$kn.test(u)&&i){const v=this.i(n[u],s,!1,r);p[u]=v.raw,a=a||v.hasExcludedProperties,m.push(...v.restricted)}else{const v=s[u],j=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&m.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&v?.restricted))?p[u]=n[u]:a=!0}return{raw:p,restricted:m,hasExcludedProperties:a}}j(n,s){const i=[];for(const r of Object.keys(n))if(E.$kn.test(r)){const a={};for(const p in n[r])a[p]=n[r][p];i.push({identifiers:(0,E.$ln)(r),keys:Object.keys(a),contents:(0,P.$ai)(a,s)})}return i}}e.$rn=w;class d extends L.$kc{constructor(n,s,i,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$fd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=d;class h{constructor(n,s,i,r,a,p,m,u,v,j,F,T,z){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=r,this.d=a,this.f=p,this.g=m,this.h=u,this.i=v,this.j=j,this.k=F,this.l=T,this.m=z}get value(){return l(this.c)}n(n,s,i){const r=n.inspect(s,i);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class o{constructor(n,s,i,r,a=new g,p=new g,m=new D.$zi,u=new g,v=new D.$zi){this.c=n,this.d=s,this.f=i,this.g=r,this.h=a,this.i=p,this.j=m,this.l=u,this.m=v,this.a=null,this.b=new D.$zi,this.n=null}getValue(n,s,i){return this.q(n,s,i).getValue(n)}updateValue(n,s,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new g,this.m.set(i.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),i.resource||(this.a=null)}inspect(n,s,i){const r=this.q(n,s,i),a=this.u(s.resource,i),p=s.resource?this.m.get(s.resource)||this.l:this.l,m=new Set;for(const u of r.overrides)for(const v of u.identifiers)r.getOverrideValue(n,v)!==void 0&&m.add(v);return new h(n,s,r.getValue(n),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,a||void 0,p)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:r,updated:a,removed:p}=C(this.c,n);s=[...r,...a,...p]}for(const r of s)for(const a of(0,E.$ln)(r)){const p=this.c.getKeysForOverrideIdentifier(a),m=n.getKeysForOverrideIdentifier(a),u=[...m.filter(v=>p.indexOf(v)===-1),...p.filter(v=>m.indexOf(v)===-1),...p.filter(v=>!I.$Zm(this.c.override(a).getValue(v),n.override(a).getValue(v)))];i.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:r}=C(this.d,n),a=[...s,...i,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.applicationConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateApplicationConfiguration(n),{keys:p,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.localUserConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateLocalUserConfiguration(n),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.remoteUserConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateRemoteUserConfiguration(n),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.workspaceConfiguration,n),p=[...s,...i,...r];return p.length&&this.updateWorkspaceConfiguration(n),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.p.get(n),{added:r,updated:a,removed:p,overrides:m}=C(i,s),u=[...r,...a,...p];return(u.length||!i)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:m}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:a,overrides:p}=C(s,void 0);return{keys:[...i,...r,...a],overrides:p}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,i){let r=this.r(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},s){let i=this.s();if(s&&n){const r=s.getFolder(n);r&&(i=this.t(r.uri)||i);const a=this.m.get(n);a&&(i=i.merge(a))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const i=this.s(),r=this.j.get(n);r?(s=i.merge(r),this.b.set(n,s)):s=i}return s}u(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:i,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:i,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.i.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.x(n.defaults),i=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),p=this.x(n.workspace),m=n.folders.reduce((u,v)=>(u.set(f.URI.revive(v[0]),this.x(v[1])),u),new D.$zi);return new o(s,i,r,a,new g,p,m,new g,new D.$zi)}static x(n){return new g(n.contents,n.keys,n.overrides)}}e.$tn=o;function $(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,s=new Map;for(const r of c)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,p])=>{const m=(0,D.$wi)(s,a,new Set);p.forEach(u=>m.add(u))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.$un=$;class y{constructor(n,s,i,r){this.change=n,this.f=s,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const p of a)this.affectedKeys.add(p);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=o.parse(this.f.data)),this.i}affectsConfiguration(n,s){const i=this.a+n,r=this.d.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this.d.length)return!1;const p=this.d.charCodeAt(a);if(p!==this.b&&p!==this.c)return!1;if(s){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!I.$Zm(m,u)}return!0}}e.$vn=y;function C(c,n){const{added:s,removed:i,updated:r}=t(n?.rawConfiguration,c?.rawConfiguration),a=[],p=c?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const u=m.filter(v=>!p.includes(v));for(const v of u)a.push([v,n.getKeysForOverrideIdentifier(v)])}if(c){const u=p.filter(v=>!m.includes(v));for(const v of u)a.push([v,c.getKeysForOverrideIdentifier(v)])}if(n&&c){for(const u of p)if(m.includes(u)){const v=t({contents:c.getOverrideValue(void 0,u)||{},keys:c.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:i,updated:r,overrides:a}}function t(c,n){const s=c?n?c.keys.filter(a=>n.keys.indexOf(a)===-1):[...c.keys]:[],i=n?c?n.keys.filter(a=>c.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(c&&n){for(const a of n.keys)if(c.keys.indexOf(a)!==-1){const p=(0,P.$di)(n.contents,a),m=(0,P.$di)(c.contents,a);I.$Zm(p,m)||r.push(a)}}return{added:s,removed:i,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,73,49,7,56,40]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class b extends A.$kc{constructor(){super(...arguments),this.a=this.B(new N.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$8m.as(S.$an.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:h})=>this.c(Array.from(d),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,h){this.h(d,E.$8m.as(S.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new I.$qn;const d=E.$8m.as(S.$an.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,h){const o=this.f();for(const $ of d){const y=o[$],C=h[$];y!==void 0?this.b.addValue($,y):C?this.b.addValue($,C.default):this.b.removeValue($)}}}e.$wn=b;class l{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new I.$qn}async initialize(){return this.configurationModel}}e.$xn=l;let g=class extends A.$kc{get configurationModel(){return this.b}constructor(d,h,o){super(),this.c=d,this.f=h,this.g=o,this.a=this.B(new N.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new I.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const h={},o=[],$=E.$8m.as(S.$an.Configuration).getConfigurationProperties();for(const y of d){const C=$[y];if(!C){o.push(y);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}o.push(y),h[C.policy.name]={type:C.type}}}return(0,D.$wf)(h)||await this.f.updatePolicyDefinitions(h),o}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const h=E.$8m.as(S.$an.Configuration).getPolicyConfigurations(),o=(0,O.$Fb)(d.map($=>h.get($)));this.m(o,!0)}m(d,h){this.g.trace("PolicyConfiguration#update",d);const o=E.$8m.as(S.$an.Configuration).getConfigurationProperties(),$=[],y=this.b.isEmpty();for(const C of d){const t=o[C]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(y?c!==void 0:!(0,L.$Zm)(this.b.getValue(C),c))&&$.push([C,c])}else this.b.getValue(C)!==void 0&&$.push([C,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const C=this.b;this.b=new I.$qn;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,c]of $)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);h&&this.a.fire(this.b)}}};e.$yn=g,e.$yn=g=ye([Y(1,P.$0m),Y(2,f.$5i)],g)}),define(oe[209],ae([0,1,5,3,2,21,19,73,208,56]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class P extends A.$kc{constructor(b,l,g,w){super(),this.j=b,this.h=this.B(new N.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$wn),this.c=g instanceof f.$_m?new S.$xn:this.B(new S.$yn(this.b,g,w)),this.f=this.B(new I.$sn(this.j,{},L.$_f,l)),this.a=new I.$tn(this.b.configurationModel,this.c.configurationModel,new I.$qn,new I.$qn),this.g=this.B(new O.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:h})=>this.n(d,h))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$tn(b,l,new I.$qn,g)}getConfigurationData(){return this.a.toData()}getValue(b,l){const g=typeof b=="string"?b:void 0,w=(0,D.$9h)(b)?b:(0,D.$9h)(l)?l:{};return this.a.getValue(g,w,void 0)}updateValue(b,l,g,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(g,l,2)}n(b,l){const g=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(w,g,7)}r(b){const l=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(b);this.s(g,l,7)}s(b,l,g){const w=new I.$vn(b,{data:l},this.a);w.source=g,w.sourceConfig=this.t(g),this.h.fire(w)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=P}),define(oe[210],ae([0,1,15,3,2,65]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkb=e.$Gkb=e.$Fkb=e.$Ekb=void 0;const D=(f,P,E)=>{const b=new Uint8Array(16);for(let w=0;w<16;w++)b[w]=Math.round(Math.random()*256);const l=(0,O.$Zd)(O.$Fd.wrap(b));return[`GET ws://localhost${f}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$Ekb=D,e.$Fkb=O.$Fd.fromString(`\r
\r
`);async function I(f,P,E,b,l){f.write(O.$Fd.fromString((0,e.$Ekb)(P,E,b)));const g=new A.$jc;try{return await new Promise((w,d)=>{let h;g.add(f.onData(o=>{h?h=O.$Fd.concat([h,o],h.byteLength+o.byteLength):h=o;const $=h.indexOf(e.$Fkb);if($===-1)return;w(f),f.pauseData();const y=h.slice($+e.$Fkb.byteLength);y.byteLength&&l.onData.fire(y)})),g.add(f.onClose(o=>d(o??new Error("socket closed")))),g.add(f.onEnd(()=>d(new Error("socket ended"))))})}catch(w){throw f.dispose(),w}finally{g.dispose()}}e.$Gkb=I;class S extends A.$kc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$id),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$fd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Hkb=S}),define(oe[211],ae([0,1,8,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,N.$Bh)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=L;class D{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=D;var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class S extends O.$_{static isNotAvailable(E){return E instanceof S&&E._code===I.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===I.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===I.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===I.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,b=I.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Mk=S;function f(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Nk=f}),define(oe[74],ae([0,1,23]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function N(f){return f.scheme===O.Schemas.vscodeRemote?f.authority:void 0}e.$Ok=N;function A(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$Pk=A;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Qk=L;function D(f){const{host:P,port:E}=S(f);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Rk=D;function I(f,P){let{host:E,port:b}=S(f);return typeof b>"u"&&(b=P),{host:E,port:b}}e.$Sk=I;function S(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=f.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=f.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:f,port:void 0}}}),define(oe[44],ae([0,1,27,4,74]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Tl=L,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var I;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class S{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,h){if(typeof d>"u"||d===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof d=="string"||typeof h=="string"){const o=typeof d=="string"?d:d.value,$=typeof h=="string"?h:h.value;return O.$Me(o,$)}return d._lower===h._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Vl=S;class f{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const h of d)this.add(h)}add(d){this.c.add(S.toKey(d))}delete(d){return this.c.delete(S.toKey(d))}has(d){return this.c.has(S.toKey(d))}}e.$Wl=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(S.toKey(d))}get(d){return this.c.get(S.toKey(d))}has(d){return this.c.has(S.toKey(d))}set(d,h){this.c.set(S.toKey(d),h)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=P;function E(w){return b(w)}e.$Yl=E;function b(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Zl=b;function l(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$1l=l;function g(w,d){if(d){const h=`onResolveRemoteAuthority:${(0,A.$Pk)(d)}`;return!!w.activationEvents?.includes(h)}return!1}e.$2l=g,e.$3l=(0,N.$Bh)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;class L extends O.$kc{constructor(I,S,f,P,E){super(),this.a=I,this.b=S,this.c=f,this.f=E,this.B(P.onDidInstallExtensions(b=>this.g(b))),this.B(P.onDidUninstallExtension(b=>this.h(b)))}g(I){for(const S of I)S.local&&this.invalidate(S.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,I)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Pl))}catch(S){(0,A.$jk)(S)!==1&&this.f.error(S)}}}e.$wp=L}),define(oe[213],ae([0,1,5,15,26,8,3,2,100,60,32,65,211,74]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const g=30*1e3;var w;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function d(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const k=new A.$pd;return setTimeout(()=>k.cancel(),q),k.token}function o(q,k){if(q.isCancellationRequested||k.isCancellationRequested)return A.CancellationToken.Cancelled;const R=new A.$pd;return q.onCancellationRequested(()=>R.cancel()),k.onCancellationRequested(()=>R.cancel()),R.token}class ${get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new I.$jc,this.promise=new Promise((R,B)=>{this.f=R,this.g=B}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function y(q,k){const R=new $(k);return R.registerDisposable(q.onControlMessage(B=>{const M=JSON.parse(B.toString()),J=V(M);J?R.reject(J):R.resolve(M)})),R.promise}function C(q,k,R,B,M,J,Z,se){const le=new $(se),ue=f.$bd.create(!1);return q.info(`Creating a socket (${Z})...`),S.mark(`code/willCreateSocket/${J}`),k.connect(R,B,M,Z).then(he=>{le.didTimeout?(S.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${Z}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${J}`),q.info(`Creating a socket (${Z}) was successful after ${ue.elapsed()} ms.`),le.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${Z}) returned an error after ${ue.elapsed()} ms.`),q.error(he),le.reject(he)}),le.promise}function t(q,k){const R=new $(k);return q.then(B=>{R.didTimeout||R.resolve(B)},B=>{R.didTimeout||R.reject(B)}),R.promise}async function c(q,k,R,B){const M=re(q,k);q.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let J;try{J=await C(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,l.$Qk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,d(k),`renderer-${d(k)}-${q.reconnectionToken}`,B)}catch(he){throw q.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),q.logService.error(he),he}q.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let Z,se;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(J,null),Z=q.reconnectionProtocol,se=!1):(Z=new E.$ph({socket:J}),se=!0),q.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const le=await t(q.signService.createNewMessage((0,P.$4f)()),B),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:le.data};Z.sendControl(N.$Fd.fromString(JSON.stringify(ue)));try{const he=await y(Z,o(B,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(q.signService.validate(le,he.signedData),B)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await t(q.signService.sign(he.data),B),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:k};return R&&(we.args=R),q.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(N.$Fd.fromString(JSON.stringify(we))),{protocol:Z,ownsProtocol:se}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(q.logService.error(`${M} the handshake timed out. Error:`),q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${M} received error control message when negotiating connection. Error:`),q.logService.error(he)),se&&G(Z),he}}async function n(q,k,R,B){const M=Date.now(),J=re(q,k),{protocol:Z,ownsProtocol:se}=await c(q,k,R,B),le=new $(B);return le.registerDisposable(Z.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(q.logService.error(`${J} received error control message when negotiating connection. Error:`),q.logService.error($e),se&&G(Z),le.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${Q(M)}!`),le.resolve({protocol:Z,firstMessage:he}))})),le.promise}async function s(q,k){const{protocol:R}=await n(q,1,void 0,k);return{protocol:R}}async function i(q,k,R){const{protocol:B,firstMessage:M}=await n(q,2,k,R),J=M&&M.debugPort;return{protocol:B,debugPort:J}}async function r(q,k,R){const B=Date.now(),M=re(q,3),{protocol:J}=await c(q,3,k,R);return q.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Q(B)}!`),J}async function a(q,k,R){const{connectTo:B,connectionToken:M}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:B,connectionToken:M,reconnectionToken:k,reconnectionProtocol:R,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function p(q,k,R){return u(q,async B=>{const{protocol:M}=await s(B,A.CancellationToken.None);return new H(q,k,R,B.reconnectionToken,M)})}e.$Xk=p;async function m(q,k){return u(q,async R=>{const{protocol:B,debugPort:M}=await i(R,k,A.CancellationToken.None);return new x(q,k,R.reconnectionToken,B,M)})}e.$Yk=m;async function u(q,k){for(let B=1;;B++)try{const M=(0,P.$4f)(),J=await a(q,M,null);return await k(J)}catch(M){if(B<5)q.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(M);else throw q.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(M),X.triggerPermanentFailure(0,0,b.$Mk.isHandled(M)),M}}async function v(q,k,R){const B=await a(q,(0,P.$4f)(),null);return await r(B,{host:k,port:R},A.CancellationToken.None)}e.$Zk=v;function j(q){return(0,O.$ug)(k=>new Promise((R,B)=>{const M=setTimeout(R,q*1e3);k.onCancellationRequested(()=>{clearTimeout(M),R()})}))}var F;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class T{constructor(k,R){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.type=0}}e.$1k=T;class z{constructor(k,R,B,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.durationSeconds=B,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$2k=z;class U{constructor(k,R,B){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=B,this.type=2}}e.$3k=U;class _{constructor(k,R,B){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=B,this.type=4}}e.$4k=_;class K{constructor(k,R,B,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=B,this.handled=M,this.type=3}}e.$5k=K;class X extends I.$kc{static triggerPermanentFailure(k,R,B){this._permanentFailure=!0,this.f=k,this.g=R,this.h=B,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(k=>k.y())}static debugPauseSocketWriting(){this.j.forEach(k=>k.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||X._permanentFailure}constructor(k,R,B,M,J){super(),this.t=k,this.u=R,this.reconnectionToken=B,this.protocol=M,this.w=J,this.m=this.B(new D.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(M.onSocketClose(Z=>{const se=ne(this.t,this.reconnectionToken,!0);Z?Z.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(Z=>{const se=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),X.j.push(this),this.B((0,I.$ic)(()=>{const Z=X.j.indexOf(this);Z>=0&&X.j.splice(Z,1)})),this.n&&this.D(X.f,X.g,X.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const k=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const M=B<R.length?R[B]:R[R.length-1];try{if(M>0){const Z=j(M);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,Z)),this.u.logService.info(`${k} waiting for ${M} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${k} resolving connection...`);const J=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${k} connecting to ${J.connectTo}...`),await this.G(J,h(g)),this.u.logService.info(`${k} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(b.$Mk.isTemporarilyNotAvailable(J)){this.u.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,L.$2)(J)){this.u.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof b.$Mk){this.u.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,b.$Mk.isHandled(J));break}this.u.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(k,R,B){this.w?X.triggerPermanentFailure(k,R,B):this.D(k,R,B)}D(k,R,B){this.m.fire(new K(this.reconnectionToken,k,R,B)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=X;class H extends X{constructor(k,R,B,M,J){super(1,k,M,J,!0),this.client=this.B(new E.$nh(J,{remoteAuthority:R,clientId:B},k.ipcLogger))}async G(k,R){await s(k,R)}}e.$7k=H;class x extends X{constructor(k,R,B,M,J){super(2,k,B,M,!1),this.H=R,this.debugPort=J}async G(k,R){await i(k,this.H,R)}}e.$8k=x;function G(q){try{q.acceptDisconnect();const k=q.getSocket();q.dispose(),k.dispose()}catch(k){(0,L.$Y)(k)}}function V(q){if(q&&q.type==="error"){const k=new Error(`Connection error: ${q.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function W(q,k){for(;q.length<k;)q+=" ";return q}function ee(q,k){return`[remote-connection][${W(d(q),13)}][${k.substr(0,5)}\u2026]`}function ne(q,k,R){return`${ee(q,k)}[${R?"reconnect":"initial"}]`}function re(q,k){return`${ne(k,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Q(q){return`${Date.now()-q} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,N.$Bh)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(D,I){return this.a[D]??=[],this.a[D].push(I),(0,O.$ic)(()=>{const S=this.a[D]?.indexOf(I);typeof S=="number"&&S>=0&&this.a[D]?.splice(S,1)})}b(D){return(this.a[D.type]||[]).find(S=>S.supports(D))}connect(D,I,S,f){const P=this.b(D);if(!P)throw new Error(`No socket factory found for ${D}`);return P.connect(D,I,S,f)}}e.$Uk=A}),define(oe[214],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=void 0,e.$h8b=(0,O.$Bh)("sharedProcessTunnelService"),e.$i8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=e.$q8b=e.$p8b=e.$o8b=e.TunnelStates=e.$n8b=e.$m8b=void 0,e.$m8b=(0,O.$Bh)("IRemoteTunnelService"),e.$n8b={active:!1};var A;(function(L){L.disconnected=D=>({type:"disconnected",onTokenFailed:D}),L.connected=(D,I)=>({type:"connected",info:D,serviceInstallFailed:I}),L.connecting=D=>({type:"connecting",progress:D}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$o8b="remote.tunnels.access",e.$p8b=e.$o8b+".hostNameOverride",e.$q8b=e.$o8b+".preventSleep",e.$r8b="remoteTunnelService",e.$s8b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,49,4,7,40]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,I.$Bh)("requestService");class P{constructor(C){this.b=C}toJSON(){if(!this.a){const C=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.b[t];this.a=C}return this.a}}class E extends A.$kc{constructor(C){super(),this.b=0,this.a=C.createLogger("network",{name:(0,L.localize)(0,null),when:S.$jj.isEqualTo((0,S.$hj)(S.LogLevel.Trace)).serialize()})}async c(C,t,c){const n=`${C} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new P(t.headers??{}));try{const s=await c();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$8)(s)),s}}}e.$Jo=E;function b(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.$Ko=b;function l(y){return y.res.statusCode===204}e.$Lo=l;async function g(y){return l(y)?null:(await(0,O.$Rd)(y.stream)).toString()}e.$Mo=g;async function w(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);return g(y)}e.$No=w;async function d(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);if(l(y))return null;const t=(await(0,O.$Rd)(y.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.$Oo=d;function h(y){$(y)}e.$Po=h;let o;function $(y){const C=f.$8m.as(D.$an.Configuration),t=o;o={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[o],remove:t?[t]:[]})}$(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0;let D=class{constructor(S,f){this.a=S,this.b=f}async download(S,f,P=O.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,f);return}const E={type:"GET",url:S.toString(!0)},b=await this.a.request(E,P);if(b.res.statusCode===200)await this.b.writeFile(f,b.stream);else{const l=await(0,L.$No)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$GN=D,e.$GN=D=ye([Y(0,L.$Io),Y(1,A.$6j)],D)}),define(oe[216],ae([0,1,15,26]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class A{constructor(I){this.a=I}listen(I,S){throw new Error("Invalid listen")}call(I,S,f,P=N.CancellationToken.None){switch(S){case"request":return this.a.request(f[0],P).then(async({res:E,stream:b})=>{const l=await(0,O.$Rd)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(f[0])}throw new Error("Invalid call")}}e.$Lq=A;class L{constructor(I){this.a=I}async request(I,S){const[f,P]=await this.a.call("request",[I],S);return{res:f,stream:(0,O.$Td)(P)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Mq=L}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=e.$N6b=e.$M6b=void 0,e.$M6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$N6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$O6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N2b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const L=await this.c();if(L){const D=String(O.a++);return this.b.set(D,L),{id:D,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const D=this.b.get(A.id);if(!D)return!1;this.b.delete(A.id);try{return D.validate(L)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$N2b=O}),define(oe[106],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,O.$Bh)(e.$Vk)}),define(oe[219],ae([0,1,218]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;class N extends O.$N2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(D=>new D.signer().sign(L))}h(){return new Promise((L,D)=>te(["vsda"],L,D))}}e.$A7b=N}),define(oe[75],ae([0,1,3,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qAb=e.$pAb=e.$oAb=e.$nAb=void 0;class A extends N.$kc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class L extends A{constructor(E,b){super(E,b,void 0),this.f=this.B(new O.$fd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class D extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$nAb=D;class I extends L{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$oAb=I;class S extends A{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$pAb=S;class f{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$qAb=f}),define(oe[107],ae([0,1,6,37,32]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function L(S){if(O.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function D(S,f,P,E,b,l,g,w){const d=Object.create(null);d["common.machineId"]=l,d.sessionID=(0,A.$4f)()+Date.now(),d.commitHash=E,d.version=b,d["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,O.$h)(O.$t),d["common.nodePlatform"]=N.$3d,d["common.nodeArch"]=P,d["common.product"]=w||"desktop",g&&(d["common.msftInternal"]=g);let h=0;const o=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),O.$l&&(d["common.snap"]="true");const $=L(f);return $&&(d["common.platformDetail"]=$),d}e.$0n=D;function I(S){const f=N.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return S.some(E=>P===E)}e.$$n=I}),define(oe[22],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,O.$Bh)("telemetryService"),e.$0k=(0,O.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(oe[220],ae([0,1,36,5,34,23,16,6,10,132,31,146,95,11,24,22]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;const d=new Map;async function h(t,c){const n=`${t}::${c.join(":")}`,s=d.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,p=2e4;function m(v,j,F,T){const z=j.substring(v.length+1);return N.Promises.withAsyncBody(async U=>{let _;try{_=await P.Promises.readdir(j,{withFileTypes:!0})}catch{U();return}if(T.count>=p){T.count+=_.length,T.maxReached=!0,U();return}let K=_.length;if(K===0){U();return}let X=_;T.count+_.length>p&&(T.maxReached=!0,K=p-T.count,X=_.slice(0,K)),T.count+=_.length;for(const H of X)if(H.isDirectory()){if(F.includes(H.name)||await m(v,(0,D.$9d)(j,H.name),F,T),--K===0){U();return}}else{const x=H.name.lastIndexOf(".");if(x>=0){const G=H.name.substring(x+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of i)G.relativePathPattern?.test(z)!==!1&&G.filePattern.test(H.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--K===0){U();return}}})}const u=N.Promises.withAsyncBody(async v=>{const j={count:0,maxReached:!1};await m(t,t,c,j);const F=await y(t);v({configFiles:o(a),fileTypes:o(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return d.set(n,u),u}e.$tr=h;function o(t){return Array.from(t.entries(),([c,n])=>({name:c,count:n})).sort((c,n)=>n.count-c.count)}function $(){const t={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/l.$Ak.GB).toFixed(2)}GB (${(O.freemem()/l.$Ak.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$Hm.value()*100)}%`},c=O.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.$ur=$;async function y(t){try{const c=new Map,n=(0,D.$9d)(t,".vscode","launch.json"),s=await P.Promises.readFile(n),i=[],r=(0,A.$Lm)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$Um)(r)==="object"&&r.configurations)for(const a of r.configurations){const p=a.type;p&&(c.has(p)?c.set(p,c.get(p)+1):c.set(p,1))}return o(c)}catch{return[]}}e.$vr=y;let C=class{constructor(c,n){this.c=c,this.d=n}f(c){const n=[];return n.push(`OS Version:       ${c.os}`),n.push(`CPUs:             ${c.cpus}`),n.push(`Memory (System):  ${c.memory}`),n.push(`VM:               ${c.vmHint}`),n.join(`
`)}g(c){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/l.$Ak.GB).toFixed(2)}GB (${(O.freemem()/l.$Ak.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${O.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.$Hm.value()*100)}%`),n.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${c.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(c,n){return Promise.all([(0,E.$sr)(c.mainPID),this.k(c)]).then(async s=>{let[i,r]=s,a=this.m(c,i);return n.forEach(p=>{if((0,b.$hm)(p))a+=`
${p.errorMessage}`,r+=`
${p.errorMessage}`;else if(a+=`

Remote: ${p.hostName}`,p.processes&&(a+=`
${this.m(c,p.processes)}`),p.workspaceMetadata){r+=`
|  Remote: ${p.hostName}`;for(const m of Object.keys(p.workspaceMetadata)){const u=p.workspaceMetadata[m];let v=`${u.fileCount} files`;u.maxFilesReached&&(v=`more than ${v}`),r+=`|    Folder (${m}): ${v}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(c,n){const{memory:s,vmHint:i,os:r,cpus:a}=$(),p={os:r,memory:s,cpus:a,vmHint:i,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(p.load=`${O.loadavg().map(m=>Math.round(m)).join(", ")}`),I.$k&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(c,n){const s=[];return(0,E.$sr)(c.mainPID).then(async i=>(s.push(""),s.push(this.g(c)),s.push(""),s.push(this.m(c,i)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(c))),n.forEach(r=>{if((0,b.$hm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(c,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const p=r.workspaceMetadata[a];let m=`${p.fileCount} files`;p.maxFilesReached&&(m=`more than ${m}`),s.push(`Folder (${a}): ${m}`),s.push(this.h(p))}}),s.push(""),s.push(""),s.join(`
`)))}h(c){const n=[];let i=0;const r=(u,v)=>{const j=` ${u}(${v})`;i+j.length>60?(n.push(a),a="|                 ",i=a.length):i+=j.length,a+=j};let a="|      File types:";const p=10,m=c.fileTypes.length>p?p:c.fileTypes.length;for(let u=0;u<m;u++){const v=c.fileTypes[u];r(v.name,v.count)}if(n.push(a),c.configFiles.length>=0&&(a="|      Conf files:",i=0,c.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),c.launchConfigFiles.length>0){let u="|      Launch Configs:";c.launchConfigFiles.forEach(v=>{const j=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;u+=j}),n.push(u)}return n.join(`
`)}j(c){const n=Math.max(...Object.keys(c).map(s=>s.length));return Object.keys(c).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${c[s]}`).join(`
                  `)}k(c){const n=[],s=[];return c.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===L.Schemas.file){const p=a.fsPath;s.push(h(p,["node_modules",".git"]).then(m=>{let u=`${m.fileCount} files`;m.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,D.$ae)(p)}): ${u}`),n.push(this.h(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${p} (${m.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(c,n){const s=new Map;c.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(c.mainPID,s,i,n,0),i.join(`
`)}n(c,n,s,i,r){const a=r===0;let p;a?p=i.pid===c?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?p=n.get(i.pid):p=`${"  ".repeat(r)} ${i.name}`;const m=process.platform==="win32"?i.mem:O.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(m/l.$Ak.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(i.children)&&i.children.forEach(u=>this.n(c,n,s,u,r+1))}async getWorkspaceFileExtensions(c){const n=new Set;for(const{uri:s}of c.folders){const i=S.URI.revive(s);if(i.scheme!==L.Schemas.file)continue;const r=i.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(p=>n.add(p.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(c){for(const{uri:n}of c.folders){const s=S.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const i=s.fsPath;try{const r=await h(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$wr=C,e.$wr=C=ye([Y(0,w.$9k),Y(1,g.$kj)],C)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0;class O{constructor(L){this.b=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,{eventName:I,data:S}){return this.b.forEach(f=>f.log(I,S)),Promise.resolve(null)}}e.$R6b=O;class N{constructor(L){this.b=L}log(L,D){return this.b.call("log",{eventName:L,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$S6b=N}),define(oe[45],ae([0,1,30,12,3,19,74,107,22]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class f{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$_n=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=P,e.$bo=new P;class E{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.$co=E,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,i){return A.Event.debounce(i.onDidChangeConfiguration,(a,p)=>{const m=a?new Set([...a.affectedKeys,...p.affectedKeys]):p.affectedKeys;return{...p,affectedKeys:m}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.$$h)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$go=b;function l(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}e.$ho=l;function g(s,i){return!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$io=g;function w(s){const i=s.getValue(S.$dl),r=s.getValue(S.$el);if(s.getValue(S.$fl)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=w;function d(s){const i={},r={},a={};$(s,a);for(let p in a){p=p.length>150?p.substr(p.length-149):p;const m=a[p];typeof m=="number"?r[p]=m:typeof m=="boolean"?r[p]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${m.length}`),i[p]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(i[p]=m)}return{properties:i,measurements:r}}e.$ko=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(s){if(!s)return"none";const i=(0,D.$Pk)(s);return h.has(i)?i:"other"}e.$lo=o;function $(s,i,r=0,a){if(s)for(const p of Object.getOwnPropertyNames(s)){const m=s[p],u=a?a+p:p;Array.isArray(m)?i[u]=(0,O.$1m)(m):m instanceof Date?i[u]=m.toISOString():(0,N.$lf)(m)?r<2?$(m,i,r+1,u+"."):i[u]=(0,O.$1m)(m):i[u]=m}}function y(s,i){const r=s.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,I.$$n)(r)||a}e.$mo=y;function C(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$no=C;function t(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const v of i)for(;;){const j=v.exec(s);if(!j)break;a.push([j.index,v.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const v=m.exec(s);if(!v)break;const j=a.some(([F,T])=>v.index<T&&F<m.lastIndex);!p.test(v[0])&&!j&&(r+=s.substring(u,v.index)+"<REDACTED: user-file-path>",u=m.lastIndex)}return u<s.length&&(r+=s.substr(u)),r}function c(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,i){return(0,O.$Xm)(s,r=>{if(r instanceof f||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const p of i)a=a.replace(p,"");return a=c(a),a}})}e.$oo=n}),define(oe[33],ae([0,1,27,29,44,6,10,8,37,45]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$He)(n.id,s.id)===0}e.$po=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,i,r)}static parse(s){const i=E.exec(s);return i&&i[1]&&i[2]?new b({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$qo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const s=l.exec(n);return s&&s[1]?[d(s[1]),s[2]]:[d(n),void 0]}e.$ro=g;function w(n,s){return`${n}.${s}`}e.$so=w;function d(n){return n.toLowerCase()}e.$to=d;function h(n,s){return d(w(n??A.$Rl,s))}e.$uo=h;function o(n,s){const i=[],r=a=>{for(const p of i)if(p.some(m=>P(s(m),s(a))))return p;return null};for(const a of n){const p=r(a);p?p.push(a):i.push([a])}return i}e.$vo=o;function $(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$wo=$;function y(n){return{id:new f.$_n(n.identifier.id),name:new f.$_n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$xo=y,e.$yo=new A.$Vl("pprice.better-merge");function C(n,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(p=>!P(p.identifier,{id:a}))){const p=n.filter(m=>P(m.identifier,{id:a}));p.length===1&&(i.push(p[0]),r.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$zo=C;async function t(n,s){if(!L.$k)return!1;let i;try{i=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$8)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(n,s){const i=await t(n,s),r=(0,N.$Un)(i?"alpine":L.$t,S.$4d);return s.debug("ComputeTargetPlatform:",r),r}e.$Ao=c}),define(oe[221],ae([0,1,18,2,21,10,11,24,5,3,16,6,37,33]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=e.$S4b=void 0;let g=class extends N.$kc{constructor($,y){super(),this.b=$,this.c=y,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,C])=>this.a.set(C.configPath,C))}getConfigBasedTips($){return this.f($)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f($){const y=[];for(const[C,t]of this.a)if(!(t.configScheme&&t.configScheme!==$.scheme))try{const c=(await this.b.readFile((0,A.$ig)($,C))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(c))&&y.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return y}};e.$S4b=g,e.$S4b=g=ye([Y(0,D.$6j),Y(1,I.$kj)],g);const w="extensionTips/promptedExecutableTips",d="extensionTips/lastPromptedMediumImpExeTime";class h extends g{constructor($,y,C,t,c,n,s,i){super(s,i),this.r=$,this.s=y,this.t=C,this.u=t,this.w=c,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const p=[],m=[],u=[];Object.entries(a.recommendations).forEach(([v,j])=>{j.important?a.important?p.push({extensionId:v,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):m.push({extensionId:v,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):u.push({extensionId:v,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),p.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),m.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:m}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),this.B((0,S.$Ig)(async()=>{await this.C(),this.F(),this.G()},3e3))}async getImportantExecutableBasedTips(){const $=await this.O(this.g),y=await this.O(this.h);return[...$,...y]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const $=await this.O(this.g),y=await this.O(this.h),C=await this.u.getInstalled();this.m=this.D($,C),this.n=this.D(y,C)}D($,y){const C=new Map;$.forEach(i=>C.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:c}=this.N([...C.keys()],y);for(const i of t){const r=C.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of c){const r=C.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const n=this.L(),s=new Map;for(const i of c){const r=C.get(i);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[$,y]=[...this.m.entries()][0];this.H(y).then(C=>{switch(C){case"reacted":this.M(y[0].exeName,y);break;case"ignored":this.m.delete($);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B((0,S.$Ig)(()=>{t.dispose(),this.F()},36e5));break}}})}G(){if(this.n.size===0)return;const $=this.I(),y=Date.now()-$,C=7*24*60*60*1e3;if(y<C){const n=this.B((0,S.$Ig)(()=>{n.dispose(),this.G()},C-y));return}const[t,c]=[...this.n.entries()][0];this.H(c).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(c[0].exeName,c);const s=this.B((0,S.$Ig)(()=>{s.dispose(),this.G()},C));break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B((0,S.$Ig)(()=>{s.dispose(),this.G()},36e5));break}}})}async H($){const y=await this.u.getInstalled(1),C=$.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(c=>y.every(n=>!(0,l.$po)(n.identifier,{id:c})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:C,source:3,name:$[0].exeFriendlyName,searchValue:`@exe:"${$[0].exeName}"`})}I(){let $=this.w.getNumber(d,-1);return $||($=Date.now(),this.J($)),$}J($){this.w.store(d,$,-1,1)}L(){return JSON.parse(this.w.get(w,-1,"{}"))}M($,y){const C=this.L();C[$]=y.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(C),-1,0)}N($,y){const C=[],t=[],c=y.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return $.forEach(n=>{c.has(n.toLowerCase())?C.push(n):t.push(n)}),{installed:C,uninstalled:t}}async O($){const y=[],C=new Map;for(const t of $.keys()){const c=$.get(t);if(!c||!(0,O.$Jb)(c.recommendations))continue;const n=[];E.$i?c.windowsPath&&n.push(c.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,P.$9d)("/usr/local/bin",t)),n.push((0,P.$9d)("/usr/bin",t)),n.push((0,P.$9d)(this.r.fsPath,t)));for(const s of n){let i=C.get(s);if(i===void 0&&(i=await this.b.exists(L.URI.file(s)),C.set(s,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:p,whenNotInstalled:m}of c.recommendations)y.push({extensionId:r,extensionName:a,isExtensionPack:p,exeName:t,exeFriendlyName:c.exeFriendlyName,windowsPath:c.windowsPath,whenNotInstalled:m})}}return y}}e.$T4b=h}),define(oe[222],ae([0,1,26,33]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nVb=void 0;async function A(L,D,I,S,f){try{const P=await L.getExtensionsControlManifest();if(!P.deprecated)return;const E=await L.getInstalled(1);for(const[b,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:g,autoMigrate:w,preRelease:d}=l.extension;if(!w)continue;const h=E.find($=>(0,N.$po)($.identifier,{id:b}));if(!h)continue;const o=(await D.getExtensions([{id:g,preRelease:d}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!o){f.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{f.info(`Migrating '${h.identifier.id}' extension to '${g}' extension...`);const $=!S.getDisabledExtensions().some(C=>(0,N.$po)(C,h.identifier));await L.uninstall(h),f.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let y=E.find(C=>(0,N.$po)(C.identifier,{id:g}));(!y||!y.isPreReleaseVersion&&$)&&(y=await L.installFromGallery(o,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${y.identifier.id}'`),$||(await S.disableExtension(y.identifier),f.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),w.storage&&(I.addToMigrationList((0,N.$so)(h.manifest.publisher,h.manifest.name),(0,N.$so)(y.manifest.publisher,y.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${h.identifier.id}' extension to '${g}' extension.`)}catch($){f.error($)}}}catch(P){f.error(P)}}e.$nVb=A}),define(oe[223],ae([0,1,3,2,35,33,44]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class I extends N.$kc{constructor(f,P,E,b,l,g,w){super(),this.f=f,this.g=P,this.h=E,this.j=b,this.m=l,this.n=g,this.r=w,this.a=this.B(new O.$fd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$sc),this.s().then(null,d=>w.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map(P=>(this.c.set(P.id,(0,N.$hc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(f){for(const P of f.extensions)this.I(this.L(P.identifier,P.version),f.profileLocation)}async y(f){for(const P of f.extensions){const E=this.L(P.identifier,P.version);f.error?this.J(E,f.profileLocation):this.I(E,f.profileLocation)}}async z(f){for(const P of f.extensions)this.J(this.L(P.identifier,P.version),f.profileLocation)}async C(f){const P=[],E=[];for(const b of f.extensions){const l=this.L(b.identifier,b.version);f.error?this.I(l,f.profileLocation):(this.J(l,f.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then(g=>{g?P.push(g):this.r.info("Extension not found at the location",b.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch(b){this.r.error(b)}}D(f){for(const P of this.h.profiles)f.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(f){const P=[],E=[],b=await this.j.scanProfileExtensions(f),l=new Set,g=new Set;for(const[w,d]of this.b)d.has(f)&&g.add(w);for(const w of b){const d=this.L(w.identifier,w.version);l.add(d),g.has(d)||(P.push(w.identifier),this.I(d,f))}for(const w of g)if(!l.has(w)){const d=this.M(w);d&&(E.push(d.identifier),this.J(w,f))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:f}:void 0,removed:E.length?{extensions:E,profileLocation:f}:void 0})}async G(f){const P=await this.j.scanProfileExtensions(f);for(const E of P)this.I(this.L(E.identifier,E.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,P){let E=this.b.get(f);E||this.b.set(f,E=new A.$Ai(b=>this.m.extUri.getComparisonKey(b))),E.add(P)}J(f,P){const E=this.b.get(f);E&&E.delete(P),E?.size||this.b.delete(f)}L(f,P){return`${D.$Vl.toKey(f.id)}@${P}`}M(f){const[P,E]=(0,L.$ro)(f);return E?{identifier:{id:P},version:E}:void 0}}e.$xp=I}),define(oe[224],ae([0,1,43,45]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function A(L,D,I,S,f,P,E){const b={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${D.nameShort})`};if((0,N.$ho)(D,I)&&(0,N.$jo)(S)===3){const l=await(0,O.$2o)(I,f,P);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$3o=A}),define(oe[225],ae([0,1,69,18,5,2,23,16,31,14,29,33,7,72,10]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;let w=class extends l.$Jq{constructor($,y,C,t){super(C),this.h=$,this.j=t,this.g=this.B(new d(y,t)),this.h.registerParticipant({postInstall:async c=>this.m(c),postUninstall:async c=>this.n(c)})}async getBuiltInExtensionTranslationsUri($,y){const t=(await this.g.getLanguagePacks())[y];if(!t){this.j.warn(`No language pack found for ${y}`);return}const c=t.translations[$];return c?g.URI.file(c):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),y=Object.keys($).map(C=>{const t=$[C];return{...this.f(C,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((C,t)=>C.label.localeCompare(t.label)),y}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const y=await this.g.getLanguagePacks();Object.keys(y).some(C=>y[C]&&y[C].extensions.some(t=>(0,E.$po)(t.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),C=await this.g.update(y);return!(0,N.$sb)(Object.keys($),Object.keys(C))}};e.$Kq=w,e.$Kq=w=ye([Y(0,P.$2n),Y(1,f.$Jh),Y(2,P.$Zn),Y(3,b.$5i)],w);let d=class extends L.$kc{constructor($,y){super(),this.j=y,this.c={},this.f=(0,I.$9d)($.userDataPath,"languagepacks.json"),this.g=new A.$Ng}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(y=>{Object.keys(y).forEach(C=>delete y[C]),this.m(y,...$)}).then(()=>this.c)}m($,...y){for(const C of y)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.n($,C);Object.keys($).forEach(C=>this.r($[C]))}n($,y){const C=y.identifier,t=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const c of t)if(y.location.scheme===D.Schemas.file&&h(c)){let n=$[c.languageId];n||(n={hash:"",extensions:[],translations:{},label:c.localizedLanguageName??c.languageName},$[c.languageId]=n);const s=n.extensions.filter(i=>(0,E.$po)(i.extensionIdentifier,C))[0];s?s.version=y.manifest.version:n.extensions.push({extensionIdentifier:C,version:y.manifest.version});for(const i of c.translations)n.translations[i.id]=(0,I.$9d)(y.location.fsPath,i.path)}}r($){if($){const y=(0,O.createHash)("md5");for(const C of $.extensions)y.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);$.hash=y.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let y=null;return S.Promises.readFile(this.f,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(y=$(C),C)).then(C=>{for(const c of Object.keys(C))C[c]||delete C[c];this.c=C,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),S.Promises.writeFile(this.f,t)}).then(()=>y,C=>this.j.error(C))})}};d=ye([Y(0,f.$Jh),Y(1,b.$5i)],d);function h(o){if(typeof o.languageId!="string"||!Array.isArray(o.translations)||o.translations.length===0)return!1;for(const $ of o.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(o.languageName&&typeof o.languageName!="string"||o.localizedLanguageName&&typeof o.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,45]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function S(P,E,b){const l=await(0,O.$cC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,O.$cC)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new l.AppInsightsCore,d=new g.PostChannel,h={instrumentationKey:P,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(b){h.extensionConfig={};const o={alwaysUseXhrOverride:!0,httpXHROverride:b};h.extensionConfig[d.identifier]=o}return w.initialize(h,[]),w.addTelemetryInitializer(o=>{E&&(o.ext=o.ext??{},o.ext.utc=o.ext.utc??{},o.ext.utc.flags=8462029)}),w}class f{constructor(E,b,l,g,w){this.e=E,this.f=b,this.g=l,this.h=w,this.c=D,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,N.$Y)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,A.$Ym)(b,this.g),b=(0,L.$ko)(b);const l=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=b?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$eN=f}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h4b=void 0;let S=class extends O.$kc{constructor(P,E,b,l,g=""){super(),this.b=g;const w=E.getLogger(I.$do);if(w)this.a=this.B(w);else{const h=(0,I.$io)(l,b)?" (Not Sent)":"",o=()=>(0,I.$ho)(l,b)&&P.getLevel()===L.LogLevel.Trace;this.a=this.B(E.createLogger(I.$do,{name:(0,N.localize)(0,null,h),hidden:!o()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(I.$do,o()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,I.$ko)(E))}};e.$h4b=S,e.$h4b=S=ye([Y(0,L.$5i),Y(1,L.$6i),Y(2,A.$Ih),Y(3,D.$kj)],S)}),define(oe[110],ae([0,1,2,30,6,27,168,19,49,102,24,40,22,45]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,o,$){this.k=o,this.l=$,this.d={},this.i=new O.$jc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,L.$qe)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$qe)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(b.$dl)||y.affectsConfiguration(b.$fl)||y.affectsConfiguration(b.$el))&&this.m()}))}setExperimentProperty(h,o){this.d[h]=o}m(){let h=(0,l.$jo)(this.k);const o=this.l.enabledTelemetryLevels;if(o){this.h=this.sendErrorTelemetry?o.error:!1;const $=o.usage?3:o.error?2:0;h=Math.min(h,$)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,o,$){this.g<o||($=(0,N.$Ym)($,this.d),$=(0,l.$oo)($,this.j),$=(0,N.$Ym)($,this.c),this.b.forEach(y=>y.log(h,$)))}publicLog(h,o){this.n(h,3,o)}publicLog2(h,o){this.publicLog(h,o)}publicLogError(h,o){this.h&&this.n(h,2,o)}publicLogError2(h,o){this.publicLogError(h,o)}};e.$Qq=g,e.$Qq=g=ye([Y(1,I.$8h),Y(2,P.$kj)],g);function w(){const d=(0,D.localize)(0,null,f.default.nameLong),h=f.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),o=A.$o?"":(0,D.localize)(3,null),$=(0,D.localize)(4,null),y=(0,D.localize)(5,null),C=(0,D.localize)(6,null),t=(0,D.localize)(7,null),c=`
|       | ${$} | ${y} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${d} ${h} ${o}

&nbsp;

${t}
${c}

&nbsp;

${n}
`}E.$8m.as(S.$an.Configuration).registerConfiguration({id:b.$cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[b.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$8m.as(S.$an.Configuration).registerConfiguration({id:b.$cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[b.$fl]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,D.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,D.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${b.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;async function D(P,E){const b=await E.request(P,N.CancellationToken.None),l=(await(0,O.$Rd)(b.stream)).toString(),g=b.res.statusCode??200;return{headers:b.res.headers,statusCode:g,responseData:l}}async function I(P){const E={method:P.type,headers:P.headers};return new Promise((l,g)=>{const w=A.request(P.url??"",E,d=>{d.on("data",function(h){l({headers:d.headers,statusCode:d.statusCode??200,responseData:h.toString()})}),d.on("error",function(h){g(h)})});w.write(P.data,d=>{d&&g(d)}),w.end()})}async function S(P,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const w=P?await D(g,P):await I(g);b(w.statusCode,w.headers,w.responseData)}catch{b(0,{})}}class f extends L.$eN{constructor(E,b,l,g,w){const d={sendPOST:(h,o)=>{S(E,h,o)}};super(b,l,g,w,d)}}e.$fN=f}),define(oe[228],ae([0,1,23,93,19,14,7,24,22,108,109,110]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=void 0;let b=class{constructor(g,w,d,h,o,$){this.b=g,this.c=w,this.d=d,this.e=h,this.f=o,this.g=$,this.a=new Map}h(g){if(!this.a.has(g.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const d=[g.id,JSON.stringify(w),g.aiKey],o=new N.$Sp(O.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),$=[new f.$S6b(o),new P.$h4b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$Qq({appenders:$,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,w,d){this.h(g).publicLog(w,d)}publicLogError(g,w,d){this.h(g).publicLogError(w,d)}};e.$97b=b,e.$97b=b=ye([Y(0,A.$8h),Y(1,S.$9k),Y(2,D.$5i),Y(3,D.$6i),Y(4,L.$Ih),Y(5,I.$kj)],b)}),define(oe[76],ae([0,1,3,19,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProvidedOnAutoForward=e.$2u=e.TunnelPrivacyId=e.TunnelProtocol=e.$1u=e.$Zu=void 0,e.$Zu=(0,A.$Bh)("tunnelService"),e.$1u=(0,A.$Bh)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D||(e.TunnelProtocol=D={}));var I;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(d){return!!d.forwardPort}e.$2u=S;var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(h)return{address:h[1],port:+h[2]}}e.$3u=P,e.$4u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(d){return e.$4u.indexOf(d)>=0}e.$5u=E,e.$6u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(d){return e.$6u.indexOf(d)>=0}e.$7u=b;function l(d,h,o,$){if(o===1)return!1;if(o===2&&b(h)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(y?.length===4&&parseInt(y[1])>=18)return!1}return d<1024}e.$8u=l;class g{constructor(h,o,$){this.remoteAddress=h,this.localAddress=o,this.b=$,this.a=new O.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$9u=g;let w=class{constructor(h,o){this.j=h,this.k=o,this.a=new O.$fd,this.onTunnelOpened=this.a.event,this.b=new O.$fd,this.onTunnelClosed=this.b.event,this.c=new O.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],o=Array.from(this.e.values());for(const $ of o){const y=Array.from($.values());for(const C of y){const t=await C.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:o}of h.values())await o.then($=>typeof $!="string"?$?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,o,$,y,C){this.p(h,o,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:o,localAddress:$,privacy:y,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,o){(b(h)||E(h))&&(h=e.$4u[0]);const $=this.r(h,o);if($)return++$.refcount,$.value}openTunnel(h,o,$,y,C,t=!1,c,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${$} on local port ${C}.`);const s=this.f??h;if(!s)return;if(o||(o="localhost"),y||(y=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(s,o,$,y,C,t,c,n);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(o,$),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(o,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==o||r.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const o=this.e.get(h.tunnelRemoteHost);if(o){const $=o.get(h.tunnelRemotePort);$&&($.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,$))}}}}async o(h,o,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${o}.`);const y=$.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(o),y}}async closeTunnel(h,o){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${o} `);const $=this.e.get(h);if($&&$.has(o)){const y=$.get(o);y.refcount=0,await this.o(h,o,y)}}p(h,o,$){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(o,{refcount:1,value:$})}async q(h,o){const $=this.e.get(h);if($){const y=$.get(o),C=y?await y.value:void 0;(!C||typeof C=="string")&&$.delete(o),$.size===0&&this.e.delete(h)}}r(h,o){const $=[h];E(h)?($.push(...e.$4u),$.push(...e.$6u)):b(h)&&$.push(...e.$6u);const y=$.map(C=>this.e.get(C));for(const C of y){const t=C?.get(o);if(t)return t}}canTunnel(h){return!!P(h)}t(h,o,$,y,C,t,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${$} on local port ${y}.`);const n=$;this.i.add(n);const s=y===void 0?$:y,i={elevationRequired:C?this.isPortPrivileged(s):!1},r={remoteAddress:{host:o,port:$},localAddressPort:y,privacy:t,public:t?t!==I.Private:void 0,protocol:c},a=h.forwardPort(r,i);return a?(this.p(o,$,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$0u=w,e.$0u=w=ye([Y(0,L.$5i),Y(1,N.$8h)],w)}),define(oe[229],ae([0,1,7,76,2,8,5]),function(te,e,O,N,A,L,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;class S extends A.$kc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$2g),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let f=class extends A.$kc{static{I=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(E,b,l,g,w,d,h){const o=new S,$=await Promise.resolve(this.f.openTunnel(E,o,l,g,w,d,h));if(!$||typeof $=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${g} (remote).`),o.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),o.dispose(),await $.dispose(),(0,L.$4)();return o.setTunnel($),this.b.set(b,o),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${$.localAddress} (local) to ${l}:${g} (remote).`),{tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$j8b=f,e.$j8b=f=I=ye([Y(0,N.$1u),Y(1,O.$5i)],f)}),define(oe[28],ae([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,O.$Bh)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,21,128,3,2]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class f{static{this._clock=0}constructor(b){this.uri=b,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let P=class{constructor(b){this.g=b,this.c=new S.$jc,this.f=2**16;const l=new Map,g=w=>{let d=l.get(w.scheme);return d===void 0&&(d=b.hasProvider(w)&&!this.g.hasCapability(w,1024),l.set(w.scheme,d)),d};this.c.add(I.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{l.delete(w.scheme)})),this.extUri=new L.$0f(g),this.d=new D.$or((w,d)=>this.extUri.compare(w,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,L.$jg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new f(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((g,w)=>g[1].time<w[1].time?1:g[1].time>w[1].time?-1:0);f._clock=0,this.d.clear();const l=this.f*.5;for(let g=0;g<l;g++)this.d.set(b[g][0],b[g][1].touch())}};e.$pr=P,e.$pr=P=ye([Y(0,A.$6j)],P),(0,N.$mr)(O.$Ck,P,1)}),define(oe[231],ae([0,1,3,2,11,47,35]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;class I extends N.$kc{constructor(f,P,E,b,l,g){super(),this.f=f,this.g=P,this.h=E,this.j=b,this.m=l,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$fd),this.onDidChangeFile=this.a.event,this.b=L.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Ai(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const f of this.j.profiles)this.c.add(f.settingsResource),this.c.add(f.keybindingsResource),this.c.add(f.tasksResource),this.c.add(f.extensionsResource)}open(f,P){return this.g.open(this.t(f),P)}close(f){return this.g.close(f)}read(f,P,E,b,l){return this.g.read(f,P,E,b,l)}write(f,P,E,b,l){return this.g.write(f,P,E,b,l)}watch(f,P){this.b.set(f,f);const E=this.g.watch(this.t(f),P);return(0,N.$ic)(()=>{this.b.delete(f),E.dispose()})}stat(f){return this.g.stat(this.t(f))}mkdir(f){return this.g.mkdir(this.t(f))}rename(f,P,E){return this.g.rename(this.t(f),this.t(P),E)}readFile(f,P){return this.g.readFile(this.t(f),P)}readFileStream(f,P,E){return this.g.readFileStream(this.t(f),P,E)}readdir(f){return this.g.readdir(this.t(f))}enforceAtomicReadFile(f){return this.c.has(f)}writeFile(f,P,E){return this.g.writeFile(this.t(f),P,E)}enforceAtomicWriteFile(f){return this.c.has(f)?{postfix:".vsctmp"}:!1}delete(f,P){return this.g.delete(this.t(f),P)}copy(f,P,E){if((0,A.$9j)(this.g))return this.g.copy(this.t(f),this.t(P),E);throw new Error("copy not supported")}cloneFile(f,P){if((0,A.$0j)(this.g))return this.g.cloneFile(this.t(f),this.t(P));throw new Error("clone not supported")}s(f){const P=[];for(const E of f){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&P.push({resource:b,type:E.type})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(f){return f.with({scheme:this.f})}u(f){return f.with({scheme:this.h})}}e.$D7b=I}),define(oe[77],ae([0,1,85]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7zb=e.$6zb=e.edit=void 0;function N(D,I,S,f){const P=(0,O.$HS)(D,I,S,f)[0];return P&&(D=D.substring(0,P.offset)+P.content+D.substring(P.offset+P.length)),D}e.edit=N;function A(D,I,S){let f=S;for(;f>=0;){if(D.charAt(f)===I.charAt(I.length-1)&&I.length===1)return f+1;if(f--,I.length===2&&f>=0&&D.charAt(f)===I.charAt(0))return f+2}return 0}e.$6zb=A;function L(D,I,S){let f=S;for(;f>=0;)if(D.charAt(f)===I.charAt(I.length-1)&&I.length===1||(f++,I.length===2&&f>=0&&D.charAt(f)===I.charAt(1)))return f;return D.length-1}e.$7zb=L}),define(oe[232],ae([0,1,30,53,12]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=void 0;function L(l,g,w,d,h,o){const $=[],y=[],C=[];if(!g){const U=l.filter(({identifier:_})=>h.every(K=>K.toLowerCase()!==_.id.toLowerCase()));return{local:{added:$,removed:y,updated:C},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}l=l.map(E),g=g.map(E),w=w?w.map(E):null;const t=new Map,c=U=>{U.uuid&&t.set(U.id.toLowerCase(),U.uuid)};l.forEach(({identifier:U})=>c(U)),g.forEach(({identifier:U})=>c(U)),w?.forEach(({identifier:U})=>c(U));const n=U=>{const _=U.identifier.uuid||t.get(U.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,_)=>(U.set(n(_),_),U),i=l.reduce(s,new Map),r=g.reduce(s,new Map),a=g.reduce((U,_)=>s(U,(0,O.$Vm)(_)),new Map),p=w?w.reduce(s,new Map):null,m=d.reduce(s,new Map),u=h.reduce((U,_)=>{const K=t.get(_.toLowerCase());return U.add(K?`uuid:${K}`:`id:${_.toLowerCase()}`)},new Set),v=o?o.reduce((U,{id:_,uuid:K})=>(K=K??t.get(_.toLowerCase()),U.add(K?`uuid:${K}`:`id:${_.toLowerCase()}`)),new Set):null,j=D(i,r,u,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const U=D(p,i,u,!1),_=D(p,r,u,!0),K=(X,H,x,G)=>{let V,W,ee;return H.installed?(V=G.pinned,ee=G.preRelease,V&&(W=G.version)):(V=x.pinned,ee=x.preRelease,V&&(W=x.version)),V===void 0&&(V=H.pinned,V&&(W=H.version)),ee===void 0&&(ee=H.preRelease),{...G,installed:H.installed||x.installed,pinned:V,preRelease:ee,version:W??(x.version&&(!H.installed||N.gt(x.version,H.version))?x.version:H.version),state:S(H,x,p?.get(X))}};for(const X of _.removed.values()){const H=i.get(X);if(!H)continue;const x=(0,A.$uf)(p?.get(X)),G=v&&!v.has(X)&&x.installed;H.installed&&G?y.push(H.identifier):a.set(X,H)}for(const X of _.added.values()){const H=(0,A.$uf)(r.get(X)),x=i.get(X);if(x){if(j.updated.has(X)){const G=K(X,x,H,H);I(x,H,!1,!1)||C.push(b(G,X)),a.set(X,G)}}else H.installed&&$.push(b(H,X))}for(const X of _.updated.values()){const H=(0,A.$uf)(r.get(X)),x=(0,A.$uf)(p?.get(X)),G=i.get(X);if(G)if(v&&!v.has(X)&&x.installed&&G.installed&&!H.installed)y.push(G.identifier);else{const W=K(X,G,H,H);C.push(b(W,X)),a.set(X,W)}else H.installed&&$.push(b(H,X))}for(const X of U.added.values())_.added.has(X)||a.set(X,(0,A.$uf)(i.get(X)));for(const X of U.updated.values()){if(_.removed.has(X)||_.updated.has(X))continue;const H=(0,A.$uf)(i.get(X)),x=(0,A.$uf)(r.get(X));a.set(X,K(X,H,x,H))}for(const X of U.removed.values())_.updated.has(X)||_.removed.has(X)||m.has(X)||(0,A.$uf)(r.get(X)).installed&&v&&(v.has(X)||!(0,A.$uf)(p?.get(X)).installed||a.delete(X))}const F=[],T=D(r,a,new Set,!0),z=T.added.size>0||T.updated.size>0||T.removed.size>0;return z&&a.forEach((U,_)=>F.push(b(U,_))),{local:{added:$,removed:y,updated:C},remote:z?{added:[...T.added].map(U=>a.get(U)),updated:[...T.updated].map(U=>a.get(U)),removed:[...T.removed].map(U=>r.get(U)),all:F}:null}}e.$22b=L;function D(l,g,w,d){const h=l?[...l.keys()].filter(t=>!w.has(t)):[],o=[...g.keys()].filter(t=>!w.has(t)),$=o.filter(t=>!h.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),y=h.filter(t=>!o.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),C=new Set;for(const t of h){if(y.has(t))continue;const c=l.get(t),n=g.get(t);(!n||!I(c,n,d,!0))&&C.add(t)}return{added:$,removed:y,updated:C}}function I(l,g,w,d){return!(l.disabled!==g.disabled||!!l.isApplicationScoped!=!!g.isApplicationScoped||d&&l.installed!==g.installed||l.installed&&g.installed&&(l.preRelease!==g.preRelease||l.pinned!==g.pinned||g.pinned&&l.version!==g.version)||!P(l.state,g.state)||w&&l.version!==g.version)}function S(l,g,w){const d=l.state,h=g.state,o=w?.state;if(!g.version||d&&N.gt(l.version,g.version))return d;if(h&&N.gt(g.version,l.version)||!d)return h;if(!h)return d;const $=(0,O.$Vm)(d),y=o?f(o,h):{added:Object.keys(h).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set},C=o?f(o,d):{added:Object.keys(d).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set};for(const t of[...y.added.values(),...y.updated.values()])$[t]=h[t];for(const t of y.removed.values())C.updated.has(t)||delete $[t];return $}function f(l,g){const w=Object.keys(l),d=Object.keys(g),h=d.filter(y=>!w.includes(y)).reduce((y,C)=>(y.add(C),y),new Set),o=w.filter(y=>!d.includes(y)).reduce((y,C)=>(y.add(C),y),new Set),$=new Set;for(const y of w){if(o.has(y))continue;const C=l[y],t=g[y];(0,O.$Zm)(C,t)||$.add(y)}return{added:h,removed:o,updated:$}}function P(l={},g={}){const{added:w,removed:d,updated:h}=f(l,g);return w.size===0&&d.size===0&&h.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,g){const w={...l,identifier:{id:l.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete w.disabled,l.installed||delete w.installed,l.state||delete w.state,l.isApplicationScoped||delete w.isApplicationScoped,w}}),define(oe[111],ae([0,1,18,19,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Bb=e.$5Bb=void 0,e.$5Bb=(0,A.$Bh)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,S){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return f=f.filter(P=>P!==I&&P!==`-${I}`),S&&f.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(I,S){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return f=f.filter(P=>P!==I&&P!==`-${I}`),S&&f.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(I){const S=I.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),f=this.b().map(b=>b.toLowerCase()),P=[],E=[];if(Array.isArray(f))for(const b of f)b.startsWith("-")?E.push(b.substring(1)):P.push(b);return(0,O.$Kb)([...S,...P].filter(b=>!E.includes(b)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$6Bb=L,e.$6Bb=L=ye([Y(0,N.$8h)],L)}),define(oe[233],ae([0,1,18,34,30,94,77]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$82b=void 0;function I(y){return(0,N.$Lm)(y)||[]}async function S(y,C,t,c,n){const s=I(y),i=I(C),r=t?I(t):null,a=[...s,...i,...r||[]].map(K=>K.key),p=await n.resolveUserBindings(a),m=P(s,i,r,p);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:y,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};const u=b(s),v=b(i),j=r?b(r):null,F=g(u,v,p),T=j?g(j,u,p):{added:[...u.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},z=j?g(j,v,p):{added:[...v.keys()].reduce((K,X)=>(K.add(X),K),new Set),removed:new Set,updated:new Set},U=f(F,T,z);let _=y;for(const K of U.removed.values())U.conflicts.has(K)||(_=o(_,K,c));for(const K of U.added.values()){if(U.conflicts.has(K))continue;const X=v.get(K);if(X.some(H=>H.command!==`-${K}`&&m.conflicts.has(p[H.key]))){U.conflicts.add(K);continue}_=h(_,X,c)}for(const K of U.updated.values()){if(U.conflicts.has(K))continue;const X=v.get(K);if(X.some(H=>H.command!==`-${K}`&&m.conflicts.has(p[H.key]))){U.conflicts.add(K);continue}_=$(_,K,X,c)}return{mergeContent:_,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.$82b=S;function f(y,C,t){const c=new Set,n=new Set,s=new Set,i=new Set;for(const r of C.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(C.updated.has(r)?i.add(r):n.add(r));for(const r of C.added.values())i.has(r)||t.added.has(r)&&y.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(C.added.has(r)?y.updated.has(r)&&i.add(r):c.add(r));for(const r of C.updated.values())i.has(r)||t.updated.has(r)&&y.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(C.updated.has(r)?y.updated.has(r)&&i.add(r):s.add(r));return{added:c,removed:n,updated:s,conflicts:i}}function P(y,C,t,c){const n=new Set,s=E(y,c),i=E(C,c),r=t?E(t,c):null,a=l(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const p=r?l(r,s):{added:[...s.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=r?l(r,i):{added:[...i.keys()].reduce((T,z)=>(T.add(z),T),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:v,updated:j,conflicts:F}=f(a,p,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:v,updated:j,conflicts:F}}function E(y,C){const t=new Map;for(const c of y){const n=C[c.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(c)}return t}function b(y){const C=new Map;for(const t of y){const c=t.command[0]==="-"?t.command.substring(1):t.command;let n=C.get(c);n||(n=[],C.set(c,n)),n.push(t)}return C}function l(y,C){const t=[...y.keys()],c=[...C.keys()],n=c.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=t.filter(r=>!c.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(s.has(r))continue;const a=y.get(r).map(m=>({...m,key:r})),p=C.get(r).map(m=>({...m,key:r}));(0,O.$sb)(a,p,(m,u)=>d(m,u))||i.add(r)}return{added:n,removed:s,updated:i}}function g(y,C,t){const c=[...y.keys()],n=[...C.keys()],s=n.filter(a=>!c.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),i=c.filter(a=>!n.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),r=new Set;for(const a of c){if(i.has(a))continue;const p=y.get(a).map(u=>({...u,key:t[u.key]})),m=C.get(a).map(u=>({...u,key:t[u.key]}));w(p,m)||r.add(a)}return{added:s,removed:i,updated:r}}function w(y,C){return!(!(0,O.$sb)(y.filter(({command:t})=>t[0]!=="-"),C.filter(({command:t})=>t[0]!=="-"),(t,c)=>d(t,c))||!(0,O.$sb)(y.filter(({command:t})=>t[0]==="-"),C.filter(({command:t})=>t[0]==="-"),(t,c)=>d(t,c)))}function d(y,C){if(y.command!==C.command||y.key!==C.key)return!1;const t=L.$Ii.deserialize(y.when),c=L.$Ii.deserialize(C.when);return!(t&&!c||!t&&c||t&&c&&!t.equals(c)||!A.$Zm(y.args,C.args))}function h(y,C,t){for(const c of C)y=D.edit(y,[-1],c,t);return y}function o(y,C,t){const c=I(y);for(let n=c.length-1;n>=0;n--)(c[n].command===C||c[n].command===`-${C}`)&&(y=D.edit(y,[n],void 0,t));return y}function $(y,C,t,c){const n=I(y),s=n.findIndex(i=>i.command===C||i.command===`-${C}`);for(let i=n.length-1;i>=0;i--)(n[i].command===C||n[i].command===`-${C}`)&&(y=D.edit(y,[i],void 0,c));for(let i=t.length-1;i>=0;i--)y=D.edit(y,[s],t[i],c);return y}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d3b=e.$c3b=void 0;function O(L,D,I){const S={},f={},P=new Set;if(!D)return{local:{added:S,updated:f,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=N(L,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:f,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=N(I,L),l=N(I,D),g={},w={},d=new Set,h=new Set;for(const o of b.removed.values())l.updated.has(o)?S[o]=D[o]:d.add(o);for(const o of l.removed.values())h.has(o)||(b.updated.has(o)?h.add(o):P.add(o));for(const o of b.updated.values())h.has(o)||(l.updated.has(o)?E.updated.has(o)&&h.add(o):w[o]=L[o]);for(const o of l.updated.values())h.has(o)||(b.updated.has(o)?E.updated.has(o)&&h.add(o):L[o]!==void 0&&(f[o]=D[o]));for(const o of b.added.values())h.has(o)||(l.added.has(o)?E.updated.has(o)&&h.add(o):g[o]=L[o]);for(const o of l.added.values())h.has(o)||(b.added.has(o)?E.updated.has(o)&&h.add(o):S[o]=D[o]);return{local:{added:S,removed:[...P.values()],updated:f},remote:{added:g,removed:[...d.values()],updated:w},conflicts:[...h.values()]}}e.$c3b=O;function N(L,D){const I=L?Object.keys(L):[],S=D?Object.keys(D):[],f=S.filter(b=>!I.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),P=I.filter(b=>!S.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of I){if(P.has(b))continue;const l=L[b],g=D[b];l!==g&&E.add(b)}return{added:f,removed:P,updated:E}}function A(L,D){const{added:I,removed:S,updated:f}=N(L,D);return I.size===0&&S.size===0&&f.size===0}e.$d3b=A}),define(oe[235],ae([0,1,30]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W4b=void 0;function N(L,D,I,S){const f={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!D){const b=L.filter(({id:l})=>!S.includes(l));return b.length?P.added=b:P=null,{local:f,remote:P}}const E=A(L,D,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=A(I,L,S),l=A(I,D,S);for(const g of l.removed){const w=L.find(d=>d.id===g);w&&f.removed.push(w)}for(const g of l.added){const w=D.find(d=>d.id===g);b.added.includes(g)?E.updated.includes(g)&&f.updated.push(w):f.added.push(w)}for(const g of l.updated)f.updated.push(D.find(w=>w.id===g));for(const g of b.added)l.added.includes(g)||P.added.push(L.find(w=>w.id===g));for(const g of b.updated)l.removed.includes(g)||l.updated.includes(g)||P.updated.push(L.find(w=>w.id===g));for(const g of b.removed){const w=D.find(d=>d.id===g);w&&P.removed.push(w)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:f,remote:P}}e.$W4b=N;function A(L,D,I){L=L?L.filter(({id:l})=>!I.includes(l)):[],D=D.filter(({id:l})=>!I.includes(l));const S=L.map(({id:l})=>l),f=D.map(({id:l})=>l),P=f.filter(l=>!S.includes(l)),E=S.filter(l=>!f.includes(l)),b=[];for(const{id:l,name:g,shortName:w,icon:d,useDefaultFlags:h}of L){if(E.includes(l))continue;const o=D.find($=>$.id===l);(!o||o.name!==g||o.shortName!==w||o.icon!==d||!(0,O.$Zm)(o.useDefaultFlags,h))&&b.push(l)}return{added:P,removed:E,updated:b}}}),define(oe[25],ae([0,1,18,12,174,49,29,4,103,40]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gb=e.$2gb=e.$1gb=e.$Zgb=e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.MergeState=e.Change=e.SyncStatus=e.$Rgb=e.$Qgb=e.$Pgb=e.UserDataSyncErrorCode=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=e.$Hgb=e.$Ggb=e.SyncResource=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.$Bgb=e.$Agb=void 0;function P(){const i=f.$8m.as(L.$an.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$Agb=P;function E(){const i=f.$8m.as(L.$an.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(m=>!!i[m].ignoreSync),a=Object.keys(i).filter(m=>i[m].scope===2||i[m].scope===6),p=P();return(0,O.$Kb)([...r,...a,...p])}e.$Bgb=E,e.$Cgb="settingsSync",e.$Dgb="settingsSync.keybindingsPerPlatform";function b(){const i="vscode://schemas/ignoredSettings",r=f.$8m.as(L.$an.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$Dgb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:D.$Mn,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.$8m.as(S.$9m.JSONContribution),p=()=>{const m=P(),u=E(),v=Object.keys(L.$bn.properties).filter(T=>!u.includes(T)),j=u.filter(T=>!m.includes(T)),F={items:{type:"string",enum:[...v,...j.map(T=>`-${T}`)]}};a.registerSchema(i,F)};return r.onDidUpdateConfiguration(()=>p())}e.$Egb=b;function l(i){return i&&(0,N.$lf)(i)&&(0,N.$jf)(i.id)&&Array.isArray(i.scopes)}e.$Fgb=l;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$Ggb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(i,...r){return i?[i,...r]:r}e.$Hgb=w;function d(i,r,a,p){return p.joinPath(a.userDataSyncHome,...w(i,r,`lastSync${r}.json`))}e.$Igb=d,e.$Jgb=(0,I.$Bh)("IUserDataSyncStoreManagementService"),e.$Kgb=(0,I.$Bh)("IUserDataSyncStoreService"),e.$Lgb=(0,I.$Bh)("IUserDataSyncLocalStoreService"),e.$Mgb="x-operation-id",e.$Ngb="X-Execution-Id";function h(i){const r={};return r[e.$Ngb]=i,r}e.$Ogb=h;var o;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(o||(e.UserDataSyncErrorCode=o={}));class $ extends Error{constructor(r,a,p,m){super(r),this.code=a,this.resource=p,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Pgb=$;class y extends ${constructor(r,a,p,m,u){super(r,p,void 0,u),this.url=a,this.serverCode=m}}e.$Qgb=y;class C extends ${constructor(r,a){super(r,a)}}e.$Rgb=C,function(i){function r(a){if(a instanceof i)return a;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(p&&p[1]){const m=p[2]==="unknown"?void 0:p[2],u=p[3]==="unknown"?void 0:p[3];return new i(a.message,p[1],m,u)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}($||(e.$Pgb=$={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var c;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(c||(e.Change=c={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Sgb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$Tgb=s,e.$Ugb=(0,I.$Bh)("IUserDataSyncEnablementService"),e.$Vgb=(0,I.$Bh)("IUserDataSyncService"),e.$Wgb=(0,I.$Bh)("IUserDataSyncResourceProviderService"),e.$Xgb=(0,I.$Bh)("IUserDataAutoSyncService"),e.$Ygb=(0,I.$Bh)("IUserDataSyncUtilService"),e.$Zgb=(0,I.$Bh)("IUserDataSyncLogService"),e.$1gb="userDataSync",e.$2gb="vscode-userdata-sync",e.$3gb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oBb=void 0;function A(D,I,S,f,P){if(!I)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const E=L(D,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=S?L(S,I):{added:Object.keys(I).reduce((o,$)=>(o.add($),o),new Set),removed:new Set,updated:new Set},l=S?L(S,D):{added:Object.keys(D).reduce((o,$)=>(o.add($),o),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},w=O.$Vm(I),d=!S;for(const o of l.added.values())o!==N.$Sgb&&d&&b.added.has(o)||(w[o]=D[o]);for(const o of l.updated.values())w[o]=D[o];for(const o of l.removed.values())f.unregistered.includes(o)||delete w[o];for(const o of b.added.values()){const $=I[o];if(f.machine.includes(o)){P.info(`GlobalState: Skipped adding ${o} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(o))continue;const y=D[o];y&&y.value===$.value||o===N.$Sgb&&d&&l.added.has(o)||(y?g.updated[o]=$:g.added[o]=$)}for(const o of b.updated.values()){const $=I[o];if(f.machine.includes(o)){P.info(`GlobalState: Skipped updating ${o} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(o)||l.removed.has(o))continue;const y=D[o];y&&y.value===$.value||(g.updated[o]=$)}for(const o of b.removed.values()){if(f.machine.includes(o)){P.trace(`GlobalState: Skipped removing ${o} in local storage because it is declared as machine scoped.`);continue}l.updated.has(o)||l.removed.has(o)||g.removed.push(o)}const h=L(I,w);return{local:g,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:w}}}e.$oBb=A;function L(D,I){const S=Object.keys(D),f=Object.keys(I),P=f.filter(l=>!S.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),E=S.filter(l=>!f.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),b=new Set;for(const l of S){if(E.has(l))continue;const g=D[l],w=I[l];O.$Zm(g,w)||b.add(l)}return{added:P,removed:E,updated:b}}}),define(oe[237],ae([0,1,18,34,85,41,30,77,25]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aAb=e.$_zb=e.$$zb=e.$0zb=e.$9zb=e.$8zb=void 0;function f(a,p,m){let u=[];m?u=E(m):u=P(p);const v=[],j=[...(0,S.$Agb)()];if(Array.isArray(u))for(const F of u)F.startsWith("-")?j.push(F.substring(1)):v.push(F);return(0,O.$Kb)([...a,...v].filter(F=>!j.includes(F)))}e.$8zb=f;function P(a){let p=a.inspect("settingsSync.ignoredSettings").userValue;return p!==void 0||(p=a.inspect("sync.ignoredSettings").userValue,p!==void 0)?p:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const p=(0,N.$Lm)(a);return p?p["settingsSync.ignoredSettings"]||p["sync.ignoredSettings"]||[]:[]}function b(a,p){const m=(0,N.$Lm)(a)||{};let u="{}";for(const v of Object.keys(m)){const j=(0,A.$HS)(u,[v],m[v],p);u=(0,A.$KS)(u,j)}return u}e.$9zb=b;function l(a,p,m,u){if(m.length){const v=r(p),j=(0,N.$Lm)(p)||{},F=(0,N.$Lm)(a);if(!F)return a;const T=[];for(const z of m){const U=j[z],_=F[z];U===void 0?a=I.edit(a,[z],void 0,u):_!==void 0?a=I.edit(a,[z],U,u):T.push(t(z,v))}T.sort((z,U)=>z.startOffset-U.startOffset),T.forEach(z=>a=o(z.setting.key,p,a,u))}return a}e.$0zb=l;function g(a,p,m,u,v,j){const F=l(a,p,u,j),T=m!==F,z=m!==p;if(!T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!z)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(z&&!T)return{conflictsSettings:[],localContent:l(p,a,u,j),remoteContent:null,hasConflicts:!1};if(m===null&&d(a)){const R=w(a,p,u)?null:l(p,a,u,j);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let U=a,_=p;const K=(0,N.$Lm)(a),X=(0,N.$Lm)(p),H=m?(0,N.$Lm)(m):null,x=u.reduce((R,B)=>(R.add(B),R),new Set),G=h(K,X,x),V=h(H,K,x),W=h(H,X,x),ee=new Map,ne=new Set,re=R=>{ne.add(R);const B=v.filter(({key:M})=>M===R)[0];B?(U=I.edit(U,[R],B.value,j),_=I.edit(_,[R],B.value,j)):ee.set(R,{key:R,localValue:K[R],remoteValue:X[R]})};for(const R of V.removed.values())W.updated.has(R)?re(R):_=I.edit(_,[R],void 0,j);for(const R of W.removed.values())ne.has(R)||(V.updated.has(R)?re(R):U=I.edit(U,[R],void 0,j));for(const R of V.updated.values())ne.has(R)||(W.updated.has(R)?G.updated.has(R)&&re(R):_=I.edit(_,[R],K[R],j));for(const R of W.updated.values())ne.has(R)||(V.updated.has(R)?G.updated.has(R)&&re(R):U=I.edit(U,[R],X[R],j));for(const R of V.added.values())ne.has(R)||(W.added.has(R)?G.updated.has(R)&&re(R):_=o(R,U,_,j));for(const R of W.added.values())ne.has(R)||(V.added.has(R)?G.updated.has(R)&&re(R):U=o(R,_,U,j));const Q=ee.size>0||!w(U,_,u),q=Q||!w(U,a,[]),k=Q||!w(_,p,[]);return{localContent:q?U:null,remoteContent:k?_:null,conflictsSettings:[...ee.values()],hasConflicts:Q}}e.$$zb=g;function w(a,p,m){if(a===p)return!0;const u=(0,N.$Lm)(a),v=(0,N.$Lm)(p),j=m.reduce((z,U)=>(z.add(U),z),new Set),F=r(a).filter(z=>!(z.setting&&j.has(z.setting.key))),T=r(p).filter(z=>!(z.setting&&j.has(z.setting.key)));if(F.length!==T.length)return!1;for(let z=0;z<F.length;z++){const U=F[z],_=T[z];if(U.setting&&_.setting){if(U.setting.key!==_.setting.key||!D.$Zm(u[U.setting.key],v[U.setting.key]))return!1}else if(!U.setting&&!_.setting){if(U.value!==_.value)return!1}else return!1}return!0}function d(a){return a?r(a).length===0:!0}e.$_zb=d;function h(a,p,m){const u=a?Object.keys(a).filter(z=>!m.has(z)):[],v=Object.keys(p).filter(z=>!m.has(z)),j=v.filter(z=>!u.includes(z)).reduce((z,U)=>(z.add(U),z),new Set),F=u.filter(z=>!v.includes(z)).reduce((z,U)=>(z.add(U),z),new Set),T=new Set;if(a)for(const z of u){if(F.has(z))continue;const U=a[z],_=p[z];D.$Zm(U,_)||T.add(z)}return{added:j,removed:F,updated:T}}function o(a,p,m,u){const v=(0,N.$Lm)(p),j=r(p),F=r(m),T=$(a,j,F);return y(m,a,v[a],T,F,u)}e.$aAb=o;function $(a,p,m){const u=p.findIndex(j=>j.setting?.key===a),v=p[u-1];if(v){if(v.setting){const F=t(v.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=c(u,p);if(F){const T=t(F.setting.key,m);if(T){const z=n(m.indexOf(T),m),U=s(p,F,p[u]);if(z){const _=s(m,T,z),K=i(U,_);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.indexOf(z),insertAfter:!1}}else{const _=s(m,T,m[m.length-1]),K=i(U,_);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const j=p[u+1];if(j)if(j.setting){const F=t(j.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=n(u,p);if(F){const T=t(F.setting.key,m);if(T){const z=c(m.indexOf(T),m),U=s(p,p[u],F);if(z){const _=s(m,z,T),K=i(U.reverse(),_.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:m.indexOf(z),insertAfter:!0}}else{const _=s(m,m[0],T),K=i(U.reverse(),_.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function y(a,p,m,u,v,j){let F;return u.index===-1?F=(0,A.$HS)(a,[p],m,j):F=C(a,p,m,u,v,j).map(T=>(0,A.$IS)(a,T,j)[0]),(0,A.$KS)(a,F)}function C(a,p,m,u,v,j){const F=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,T=(0,L.$ES)(j,a),z=v[u.index];if(u.insertAfter){const U=[];if(z.setting)U.push({offset:z.endOffset,length:0,content:","+F});else{const _=n(u.index,v),K=c(u.index,v),X=K?.setting?.commaOffset;K&&X===void 0&&U.push({offset:K.endOffset,length:0,content:","});const H=X!==void 0&&X>z.endOffset;U.push({offset:H?X+1:z.endOffset,length:0,content:_?T+F+",":T+F})}return U}else{if(z.setting)return[{offset:z.startOffset,length:0,content:F+","}];const U=(v[u.index-1]&&!v[u.index-1].setting?T:"")+F+(n(u.index,v)?",":"")+T;return[{offset:z.startOffset,length:0,content:U}]}}function t(a,p){return p.filter(m=>m.setting?.key===a)[0]}function c(a,p){for(let m=a-1;m>=0;m--)if(p[m].setting)return p[m]}function n(a,p){for(let m=a+1;m<p.length;m++)if(p[m].setting)return p[m]}function s(a,p,m){const u=a.indexOf(p),v=a.indexOf(m);return a.filter((j,F)=>u<F&&F<v)}function i(a,p){if(a.length&&p.length){let m=0;for(;m<p.length&&m<a.length;m++)if(a[m].value!==p[m].value)return p[m-1];return p[m-1]}}function r(a){const p=[];let m=-1,u,v;const j={onObjectBegin:F=>{m++},onObjectProperty:(F,T,z)=>{m===0&&(u=T,v=F)},onObjectEnd:(F,T)=>{m--,m===0&&p.push({startOffset:u,endOffset:F+T,value:a.substring(u,F+T),setting:{key:v,commaOffset:void 0}})},onArrayBegin:(F,T)=>{m++},onArrayEnd:(F,T)=>{m--,m===0&&p.push({startOffset:u,endOffset:F+T,value:a.substring(u,F+T),setting:{key:v,commaOffset:void 0}})},onLiteralValue:(F,T,z)=>{m===0&&p.push({startOffset:u,endOffset:T+z,value:a.substring(u,T+z),setting:{key:v,commaOffset:void 0}})},onSeparator:(F,T,z)=>{if(m===0&&F===","){let U=p.length-1;for(;U>=0&&!p[U].setting;U--);const _=p[U];_&&p.splice(U,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:T}})}},onComment:(F,T)=>{m===0&&p.push({startOffset:F,endOffset:F+T,value:a.substring(F,F+T)})}};return(0,N.$Sm)(a,j),p}}),define(oe[78],ae([0,1,3,2,4,25]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Szb=e.$Rzb=void 0,e.$Rzb=(0,A.$Bh)("IUserDataSyncAccountService");let D=class extends N.$kc{get account(){return this.a}constructor(S,f){super(),this.g=S,this.h=f,this.b=this.B(new O.$fd),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$fd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$Szb=D,e.$Szb=D=ye([Y(0,L.$Kgb),Y(1,L.$Zgb)],D)}),define(oe[238],ae([0,1,2,10]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=e.$b8b=e.$a8b=e.$_7b=e.$$7b=e.$07b=void 0;class A{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$07b=A;class L{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$$7b=L;class D{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$_7b=D;class I{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,g){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$a8b=I;class S{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$b8b=S;class f{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$c8b=f;class P extends O.$kc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:N.URI.revive(b.url),type:b.type,defaultUrl:N.URI.revive(b.defaultUrl),insidersUrl:N.URI.revive(b.insidersUrl),stableUrl:N.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$d8b=P}),define(oe[239],ae([0,1,21,175,14,7,25]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Bb=void 0;let I=class extends L.$0i{constructor(f,P){super(),this.g=this.B(f.createLogger((0,O.$ig)(P.logsHome,`${D.$1gb}.log`),{id:D.$1gb,name:(0,N.localize)(0,null)}))}trace(f,...P){this.g.trace(f,...P)}debug(f,...P){this.g.debug(f,...P)}info(f,...P){this.g.info(f,...P)}warn(f,...P){this.g.warn(f,...P)}error(f,...P){this.g.error(f,...P)}flush(){this.g.flush()}};e.$7Bb=I,e.$7Bb=I=ye([Y(0,L.$6i),Y(1,A.$Ih)],I)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=void 0,e.$D8b=(0,N.$Bh)("voiceRecognitionService");let L=class{constructor(I,S){this.a=I,this.b=S}async transcribe(I,S){const f=process.env.VSCODE_VOICE_MODULE_PATH;if(!f||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${I.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();try{const E=te.__$__nodeRequire(f),b=new AbortController;S.onCancellationRequested(()=>b.abort());const l=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:I},{language:"en",signal:b.signal});return this.a.info(`[voice] transcribe(${I.length}): Text "${l}", took ${Date.now()-P}ms)`),l}catch(E){throw this.a.error(`[voice] transcribe(${I.length}): Failed width "${E}", took ${Date.now()-P}ms)`),E}}};e.$E8b=L,e.$E8b=L=ye([Y(0,O.$5i),Y(1,A.$kj)],L)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,O,N,A,L,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;let S=class extends O.$kc{static{I=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(l,g,w){super(),this.b=l,this.c=g,this.f=w,this.g()}g(){this.B(this.b(l=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${I.a})`),I.a?this.B(new P(l,this.c,this.f)):this.B(new E(l,this.c,this.f))}))}};e.$F8b=S,e.$F8b=S=I=ye([Y(1,N.$D8b),Y(2,A.$5i)],S);class f extends O.$kc{static{this.a=30*16e3*16*1/8}constructor(l,g,w){super(),this.b=l,this.c=g,this.f=w,this.g()}g(){const l=new L.$pd;this.B((0,O.$ic)(()=>l.dispose(!0)));const g=d=>{d.data instanceof Float32Array&&this.h(d.data,l.token)};this.b.on("message",g),this.B((0,O.$ic)(()=>this.b.off("message",g))),this.b.start();let w=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),w=!0,this.dispose()}),this.B((0,O.$ic)(()=>{w||this.b.close()}))}j(l){const g=new Float32Array(l.reduce((d,h)=>d+h.length,0));let w=0;for(const d of l)g.set(d,w),w+=d.length;return g}}class P extends f{constructor(){super(...arguments),this.m=this.B(new D.$Ng),this.n=[],this.r=new Float32Array(0)}async h(l,g){if(l.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,l]):l;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const w=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(w,g))}}async t(l,g){if(!g.isCancellationRequested){if(l.length>f.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(l.length!==0){const w=await this.c.transcribe(l,g);w&&this.n.push(w)}g.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends f{constructor(){super(...arguments),this.m=new D.$Og,this.n=void 0,this.r=0,this.s=""}async h(l,g){const w=this.n?this.j([this.n,l]):l;if(w.length>f.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=w,this.m.queue(()=>this.u(g))}async u(l){if(l.isCancellationRequested)return;const g=this.n?.slice(0);if(!g)return;let w;g.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),w=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),w=await this.c.transcribe(g,l)),this.s=w,this.r=g.length,!l.isCancellationRequested&&this.b.postMessage(w)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;class L extends A.$kc{constructor({onDidOpenWindow:I,onDidFocusWindow:S,getActiveWindowId:f}){super(),this.a=this.B(new A.$jc),N.Event.latch(N.Event.any(I,S))(this.f,this,this.a),this.b=(0,O.$ug)(()=>f()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$b7b=L}),define(oe[113],ae([0,1,178,16,47,21,10,4,23]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,I.$Bh)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.$Lh=f;function P(s){return typeof s?.id=="string"&&!f(s)&&!b(s)}e.$Mh=P,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$ae)(s)}:i?e.$Nh:e.$Oh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Ph=E;function b(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.$Qh=b;function l(s){const i=s;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Rh=l;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function w(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Sh=w;function d(s){const i=s;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Th=d;class h{constructor(i,r,a,p,m){this.h=i,this.j=a,this.k=p,this.l=m,this.c=A.$Hh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=A.$Hh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=h;class o{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.$ig)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=o;function $(s){return new o({uri:s,index:0,name:(0,L.$eg)(s)},{uri:s.toString()})}e.$Wh=$,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,O.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function y(s,i){return L.$_f.isEqualOrParent(s,i.untitledWorkspacesHome)}e.$2h=y;function C(s){let i;return D.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===S.Schemas.tmp}e.$3h=C,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$4h}e.$5h=t;function c(s,i){return!y(s,i)&&!C(s)}e.$6h=c;function n(s){return(typeof s=="string"?(0,N.$be)(s):(0,L.$gg)(s))===e.$Yh}e.$7h=n}),define(oe[17],ae([0,1,51,3,2,21,10,169,14,11,4,7,113,35,28,5,32,27,12]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var $;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function y(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.$Dk=y,e.$Ek=(0,P.$Bh)("IUserDataProfilesService");function C(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:D.URI.revive(s.location).with({scheme:i}),globalStorageHome:D.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:D.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Fk=C;function t(s,i,r,a,p,m){return{id:s,name:i,location:r,isDefault:!1,shortName:p?.shortName,icon:p?.icon,globalStorageHome:m&&p?.useDefaultFlags?.globalState?m.globalStorageHome:(0,L.$ig)(r,"globalStorage"),settingsResource:m&&p?.useDefaultFlags?.settings?m.settingsResource:(0,L.$ig)(r,"settings.json"),keybindingsResource:m&&p?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,L.$ig)(r,"keybindings.json"),tasksResource:m&&p?.useDefaultFlags?.tasks?m.tasksResource:(0,L.$ig)(r,"tasks.json"),snippetsHome:m&&p?.useDefaultFlags?.snippets?m.snippetsHome:(0,L.$ig)(r,"snippets"),extensionsResource:m&&p?.useDefaultFlags?.extensions?m.extensionsResource:(0,L.$ig)(r,"extensions.json"),cacheHome:(0,L.$ig)(a,s),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}e.$Gk=t;let c=class extends A.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,r,a,p){super(),this.t=i,this.u=r,this.w=a,this.y=p,this.f=!0,this.h=this.B(new N.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zi,emptyWindows:new Map},this.profilesHome=(0,L.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),r=[i];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,o.$jf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(t((0,L.$fg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},i))}}catch(m){this.y.error(m)}const a=new l.$zi,p=new Map;if(r.length)try{const m=this.Q();if(m.workspaces)for(const[u,v]of Object.entries(m.workspaces)){const j=D.URI.parse(u),F=r.find(T=>T.id===v);F&&a.set(j,F)}if(m.emptyWindows)for(const[u,v]of Object.entries(m.emptyWindows)){const j=r.find(F=>F.id===v);j&&p.set(u,j)}}catch(m){this.y.error(m)}this.z={profiles:r,workspaces:a,emptyWindows:p}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,h.$qe)(r)}\\s(\\d+)`);let p=0;for(const u of this.profiles){const v=a.exec(u.name),j=v?parseInt(v[1]):0;p=j>p?j:p}const m=`${r} ${p+1}`;return this.createProfile((0,O.$pi)((0,d.$4f)()).toString(16),m,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,O.$pi)((0,d.$4f)()).toString(16),i,r,a)}async createProfile(i,r,a,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(i,r,a);return p&&await this.setProfileForWorkspace(p,m),m}async F(i,r,a){if(!(0,o.$jf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.r.get(r);return p||(p=(async()=>{try{const m=this.profiles.find(j=>j.name===r||j.id===i);if(m)return m;const u=t(i,r,(0,L.$ig)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const v=[];return this.j.fire({profile:u,join(j){v.push(j)}}),await w.Promises.settled(v),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,p)),p}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(p=>p.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(p=>p.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:r,join(p){a.push(p)}});try{await Promise.allSettled(a)}catch(p){this.y.error(p)}for(const p of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(p)?.id&&this.C.emptyWindows.delete(p);for(const p of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(p)?.id&&this.C.workspaces.delete(p);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(p){(0,f.$jk)(p)!==1&&this.y.error(p)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(p=>p.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.G(i);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(i){return(0,b.$Lh)(i)?i.uri:(0,b.$Qh)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location)))}I(i,r,a){const p=[...this.profiles,...i],m=[];this.s.profiles=[];for(let u of p)u.isDefault||r.some(v=>u.id===v.id)||(u=a.find(v=>u.id===v.id)??u,u.isTransient?this.s.profiles.push(u):m.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(m),this.z=void 0,this.J(i,r,a)}J(i,r,a){this.h.fire({added:i,removed:r,updated:a,all:this.profiles})}L(i,r,a){a=r?.isTransient?!0:a,a||this.L(i,void 0,!0);const p=this.G(i),m=a?this.s:this.C;D.URI.isUri(p)?(m.workspaces.delete(p),r&&m.workspaces.set(p,r)):(m.emptyWindows.delete(p),r&&m.emptyWindows.set(p,r)),a||this.M()}M(){const i={};for(const[a,p]of this.C.workspaces.entries())i[a.toString()]=p.id;const r={};for(const[a,p]of this.C.emptyWindows.entries())r[a.toString()]=p.id;this.R({workspaces:i,emptyWindows:r}),this.z=void 0}N(i){const r={},a=this.D();if(i.workspaces)for(const[m,u]of Object.entries(i.workspaces)){const v=D.URI.parse(u);r[m]=this.w.extUri.isEqual(v,a.location)?a.id:this.w.extUri.basename(v)}const p={};if(i.emptyWindows)for(const[m,u]of Object.entries(i.emptyWindows)){const v=D.URI.parse(u);p[m]=this.w.extUri.isEqual(v,a.location)?a.id:this.w.extUri.basename(v)}return{workspaces:r,emptyWindows:p}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Hk=c,e.$Hk=c=ye([Y(0,S.$Ih),Y(1,f.$6j),Y(2,g.$Ck),Y(3,E.$5i)],c);class n extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Ik=n}),define(oe[242],ae([0,1,5,2,17]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;let L=class extends N.$kc{constructor(I){super(),this.B(new O.$Sg(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$l8b=L,e.$l8b=L=ye([Y(0,A.$Ek)],L)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,12,10,152,29,33,44,7,24,22,28,17]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=void 0;let y=class extends I.$kc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,r,a,p,m,u){super(),this.z=i,this.C=r,this.D=a,this.F=p,this.G=m,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$fd),this.s=this.B(new D.$fd),this.t=this.B(new D.$fd),this.u=this.B(new D.$fd),this.w=this.B(new D.$fd),this.y=[],this.B((0,I.$ic)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,b.$Wn)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const p=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:m})=>(0,l.$po)(m,i.identifier));if(p?.local)return p?.local;throw p?.error?p.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new b.$1n(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:p,options:m})=>{try{const u=await this.O(p,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);a.push({...u,options:m})}catch(u){r.push({identifier:p.identifier,operation:2,source:p,error:u})}})),a.length&&r.push(...await this.I(a));for(const p of r)p.error&&(this.F.error("Failed to install extension.",p.identifier.id),this.F.error(p.error),p.source&&!P.URI.isUri(p.source)&&c(this.C,"extensionGallery:install",{extensionData:(0,l.$xo)(p.source),error:p.error}));return r}async uninstall(i,r={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,r)}async toggleAppliationScope(i,r){if((0,g.$Yl)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(i,this.H.defaultProfile.extensionsResource,r));for(const p of this.H.profiles){const m=(await this.getInstalled(1,p.extensionsResource)).find(u=>(0,l.$po)(u.identifier,i.identifier));m?this.w.fire(m):this.u.fire({identifier:i.identifier,profileLocation:p.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const p=await this.J(a);r.push(...p)}catch(p){r.push({identifier:{id:(0,l.$uo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:p})}})),this.s.fire(r),r}async J({manifest:i,extension:r,options:a}){const p=a.isApplicationScoped||a.isBuiltin||(0,g.$Yl)(i),m={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},u=U=>`${l.$qo.create(U).toString()}${m.profileLocation?`-${m.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const U=this.j.get(u(r));if(U)return this.F.info("Extensions is already requested to install",r.identifier.id),await U.task.waitUntilTaskIsFinished(),[]}const v=[],j=[],F=[],T=this.Z(i,r,m);P.URI.isUri(r)||this.j.set(u(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:m.profileLocation}),this.F.info("Installing extension:",T.identifier.id),v.push({task:T,manifest:i});let z=!1;try{if(m.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const _=await this.N(T.identifier,i,!!m.installOnlyNewlyAddedFromExtensionPack,!!m.installPreReleaseVersion,m.profileLocation),K=await this.getInstalled(void 0,m.profileLocation),X={...m,donotIncludePackAndDependencies:!0,context:{...m.context,[b.$Rn]:!0}};for(const{gallery:H,manifest:x}of(0,O.$Kb)(_,({gallery:G})=>G.identifier.id)){z=z||!!x.extensionDependencies?.some(W=>(0,l.$po)({id:W},T.identifier));const G=u(H),V=this.j.get(G);if(V){if(this.L(T,V.task)){const W=V.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,T.identifier.id),V.waitingTasks.push(T),j.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,l.$po)(ne.identifier,W)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,T.identifier.id),!ee.find(re=>(0,l.$po)(re.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!K.some(({identifier:W})=>(0,l.$po)(W,H.identifier))){const W=this.Z(x,H,X);this.j.set(G,{task:W,waitingTasks:[T]}),this.n.fire({identifier:W.identifier,source:H,profileLocation:m.profileLocation}),this.F.info("Installing extension:",W.identifier.id,T.identifier.id),v.push({task:W,manifest:x})}}}catch(_){if(P.URI.isUri(T.source))(0,O.$Jb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,_.message),(0,O.$Jb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,_.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),_}const U=v.reduce((_,{task:K,manifest:X})=>(_.set(K.identifier.id.toLowerCase(),{task:K,manifest:X}),_),new Map);for(;U.size;){let _;const K=[...U.values()].filter(({manifest:X})=>!X.extensionDependencies?.some(H=>U.has(H.toLowerCase())));K.length?_=U.size===1?K:K.filter(({task:X})=>!(X===T&&!z)):(this.F.info("Found extensions with circular dependencies",K.map(({task:X})=>X.identifier.id)),_=[...U.values()]),await this.M(_.map(async({task:X})=>{const H=new Date().getTime();try{const x=await X.run();if(await this.M(this.y.map(G=>G.postInstall(x,X.source,m,A.CancellationToken.None))),!P.URI.isUri(X.source)){const G=X.operation===3,V=G?void 0:(new Date().getTime()-X.source.lastUpdated)/1e3;if(c(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$xo)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:V}),S.$o&&X.operation!==3)try{await this.z.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}F.push({local:x,identifier:X.identifier,operation:X.operation,source:X.source,context:X.options.context,profileLocation:X.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw P.URI.isUri(X.source)||c(this.C,X.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$xo)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-H,error:x}),this.F.error("Error while installing the extension:",X.identifier.id),x}finally{U.delete(X.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),F.forEach(({identifier:_})=>this.F.info("Extension installed successfully:",_.id)),F}catch(U){if(v.forEach(({task:_})=>_.cancel()),F.length)try{const _=await Promise.allSettled(F.map(({local:K})=>this.$(K,{versionOnly:!0,profileLocation:m.profileLocation}).run()));for(let K=0;K<_.length;K++){const X=_[K],{identifier:H}=F[K];X.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",H.id):this.F.warn("Rollback: Error while uninstalling extension",H.id,(0,L.$8)(X.reason))}}catch(_){this.F.warn("Error while rolling back extensions",(0,L.$8)(_),F.map(({identifier:K})=>K.id))}return v.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:m.context,profileLocation:m.profileLocation,error:U}))}finally{for(const{task:U}of v)U.source&&!P.URI.isUri(U.source)&&this.j.delete(u(U.source))}}L(i,r){for(const[,{task:a,waitingTasks:p}]of this.j.entries())if(a===i&&(p.includes(r)||p.some(m=>this.L(m,r)))||a===r&&p[0]&&!this.L(i,p[0]))return!1;return!0}async M(i){const r=[],a=[],p=await Promise.allSettled(i);for(const m of p)m.status==="fulfilled"?r.push(m.value):a.push(m.reason);if(a.length)throw C(a);return r}async N(i,r,a,p,m){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,m),v=[],j=[],F=async(T,z)=>{v.push(T);const U=z.extensionDependencies||[],_=[...U];if(z.extensionPack){const K=a?u.find(X=>(0,l.$po)(X.identifier,T)):void 0;for(const X of z.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(H=>(0,l.$po)({id:H},{id:X}))||_.every(H=>!(0,l.$po)({id:H},{id:X}))&&_.push(X)}if(_.length){const K=_.filter(X=>v.every(H=>!(0,l.$po)(H,{id:X})));if(K.length){const X=await this.z.getExtensions(K.map(H=>({id:H,preRelease:p})),A.CancellationToken.None);for(const H of X){if(v.find(V=>(0,l.$po)(V,H.identifier)))continue;const x=U.some(V=>(0,l.$po)({id:V},H.identifier));let G;try{G=await this.O(H,!1,p)}catch(V){if(x)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,L.$8)(V));continue}j.push({gallery:G.extension,manifest:G.manifest}),await F(G.extension.identifier,G.manifest)}}}};return await F(i,r),j}async O(i,r,a){let p;const m=await this.getExtensionsControlManifest();if(m.malicious.some(j=>(0,l.$po)(i.identifier,j)))throw new b.$1n(E.localize(1,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);const u=m.deprecated[i.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),p=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!p)throw new b.$1n(E.localize(2,null,i.identifier.id,u.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const j=await this.getTargetPlatform();throw new b.$1n(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,b.$Sn)(j)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(p=await this.P(i,r,a),!p)throw!a&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],A.CancellationToken.None))[0]?new b.$1n(E.localize(4,null,i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$1n(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",p.identifier.id);const v=await this.z.getManifest(p,A.CancellationToken.None);if(v===null)throw new b.$1n(`Missing manifest for extension ${p.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(v.version!==p.version)throw new b.$1n(`Cannot install '${p.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:p,manifest:v}}async P(i,r,a){const p=await this.getTargetPlatform();let m=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(m=(await this.z.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:p,compatible:!0},A.CancellationToken.None))[0]||null),!m&&await this.z.isExtensionCompatible(i,a,p)&&(m=i),m||(r?m=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:p,compatible:!0},A.CancellationToken.None))[0]||null:m=await this.z.getCompatibleExtension(i,a,p)),m}async Q(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},p=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,m=this.m.get(p(i.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const u=T=>{const z=this.$(T,a);return this.m.set(p(z.extension.identifier),z),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),z},v=(T,z)=>{z?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,z.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),c(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$wo)(T),error:z}),this.u.fire({identifier:T.identifier,error:z?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},j=[],F=[];try{j.push(u(i));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const z=this.U(i,T);for(const U of z)this.m.has(p(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):j.push(u(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(j.map(z=>z.extension),T,i),await this.M(j.map(async z=>{try{if(await z.run(),await this.M(this.y.map(U=>U.postUninstall(z.extension,a,A.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}v(z.extension)}catch(U){const _=U instanceof b.$1n?U:new b.$1n((0,L.$8)(U),b.ExtensionManagementErrorCode.Internal);throw v(z.extension,_),_}finally{F.push(z)}}))}catch(T){const z=T instanceof b.$1n?T:new b.$1n((0,L.$8)(T),b.ExtensionManagementErrorCode.Internal);for(const U of j){try{U.cancel()}catch{}F.includes(U)||v(U.extension,z)}throw z}finally{for(const T of j)this.m.delete(p(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(i,r,a){for(const p of i){const m=this.W(p,r);if(m.length){const u=m.filter(v=>!i.some(j=>(0,l.$po)(j.identifier,v.identifier)));if(u.length)throw new Error(this.S(p,u,a))}}}S(i,r,a){return a===i?r.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const p=i.manifest.extensionPack?i.manifest.extensionPack:[];if(p.length){const m=r.filter(v=>!v.isBuiltin&&p.some(j=>(0,l.$po)({id:j},v.identifier))),u=[];for(const v of m)u.push(...this.U(v,r,a));return[...m,...u]}return[]}W(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(p=>(0,l.$po)({id:p},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$fp=y,e.$fp=y=ye([Y(0,b.$Zn),Y(1,h.$9k),Y(2,o.$Ck),Y(3,w.$5i),Y(4,d.$kj),Y(5,$.$Ek)],y);function C(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$gp=C;function t(s){if(s instanceof b.$1n)return s;const i=new b.$1n(s.message,b.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.$hp=t;function c(s,i,{extensionData:r,verificationStatus:a,duration:p,error:m,durationSinceUpdate:u}){let v,j;(0,f.$rf)(a)&&(a===!0?a="Verified":(a===!1||(v=b.ExtensionManagementErrorCode.Signature,j=a),a="Unverified")),m&&(m instanceof b.$1n?(v=m.code,m.code===b.ExtensionManagementErrorCode.Signature&&(j=m.message)):v=b.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...r,verificationStatus:a,success:!m,duration:p,errorcode:v,errorcodeDetail:j,durationSinceUpdate:u})}class n{constructor(){this.d=new N.$Fg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$ug)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$ug)(i=>new Promise((r,a)=>{const p=i.onCancellationRequested(()=>{p.dispose(),a(new L.$3)})})),this.d.open()),this.g.cancel()}}e.$ip=n}),define(oe[50],ae([0,1,5,15,2,3,35,10,29,33,11,4,7,17,28,12,8,22]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var o;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(o||(e.ExtensionsProfileScanningErrorCode=o={}));class $ extends Error{constructor(n,s){super(n),this.code=s}}e.$jp=$,e.$kp=(0,E.$Bh)("IExtensionsProfileScannerService");let y=class extends A.$kc{constructor(n,s,i,r,a,p){super(),this.j=n,this.m=s,this.n=i,this.r=r,this.s=a,this.t=p,this.b=this.B(new L.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new L.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zi}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],r=[];try{return await this.u(s,a=>{const p=[];for(const m of a)n.some(([u])=>(0,f.$po)(u.identifier,m.identifier)&&u.manifest.version!==m.version)?i.push(m):p.push(m);for(const[m,u]of n){const v=p.findIndex(F=>(0,f.$po)(F.identifier,m.identifier)&&F.version===m.manifest.version),j={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:u};v===-1?(r.push(j),p.push(j)):p.splice(v,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),i.length&&this.f.fire({extensions:i,profileLocation:s}),p}),r.length&&this.c.fire({extensions:r,profileLocation:s}),i.length&&this.g.fire({extensions:i,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),i.length&&this.g.fire({extensions:i,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const i=[];return await this.u(s,r=>{const a=[];for(const p of r){const m=n.find(([u])=>(0,f.$po)(u.identifier,p.identifier)&&u.manifest.version===p.version);m&&(p.metadata={...p.metadata,...m[1]},i.push(p)),a.push(p)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,r=>{const a=[];for(const p of r)(0,f.$po)(p.identifier,n.identifier)?i.push(p):a.push(p);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:s}),r}}async u(n,s,i){return this.F(n).queue(async()=>{let r=[],a;try{const p=await this.m.readFile(n);a=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,P.$jk)(p)!==1)throw p;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new $((0,d.$8)(p),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let p=!1;for(const m of a){C(m)||this.w(n);let u;if((0,w.$jf)(m.relativeLocation)&&m.relativeLocation)u=this.z(m.relativeLocation);else if((0,w.$jf)(m.location))u=this.z(m.location),p=!0,m.relativeLocation=m.location,m.location=u.toJSON();else{u=I.URI.revive(m.location);const v=this.y(u);v&&(p=!0,m.relativeLocation=v)}r.push({identifier:m.identifier,location:u,version:m.version,metadata:m.metadata})}p&&await this.m.writeFile(n,N.$Fd.fromString(JSON.stringify(a)))}if(s){r=s(r);const p=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.y(m.location),metadata:m.metadata}));await this.m.writeFile(n,N.$Fd.fromString(JSON.stringify(p)))}return r})}w(n){const s=new $(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,P.$jk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(p=>C(p))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Fd.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$jk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,P.$jk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,P.$jk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$Ng,this.h.set(n,s)),s}};e.$lp=y,e.$lp=y=ye([Y(1,P.$6j),Y(2,l.$Ek),Y(3,g.$Ck),Y(4,h.$9k),Y(5,b.$5i)],y);function C(c){return(0,w.$lf)(c)&&(0,S.$Yn)(c.identifier)&&(t(c.location)||(0,w.$jf)(c.location)&&c.location)&&((0,w.$qf)(c.relativeLocation)||(0,w.$jf)(c.relativeLocation))&&c.version&&(0,w.$jf)(c.version)}function t(c){return c?(0,w.$jf)(c.path)&&(0,w.$jf)(c.scheme):!1}}),define(oe[79],ae([0,1,18,5,30,15,8,34,139,2,23,16,6,21,53,89,12,10,155,14,33,44,67,11,4,7,24,3,63,50,17,28,183]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c,n,s,i,r,a,p,m,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var j;(function(X){function H(x,G){if(x===G)return!0;const V=Object.keys(x),W=new Set;for(const ee of Object.keys(G))W.add(ee);if(V.length!==W.size)return!1;for(const ee of V){if(x[ee]!==G[ee])return!1;W.delete(ee)}return W.size===0}X.equals=H})(j||(e.Translations=j={})),e.$op=(0,n.$Bh)("IExtensionsScannerService");let F=class extends f.$kc{constructor(H,x,G,V,W,ee,ne,re,Q,q,k,R){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=x,this.r=G,this.s=V,this.t=W,this.u=ee,this.w=ne,this.y=re,this.z=Q,this.C=q,this.D=k,this.F=R,this.g=this.B(new r.$fd),this.onDidChangeCache=this.g.event,this.h=(0,l.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(H,x,G){const[V,W]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(x)]),ee=G?await this.scanExtensionsUnderDevelopment(H,[...V,...W]):[];return this.L(V,W,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const x=[];x.push(this.M(!!H.useCache,H.language)),x.push(this.N(H.language,!!H.checkControlFile));const[G,V]=await Promise.all(x);return this.J([...G,...V],0,H,!1)}async scanUserExtensions(H){const x=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",x);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(x,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),W=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ee;try{ee=await W.scanExtensions(V)}catch(ne){if(ne instanceof p.$jp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await W.scanExtensions(V);else throw ne}return ee=await this.J(ee,1,H,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(H,x){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const W=await this.P(V,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(ne=>(ne.type=x.find(re=>(0,y.$po)(re.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,W)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,x,G){const V=await this.P(H,!1,x,!0,G.language,!0,void 0),W=await this.n.scanExtension(V);return!W||!G.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(H,x,G){const V=await this.P(H,!1,x,!0,G.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(V);return this.J(W,x,G,!0)}async scanMetadata(H){const x=(0,l.$ig)(H,"package.json"),G=(await this.w.readFile(x)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,x){const G=(0,l.$ig)(H,"package.json"),V=(await this.w.readFile(G)).value.toString(),W=JSON.parse(V);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,W.__metadata={...W.__metadata,...x},await this.w.writeFile((0,l.$ig)(H,"package.json"),L.$Fd.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof p.$jp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(x=>[x,x.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Fd.fromString(JSON.stringify([])))}catch(x){(0,c.$jk)(x)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(x))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,x,G,V){return G.includeAllVersions||(H=this.L(x===0?H:void 0,x===1?H:void 0,x==="development"?H:void 0,await this.getTargetPlatform(),V)),G.includeInvalid||(H=H.filter(W=>W.isValid)),H.sort((W,ee)=>{const ne=E.$ae(W.location.fsPath),re=E.$ae(ee.location.fsPath);return ne<re?-1:ne>re?1:0})}L(H,x,G,V,W){const ee=(re,Q,q)=>{if(re.isValid&&!Q.isValid)return!1;if(re.isValid===Q.isValid){if(W&&g.gt(re.manifest.version,Q.manifest.version))return this.y.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,Q.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${Q.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===V)return this.y.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${re.location.path} with ${Q.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${Q.location.path}.`),!0},ne=new C.$Xl;return H?.forEach(re=>{const Q=ne.get(re.identifier.id);(!Q||ee(Q,re,!1))&&ne.set(re.identifier.id,re)}),x?.forEach(re=>{const Q=ne.get(re.identifier.id);if(!Q&&H&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!Q||ee(Q,re,!1))&&ne.set(re.identifier.id,re)}),G?.forEach(re=>{const Q=ne.get(re.identifier.id);(!Q||ee(Q,re,!0))&&ne.set(re.identifier.id,re),ne.set(re.identifier.id,re)}),[...ne.values()]}async M(H,x){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),W=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",W.length),W}async N(H,x){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const V=x?await this.O():{},W=[],ee=h.URI.file(E.$7d(E.$9d(P.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of G){const Q=V[re.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":W.push((0,l.$ig)(ee,re.name));break;default:W.push(h.URI.file(Q));break}}const ne=await Promise.all(W.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,O.$Fb)(ne)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,x,G,V,W,ee,ne){const re=await this.f(W??b.$v),Q=await this.Q(H),q=x&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,k=q?await this.Q(q):void 0;return new T(H,Q,q,k,x,ne,G,V,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,re)}async Q(H){try{const x=await this.w.stat(H);if(typeof x.mtime=="number")return x.mtime}catch{}}};e.$pp=F,e.$pp=F=ye([Y(4,m.$Ek),Y(5,p.$kp),Y(6,c.$6j),Y(7,s.$5i),Y(8,$.$Ih),Y(9,i.$kj),Y(10,u.$Ck),Y(11,n.$Ah)],F);class T{constructor(H,x,G,V,W,ee,ne,re,Q,q,k,R,B,M,J){this.location=H,this.mtime=x,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=re,this.validate=Q,this.productVersion=q,this.productDate=k,this.productCommit=R,this.devMode=B,this.language=M,this.translations=J}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,x){return(0,l.$bg)(H.location,x.location)&&H.mtime===x.mtime&&(0,l.$bg)(H.applicationExtensionslocation,x.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&H.profile===x.profile&&A.$Zm(H.profileScanOptions,x.profileScanOptions)&&H.type===x.type&&H.excludeObsolete===x.excludeObsolete&&H.validate===x.validate&&H.productVersion===x.productVersion&&H.productDate===x.productDate&&H.productCommit===x.productCommit&&H.devMode===x.devMode&&H.language===x.language&&j.equals(H.translations,x.translations)}}e.$qp=T;let z=class extends f.$kc{constructor(H,x,G,V,W){super(),this.f=H,this.g=x,this.h=G,this.j=V,this.m=W}async scanExtensions(H){const x=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(V)}catch{}return(0,d.$wf)(G)?x:x.filter(V=>!G[y.$qo.create(V).toString()])}async n(H){const x=await this.j.resolve(H.location);if(!x.children?.length)return[];const G=await Promise.all(x.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,l.$fg)(V.resource).indexOf(".")===0)return null;const W=new T(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(W)}));return(0,O.$Fb)(G).sort((V,W)=>V.location.path<W.location.path?-1:1)}async r(H){let x=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){x=x.filter(V=>!V.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);x.push(...G)}return x}async s(H,x,G){const V=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async ee=>{if(x(ee)){const ne=new T(ee.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,O.$Fb)(W)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$ig)(H.location,"package.json"))){const x=await this.scanExtension(H);return x?[x]:[]}else return await this.scanExtensions(H)}catch(x){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,D.$8)(x)),[]}}async scanExtension(H,x){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=C.$Rl),x=x??G.__metadata,delete G.__metadata;const V=(0,y.$uo)(G.publisher,G.name),W=x?.id?{id:V,uuid:x.id}:{id:V},ee=x?.isSystem?0:H.type,ne=ee===0||!!x?.isBuiltin;G=await this.t(H.location,G,T.createNlsConfiguration(H));const re={type:ee,identifier:W,manifest:G,location:H.location,isBuiltin:ne,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return H.validate?this.validate(re,H):re}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,x){let G=!0;const V=(0,t.$Fo)(x.productVersion,x.productDate,x.location,H.manifest,H.isBuiltin);for(const[W,ee]of V)W===w.default.Error&&(G=!1,this.m.error(this.z(x.location,ee)));return H.isValid=G,H.validations=V,H}async scanExtensionManifest(H){const x=(0,l.$ig)(H,"package.json");let G;try{G=(await this.j.readFile(x)).value.toString()}catch(W){return(0,c.$jk)(W)!==1&&this.m.error(this.z(H,(0,o.localize)(0,null,x.path,W.message))),null}let V;try{V=JSON.parse(G)}catch{const ee=[];(0,I.$Lm)(G,ee);for(const ne of ee)this.m.error(this.z(H,(0,o.localize)(1,null,x.path,ne.offset,ne.length,(0,S.$mp)(ne.error))));return null}return(0,I.$Um)(V)!=="object"?(this.m.error(this.z(H,(0,o.localize)(2,null,x.path))),null):V}async t(H,x,G){const V=await this.u(H,x,G);if(V)try{const W=[],ee=await this.w(V.default,W);if(W.length>0)return W.forEach(re=>{this.m.error(this.z(H,(0,o.localize)(3,null,V.default?.path,(0,S.$mp)(re.error))))}),x;if((0,I.$Um)(V)!=="object")return this.m.error(this.z(H,(0,o.localize)(4,null,V.default?.path))),x;const ne=V.values||Object.create(null);return(0,v.$np)(this.m,x,ne,ee)}catch{}return x}async u(H,x,G){const V=(0,l.$ig)(H,"package.nls.json"),W=(Q,q)=>{q.forEach(k=>{this.m.error(this.z(H,(0,o.localize)(5,null,Q?.path,(0,S.$mp)(k.error))))})},ee=Q=>{this.m.error(this.z(H,(0,o.localize)(6,null,Q?.path)))},ne=`${x.publisher}.${x.name}`,re=G.translations[ne];if(re)try{const Q=h.URI.file(re),q=(await this.j.readFile(Q)).value.toString(),k=[],R=(0,I.$Lm)(q,k);return k.length>0?(W(Q,k),{values:void 0,default:V}):(0,I.$Um)(R)!=="object"?(ee(Q),{values:void 0,default:V}):{values:R.contents?R.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(H,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const k=(await this.j.readFile(q.localized)).value.toString(),R=[],B=(0,I.$Lm)(k,R);return R.length>0?(W(q.localized,R),{values:void 0,default:q.original}):(0,I.$Um)(B)!=="object"?(ee(q.localized),{values:void 0,default:q.original}):{values:B,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,x){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,I.$Lm)(G,x)}catch{}}y(H,x){return new Promise((G,V)=>{const W=ee=>{const ne=(0,l.$ig)(H,`package.nls.${ee}.json`);this.j.exists(ne).then(re=>{re&&G({localized:ne,original:(0,l.$ig)(H,"package.nls.json")});const Q=ee.lastIndexOf("-");Q===-1?G({localized:(0,l.$ig)(H,"package.nls.json"),original:null}):(ee=ee.substring(0,Q),W(ee))})};if(x.devMode||x.pseudo||!x.language)return G({localized:(0,l.$ig)(H,"package.nls.json"),original:null});W(x.language)})}z(H,x){return`[${H.path}]: ${x}`}};z=ye([Y(1,p.$kp),Y(2,u.$Ck),Y(3,c.$6j),Y(4,s.$5i)],z);let U=class extends z{constructor(H,x,G,V,W,ee,ne){super(x,V,W,ee,ne),this.G=H,this.H=G,this.D=this.B(new N.$Eg(3e3)),this.F=this.B(new r.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const x=this.M(H),G=await this.I(x);if(this.C=H,G&&G.input&&T.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(W=>(W.location=h.URI.revive(W.location),W));const V=await super.scanExtensions(H);return await this.J(x,{input:H,result:V}),V}async I(H){try{const x=await this.j.readFile(H),G=JSON.parse(x.value.toString());return{result:G.result,input:(0,a.$$g)(G.input)}}catch(x){this.m.debug("Error while reading the extension cache file:",H.path,(0,D.$8)(x))}return null}async J(H,x){try{await this.j.writeFile(H,L.$Fd.fromString(JSON.stringify(x)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,D.$8)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),x=await this.I(H);if(!x)return;const G=x.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$Zm(V,G))try{this.m.info("Invalidating Cache",G,V),await this.j.del(H),this.F.fire()}catch(W){this.m.error(W)}}M(H){const x=this.N(H);return this.h.extUri.joinPath(x.cacheHome,H.type===0?C.$Ql:C.$Pl)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(x=>this.h.extUri.isEqual(H.location,x.extensionsResource))??this.G:this.H.defaultProfile}};U=ye([Y(2,m.$Ek),Y(3,p.$kp),Y(4,u.$Ck),Y(5,c.$6j),Y(6,s.$5i)],U);function _(X,H){const x=(0,y.$so)(X.manifest.publisher,X.manifest.name);return{id:x,identifier:new C.$Vl(x),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:H,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.$rp=_;class K extends F{constructor(H,x,G,V,W,ee,ne,re,Q,q,k,R){super(H,x,(0,l.$ig)(G,".vscode-oss-dev","extensions","control.json"),V,W,ee,ne,re,Q,q,k,R),this.R=(async()=>{if(b.$y)try{const B=await this.w.readFile(h.URI.file(b.$y));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$sp=K}),define(oe[244],ae([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let b=class extends D.$kc{constructor(g,w){super(),this.b=g,this.f=w,this.a=new N.$Mg(5)}async postUninstall(g){const w=this.g(g,"uninstall");w&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(d)}}));try{await f.Promises.rm(this.m(g))}catch(d){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(d)}}g(g,w){const d=`vscode:${w}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[d]=="string"){const h=g.manifest.scripts[d].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${d} should be a node script`),null):{script:(0,S.$9d)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,w,d,h,o){return new Promise(($,y)=>{const C=this.j(g,w,d,o);let t;const c=n=>{t&&(clearTimeout(t),t=null),n?y(n):$(void 0)};C.on("error",n=>{c((0,A.$mi)(n)||"Unknown")}),C.on("exit",(n,s)=>{c(n?`post-${w} process exited with code ${n}`:void 0)}),h&&(t=setTimeout(()=>{t=null,C.kill(),y("timed out")},5e3))})}j(g,w,d,h){const o={silent:!0,execArgv:void 0},$=(0,O.fork)(g,[`--type=extension-post-${w}`,...d],o);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const y=L.Event.fromNodeEventEmitter($.stdout,"data"),C=L.Event.fromNodeEventEmitter($.stderr,"data");y(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,n)),C(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,n));const t=L.Event.any(L.Event.map(y,n=>({data:`%c${n}`,format:[""]})),L.Event.map(C,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),$}m(g){return(0,S.$9d)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$up=b,e.$up=b=ye([Y(0,E.$Ek),Y(1,P.$5i)],b)}),define(oe[245],ae([0,1,7,17,28,22,50,11,14,10]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=void 0;let P=class extends D.$lp{constructor(b,l,g,w,d,h){super(f.URI.file(b.extensionsPath),l,g,w,d,h)}};e.$qN=P,e.$qN=P=ye([Y(0,S.$Jh),Y(1,I.$6j),Y(2,N.$Ek),Y(3,A.$Ck),Y(4,L.$9k),Y(5,O.$5i)],P)}),define(oe[246],ae([0,1,10,14,50,79,11,4,7,24,28,17]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;let b=class extends L.$sp{constructor(g,w,d,h,o,$,y,C){super(O.URI.file(o.builtinExtensionsPath),O.URI.file(o.extensionsPath),o.userHome,g.defaultProfile,g,w,d,h,o,$,y,C)}};e.$f7b=b,e.$f7b=b=ye([Y(0,E.$Ek),Y(1,A.$kp),Y(2,D.$6j),Y(3,S.$5i),Y(4,N.$Jh),Y(5,f.$kj),Y(6,P.$Ck),Y(7,I.$Ah)],b)}),define(oe[20],ae([0,1,5,3,2,100,12,66,4,17]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,S.$Bh)("storageService");var P;(function(o){o[o.NONE=0]="NONE",o[o.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(o){o[o.APPLICATION=-1]="APPLICATION",o[o.PROFILE=0]="PROFILE",o[o.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(o){o[o.USER=0]="USER",o[o.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(o){const $=o.get(e.$Uo);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Wo=l;class g extends A.$kc{static{this.a=60*1e3}constructor($={flushInterval:g.a}){super(),this.m=$,this.b=this.B(new N.$id),this.c=this.B(new N.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,y,C){return N.Event.filter(this.b.event,t=>t.scope===$&&(y===void 0||t.key===y),C)}n(){this.j.value=(0,O.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,y){const{key:C,external:t}=y;if(C===e.$Uo){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:C,target:this.J($)[C],external:t})}w($){this.f.fire({reason:$})}get($,y,C){return this.P(y)?.get($,C)}getBoolean($,y,C){return this.P(y)?.getBoolean($,C)}getNumber($,y,C){return this.P(y)?.getNumber($,C)}getObject($,y,C){return this.P(y)?.getObject($,C)}storeAll($,y){this.y(()=>{for(const C of $)this.store(C.key,C.value,C.scope,C.target,y)})}store($,y,C,t,c=!1){if((0,D.$sf)(y)){this.remove($,C,c);return}this.y(()=>{this.z($,C,t),this.P(C)?.set($,y,c)})}remove($,y,C=!1){this.y(()=>{this.z($,y,void 0),this.P(y)?.delete($,C)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,y){const C=[],t=this.J($);for(const c of Object.keys(t))t[c]===y&&C.push(c);return C}z($,y,C,t=!1){const c=this.J(y);typeof C=="number"?c[$]!==C&&(c[$]=C,this.P(y)?.set(e.$Uo,JSON.stringify(c),t)):typeof c[$]=="number"&&(delete c[$],this.P(y)?.set(e.$Uo,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const y=this.P($);return y?l(y):Object.create(null)}isNew($){return this.getBoolean(e.$To,$)===!0}async flush($=P.NONE){this.f.fire({reason:$});const y=this.P(-1),C=this.P(0),t=this.P(1);switch($){case P.NONE:await O.Promises.settled([y?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([y?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,y=this.P(0)?.items??new Map,C=this.P(1)?.items??new Map;return h($,y,C,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,y){return this.w(P.NONE),(0,f.$Dk)($)?this.R($,y):this.S($,y)}M($,y){return!($.id===y.id||w(y)&&w($))}N($,y,C){this.y(()=>{const t=new Set;for(const[c,n]of $)t.add(c),y.get(c)!==n&&this.u(C,{key:c,external:!0});for(const[c]of y.items)t.has(c)||this.u(C,{key:c,external:!0})})}}e.$Xo=g;function w(o){return o.isDefault||!!o.useDefaultFlags?.globalState}e.$Yo=w;class d extends g{constructor(){super(),this.U=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Ro(new I.$So,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Zo=d;async function h(o,$,y,C,t,c){const n=j=>{try{return JSON.parse(j)}catch{return j}},s=new Map,i=new Map;o.forEach((j,F)=>{s.set(F,j),i.set(F,n(j))});const r=new Map,a=new Map;$.forEach((j,F)=>{r.set(F,j),a.set(F,n(j))});const p=new Map,m=new Map;y.forEach((j,F)=>{p.set(F,j),m.set(F,n(j))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const u=[];if(s.forEach((j,F)=>{u.push({key:F,value:j})}),console.table(u),console.groupEnd(),console.log(i),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];r.forEach((F,T)=>{j.push({key:T,value:F})}),console.table(j),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const v=[];p.forEach((j,F)=>{v.push({key:F,value:j})}),console.table(v),console.groupEnd(),console.log(m)}e.$1o=h}),define(oe[114],ae([0,1,3,2,12,29,33,20]),function(te,e,O,N,A,L,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qzb=e.$Pzb=void 0;let S=class extends N.$kc{constructor(E,b){super(),this.a=new O.$fd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new f(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:g,operation:w})=>{g&&w===4&&this.f(g.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(L.$3n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,D.$po)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const g=b[l];if((0,D.$po)(g,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(L.$3n,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$Pzb=S,e.$Pzb=S=ye([Y(0,I.$Vo),Y(1,L.$2n)],S);class f extends N.$kc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new O.$fd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$jc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,A.$sf)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const g=JSON.stringify(b.map(({id:d,uuid:h})=>({id:d,uuid:h})));this.g(E,l)!==g&&(l===0&&(b.length?this.a[E]=g:delete this.a[E]),this.h(E,b.length?g:void 0,l))}f(E){if(!(0,A.$sf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),w=l.filter(h=>!g.some(o=>(0,D.$po)(h,o))),d=g.filter(h=>!l.some(o=>(0,D.$po)(o,h)));(w.length||d.length)&&this.b.fire([...w,...d])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$Qzb=f}),define(oe[247],ae([0,1,18,26,8,6,37,12,10,19,14,29,33,67,11,7,24,57,224,20,22,60]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=void 0;const t=L.$o?"web":(0,E.$Un)(L.$t,D.$4d),c="X-Market-Search-Activity-Id";var n;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...k){return String(k.reduce((R,B)=>R|B,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(R=m){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,B=this.d.pageSize){return new u({...this.d,pageNumber:R,pageSize:B})}withFilter(R,...B){const M=[...this.d.criteria,...B.length?B.map(J=>({filterType:R,value:J})):[{filterType:R}]];return new u({...this.d,criteria:M})}withSortBy(R){return new u({...this.d,sortBy:R})}withSortOrder(R){return new u({...this.d,sortOrder:R})}withFlags(...R){return new u({...this.d,flags:R.reduce((B,M)=>B|M,0)})}withAssetTypes(...R){return new u({...this.d,assetTypes:R})}withSource(R){return new u({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:B,pageSize:M,sortBy:J,sortOrder:Z,flags:se,assetTypes:le}=this.d;return{filters:[{criteria:R,pageNumber:B,pageSize:M,sortBy:J,sortOrder:Z}],assetTypes:le,flags:se}}get searchText(){const R=this.d.criteria.filter(B=>B.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(k,R){const B=(k||[]).filter(M=>M.statisticName===R)[0];return B?B.value:0}function j(k){const R="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,J)=>{const Z=z(k,J.assetType);return Z&&M.push([J.assetType.substring(R.length),Z]),M},[])}function F(k){if(k.properties){const R=k.properties.filter(J=>J.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=R.filter(J=>B.test(J.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return z(k,r.Repository)}function T(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function z(k,R){return k.files.filter(M=>M.assetType===R)[0]?{uri:`${k.assetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function U(k,R){const B=k.properties?k.properties.filter(J=>J.key===R):[],M=B.length>0&&B[0].value;return M?M.split(",").map(J=>(0,b.$to)(J)):[]}function _(k){const R=k.properties?k.properties.filter(B=>B.key===a.Engine):[];return R.length>0&&R[0].value||""}function K(k){const R=k.properties?k.properties.filter(B=>B.key===a.PreRelease):[];return R.length>0&&R[0].value==="true"}function X(k){const R=k.properties?k.properties.filter(M=>M.key===a.LocalizedLanguages):[],B=R.length>0&&R[0].value||"";return B?B.split(","):[]}function H(k){return k.properties?.find(R=>R.key===a.SponsorLink)?.value}function x(k){return k.indexOf("preview")!==-1}function G(k){return k.targetPlatform?(0,E.$Tn)(k.targetPlatform):"undefined"}function V(k){const R=(0,O.$Kb)(k.versions.map(G)),B=!!k.tags?.includes(E.$On),M=R.indexOf("web");return B?M===-1&&R.push("web"):M!==-1&&R.splice(M,1),R}function W(k,R){const B=(0,E.$Xn)(R);for(let M=0;M<k.length;M++){const J=k[M];if(J.version===k[M-1]?.version){let Z=M;const se=G(J);if(se===R)for(;Z>0&&k[Z-1].version===J.version;)Z--;else if(B.includes(se))for(;Z>0&&k[Z-1].version===J.version&&G(k[Z-1])!==R;)Z--;Z!==M&&(k.splice(M,1),k.splice(Z,0,J))}}return k}e.$4o=W;function ee(k,R,B){k.telemetryData={index:R,querySource:B,queryActivityId:k.queryContext?.[c]}}function ne(k,R,B,M){const J=k.versions[0],Z={manifest:z(R,r.Manifest),readme:z(R,r.Details),changelog:z(R,r.Changelog),license:z(R,r.License),repository:F(R),download:T(R),icon:z(R,r.Icon),signature:z(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,b.$uo)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:R.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(J),description:k.shortDescription||"",installCount:v(k.statistics,"install"),rating:v(k.statistics,"averagerating"),ratingCount:v(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:B,assets:Z,properties:{dependencies:U(R,a.Dependency),extensionPack:U(R,a.ExtensionPack),engine:_(R),localizedLanguages:X(R),targetPlatform:G(R),isPreReleaseVersion:K(R)},hasPreReleaseVersion:K(J),hasReleaseVersion:!0,preview:x(k.flags),isSigned:!!Z.signature,queryContext:M}}let re=class{constructor(R,B,M,J,Z,se,le,ue){this.k=B,this.l=M,this.n=J,this.o=Z,this.q=se,this.u=le,this.w=ue;const he=le.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,o.$3o)(le.version,le,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,B,M){const J=N.CancellationToken.isCancellationToken(B)?{}:B,Z=N.CancellationToken.isCancellationToken(B)?B:M,se=[],le=[],ue=[],he=[];let $e=!0;for(const ve of R){ve.uuid?le.push(ve.uuid):se.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Ie}if(!le.length&&!se.length)return[];let de=new u().withPage(1,R.length);le.length&&(de=de.withFilter(i.ExtensionId,...le)),se.length&&(de=de.withFilter(i.ExtensionName,...se)),(J.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),J.source&&(de=de.withSource(J.source));const{extensions:we}=await this.z(de,{targetPlatform:J.targetPlatform??t,includePreRelease:ue,versions:he,compatible:!!J.compatible},Z);return J.source&&we.forEach((ve,Ie)=>ee(ve,Ie,J.source)),we}async getCompatibleExtension(R,B,M){if((0,E.$Vn)(R.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(R,B,M))return R;const J=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,R.identifier.uuid),{extensions:Z}=await this.z(J,{targetPlatform:M,compatible:!0,includePreRelease:B},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(R,B,M){if(!(0,E.$Wn)(R.properties.targetPlatform,R.allTargetPlatforms,M)||!B&&R.properties.isPreReleaseVersion)return!1;let J=R.properties.engine;if(!J){const Z=await this.getManifest(R,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");J=Z.engines.vscode}return(0,l.$Ho)(J,this.u.version,this.u.date)}async y(R,B,M,J,Z){if(!(0,E.$Wn)(G(R),J,Z)||B!=="any"&&K(R)!==(B==="prerelease"))return!1;if(M)try{const se=await this.E(R);if(!(0,l.$Ho)(se,this.u.version,this.u.date))return!1}catch(se){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,A.$8)(se)),!1}return!0}async query(R,B){let M=R.text||"";const J=R.pageSize??50;let Z=new u().withPage(1,J);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(i.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(i.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),Z=Z.withFilter(i.SearchText,M)),Z=Z.withSortBy(0)):R.ids?Z=Z.withFilter(i.ExtensionId,...R.ids):R.names?Z=Z.withFilter(i.ExtensionName,...R.names):Z=Z.withSortBy(4),typeof R.sortBy=="number"&&(Z=Z.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(Z=Z.withSortOrder(R.sortOrder)),R.source&&(Z=Z.withSource(R.source));const se=async($e,de)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:t,compatible:!1,includePreRelease:!!R.includePreRelease},de);return we.forEach((Ie,Le)=>ee(Ie,($e.pageNumber-1)*$e.pageSize+Le,R.source)),{extensions:we,total:ve}},{extensions:le,total:ue}=await se(Z,B),he=async($e,de)=>{if(de.isCancellationRequested)throw new A.$3;const{extensions:we}=await se(Z.withPage($e+1),de);return we};return{firstPage:le,total:ue,pageSize:Z.pageSize,getPage:he}}async z(R,B,M){const J=R.flags;R.flags&n.IncludeLatestVersionOnly&&R.flags&n.IncludeVersions&&(R=R.withFlags(R.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(R.flags&n.IncludeLatestVersionOnly)&&!(R.flags&n.IncludeVersions)&&(R=R.withFlags(R.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(R=R.withFlags(R.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),R=R.withFlags(R.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Z,total:se,context:le}=await this.B(R,M);if(!(R.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of Z){const ve=await this.A(we,B,le);ve&&de.push(ve)}return{extensions:de,total:se}}const he=[],$e=new Map;for(let de=0;de<Z.length;de++){const we=Z[de],ve={id:(0,b.$uo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,I.$pf)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Te=>(0,b.$po)(Te,ve))?.includePreRelease;if(B.compatible&&(0,E.$Vn)(V(we),B.targetPlatform))continue;const Le=await this.A(we,B,le);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==B.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new C.$bd,we=new u().withFlags(J&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(i.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,B,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of ve){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:se}}async A(R,B,M){const J={id:(0,b.$uo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},Z=B.versions?.find(he=>(0,b.$po)(he,J))?.version,se=(0,I.$pf)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(he=>(0,b.$po)(he,J))?.includePreRelease,le=V(R),ue=W(R.versions,B.targetPlatform);if(B.compatible&&(0,E.$Vn)(le,B.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(Z&&$e.version!==Z)){if(await this.y($e,se?"any":"release",B.compatible,le,B.targetPlatform))return ne(R,$e,le,M);if(Z&&$e.version===Z)return null}}return Z||B.compatible?null:ne(R,R.versions[0],le)}async B(R,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const M=await this.j,J=JSON.stringify(R.raw),Z={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},se=new C.$bd;let le,ue,he=0;try{if(le=await this.k.request({type:"POST",url:this.g&&R.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:Z},B),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$Oo)(le);if($e){const de=$e.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[c]:le.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(J.length),duration:se.elapsed(),success:!!le&&(0,h.$Ko)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ue?(0,A.$2)(ue)?"canceled":(0,A.$8)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(R,B,M,J){if(!this.isEnabled())return;const Z=L.$o?this.x(`/itemName/${R}.${B}/version/${M}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${B}/${M}/stats?statType=${J}`),se=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:se};try{await this.k.request({type:"POST",url:Z,headers:ue},N.CancellationToken.None)}catch{}}async download(R,B,M){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const J=(0,b.$xo)(R),Z=new Date().getTime(),se=de=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:de}),le=M===2?"install":M===3?"update":"",ue=le?{uri:`${R.assets.download.uri}${S.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${S.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,he=R.queryContext?.[c]?{[c]:R.queryContext[c]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(B,$e.stream),se(new Date().getTime()-Z)}async downloadSignatureArchive(R,B){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const M=await this.D(R.assets.signature);await this.q.writeFile(B,M.stream)}async getReadme(R,B){if(R.assets.readme){const M=await this.D(R.assets.readme,{},B);return await(0,h.$No)(M)||""}return""}async getManifest(R,B){if(R.assets.manifest){const M=await this.D(R.assets.manifest,{},B),J=await(0,h.$No)(M);return J?JSON.parse(J):null}return null}async C(R,B){const M=z(R,r.Manifest);if(!M)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},Z=await this.D(M,{headers:J});return await(0,h.$Oo)(Z)}async getCoreTranslation(R,B){const M=R.assets.coreTranslations.filter(J=>J[0]===B.toUpperCase())[0];if(M){const J=await this.D(M[1]),Z=await(0,h.$No)(J);return Z?JSON.parse(Z):null}return null}async getChangelog(R,B){if(R.assets.changelog){const M=await this.D(R.assets.changelog,{},B);return await(0,h.$No)(M)||""}return""}async getAllCompatibleVersions(R,B,M){let J=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?J=J.withFilter(i.ExtensionId,R.identifier.uuid):J=J.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:Z}=await this.B(J,N.CancellationToken.None);if(!Z.length)return[];const se=V(Z[0]);if((0,E.$Vn)(se,M))return[];const le=[];await Promise.all(Z[0].versions.map(async $e=>{try{await this.y($e,B?"any":"release",!0,se,M)&&le.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of W(le,M))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:K($e)}));return ue}async D(R,B={},M=N.CancellationToken.None){const J=await this.j,Z={type:"GET"},se={...J,...B.headers||{}};B={...B,...Z,headers:se};const le=R.uri,ue=R.fallbackUri,he={...B,url:le};try{const $e=await this.k.request(he,M);if($e.res.statusCode===200)return $e;const de=await(0,h.$No)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,A.$2)($e))throw $e;const de=(0,A.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const we={...B,url:ue};return this.k.request(we,M)}}async E(R){let B=_(R);if(!B){const M=await this.C(R,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");B=M.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const R=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,h.$Oo)(R),M=[],J={},Z=[];if(B){for(const se of B.malicious)M.push({id:se});if(B.migrateToPreRelease)for(const[se,le]of Object.entries(B.migrateToPreRelease))(!le.engine||(0,l.$Ho)(le.engine,this.u.version,this.u.date))&&(J[se.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[se,le]of Object.entries(B.deprecated))le&&(J[se.toLowerCase()]=(0,I.$pf)(le)?{}:le);if(B.search)for(const se of B.search)Z.push(se)}return{malicious:M,deprecated:J,search:Z}}};re=ye([Y(1,h.$Io),Y(2,w.$5i),Y(3,P.$Ih),Y(4,y.$9k),Y(5,g.$6j),Y(6,d.$kj),Y(7,f.$8h)],re);let Q=class extends re{constructor(R,B,M,J,Z,se,le,ue){super(R,B,M,J,Z,se,le,ue)}};e.$5o=Q,e.$5o=Q=ye([Y(0,$.$Vo),Y(1,h.$Io),Y(2,w.$5i),Y(3,P.$Ih),Y(4,y.$9k),Y(5,g.$6j),Y(6,d.$kj),Y(7,f.$8h)],Q);let q=class extends re{constructor(R,B,M,J,Z,se,le){super(void 0,R,B,M,J,Z,se,le)}};e.$6o=q,e.$6o=q=ye([Y(0,h.$Io),Y(1,w.$5i),Y(2,P.$Ih),Y(3,y.$9k),Y(4,g.$6j),Y(5,d.$kj),Y(6,f.$8h)],q)}),define(oe[80],ae([0,1,4,3,2,20,33,24,18,7,12]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.$Nu=void 0,e.$Nu=(0,O.$Bh)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.$kc{static{E=this}static{this.a=512*1024}static b(w){return`extensionKeys/${(0,D.$to)(w.id)}@${w.version}`}static c(w){const d=b.exec(w);if(d&&d[1])return{id:d[1],version:d[2]}}static async removeOutdatedExtensionVersions(w,d){const h=await w.getInstalled(),o=[];for(const[$,y]of E.f(d)){const C=h.find(t=>(0,D.$po)(t.identifier,{id:$}))?.manifest.version;for(const t of y)C!==t&&o.push(E.b({id:$,version:t}))}for(const $ of o)d.remove($,0)}static f(w){const d=new Map,h=w.keys(0,1);for(const o of h){const $=E.c(o);if($){let y=d.get($.id.toLowerCase());y||d.set($.id.toLowerCase(),y=[]),y.push($.version)}}return d}constructor(w,d,h){super(),this.j=w,this.m=d,this.n=h,this.g=this.B(new N.$fd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(w),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$jc))(o=>this.r(o)))}r(w){if(this.h.has(w.key.toLowerCase())){this.g.fire();return}const d=E.c(w.key);if(d){if(this.j.get(w.key,0)===void 0)this.h.delete(d.id.toLowerCase());else{let h=this.h.get(d.id.toLowerCase());h||this.h.set(d.id.toLowerCase(),h=[]),h.push(d.version),this.g.fire()}return}}s(w){if((0,P.$jf)(w))return w;const d=w.manifest?w.manifest.publisher:w.publisher,h=w.manifest?w.manifest.name:w.name;return(0,D.$so)(d,h)}getExtensionState(w,d){const h=this.s(w),o=this.getExtensionStateRaw(w,d);if(o)try{return JSON.parse(o)}catch($){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${d}): ${$}`)}}getExtensionStateRaw(w,d){const h=this.s(w),o=this.j.get(h,d?0:1);return o&&o?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${d}): ${o.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),o}setExtensionState(w,d,h){const o=this.s(w);d===void 0?this.j.remove(o,h?0:1):this.j.store(o,JSON.stringify(d),h?0:1,1)}setKeysForSync(w,d){this.j.store(E.b(w),JSON.stringify(d),0,1)}getKeysForSync(w){const d=this.m.extensionSyncedKeys?.[w.id.toLowerCase()],h=this.j.get(E.b(w),0),o=h?JSON.parse(h):void 0;return o&&d?(0,S.$Kb)([...o,...d]):o||d}addToMigrationList(w,d){if(w!==d){const h=this.t.filter(o=>!o.includes(w)&&!o.includes(d));h.push([w,d]),this.t=h}}getSourceExtensionToMigrate(w){const d=this.t.find(([,h])=>w===h);return d?d[0]:void 0}get t(){const w=this.j.get("extensionStorage.migrationList",-1,"[]");try{const d=JSON.parse(w);if(Array.isArray(d))return d}catch{}return[]}set t(w){w.length?this.j.store("extensionStorage.migrationList",JSON.stringify(w),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Ou=l,e.$Ou=l=E=ye([Y(0,L.$Vo),Y(1,I.$kj),Y(2,f.$5i)],l)}),define(oe[248],ae([0,1,29,11,24,14,98,55,20,22,221]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=void 0;let E=class extends P.$T4b{constructor(l,g,w,d,h,o,$,y){super(l.userHome,h,g,w,d,o,$,y)}};e.$A8b=E,e.$A8b=E=ye([Y(0,L.$Jh),Y(1,f.$9k),Y(2,O.$2n),Y(3,S.$Vo),Y(4,I.$n6b),Y(5,D.$0Ub),Y(6,N.$6j),Y(7,A.$kj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,64,24,6,5,101,19,165,36,20,12,133,21]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=void 0;const C=[O.$p8b,O.$q8b],t="remoteTunnelSession",c="remoteTunnelIsService";let n=class extends D.$kc{constructor(a,p,m,u,v,j,F){super(),this.y=a,this.z=p,this.C=m,this.D=j,this.F=F,this.f=new N.$fd,this.onDidTokenFailed=this.f.event,this.g=new N.$fd,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$fd,this.onDidChangeMode=this.h.event,this.n=O.$n8b,this.w=!1,this.I=(T,z)=>{z?this.j.error(T):this.j.info(T)},this.j=this.B(u.createLogger((0,y.$ig)(m.logsHome,`${O.$r8b}.log`),{id:O.$r8b,name:O.$s8b})),this.t=new b.$Dg(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,I.$hj)(T)))),this.B(v.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(T=>{C.some(z=>T.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(p){this.j.error(p)}return this.s}J(){if(!this.u){let a;E.$j?a=this.C.appRoot:a=(0,S.$_d)((0,S.$_d)(this.C.appRoot)),this.u=(0,S.$9d)(a,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(p){this.j.error(p)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(O.$n8b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(p){this.j.error(p)}try{await this.O("stop",["kill"])}catch(p){this.j.error(p)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",p=!1;const m=(z,U)=>{U?this.j.error(z):a+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,w.localize)(0,null)))},u=this.O("status",["status"],m);this.r=u;try{if(await u,this.r!==u)return;const z=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")));if(p=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const v=this.n.active?this.n.session:void 0;if(v&&v.token){const z=v.token;this.G(O.TunnelStates.connecting((0,w.localize)(1,null,v.accountLabel,v.providerId)));const U=(K,X)=>{K=K.replaceAll(z,"*".repeat(4)),m(K,X)},_=this.O("login",["user","login","--provider",v.providerId,"--access-token",z,"--log",(0,I.$hj)(this.j.getLevel())],U);this.r=_;try{if(await _,this.r!==_)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(v),this.G(O.TunnelStates.disconnected(v));return}}const j=this.Q();j?this.G(O.TunnelStates.connecting((0,w.localize)(2,null,j))):this.G(O.TunnelStates.connecting((0,w.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,I.$hj)(this.j.getLevel())];j?F.push("--name",j):F.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!p&&(T=await this.M(F)===!1),this.N(v,F,T)}async M(a){let p;try{p=await this.O("serviceInstall",["service","install",...a])}catch(m){this.j.error(m),p=1}if(p!==0){const m=(0,w.localize)(4,null);return this.j.warn(m),this.G(O.TunnelStates.connecting(m)),!1}return!0}async N(a,p,m){p.push("--parent-process-id",String(process.pid)),this.P()&&p.push("--no-sleep");let u=!1;const v=this.O("tunnel",p,(j,F)=>{F?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(u=!0);const T=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const z={link:T[1],domain:T[2],tunnelName:T[4],isAttached:u};this.G(O.TunnelStates.connected(z,m))}else j.match(/error refreshing token/)&&(v.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=v,v.finally(()=>{v===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$n8b,this.G(O.TunnelStates.disconnected()))})}O(a,p,m=this.I){return(0,b.$ug)(u=>new Promise((v,j)=>{u.isCancellationRequested&&v(-1);let F;const T=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)m(`Building tunnel CLI from sources and run
`,!1),m(`${a} Spawning: cargo run -- tunnel ${p.join(" ")}
`,!1),F=(0,f.spawn)("cargo",["run","--","tunnel",...p],{cwd:(0,S.$9d)(this.C.appRoot,"cli"),stdio:T});else{m(`Running tunnel CLI
`,!1);const z=this.J();m(`${a} Spawning: ${z} tunnel ${p.join(" ")}
`,!1),F=(0,f.spawn)(z,["tunnel",...p],{cwd:(0,d.homedir)(),stdio:T})}F.stdout.pipe(new $.$VS(`
`)).on("data",z=>{if(F){const U=z.toString();m(U,!1)}}),F.stderr.pipe(new $.$VS(`
`)).on("data",z=>{if(F){const U=z.toString();m(U,!0)}}),F.on("exit",z=>{F&&(m(`${a} exit(${F.pid}): + ${z} `,!1),F=void 0,v(z||0))}),F.on("error",z=>{F&&(m(`${a} error(${F.pid}): + ${z} `,!0),F=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$q8b)}Q(){let a=this.D.getValue(O.$p8b)||(0,d.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),p=this.F.getBoolean(c,-1,!1);if(a){const m=JSON.parse(a);if(m&&(0,o.$jf)(m.accountLabel)&&(0,o.$jf)(m.sessionId)&&(0,o.$jf)(m.providerId))return{active:!0,session:m,asService:p};this.j.error("Problems restoring session from storage, invalid format",m)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$n8b}S(a){if(a.active){const p={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(p),-1,1),this.F.store(c,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(c,-1)}};e.$w8b=n,e.$w8b=n=ye([Y(0,A.$9k),Y(1,P.$kj),Y(2,L.$Jh),Y(3,I.$6i),Y(4,l.$u8b),Y(5,g.$8h),Y(6,h.$Vo)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const i=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(oe[250],ae([0,1,5,2,23,21,66,20,75,17]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=void 0;class P extends I.$Xo{constructor(b,l,g,w){super(),this.bb=b,this.cb=l,this.db=g,this.eb=w,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$jc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$jc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new S.$nAb(this.db.getChannel("storage"))),l=this.B(new D.$Ro(b));return this.B(l.onDidChangeStorage(g=>this.u(-1,g))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,I.$Yo)(b))l=this.U;else{const g=this.X.add(new S.$oAb(this.db.getChannel("storage"),b));l=this.X.add(new D.$Ro(g))}return this.X.add(l.onDidChangeStorage(g=>this.u(0,g))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const g=this.$.add(new S.$pAb(this.db.getChannel("storage"),b));l=this.$.add(new D.$Ro(g)),this.$.add(l.onDidChangeStorage(w=>this.u(1,w)))}return l}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$ig)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,g=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N(g,this.Y,0)}async S(b,l){const g=this.ab,w=g?.items??new Map;await g?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(w,this.ab,1)}hasScope(b){return(0,f.$Dk)(b)?this.W.id===b.id:this.Z===b.id}}e.$B8b=P}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=void 0;class D{constructor(f,P){this.a=f,this.b=P}listen(f,P){const E=this.b(f);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,L.$Dm)({...l},E)),added:b.added.map(l=>(0,L.$Dm)({...l},E)),removed:b.removed.map(l=>(0,L.$Dm)({...l},E)),updated:b.updated.map(l=>(0,L.$Dm)({...l},E))}))}throw new Error(`Invalid listen ${P}`)}async call(f,P,E){const b=this.b(f);switch(P){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,L.$Dm)({...l},b)}case"updateProfile":{let l=(0,A.$Fk)((0,L.$Em)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,L.$Dm)({...l},b)}case"removeProfile":{const l=(0,A.$Fk)((0,L.$Em)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$xN=D;class I extends N.$kc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(f,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new O.$fd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=f.map(b=>(0,A.$Fk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),g=b.removed.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),w=b.updated.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme));this.a=b.all.map(d=>(0,A.$Fk)(d,this.profilesHome.scheme)),this.b.fire({added:l,removed:g,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(f){this.c=f}isEnabled(){return this.c}async createNamedProfile(f,P,E){const b=await this.f.call("createNamedProfile",[f,P,E]);return(0,A.$Fk)(b,this.profilesHome.scheme)}async createProfile(f,P,E,b){const l=await this.f.call("createProfile",[f,P,E,b]);return(0,A.$Fk)(l,this.profilesHome.scheme)}async createTransientProfile(f){const P=await this.f.call("createTransientProfile",[f]);return(0,A.$Fk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(f,P){await this.f.call("setProfileForWorkspace",[f,P])}removeProfile(f){return this.f.call("removeProfile",[f])}async updateProfile(f,P){const E=await this.f.call("updateProfile",[f,P]);return(0,A.$Fk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$yN=I}),define(oe[58],ae([0,1,2,66,4,20,3,75,17]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tAb=e.$sAb=e.$rAb=void 0,e.$rAb=(0,A.$Bh)("IUserDataProfileStorageService");let f=class extends O.$kc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async g=>this.b(g))}async updateStorageData(l,g,w){return this.withProfileScopedStorageService(l,async d=>this.c(d,g,w))}async withProfileScopedStorageService(l,g){if(this.a.hasScope(l))return g(this.a);const w=await this.g(l),d=new E(w);try{await d.initialize();const h=await g(d);return await d.flush(),h}finally{d.dispose(),await this.f(w)}}b(l){const g=new Map,w=d=>{for(const h of l.keys(0,d))g.set(h,{value:l.get(h,0),target:d})};return w(0),w(1),g}c(l,g,w){l.storeAll(Array.from(g.entries()).map(([d,h])=>({key:d,value:h,scope:0,target:w})),!0)}async f(l){try{await l.close()}finally{(0,O.$ec)(l)&&l.dispose()}}};e.$sAb=f,e.$sAb=f=ye([Y(0,L.$Vo)],f);class P extends f{constructor(l,g,w,d){super(w),this.j=l;const h=l.getChannel("profileStorageListener"),o=this.B(new O.$lc);this.h=this.B(new D.$fd({onWillAddFirstListener:()=>{o.value=h.listen("onDidChange")($=>{d.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(y=>(0,S.$Fk)(y,g.profilesHome.scheme)),valueChanges:$.valueChanges.map(y=>({...y,profile:(0,S.$Fk)(y.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>o.value=void 0})),this.onDidChange=this.h.event}async g(l){const g=this.j.getChannel("storage");return(0,L.$Yo)(l)?new I.$nAb(g):new I.$oAb(g,l)}}e.$tAb=P;class E extends L.$Xo{constructor(l){super({flushInterval:100}),this.s=this.B(new N.$Ro(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,20,7,17,71,58]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0;let I=class extends D.$tAb{constructor(f,P,E,b){super(f,P,E,b)}};e.$g8b=I,e.$g8b=I=ye([Y(0,L.$E7b),Y(1,A.$Ek),Y(2,O.$Vo),Y(3,N.$5i)],I)}),define(oe[39],ae([0,1,18,5,15,26,3,34,2,27,12,170,19,14,11,7,43,20,22,28,25,17]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nBb=e.$mBb=e.$lBb=e.$kBb=e.$jBb=e.$iBb=e.$hBb=void 0;function t(p){return!!(p&&p.ref!==void 0&&typeof p.ref=="string"&&p.ref!==""&&p.syncData!==void 0&&(p.syncData===null||c(p.syncData)))}e.$hBb=t;function c(p){return!!(p&&p.version!==void 0&&typeof p.version=="number"&&p.content!==void 0&&typeof p.content=="string"&&(Object.keys(p).length===2||Object.keys(p).length===3&&p.machineId!==void 0&&typeof p.machineId=="string"))}e.$iBb=c;function n(p,m){return`${(0,f.$bf)(p)}${m.isDefault?"":` (${m.name})`}`}e.$jBb=n;let s=class extends S.$kc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(m,u,v,j,F,T,z,U,_,K,X,H){super(),this.syncResource=m,this.collection=u,this.G=v,this.H=j,this.I=F,this.J=T,this.L=z,this.M=U,this.N=_,this.O=K,this.P=X,this.c=null,this.m="idle",this.n=this.B(new D.$fd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$fd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Eg(50)),this.w=this.B(new D.$fd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(m.syncResource,m.profile),this.h=H.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,y.$Hgb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,y.$3gb),this.y=(0,y.$Igb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,j,this.h),this.j=(0,d.$2o)(j,v,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const u=await this.Y(m.remoteUserData,m.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.ub(m):!0)&&this.w.fire()}}S(m){this.m!==m&&(this.m=m,this.n.fire(m))}async sync(m,u={}){await this.U(m,!0,this.ob(),u)}async preview(m,u,v={}){return this.U(m,!1,u,v)}async apply(m,u={}){try{this.F={...u};const v=await this.ab(m);return this.S(v),this.c}finally{this.F={}}}async U(m,u,v,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const T=await this.getLastSyncUserData(),z=await this.X(m,T);return F=await this.Y(z,T,u,v),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(m){const u=this.kb(m);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const v=await this.getLastSyncUserData(),j=await this.X(null,v),F=await this.W(j),T=await this.qb({ref:j.ref,syncData:u},v,F,this.ob(),L.CancellationToken.None),z=[];for(const U of T){const _=await this.sb(U,U.remoteResource,void 0,L.CancellationToken.None),{remoteChange:K}=await this.sb(U,U.previewResource,U.remoteContent,L.CancellationToken.None);z.push([U,{..._,remoteChange:K!==0?K:2}])}await this.tb(j,v,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(m){const u=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===u}async X(m,u){if(u){const v=m?m[this.resource]:void 0;if(u.ref===v||v===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(m,u,v,j){if(m.syncData&&m.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new y.$Pgb((0,E.localize)(0,null,this.resource,this.pb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(m,u,v,j)}catch(F){if(F instanceof y.$Pgb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(m,u,v,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(m,u,v,j)}throw F}}async Z(m,u,v,j){try{const F=await this.W(m),T=!F&&u===null&&this.gb()!==void 0,z=v&&!T;this.c||(this.c=(0,N.$ug)(_=>this.eb(m,u,F,z,j,_)));let U=await this.c;if(v&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of U.resourcePreviews)U=await this.accept(_.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":v?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(m){return await this.$(m,async u=>{const v=await this.rb(u,L.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$Fd.fromString(v?.content||""));const j=v&&!v.hasConflicts?await this.sb(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=j,u.mergeState=v.hasConflicts?"conflict":j?"accepted":"preview",u.localChange=j?j.localChange:v.localChange,u.remoteChange=j?j.remoteChange:v.remoteChange,u}),this.c}async accept(m,u){return await this.$(m,async v=>{const j=await this.sb(v,m,u,L.CancellationToken.None);return v.acceptResult=j,v.mergeState="accepted",v.localChange=j.localChange,v.remoteChange=j.remoteChange,v}),this.c}async discard(m){return await this.$(m,async u=>{const v=await this.rb(u,L.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$Fd.fromString(v.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=v.localChange,u.remoteChange=v.remoteChange,u}),this.c}async $(m,u){if(!this.c)return;let v=await this.c;const j=v.resourcePreviews.findIndex(({localResource:F,remoteResource:T,previewResource:z})=>this.h.isEqual(F,m)||this.h.isEqual(T,m)||this.h.isEqual(z,m));j!==-1&&(this.c=(0,N.$ug)(async F=>{const T=[...v.resourcePreviews];return T[j]=await u(T[j]),{...v,resourcePreviews:T}}),v=await this.c,this.cb(v.resourcePreviews),v.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(m){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(v=>[v,v.acceptResult]),m),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(m){const u=m.filter(({mergeState:v})=>v==="conflict");(0,O.$sb)(this.s,u,(v,j)=>this.h.isEqual(v.previewResource,j.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async db(m){const u=this.c?await this.c:null;if(u)for(const v of u.resourcePreviews){if(this.h.isEqual(v.acceptedResource,m))return v.acceptResult?v.acceptResult.content:null;if(this.h.isEqual(v.remoteResource,m))return v.remoteContent;if(this.h.isEqual(v.localResource,m))return v.localContent;if(this.h.isEqual(v.baseResource,m))return v.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(m){(0,g.$jk)(m)!==1&&this.O.error(m)}}async eb(m,u,v,j,F,T){const z=await this.qb(m,u,v,F,T),U=[];for(const _ of z){const K=_.previewResource.with({scheme:y.$2gb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)U.push({..._,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=j?await this.rb(_,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(_.previewResource,A.$Fd.fromString(X?.content||""));const H=X&&!X.hasConflicts?await this.sb(_,_.previewResource,void 0,T):void 0;U.push({..._,acceptResult:H,mergeState:X?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:X?X.localChange:_.localChange,remoteChange:H?H.remoteChange:X?X.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:u,resourcePreviews:U,isLastSyncFromCurrentMachine:v}}async getLastSyncUserData(){let m=this.gb();if(m||(m=await this.jb()),!m)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(m),v=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!v&&u.version!==v,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;let j,F=1;for(;j===void 0&&F++<6;)try{const T=await this.hb();T&&(T.ref===u.ref?j=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof g.$nk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof y.$Pgb)throw T;this.O.error(T,F)}}if(j===void 0)try{const T=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);j=T===null?null:this.kb(T),await this.ib({ref:u.ref,syncData:j})}catch(T){if(T instanceof y.$Pgb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return j===void 0?null:{...u,syncData:j}}async fb(m,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const v=this.M.getResourceSyncStateVersion(this.resource),j={ref:m.ref,version:v,...u};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(m)}gb(){return this.I.get(this.z,-1)}async hb(){const m=(await this.G.readFile(this.y)).value.toString();try{const u=m?JSON.parse(m):void 0;if(t(u))return u}catch(u){this.O.error(u)}}async ib(m){await this.G.writeFile(this.y,A.$Fd.fromString(JSON.stringify(m)))}async jb(){try{const m=await this.G.readFile(this.y),u=JSON.parse(m.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(m){m instanceof g.$nk&&m.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(m)}return this.I.get(this.z,-1)}async getRemoteUserData(m){const{ref:u,content:v}=await this.lb(m);let j=null;return v!==null&&(j=this.kb(v)),{ref:u,syncData:j}}kb(m){try{const u=JSON.parse(m);if(c(u))return u}catch(u){this.O.error(u)}throw new y.$Pgb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(m){const u=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(m,u){const v=await this.j,j={version:this.pb,machineId:v,content:m};try{return u=await this.J.writeResource(this.resource,JSON.stringify(j),u,this.collection,this.F),{ref:u,syncData:j}}catch(F){throw F instanceof y.$Pgb&&F.code==="TooLarge"&&(F=new y.$Pgb(F.message,F.code,this.resource)),F}}async nb(m){const u={version:this.pb,content:m};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(y.$Cgb)}};e.$kBb=s,e.$kBb=s=ye([Y(2,g.$6j),Y(3,l.$Ih),Y(4,h.$Vo),Y(5,y.$Kgb),Y(6,y.$Lgb),Y(7,y.$Ugb),Y(8,o.$9k),Y(9,y.$Zgb),Y(10,b.$8h),Y(11,$.$Ck)],s);let i=class extends s{constructor(m,u,v,j,F,T,z,U,_,K,X,H,x){super(u,v,j,F,T,z,U,_,K,X,H,x),this.r=m,this.B(this.G.watch(this.h.dirname(m))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(m,u,v){try{u?await this.G.writeFile(this.r,A.$Fd.fromString(m),v?void 0:u):await this.G.createFile(this.r,A.$Fd.fromString(m),{overwrite:v})}catch(j){throw j instanceof g.$nk&&j.fileOperationResult===1||j instanceof g.$nk&&j.fileOperationResult===3?new y.$Pgb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(m){if(!(m instanceof g.$nk&&m.fileOperationResult===1))throw m}}yb(m){m.contains(this.r)&&this.Q()}};e.$lBb=i,e.$lBb=i=ye([Y(3,g.$6j),Y(4,l.$Ih),Y(5,h.$Vo),Y(6,y.$Kgb),Y(7,y.$Lgb),Y(8,y.$Ugb),Y(9,o.$9k),Y(10,y.$Zgb),Y(11,b.$8h),Y(12,$.$Ck)],i);let r=class extends i{constructor(m,u,v,j,F,T,z,U,_,K,X,H,x,G){super(m,u,v,j,F,T,z,U,_,K,X,x,G),this.zb=H,this.Bb=void 0}Ab(m,u){const v=[],j=(0,I.$Lm)(m,v,{allowEmptyContent:!0,allowTrailingComma:!0});return v.length>0||!(0,P.$qf)(j)&&u!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$mBb=r,e.$mBb=r=ye([Y(3,g.$6j),Y(4,l.$Ih),Y(5,h.$Vo),Y(6,y.$Kgb),Y(7,y.$Lgb),Y(8,y.$Ugb),Y(9,o.$9k),Y(10,y.$Zgb),Y(11,y.$Ygb),Y(12,b.$8h),Y(13,$.$Ck)],r);let a=class{constructor(m,u,v,j,F,T,z){this.resource=m,this.g=u,this.h=v,this.j=j,this.k=F,this.l=T,this.d=z.extUri,this.f=(0,y.$Igb)(void 0,this.resource,v,this.d)}async initialize({ref:m,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const v=this.m(u);if(v)try{await this.o({ref:m,syncData:v})}catch(j){this.j.error(j)}}m(m){try{const u=JSON.parse(m);if(c(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const v={ref:m.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(v),-1,1),await this.k.writeFile(this.f,A.$Fd.fromString(JSON.stringify(m)))}};e.$nBb=a,e.$nBb=a=ye([Y(1,C.$Ek),Y(2,l.$Ih),Y(3,w.$5i),Y(4,g.$6j),Y(5,h.$Vo),Y(6,$.$Ck)],a)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,19,14,114,29,33,80,44,11,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c,n,s,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$72b=e.$62b=e.$52b=e.$42b=e.$32b=void 0;async function p(T,z){const U=JSON.parse(T.content);if(T.version===1||T.version===2){const _=(await z.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of U)T.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),T.version===2&&_.every(X=>!(0,l.$po)(X.identifier,K.identifier))&&(K.installed=!0)}return U}function m(T){return JSON.parse(T.content)}e.$32b=m;function u(T,z){return T.sort((U,_)=>!U.identifier.uuid&&_.identifier.uuid?-1:U.identifier.uuid&&!_.identifier.uuid?1:(0,S.$Fe)(U.identifier.id,_.identifier.id)),z?(0,D.$DS)(T,{}):JSON.stringify(T)}e.$42b=u;let v=class extends n.$kBb{constructor(z,U,_,K,X,H,x,G,V,W,ee,ne,re,Q,q,k,R){super({syncResource:"extensions",profile:z},U,K,_,X,H,x,ne,re,W,ee,q),this.Cb=G,this.Db=V,this.Eb=R,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$2gb,authority:"base"}),this.yb=this.wb.with({scheme:r.$2gb,authority:"local"}),this.zb=this.wb.with({scheme:r.$2gb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$2gb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:M})=>!!M)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(k.onDidChange,B=>B.valueChanges.some(({profile:M,changes:J})=>this.syncResource.profile.id===M.id&&J.some(Z=>Z.key===b.$3n))),Q.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,U){const _=z.syncData?await p(z.syncData,this.Cb):null,K=U?.skippedExtensions??[],X=U?.builtinExtensions??null,H=U?.syncData?await p(U.syncData,this.Cb):null,{localExtensions:x,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:W}=(0,s.$22b)(x,_,H,K,G,X),ee={local:V,remote:W,content:this.Hb(x,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:W!==null?2:0},ne=this.Ob(x,!1);return[{skippedExtensions:K,builtinExtensions:X,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ne,localResource:this.yb,localContent:ne,localExtensions:x,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(z){const U=z.syncData?await p(z.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.$22b)(_,U,U,z.skippedExtensions||[],K,z.builtinExtensions||[]);return X!==null}Hb(z,U,_,K){const X=[...U,..._],H=new Set,x=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};X.forEach(({identifier:G})=>x(G)),K.forEach(x);for(const G of z)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||X.push(G);return this.Ob(X,!1)}async rb(z,U){return{...z.previewResult,hasConflicts:!1}}async sb(z,U,_,K){if(this.h.isEqual(U,this.yb))return this.Kb(z);if(this.h.isEqual(U,this.zb))return this.Lb(z);if(this.h.isEqual(U,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(z){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(U),K=(0,s.$22b)(z.localExtensions,null,null,z.skippedExtensions,_,z.builtinExtensions),{local:X,remote:H}=K;return{content:z.localContent,local:X,remote:H,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(z){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(U),K=z.remoteContent?JSON.parse(z.remoteContent):null;if(K!==null){const X=(0,s.$22b)(z.localExtensions,K,z.localExtensions,[],_,z.builtinExtensions),{local:H,remote:x}=X;return{content:z.remoteContent,local:H,remote:x,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,U,_,K){let{skippedExtensions:X,builtinExtensions:H,localExtensions:x}=_[0][0];const{local:G,remote:V,localChange:W,remoteChange:ee}=_[0][1];if(W===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),W!==0&&(await this.nb(JSON.stringify(x)),X=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,X,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(V.all);z=await this.mb(ne,K?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(re=>re.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(re=>re.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(re=>re.identifier.id))}.`:""}`)}U?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(x,H),await this.fb(z,{skippedExtensions:X,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(ne=>ne.identifier.id))}.`:""}`))}Nb(z,U){const _=new Set,K=[];for(const X of z)_.add(X.identifier.id.toLowerCase()),X.installed||K.push(X.identifier);if(U)for(const X of U)_.has(X.id.toLowerCase())||K.push(X);return K}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const U=await this.db(z);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(z,U){return u(z,U)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$52b=v,e.$52b=v=ye([Y(2,P.$Ih),Y(3,d.$6j),Y(4,y.$Vo),Y(5,r.$Kgb),Y(6,r.$Lgb),Y(7,b.$2n),Y(8,i.$5Bb),Y(9,r.$Zgb),Y(10,f.$8h),Y(11,r.$Ugb),Y(12,C.$9k),Y(13,g.$Nu),Y(14,t.$Ck),Y(15,a.$rAb),Y(16,h.$Ah)],v);let j=class{constructor(z,U,_,K,X,H){this.a=z,this.b=U,this.c=_,this.d=K,this.f=X,this.g=H}async getLocalExtensions(z){const U=await this.a.getInstalled(void 0,z.extensionsResource),_=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(z,async(X,H)=>{const x=X.getDisabledExtensions();return U.map(G=>{const{identifier:V,isBuiltin:W,manifest:ee,preRelease:ne,pinned:re,isApplicationScoped:Q}=G,q={identifier:V,preRelease:ne,version:ee.version,pinned:!!re};Q&&!(0,w.$Yl)(ee)&&(q.isApplicationScoped=Q),x.some(k=>(0,l.$po)(k,V))&&(q.disabled=!0),W||(q.installed=!0);try{const k=H.getKeysForSync({id:V.id,version:ee.version});if(k){const R=H.getExtensionState(G,!0)||{};q.state=Object.keys(R).reduce((B,M)=>(k.includes(M)&&(B[M]=R[M]),B),{})}}catch(k){this.g.info(`${(0,n.$jBb)("extensions",z)}: Error while parsing extension state`,(0,A.$8)(k))}return q})}),ignoredExtensions:_}}async updateLocalExtensions(z,U,_,K,X){const H=(0,n.$jBb)("extensions",X),x=[],G=new Map,V=[],W=[],ee=await this.a.getInstalled(void 0,X.extensionsResource);if((z.length||_.length)&&await this.j(X,async(Q,q)=>{await O.Promises.settled([...z,..._].map(async k=>{const R=ee.find(J=>(0,l.$po)(J.identifier,k.identifier));if(R&&R.isBuiltin){k.state&&R.manifest.version===k.version&&this.h(k.state,R,R.manifest.version,q),Q.getDisabledExtensions().some(Z=>(0,l.$po)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id),await Q.disableExtension(k.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id),await Q.enableExtension(k.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id))),V.push(k.identifier);return}const B=k.pinned?k.version:void 0,M=(await this.c.getExtensions([{...k.identifier,version:B,preRelease:B?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(R?R.manifest.version===k.version:M)&&this.h(k.state,R||M,R?.manifest.version,q),M)try{Q.getDisabledExtensions().some(Z=>(0,l.$po)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id,M.version),await Q.disableExtension(M.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id,M.version)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id,M.version),await Q.enableExtension(M.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id,M.version))),(!R||R.preRelease!==k.preRelease||R.pinned!==k.pinned||B&&R.manifest.version!==B)&&(await this.a.canInstall(M)?(x.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[b.$Pn]:!0,[b.$Qn]:!0}}}),G.set(M.identifier.id.toLowerCase(),k)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),W.push(k)))}catch(J){W.push(k),this.g.error(J),this.g.info(`${H}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else W.push(k),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),U.length){const Q=ee.filter(({identifier:q,isBuiltin:k})=>!k&&U.some(R=>(0,l.$po)(q,R)));await O.Promises.settled(Q.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const ne=await this.a.installGalleryExtensions(x);for(const{identifier:Q,local:q,error:k,source:R}of ne){const B=R;if(q)this.g.info(`${H}: Installed extension.`,Q.id,B.version),V.push(Q);else{const M=G.get(Q.id.toLowerCase());M&&(W.push(M),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),k instanceof b.$1n&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):k&&this.g.error(k)}}const re=[];for(const Q of K)V.some(q=>(0,l.$po)(q,Q.identifier))||re.push(Q);for(const Q of W)re.some(q=>(0,l.$po)(q.identifier,Q.identifier))||re.push(Q);return re}h(z,U,_,K){const X=K.getExtensionState(U,!0)||{},H=_?K.getKeysForSync({id:U.identifier.id,version:_}):void 0;H?H.forEach(x=>{X[x]=z[x]}):Object.keys(z).forEach(x=>X[x]=z[x]),K.setExtensionState(U,X,!0)}async j(z,U){return this.b.withProfileScopedStorageService(z,async _=>{const K=new I.$jc,X=this.f.createChild(new o.$zh([y.$Vo,_])),H=K.add(X.createInstance(E.$Pzb)),x=K.add(X.createInstance(g.$Ou));try{return await U(H,x)}finally{K.dispose()}})}};e.$62b=j,e.$62b=j=ye([Y(0,b.$2n),Y(1,a.$rAb),Y(2,b.$Zn),Y(3,i.$5Bb),Y(4,h.$Ah),Y(5,r.$Zgb)],j);let F=class extends n.$nBb{constructor(z,U,_,K,X,H,x,G){super("extensions",K,X,H,_,x,G),this.p=z,this.q=U}async t(z){return z.syncData?await p(z.syncData,this.p):null}u(z,U){const _=[],K=[],X=[];for(const H of z){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const x=U.find(G=>(0,l.$po)(G.identifier,H.identifier));x?(_.push(x),H.disabled&&X.push(H.identifier)):H.installed&&(K.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&X.push(H.identifier))}return{installedExtensions:_,newExtensions:K,disabledExtensions:X,remoteExtensions:z}}};e.$72b=F,e.$72b=F=ye([Y(0,b.$2n),Y(1,i.$5Bb),Y(2,d.$6j),Y(3,c.$Ek),Y(4,P.$Ih),Y(5,$.$5i),Y(6,y.$Vo),Y(7,t.$Ck)],F)}),define(oe[116],ae([0,1,15,8,3,34,41,6,32,19,14,11,7,43,20,22,28,39,77,236,25,17,58,4]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tBb=e.$sBb=e.$rBb=e.$qBb=e.$pBb=void 0;const n="globalState.argv.",s=["locale"];function i(v,j){const F=v.storage?Object.keys(v.storage).sort():[],T={};return F.forEach(z=>T[z]=v.storage[z]),v.storage=T,j?(0,D.$DS)(v,{}):JSON.stringify(v)}e.$pBb=i;const r=1;let a=class extends h.$kBb{constructor(j,F,T,z,U,_,K,X,H,x,G,V,W,ee){super({syncResource:"globalState",profile:j},F,z,X,V,U,_,H,x,K,G,W),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:y.$2gb,authority:"base"}),this.xb=this.vb.with({scheme:y.$2gb,authority:"local"}),this.yb=this.vb.with({scheme:y.$2gb,authority:"remote"}),this.zb=this.vb.with({scheme:y.$2gb,authority:"accepted"}),this.Ab=ee.createInstance(p),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(z.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),A.Event.filter(T.onDidChange,ne=>!!(ne.targetChanges.some(re=>this.syncResource.profile.id===re.id)||ne.valueChanges.some(({profile:re,changes:Q})=>this.syncResource.profile.id===re.id&&Q.some(q=>q.target===0)))))(()=>this.Q()))}async qb(j,F,T){const z=j.syncData?JSON.parse(j.syncData.content):null;F=F===null&&T?j:F;const U=F&&F.syncData?JSON.parse(F.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(U),{local:X,remote:H}=(0,$.$oBb)(_.storage,z?z.storage:null,U?U.storage:null,K,this.O),x={content:null,local:X,remote:H,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=i(_,!1);return[{baseResource:this.wb,baseContent:U?i(U,!1):G,localResource:this.xb,localContent:G,localUserData:_,remoteResource:this.yb,remoteContent:z?i(z,!1):null,previewResource:this.vb,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(F===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(F),{remote:U}=(0,$.$oBb)(T.storage,F.storage,F.storage,z,this.O);return U.all!==null}async rb(j,F){return{...j.previewResult,hasConflicts:!1}}async sb(j,F,T,z){if(this.h.isEqual(F,this.xb))return this.Gb(j);if(this.h.isEqual(F,this.yb))return this.Hb(j);if(this.h.isEqual(F,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const F=JSON.parse(j.remoteContent),{local:T,remote:z}=(0,$.$oBb)(j.localUserData.storage,F.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:T,remote:z,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,F,T,z){const{localUserData:U}=T[0][0],{local:_,remote:K,localChange:X,remoteChange:H}=T[0][1];if(X===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),X!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const x=JSON.stringify({storage:K.all});j=await this.mb(x,z?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}F?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const F=await this.db(j);return F&&i(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const F=await this.Bb.readStorageData(this.syncResource.profile),T=[],z=[];for(const[K,X]of F)X.target===0?T.push(K):X.target===1&&z.push(K);const U=[...T,...z],_=j?.storage?Object.keys(j.storage).filter(K=>!K.startsWith(n)&&!U.includes(K)&&F.get(K)!==void 0):[];if(!I.$o){const K=[...y.$Ggb.map(X=>(0,y.$Tgb)(X)),y.$Sgb];_.push(...K),z.push(...K)}return{user:T,machine:z,unregistered:_}}};e.$qBb=a,e.$qBb=a=ye([Y(2,t.$rAb),Y(3,E.$6j),Y(4,y.$Kgb),Y(5,y.$Lgb),Y(6,y.$Zgb),Y(7,P.$Ih),Y(8,y.$Ugb),Y(9,w.$9k),Y(10,f.$8h),Y(11,g.$Vo),Y(12,d.$Ck),Y(13,c.$Ah)],a);let p=class{constructor(j,F,T,z){this.a=j,this.b=F,this.c=T,this.d=z}async getLocalGlobalState(j){const F={};if(j.isDefault){const z=await this.f(),U=(0,L.$Lm)(z);for(const _ of s)U[_]!==void 0&&(F[`${n}${_}`]={version:1,value:U[_]})}const T=await this.c.readStorageData(j);for(const[z,U]of T)U.value&&U.target===0&&(F[z]={version:1,value:U.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,N.$8)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:F,updated:T},z){const U=(0,h.$jBb)("globalState",z),_={},K=new Map,X=await this.c.readStorageData(z),H=(x,G)=>{for(const V of x){if(V.startsWith(n)){_[V.substring(n.length)]=G?G[V].value:void 0;continue}if(G){const W=G[V];W.value!==X.get(V)?.value&&K.set(V,W.value)}else X.get(V)!==void 0&&K.set(V,void 0)}};if(H(Object.keys(j),j),H(Object.keys(T),T),H(F),Object.keys(_).length){this.d.trace(`${U}: Updating locale...`);const x=await this.f();let G=x;for(const V of Object.keys(_))G=(0,o.edit)(G,[V],_[V],{});x!==G&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$Fd.fromString(G)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}K.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(z,K,0),this.d.info(`${U}: Updated global state`,[...K.keys()]))}};e.$rBb=p,e.$rBb=p=ye([Y(0,E.$6j),Y(1,P.$Ih),Y(2,t.$rAb),Y(3,y.$Zgb)],p);let m=class extends h.$nBb{constructor(j,F,T,z,U,_){super("globalState",T,z,U,F,j,_)}async o(j){const F=j.syncData?JSON.parse(j.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},z={};for(const U of Object.keys(F.storage))U.startsWith(n)?T[U.substring(n.length)]=F.storage[U].value:this.l.get(U,0)===void 0&&(z[U]=F.storage[U].value);if(Object.keys(T).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(T))U=(0,o.edit)(U,[_],T[_],{});await this.k.writeFile(this.h.argvResource,O.$Fd.fromString(U))}if(Object.keys(z).length){const U=[];for(const _ of Object.keys(z))U.push({key:_,value:z[_],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$sBb=m,e.$sBb=m=ye([Y(0,g.$Vo),Y(1,E.$6j),Y(2,C.$Ek),Y(3,P.$Ih),Y(4,y.$Zgb),Y(5,d.$Ck)],m);let u=class{constructor(j,F,T,z,U){this.a=j,this.b=F,this.c=T,this.d=z,this.f=U}getSyncStoreType(j){return this.h(j)?.storage[y.$Sgb]?.value}async sync(j){const F=(0,y.$Ogb)((0,S.$4f)());try{return await this.g(j,F)}catch(T){if(T instanceof y.$Pgb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,F)}throw T}}async g(j,F){const T=await this.a.readResource("globalState",null,void 0,F),z=this.h(T)||{storage:{}};z.storage[y.$Sgb]={value:j,version:r};const U=await(0,l.$2o)(this.c,this.d,this.b),_={version:r,machineId:U,content:i(z,!1)};await this.a.writeResource("globalState",JSON.stringify(_),T.ref,void 0,F)}h({content:j}){if(!j)return null;const F=JSON.parse(j);if((0,h.$iBb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$tBb=u,e.$tBb=u=ye([Y(1,g.$Vo),Y(2,P.$Ih),Y(3,E.$6j),Y(4,b.$5i)],u)}),define(oe[117],ae([0,1,18,15,3,34,6,12,171,19,14,11,20,22,28,17,39,233,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$2b=e.$02b=e.$92b=void 0;function $(t,c,n){try{const s=JSON.parse(t);if(!c)return(0,I.$qf)(s.all)?null:s.all;switch(D.OS){case 2:return(0,I.$qf)(s.mac)?null:s.mac;case 3:return(0,I.$qf)(s.linux)?null:s.linux;case 1:return(0,I.$qf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$92b=$;let y=class extends d.$mBb{constructor(c,n,s,i,r,a,p,m,u,v,j,F,T){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},n,m,u,v,s,i,p,F,r,j,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:o.$2gb,authority:"base"}),this.Gb=this.Eb.with({scheme:o.$2gb,authority:"local"}),this.Hb=this.Eb.with({scheme:o.$2gb,authority:"remote"}),this.Ib=this.Eb.with({scheme:o.$2gb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(c,n,s,i){const r=c.syncData?$(c.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?c:n;const a=n?this.Ob(n):null,p=await this.vb(),m=await this.Cb();let u=null,v=!1,j=!1,F=!1;if(r){let U=p?p.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new o.$Pgb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,h.$82b)(U,r,a,m,this.zb);_.hasChanges&&(u=_.mergeContent,F=_.hasConflicts,v=F||_.mergeContent!==U,j=F||_.mergeContent!==r)}}else p&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=p.value.toString(),j=!0);const T={content:F?a:u,localChange:v?p?2:1:0,remoteChange:j?2:0,hasConflicts:F},z=p?p.value.toString():null;return[{fileContent:p,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:z,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(c){const n=this.Ob(c);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",r=await this.Cb(),a=await(0,h.$82b)(i||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(c,n){return c.previewResult}async sb(c,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(c,n,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:p,remoteChange:m}=s[0][1];if(p===0&&m===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new o.$Pgb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(p!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,i),this.O.info(`${this.D}: Updated local keybindings`)),m!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",c.syncData?.content);c=await this.mb(u,i?null:c.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(c,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.vb();if(c){const n=(0,L.$Lm)(c.value.toString());if((0,O.$Jb)(n))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Hb,c)||this.h.isEqual(this.Fb,c)||this.h.isEqual(this.Gb,c)||this.h.isEqual(this.Ib,c)?this.db(c):null}Ob(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Qb()?null:$(c.syncData.content,this.Qb(),this.O)}Pb(c,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=c,D.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(o.$Dgb)}};e.$02b=y,e.$02b=y=ye([Y(2,o.$Kgb),Y(3,o.$Lgb),Y(4,o.$Zgb),Y(5,f.$8h),Y(6,o.$Ugb),Y(7,E.$6j),Y(8,P.$Ih),Y(9,b.$Vo),Y(10,o.$Ygb),Y(11,l.$9k),Y(12,g.$Ck)],y);let C=class extends d.$nBb{constructor(c,n,s,i,r,a){super("keybindings",n,s,i,c,r,a)}async o(c){const n=c.syncData?this.p(c.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Fd.fromString(n)),await this.n(c)}async i(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$Lm)(c.value.toString());return!(0,O.$Jb)(n)}catch(c){return c.fileOperationResult===1}}p(c){try{return $(c,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$$2b=C,e.$$2b=C=ye([Y(0,E.$6j),Y(1,w.$Ek),Y(2,P.$Ih),Y(3,o.$Zgb),Y(4,b.$Vo),Y(5,g.$Ck)],C)}),define(oe[118],ae([0,1,15,3,172,19,73,14,29,11,20,22,28,17,39,237,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b3b=e.$a3b=e.$_2b=void 0;function h(C){return C&&C.settings&&typeof C.settings=="string"&&Object.keys(C).length===1}function o(C){const t=JSON.parse(C);return h(t)?t:{settings:C}}e.$_2b=o;let $=class extends g.$mBb{constructor(t,c,n,s,i,r,a,p,m,u,v,j,F,T){super(t.settingsResource,{syncResource:"settings",profile:t},c,n,s,i,r,a,v,j,p,m,u,T),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.$2gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$2gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$2gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$2gb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const c=await this.getLastSyncUserData(),n=await this.X(t,c),s=this.Lb(n),i=new D.$rn(d.$Cgb);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(d.$Cgb)||{}}async qb(t,c,n){const s=await this.vb(),i=await this.Cb(),r=this.Lb(t);c=c===null&&n?t:c;const a=c?this.Lb(c):null,p=await this.Pb();let m=null,u=!1,v=!1,j=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,w.$$zb)(U,r.settings,a?a.settings:null,p,[],i);m=_.localContent||_.remoteContent,u=_.localContent!==null,v=_.remoteContent!==null,j=_.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),m=s.value.toString().trim()||"{}",this.Qb(m),v=!0);const F=s?s.value.toString():null,T=a?.settings??null,z={content:j?T:m,localChange:u?2:0,remoteChange:v?2:0,hasConflicts:j};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:F,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(t){const c=this.Lb(t);if(c===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),r=await this.Cb();return(0,w.$$zb)(s||"{}",c.settings,c.settings,i,[],r).remoteContent!==null}async rb(t,c){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,w.$0zb)(t.previewResult.content,"{}",s,n):null}}async sb(t,c,n,s){const i=await this.Cb(),r=await this.Pb();if(this.h.isEqual(c,this.localResource))return{content:t.fileContent?(0,w.$0zb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.remoteResource))return{content:t.remoteContent!==null?(0,w.$0zb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,w.$0zb)(n,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(t,c,n,s){const{fileContent:i}=n[0][0];let{content:r,localChange:a,remoteChange:p}=n[0][1];if(a===0&&p===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(r,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),p!==0){const m=await this.Cb(),u=this.Lb(t),v=await this.Pb(r);r=(0,w.$0zb)(r,u?u.settings:"{}",v,m),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(r)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}c?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,w.$_zb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let c=await super.db(t);if(c){const n=await this.Cb(),s=await this.Pb();c=(0,w.$0zb)(c,"{}",s,n)}return c}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return o(t)}catch(c){this.O.error(c)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const c=await this.Ob;return(0,w.$8zb)(c,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new d.$Pgb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$a3b=$,e.$a3b=$=ye([Y(2,f.$6j),Y(3,I.$Ih),Y(4,P.$Vo),Y(5,d.$Kgb),Y(6,d.$Lgb),Y(7,d.$Zgb),Y(8,d.$Ygb),Y(9,L.$8h),Y(10,d.$Ugb),Y(11,E.$9k),Y(12,S.$2n),Y(13,b.$Ck)],$);let y=class extends g.$nBb{constructor(t,c,n,s,i,r){super("settings",c,n,s,t,i,r)}async o(t){const c=t.syncData?this.p(t.syncData.content):null;if(!c){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$Fd.fromString(c.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$_zb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return o(t)}catch(c){this.j.error(c)}return null}};e.$b3b=y,e.$b3b=y=ye([Y(0,f.$6j),Y(1,l.$Ek),Y(2,I.$Ih),Y(3,d.$Zgb),Y(4,P.$Vo),Y(5,b.$Ck)],y)}),define(oe[119],ae([0,1,15,3,30,19,14,11,20,22,28,17,39,234,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=e.$e3b=void 0;function w(o){return JSON.parse(o.content)}e.$e3b=w;let d=class extends b.$kBb{constructor($,y,C,t,c,n,s,i,r,a,p,m){super({syncResource:"snippets",profile:$},y,t,C,c,n,s,a,p,i,r,m),this.pb=1,this.vb=$.snippetsHome,this.B(this.G.watch(C.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb($,y,C){const t=await this.Hb(),c=this.Gb(t),n=$.syncData?this.Fb($.syncData):null;y=y===null&&C?$:y;const s=y&&y.syncData?this.Fb(y.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,l.$c3b)(c,n,s);return this.Bb(i,t,n||{},s||{})}async ub($){const y=$.syncData?this.Fb($.syncData):null;if(y===null)return!0;const C=await this.Hb(),t=this.Gb(C),c=(0,l.$c3b)(t,y,y);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async rb($,y){return $.previewResult}async sb($,y,C,t){if(this.h.isEqualOrParent(y,this.g.with({scheme:g.$2gb,authority:"local"})))return{content:$.fileContent?$.fileContent.value.toString():null,localChange:0,remoteChange:$.fileContent?$.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(y,this.g.with({scheme:g.$2gb,authority:"remote"})))return{content:$.remoteContent,localChange:$.remoteContent!==null?$.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(y,this.g))return C===void 0?{content:$.previewResult.content,localChange:$.previewResult.localChange,remoteChange:$.previewResult.remoteChange}:{content:C,localChange:C===null?$.fileContent!==null?3:0:2,remoteChange:C===null?$.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async tb($,y,C,t){const c=C.map(([n,s])=>({...n,acceptResult:s}));c.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),c.some(({localChange:n})=>n!==0)&&(await this.Cb(c),await this.Db(c,t)),c.some(({remoteChange:n})=>n!==0)&&($=await this.Eb(c,$,t)),y?.ref!==$.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb($),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of c)try{await this.G.del(n)}catch{}}Bb($,y,C,t){const c=new Map;for(const n of Object.keys($.local.added)){const s={content:$.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of Object.keys($.local.updated)){const s={content:$.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of $.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of Object.keys($.remote.added)){const s={content:$.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of Object.keys($.remote.updated)){const s={content:$.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of $.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of $.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:y[n]?2:1,remoteChange:C[n]?2:1},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}for(const n of Object.keys(y))if(!c.has(n)){const s={content:y[n]?y[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=y[n]?y[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"local"}),fileContent:y[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$2gb,authority:"accepted"})})}return[...c.values()]}async resolveContent($){return this.h.isEqualOrParent($,this.g.with({scheme:g.$2gb,authority:"remote"}))||this.h.isEqualOrParent($,this.g.with({scheme:g.$2gb,authority:"local"}))||this.h.isEqualOrParent($,this.g.with({scheme:g.$2gb,authority:"base"}))||this.h.isEqualOrParent($,this.g.with({scheme:g.$2gb,authority:"accepted"}))?this.db($):null}async hasLocalData(){try{const $=await this.Hb();if(Object.keys($).length)return!0}catch{}return!1}async Cb($){const y={};for(const C of $)C.fileContent&&(y[this.h.basename(C.localResource)]=C.fileContent);await this.nb(JSON.stringify(this.Gb(y)))}async Db($,y){for(const{fileContent:C,acceptResult:t,localResource:c,remoteResource:n,localChange:s}of $)if(s!==0){const i=n?this.h.basename(n):this.h.basename(c),r=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$Fd.fromString(t.content),{overwrite:y}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$Fd.fromString(t.content),y?void 0:C),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb($,y,C){const t=y.syncData?this.Fb(y.syncData):{},c=(0,A.$Vm)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:r}of $)if(r!==0){const a=s?this.h.basename(s):this.h.basename(i);r===3?delete c[a]:c[a]=n.content}return(0,l.$d3b)(t,c)||(this.O.trace(`${this.D}: Updating remote snippets...`),y=await this.mb(JSON.stringify(c),C?null:y.ref),this.O.info(`${this.D}: Updated remote snippets`)),y}Fb($){return w($)}Gb($){const y={};for(const C of Object.keys($))y[C]=$[C].value.toString();return y}async Hb(){const $={};let y;try{y=await this.G.resolve(this.vb)}catch(C){if(C instanceof I.$nk&&C.fileOperationResult===1)return $;throw C}for(const C of y.children||[]){const t=C.resource,c=this.h.extname(t);if(c===".json"||c===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);$[n]=s}}return $}};e.$f3b=d,e.$f3b=d=ye([Y(2,D.$Ih),Y(3,I.$6j),Y(4,S.$Vo),Y(5,g.$Kgb),Y(6,g.$Lgb),Y(7,g.$Zgb),Y(8,L.$8h),Y(9,g.$Ugb),Y(10,f.$9k),Y(11,P.$Ck)],d);let h=class extends b.$nBb{constructor($,y,C,t,c,n){super("snippets",y,C,t,$,c,n)}async o($){const y=$.syncData?JSON.parse($.syncData.content):null;if(!y){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(y)){const c=y[t];if(c){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,O.$Fd.fromString(c)),this.j.info("Created snippet",this.d.basename(n))}}await this.n($)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch($){return $.fileOperationResult===1}}};e.$g3b=h,e.$g3b=h=ye([Y(0,I.$6j),Y(1,E.$Ek),Y(2,D.$Ih),Y(3,g.$Zgb),Y(4,S.$Vo),Y(5,P.$Ck)],h)}),define(oe[120],ae([0,1,15,19,14,11,20,22,28,17,39,25]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=e.$i3b=e.$h3b=void 0;function b(d,h){try{return JSON.parse(d).tasks??null}catch(o){return h.error(o),null}}e.$h3b=b;let l=class extends P.$lBb{constructor(h,o,$,y,C,t,c,n,s,i,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},o,n,s,i,$,y,c,r,C,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$2gb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$2gb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$2gb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$2gb,authority:"accepted"})}async qb(h,o,$,y){const C=h.syncData?b(h.syncData.content,this.O):null;o=o===null&&$?h:o;const t=o?.syncData?b(o.syncData.content,this.O):null,c=await this.vb();let n=null,s=!1,i=!1,r=!1;if(h.syncData){const m=c?c.value.toString():null;if(!t||t!==m||t!==C){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=w(m,C,t);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,i=u.hasRemoteChanged}}else c&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=c.value.toString(),i=!0);const a={content:r?t:n,localChange:s?c?2:1:0,remoteChange:i?2:0,hasConflicts:r},p=c?c.value.toString():null;return[{fileContent:c,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:p,localChange:a.localChange,remoteResource:this.Db,remoteContent:C,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const o=h?.syncData?b(h.syncData.content,this.O):null;if(o===null)return!0;const $=await this.vb(),y=$?$.value.toString():null,C=w(y,o,o);return C.hasLocalChanged||C.hasRemoteChanged}async rb(h,o){return h.previewResult}async sb(h,o,$,y){if(this.h.isEqual(o,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.Ab))return $===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:$,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(h,o,$,y){const{fileContent:C}=$[0][0],{content:t,localChange:c,remoteChange:n}=$[0][1];if(c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),c!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),C&&await this.nb(JSON.stringify(this.Kb(C.value.toString()))),t?await this.wb(t,C,y):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));h=await this.mb(s,y?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}o?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$i3b=l,e.$i3b=l=ye([Y(2,E.$Kgb),Y(3,E.$Lgb),Y(4,E.$Zgb),Y(5,N.$8h),Y(6,E.$Ugb),Y(7,L.$6j),Y(8,A.$Ih),Y(9,D.$Vo),Y(10,I.$9k),Y(11,S.$Ck)],l);let g=class extends P.$nBb{constructor(h,o,$,y,C,t){super("tasks",o,$,y,h,C,t),this.c=this.g.defaultProfile.tasksResource}async o(h){const o=h.syncData?b(h.syncData.content,this.j):null;if(!o){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$Fd.fromString(o)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$j3b=g,e.$j3b=g=ye([Y(0,L.$6j),Y(1,f.$Ek),Y(2,A.$Ih),Y(3,E.$Zgb),Y(4,D.$Vo),Y(5,S.$Ck)],g);function w(d,h,o){if(d===null&&h===null&&o===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(d===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const $=o!==d,y=o!==h;return!$&&!y?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:$&&!y?{content:d,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:y&&!$?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:d,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,19,14,11,20,22,28,17,39,235,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=e.$Y4b=e.$X4b=void 0;let l=class extends P.$kBb{constructor(h,o,$,y,C,t,c,n,s,i,r,a,p){super({syncResource:"profiles",profile:h},o,y,C,t,c,n,r,a,s,i,p),this.vb=$,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$2gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$2gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$2gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$2gb,authority:"accepted"}),this.B($.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?w(h.syncData):null}async getRemoteSyncedProfiles(h){const o=await this.getLastSyncUserData(),$=await this.X(h,o);return $?.syncData?w($.syncData):null}async qb(h,o,$){if(!this.vb.isEnabled())throw new b.$Pgb("Cannot sync profiles because they are disabled","LocalError");const y=h.syncData?w(h.syncData):null,C=o?.syncData?w(o.syncData):null,t=this.Db(),{local:c,remote:n}=(0,E.$W4b)(t,y,C,[]),s={local:c,remote:n,content:C?this.Eb(C):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:n!==null?2:0},i=g(t,!1);return[{baseResource:this.baseResource,baseContent:C?this.Eb(C):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:y?this.Eb(y):null,remoteProfiles:y,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const o=h?.syncData?w(h.syncData):null,$=this.Db(),{remote:y}=(0,E.$W4b)($,o,o,[]);return!!y?.added.length||!!y?.removed.length||!!y?.updated.length}async rb(h,o){return{...h.previewResult,hasConflicts:!1}}async sb(h,o,$,y){if(this.h.isEqual(o,this.localResource))return this.Ab(h);if(this.h.isEqual(o,this.remoteResource))return this.Bb(h);if(this.h.isEqual(o,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${o.toString()}`)}async Ab(h){const o=this.Db(),$=(0,E.$W4b)(o,null,null,[]),{local:y,remote:C}=$;return{content:h.localContent,local:y,remote:C,localChange:y.added.length>0||y.removed.length>0||y.updated.length>0?2:0,remoteChange:C!==null?2:0}}async Bb(h){const o=h.remoteContent?JSON.parse(h.remoteContent):null,$=[],y=[];for(const C of this.Db()){const t=o?.find(c=>c.id===C.id);t&&($.push({id:C.id,name:C.name,collection:t.collection}),y.push(C))}if(o!==null){const C=(0,E.$W4b)(y,o,$,[]),{local:t,remote:c}=C;return{content:h.remoteContent,local:t,remote:c,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,o,$,y){const{local:C,remote:t,localChange:c,remoteChange:n}=$[0][1];c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=$[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new b.$Pgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.nb(g(this.Db(),!1));const i=[];for(const r of C.added)i.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of C.removed)i.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of C.updated){const a=this.vb.profiles.find(p=>p.id===r.id);a?i.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],r=s.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const p=await this.J.createCollection(this.F);i.push(p),s.push({id:a.id,name:a.name,collection:p,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:p})=>a.id===p),1);for(const a of t?.updated||[]){const p=s.find(({id:m})=>a.id===m);p&&s.splice(s.indexOf(p),1,{...p,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,y?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const p of i)await this.J.deleteCollection(p,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}o?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,o){return this.mb(this.Eb(h),o)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const o=await this.db(h);return o&&(0,O.$DS)(JSON.parse(o),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((o,$)=>o.name.localeCompare($.name)))}};e.$X4b=l,e.$X4b=l=ye([Y(2,f.$Ek),Y(3,L.$6j),Y(4,A.$Ih),Y(5,D.$Vo),Y(6,b.$Kgb),Y(7,b.$Lgb),Y(8,b.$Zgb),Y(9,N.$8h),Y(10,b.$Ugb),Y(11,I.$9k),Y(12,S.$Ck)],l);function g(d,h){const o=[...d].sort(($,y)=>$.name.localeCompare(y.name)).map($=>({id:$.id,name:$.name}));return h?(0,O.$DS)(o,{}):JSON.stringify(o)}e.$Y4b=g;function w(d){return JSON.parse(d.content)}e.$Z4b=w}),define(oe[253],ae([0,1,3,2,6,14,20,22,25]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=void 0;const f="sync.enable";let P=class extends N.$kc{constructor(b,l,g,w){super(),this.c=b,this.f=l,this.g=g,this.h=w,this.a=new O.$fd,this.onDidChangeEnablement=this.a.event,this.b=new O.$fd,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new N.$jc))(d=>this.m(d)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(f,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(f,{enabled:b}),this.c.store(f,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,S.$Tgb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const g=(0,S.$Tgb)(b);this.j(g,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,A.$o?0:1)}m(b){if(f===b.key){this.a.fire(this.isEnabled());return}const l=S.$Ggb.filter(g=>(0,S.$Tgb)(g)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$K4b=P,e.$K4b=P=ye([Y(0,D.$Vo),Y(1,I.$9k),Y(2,L.$Ih),Y(3,S.$Jgb)],P)}),define(oe[254],ae([0,1,5,15,62,2,21,19,14,11,17,25]),function(te,e,O,N,A,L,D,I,S,f,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=void 0;let b=class extends L.$kc{constructor(g,w,d,h,o){super(),this.a=g,this.b=w,this.c=d,this.f=h,this.g=o,this.h()}async h(){for(const w of this.g.profiles)for(const d of E.$Ggb)try{await this.m(this.j(d,w.isDefault?void 0:w.id))}catch(h){this.f.error(h)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,f.$jk)(w)!==1&&this.f.error(w);return}if(g.children){for(const w of g.children)if(w.isDirectory&&!this.g.profiles.some(d=>d.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch(d){this.f.error(d)}}}async getAllResourceRefs(g,w,d){const h=this.j(g,w,d);try{const o=await this.b.resolve(h);if(o.children)return o.children.filter(y=>y.isFile&&!y.name.startsWith("lastSync")).sort().reverse().map(y=>({ref:y.name,created:this.n(y)}))}catch(o){if((0,f.$jk)(o)!==1)throw o}return[]}async resolveResourceContent(g,w,d,h){const o=this.j(g,d,h),$=(0,D.$ig)(o,w);try{return(await this.b.readFile($)).value.toString()}catch(y){return this.f.error(y),null}}async writeResource(g,w,d,h,o){const $=this.j(g,h,o),y=(0,D.$ig)($,`${(0,A.$7l)(d).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(y,N.$Fd.fromString(w))}catch(C){this.f.error(C)}}j(g,w,d=this.a.userDataSyncHome){return(0,D.$ig)(d,...w?[w,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const w=await this.b.resolve(g);if(w.children){const d=w.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let o=d.filter(y=>Date.now()-this.n(y)>h);const $=d.length-o.length;$<10&&(o=o.slice(10-$)),await O.Promises.settled(o.map(async y=>{this.f.info("Deleting from backup",y.resource.path),await this.b.del(y.resource)}))}}catch(w){this.f.error(w)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$V4b=b,e.$V4b=b=ye([Y(0,S.$Ih),Y(1,f.$6j),Y(2,I.$8h),Y(3,E.$Zgb),Y(4,P.$Ek)],b)}),define(oe[81],ae([0,1,3,2,6,27,176,14,11,4,24,43,20,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$zgb=e.$ygb=e.$xgb=void 0,e.$xgb=(0,f.$Bh)("IUserDataSyncMachinesService");const w="sync.currentMachineName",d="Safari",h="Chrome",o="Edge",$="Firefox",y="Android";function C(n){switch(n){case d:case h:case o:case $:case y:case(0,A.$h)(0):return!0}return!1}e.$ygb=C;function t(){return A.$F?d:A.$D?h:A.$G?o:A.$E?$:A.$H?y:(0,A.$h)(A.$o?0:A.$t)}let c=class extends N.$kc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(s,i,r,a,p,m){super(),this.h=r,this.j=a,this.m=p,this.n=m,this.c=this.B(new O.$fd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$2o)(s,i,r)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===i)||(r.machines.push({id:i,name:this.r(r.machines),platform:t()}),await this.t(r))}async removeCurrentMachine(s){const i=await this.f,r=await this.s(s),a=r.machines.filter(({id:p})=>p!==i);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,i,r){const a=await this.s(r),p=a.machines.find(({id:m})=>m===s);if(p){p.name=i,await this.t(a);const m=await this.f;s===m&&this.h.store(w,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[r,a]of s){const p=i.machines.find(m=>m.id===r);p&&(p.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(w,-1);if(i)return i;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$qe)(r)}\\s#(\\d+)`);let p=0;for(const m of s){const u=a.exec(m.name),v=u?parseInt(u[1]):0;p=v>p?v:p}return`${r} #${p+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==g.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),r=await this.j.writeResource(g.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[g.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:g.a,machines:[]}}};e.$zgb=c,e.$zgb=c=g=ye([Y(0,I.$Ih),Y(1,S.$6j),Y(2,b.$Vo),Y(3,l.$Kgb),Y(4,l.$Zgb),Y(5,P.$kj)],c)}),define(oe[255],ae([0,1,5,62,38,8,3,2,6,21,10,173,24,20,22,25,78,81]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=void 0;const o="sync.disableMachineEventually",$="sync.sessionId",y="sync.storeUrl",C="sync.productQuality";let t=class extends I.$kc{get n(){const s=this.H.get(y,-1);return s?P.URI.parse(s):void 0}set n(s){s?this.H.store(y,s.toString(),-1,1):this.H.remove(y,-1)}get s(){return this.H.get(C,-1)}set s(s){s?this.H.store(C,s,-1,1):this.H.remove(C,-1)}constructor(s,i,r,a,p,m,u,v,j,F){super(),this.u=i,this.w=r,this.y=a,this.z=p,this.C=m,this.D=u,this.F=v,this.G=j,this.H=F,this.a=this.B(new I.$lc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$fd),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$Eg(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,f.$bg)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(p.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new c(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$7l)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove($,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=w.$Pgb.toUserDataSyncError(s);i instanceof w.$Rgb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?S.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(o,!0,-1,1),await(0,O.$Hg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(o,-1,!1)}R(){this.H.remove(o,-1)}async triggerSync(s,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$24b=t,e.$24b=t=ye([Y(0,b.$kj),Y(1,w.$Jgb),Y(2,w.$Kgb),Y(3,w.$Ugb),Y(4,w.$Vgb),Y(5,w.$Zgb),Y(6,d.$Rzb),Y(7,g.$9k),Y(8,h.$xgb),Y(9,l.$Vo)],t);class c extends I.$kc{static{this.a="Interval"}constructor(s,i,r,a,p,m,u,v,j){super(),this.m=s,this.n=i,this.r=r,this.s=a,this.u=p,this.w=m,this.y=u,this.z=v,this.C=j,this.b=this.B(new I.$lc),this.c=this.B(new D.$fd),this.onDidStartSync=this.c.event,this.f=this.B(new D.$fd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$ic)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}D(){this.b.value=(0,O.$Ig)(()=>this.sync(c.a,!1),this.n)}sync(s,i){const r=(0,O.$ug)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(p){if((0,L.$2)(p))return}return this.H(s,i,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,f.$bg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,f.$bg)(i.defaultUrl,s.defaultUrl)||!(0,f.$bg)(i.insidersUrl,s.insidersUrl)||!(0,f.$bg)(i.stableUrl,s.stableUrl))}async H(s,i,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,r)}catch(p){if(this.y.error(p),a=p,w.$Pgb.toUserDataSyncError(p).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,r),a=void 0}catch(m){this.y.error(m),a=m}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new w.$Rgb((0,E.localize)(0,null),"DefaultServiceChanged"):new w.$Rgb((0,E.localize)(1,null),"ServiceChanged"):new w.$Rgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get($,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new w.$Rgb((0,E.localize)(3,null),"DefaultServiceChanged"):new w.$Rgb((0,E.localize)(4,null),"ServiceChanged"):new w.$Rgb((0,E.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const p=a.find(u=>u.isCurrent);if(p?.disabled)throw new w.$Rgb((0,E.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new w.$Rgb((0,A.$mi)(u),u instanceof w.$Pgb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store($,this.g.session,-1,1),!i.isCancellationRequested&&(p||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(oe[256],ae([0,1,10,177,14,11,43,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=void 0;let n=class{static{c=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,r,a,p,m,u,v,j,F,T){this.e=i,this.f=r,this.g=a,this.h=m,this.i=u,this.j=v,this.k=j,this.l=F,this.n=T,this.d=p.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const r=this.L(i.content,"profiles");return(0,y.$Z4b)(r)}return[]}async getLocalSyncedProfiles(i){const r=await this.f.getAllResourceRefs("profiles",void 0,i);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,i);if(a){const p=this.L(a,"profiles");return(0,y.$Z4b)(p)}}return[]}async getLocalSyncedMachines(i){const r=await this.f.getAllResourceRefs("machines",void 0,i);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(m=>({...m,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,r){return(await this.e.getAllResourceRefs(i,r?.collection)).map(({created:p,ref:m})=>({created:p,uri:this.J({remote:!0,syncResource:i,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:m,node:void 0})}))}async getLocalSyncResourceHandles(i,r,a){return(await this.f.getAllResourceRefs(i,r?.collection,a)).map(({created:m,ref:u})=>({created:m,uri:this.J({remote:!1,syncResource:i,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const r=this.K(i),a=r?this.k.profiles.find(p=>p.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:i}){const r=this.K(i);if(!r)return[];const a=this.k.profiles.find(p=>p.id===r.profile);switch(r.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const r=this.K(i);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,D.$2o)(this.h,this.j,this.i)}}async resolveContent(i){const r=this.K(i);if(!r||r.node===c.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(i,r,a,p,m){if(i){const{content:u}=await this.M(r,p,a);return u}return this.f.resolveResourceContent(r,p,a,m)}q(i,r,a){const p=this.L(r,i);switch(i){case"settings":return this.t(p,a);case"keybindings":return this.v(p,a);case"tasks":return this.x(p,a);case"snippets":return this.z(p,a);case"globalState":return this.E(p,a);case"extensions":return this.B(p,a);case"profiles":return this.H(p,a);case"workspaceState":return null}}async r(i,r){const a=this.k.profiles.find(p=>p.id===r);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,r){const a=this.d.joinPath(i,"settings.json"),p=r?r.settingsResource:this.d.joinPath(i,c.a);return[{resource:a,comparableResource:p}]}t(i,r){switch(r){case"settings.json":return(0,l.$_2b)(i.content).settings}return null}u(i,r){const a=this.d.joinPath(i,"keybindings.json"),p=r?r.keybindingsResource:this.d.joinPath(i,c.a);return[{resource:a,comparableResource:p}]}v(i,r){switch(r){case"keybindings.json":return(0,g.$92b)(i.content,!!this.l.getValue(f.$Dgb),this.g)}return null}w(i,r){const a=this.d.joinPath(i,"tasks.json"),p=r?r.tasksResource:this.d.joinPath(i,c.a);return[{resource:a,comparableResource:p}]}x(i,r){switch(r){case"tasks.json":return(0,d.$h3b)(i.content,this.g)}return null}async y(i,r){const a=await this.resolveContent(i);if(a){const p=this.L(a,"snippets");if(p){const m=(0,b.$e3b)(p),u=[];for(const v of Object.keys(m)){const j=this.d.joinPath(i,v),F=r?this.d.joinPath(r.snippetsHome,v):this.d.joinPath(i,c.a);u.push({resource:j,comparableResource:F})}return u}}return[]}z(i,r){return(0,b.$e3b)(i)[r]||null}A(i,r){const a=this.d.joinPath(i,"extensions.json"),p=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,c.a);return[{resource:a,comparableResource:p}]}B(i,r){switch(r){case"extensions.json":return(0,h.$42b)((0,h.$32b)(i),!0)}return null}async C(i){const{localExtensions:r}=await this.n.createInstance(h.$62b).getLocalExtensions(i);return(0,h.$42b)(r,!0)}D(i,r){const a=this.d.joinPath(i,"globalState.json"),p=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,c.a);return[{resource:a,comparableResource:p}]}E(i,r){switch(r){case"globalState.json":return(0,o.$pBb)(JSON.parse(i.content),!0)}return null}async F(i){const r=await this.n.createInstance(o.$rBb).getLocalGlobalState(i);return(0,o.$pBb)(r,!0)}G(i,r){const a=this.d.joinPath(i,"profiles.json"),p=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:p}]}H(i,r){switch(r){case"profiles.json":return(0,C.$DS)(JSON.parse(i.content),{})}return null}async I(i){return(0,y.$Y4b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(i){const r=i.remote?c.b:c.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$te)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(O.URI.from({scheme:f.$2gb,authority:r,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==f.$2gb)return;const r=[];for(;i.path!=="/";)r.unshift(this.d.basename(i)),i=this.d.dirname(i);if(r.length<2)return;const a=i.authority===c.b;let p,m;const u=[];let v,j,F,T,z;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?p=U.substring(7):U.startsWith("authority:")?m=U.substring(10):U.startsWith("syncResource:")?v=U.substring(13):U.startsWith("profile:")?j=U.substring(8):U.startsWith("collection:")?F=U.substring(11):U.startsWith("ref:")?T=U.substring(4):v?z=U:u.push(U)}return{remote:a,syncResource:v,profile:j,collection:F,ref:T,node:z,location:p&&m!==void 0?this.d.joinPath(O.URI.from({scheme:p,authority:m,query:i.query,fragment:i.fragment,path:"/"}),...u):void 0}}L(i,r){try{const a=JSON.parse(i);if((0,E.$iBb)(a))return a}catch(a){this.g.error(a)}throw new f.$Pgb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(i,r,a){const p=await this.e.resolveResourceContent(i,r,a);return{ref:r,content:p}}};e.$A5b=n,e.$A5b=n=c=ye([Y(0,f.$Kgb),Y(1,f.$Lgb),Y(2,f.$Zgb),Y(3,S.$Ck),Y(4,A.$Ih),Y(5,I.$Vo),Y(6,L.$6j),Y(7,P.$Ek),Y(8,w.$8h),Y(9,$.$Ah)],n)}),define(oe[257],ae([0,1,18,5,26,38,3,2,21,12,32,19,29,11,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$14b=void 0;const i="sync.lastSyncTime";let r=class extends I.$kc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(v,j,F,T,z,U,_,K,X,H,x){super(),this.C=v,this.D=j,this.F=F,this.G=T,this.H=z,this.I=U,this.J=_,this.L=K,this.M=X,this.N=H,this.O=x,this.f="uninitialized",this.g=this.B(new D.$fd),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$fd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$fd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$fd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$fd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$fd),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$fd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$ic)(()=>this.bb()))}async createSyncTask(v,j){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),T=(0,P.$4f)();try{const K=(0,s.$Ogb)(T);j&&(K["Cache-Control"]="no-cache"),v=await this.D.manifest(v,K)}catch(K){const X=s.$Pgb.toUserDataSyncError(K);throw m(X,T,this.F,this.I),X}const z=!1,U=this;let _;return{manifest:v,async run(){if(z)throw new Error("Can run a task only once");_=(0,N.$ug)(K=>U.P(v,!1,T,K)),await _.finally(()=>_=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),U.$()},stop(){return _?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Pgb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const v=new Date().getTime(),j=(0,P.$4f)(),F=(0,s.$Ogb)(j);let T;try{T=await this.D.manifest(null,F)}catch(_){const K=s.$Pgb.toUserDataSyncError(_);throw m(K,j,this.F,this.I),K}await this.resetLocal();const z=this,U=new A.$pd;return{id:j,async merge(){return z.P(T,!0,j,U.token)},async apply(){try{try{await z.R(T,j,U.token)}catch(_){if(s.$Pgb.toUserDataSyncError(_).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(T,j,U.token);else throw _}}catch(_){throw z.H.error(_),_}z.H.info(`Sync done. Took ${new Date().getTime()-v}ms`),z.$()},async stop(){U.cancel(),await z.U(),await z.resetLocal()}}}async P(v,j,F,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,v,j,F,T));const U=z.enabled.find(_=>_.resource==="profiles");if(U){const _=await U.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(_,v,j,F,T)}}finally{this.r.fire(this.n)}}async Q(v,j,F,T,z){for(const U of v){if(z.isCancellationRequested)return;const _=this.M.profiles.find(X=>X.id===U.id);if(!_){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const K=this.getOrCreateActiveProfileSynchronizer(_,U);this.n.push(...await this.S(K,j,F,T,z))}for(const[U,_]of this.z.entries())this.M.profiles.some(K=>K.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(U))}async R(v,j,F){const T=this.ab();for(const X of T){if(F.isCancellationRequested)return;await X.apply(j,F)}const z=T.find(X=>X.profile.isDefault);if(!z)return;const U=z.enabled.find(X=>X.resource==="profiles");if(!U)return;const K=(await U.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(X=>T.every(H=>H.profile.id!==X.id));K.length&&await this.Q(K,v,!1,j,F)}async S(v,j,F,T,z){return(await v.sync(j,F,T,z)).map(([_,K])=>({profile:v.profile,syncResource:_,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(v=>v.stop()))}async resolveContent(v){const j=await this.N.resolveContent(v);if(j)return j;for(const F of this.ab())for(const T of F.enabled){const z=await T.resolveContent(v);if(z)return z}return null}async replace(v){this.cb();const j=this.N.resolveUserDataSyncResource(v);if(!j)return;const F=await this.resolveContent(v.uri);F&&await this.W(j.profile,async T=>{if(j.syncResource===T.resource)return await T.replace(F),!0})}async accept(v,j,F,T){this.cb(),await this.W(v.profile,async z=>{if(v.syncResource===z.resource)return await z.accept(j,F),T&&await z.apply((0,f.$pf)(T)?!1:T.force,(0,s.$Ogb)((0,P.$4f)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(v){this.H.error(v)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[v]of this.z.values())try{await v.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.N.getRemoteSyncedProfiles(),j=v.map(U=>U.collection),F=await this.D.getAllCollections(),T=F.filter(U=>!j.includes(U));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const z=v.filter(U=>F.includes(U.collection));if(z.length!==v.length){const U=this.G.createInstance(n.$X4b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(v){this.cb();const j=await this.D.getActivityData();await this.C.writeFile(v,j)}async extractActivityData(v,j){const F=(await this.C.readFile(v)).value.toString(),T=JSON.parse(F);if(T.resources)for(const z in T.resources)for(const U of T.resources[z])await this.O.writeResource(z,U.content,new Date(U.created*1e3),void 0,j);if(T.collections)for(const z in T.collections)for(const U in T.collections[z].resources)for(const _ of T.collections[z].resources?.[U]??[])await this.O.writeResource(U,_.content,new Date(_.created*1e3),z,j)}async W(v,j){const F=new I.$jc;try{const T=this.z.get(v.id);if(T){const X=await this.X(T[0],j,F);return(0,f.$qf)(X)?null:X}if(v.isDefault){const X=F.add(this.G.createInstance(a,v,void 0)),H=await this.X(X,j,F);return(0,f.$qf)(H)?null:H}if(this.M.isEnabled())return null;const z=F.add(this.G.createInstance(n.$X4b,v,void 0)),U=await this.D.manifest(null),K=(await z.getRemoteSyncedProfiles(U?.latest??null)||[]).find(X=>X.id===v.id);if(K){const X=F.add(this.G.createInstance(a,v,K.collection)),H=await this.X(X,j,F);return(0,f.$qf)(H)?null:H}return null}finally{F.dispose()}}async X(v,j,F){const T=[...v.enabled,...v.disabled.reduce((z,U)=>(U!=="workspaceState"&&z.push(F.add(v.createSynchronizer(U))),z),[])];for(const z of T){const U=await j(z);if(!(0,f.$qf)(U))return U}}Y(v){const j=this.f;this.f!==v&&(this.f=v,this.g.fire(v),j==="hasConflicts"&&this.$())}Z(){const v=this.ab().map(j=>j.conflicts).flat();(0,O.$sb)(this.j,v,(j,F)=>j.profile.id===F.profile.id&&j.syncResource===F.syncResource&&(0,O.$sb)(j.conflicts,F.conflicts,(T,z)=>(0,S.$bg)(T.previewResource,z.previewResource)))||(this.j=v,this.m.fire(v))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(v,j){let F=this.z.get(v.id);if(F&&F[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(v.id)),!F){const T=new I.$jc,z=T.add(this.G.createInstance(a,v,j?.collection));T.add(z.onDidChangeStatus(U=>this.Y(U))),T.add(z.onDidChangeConflicts(U=>this.Z())),T.add(z.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(v.id,F=[z,T])}return F[0]}ab(){const v=[];for(const[j]of this.z.values())v.push(j);return v}bb(){this.z.forEach(([,v])=>v.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$14b=r,e.$14b=r=ye([Y(0,l.$6j),Y(1,s.$Kgb),Y(2,s.$Jgb),Y(3,g.$Ah),Y(4,s.$Zgb),Y(5,d.$9k),Y(6,w.$Vo),Y(7,s.$Ugb),Y(8,h.$Ek),Y(9,s.$Wgb),Y(10,s.$Lgb)],r);let a=class extends I.$kc{get enabled(){return this.f.sort((v,j)=>v[1]-j[1]).map(([v])=>v)}get disabled(){return s.$Ggb.filter(v=>!this.r.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.m}constructor(v,j,F,T,z,U,_,K,X,H){super(),this.profile=v,this.collection=j,this.r=F,this.t=T,this.u=z,this.w=U,this.y=_,this.z=K,this.C=X,this.D=H,this.f=[],this.g="idle",this.h=this.B(new D.$fd),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$fd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$fd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([x,G])=>this.F(x,G))),this.B((0,I.$ic)(()=>this.f.splice(0,this.f.length).forEach(([,,x])=>x.dispose())));for(const x of s.$Ggb)F.isResourceEnabled(x)&&this.G(x)}F(v,j){j?this.G(v):this.H(v)}G(v){if(this.f.some(([z])=>z.resource===v))return;if(v==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||v==="workspaceState")return;if(v!=="profiles"&&this.profile.useDefaultFlags?.[v]){this.z.debug(`Skipping syncing ${v} in ${this.profile.name} because it is already synced by default profile`);return}const j=new I.$jc,F=j.add(this.createSynchronizer(v));j.add(F.onDidChangeStatus(()=>this.L())),j.add(F.onDidChangeConflicts(()=>this.M())),j.add(F.onDidChangeLocal(()=>this.j.fire(v)));const T=this.N(v);this.f.push([F,T,j])}H(v){const j=this.f.findIndex(([F])=>F.resource===v);if(j!==-1){const[[F,,T]]=this.f.splice(j,1);T.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(v){switch(v){case"settings":return this.t.createInstance(C.$a3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(y.$02b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$f3b,this.profile,this.collection);case"tasks":return this.t.createInstance(c.$i3b,this.profile,this.collection);case"globalState":return this.t.createInstance($.$qBb,this.profile,this.collection);case"extensions":return this.t.createInstance(o.$52b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$X4b,this.profile,this.collection)}}async sync(v,j,F,T){if(T.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const U=[],_=(0,s.$Ogb)(F),K=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,X=j?await this.I(K):{};for(const H of z){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(j){const x=await H.preview(K,X,_);if(x)for(const G of x.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await H.merge(G.previewResource)}else await H.sync(K,_)}catch(x){const G=s.$Pgb.toUserDataSyncError(x);if(m(G,F,this.w,this.y),p(x))throw G;this.z.error(x),this.z.error(`${H.resource}: ${(0,L.$mi)(x)}`),U.push([H.resource,G])}}return U}finally{this.L()}}async apply(v,j){const F=(0,s.$Ogb)(v);for(const T of this.enabled){if(j.isCancellationRequested)return;try{await T.apply(!1,F)}catch(z){const U=s.$Pgb.toUserDataSyncError(z);if(m(U,v,this.w,this.y),p(z))throw U;this.z.error(z),this.z.error(`${T.resource}: ${(0,L.$mi)(z)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(j){this.z.error(`${v.resource}: ${(0,L.$mi)(j)}`),this.z.error(j)}}async I(v){if(!this.profile.isDefault)return{};const j=this.D.getValue(s.$Cgb),F=this.enabled.find(T=>T instanceof C.$a3b);if(F){const T=await F.getRemoteUserDataSyncConfiguration(v);return{...j,...T}}return j}J(v){this.g!==v&&(this.g=v,this.h.fire(v))}L(){return this.M(),this.enabled.some(v=>v.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const v=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,O.$sb)(this.m,v,(j,F)=>j.syncResource===F.syncResource&&(0,O.$sb)(j.conflicts,F.conflicts,(T,z)=>(0,S.$bg)(T.previewResource,z.previewResource)))||(this.m=v,this.n.fire(v))}N(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Y(2,s.$Ugb),Y(3,g.$Ah),Y(4,b.$Zn),Y(5,s.$Jgb),Y(6,d.$9k),Y(7,s.$Zgb),Y(8,h.$Ek),Y(9,E.$8h)],a);function p(u){if(u instanceof s.$Pgb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function m(u,v,j,F){F.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$Qgb?String(u.serverCode):void 0,url:u instanceof s.$Qgb?u.url:void 0,resource:u.resource,executionId:v,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,10,17,25]),function(te,e,O,N,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=e.$e8b=void 0;function I(b,l){return{...b,profile:(0,L.$Fk)(b.profile,l.profilesHome.scheme)}}function S(b){return{created:b.created,uri:A.URI.revive(b.uri)}}class f{constructor(l,g,w){this.c=l,this.d=g,this.f=w,this.a=new Map,this.b=new O.$fd}listen(l,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(l,g,w){try{return await this.g(l,g,w)}catch(d){throw this.f.error(d),d}}async g(l,g,w){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(w[0]));case"accept":return this.c.accept(I(w[0],this.d),A.URI.revive(w[1]),w[2],w[3]);case"replace":return this.c.replace(S(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(w[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(w[0]),A.URI.revive(w[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const d=g.substring(11),h=w[0],o=this.h(h);switch(w=w.slice(1),d){case"merge":return o.merge();case"apply":return o.apply().then(()=>this.a.delete(this.j(o.id)));case"stop":return o.stop().finally(()=>this.a.delete(this.j(o.id)))}}throw new Error("Invalid call")}h(l){const g=this.a.get(this.j(l));if(!g)throw new Error(`Manual sync taks not found: ${l}`);return g}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$e8b=f;let P=class extends N.$kc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new O.$fd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$fd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$fd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$fd),this.onSyncErrors=this.m.event,this.a={call(w,d,h){return l.call(w,d,h).then(null,o=>{throw D.$Pgb.toUserDataSyncError(o)})},listen(w,d){return l.listen(w,d)}},this.a.call("_getInitialData").then(([w,d,h])=>{this.s(w),this.t(d),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(o=>this.s(o))),this.B(this.a.listen("onDidChangeLastSyncTime")(o=>this.u(o)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.t(w))),this.B(this.a.listen("onSyncErrors")(w=>this.m.fire(w.map(d=>({...d,error:D.$Pgb.toUserDataSyncError(d.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),g=this;return new E(l,{async call(d,h,o){return g.a.call(`manualSync/${d}`,[l,...Array.isArray(h)?h:[h]],o)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,g,w,d){return this.a.call("accept",[l,g,w,d])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,g){return this.a.call("extractActivityData",[l,g])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(g=>({syncResource:g.syncResource,profile:(0,L.$Fk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(w=>({...w,baseResource:A.URI.revive(w.baseResource),localResource:A.URI.revive(w.localResource),remoteResource:A.URI.revive(w.remoteResource),previewResource:A.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$f8b=P,e.$f8b=P=ye([Y(1,L.$Ek)],P);class E extends N.$kc{constructor(l,g){super(),this.id=l,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,21,12,10,32,19,14,11,24,57,43,20,25]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gBb=e.$fBb=e.$eBb=e.$dBb=e.$cBb=void 0;const C="configurationSync.store",t="sync.previous.store",c="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends D.$kc{get userDataSyncStore(){return this.b}get c(){return this.h.get(y.$Sgb,-1)}set c(F){this.h.store(y.$Sgb,F,-1,S.$o?0:1)}constructor(F,T,z){super(),this.f=F,this.g=T,this.h=z,this.a=this.B(new L.$fd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new D.$jc);this.B(L.Event.filter(z.onDidChangeValue(-1,y.$Sgb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[C]),this.a.fire()}m(F){if(F&&(F=S.$o&&F.web?{...F,...F.web}:F,(0,P.$jf)(F.url)&&(0,P.$lf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(T=>Array.isArray(F.authenticationProviders[T].scopes)))){const T=F,z=!!T.canSwitch,U=T.url===T.insidersUrl?"insiders":"stable",_=(z?this.c:void 0)||U,K=_==="insiders"?T.insidersUrl:_==="stable"?T.stableUrl:T.url;return{url:E.URI.parse(K),type:_,defaultType:U,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(T.authenticationProviders).reduce((X,H)=>(X.push({id:H,scopes:T.authenticationProviders[H].scopes}),X),[])}}}};e.$cBb=a,e.$cBb=a=ye([Y(0,d.$kj),Y(1,l.$8h),Y(2,$.$Vo)],a);let p=class extends a{constructor(F,T,z){super(F,T,z);const U=this.h.get(t,-1);U&&(this.n=JSON.parse(U));const _=this.f[C];_?this.h.store(t,JSON.stringify(_),-1,1):this.h.remove(t,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$dBb=p,e.$dBb=p=ye([Y(0,d.$kj),Y(1,l.$8h),Y(2,$.$Vo)],p);let m=class extends D.$kc{get donotMakeRequestsUntil(){return this.j}constructor(F,T,z,U,_,K,X){super(),this.n=z,this.r=U,this.s=X,this.g=this.B(new L.$fd),this.onTokenFailed=this.g.event,this.h=this.B(new L.$fd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$fd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,o.$2o)(_,K,X).then(H=>{const x={"X-Client-Name":`${T.applicationName}${S.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(x["X-Client-Commit"]=T.commit),x}),this.f=new v(i,r,this.n,this.r),this.u(),this.B((0,D.$ic)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,T){this.b={token:F,type:T}}t(F){this.a=F?(0,f.$ig)(F,"v1"):void 0}u(){const F=this.s.getNumber(c,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(c,this.j.getTime(),-1,1),this.w=(0,O.$ug)(T=>(0,O.$Hg)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(c,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,f.$ig)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const z=await this.D(T,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,h.$Oo)(z))?.map(({id:U})=>U)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,f.$ig)(this.a,"collection").toString();F={...F},F["Content-Type"]=I.$Hr.text;const z=await this.D(T,{type:"POST",headers:F},[],N.CancellationToken.None),U=await(0,h.$No)(z);if(!U)throw new y.$Qgb("Server did not return the collection id",T,"NoCollection",z.res.statusCode,z.res.headers[y.$Mgb]);return U}async deleteCollection(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=F?(0,f.$ig)(this.a,"collection",F).toString():(0,f.$ig)(this.a,"collection").toString();T={...T},await this.D(z,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(F,T){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,T,F),U={},_=await this.D(z.toString(),{type:"GET",headers:U},[],N.CancellationToken.None);return(await(0,h.$Oo)(_)||[]).map(({url:X,created:H})=>({ref:(0,f.$kg)(z,z.with({path:X})),created:H*1e3}))}async resolveResourceContent(F,T,z,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,f.$ig)(this.z(this.a,z,F),T).toString();U={...U},U["Cache-Control"]="no-cache";const K=await this.D(_,{type:"GET",headers:U},[],N.CancellationToken.None);return await(0,h.$No)(K)}async deleteResource(F,T,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=T!==null?(0,f.$ig)(this.z(this.a,z,F),T).toString():this.z(this.a,z,F).toString(),_={};await this.D(U,{type:"DELETE",headers:_},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$ig)(this.a,"resource").toString(),T={"Content-Type":I.$Hr.text};await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(F,T,z,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,f.$ig)(this.z(this.a,z,F),"latest").toString();U={...U},U["Cache-Control"]="no-cache",T&&(U["If-None-Match"]=T.ref);const K=await this.D(_,{type:"GET",headers:U},[304],N.CancellationToken.None);let X=null;if(K.res.statusCode===304&&(X=T),X===null){const H=K.res.headers.etag;if(!H)throw new y.$Qgb("Server did not return the ref",_,"NoRef",K.res.statusCode,K.res.headers[y.$Mgb]);const x=await(0,h.$No)(K);if(!x&&K.res.statusCode===304)throw new y.$Qgb("Empty response",_,"EmptyResponse",K.res.statusCode,K.res.headers[y.$Mgb]);X={ref:H,content:x}}return X}async writeResource(F,T,z,U,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,U,F).toString();_={..._},_["Content-Type"]=I.$Hr.text,z&&(_["If-Match"]=z);const X=await this.D(K,{type:"POST",data:T,headers:_},[],N.CancellationToken.None),H=X.res.headers.etag;if(!H)throw new y.$Qgb("Server did not return the ref",K,"NoRef",X.res.statusCode,X.res.headers[y.$Mgb]);return H}async manifest(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,f.$ig)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",F&&(T["If-None-Match"]=F.ref);const U=await this.D(z,{type:"GET",headers:T},[304],N.CancellationToken.None);let _=null;if(U.res.statusCode===304&&(_=F),!_){const X=U.res.headers.etag;if(!X)throw new y.$Qgb("Server did not return the ref",z,"NoRef",U.res.statusCode,U.res.headers[y.$Mgb]);const H=await(0,h.$No)(U);if(!H&&U.res.statusCode===304)throw new y.$Qgb("Empty response",z,"EmptyResponse",U.res.statusCode,U.res.headers[y.$Mgb]);H&&(_={...JSON.parse(H),ref:X})}const K=this.s.get(n,-1);return K&&_&&K!==_.session&&this.C(),_===null&&K&&this.C(),_&&this.s.store(n,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$ig)(this.a,"download").toString(),T={},z=await this.D(F,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,h.$Ko)(z))throw new y.$Qgb("Server returned "+z.res.statusCode,F,"EmptyResponse",z.res.statusCode,z.res.headers[y.$Mgb]);if((0,h.$Lo)(z))throw new y.$Qgb("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[y.$Mgb]);return z.stream}z(F,T,z){return T?(0,f.$ig)(F,"collection",T,"resource",z):(0,f.$ig)(F,"resource",z)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(F,T,z,U){if(!this.b)throw new y.$Qgb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new y.$Qgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;T.headers={...T.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:F,type:T.type,headers:{...T.headers,authorization:void 0}});let K;try{K=await this.f.request(F,T,U)}catch(V){if(!(V instanceof y.$Qgb)){let W="RequestFailed";const ee=(0,A.$8)(V).toLowerCase();ee.includes("xhr timeout")?W="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?W="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":ee.includes("headers must be an object")?W="RequestHeadersNotObject":(0,A.$2)(V)&&(W="RequestCanceled"),V=new y.$Qgb(`Connection refused for the request '${F}'.`,F,W,void 0,void 0)}throw this.r.info("Request failed",F),V}const X=K.res.headers[y.$Mgb],H={url:F,status:K.res.statusCode,"execution-id":T.headers[y.$Ngb],"operation-id":X},x=(0,h.$Ko)(K)||K.res.statusCode&&z.includes(K.res.statusCode);let G="";if(x?this.r.trace("Request succeeded",H):(G=await(0,h.$Mo)(K)||"",this.r.info("Request failed",H,G)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new y.$Qgb(`${T.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",K.res.statusCode,X);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new y.$Qgb(`${T.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",K.res.statusCode,X)}if(this.h.fire(),K.res.statusCode===404)throw new y.$Qgb(`${T.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",K.res.statusCode,X);if(K.res.statusCode===405)throw new y.$Qgb(`${T.type} request '${F}' failed because the requested endpoint is not found (405). ${G}`,F,"MethodNotFound",K.res.statusCode,X);if(K.res.statusCode===409)throw new y.$Qgb(`${T.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",K.res.statusCode,X);if(K.res.statusCode===410)throw new y.$Qgb(`${T.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",K.res.statusCode,X);if(K.res.statusCode===412)throw new y.$Qgb(`${T.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",K.res.statusCode,X);if(K.res.statusCode===413)throw new y.$Qgb(`${T.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",K.res.statusCode,X);if(K.res.statusCode===426)throw new y.$Qgb(`${T.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",K.res.statusCode,X);if(K.res.statusCode===429){const V=K.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new y.$Qgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",K.res.statusCode,X)):new y.$Qgb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",K.res.statusCode,X)}if(!x)throw new y.$Qgb("Server returned "+K.res.statusCode,F,"Unknown",K.res.statusCode,X);return K}F(F){let T=this.s.get(s,-1);T===void 0&&(T=(0,b.$4f)(),this.s.store(s,T,-1,1)),F["X-Machine-Session-Id"]=T;const z=this.s.get(n,-1);z!==void 0&&(F["X-User-Session-Id"]=z)}};e.$eBb=m,e.$eBb=m=ye([Y(1,d.$kj),Y(2,h.$Io),Y(3,y.$Zgb),Y(4,g.$Ih),Y(5,w.$6j),Y(6,$.$Vo)],m);let u=class extends m{constructor(F,T,z,U,_,K,X){super(F.userDataSyncStore?.url,T,z,U,_,K,X),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$fBb=u,e.$fBb=u=ye([Y(0,y.$Jgb),Y(1,d.$kj),Y(2,h.$Io),Y(3,y.$Zgb),Y(4,g.$Ih),Y(5,w.$6j),Y(6,$.$Vo)],u);class v{constructor(F,T,z,U){this.c=F,this.d=T,this.f=z,this.g=U,this.a=[],this.b=void 0}request(F,T,z){if(this.h()&&this.i(),T.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new y.$Qgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(T,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$gBb=v}),define(oe[260],ae([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,O,N,A,L,D,I,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=void 0;let E=class extends I.$24b{constructor(l,g,w,d,h,o,$,y,C,t,c){super(l,g,w,d,h,$,y,C,t,c),this.B(O.Event.debounce(O.Event.any(O.Event.map(o.onDidFocusWindow,()=>"windowFocus"),O.Event.map(o.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$z8b=E,e.$z8b=E=ye([Y(0,A.$kj),Y(1,S.$Jgb),Y(2,S.$Kgb),Y(3,S.$Ugb),Y(4,S.$Vgb),Y(5,N.$n6b),Y(6,S.$Zgb),Y(7,f.$Rzb),Y(8,D.$9k),Y(9,P.$xgb),Y(10,L.$Vo)],E)}),define(oe[261],ae([0,1,69,23,6,21]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=e.$Y5b=e.$X5b=void 0,e.$X5b=128/4;function D(f){function P(){let E=f.scheme===N.Schemas.file?(0,L.$9f)(f):f.toString();return A.$k||(E=E.toLowerCase()),(0,O.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:f}}e.$Y5b=D;function I(f,P){function E(){if(f.scheme!==N.Schemas.file)return(0,O.createHash)("md5").update(f.toString()).digest("hex");if(!P)return;let l;return A.$k?l=P.ino:A.$j?l=P.birthtime.getTime():A.$i&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,O.createHash)("md5").update(f.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:f}}e.$Z5b=I;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$15b=S}),define(oe[262],ae([0,1,5,8,2,16,31,14,7,75,113,261,55,71,23]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;let w=class extends A.$kc{constructor(h,o,$,y){super(),this.a=h,this.b=o,this.c=$,this.f=y,this.B(new O.$Sg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,o=await D.Promises.readdir(h),$=new f.$qAb(this.f.getChannel("storage"));await Promise.all(o.map(async y=>{const C=(0,L.$9d)(h,y);y.length===E.$X5b||y===P.$Nh.id||(await this.c.getWindows()).some(n=>n.workspace?.id===y)||await $.isUsed(C)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${y} as it seems to be an unused empty workspace.`),await D.Promises.rm(C))}))}catch(h){(0,N.$Y)(h)}}};e.$67b=w,e.$67b=w=ye([Y(0,I.$Jh),Y(1,S.$5i),Y(2,b.$n6b),Y(3,l.$E7b)],w)}),define(oe[82],ae([0,1,52,5,16,12,31,148,273,274]),function(te,e,O,N,A,L,D,I,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.zip=e.$bp=e.$ap=void 0,e.$ap="end of central directory record signature not found";const P=new RegExp(e.$ap);class E extends Error{constructor(c,n){let s=n.message;switch(c){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=c,this.cause=n}}e.$bp=E;function b(t){const c=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>c&n).reduce((n,s)=>n+s,c&61440)}function l(t){if(t instanceof E)return t;let c;return P.test(t.message)&&(c="CorruptZip"),new E(c,t)}function g(t,c,n,s,i,r){const a=A.$_d(c),p=A.$9d(s,a);if(!p.startsWith(s))return Promise.reject(new Error(I.localize(0,null,c)));const m=A.$9d(s,c);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(D.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((v,j)=>{if(!r.isCancellationRequested)try{u=(0,O.createWriteStream)(m,{mode:n}),u.once("close",()=>v()),u.once("error",j),t.once("error",j),t.pipe(u)}catch(F){j(F)}}))}function w(t,c,n,s){let i=(0,N.$ug)(()=>Promise.resolve()),r=0;const a=s.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((p,m)=>{const u=new N.$Bg,v=j=>{j.isCancellationRequested||(r++,t.readEntry())};t.once("error",m),t.once("close",()=>i.then(()=>{s.isCancellationRequested||t.entryCount===r?p():m(new E("Incomplete",new Error(I.localize(1,null,r,t.entryCount))))},m)),t.readEntry(),t.on("entry",j=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){v(s);return}const F=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const U=A.$9d(c,F);i=(0,N.$ug)(_=>D.Promises.mkdir(U,{recursive:!0}).then(()=>v(_)).then(void 0,m));return}const T=h(t,j),z=b(j);i=(0,N.$ug)(U=>u.queue(()=>T.then(_=>g(_,F,z,c,n,U).then(()=>v(U)))).then(null,m))})}).finally(()=>a.dispose())}function d(t,c=!1){return new Promise((n,s)=>{(0,S.open)(t,c?{lazyEntries:!0}:void 0,(i,r)=>{i?s(l(i)):n((0,L.$uf)(r))})})}function h(t,c){return new Promise((n,s)=>{t.openReadStream(c,(i,r)=>{i?s(l(i)):n((0,L.$uf)(r))})})}function o(t,c){return new Promise((n,s)=>{const i=new f.ZipFile;c.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,O.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(t))})}e.zip=o;function $(t,c,n={},s){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=d(t,!0);return n.overwrite&&(r=r.then(a=>D.Promises.rm(c).then(()=>a))),r.then(a=>w(a,c,{sourcePathRegex:i},s))}e.$dp=$;function y(t,c){return d(t).then(n=>new Promise((s,i)=>{n.on("entry",r=>{r.fileName===c&&h(n,r).then(a=>s(a),a=>i(a))}),n.once("close",()=>i(new Error(I.localize(2,null,c))))}))}function C(t,c){return y(t,c).then(n=>new Promise((s,i)=>{const r=[];n.once("error",i),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.$ep=C}),define(oe[263],ae([0,1,5,8,2,23,21,53,12,32,31,82,19,14,29,33,97,11,7]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;let y=class extends A.$kc{static{$=this}static{this.c=".sigzip"}constructor(t,c,n,s,i,r){super(),this.h=c,this.j=n,this.m=s,this.n=i,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,c,n){await this.g;const s=(0,D.$ig)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,r=>this.j.download(t,r,c))}catch(r){throw new g.$1n(r.message,g.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const r=await this.u(t);try{i=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===o.LogLevel.Trace)}catch(a){const p=a;if(i=p.code,p.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${p.output}`),i===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$1n(E.$ap,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return!1;const c=this.m.getValue("extensions.verifySignature");return(0,S.$pf)(c)?c:!0}async u(t){await this.g;const c=(0,D.$ig)(this.extensionsDownloadDir,`${this.z(t)}${$.c}`);return await this.w(t,c,n=>this.j.downloadSignatureArchive(t,n)),c}async w(t,c,n){if(await this.h.exists(c))return;if(c.scheme!==L.Schemas.file){await n(c);return}const s=(0,D.$ig)(this.extensionsDownloadDir,`.${(0,f.$4f)()}`);await this.h.exists(s)||await n(s);try{await P.Promises.rename(s.fsPath,c.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,c.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const c=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith($.c))s.push(a.resource);else{const p=w.$qo.parse(a.name);p&&n.push([p,a])}const i=(0,w.$vo)(n,([a])=>a),r=[];for(const a of i)a.sort((p,m)=>I.rcompare(p[0].version,m[0].version)),c.push(...a.slice(1).map(p=>p[1].resource)),r.push(a[0][1]);r.sort((a,p)=>a.mtime-p.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),c.push(...s),await O.Promises.settled(c.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$qo.create(t).toString().toLowerCase():(0,f.$4f)()}};e.$tp=y,e.$tp=y=$=ye([Y(0,l.$Jh),Y(1,h.$6j),Y(2,g.$Zn),Y(3,b.$8h),Y(4,d.$7o),Y(5,o.$5i)],y)}),define(oe[264],ae([0,1,82,157]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function A(L){return(0,O.$ep)(L,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$vp=A}),define(oe[122],ae([0,1,5,15,26,38,8,3,51,2,35,23,16,21,53,12,10,32,31,82,156,96,14,243,29,33,50,79,263,244,264,212,223,67,11,4,7,24,22,28,17]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c,n,s,i,r,a,p,m,u,v,j,F,T,z,U,_,K,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$yp=(0,T.$Ch)(n.$2n);const H=".vsctmp";let x=class extends c.$fp{constructor(Q,q,k,R,B,M,J,Z,se,le,ue,he){super(Q,q,ue,k,le,he),this.fb=B,this.gb=M,this.hb=J,this.ib=se,this.eb=new Map,this.rb=new P.$Ai;const $e=this.B(Z.createInstance(p.$up));this.bb=this.B(Z.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new u.$wp(he,se,ue,this,this.F)),this.db=this.B(Z.createInstance(a.$tp));const de=this.B(new v.$xp(this,this.fb,he,M,ue,se,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Ao)(this.ib,this.F)),this.jb}async zip(Q){this.F.trace("ExtensionManagementService#zip",Q.identifier.id);const q=await this.pb(Q),k=await(0,$.zip)((0,l.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)()).fsPath,q);return d.URI.file(k)}async unzip(Q){return this.F.trace("ExtensionManagementService#unzip",Q.toString()),(await this.install(Q)).identifier}async getManifest(Q){const{location:q,cleanup:k}=await this.lb(Q),R=b.$0d(q.fsPath);try{return await(0,m.$vp)(R)}finally{await k()}}getInstalled(Q,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Q??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.bb.scanUserExtensionAtLocation(Q)}async install(Q,q={}){this.F.trace("ExtensionManagementService#install",Q.toString());const{location:k,cleanup:R}=await this.lb(Q);try{const B=await(0,m.$vp)(b.$0d(k.fsPath)),M=(0,s.$uo)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,j.$Ho)(B.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,M,this.G.version));const Z=(await this.I([{manifest:B,extension:k,options:q}])).find(({identifier:se})=>(0,s.$po)(se,{id:M}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,c.$hp)(new Error(`Unknown error while installing extension ${M}`))}finally{await R()}}async installFromLocation(Q,q){this.F.trace("ExtensionManagementService#installFromLocation",Q.toString());const k=await this.bb.scanUserExtensionAtLocation(Q);if(!k)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.ub([[k,void 0]],q),this.F.info("Successfully installed extension",k.identifier.id,q.toString()),k}async installExtensionsFromProfile(Q,q,k){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Q,q.toString(),k.toString());const R=(await this.bb.scanExtensions(1,q)).filter(B=>Q.some(M=>(0,s.$po)(M,B.identifier)));if(R.length){const B=await Promise.all(R.map(M=>this.bb.scanMetadata(M,q)));await this.ub(R.map((M,J)=>[M,B[J]]),k),this.F.info("Successfully installed extensions",R.map(M=>M.identifier.id),k.toString())}return R}async updateMetadata(Q,q,k=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.pinned=q.pinned||void 0,Q=await this.bb.updateMetadata(Q,q,k),this.cb.invalidate(k),this.w.fire(Q),Q}async reinstallFromGallery(Q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const q=await this.getTargetPlatform(),[k]=await this.z.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:q,compatible:!0},A.CancellationToken.None);if(!k)throw new Error(y.localize(2,null));await this.bb.setUninstalled(Q);try{await this.bb.removeUninstalledExtension(Q)}catch(R){throw new Error(y.localize(3,null,(0,L.$mi)(R)))}return this.installFromGallery(k)}ab(Q,q,k,R){return this.bb.copyExtension(Q,q,k,R)}copyExtensions(Q,q){return this.bb.copyExtensions(Q,q)}markAsUninstalled(...Q){return this.bb.setUninstalled(...Q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Q){this.F.error(Q)}}async download(Q,q,k){const{location:R}=await this.db.download(Q,q,!k);return R}async lb(Q){if(Q.scheme===E.Schemas.file)return{location:Q,async cleanup(){}};this.F.trace("Downloading extension from",Q.toString());const q=(0,l.$ig)(this.db.extensionsDownloadDir,(0,h.$4f)());return await this.hb.download(Q,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(R){this.F.error(R)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Q,q,k){if(d.URI.isUri(q))return new ee(Q,q,k,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const R=s.$qo.create(q).toString();let B=this.eb.get(R);return B||(this.eb.set(R,B=new W(Q,q,k,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(R))),B}$(Q,q){return new ne(Q,q.profileLocation,this.gb)}async pb(Q){const q=async R=>{let B=await o.Promises.readdir(R);B=B.map(Z=>b.$9d(R,Z));const M=await Promise.all(B.map(Z=>o.Promises.stat(Z)));let J=Promise.resolve([]);return M.forEach((Z,se)=>{const le=B[se];Z.isFile()&&(J=J.then(ue=>[...ue,le])),Z.isDirectory()&&(J=J.then(ue=>q(le).then(he=>[...ue,...he])))}),J};return(await q(Q.location.fsPath)).map(R=>({path:`extension/${b.$$d(Q.location.fsPath,R)}`,localPath:R}))}async qb({added:Q,removed:q}){if(q)for(const k of q.extensions)this.F.info("Extensions removed from another source",k.id,q.profileLocation.toString()),this.u.fire({identifier:k,profileLocation:q.profileLocation});if(Q){const R=(await this.bb.scanExtensions(1,Q.profileLocation)).filter(B=>Q.extensions.some(M=>(0,s.$po)(M,B.identifier)));this.s.fire(R.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,Q.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:Q.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Q=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Q.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Q){if(!Q.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const k of Q.rawAdded){if(this.rb.has(k)||!this.D.extUri.isEqual(this.D.extUri.dirname(k),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(k,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(k).startsWith(".")||!(await this.ib.stat(k)).isDirectory)continue;const R=await this.bb.scanUserExtensionAtLocation(k);R&&R.installedTimestamp===void 0&&(this.rb.add(k),q.push(R))}q.length&&(await this.ub(q.map(k=>[k,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(k=>k.identifier.id)))}async ub(Q,q){const k=Q.map(R=>R[0]);await this.vb(k),await this.gb.addExtensionsToProfile(Q,q),this.s.fire(k.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:q})))}async vb(Q){const q=await this.bb.getUninstalledExtensions();for(const k of Q){const R=s.$qo.create(k);q[R.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",R.id),await this.bb.setInstalled(R),this.F.info("Removed the extension from uninstalled list:",R.id))}}};e.$zp=x,e.$zp=x=ye([Y(0,n.$Zn),Y(1,_.$9k),Y(2,z.$5i),Y(3,t.$Jh),Y(4,r.$op),Y(5,i.$kp),Y(6,C.$Dn),Y(7,T.$Ah),Y(8,F.$6j),Y(9,U.$kj),Y(10,K.$Ck),Y(11,X.$Ek)],x);let G=class extends f.$kc{constructor(Q,q,k,R,B,M){super(),this.j=Q,this.m=q,this.n=k,this.s=R,this.t=B,this.u=M,this.h=this.B(new I.$fd),this.onExtract=this.h.event,this.c=(0,l.$ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Ng}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Q,q){const k={includeInvalid:!0,profileLocation:q};let R=[];return Q===null||Q===0?R.push(...await this.n.scanAllExtensions({includeInvalid:!0},k,!1)):Q===1&&R.push(...await this.n.scanUserExtensions(k)),R=Q!==null?R.filter(B=>B.type===Q):R,Promise.all(R.map(B=>this.F(B)))}async scanAllUserExtensions(Q){const q=await this.n.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return Promise.all(q.map(k=>this.F(k)))}async scanUserExtensionAtLocation(Q){try{const q=await this.n.scanExistingExtension(Q,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Q,q,k,R,B){const M=Q.toString(),J=d.URI.file(b.$9d(this.n.userExtensionsLocation.fsPath,`.${(0,h.$4f)()}`)),Z=d.URI.file(b.$9d(this.n.userExtensionsLocation.fsPath,M));let se=await this.m.exists(Z);if(se&&R){try{await this.y(Q.id,Z,"removeExisting")}catch{throw new n.$1n(y.localize(4,null,Z.fsPath,Q.id),n.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.u.trace(`Started extracting the extension from ${q} to ${Z.fsPath}`),await(0,$.$dp)(q,J.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${Z}:`,Q.id)}catch(le){let ue=n.ExtensionManagementErrorCode.Extract;throw le instanceof $.$bp&&(le.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$1n(le.message,ue)}await this.n.updateMetadata(J,k);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${Z.fsPath}`),await this.C(J.fsPath,Z.fsPath),this.u.info("Renamed to",Z.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);else throw this.u.info(`Rename failed because of ${(0,D.$8)(le)}. Deleted from extracted location`,J),le}this.h.fire(Z)}catch(le){try{await this.m.del(J,{recursive:!0})}catch{}throw le}return this.D(Z,1)}async scanMetadata(Q,q){return q?(await this.w(Q,q))?.metadata:this.n.scanMetadata(Q.location)}async w(Q,q){return(await this.s.scanProfileExtensions(q)).find(R=>(0,s.$po)(R.identifier,Q.identifier))}async updateMetadata(Q,q,k){return k?await this.s.updateMetadata([[Q,q]],k):await this.n.updateMetadata(Q.location,q),this.D(Q.location,Q.type,k)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Q){const q=Q.map(k=>s.$qo.create(k));await this.z(k=>q.forEach(R=>{k[R.toString()]=!0,this.u.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(Q){await this.z(q=>delete q[Q.toString()])}async removeExtension(Q,q){if(this.t.extUri.isEqualOrParent(Q.location,this.n.userExtensionsLocation))return this.y(Q.identifier.id,Q.location,q)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.z(q=>delete q[s.$qo.create(Q).toString()])}async copyExtension(Q,q,k,R){const B=await this.w(Q,q),M=await this.w(Q,k);return R={...B?.metadata,...R},M?await this.s.updateMetadata([[Q,{...M.metadata,...R}]],k):await this.s.addExtensionsToProfile([[Q,R]],k),this.D(Q.location,Q.type,k)}async copyExtensions(Q,q){const k=await this.scanExtensions(1,Q),R=await Promise.all(k.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,Q)]));await this.s.addExtensionsToProfile(R,q)}async y(Q,q,k){this.u.trace(`Deleting ${k} extension from disk`,Q,q.fsPath);const R=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$pi)((0,h.$4f)()).toString(16)}${H}`);await this.C(q.fsPath,R.fsPath),await this.m.del(R,{recursive:!0}),this.u.info(`Deleted ${k} extension from disk`,Q,q.fsPath)}async z(Q){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,F.$jk)(R)!==1)throw R}let k={};if(q)try{k=JSON.parse(q)}catch{}return Q&&(Q(k),Object.keys(k).length?await this.m.writeFile(this.c,N.$Fd.fromString(JSON.stringify(k))):await this.m.del(this.c)),k})}async C(Q,q){try{await o.Promises.rename(Q,q,2*60*1e3)}catch(k){throw new n.$1n(k.message||y.localize(5,null,Q,q),k.code||n.ExtensionManagementErrorCode.Rename)}}async D(Q,q,k){if(k){const B=(await this.n.scanUserExtensions({profileLocation:k})).find(M=>this.t.extUri.isEqual(M.location,Q));if(B)return this.F(B)}else{const R=await this.n.scanExistingExtension(Q,q,{includeInvalid:!0});if(R)return this.F(R)}throw new Error(y.localize(6,null,Q.path))}async F(Q){const q=await this.m.resolve(Q.location);let k,R;return q.children&&(k=q.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,R=q.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:k,changelogUrl:R,publisherDisplayName:Q.metadata?.publisherDisplayName||null,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned}}async G(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Q));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const B of q)Q[s.$qo.create(B).toString()]||k.add(B.identifier.id.toLowerCase());try{const B=(0,s.$vo)(q,M=>M.identifier);await O.Promises.settled(B.map(async M=>{const J=M.sort((Z,se)=>g.rcompare(Z.manifest.version,se.manifest.version))[0];k.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(B){this.u.error(B)}const R=q.filter(B=>B.metadata&&Q[s.$qo.create(B).toString()]);await Promise.allSettled(R.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Q;try{Q=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,F.$jk)(q)!==1&&this.u.error(q);return}if(Q?.children)try{await Promise.allSettled(Q.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(k){(0,F.$jk)(k)!==1&&this.u.error(k)}}}))}catch{}}};e.$Ap=G,e.$Ap=G=ye([Y(1,F.$6j),Y(2,r.$op),Y(3,i.$kp),Y(4,K.$Ck),Y(5,z.$5i)],G);class V extends c.$ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$qf)(this.options.operation)?this.l:this.options.operation}constructor(Q,q,k,R,B,M,J,Z,se){super(),this.identifier=Q,this.source=q,this.options=k,this.m=R,this.n=B,this.o=M,this.p=J,this.q=Z,this.s=se,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Q){const[q,k]=await this.x(Q);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,k]],this.j),q}async u({zipPath:Q,key:q,metadata:k},R,B){let M=await this.v(q);return M||(this.s.trace("Extracting extension...",q.id),M=await this.m.extractUserExtension(q,Q,k,R,B),this.s.info("Extracting extension completed.",q.id)),M}async v(Q){return await this.w(Q)?(this.s.trace("Removing the extension from uninstalled list:",Q.id),await this.m.setInstalled(Q),this.s.info("Removed the extension from uninstalled list:",Q.id),(await this.m.scanAllUserExtensions(!0)).find(R=>s.$qo.create(R).equals(Q))):void 0}async w(Q){return!!(await this.m.getUninstalledExtensions())[Q.toString()]}}class W extends V{constructor(Q,q,k,R,B,M,J,Z,se,le){super(q.identifier,q,k,B,M,J,Z,se,le),this.y=q,this.z=R}async x(Q){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(J=>(0,s.$po)(J.identifier,this.y.identifier));k&&(this.l=3);const R={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$pf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,R),R];const{location:B,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$qo.create(this.y),metadata:R},!1,Q),R]}catch(J){try{await this.z.delete(B)}catch(Z){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,D.$8)(Z))}throw J}}async B(Q){try{await(0,m.$vp)(Q)}catch(q){throw new n.$1n((0,c.$gp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Bp=W;class ee extends V{constructor(Q,q,k,R,B,M,J,Z,se,le){super({id:(0,s.$uo)(Q.publisher,Q.name)},q,k,B,M,J,Z,se,le),this.y=Q,this.z=q,this.A=R}async h(Q){const q=await super.h(Q);return this.D(q,Q),q}async x(Q){const q=new s.$qo(this.identifier,this.y.version),R=(await this.m.scanExtensions(1,this.options.profileLocation)).find(J=>(0,s.$po)(this.identifier,J.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this.l=3,q.equals(new s.$qo(R.identifier,R.manifest.version)))try{await this.m.removeExtension(R,"existing")}catch{throw new Error(y.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(R.manifest.version,this.y.version)&&await this.m.setUninstalled(R);else{const J=await this.v(q);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(y.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$0d(this.z.fsPath),key:q,metadata:B},!0,Q),B]}async D(Q,q){try{let[k]=await this.A.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],q);if(k||([k]=await this.A.getExtensions([{id:Q.identifier.id}],q)),k){const R={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Q,R,this.options.profileLocation)}}catch{}}}class ne extends c.$ip{constructor(Q,q,k){super(),this.extension=Q,this.j=q,this.k=k}async h(Q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,80,222,122,7,20]),function(te,e,O,N,A,L,D,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;let f=class extends O.$kc{constructor(E,b,l,g,w,d){super(),E.cleanUp(),(0,L.$nVb)(E,b,l,g,d),A.$Ou.removeOutdatedExtensionVersions(E,w)}};e.$t8b=f,e.$t8b=f=ye([Y(0,D.$yp),Y(1,N.$Zn),Y(2,A.$Nu),Y(3,N.$5n),Y(4,S.$Vo),Y(5,I.$5i)],f)}),define(oe[123],ae([0,1,69,61,36,275,15,8,3,2,16,6,32,42,65]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class w{traceSocketEvent(u,v){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,v)}constructor(u,v=""){this.f=!0,this.debugLabel=v,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const v=j=>{this.traceSocketEvent("read",j),u(D.$Fd.wrap(j))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(u){const v=j=>{u({type:0,hadError:j,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(u){const v=()=>{u()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,I.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,I.$Y)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$qh=w;var d;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var h;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(h||(h={}));class o extends f.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,v){this.socket.traceSocketEvent(u,v)}constructor(u,v,j,F){super(),this.f=this.B(new S.$fd),this.g=this.B(new S.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new $(this,v,j,F,this.f,(T,z)=>this.m(T,z))),this.B(this.a.onError(T=>{console.error(T),(0,I.$Y)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new g.$lh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let v=0;for(;v<u.byteLength;)this.a.writeMessage(u.slice(v,Math.min(v+262144,u.byteLength))),v+=262144}m(u,v){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let j=2;u.byteLength<126?j+=0:u.byteLength<2**16?j+=2:j+=8;const F=D.$Fd.alloc(j);if(v?F.writeUInt8(194,0):F.writeUInt8(130,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let T=1;F.writeUInt8(u.byteLength>>>8&255,++T),F.writeUInt8(u.byteLength>>>0&255,++T)}else{F.writeUInt8(127,1);let T=1;F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(0,++T),F.writeUInt8(u.byteLength>>>24&255,++T),F.writeUInt8(u.byteLength>>>16&255,++T),F.writeUInt8(u.byteLength>>>8&255,++T),F.writeUInt8(u.byteLength>>>0&255,++T)}this.socket.write(D.$Fd.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),j=v.readUInt8(0),F=(j&128)>>>7,T=(j&64)>>>6,z=v.readUInt8(1),U=(z&128)>>>7,_=z&127;this.j.state=2,this.j.readLen=2+(U?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),j=v.readUInt8(1),F=(j&128)>>>7;let T=j&127,z=1;T===126?T=v.readUInt8(++z)*2**8+v.readUInt8(++z):T===127&&(T=v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*2**24+v.readUInt8(++z)*2**16+v.readUInt8(++z)*2**8+v.readUInt8(++z));let U=0;F&&(U=v.readUInt8(++z)*2**24+v.readUInt8(++z)*2**16+v.readUInt8(++z)*2**8+v.readUInt8(++z)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(v,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=o;class $ extends f.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Fd.alloc(0)}constructor(u,v,j,F,T,z){super(),this.n=u,this.r=T,this.s=z,this.a=this.B(new S.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new y(this.n,F,j,{windowBits:15})),this.f=this.B(new C(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(u){this.g.push(u),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const u=this.g.shift();if(this.f){const v=await this.w(this.f,u);this.s(v,!0)}else this.s(u,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,v){return new Promise((j,F)=>{u.write(v),u.flush(T=>j(T))})}acceptFrame(u,v,j){this.h.push({data:u,isCompressed:v,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const v=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,v,j){return new Promise((F,T)=>{u.write(v),j&&u.write(D.$Fd.fromByteArray([0,0,255,255])),u.flush(z=>F(z))})}}class y extends f.$kc{get recordedInflateBytes(){return this.j?D.$Fd.concat(this.f):D.$Fd.alloc(0)}constructor(u,v,j,F){super(),this.h=u,this.j=v,this.a=this.B(new S.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(F),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(D.$Fd.wrap(T))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=D.$Fd.concat(this.g);this.g.length=0,u(v)})}}class C extends f.$kc{constructor(u,v){super(),this.g=u,this.a=this.B(new S.$fd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$Fd.wrap(j))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=D.$Fd.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),u(v)})}}function t(m,u){if(u===0)return;const v=m.byteLength>>>2;for(let _=0;_<v;_++){const K=m.readUInt32BE(_*4);m.writeUInt32BE(K^u,_*4)}const j=v*4,F=m.byteLength-j,T=u>>>24&255,z=u>>>16&255,U=u>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(j)^T,j),F>=2&&m.writeUInt8(m.readUInt8(j+1)^z,j+1),F>=3&&m.writeUInt8(m.readUInt8(j+2)^U,j+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function n(){const m=(0,b.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const u=process.platform!=="darwin"&&e.$sh?e.$sh:(0,A.tmpdir)(),v=(0,P.$9d)(u,`vscode-ipc-${m}.sock`);return i(v),v}e.$th=n;function s(m,u,v){const j=(0,O.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${v}-${u}-sock`;const F=v.substr(0,4),T=u.substr(0,6),z=j.substr(0,8);let U;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?U=(0,P.$9d)(e.$sh,`vscode-${z}-${F}-${T}.sock`):U=(0,P.$9d)(m,`${F}-${T}.sock`),i(U),U}e.$uh=s;function i(m){const u=c[E.$t];typeof u=="number"&&m.length>=u&&console.warn(`WARNING: IPC handle "${m}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$fh{static b(u){const v=S.Event.fromNodeEventEmitter(u,"connection");return S.Event.map(v,j=>({protocol:new g.$mh(new w(j,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(j,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=r;function a(m){return new Promise((u,v)=>{const j=(0,N.createServer)();j.on("error",v),j.listen(m,()=>{j.removeListener("error",v),u(new r(j))})})}e.$wh=a;function p(m,u){return new Promise((v,j)=>{const F=(0,N.createConnection)(m,()=>{F.removeListener("error",j),v(g.$nh.fromSocket(new w(F,`ipc-client${u}`),u))});F.once("error",j)})}e.$xh=p}),define(oe[266],ae([0,1,61,123,210]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8b=void 0,e.$C8b=new class{supports(L){return!0}connect({host:L,port:D},I,S,f){return new Promise((P,E)=>{const b=O.createConnection({host:L,port:D},()=>{b.removeListener("error",E),b.write((0,A.$Ekb)(I,S,f));const l=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),P(new N.$qh(b,f)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(oe[267],ae([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,15]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=e.$w7b=e.$v7b=void 0;async function h(t,c,n,s,i){let r;for(let a=3;a&&(r?.dispose(),r=await new o(t,c,n,s,i).waitForReady(),!(i&&A.$7f[i]||!A.$7f[r.tunnelLocalPort]));a--);return r}class o extends I.$kc{constructor(c,n,s,i,r){super(),this.m=n,this.n=r,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=O.createServer(),this.c=new D.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,n=(0,w.$7u)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,A.$8f)(c,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(c){c.pause();const n=(0,w.$5u)(this.tunnelRemoteHost)||(0,w.$7u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,b.$Zk)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),i instanceof L.$qh?i.socket.destroy():i.end()}),i instanceof L.$qh?this.t(c,i):this.s(c,i),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),i.end()})}s(c,n){n.onClose(()=>c.destroy()),n.onEnd(()=>c.end()),n.onData(s=>c.write(s.buffer)),c.on("data",s=>n.write(d.$Fd.wrap(s))),c.resume()}t(c,n){const s=n.socket;s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),s.pipe(c),c.pipe(s)}}e.$v7b=o;let $=class extends w.$0u{constructor(c,n,s,i,r){super(n,r),this.u=c,this.v=s,this.w=i}isPortPrivileged(c){return(0,w.$8u)(c,this.l,S.OS,N.release())}s(c,n,s,i,r,a,p,m){const u=this.r(n,s);if(u)return++u.refcount,u.value;if((0,w.$2u)(c))return this.t(c,n,s,r,a,p,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=h(v,i,n,s,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,s,j),j}}};e.$w7b=$,e.$w7b=$=ye([Y(0,l.$Tk),Y(1,P.$5i),Y(2,g.$Wk),Y(3,E.$kj),Y(4,f.$8h)],$);let y=class extends ${constructor(c,n,s,i,r){super(c,n,s,i,r)}};e.$x7b=y,e.$x7b=y=ye([Y(0,l.$Tk),Y(1,P.$5i),Y(2,g.$Wk),Y(3,E.$kj),Y(4,f.$8h)],y);let C=class extends I.$kc{constructor(c,n,s,i,r){super(),this.b=c,this.c=n,this.f=s,this.g=i,this.h=r,this.a=new Map}async openTunnel(c,n,s,i,r,a,p,m,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(c)){const v=new y(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(c,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(n,s,i,r,a,p,m,u)}};e.$y7b=C,e.$y7b=C=ye([Y(0,l.$Tk),Y(1,P.$5i),Y(2,E.$kj),Y(3,g.$Wk),Y(4,f.$8h)],C)}),define(oe[276],ae([0,1,36,38,8,2,23,10,18,3,42,147,204,205,196,197,262,187,189,19,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,45,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,9,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,O,N,A,L,D,I,S,f,P,E,b,l,g,w,d,h,o,$,y,C,t,c,n,s,i,r,a,p,m,u,v,j,F,T,z,U,_,K,X,H,x,G,V,W,ee,ne,re,Q,q,k,R,B,M,J,Z,se,le,ue,he,$e,de,we,ve,Ie,Le,Te,ce,ge,be,Se,Pe,ze,De,Be,Me,ie,fe,me,pe,ke,Re,Ce,Oe,je,Ae,Ne,qe,Ue,Ve,xe,ut,vt,Et,kt,St,ft,Ct,Pt,Rt,It,Ot,Dt,jt,dt,At,gt,Lt,Nt,$t,Ft,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Mt extends L.$kc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$aT(this)),this.b=void 0,this.c=this.B(new f.$fd),this.g()}g(){let Ee=!1;const Fe=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,E.$bT)(process.parentPort,tt.$M6b.exit,Fe)}async init(){const Ee=await this.h();(0,se.$Egb)(),Ee.invokeFunction(Fe=>{const Ke=Fe.get(x.$5i);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke)}),this.B((0,L.$hc)(Ee.createInstance(b.$27b,this.f.codeCachePath),Ee.createInstance(l.$37b),Ee.createInstance(d.$67b),Ee.createInstance(w.$57b),Ee.createInstance(g.$47b),Ee.createInstance(Et.$t8b),Ee.createInstance(xe.$l8b),Ee.createInstance(Ft.$F8b,this.c.event)))}async h(){const Ee=new K.$zh,Fe={_serviceBrand:void 0,...V.default};Ee.set(W.$kj,Fe);const Ke=new P.$jh(We=>We==="main"),He=new dt.$F7b(this.a,Ke);Ee.set(dt.$E7b,He);const nt=this.f.policiesData?new Ne.$e7b(this.f.policiesData,He.getChannel("policy")):new qe.$_m;Ee.set(qe.$0m,nt);const Ge=new Nt.$_l(this.f.args,Fe);Ee.set(s.$Jh,Ge);const Xe=new G.$1q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(We=>({...We,resource:I.URI.revive(We.resource)})),He.getChannel("logger"));Ee.set(x.$6i,Xe);const st=this.B(Xe.createLogger("sharedprocess",{name:(0,kt.localize)(0,null)})),ct=this.B(new x.$aj(st.getLevel())),Je=this.B(new St.$rN(st,[ct]));Ee.set(x.$5i,Je),this.b=this.B(new ft.$v8b(Je)),Ee.set(ft.$u8b,this.b);const Ze=this.B(new F.$Dp(Je));Ee.set(j.$6j,Ze);const lt=this.B(new T.$3p(Je));Ze.registerProvider(D.Schemas.file,lt);const rt=new ie.$pr(Ze);Ee.set(Me.$Ck,rt);const Qe=this.B(new Ue.$yN(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Ee.set(je.$Ek,Qe);const ht=this.B(new me.$D7b(D.Schemas.file,this.B(new pe.$aN(He.getChannel(pe.$_M),{pathCaseSensitive:fe.$k})),D.Schemas.vscodeUserData,Qe,rt,Je));Ze.registerProvider(D.Schemas.vscodeUserData,ht);const Ye=this.B(new y.$zn(Qe.defaultProfile.settingsResource,Ze,nt,Je));Ee.set($.$8h,Ye);const _e=new At.$B8b(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},He,Ge);Ee.set(ne.$Vo,_e),this.B((0,L.$ic)(()=>_e.flush())),await Promise.all([Ye.initialize(),_e.initialize()]);const bt=new Rt.$Mq(He.getChannel("request"));Ee.set(ee.$Io,bt),Ee.set(h.$77b,new z.$yh(o.$87b,void 0,!1)),Ee.set(Re.$JE,new z.$yh(ke.$k8b,void 0,!1));const wt=P.ProxyChannel.toService(He.getChannel("nativeHost"));Ee.set(Ot.$n6b,wt),Ee.set(c.$Dn,new z.$yh(n.$GN,void 0,!0));const Tt=this.B(new ge.$b7b(wt)),zt=new P.$jh(We=>Tt.getActiveClientId().then(at=>We===at));Ee.set(v.$0Ub,new It.$x8b(this.a.getChannel("extensionRecommendationNotification",zt)));let ot;const et=[],yt=(0,B.$mo)(Fe,Ye);if((0,B.$ho)(Fe,Ge)){const We=new k.$h4b(Je,Xe,Ge,Fe);if(et.push(We),Fe.aiConfig?.ariaKey){const at=new Ve.$fN(bt,yt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,L.$ic)(()=>at.flush())),et.push(at)}ot=new R.$Qq({appenders:et,commonProperties:(0,re.$0n)((0,O.release)(),(0,O.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,B.$no)(Ge)},Ye,Fe)}else{ot=B.$bo;const We=B.$fo;et.push(We)}this.a.registerChannel("telemetryAppender",new q.$R6b(et)),Ee.set(Q.$9k,ot);const Bt=new M.$97b(Ye,ot,Je,Xe,Ge,Fe);Ee.set(Q.$0k,Bt),Ee.set(Ae.$kp,new z.$yh(Pt.$qN,void 0,!0)),Ee.set(Ce.$op,new z.$yh(Oe.$f7b,void 0,!0)),Ee.set(p.$7o,new z.$yh(p.$8o,void 0,!0)),Ee.set(u.$yp,new z.$yh(u.$zp,void 0,!0)),Ee.set(a.$Zn,new z.$yh(r.$5o,void 0,!0)),Ee.set(a.$6n,new z.$yh(jt.$A8b,void 0,!1)),Ee.set(X.$Iq,new z.$yh(H.$Kq,void 0,!1)),Ee.set(C.$gm,new z.$yh(t.$wr,void 0,!1)),Ee.set(le.$Rzb,new z.$yh(le.$Szb,void 0,!0)),Ee.set(se.$Zgb,new z.$yh($e.$7Bb,void 0,!0)),Ee.set(se.$Ygb,new he.$_7b(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),Ee.set(a.$5n,new z.$yh(i.$Pzb,void 0,!1)),Ee.set(Z.$5Bb,new z.$yh(Z.$6Bb,void 0,!0)),Ee.set(J.$Nu,new z.$yh(J.$Ou)),Ee.set(se.$Jgb,new z.$yh(Le.$dBb,void 0,!0)),Ee.set(se.$Kgb,new z.$yh(Le.$fBb,void 0,!0)),Ee.set(de.$xgb,new z.$yh(de.$zgb,void 0,!0)),Ee.set(se.$Lgb,new z.$yh(ue.$V4b,void 0,!1)),Ee.set(se.$Ugb,new z.$yh(we.$K4b,void 0,!0)),Ee.set(se.$Vgb,new z.$yh(ve.$14b,void 0,!1)),Ee.set(Te.$rAb,new z.$yh(ce.$g8b,void 0,!0)),Ee.set(se.$Wgb,new z.$yh(vt.$A5b,void 0,!0)),Ee.set(be.$Wk,new z.$yh(Se.$A7b,void 0,!1));const pt=new gt.$Uk;return Ee.set(gt.$Tk,pt),pt.register(0,Lt.$C8b),Ee.set(Pe.$1u,new z.$yh(ze.$y7b)),Ee.set(De.$h8b,new z.$yh(Be.$j8b)),Ee.set(ut.$m8b,new z.$yh(Ct.$w8b)),Ee.set($t.$D8b,new z.$yh($t.$E8b)),new _.$6p(Ee)}j(Ee){const Fe=this.B(new L.$jc),Ke=new m.$0o(Ee.get(a.$2n),()=>null);this.a.registerChannel("extensions",Ke);const He=P.ProxyChannel.fromService(Ee.get(X.$Iq),Fe);this.a.registerChannel("languagePacks",He);const nt=P.ProxyChannel.fromService(Ee.get(C.$gm),Fe);this.a.registerChannel("diagnostics",nt);const Ge=new m.$_o(Ee.get(a.$6n));this.a.registerChannel("extensionTipsService",Ge);const Xe=P.ProxyChannel.fromService(Ee.get(h.$77b),Fe);this.a.registerChannel("checksum",Xe);const st=P.ProxyChannel.fromService(Ee.get(Re.$JE),Fe);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$a8b(Ee.get(de.$xgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(Ee.get(Q.$0k),Fe);this.a.registerChannel("customEndpointTelemetry",Je);const Ze=new he.$b8b(Ee.get(le.$Rzb));this.a.registerChannel("userDataSyncAccount",Ze);const lt=new he.$c8b(Ee.get(se.$Jgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$e8b(Ee.get(se.$Vgb),Ee.get(je.$Ek),Ee.get(x.$5i));this.a.registerChannel("userDataSync",rt);const Qe=this.B(Ee.get(U.$Ah).createInstance(Dt.$z8b)),ht=new he.$07b(Qe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ee.get(se.$Wgb),Fe));const Ye=P.ProxyChannel.fromService(Ee.get(De.$h8b),Fe);this.a.registerChannel(De.$i8b,Ye);const _e=P.ProxyChannel.fromService(Ee.get(ut.$m8b),Fe);this.a.registerChannel("remoteTunnel",_e)}m(Ee){process.on("uncaughtException",Fe=>(0,A.$Y)(Fe)),process.on("unhandledRejection",Fe=>(0,A.$Y)(Fe)),(0,A.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,N.$mi)(Fe,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}handledClientConnection(Ee){if(Ee.data!==tt.$O6b.response)return!1;const Fe=(0,S.$Mb)(Ee.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function mt(it){const Ee=new Mt(it);process.parentPort.postMessage(tt.$M6b.ipcReady),await Ee.init(),process.parentPort.postMessage(tt.$M6b.initDone)}e.main=mt,process.parentPort.once("message",it=>{mt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
