/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ve){for(var e=[],w=0,M=ve.length;w<M;w++)e[w]=Ae[ve[w]];return e};define(Ae[65],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function w(A){return(h,k,m)=>{let P=null,D=null;if(typeof m.value=="function"?(P="value",D=m.value):typeof m.get=="function"&&(P="get",D=m.get),!D)throw new Error("not supported");m[P]=A(D,k)}}function M(A,h,k){let m=null,P=null;if(typeof k.value=="function"?(m="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(m="get",P=k.get),!P)throw new Error("not supported");const D=`$memoize$${h}`;k[m]=function(...c){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,c)}),this[D]}}e.$6g=M;function C(A,h,k){return w((m,P)=>{const D=`$debounce$${P}`,c=`$debounce$result$${P}`;return function(...v){this[c]||(this[c]=k?k():void 0),clearTimeout(this[D]),h&&(this[c]=h(this[c],...v),v=[this[c]]),this[D]=setTimeout(()=>{m.apply(this,v),this[c]=k?k():void 0},A)}})}e.$7g=C;function F(A,h,k){return w((m,P)=>{const D=`$throttle$timer$${P}`,c=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...g){if(this[c]||(this[c]=k?k():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),h&&(this[c]=h(this[c],...g)),this[p])return;const t=this[v]+A;t<=Date.now()?(this[v]=Date.now(),m.apply(this,[this[c]]),this[c]=k?k():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),m.apply(this,[this[c]]),this[c]=k?k():void 0},t-Date.now()))}})}e.$8g=F}),define(Ae[88],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$_L=w,e.$aM=new w("id#")}),define(Ae[116],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function A(r,o=!1){let n=0;const a=r.length;let E="",b=0,S=16,I=0;function u(W){let O=0,N=0;for(;O<W;){const ee=r.charCodeAt(n);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;n++,O++}return O<W&&(N=-1),N}function f(W){n=W,E="",b=0,S=16,I=0}function l(){const W=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&m(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&m(r.charCodeAt(n)))for(n++;n<r.length&&m(r.charCodeAt(n));)n++;else return I=3,r.substring(W,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&m(r.charCodeAt(n))){for(n++;n<r.length&&m(r.charCodeAt(n));)n++;O=n}else I=3;return r.substring(W,O)}function R(){let W="",O=n;for(;;){if(n>=a){W+=r.substring(O,n),I=2;break}const N=r.charCodeAt(n);if(N===34){W+=r.substring(O,n),n++;break}if(N===92){if(W+=r.substring(O,n),n++,n>=a){I=2;break}switch(r.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const Z=u(4);Z>=0?W+=String.fromCharCode(Z):I=4;break}default:I=5}O=n;continue}if(N>=0&&N<=31)if(k(N)){W+=r.substring(O,n),I=2;break}else I=6;n++}return W}function B(){if(E="",I=0,b=n,n>=a)return b=a,S=17;let W=r.charCodeAt(n);if(h(W)){do n++,E+=String.fromCharCode(W),W=r.charCodeAt(n);while(h(W));return S=15}if(k(W))return n++,E+=String.fromCharCode(W),W===13&&r.charCodeAt(n)===10&&(n++,E+=`
`),S=14;switch(W){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,E=R(),S=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<a&&!k(r.charCodeAt(n));)n++;return E=r.substring(O,n),S=12}if(r.charCodeAt(n+1)===42){n+=2;const N=a-1;let ee=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,ee=!0;break}n++}return ee||(n++,I=1),E=r.substring(O,n),S=13}return E+=String.fromCharCode(W),n++,S=16}case 45:if(E+=String.fromCharCode(W),n++,n===a||!m(r.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=l(),S=11;default:for(;n<a&&V(W);)n++,W=r.charCodeAt(n);if(b!==n){switch(E=r.substring(b,n),E){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return E+=String.fromCharCode(W),n++,S=16}}function V(W){if(h(W)||k(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:f,getPosition:()=>n,scan:o?U:B,getToken:()=>S,getTokenValue:()=>E,getTokenOffset:()=>b,getTokenLength:()=>n-b,getTokenError:()=>I}}e.$Jm=A;function h(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function k(r){return r===10||r===13||r===8232||r===8233}function m(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function D(r,o){const n=[],a=new Object;let E;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function I(u,f,l,R){b.value=u,b.offset=f,b.length=l,b.type=R,b.colonOffset=void 0,E=b}try{d(r,{onObjectBegin:(u,f)=>{if(o<=u)throw a;E=void 0,S=o>u,n.push("")},onObjectProperty:(u,f,l)=>{if(o<f||(I(u,f,l,"property"),n[n.length-1]=u,o<=f+l))throw a},onObjectEnd:(u,f)=>{if(o<=u)throw a;E=void 0,n.pop()},onArrayBegin:(u,f)=>{if(o<=u)throw a;E=void 0,n.push(0)},onArrayEnd:(u,f)=>{if(o<=u)throw a;E=void 0,n.pop()},onLiteralValue:(u,f,l)=>{if(o<f||(I(u,f,l,$(u)),o<=f+l))throw a},onSeparator:(u,f,l)=>{if(o<=f)throw a;if(u===":"&&E&&E.type==="property")E.colonOffset=f,S=!1,E=void 0;else if(u===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(S=!0,n[n.length-1]=""),E=void 0}}})}catch(u){if(u!==a)throw u}return{path:n,previousNode:E,isAtPropertyKey:S,matches:u=>{let f=0;for(let l=0;f<u.length&&l<n.length;l++)if(u[f]===n[l]||u[f]==="*")f++;else if(u[f]!=="**")return!1;return f===u.length}}}e.$Km=D;function c(r,o=[],n=F.DEFAULT){let a=null,E=[];const b=[];function S(u){Array.isArray(E)?E.push(u):a!==null&&(E[a]=u)}return d(r,{onObjectBegin:()=>{const u={};S(u),b.push(E),E=u,a=null},onObjectProperty:u=>{a=u},onObjectEnd:()=>{E=b.pop()},onArrayBegin:()=>{const u=[];S(u),b.push(E),E=u,a=null},onArrayEnd:()=>{E=b.pop()},onLiteralValue:S,onError:(u,f,l)=>{o.push({error:u,offset:f,length:l})}},n),E[0]}e.$Lm=c;function v(r,o=[],n=F.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(u){a.type==="property"&&(a.length=u-a.offset,a=a.parent)}function b(u){return a.children.push(u),u}d(r,{onObjectBegin:u=>{a=b({type:"object",offset:u,length:-1,parent:a,children:[]})},onObjectProperty:(u,f,l)=>{a=b({type:"property",offset:f,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:u,offset:f,length:l,parent:a})},onObjectEnd:(u,f)=>{a.length=u+f-a.offset,a=a.parent,E(u+f)},onArrayBegin:(u,f)=>{a=b({type:"array",offset:u,length:-1,parent:a,children:[]})},onArrayEnd:(u,f)=>{a.length=u+f-a.offset,a=a.parent,E(u+f)},onLiteralValue:(u,f,l)=>{b({type:$(u),offset:f,length:l,parent:a,value:u}),E(f+l)},onSeparator:(u,f,l)=>{a.type==="property"&&(u===":"?a.colonOffset=f:u===","&&E(f))},onError:(u,f,l)=>{o.push({error:u,offset:f,length:l})}},n);const I=a.children[0];return I&&delete I.parent,I}e.$Mm=v;function p(r,o){if(!r)return;let n=r;for(const a of o)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let E=!1;for(const b of n.children)if(Array.isArray(b.children)&&b.children[0].value===a){n=b.children[1],E=!0;break}if(!E)return}else{const E=a;if(n.type!=="array"||E<0||!Array.isArray(n.children)||E>=n.children.length)return;n=n.children[E]}return n}e.$Nm=p;function g(r){if(!r.parent||!r.parent.children)return[];const o=g(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.$Om=g;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const o=Object.create(null);for(const n of r.children){const a=n.children[1];a&&(o[n.children[0].value]=t(a))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Pm=t;function i(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.$Qm=i;function s(r,o,n=!1){if(i(r,o,n)){const a=r.children;if(Array.isArray(a))for(let E=0;E<a.length&&a[E].offset<=o;E++){const b=s(a[E],o,n);if(b)return b}return r}}e.$Rm=s;function d(r,o,n=F.DEFAULT){const a=A(r,!1);function E(Ee){return Ee?()=>Ee(a.getTokenOffset(),a.getTokenLength()):()=>!0}function b(Ee){return Ee?ce=>Ee(ce,a.getTokenOffset(),a.getTokenLength()):()=>!0}const S=E(o.onObjectBegin),I=b(o.onObjectProperty),u=E(o.onObjectEnd),f=E(o.onArrayBegin),l=E(o.onArrayEnd),R=b(o.onLiteralValue),B=b(o.onSeparator),V=E(o.onComment),U=b(o.onError),W=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const Ee=a.scan();switch(a.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(Ee){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return Ee}}}function ee(Ee,ce=[],$e=[]){if(U(Ee),ce.length+$e.length>0){let ie=a.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Z(Ee){const ce=a.getTokenValue();return Ee?R(ce):I(ce),N(),!0}function ye(){switch(a.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(a.getTokenValue()),typeof Ee!="number"&&(ee(2),Ee=0)}catch{ee(2)}R(Ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return N(),!0}function De(){return a.getToken()!==10?(ee(3,[],[2,5]),!1):(Z(!1),a.getToken()===6?(B(":"),N(),le()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){S(),N();let Ee=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),a.getToken()===2&&O)break}else Ee&&ee(6,[],[]);De()||ee(4,[],[2,5]),Ee=!0}return u(),a.getToken()!==2?ee(7,[2],[]):N(),!0}function Y(){f(),N();let Ee=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),a.getToken()===4&&O)break}else Ee&&ee(6,[],[]);le()||ee(4,[],[4,5]),Ee=!0}return l(),a.getToken()!==4?ee(8,[4],[]):N(),!0}function le(){switch(a.getToken()){case 3:return Y();case 1:return Pe();case 10:return Z(!0);default:return ye()}}return N(),a.getToken()===17?n.allowEmptyContent?!0:(ee(4,[],[]),!1):le()?(a.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Sm=d;function y(r,o){const n=A(r),a=[];let E,b=0,S;do switch(S=n.getPosition(),E=n.scan(),E){case 12:case 13:case 17:b!==S&&a.push(r.substring(b,S)),o!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,o)),b=n.getPosition();break}while(E!==17);return a.join("")}e.$Tm=y;function $(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=$}),define(Ae[28],Re([1,0]),function(ve,e){"use strict";var w,M,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function F(i,s,d){let y=i.get(s);return y===void 0&&(y=d,i.set(s,y)),y}e.$wi=F;function A(i){const s=[];return i.forEach((d,y)=>{s.push(`${y} => ${d}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.$xi=A;function h(i){const s=[];return i.forEach(d=>{s.push(d)}),`Set(${i.size}) {${s.join(", ")}}`}e.$yi=h;class k{constructor(s,d){this.uri=s,this.value=d}}function m(i){return Array.isArray(i)}class P{static{this.a=s=>s.toString()}constructor(s,d){if(this[w]="ResourceMap",s instanceof P)this.b=new Map(s.b),this.c=d??P.a;else if(m(s)){this.b=new Map,this.c=d??P.a;for(const[y,$]of s)this.set(y,$)}else this.b=new Map,this.c=s??P.a}set(s,d){return this.b.set(this.c(s),new k(s,d)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,d){typeof d<"u"&&(s=s.bind(d));for(const[y,$]of this.b)s($.value,$.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.$zi=P;class D{constructor(s,d){this[M]="ResourceSet",!s||typeof s=="function"?this.a=new P(s):(this.a=new P(d),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,d){this.a.forEach((y,$)=>s.call(d,$,$,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=D;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c||(e.Touch=c={}));class v{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,d=0){const y=this.a.get(s);if(y)return d!==0&&this.j(y,d),y.value}set(s,d,y=0){let $=this.a.get(s);if($)$.value=d,y!==0&&this.j($,y);else{switch($={key:s,value:d,next:void 0,previous:void 0},y){case 0:this.h($);break;case 1:this.g($);break;case 2:this.h($);break;default:this.h($);break}this.a.set(s,$),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const d=this.a.get(s);if(d)return this.a.delete(s),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,d){const y=this.e;let $=this.b;for(;$;){if(d?s.bind(d)($.value,$.key,this):s($.value,$.key,this),this.e!==y)throw new Error("LinkedMap got modified during iteration.");$=$.next}}keys(){const s=this,d=this.e;let y=this.b;const $={[Symbol.iterator](){return $},next(){if(s.e!==d)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:y.key,done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return $}values(){const s=this,d=this.e;let y=this.b;const $={[Symbol.iterator](){return $},next(){if(s.e!==d)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:y.value,done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return $}entries(){const s=this,d=this.e;let y=this.b;const $={[Symbol.iterator](){return $},next(){if(s.e!==d)throw new Error("LinkedMap got modified during iteration.");if(y){const r={value:[y.key,y.value],done:!1};return y=y.next,r}else return{value:void 0,done:!0}}};return $}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let d=this.b,y=this.size;for(;d&&y>s;)this.a.delete(d.key),d=d.next,y--;this.b=d,this.d=y,d&&(d.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const d=s.next,y=s.previous;if(!d||!y)throw new Error("Invalid list");d.previous=y,y.next=d}s.next=void 0,s.previous=void 0,this.e++}j(s,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(s===this.b)return;const y=s.next,$=s.previous;s===this.c?($.next=void 0,this.c=$):(y.previous=$,$.next=y),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(d===2){if(s===this.c)return;const y=s.next,$=s.previous;s===this.b?(y.previous=void 0,this.b=y):(y.previous=$,$.next=y),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((d,y)=>{s.push([y,d])}),s}fromJSON(s){this.clear();for(const[d,y]of s)this.set(d,y)}}e.$Bi=v;class p extends v{constructor(s,d=1){super(),this.k=s,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,d=2){return super.get(s,d)}peek(s){return super.get(s,0)}set(s,d){return super.set(s,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=p;class g{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let d=this.a.get(s)||0;return d===0?!1:(d--,d===0?this.a.delete(s):this.a.set(s,d),!0)}has(s){return this.a.has(s)}}e.$Di=g;class t{constructor(s){if(this.a=new Map,this.b=new Map,s)for(const[d,y]of s)this.set(d,y)}clear(){this.a.clear(),this.b.clear()}set(s,d){this.a.set(s,d),this.b.set(d,s)}get(s){return this.a.get(s)}getKey(s){return this.b.get(s)}delete(s){const d=this.a.get(s);return d===void 0?!1:(this.a.delete(s),this.b.delete(d),!0)}forEach(s,d){this.a.forEach((y,$)=>{s.call(d,y,$,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=t}),function(ve,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(be,ge){for(var ke=0;ke<ge.length;ke++){var re=ge[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(be,re.key,re)}}function w(be,ge,ke){return ge&&e(be.prototype,ge),ke&&e(be,ke),Object.defineProperty(be,"prototype",{writable:!1}),be}function M(be,ge){if(be){if(typeof be=="string")return C(be,ge);var ke=Object.prototype.toString.call(be).slice(8,-1);if(ke==="Object"&&be.constructor&&(ke=be.constructor.name),ke==="Map"||ke==="Set")return Array.from(be);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(be,ge)}}function C(be,ge){(ge==null||ge>be.length)&&(ge=be.length);for(var ke=0,re=new Array(ge);ke<ge;ke++)re[ke]=be[ke];return re}function F(be,ge){var ke=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(ke)return(ke=ke.call(be)).next.bind(ke);if(Array.isArray(be)||(ke=M(be))||ge&&be&&typeof be.length=="number"){ke&&(be=ke);var re=0;return function(){return re>=be.length?{done:!0}:{done:!1,value:be[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=A();function h(be){ve.defaults=be}var k=/[&<>"']/,m=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ge){return c[ge]};function p(be,ge){if(ge){if(k.test(be))return be.replace(m,v)}else if(P.test(be))return be.replace(D,v);return be}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(be){return be.replace(g,function(ge,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var i=/(^|[^\[])\^/g;function s(be,ge){be=typeof be=="string"?be:be.source,ge=ge||"";var ke={replace:function(he,se){return se=se.source||se,se=se.replace(i,"$1"),be=be.replace(he,se),ke},getRegex:function(){return new RegExp(be,ge)}};return ke}var d=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function $(be,ge,ke){if(be){var re;try{re=decodeURIComponent(t(ke)).replace(d,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}ge&&!y.test(ke)&&(ke=E(ge,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(be,ge){r[" "+be]||(o.test(be)?r[" "+be]=be+"/":r[" "+be]=u(be,"/",!0)),be=r[" "+be];var ke=be.indexOf(":")===-1;return ge.substring(0,2)==="//"?ke?ge:be.replace(n,"$1")+ge:ge.charAt(0)==="/"?ke?ge:be.replace(a,"$1")+ge:be+ge}var b={exec:function(){}};function S(be){for(var ge=1,ke,re;ge<arguments.length;ge++){ke=arguments[ge];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(be[re]=ke[re])}return be}function I(be,ge){var ke=be.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,T=oe;--T>=0&&fe[T]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=ke.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>ge)re.splice(ge);else for(;re.length<ge;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function u(be,ge,ke){var re=be.length;if(re===0)return"";for(var he=0;he<re;){var se=be.charAt(re-he-1);if(se===ge&&!ke)he++;else if(se!==ge&&ke)he++;else break}return be.slice(0,re-he)}function f(be,ge){if(be.indexOf(ge[1])===-1)return-1;for(var ke=be.length,re=0,he=0;he<ke;he++)if(be[he]==="\\")he++;else if(be[he]===ge[0])re++;else if(be[he]===ge[1]&&(re--,re<0))return he;return-1}function l(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(be,ge){if(ge<1)return"";for(var ke="";ge>1;)ge&1&&(ke+=be),ge>>=1,be+=be;return ke+be}function B(be,ge,ke,re){var he=ge.href,se=ge.title?p(ge.title):null,oe=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:ke,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,fe}return{type:"image",raw:ke,href:he,title:se,text:p(oe)}}function V(be,ge){var ke=be.match(/^(\s+)(?:```)/);if(ke===null)return ge;var re=ke[1];return ge.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function be(ke){this.options=ke||ve.defaults}var ge=be.prototype;return ge.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ge.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},ge.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},ge.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=u(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},ge.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},ge.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},ge.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,fe,Ie,T,K,G,Q,J,x,ae,Oe,Ue=he[1].trim(),Qe=Ue.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Oe=!1,!(!(he=et.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],J=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(J)&&(se+=J+`
`,re=re.substring(J.length+1),Oe=!0),!Oe)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||xe.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=x+`
`,re=re.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var ze=He.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,He.items[T].tokens=this.lexer.blockTokens(He.items[T].text,[]);var st=He.items[T].tokens.filter(function(X){return X.type==="space"}),_=st.every(function(X){for(var pe=X.raw.split(""),je=0,Ne=F(pe),Xe;!(Xe=Ne()).done;){var nt=Xe.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[T].loose=!0)}return He}},ge.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},ge.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},ge.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:I(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,fe,Ie,T,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=I(se.rows[fe],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],T=0;T<K.length;T++)K[T].tokens=this.lexer.inline(K[T].text);return se}}},ge.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ge.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},ge.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ge.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:p(he[1])}},ge.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]):he[0]}},ge.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=u(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=f(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,T=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,T).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ge.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return B(se,oe,se[0],this.lexer)}},ge.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,T,K,G=Ie,Q=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=J.exec(he))!=null;)if(T=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!T){if(K=T.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var x=re.slice(1,Ie+oe.index+K);return{type:"em",raw:re.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=re.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},ge.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=p(se,!0),{type:"codespan",raw:he[0],text:se}}},ge.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},ge.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ge.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,fe;return se[2]==="@"?(oe=p(this.options.mangle?he(se[1]):se[1]),fe="mailto:"+oe):(oe=p(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,fe;if(se[2]==="@")oe=p(this.options.mangle?he(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=p(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):p(se[0]):se[0]:oe=p(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},be}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=s(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=s(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=s(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=s(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=s(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=s(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=s(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=s(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:s(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=s(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=s(W._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=s(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=s(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=s(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=s(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=s(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=s(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=s(O.reflink).replace("label",O._label).replace("ref",W._label).getRegex(),O.nolink=s(O.nolink).replace("ref",W._label).getRegex(),O.reflinkSearch=s(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=S({},O),O.pedantic=S({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=S({},O.normal,{escape:s(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=s(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=S({},O.gfm,{br:s(O.br).replace("{2,}","*").getRegex(),text:s(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(be){var ge="",ke,re,he=be.length;for(ke=0;ke<he;ke++)re=be.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),ge+="&#"+re+";";return ge}var Z=function(){function be(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ve.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:W.normal,inline:O.normal};this.options.pedantic?(re.block=W.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=W.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}be.lex=function(re,he){var se=new be(he);return se.lex(re)},be.lexInline=function(re,he){var se=new be(he);return se.inlineTokens(re)};var ge=be.prototype;return ge.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ge.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,Q,J){return Q+"    ".repeat(J.length)});for(var oe,fe,Ie,T;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=re.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Q),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],T&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),T=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(re){var K="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},ge.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},ge.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,fe,Ie,T=re,K,G,Q;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,K.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,T,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,ee)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ee))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Oe=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Oe),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=re.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(be,null,[{key:"rules",get:function(){return{block:W,inline:O}}}]),be}(),ye=function(){function be(ke){this.options=ke||ve.defaults}var ge=be.prototype;return ge.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,oe);fe!=null&&fe!==re&&(se=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+p(oe,!0)+'">'+(se?re:p(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:p(re,!0))+`</code></pre>
`},ge.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},ge.html=function(re){return re},ge.heading=function(re,he,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+fe+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(re,he,se){var oe=he?"ol":"ul",fe=he&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+re+"</"+oe+`>
`},ge.listitem=function(re){return"<li>"+re+`</li>
`},ge.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(re){return"<p>"+re+`</p>
`},ge.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},ge.tablerow=function(re){return`<tr>
`+re+`</tr>
`},ge.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},ge.strong=function(re){return"<strong>"+re+"</strong>"},ge.em=function(re){return"<em>"+re+"</em>"},ge.codespan=function(re){return"<code>"+re+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(re){return"<del>"+re+"</del>"},ge.link=function(re,he,se){if(re=$(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+p(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},ge.image=function(re,he,se){if(re=$(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},ge.text=function(re){return re},be}(),De=function(){function be(){}var ge=be.prototype;return ge.strong=function(re){return re},ge.em=function(re){return re},ge.codespan=function(re){return re},ge.del=function(re){return re},ge.html=function(re){return re},ge.text=function(re){return re},ge.link=function(re,he,se){return""+se},ge.image=function(re,he,se){return""+se},ge.br=function(){return""},be}(),Pe=function(){function be(){this.seen={}}var ge=be.prototype;return ge.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},ge.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},be}(),Y=function(){function be(ke){this.options=ke||ve.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Pe}be.parse=function(re,he){var se=new be(he);return se.parse(re)},be.parseInline=function(re,he){var se=new be(he);return se.parseInline(re)};var ge=be.prototype;return ge.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,fe,Ie,T,K,G,Q,J,x,ae,Oe,Ue,Qe,He,et,Ye,xe,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ae=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Q="",T=ae.header.length,fe=0;fe<T;fe++)Q+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(Q),x="",T=ae.rows.length,fe=0;fe<T;fe++){for(G=ae.rows[fe],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ae.ordered,Ue=ae.start,Qe=ae.loose,T=ae.items.length,x="",fe=0;fe<T;fe++)et=ae.items[fe],Ye=et.checked,xe=et.task,He="",et.task&&(it=this.renderer.checkbox(Ye),Qe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Qe),x+=this.renderer.listitem(He,xe,Ye);se+=this.renderer.list(x,Oe,Ue);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&re[oe+1].type==="text";)ae=re[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},ge.parseInline=function(re,he){he=he||this.renderer;var se="",oe,fe,Ie,T=re.length;for(oe=0;oe<T;oe++){if(fe=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=he.text(fe.text);break}case"html":{se+=he.html(fe.text);break}case"link":{se+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{se+=he.image(fe.href,fe.title,fe.text);break}case"strong":{se+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{se+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{se+=he.codespan(fe.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(fe.tokens,he));break}case"text":{se+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},be}();function le(be,ge,ke){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof ge=="function"&&(ke=ge,ge=null),ge=S({},le.defaults,ge||{}),l(ge),ke){var re=ge.highlight,he;try{he=Z.lex(be,ge)}catch(T){return ke(T)}var se=function(K){var G;if(!K)try{ge.walkTokens&&le.walkTokens(he,ge.walkTokens),G=Y.parse(he,ge)}catch(Q){K=Q}return ge.highlight=re,K?ke(K):ke(null,G)};if(!re||re.length<3||(delete ge.highlight,!he.length))return se();var oe=0;le.walkTokens(he,function(T){T.type==="code"&&(oe++,setTimeout(function(){re(T.text,T.lang,function(K,G){if(K)return se(K);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Ie=Z.lex(be,ge);if(ge.walkTokens){if(ge.async)return Promise.all(le.walkTokens(Ie,ge.walkTokens)).then(function(){return Y.parse(Ie,ge)}).catch(fe);le.walkTokens(Ie,ge.walkTokens)}return Y.parse(Ie,ge)}catch(T){fe(T)}}le.options=le.setOptions=function(be){return S(le.defaults,be),h(le.defaults),le},le.getDefaults=A,le.defaults=ve.defaults,le.use=function(){for(var be=arguments.length,ge=new Array(be),ke=0;ke<be;ke++)ge[ke]=arguments[ke];var re=S.apply(void 0,[{}].concat(ge)),he=le.defaults.extensions||{renderers:{},childTokens:{}},se;ge.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var T=he.renderers?he.renderers[Ie.name]:null;T?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var J=Ie.renderer.apply(this,G);return J===!1&&(J=T.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=le.defaults.renderer||new ye,T=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var Ue=oe.renderer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.renderer)T(K);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=le.defaults.tokenizer||new U,T=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var Ue=oe.tokenizer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.tokenizer)T(K);re.tokenizer=Ie}(),oe.walkTokens){var fe=le.defaults.walkTokens;re.walkTokens=function(Ie){var T=[];return T.push(oe.walkTokens.call(this,Ie)),fe&&(T=T.concat(fe.call(this,Ie))),T}}se&&(re.extensions=he),le.setOptions(re)})},le.walkTokens=function(be,ge){for(var ke=[],re=function(){var fe=se.value;switch(ke=ke.concat(ge.call(le,fe)),fe.type){case"table":{for(var Ie=F(fe.header),T;!(T=Ie()).done;){var K=T.value;ke=ke.concat(le.walkTokens(K.tokens,ge))}for(var G=F(fe.rows),Q;!(Q=G()).done;)for(var J=Q.value,x=F(J),ae;!(ae=x()).done;){var Oe=ae.value;ke=ke.concat(le.walkTokens(Oe.tokens,ge))}break}case"list":{ke=ke.concat(le.walkTokens(fe.items,ge));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[fe.type]?le.defaults.extensions.childTokens[fe.type].forEach(function(Ue){ke=ke.concat(le.walkTokens(fe[Ue],ge))}):fe.tokens&&(ke=ke.concat(le.walkTokens(fe.tokens,ge)))}},he=F(be),se;!(se=he()).done;)re();return ke},le.parseInline=function(be,ge){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");ge=S({},le.defaults,ge||{}),l(ge);try{var ke=Z.lexInline(be,ge);return ge.walkTokens&&le.walkTokens(ke,ge.walkTokens),Y.parseInline(ke,ge)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+p(re.message+"",!0)+"</pre>";throw re}},le.Parser=Y,le.parser=Y.parse,le.Renderer=ye,le.TextRenderer=De,le.Lexer=Z,le.lexer=Z.lex,le.Tokenizer=U,le.Slugger=Pe,le.parse=le;var Ee=le.options,ce=le.setOptions,$e=le.use,ie=le.walkTokens,z=le.parseInline,q=le,ue=Y.parse,we=Z.lex;ve.Lexer=Z,ve.Parser=Y,ve.Renderer=ye,ve.Slugger=Pe,ve.TextRenderer=De,ve.Tokenizer=U,ve.getDefaults=A,ve.lexer=we,ve.marked=le,ve.options=Ee,ve.parse=q,ve.parseInline=z,ve.parser=ue,ve.setOptions=ce,ve.use=$e,ve.walkTokens=ie,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function w(h,k,m){return Math.min(Math.max(h,k),m)}e.$Hl=w;function M(h,k){return(k+h%k)%k}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=C;class F{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=F;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const m=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=A}),function(){function ve(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function A(k){F.push(k,Date.now())}function h(){const k=[];for(let m=0;m<F.length;m+=2)k.push({name:F[m],startTime:F[m+1]});return k}return{mark:A,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))F.push({name:A.name,startTime:Math.round(C+A.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:ve)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function w(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return ve[M].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=ve,w.c=e,w.d=function(M,C,F){w.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:F})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,C){if(1&C&&(M=w(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)w.d(F,A,function(h){return M[h]}.bind(null,A));return F},w.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(C,"a",C),C},w.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},w.p="",w(w.s=0)}([function(ve,e,w){(function(M){var C;e=ve.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],k=e.src=[],m=0,P=m++;k[P]="0|[1-9]\\d*";var D=m++;k[D]="[0-9]+";var c=m++;k[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=m++;k[v]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var p=m++;k[p]="("+k[D]+")\\.("+k[D]+")\\.("+k[D]+")";var g=m++;k[g]="(?:"+k[P]+"|"+k[c]+")";var t=m++;k[t]="(?:"+k[D]+"|"+k[c]+")";var i=m++;k[i]="(?:-("+k[g]+"(?:\\."+k[g]+")*))";var s=m++;k[s]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var d=m++;k[d]="[0-9A-Za-z-]+";var y=m++;k[y]="(?:\\+("+k[d]+"(?:\\."+k[d]+")*))";var $=m++,r="v?"+k[v]+k[i]+"?"+k[y]+"?";k[$]="^"+r+"$";var o="[v=\\s]*"+k[p]+k[s]+"?"+k[y]+"?",n=m++;k[n]="^"+o+"$";var a=m++;k[a]="((?:<|>)?=?)";var E=m++;k[E]=k[D]+"|x|X|\\*";var b=m++;k[b]=k[P]+"|x|X|\\*";var S=m++;k[S]="[v=\\s]*("+k[b]+")(?:\\.("+k[b]+")(?:\\.("+k[b]+")(?:"+k[i]+")?"+k[y]+"?)?)?";var I=m++;k[I]="[v=\\s]*("+k[E]+")(?:\\.("+k[E]+")(?:\\.("+k[E]+")(?:"+k[s]+")?"+k[y]+"?)?)?";var u=m++;k[u]="^"+k[a]+"\\s*"+k[S]+"$";var f=m++;k[f]="^"+k[a]+"\\s*"+k[I]+"$";var l=m++;k[l]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=m++;k[R]="(?:~>?)";var B=m++;k[B]="(\\s*)"+k[R]+"\\s+",h[B]=new RegExp(k[B],"g");var V=m++;k[V]="^"+k[R]+k[S]+"$";var U=m++;k[U]="^"+k[R]+k[I]+"$";var W=m++;k[W]="(?:\\^)";var O=m++;k[O]="(\\s*)"+k[W]+"\\s+",h[O]=new RegExp(k[O],"g");var N=m++;k[N]="^"+k[W]+k[S]+"$";var ee=m++;k[ee]="^"+k[W]+k[I]+"$";var Z=m++;k[Z]="^"+k[a]+"\\s*("+o+")$|^$";var ye=m++;k[ye]="^"+k[a]+"\\s*("+r+")$|^$";var De=m++;k[De]="(\\s*)"+k[a]+"\\s*("+o+"|"+k[S]+")",h[De]=new RegExp(k[De],"g");var Pe=m++;k[Pe]="^\\s*("+k[S]+")\\s+-\\s+("+k[S]+")\\s*$";var Y=m++;k[Y]="^\\s*("+k[I]+")\\s+-\\s+("+k[I]+")\\s*$";var le=m++;k[le]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)C(Ee,k[Ee]),h[Ee]||(h[Ee]=new RegExp(k[Ee]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>F||!(x?h[n]:h[$]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?h[n]:h[$]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ue=+Oe;if(Ue>=0&&Ue<A)return Ue}return Oe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),z(this.major,J.major)||z(this.minor,J.minor)||z(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Oe=J.prerelease[x];if(C("prerelease compare",x,ae,Oe),ae===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ae===void 0)return-1;if(ae!==Oe)return z(ae,Oe)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Oe){typeof ae=="string"&&(Oe=ae,ae=void 0);try{return new $e(J,ae).inc(x,Oe).version}catch{return null}},e.diff=function(J,x){if(be(J,x))return null;var ae=ce(J),Oe=ce(x);if(ae.prerelease.length||Oe.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Oe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Oe[Ue])return Ue},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(J,x){var ae=ie.test(J),Oe=ie.test(x);return ae&&Oe&&(J=+J,x=+x),ae&&!Oe?-1:Oe&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function ue(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function be(J,x,ae){return q(J,x,ae)===0}function ge(J,x,ae){return q(J,x,ae)!==0}function ke(J,x,ae){return q(J,x,ae)>=0}function re(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Oe){var Ue;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J!==ae;break;case"":case"=":case"==":Ue=be(J,ae,Oe);break;case"!=":Ue=ge(J,ae,Oe);break;case">":Ue=ue(J,ae,Oe);break;case">=":Ue=ke(J,ae,Oe);break;case"<":Ue=we(J,ae,Oe);break;case"<=":Ue=re(J,ae,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return z(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Oe){return e.compare(ae,Oe,x)})},e.rsort=function(J,x){return J.sort(function(ae,Oe){return e.rcompare(ae,Oe,x)})},e.gt=ue,e.lt=we,e.eq=be,e.neq=ge,e.gte=ke,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof se)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function T(J,x,ae,Oe,Ue,Qe,He,et,Ye,xe,it,tt,ze){return((x=Ie(ae)?"":Ie(Oe)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Oe+".0":">="+x)+" "+(et=Ie(Ye)?"":Ie(xe)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+et)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Oe=J[ae].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function Q(J,x,ae,Oe){var Ue,Qe,He,et,Ye;switch(J=new $e(J,Oe),x=new fe(x,Oe),ae){case">":Ue=ue,Qe=re,He=we,et=">",Ye=">=";break;case"<":Ue=we,Qe=ke,He=ue,et="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Oe))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Oe)?tt=st:He(st.semver,ze.semver,Oe)&&(ze=st)}),tt.operator===et||tt.operator===Ye||(!ze.operator||ze.operator===et)&&Qe(J,ze.semver)||ze.operator===Ye&&He(J,ze.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?h[Z]:h[ye],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Oe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ye=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Oe||Ue||Qe&&He||et||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?h[Y]:h[Pe];J=J.replace(ae,T),C("hyphen replace",J),J=J.replace(h[De],"$1$2$3"),C("comparator trim",J,h[De]),J=(J=(J=J.replace(h[B],"$1~")).replace(h[O],"$1^")).split(/\s+/).join(" ");var Oe=x?h[Z]:h[ye],Ue=J.split(" ").map(function(Qe){return function(He,et){return C("comp",He),He=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?h[ee]:h[N];return tt.replace(st,function(_,X,pe,je,Ne){var Xe;return C("caret",tt,_,X,pe,je,Ne),Ie(X)?Xe="":Ie(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(je)?Xe=X==="0"?">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+".0 <"+(+X+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+je+Ne+" <"+X+"."+pe+"."+(+je+1):">="+X+"."+pe+"."+je+Ne+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+je+Ne+" <"+(+X+1)+".0.0"):(C("no pr"),Xe=X==="0"?pe==="0"?">="+X+"."+pe+"."+je+" <"+X+"."+pe+"."+(+je+1):">="+X+"."+pe+"."+je+" <"+X+"."+(+pe+1)+".0":">="+X+"."+pe+"."+je+" <"+(+X+1)+".0.0"),C("caret return",Xe),Xe})}(it,xe)}).join(" ")}(He,et),C("caret",He),He=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?h[U]:h[V];return tt.replace(st,function(_,X,pe,je,Ne){var Xe;return C("tilde",tt,_,X,pe,je,Ne),Ie(X)?Xe="":Ie(pe)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(je)?Xe=">="+X+"."+pe+".0 <"+X+"."+(+pe+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+pe+"."+je+Ne+" <"+X+"."+(+pe+1)+".0"):Xe=">="+X+"."+pe+"."+je+" <"+X+"."+(+pe+1)+".0",C("tilde return",Xe),Xe})}(it,xe)}).join(" ")}(He,et),C("tildes",He),He=function(Ye,xe){return C("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?h[f]:h[u];return tt.replace(st,function(_,X,pe,je,Ne,Xe){C("xRange",tt,_,X,pe,je,Ne,Xe);var nt=Ie(pe),dt=nt||Ie(je),wt=dt||Ie(Ne);return X==="="&&wt&&(X=""),nt?_=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(dt&&(je=0),wt&&(Ne=0),X===">"?(X=">=",dt?(pe=+pe+1,je=0,Ne=0):wt&&(je=+je+1,Ne=0)):X==="<="&&(X="<",dt?pe=+pe+1:je=+je+1),_=X+pe+"."+je+"."+Ne):dt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":wt&&(_=">="+pe+"."+je+".0 <"+pe+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,xe)}).join(" ")}(He,et),C("xrange",He),He=function(Ye,xe){return C("replaceStars",Ye,xe),Ye.trim().replace(h[le],"")}(He,et),C("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Oe)})),Ue=Ue.map(function(Qe){return new se(Qe,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Oe){return J.set.some(function(Ue){return Ue.every(function(Qe){return Oe.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Oe=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&Ue.compare(He)!==-1||(Ue=new $e(Oe=He,ae)))}),Oe},e.minSatisfying=function(J,x,ae){var Oe=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&Ue.compare(He)!==1||(Ue=new $e(Oe=He,ae)))}),Oe},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Q(J,x,"<",ae)},e.gtr=function(J,x,ae){return Q(J,x,">",ae)},e.outside=Q,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(h[l]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(ve,e){var w,M,C=ve.exports={};function F(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function h(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var k,m=[],P=!1,D=-1;function c(){P&&k&&(P=!1,k.length?m=k.concat(m):D=-1,m.length&&v())}function v(){if(!P){var t=h(c);P=!0;for(var i=m.length;i;){for(k=m,m=[];++D<i;)k&&k[D].run();D=-1,i=m.length}k=null,P=!1,function(s){if(M===clearTimeout)return clearTimeout(s);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(s);try{M(s)}catch{try{return M.call(null,s)}catch{return M.call(this,s)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function g(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)i[s-1]=arguments[s];m.push(new p(t,i)),m.length!==1||P||h(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function C(y){const $=y;return $?typeof $.read=="function":!1}e.$qd=C;function F(y){const $=y;return $?[$.on,$.pause,$.resume,$.destroy].every(r=>typeof r=="function"):!1}e.$rd=F;function A(y){const $=y;return $?F($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}e.$sd=A;function h(y,$){return new k(y,$)}e.$td=h;class k{constructor($,r){this.e=$,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(r=>r($))}h($){this.c.error.length===0?(0,w.$Y)($):this.c.error.slice(0).forEach(r=>r($))}i(){this.c.end.slice(0).forEach($=>$())}on($,r){if(!this.a.destroyed)switch($){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener($,r){if(this.a.destroyed)return;let o;switch($){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(r);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(y,$){const r=[];let o;for(;(o=y.read())!==null;)r.push(o);return $(r)}e.$ud=m;function P(y,$,r){const o=[];let n;for(;(n=y.read())!==null&&o.length<r;)o.push(n);return n===null&&o.length>0?$(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const a=n;return n=void 0,a}return y.read()}}}e.$vd=P;function D(y,$){return new Promise((r,o)=>{const n=[];c(y,{onData:a=>{$&&n.push(a)},onError:a=>{$?o(a):r(void 0)},onEnd:()=>{r($?$(n):void 0)}})})}e.$wd=D;function c(y,$,r){y.on("error",o=>{r?.isCancellationRequested||$.onError(o)}),y.on("end",()=>{r?.isCancellationRequested||$.onEnd()}),y.on("data",o=>{r?.isCancellationRequested||$.onData(o)})}e.$xd=c;function v(y,$){return new Promise((r,o)=>{const n=new M.$jc,a=[],E=I=>{if(a.push(I),a.length>$)return n.dispose(),y.pause(),r({stream:y,buffer:a,ended:!1})},b=I=>(n.dispose(),o(I)),S=()=>(n.dispose(),r({stream:y,buffer:a,ended:!0}));n.add((0,M.$ic)(()=>y.removeListener("error",b))),y.on("error",b),n.add((0,M.$ic)(()=>y.removeListener("end",S))),y.on("end",S),n.add((0,M.$ic)(()=>y.removeListener("data",E))),y.on("data",E)})}e.$yd=v;function p(y,$){const r=h($);return r.end(y),r}e.$zd=p;function g(){const y=h(()=>{throw new Error("not supported")});return y.end(),y}e.$Ad=g;function t(y){let $=!1;return{read:()=>$?null:($=!0,y)}}e.$Bd=t;function i(y,$,r){const o=h(r);return c(y,{onData:n=>o.write($.data(n)),onError:n=>o.error($.error?$.error(n):n),onEnd:()=>o.end()}),o}e.$Cd=i;function s(y,$,r){let o=!1;return{read:()=>{const n=$.read();return o?n:(o=!0,n!==null?r([y,n]):y)}}}e.$Dd=s;function d(y,$,r){let o=!1;const n=h(r);return c($,{onData:a=>o?n.write(a):(o=!0,n.write(r([y,a]))),onError:a=>n.error(a),onEnd:()=>{o||(o=!0,n.write(y)),n.end()}}),n}e.$Ed=d}),define(Ae[25],Re([1,0,66,119]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const C=typeof Buffer<"u",F=new w.$T(()=>new Uint8Array(256));let A,h;class k{static alloc(l){return C?new k(Buffer.allocUnsafe(l)):new k(new Uint8Array(l))}static wrap(l){return C&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new k(l)}static fromString(l,R){return!(R?.dontUseNodeBuffer||!1)&&C?new k(Buffer.from(l)):(A||(A=new TextEncoder),new k(A.encode(l)))}static fromByteArray(l){const R=k.alloc(l.length);for(let B=0,V=l.length;B<V;B++)R.buffer[B]=l[B];return R}static concat(l,R){if(typeof R>"u"){R=0;for(let U=0,W=l.length;U<W;U++)R+=l[U].byteLength}const B=k.alloc(R);let V=0;for(let U=0,W=l.length;U<W;U++){const O=l[U];B.set(O,V),V+=O.byteLength}return B}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=k.alloc(this.byteLength);return l.set(this),l}toString(){return C?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(l,R){return new k(this.buffer.subarray(l,R))}set(l,R){if(l instanceof k)this.buffer.set(l.buffer,R);else if(l instanceof Uint8Array)this.buffer.set(l,R);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),R);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return c(this.buffer,l)}writeUInt32BE(l,R){v(this.buffer,l,R)}readUInt32LE(l){return p(this.buffer,l)}writeUInt32LE(l,R){g(this.buffer,l,R)}readUInt8(l){return t(this.buffer,l)}writeUInt8(l,R){i(this.buffer,l,R)}indexOf(l,R=0){return m(this.buffer,l instanceof k?l.buffer:l,R)}}e.$Fd=k;function m(f,l,R=0){const B=l.byteLength,V=f.byteLength;if(B===0)return 0;if(B===1)return f.indexOf(l[0]);if(B>V-R)return-1;const U=F.value;U.fill(l.length);for(let ee=0;ee<l.length;ee++)U[l[ee]]=l.length-ee-1;let W=R+l.length-1,O=W,N=-1;for(;W<V;)if(f[W]===l[O]){if(O===0){N=W;break}W--,O--}else W+=Math.max(l.length-O,U[f[W]]),O=l.length-1;return N}e.$Gd=m;function P(f,l){return f[l+0]<<0>>>0|f[l+1]<<8>>>0}e.$Hd=P;function D(f,l,R){f[R+0]=l&255,l=l>>>8,f[R+1]=l&255}e.$Id=D;function c(f,l){return f[l]*2**24+f[l+1]*2**16+f[l+2]*2**8+f[l+3]}e.$Jd=c;function v(f,l,R){f[R+3]=l,l=l>>>8,f[R+2]=l,l=l>>>8,f[R+1]=l,l=l>>>8,f[R]=l}e.$Kd=v;function p(f,l){return f[l+0]<<0>>>0|f[l+1]<<8>>>0|f[l+2]<<16>>>0|f[l+3]<<24>>>0}e.$Ld=p;function g(f,l,R){f[R+0]=l&255,l=l>>>8,f[R+1]=l&255,l=l>>>8,f[R+2]=l&255,l=l>>>8,f[R+3]=l&255}e.$Md=g;function t(f,l){return f[l]}e.$Nd=t;function i(f,l,R){f[R]=l}e.$Od=i;function s(f){return M.$ud(f,l=>k.concat(l))}e.$Pd=s;function d(f){return M.$Bd(f)}e.$Qd=d;function y(f){return M.$wd(f,l=>k.concat(l))}e.$Rd=y;async function $(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await y(f.stream)])}e.$Sd=$;function r(f){return M.$zd(f,l=>k.concat(l))}e.$Td=r;function o(f){return M.$Cd(f,{data:l=>typeof l=="string"?k.fromString(l):k.wrap(l)},l=>k.concat(l))}e.$Ud=o;function n(f){return M.$td(l=>k.concat(l),f)}e.$Vd=n;function a(f,l){return M.$Dd(f,l,R=>k.concat(R))}e.$Wd=a;function E(f,l){return M.$Ed(f,l,R=>k.concat(R))}e.$Xd=E;function b(f){let l=0,R=0,B=0;const V=new Uint8Array(Math.floor(f.length/4*3)),U=O=>{switch(R){case 3:V[B++]=l|O,R=0;break;case 2:V[B++]=l|O>>>2,l=O<<6,R=3;break;case 1:V[B++]=l|O>>>4,l=O<<4,R=2;break;default:l=O<<2,R=1}};for(let O=0;O<f.length;O++){const N=f.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${f[O]}`)}}const W=B;for(;R>0;)U(0);return k.wrap(V).slice(0,W)}e.$Yd=b;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:f},l=!0,R=!1){const B=R?I:S;let V="";const U=f.byteLength%3;let W=0;for(;W<f.byteLength-U;W+=3){const O=f[W+0],N=f[W+1],ee=f[W+2];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[(N<<2|ee>>>6)&63],V+=B[ee&63]}if(U===1){const O=f[W+0];V+=B[O>>>2],V+=B[O<<4&63],l&&(V+="==")}else if(U===2){const O=f[W+0],N=f[W+1];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[N<<2&63],l&&(V+="=")}return V}e.$Zd=u}),define(Ae[120],Re([1,0,28,15]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.FuzzyScore=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.or=void 0;function C(...se){return function(oe,fe){for(let Ie=0,T=se.length;Ie<T;Ie++){const K=se[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$xj=F.bind(void 0,!1),e.$yj=F.bind(void 0,!0);function F(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=M.$Ne(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.$zj=A;function h(se,oe){return k(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Aj=h;function k(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let T=null;return(T=k(se,oe,fe+1,Ie+1))?i({start:Ie,end:Ie+1},T):null}return k(se,oe,fe,Ie+1)}function m(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Bj=P;function D(se){return 48<=se&&se<=57}function c(se){return se===32||se===9||se===10||se===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>v.add(se.charCodeAt(0)));function p(se){return c(se)||v.has(se)}function g(se,oe){return se===oe||p(se)&&p(oe)}function t(se){return m(se)||P(se)||D(se)}function i(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function s(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||D(Ie)||fe>0&&!t(se.charCodeAt(fe-1)))return fe}return se.length}function d(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let T=null,K=Ie+1;for(T=d(se,oe,fe+1,Ie+1);!T&&(K=s(oe,K))<oe.length;)T=d(se,oe,fe+1,K),K++;return T===null?null:i({start:Ie,end:Ie+1},T)}}function y(se){let oe=0,fe=0,Ie=0,T=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,m(K)&&fe++,t(K)&&Ie++,D(K)&&T++;const G=oe/se.length,Q=fe/se.length,J=Ie/se.length,x=T/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:J,numericPercent:x}}function $(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:T}=se;return fe>.2&&oe<.8&&Ie>.6&&T<.2}function o(se){let oe=0,fe=0,Ie=0,T=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,m(Ie)&&fe++,c(Ie)&&T++;return(oe===0||fe===0)&&T===0?se.length<=30:oe<=5}function n(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!o(se)||oe.length>60)return null;const fe=y(oe);if(!r(fe)){if(!$(fe))return null;oe=oe.toLowerCase()}let Ie=null,T=0;for(se=se.toLowerCase();T<oe.length&&(Ie=d(se,oe,0,T))===null;)T=s(oe,T+1);return Ie}e.$Cj=n;function a(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,T=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();T<oe.length&&(Ie=E(se,oe,0,T,fe))===null;)T=b(oe,T+1);return Ie}e.$Dj=a;function E(se,oe,fe,Ie,T){if(fe===se.length)return[];if(Ie===oe.length)return null;if(g(se.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=E(se,oe,fe+1,Ie+1,T),!T)for(;!K&&(G=b(oe,G))<oe.length;)K=E(se,oe,fe+1,G,T),G++;return K?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function b(se,oe){for(let fe=oe;fe<se.length;fe++)if(p(se.charCodeAt(fe))||fe>0&&p(se.charCodeAt(fe-1)))return fe;return se.length}const S=C(e.$yj,n,A),I=C(e.$yj,n,h),u=new w.$Ci(1e4);function f(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=u.get(se);Ie||(Ie=new RegExp(M.$we(se),"i"),u.set(se,Ie));const T=Ie.exec(oe);return T?[{start:T.index,end:T.index+T[0].length}]:fe?I(se,oe):S(se,oe)}e.$Ej=f;function l(se,oe){const fe=ue(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?B(fe):null}e.$Fj=l;function R(se,oe,fe,Ie,T,K){const G=Math.min(13,se.length);for(;fe<G;fe++){const Q=ue(se,oe,fe,Ie,T,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Gj=R;function B(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const T=se[Ie]+fe,K=oe[oe.length-1];K&&K.end===T?K.end=T+1:oe.push({start:T,end:T+1})}return oe}e.$Hj=B;const V=128;function U(){const se=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)se.push(oe.slice(0));return se}function W(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const O=W(2*V),N=W(2*V),ee=U(),Z=U(),ye=U(),De=!1;function Pe(se,oe,fe,Ie,T){function K(Q,J,x=" "){for(;Q.length<J;)Q=x+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=fe;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,T+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function Y(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(Z,se,se.length,fe,fe.length)),console.log(Pe(ye,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function le(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$6e(fe)}}function Ee(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function $e(se,oe,fe,Ie,T,K,G=!1){for(;oe<fe&&T<K;)se[oe]===Ie[T]&&(G&&(O[oe]=T),oe+=1),T+=1;return oe===fe}e.$Ij=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Jj=q;function ue(se,oe,fe,Ie,T,K,G=q.default){const Q=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(fe>=Q||K>=J||Q-fe>J-K||!$e(oe,fe,Q,T,K,J,!0))return;we(Q,J,fe,K,oe,T);let x=1,ae=1,Oe=fe,Ue=K;const Qe=[!1];for(x=1,Oe=fe;Oe<Q;x++,Oe++){const it=O[Oe],tt=N[Oe],ze=Oe+1<Q?N[Oe+1]:J;for(ae=it-K+1,Ue=it;Ue<ze;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=be(se,oe,Oe,fe,Ie,T,Ue,J,K,ee[x-1][ae-1]===0,Qe));let X=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,X=st+Z[x-1][ae-1]);const pe=Ue>it,je=pe?Z[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,Ne=Ue>it+1&&ee[x][ae-1]>0,Xe=Ne?Z[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(Ne&&(!pe||Xe>=je)&&(!_||Xe>=X))Z[x][ae]=Xe,ye[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||je>=X))Z[x][ae]=je,ye[x][ae]=2,ee[x][ae]=0;else if(_)Z[x][ae]=X,ye[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(De&&Y(se,fe,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[Z[x][ae],K];let et=0,Ye=0;for(;x>=1;){let it=ae;do{const tt=ye[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&oe[fe+x-1]===T[K+ae-1]&&!ce(it+K-1,Ie,T)&&et+1>ee[x][it]&&(it=ae),it===ae?et++:et=1,Ye||(Ye=it),x--,ae=it-1,He.push(ae)}J===Q&&G.boostFullMatch&&(He[0]+=2);const xe=Ye-Q;return He[0]-=xe,He}e.$Kj=ue;function we(se,oe,fe,Ie,T,K){let G=se-1,Q=oe-1;for(;G>=fe&&Q>=Ie;)T[G]===K[Q]&&(N[G]=Q,G--),Q--}function be(se,oe,fe,Ie,T,K,G,Q,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Oe=1,Ue=!1;return G===fe-Ie?Oe=se[fe]===T[G]?7:5:ce(G,T,K)&&(G===0||!ce(G-1,T,K))?(Oe=se[fe]===T[G]?7:5,Ue=!0):le(K,G)&&(G===0||!le(K,G-1))?Oe=5:(le(K,G-1)||Ee(K,G-1))&&(Oe=5,Ue=!0),Oe>1&&fe===Ie&&(ae[0]=!0),Ue||(Ue=ce(G,T,K)||le(K,G-1)||Ee(K,G-1)),fe===Ie?G>J&&(Oe-=Ue?3:5):x?Oe+=Ue?2:0:Oe+=Ue?0:1,G+1===Q&&(Oe-=Ue?3:5),Oe}function ge(se,oe,fe,Ie,T,K,G){return re(se,oe,fe,Ie,T,K,!0,G)}e.$Lj=ge;function ke(se,oe,fe,Ie,T,K,G){return re(se,oe,fe,Ie,T,K,!1,G)}e.$Mj=ke;function re(se,oe,fe,Ie,T,K,G,Q){let J=ue(se,oe,fe,Ie,T,K,Q);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=fe+1;ae<x;ae++){const Oe=he(se,ae);if(Oe){const Ue=ue(Oe,Oe.toLowerCase(),fe,Ie,T,K,Q);Ue&&(Ue[0]-=3,(!J||Ue[0]>J[0])&&(J=Ue))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const F="error",A="warning",h="warn",k="info",m="ignore";function P(c){return c?w.$Me(F,c)?C.Error:w.$Me(A,c)||w.$Me(h,c)?C.Warning:w.$Me(k,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function D(c){switch(c){case C.Error:return F;case C.Warning:return A;case C.Info:return k;default:return m}}C.toString=D}(M||(M={})),e.default=M}),define(Ae[121],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class C{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),g=this.b.charCodeAt(this.c);return p-g}value(){return this.b[this.c]}}e.$Dh=C;class F{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,M.$Ge)(v,this.b,0,v.length,this.c,this.d):(0,M.$Ie)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=F;class A{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const g=this.b.charCodeAt(p);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,M.$Ge)(v,this.b,0,v.length,this.d,this.e):(0,M.$Ie)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=A;var h;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(h||(h={}));class k{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,M.$He)(v,this.c.scheme);if(this.d[this.e]===2)return(0,M.$He)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,M.$Fe)(v,this.c.query);if(this.d[this.e]===5)return(0,M.$Fe)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=k;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(P||(P={}));class D{static forUris(v=()=>!1,p=()=>!1){return new D(new k(v,p))}static forPaths(v=!1){return new D(new A(void 0,!v))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new F)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const g=p.slice(0);(0,w.$Vb)(g);for(const t of g)this.set(t,v)}else{const g=v.slice(0);(0,w.$Vb)(g);for(const t of g)this.set(t[0],t[1])}}set(v,p){const g=this.b.reset(v);let t;this.c||(this.c=new m,this.c.segment=g.value());const i=[];for(t=this.c;;){const d=g.cmp(t.segment);if(d>0)t.left||(t.left=new m,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(d<0)t.right||(t.right=new m,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new m,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const s=t.value;t.value=p,t.key=v;for(let d=i.length-1;d>=0;d--){const y=i[d][1];y.updateHeight();const $=y.balanceFactor();if($<-1||$>1){const r=i[d][0],o=i[d+1][0];if(r===1&&o===1)i[d][1]=y.rotateLeft();else if(r===-1&&o===-1)i[d][1]=y.rotateRight();else if(r===1&&o===-1)y.right=i[d+1][1]=i[d+1][1].rotateRight(),i[d][1]=y.rotateLeft();else if(r===-1&&o===1)y.left=i[d+1][1]=i[d+1][1].rotateLeft(),i[d][1]=y.rotateRight();else throw new Error;if(d>0)switch(i[d-1][0]){case-1:i[d-1][1].left=i[d][1];break;case 1:i[d-1][1].right=i[d][1];break;case 0:i[d-1][1].mid=i[d][1];break}else this.c=i[0][1]}}return s}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let g=this.c;for(;g;){const t=p.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else break}return g}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const g=this.b.reset(v),t=[];let i=this.c;for(;i;){const s=g.cmp(i.segment);if(s>0)t.push([-1,i]),i=i.left;else if(s<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const s=this.f(i.right);if(s.key){const{key:d,value:y,segment:$}=s;this.e(s.key,!1),i.key=d,i.value=y,i.segment=$}}else{const s=i.left??i.right;if(t.length>0){const[d,y]=t[t.length-1];switch(d){case-1:y.left=s;break;case 0:y.mid=s;break;case 1:y.right=s;break}}else this.c=s}for(let s=t.length-1;s>=0;s--){const d=t[s][1];d.updateHeight();const y=d.balanceFactor();if(y>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),t[s][1]=d.rotateLeft()):y<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),t[s][1]=d.rotateRight()),s>0)switch(t[s-1][0]){case-1:t[s-1][1].left=t[s][1];break;case 1:t[s-1][1].right=t[s][1];break;case 0:t[s-1][1].mid=t[s][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let g=this.c,t;for(;g;){const i=p.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(p.hasNext())p.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(v){return this.g(v,!1)}g(v,p){const g=this.b.reset(v);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,g]of this)v(g,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const g=p.balanceFactor();return g<-1||g>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$Hh=D}),define(Ae[40],Re([1,0,89]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var M;(function(A){function h(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=h})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Qj=C;var F;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(s){const d=h.exec(s.id);if(!d)return k(w.$Pj.error);const[,y,$]=d,r=["codicon","codicon-"+y];return $&&r.push("codicon-modifier-"+$.substring(1)),r}A.asClassNameArray=k;function m(s){return k(s).join(" ")}A.asClassName=m;function P(s){return"."+k(s).join(".")}A.asCSSSelector=P;function D(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||M.isThemeColor(s.color))}A.isThemeIcon=D;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function v(s){const d=c.exec(s);if(!d)return;const[,y]=d;return{id:y}}A.fromString=v;function p(s){return{id:s}}A.fromId=p;function g(s,d){let y=s.id;const $=y.lastIndexOf("~");return $!==-1&&(y=y.substring(0,$)),d&&(y=`${y}~${d}`),{id:y}}A.modify=g;function t(s){const d=s.id.lastIndexOf("~");if(d!==-1)return s.id.substring(d+1)}A.getModifier=t;function i(s,d){return s.id===d.id&&s.color?.id===d.color?.id}A.isEqual=i})(F||(e.ThemeIcon=F={}))}),define(Ae[122],Re([1,0,120,15,40]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=void 0;const F="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${A.source}`,"g");function k(i){return i.replace(h,(s,d)=>d?s:`\\${s}`)}e.$Rj=k;const m=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(m,s=>`\\${s}`)}e.$Sj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(i){return i.indexOf(F)===-1?i:i.replace(D,(s,d,y,$)=>y?s:d||$||"")}e.$Tj=c;function v(i){return i?i.replace(/\$\((.*?)\)/g,(s,d)=>` ${d} `).trim():""}e.$Uj=v;const p=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){p.lastIndex=0;let s="";const d=[];let y=0;for(;;){const $=p.lastIndex,r=p.exec(i),o=i.substring($,r?.index);if(o.length>0){s+=o;for(let n=0;n<o.length;n++)d.push(y)}if(!r)break;y+=r[0].length}return{text:s,iconOffsets:d}}e.$Vj=g;function t(i,s,d=!1){const{text:y,iconOffsets:$}=s;if(!$||$.length===0)return(0,w.$Ej)(i,y,d);const r=(0,M.$ue)(y," "),o=y.length-r.length,n=(0,w.$Ej)(i,r,d);if(n)for(const a of n){const E=$[a.start+o]+o;a.start+=E,a.end+=E}return n}e.$Wj=t}),define(Ae[36],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return w.test(C)}e.$3f=M,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(h){for(let k=0;k<h.length;k++)h[k]=Math.floor(Math.random()*256);return h};const F=new Uint8Array(16),A=[];for(let h=0;h<256;h++)A.push(h.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let k=0,m="";return m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m+="-",m+=A[F[k++]],m+=A[F[k++]],m+="-",m+=A[F[k++]],m+=A[F[k++]],m+="-",m+=A[F[k++]],m+=A[F[k++]],m+="-",m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m+=A[F[k++]],m}}()}),define(Ae[123],Re([1,0,18,67,36]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=e.$Qs=e.$Ps=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ps=F;function A(D,c,v){const p={id:(0,C.$4f)(),name:D,uri:c,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$Qs=A;class h{constructor(){this.a=new Map}get size(){let c=0;for(const v of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const v=[...this.a.keys()];return M.Iterable.some(this,([p,g])=>g.asFile())&&v.push("files"),P(k(c),v)}get(c){return this.a.get(this.b(c))?.[0]}append(c,v){const p=this.a.get(c);p?p.push(v):this.a.set(this.b(c),[v])}replace(c,v){this.a.set(this.b(c),[v])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,v]of this.a)for(const p of v)yield[c,p]}b(c){return k(c)}}e.$Rs=h;function k(D){return D.toLowerCase()}function m(D,c){return P(k(D),c.map(k))}e.$Ss=m;function P(D,c){if(D==="*/*")return c.length>0;if(c.includes(D))return!0;const v=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,g,t]=v;return t==="*"?c.some(i=>i.startsWith(g+"/")):!1}e.$Ts=Object.freeze({create:D=>(0,w.$Kb)(D.map(c=>c.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ts.split(D).filter(c=>!c.startsWith("#"))})}),define(Ae[124],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0,e.$Ur={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[125],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(h){if(this.e=null,this.f=!1,this.open=h.open,this.close=h.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(h.notIn))for(let k=0,m=h.notIn.length;k<m;k++)switch(h.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(h,k){if(h.getTokenCount()===0)return!0;const m=h.findTokenIndexAtOffset(k-2),P=h.getStandardTokenType(m);return this.isOK(P)}g(h,k){for(let m=h;m<=k;m++){const P=String.fromCharCode(m);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$gt=M;class C{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of h)F(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),F(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),F(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),F(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&F(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$ht=C;function F(A,h,k){A.has(h)?A.get(h).push(k):A.set(h,[k])}}),define(Ae[126],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7=e.$q7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const A=this.a.get(F);return this.a.delete(F),A}}addDragOperationTransfer(F,A){this.a.set(F,A)}}e.$q7=w;class M{constructor(F){this.identifier=F}}e.$r7=M}),define(Ae[127],Re([10,11]),function(ve,e){return ve.create("vs/base/common/actions",e)}),define(Ae[128],Re([1,0,5,6,127]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class F extends M.$kc{constructor(c,v="",p="",g=!0,t){super(),this.h=this.B(new w.$fd),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=v,this.u=p,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,v){this.C&&await this.C(c)}}e.$gi=F;class A extends M.$kc{constructor(){super(...arguments),this.f=this.B(new w.$fd),this.onWillRun=this.f.event,this.m=this.B(new w.$fd),this.onDidRun=this.m.event}async run(c,v){if(!c.enabled)return;this.f.fire({action:c});let p;try{await this.u(c,v)}catch(g){p=g}this.m.fire({action:c,error:p})}async u(c,v){await c.run(v)}}e.$hi=A;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let v=[];for(const p of c)p.length&&(v.length?v=[...v,new h,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$ii=h;class k{get actions(){return this.a}constructor(c,v,p,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=v,this.class=g,this.a=p}async run(){}}e.$ji=k;class m extends F{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,C.localize(0,null),void 0,!1)}}e.$ki=m;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...c)=>D.run(),tooltip:D.label}}e.$li=P}),define(Ae[129],Re([10,11]),function(ve,e){return ve.create("vs/base/common/date",e)}),define(Ae[130],Re([1,0,129]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const M=60,C=M*60,F=C*24,A=F*7,h=F*30,k=F*365;function m(D,c,v,p){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,w.localize)(0,null,m(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,w.localize)(1,null);let t;return g<M?(t=g,c?t===1?v?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):v?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?v?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):v?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):g<C?(t=Math.floor(g/M),c?t===1?v?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):v?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?v?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):v?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):g<F?(t=Math.floor(g/C),c?t===1?v?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):v?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?v?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):v?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):g<A?(t=Math.floor(g/F),c?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):g<h?(t=Math.floor(g/A),c?t===1?v?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):v?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?v?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):v?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):g<k?(t=Math.floor(g/h),c?t===1?v?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):v?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?v?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):v?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(g/k),c?t===1?v?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):v?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?v?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):v?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$6l=m;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=P}),define(Ae[131],Re([10,11]),function(ve,e){return ve.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,131]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function F(D,c){return c&&(D.stack||D.stacktrace)?C.localize(0,null,h(D),A(D.stack)||A(D.stacktrace)):h(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function h(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function k(D=null,c=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const v=w.$Fb(D),p=k(v[0],c);return v.length>1?C.localize(4,null,p,v.length):p}if(M.$jf(D))return D;if(D.detail){const v=D.detail;if(v.error)return F(v.error,c);if(v.exception)return F(v.exception,c)}return D.stack?F(D,c):D.message?D.message:C.localize(5,null)}e.$mi=k;function m(D){const c=D;return c instanceof Error&&Array.isArray(c.actions)}e.$ni=m;function P(D,c){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=c,v}e.$oi=P}),define(Ae[132],Re([1,0,66,19]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=void 0;const C=new w.$T(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(I,u,f=!1){const l=I||"",R=u||"",B=C.value.collator.compare(l,R);return C.value.collatorIsNumeric&&B===0&&l!==R?l<R?-1:1:B}e.$0p=h;function k(I,u){const f=F.value.collator;return I=I||"",u=u||"",y(f,I,u)}e.$$p=k;function m(I,u){const f=F.value.collator;return I=I||"",u=u||"",n(I,u)||y(f,I,u)}e.$_p=m;function P(I,u){const f=F.value.collator;return I=I||"",u=u||"",o(I,u)||y(f,I,u)}e.$aq=P;function D(I,u){return I=I||"",u=u||"",I===u?0:I<u?-1:1}e.$bq=D;function c(I,u){const[f,l]=s(I),[R,B]=s(u);let V=C.value.collator.compare(l,B);if(V===0){if(C.value.collatorIsNumeric&&l!==B)return l<B?-1:1;if(V=C.value.collator.compare(f,R),C.value.collatorIsNumeric&&V===0&&f!==R)return f<R?-1:1}return V}e.$cq=c;function v(I,u){I=I||"",u=u||"";const f=d(I),l=d(u),R=F.value.collator,B=A.value.collator;return y(B,f,l)||y(R,I,u)}e.$dq=v;function p(I,u){I=I||"",u=u||"";const f=d(I),l=d(u),R=F.value.collator,B=A.value.collator;return y(B,f,l)||n(I,u)||y(R,I,u)}e.$eq=p;function g(I,u){I=I||"",u=u||"";const f=d(I),l=d(u),R=F.value.collator,B=A.value.collator;return y(B,f,l)||o(I,u)||y(R,I,u)}e.$fq=g;function t(I,u){I=I||"",u=u||"";const f=d(I).toLowerCase(),l=d(u).toLowerCase();return f!==l?f<l?-1:1:I!==u?I<u?-1:1:0}e.$gq=t;const i=/^(.*?)(\.([^.]*))?$/;function s(I,u=!1){const f=I?i.exec(I):[];let l=[f&&f[1]||"",f&&f[3]||""];return u&&(!l[0]&&l[1]||l[0]&&l[0].charAt(0)===".")&&(l=[l[0]+"."+l[1],""]),l}function d(I){const u=I?i.exec(I):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function y(I,u,f){const l=I.compare(u,f);return l!==0?l:u.length!==f.length?u.length<f.length?-1:1:0}function $(I){const u=I.charAt(0);return u.toLocaleUpperCase()!==u}function r(I){const u=I.charAt(0);return u.toLocaleLowerCase()!==u}function o(I,u){return $(I)&&r(u)?-1:r(I)&&$(u)?1:0}function n(I,u){return r(I)&&$(u)?-1:$(I)&&r(u)?1:0}function a(I,u,f=!1){return f||(I=I&&I.toLowerCase(),u=u&&u.toLowerCase()),I===u?0:I<u?-1:1}function E(I,u,f=!1){const l=I.split(M.sep),R=u.split(M.sep),B=l.length-1,V=R.length-1;let U,W;for(let O=0;;O++){if(U=B===O,W=V===O,U&&W)return h(l[O],R[O],f);if(U)return-1;if(W)return 1;const N=a(l[O],R[O],f);if(N!==0)return N}}e.$hq=E;function b(I,u,f){const l=I.toLowerCase(),R=u.toLowerCase(),B=S(I,u,f);if(B)return B;const V=l.endsWith(f),U=R.endsWith(f);if(V!==U)return V?-1:1;const W=h(l,R);return W!==0?W:l.localeCompare(R)}e.$iq=b;function S(I,u,f){const l=I.toLowerCase(),R=u.toLowerCase(),B=l.startsWith(f),V=R.startsWith(f);if(B!==V)return B?-1:1;if(B&&V){if(l.length<R.length)return-1;if(l.length>R.length)return 1}return 0}e.$jq=S}),define(Ae[42],Re([1,0,19,22,15,16]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function A(b){return b===47||b===92}e.$Bf=A;function h(b){return b.replace(/[\\/]/g,w.$6d.sep)}e.$Cf=h;function k(b){return b.indexOf("/")===-1&&(b=h(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.$Df=k;function m(b,S=w.$6d.sep){if(!b)return"";const I=b.length,u=b.charCodeAt(0);if(A(u)){if(A(b.charCodeAt(1))&&!A(b.charCodeAt(2))){let l=3;const R=l;for(;l<I&&!A(b.charCodeAt(l));l++);if(R!==l&&!A(b.charCodeAt(l+1))){for(l+=1;l<I;l++)if(A(b.charCodeAt(l)))return b.slice(0,l+1).replace(/[\\/]/g,S)}}return S}else if(i(u)&&b.charCodeAt(1)===58)return A(b.charCodeAt(2))?b.slice(0,2)+S:b.slice(0,2);let f=b.indexOf("://");if(f!==-1){for(f+=3;f<I;f++)if(A(b.charCodeAt(f)))return b.slice(0,f+1)}return""}e.$Ef=m;function P(b){if(!M.$i||!b||b.length<5)return!1;let S=b.charCodeAt(0);if(S!==92||(S=b.charCodeAt(1),S!==92))return!1;let I=2;const u=I;for(;I<b.length&&(S=b.charCodeAt(I),S!==92);I++);return!(u===I||(S=b.charCodeAt(I+1),isNaN(S)||S===92))}e.$Ff=P;const D=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(b,S=M.$i){const I=S?D:c;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||S&&v.test(b)||b==="."||b===".."||S&&b[b.length-1]==="."||S&&b.length!==b.trim().length||b.length>255)}e.$Gf=p;function g(b,S,I){const u=b===S;return!I||u?u:!b||!S?!1:(0,C.$Me)(b,S)}e.$Hf=g;function t(b,S,I,u=w.sep){if(b===S)return!0;if(!b||!S||S.length>b.length)return!1;if(I){if(!(0,C.$Ne)(b,S))return!1;if(S.length===b.length)return!0;let l=S.length;return S.charAt(S.length-1)===u&&l--,b.charAt(l)===u}return S.charAt(S.length-1)!==u&&(S+=u),b.indexOf(S)===0}e.$If=t;function i(b){return b>=65&&b<=90||b>=97&&b<=122}e.$Jf=i;function s(b,S){return M.$i&&b.endsWith(":")&&(b+=w.sep),(0,w.$8d)(b)||(b=(0,w.$9d)(S,b)),b=(0,w.$7d)(b),M.$i?(b=(0,C.$ve)(b,w.sep),b.endsWith(":")&&(b+=w.sep)):(b=(0,C.$ve)(b,w.sep),b||(b=w.sep)),b}e.$Kf=s;function d(b){const S=(0,w.$7d)(b);return M.$i?b.length>3?!1:y(S)&&(b.length===2||S.charCodeAt(2)===92):S===w.$6d.sep}e.$Lf=d;function y(b,S=M.$i){return S?i(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.$Mf=y;function $(b,S=M.$i){return y(b,S)?b[0]:void 0}e.$Nf=$;function r(b,S,I){return S.length>b.length?-1:b===S?0:(I&&(b=b.toLowerCase(),S=S.toLowerCase()),b.indexOf(S))}e.$Of=r;function o(b){const S=b.split(":");let I,u,f;for(const l of S){const R=Number(l);(0,F.$nf)(R)?u===void 0?u=R:f===void 0&&(f=R):I=I?[I,l].join(":"):l}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:u!==void 0?u:void 0,column:f!==void 0?f:u!==void 0?1:void 0}}e.$Pf=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(b,S,I=8){let u="";for(let l=0;l<I;l++){let R;l===0&&M.$i&&!S&&(I===3||I===4)?R=a:R=n,u+=R.charAt(Math.floor(Math.random()*R.length))}let f;return S?f=`${S}-${u}`:f=u,b?(0,w.$9d)(b,f):f}e.$Qf=E}),define(Ae[68],Re([1,0,19]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(P){const D=(0,w.$be)(P),c=M[D.toLowerCase()];return c!==void 0?c:A(P)}e.$Ir=F;function A(P){const D=(0,w.$be)(P);return C[D.toLowerCase()]}e.$Jr=A;function h(P){for(const D in C)if(C[D]===P)return D}e.$Kr=h;const k=/^(.+)\/(.+?)(;.+)?$/;function m(P,D){const c=k.exec(P);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:D?void 0:P}e.$Lr=m}),define(Ae[69],Re([1,0,25,2]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function C(k){return JSON.stringify(k,A)}e.$9g=C;function F(k){let m=JSON.parse(k);return m=h(m),m}e.$0g=F;function A(k,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function h(k,m=0){if(!k||m>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof w.$Fd||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=h(k[P],m+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=h(k[P],m+1))}return k}e.$$g=h}),define(Ae[13],Re([1,0,9,22,2]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var F;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${F.vscodeRemoteResource}`}set(P,D,c){this.a[P]=D,this.b[P]=c}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Y(t),P}const D=P.authority;let c=this.a[D];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const v=this.b[D],p=this.c[D];let g=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(g+=`&${e.$Vf}=${encodeURIComponent(p)}`),C.URI.from({scheme:M.$o?this.d:F.vscodeRemoteResource,authority:`${c}:${v}`,path:this.f,query:g})}}e.$Wf=new A,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class h{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,ve);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===F.vscodeRemote?e.$Wf.rewrite(P):P.scheme===F.file&&(M.$m||M.$p&&M.$g.origin===`${F.vscodeFileResource}://${h.a}`)?P.with({scheme:F.vscodeFileResource,authority:P.authority||h.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,ve);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===F.vscodeFileResource?P.with({scheme:F.file,authority:P.authority!==h.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return C.URI.isUri(P)?P:C.URI.parse(D.toUrl(P))}}e.$2f=new h;var k;(function(m){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function c(p){let g;typeof p=="string"?g=new URL(p).searchParams:p instanceof URL?g=p.searchParams:C.URI.isUri(p)&&(g=new URL(p.toString(!0)).searchParams);const t=g?.get(D);if(t)return P.get(t)}m.getHeadersFromQuery=c;function v(p,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,i):p[D]=i}m.addSearchParam=v})(k||(e.COI=k={}))}),define(Ae[23],Re([1,0,42,13,19,22,15,2]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function k(v){return(0,h.$Tf)(v,!0)}e.$9f=k;class m{constructor(p){this.a=p}compare(p,g,t=!1){return p===g?0:(0,A.$Fe)(this.getComparisonKey(p,t),this.getComparisonKey(g,t))}isEqual(p,g,t=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,t)===this.getComparisonKey(g,t)}getComparisonKey(p,g=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,g,t=!1){if(p.scheme===g.scheme){if(p.scheme===M.Schemas.file)return w.$If(k(p),k(g),this.a(p))&&p.query===g.query&&(t||p.fragment===g.fragment);if((0,e.$ng)(p.authority,g.authority))return w.$If(p.path,g.path,this.a(p),"/")&&p.query===g.query&&(t||p.fragment===g.fragment)}return!1}joinPath(p,...g){return h.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.$fg)(p)||p.authority}basename(p){return C.$6d.basename(p.path)}extname(p){return C.$6d.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===M.Schemas.file?g=h.URI.file(C.$_d(k(p))).path:(g=C.$6d.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===M.Schemas.file?g=h.URI.file(C.$7d(k(p))).path:g=C.$6d.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.$ng)(p.authority,g.authority))return;if(p.scheme===M.Schemas.file){const s=C.$$d(k(p),k(g));return F.$i?w.$Cf(s):s}let t=p.path||"/";const i=g.path||"/";if(this.a(p)){let s=0;for(const d=Math.min(t.length,i.length);s<d&&!(t.charCodeAt(s)!==i.charCodeAt(s)&&t.charAt(s).toLowerCase()!==i.charAt(s).toLowerCase());s++);t=i.substr(0,s)+t.substr(s)}return C.$6d.relative(t,i)}resolvePath(p,g){if(p.scheme===M.Schemas.file){const t=h.URI.file(C.$0d(k(p),g));return p.with({authority:t.authority,path:t.path})}return g=w.$Df(g),p.with({path:C.$6d.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,A.$Me)(p,g)}hasTrailingPathSeparator(p,g=C.sep){if(p.scheme===M.Schemas.file){const t=k(p);return t.length>w.$Ef(t).length&&t[t.length-1]===g}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=C.sep){return(0,e.$og)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=C.sep){let t=!1;if(p.scheme===M.Schemas.file){const i=k(p);t=i!==void 0&&i.length===w.$Ef(i).length&&i[i.length-1]===g}else{g="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$og)(p,g)?p.with({path:p.path+"/"}):p}}e.$0f=m,e.$$f=new m(()=>!1),e.$_f=new m(v=>v.scheme===M.Schemas.file?!F.$k:!0),e.$ag=new m(v=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function P(v,p){const g=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((s,d)=>d===t?!1:(0,e.$cg)(i,p(s)))||g.push(v[t])}return g}e.$rg=P;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[y,$]=d.split(":");y&&$&&t.set(y,$)});const s=g.path.substring(0,g.path.indexOf(";"));return s&&t.set(v.META_DATA_MIME,s),t}v.parseMetaData=p})(D||(e.DataUri=D={}));function c(v,p,g){if(p){let t=v.path;return t&&t[0]!==C.$6d.sep&&(t=C.$6d.sep+t),v.with({scheme:g,authority:p,path:t})}return v.with({scheme:g})}e.$sg=c}),define(Ae[12],Re([1,0,21,9,5,6,23,22,121]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function m(z){return!!z&&typeof z.then=="function"}e.$tg=m;function P(z){const q=new w.$pd,ue=z(q.token),we=new Promise((be,ge)=>{const ke=q.token.onCancellationRequested(()=>{ke.dispose(),q.dispose(),ge(new M.$3)});Promise.resolve(ue).then(re=>{ke.dispose(),q.dispose(),be(re)},re=>{ke.dispose(),q.dispose(),ge(re)})});return new class{cancel(){q.cancel()}then(be,ge){return we.then(be,ge)}catch(be){return this.then(void 0,be)}finally(be){return we.finally(be)}}}e.$ug=P;function D(z,q,ue){return new Promise((we,be)=>{const ge=q.onCancellationRequested(()=>{ge.dispose(),we(ue)});z.then(we,be).finally(()=>ge.dispose())})}e.$vg=D;function c(z,q){return new Promise((ue,we)=>{const be=q.onCancellationRequested(()=>{be.dispose(),we(new M.$3)});z.then(ue,we).finally(()=>be.dispose())})}e.$wg=c;async function v(z){let q=-1;const ue=z.map((we,be)=>we.then(ge=>(q=be,ge)));try{return await Promise.race(ue)}finally{z.forEach((we,be)=>{be!==q&&we.cancel()})}}e.$xg=v;function p(z,q,ue){let we;const be=setTimeout(()=>{we?.(void 0),ue?.()},q);return Promise.race([z.finally(()=>clearTimeout(be)),new Promise(ge=>we=ge)])}e.$yg=p;function g(z){return new Promise((q,ue)=>{const we=z();m(we)?we.then(q,ue):q(we)})}e.$zg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const ue=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ue,ue).then(we)})}return new Promise((ue,we)=>{this.b.then(ue,we)})}return this.a=q(),new Promise((ue,we)=>{this.a.then(be=>{this.a=null,ue(be)},be=>{this.a=null,we(be)})})}dispose(){this.f=!0}}e.$Ag=t;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Bg=i;class s{constructor(){this.a=new Map}queue(q,ue){const be=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(q)===be&&this.a.delete(q)});return this.a.set(q,be),be}}e.$Cg=s;const d=(z,q)=>{let ue=!0;const we=setTimeout(()=>{ue=!1,q()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(we),ue=!1}}},y=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class ${constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ue=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((be,ge)=>{this.d=be,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ue===k.$cd?y(we):d(ue,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=$;class r{constructor(q){this.a=new $(q),this.b=new t}trigger(q,ue){return this.a.trigger(()=>this.b.queue(q),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=r;class o{constructor(){this.a=!1,this.b=new Promise((q,ue)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=o;class n extends o{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Gg=n;function a(z,q){return q?new Promise((ue,we)=>{const be=setTimeout(()=>{ge.dispose(),ue()},z),ge=q.onCancellationRequested(()=>{clearTimeout(be),ge.dispose(),we(new M.$3)})}):P(ue=>a(z,ue))}e.$Hg=a;function E(z,q=0,ue){const we=setTimeout(()=>{z(),ue&&be.dispose()},q),be=(0,F.$ic)(()=>{clearTimeout(we),ue?.deleteAndLeak(be)});return ue?.add(be),be}e.$Ig=E;function b(z){const q=[];let ue=0;const we=z.length;function be(){return ue<we?z[ue++]():null}function ge(ke){ke!=null&&q.push(ke);const re=be();return re?re.then(ge):Promise.resolve(q)}return Promise.resolve(null).then(ge)}e.$Jg=b;function S(z,q=we=>!!we,ue=null){let we=0;const be=z.length,ge=()=>{if(we>=be)return Promise.resolve(ue);const ke=z[we++];return Promise.resolve(ke()).then(he=>q(he)?Promise.resolve(he):ge())};return ge()}e.$Kg=S;function I(z,q=we=>!!we,ue=null){if(z.length===0)return Promise.resolve(ue);let we=z.length;const be=()=>{we=-1;for(const ge of z)ge.cancel?.()};return new Promise((ge,ke)=>{for(const re of z)re.then(he=>{--we>=0&&q(he)?(be(),ge(he)):we===0&&ge(ue)}).catch(he=>{--we>=0&&(be(),ke(he))})})}e.$Lg=I;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((ue,we)=>{this.f.push({factory:q,c:ue,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const ue=q.factory();ue.then(q.c,q.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=u;class f extends u{constructor(){super(1)}}e.$Ng=f;class l{constructor(){this.a=new ye,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Og=l;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Y;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,ue=A.$$f){const we=ue.getComparisonKey(q);let be=this.a.get(we);if(!be){be=new f;const ge=this.f++,ke=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$sc),this.d.set(ge,ke),this.a.set(we,be)}return be}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=R;class B{constructor(q,ue){this.a=-1,typeof q=="function"&&typeof ue=="number"&&this.setIfNotSet(q,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ue)}setIfNotSet(q,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ue))}}e.$Qg=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setInterval(()=>{q()},ue)}}e.$Rg=V;class U{constructor(q,ue){this.b=-1,this.a=q,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=U;class W{constructor(q,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=q,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=W;class O extends U{constructor(q,ue){super(q,ue),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Ug=O;class N extends F.$kc{constructor(q,ue){super(),this.g=q,this.h=ue,this.a=[],this.b=this.B(new F.$lc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of q)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=z=>{(0,h.$A)(()=>{if(q)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Wg=(z,q)=>{const ue=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ue))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=ee;async function Z(z,q,ue){let we;for(let be=0;be<ue;be++)try{return await z()}catch(ge){we=ge,await a(q)}throw we}e.$Yg=Z;class ye{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,ue,we){return this.a={taskId:q,cancel:()=>we?.(),promise:ue},ue.then(()=>this.d(q),()=>this.d(q)),ue}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let ue,we;const be=new Promise((ge,ke)=>{ue=ge,we=ke});this.b={run:q,promise:be,promiseResolve:ue,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=ye;class De{constructor(q,ue=()=>Date.now()){this.d=q,this.f=ue,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$1g=De;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class Y{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,ue)=>{this.a=q,this.b=ue})}complete(q){return new Promise(ue=>{this.a(q),this.d={outcome:0,value:q},ue()})}error(q){return new Promise(ue=>{this.b(q),this.d={outcome:1,value:q},ue()})}cancel(){return this.error(new M.$3)}}e.$2g=Y;var le;(function(z){async function q(we){let be;const ge=await Promise.all(we.map(ke=>ke.then(re=>re,re=>{be||(be=re)})));if(typeof be<"u")throw be;return ge}z.settled=q;function ue(we){return new Promise(async(be,ge)=>{try{await we(be,ge)}catch(ke){ge(ke)}})}z.withAsyncBody=ue})(le||(e.Promises=le={}));var Ee;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Ee||(Ee={}));class ce{static fromArray(q){return new ce(ue=>{ue.emitMany(q)})}static fromPromise(q){return new ce(async ue=>{ue.emitMany(await q)})}static fromPromises(q){return new ce(async ue=>{await Promise.all(q.map(async we=>ue.emitOne(await we)))})}static merge(q){return new ce(async ue=>{await Promise.all(q.map(async we=>{for await(const be of we)ue.emitOne(be)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$fd,queueMicrotask(async()=>{const ue={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(ue)),this.j()}catch(we){this.k(we)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,ue){return new ce(async we=>{for await(const be of q)we.emitOne(ue(be))})}map(q){return ce.map(this,q)}static filter(q,ue){return new ce(async we=>{for await(const be of q)ue(be)&&we.emitOne(be)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,ue=>!!ue)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const ue=[];for await(const we of q)ue.push(we);return ue}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$3g=ce;class $e extends ce{constructor(q,ue){super(ue),this.l=q}cancel(){this.l.cancel()}}e.$4g=$e;function ie(z){const q=new w.$pd,ue=z(q.token);return new $e(q,async we=>{const be=q.token.onCancellationRequested(()=>{be.dispose(),q.dispose(),we.reject(new M.$3)});try{for await(const ge of ue){if(q.token.isCancellationRequested)return;we.emitOne(ge)}be.dispose(),q.dispose()}catch(ge){be.dispose(),q.dispose(),we.reject(ge)}})}e.$5g=ie}),define(Ae[37],Re([1,0,18,12,42,28,19,22,15]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function m(){return Object.create(null)}e.$mj=m,e.$nj="**",e.$oj="/";const P="[/\\\\]",D="[^/\\\\]",c=/\//g;function v(ye,De){switch(ye){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${De?`|${P}${D}+`:""})*?`}}function p(ye,De){if(!ye)return[];const Pe=[];let Y=!1,le=!1,Ee="";for(const ce of ye){switch(ce){case De:if(!Y&&!le){Pe.push(Ee),Ee="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":le=!0;break;case"]":le=!1;break}Ee+=ce}return Ee&&Pe.push(Ee),Pe}e.$pj=p;function g(ye){if(!ye)return"";let De="";const Pe=p(ye,e.$oj);if(Pe.every(Y=>Y===e.$nj))De=".*";else{let Y=!1;Pe.forEach((le,Ee)=>{if(le===e.$nj){if(Y)return;De+=v(2,Ee===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of le){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let ue;q==="-"?ue=q:(q==="^"||q==="!")&&!z?ue="^":q===e.$oj?ue="":ue=(0,k.$qe)(q),z+=ue;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${p($e,",").map(be=>g(be)).join("|")})`;De+=we,ce=!1,$e="";break}case"]":{De+="["+z+"]",ie=!1,z="";break}case"?":De+=D;continue;case"*":De+=v(1);continue;default:De+=(0,k.$qe)(q)}}Ee<Pe.length-1&&(Pe[Ee+1]!==e.$nj||Ee+2<Pe.length)&&(De+=P)}Y=le===e.$nj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.$Ci(1e4),o=function(){return!1},n=function(){return null};function a(ye,De){if(!ye)return n;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const Y=`${Pe}_${!!De.trimForExclusions}`;let le=r.get(Y);if(le)return E(le,ye);let Ee;return t.test(Pe)?le=S(Pe.substr(4),Pe):(Ee=i.exec(b(Pe,De)))?le=I(Ee[1],Pe):(De.trimForExclusions?d:s).test(Pe)?le=u(Pe,De):(Ee=y.exec(b(Pe,De)))?le=f(Ee[1].substr(1),Pe,!0):(Ee=$.exec(b(Pe,De)))?le=f(Ee[1],Pe,!1):le=l(Pe),r.set(Y,le),E(le,ye)}function E(ye,De){if(typeof De=="string")return ye;const Pe=function(Y,le){return(0,C.$If)(Y,De.base,!h.$k)?ye((0,k.$ue)(Y.substr(De.base.length),A.sep),le):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function b(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function S(ye,De){return function(Pe,Y){return typeof Pe=="string"&&Pe.endsWith(ye)?De:null}}function I(ye,De){const Pe=`/${ye}`,Y=`\\${ye}`,le=function(ce,$e){return typeof ce!="string"?null:$e?$e===ye?De:null:ce===ye||ce.endsWith(Pe)||ce.endsWith(Y)?De:null},Ee=[ye];return le.basenames=Ee,le.patterns=[De],le.allBasenames=Ee,le}function u(ye,De){const Pe=ee(ye.slice(1,-1).split(",").map($e=>a($e,De)).filter($e=>$e!==n),ye),Y=Pe.length;if(!Y)return n;if(Y===1)return Pe[0];const le=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return ye;return null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function f(ye,De,Pe){const Y=A.sep===A.$6d.sep,le=Y?ye:ye.replace(c,A.sep),Ee=A.sep+le,ce=A.$6d.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===le||ie.endsWith(Ee)||!Y&&(ie===ye||ie.endsWith(ce)))?De:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===le||!Y&&ie===ye)?De:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function l(ye){try{const De=new RegExp(`^${g(ye)}$`);return function(Pe){return De.lastIndex=0,typeof Pe=="string"&&De.test(Pe)?ye:null}}catch{return n}}function R(ye,De,Pe){return!ye||typeof De!="string"?!1:B(ye)(De,void 0,Pe)}e.$qj=R;function B(ye,De={}){if(!ye)return o;if(typeof ye=="string"||V(ye)){const Pe=a(ye,De);if(Pe===n)return o;const Y=function(le,Ee){return!!Pe(le,Ee)};return Pe.allBasenames&&(Y.allBasenames=Pe.allBasenames),Pe.allPaths&&(Y.allPaths=Pe.allPaths),Y}return O(ye,De)}e.$rj=B;function V(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$sj=V;function U(ye){return ye.allBasenames||[]}e.$tj=U;function W(ye){return ye.allPaths||[]}e.$uj=W;function O(ye,De){const Pe=ee(Object.getOwnPropertyNames(ye).map($e=>N($e,ye[$e],De)).filter($e=>$e!==n)),Y=Pe.length;if(!Y)return n;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Y===1)return Pe[0];const $e=function(q,ue){let we;for(let be=0,ge=Pe.length;be<ge;be++){const ke=Pe[be](q,ue);if(typeof ke=="string")return ke;(0,M.$tg)(ke)&&(we||(we=[]),we.push(ke))}return we?(async()=>{for(const be of we){const ge=await be;if(typeof ge=="string")return ge}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,ue)=>ue.allPaths?q.concat(ue.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const le=function($e,ie,z){let q,ue;for(let we=0,be=Pe.length;we<be;we++){const ge=Pe[we];ge.requiresSiblings&&z&&(ie||(ie=(0,A.$ae)($e)),q||(q=ie.substr(0,ie.length-(0,A.$be)($e).length)));const ke=ge($e,ie,q,z);if(typeof ke=="string")return ke;(0,M.$tg)(ke)&&(ue||(ue=[]),ue.push(ke))}return ue?(async()=>{for(const we of ue){const be=await we;if(typeof be=="string")return be}return null})():null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function N(ye,De,Pe){if(De===!1)return n;const Y=a(ye,Pe);if(Y===n)return n;if(typeof De=="boolean")return Y;if(De){const le=De.when;if(typeof le=="string"){const Ee=(ce,$e,ie,z)=>{if(!z||!Y(ce,$e))return null;const q=le.replace("$(basename)",()=>ie),ue=z(q);return(0,M.$tg)(ue)?ue.then(we=>we?ye:null):ue?ye:null};return Ee.requiresSiblings=!0,Ee}}return Y}function ee(ye,De){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const Y=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let le;if(De){le=[];for(let $e=0,ie=Y.length;$e<ie;$e++)le.push(De)}else le=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Ee=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const ue=$e.charCodeAt(q-1);if(ue===47||ue===92)break}ie=$e.substr(q)}const z=Y.indexOf(ie);return z!==-1?le[z]:null};Ee.basenames=Y,Ee.patterns=le,Ee.allBasenames=Y;const ce=ye.filter($e=>!$e.basenames);return ce.push(Ee),ce}function Z(ye,De){return(0,w.$sb)(ye,De,(Pe,Y)=>typeof Pe=="string"&&typeof Y=="string"?Pe===Y:typeof Pe!="string"&&typeof Y!="string"?Pe.base===Y.base&&Pe.pattern===Y.pattern:!1)}e.$vj=Z}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class k{constructor(i="",s=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$5)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(i,s=0){return this.value+=c(this.supportThemeIcons?(0,M.$Rj)(i):i).replace(/([ \t]+)/g,(d,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,s){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(i,s,d){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(i),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(i,s){const d=new RegExp((0,F.$qe)(s),"g");return i.replace(d,(y,$)=>i.charAt($-1)!=="\\"?`\\${y}`:y)}}e.$Xj=k;function m(t){return P(t)?!t.value:Array.isArray(t)?t.every(m):!0}e.$Yj=m;function P(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Zj=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$bg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$1j=D;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$2j=c;function v(t){return t.replace(/"/g,"&quot;")}e.$3j=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$4j=p;function g(t){const i=[],s=t.split("|").map(y=>y.trim());t=s[0];const d=s[1];if(d){const y=/height=(\d+)/.exec(d),$=/width=(\d+)/.exec(d),r=y?y[1]:"",o=$?$[1]:"",n=isFinite(parseInt(o)),a=isFinite(parseInt(r));n&&i.push(`width="${o}"`),a&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$5j=g}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=void 0;function k(a,E){const{os:b,tildify:S,relative:I}=E;if(I){const l=m(a,I,b);if(typeof l=="string")return l}let u=a.fsPath;if(b===1&&!F.$i?u=u.replace(/\//g,"\\"):b!==1&&F.$i&&(u=u.replace(/\\/g,"/")),b!==1&&S?.userHome){const l=S.userHome.fsPath;let R;a.scheme!==S.userHome.scheme&&a.path.startsWith(C.$6d.sep)?R=S.userHome.with({path:a.path}).fsPath:R=a.fsPath,u=c(R,l,b)}return(b===1?C.$5d:C.$6d).normalize(P(u,b===1))}e.$hv=k;function m(a,E,b){const S=b===1?C.$5d:C.$6d,I=b===3?A.$$f:A.$ag,u=E.getWorkspace(),f=(0,w.$Mb)(u.folders);if(!f)return;a.scheme!==f.uri.scheme&&a.path.startsWith(C.$6d.sep)&&(a=f.uri.with({path:a.path}));const l=E.getWorkspaceFolder(a);if(!l)return;let R;if(I.isEqual(l.uri,a)?R="":R=I.relativePath(l.uri,a)??"",R&&(R=S.normalize(R)),u.folders.length>1&&!E.noPrefix){const B=l.name?l.name:I.basenameOrAuthority(l.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(a,E=F.$i){return(0,M.$Mf)(a,E)?a.charAt(0).toUpperCase()+a.slice(1):a}e.$iv=P;let D=Object.create(null);function c(a,E,b=F.OS){if(b===1||!a||!E)return a;let S=D.original===E?D.normalized:void 0;S||(S=E,F.$i&&(S=(0,M.$Cf)(S)),S=`${(0,h.$ve)(S,C.$6d.sep)}${C.$6d.sep}`,D={original:E,normalized:S});let I=a;return F.$i&&(I=(0,M.$Cf)(I)),(b===3?I.startsWith(S):(0,h.$Ne)(I,S))?`~/${I.substr(S.length)}`:a}e.$jv=c;function v(a,E){return a.replace(/^~($|\/|\\)/,`${E}$1`)}e.$kv=v;const p="\u2026",g="\\\\",t="~";function i(a,E=C.sep){const b=new Array(a.length);let S=!1;for(let I=0;I<a.length;I++){const u=a[I];if(u===""){b[I]=`.${E}`;continue}if(!u){b[I]=u;continue}S=!0;let f="",l=u;l.indexOf(g)===0?(f=l.substr(0,l.indexOf(g)+g.length),l=l.substr(l.indexOf(g)+g.length)):l.indexOf(E)===0?(f=l.substr(0,l.indexOf(E)+E.length),l=l.substr(l.indexOf(E)+E.length)):l.indexOf(t)===0&&(f=l.substr(0,l.indexOf(t)+t.length),l=l.substr(l.indexOf(t)+t.length));const R=l.split(E);for(let B=1;S&&B<=R.length;B++)for(let V=R.length-B;S&&V>=0;V--){S=!1;let U=R.slice(V,V+B).join(E);for(let W=0;!S&&W<a.length;W++)if(W!==I&&a[W]&&a[W].indexOf(U)>-1){const O=V+B===R.length,N=V>0&&a[W].indexOf(E)>-1?E+U:U,ee=a[W].endsWith(N);S=!O||ee}if(!S){let W="";(R[0].endsWith(":")||f!=="")&&(V===1&&(V=0,B++,U=R[0]+E+U),V>0&&(W=R[0]+E),W=f+W),V>0&&(W=W+p+E),W=W+U,V+B<R.length&&(W=W+E+p),b[I]=W}}S&&(b[I]=u)}return b}e.$lv=i;var s;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function d(a,E=Object.create(null)){const b=[];let S=!1,I="";for(const u of a)if(u==="$"||S&&u==="{")I&&b.push({value:I,type:s.TEXT}),I="",S=!0;else if(u==="}"&&S){const f=E[I];if(typeof f=="string")f.length&&b.push({value:f,type:s.VARIABLE});else if(f){const l=b[b.length-1];(!l||l.type!==s.SEPARATOR)&&b.push({value:f.label,type:s.SEPARATOR})}I="",S=!1}else I+=u;return I&&!S&&b.push({value:I,type:s.TEXT}),b.filter((u,f)=>{if(u.type===s.SEPARATOR){const l=b[f-1],R=b[f+1];return[l,R].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.$mv=d;function y(a,E){return F.$j||E?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):a.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.$nv=y;function $(a,E){return F.$j||E?a.replace(/\(&&\w\)|&&/g,""):F.$i?a.replace(/&&|&/g,b=>b==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.$ov=$;function r(a){return a.replace(/&/g,"&&")}e.$pv=r;function o(a){if(a.endsWith("]")){const E=a.lastIndexOf(" [",a.length-2);if(E!==-1){const b=n(a.substring(0,E));return{name:b.name,parentPath:b.parentPath+a.substring(E)}}}return n(a)}e.$qv=o;function n(a){const E=a.indexOf("/")!==-1?C.$6d:C.$5d,b=E.basename(a),S=E.dirname(a);return b.length?{name:b,parentPath:S}:{name:S,parentPath:""}}}),define(Ae[133],Re([1,0,25,2]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function C(D){return D.toJSON()}class F{constructor(c){this.a=c}transformIncoming(c){const v=this.a.transformIncoming(c);return v===c?c:C(M.URI.from(v))}transformOutgoing(c){const v=this.a.transformOutgoing(c);return v===c?c:C(M.URI.from(v))}transformOutgoingURI(c){const v=this.a.transformOutgoing(c);return v===c?c:M.URI.from(v)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$Bm=F,e.$Cm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,c,v){if(!D||v>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return c.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const g=A(D[p],c,v+1);g!==null&&(D[p]=g)}}return null}function h(D,c){const v=A(D,c,0);return v===null?D:v}e.$Dm=h;function k(D,c,v,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return v?M.URI.revive(c.transformIncoming(D)):c.transformIncoming(D);if(D instanceof w.$Fd)return null;for(const g in D)if(Object.hasOwnProperty.call(D,g)){const t=k(D[g],c,v,p+1);t!==null&&(D[g]=t)}}return null}function m(D,c){const v=k(D,c,!1,0);return v===null?D:v}e.$Em=m;function P(D,c){const v=k(D,c,!0,0);return v===null?D:v}e.$Fm=P}),define(Ae[134],Re([1,0,37,19]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=void 0;function C(F,A,h,k,m,P){if(Array.isArray(F)){let D=0;for(const c of F){const v=C(c,A,h,k,m,P);if(v===10)return v;v>D&&(D=v)}return D}else{if(typeof F=="string")return k?F==="*"?5:F===h?10:0:0;if(F){const{language:D,pattern:c,scheme:v,hasAccessToAllModels:p,notebookType:g}=F;if(!k&&!p)return 0;g&&m&&(A=m);let t=0;if(v)if(v===A.scheme)t=10;else if(v==="*")t=5;else return 0;if(D)if(D===h)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(g)if(g===P)t=10;else if(g==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,M.$7d)(c.base)},i===A.fsPath||(0,w.$qj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$gE=C}),define(Ae[91],Re([1,0,25,22]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0=e.$A0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function F(D){for(let c=0,v=D.length;c<v;c+=4){const p=D[c+0],g=D[c+1],t=D[c+2],i=D[c+3];D[c+0]=i,D[c+1]=t,D[c+2]=g,D[c+3]=p}}function A(D){const c=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$C()||F(c),w.$Fd.wrap(c)}function h(D){const c=D.buffer;if(M.$C()||F(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const v=new Uint8Array(c.byteLength);return v.set(c),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function k(D){const c=new Uint32Array(m(D));let v=0;if(c[v++]=D.id,D.type==="full")c[v++]=1,c[v++]=D.data.length,c.set(D.data,v),v+=D.data.length;else{c[v++]=2,c[v++]=D.deltas.length;for(const p of D.deltas)c[v++]=p.start,c[v++]=p.deleteCount,p.data?(c[v++]=p.data.length,c.set(p.data,v),v+=p.data.length):c[v++]=0}return A(c)}e.$A0=k;function m(D){let c=0;if(c+=1+1,D.type==="full")c+=1+D.data.length;else{c+=1,c+=(1+1+1)*D.deltas.length;for(const v of D.deltas)v.data&&(c+=v.data.length)}return c}function P(D){const c=h(D);let v=0;const p=c[v++];if(c[v++]===1){const s=c[v++],d=c.subarray(v,v+s);return v+=s,{id:p,type:"full",data:d}}const t=c[v++],i=[];for(let s=0;s<t;s++){const d=c[v++],y=c[v++],$=c[v++];let r;$>0&&(r=c.subarray(v,v+$),v+=$),i[s]={start:d,deleteCount:y,data:r}}return{id:p,type:"delta",deltas:i}}e.$B0=P}),define(Ae[135],Re([10,11]),function(ve,e){return ve.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,124,137,135]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=m;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(X,pe,je,Ne){this.id=X,this.name=pe,this.defaultValue=je,this.schema=Ne}applyUpdate(X,pe){return v(X,pe)}compute(X,pe,je){return je}}class c{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=c;function v(_,X){if(typeof _!="object"||typeof X!="object"||!_||!X)return new c(X,_!==X);if(Array.isArray(_)||Array.isArray(X)){const je=Array.isArray(_)&&Array.isArray(X)&&w.$sb(_,X);return new c(X,!je)}let pe=!1;for(const je in X)if(X.hasOwnProperty(je)){const Ne=v(_[je],X[je]);Ne.didChange&&(_[je]=Ne.newValue,pe=!0)}return new c(_,pe)}class p{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return v(X,pe)}validate(X){return this.defaultValue}}class g{constructor(X,pe,je,Ne){this.id=X,this.name=pe,this.defaultValue=je,this.schema=Ne}applyUpdate(X,pe){return v(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,je){return je}}function t(_,X){return typeof _>"u"?X:_==="false"?!1:!!_}e.boolean=t;class i extends g{constructor(X,pe,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=je),super(X,pe,je,Ne)}validate(X){return t(X,this.defaultValue)}}function s(_,X,pe,je){if(typeof _>"u")return X;let Ne=parseInt(_,10);return isNaN(Ne)?X:(Ne=Math.max(pe,Ne),Ne=Math.min(je,Ne),Ne|0)}e.clampedInt=s;class d extends g{static clampedInt(X,pe,je,Ne){return s(X,pe,je,Ne)}constructor(X,pe,je,Ne,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Ne,nt.maximum=Xe),super(X,pe,je,nt),this.minimum=Ne,this.maximum=Xe}validate(X){return d.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function y(_,X,pe,je){if(typeof _>"u")return X;const Ne=$.float(_,X);return $.clamp(Ne,pe,je)}e.clampedFloat=y;class $ extends g{static clamp(X,pe,je){return X<pe?pe:X>je?je:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const je=parseFloat(X);return isNaN(je)?pe:je}constructor(X,pe,je,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=je),super(X,pe,je,Xe),this.validationFn=Ne}validate(X){return this.validationFn($.float(X,this.defaultValue))}}class r extends g{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=je),super(X,pe,je,Ne)}validate(X){return r.string(X,this.defaultValue)}}function o(_,X,pe,je){return typeof _!="string"?X:je&&_ in je?je[_]:pe.indexOf(_)===-1?X:_}e.stringSet=o;class n extends g{constructor(X,pe,je,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=je),super(X,pe,je,Xe),this.c=Ne}validate(X){return o(X,this.defaultValue,this.c)}}class a extends D{constructor(X,pe,je,Ne,Xe,nt,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Xe,dt.default=Ne),super(X,pe,je,dt),this.c=Xe,this.d=nt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function E(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,je){return je===0?X.accessibilitySupport:je}}class S extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:h.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function u(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function l(_){switch(_){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function R(_){switch(_){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class B extends p{constructor(){super(140)}compute(X,pe,je){const Ne=["monaco-editor"];return pe.get(39)&&Ne.push(pe.get(39)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),pe.get(73)==="default"?Ne.push("mouse-default"):pe.get(73)==="copy"&&Ne.push("mouse-copy"),pe.get(110)&&Ne.push("showUnused"),pe.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(X,pe,je){return je&&X.emptySelectionClipboard}}class U extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:h.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:h.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":o(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":o(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?W.OFF:X==="true"?W.ON:X:X?W.ON:W.OFF}}e.EditorFontLigatures=W;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?O.OFF:X==="true"?O.TRANSLATE:X:X?O.TRANSLATE:O.OFF}compute(X,pe,je){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends p{constructor(){super(50)}compute(X,pe,je){return X.fontInfo}}class ee extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(X){const pe=$.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:$.clamp(pe,6,100)}compute(X,pe,je){return X.fontInfo.fontSize}}class Z extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(d.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class ye extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:je,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:je,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:je,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:je,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:je,description:h.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:o(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??o(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??o(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??o(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??o(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??o(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends D{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:h.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:h.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:h.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:d.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:d.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Y extends p{constructor(){super(143)}compute(X,pe,je){return Y.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,je=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Xe=(je+X.viewLineCount+Ne)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:nt}}static c(X,pe){const je=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=pe.stableMinimapLayoutInput,dt=nt&&X.outerHeight===nt.outerHeight&&X.lineHeight===nt.lineHeight&&X.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&X.pixelRatio===nt.pixelRatio&&X.scrollBeyondLastLine===nt.scrollBeyondLastLine&&X.paddingTop===nt.paddingTop&&X.paddingBottom===nt.paddingBottom&&X.minimap.enabled===nt.minimap.enabled&&X.minimap.side===nt.minimap.side&&X.minimap.size===nt.minimap.size&&X.minimap.showSlider===nt.minimap.showSlider&&X.minimap.renderCharacters===nt.minimap.renderCharacters&&X.minimap.maxColumn===nt.minimap.maxColumn&&X.minimap.scale===nt.minimap.scale&&X.verticalScrollbarWidth===nt.verticalScrollbarWidth&&X.isViewportWrapping===nt.isViewportWrapping,wt=X.lineHeight,Pt=X.typicalHalfwidthCharacterWidth,Xt=X.scrollBeyondLastLine,Kt=X.minimap.renderCharacters;let pt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const jt=X.minimap.maxColumn,Nt=X.minimap.size,Bt=X.minimap.side,At=X.verticalScrollbarWidth,Rt=X.viewLineCount,zt=X.remainingWidth,Wt=X.isViewportWrapping,Jt=Kt?2:3;let Vt=Math.floor(Xe*Ne);const qt=Vt/Xe;let ot=!1,ft=!1,Mt=Jt*pt,Tt=pt/Xe,It=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:me,extraLinesBeyondLastLine:H,desiredRatio:Te,minimapLineCount:Be}=Y.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Xt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Xe});if(Rt/Be>1)ot=!0,ft=!0,pt=1,Mt=1,Tt=pt/Xe;else{let We=!1,_e=pt+1;if(Nt==="fit"){const $t=Math.ceil((me+Rt+H)*Mt);Wt&&dt&&zt<=pe.stableFitRemainingWidth?(We=!0,_e=pe.stableFitMaxMinimapScale):We=$t>Vt}if(Nt==="fill"||We){ot=!0;const $t=pt;Mt=Math.min(wt*Xe,Math.max(1,Math.floor(1/Te))),Wt&&dt&&zt<=pe.stableFitRemainingWidth&&(_e=pe.stableFitMaxMinimapScale),pt=Math.min(_e,Math.max(1,Math.floor(Mt/Jt))),pt>$t&&(It=Math.min(2,pt/$t)),Tt=pt/Xe/It,Vt=Math.ceil(Math.max(Me,me+Rt+H)*Mt),Wt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=zt,pe.stableFitMaxMinimapScale=pt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ht=Math.floor(jt*Tt),Dt=Math.min(ht,Math.max(0,Math.floor((zt-At-2)*Tt/(Pt+Tt)))+e.MINIMAP_GUTTER_WIDTH);let kt=Math.floor(Xe*Dt);const Ft=kt/Xe;kt=Math.floor(kt*It);const Ve=Kt?1:2,Ce=Bt==="left"?0:je-Dt-At;return{renderMinimap:Ve,minimapLeft:Ce,minimapWidth:Dt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:pt,minimapLineHeight:Mt,minimapCanvasInnerWidth:kt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:qt}}static computeLayout(X,pe){const je=pe.outerWidth|0,Ne=pe.outerHeight|0,Xe=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,dt=pe.typicalHalfwidthCharacterWidth,wt=pe.maxDigitWidth,Pt=pe.pixelRatio,Xt=pe.viewLineCount,Kt=X.get(135),pt=Kt==="inherit"?X.get(134):Kt,jt=pt==="inherit"?X.get(130):pt,Nt=X.get(133),Bt=pe.isDominatedByLongLines,At=X.get(57),Rt=X.get(67).renderType!==0,zt=X.get(68),Wt=X.get(104),Jt=X.get(83),Vt=X.get(72),qt=X.get(102),ot=qt.verticalScrollbarSize,ft=qt.verticalHasArrows,Mt=qt.arrowSize,Tt=qt.horizontalScrollbarSize,It=X.get(43),ht=X.get(109)!=="never";let Dt=X.get(65);It&&ht&&(Dt+=16);let kt=0;if(Rt){const bt=Math.max(nt,zt);kt=Math.round(bt*wt)}let Ft=0;At&&(Ft=Xe*pe.glyphMarginDecorationLaneCount);let Ve=0,Ce=Ve+Ft,Me=Ce+kt,me=Me+Dt;const H=je-Ft-kt-Dt;let Te=!1,Be=!1,Ge=-1;pt==="inherit"&&Bt?(Te=!0,Be=!0):jt==="on"||jt==="bounded"?Be=!0:jt==="wordWrapColumn"&&(Ge=Nt);const We=Y.c({outerWidth:je,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:dt,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Vt,verticalScrollbarWidth:ot,viewLineCount:Xt,remainingWidth:H,isViewportWrapping:Be},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Ve+=We.minimapWidth,Ce+=We.minimapWidth,Me+=We.minimapWidth,me+=We.minimapWidth);const _e=H-We.minimapWidth,$t=Math.max(1,Math.floor((_e-ot-2)/dt)),Ct=ft?Mt:0;return Be&&(Ge=Math.max(1,$t),jt==="bounded"&&(Ge=Math.min(Ge,Nt))),{width:je,height:Ne,glyphMarginLeft:Ve,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:kt,decorationsLeft:Me,decorationsWidth:Dt,contentLeft:me,contentWidth:_e,minimap:We,viewportColumn:$t,isWordWrapMinified:Te,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Tt,overviewRuler:{top:Ct,width:ot,height:Ne-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Y;class le extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(47,null),h.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(49,null)}})}validate(X){return o(X,"simple",["simple","advanced"])}compute(X,pe,je){return pe.get(2)===2?"advanced":je}}class Ee extends D{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:h.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class ce extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:h.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:h.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:h.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:h.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:d.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:h.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(56,null),h.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:h.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:h.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:h.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:o(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:d.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):d.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,je){return je<0?d.clampedInt(-je*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class z extends ${constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>$.clamp(X,0,150),{markdownDescription:h.localize(63,null)})}compute(X,pe,je){return X.fontInfo.lineHeight}}class q extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:h.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:h.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:X.size,description:h.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:h.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:h.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:h.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:h.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:o(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(pe.side,this.defaultValue.side,["right","left"]),showSlider:o(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(pe.scale,1,1,3),maxColumn:d.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:d.clampedInt(pe.top,0,0,1e3),bottom:d.clampedInt(pe.bottom,0,0,1e3)}}}class be extends D{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:h.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:h.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(141)}compute(X,pe,je){return X.pixelRatio}}class ke extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(79,null),h.localize(80,null),h.localize(81,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:h.localize(82,null)},comments:{anyOf:pe,default:X.comments,description:h.localize(83,null)},other:{anyOf:pe,default:X.other,description:h.localize(84,null)}},default:X,markdownDescription:h.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Pt=X?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:je,strings:Ne}=X,Xe=["on","inline","off"];let nt,dt,wt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=o(pe,this.defaultValue.other,Xe),typeof je=="boolean"?dt=je?"on":"off":dt=o(je,this.defaultValue.comments,Xe),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=o(Ne,this.defaultValue.strings,Xe),{other:nt,comments:dt,strings:wt}}}var re;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(86,null),h.localize(87,null),h.localize(88,null),h.localize(89,null)],default:"on",description:h.localize(90,null)})}validate(X){let pe=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,je=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:je}}}function se(_){const X=_.get(97);return X==="editable"?_.get(90):X!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const X=[],pe={type:"number",description:h.localize(91,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(92,null),format:"color-hex"}}}]},default:X,description:h.localize(93,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const je of X)if(typeof je=="number")pe.push({column:d.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Ne=je;pe.push({column:d.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((je,Ne)=>je.column-Ne.column),pe}return this.defaultValue}}class fe extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(_,X){if(typeof _!="string")return X;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:"auto",description:h.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:"auto",description:h.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:h.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:h.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,je=d.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=d.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:d.clampedInt(pe.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:d.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:h.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:h.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:h.localize(111,null)}})}applyUpdate(X,pe){let je=!1;pe.allowedCharacters&&X&&(M.$Zm(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},je=!0)),pe.allowedLocales&&X&&(M.$Zm(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},je=!0));const Ne=super.applyUpdate(X,pe);return je?new c(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const je={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&(je[Ne]=!0);return je}}class G extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:h.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(113,null),h.localize(114,null)],description:h.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:h.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:o(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends D{constructor(){const X={enabled:F.$Ur.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Ur.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:h.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(119,null),h.localize(120,null),h.localize(121,null)],default:X.bracketPairs,description:h.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(123,null),h.localize(124,null),h.localize(125,null)],default:X.bracketPairsHorizontal,description:h.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:h.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:h.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(129,null),h.localize(130,null),h.localize(131,null)],default:X.highlightActiveIndentation,description:h.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,X,pe){const je=pe.indexOf(_);return je===-1?X:pe[je]}class ae extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(133,null),h.localize(134,null)],default:X.insertMode,description:h.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:h.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:h.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:h.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(139,null),h.localize(140,null),h.localize(141,null),h.localize(142,null)],default:X.selectionMode,markdownDescription:h.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:h.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:h.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:h.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:h.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:h.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(180,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:o(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:o(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(182,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(183,null),h.localize(184,null),h.localize(185,null),h.localize(186,null)],description:h.localize(187,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,je){return pe.get(2)===2?0:je}}class He extends p{constructor(){super(144)}compute(X,pe,je){const Ne=pe.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(190,null),h.localize(191,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:o(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:h.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(194,null),h.localize(195,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:o(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:xe,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(197,null),""],markdownDescription:h.localize(198,null)})),accessibilitySupport:ze(new b),accessibilityPageSize:ze(new d(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",h.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(202,null),h.localize(203,null),""],description:h.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(205,null),h.localize(206,null),""],description:h.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(208,null),""],description:h.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(210,null),""],description:h.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(212,null),h.localize(213,null),""],description:h.localize(214,null)})),autoIndent:ze(new a(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[h.localize(215,null),h.localize(216,null),h.localize(217,null),h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(221,null),h.localize(222,null),h.localize(223,null),""],description:h.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new J),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:h.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:h.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:h.localize(227,null)})),codeLensFontSize:ze(new d(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:h.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null)],description:h.localize(233,null)})),colorDecoratorsLimit:ze(new d(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:h.localize(235,null)})),comments:ze(new S),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:h.localize(236,null)})),cursorBlinking:ze(new a(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:h.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(238,null),h.localize(239,null),h.localize(240,null)],description:h.localize(241,null)})),cursorStyle:ze(new a(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:h.localize(242,null)})),cursorSurroundingLines:ze(new d(29,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(244,null),h.localize(245,null)],markdownDescription:h.localize(246,null)})),cursorWidth:ze(new d(31,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:h.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new et),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(249,null),h.localize(250,null),h.localize(251,null)],description:h.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new $(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:h.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:h.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:h.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:h.localize(259,null)})),foldingMaximumRegions:ze(new d(47,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new W),fontSize:ze(new ee),fontWeight:ze(new Z),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:h.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:h.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:h.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:h.localize(266,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new $(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>$.clamp(_,-5,20),{description:h.localize(267,null)})),lightbulb:ze(new Ee),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new d(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:h.localize(268,null)})),links:ze(new i(70,"links",!0,{description:h.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:h.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new $(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:h.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:h.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:h.localize(273,null)})),multiCursorModifier:ze(new a(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(274,null),h.localize(275,null)],markdownDescription:h.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(277,null),h.localize(278,null)],markdownDescription:h.localize(279,null)})),multiCursorLimit:ze(new d(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:h.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:h.localize(282,null)})),overviewRulerLanes:ze(new d(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Ye),parameterHints:ze(new be),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(283,null),h.localize(284,null)],description:h.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:h.localize(286,null)})),quickSuggestions:ze(new ke),quickSuggestionsDelay:ze(new d(89,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new i(92,"renameOnType",!1,{description:h.localize(288,null),markdownDeprecationMessage:h.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:h.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:h.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(292,null)],description:h.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(295,null),h.localize(296,null),h.localize(297,null),""],description:h.localize(298,null)})),revealHorizontalRightPadding:ze(new d(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:h.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new d(103,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:h.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:h.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:h.localize(303,null),included:C.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:h.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(305,null),h.localize(306,null),h.localize(307,null)],description:h.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:h.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:h.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(311,null),h.localize(312,null),h.localize(313,null),h.localize(314,null)],description:h.localize(315,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:h.localize(316,null)})),stopRenderingLineAfter:ze(new d(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(317,null)})),suggestFontSize:ze(new d(118,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new d(119,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:h.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(321,null),h.localize(322,null),h.localize(323,null)],description:h.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(325,null),h.localize(326,null),h.localize(327,null)],description:h.localize(328,null)})),tabIndex:ze(new d(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(329,null),h.localize(330,null),h.localize(331,null)],description:h.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:h.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(334,null),h.localize(335,null)],description:h.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Vr,{description:h.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(338,null),h.localize(339,null),h.localize(340,null),h.localize(341,null)],description:h.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new d(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:h.localize(344,null)})),pixelRatio:ze(new ge),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:h.localize(345,null)})),layoutInfo:ze(new Y),wrappingInfo:ze(new He),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new le)}}),define(Ae[138],Re([10,11]),function(ve,e){return ve.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(ve,e){return ve.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(ve,e){return ve.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(ve,e){return ve.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(ve,e){return ve.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(ve,e){return ve.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(ve,e){return ve.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(ve,e){return ve.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(ve,e){return ve.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(ve,e){return ve.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(ve,e){return ve.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(ve,e){return ve.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(ve,e){return ve.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(ve,e){return ve.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(ve,e){return ve.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var C;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...m){switch(m.length){case 1:return(0,M.localize)(0,null,m[0]);case 2:return(0,M.localize)(1,null,m[0],m[1]);case 3:return(0,M.localize)(2,null,m[0],m[1],m[2]);default:return}}const A=(0,M.localize)(3,null),h=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,c=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:c};this.g.push({offset:D,lexeme:c,additionalInfo:P}),this.f.push(v)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),c=k.b.get(D);c?this.k(c):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,c=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(h);return}const p=this.c.charCodeAt(P);if(D)D=!1;else if(p===47&&!c){P++;break}else p===91?c=!0:p===92?D=!0:p===93&&(c=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=k}),define(Ae[170],Re([1,0,23,29,142,277]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function k(i){return i=i.trim(),i==="*"||A.test(i)}e.$Bo=k;function m(i){if(!k(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=i.match(A);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$Co=m;function P(i){if(!i)return null;const s=i.majorBase,d=i.majorMustEqual,y=i.minorBase;let $=i.minorMustEqual;const r=i.patchBase;let o=i.patchMustEqual;i.hasCaret&&(s===0||($=!1),o=!1);let n=0;if(i.preRelease){const a=h.exec(i.preRelease);if(a){const[,E,b,S]=a;n=Date.UTC(Number(E),Number(b)-1,Number(S))}}return{majorBase:s,majorMustEqual:d,minorBase:y,minorMustEqual:$,patchBase:r,patchMustEqual:o,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$Do=P;function D(i,s,d){let y;typeof i=="string"?y=P(m(i)):y=i;let $;s instanceof Date?$=s.getTime():typeof s=="string"&&($=new Date(s).getTime());let r;if(typeof d=="string"?r=P(m(d)):r=d,!y||!r)return!1;const o=y.majorBase,n=y.minorBase,a=y.patchBase;let E=r.majorBase,b=r.minorBase,S=r.patchBase;const I=r.notBefore;let u=r.majorMustEqual,f=r.minorMustEqual,l=r.patchMustEqual;return r.isMinimum?o>E?!0:o<E?!1:n>b?!0:n<b||$&&$<I?!1:a>=S:(o===1&&E===0&&(!u||!f||!l)&&(E=1,b=0,S=0,u=!0,f=!1,l=!1),o<E?!1:o>E?!u:n<b?!1:n>b?!f:a<S?!1:a>S?!l:!($&&$<I))}e.$Eo=D;function c(i,s,d,y,$){const r=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof y.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof y.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!y.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof y.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof y.extensionDependencies<"u"&&!t(y.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof y.activationEvents<"u"){if(!t(y.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof y.main>"u"&&typeof y.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const a=(0,w.$ig)(d,y.main);(0,w.$cg)(a,d)||r.push([M.default.Warning,C.localize(10,null,a.path,d.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const a=(0,w.$ig)(d,y.browser);(0,w.$cg)(a,d)||r.push([M.default.Warning,C.localize(12,null,a.path,d.path)])}}if(!F.valid(y.version))return r.push([M.default.Error,C.localize(13,null)]),r;const o=[];if(!v(i,s,y,$,o))for(const a of o)r.push([M.default.Error,a]);return r}e.$Fo=c;function v(i,s,d,y,$){return y||typeof d.main>"u"&&typeof d.browser>"u"?!0:g(i,s,d.engines.vscode,$)}e.$Go=v;function p(i,s,d){return i==="*"||g(s,d,i)}e.$Ho=p;function g(i,s,d,y=[]){const $=P(m(d));if(!$)return y.push(C.localize(14,null,d)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return y.push(C.localize(15,null,d)),!1}else if(!$.majorMustEqual)return y.push(C.localize(16,null,d)),!1;return D(i,s,$)?!0:(y.push(C.localize(17,null,i,d)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let s=0,d=i.length;s<d;s++)if(typeof i[s]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class w{constructor(C,F=[],A=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=A}}e.$yh=w}),define(Ae[71],Re([1,0,70]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const M=[];var C;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(h,k,m){k instanceof w.$yh||(k=new w.$yh(k,[],!!m)),M.push([h,k])}e.$mr=F;function A(){return M}e.$nr=A}),define(Ae[171],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class w{constructor(F,A){this.key=F,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$4p=w;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const A of this.a.values())A.outgoing.size===0&&F.push(A);return F}insertEdge(F,A){const h=this.lookupOrInsertNode(F),k=this.lookupOrInsertNode(A);h.outgoing.set(k.key,k),k.incoming.set(h.key,h)}removeNode(F){const A=this.b(F);this.a.delete(A);for(const h of this.a.values())h.outgoing.delete(A),h.incoming.delete(A)}lookupOrInsertNode(F){const A=this.b(F);let h=this.a.get(A);return h||(h=new w(A,F),this.a.set(A,h)),h}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[A,h]of this.a)F.push(`${A}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,A]of this.a){const h=new Set([F]),k=this.c(A,h);if(k)return k}}c(F,A){for(const[h,k]of F.outgoing){if(A.has(h))return[...A,h].join(" -> ");A.add(h);const m=this.c(k,A);if(m)return m;A.delete(h)}}}e.$5p=M}),define(Ae[4],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function h(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=h})(w||(e._util=w={})),e.$Ah=C("instantiationService");function M(A,h,k){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:A,index:k}):(h[w.DI_DEPENDENCIES]=[{id:A,index:k}],h[w.DI_TARGET]=h)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const h=function(k,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(h,k,P)};return h.toString=()=>A,w.serviceIds.set(A,h),h}e.$Bh=C;function F(A){return A}e.$Ch=F}),define(Ae[43],Re([1,0,16,2,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,C.$Bh)("configurationService");function F(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$9h=F;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$0h=A;var h;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function k(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=k;function m(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$_h=m;function P(i,s){const d=Object.create(null);for(const y in i)D(d,y,i[y],s);return d}e.$ai=P;function D(i,s,d,y){const $=s.split("."),r=$.pop();let o=i;for(let n=0;n<$.length;n++){const a=$[n];let E=o[a];switch(typeof E){case"undefined":E=o[a]=Object.create(null);break;case"object":break;default:y(`Ignoring ${s} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(E)}`);return}o=E}if(typeof o=="object"&&o!==null)try{o[r]=d}catch{y(`Ignoring ${s} as ${$.join(".")} is ${JSON.stringify(o)}`)}else y(`Ignoring ${s} as ${$.join(".")} is ${JSON.stringify(o)}`)}e.$bi=D;function c(i,s){const d=s.split(".");v(i,d)}e.$ci=c;function v(i,s){const d=s.shift();if(s.length===0){delete i[d];return}if(Object.keys(i).indexOf(d)!==-1){const y=i[d];typeof y=="object"&&!Array.isArray(y)&&(v(y,s),Object.keys(y).length===0&&delete i[d])}}function p(i,s,d){function y(o,n){let a=o;for(const E of n){if(typeof a!="object"||a===null)return;a=a[E]}return a}const $=s.split("."),r=y(i,$);return typeof r>"u"?d:r}e.$di=p;function g(i,s,d){Object.keys(s).forEach(y=>{y!=="__proto__"&&(y in i?w.$lf(i[y])&&w.$lf(s[y])?g(i[y],s[y],d):d&&(i[y]=s[y]):i[y]=s[y])})}e.$ei=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$fi=t}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",w.$j),k.set("isLinux",w.$k),k.set("isWindows",w.$i),k.set("isWeb",w.$o),k.set("isMacNative",w.$j&&!w.$o),k.set("isEdge",w.$G),k.set("isFirefox",w.$E),k.set("isChrome",w.$D),k.set("isSafari",w.$F);function m(ie,z){if(k.get(ie)!==void 0)throw(0,h.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(ie,z)}e.$Gi=m;const P=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const c={regexParsingWithErrorRecovery:!0},v=(0,A.localize)(0,null),p=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),s=(0,A.localize)(5,null),d=(0,A.localize)(6,null),y=(0,A.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=c){this.k=z,this.d=new C.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const ue=this.D(),we=ue.type===17?s:void 0;throw this.h.push({message:i,offset:ue.offset,lexeme:C.$Fi.getLexeme(ue),additionalInfo:we}),$.c}return q}catch(q){if(q!==$.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const be=we.lexeme,ge=be.lastIndexOf("/"),ke=ge===be.length-1?void 0:this.w(be.substring(ge+1));let re;try{re=new RegExp(be.substring(1,ge),ke)}catch{throw this.B("REGEX",we)}return N.create(q,re)}switch(we.type){case 10:case 19:{const be=[we.lexeme];this.z();let ge=this.D(),ke=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let fe=0;fe<ge.lexeme.length;fe++)ge.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--}if(ke<0)break;be.push(C.$Fi.getLexeme(ge)),this.z(),ge=this.D()}const re=be.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const be=we.lexeme;this.z();let ge=null;if(!(0,M.$me)(be)){const ke=be.indexOf("/"),re=be.lastIndexOf("/");if(ke!==re&&ke>=0){const he=be.slice(ke+1,re),se=be[re+1]==="i"?"i":"";try{ge=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(ge===null)throw this.B("REGEX",we);return N.create(q,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:d,offset:z.offset,lexeme:"",additionalInfo:y}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,ue){const we=(0,A.localize)(8,null,z,C.$Fi.getLexeme(q)),be=q.offset,ge=C.$Fi.getLexeme(q);return this.h.push({message:we,offset:be,lexeme:ge,additionalInfo:ue}),$.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=$;class r{static false(){return E.INSTANCE}static true(){return b.INSTANCE}static has(z){return S.create(z)}static equals(z,q){return I.create(z,q)}static notEquals(z,q){return l.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return u.create(z,q)}static notIn(z,q){return f.create(z,q)}static not(z){return R.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return De.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return W.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ii=r;function o(ie){const z=new $({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Ji=o;function n(ie,z){const q=ie?ie.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!q&&!ue?!0:!q||!ue?!1:q.equals(ue)}e.$Ki=n;function a(ie,z){return ie.cmp(z)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return b.INSTANCE}}e.$Li=E;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return E.INSTANCE}}e.$Mi=b;class S{static create(z,q=null){const ue=k.get(z);return typeof ue=="boolean"?ue?b.INSTANCE:E.INSTANCE:new S(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=k.get(this.key);return typeof z=="boolean"?z?b.INSTANCE:E.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Ni=S;class I{static create(z,q,ue=null){if(typeof q=="boolean")return q?S.create(z,ue):R.create(z,ue);const we=k.get(z);return typeof we=="boolean"?q===(we?"true":"false")?b.INSTANCE:E.INSTANCE:new I(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?b.INSTANCE:E.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.$Oi=I;class u{static create(z,q){return new u(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:le(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(q)?q.includes(ue):typeof ue=="string"&&typeof q=="object"&&q!==null?P.call(q,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Pi=u;class f{static create(z,q){return new f(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=u.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=f;class l{static create(z,q,ue=null){if(typeof q=="boolean")return q?R.create(z,ue):S.create(z,ue);const we=k.get(z);return typeof we=="boolean"?q===(we?"true":"false")?E.INSTANCE:b.INSTANCE:new l(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?E.INSTANCE:b.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=l;class R{static create(z,q=null){const ue=k.get(z);return typeof ue=="boolean"?ue?E.INSTANCE:b.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=k.get(this.c);return typeof z=="boolean"?z?E.INSTANCE:b.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Si=R;function B(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):E.INSTANCE}class V{static create(z,q,ue=null){return B(q,we=>new V(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ti=V;class U{static create(z,q,ue=null){return B(q,we=>new U(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ui=U;class W{static create(z,q,ue=null){return B(q,we=>new W(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Vi=W;class O{static create(z,q,ue=null){return B(q,we=>new O(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Wi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return q<ue?-1:q>ue?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&q===ue}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Xi=N;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$Yi=ee;function Z(ie){let z=null;for(let q=0,ue=ie.length;q<ue;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let be=0;be<q;be++)z[be]=ie[be]}z!==null&&(z[q]=we)}return z===null?ie:z}class ye{static create(z,q,ue){return ye.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=a(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,ue){const we=[];let be=!1;for(const ge of z)if(ge){if(ge.type===1){be=!0;continue}if(ge.type===0)return E.INSTANCE;if(ge.type===6){we.push(...ge.expr);continue}we.push(ge)}if(we.length===0&&be)return b.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(a);for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];for(;we.length>1;){const ge=we[we.length-1];if(ge.type!==9)break;we.pop();const ke=we.pop(),re=we.length===0,he=De.create(ge.expr.map(se=>ye.create([se,ke],null,ue)),null,re);he&&(we.push(he),we.sort(a))}if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ke=ge+1;ke<we.length;ke++)if(we[ge].negate().equals(we[ke]))return E.INSTANCE;if(we.length===1)return we[0]}return new ye(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ye(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=De.create(z,this,!0)}return this.c}}e.$Zi=ye;class De{static create(z,q,ue){return De.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=a(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:De.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,ue){let we=[],be=!1;if(z){for(let ge=0,ke=z.length;ge<ke;ge++){const re=z[ge];if(re){if(re.type===0){be=!0;continue}if(re.type===1)return b.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&be)return E.INSTANCE;we.sort(a)}if(we.length!==0){if(we.length===1)return we[0];for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ke=ge+1;ke<we.length;ke++)if(we[ge].negate().equals(we[ke]))return b.INSTANCE;if(we.length===1)return we[0]}return new De(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new De(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),ue=z.shift(),we=[];for(const be of $e(q))for(const ge of $e(ue))we.push(ye.create([be,ge],null,!1));z.unshift(De.create(we,null,!1))}this.c=De.create(z,this,!0)}return this.c}}e.$1i=De;class Pe extends S{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,ue){super(z,null),this.f=q,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return I.create(this.key,z)}notEqualsTo(z){return l.create(this.key,z)}}e.$2i=Pe,e.$3i=(0,F.$Bh)("contextKeyService");function Y(ie,z){return ie<z?-1:ie>z?1:0}function le(ie,z,q,ue){return ie<q?-1:ie>q?1:z<ue?-1:z>ue?1:0}function Ee(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(Ee(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(Ee(q,z))return!0;return!1}return ie.equals(z)}e.$4i=Ee;function ce(ie,z){let q=0,ue=0;for(;q<ie.length&&ue<z.length;){const we=ie[q].cmp(z[ue]);if(we<0)return!1;we===0&&q++,ue++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[172],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,w.$Bh)("environmentService"),e.$Jh=(0,w.$Ch)(e.$Ih)}),define(Ae[92],Re([1,0,141,4]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function C(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=C;function F(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=F;function A(s,d){switch(s){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=A;function h(s,d){return d==="web"&&!s.includes("web")}e.$Vn=h;function k(s,d,y){return h(d,y)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===y?!0:m(y).includes(s)}e.$Wn=k;function m(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=m;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$Yn=P;var D;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var c;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var v;(function(s){s.Install="install",s.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var p;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Zn=(0,M.$Bh)("extensionGalleryService");var g;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var t;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(d,y){super(d),this.code=y,this.name=y}}e.$1n=i,e.$2n=(0,M.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,M.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,M.$Bh)("IExtensionTipsService"),e.$7n=(0,w.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,13]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,k.$Bh)("fileService");function D(Y){return Y.create===!0}e.$7j=D;var c;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var v;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var p;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function g(Y){return!!(Y.capabilities&2)}e.$8j=g;function t(Y){return!!(Y.capabilities&8)}e.$9j=t;function i(Y){return!!(Y.capabilities&131072)}e.$0j=i;function s(Y){return!!(Y.capabilities&4)}e.$$j=s;function d(Y){return!!(Y.capabilities&16)}e.$_j=d;function y(Y){return g(Y)?!!(Y.capabilities&16384):!1}e.$ak=y;function $(Y){return g(Y)?!!(Y.capabilities&32768):!1}e.$bk=$;function r(Y){return!!(Y.capabilities&65536)}e.$ck=r;function o(Y){return!!(Y.capabilities&2048)}e.$dk=o;var n;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(le,Ee){const ce=new a(le.toString(),Ee);return S(ce,Ee),ce}constructor(le,Ee){super(le),this.code=Ee}}e.$ek=a;function E(Y,le){return a.create(Y,le)}e.$fk=E;function b(Y){return Y||E((0,h.localize)(0,null),n.Unknown)}e.$gk=b;function S(Y,le){return Y.name=le?`${le} (FileSystemError)`:"FileSystemError",Y}e.$hk=S;function I(Y){if(!Y)return n.Unknown;if(Y instanceof a)return Y.code;const le=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!le)return n.Unknown;switch(le[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ik=I;function u(Y){if(Y instanceof U)return Y.fileOperationResult;switch(I(Y)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$jk=u;var f;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class l{constructor(le,Ee,ce){this.resource=le,this.operation=Ee,this.target=ce}isOperation(le){return this.operation===le}}e.$kk=l;var R;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(le,Ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of le){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Hh.forUris(()=>Ee),this.a.fill(ie);break;case 0:this.b=w.$Hh.forUris(()=>Ee),this.b.fill(ie);break;case 2:this.c=w.$Hh.forUris(()=>Ee),this.c.fill(ie);break}}contains(le,...Ee){return this.d(le,{includeChildren:!1},...Ee)}affects(le,...Ee){return this.d(le,{includeChildren:!0},...Ee)}d(le,Ee,...ce){if(!le)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(le)||Ee.includeChildren&&this.a?.findSuperstr(le))||(!$e||ce.includes(0))&&(this.b?.get(le)||Ee.includeChildren&&this.b?.findSuperstr(le))||(!$e||ce.includes(2))&&(this.c?.findSubstr(le)||Ee.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=B;function V(Y,le,Ee){return!Y||!le||Y===le||le.length>Y.length?!1:(le.charAt(le.length-1)!==M.sep&&(le+=M.sep),Ee?(0,C.$Ne)(Y,le):Y.indexOf(le)===0)}e.$mk=V;class U extends Error{constructor(le,Ee,ce){super(le),this.fileOperationResult=Ee,this.options=ce}}e.$nk=U;class W extends U{constructor(le,Ee,ce,$e){super(le,Ee,$e),this.fileOperationResult=Ee,this.size=ce}}e.$ok=W;class O extends U{constructor(le,Ee,ce){super(le,2,ce),this.stat=Ee}}e.$pk=O;var N;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var ee;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$xk="";function Z(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.$yk=Z;async function ye(Y,le){if(!le.hasProvider(A.URI.from({scheme:Y.scheme})))return new Promise(Ee=>{const ce=le.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Y.scheme&&$e.added&&(ce.dispose(),Ee())})})}e.$zk=ye;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(le){return(0,F.$nf)(le)||(le=0),le<De.KB?(0,h.localize)(1,null,le.toFixed(0)):le<De.MB?(0,h.localize)(2,null,(le/De.KB).toFixed(2)):le<De.GB?(0,h.localize)(3,null,(le/De.MB).toFixed(2)):le<De.TB?(0,h.localize)(4,null,(le/De.GB).toFixed(2)):(0,h.localize)(5,null,(le/De.TB).toFixed(2))}}e.$Ak=De;function Pe(Y){const le=typeof Y=="string"||Y?.scheme===P.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===P.Schemas.file?1024*De.MB:le?10*De.MB:m.$o?50*De.MB:1024*De.MB}e.$Bk=Pe}),define(Ae[72],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class w{constructor(...C){this.a=new Map;for(const[F,A]of C)this.set(F,A)}set(C,F){const A=this.a.get(C);return this.a.set(C,F),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$zh=w}),define(Ae[173],Re([1,0,12,9,6,70,171,4,72,174]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new k.$zh,i=!1,s,d=P){this.f=t,this.g=i,this.h=s,this.i=d,this.o=new Set,this.f.set(h.$Ah,this),this._globalGraph=d?s?._globalGraph??new A.$5p(y=>y):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...i){const s=p.traceInvocation(this.i,t);let d=!1;try{return t({get:$=>{if(d)throw(0,M.$6)("service accessor is only valid during the invocation of its target method");const r=this.m($,s);if(!r)throw new Error(`[invokeFunction] unknown service '${$}'`);return r}},...i)}finally{d=!0,s.stop()}}createInstance(t,...i){let s,d;return t instanceof F.$yh?(s=p.traceCreation(this.i,t.ctor),d=this.j(t.ctor,t.staticArguments.concat(i),s)):(s=p.traceCreation(this.i,t),d=this.j(t,i,s)),s.stop(),d}j(t,i=[],s){const d=h._util.getServiceDependencies(t).sort((r,o)=>r.index-o.index),y=[];for(const r of d){const o=this.m(r.id,s);o||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),y.push(o)}const $=d.length>0?d[0].index:i.length;if(i.length!==$){console.trace(`[createInstance] First service dependency of ${t.name} at position ${$+1} conflicts with ${i.length} static arguments`);const r=$-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,$)}return Reflect.construct(t,i.concat(y))}k(t,i){if(this.f.get(t)instanceof F.$yh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const s=this.l(t);return s instanceof F.$yh?this.q(t,s,i.branch(t,!0)):(i.branch(t,!1),s)}q(t,i,s){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,s)}finally{this.o.delete(t)}}r(t,i,s){const d=new A.$5p(r=>r.id.toString());let y=0;const $=[{id:t,desc:i,_trace:s}];for(;$.length;){const r=$.pop();if(d.lookupOrInsertNode(r),y++>1e3)throw new D(d);for(const o of h._util.getServiceDependencies(r.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${t} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(o.id)),n instanceof F.$yh){const a={id:o.id,desc:n,_trace:r._trace.branch(o.id,!0)};d.insertEdge(r,a),$.push(a)}}}for(;;){const r=d.roots();if(r.length===0){if(!d.isEmpty())throw new D(d);break}for(const{data:o}of r){if(this.l(o.id)instanceof F.$yh){const a=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,a)}d.removeNode(o)}}return this.l(t)}s(t,i,s=[],d,y){if(this.f.get(t)instanceof F.$yh)return this.t(t,i,s,d,y);if(this.h)return this.h.s(t,i,s,d,y);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,s=[],d,y){if(d){const $=new c(void 0,this.g,this,this.i);$.c=String(t);const r=new Map,o=new w.$Xg(()=>{const n=$.j(i,s,y);for(const[a,E]of r){const b=n[a];if(typeof b=="function")for(const S of E)b.apply(n,S)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let S=r.get(a);return S||(S=new m.$tc,r.set(a,S)),(u,f,l)=>{const R=S.push([u,f,l]);return(0,C.$ic)(R)}}if(a in n)return n[a];const E=o.value;let b=E[a];return typeof b!="function"||(b=b.bind(E),n[a]=b),b},set(n,a,E){return o.value[a]=E,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,s,y)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$6p=c;var v;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const s=new p(3,t.toString());return this.h.push([t,i,s]),s}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function s(y,$){const r=[],o=new Array(y+1).join("	");for(const[n,a,E]of $.h)if(a&&E){i=!0,r.push(`${o}CREATES -> ${n}`);const b=s(y+1,E);b&&r.push(b)}else r.push(`${o}uses -> ${n}`);return r.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(d.join(`
`))}}e.$7p=p}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,c.$Bh)("logService"),e.$6i=(0,c.$Bh)("loggerService");function v(){return new Date().toISOString()}function p(u){return(0,m.$nf)(u)}e.$7i=p;var g;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$8i=g.Info;function t(u,f,l){switch(f){case g.Trace:u.trace(l);break;case g.Debug:u.debug(l);break;case g.Info:u.info(l);break;case g.Warning:u.warn(l);break;case g.Error:u.error(l);break;case g.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=t;function i(u,f=!1){let l="";for(let R=0;R<u.length;R++){let B=u[R];if(B instanceof Error&&(B=(0,w.$mi)(B,f)),typeof B=="object")try{B=JSON.stringify(B)}catch{}l+=(R>0?" ":"")+B}return l}class s extends F.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new M.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==g.Off&&this.b<=f}}e.$0i=s;class d extends s{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...l){this.f(g.Trace)&&this.g(g.Trace,i([f,...l],!0))}debug(f,...l){this.f(g.Debug)&&this.g(g.Debug,i([f,...l]))}info(f,...l){this.f(g.Info)&&this.g(g.Info,i([f,...l]))}warn(f,...l){this.f(g.Warning)&&this.g(g.Warning,i([f,...l]))}error(f,...l){if(this.f(g.Error))if(f instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=f.stack,this.g(g.Error,i(R))}else this.g(g.Error,i([f,...l]))}flush(){}}e.$$i=d;class y extends s{constructor(f=e.$8i){super(),this.setLevel(f),this.g=!h.$i}trace(f,...l){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...l):console.log(`[main ${v()}]`,f,...l))}debug(f,...l){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...l):console.log(`[main ${v()}]`,f,...l))}info(f,...l){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...l):console.log(`[main ${v()}]`,f,...l))}warn(f,...l){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,f,...l):console.warn(`[main ${v()}]`,f,...l))}error(f,...l){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,f,...l):console.error(`[main ${v()}]`,f,...l))}dispose(){}flush(){}}e.$_i=y;class $ extends s{constructor(f=e.$8i,l=!0){super(),this.g=l,this.setLevel(f)}trace(f,...l){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...l):console.log(f,...l))}debug(f,...l){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...l):console.log(f,...l))}info(f,...l){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...l):console.log(f,...l))}warn(f,...l){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...l):console.log(f,...l))}error(f,...l){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...l):console.error(f,...l))}dispose(){}flush(){}}e.$aj=$;class r extends s{constructor(f,l=e.$8i){super(),this.g=f,this.setLevel(l)}trace(f,...l){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(f),...l])}debug(f,...l){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(f),...l])}info(f,...l){this.f(g.Info)&&this.g.log(g.Info,[this.h(f),...l])}warn(f,...l){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(f),...l])}error(f,...l){this.f(g.Error)&&this.g.log(g.Error,[this.h(f),...l])}h(f){return typeof f=="string"?f:(0,w.$mi)(f,this.f(g.Trace))}dispose(){}flush(){}}e.$bj=r;class o extends s{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const l of this.g)l.setLevel(f);super.setLevel(f)}trace(f,...l){for(const R of this.g)R.trace(f,...l)}debug(f,...l){for(const R of this.g)R.debug(f,...l)}info(f,...l){for(const R of this.g)R.info(f,...l)}warn(f,...l){for(const R of this.g)R.warn(f,...l)}error(f,...l){for(const R of this.g)R.error(f,...l)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$cj=o;class n extends F.$kc{constructor(f,l,R){if(super(),this.h=f,this.j=l,this.b=new A.$zi,this.c=this.B(new M.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fd),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(f){return(0,m.$jf)(f)?[...this.b.values()].find(l=>l.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,l){const R=this.n(f),B=(0,m.$jf)(f)?f:l?.id??(0,C.$pi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const U=l?.logLevel==="always"?g.Trace:l?.logLevel;V||(V=this.s(R,U??this.getLogLevel(R)??this.h,{...l,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:U,name:l?.name,hidden:l?.hidden,extensionId:l?.extensionId,when:l?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(f){return(0,m.$jf)(f)?(0,k.$ig)(this.j,`${f}.log`):f}setLogLevel(f,l){if(P.URI.isUri(f)){const R=f,B=l,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=f;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,l){const R=this.m(f);R&&l!==!R.info.hidden&&(R.info.hidden=!l,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,l]))}getLogLevel(f){let l;return f&&(l=this.b.get(f)?.info.logLevel),l??this.h}registerLogger(f){const l=this.b.get(f.resource);l?l.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const l=this.b.get(f);l&&(l.logger&&l.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[l.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=n;class a{constructor(){this.onDidChangeLogLevel=new M.$fd().event}setLevel(f){}getLevel(){return g.Info}trace(f,...l){}debug(f,...l){}info(f,...l){}warn(f,...l){}error(f,...l){}critical(f,...l){}dispose(){}flush(){}}e.$ej=a;class E extends a{}e.$fj=E;function b(u){if(u.verbose)return g.Trace;if(typeof u.logLevel=="string"){const f=I(u.logLevel.toLowerCase());if(f!==void 0)return f}return e.$8i}e.$gj=b;function S(u){switch(u){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$hj=S;function I(u){switch(u){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ij=I,e.$jj=new D.$2i("logLevel",S(g.Info))}),define(Ae[175],Re([1,0,6,14]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class C extends w.$kc{constructor(A,h=[]){super(),this.a=new M.$cj([A,...h]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...h){this.a.trace(A,...h)}debug(A,...h){this.a.debug(A,...h)}info(A,...h){this.a.info(A,...h)}warn(A,...h){this.a.warn(A,...h)}error(A,...h){this.a.error(A,...h)}flush(){this.a.flush()}}e.$rN=C}),define(Ae[94],Re([1,0,29,144,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function m(p,g){return g-p}k.compare=m;const P=Object.create(null);P[k.Error]=(0,M.localize)(0,null),P[k.Warning]=(0,M.localize)(1,null),P[k.Info]=(0,M.localize)(2,null);function D(p){return P[p]||""}k.toString=D;function c(p){switch(p){case w.default.Error:return k.Error;case w.default.Warning:return k.Warning;case w.default.Info:return k.Info;case w.default.Ignore:return k.Hint}}k.fromSeverity=c;function v(p){switch(p){case k.Error:return w.default.Error;case k.Warning:return w.default.Warning;case k.Info:return w.default.Info;case k.Hint:return w.default.Ignore}}k.toSeverity=v}(A||(e.MarkerSeverity=A={}));var h;(function(k){const m="";function P(c){return D(c,!0)}k.makeKey=P;function D(c,v){const p=[m];return c.source?p.push(c.source.replace("\xA6","\\\xA6")):p.push(m),c.code?typeof c.code=="string"?p.push(c.code.replace("\xA6","\\\xA6")):p.push(c.code.value.replace("\xA6","\\\xA6")):p.push(m),c.severity!==void 0&&c.severity!==null?p.push(A.toString(c.severity)):p.push(m),c.message&&v?p.push(c.message.replace("\xA6","\\\xA6")):p.push(m),c.startLineNumber!==void 0&&c.startLineNumber!==null?p.push(c.startLineNumber.toString()):p.push(m),c.startColumn!==void 0&&c.startColumn!==null?p.push(c.startColumn.toString()):p.push(m),c.endLineNumber!==void 0&&c.endLineNumber!==null?p.push(c.endLineNumber.toString()):p.push(m),c.endColumn!==void 0&&c.endColumn!==null?p.push(c.endColumn.toString()):p.push(m),p.push(m),p.join("\xA6")}k.makeKeyOptionalMessage=D})(h||(e.IMarkerData=h={})),e.$3s=(0,C.$Bh)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Qu=e.Severity=void 0,e.Severity=M.default,e.$Qu=(0,C.$Bh)("notificationService");var F;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class k{constructor(){this.progress=new m,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Ru=k;class m{infinite(){}done(){}total(D){}worked(D){}}e.$Su=m}),define(Ae[95],Re([1,0,15,2,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=e.$UT=e.$TT=e.$ST=void 0,e.$ST=(0,C.$Bh)("openerService");function F(m,P){return M.URI.isUri(m)?(0,w.$Me)(m.scheme,P):(0,w.$Ne)(m,P+":")}e.$TT=F;function A(m,...P){return P.some(D=>F(m,D))}e.$UT=A;function h(m,P){return m.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$VT=h;function k(m){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},m=m.with({fragment:""})),{selection:P,uri:m}}e.$WT=k}),define(Ae[177],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,w.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(ve,e,w,M){var C=arguments.length,F=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ve,e,w,M);else for(var h=ve.length-1;h>=0;h--)(A=ve[h])&&(F=(C<3?A(F):C>3?A(e,w,F):A(e,w))||F);return C>3&&F&&Object.defineProperty(e,w,F),F},qe=this&&this.__param||function(ve,e){return function(w,M){e(w,M,ve)}};define(Ae[50],Re([1,0,12,21,6,4]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.ProgressLocation=e.$Tu=void 0,e.$Tu=(0,F.$Bh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Uu=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,c){this.c=D,this.report=c?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const c=this.c(this.a);this.b=Promise.resolve(c).finally(()=>this.b=void 0)})}}e.$Vu=h;let k=class extends C.$kc{constructor(D,c){super(),this.a=new w.$2g,c.withProgress(D,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,C.$ic)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$Wu=k,e.$Wu=k=Ke([qe(1,e.$Tu)],k);class m extends C.$kc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$jc)}start(D){this.stop();const c=++this.a,v=new M.$pd;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$ic)(()=>clearTimeout(this.f))),this.b.add((0,C.$ic)(()=>v.cancel())),this.b.add((0,C.$ic)(()=>this.c?this.c.done():void 0)),{id:c,token:v.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$Xu=m,e.$Yu=(0,F.$Bh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class C{constructor(){this.a=new Map}add(A,h){w.ok(M.$jf(A)),w.ok(M.$lf(h)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,h)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$8m=new C}),define(Ae[73],Re([1,0,5,30]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function C(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class F{constructor(){this.b=new w.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,m){this.a[C(k)]=m,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new F;M.$8m.add(e.$9m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,138,43,73,30]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var m;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$an={Configuration:"base.contributions.configuration"};var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const D=k.$8m.as(h.$9m.JSONContribution);class c{constructor(){this.h=new Set,this.i=new M.$fd,this.onDidSchemaChange=this.i.event,this.j=new M.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const n=new Set;this.n(r,o,n),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const o=new Set;this.o(r,o),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:r,remove:o}){const n=new Set;this.o(o,n),this.n(r,!1,n),D.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const o=new Set;this.k(r,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(r,o){const n=[];for(const{overrides:a,source:E}of r)for(const b in a)if(o.add(b),e.$kn.test(b)){const S=this.a.get(b),I=S?.valuesSources??new Map;if(E)for(const R of Object.keys(a[b]))I.set(R,E);const u={...S?.value||{},...a[b]};this.a.set(b,{source:E,value:u,valuesSources:I});const f=(0,A.$fi)(b),l={type:"object",default:u,description:F.localize(1,null,f),$ref:e.$hn,defaultDefaultValue:u,source:C.$jf(E)?void 0:E,defaultValueSource:E};n.push(...g(b)),this.d[b]=l,this.b.properties[b]=l}else{this.a.set(b,{value:a[b],source:E});const S=this.d[b];S&&(this.w(b,S),this.r(b,S))}this.m(n)}deregisterDefaultConfigurations(r){const o=new Set;this.l(r,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(r,o){for(const{overrides:n,source:a}of r)for(const E in n){const b=this.a.get(E),S=C.$jf(a)?a:a?.id,I=C.$jf(b?.source)?b?.source:b?.source?.id;if(S===I)if(o.add(E),this.a.delete(E),e.$kn.test(E))delete this.d[E],delete this.b.properties[E];else{const u=this.d[E];u&&(this.w(E,u),this.r(E,u))}}this.u()}deltaConfiguration(r){let o=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),o=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),o=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const o of r)this.h.add(o);this.u()}n(r,o,n){r.forEach(a=>{this.p(a,o,a.extensionInfo,a.restrictedProperties,void 0,n),this.c.push(a),this.q(a)})}o(r,o){const n=a=>{if(a.properties)for(const E in a.properties){o.add(E);const b=this.d[E];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[E],this.s(E,a.properties[E])}a.allOf?.forEach(E=>n(E))};for(const a of r){n(a);const E=this.c.indexOf(a);E!==-1&&this.c.splice(E,1)}}p(r,o=!0,n,a,E=3,b){E=C.$sf(r.scope)?E:r.scope;const S=r.properties;if(S)for(const u in S){const f=S[u];if(o&&d(u,f)){delete S[u];continue}if(f.source=n,f.defaultDefaultValue=S[u].default,this.w(u,f),e.$kn.test(u)?f.scope=void 0:(f.scope=C.$sf(f.scope)?E:f.scope,f.restricted=C.$sf(f.restricted)?!!a?.includes(u):f.restricted),S[u].hasOwnProperty("included")&&!S[u].included){this.f[u]=S[u],delete S[u];continue}else this.d[u]=S[u],S[u].policy?.name&&this.e.set(S[u].policy.name,u);!S[u].deprecationMessage&&S[u].markdownDeprecationMessage&&(S[u].deprecationMessage=S[u].markdownDeprecationMessage),b.add(u)}const I=r.allOf;if(I)for(const u of I)this.p(u,o,n,a,E,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const o=n=>{const a=n.properties;if(a)for(const b in a)this.r(b,a[b]);n.allOf?.forEach(o)};o(r)}r(r,o){switch(e.$bn.properties[r]=o,o.scope){case 1:e.$cn.properties[r]=o;break;case 2:e.$dn.properties[r]=o;break;case 6:e.$en.properties[r]=o;break;case 3:e.$fn.properties[r]=o;break;case 4:e.$gn.properties[r]=o;break;case 5:e.$gn.properties[r]=o,this.g.properties[r]=o;break}}s(r,o){switch(delete e.$bn.properties[r],o.scope){case 1:delete e.$cn.properties[r];break;case 2:delete e.$dn.properties[r];break;case 6:delete e.$en.properties[r];break;case 3:delete e.$fn.properties[r];break;case 4:case 5:delete e.$gn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const o=`[${r}]`,n={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$hn};this.w(o,n),e.$bn.properties[o]=n,e.$cn.properties[o]=n,e.$dn.properties[o]=n,e.$en.properties[o]=n,e.$fn.properties[o]=n,e.$gn.properties[o]=n}}v(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=r,e.$cn.patternProperties[e.$jn]=r,e.$dn.patternProperties[e.$jn]=r,e.$en.patternProperties[e.$jn]=r,e.$fn.patternProperties[e.$jn]=r,e.$gn.patternProperties[e.$jn]=r,this.i.fire()}w(r,o){const n=this.a.get(r);let a=n?.value,E=n?.source;C.$qf(a)&&(a=o.defaultDefaultValue,E=void 0),C.$qf(a)&&(a=i(o.type)),o.default=a,o.defaultValueSource=E}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$jn=`^(${v})+$`,e.$kn=new RegExp(e.$jn);function g($){const r=[];if(e.$kn.test($)){let o=p.exec($);for(;o?.length;){const n=o[1].trim();n&&r.push(n),o=p.exec($)}}return(0,w.$Kb)(r)}e.$ln=g;function t($){return $.reduce((r,o)=>`${r}[${o}]`,"")}e.$mn=t;function i($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=i;const s=new c;k.$8m.add(e.$an.Configuration,s);function d($,r){return $.trim()?e.$kn.test($)?F.localize(7,null,$):s.getConfigurationProperties()[$]!==void 0?F.localize(8,null,$):r.policy?.name&&s.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,$,r.policy?.name,s.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.$on=d;function y(){const $=[],r=s.getConfigurationProperties();for(const o of Object.keys(r))$.push([o,r[o].scope]);return $.push(["launch",4]),$.push(["task",4]),$}e.$pn=y}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function v(o){return Object.isFrozen(o)?o:h.$Wm(o)}class p{constructor(n={},a=[],E=[],b){this.b=n,this.c=a,this.d=E,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(a=>{if(a instanceof p)return a;const E=new g("");return E.parseRaw(a),E.configurationModel});this.f=n.reduce((a,E)=>E===a?E:a.merge(E),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$di)(this.contents,n):this.contents}inspect(n,a){const E=this.rawConfiguration.getValue(n),b=a?this.rawConfiguration.getOverrideValue(n,a):void 0,S=a?this.rawConfiguration.override(a).getValue(n):E;return{value:E,override:b,merged:S}}getOverrideValue(n,a){const E=this.i(a);return E?n?(0,P.$di)(E,n):E:void 0}getKeysForOverrideIdentifier(n){const a=[];for(const E of this.overrides)E.identifiers.includes(n)&&a.push(...E.keys);return w.$Kb(a)}getAllOverrideIdentifiers(){const n=[];for(const a of this.overrides)n.push(...a.identifiers);return w.$Kb(n)}override(n){let a=this.a.get(n);return a||(a=this.g(n),this.a.set(n,a)),a}merge(...n){const a=h.$Vm(this.contents),E=h.$Vm(this.overrides),b=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of n)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(a,I.contents);for(const u of I.overrides){const[f]=E.filter(l=>w.$sb(l.identifiers,u.identifiers));f?(this.h(f.contents,u.contents),f.keys.push(...u.keys),f.keys=w.$Kb(f.keys)):E.push(h.$Vm(u))}for(const u of I.keys)b.indexOf(u)===-1&&b.push(u)}return new p(a,b,E,S.every(I=>I instanceof p)?void 0:S)}g(n){const a=this.i(n);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const E={};for(const b of w.$Kb([...Object.keys(this.contents),...Object.keys(a)])){let S=this.contents[b];const I=a[b];I&&(typeof S=="object"&&typeof I=="object"?(S=h.$Vm(S),this.h(S,I)):S=I),E[b]=S}return new p(E,this.keys,this.overrides)}h(n,a){for(const E of Object.keys(a)){if(E in n&&k.$lf(n[E])&&k.$lf(a[E])){this.h(n[E],a[E]);continue}n[E]=h.$Vm(a[E])}}i(n){let a=null,E=null;const b=S=>{S&&(E?this.h(E,S):E=h.$Vm(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===n?a=S.contents:S.identifiers.includes(n)&&b(S.contents);return b(a),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,a){this.j(n,a,!0)}setValue(n,a){this.j(n,a,!1)}removeValue(n){const a=this.keys.indexOf(n);a!==-1&&(this.keys.splice(a,1),(0,P.$ci)(this.contents,n),D.$kn.test(n)&&this.overrides.splice(this.overrides.findIndex(E=>w.$sb(E.identifiers,(0,D.$ln)(n))),1))}j(n,a,E){(0,P.$bi)(this.contents,n,a,b=>console.error(b)),E=E||this.keys.indexOf(n)===-1,E&&this.keys.push(n),D.$kn.test(n)&&this.overrides.push({identifiers:(0,D.$ln)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$ai)(this.contents[n],b=>console.error(b))})}}e.$qn=p;class g{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,a){if(!k.$sf(n)){const E=this.g(n);this.parseRaw(E,a)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,a){this.a=n;const{contents:E,keys:b,overrides:S,restricted:I,hasExcludedProperties:u}=this.h(n,a);this.b=new p(E,b,S,u?[n]:void 0),this.c=I||[]}g(n){let a={},E=null,b=[];const S=[],I=[];function u(l){Array.isArray(b)?b.push(l):E!==null&&(b[E]=l)}const f={onObjectBegin:()=>{const l={};u(l),S.push(b),b=l,E=null},onObjectProperty:l=>{E=l},onObjectEnd:()=>{b=S.pop()},onArrayBegin:()=>{const l=[];u(l),S.push(b),b=l,E=null},onArrayEnd:()=>{b=S.pop()},onLiteralValue:u,onError:(l,R,B)=>{I.push({error:l,offset:R,length:B})}};if(n)try{C.$Sm(n,f),a=b[0]||{}}catch(l){console.error(`Error while parsing settings file ${this.f}: ${l}`),this.d=[l]}return a}h(n,a){const E=c.$8m.as(D.$an.Configuration).getConfigurationProperties(),b=this.i(n,E,!0,a);n=b.raw;const S=(0,P.$ai)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),I=Object.keys(n),u=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:S,keys:I,overrides:u,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(n,a,E,b){let S=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:S};const I={},u=[];for(const f in n)if(D.$kn.test(f)&&E){const l=this.i(n[f],a,!1,b);I[f]=l.raw,S=S||l.hasExcludedProperties,u.push(...l.restricted)}else{const l=a[f],R=l?typeof l.scope<"u"?l.scope:3:void 0;l?.restricted&&u.push(f),!b.exclude?.includes(f)&&(b.include?.includes(f)||(R===void 0||b.scopes===void 0||b.scopes.includes(R))&&!(b.skipRestricted&&l?.restricted))?I[f]=n[f]:S=!0}return{raw:I,restricted:u,hasExcludedProperties:S}}j(n,a){const E=[];for(const b of Object.keys(n))if(D.$kn.test(b)){const S={};for(const I in n[b])S[I]=n[b][I];E.push({identifiers:(0,D.$ln)(b),keys:Object.keys(S),contents:(0,P.$ai)(S,a)})}return E}}e.$rn=g;class t extends F.$kc{constructor(n,a,E,b){super(),this.c=n,this.f=a,this.g=b,this.b=this.B(new M.$fd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&E.isEqual(S.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=t;class i{constructor(n,a,E,b,S,I,u,f,l,R,B,V,U){this.a=n,this.b=a,this.c=E,this.overrideIdentifiers=b,this.d=S,this.f=I,this.g=u,this.h=f,this.i=l,this.j=R,this.k=B,this.l=V,this.m=U}get value(){return v(this.c)}n(n,a,E){const b=n.inspect(a,E);return{get value(){return v(b.value)},get override(){return v(b.override)},get merged(){return v(b.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(n,a,E,b,S=new p,I=new p,u=new A.$zi,f=new p,l=new A.$zi){this.c=n,this.d=a,this.f=E,this.g=b,this.h=S,this.i=I,this.j=u,this.l=f,this.m=l,this.a=null,this.b=new A.$zi,this.n=null}getValue(n,a,E){return this.q(n,a,E).getValue(n)}updateValue(n,a,E={}){let b;E.resource?(b=this.m.get(E.resource),b||(b=new p,this.m.set(E.resource,b))):b=this.l,a===void 0?b.removeValue(n):b.setValue(n,a),E.resource||(this.a=null)}inspect(n,a,E){const b=this.q(n,a,E),S=this.u(a.resource,E),I=a.resource?this.m.get(a.resource)||this.l:this.l,u=new Set;for(const f of b.overrides)for(const l of f.identifiers)b.getOverrideValue(n,l)!==void 0&&u.add(l);return new i(n,a,b.getValue(n),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,S||void 0,I)}keys(n){const a=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,a){this.j.set(n,a),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,a){const E=[];if(!a){const{added:b,updated:S,removed:I}=$(this.c,n);a=[...b,...S,...I]}for(const b of a)for(const S of(0,D.$ln)(b)){const I=this.c.getKeysForOverrideIdentifier(S),u=n.getKeysForOverrideIdentifier(S),f=[...u.filter(l=>I.indexOf(l)===-1),...I.filter(l=>u.indexOf(l)===-1),...I.filter(l=>!h.$Zm(this.c.override(S).getValue(l),n.override(S).getValue(l)))];E.push([S,f])}return this.updateDefaultConfiguration(n),{keys:a,overrides:E}}compareAndUpdatePolicyConfiguration(n){const{added:a,updated:E,removed:b}=$(this.d,n),S=[...a,...E,...b];return S.length&&this.updatePolicyConfiguration(n),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:a,updated:E,removed:b,overrides:S}=$(this.applicationConfiguration,n),I=[...a,...E,...b];return I.length&&this.updateApplicationConfiguration(n),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(n){const{added:a,updated:E,removed:b,overrides:S}=$(this.localUserConfiguration,n),I=[...a,...E,...b];return I.length&&this.updateLocalUserConfiguration(n),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(n){const{added:a,updated:E,removed:b,overrides:S}=$(this.remoteUserConfiguration,n),I=[...a,...E,...b];return I.length&&this.updateRemoteUserConfiguration(n),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(n){const{added:a,updated:E,removed:b,overrides:S}=$(this.workspaceConfiguration,n),I=[...a,...E,...b];return I.length&&this.updateWorkspaceConfiguration(n),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(n,a){const E=this.p.get(n),{added:b,updated:S,removed:I,overrides:u}=$(E,a),f=[...b,...S,...I];return(f.length||!E)&&this.updateFolderConfiguration(n,a),{keys:f,overrides:u}}compareAndDeleteFolderConfiguration(n){const a=this.p.get(n);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:E,updated:b,removed:S,overrides:I}=$(a,void 0);return{keys:[...E,...b,...S],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,a,E){let b=this.r(a,E);return a.overrideIdentifier&&(b=b.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(b=b.merge(this.d)),b}r({resource:n},a){let E=this.s();if(a&&n){const b=a.getFolder(n);b&&(E=this.t(b.uri)||E);const S=this.m.get(n);S&&(E=E.merge(S))}return E}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let a=this.b.get(n);if(!a){const E=this.s(),b=this.j.get(n);b?(a=E.merge(b),this.b.set(n,a)):a=E}return a}u(n,a){if(a&&n){const E=a.getFolder(n);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,a)=>{const{contents:E,overrides:b,keys:S}=this.j.get(a);return n.push([a,{contents:E,overrides:b,keys:S}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(a=>n.add(a)),this.userConfiguration.keys.forEach(a=>n.add(a)),this.i.keys.forEach(a=>n.add(a)),this.j.forEach(a=>a.keys.forEach(E=>n.add(E))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>n.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(E=>n.add(E))),[...n.values()]}w(n){const a=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(E=>a.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(E=>a.add(E)),this.i.getKeysForOverrideIdentifier(n).forEach(E=>a.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(n).forEach(b=>a.add(b))),[...a.values()]}static parse(n){const a=this.x(n.defaults),E=this.x(n.policy),b=this.x(n.application),S=this.x(n.user),I=this.x(n.workspace),u=n.folders.reduce((f,l)=>(f.set(m.URI.revive(l[0]),this.x(l[1])),f),new A.$zi);return new s(a,E,b,S,new p,I,u,new p,new A.$zi)}static x(n){return new p(n.contents,n.keys,n.overrides)}}e.$tn=s;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,a=new Map;for(const b of o)b.keys.forEach(S=>n.add(S)),b.overrides.forEach(([S,I])=>{const u=(0,A.$wi)(a,S,new Set);I.forEach(f=>u.add(f))});const E=[];return a.forEach((b,S)=>E.push([S,[...b.values()]])),{keys:[...n.values()],overrides:E}}e.$un=d;class y{constructor(n,a,E,b){this.change=n,this.f=a,this.g=E,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of n.keys)this.affectedKeys.add(S);for(const[,S]of n.overrides)for(const I of S)this.affectedKeys.add(I);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(n,a){const E=this.a+n,b=this.d.indexOf(E);if(b<0)return!1;const S=b+E.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(a){const u=this.previousConfiguration?this.previousConfiguration.getValue(n,a,this.f?.workspace):void 0,f=this.g.getValue(n,a,this.h);return!h.$Zm(u,f)}return!0}}e.$vn=y;function $(o,n){const{added:a,removed:E,updated:b}=r(n?.rawConfiguration,o?.rawConfiguration),S=[],I=o?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const f=u.filter(l=>!I.includes(l));for(const l of f)S.push([l,n.getKeysForOverrideIdentifier(l)])}if(o){const f=I.filter(l=>!u.includes(l));for(const l of f)S.push([l,o.getKeysForOverrideIdentifier(l)])}if(n&&o){for(const f of I)if(u.includes(f)){const l=r({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});S.push([f,[...l.added,...l.removed,...l.updated]])}}return{added:a,removed:E,updated:b,overrides:S}}function r(o,n){const a=o?n?o.keys.filter(S=>n.keys.indexOf(S)===-1):[...o.keys]:[],E=n?o?n.keys.filter(S=>o.keys.indexOf(S)===-1):[...n.keys]:[],b=[];if(o&&n){for(const S of n.keys)if(o.keys.indexOf(S)!==-1){const I=(0,P.$di)(n.contents,S),u=(0,P.$di)(o.contents,S);h.$Zm(I,u)||b.push(S)}}return{added:a,removed:E,updated:b}}}),define(Ae[97],Re([1,0,9,4]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,M.$Bh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=F;class A{constructor(D,c){this.host=D,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=A;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class k extends w.$_{static isNotAvailable(D){return D instanceof k&&D._code===h.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===h.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===h.NoResolverFound}static isInvalidAuthority(D){return D instanceof k&&D._code===h.InvalidAuthority}static isHandled(D){return D instanceof k&&D.isHandled}constructor(D,c=h.Unknown,v){super(D),this._message=D,this._code=c,this._detail=v,this.isHandled=c===h.NotAvailable&&v===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Mk=k;function m(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Nk=m}),define(Ae[52],Re([1,0,13]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function M(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.$Ok=M;function C(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.$Pk=C;function F(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$Qk=F;function A(m){const{host:P,port:D}=k(m);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Rk=A;function h(m,P){let{host:D,port:c}=k(m);return typeof c>"u"&&(c=P),{host:D,port:c}}e.$Sk=h;function k(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=m.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const c=m.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:m,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function F(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$Tl=F,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var h;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const s=typeof t=="string"?t:t.value,d=typeof i=="string"?i:i.value;return w.$Me(s,d)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Vl=k;class m{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$Wl=m;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,i){this.c.set(k.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=P;function D(g){return c(g)}e.$Yl=D;function c(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$Zl=c;function v(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$1l=v;function p(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Pk)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$2l=p,e.$3l=(0,M.$Bh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IE=e.$HE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,h){this.a.set(A,h)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const h=Object.create(null);for(const k of A){const m=this.readActivationEvents(k);m.length>0&&(h[M.$Vl.toKey(k.identifier)]=m)}return h}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const h=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return h;for(const k in A.contributes){const m=this.a.get(k);if(!m)continue;const P=A.contributes[k],D=Array.isArray(P)?P:[P];try{m(D,h)}catch(c){(0,w.$Y)(c)}}return h}}e.$HE=C,e.$IE=new C}),define(Ae[179],Re([1,0,22,74,36]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function F(k){if(w.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,m,P,D,c,v,p,g){const t=Object.create(null);t["common.machineId"]=v,t.sessionID=(0,C.$4f)()+Date.now(),t.commitHash=D,t.version=c,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=M.$3d,t["common.nodeArch"]=P,t["common.product"]=g||"desktop",p&&(t["common.msftInternal"]=p);let i=0;const s=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const d=F(m);return d&&(t["common.platformDetail"]=d),t}e.$0n=A;function h(k){const m=M.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return k.some(D=>P===D)}e.$$n=h}),define(Ae[180],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,w.$Bh)("telemetryService"),e.$0k=(0,w.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,179,180]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class m{constructor(E){this.value=E,this.isTrustedTelemetryValue=!0}}e.$_n=m;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=P,e.$bo=new P;class D{async publicLog(E,b,S){}async publicLogError(E,b,S){}}e.$co=D,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,E){return C.Event.debounce(E.onDidChangeConfiguration,(S,I)=>{const u=S?new Set([...S.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:u}},1e3,!0)(S=>{S.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,F.$$h)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$go=c;function v(a,E){return!E.isBuilt&&!E.disableTelemetry?!0:!(E.disableTelemetry||!a.enableTelemetry||E.extensionTestsLocationURI)}e.$ho=v;function p(a,E){return!(E.isBuilt||E.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.$io=p;function g(a){const E=a.getValue(k.$dl),b=a.getValue(k.$el);if(a.getValue(k.$fl)===!1||b===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=g;function t(a){const E={},b={},S={};d(a,S);for(let I in S){I=I.length>150?I.substr(I.length-149):I;const u=S[I];typeof u=="number"?b[I]=u:typeof u=="boolean"?b[I]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${u.length}`),E[I]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(E[I]=u)}return{properties:E,measurements:b}}e.$ko=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(a){if(!a)return"none";const E=(0,A.$Pk)(a);return i.has(E)?E:"other"}e.$lo=s;function d(a,E,b=0,S){if(a)for(const I of Object.getOwnPropertyNames(a)){const u=a[I],f=S?S+I:I;Array.isArray(u)?E[f]=(0,w.$1m)(u):u instanceof Date?E[f]=u.toISOString():(0,M.$lf)(u)?b<2?d(u,E,b+1,f+"."):E[f]=(0,w.$1m)(u):E[f]=u}}function y(a,E){const b=a.msftInternalDomains||[],S=E.getValue("telemetry.internalTesting");return(0,h.$$n)(b)||S}e.$mo=y;function $(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.$no=$;function r(a,E){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let b=a;const S=[];for(const l of E)for(;;){const R=l.exec(a);if(!R)break;S.push([R.index,l.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(b="";;){const l=u.exec(a);if(!l)break;const R=S.some(([B,V])=>l.index<V&&B<u.lastIndex);!I.test(l[0])&&!R&&(b+=a.substring(f,l.index)+"<REDACTED: user-file-path>",f=u.lastIndex)}return f<a.length&&(b+=a.substr(f)),b}function o(a){if(!a)return a;const E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of E)if(b.regex.test(a))return`<REDACTED: ${b.label}>`;return a}function n(a,E){return(0,w.$Xm)(a,b=>{if(b instanceof m||Object.hasOwnProperty.call(b,"isTrustedTelemetryValue"))return b.value;if(typeof b=="string"){let S=b.replaceAll("%20"," ");S=r(S,E);for(const I of E)S=S.replace(I,"");return S=o(S),S}})}e.$oo=n}),define(Ae[181],Re([1,0,15,92,20,22,2,9,74,53]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function P(n,a){return n.uuid&&a.uuid?n.uuid===a.uuid:n.id===a.id?!0:(0,w.$He)(n.id,a.id)===0}e.$po=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(a){const E=a.manifest?a.manifest.version:a.version,b=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new c(a.identifier,E,b)}static parse(a){const E=D.exec(a);return E&&E[1]&&E[2]?new c({id:E[1]},E[2],E[4]||void 0):null}constructor(a,E,b="undefined"){this.version=E,this.targetPlatform=b,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof c?P(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$qo=c;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const a=v.exec(n);return a&&a[1]?[t(a[1]),a[2]]:[t(n),void 0]}e.$ro=p;function g(n,a){return`${n}.${a}`}e.$so=g;function t(n){return n.toLowerCase()}e.$to=t;function i(n,a){return t(g(n??C.$Rl,a))}e.$uo=i;function s(n,a){const E=[],b=S=>{for(const I of E)if(I.some(u=>P(a(u),a(S))))return I;return null};for(const S of n){const I=b(S);I?I.push(S):E.push([S])}return E}e.$vo=s;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$wo=d;function y(n){return{id:new m.$_n(n.identifier.id),name:new m.$_n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$xo=y,e.$yo=new C.$Vl("pprice.better-merge");function $(n,a){const E=[],b=a.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const S=b.shift();if(S&&E.every(I=>!P(I.identifier,{id:S}))){const I=n.filter(u=>P(u.identifier,{id:S}));I.length===1&&(E.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$zo=$;async function r(n,a){if(!F.$k)return!1;let E;try{E=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){a.debug("Error while getting the os-release file.",(0,h.$8)(S))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,a){const E=await r(n,a),b=(0,M.$Un)(E?"alpine":F.$t,k.$4d);return a.debug("ComputeTargetPlatform:",b),b}e.$Ao=o}),define(Ae[182],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function w(k){return[...k.entries()]}e.$ar=w;function M(k){return k?[...k.entries()]:[]}e.$br=M;function C(k){return new Map(k)}e.$cr=C;function F(k){return new Map(k??[])}e.$dr=F;function A(k){return Array.from(k.entries()).map(m=>[m[0],w(m[1].map),M(m[1].descriptionMap)])}e.$er=A;function h(k){return new Map(k.map(m=>[m[0],{map:C(m[1]),descriptionMap:F(m[2])}]))}e.$fr=h}),define(Ae[183],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,A=5){const h=F(k=>{const m=typeof k=="string"?k:k.data;let P=this.a.get(C);if(P){P.data.push(m);return}const D=setTimeout(()=>this.flushBuffer(C),A);P={data:[m],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),h.dispose()}},this.a.set(C,P)});return h}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$Xkb=w}),define(Ae[184],Re([1,0,12,89,40,5,16,2,145,73,30]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.IconFontDefinition=e.IconContribution=e.$Uv=void 0,e.$Uv={IconContribution:"base.contributions.icons"};var D;(function(y){function $(r,o){let n=r.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const a=p.getIcon(n.id);if(!a)return;n=a.defaults}return n}y.getDefinition=$})(D||(e.IconContribution=D={}));var c;(function(y){function $(o){return{weight:o.weight,style:o.style,src:o.src.map(n=>({format:n.format,location:n.location.toString()}))}}y.toJSONObject=$;function r(o){const n=a=>(0,A.$jf)(a)?a:void 0;if(o&&Array.isArray(o.src)&&o.src.every(a=>(0,A.$jf)(a.format)&&(0,A.$jf)(a.location)))return{weight:n(o.weight),style:n(o.style),src:o.src.map(a=>({format:a.format,location:h.URI.parse(a.location)}))}}y.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class v{constructor(){this.a=new F.$fd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon($,r,o,n){const a=this.b[$];if(a){if(o&&!a.description){a.description=o,this.d.properties[$].markdownDescription=`${o} $(${$})`;const S=this.e.enum.indexOf($);S!==-1&&(this.e.enumDescriptions[S]=o),this.a.fire()}return a}const E={id:$,description:o,defaults:r,deprecationMessage:n};this.b[$]=E;const b={$ref:"#/definitions/icons"};return n&&(b.deprecationMessage=n),o&&(b.markdownDescription=`${o}: $(${$})`),this.d.properties[$]=b,this.e.enum.push($),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:$}}deregisterIcon($){delete this.b[$],delete this.d.properties[$];const r=this.e.enum.indexOf($);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map($=>this.b[$])}getIcon($){return this.b[$]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont($,r){const o=this.f[$];return o||(this.f[$]=r,this.a.fire(),r)}deregisterIconFont($){delete this.f[$]}getIconFont($){return this.f[$]}toString(){const $=(a,E)=>a.id.localeCompare(E.id),r=a=>{for(;C.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(a=>this.b[a]);for(const a of n.filter(E=>!!E.description).sort($))o.push(`|<i class="${r(a)}"></i>|${a.id}|${C.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const a of n.filter(E=>!C.ThemeIcon.isThemeIcon(E.defaults)).sort($))o.push(`|<i class="${r(a)}"></i>|${a.id}|`);return o.join(`
`)}}const p=new v;P.$8m.add(e.$Uv.IconContribution,p);function g(y,$,r,o){return p.registerIcon(y,$,r,o)}e.$Vv=g;function t(){return p}e.$Wv=t;function i(){const y=(0,M.$Nj)();for(const $ in y){const r="\\"+y[$].toString(16);p.registerIcon($,{fontCharacter:r})}}i(),e.$Xv="vscode://schemas/icons";const s=P.$8m.as(m.$9m.JSONContribution);s.registerSchema(e.$Xv,p.getIconSchema());const d=new w.$Sg(()=>s.notifySchemaChanged(e.$Xv),200);p.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.$Yv=g("widget-close",M.$Pj.close,(0,k.localize)(2,null)),e.$Zv=g("goto-previous-location",M.$Pj.arrowUp,(0,k.localize)(3,null)),e.$1v=g("goto-next-location",M.$Pj.arrowDown,(0,k.localize)(4,null)),e.$2v=C.ThemeIcon.modify(M.$Pj.sync,"spin"),e.$3v=C.ThemeIcon.modify(M.$Pj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProvidedOnAutoForward=e.$2u=e.TunnelPrivacyId=e.TunnelProtocol=e.$1u=e.$Zu=void 0,e.$Zu=(0,C.$Bh)("tunnelService"),e.$1u=(0,C.$Bh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function k(t){return!!t.forwardPort}e.$2u=k;var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$3u=P,e.$4u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$4u.indexOf(t)>=0}e.$5u=D,e.$6u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$6u.indexOf(t)>=0}e.$7u=c;function v(t,i,s,d){if(s===1)return!1;if(s===2&&c(i)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(y?.length===4&&parseInt(y[1])>=18)return!1}return t<1024}e.$8u=v;class p{constructor(i,s,d){this.remoteAddress=i,this.localAddress=s,this.b=d,this.a=new w.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$9u=p;let g=class{constructor(i,s){this.j=i,this.k=s,this.a=new w.$fd,this.onTunnelOpened=this.a.event,this.b=new w.$fd,this.onTunnelClosed=this.b.event,this.c=new w.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],s=Array.from(this.e.values());for(const d of s){const y=Array.from(d.values());for(const $ of y){const r=await $.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(d=>typeof d!="string"?d?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,d,y,$){this.p(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:d,privacy:y,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(c(i)||D(i))&&(i=e.$4u[0]);const d=this.r(i,s);if(d)return++d.refcount,d.value}openTunnel(i,s,d,y,$,r=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${d} on local port ${$}.`);const a=this.f??i;if(!a)return;if(s||(s="localhost"),y||(y=this.l),this.f&&this.i.has(d)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const E=this.s(a,s,d,y,$,r,o,n);return E?E.then(b=>{if(b){if(typeof b=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,d),b}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,d);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(b);return(b.tunnelRemoteHost!==s||b.tunnelRemotePort!==d)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&b.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),E)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const d=s.get(i.tunnelRemotePort);d&&(d.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,d))}}}}async o(i,s,d){if(d.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const y=d.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),y}}async closeTunnel(i,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const d=this.e.get(i);if(d&&d.has(s)){const y=d.get(s);y.refcount=0,await this.o(i,s,y)}}p(i,s,d){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:d})}async q(i,s){const d=this.e.get(i);if(d){const y=d.get(s),$=y?await y.value:void 0;(!$||typeof $=="string")&&d.delete(s),d.size===0&&this.e.delete(i)}}r(i,s){const d=[i];D(i)?(d.push(...e.$4u),d.push(...e.$6u)):c(i)&&d.push(...e.$6u);const y=d.map($=>this.e.get($));for(const $ of y){const r=$?.get(s);if(r)return r}}canTunnel(i){return!!P(i)}t(i,s,d,y,$,r,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${d} on local port ${y}.`);const n=d;this.i.add(n);const a=y===void 0?d:y,E={elevationRequired:$?this.isPortPrivileged(a):!1},b={remoteAddress:{host:s,port:d},localAddressPort:y,privacy:r,public:r?r!==h.Private:void 0,protocol:o},S=i.forwardPort(b,E);return S?(this.p(s,d,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),S}};e.$0u=g,e.$0u=g=Ke([qe(0,F.$5i),qe(1,M.$8h)],g)}),define(Ae[186],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$$u=void 0,e.$$u=(0,w.$Bh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[187],Re([1,0,13]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=void 0;function M(k){return k.scheme!==w.Schemas.file&&k.scheme!==w.Schemas.vscodeRemote}e.$CJ=M;function C(k){if(k.folders.length)return k.folders.every(m=>M(m.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$DJ=C;function F(k){return C(k)?.scheme}e.$EJ=F;function A(k){return C(k)?.authority}e.$FJ=A;function h(k){return C(k)!==void 0}e.$GJ=h}),define(Ae[54],Re([1,0,146,19,48,23,2,4,13]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,h.$Bh)("contextService");function m(a){const E=a;return typeof E?.id=="string"&&A.URI.isUri(E.uri)}e.$Lh=m;function P(a){return typeof a?.id=="string"&&!m(a)&&!c(a)}e.$Mh=P,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function D(a,E){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,M.$ae)(a)}:E?e.$Nh:e.$Oh;const b=a;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.$Ph=D;function c(a){const E=a;return typeof E?.id=="string"&&A.URI.isUri(E.configPath)}e.$Qh=c;function v(a){const E=a;if(E?.uri)return{id:E.id,uri:A.URI.revive(E.uri)};const b=a;if(b?.configPath)return{id:b.id,configPath:A.URI.revive(b.configPath)};if(a?.id)return{id:a.id}}e.$Rh=v;var p;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function g(a){const E=a;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$Sh=g;function t(a){const E=a;return!!(E&&typeof E=="object"&&A.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$Th=t;class i{constructor(E,b,S,I,u){this.h=E,this.j=S,this.k=I,this.l=u,this.c=C.$Hh.forUris(this.l,()=>!0),this.folders=b}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=C.$Hh.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=i;class s{constructor(E,b){this.raw=b,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,F.$ig)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=s;function d(a){return new s({uri:a,index:0,name:(0,F.$eg)(a)},{uri:a.toString()})}e.$Wh=d,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,w.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function y(a,E){return F.$_f.isEqualOrParent(a,E.untitledWorkspacesHome)}e.$2h=y;function $(a){let E;return A.URI.isUri(a)?E=a:E=a.configuration,E?.scheme===k.Schemas.tmp}e.$3h=$,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(a){return a.id===e.$4h}e.$5h=r;function o(a,E){return!y(a,E)&&!$(a)}e.$6h=o;function n(a){return(typeof a=="string"?(0,M.$be)(a):(0,F.$gg)(a))===e.$Yh}e.$7h=n}),define(Ae[55],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$jbc=w}),define(Ae[39],Re([1,0,13,23,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0;class F{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$0f(h=>{const k=this.b.get(h.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(h,k){k===null?this.b.delete(h.scheme):this.b.set(h.scheme,k)}isFreeScheme(h){return!this.b.has(h)&&!this.a.has(h)}getCapabilities(h){return this.b.get(h)}}e.$lbc=F,e.$mbc=(0,C.$Bh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=void 0,e.$kM=(0,w.$Bh)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;let A=class extends C.$rN{constructor(k,m,P){const D=P.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",c=P.remote.isRemote?(0,w.localize)(0,null):k?(0,w.localize)(1,null):(0,w.localize)(2,null);super(m.createLogger(D,{name:c}))}};e.$tdc=A,e.$tdc=A=Ke([qe(1,M.$6i),qe(2,F.$kM)],A)}),define(Ae[189],Re([1,0,12]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=e.$Obc=void 0;class M{constructor(A,h,k){this.h=new Map,this.a=A,this.b=h,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new w.$Sg(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of m.values())P.complete()}catch(P){for(const D of m.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,h){let k=this.f[A];return typeof k>"u"&&(k=h),k}update(A,h){this.f[A]=h;const k=this.h.get(A);if(k!==void 0)return k.p;const m=new w.$2g;return this.h.set(A,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.$Obc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,h){super(A.identifier.value,!0,h),this.j=A}}e.$Pbc=C}),define(Ae[190],Re([1,0,5,2]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class C{constructor(A){this.c=A,this.a=new w.$fd,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$fd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,h,k,m){const D=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(h.value,k,m);this.b.fire(D)}$acceptDirtyStateChanged(A,h){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(h)}$acceptModelSaved(A){const h=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(h.apiNotebook)}}e.$bdc=C}),define(Ae[17],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0,e.$7L=(0,w.$Bh)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$8L=M}),define(Ae[191],Re([1,0,20,5]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class C{#e;constructor(A,h){this.b=new M.$fd,this.onDidChange=this.b.event,this.a=w.$Vl.toKey(A.identifier),this.#e=h,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return this.#e.get(this.a,A)}store(A,h){return this.#e.store(this.a,A,h)}delete(A){return this.#e.delete(this.a,A)}}e.$1bc=C}),define(Ae[56],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0,e.$wbc=(0,w.$Bh)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$xbc=M}),define(Ae[192],Re([1,0,25]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecb=e.$dcb=void 0;class M{constructor(){this.buffers=[]}add(k){let m=this.buffers.indexOf(k);return m<0&&(m=this.buffers.length,this.buffers.push(k)),m}}function C(h,k){if(k.serializeBuffersForPostMessage){const m=new M,D=JSON.stringify(h,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(p)};if(ArrayBuffer.isView(p)){const g=F(p);if(g)return{$$vscode_array_buffer_reference$$:!0,index:m.add(p.buffer),view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),c=m.buffers.map(v=>{const p=new Uint8Array(v);return w.$Fd.wrap(p)});return{message:D,buffers:c}}else return{message:JSON.stringify(h),buffers:[]}}e.$dcb=C;function F(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(h,k){const m=k.map(c=>{const v=new ArrayBuffer(c.byteLength);return new Uint8Array(v).set(c.buffer),v}),P=k.length?(c,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:g}=p,t=m[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse(h,P),arrayBuffers:m}}e.$ecb=A}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,13,41,128,29]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.EditorsOrder=e.$6D=e.CloseDirection=e.$5D=e.$4D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.EditorInputCapabilities=e.$UD=e.SaveReason=e.Verbosity=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=void 0,e.$ID={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$JD={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$KD="workbench.editor.sidebysideEditor",e.$LD="workbench.editors.textDiffEditor",e.$MD="workbench.editors.binaryResourceDiffEditor";var v;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function g(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$ND=g;function t(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$OD=t;function i(ce){if(b(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$PD=i;function s(ce){if(b(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$QD=s;function d(ce){if(b(ce)||s(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$RD=d;function y(ce){if(b(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===m.Schemas.untitled||$e.forceUntitled===!0:!1}e.$SD=y;function $(ce){if(b(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$TD=$;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var o;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class n{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$UD=new n;var a;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(a||(e.EditorInputCapabilities=a={}));class E extends F.$kc{}e.$VD=E;function b(ce){return ce instanceof E}e.$WD=b;function S(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function I(ce){const $e=ce;return b($e?.primary)&&b($e?.secondary)}e.$XD=I;function u(ce){const $e=ce;return b($e?.modified)&&b($e?.original)}e.$YD=u;function f(ce,$e,ie,z,q){return Ee(z,[(0,D.$li)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ue={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,ue)}}),(0,D.$li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$ZD=f;function l(ce){return b(ce?.editor)}e.$1D=l;function R(ce){const $e=ce;return l(ce)&&$e?.group!==void 0}e.$2D=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&b($e.editor)}e.$3D=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class O{getOriginalUri($e,ie){if(!$e)return;if($($e))return e.$5D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(s($e)||d($e)||$($e))return;const z=S($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return I($e)||d($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||s($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if($($e))return e.$5D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(s($e)||d($e)||$($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$4D=ee,e.$5D=new O;var Z;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Ah);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$uf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,F.$ic)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}h.$8m.add(e.$ID.EditorFactory,new ye);async function De(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,be=z.type;if(typeof we!="boolean"||typeof be!="number")try{be=(await $e.stat(q)).isDirectory?k.FileType.Directory:k.FileType.Unknown,we=!0}catch(ke){ie.error(ke),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(be===k.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const ge={...z.options,pinned:!0};return we?{resource:q,options:ge}:{resource:q,options:ge,forceUntitled:!0}}))}e.$6D=De;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Y(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return Y(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$7D=Y;function le(ce){return(0,P.$ni)(ce)}e.$8D=le;function Ee(ce,$e,ie){const z=(0,P.$oi)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$9D=Ee}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$dE=e.$cE=e.ViewContentGroups=e.$bE=e.$aE=e.ViewContainerLocation=e.Extensions=e.$_D=void 0,e.$_D=(0,c.$Vv)("default-view-icon",D.$Pj.window,(0,M.localize)(0,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var p;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$aE=[0,1,2];function g(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bE=g;class t extends F.$kc{constructor(){super(...arguments),this.c=this.B(new w.$fd),this.onDidRegister=this.c.event,this.f=this.B(new w.$fd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Pb)([...this.g.values()])}registerViewContainer(a,E,b){const S=this.get(a.id);if(S)return S;const I=a;return I.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$wi)(this.g,E,[]).push(I),b?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:E}),I}deregisterViewContainer(a){for(const E of this.g.keys()){const b=this.g.get(E),S=b?.indexOf(a);if(S!==-1){b?.splice(S,1),b.length===0&&this.g.delete(E),this.f.fire({viewContainer:a,viewContainerLocation:E});return}}}get(a){return this.all.filter(E=>E.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(E=>this.getViewContainers(E).filter(b=>b?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(E=>this.getViewContainerLocation(E)===a)}}h.$8m.add(v.ViewContainersRegistry,new t);var i;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(i||(e.ViewContentGroups=i={}));function s(n,a){const E=n.group??i.More,b=a.group??i.More;return E!==b?E.localeCompare(b):(n.order??5)-(a.order??5)}class d extends F.$kc{constructor(){super(...arguments),this.c=this.B(new w.$fd),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$fd),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$fd),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$fd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new m.$L}registerViews(a,E){this.registerViews2([{views:a,viewContainer:E}])}registerViews2(a){a.forEach(({views:E,viewContainer:b})=>this.r(E,b)),this.c.fire(a)}deregisterViews(a,E){const b=this.s(a,E);b.length&&this.f.fire({views:b,viewContainer:E})}moveViews(a,E){for(const b of this.m.keys())if(b!==E){const S=this.s(a,b);S.length&&(this.r(S,E),this.g.fire({views:S,from:b,to:E}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const E of this.j){const b=(this.m.get(E)||[]).filter(S=>S.id===a)[0];if(b)return b}return null}getViewContainer(a){for(const E of this.j)if((this.m.get(E)||[]).filter(S=>S.id===a)[0])return E;return null}registerViewWelcomeContent(a,E){return this.n.add(a,E),this.h.fire(a),(0,F.$ic)(()=>{this.n.delete(a,E),this.h.fire(a)})}registerViewWelcomeContent2(a,E){const b=new Map;for(const[S,I]of E)this.n.add(a,I),b.set(S,(0,F.$ic)(()=>{this.n.delete(a,I),this.h.fire(a)}));return this.h.fire(a),b}getViewWelcomeContent(a){const E=[];return this.n.forEach(a,b=>E.push(b)),E.sort(s)}r(a,E){let b=this.m.get(E);b||(b=[],this.m.set(E,b),this.j.push(E));for(const S of a){if(this.getView(S.id)!==null)throw new Error((0,M.localize)(1,null,S.id));b.push(S)}}s(a,E){const b=this.m.get(E);if(!b)return[];const S=[],I=[];for(const u of b)a.includes(u)?S.push(u):I.push(u);return S.length&&(I.length?this.m.set(E,I):(this.m.delete(E),this.j.splice(this.j.indexOf(E),1))),S}}h.$8m.add(v.ViewsRegistry,new d),e.$cE=(0,C.$Bh)("viewsService"),e.$dE=(0,C.$Bh)("viewDescriptorService");var y;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(y||(e.ViewVisibilityState=y={}));var $;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})($||(e.TreeItemCollapsibleState=$={}));class r{constructor(a,E){this.c=!1,this.d=!1,(0,P.$Ym)(this,a),this.d=!!E,this.resolve=async b=>{if(E&&!this.c){const S=await E(b);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$eE=r;class o extends Error{constructor(a){super((0,M.localize)(2,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$fE=o}),define(Ae[194],Re([1,0,5,12,162]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new w.$fd,this.n=new w.$fd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(h){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=h}onEvent(h){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=h}onRequest(h){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=h}sendResponse(h){h.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.s("response",h)}sendRequest(h,k,m,P){const D={command:h};if(k&&Object.keys(k).length>0&&(D.arguments=k),this.s("request",D),typeof P=="number"){const c=setTimeout(()=>{clearTimeout(c);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:h,message:(0,C.localize)(0,null,P,h)};v(p)}},P)}return m&&this.f.set(D.seq,m),D.seq}acceptMessage(h){this.j?this.j(h):(this.k.push(h),this.k.length===1&&this.q())}o(h,k){return h.type!=="event"||k.type!=="event"}async q(){let h;for(;this.k.length;){if((!h||this.o(this.k[0],h))&&await(0,M.$Hg)(0),h=this.k.shift(),!h)return;switch(h.type){case"event":this.i?.(h);break;case"request":this.g?.(h);break;case"response":{const k=h,m=this.f.get(k.request_seq);m&&(this.f.delete(k.request_seq),m(k));break}}}}s(h,k){k.type=h,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const h=new Map;this.f.forEach((k,m)=>h.set(m,k)),await(0,M.$Hg)(500),h.forEach((k,m)=>{k({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Jcb=F}),define(Ae[195],Re([1,0,163,32,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$UG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$TG=e.MemoryRangeType=e.$SG=e.State=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF="workbench.view.debug",e.$RF="workbench.debug.variablesView",e.$SF="workbench.debug.watchExpressionsView",e.$TF="workbench.debug.callStackView",e.$UF="workbench.debug.loadedScriptsView",e.$VF="workbench.debug.breakPointsView",e.$WF="workbench.debug.disassemblyView",e.$XF="workbench.panel.repl",e.$YF="workbench.panel.repl.view",e.$ZF=new M.$2i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$1F=new M.$2i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$2F=new M.$2i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$3F="debugUx",e.$4F=new M.$2i(e.$3F,"default",{type:"string",description:w.localize(3,null)}),e.$5F=new M.$2i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$6F=new M.$2i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$7F=new M.$2i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$8F=new M.$2i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$9F=new M.$2i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$0F=new M.$2i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$$F=new M.$2i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$_F=new M.$2i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$aG=new M.$2i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$bG=new M.$2i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$cG=new M.$2i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$dG=new M.$2i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$eG=new M.$2i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$fG=new M.$2i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$gG=new M.$2i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$hG=new M.$2i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$iG=new M.$2i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$jG=new M.$2i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$kG=new M.$2i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$lG=new M.$2i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$mG=new M.$2i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$nG=new M.$2i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$oG=new M.$2i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$pG=new M.$2i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$qG=new M.$2i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$rG=new M.$2i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$sG=new M.$2i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$tG=new M.$2i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$uG=new M.$2i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$vG=new M.$2i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$wG=new M.$2i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$xG=new M.$2i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$yG=new M.$2i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$zG=new M.$2i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$AG=new M.$2i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$BG=new M.$2i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$CG=new M.$2i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$DG=new M.$2i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$EG=new M.$2i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$FG=new M.$2i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$GG=new M.$2i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$HG=new M.$2i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$IG=new M.$2i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$JG=new M.$2i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$KG=new M.$2i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$LG=new M.$2i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$MG=new M.$2i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=c=>w.localize(51,null,c);e.$NG=F,e.$OG="editor.contrib.debug",e.$PG="editor.contrib.breakpoint",e.$QG="debug",e.$RG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(A||(e.State=A={}));function h(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$SG=h;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$TG="vscode-debug-memory";var m;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var P;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$UG=(0,C.$Bh)("debugService");var D;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[196],Re([1,0,15,2,19,24,13,44,21,18]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const P=/{([^}]+)}/g;function D(I,u,f){return I.replace(P,function(l,R){return u&&R.length>0&&R[0]!=="_"?l:f&&f.hasOwnProperty(R)?f[R]:l})}e.$fF=D;function c(I){const u={};for(const f of Object.keys(I))f.startsWith("!")||(u[f]=I[f]);return u}e.$gF=c;function v(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||v(I.parentSession))}e.$hF=v;function p(I){let u=I.configuration.type;if(u)return u==="vslsShare"&&(u=I.configuration.adapterProxy.configuration.type),(0,w.$Me)(u,"extensionhost")||(0,w.$Me)(u,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}e.$iF=p;function g(I){return I.type&&(I.label||I.program||I.runtime)}e.$jF=g;function t(I,u,f){let l,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(I);){const U=V.index+1,W=U+V[0].length;if(U<=u&&W>=f){l=V[0],R=U;break}}if(l){const U=/\w+/g;let W=null;for(;(W=U.exec(l))&&!(W.index+1+R+W[0].length>=f););W&&(l=l.substring(0,U.lastIndex))}return l?{start:R,end:R+l.length-1}:{start:0,end:0}}e.$kF=t;async function i(I,u,f,l){if(I.evaluatableExpressionProvider.has(u)){const R=I.evaluatableExpressionProvider.ordered(u),B=(0,m.$Fb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(u,f,l??k.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const U=B[0].range;return V||(V=u.getLineContent(f.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const R=u.getLineContent(f.lineNumber),{start:B,end:V}=t(R,f.column,f.column),U=R.substring(B-1,V);return{matchingExpression:U,range:new h.$ks(f.lineNumber,B,f.lineNumber,B+U.length)}}return null}e.$lF=i;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(I){return!!(I&&I.match(s))}e.$mF=d;function y(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(d(I.path))return M.URI.parse(I.path);if((0,C.$8d)(I.path))return M.URI.file(I.path)}return I.path}function $(I){if(typeof I.path=="object"){const u=M.URI.revive(I.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return I.path}function r(I,u){const f=u?y:$,l=(0,F.$Vm)(I);return n(l,(R,B)=>{R&&B&&(B.path=f(B))}),l}e.$nF=r;function o(I,u){const f=u?y:$,l=(0,F.$Vm)(I);return n(l,(R,B)=>{!R&&B&&(B.path=f(B))}),l}e.$oF=o;function n(I,u){switch(I.type){case"event":{const f=I;switch(f.event){case"output":u(!1,f.body.source);break;case"loadedSource":u(!1,f.body.source);break;case"breakpoint":u(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=I;switch(f.command){case"setBreakpoints":u(!0,f.arguments.source);break;case"breakpointLocations":u(!0,f.arguments.source);break;case"source":u(!0,f.arguments.source);break;case"gotoTargets":u(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(l=>u(!1,l));break;default:break}break}case"response":{const f=I;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(l=>u(!1,l.source));break;case"loadedSources":f.body.sources.forEach(l=>u(!1,l));break;case"scopes":f.body.scopes.forEach(l=>u(!1,l.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(l=>u(!1,l.source));break;case"setBreakpoints":f.body.breakpoints.forEach(l=>u(!1,l.source));break;case"disassemble":f.body?.instructions.forEach(R=>u(!1,R.location));break;default:break}break}}}function a(I){return I.filter(u=>!u.presentation?.hidden).sort((u,f)=>u.presentation?f.presentation?u.presentation.group?f.presentation.group?u.presentation.group!==f.presentation.group?u.presentation.group.localeCompare(f.presentation.group):E(u.presentation.order,f.presentation.order):-1:f.presentation.group?1:E(u.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$pF=a;function E(I,u){return typeof I!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:I-u}async function b(I,u){const f=I.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(f!=="none"&&(await u.saveAll(),f==="allEditorsInActiveGroup")){const l=u.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:l.input,groupId:l.group.id})}await I.reloadConfiguration()}e.$qF=b;const S=(I,u)=>!I||!u?I===u:I.name===u.name&&I.path===u.path&&I.sourceReference===u.sourceReference;e.$rF=S}),define(Ae[75],Re([1,0,25,37,67,68,13,19,22,32]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gI=e.$fI=e.$eI=e.$dI=e.CellStatusbarAlignment=e.$cI=e.$bI=e.$aI=e.NotebookEditorPriority=e.$_H=e.$$H=e.$0H=e.$9H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$8H=e.$7H=e.$6H=e.$5H=e.CellKind=e.$4H=e.$3H=e.$2H=void 0,e.$2H="workbench.editor.notebook",e.$3H="workbench.editor.notebookTextDiffEditor",e.$4H="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$5H=["application/json","application/javascript","text/html","image/svg+xml",F.$Hr.latex,F.$Hr.markdown,"image/png","image/jpeg",F.$Hr.text],e.$6H=[F.$Hr.latex,F.$Hr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Hr.text],e.$7H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$8H="_notAvailable";var D;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var g;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var s;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var d;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${ee.join("")}]+`),ye=7;function De($e,ie){const z=ie.toString(ye),ue=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,w.$Zd)(w.$Fd.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:ue})}N.generate=De;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Z,""),ye),q=(0,w.$Yd)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function Y($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=Y;function le($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=le;function Ee($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=Ee;function ce($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(d||(e.CellUri=d={}));const y=N=>k.$i?N.replace(/\//g,"\\"):N;class ${constructor(ee=[],Z=e.$5H){this.e=Z,this.d=[...new Set(ee)].map(ye=>({pattern:ye,matches:M.$rj(y(ye))}))}sort(ee){const Z=new Map(C.Iterable.map(ee,De=>[De,y(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Pe,Y]of Z)if(De(Y)){ye.push(Pe),Z.delete(Pe);break}return Z.size&&(ye=ye.concat([...Z.keys()].sort((De,Pe)=>this.e.indexOf(De)-this.e.indexOf(Pe)))),ye}prioritize(ee,Z){const ye=this.f(ee);if(ye===-1){this.d.unshift({pattern:ee,matches:M.$rj(y(ee))});return}const De=new Set(Z.map(Y=>this.f(Y,ye)));De.delete(-1);const Pe=Array.from(De).sort();this.d.splice(ye+1,0,...Pe.map(Y=>this.d[Y]));for(let Y=Pe.length-1;Y>=0;Y--)this.d.splice(Pe[Y],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,Z=this.d.length){const ye=y(ee);for(let De=0;De<Z;De++)if(this.d[De].matches(ye))return De;return-1}}e.$9H=$;function r(N,ee,Z,ye=(De,Pe)=>De===Pe){const De=[];function Pe(Ee,ce,$e){if(ce===0&&$e.length===0)return;const ie=De[De.length-1];ie&&ie.start+ie.deleteCount===Ee?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):De.push({start:Ee,deleteCount:ce,toInsert:$e})}let Y=0,le=0;for(;;){if(Y===N.length){Pe(Y,0,ee.slice(le));break}if(le===ee.length){Pe(Y,N.length-Y,[]);break}const Ee=N[Y],ce=ee[le];if(ye(Ee,ce)){Y+=1,le+=1;continue}Z(ce)?(Pe(Y,1,[]),Y+=1):(Pe(Y,0,[ce]),le+=1)}return De}e.$0H=r,e.$$H=new m.$2i("notebookEditorCursorAtBoundary","none"),e.$_H=new m.$2i("notebookEditorCursorAtLineBoundary","none");var o;(function(N){N.default="default",N.option="option"})(o||(e.NotebookEditorPriority=o={}));function n(N){const ee=N;return!!((typeof ee.include=="string"||M.$sj(ee.include))&&(typeof ee.exclude=="string"||M.$sj(ee.exclude)))}e.$aI=n;function a(N,ee,Z){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const ye=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,De=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$qj(ye,(0,h.$ae)(Z.fsPath).toLowerCase()))return!(De&&M.$qj(De,(0,h.$ae)(Z.fsPath).toLowerCase()))}return!1}e.$bI=a,e.$cI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",cellExecutionScroll:"notebook.revealNextOnExecuteBehavior"};var E;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(E||(e.CellStatusbarAlignment=E={}));class b{static{this.d="notebook/"}static create(ee){return`${b.d}${ee}`}static parse(ee){if(ee.startsWith(b.d))return ee.substring(b.d.length)}}e.$dI=b;function S(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$eI=S;const I=new TextDecoder;function u(N){const ee=[];let Z=!1;for(const Y of N)(ee.length===0||Z)&&(ee.push(Y),Z=!0);let ye=R(ee);const De=w.$Fd.concat(ee.map(Y=>w.$Fd.wrap(Y))),Pe=O(De);return ye=ye||Pe.byteLength!==De.byteLength,{data:Pe,didCompression:ye}}e.$fI=u,e.$gI=`${String.fromCharCode(27)}[A`;const f=e.$gI.split("").map(N=>N.charCodeAt(0)),l=10;function R(N){let ee=!1;return N.forEach((Z,ye)=>{if(ye===0||Z.length<e.$gI.length)return;const De=N[ye-1],Pe=Z.subarray(0,e.$gI.length);if(Pe[0]===f[0]&&Pe[1]===f[1]&&Pe[2]===f[2]){const Y=De.lastIndexOf(l);if(Y===-1)return;ee=!0,N[ye-1]=De.subarray(0,Y),N[ye]=Z.subarray(e.$gI.length)}}),ee}function B(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let Z=N.match(/\r+(.*)$/m)[1];Z=Z+ee.slice(Z.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return N}const U="\b".charCodeAt(0),W="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(W)?N:w.$Fd.fromString(V(B(I.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p){"use strict";var g,t,i,s,d,y,$,r,o,n,a,E,b,S,I,u,f,l;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$VL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.TestRunProfileKind=e.TestResultState=e.$CL=e.$BL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AL=e.$zL=e.$yL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.ColorThemeKind=e.$rL=e.$qL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pL=e.DebugConsoleMode=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$jL=e.$iL=e.FileChangeType=e.$hL=e.$gL=e.$fL=e.$eL=e.InlineCompletionTriggerKind=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.ConfigurationTarget=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$TK=e.ViewBadge=e.ProgressLocation=e.$SK=e.$RK=e.TaskScope=e.ShellQuoting=e.$QK=e.$PK=e.$OK=e.TaskPanelKind=e.TaskRevealKind=e.$NK=e.TerminalLocation=e.$MK=e.$LK=e.$KK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$JK=e.$IK=e.$HK=e.$GK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$FK=e.StatusBarAlignment=e.ViewColumn=e.$EK=e.$DK=e.$CK=e.$BK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$AK=e.$zK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.LanguageStatusSeverity=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.CodeActionTriggerKind=e.$nK=e.$mK=e.SymbolTag=e.SymbolKind=e.$lK=e.DocumentHighlightKind=e.$kK=e.$jK=e.$iK=e.$hK=e.DiagnosticSeverity=e.DiagnosticTag=e.$gK=e.$fK=e.FileEditType=e.$eK=e.$dK=e.$cK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(j,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const[Se,...Je]=ne;return Reflect.construct(j,Je,Se.constructor)}}})}var B;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=g=class{static from(...L){let ne=L;return new g(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8J=U,e.$8J=U=g=Ke([R],U);let W=t=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:ne,character:Se}=L;return typeof ne=="number"&&typeof Se=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ne){if(L<0)throw(0,M.$5)("line must be non-negative");if(ne<0)throw(0,M.$5)("character must be non-negative");this.c=L,this.e=ne}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,M.$5)();let Se;return typeof L>"u"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ne===0?this:new t(this.line+Se,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,M.$5)();let Se;return typeof L>"u"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Se===this.line&&ne===this.character?this:new t(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$9J=W,e.$9J=W=t=Ke([R],W);let O=i=class{static isRange(L){return L instanceof i?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ne,Se,Je){let Ze,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ze=new W(L,ne),at=new W(Se,Je)):W.isPosition(L)&&W.isPosition(ne)&&(Ze=W.of(L),at=W.of(ne)),!Ze||!at)throw new Error("Invalid arguments");Ze.isBefore(at)?(this.c=Ze,this.e=at):(this.c=at,this.e=Ze)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ne=W.Max(L.start,this.c),Se=W.Min(L.end,this.e);if(!ne.isAfter(Se))return new i(ne,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=W.Min(L.start,this.c),Se=W.Max(L.end,this.end);return new i(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,M.$5)();let Se;return L?W.isPosition(L)?Se=L:(Se=L.start||this.start,ne=L.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new i(Se,ne)}toJSON(){return[this.start,this.end]}};e.$0J=O,e.$0J=O=i=Ke([R],O);let N=s=class extends O{static isSelection(L){return L instanceof s?!0:L?O.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ne,Se,Je){let Ze,at;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ze=new W(L,ne),at=new W(Se,Je)):W.isPosition(L)&&W.isPosition(ne)&&(Ze=W.of(L),at=W.of(ne)),!Ze||!at)throw new Error("Invalid arguments");super(Ze,at),this.f=Ze,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$J=N,e.$$J=N=s=Ke([R],N);const ee=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$5)("connectionToken")};class Z{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne,Se){if(typeof L!="string"||L.length===0)throw(0,M.$5)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$5)("port");typeof Se<"u"&&ee(Se),this.host=L,this.port=Math.round(ne),this.connectionToken=Se}}e.$_J=Z;class ye{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne){this.makeConnection=L,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.$aK=ye;class De extends Error{static NotAvailable(L,ne){return new De(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new De(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=v.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L),this._message=L,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$bK=De;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Y;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let le=d=class{static isTextEdit(L){return L instanceof d?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new d(L,ne)}static insert(L,ne){return d.replace(new O(L,L),ne)}static delete(L){return d.replace(L,"")}static setEndOfLine(L){const ne=new d(new O(new W(0,0),new W(0,0)),"");return ne.newEol=L,ne}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,M.$5)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$5)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$5)("newEol");this.f=L}constructor(L,ne){this.c=L,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cK=le,e.$cK=le=d=Ke([R],le);let Ee=y=class{static isNotebookCellEdit(L){return L instanceof y?!0:L?xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new y(L,ne)}static insertCells(L,ne){return new y(new xt(L,L),ne)}static deleteCells(L){return new y(L,[])}static updateCellMetadata(L,ne){const Se=new y(new xt(L,L),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(L){const ne=new y(new xt(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};e.$dK=Ee,e.$dK=Ee=y=Ke([R],Ee);class ce{static isSnippetTextEdit(L){return L instanceof ce?!0:L?O.isRange(L.range)&&z.isSnippetString(L.snippet):!1}static replace(L,ne){return new ce(L,ne)}static insert(L,ne){return ce.replace(new O(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.$eK=ce;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ne,Se,Je){this.c.push({_type:1,from:L,to:ne,options:Se,metadata:Je})}createFile(L,ne,Se){this.c.push({_type:1,from:void 0,to:L,options:ne,metadata:Se})}deleteFile(L,ne,Se){this.c.push({_type:1,from:L,to:void 0,options:ne,metadata:Se})}e(L,ne,Se){this.c.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(L,ne,Se,Je){const Ze=ne.start,at=ne.end;(Ze!==at||Se.length>0)&&this.c.push({_type:5,uri:L,index:Ze,count:at-Ze,cells:Se,metadata:Je})}g(L,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:L,edit:{editType:3,index:ne,metadata:Se}})}replace(L,ne,Se,Je){this.c.push({_type:2,uri:L,edit:new le(ne,Se),metadata:Je})}insert(L,ne,Se,Je){this.replace(L,new O(ne,ne),Se,Je)}delete(L,ne,Se){this.replace(L,ne,"",Se)}has(L){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,Ze;Array.isArray(Se)?(Je=Se[0],Ze=Se[1]):Je=Se,Ee.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(L,Je.range.start,Je.newCellMetadata,Ze):Je.newNotebookMetadata?this.e(L,Je.newNotebookMetadata,Ze):this.f(L,Je.range,Je.newCells,Ze):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:L,range:Je.range,edit:Je.snippet,metadata:Ze}):this.c.push({_type:2,uri:L,edit:Je,metadata:Ze})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===L.toString()&&(this.c[Se]=void 0);break}}(0,w.$Gb)(this.c)}}get(L){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===L.toString()&&ne.push(Se.edit);return ne}entries(){const L=new F.$zi;for(const ne of this.c)if(ne._type===2){let Se=L.get(ne.uri);Se||(Se=[ne.uri,[]],L.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fK=ie,e.$fK=ie=Ke([R],ie);let z=$=class{static isSnippetString(L){return L instanceof $?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=$.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this.e++){if(typeof L=="function"){const Se=new $;Se.e=this.e,L(Se),this.e=Se.e,L=Se.value}else L=$.c(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this.e++){const Se=L.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Se=new $;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$gK=z,e.$gK=z=$=Ke([R],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ue;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let we=r=class{static isLocation(L){return L instanceof r?!0:L?O.isRange(L.range)&&m.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(O.isRange(ne))this.range=O.of(ne);else if(W.isPosition(ne))this.range=new O(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hK=we,e.$hK=we=r=Ke([R],we);let be=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&m.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};e.$iK=be,e.$iK=be=Ke([R],be);let ge=class{constructor(L,ne,Se=ue.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Se}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,w.$sb)(L.tags,ne.tags)&&(0,w.$sb)(L.relatedInformation,ne.relatedInformation,be.isEqual)}};e.$jK=ge,e.$jK=ge=Ke([R],ge);let ke=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};e.$kK=ke,e.$kK=ke=Ke([R],ke);var re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(L,ne=re.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$lK=he,e.$lK=he=Ke([R],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=o=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,Se,Je,Ze){this.name=L,this.kind=ne,this.containerName=Ze,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),o.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$mK=fe,e.$mK=fe=o=Ke([R],fe);let Ie=n=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(n.validate)}constructor(L,ne,Se,Je,Ze){this.name=L,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=Ze,this.children=[],n.validate(this)}};e.$nK=Ie,e.$nK=Ie=n=Ke([R],Ie);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let K=class{constructor(L,ne){this.title=L,this.kind=ne}};e.$oK=K,e.$oK=K=Ke([R],K);let G=class{static{a=this}static{this.c="."}constructor(L){this.value=L}append(L){return new a(this.value?this.value+a.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+a.c)}};e.$pK=G,e.$pK=G=a=Ke([R],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$qK=Q,e.$qK=Q=Ke([R],Q);class J{constructor(L,ne,Se,Je,Ze,at){this.kind=L,this.name=ne,this.detail=Se,this.uri=Je,this.range=Ze,this.selectionRange=at}}e.$rK=J;class x{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.$sK=x;class ae{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.$tK=ae;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ue=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};e.$uK=Ue,e.$uK=Ue=Ke([R],Ue);let Qe=E=class{#e;static isMarkdownString(L){return L instanceof E?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){this.#e=new C.$Xj(L,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ne){return this.#e.appendCodeblock(ne??"",L),this}};e.$vK=Qe,e.$vK=Qe=E=Ke([R],Qe);let He=class{constructor(L,ne){this.label=L,this.documentation=ne}};e.$wK=He,e.$wK=He=Ke([R],He);let et=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};e.$xK=et,e.$xK=et=Ke([R],et);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$yK=Ye,e.$yK=Ye=Ke([R],Ye);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$zK=tt,e.$zK=tt=Ke([R],tt);let ze=class{constructor(L,ne,Se){this.position=L,this.label=ne,this.kind=Se}};e.$AK=ze,e.$AK=ze=Ke([R],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var _;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(_||(e.CompletionItemKind=_={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let pe=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&_[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$BK=pe,e.$BK=pe=Ke([R],pe);let je=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};e.$CK=je,e.$CK=je=Ke([R],je);let Ne=class{constructor(L,ne,Se){this.insertText=L,this.range=ne,this.command=Se}};e.$DK=Ne,e.$DK=Ne=Ke([R],Ne);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$EK=Xe,e.$EK=Xe=Ke([R],Xe);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var dt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(dt||(e.StatusBarAlignment=dt={}));function wt(j,L){return`${D.$Vl.toKey(j)}.${L}`}e.$FK=wt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Xt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var Kt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var pt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(j){function L(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function L(ne){switch(ne){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(L,ne){if(ne&&!m.URI.isUri(ne))throw(0,M.$5)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.$5)("range");this.range=L,this.target=ne}};e.$GK=At,e.$GK=At=Ke([R],At);let Rt=class{constructor(L,ne,Se,Je){this.red=L,this.green=ne,this.blue=Se,this.alpha=Je}};e.$HK=Rt,e.$HK=Rt=Ke([R],Rt);let zt=class{constructor(L,ne){if(ne&&!(ne instanceof Rt))throw(0,M.$5)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.$5)("range");this.range=L,this.color=ne}};e.$IK=zt,e.$IK=zt=Ke([R],zt);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$5)("label");this.label=L}};e.$JK=Wt,e.$JK=Wt=Ke([R],Wt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ot{constructor(L,ne,Se){if(this.startIndex=L,this.length=ne,this.tooltip=Se,typeof L!="number"||L<0)throw(0,M.$5)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$5)("tooltip")}}e.$KK=ot;class ft{constructor(L){this.uri=L}}e.$LK=ft;class Mt{constructor(L){this.terminalCommand=L}}e.$MK=Mt;var Tt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class It{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$5)("options")}}e.$NK=It;var ht;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ht||(e.TaskRevealKind=ht={}));var Dt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Dt||(e.TaskPanelKind=Dt={}));let kt=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,M.$5)("name");this.c=L}get id(){return this.c}};e.$OK=kt,e.$OK=kt=b=Ke([R],kt);function Ft(j){let L="";for(let ne=0;ne<j.length;ne++)L+=j[ne].replace(/,/g,",,")+",";return L}let Ve=class{constructor(L,ne,Se){if(typeof L!="string")throw(0,M.$5)("process");this.e=[],this.c=L,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$5)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)L.push(ne);return Ft(L)}};e.$PK=Ve,e.$PK=Ve=Ke([R],Ve);let Ce=class{constructor(L,ne,Se){if(this.f=[],Array.isArray(ne)){if(!L)throw(0,M.$5)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$5)("command");this.e=L,this.f=ne,this.g=Se}else{if(typeof L!="string")throw(0,M.$5)("commandLine");this.c=L,this.g=ne}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$5)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$5)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)L.push(typeof ne=="string"?ne:ne.value);return Ft(L)}};e.$QK=Ce,e.$QK=Ce=Ke([R],Ce);var Me;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var me;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(me||(e.TaskScope=me={}));class H{constructor(L){this.c=L}computeId(){return"customExecution"+(0,P.$4f)()}set callback(L){this.c=L}get callback(){return this.c}}e.$RK=H;let Te=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ne,Se,Je,Ze,at){this.j=!1,this.k=this.definition=L;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=Se,this.execution=Je,lt=Ze,this.j=!0):ne===me.Global||ne===me.Workspace?(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ze,lt=at):(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ze,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ve?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,P.$4f)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$5)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$5)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const ne=this.k.type;(S.g===ne||S.e===ne||S.f===ne||S.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$5)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$SK=Te,e.$SK=Te=S=Ke([R],Te);var Be;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(j){function L(ne){const Se=ne;return(0,k.$nf)(Se.value)?Se.tooltip&&!(0,k.$jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=L})(Ge||(e.ViewBadge=Ge={}));let We=I=class{static isTreeItem(L,ne){const Se=L;if(Se.checkboxState!==void 0){const Je=(0,k.$nf)(Se.checkboxState)?Se.checkboxState:(0,k.$lf)(Se.checkboxState)&&(0,k.$nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ze=!(0,k.$nf)(Se.checkboxState)&&(0,k.$lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==$t.Checked&&Je!==$t.Unchecked||Ze!==void 0&&!(0,k.$jf)(Ze))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(L instanceof I)return!0;if(Se.label!==void 0&&!(0,k.$jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,k.$jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,k.$jf)(Se.iconPath)&&!m.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,k.$jf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,k.$jf)(Je.light)&&!m.URI.isUri(Je.light)&&!(0,k.$jf)(Je.dark)&&!m.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,k.$jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!m.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,k.$jf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<_e.None&&Se.collapsibleState>_e.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,k.$jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(L,ne=_e.None){this.collapsibleState=ne,m.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$TK=We,e.$TK=We=I=Ke([R],We);var _e;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(_e||(e.TreeItemCollapsibleState=_e={}));var $t;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let Ct=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$UK=Ct,e.$UK=Ct=Ke([R],Ct);class bt extends Ct{}e.$VK=bt;class ut extends bt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$WK=ut;class mt{constructor(L,ne,Se,Je){this.name=L,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$XK=mt;let yt=class{#e=new Map;constructor(L){for(const[ne,Se]of L??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ne){this.#e.set(this.#t(L),[ne])}forEach(L,ne){for(const[Se,Je]of this.#e)for(const Ze of Je)L.call(ne,Ze,Se,this)}*[Symbol.iterator](){for(const[L,ne]of this.#e)for(const Se of ne)yield[L,Se]}#t(L){return L.toLowerCase()}};e.$YK=yt,e.$YK=yt=Ke([R],yt);let gi=class{constructor(L){this.insertText=L}};e.$ZK=gi,e.$ZK=gi=Ke([R],gi);let Ht=class{constructor(L,ne){this.label=ne,this.insertText=L}};e.$1K=Ht,e.$1K=Ht=Ke([R],Ht);let Zt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$2K=Zt,e.$2K=Zt=Ke([R],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let si=class{constructor(L){this.id=L}};e.$3K=si,e.$3K=si=Ke([R],si);var Di;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let St=class{get base(){return this.c}set base(L){this.c=L,this.e=m.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!m.URI.isUri(L)&&!m.URI.isUri(L.uri)))throw(0,M.$5)("base");if(typeof ne!="string")throw(0,M.$5)("pattern");typeof L=="string"?this.baseUri=m.URI.file(L):m.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$4K=St,e.$4K=St=Ke([R],St);const Zi=new WeakMap;function un(j,L){Zi.set(j,L)}e.$5K=un;let vt=class{constructor(L,ne,Se,Je){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Zi.get(this)??(0,P.$4f)()),this.c}};e.$6K=vt,e.$6K=vt=Ke([R],vt);let mi=class extends vt{constructor(L,ne,Se,Je,Ze){if(super(ne,Se,Je,Ze),L===null)throw(0,M.$5)("location");this.location=L}};e.$7K=mi,e.$7K=mi=Ke([R],mi);let $i=class extends vt{constructor(L,ne,Se,Je,Ze){super(ne,Se,Je,Ze),this.functionName=L}};e.$8K=$i,e.$8K=$i=Ke([R],$i);let oi=class extends vt{constructor(L,ne,Se,Je,Ze,at,lt){if(super(Je,Ze,at,lt),!ne)throw(0,M.$5)("dataId");this.label=L,this.dataId=ne,this.canPersist=Se}};e.$9K=oi,e.$9K=oi=Ke([R],oi);let ki=class{constructor(L,ne,Se){this.command=L,this.args=ne||[],this.options=Se}};e.$0K=ki,e.$0K=ki=Ke([R],ki);let Si=class{constructor(L,ne){this.port=L,this.host=ne}};e.$$K=Si,e.$$K=Si=Ke([R],Si);let Lt=class{constructor(L){this.path=L}};e.$_K=Lt,e.$_K=Lt=Ke([R],Lt);let pi=class{constructor(L){this.implementation=L}};e.$aL=pi,e.$aL=pi=Ke([R],pi);let Ii=class{constructor(L,ne,Se){this.session=L,this.threadId=ne,this.frameId=Se}};e.$bL=Ii,e.$bL=Ii=Ke([R],Ii);let ai=class{constructor(L,ne){this.session=L,this.threadId=ne}};e.$cL=ai,e.$cL=ai=Ke([R],ai);let ci=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$dL=ci,e.$dL=ci=Ke([R],ci);var ct;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ct||(e.InlineCompletionTriggerKind=ct={}));let Ci=class{constructor(L,ne){this.range=L,this.text=ne}};e.$eL=Ci,e.$eL=Ci=Ke([R],Ci);let Yt=class{constructor(L,ne,Se=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$fL=Yt,e.$fL=Yt=Ke([R],Yt);let ii=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$gL=ii,e.$gL=ii=Ke([R],ii);let vi=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};e.$hL=vi,e.$hL=vi=Ke([R],vi);var Yi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Yi||(e.FileChangeType=Yi={}));let Pi=u=class extends Error{static FileExists(L){return new u(L,c.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,c.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,c.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,c.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,c.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,ne=c.FileSystemProviderErrorCode.Unknown,Se){super(m.URI.isUri(L)?L.toString(!0):L),this.code=Se?.name??"Unknown",(0,c.$hk)(this,ne),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$iL=Pi,e.$iL=Pi=u=Ke([R],Pi);let Ai=class{constructor(L,ne,Se){this.start=L,this.end=ne,this.kind=Se}};e.$jL=Ai,e.$jL=Ai=Ke([R],Ai);var Ri;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var _i;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var Mi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Mi||(e.CommentMode=Mi={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var xi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class Ti{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.$kL=Ti;function Fi(j){return typeof j>"u"||(0,k.$kf)(j)}class Li{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let ne=0,Se=L.tokenTypes.length;ne<Se;ne++)this.j.set(L.tokenTypes[ne],ne);for(let ne=0,Se=L.tokenModifiers.length;ne<Se;ne++)this.k.set(L.tokenModifiers[ne],ne)}}push(L,ne,Se,Je,Ze){if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(L,ne,Se,Je,Ze);if(O.isRange(L)&&typeof ne=="string"&&Fi(Se))return this.m(L,ne,Se);throw(0,M.$5)()}m(L,ne,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=L.start.line,Ze=L.start.character,at=L.end.character-L.start.character,lt=this.j.get(ne);let Ut=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Qt);Ut|=1<<_t>>>0}this.n(Je,Ze,at,lt,Ut)}n(L,ne,Se,Je,Ze){if(this.f&&(L<this.c||L===this.c&&ne<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,_t=0;for(let ti=0;ti<Ut;ti++){let ri=this.g[5*ti],Qi=this.g[5*ti+1];ri===0?(ri=Qt,Qi+=_t):ri+=Qt,this.g[5*ti]=ri,this.g[5*ti+1]=Qi,Qt=ri,_t=Qi}}let at=L,lt=ne;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Ze,this.c=L,this.e=ne}static o(L){const ne=[],Se=L.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,Ut)=>{const Qt=L[5*lt],_t=L[5*Ut];if(Qt===_t){const ti=L[5*lt+1],ri=L[5*Ut+1];return ti-ri}return Qt-_t});const Je=new Uint32Array(L.length);let Ze=0,at=0;for(let lt=0;lt<Se;lt++){const Ut=5*ne[lt],Qt=L[Ut+0],_t=L[Ut+1],ti=L[Ut+2],ri=L[Ut+3],Qi=L[Ut+4],En=Qt-Ze,Mn=En===0?_t-at:_t,Xi=5*lt;Je[Xi+0]=En,Je[Xi+1]=Mn,Je[Xi+2]=ti,Je[Xi+3]=ri,Je[Xi+4]=Qi,Ze=Qt,at=_t}return Je}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(Li.o(this.g),L)}}e.$lL=Li;class Oi{constructor(L,ne){this.resultId=ne,this.data=L}}e.$mL=Oi;class hi{constructor(L,ne,Se){this.start=L,this.deleteCount=ne,this.data=Se}}e.$nL=hi;class ln{constructor(L,ne){this.resultId=ne,this.edits=L}}e.$oL=ln;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Zt("arrow-left")}}constructor(){}};e.$pL=Ni,e.$pL=Ni=Ke([R],Ni);var di;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(L){if(typeof L.badge=="string"){let ne=(0,h.$We)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,h.$We)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Zt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,Se){this.badge=L,this.tooltip=ne,this.color=Se}}e.$qL=hn;let ni=class{constructor(L){this.kind=L}};e.$rL=ni,e.$rL=ni=Ke([R],ni);var zi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class xt{static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ne){if(L<0)throw(0,M.$5)("start must be positive");if(ne<0)throw(0,M.$5)("end must be positive");L<=ne?(this.c=L,this.e=ne):(this.c=ne,this.e=L)}with(L){let ne=this.c,Se=this.e;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Se=L.end),ne===this.c&&Se===this.e?this:new xt(ne,Se)}}e.$sL=xt;class bi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,Se,Je,Ze,at,lt){this.kind=L,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=Ze??[],this.metadata=at,this.executionSummary=lt,bi.validate(this)}}e.$tL=bi;class rn{constructor(L){this.cells=L}}e.$uL=rn;class Gt{static isNotebookCellOutputItem(L){return L instanceof Gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Gt(L,ne)}static#e=new TextEncoder;static text(L,ne=A.$Hr.text){const Se=Gt.#e.encode(String(L));return new Gt(Se,ne)}static json(L,ne="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return Gt.text(Se,ne)}constructor(L,ne){this.data=L,this.mime=ne;const Se=(0,A.$Lr)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$vL=Gt;class wi{static isNotebookCellOutput(L){return L instanceof wi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Se=new Set,Je=new Set;for(let Ze=0;Ze<L.length;Ze++){const at=L[Ze],lt=(0,A.$Lr)(at.mime);if(!Se.has(lt)||(0,p.$eI)(lt)){Se.add(lt);continue}Je.add(Ze),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Je.size===0?L:L.filter((Ze,at)=>!Je.has(at))}constructor(L,ne,Se){this.items=wi.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$4f)(),this.metadata=ne??Se)}}e.$wL=wi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Le;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Le||(e.NotebookEditorRevealType=Le={}));class ei{constructor(L,ne){this.text=L,this.alignment=ne}}e.$xL=ei;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var gt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(L,ne=[]){this.uri=L,this.provides=(0,w.$1b)(ne)}}e.$yL=dn;class fn{constructor(L){this.label=L}}e.$zL=fn;let Ei=class{constructor(L,ne){this.label=L,this.timestamp=ne}};e.$AL=Ei,e.$AL=Ei=Ke([R],Ei);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.$BL=gn;class mn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$CL=mn;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(L=void 0,ne=void 0,Se=void 0,Je=!1){this.include=L,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$DL=Wi,e.$DL=Wi=Ke([R],Wi);let Vi=f=class{static diff(L,ne,Se){const Je=new f(L);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(L){this.message=L}};e.$EL=Vi,e.$EL=Vi=f=Ke([R],Vi);let qi=class{constructor(L){this.id=L}};e.$FL=qi,e.$FL=qi=Ke([R],qi);let li=class{constructor(L,ne){this.covered=L,this.total=ne}};e.$GL=li,e.$GL=li=Ke([R],li);let Ki=l=class{static fromDetails(L,ne){const Se=new li(0,0),Je=new li(0,0),Ze=new li(0,0);for(const lt of ne)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const at=new l(L,Se,Je.total>0?Je:void 0,Ze.total>0?Ze:void 0);return at.detailedCoverage=ne,at}constructor(L,ne,Se,Je){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=Je}};e.$HL=Ki,e.$HL=Ki=l=Ke([R],Ki);let Ji=class{constructor(L,ne,Se=[]){this.executionCount=L,this.location=ne,this.branches=Se}};e.$IL=Ji,e.$IL=Ji=Ke([R],Ji);let Hi=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$JL=Hi,e.$JL=Hi=Ke([R],Hi);let Gi=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$KL=Gi,e.$KL=Gi=Ke([R],Gi);var te;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var de;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(de||(e.WorkspaceTrustState=de={}));var Fe;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Fe||(e.PortAutoForwardAction=Fe={}));class rt{constructor(L,ne,Se,Je,Ze,at){this.kind=L,this.name=ne,this.detail=Se,this.uri=Je,this.range=Ze,this.selectionRange=at}}e.$LL=rt;class Et{constructor(L){this.uri=L}}e.$ML=Et;class Ot{constructor(L,ne){this.original=L,this.modified=ne}}e.$NL=Ot;class Dn{constructor(L,ne,Se,Je){this.base=L,this.input1=ne,this.input2=Se,this.result=Je}}e.$OL=Dn;class kn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.$PL=kn;class Sn{constructor(L){this.viewType=L}}e.$QL=Sn;class In{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.$RL=In;class Cn{constructor(L,ne,Se){this.original=L,this.modified=ne,this.notebookType=Se}}e.$SL=Cn;class Pn{constructor(){}}e.$TL=Pn;class An{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.$UL=An;var $n;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var bn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(L,ne){this.role=L,this.content=ne}}e.$VL=Rn;var yn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Ae[101],Re([1,0,51,13,15,278,137,7,18]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=void 0;const m=new Map;function P(p,g){g?m.set(p,g):m.delete(p)}e.$9L=P;function D(p){return m.get(p)}class c extends F.$Mu{constructor(g,t,i,s,d,y,$,r){super(t,i,s,d),this.c=g,this.m=y,this.q=$,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,k.$sb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===M.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,w.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,w.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,s=t.start.line,d=t.end.line,y=[];y.push(this.f[s].substring(t.start.character));for(let $=s+1;$<d;$++)y.push(this.f[$]);return y.push(this.f[d].substring(0,t.end.character)),y.join(i)}t(g){let t;if(g instanceof h.$9J?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new h.$9J(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof h.$0J))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new h.$0J(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof h.$9J))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,s=!1;if(t<0)t=0,i=0,s=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,s=!0;else{const d=this.f[t].length;i<0?(i=0,s=!0):i>d&&(i=d,s=!0)}return s?new h.$9J(t,i):g}y(g,t){const i=this.x(g);if(!t)t=D(this.m);else if((0,C.$ze)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const s=(0,A.$Zr)(i.character+1,(0,A.$Xr)(t),this.f[i.line],0);if(s)return new h.$0J(i.line,s.startColumn-1,i.line,s.endColumn-1)}}e.$0L=c;class v{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new h.$0J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new h.$0J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$$L=v}),define(Ae[197],Re([1,0,7,17,5]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;let F=class{constructor(h){this.a=new w.$rL(w.ColorThemeKind.Dark),this.b=new C.$fd}get activeColorTheme(){return this.a}$onColorThemeChange(h){let k;switch(h){case"light":k=w.ColorThemeKind.Light;break;case"hcDark":k=w.ColorThemeKind.HighContrast;break;case"hcLight":k=w.ColorThemeKind.HighContrastLight;break;default:k=w.ColorThemeKind.Dark}this.a=new w.$rL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Wcc=F,e.$Wcc=F=Ke([qe(0,M.$7L)],F)}),define(Ae[198],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$iI=(0,w.$Bh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,h,k=A.parent){if(A._isRoot)return new C([h]);const m=[A.id];for(let P=k;P&&P.id!==h;P=P.parent)m.push(P.id);return m.push(h),new C(m.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const h=A.indexOf("\0");return h===-1?A:A.slice(0,h)}static fromString(A){return new C(A.split("\0"))}static join(A,h){return new C([...A.path,h])}static joinToString(A,h){return A.toString()+"\0"+h}static parentId(A){const h=A.lastIndexOf("\0");return h===-1?void 0:A.slice(0,h)}static localId(A){const h=A.lastIndexOf("\0");return h===-1?A:A.slice(h+1)}static isChild(A,h){return h.startsWith(A)&&h[A.length]==="\0"}static compare(A,h){return A===h?0:C.isChild(A,h)?2:C.isChild(h,A)?3:1}constructor(A,h=A.length){if(this.path=A,this.d=h,A.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let h=0;h<A.d&&h<this.d;h++)if(A.path[h]!==this.path[h])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$XI=C}),define(Ae[57],Re([1,0,2,44,45]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$4I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3I=e.$2I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZI=e.$YI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var h;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$YI=[2,4,8,16,32,64];const k=I=>"runId"in I;e.$ZI=k;var m;(function(I){I.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),I.deserialize=u=>({range:M.$ks.lift(u.range),uri:w.URI.revive(u.uri)})})(m||(e.IRichLocation=m={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(I){I.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&m.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&m.deserialize(u.location)})})(D||(e.ITestErrorMessage=D={}));const c=(I,u)=>`${u?"s":"e"}${I}`;e.$1I=c;var v;(function(I){I.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&m.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&m.deserialize(u.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(I){I.serialize=u=>u.type===0?D.serialize(u):v.serialize(u),I.deserialize=u=>u.type===0?D.deserialize(u):v.deserialize(u)})(p||(e.ITestMessage=p={}));var g;(function(I){I.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),I.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.serialize)}),I.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(p.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(I,u)=>I+t+u;e.$2I=i;const s=I=>{const u=I.indexOf(t);return{ctrlId:I.slice(0,u),tagId:I.slice(u+1)}};e.$3I=s;var d;(function(I){I.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),I.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?M.$ks.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(d||(e.ITestItem=d={}));var y;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var $;(function(I){I.serialize=u=>({expand:u.expand,item:d.serialize(u.item)}),I.deserialize=u=>({controllerId:C.$XI.root(u.item.extId),expand:u.expand,item:d.deserialize(u.item)})})($||(e.InternalTestItem=$={}));var r;(function(I){I.serialize=u=>{let f;return u.item&&(f={},u.item.label!==void 0&&(f.label=u.item.label),u.item.tags!==void 0&&(f.tags=u.item.tags),u.item.busy!==void 0&&(f.busy=u.item.busy),u.item.uri!==void 0&&(f.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(f.range=u.item.range?.toJSON()),u.item.description!==void 0&&(f.description=u.item.description),u.item.error!==void 0&&(f.error=u.item.error),u.item.sortText!==void 0&&(f.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:f}},I.deserialize=u=>{let f;return u.item&&(f={},u.item.label!==void 0&&(f.label=u.item.label),u.item.tags!==void 0&&(f.tags=u.item.tags),u.item.busy!==void 0&&(f.busy=u.item.busy),u.item.range!==void 0&&(f.range=u.item.range?M.$ks.lift(u.item.range):null),u.item.description!==void 0&&(f.description=u.item.description),u.item.error!==void 0&&(f.error=u.item.error),u.item.sortText!==void 0&&(f.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:f}}})(r||(e.ITestItemUpdate=r={}));const o=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.$4I=o;var n;(function(I){I.serializeWithoutMessages=u=>({...$.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serializeWithoutMessages)}),I.serialize=u=>({...$.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serialize)}),I.deserialize=u=>({...$.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var a;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(a||(e.DetailType=a={}));var E;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(E||(e.TestDiffOpType=E={}));var b;(function(I){I.deserialize=u=>u.op===0?{op:u.op,item:$.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,I.serialize=u=>u.op===0?{op:u.op,item:$.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})(b||(e.TestsDiffOp=b={}));class S{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const f=this.p();for(const l of u)switch(l.op){case 0:this.k($.deserialize(l.item),f);break;case 1:this.l(r.deserialize(l.item),f);break;case 3:this.m(l.itemId,f);break;case 5:this.o(l.itemId);break;case 4:this.updatePendingRoots(l.amount);break;case 6:this.d.set(l.tag.id,l.tag);break;case 7:this.d.delete(l.id);break}f.complete?.()}k(u,f){const l=C.$XI.parentId(u.item.extId)?.toString();let R;if(!l)R=this.q(u),this.g.add(R),this.f.set(u.item.extId,R);else if(this.f.has(l)){const B=this.f.get(l);B.children.add(u.item.extId),R=this.q(u,B),this.f.set(u.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return f.add?.(R),u.expand===2&&this.h++,R}l(u,f){const l=this.f.get(u.extId);if(l)return u.expand!==void 0&&(l.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$4I)(l,u),f.update?.(l),l}m(u,f){const l=this.f.get(u);if(!l)return;const R=C.$XI.parentId(l.item.extId)?.toString();R?this.f.get(R).children.delete(l.item.extId):this.g.delete(l);const B=[[u]];for(;B.length;)for(const V of B.pop()){const U=this.f.get(V);U&&(B.push(U.children),this.f.delete(V),f.remove?.(U,U!==l),U.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$5I=S}),define(Ae[76],Re([1,0,12,5,6,51,57,45]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.TestItemEventOp=void 0;var k;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const m=(s,d)=>s===d,D=Object.entries({range:(s,d)=>s===d?!0:!s||!d?!1:s.equalsRange(d),busy:m,label:m,description:m,error:m,sortText:m,tags:(s,d)=>!(s.length!==d.length||s.some(y=>!d.includes(y)))}),c=(s,d)=>{let y;for(const[$,r]of D)r(s[$],d[$])||(y?y[$]=d[$]:y={[$]:d[$]});return y};class v extends C.$kc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new w.$Sg(()=>this.flushDiff(),200)),this.g=this.B(new M.$fd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(d){this.h=d;for(const y of this.tree.values())this.I(y)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case 2:{for(const y of this.m)if(y.op===2&&y.uri===d.uri){y.docv=d.docv;return}break}case 1:{const y=this.m[this.m.length-1];if(y){if(y.op===1&&y.item.extId===d.item.extId){(0,A.$4I)(y.item,d.item);return}if(y.op===0&&y.item.item.extId===d.item.extId){(0,A.$4I)(y.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,y){const $=this.tree.get(d);if($){if(($.expandLevels===void 0||y>$.expandLevels)&&($.expandLevels=y),$.expand===1){const r=this.L($);return r.isOpen()?this.J($,y-1):r.wait().then(()=>this.J($,y-1))}else if($.expand===3)return $.resolveBarrier?.isOpen()===!1?$.resolveBarrier.wait().then(()=>this.J($,y-1)):this.J($,y-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(d,y){switch(y.op){case 3:this.N(h.$XI.joinToString(d.fullId,y.id));break;case 0:this.y(y.item,d);break;case 5:for(const $ of y.ops)this.u(d,$);break;case 1:this.z(y.new,y.old,d.fullId.toString());break;case 2:this.I(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:y.update}});break;case 6:this.w(d.actual.uri);break;default:(0,F.$vc)(y)}}w(d){d&&this.pushDiff({op:2,uri:d,docv:this.s.getDocumentVersion(d)})}y(d,y){const $=h.$XI.fromExtHostTestItem(d,this.root.id,y?.actual),r=this.s.getApiFor(d);r.parent&&r.parent!==y?.actual&&this.s.getChildren(r.parent).delete(d.id);let o=this.tree.get($.toString());if(!o){o={fullId:$,actual:d,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},d.tags.forEach(this.C,this),this.tree.set(o.fullId.toString(),o),this.F(d,y),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(d)}}),this.H(d,o,y);return}if(o.actual===d){this.G(d,o,y);return}if(o.actual.uri?.toString()!==d.uri?.toString())return this.N($.toString()),this.y(d,y);const n=this.s.getChildren(o.actual),a=o.actual,E=c(this.s.toITestItem(a),this.s.toITestItem(d));this.s.getApiFor(a).listener=void 0,o.actual=d,o.expand=0,E&&(E.hasOwnProperty("tags")&&(this.z(d.tags,a.tags,$.toString()),delete E.tags),this.u(o,{op:4,update:E})),this.H(d,o,y);for(const[b,S]of n)this.s.getChildren(d).get(S.id)||this.N(h.$XI.joinToString($,S.id));this.w(o.actual.uri)}z(d,y,$){const r=new Set(y.map(o=>o.id));for(const o of d)r.delete(o.id)||this.C(o);this.pushDiff({op:1,item:{extId:$,item:{tags:d.map(o=>(0,A.$2I)(this.s.controllerId,o.id))}}}),r.forEach(this.D,this)}C(d){const y=this.j.get(d.id);y?y.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$2I)(this.s.controllerId,d.id)}}))}D(d){const y=this.j.get(d);y&&!--y.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,A.$2I)(this.s.controllerId,d)}))}F(d,y){this.s.getApiFor(d).parent=y&&y.actual!==this.root?y.actual:void 0}G(d,y,$){this.F(d,$);const r=this.s.getApiFor(d);r.parent=$?.actual,r.listener=o=>this.u(y,o),this.I(y)}H(d,y,$){this.G(d,y,$);for(const[r,o]of this.s.getChildren(d))this.y(o,y)}I(d){let y;this.h?d.resolveBarrier?y=d.resolveBarrier.isOpen()?3:2:y=d.actual.canResolveChildren?1:0:y=0,y!==d.expand&&(d.expand=y,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:y}}),y===1&&d.expandLevels!==void 0&&this.L(d))}J(d,y){if(y<0)return;const $=[];for(const[r,o]of this.s.getChildren(d.actual)){const n=this.expand(h.$XI.joinToString(d.fullId,o.id),y);(0,w.$tg)(n)&&$.push(n)}if($.length)return Promise.all($).then(()=>{})}L(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const o=new w.$Fg;return o.open(),o}d.expand=2,this.M(d);const y=d.resolveBarrier=new w.$Fg,$=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let r;try{r=this.h(d.actual===this.root?void 0:d.actual)}catch(o){$(o)}return(0,w.$tg)(r)?r.catch($).then(()=>{y.open(),this.I(d)}):(y.open(),this.I(d)),d.resolveBarrier}M(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}N(d){const y=this.tree.get(d);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const $=[y];for(;$.length;){const r=$.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const o of r.actual.tags)this.D(o.id);this.tree.delete(r.fullId.toString());for(const[o,n]of this.s.getChildren(r.actual))$.push(this.tree.get(h.$XI.joinToString(r.fullId,n.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$WL=v;class p extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$XL=p;class g extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$YL=g;class t extends Error{constructor(d,y,$){super(`TestItem with ID "${d}" is from controller "${y}" and cannot be added as a child of an item from controller "${$}".`)}}e.$ZL=t;const i=(s,d,y)=>{let $=new Map;return{get size(){return $.size},forEach(r,o){for(const n of $.values())r.call(o,n,this)},[Symbol.iterator](){return $.entries()},replace(r){const o=new Map,n=new Set($.keys()),a={op:5,ops:[]};for(const E of r){if(!(E instanceof y))throw new g(E.id);const b=d(E).controllerId;if(b!==s.controllerId)throw new t(E.id,b,s.controllerId);if(o.has(E.id))throw new p(E.id);o.set(E.id,E),n.delete(E.id),a.ops.push({op:0,item:E})}for(const E of n.keys())a.ops.push({op:3,id:E});s.listener?.(a),$=o},add(r){if(!(r instanceof y))throw new g(r.id);$.set(r.id,r),s.listener?.({op:0,item:r})},delete(r){$.delete(r)&&s.listener?.({op:3,id:r})},get(r){return $.get(r)},toJSON(){return Array.from($.values())}}};e.$1L=i}),define(Ae[102],Re([1,0,76]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0;const M=new WeakMap,C=(A,h)=>{const k={controllerId:h};return M.set(A,k),k};e.$2L=C;const F=A=>{const h=M.get(A);if(!h)throw new w.$YL(A?.id||"<unknown>");return h};e.$3L=F}),define(Ae[77],Re([1,0,13,2]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpb=e.$cpb=e.$bpb=e.$apb=e.$_ob=void 0,e.$_ob="vscode-cdn.net",e.$apb=`vscode-resource.${e.$_ob}`,e.$bpb=`'self' https://*.${e.$_ob}`;function C(h,k){return h.scheme===w.Schemas.http||h.scheme===w.Schemas.https?h:(k&&k.authority&&k.isRemote&&h.scheme===w.Schemas.file&&(h=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:k.authority,path:h.path})),M.URI.from({scheme:w.Schemas.https,authority:`${h.scheme}+${F(h.authority)}.${e.$apb}`,path:h.path,fragment:h.fragment,query:h.query}))}e.$cpb=C;function F(h){return h.replace(/./g,k=>{const m=k.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?k:"-"+m.toString(16).padStart(4,"0")})}function A(h){return h.replace(/-([0-9a-f]{4})/g,(k,m)=>String.fromCharCode(parseInt(m,16)))}e.$dpb=A}),define(Ae[199],Re([1,0,5,6,77]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class F{constructor(h,k,m){this.d=h,this.e=k,this.f=m,this.a=0,this.b=new M.$jc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(h=>h.inset.dispose()),this.b.dispose()}createWebviewEditorInset(h,k,m,P,D){let c;for(const d of this.e.getVisibleTextEditors(!0))if(d.value===h){c=d;break}if(!c)throw new Error("not a visible editor");const v=this,p=this.a++,g=new w.$fd,t=new w.$fd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(d){return(0,C.$cpb)(d,v.f)}get cspSource(){return C.$bpb}set options(d){this.b=d,v.d.$setOptions(p,d)}get options(){return this.b}set html(d){this.a=d,v.d.$setHtml(p,d)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(d){return v.d.$postMessage(p,d)}},s=new class{constructor(){this.editor=h,this.line=k,this.height=m,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(p,c.id,c.value.document.uri,k+1,m,P||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:h,inset:s,onDidReceiveMessage:g}),s}$onDidDispose(h){const k=this.c.get(h);k&&k.inset.dispose()}$onDidReceiveMessage(h,k){this.c.get(h)?.onDidReceiveMessage.fire(k)}}e.$ucc=F}),define(Ae[200],Re([1,0,4]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.VariableKind=e.$SM=void 0,e.$SM=(0,w.$Bh)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,h){super(h),this.variable=A}}e.$TM=C}),define(Ae[201],Re([1,0,19,74,16,24,22,90,166,200,15]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,g,t){this.h=new Map,this.a=v,this.b=p,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(A.$i){const p=Object.create(null);return Object.keys(v).forEach(g=>{p[g.toLowerCase()]=v[g]}),p}return v}resolveWithEnvironment(v,p,g){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,g)}async resolveAsync(v,p){const g={env:await this.c,userHome:await this.g};return this.l(g,v?v.uri:void 0,p)}async j(v,p,g,t){const i=F.$Vm(p);A.$i&&i.windows?Object.keys(i.windows).forEach(d=>i[d]=i.windows[d]):A.$j&&i.osx?Object.keys(i.osx).forEach(d=>i[d]=i.osx[d]):A.$k&&i.linux&&Object.keys(i.linux).forEach(d=>i[d]=i.linux[d]),delete i.windows,delete i.osx,delete i.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,i,g,t)}async resolveAnyAsync(v,p,g){return this.j(v,p,g)}async resolveAnyMap(v,p,g){const t=new Map;return{newConfig:await this.j(v,p,g,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,g,t,i){if(C.$jf(g))return this.m(v,p,g,t,i);if(Array.isArray(g))return Promise.all(g.map(s=>this.l(v,p,s,t,i)));if(C.$lf(g)){const s=Object.create(null),d=await Promise.all(Object.keys(g).map(async y=>[await this.m(v,p,y,t,i),await this.l(v,p,g[y],t,i)]));for(const[y,$]of d)s[y]=$;return s}return g}m(v,p,g,t,i){return(0,P.$Ee)(g,D.VARIABLE_REGEXP,async(s,d)=>{if(d.includes(D.VARIABLE_LHS))return s;let y=await this.o(v,s,d,p,t);return i?.set(d,y),y!==s&&C.$jf(y)&&y.match(D.VARIABLE_REGEXP)&&(y=await this.m(v,p,y,t,i)),y})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,g,t,i){let s;const d=g.split(":");d.length>1&&(g=d[0],s=d[1]);const y=o=>{const n=this.a.getFilePath();if(n)return(0,h.$iv)(n);throw new m.$TM(o,(0,k.localize)(0,null,p))},$=o=>{const n=y(o);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,h.$iv)(a)}throw new m.$TM(o,(0,k.localize)(1,null,p,w.$ae(n)))},r=o=>{if(s){const n=this.a.getFolderUri(s);if(n)return n;throw new m.$TM(o,(0,k.localize)(2,null,p,s))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new m.$TM(o,(0,k.localize)(3,null,p)):new m.$TM(o,(0,k.localize)(4,null,p))};switch(g){case"env":if(s){if(v.env){const o=v.env[A.$i?s.toLowerCase():s];if(C.$jf(o))return o}return""}throw new m.$TM(m.VariableKind.Env,(0,k.localize)(5,null,p));case"config":if(s){const o=this.a.getConfigurationValue(t,s);if(C.$sf(o))throw new m.$TM(m.VariableKind.Config,(0,k.localize)(6,null,p,s));if(C.$lf(o))throw new m.$TM(m.VariableKind.Config,(0,k.localize)(7,null,p,s));return o}throw new m.$TM(m.VariableKind.Config,(0,k.localize)(8,null,p));case"command":return this.p(m.VariableKind.Command,p,s,i,"command");case"input":return this.p(m.VariableKind.Input,p,s,i,"input");case"extensionInstallFolder":if(s){const o=await this.a.getExtension(s);if(!o)throw new m.$TM(m.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,p,s));return this.n(o.extensionLocation)}throw new m.$TM(m.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,p));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,h.$iv)(this.n(r(m.VariableKind.WorkspaceFolder)));case"cwd":return t||s?(0,h.$iv)(this.n(r(m.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.$iv)(w.$ae(this.n(r(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new m.$TM(m.VariableKind.UserHome,(0,k.localize)(11,null,p))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new m.$TM(m.VariableKind.LineNumber,(0,k.localize)(12,null,p))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new m.$TM(m.VariableKind.SelectedText,(0,k.localize)(13,null,p))}case"file":return y(m.VariableKind.File);case"fileWorkspaceFolder":return $(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||s?w.$$d(this.n(r(m.VariableKind.RelativeFile)),y(m.VariableKind.RelativeFile)):y(m.VariableKind.RelativeFile);case"relativeFileDirname":{const o=w.$_d(y(m.VariableKind.RelativeFileDirname));if(t||s){const n=w.$$d(this.n(r(m.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return w.$_d(y(m.VariableKind.FileDirname));case"fileExtname":return w.$be(y(m.VariableKind.FileExtname));case"fileBasename":return w.$ae(y(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=w.$ae(y(m.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-w.$be(o).length)}case"fileDirnameBasename":return w.$ae(w.$_d(y(m.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||p}case"execInstallFolder":{const o=this.a.getAppRoot();return o||p}case"pathSeparator":return w.sep;default:try{const o=s?`${g}:${s}`:g;return this.p(m.VariableKind.Unknown,p,o,i,void 0)}catch{return p}}}}p(v,p,g,t,i){if(g&&t){const s=i===void 0?t[g]:t[i+":"+g];if(typeof s=="string")return s;throw new m.$TM(v,(0,k.localize)(14,null,p))}return p}}e.$8M=D}),define(Ae[103],Re([1,0,4,99]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0B=e.$9B=e.OpenEditorContext=e.GroupsOrder=e.$8B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$7B=void 0,e.$7B=(0,w.$Bh)("editorGroupsService");var C;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var h;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var k;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function m(p){const g=p;return(0,M.$WD)(g?.editor)&&(0,M.$WD)(g?.replacement)}e.$8B=m;var P;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function c(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$9B=c;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$0B=v}),define(Ae[202],Re([1,0,4,103]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=void 0,e.$$B=(0,w.$Bh)("editorService"),e.$_B=-1,e.$aC=-2;function C(F){const A=F;return typeof F=="number"||(0,M.$9B)(A)}e.$bC=C}),define(Ae[8],Re([1,0,18,25,123,203,49,28,117,69,68,24,16,2,44,78,94,102,99,75,45,57,202,7]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$6L=e.$5L=e.MarkdownString=e.$4L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Me(H){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=H,_e=new o.$9J(Te-1,Be-1),$t=new o.$9J(Ge-1,We-1);return new o.$$J(_e,$t)}Ce.to=Me;function me(H){const{anchor:Te,active:Be}=H;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=me})(n||(e.Selection=n={}));var a;(function(Ce){function Me(H){if(!H)return;const{start:Te,end:Be}=H;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Me;function me(H){if(!H)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:Ge,endColumn:We}=H;return new o.$0J(Te-1,Be-1,Ge-1,We-1)}Ce.to=me})(a||(e.Range=a={}));var E;(function(Ce){function Me(me){switch(me){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ce.to=Me})(E||(e.TokenType=E={}));var b;(function(Ce){function Me(H){return new o.$9J(H.lineNumber-1,H.column-1)}Ce.to=Me;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(b||(e.Position=b={}));var S;(function(Ce){function Me(Te,Be,Ge){return(0,w.$Fb)((0,w.$1b)(Te).map(We=>me(We,Be,Ge)))}Ce.from=Me;function me(Te,Be,Ge){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ge?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:H(Te.scheme,Be),pattern:st.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})(S||(e.DocumentSelector=S={}));var I;(function(Ce){function Me(H){switch(H){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function me(H){switch(H){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(I||(e.DiagnosticTag=I={}));var u;(function(Ce){function Me(H){let Te;return H.code&&((0,c.$jf)(H.code)||(0,c.$nf)(H.code)?Te=String(H.code):Te={value:String(H.code.value),target:H.code.target}),{...a.from(H.range),message:H.message,source:H.source,code:Te,severity:l.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(f.from),tags:Array.isArray(H.tags)?(0,w.$Fb)(H.tags.map(I.from)):void 0}}Ce.from=Me;function me(H){const Te=new o.$jK(a.to(H),H.message,l.to(H.severity));return Te.source=H.source,Te.code=(0,c.$jf)(H.code)?H.code:H.code?.value,Te.relatedInformation=H.relatedInformation&&H.relatedInformation.map(f.to),Te.tags=H.tags&&(0,w.$Fb)(H.tags.map(I.to)),Te}Ce.to=me})(u||(e.Diagnostic=u={}));var f;(function(Ce){function Me(H){return{...a.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Me;function me(H){return new o.$iK(new o.$hK(H.resource,a.to(H)),H.message)}Ce.to=me})(f||(e.DiagnosticRelatedInformation=f={}));var l;(function(Ce){function Me(H){switch(H){case o.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function me(H){switch(H){case t.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ce.to=me})(l||(e.DiagnosticSeverity=l={}));var R;(function(Ce){function Me(H){return typeof H=="number"&&H>=o.ViewColumn.One?H-1:H===o.ViewColumn.Beside?r.$aC:r.$_B}Ce.from=Me;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$4L=V;var U;(function(Ce){function Me(We){return We.map(Ce.from)}Ce.fromMany=Me;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let _e;if(me(We)){const{language:ut,value:mt}=We;_e={value:"```"+ut+`
`+mt+"\n```\n"}}else o.$vK.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const $t=Object.create(null);_e.uris=$t;const Ct=ut=>{try{let mt=v.URI.parse(ut,!0);mt=mt.with({query:Te(mt.query,$t)}),$t[ut]=mt}catch{}return""},bt=new k.marked.Renderer;return bt.link=Ct,bt.image=ut=>typeof ut=="string"?Ct(A.$5j(ut).href):"",(0,k.marked)(_e.value,{renderer:bt}),_e}Ce.from=H;function Te(We,_e){if(!We)return We;let $t;try{$t=(0,m.$0g)(We)}catch{}if(!$t)return We;let Ct=!1;return $t=(0,D.$Xm)($t,bt=>{if(v.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[ut]=bt,Ct=!0,ut}else return}),Ct?JSON.stringify($t):We}function Be(We){const _e=new o.$vK(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?v.URI.from(We.baseUri):void 0,_e}Ce.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function W(Ce){return V(Ce)?Ce.map(Me=>({range:a.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?U.fromMany(Me.hoverMessage):Me.hoverMessage?U.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:a.from(Me)}))}e.$5L=W;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?v.URI.file(Ce):Ce}e.$6L=O;var N;(function(Ce){function Me(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Me})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(Ce){function Me(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Me})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Z;(function(Ce){function Me(me){if(typeof me>"u")return me;switch(me){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(Z||(e.DecorationRangeBehavior=Z={}));var ye;(function(Ce){function Me(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Z.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ee.from(me.light):void 0,dark:me.dark?ee.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Me})(ye||(e.DecorationRenderOptions=ye={}));var De;(function(Ce){function Me(H){return{text:H.newText,eol:H.newEol&&Ye.from(H.newEol),range:a.from(H.range)}}Ce.from=Me;function me(H){const Te=new o.$cK(a.to(H.range),H.text);return Te.newEol=typeof H.eol>"u"?void 0:Ye.to(H.eol),Te}Ce.to=me})(De||(e.TextEdit=De={}));var Pe;(function(Ce){function Me(H,Te){const Be={edits:[]};if(H instanceof o.$fK){const Ge=new h.$Ai;for(const We of H._allEntries())We._type===1&&v.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,M.$Zd)(M.$Fd.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:a.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(dt.from)}})}return Be}Ce.from=Me;function me(H){const Te=new o.$fK,Be=new h.$zi;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,_e=v.URI.revive(We.resource),$t=a.to(We.textEdit.range),Ct=We.textEdit.text,bt=We.textEdit.insertAsSnippet;let ut;bt?ut=o.$eK.replace($t,new o.$gK(Ct)):ut=o.$cK.replace($t,Ct);const mt=Be.get(_e);mt?mt.push(ut):Be.set(_e,[ut])}else Te.renameFile(v.URI.revive(Ge.oldResource),v.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Te.set(Ge,We);return Te}Ce.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var Y;(function(Ce){const Me=Object.create(null);Me[o.SymbolKind.File]=0,Me[o.SymbolKind.Module]=1,Me[o.SymbolKind.Namespace]=2,Me[o.SymbolKind.Package]=3,Me[o.SymbolKind.Class]=4,Me[o.SymbolKind.Method]=5,Me[o.SymbolKind.Property]=6,Me[o.SymbolKind.Field]=7,Me[o.SymbolKind.Constructor]=8,Me[o.SymbolKind.Enum]=9,Me[o.SymbolKind.Interface]=10,Me[o.SymbolKind.Function]=11,Me[o.SymbolKind.Variable]=12,Me[o.SymbolKind.Constant]=13,Me[o.SymbolKind.String]=14,Me[o.SymbolKind.Number]=15,Me[o.SymbolKind.Boolean]=16,Me[o.SymbolKind.Array]=17,Me[o.SymbolKind.Object]=18,Me[o.SymbolKind.Key]=19,Me[o.SymbolKind.Null]=20,Me[o.SymbolKind.EnumMember]=21,Me[o.SymbolKind.Struct]=22,Me[o.SymbolKind.Event]=23,Me[o.SymbolKind.Operator]=24,Me[o.SymbolKind.TypeParameter]=25;function me(Te){return typeof Me[Te]=="number"?Me[Te]:6}Ce.from=me;function H(Te){for(const Be in Me)if(Me[Be]===Te)return Number(Be);return o.SymbolKind.Property}Ce.to=H})(Y||(e.SymbolKind=Y={}));var le;(function(Ce){function Me(H){switch(H){case o.SymbolTag.Deprecated:return 1}}Ce.from=Me;function me(H){switch(H){case 1:return o.SymbolTag.Deprecated}}Ce.to=me})(le||(e.SymbolTag=le={}));var Ee;(function(Ce){function Me(H){return{name:H.name,kind:Y.from(H.kind),tags:H.tags&&H.tags.map(le.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Me;function me(H){const Te=new o.$mK(H.name,Y.to(H.kind),H.containerName,q.to(H.location));return Te.tags=H.tags&&H.tags.map(le.to),Te}Ce.to=me})(Ee||(e.WorkspaceSymbol=Ee={}));var ce;(function(Ce){function Me(H){const Te={name:H.name||"!!MISSING: name!!",detail:H.detail,range:a.from(H.range),selectionRange:a.from(H.selectionRange),kind:Y.from(H.kind),tags:H.tags?.map(le.from)??[]};return H.children&&(Te.children=H.children.map(Me)),Te}Ce.from=Me;function me(H){const Te=new o.$nK(H.name,H.detail,Y.to(H.kind),a.to(H.range),a.to(H.selectionRange));return(0,w.$Jb)(H.tags)&&(Te.tags=H.tags.map(le.to)),H.children&&(Te.children=H.children.map(me)),Te}Ce.to=me})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Me(H){const Te=new o.$rK(Y.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),a.to(H.range),a.to(H.selectionRange));return Te._sessionId=H._sessionId,Te._itemId=H._itemId,Te}Ce.to=Me;function me(H,Te,Be){if(Te=Te??H._sessionId,Be=Be??H._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:H.name,detail:H.detail,kind:Y.from(H.kind),uri:H.uri,range:a.from(H.range),selectionRange:a.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=me})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Me(me){return new o.$sK($e.to(me.from),me.fromRanges.map(H=>a.to(H)))}Ce.to=Me})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Me(me){return new o.$tK($e.to(me.to),me.fromRanges.map(H=>a.to(H)))}Ce.to=Me})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Me(H){return{range:H.range&&a.from(H.range),uri:H.uri}}Ce.from=Me;function me(H){return new o.$hK(v.URI.revive(H.uri),a.to(H.range))}Ce.to=me})(q||(e.location=q={}));var ue;(function(Ce){function Me(H){const Te=H,Be=H;return{originSelectionRange:Te.originSelectionRange?a.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:a.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?a.from(Te.targetSelectionRange):void 0}}Ce.from=Me;function me(H){return{targetUri:v.URI.revive(H.uri),targetRange:a.to(H.range),targetSelectionRange:H.targetSelectionRange?a.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?a.to(H.originSelectionRange):void 0}}Ce.to=me})(ue||(e.DefinitionLink=ue={}));var we;(function(Ce){function Me(H){return{range:a.from(H.range),contents:U.fromMany(H.contents)}}Ce.from=Me;function me(H){return new o.$kK(H.contents.map(U.to),a.to(H.range))}Ce.to=me})(we||(e.Hover=we={}));var be;(function(Ce){function Me(H){return{range:a.from(H.range),expression:H.expression}}Ce.from=Me;function me(H){return new o.$dL(a.to(H.range),H.expression)}Ce.to=me})(be||(e.EvaluatableExpression=be={}));var ge;(function(Ce){function Me(H){if(H instanceof o.$eL)return{type:"text",range:a.from(H.range),text:H.text};if(H instanceof o.$fL)return{type:"variable",range:a.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof o.$gL)return{type:"expression",range:a.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function me(H){switch(H.type){case"text":return{range:a.to(H.range),text:H.text};case"variable":return{range:a.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:a.to(H.range),expression:H.expression}}}Ce.to=me})(ge||(e.InlineValue=ge={}));var ke;(function(Ce){function Me(H){return{frameId:H.frameId,stoppedLocation:a.from(H.stoppedLocation)}}Ce.from=Me;function me(H){return new o.$hL(H.frameId,a.to(H.stoppedLocation))}Ce.to=me})(ke||(e.InlineValueContext=ke={}));var re;(function(Ce){function Me(H){return{range:a.from(H.range),kind:H.kind}}Ce.from=Me;function me(H){return new o.$lK(a.to(H.range),H.kind)}Ce.to=me})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Me(me){switch(me){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ce.to=Me})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Me(me){return{triggerKind:he.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Me})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Me(H){switch(H){case o.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function me(H){switch(H){case 1:return o.CompletionItemTag.Deprecated}}Ce.to=me})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Me=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function me(Be){return Me.get(Be)??9}Ce.from=me;const H=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Te(Be){return H.get(Be)??o.CompletionItemKind.Property}Ce.to=Te})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Me(me,H){const Te=new o.$BK(me.label);return Te.insertText=me.insertText,Te.kind=fe.to(me.kind),Te.tags=me.tags?.map(oe.to),Te.detail=me.detail,Te.documentation=A.$Zj(me.documentation)?U.to(me.documentation):me.documentation,Te.sortText=me.sortText,Te.filterText=me.filterText,Te.preselect=me.preselect,Te.commitCharacters=me.commitCharacters,p.$ks.isIRange(me.range)?Te.range=a.to(me.range):typeof me.range=="object"&&(Te.range={inserting:a.to(me.range.insert),replacing:a.to(me.range.replace)}),Te.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Te.insertText=new o.$gK(me.insertText):(Te.insertText=me.insertText,Te.textEdit=Te.range instanceof o.$0J?new o.$cK(Te.range,Te.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Te.additionalTextEdits=me.additionalTextEdits.map(Be=>De.to(Be))),Te.command=H&&me.command?H.fromInternal(me.command):void 0,Te}Ce.to=Me})(Ie||(e.CompletionItem=Ie={}));var T;(function(Ce){function Me(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ce.from=Me;function me(H){return{label:H.label,documentation:A.$Zj(H.documentation)?U.to(H.documentation):H.documentation}}Ce.to=me})(T||(e.ParameterInformation=T={}));var K;(function(Ce){function Me(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(T.from):[],activeParameter:H.activeParameter}}Ce.from=Me;function me(H){return{label:H.label,documentation:A.$Zj(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(T.to):[],activeParameter:H.activeParameter}}Ce.to=me})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Me;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Me(me,H){const Te=new o.$AK(b.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Te.textEdits=H.textEdits&&H.textEdits.map(De.to),Te.tooltip=A.$Zj(H.tooltip)?U.to(H.tooltip):H.tooltip,Te.paddingLeft=H.paddingLeft,Te.paddingRight=H.paddingRight,Te}Ce.to=Me})(Q||(e.InlayHint=Q={}));var J;(function(Ce){function Me(me,H){const Te=new o.$zK(H.label);return Te.tooltip=A.$Zj(H.tooltip)?U.to(H.tooltip):H.tooltip,g.Command.is(H.command)&&(Te.command=me.fromInternal(H.command)),H.location&&(Te.location=q.to(H.location)),Te}Ce.to=Me})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Me(H){return H}Ce.from=Me;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Me(H){return{range:a.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Me;function me(H){let Te;if(H.url)try{Te=typeof H.url=="string"?v.URI.parse(H.url,!0):v.URI.revive(H.url)}catch{}return new o.$GK(a.to(H.range),Te)}Ce.to=me})(ae||(e.DocumentLink=ae={}));var Oe;(function(Ce){function Me(H){const Te=new o.$JK(H.label);return H.textEdit&&(Te.textEdit=De.to(H.textEdit)),H.additionalTextEdits&&(Te.additionalTextEdits=H.additionalTextEdits.map(Be=>De.to(Be))),Te}Ce.to=Me;function me(H){return{label:H.label,textEdit:H.textEdit?De.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Te=>De.from(Te)):void 0}}Ce.from=me})(Oe||(e.ColorPresentation=Oe={}));var Ue;(function(Ce){function Me(H){return new o.$HK(H[0],H[1],H[2],H[3])}Ce.to=Me;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Me(H){return{range:a.from(H.range)}}Ce.from=Me;function me(H){return new o.$qK(a.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ce){function Me(me){switch(me){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ce){function Me(H){switch(H){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function me(H){switch(H){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ce.to=me})(et||(e.TextEditorLineNumbersStyle=et={}));var Ye;(function(Ce){function Me(H){if(H===o.EndOfLine.CRLF)return 1;if(H===o.EndOfLine.LF)return 0}Ce.from=Me;function me(H){if(H===1)return o.EndOfLine.CRLF;if(H===0)return o.EndOfLine.LF}Ce.to=me})(Ye||(e.EndOfLine=Ye={}));var xe;(function(Ce){function Me(me){if(typeof me=="object")return me.viewId;switch(me){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(xe||(e.ProgressLocation=xe={}));var it;(function(Ce){function Me(H){const Te={start:H.start+1,end:H.end+1};return H.kind&&(Te.kind=tt.from(H.kind)),Te}Ce.from=Me;function me(H){const Te={start:H.start-1,end:H.end-1};return H.kind&&(Te.kind=tt.to(H.kind)),Te}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Me(H){if(H)switch(H){case o.FoldingRangeKind.Comment:return g.$_s.Comment;case o.FoldingRangeKind.Imports:return g.$_s.Imports;case o.FoldingRangeKind.Region:return g.$_s.Region}}Ce.from=Me;function me(H){if(H)switch(H.value){case g.$_s.Comment.value:return o.FoldingRangeKind.Comment;case g.$_s.Imports.value:return o.FoldingRangeKind.Imports;case g.$_s.Region.value:return o.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Me(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?a.from(me.selection):void 0,override:typeof me.override=="boolean"?s.$JD.id:void 0}}Ce.from=Me})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Me(Be){return Be instanceof o.$4K?Be.toJSON():typeof Be=="string"?Be:me(Be)||H(Be)?new o.$4K(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Me;function me(Be){const Ge=Be;return Ge?v.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new o.$4K(v.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Te})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Me(me){if(me){if(Array.isArray(me))return me.map(Me);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Me})(_||(e.LanguageSelector=_={}));var X;(function(Ce){function Me(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Te=>Te instanceof o.$$J)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Te=>Te&&typeof Te=="object"&&v.URI.isUri(Te.uri)&&Te.range instanceof o.$0J)}Ce.is=Me;function me(H){return{selections:H.selections.map(Te=>n.from(Te)),related:H.related.map(Te=>({uri:v.URI.from(Te.uri),range:a.from(Te.range)}))}}Ce.from=me})(X||(e.MappedEditsContext=X={}));var pe;(function(Ce){function Me(H){return{start:H.start,end:H.end}}Ce.from=Me;function me(H){return new o.$sL(H.start,H.end)}Ce.to=me})(pe||(e.NotebookRange=pe={}));var je;(function(Ce){function Me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Me;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(je||(e.NotebookCellExecutionSummary=je={}));var Ne;(function(Ce){function Me(me){if(me===d.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Pending)return;if(me===d.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Me})(Ne||(e.NotebookCellExecutionState=Ne={}));var Xe;(function(Ce){function Me(H){switch(H){case o.NotebookCellKind.Markup:return d.CellKind.Markup;case o.NotebookCellKind.Code:default:return d.CellKind.Code}}Ce.from=Me;function me(H){switch(H){case d.CellKind.Markup:return o.NotebookCellKind.Markup;case d.CellKind.Code:default:return o.NotebookCellKind.Code}}Ce.to=me})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ce){function Me(H){const Te={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)o.$tL.validate(Be),Te.cells.push(dt.from(Be));return Te}Ce.from=Me;function me(H){const Te=new o.$uL(H.cells.map(dt.to));return(0,c.$wf)(H.metadata)||(Te.metadata=H.metadata),Te}Ce.to=me})(nt||(e.NotebookData=nt={}));var dt;(function(Ce){function Me(H){return{cellKind:Xe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:je.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Me;function me(H){return new o.$tL(Xe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?je.to(H.internalMetadata):void 0)}Ce.to=me})(dt||(e.NotebookCellData=dt={}));var wt;(function(Ce){function Me(H){return{mime:H.mime,valueBytes:M.$Fd.wrap(H.data)}}Ce.from=Me;function me(H){return new o.$vL(H.valueBytes.buffer,H.mime)}Ce.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Me(H){return{outputId:H.id,items:H.items.map(wt.from),metadata:H.metadata}}Ce.from=Me;function me(H){const Te=H.items.map(wt.to);return new o.$wL(Te,H.outputId,H.metadata)}Ce.to=me})(Pt||(e.NotebookCellOutput=Pt={}));var Xt;(function(Ce){function Me(Te){return H(Te)?{include:st.from(Te.include)??void 0,exclude:st.from(Te.exclude)??void 0}:st.from(Te)??void 0}Ce.from=Me;function me(Te){return H(Te)?{include:st.to(Te.include),exclude:st.to(Te.exclude)}:st.to(Te)}Ce.to=me;function H(Te){const Be=Te;return Be?!(0,c.$sf)(Be.include)&&!(0,c.$sf)(Be.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Kt;(function(Ce){function Me(me,H,Te){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Te),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Me})(Kt||(e.NotebookStatusBarItem=Kt={}));var pt;(function(Ce){function Me(me,H,Te){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(Be,Te),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Me})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Me(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Me})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Me(H){return{uri:H.uri,provides:H.provides}}Ce.from=Me;function me(H){return new o.$yL(v.URI.revive(H.uri),H.provides)}Ce.to=me})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Me(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:a.from(H.location.range),uri:H.location.uri}}}Ce.from=Me;function me(H){const Te=new o.$EL(typeof H.message=="string"?H.message:U.to(H.message));return Te.actualOutput=H.actual,Te.expectedOutput=H.expected,Te.contextValue=H.contextValue,Te.location=H.location?q.to(H.location):void 0,Te}Ce.to=me})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=$.$2I,Ce.denamespace=$.$3I})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Me(H){const Te=(0,i.$3L)(H).controllerId;return{extId:y.$XI.fromExtHostTestItem(H,Te).toString(),label:H.label,uri:v.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>At.namespace(Te,Be.id)),range:p.$ks.lift(a.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ce.from=Me;function me(H){return{parent:void 0,error:void 0,id:y.$XI.fromString(H.extId).localId,label:H.label,uri:v.URI.revive(H.uri),tags:(H.tags||[]).map(Te=>{const{tagId:Be}=At.denamespace(Te);return new o.$FL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ce){function Me(H){return{id:H.id}}Ce.from=Me;function me(H){return new o.$FL(H.id)}Ce.to=me}(At||(e.TestTag=At={}));var zt;(function(Ce){const Me=(H,Te)=>{const Be=[];for(const[We,_e]of Te)y.$XI.compare(_e.item.extId,We)===2&&(Te.delete(We),Be.push(_e));const Ge={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(Bt.to)})),children:Be.map(We=>Me(We,Te))};for(const We of Ge.children)We.parent=Ge;return Ge};function me(H){const Te=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const We=y.$XI.root(Ge.item.extId);H.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(Ge.item.extId))&&Te.push(Ge)}return{completedAt:H.completedAt,results:Te.map(Ge=>Me(Ge,Be))}}Ce.to=me})(zt||(e.TestResults=zt={}));var Wt;(function(Ce){function Me(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?b.from(Be):a.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&me(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}Ce.fromDetailed=H;function Te(Be){return{uri:Be.uri,statement:Me(Be.statementCoverage),branch:Be.branchCoverage&&Me(Be.branchCoverage),function:Be.functionCoverage&&Me(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ce.fromFile=Te})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Me(me){switch(me){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Jt||(e.CodeActionTriggerKind=Jt={}));var Vt;(function(Ce){function Me(H){const Te=new o.$LL(Y.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),a.to(H.range),a.to(H.selectionRange));return Te._sessionId=H._sessionId,Te._itemId=H._itemId,Te}Ce.to=Me;function me(H,Te,Be){if(Te=Te??H._sessionId,Be=Be??H._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:Y.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:a.from(H.range),selectionRange:a.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=me})(Vt||(e.TypeHierarchyItem=Vt={}));var qt;(function(Ce){function Me(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Me})(qt||(e.ViewBadge=qt={}));var ot;(function(Ce){function Me(Be,Ge,We){const _e=Ge.fileData;return _e?new o.$WK(new o.$XK(_e.name,v.URI.revive(_e.uri),_e.id,(0,F.$bb)(()=>We(_e.id)))):Be===P.$Hr.uriList&&Ge.uriListData?new o.$VK(Te(Ge.uriListData)):new o.$VK(Ge.asString)}Ce.to=Me;async function me(Be,Ge){const We=await Ge.asString();if(Be===P.$Hr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const _e=Ge.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ce.from=me;function H(Be){return C.$Ts.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return v.URI.parse(Ge)}catch{}return Ge})}function Te(Be){return C.$Ts.create(Be.map(Ge=>typeof Ge=="string"?Ge:v.URI.revive(Ge)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Ce){function Me(H,Te){const Be=H.items.map(([Ge,We])=>[Ge,ot.to(Ge,We,Te)]);return new o.$YK(Be)}Ce.toDataTransfer=Me;async function me(H){const Te={items:[]},Be=[];for(const[Ge,We]of H)Be.push((async()=>{Te.items.push([Ge,await ot.from(Ge,We)])})());return await Promise.all(Be),Te}Ce.from=me})(ft||(e.DataTransfer=ft={}));var Mt;(function(Ce){function Me(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Me;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(Mt||(e.ChatReplyFollowup=Mt={}));var Tt;(function(Ce){function Me(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:Mt.from(me)}Ce.from=Me})(Tt||(e.ChatFollowup=Tt={}));var It;(function(Ce){function Me(H){const Te=new o.$VL(ht.to(H.role),H.content);return Te.name=H.name,Te}Ce.to=Me;function me(H){return{role:ht.from(H.role),content:H.content,name:H.name}}Ce.from=me})(It||(e.ChatMessage=It={}));var ht;(function(Ce){function Me(H){switch(H){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant;case 3:return o.ChatMessageRole.Function}}Ce.to=Me;function me(H){switch(H){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.Function:return 3;case o.ChatMessageRole.User:default:return 1}}Ce.from=me})(ht||(e.ChatMessageRole=ht={}));var Dt;(function(Ce){function Me(H){return{level:kt.to(H.level),value:H.value,description:H.description}}Ce.to=Me;function me(H){return{level:kt.from(H.level),value:H.value,description:H.description}}Ce.from=me})(Dt||(e.ChatVariable=Dt={}));var kt;(function(Ce){function Me(H){switch(H){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Ce.to=Me;function me(H){switch(H){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(kt||(e.ChatVariableLevel=kt={}));var Ft;(function(Ce){function Me(me){switch(me){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Me})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Ve;(function(Ce){function Me(me,H,Te){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Te)}Ce.from=Me})(Ve||(e.TerminalQuickFix=Ve={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class h{constructor(m,P,D,c={timeout:1500,errors:3}){this.c=m,this.d=P,this.f=D,this.g=c,this.a=new A.$tc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(P,D,c)=>{const p={dispose:this.a.push([P,D,m])};return Array.isArray(c)&&c.push(p),p}}async $participateInSave(m,P){const D=w.URI.revive(m);let c=!1;const v=setTimeout(()=>c=!0,this.g.timeout),p=[];try{for(const g of[...this.a]){if(c)break;const t=this.d.getDocument(D),i=await this.h(g,{document:t,reason:F.TextDocumentSaveReason.to(P)});p.push(i)}}finally{clearTimeout(v)}return p}h([m,P,D],c){const v=this.b.get(m);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(D,m,P,c).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this.b.get(m);this.b.set(m,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,P,D,c){const v=[],p=Date.now(),{document:g,reason:t}=c,{version:i}=g,s=Object.freeze({document:g,reason:t,waitUntil(d){if(Object.isFrozen(v))throw(0,M.$6)("waitUntil can not be called async");v.push(Promise.resolve(d))}});try{P.apply(D,[s])}catch(d){return Promise.reject(d)}return Object.freeze(v),new Promise((d,y)=>{const $=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout($),d(r)}).catch(r=>{clearTimeout($),y(r)})}).then(d=>{const y={edits:[]};for(const $ of d)if(Array.isArray($)&&$.every(r=>r instanceof C.$cK))for(const{newText:r,newEol:o,range:n}of $)y.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:n&&F.Range.from(n),text:r,eol:o&&F.EndOfLine.from(o)}});if(y.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.$Fbc=h}),define(Ae[205],Re([1,0,13,2,8,7,75]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;class h{constructor(D,c,v,p){this.start=D,this.deletedCount=c,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new F.$sL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(D,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,c,v){this.notebook=D,this.h=c,this.j=v,this.handle=v.handle,this.uri=M.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(C.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,c,v){const p=v.map(C.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===D);if(g&&(c||(g.items.length=0),g.items.push(...p),g.items.length>1&&g.items.every(t=>A.$eI(t.mime)))){const t=new Map,i=[];g.items.forEach(s=>{let d;t.has(s.mime)?d=t.get(s.mime):(d=[],t.set(s.mime,d),i.push(s.mime)),d.push(s.data)}),g.items.length=0,i.forEach(s=>{const d=A.$fI(t.get(s));g.items.push({mime:s,data:d.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Scc=k;class m{static{this.a=0}constructor(D,c,v,p,g){this.k=D,this.l=c,this.m=v,this.uri=p,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,c={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(g=>g.apiCell)},save(){return D.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,c,v){this.g=D.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},g=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const s=g[i],d=t.get(s.cell);if(d===void 0){const y=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});t.set(s.cell,y-1)}else p.cellChanges[d]={...p.cellChanges[d],...s}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let c=D.start|0,v=D.end|0;return c<0&&(c=0),v>this.b.length&&(v=this.b.length),D.with({start:c,end:v})}p(D){D=this.o(D);const c=[];for(let v=D.start;v<D.end;v++)c.push(this.b[v]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,c,v){if(this.j)return;const p=[],g=[],t=[];if(D.reverse().forEach(i=>{const d=i[2].map(r=>{const o=new k(this,this.l,r);return c||g.push(k.asModelAddData(this.apiNotebook,r)),o}),y=new h(i[0],i[1],[],d),$=this.b.splice(i[0],i[1],...d);for(const r of $)t.push(r.uri),y.deletedItems.push(r.apiCell);p.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}s(D,c,v,p){const g=this.b.splice(D,c);this.b.splice(v,0,...g);const t=[new h(D,c,g.map(i=>i.apiCell),[]),new h(v,0,[],g)];for(const i of t)p.push(i.asApiEvent())}t(D,c){this.b[D].setOutputs(c)}u(D,c,v,p){this.b[D].setOutputItems(c,v,p)}v(D,c){const v=this.b[D];v.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(v.uri,c)}w(D,c){const v=this.b[D];v.apiCell.mime=c}x(D,c){this.b[D].setMetadata(c)}y(D,c){this.b[D].setInternalMetadata(c)}getCellFromApiCell(D){return this.b.find(c=>c.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(c=>c.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Tcc=m}),define(Ae[206],Re([1,0,5,2,8,7]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class A{constructor(k,m,P,D={timeout:1500,errors:3}){this.b=k,this.c=m,this.d=P,this.f=D,this.a=new w.$hd}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(m,P,D)=>{const c=function(p){m.call(P,p)};return c.extension=k,this.a.event(c,void 0,D)}}async $participateInSave(k,m,P){const D=M.URI.revive(k),c=this.c.getNotebookDocument(D);if(!c)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:C.TextDocumentSaveReason.to(m)},P,async(g,t)=>{const i=Date.now(),s=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&s&&(s instanceof F.$fK?v.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const g of v){const{edits:t}=C.WorkspaceEdit.from(g);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$hdc=A}),define(Ae[104],Re([1,0,9,8,7]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,k,m,P,D,c){this.id=h,this.f=k,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=c}get apiEditor(){if(!this.e){const h=this;this.e={get notebook(){return h.notebookData.apiNotebook},get selection(){return h.a[0]},set selection(k){this.selections=[k]},get selections(){return h.a},set selections(k){if(!Array.isArray(k)||!k.every(C.$sL.isNotebookRange))throw(0,w.$5)("selections");h.a=k,h.g(k)},get visibleRanges(){return h.b},revealRange(k,m){h.f.$tryRevealRange(h.id,M.NotebookRange.from(k),m??C.NotebookEditorRevealType.Default)},get viewColumn(){return h.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(h){this.d=h}_acceptVisibleRanges(h){this.b=h}_acceptSelections(h){this.a=h}g(h){this.f.$trySetSelections(this.id,h.map(M.NotebookRange.from))}_acceptViewColumn(h){this.c=h}}e.$Ucc=F}),define(Ae[207],Re([1,0,9,5,14,8]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;let A=class{constructor(k,m){this.c=k,this.d=m,this.a=new M.$fd({onListenerError:w.$Z}),this.b=new M.$fd({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,m);const P=this.d.getEditorById(k);m.visibleRanges&&P._acceptVisibleRanges(m.visibleRanges.ranges.map(F.NotebookRange.to)),m.selections&&P._acceptSelections(m.selections.selections.map(F.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const m in k)this.d.getEditorById(m)._acceptViewColumn(F.ViewColumn.to(k[m]))}};e.$adc=A,e.$adc=A=Ke([qe(0,C.$5i)],A)}),define(Ae[208],Re([1,0,8,50,153,21,65,9]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class k{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,v,p){const g=this.b++,{title:t,location:i,cancellable:s}=v,d={label:(0,C.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(g,{location:w.ProgressLocation.from(i),title:t,source:d,cancellable:s},c.isUnderDevelopment?void 0:c.identifier.value).catch(h.$Z),this.d(g,p,!!s)}d(c,v,p){let g;p&&(g=new F.$pd,this.c.set(c,g));const t=s=>{this.a.$progressEnd(s),this.c.delete(s),g?.dispose()};let i;try{i=v(new P(this.a,c),p&&g?g.token:F.CancellationToken.None)}catch(s){throw t(c),s}return i.then(s=>t(c),s=>t(c)),i}$acceptProgressCanceled(c){const v=this.c.get(c);v&&(v.cancel(),this.c.delete(c))}}e.$ecc=k;function m(D,c){return D.message=c.message,typeof c.increment=="number"&&(typeof D.increment=="number"?D.increment+=c.increment:D.increment=c.increment),D}class P extends M.$Vu{constructor(c,v){super(p=>this.throttledReport(p)),this.f=c,this.g=v}throttledReport(c){this.f.$progressReport(this.g,c)}}Ke([(0,A.$8g)(100,(D,c)=>m(D,c),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,57,8,2]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=void 0;const m=(d,y,$,r)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!$(o,n)){const a=o;o=n,d.listener?.(r(n,a))}}}},P=(d,y)=>d===y,D={range:(d,y)=>d===y?!0:!d||!y?!1:d.isEqual(y),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(d,y)=>!(d.length!==y.length||d.some($=>!y.find(r=>$.id===r.id)))},c=d=>y=>({op:4,update:d(y)}),v=(d,y)=>({range:(()=>{let $;const r=c(o=>({range:w.$ks.lift(h.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return $},set(o){d.listener?.({op:6}),D.range($,o)||($=o,d.listener?.(r(o)))}}})(),label:m(d,y,D.label,c($=>({label:$}))),description:m(d,void 0,D.description,c($=>({description:$}))),sortText:m(d,void 0,D.sortText,c($=>({sortText:$}))),canResolveChildren:m(d,!1,D.canResolveChildren,$=>({op:2,state:$})),busy:m(d,!1,D.busy,c($=>({busy:$}))),error:m(d,void 0,D.error,c($=>({error:h.MarkdownString.fromStrict($)||null}))),tags:m(d,[],D.tags,($,r)=>({op:1,new:$.map(h.TestTag.from),old:r.map(h.TestTag.from)}))}),p=d=>{const y=C.$XI.fromString(d.extId),$=new t(y.controllerId,y.localId,d.label,k.URI.revive(d.uri)||void 0);return $.range=h.Range.to(d.range||void 0),$.description=d.description||void 0,$.sortText=d.sortText||void 0,$.tags=d.tags.map(r=>h.TestTag.to({id:(0,A.$3I)(r).tagId})),$},g=d=>{let y;for(const $ of d.tests){const r=p($.item);(0,M.$3L)(r).parent=y,y=r}return y};e.$gM=g;class t{constructor(y,$,r,o){if($.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify($)} symbol`);const n=(0,M.$2L)(this,y);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,F.$1L)(n,M.$3L,t),enumerable:!0,writable:!1},...v(n,r)})}}e.$hM=t;class i extends t{constructor(y,$){super(y,y,$,void 0),this._isRoot=!0}}e.$iM=i;class s extends F.$WL{constructor(y,$,r){super({controllerId:y,getDocumentVersion:o=>o&&r.getDocument(o)?.version,getApiFor:M.$3L,getChildren:o=>o.children,root:new i(y,$),toITestItem:h.TestItem.from})}}e.$jM=s}),define(Ae[106],Re([1,0,51,9,88,8,7]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=e.$bM=void 0;class h{static{this.c=new C.$_L("TextEditorDecorationType")}constructor(c,v,p){const g=h.c.nextId();c.$registerTextEditorDecorationType(v.identifier,g,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){c.$removeTextEditorDecorationType(g)}})}}e.$bM=h;class k{constructor(c,v){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,v){this.k();let p=null;if(c instanceof A.$9J)p=new A.$0J(c,c);else if(c instanceof A.$0J)p=c;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(c,v){this.k(),this.l(new A.$0J(c,c),v,!0)}delete(c){this.k();let v=null;if(c instanceof A.$0J)v=c;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(c,v,p){const g=this.c.validateRange(c);this.g.push({range:g,text:v,forceMoveMarkers:p})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,M.$5)("endOfLine");this.h=c}}class m{constructor(c,v,p,g){this.c=c,this.d=v,this._accept(p),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const v=Math.floor(c);return v>0?v:null}if(typeof c=="string"){const v=parseInt(c,10);return isNaN(v)?null:v>0?v:null}return null}m(c){const v=this.l(c);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const v=Math.floor(c);return v>0?v:null}if(typeof c=="string"){const v=parseInt(c,10);return isNaN(v)?null:v>0?v:null}return null}o(c){const v=this.n(c);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const v=this.p(c);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(c)})))}assign(c){const v={};let p=!1;if(typeof c.tabSize<"u"){const g=this.l(c.tabSize);g==="auto"?(p=!0,v.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,p=!0,v.tabSize=g)}if(typeof c.indentSize<"u"){const g=this.n(c.indentSize);g==="tabSize"?(p=!0,v.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,p=!0,v.indentSize=g)}if(typeof c.insertSpaces<"u"){const g=this.p(c.insertSpaces);g==="auto"?(p=!0,v.insertSpaces=g):this.h!==g&&(this.h=g,p=!0,v.insertSpaces=g)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,p=!0,v.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,p=!0,v.lineNumbers=F.TextEditorLineNumbersStyle.from(c.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(c,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(p)})}}e.$cM=m;class P{constructor(c,v,p,g,t,i,s,d){this.id=c,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new m(this.j,this.id,i,p),this.e=s,this.f=d;const y=this;this.value=Object.freeze({get document(){return g.value},set document($){throw new M.$7("document")},get selection(){return y.c&&y.c[0]},set selection($){if(!($ instanceof A.$$J))throw(0,M.$5)("selection");y.c=[$],y.l()},get selections(){return y.c},set selections($){if(!Array.isArray($)||$.some(r=>!(r instanceof A.$$J)))throw(0,M.$5)("selections");y.c=$,y.l()},get visibleRanges(){return y.e},set visibleRanges($){throw new M.$7("visibleRanges")},get options(){return y.d.value},set options($){y.g||y.d.assign($)},get viewColumn(){return y.f},set viewColumn($){throw new M.$7("viewColumn")},edit($,r={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new k(g.value,r);return $(o),y.m(o)},insertSnippet($,r,o={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=y.c.map(a=>F.Range.from(a));else if(r instanceof A.$9J){const{lineNumber:a,column:E}=F.Position.from(r);n=[{startLineNumber:a,startColumn:E,endLineNumber:a,endColumn:E}]}else if(r instanceof A.$0J)n=[F.Range.from(r)];else{n=[];for(const a of r)if(a instanceof A.$0J)n.push(F.Range.from(a));else{const{lineNumber:E,column:b}=F.Position.from(a);n.push({startLineNumber:E,startColumn:b,endLineNumber:E,endColumn:b})}}return v.$tryInsertSnippet(c,g.value.version,$.value,n,o)},setDecorations($,r){const o=r.length===0;o&&!y.h.has($.key)||(o?y.h.delete($.key):y.h.add($.key),y.n(()=>{if(F.$4L(r))return v.$trySetDecorations(c,$.key,F.$5L(r));{const n=new Array(4*r.length);for(let a=0,E=r.length;a<E;a++){const b=r[a];n[4*a]=b.start.line+1,n[4*a+1]=b.start.character+1,n[4*a+2]=b.end.line+1,n[4*a+3]=b.end.character+1}return v.$trySetDecorationsFast(c,$.key,n)}}))},revealRange($,r){y.n(()=>v.$tryRevealRange(c,F.Range.from($),r||A.TextEditorRevealType.Default))},show($){v.$tryShowEditor(c,F.ViewColumn.from($))},hide(){v.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,w.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,w.ok)(!this.g),this.f=c}_acceptSelections(c){(0,w.ok)(!this.g),this.c=c}async l(){const c=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const v=c.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const s=p[t].end;if(p[t+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=v.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,g,{setEndOfLine:typeof v.setEndOfLine=="number"?F.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$dM=P}),define(Ae[209],Re([1,0,4,172]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=void 0,e.$qJ=(0,w.$Ch)(M.$Ih)}),define(Ae[107],Re([1,0,20,5,19,6]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=e.$R3b=e.$Q3b=e.$P3b=e.$O3b=e.$N3b=void 0;class A{constructor(i,s){this.versionId=i,this.removedDueToLooping=s}}e.$N3b=A;class h{static isHostExtension(i,s,d){if(s.getExtensionDescription(i))return!1;const y=d.getExtensionDescription(i);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(i,s){this.j=i,this.c=new M.$fd,this.onDidChange=this.c.event,this.d=0,this.e=s,this.k()}k(){this.e.sort(p),this.f=new w.$Xl,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const s=this.j.readActivationEvents(i);if(Array.isArray(s))for(let d of s)d==="onUri"&&(d=`onUri:${w.$Vl.toKey(i.identifier)}`),this.h.has(d)||this.h.set(d,[]),this.h.get(d).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,s){this.e=g(this.e,s),this.e=this.e.concat(i);const d=h.l(this.e);return this.e=g(this.e,d.map(y=>y.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,d)}static l(i){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(o){this.d.has(o)||(this.d.add(o),this.e.push(o))}addArc(o,n){this.addNode(o),this.addNode(n),this.c.has(o)?this.c.get(o).push(n):this.c.set(o,[n])}getArcs(o){return this.c.has(o)?this.c.get(o):[]}hasOnlyGoodArcs(o,n){const a=s.getArcs(o);for(let E=0;E<a.length;E++)if(!n.has(a[E]))return!1;return!0}getNodes(){return this.e}},d=new w.$Xl;for(const o of i)if(d.set(o.identifier,o),o.extensionDependencies)for(const n of o.extensionDependencies)s.addArc(w.$Vl.toKey(o.identifier),w.$Vl.toKey(n));const y=new Set;s.getNodes().filter(o=>s.getArcs(o).length===0).forEach(o=>y.add(o));const $=s.getNodes().filter(o=>!y.has(o));let r;do{r=!1;for(let o=0;o<$.length;o++){const n=$[o];s.hasOnlyGoodArcs(n,y)&&($.splice(o,1),o--,y.add(n),r=!0)}}while(r);return $.map(o=>d.get(o))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const s=this.h.get(i);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const s=this.f.get(i);return s||void 0}getExtensionDescriptionByUUID(i){for(const s of this.g)if(s.uuid===i)return s}getExtensionDescriptionByIdOrUUID(i,s){return this.getExtensionDescription(i)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$O3b=h;class k{constructor(i,s){this.versionId=i,this.extensions=s}}e.$P3b=k,e.$Q3b={readActivationEvents:t=>t.activationEvents};class m{constructor(i){this.d=new c,this.c=new h(i,[])}async acquireLock(i){const s=await this.d.acquire(i);return new P(this,s)}deltaExtensions(i,s,d){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,d)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,s){return this.c.getExtensionDescriptionByIdOrUUID(i,s)}}e.$R3b=m;class P extends F.$kc{constructor(i,s){super(),this.f=i,this.c=!1,this.B(s)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$S3b=P;class D{constructor(i){this.name=i,this.promise=new Promise((s,d)=>{this.c=s})}resolve(i){this.c(i)}}class c{constructor(){this.c=[],this.d=!1}async acquire(i){const s=new D(i);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let s=!0;const d=setTimeout(()=>{s&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{s&&(clearTimeout(d),s=!1,this.d=!1,this.e())};i.resolve((0,F.$ic)(y))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const s=t.isBuiltin?0:t.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(s!==d)return s-d;const y=C.$6d.basename(t.extensionLocation.path),$=C.$6d.basename(i.extensionLocation.path);return y<$?-1:y>$?1:0}function g(t,i){const s=new w.$Wl(i);return t.filter(d=>!s.has(d.identifier))}}),define(Ae[79],Re([1,0,25]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$5l=e.$4l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function A(m){const P=w.$Fd.alloc(1);switch(m){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$4l=A;function h(m,P){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$5l=h;var k;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,155]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.$mM=e.$lM=void 0;let v=class extends D.$kc{constructor(i,s){super(),this.s=i,this.t=s,this.a=this.B(new M.$fd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$fd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=s.createLogger(this.m,{id:k.$eo,name:(0,c.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(d=>{(0,C.$7i)(d)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,s,d){const y=this.getTelemetryDetails(),$=new p(s,d,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,$]),$.apiTelemetryLogger}$initializeTelemetryLevel(i,s,d){this.f=i,this.g=s,this.c=d??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const s=Object.create(null);switch(s["common.extname"]=`${i.publisher}.${i.name}`,s["common.extversion"]=i.version,s["common.vscodemachineid"]=this.s.telemetryInfo.machineId,s["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,s["common.vscodeversion"]=this.s.version,s["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),s["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:s["common.uikind"]="web";break;case A.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,h.$Pk)((0,k.$lo)(this.s.remote.authority)),s}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const s=this.getTelemetryDetails();this.r.forEach((d,y)=>{const $=d.filter(r=>!r.isDisposed);$.length===0?this.r.delete(y):this.r.set(y,$)}),this.r.forEach(d=>{for(const y of d)y.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,s){const y=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!y)return this.r.delete(i.value),!1;let $=!1;for(const r of y)r.ignoreUnhandledExtHostErrors||(r.logError(s),$=!0);return $}};e.$lM=v,e.$lM=v=Ke([qe(0,F.$kM),qe(1,C.$6i)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,s,d,y,$,r,o){this.g=d,this.h=y,this.i=$,this.j=r,this.a=new M.$fd,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(i,s){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let s="properties"in i?i.properties??{}:i;return s=(0,k.$oo)(s,[]),this.c&&(s=(0,m.$Ym)(s,this.c)),this.b||(s=(0,m.$Ym)(s,this.j)),"properties"in i?i.properties=s:i=s,i}k(i,s){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(i,s),this.h.trace(i,s))}logUsage(i,s){this.d.isUsageEnabled&&this.k(i,s)}logError(i,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,s);else{const d={name:i.name,message:i.message,stack:i.stack,cause:i.cause},y=(0,k.$oo)(d,[]),$=new Error(y.message,{cause:y.cause});$.stack=y.stack,$.name=y.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData($,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const i=this,s={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$mM=p;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$nM=g,e.$oM=(0,w.$Bh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.ActivationKind=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.ExtensionHostStartup=e.$1E=e.$ZE=e.$YE=e.$XE=void 0,e.$XE=Object.freeze({identifier:new A.$Vl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YE="extensions.webWorker",e.$ZE=(0,h.$Bh)("extensionService");class k{constructor($){this.dependency=$}}e.$1E=k;var m;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor($,r,o){this.c=$,this.d=r.slice(0),this.e=o.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$IE.createActivationEventsMap(this.d)}}set($,r,o){if(this.c>$)throw new Error(`ExtensionHostExtensions: invalid versionId ${$} (current: ${this.c})`);const n=[],a=[],E=[],b=[],S=D(this.d),I=D(r),u=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=I.get(V.identifier);if(!U){n.push(V.identifier),S.delete(V.identifier);continue}if(!u(V,U)){n.push(V.identifier),S.delete(V.identifier);continue}}for(const V of r){const U=S.get(V.identifier);if(!U){a.push(V);continue}if(!u(U,V)){n.push(U.identifier),S.delete(U.identifier);continue}}const f=new A.$Wl(this.e),l=new A.$Wl(o);for(const V of this.e)l.has(V)||E.push(V);for(const V of o)f.has(V)||b.push(V);const R=F.$IE.createActivationEventsMap(a),B={versionId:$,toRemove:n,toAdd:a,addActivationEvents:R,myToRemove:E,myToAdd:b};return this.delta(B),B}delta($){if(this.c>=$.versionId)return null;const{toRemove:r,toAdd:o,myToRemove:n,myToAdd:a}=$,E=new A.$Wl(r),b=new A.$Wl(n);for(let S=0;S<this.d.length;S++)E.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)b.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of o)this.d.push(S);for(const S of a)this.e.push(S);return $}containsExtension($){for(const r of this.e)if(A.$Vl.equals(r,$))return!0;return!1}}e.$2E=P;function D(y){const $=new A.$Xl;for(const r of y)$.set(r.identifier,r);return $}function c(y,$){return y.enabledApiProposals?y.enabledApiProposals.includes($):!1}e.$3E=c;function v(y,$){if(!c(y,$))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${$}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${$}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.$4E=v;class p{constructor($,r,o,n){this.codeLoadingTime=$,this.activateCallTime=r,this.activateResolvedTime=o,this.activationReason=n}}e.$5E=p;class g{constructor($,r){this.description=$,this.value=r}}e.$6E=g;var t;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,C.$uo)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.$7E=i;function s(y,$){return{identifier:new A.$Vl((0,C.$so)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!$,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform}}e.$8E=s;class d{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent($){return Promise.resolve(void 0)}activationEventIsDone($){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions($){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts($,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment($){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9E=d}),define(Ae[210],Re([1,0,9,107,20,26,14,12]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=e.$Jbc=e.$Ibc=e.$Hbc=e.$Gbc=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(i,s,d,y){this.startup=i,this.codeLoadingTime=s,this.activateCallTime=d,this.activateResolvedTime=y}}e.$Gbc=k;class m{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,s){return i===-1||s===-1?-1:s-i}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hbc=m;class P{constructor(i,s,d,y,$,r){this.activationFailed=i,this.activationFailedError=s,this.activationTimes=d,this.module=y,this.exports=$,this.subscriptions=r}}e.$Ibc=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jbc=D;class c extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kbc=c;class v extends P{constructor(i){super(!0,i,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,s,d,y){this.g=y,this.a=i,this.b=s,this.c=d,this.d=new C.$Xl,this.f=Object.create(null)}dispose(){for(const[i,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const i=[];for(const[s,d]of this.d)i.push(d.wait());await Promise.all(i)}isActivated(i){const s=this.d.get(i);return!!(s&&s.value)}getActivatedExtension(i){const s=this.d.get(i);if(!s||!s.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return s.value}async activateByEvent(i,s){if(this.f[i])return;const d=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(d.map(y=>({id:y.identifier,reason:{startup:s,extensionId:y.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,s){const d=this.a.getExtensionDescription(i);if(!d)throw new Error(`Extension '${i}' is not known`);return this.h([{id:d.identifier,reason:s}])}async h(i){const s=i.filter(d=>!this.isActivated(d.id)).map(d=>this.j(d));await Promise.all(s.map(d=>d.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const s=this.a.getExtensionDescription(i.id);if(!s){const $=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new v($));return this.c.onExtensionActivationError(i.id,$,new F.$1E(i.id.value)),r}const d=[],y=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const $ of y){if(this.m($))continue;const r=this.d.get($);if(r){d.push(r);continue}if(this.l($)){d.push(this.j({id:this.b.getExtensionDescription($).identifier,reason:i.reason}));continue}const o=this.a.getExtensionDescription($);if(o){if(!o.main&&!o.browser)continue;d.push(this.j({id:o.identifier,reason:i.reason}));continue}const n=s.displayName||s.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${$}'`),E=this.k(i,s.displayName,[],new v(a));return this.c.onExtensionActivationError(s.identifier,a,new F.$1E($)),E}return this.k(i,s.displayName,d,null)}k(i,s,d,y){const $=new g(i.id,s,i.reason,d,y,this.c,this.g);return this.d.set(i.id,$),$}l(i){return M.$O3b.isHostExtension(i,this.a,this.b)}m(i){const s=this.b.getExtensionDescription(i);return s?!s.main&&!s.browser:!1}};e.$Lbc=p,e.$Lbc=p=Ke([qe(3,A.$5i)],p);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,s,d,y,$,r,o){this.c=i,this.d=s,this.f=d,this.g=y,this.h=$,this.j=r,this.k=o,this.a=new h.$Fg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const s=this.g[i];if(s.value&&!s.value.activationFailed){this.g.splice(i,1),i--;continue}if(s.value&&s.value.activationFailed){const d=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);d.detail=s.value.activationFailedError,this.h=new v(d),this.j.onExtensionActivationError(this.c,d,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const s=new Error;if(i&&i.name&&(s.name=i.name),i&&i.message?s.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(s.stack=i.stack),this.h=new v(s),this.b&&w.$2(i))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ke([qe(6,A.$5i)],g)}),define(Ae[211],Re([1,0,157,23,2,5,6,193,12,7,16,18,8,49,21,126,26]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;function i(y,$){if((0,P.$jf)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let r;return Array.isArray(y.highlights)&&(r=y.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),r=r.length?r:void 0),{label:y.label,highlights:r}}}class s extends A.$kc{constructor($,r,o){super(),this.f=$,this.g=r,this.h=o,this.a=new Map,this.b=new g.$q7;function n(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:a=>n(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(E=>n(E)?this.r(E):E):a})}registerTreeDataProvider($,r,o){const n=this.createTreeView($,{treeDataProvider:r},o);return{dispose:()=>n.dispose()}}createTreeView($,r,o){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=r.dragAndDropController?.dropMimeTypes??[],a=r.dragAndDropController?.dragMimeTypes??[],E=!!r.dragAndDropController?.handleDrag,b=!!r.dragAndDropController?.handleDrop,S=this.m($,r,o),I={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:n,dragMimeTypes:a,hasHandleDrag:E,hasHandleDrop:b,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider($,I),f={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$4E)(o,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$4E)(o,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(l){(0,v.$Zj)(l)&&(0,t.$4E)(o,"treeViewMarkdownMessage"),S.message=l},get title(){return S.title},set title(l){S.title=l},get description(){return S.description},set description(l){S.description=l},get badge(){return S.badge},set badge(l){l!==void 0&&m.ViewBadge.isViewBadge(l)?S.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(S.badge=void 0)},reveal:(l,R)=>S.reveal(l,R),dispose:async()=>{await u,this.a.delete($),S.dispose()}};return this.B(f),f}$getChildren($,r){const o=this.a.get($);return o?o.getChildren(r):Promise.reject(new h.$fE($))}async $handleDrop($,r,o,n,a,E,b,S){const I=this.a.get($);if(!I)return Promise.reject(new h.$fE($));const u=c.DataTransfer.toDataTransfer(o,async f=>(await this.f.$resolveDropFileData($,r,f)).buffer);return b===$&&S&&await this.j(u,I,S,a,E),I.onDrop(u,n,a)}async j($,r,o,n,a){const E=this.b.removeDragOperationTransfer(a);if(E)(await E)?.forEach((b,S)=>{b&&$.set(S,b)});else if(a&&r.handleDrag){const b=r.handleDrag(o,$,n);this.b.addDragOperationTransfer(a,b),await b}return $}async $handleDrag($,r,o,n){const a=this.a.get($);if(!a)return Promise.reject(new h.$fE($));const E=await this.j(new m.$YK,a,r,n,o);if(!(!E||n.isCancellationRequested))return c.DataTransfer.from(E)}async $hasResolve($){const r=this.a.get($);if(!r)throw new h.$fE($);return r.hasResolve}$resolve($,r,o){const n=this.a.get($);if(!n)throw new h.$fE($);return n.resolveTreeItem(r,o)}$setExpanded($,r,o){const n=this.a.get($);if(!n)throw new h.$fE($);n.setExpanded(r,o)}$setSelectionAndFocus($,r,o){const n=this.a.get($);if(!n)throw new h.$fE($);n.setSelectionAndFocus(r,o)}$setVisible($,r){const o=this.a.get($);if(!o){if(!r)return;throw new h.$fE($)}o.setVisible(r)}$changeCheckboxState($,r){const o=this.a.get($);if(!o)throw new h.$fE($);o.setCheckboxState(r)}m($,r,o){const n=this.B(new d($,r,this.f,this.g.converter,this.h,o));return this.a.set($,n),n}r($){const r=this.a.get($.$treeViewId);return r&&"$treeItemHandle"in $?r.getExtensionElement($.$treeItemHandle):r&&"$focusedTreeItem"in $&&$.$focusedTreeItem?r.focusedElement:null}}e.$lcc=s;class d extends A.$kc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map($=>this.getExtensionElement($)).filter($=>!(0,P.$sf)($))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor($,r,o,n,a,E){if(super(),this.I=$,this.J=o,this.L=n,this.M=a,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$fd),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$fd),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$fd),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$fd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$fd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$fd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$fd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$pd,E.contributes&&E.contributes.views)for(const u in E.contributes.views)for(const f of E.contributes.views[u])f.id===$&&(this.P=f.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let b,S;const I=F.Event.debounce(this.F.event,(u,f)=>(u||(u={message:!1,elements:[]}),f.element!==!1&&(b||(b=new Promise(l=>S=l),this.G=this.G.then(()=>b)),Array.isArray(f.element)?u.elements.push(...f.element):u.elements.push(f.element)),f.message&&(u.message=!0),u),200,!0);this.B(I(({message:u,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const l=S;return b=null,this.$(f).then(()=>l())})),u&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren($){const r=$?this.getExtensionElement($):void 0;if($&&!r)return this.M.error(`No tree item with id '${$}' found.`),Promise.resolve([]);let o=this.X($);return o||(o=await this.Y(r)),o?o.map(n=>n.item):void 0}getExtensionElement($){return this.j.get($)}reveal($,r){r=r||{select:!0,focus:!1};const o=(0,P.$sf)(r.select)?!0:r.select,n=(0,P.$sf)(r.focus)?!1:r.focus,a=(0,P.$sf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):$?this.G.then(()=>this.S($)).then(E=>this.W($,E[E.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:E.map(S=>S.item)},{select:o,focus:n,expand:a})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:o,focus:n,expand:a})}get message(){return this.O}set message($){this.O=$,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title($){this.P=$,this.J.$setTitle(this.I,$,this.Q)}get description(){return this.Q}set description($){this.Q=$,this.J.$setTitle(this.I,this.P,$)}get badge(){return this.R}set badge($){this.R?.value===$?.value&&this.R?.tooltip===$?.tooltip||(this.R=c.ViewBadge.from($),this.J.$setBadge(this.I,$))}setExpanded($,r){const o=this.getExtensionElement($);o&&(r?this.u.fire(Object.freeze({element:o})):this.w.fire(Object.freeze({element:o})))}setSelectionAndFocus($,r){const o=!(0,D.$sb)(this.s,$);this.s=$;const n=this.t!==r;this.t=r,o&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible($){$!==this.r&&(this.r=$,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState($){const r=(await Promise.all($.map(async o=>{const n=this.getExtensionElement(o.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:o.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);r.forEach(o=>{o.treeItem.checkboxState=o.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(o=>[o.extensionItem,o.newState])})}async handleDrag($,r,o){const n=[];for(const a of $){const E=this.getExtensionElement(a);E&&n.push(E)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,r,o),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop($,r,o){const n=r?this.getExtensionElement(r):void 0;if(!(!n&&r||!this.g?.handleDrop))return(0,k.$zg)(()=>this.g?.handleDrop?this.g.handleDrop(n,$,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem($,r){if(!this.f.resolveTreeItem)return;const o=this.j.get($);if(o){const n=this.m.get(o);if(n){const a=await this.f.resolveTreeItem(n.extensionItem,o,r)??n.extensionItem;return this.hb(a),n.item.tooltip=this.eb(a.tooltip),n.item.command=this.fb(n.disposableStore,a.command),n.item}}}S($){return this.U($).then(r=>r?this.S(r).then(o=>this.W(r,o[o.length-1]).then(n=>(o.push(n),o))):Promise.resolve([]))}U($){const r=this.m.get($);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,k.$zg)(()=>this.f.getParent($))}W($,r){const o=this.m.get($);return o?Promise.resolve(o):(0,k.$zg)(()=>this.f.getTreeItem($)).then(n=>this.kb($,n,r,!0)).then(n=>this.getChildren(r?r.item.handle:void 0).then(()=>{const a=this.getExtensionElement(n);if(a){const E=this.m.get(a);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X($){if($){let r;if(typeof $=="string"){const o=this.getExtensionElement($);r=o?this.m.get(o):void 0}else r=$;return r&&r.children||void 0}return this.h}async Y($){this.rb($);const r=new p.$pd(this.Z.token);try{const o=$?this.m.get($):void 0,n=await this.f.getChildren($);if(r.token.isCancellationRequested)return;const a=await Promise.all((0,D.$Fb)(n||[]).map(async E=>{const b=await this.f.getTreeItem(E);return b&&!r.token.isCancellationRequested?this.db(E,b,o):null}));return r.token.isCancellationRequested?void 0:(0,D.$Fb)(a)}finally{r.dispose()}}$($){if($.some(o=>!o))return this.Z.dispose(!0),this.Z=new p.$pd,this.tb(),this.J.$refresh(this.I);{const o=this.ab($);if(o.length)return this.bb(o)}return Promise.resolve(void 0)}ab($){const r=new Set,o=$.map(a=>this.m.get(a));for(const a of o)if(a&&!r.has(a.item.handle)){let E=a;for(;E&&E.parent&&o.findIndex(b=>E&&E.parent&&b&&b.item.handle===E.parent.item.handle)===-1;){const b=this.j.get(E.parent.item.handle);E=b?this.m.get(b):void 0}E&&!E.parent&&r.add(a.item.handle)}const n=[];return r.forEach(a=>{const E=this.j.get(a);if(E){const b=this.m.get(E);b&&(!b.parent||!r.has(b.parent.item.handle))&&n.push(a)}}),n}bb($){const r={};return Promise.all($.map(o=>this.cb(o).then(n=>{n&&(r[o]=n.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb($){const r=this.getExtensionElement($);if(r){const o=this.m.get(r);if(o)return this.rb(r),(0,k.$zg)(()=>this.f.getTreeItem(r)).then(n=>{if(n){const a=this.ib(r,n,o.parent);return this.pb(r,a,o,o.parent),o.dispose(),a}return null})}return Promise.resolve(null)}db($,r,o){const n=this.ib($,r,o);if(r.id&&this.j.has(n.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob($,n),this.qb(n,o),n}eb($){return m.$vK.isMarkdownString($)?c.MarkdownString.from($):$}fb($,r){return r?{...this.L.toInternal(r,$),originalId:r.command}:void 0}gb($){if($.checkboxState===void 0)return;let r,o,n;return typeof $.checkboxState=="number"?r=$.checkboxState:(r=$.checkboxState.state,o=$.checkboxState.tooltip,n=$.checkboxState.accessibilityInformation),{isChecked:r===m.TreeItemCheckboxState.Checked,tooltip:o,accessibilityInformation:n}}hb($){if(!m.$TK.isTreeItem($,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib($,r,o){this.hb(r);const n=this.B(new A.$jc),a=this.kb($,r,o),E=this.lb(r);return{item:{handle:a,parentHandle:o?o.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(n,r.command),contextValue:r.contextValue,icon:E,iconDark:this.mb(r)||E,themeIcon:this.jb(r),collapsibleState:(0,P.$sf)(r.collapsibleState)?m.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:o,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb($){return $.iconPath instanceof m.$2K?$.iconPath:void 0}kb($,{id:r,label:o,resourceUri:n},a,E){if(r)return`${d.b}/${r}`;const b=i(o,this.N),S=a?a.item.handle:d.a;let I=b?b.label:n?(0,M.$fg)(n):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const u=this.m.has($)?this.m.get($).item.handle:void 0,f=this.X(a)||[];let l,R=0;do{if(l=`${S}/${R}:${I}`,E||!this.j.has(l)||u===l)break;R++}while(R<=f.length);return l}lb($){if($.iconPath&&!($.iconPath instanceof m.$2K))return typeof $.iconPath=="string"||C.URI.isUri($.iconPath)?this.nb($.iconPath):this.nb($.iconPath.light)}mb($){if($.iconPath&&!($.iconPath instanceof m.$2K)&&$.iconPath.dark)return this.nb($.iconPath.dark)}nb($){return C.URI.isUri($)?$:C.URI.file($)}ob($,r){this.j.set(r.item.handle,$),this.m.set($,r)}pb($,r,o,n){this.j.delete(r.item.handle),this.m.delete($),r.item.handle!==o.item.handle&&this.j.delete(o.item.handle),this.ob($,r);const a=this.X(n)||[],E=a.filter(b=>b.item.handle===o.item.handle)[0];E&&a.splice(a.indexOf(E),1,r)}qb($,r){r?(r.children||(r.children=[]),r.children.push($)):(this.h||(this.h=[]),this.h.push($))}rb($){if($){const r=this.m.get($);if(r){if(r.children)for(const o of r.children){const n=this.j.get(o.item.handle);n&&this.sb(n)}r.children=void 0}}else this.tb()}sb($){const r=this.m.get($);if(r){if(r.children)for(const o of r.children){const n=this.j.get(o.item.handle);n&&this.sb(n)}this.m.delete($),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach($=>$.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,73,30,20,212,177,98]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=void 0;const c=h.$8m.as(A.$9m.JSONContribution);class v{constructor($,r,o){this.a=$,this.b=r,this.c=o}d($,r){this.a({type:$,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error($){this.d(C.default.Error,$)}warn($){this.d(C.default.Warning,$)}info($){this.d(C.default.Info,$)}}e.$RE=v;class p{static a($){const r=new k.$Wl;for(let o=0,n=$.length;o<n;o++)r.add($[o].description.identifier);return r}static compute($,r){if(!$||!$.length)return new p(r,[]);if(!r||!r.length)return new p([],$);const o=this.a($),n=this.a(r),a=r.filter(b=>!o.has(b.description.identifier)),E=$.filter(b=>!n.has(b.description.identifier));return new p(a,E)}constructor($,r){this.added=$,this.removed=r}}e.$SE=p;class g{constructor($,r){this.name=$,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler($){if(this.a!==null)throw new Error("Handler already set!");this.a=$,this.d()}acceptUsers($){this.c=p.compute(this.b,$),this.b=$,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch($){(0,M.$Y)($)}}}e.$TE=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$UE={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Ul},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Mn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Mn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint($){if(this.a.has($.extensionPoint))throw new Error("Duplicate extension point: "+$.extensionPoint);const r=new g($.extensionPoint,$.defaultExtensionKind);return this.a.set($.extensionPoint,r),$.activationEventsGenerator&&D.$IE.register($.extensionPoint,$.activationEventsGenerator),e.$UE.properties.contributes.properties[$.extensionPoint]=$.jsonSchema,c.registerSchema(i,e.$UE),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$VE=s;const d={ExtensionsRegistry:"ExtensionsRegistry"};h.$8m.add(d.ExtensionsRegistry,new s),e.$WE=h.$8m.as(d.ExtensionsRegistry),c.registerSchema(i,e.$UE),c.registerSchema(P.$lj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var m;(function(c){function v(p,g,t){if(!p)return;const i=M.$jf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const s=[];if(Array.isArray(p.required))for(const d of p.required)M.$jf(d)&&s.push(d);return{extensionId:g.value,taskType:i,required:s,properties:p.properties?C.$Vm(p.properties):{},when:p.when?A.$Ii.deserialize(p.when):void 0}}c.from=v})(m||(m={}));const P=F.$WE.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,v)=>{for(const p of c)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:k}});class D{constructor(){this.d=new h.$fd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{P.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const s=i.value;for(const d of s)this.a&&d.type&&this.a[d.type]&&delete this.a[d.type]}for(const i of t.added){const s=i.value;for(const d of s){const y=m.from(d,i.description.identifier,i.collector);y&&(this.a[y.taskType]=y)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const g={type:"object",additionalProperties:!1};p.required.length>0&&(g.required=p.required.slice(0)),p.properties!==void 0?g.properties=C.$Vm(p.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[p.taskType]},v.push(g)}this.c={oneOf:v}}return this.c}}e.$FF=new D}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$PF=e.JsonSchemaVersion=e.ExecutionEngine=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$JF=e.ShellQuoting=e.$IF=e.$HF=e.$GF=void 0,e.$GF="settings",e.$HF=new A.$2i("taskRunning",!1,w.localize(0,null)),e.$IF={value:w.localize(1,null),original:"Tasks"};var k;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$JF="$customized",function(O){function N(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(k||(e.ShellQuoting=k={}));var m;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(D||(e.RevealProblemKind=D={}));var c;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(c||(e.PanelKind=c={})),function(O){function N(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(c||(e.PanelKind=c={}));var v;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(O){function N(Z){switch(Z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ee(Z){switch(Z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}(p||(e.RuntimeType=p={}));var g;(function(O){function N(ee){return M.$jf(ee)?ee:ee.value}O.value=N})(g||(e.CommandString=g={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Z){return Z===O.Clean._id||Z===O.Build._id||Z===O.Rebuild._id||Z===O.Test._id}O.is=N;function ee(Z){if(Z!==void 0)return M.$jf(Z)?N(Z)?{_id:Z,isDefault:!1}:void 0:Z}O.from=ee})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var s;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(s||(e.TaskSourceKind=s={}));var d;(function(O){O.parallel="parallel",O.sequence="sequence"})(d||(e.DependsOrder=d={}));var y;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(y||(e.RunOnOptions=y={}));var $;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})($||(e.RunOptions=$={}));class r{constructor(N,ee,Z,ye,De,Pe){this._label="",this._id=N,ee&&(this._label=ee),Z&&(this.type=Z),this.runOptions=ye,this.configurationProperties=De,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(M.$jf(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$KF=r;class o extends r{constructor(N,ee,Z,ye,De,Pe,Y,le){super(N,Z,void 0,Y,le,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,De&&(this.command=De)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case p.Shell:ee="shell";break;case p.Process:ee="process";break;case p.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof o}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$GF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(ee+=this._source.kind);const Z={type:e.$JF,folder:N,id:ee};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new o(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$LF=o;class n extends r{constructor(N,ee,Z,ye,De,Pe,Y){super(N,Z,ye,Pe,Y,ee),this._source=ee,this.configures=De}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$GF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(ee+=this._source.kind);const Z={type:e.$JF,folder:N,id:ee};return JSON.stringify(Z)}}e.$MF=n;class a extends r{constructor(N,ee,Z,ye,De,Pe,Y,le,Ee){super(N,Z,ye,le,Ee,ee),this.defines=De,this.hasDefinedMatchers=Y,this.command=Pe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof a}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new a(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$NF=a;class E extends r{constructor(N,ee,Z,ye,De,Pe){super(N,Z,ye,De,Pe,ee),this._source=ee}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new E(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$OF=E;var b;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(O){O._default=O.Terminal}(b||(e.ExecutionEngine=b={}));var S;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(N){this.c=new Map;for(let ee=0;ee<N.length;ee++)this.c.set(N[ee].uri.toString(),ee)}compare(N,ee){const Z=N.getWorkspaceFolder(),ye=ee.getWorkspaceFolder();if(Z&&ye){let De=this.c.get(Z.uri.toString());De=De===void 0?0:De+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,De===Pe?N._label.localeCompare(ee._label):De-Pe}else return!Z&&ye?-1:Z&&!ye?1:0}}e.$PF=I;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var f;(function(O){O.SingleRun="singleRun",O.Background="background"})(f||(e.TaskRunType=f={}));var l;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(l||(e.TaskRunSource=l={}));var R;(function(O){function N(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ee(le,Ee,ce){return{...N(le),kind:"start",terminalId:Ee,resolvedVariables:ce}}O.start=ee;function Z(le,Ee,ce){return{...N(le),kind:"processStarted",terminalId:Ee,processId:ce}}O.processStarted=Z;function ye(le,Ee,ce){return{...N(le),kind:"processEnded",terminalId:Ee,exitCode:ce}}O.processEnded=ye;function De(le,Ee,ce){return{...N(le),kind:"terminated",exitReason:ce,terminalId:Ee}}O.terminated=De;function Pe(le,Ee,ce){return{...N(Ee),kind:le,terminalId:ce}}O.general=Pe;function Y(){return{kind:"changed"}}O.changed=Y})(R||(e.TaskEvent=R={}));var B;(function(O){function N(Z){const ye=Object.keys(Z).sort();let De="";for(const Pe of ye){let Y=Z[Pe];Y instanceof Object?Y=N(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),De+=Pe+","+Y+","}return De}function ee(Z){const De={_key:N(Z),type:Z.taskType};return Object.assign(De,Z),De}O.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var W;(function(O){function N(ee,Z){const ye=h.$FF.get(ee.type);if(ye===void 0){const le=F.$Vm(ee);return delete le._key,B.create(le)}const De=Object.create(null);De.type=ye.taskType;const Pe=new Set;ye.required.forEach(le=>Pe.add(le));const Y=ye.properties;for(const le of Object.keys(Y)){const Ee=ee[le];if(Ee!=null)De[le]=Ee;else if(Pe.has(le)){const ce=Y[le];if(ce.default!==void 0)De[le]=F.$Vm(ce.default);else switch(ce.type){case"boolean":De[le]=!1;break;case"number":case"integer":De[le]=0;break;case"string":De[le]="";break;default:Z.error(w.localize(2,null,JSON.stringify(ee,void 0,0),le));return}}}return B.create(De)}O.createTaskIdentifier=N})(W||(e.TaskDefinition=W={}))}),define(Ae[216],Re([1,0,9]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=e.$T3b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,h)=>{this.b=A,this.d=h,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,h){return this.j().then(A,h)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$T3b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$U3b=C}),define(Ae[46],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=void 0;class w{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++w.count}}e.$dv=w;const M=[];function C(h){const k=new w(h);return M[k.nid]=k,k}e.$ev=C;function F(h){return M[h].sid}e.$fv=F;class A{constructor(k){this.value=k}}e.$gv=A}),define(Ae[3],Re([1,0,46]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var h;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var k;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var m;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var P;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$5J=D;var c;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var v;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$6J={MainThreadAuthentication:(0,w.$ev)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$ev)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$ev)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.$ev)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,w.$ev)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$ev)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$ev)("MainThreadClipboard"),MainThreadCommands:(0,w.$ev)("MainThreadCommands"),MainThreadComments:(0,w.$ev)("MainThreadComments"),MainThreadConfiguration:(0,w.$ev)("MainThreadConfiguration"),MainThreadConsole:(0,w.$ev)("MainThreadConsole"),MainThreadDebugService:(0,w.$ev)("MainThreadDebugService"),MainThreadDecorations:(0,w.$ev)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$ev)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$ev)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$ev)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$ev)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$ev)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$ev)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$ev)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$ev)("MainThreadErrors"),MainThreadTreeViews:(0,w.$ev)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$ev)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$ev)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$ev)("MainThreadLanguages"),MainThreadLogger:(0,w.$ev)("MainThreadLogger"),MainThreadMessageService:(0,w.$ev)("MainThreadMessageService"),MainThreadOutputService:(0,w.$ev)("MainThreadOutputService"),MainThreadProgress:(0,w.$ev)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$ev)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$ev)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$ev)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$ev)("MainThreadSecretState"),MainThreadStorage:(0,w.$ev)("MainThreadStorage"),MainThreadTelemetry:(0,w.$ev)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$ev)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$ev)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$ev)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$ev)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$ev)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$ev)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$ev)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$ev)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$ev)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$ev)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$ev)("MainThreadExtensionService"),MainThreadSCM:(0,w.$ev)("MainThreadSCM"),MainThreadSearch:(0,w.$ev)("MainThreadSearch"),MainThreadShare:(0,w.$ev)("MainThreadShare"),MainThreadTask:(0,w.$ev)("MainThreadTask"),MainThreadWindow:(0,w.$ev)("MainThreadWindow"),MainThreadLabelService:(0,w.$ev)("MainThreadLabelService"),MainThreadNotebook:(0,w.$ev)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$ev)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$ev)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$ev)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$ev)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$ev)("MainThreadInteractive"),MainThreadChat:(0,w.$ev)("MainThreadChat"),MainThreadInlineChat:(0,w.$ev)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$ev)("MainThreadTheming"),MainThreadTunnelService:(0,w.$ev)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$ev)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$ev)("MainThreadTimeline"),MainThreadTesting:(0,w.$ev)("MainThreadTesting"),MainThreadLocalization:(0,w.$ev)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$ev)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$ev)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$ev)("MainThreadIssueReporter")},e.$7J={ExtHostCommands:(0,w.$ev)("ExtHostCommands"),ExtHostConfiguration:(0,w.$ev)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$ev)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$ev)("ExtHostDebugService"),ExtHostDecorations:(0,w.$ev)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$ev)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$ev)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$ev)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$ev)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$ev)("ExtHostEditors"),ExtHostTreeViews:(0,w.$ev)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$ev)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$ev)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$ev)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$ev)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$ev)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$ev)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$ev)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$ev)("ExtHostStatusBar"),ExtHostShare:(0,w.$ev)("ExtHostShare"),ExtHostExtensionService:(0,w.$ev)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$ev)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$ev)("ExtHostTerminalService"),ExtHostSCM:(0,w.$ev)("ExtHostSCM"),ExtHostSearch:(0,w.$ev)("ExtHostSearch"),ExtHostTask:(0,w.$ev)("ExtHostTask"),ExtHostWorkspace:(0,w.$ev)("ExtHostWorkspace"),ExtHostWindow:(0,w.$ev)("ExtHostWindow"),ExtHostWebviews:(0,w.$ev)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$ev)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$ev)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$ev)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$ev)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$ev)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$ev)("ExtHostProgress"),ExtHostComments:(0,w.$ev)("ExtHostComments"),ExtHostSecretState:(0,w.$ev)("ExtHostSecretState"),ExtHostStorage:(0,w.$ev)("ExtHostStorage"),ExtHostUrls:(0,w.$ev)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$ev)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$ev)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$ev)("ExtHostOutputService"),ExtHosLabelService:(0,w.$ev)("ExtHostLabelService"),ExtHostNotebook:(0,w.$ev)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$ev)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$ev)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$ev)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$ev)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$ev)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$ev)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$ev)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$ev)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.$ev)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,w.$ev)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$ev)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$ev)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$ev)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$ev)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$ev)("ExtHostTheming"),ExtHostTunnelService:(0,w.$ev)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$ev)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$ev)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$ev)("ExtHostTimeline"),ExtHostTesting:(0,w.$ev)("ExtHostTesting"),ExtHostTelemetry:(0,w.$ev)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$ev)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$ev)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$6J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,h,k){if(this.a.size===0)throw new Error("No related information providers registered");const m=this.a.get(A);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(h,k)??[]}getRelatedInformation(A,h,k){return this.c.$getAiRelatedInformation(h,k)}registerRelatedInformationProvider(A,h,k){const m=this.b;return this.b++,this.a.set(m,k),this.c.$registerAiRelatedInformationProvider(m,h),new M.$8J(()=>{this.c.$unregisterAiRelatedInformationProvider(m),this.a.delete(m)})}}e.$ndc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=e.$pbc=void 0,e.$pbc=(0,w.$Bh)("IExtHostApiDeprecationService");let A=class{constructor(k,m){this.c=m,this.a=new Set,this.b=k.getProxy(C.$6J.MainThreadTelemetry)}report(k,m,P){const D=this.d(k,m);this.a.has(D)||(this.a.add(D),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:k}))}d(k,m){return`${k}-${m.identifier.value}`}};e.$qbc=A,e.$qbc=A=Ke([qe(0,F.$7L),qe(1,M.$5i)],A),e.$rbc=Object.freeze(new class{report(h,k,m){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class A{constructor(m){this.b=new Map,this.c=[],this.d=new w.$fd,this.onDidChangeSessions=this.d.event,this.f=new h,this.g=new h,this.a=m.getProxy(M.$6J.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,P,D,c={}){const v=F.$Vl.toKey(m.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${v} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const g=m.displayName||m.name;return this.a.$getSession(P,D,v,g,c)})}async getSessions(m,P,D){const c=F.$Vl.toKey(m.identifier),v=[...D].sort().join(" ");return await this.g.getOrCreate(`${c} ${v}`,async()=>{await this.a.$ensureProvider(P);const p=m.displayName||m.name;return this.a.$getSessions(P,D,c,p)})}async removeSession(m,P){const D=this.b.get(m);return D?D.provider.removeSession(P):this.a.$removeSession(m,P)}registerAuthenticationProvider(m,P,D,c){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:P,provider:D,options:c??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===m)||this.c.push({id:m,label:P});const v=D.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(m,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(m,P,c?.supportsMultipleAccounts??!1),new C.$8J(()=>{v.dispose(),this.b.delete(m);const p=this.c.findIndex(g=>g.id===m);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,P,D){const c=this.b.get(m);if(c)return Promise.resolve(c.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,P){const D=this.b.get(m);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,P){const D=this.b.get(m);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,P){return this.d.fire({provider:{id:m,label:P}}),Promise.resolve()}}e.$Xcc=A;class h{constructor(){this.a=new Map}getOrCreate(m,P){const D=this.a.get(m);if(D)return D;const c=P().finally(()=>this.a.delete(m));return this.a.set(m,c),c}}}),define(Ae[219],Re([1,0,3,17,8]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;let F=class{constructor(h,k){this.a=h.getProxy(w.$6J.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>k.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,k,m){const P=C.WorkspaceEdit.from(h,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,m?.isRefactoring??!1)}};e.$4cc=F,e.$4cc=F=Ke([qe(0,M.$7L)],F)}),define(Ae[220],Re([1,0,12,5,67,6,59,147,3,8]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class P{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=P.a++}}class D{static{this.a=0}constructor(v,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new M.$fd,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(k.$6J.MainThreadChat)}registerChatProvider(v,p,g){const t=new P(v,g);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,F.$ic)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,p){const g=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof g=="number"&&this.g.$transferChatSession(g,p)}addChatRequest(v){this.g.$addRequest(v)}sendInteractiveRequestToProvider(v,p){this.g.$sendRequestToProvider(v,p)}async $prepareChat(v,p,g){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession(p,g);if(!i)return;const s=D.a++;return this.d.set(s,i),{id:s,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(v,p,g,t){const i=this.b.get(v);if(!i)return;const s=this.d.get(p);if(!s||!i.provider.resolveRequest)return;const d=await i.provider.resolveRequest(s,g,t);if(d)return{message:typeof d.message=="string"?d.message:m.ChatReplyFollowup.from(d.message)}}async $provideWelcomeMessage(v,p){const g=this.b.get(v);if(!g||!g.provider.provideWelcomeMessage)return;const t=await g.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:i.map(s=>m.ChatReplyFollowup.from(s)))}async $provideFollowups(v,p,g){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,g))?.map(d=>m.ChatFollowup.from(d))}$removeRequest(v,p,g){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,g)}async $provideReply(v,p,g,t){const i=this.b.get(v);if(!i)return;const s=this.d.get(p);if(!s)return;const d={session:s,message:typeof g.message=="string"?g.message:m.ChatReplyFollowup.to(g.message),variables:{}};if(g.variables)for(const a of Object.keys(g.variables))d.variables[a]=g.variables[a].map(m.ChatVariable.to);const y=A.$bd.create(!1);let $;const r={report:a=>{if(!t.isCancellationRequested)if(typeof $>"u"&&($=y.elapsed()),"responseId"in a)this.g.$acceptResponseProgress(v,p,{requestId:a.responseId});else if("placeholder"in a&&"resolvedContent"in a){const E=Promise.all([this.g.$acceptResponseProgress(v,p,{placeholder:a.placeholder}),a.resolvedContent]);(0,w.$vg)(E,t).then(b=>{if(!b)return;const[S,I]=b;this.g.$acceptResponseProgress(v,p,I,S??void 0)})}else"content"in a?this.g.$acceptResponseProgress(v,p,{content:typeof a.content=="string"?a.content:m.MarkdownString.from(a.content)}):this.g.$acceptResponseProgress(v,p,a)}};let o;try{o=await i.provider.provideResponseWithProgress(d,r,t),o||(o={errorDetails:{message:(0,h.localize)(0,null)}})}catch(a){o={errorDetails:{message:(0,h.localize)(1,null,a.message),responseIsIncomplete:!0}},this.h.error(a)}try{if(s.saveState&&this.d.has(p)){const a=s.saveState();this.g.$acceptChatState(p,a)}}catch(a){this.h.warn(a)}const n={firstProgress:$??0,totalElapsed:y.elapsed()};return{errorDetails:o.errorDetails,timings:n}}async $provideSlashCommands(v,p,g){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,g))?.map(d=>({...d,kind:m.CompletionItemKind.from(d.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$fdc=D}),define(Ae[221],Re([1,0,12,6,50,3,8,7]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class k{static{this.a=0}constructor(D,c,v){this.d=c,this.e=v,this.b=new Map,this.c=D.getProxy(F.$6J.MainThreadChatAgents)}registerAgent(D,c,v,p){const g=k.a++;return this.b.set(g,{extension:D,agent:v}),this.c.$registerAgent(g,c,p),(0,M.$ic)(()=>{this.c.$unregisterAgent(g),this.b.delete(g)})}async $invokeAgent(D,c,v,p,g){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function s(){if(i)throw new Error("Only valid while executing the command")}const d=new w.$2g;g.onCancellationRequested(()=>d.complete()),setTimeout(()=>d.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,d.p);const y=t.agent({role:h.ChatMessageRole.User,content:v},{history:p.history.map(A.ChatMessage.to)},new C.$Vu($=>{s(),this.c.$handleProgressChunk(c,{content:m($.message)?$.message:$.message.value})}),g);try{return await(0,w.$vg)(Promise.resolve(y).then($=>{if($&&"followUp"in $)return{followUp:$?.followUp?.map(o=>A.ChatFollowup.from(o))}}),g)}finally{i=!0,d.complete()}}}e.$pdc=k;function m(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[222],Re([1,0,6,3,8,50,20]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class h{static{this.a=1}constructor(m,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Xl,this.b=m.getProxy(M.$6J.MainThreadChatProvider)}registerProvider(m,P,D,c){const v=h.a++;return this.c.set(v,{extension:m,provider:D}),this.b.$registerProvider(v,P,{extension:m,displayName:c.name??m.value}),(0,w.$ic)(()=>{this.b.$unregisterProvider(v),this.c.delete(v)})}async $provideChatResponse(m,P,D,c,v){const p=this.c.get(m);if(!p)return;const g=new F.$Vu(async t=>{if(v.isCancellationRequested){this.d.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return p.provider.provideChatResponse(D.map(C.ChatMessage.to),c,g,v)}allowListExtensionWhile(m,P){this.f.set(m,P),P.finally(()=>this.f.delete(m))}async requestChatResponseProvider(m,P){if(!this.f.has(m))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(m)},async makeRequest(c,v,p,g){if(!D.f.has(m))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,p);try{await D.b.$fetchResponse(m,P,t,c.map(C.ChatMessage.from),v,g)}finally{D.e.delete(t)}}}}async $handleResponseFragment(m,P){this.e.get(m)?.report(P)}}e.$kdc=h}),define(Ae[223],Re([1,0,6,3,7,8,50,12]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class k{static{this.a=0}constructor(D,c,v){this.d=c,this.e=v,this.b=new Map,this.c=D.getProxy(M.$6J.MainThreadChatSlashCommands)}registerCommand(D,c,v,p){const g=k.a++;return this.b.set(g,{extension:D,command:v}),this.c.$registerCommand(g,c,p.description),(0,w.$ic)(()=>{this.c.$unregisterCommand(g),this.b.delete(g)})}async $executeCommand(D,c,v,p,g){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT execute command because the command is not registered`);return}let i=!1;function s(){if(i)throw new Error("Only valid while executing the command")}const d=new h.$2g;g.onCancellationRequested(()=>d.complete()),setTimeout(()=>d.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,d.p);const y=t.command({role:C.ChatMessageRole.User,content:v},{history:p.history.map(F.ChatMessage.to)},new A.$Vu($=>{s(),this.c.$handleProgressChunk(c,{content:m($.message)?$.message:$.message.value})}),g);try{return await(0,h.$vg)(Promise.resolve(y).then($=>{if($&&"followUp"in $)return{followUp:$?.followUp?.map(o=>F.ChatFollowup.from(o))}}),g)}finally{i=!0,d.complete()}}}e.$ldc=k;function m(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[224],Re([1,0,6,3,9,8]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class A{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(M.$6J.MainThreadChatVariables)}async $resolveVariable(k,m,P){const D=this.b.get(k);if(D)try{const c=await D.resolver.resolve(D.data.name,{message:m},P);if(c)return c.map(F.ChatVariable.from)}catch(c){(0,C.$Z)(c)}}registerVariableResolver(k,m,P,D){const c=A.a++;return this.b.set(c,{extension:k.identifier,data:{name:m,description:P},resolver:D}),this.c.$registerVariable(c,{name:m,description:P}),(0,w.$ic)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$mdc=A}),define(Ae[225],Re([1,0,3]),function(ve,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class M{constructor(F){const A=F.getProxy(w.$6J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(h){return A.$writeText(h)}})}}e.$ubc=M}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,69,44,279,2,6,4,17,105,25,46,41,59,53,58]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=void 0;let o=class{#e;#t;#i;constructor(I,u,f){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$6J.MainThreadCommands),this.d=u,this.#i=f,this.#t=I.getProxy(A.$6J.MainThreadTelemetry),this.converter=new n(this,l=>{const R=this.c.get(l);return R?.result===E.Void?R:void 0},u),this.f=[{processArgument(l){return(0,m.$$g)(l)}},{processArgument(l){return(0,F.$Xm)(l,function(R){if(P.$ks.isIRange(R))return C.Range.to(R);if(D.$js.isIPosition(R))return C.Position.to(R);if(P.$ks.isIRange(R.range)&&c.URI.isUri(R.uri))return C.location.to(R);if(R instanceof i.$Fd)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const u=this.registerCommand(!1,I.id,async(...f)=>{const l=I.args.map((B,V)=>{if(!B.validate(f[V]))throw new Error(`Invalid argument '${B.name}' when running '${I.id}', received: ${f[V]}`);return B.convert(f[V])}),R=await this.executeCommand(I.internalId,...l);return I.result.convert(R,f,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new M.$8J(()=>{u.dispose(),this.c.delete(I.id)})}registerCommand(I,u,f,l,R,B){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:f,thisArg:l,description:R,extension:B}),I&&this.#e.$registerCommand(u),new M.$8J(()=>{this.b.delete(u)&&I&&this.#e.$unregisterCommand(u)})}executeCommand(I,...u){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,u,!0)}async g(I,u,f){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,u,!1);{let l=!1;const R=(0,F.$Xm)(u,function(B){if(B instanceof M.$9J)return C.Position.from(B);if(B instanceof M.$0J)return C.Range.from(B);if(B instanceof M.$hK)return C.location.from(B);if(M.$sL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return l=!0,i.$Fd.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return l=!0,i.$Fd.wrap(B);if(B instanceof i.$Fd)return l=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(I,l?new s.$gv(R):R,f);return(0,m.$$g)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(I,u,!1);throw B}}}async h(I,u,f){const l=this.b.get(I);if(!l)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=l;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$Af)(u[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${V.args[W].name}' - ${V.args[W].description}`)}const U=y.$bd.create();try{return await R.apply(B,u)}catch(W){if(I===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(I=O.command)}if(this.d.error(W,I,l.extension?.identifier),!f)throw W;if(l.extension?.identifier){const O=this.#i.onExtensionError(l.extension.identifier,W);this.d.trace("forwarded error to extension?",O,l.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$mi)(W)),this.id=I,this.source=l.extension?.displayName??l.extension?.name}}}finally{this.j(l,I,U.elapsed())}}j(I,u,f){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new $.$_n(u),duration:f})}$executeContributedCommand(I,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const f=this.b.get(I);return f?(u=u.map(l=>this.f.reduce((R,B)=>B.processArgument(R,f.extension?.identifier),l)),this.h(I,u,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(u=>(I&&(u=u.filter(f=>f[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[u,f]of this.b){const{description:l}=f;l&&(I[u]=l)}return Promise.resolve(I)}};e.$pM=o,e.$pM=o=Ke([qe(0,g.$7L),qe(1,k.$5i),qe(2,r.$oM)],o),e.$qM=(0,p.$Bh)("IExtHostCommands");class n{constructor(I,u,f){this.d=I,this.f=u,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,u){if(!I)return;const f={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return f;const l=this.f(I.command);if(l)f.id=l.internalId,f.arguments=l.args.map((R,B)=>R.convert(I.arguments&&I.arguments[B]));else if((0,h.$Jb)(I.arguments)){const R=`${I.command}/${++this.c}`;this.b.set(R,I),u.add((0,v.$ic)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),f.$ident=R,f.id=this.delegatingCommandId,f.arguments=[R],this.g.trace("CommandsConverter#CREATE",I.command,R)}return f}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const u=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$rM=n;class a{static{this.Uri=new a("uri","Uri of a text document",I=>c.URI.isUri(I),I=>I)}static{this.Position=new a("position","A position in a text document",I=>M.$9J.isPosition(I),C.Position.from)}static{this.Range=new a("range","A range in a text document",I=>M.$0J.isRange(I),C.Range.from)}static{this.Selection=new a("selection","A selection in a text document",I=>M.$$J.isSelection(I),C.Selection.from)}static{this.Number=new a("number","",I=>typeof I=="number",I=>I)}static{this.String=new a("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=a.Arr(a.String)}static Arr(I){return new a(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,u=>Array.isArray(u)&&u.every(f=>I.validate(f)),u=>u.map(f=>I.convert(f)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",I=>I instanceof M.$rK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",I=>I instanceof M.$LL,C.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",I=>I instanceof t.$hM,C.TestItem.from)}constructor(I,u,f,l){this.name=I,this.description=u,this.validate=f,this.convert=l}optional(){return new a(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,u){return new a(I??this.name,u??this.description,this.validate,this.convert)}}e.$sM=a;class E{static{this.Void=new E("no result",I=>I)}constructor(I,u){this.description=I,this.convert=u}}e.$tM=E;class b{constructor(I,u,f,l,R){this.id=I,this.internalId=u,this.description=f,this.args=l,this.result=R}}e.$uM=b}),define(Ae[226],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;const c=[new m.$uM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of DocumentHighlight-instances.",p(P.DocumentHighlight.to))),new m.$uM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$sM.Uri],new m.$tM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$Ib)(t))return;class s extends D.$mK{static to(y){const $=new s(y.name,P.SymbolKind.to(y.kind),y.containerName||"",new D.$hK(i[0],P.Range.to(y.range)));return $.detail=y.detail,$.range=$.location.range,$.selectionRange=P.Range.to(y.selectionRange),$.children=y.children?y.children.map(s.to):[],$}}return t.map(s.to)})),new m.$uM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$sM.Uri,new m.$sM("options","Formatting options",t=>!0,t=>t)],new m.$tM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.$uM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$sM.Uri,m.$sM.Range,new m.$sM("options","Formatting options",t=>!0,t=>t)],new m.$tM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.$uM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$sM.Uri,m.$sM.Position,new m.$sM("ch","Trigger character",t=>typeof t=="string",t=>t),new m.$sM("options","Formatting options",t=>!0,t=>t)],new m.$tM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new m.$uM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$uM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$uM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$uM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$uM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Location-instances.",p(P.location.to))),new m.$uM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of Hover-instances.",p(P.Hover.to))),new m.$uM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$sM.Uri,new m.$sM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$9J.isPosition(i)),t=>t.map(P.Position.from))],new m.$tM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let s;for(const d of i.reverse())s=new D.$qK(P.Range.to(d),s);return s}))),new m.$uM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$sM.String.with("query","Search string")],new m.$tM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new m.$uM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new m.$uM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$sM.CallHierarchyItem],new m.$tM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new m.$uM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$sM.CallHierarchyItem],new m.$tM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new m.$uM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new m.$uM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$sM.Uri,m.$sM.Position,m.$sM.String.with("newName","The new symbol name")],new m.$tM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new m.$uM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$sM.Uri,m.$sM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$tM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new m.$uM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$sM.Uri],new m.$tM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$kL(t.tokenTypes,t.tokenModifiers)})),new m.$uM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$sM.Uri],new m.$tM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$B0)(t);if(i.type==="full")return new D.$mL(i.data,void 0)})),new m.$uM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$sM.Uri,m.$sM.Range.optional()],new m.$tM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$kL(t.tokenTypes,t.tokenModifiers)})),new m.$uM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$sM.Uri,m.$sM.Range],new m.$tM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$B0)(t);if(i.type==="full")return new D.$mL(i.data,void 0)})),new m.$uM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$sM.Uri,m.$sM.Position,m.$sM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$sM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$tM("A promise that resolves to a CompletionList-instance.",(t,i,s)=>{if(!t)return new D.$CK([]);const d=t.suggestions.map(y=>P.CompletionItem.to(y,s));return new D.$CK(d,t.incomplete)})),new m.$uM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$sM.Uri,m.$sM.Position,m.$sM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$tM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new m.$uM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$sM.Uri,m.$sM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$tM("A promise that resolves to an array of CodeLens-instances.",(t,i,s)=>p(d=>new D.$uK(P.Range.to(d.range),d.command&&s.fromInternal(d.command)))(t))),new m.$uM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$sM.Uri,new m.$sM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$0J.isRange(t),t=>D.$$J.isSelection(t)?P.Selection.from(t):P.Range.from(t)),m.$sM.String.with("kind","Code action kind to return code actions for").optional(),m.$sM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$tM("A promise that resolves to an array of Command-instances.",(t,i,s)=>p(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(d.command)}else{const y=new D.$oK(d.title,d.kind?new D.$pK(d.kind):void 0);return d.edit&&(y.edit=P.WorkspaceEdit.to(d.edit)),d.command&&(y.command=s.fromInternal(d.command)),y.isPreferred=d.isPreferred,y}})(t))),new m.$uM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$sM.Uri],new m.$tM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$IK(P.Range.to(i.range),P.Color.to(i.color))):[])),new m.$uM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$sM("color","The color to show and insert",t=>t instanceof D.$HK,P.Color.from),new m.$sM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new m.$tM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new m.$uM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$sM.Uri,m.$sM.Range],new m.$tM("A promise that resolves to an array of Inlay objects",(t,i,s)=>t.map(P.InlayHint.to.bind(void 0,s)))),new m.$uM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$sM.Uri],new m.$tM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new m.$uM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$tM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new m.$uM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$sM.Uri,m.$sM.Range,new m.$sM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$0J,t=>P.InlineValueContext.from(t))],new m.$tM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new m.$uM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$sM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,k.$UT)(t,M.Schemas.http,M.Schemas.https),t=>t),new m.$sM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),m.$sM.String.with("label","").optional()],m.$tM.Void),new m.$uM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$sM.Uri.with("resource","Resource to open"),m.$sM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new m.$sM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],m.$tM.Void),new m.$uM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$sM.Uri.with("left","Left-hand side resource of the diff editor"),m.$sM.Uri.with("right","Right-hand side resource of the diff editor"),m.$sM.String.with("title","Human readable title for the diff editor").optional(),new m.$sM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],m.$tM.Void),new m.$uM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$sM.Uri,m.$sM.Position],new m.$tM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.$uM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$sM.TypeHierarchyItem],new m.$tM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.$uM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$sM.TypeHierarchyItem],new m.$tM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new m.$uM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$sM.TestItem],m.$tM.Void),new m.$uM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$sM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$tM.Void),new m.$uM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$sM.String.with("name","The context key name"),new m.$sM("value","The context key value",()=>!0,t=>t)],m.$tM.Void),new m.$uM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$sM.Uri,m.$sM.StringArray,new m.$sM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new m.$tM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class v{static register(i){c.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",h.$Ji)}}e.$tbc=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const s of t)F.$8s(s)?i.push(P.DefinitionLink.to(s)):i.push(P.location.to(s));return i}}),define(Ae[227],Re([1,0,12,65,5,6,2,78,20,8,7,3,26]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;function v(p,g,t){const i=p.getProxy(D.$6J.MainThreadComments);class s{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$Xl,g.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const S=this.b.get(b.handle);return S?S.value:b}else if(b&&b.$mid===7){const S=this.b.get(b.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const u=b.commentUniqueId,f=I.getCommentByUniqueId(u);return f||b}else if(b&&b.$mid===11){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const u=b.text,f=b.commentUniqueId,l=I.getCommentByUniqueId(f);return l?(typeof l.body=="string"?l.body=u:l.body=new P.$vK(u),l):b}return b}})}createCommentController(b,S,I){const u=s.a++,f=new y(b,u,S,I);this.b.set(f.handle,f);const l=this.c.get(b.identifier)||[];return l.push(f),this.c.set(b.identifier,l),f.value}$createCommentThreadTemplate(b,S,I){const u=this.b.get(b);u&&u.$createCommentThreadTemplate(S,I)}async $updateCommentThreadTemplate(b,S,I){const u=this.b.get(b);u&&u.$updateCommentThreadTemplate(S,I)}$deleteCommentThread(b,S){this.b.get(b)?.$deleteCommentThread(S)}$provideCommentingRanges(b,S,I){const u=this.b.get(b);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const f=t.getDocument(A.URI.revive(S));return(0,w.$zg)(async()=>{const l=await u.commentingRangeProvider.provideCommentingRanges(f,I);let R;return Array.isArray(l)?R={ranges:l,fileComments:!1}:l?R={ranges:l.ranges||[],fileComments:l.fileComments||!1}:R=l??void 0,R}).then(l=>{let R;return l&&(R={ranges:l.ranges.map(B=>m.Range.from(B)),fileComments:l.fileComments}),R})}$toggleReaction(b,S,I,u,f){const l=this.b.get(b);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.$zg)(()=>{const R=l.getCommentThread(S);if(R){const B=R.getCommentByUniqueId(u.uniqueIdInThread);if(l!==void 0&&B&&l.reactionHandler)return l.reactionHandler(B,o(f))}return Promise.resolve(void 0)})}}class d{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,S,I,u,f,l,R,B){this.m=S,this.n=I,this.o=u,this.p=f,this.q=l,this.extensionDescription=R,this.r=B,this.handle=d.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$fd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$lc,this.l.value=new F.$jc,this.n===void 0&&(this.n=`${b}.${this.handle}`),i.$createCommentThread(S,this.handle,this.n,this.o,m.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this.i.push({dispose:()=>{i.$deleteCommentThread(S,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$jc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),S={};b("range")&&(S.range=m.Range.from(this.p)),b("label")&&(S.label=this.label),b("contextValue")&&(S.contextValue=this.contextValue??null),b("comments")&&(S.comments=this.q.map(I=>$(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&(S.collapseState=n(this.g)),b("canReply")&&(S.canReply=this.canReply),b("state")&&(S.state=a(this.h)),b("isTemplate")&&(S.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(b){for(const S of this.k){const I=S[0],u=S[1];if(b===u)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ke([(0,M.$7g)(100)],d.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(b,S,I,u){this.f=b,this.g=S,this.h=I,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,I,u,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(l){f.options=l},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(l){f.commentingRangeProvider=l},get reactionHandler(){return f.reactionHandler},set reactionHandler(l){f.reactionHandler=l},createCommentThread(l,R,B){return f.createCommentThread(l,R,B).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(b,S,I){S===void 0&&(0,c.$4E)(this.f,"fileComments");const u=new d(this.id,this.handle,void 0,b,S,I,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(b,S){const I=new d(this.id,this.handle,void 0,A.URI.revive(b),m.Range.to(S),[],this.f,!0);return I.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,S){const I=this.a.get(b);I&&(I.range=m.Range.to(S))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.e.forEach(b=>b.dispose())}}function $(E,b,S,I){let u=S.get(b);return u||(u=++E.commentHandle,S.set(b,u)),b.state!==void 0&&(0,c.$4E)(I,"commentsDraftState"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:u,body:typeof b.body=="string"?b.body:m.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(f=>r(f)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function r(E){return{label:E.label,iconPath:E.iconPath?m.$6L(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted}}function o(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?A.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1}}function n(E){if(E!==void 0)switch(E){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function a(E){if(E!==void 0)switch(E){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new s}e.$vbc=v}),define(Ae[228],Re([1,0,24,3,27,17]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(M.$6J.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const c=this,v=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){c.e(P,D,v,arguments)}})}e(P,D,c,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:k(v,this.b)}),this.c&&this.f(P,c,v)}};e.$sdc=A,e.$sdc=A=Ke([qe(0,F.$7L),qe(1,C.$kM)],A);const h=1e5;function k(m,P){const D=[];if(m.length)for(let c=0;c<m.length;c++){let v=m[c];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}D.push(v)}if(P){const c=new Error().stack;c&&D.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,w.$1m)(D);return c.length>h?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;let v=class{static{c=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(M.$6J.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=c.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const s=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(i,null);return}const y=(0,k.$1b)(d);if(y.length<=c.d){this.g.$onDidChange(i,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,y.length);const $=y.map(n=>({uri:n,rank:(0,m.$re)(n.path,"/")})),r=(0,k.$xb)($,(n,a)=>n.rank-a.rank||(0,m.$Fe)(n.uri.path,a.uri.path)),o=[];e:for(const n of r){let a;for(const E of n){const b=(0,P.$_d)(E.uri.path);if(a!==b&&(a=b,o.push(E.uri)>=c.d))break e}}this.g.$onDidChange(i,o)});return new C.$8J(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const s=Object.create(null),{provider:d,extensionDescription:y}=this.f.get(g);return await Promise.all(t.map(async $=>{try{const{uri:r,id:o}=$,n=await Promise.resolve(d.provideFileDecoration(w.URI.revive(r),i));if(!n)return;try{C.$qL.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.$4E)(y,"codiconDecoration"),s[o]=[n.propagate,n.tooltip,n.badge,n.color]}catch(a){this.h.warn(`INVALID decoration from extension '${y.identifier.value}': ${a}`)}}catch(r){this.h.error(r)}})),s}};e.$wcc=v,e.$wcc=v=c=Ke([qe(0,A.$7L),qe(1,h.$5i)],v),e.$xcc=(0,F.$Bh)("IExtHostDecorations")}),define(Ae[229],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=void 0;class v{#e;#t;#i;constructor(t,i,s,d,y,$,r,o){this.d=t,this.e=i,this.f=s,this.g=d,this.h=y,this.c=!1,this.f=Math.max(d,s),this.#i=new P.$zi(n=>$.getComparisonKey(n)),this.#e=r,this.#t=o}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let s=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),s=[t]}else if(Array.isArray(t)){s=[];let $;t=[...t].sort(v.k);for(const r of t){const[o,n]=r;if((!$||o.toString()!==$.toString())&&($&&this.#i.get($).length===0&&this.#i.delete($),$=o,s.push(o),this.#i.set(o,[])),n)this.#i.get(o)?.push(...n);else{const a=this.#i.get(o);a&&(a.length=0)}}}if(this.#t.fire(s),!this.#e)return;const d=[];let y=0;for(const $ of s){let r=[];const o=this.#i.get($);if(o)if(o.length>this.g){r=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const E of o)if(E.severity===n[a]&&r.push({...h.Diagnostic.from(E),modelVersionId:this.h($)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,o.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=o.map(n=>({...h.Diagnostic.from(n),modelVersionId:this.h($)}));if(d.push([$,r]),y+=r.length,y>this.f)break}this.#e.$changeMany(this.e,d)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[s,d]of this)t.call(i,s,d,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$nbc=v;let p=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*c.d}static _mapper(t){const i=new P.$zi;for(const s of t)i.set(s,s);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,s,d){this.j=i,this.k=s,this.l=d,this.g=new Map,this.h=new k.$jd({merge:y=>y.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,c._mapper),this.f=t.getProxy(F.$6J.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:s,f:d,h:y,j:$,k:r,l:o}=this,n=new class{$changeMany(b,S){d.$changeMany(b,S),$.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,b,S.length===0?"CLEARING":S)}$clear(b){d.$clear(b),$.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,b)}dispose(){d.dispose()}};let a;if(!i)i="_generated_diagnostic_collection_name_#"+c.c++,a=i;else if(!s.has(i))a=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do a=i+c.c++;while(s.has(a))}return new class extends v{constructor(){super(i,a,c.e,c.d,b=>o.getDocument(b)?.version,r.extUri,n,y),s.set(a,this)}dispose(){super.dispose(),s.delete(a)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,s=[];for(const d of this.g.values())d.forEach((y,$)=>{let r=i.get(y.toString());typeof r>"u"&&(r=s.length,i.set(y.toString(),r),s.push([y,[]])),s[r][1]=s[r][1].concat(...$)});return s}}m(t){let i=[];for(const s of this.g.values())s.has(t)&&(i=i.concat(s.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",s=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,d=>{},this.k.extUri,void 0,this.h);this.g.set(i,s),this.n=s}for(const[i,s]of t)this.n.set(C.URI.revive(i),s.map(h.Diagnostic.to))}};e.$obc=p,e.$obc=p=c=Ke([qe(1,m.$5i),qe(2,D.$mbc)],p)}),define(Ae[230],Re([1,0,2,3,26]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class F{constructor(h){this.a=h.getProxy(M.$6J.MainThreadDialogs)}showOpenDialog(h,k){return k?.allowUIResources&&(0,C.$4E)(h,"showLocal"),this.a.$showOpenDialog(k).then(m=>m?m.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(h){return this.a.$showSaveDialog(h).then(k=>k?w.URI.revive(k):void 0)}}e.$Dbc=F}),define(Ae[231],Re([1,0,9,2,7,3,13,21,15]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class m{static{this.a=0}constructor(D,c,v){this.d=c,this.e=v,this.b=new Map,this.c=D.getProxy(F.$6J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,c){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=m.a++;this.b.set(v,c),this.c.$registerTextContentProvider(v,D);let p;return typeof c.onDidChange=="function"&&(p=c.onDidChange(g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(v,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const s=(0,k.$Ae)(t);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(g,t)},w.$Y)})),new C.$8J(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,c){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(M.URI.revive(c),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$Ebc=m}),define(Ae[232],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class c{constructor(p,g){this.a=new w.$fd({onListenerError:D.$Z}),this.b=new w.$fd({onListenerError:D.$Z}),this.c=new w.$fd({onListenerError:D.$Z}),this.d=new w.$fd({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$jc,this.h=new Map,this.f=p.getProxy(F.$6J.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const g=this.g.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this.g.getDocument(p);if(g)return Promise.resolve(g);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const s=C.URI.revive(i);return(0,k.$uf)(this.g.getDocument(s))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged(p,g){const t=C.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(p){const g=C.URI.revive(p),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,g){const t=C.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,t){const i=C.URI.revive(p),s=this.g.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(t),s.onEvents(g);let d;g.isUndoing?d=P.TextDocumentChangeReason.Undo:g.isRedoing&&(d=P.TextDocumentChangeReason.Redo),this.c.fire((0,m.$Wm)({document:s.document,contentChanges:g.changes.map(y=>({range:h.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:d}))}setWordDefinitionFor(p,g){(0,A.$9L)(p,g)}}e.$kbc=c}),define(Ae[60],Re([1,0,51,5,6,2,4,3,101,17,106,8,14,28,13,67,66]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=void 0;class i{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor(y,$){this.h=y,this.i=$,this.a=null,this.b=new Map,this.c=new v.$zi,this.d=new M.$fd,this.e=new M.$fd,this.f=new M.$fd,this.g=new M.$fd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const $=[],r=[],o=[];if(y.removedDocuments)for(const n of y.removedDocuments){const a=F.URI.revive(n),E=this.c.get(a);E?.unref()&&(this.c.delete(a),$.push(E.value))}if(y.addedDocuments)for(const n of y.addedDocuments){const a=F.URI.revive(n.uri);let E=this.c.get(a);if(E&&a.scheme!==p.Schemas.vscodeNotebookCell&&a.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);E||(E=new i(new k.$0L(this.h.getProxy(h.$6J.MainThreadDocuments),a,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(a,E),r.push(E.value)),E.ref()}if(y.removedEditors)for(const n of y.removedEditors){const a=this.b.get(n);this.b.delete(n),a&&o.push(a)}if(y.addedEditors)for(const n of y.addedEditors){const a=F.URI.revive(n.documentUri);w.ok(this.c.has(a),`document '${a}' does not exist`),w.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const E=this.c.get(a).value,b=new P.$dM(n.id,this.h.getProxy(h.$6J.MainThreadTextEditors),this.i,new t.$T(()=>E.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(S=>D.Range.to(S)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,b)}y.newActiveEditor!==void 0&&(w.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,C.$fc)($),(0,C.$fc)(o),y.removedDocuments&&this.e.fire($),y.addedDocuments&&this.d.fire(r),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return g.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const $=this.b.get(this.a);return y?$:$?.value}allEditors(){return[...this.b.values()]}};e.$eM=s,e.$eM=s=Ke([qe(0,m.$7L),qe(1,c.$5i)],s),e.$fM=(0,A.$Bh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,100]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0,e.$Bcc=(0,A.$Bh)("IExtHostEditorTabs");class D{constructor(t,i,s){this.e=s,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new h.$ML(C.URI.revive(this.b.input.uri));case 2:return new h.$NL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new h.$OL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new h.$PL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new h.$QL(this.b.input.viewType);case 4:return new h.$RL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new h.$SL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new h.$TL;case 9:return new h.$UL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const s of t.tabs)s.isActive&&(this.d=s.id),this.c.push(new D(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(s=>s.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(s=>s.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const s=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,s),t.tabDto.isActive&&(this.d=s.tabId),s}else if(t.kind===1){const s=this.c.splice(t.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(t.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,s),s}const i=this.c.find(s=>s.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new F.$fd,this.c=new F.$fd,this.e=[],this.a=t.getProxy(M.$6J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(s=>s.apiObject))},get activeTabGroup(){const s=t.d;return(0,m.$uf)(t.e.find(y=>y.groupId===s)?.apiObject)},close:async(s,d)=>{const y=Array.isArray(s)?s:[s];return y.length?p(y[0])?this.j(y,d):this.i(y,d):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),s=new Set(t.map(n=>n.groupId)),d=(0,P.$J)(i,s),y=this.e.filter(n=>d.removed.includes(n.groupId)).map(n=>n.apiObject),$=[],r=[];this.e=t.map(n=>{const a=new c(n,()=>this.d);return d.added.includes(a.groupId)?$.push(a.apiObject):r.push(a.apiObject),a});const o=(0,m.$uf)(t.find(n=>n.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:$,closed:y,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(s=>s.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(d=>d.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const s=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(t){for(const i of this.e)for(const s of i.tabs)if(s.apiObject===t)return s}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const s=[];for(const d of t){const y=this.g(d);if(!y)throw new Error("Tab close: Invalid tab not found!");s.push(y.tabId)}return this.a.$closeTab(s,i)}async j(t,i){const s=[];for(const d of t){const y=this.h(d);if(!y)throw new Error("Group close: Invalid group not found!");s.push(y.groupId)}return this.a.$closeGroup(s,i)}};e.$Ccc=v,e.$Ccc=v=Ke([qe(0,k.$7L)],v);function p(g){return g.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$6J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,h,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const m=this.a.get(A);if(!m)throw new Error("Embedding vector provider not found");const P=await m.provideEmbeddingVector(h,k);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,h,k){const m=this.b;return this.b++,this.a.set(m,k),this.c.$registerAiEmbeddingVectorProvider(h,m),new M.$8J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(m),this.a.delete(m)})}}e.$odc=C}),define(Ae[234],Re([1,0,2,3,6,7,8,280,15,25,26,49]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;class c{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,s,d=14,y=14;for(const $ of g){let r=i?(0,k.$Oe)(i,$):0;for(r===0?s=1:s=y;r<$.length;r++)r+1===$.length?(d=y,y=9):y+=1,t.push([s,$.toUpperCase().charCodeAt(r),y]),t.push([s,$.toLowerCase().charCodeAt(r),y]),s=y;i=$,y=d}t.push([9,58,10]),t.push([10,47,12]),this.b=new h.$DY(t)}}provideDocumentLinks(g){this.c();const t=[],i=h.$EY.computeLinks({getLineContent(s){return g.lineAt(s-1).text},getLineCount(){return g.lineCount}},this.b);for(const s of i){const d=A.DocumentLink.to(s);d.target&&t.push(d)}return t}}class v{constructor(g,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(M.$6J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,s={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const d=this.h++;this.b.add(t),this.d.add(t),this.c.set(d,i);let y=2;s.isCaseSensitive&&(y+=1024),s.isReadonly&&(y+=2048),typeof i.copy=="function"&&(y+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$4E)(g,"fsChunks"),y+=4);let $;s.isReadonly&&(0,D.$Zj)(s.isReadonly)&&((0,P.$4E)(g,"readonlyMessage"),$={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(d,t,y,$).catch(o=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(o)});const r=i.onDidChangeFile(o=>{const n=[];for(const a of o){const{uri:E,type:b}=a;if(E.scheme!==t)continue;let S;switch(b){case F.FileChangeType.Changed:S=0;break;case F.FileChangeType.Created:S=1;break;case F.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:E,type:S})}this.a.$onFileSystemChange(d,n)});return(0,C.$ic)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:s,size:d,permissions:y}=g;return{type:t,ctime:i,mtime:s,size:d,permissions:y}}$stat(g,t){return Promise.resolve(this.l(g).stat(w.URI.revive(t))).then(i=>v.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(w.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(w.URI.revive(t))).then(i=>m.$Fd.wrap(i))}$writeFile(g,t,i,s){return Promise.resolve(this.l(g).writeFile(w.URI.revive(t),i.buffer,s))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(w.URI.revive(t),i))}$rename(g,t,i,s){return Promise.resolve(this.l(g).rename(w.URI.revive(t),w.URI.revive(i),s))}$copy(g,t,i,s){const d=this.l(g);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(w.URI.revive(t),w.URI.revive(i),s))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(w.URI.revive(t)))}$watch(g,t,i,s){const d=this.l(g).watch(w.URI.revive(i),s);this.f.set(t,d)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const s=this.l(g);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(w.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,s){const d=this.l(g);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const y=m.$Fd.alloc(s);return Promise.resolve(d.read(t,i,y.buffer,0,s)).then($=>y.slice(0,$))}$write(g,t,i,s){const d=this.l(g);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(t,i,s.buffer,0,s.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$$bc=v}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=void 0;let p=v=class{constructor(t,i){this.b=new Map,this.c=new P.$Pg,this.a=t.getProxy(w.$6J.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(d){try{let y;const $=s.b.get(d.scheme);return $?(await s.a.$ensureActivation(d.scheme),y=await $.impl.stat(d)):y=await s.a.$stat(d),{type:y.type,ctime:y.ctime,mtime:y.mtime,size:y.size,permissions:y.permissions===M.FilePermission.Readonly?1:void 0}}catch(y){v.e(y)}},async readDirectory(d){try{const y=s.b.get(d.scheme);return y?(await s.a.$ensureActivation(d.scheme),(await y.impl.readDirectory(d)).slice()):await s.a.$readdir(d)}catch(y){return v.e(y)}},async createDirectory(d){try{const y=s.b.get(d.scheme);return y&&!y.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d(y.impl,y.extUri,d)):await s.a.$mkdir(d)}catch(y){return v.e(y)}},async readFile(d){try{const y=s.b.get(d.scheme);return y?(await s.a.$ensureActivation(d.scheme),(await y.impl.readFile(d)).slice()):(await s.a.$readFile(d)).buffer}catch(y){return v.e(y)}},async writeFile(d,y){try{const $=s.b.get(d.scheme);return $&&!$.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d($.impl,$.extUri,$.extUri.dirname(d)),await s.c.queueFor(d).queue(()=>Promise.resolve($.impl.writeFile(d,y,{create:!0,overwrite:!0})))):await s.a.$writeFile(d,F.$Fd.wrap(y))}catch($){return v.e($)}},async delete(d,y){try{const $=s.b.get(d.scheme);return $&&!$.isReadonly?(await s.a.$ensureActivation(d.scheme),await $.impl.delete(d,{recursive:!1,...y})):await s.a.$delete(d,{recursive:!1,useTrash:!1,atomic:!1,...y})}catch($){return v.e($)}},async rename(d,y,$){try{return await s.a.$rename(d,y,{overwrite:!1,...$})}catch(r){return v.e(r)}},async copy(d,y,$){try{return await s.a.$copy(d,y,{overwrite:!1,...$})}catch(r){return v.e(r)}},isWritableFileSystem(d){const y=i.getCapabilities(d);if(typeof y=="number")return!(y&2048)}})}async d(t,i,s){const d=[];for(;!i.isEqual(s,i.dirname(s));)try{if(!((await t.stat(s)).type&M.FileType.Directory))throw C.$iL.FileExists(`Unable to create folder '${s.scheme===c.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(y){if(M.$ik(y)!==M.FileSystemProviderErrorCode.FileNotFound)throw y;d.push(i.basename(s)),s=i.dirname(s)}for(let y=d.length-1;y>=0;y--){s=i.joinPath(s,d[y]);try{await t.createDirectory(s)}catch($){if(M.$ik($)!==M.FileSystemProviderErrorCode.FileExists)throw $}}}static e(t){if(t instanceof C.$iL)throw t;if(t instanceof M.$ek)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$iL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$iL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$iL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$iL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$iL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$iL.Unavailable(t.message);default:throw new C.$iL(t.message,t.name)}if(!(t instanceof Error))throw new C.$iL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$iL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$iL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$iL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$iL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$iL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$iL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$iL.Unavailable(t.message);default:throw new C.$iL(t.message,t.name)}}addFileSystemProvider(t,i,s){return this.b.set(t,{impl:i,extUri:s?.isCaseSensitive?D.$$f:D.$ag,isReadonly:!!s?.isReadonly}),(0,m.$ic)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$$f}};e.$Qbc=p,e.$Qbc=p=v=Ke([qe(0,h.$7L),qe(1,k.$mbc)],p),e.$Rbc=(0,A.$Bh)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,37,2,3,8,7]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,c,v,p,g,t,i,s){this.a=new w.$fd,this.b=new w.$fd,this.c=new w.$fd;const d=this.h(D,v,g);this.g=0,t&&(this.g+=1),i&&(this.g+=2),s&&(this.g+=4);const y=(0,M.$rj)(g),$=typeof g=="string",r=p(o=>{if(!t)for(const n of o.created){const a=C.URI.revive(n);y(a.fsPath)&&(!$||c.getWorkspaceFolder(a))&&this.a.fire(a)}if(!i)for(const n of o.changed){const a=C.URI.revive(n);y(a.fsPath)&&(!$||c.getWorkspaceFolder(a))&&this.b.fire(a)}if(!s)for(const n of o.deleted){const a=C.URI.revive(n);y(a.fsPath)&&(!$||c.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=h.$8J.from(d,this.a,this.b,this.c,r)}h(D,c,v){const p=h.$8J.from();if(typeof v=="string")return p;const g=D.getProxy(F.$6J.MainThreadFileSystem);let t=!1;(v.pattern.includes(M.$nj)||v.pattern.includes(M.$oj))&&(t=!0);const i=Math.random();return g.$watch(c.identifier.value,i,v.baseUri,{recursive:t,excludes:[]}),h.$8J.from({dispose:()=>g.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class m{constructor(D,c,v){this.j=D,this.k=c,this.l=v,this.a=new w.$fd,this.b=new w.$fd,this.c=new w.$fd,this.d=new w.$fd,this.g=new w.$hd,this.h=new w.$hd,this.i=new w.$hd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,c,v,p,g,t){return new k(this.j,D,c,this.a.event,A.GlobPattern.from(v),p,g,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,c){switch(D){case 2:this.b.fire(Object.freeze({files:c.map(v=>({oldUri:C.URI.revive(v.source),newUri:C.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:c.map(v=>C.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:c.map(v=>C.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,c){return(v,p,g)=>{const t=function(s){v.call(p,s)};return t.extension=D,c.event(t,void 0,g)}}async $onWillRunFileOperation(D,c,v,p){switch(D){case 2:return await this.n(this.g,{files:c.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))},v,p);case 1:return await this.n(this.i,{files:c.map(g=>C.URI.revive(g.target))},v,p);case 0:case 3:return await this.n(this.h,{files:c.map(g=>C.URI.revive(g.target))},v,p)}}async n(D,c,v,p){const g=new Set,t=[];if(await D.fireAsync(c,p,async(s,d)=>{const y=Date.now(),$=await Promise.resolve(s);$ instanceof h.$fK&&(t.push([d.extension,$]),g.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-y>v&&this.k.warn("SLOW file-participant",d.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,s]of t){const{edits:d}=A.WorkspaceEdit.from(s,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(d)}return{edit:i,extensionNames:Array.from(g)}}}e.$_bc=m}),define(Ae[236],Re([1,0,6,2,3,8,7,31]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class k{static{this.a=0}constructor(c,v){this.extension=c,this.provider=v,this.handle=k.a++}}class m{constructor(c){this.session=c,this.responses=[]}}class P{static{this.a=0}constructor(c,v,p,g){this.f=p,this.g=g,this.b=new Map,this.d=new Map,this.e=c.getProxy(C.$6J.MainThreadInlineChat),v.registerApiCommand(new h.$uM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.$sM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],h.$tM.Void))}registerProvider(c,v,p){const g=new k(c,v);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,p.label,c.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function"),(0,w.$ic)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(c,v,p,g){const t=this.b.get(c);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(v)),s=F.Selection.to(p),d=await t.provider.prepareInteractiveEditorSession({document:i,selection:s},g);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=P.a++;return this.d.set(y,new m(d)),{id:y,placeholder:d.placeholder,slashCommands:d.slashCommands?.map($=>({command:$.command,detail:$.detail,refer:$.refer,executeImmediately:$.executeImmediately})),wholeRange:F.Range.from(d.wholeRange),message:d.message}}async $provideResponse(c,v,p,g){const t=this.b.get(c);if(!t)return;const i=this.d.get(v.id);if(!i)return;const s={prompt:p.prompt,selection:F.Selection.to(p.selection),wholeRange:F.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let d=!1;const y={report:o=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");d||g.isCancellationRequested||!o.message&&!o.edits||this.e.$handleProgressChunk(p.requestId,{message:o.message,edits:o.edits?.map(F.TextEdit.from)})}},$=t.provider.provideInteractiveEditorResponse(i.session,s,y,g);Promise.resolve($).finally(()=>d=!0);const r=await $;if(r){const o=i.responses.push(r)-1,n={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...n,id:o,type:"message",message:F.MarkdownString.from(r.contents)};const{edits:a}=r;if(a instanceof A.$fK)return{...n,id:o,type:"bulkEdit",edits:F.WorkspaceEdit.from(a)};if(Array.isArray(a))return{...n,id:o,type:"editorEdit",edits:a.map(F.TextEdit.from)}}}$handleFeedback(c,v,p,g){const t=this.b.get(c),i=this.d.get(v),s=i?.responses[p];if(t&&s){const d=F.InteractiveEditorResponseFeedbackKind.to(g);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,s,d)}}$releaseSession(c,v){}static h(c){return typeof c=="object"&&typeof c.contents=="object"}}e.$gdc=P}),define(Ae[237],Re([1,0,2,31]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class C{constructor(A,h,k,m,P){this.a=h,this.b=k,this.c=m;const D=new M.$uM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$sM("showOptions","Show Options",c=>!0,c=>c),new M.$sM("resource","Interactive resource Uri",c=>!0,c=>c),new M.$sM("controllerId","Notebook controller Id",c=>!0,c=>c),new M.$sM("title","Interactive editor title",c=>!0,c=>c)],new M.$tM("Notebook and input URI",c=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const v=this.a.getEditorById(c.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri),notebookEditor:v.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,h,k,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,h){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$cdc=C}),define(Ae[238],Re([1,0,3,7]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$6J.MainThreadIssueReporter)}async $getIssueReporterUri(A,h){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const m=await k.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}registerIssueUriRequestHandler(A,h){const k=A.identifier.value;return this.a.set(k,h),this.b.$registerIssueUriRequestHandler(k),new M.$8J(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$idc=C}),define(Ae[239],Re([1,0,6,3]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$6J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const h=this.b++;return this.a.$registerResourceLabelFormatter(h,A),(0,w.$ic)(()=>{this.a.$unregisterResourceLabelFormatter(h)})}}e.$vcc=C}),define(Ae[240],Re([1,0,2,24,8,7,78,3,15,44,18,16,281,21,20,6,91,88,55,59,9,12,26,150]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=void 0;class n{constructor(T,K){this.d=T,this.e=K}async provideDocumentSymbols(T,K){const G=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Ib)(Q))return Q[0]instanceof F.$nK?Q.map(C.DocumentSymbol.from):n.f(Q)}static f(T){T=T.slice(0).sort((Q,J)=>{let x=Q.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Q.location.range.end)),x});const K=[],G=[];for(const Q of T){const J={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(m.$ks.containsRange(x.range,J.range)&&!m.$ks.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class a{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,K,G){this.g=T,this.h=K,this.j=G,this.e=new s.$jbc("CodeLens"),this.f=new Map}async provideCodeLenses(T,K){const G=this.g.getDocument(T),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const J=this.e.add(Q),x=new g.$jc;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Oe=0;Oe<Q.length;Oe++)ae.lenses.push({cacheId:[J,Oe],range:C.Range.from(Q[Oe].range),command:this.h.toInternal(Q[Oe].command,x)});return ae}async resolveCodeLens(T,K){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const J=T.cacheId&&this.f.get(T.cacheId[0]);if(J)return T.command=this.h.toInternal(Q.command??a.d,J),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function E(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class b{constructor(T,K){this.d=T,this.e=K}async provideDefinition(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideDefinition(Q,J,G);return E(x)}}class S{constructor(T,K){this.d=T,this.e=K}async provideDeclaration(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideDeclaration(Q,J,G);return E(x)}}class I{constructor(T,K){this.d=T,this.e=K}async provideImplementation(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideImplementation(Q,J,G);return E(x)}}class u{constructor(T,K){this.d=T,this.e=K}async provideTypeDefinition(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Q,J,G);return E(x)}}class f{constructor(T,K){this.d=T,this.e=K}async provideHover(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideHover(Q,J,G);if(!(!x||(0,P.$Ib)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(J)),x.range||(x.range=new F.$0J(J,J)),C.Hover.from(x)}}class l{constructor(T,K){this.d=T,this.e=K}async provideEvaluatableExpression(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Q,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(T,K){this.d=T,this.e=K}async provideInlineValues(T,K,G,Q){const J=this.d.getDocument(T),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class B{constructor(T,K){this.d=T,this.e=K}async provideDocumentHighlights(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Q,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(T,K){this.d=T,this.e=K}async provideLinkedEditingRanges(T,K,G){const Q=this.d.getDocument(T),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Q,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Fb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(T,K){this.d=T,this.e=K}async provideReferences(T,K,G,Q){const J=this.d.getDocument(T),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(T,K,G,Q,J,x,ae){this.g=T,this.h=K,this.j=G,this.k=Q,this.l=J,this.m=x,this.n=ae,this.e=new s.$jbc("CodeAction"),this.f=new Map}async provideCodeActions(T,K,G,Q){const J=this.g.getDocument(T),x=c.$ms.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Ye of this.j.getDiagnostics(T))if(x.intersection(Ye.range)&&ae.push(Ye)>W.d)break;const Oe={diagnostics:ae,only:G.only?new F.$pK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(J,x,Oe,Q);if(!(0,P.$Jb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),He=new g.$jc;this.f.set(Qe,He);const et=[];for(let Ye=0;Ye<Ue.length;Ye++){const xe=Ue[Ye];xe&&(W.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,He)})):(Oe.only&&(xe.kind?Oe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Qe,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,He),diagnostics:xe.diagnostics&&xe.diagnostics.map(C.Diagnostic.from),edit:xe.edit&&C.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:et}}async resolveCodeAction(T,K){const[G,Q]=T,J=this.e.get(G,Q);if(!J||W.o(J))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const Ue=this.f.get(G);Ue&&(Oe=this.h.toInternal(x.command,Ue))}return{edit:ae,command:Oe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class O{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,G,Q,J){this.d=T,this.e=K,this.f=G,this.g=Q,this.h=J}async prepareDocumentPaste(T,K,G,Q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(T),x=K.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new y.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Q),Q.isCancellationRequested)return;const Oe=Array.from(ae).filter(([,Ue])=>!(Ue instanceof F.$VK));return C.DataTransfer.from(Oe)}async providePasteEdits(T,K,G,Q,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ae,Oe,J);if(Ue)return{label:Ue.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(T,K){this.d=T,this.e=K}async provideDocumentFormattingEdits(T,K,G){const Q=this.d.getDocument(T),J=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeFormattingEdits(T,K,G,Q){const J=this.d.getDocument(T),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,K,G,Q){(0,D.$tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(T),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Z{constructor(T,K){this.d=T,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,K,G,Q,J){const x=this.d.getDocument(T),ae=C.Position.to(K),Oe=await this.e.provideOnTypeFormattingEdits(x,ae,G,Q,J);if(Array.isArray(Oe))return Oe.map(C.TextEdit.from)}}class ye{constructor(T,K){this.e=T,this.f=K,this.d=new s.$jbc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,K){const G=await this.e.provideWorkspaceSymbols(T,K);if(!(0,P.$Jb)(G))return{symbols:[]};const Q=this.d.add(G),J={cacheId:Q,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return J}async resolveWorkspaceSymbol(T,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,M.$Ym)(T,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,K,G){this.d=T,this.e=K,this.f=G}async provideRenameEdits(T,K,G,Q){const J=this.d.getDocument(T),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Oe=De.g(ae);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(T,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),J=C.Position.to(K);try{const x=await this.e.prepareRename(Q,J,G);let ae,Oe;if(F.$0J.isRange(x)?(ae=x,Oe=Q.getText(x)):(0,D.$lf)(x)&&(ae=x.range,Oe=x.placeholder),!ae||!Oe)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Oe}}catch(x){const ae=De.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Pe{constructor(T,K){this.resultId=T,this.tokens=K}}class Y{constructor(T,K){this.f=T,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,K,G){const Q=this.f.getDocument(T),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,J.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return J&&this.d.delete(K),x?(x=Y.h(x),this.o(Y.n(J,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return Y.j(T)?Y.k(T)?T:new F.$mL(new Uint32Array(T.data),T.resultId):Y.l(T)?Y.m(T)?T:new F.$oL(T.edits.map(K=>new F.$nL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const K of T.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(T,K){if(!Y.j(K)||!T||!T.tokens)return K;const G=T.tokens,Q=G.length,J=K.data,x=J.length;let ae=0;const Oe=Math.min(Q,x);for(;ae<Oe&&G[ae]===J[ae];)ae++;if(ae===Q&&ae===x)return new F.$oL([],K.resultId);let Ue=0;const Qe=Oe-ae;for(;Ue<Qe&&G[Q-Ue-1]===J[x-Ue-1];)Ue++;return new F.$oL([{start:ae,deleteCount:Q-ae-Ue,data:J.subarray(ae,x-Ue)}],K.resultId)}o(T,K){if(Y.j(T)){const G=this.e++;return this.d.set(G,new Pe(T.resultId,T.data)),(0,t.$A0)({id:G,type:"full",data:T.data})}if(Y.l(T)){const G=this.e++;return Y.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(T.resultId)),(0,t.$A0)({id:G,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeSemanticTokens(T,K,G){const Q=this.d.getDocument(T),J=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return J?this.f(J):null}f(T){return(0,t.$A0)({id:0,type:"full",data:T.data})}}class Ee{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,K,G,Q,J){this.f=T,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new s.$jbc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,K,G,Q){const J=this.f.getDocument(T),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new F.$0J(x,x),Oe=ae.with({end:x}),Ue=new d.$bd,Qe=await this.h.provideCompletionItems(J,x,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new F.$CK(Qe):Qe,et=Ee.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ye=new g.$jc;this.e.set(et,Ye);const xe=[],it={x:et,b:xe,a:{replace:C.Range.from(ae),insert:C.Range.from(Oe)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const ze=He.items[tt],st=this.l(ze,[et,tt],Oe,ae);xe.push(st)}return it}async resolveCompletionItem(T,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const Q=this.l(G,T),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,T);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,M.$Zm)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K,G,Q){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,J),ae={x:K,a:T.label,b:T.kind!==void 0?C.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(C.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:C.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=T.textEdit.newText):typeof T.insertText=="string"?ae.h=T.insertText:T.insertText instanceof F.$gK&&(ae.h=T.insertText.value,ae.i|=4);let Oe;return T.textEdit?Oe=T.textEdit.range:T.range&&(Oe=T.range),F.$0J.isRange(Oe)?ae.j=C.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!Q?.isEqual(Oe.replacing))&&(ae.j={insert:C.Range.from(Oe.inserting),replace:C.Range.from(Oe.replacing)}),ae}}class ce{async provideInlineCompletions(T,K,G,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,K,G){}handlePartialAccept(T,K,G){}}class $e extends ce{constructor(T,K,G,Q){super(),this.f=T,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$3E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$3E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,K,G,Q){const J=this.g.getDocument(T),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Oe=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Oe}),items:Oe.map((Ye,xe)=>{let it;Ye.command&&(He||(He=new g.$jc),it=this.j.toInternal(Ye.command,He));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(He||(He=new g.$jc),this.j.toInternal(Ye,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,K,G){const Q=this.d.get(T)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(T,K,G){const Q=this.d.get(T)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const K=this.e++;return this.d.set(K,T),K}disposeReferenceId(T){const K=this.d.get(T);return this.d.delete(T),K}get(T){return this.d.get(T)}}class z{constructor(T,K){this.e=T,this.f=K,this.d=new s.$jbc("SignatureHelp")}async provideSignatureHelp(T,K,G,Q){const J=this.e.getDocument(T),x=C.Position.to(K),ae=this.g(G),Oe=await this.f.provideSignatureHelp(J,x,Q,ae);if(Oe){const Ue=this.d.add([Oe]);return{...C.SignatureHelp.from(Oe),id:Ue}}}g(T){let K;if(T.activeSignatureHelp){const G=C.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...T,activeSignatureHelp:K}}releaseSignatureHelp(T){this.d.delete(T)}}class q{constructor(T,K,G,Q,J){this.f=T,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new s.$jbc("InlayHints"),this.e=new Map}async provideInlayHints(T,K,G){const Q=this.f.getDocument(T),J=C.Range.to(K),x=await this.h.provideInlayHints(Q,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new g.$jc);const Oe={hints:[],cacheId:ae};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],J)&&Oe.hints.push(this.m(x[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Oe}async resolveInlayHint(T,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(K&&!K.contains(T.position))}m(T,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(T.tooltip),position:C.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(C.TextEdit.from),kind:T.kind&&C.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),F.$hK.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Q}}class ue{constructor(T,K){this.e=T,this.f=K,this.d=new s.$jbc("DocumentLink")}async provideLinks(T,K){const G=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const J=this.d.add(Q),x={links:[],cacheId:J};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Oe=C.DocumentLink.from(Q[ae]);Oe.cacheId=[J,ae],x.links.push(Oe)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class we{constructor(T,K){this.d=T,this.e=K}async provideColors(T,K){const G=this.d.getDocument(T),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(T,K,G){const Q=this.d.getDocument(T),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class be{constructor(T,K){this.d=T,this.e=K}async provideFoldingRanges(T,K,G){const Q=this.d.getDocument(T),J=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class ge{constructor(T,K,G){this.d=T,this.e=K,this.f=G}async provideSelectionRanges(T,K,G){const Q=this.d.getDocument(T),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,J,G);if(!(0,P.$Jb)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Oe=0;Oe<J.length;Oe++){const Ue=[];ae.push(Ue);let Qe=J[Oe],He=x[Oe];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ae}}class ke{constructor(T,K){this.f=T,this.g=K,this.d=new i.$_L(""),this.e=new Map}async prepareSession(T,K,G){const Q=this.f.getDocument(T),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideCallsTo(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(J)return J.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(J)return J.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(T){this.e.delete(T)}h(T,K){const G=this.e.get(T),Q=C.CallHierarchyItem.from(K,T,G.size.toString(36));return G.set(Q._itemId,K),Q}j(T,K){return this.e.get(T)?.get(K)}}class re{constructor(T,K){this.f=T,this.g=K,this.d=new i.$_L(""),this.e=new Map}async prepareSession(T,K,G){const Q=this.f.getDocument(T),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideSupertypes(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Q,G);if(J)return J.map(x=>this.h(T,x))}async provideSubtypes(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Q,G);if(J)return J.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,K){const G=this.e.get(T),Q=C.TypeHierarchyItem.from(K,T,G.size.toString(36));return G.set(Q._itemId,K),Q}j(T,K){return this.e.get(T)?.get(K)}}class he{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,G,Q,J){this.d=T,this.e=K,this.f=G,this.g=Q,this.h=J}async provideDocumentOnDropEdits(T,K,G,Q,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ae,Oe,J);if(Ue)return{label:Ue.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(T,K){this.d=T,this.e=K}async provideMappedEdits(T,K,G,Q){const J=w.URI.revive(T),x=this.d.getDocument(J),ae={selections:G.selections.map(Ue=>C.Selection.to(Ue)),related:G.related.map(Ue=>({uri:w.URI.revive(Ue.uri),range:C.Range.to(Ue.range)}))},Oe=await this.e.provideMappedEdits(x,K,ae,Q);return Oe?C.WorkspaceEdit.from(Oe):null}}class oe{constructor(T,K){this.adapter=T,this.extension=K}}class fe{static{this.d=0}constructor(T,K,G,Q,J,x,ae,Oe){this.g=K,this.h=G,this.j=Q,this.k=J,this.l=x,this.m=ae,this.n=Oe,this.f=new Map,this.e=T.getProxy(h.$6J.MainThreadLanguageFeatures)}o(T,K){return C.DocumentSelector.from(T,this.g,K)}p(T){return new F.$8J(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return fe.d++}async t(T,K,G,Q,J,x=!1){const ae=this.f.get(T);if(!ae||!(ae.adapter instanceof K))return Q;const Oe=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Qe=>{(0,y.$2)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),v.CancellationToken.isCancellationToken(J)?(0,$.$wg)(Ue,J):Ue}u(T,K){const G=this.q();return this.f.set(G,new oe(T,K)),G}static w(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,K,G,Q){const J=this.u(new n(this.h,G),T),x=Q&&Q.label||fe.w(T);return this.e.$registerDocumentSymbolProvider(J,this.o(K,T),x),this.p(J)}$provideDocumentSymbols(T,K,G){return this.t(T,n,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(T,K,G){const Q=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new a(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(Q,this.o(K,T),J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(J));x=F.$8J.from(x,ae)}return x}$provideCodeLenses(T,K,G){return this.t(T,a,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(T,K,G){return this.t(T,a,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(T,K){this.t(T,a,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(T,K,G){const Q=this.u(new b(this.h,G),T);return this.e.$registerDefinitionSupport(Q,this.o(K,T)),this.p(Q)}$provideDefinition(T,K,G,Q){return this.t(T,b,J=>J.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(T,K,G){const Q=this.u(new S(this.h,G),T);return this.e.$registerDeclarationSupport(Q,this.o(K,T)),this.p(Q)}$provideDeclaration(T,K,G,Q){return this.t(T,S,J=>J.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(T,K,G){const Q=this.u(new I(this.h,G),T);return this.e.$registerImplementationSupport(Q,this.o(K,T)),this.p(Q)}$provideImplementation(T,K,G,Q){return this.t(T,I,J=>J.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(T,K,G){const Q=this.u(new u(this.h,G),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,T)),this.p(Q)}$provideTypeDefinition(T,K,G,Q){return this.t(T,u,J=>J.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(T,K,G,Q){const J=this.u(new f(this.h,G),T);return this.e.$registerHoverProvider(J,this.o(K,T)),this.p(J)}$provideHover(T,K,G,Q){return this.t(T,f,J=>J.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,K,G,Q){const J=this.u(new l(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,T)),this.p(J)}$provideEvaluatableExpression(T,K,G,Q){return this.t(T,l,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(T,K,G,Q){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,G),T);this.e.$registerInlineValuesProvider(x,this.o(K,T),J);let ae=this.p(x);if(J!==void 0){const Oe=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(J));ae=F.$8J.from(ae,Oe)}return ae}$provideInlineValues(T,K,G,Q,J){return this.t(T,R,x=>x.provideInlineValues(w.URI.revive(K),G,Q,J),void 0,J)}registerDocumentHighlightProvider(T,K,G){const Q=this.u(new B(this.h,G),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,T)),this.p(Q)}$provideDocumentHighlights(T,K,G,Q){return this.t(T,B,J=>J.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,K,G){const Q=this.u(new V(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,T)),this.p(Q)}$provideLinkedEditingRanges(T,K,G,Q){return this.t(T,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.y(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,K,G){const Q=this.u(new U(this.h,G),T);return this.e.$registerReferenceSupport(Q,this.o(K,T)),this.p(Q)}$provideReferences(T,K,G,Q,J){return this.t(T,U,x=>x.provideReferences(w.URI.revive(K),G,Q,J),void 0,J)}registerCodeActionProvider(T,K,G,Q){const J=new g.$jc,x=this.u(new W(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(K,T),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.w(T),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(T,K,G,Q,J){return this.t(T,W,x=>x.provideCodeActions(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCodeAction(T,K,G){return this.t(T,W,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(T,K){this.t(T,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(T,K,G){const Q=this.u(new N(this.h,G),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,K,G,Q){return this.t(T,N,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.u(new ee(this.h,G),T);return this.e.$registerRangeFormattingSupport(J,this.o(K,T),T.identifier,T.displayName||T.name,Q),this.p(J)}$provideDocumentRangeFormattingEdits(T,K,G,Q,J){return this.t(T,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}$provideDocumentRangesFormattingEdits(T,K,G,Q,J){return this.t(T,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}registerOnTypeFormattingEditProvider(T,K,G,Q){const J=this.u(new Z(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,T),Q,T.identifier),this.p(J)}$provideOnTypeFormattingEdits(T,K,G,Q,J,x){return this.t(T,Z,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,J,x),void 0,x)}registerWorkspaceSymbolProvider(T,K){const G=this.u(new ye(K,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,K,G){return this.t(T,ye,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,K,G){return this.t(T,ye,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(T,K){this.t(T,ye,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(T,K,G){const Q=this.u(new De(this.h,G,this.l),T);return this.e.$registerRenameSupport(Q,this.o(K,T),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(T,K,G,Q,J){return this.t(T,De,x=>x.provideRenameEdits(w.URI.revive(K),G,Q,J),void 0,J)}$resolveRenameLocation(T,K,G,Q){return this.t(T,De,J=>J.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,K,G,Q){const J=this.u(new Y(this.h,G),T),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,T),Q,x);let ae=this.p(J);if(x){const Oe=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ae=F.$8J.from(ae,Oe)}return ae}$provideDocumentSemanticTokens(T,K,G,Q){return this.t(T,Y,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(T,K){this.t(T,Y,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,K,G,Q){const J=this.u(new le(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,T),Q),this.p(J)}$provideDocumentRangeSemanticTokens(T,K,G,Q){return this.t(T,le,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(T,K,G,Q){const J=this.u(new Ee(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(J,this.o(K,T),Q,Ee.supportsResolving(G),T.identifier),this.p(J)}$provideCompletionItems(T,K,G,Q,J){return this.t(T,Ee,x=>x.provideCompletionItems(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCompletionItem(T,K,G){return this.t(T,Ee,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(T,K){this.t(T,Ee,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(T,K,G,Q){const J=new $e(T,this.h,G,this.j.converter),x=this.u(J,T);return this.e.$registerInlineCompletionsSupport(x,this.o(K,T),J.supportsHandleEvents,p.$Vl.toKey(T.identifier.value),Q?.yieldTo?.map(ae=>p.$Vl.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(T,K,G,Q,J){return this.t(T,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,Q,J),void 0,J)}$handleInlineCompletionDidShow(T,K,G,Q){this.t(T,ce,async J=>{J.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,K,G,Q){this.t(T,ce,async J=>{J.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(T,K){this.t(T,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(T,K,G,Q){const J=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.u(new z(this.h,G),T);return this.e.$registerSignatureHelpProvider(x,this.o(K,T),J),this.p(x)}$provideSignatureHelp(T,K,G,Q,J){return this.t(T,z,x=>x.provideSignatureHelp(w.URI.revive(K),G,Q,J),void 0,J)}$releaseSignatureHelp(T,K){this.t(T,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(T,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new q(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(J,this.o(K,T),typeof G.resolveInlayHint=="function",Q,fe.w(T));let x=this.p(J);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(Q));x=F.$8J.from(x,ae)}return x}$provideInlayHints(T,K,G,Q){return this.t(T,q,J=>J.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(T,K,G){return this.t(T,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(T,K){this.t(T,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(T,K,G){const Q=this.u(new ue(this.h,G),T);return this.e.$registerDocumentLinkProvider(Q,this.o(K,T),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,K,G){return this.t(T,ue,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(T,K,G){return this.t(T,ue,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(T,K){this.t(T,ue,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(T,K,G){const Q=this.u(new we(this.h,G),T);return this.e.$registerDocumentColorProvider(Q,this.o(K,T)),this.p(Q)}$provideDocumentColors(T,K,G){return this.t(T,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(T,K,G,Q){return this.t(T,we,J=>J.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(T,K,G){const Q=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new be(this.h,G),T)),this.e.$registerFoldingRangeProvider(Q,this.o(K,T),T.identifier,J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=F.$8J.from(x,ae)}return x}$provideFoldingRanges(T,K,G,Q){return this.t(T,be,J=>J.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(T,K,G){const Q=this.u(new ge(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(K,T)),this.p(Q)}$provideSelectionRanges(T,K,G,Q){return this.t(T,ge,J=>J.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(T,K,G){const Q=this.u(new ke(this.h,G),T);return this.e.$registerCallHierarchyProvider(Q,this.o(K,T)),this.p(Q)}$prepareCallHierarchy(T,K,G,Q){return this.t(T,ke,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,K,G,Q){return this.t(T,ke,J=>J.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,K,G,Q){return this.t(T,ke,J=>J.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(T,K){this.t(T,ke,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(T,K,G){const Q=this.u(new re(this.h,G),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,T)),this.p(Q)}$prepareTypeHierarchy(T,K,G,Q){return this.t(T,re,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,K,G,Q){return this.t(T,re,J=>J.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,K,G,Q){return this.t(T,re,J=>J.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(T,K){this.t(T,re,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(T,K,G,Q){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,T),T));const x=(0,r.$3E)(T,"dropMetadata")&&Q?he.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,T),x,(0,r.$3E)(T,"dropMetadata")?Q:void 0),this.p(J)}$provideDocumentOnDropEdits(T,K,G,Q,J,x){return this.t(T,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,J,x)),void 0,void 0)}registerMappedEditsProvider(T,K,G){const Q=this.u(new se(this.h,G),T);return this.e.$registerMappedEditsProvider(Q,this.o(K,T)),this.p(Q)}$provideMappedEdits(T,K,G,Q,J){return this.t(T,se,x=>Promise.resolve(x.provideMappedEdits(K,G,Q,J)),null,J)}registerDocumentPasteEditProvider(T,K,G,Q){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,T),T));const x=O.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(J,this.o(K,T),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(T,K,G,Q,J){return this.t(T,O,x=>x.prepareDocumentPaste(w.URI.revive(K),G,Q,J),void 0,J)}$providePasteEdits(T,K,G,Q,J,x){return this.t(T,O,ae=>ae.providePasteEdits(K,w.URI.revive(G),Q,J,x),void 0,x)}static y(T){return{pattern:T.source,flags:T.flags}}static z(T){return{decreaseIndentPattern:fe.y(T.decreaseIndentPattern),increaseIndentPattern:fe.y(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?fe.y(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?fe.y(T.unIndentedLinePattern):void 0}}static B(T){return{beforeText:fe.y(T.beforeText),afterText:T.afterText?fe.y(T.afterText):void 0,previousLineText:T.previousLineText?fe.y(T.previousLineText):void 0,action:T.action}}static C(T){return T.map(fe.B)}static D(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(K=>F.SyntaxTokenType.toString(K)):void 0}}static E(T){return T.map(fe.D)}setLanguageConfiguration(T,K,G){const{wordPattern:Q}=G;if(Q&&(0,k.$ze)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?fe.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(T){for(const K of T)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$sbc=fe}),define(Ae[241],Re([1,0,3,8,7,29,12,6]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class k{constructor(P,D,c,v){this.c=D,this.d=c,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$6J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const c=this.c.getDocumentData(P);if(!c)throw new Error(`document '${P.toString()}' NOT found`);return c.document}async tokenAtPosition(P,D){const c=P.version,v=M.Position.from(D),p=await this.a.$tokensAtPosition(P.uri,v),g={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new C.$0J(D.line,D.character,D.line,D.character)};if(!p)return g;const t={range:M.Range.to(p.range),type:M.TokenType.to(p.type)};return!t.range.contains(D)||c!==P.version?g:t}createLanguageStatusItem(P,D,c){const v=this.f++,p=this.a,g=this.g,t=`${P.identifier.value}/${D}`;if(g.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);g.add(t);const i={selector:c,id:D,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const d=new h.$jc,y=()=>{if(s?.dispose(),!g.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,A.$Ig)(()=>{d.clear(),this.a.$setLanguageStatus(v,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?F.default.Error:i.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:i.command&&this.d.toInternal(i.command,d),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},$={dispose(){d.dispose(),s?.dispose(),p.$removeLanguageStatus(v),g.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,y()},get selector(){return i.selector},set selector(r){i.selector=r,y()},get text(){return i.text},set text(r){i.text=r,y()},get detail(){return i.detail},set detail(r){i.detail=r,y()},get severity(){return i.severity},set severity(r){i.severity=r,y()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,y()},get command(){return i.command},set command(r){i.command=r,y()},get busy(){return i.busy},set busy(r){i.busy=r,y()}};return y(),$}}e.$acc=k}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=void 0;let P=class{constructor(c,v,p){this.f=p,this.d=new Map,this.a=v.getProxy(h.$6J.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===w.$f}getMessage(c,v){const{message:p,args:g,comment:t}=v;if(this.c)return(0,M.$oe)(p,g??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const s=this.d.get(c)?.contents[i];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$oe)(s??p,g??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let v;const p=await this.g(c);if(!p){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(p),t=JSON.parse(g);v=c.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${c.identifier.value} from ${p}: ${g.message}`);return}v&&this.d.set(c.identifier.value,{contents:v,uri:p})}async g(c){if(c.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(v)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2bc=P,e.$2bc=P=Ke([qe(0,k.$kM),qe(1,m.$7L),qe(2,A.$5i)],P),e.$3bc=(0,F.$Bh)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,69]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let k=class extends w.$dj{constructor(D,c){super(c.logLevel,c.logsLocation,c.loggers.map(v=>(0,h.$$g)(v))),this.r=D.getProxy(M.$6J.MainThreadLogger)}$setLogLevel(D,c){c?this.setLogLevel(A.URI.revive(c),D):this.setLogLevel(D)}setVisibility(D,c){super.setVisibility(D,c),this.r.$setVisibility(D,c)}s(D,c,v){return new m(this.r,D,c,v)}};e.$rdc=k,e.$rdc=k=Ke([qe(0,F.$7L),qe(1,C.$kM)],k);class m extends w.$$i{constructor(D,c,v,p){super(p?.logLevel==="always"),this.r=D,this.s=c,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(c,p).then(()=>{this.u(this.n),this.m=!0})}g(D,c){const v=[[D,c]];this.m?this.u(v):this.n.push(...v)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0,e.$4bc=(0,M.$Bh)("IExtHostManagedSockets");let h=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(w.$6J.MainThreadManagedSockets)}setFactory(D,c){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(D,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const c=++this.b,v=await this.c.makeConnection(),p=new C.$jc;return this.d.set(c,new m(c,v,p)),p.add((0,C.$ic)(()=>this.d.delete(c))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),p.dispose()})),p.add(v.onDidClose(g=>{this.a.$onDidManagedSocketClose(c,g?.stack??g?.message),p.dispose()})),p.add(v.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(c,A.$Fd.wrap(g)))),c}$remoteSocketWrite(D,c){this.d.get(D)?.actual.send(c.buffer)}$remoteSocketEnd(D){const c=this.d.get(D);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$5bc=h,e.$5bc=h=Ke([qe(0,F.$7L)],h);class k{constructor(D,c){this.socketFactoryId=D,this.makeConnection=c}}class m extends C.$kc{constructor(D,c,v){super(),this.socketId=D,this.actual=c,this.B(v)}}}),define(Ae[243],Re([1,0,3,14,26]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;function F(h){return h&&h.title}let A=class{constructor(k,m){this.b=m,this.a=k.getProxy(w.$6J.MainThreadMessageService)}showMessage(k,m,P,D,c){const v={source:{identifier:k.identifier,label:k.displayName||k.name}};let p;typeof D=="string"||F(D)?p=[D,...c]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,p=c),v.useCustom&&(0,C.$4E)(k,"resolvers");const g=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:s,isCloseAffordance:d}=i;g.push({title:s,isCloseAffordance:!!d,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(m,P,v,g).then(t=>{if(typeof t=="number")return p[t]})}};e.$bcc=A,e.$bcc=A=Ke([qe(1,M.$5i)],A)}),define(Ae[244],Re([1,0,152,25,5,6,28,15,16,2,38,55,3,31,8,7,46,205,104,9,24,13]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,a,E,b,S){this.q=E,this.r=b,this.s=S,this.f=new Map,this.g=new A.$zi,this.h=new Map,this.j=new C.$fd({onListenerError:d.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$fd({onListenerError:d.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$fd({onListenerError:d.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$fd({onListenerError:d.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$jbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(c.$6J.MainThreadNotebook),this.c=n.getProxy(c.$6J.MainThreadNotebookDocuments),this.d=n.getProxy(c.$6J.MainThreadNotebookEditors),this.i=a.converter,a.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const u=I.notebookEditor?.notebookUri,f=I.cell.handle,R=this.g.get(u)?.getCell(f);if(R)return R.apiCell}if(I&&I.$mid===14){const u=I.uri,f=this.g.get(u);if(f)return f.apiNotebook}return I}}),r.A(a)}getEditorById(n){const a=this.h.get(n);if(!a)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return a}getIdByEditor(n){for(const[a,E]of this.h)if(E.apiEditor===n)return a}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,a){const E=this.g.get(n);if(!E&&!a)throw new Error(`NO notebook document for '${n}'`);return E}static t(n,a){if(!a)return;const E=a.filenamePattern.map(b=>p.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(a.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:a.displayName,filenamePattern:E,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,a,E){const b=r.a++,S=typeof E.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(b,E),this.b.$registerNotebookCellStatusBarItemProvider(b,S,a);let I;return S!==void 0&&(I=E.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(S))),new g.$8J(()=>{this.f.delete(b),this.b.$unregisterNotebookCellStatusBarItemProvider(b,S),I?.dispose()})}async createNotebookDocument(n){const a=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&p.NotebookData.from(n.content)});return m.URI.revive(a)}async openNotebookDocument(n){const a=this.g.get(n);if(a)return a.apiNotebook;const E=await this.c.$tryOpenNotebook(n),b=this.g.get(m.URI.revive(E));return(0,k.$uf)(b?.apiNotebook)}async showNotebookDocument(n,a){m.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let E;typeof a=="object"?E={position:p.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(p.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:E={preserveFocus:!1};const b=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,E),S=b&&this.h.get(b)?.apiEditor;if(S)return S;throw b?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,a,E,b){const S=this.f.get(n),I=m.URI.revive(a),u=this.g.get(I);if(!u||!S)return;const f=u.getCellFromIndex(E);if(!f)return;const l=await S.provideCellStatusBarItems(f.apiCell,b);if(!l)return;const R=new F.$jc,B=this.p.add([R]),U=(Array.isArray(l)?l:[l]).map(W=>p.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:U}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,a,E,b,S){if((0,h.$me)(a))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:a,serializer:E,options:b}),this.b.$registerNotebookSerializer(I,{id:n.identifier,location:n.extensionLocation},a,p.NotebookDocumentContentOptions.from(b),r.t(n,S)),(0,F.$ic)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(n,a,E){const b=this.w.get(n);if(!b)throw new Error("NO serializer found");const S=await b.serializer.deserializeNotebook(a.buffer,E);return new t.$gv(p.NotebookData.from(S))}async $notebookToData(n,a,E){const b=this.w.get(n);if(!b)throw new Error("NO serializer found");const S=await b.serializer.serializeNotebook(p.NotebookData.to(a.value),E);return M.$Fd.wrap(S)}async $saveNotebook(n,a,E,b,S){const I=m.URI.revive(a),u=this.w.get(n);if(!u)throw new Error("NO serializer found");const f=this.g.get(I);if(!f)throw new Error("Document NOT found");if(f.versionId!==E)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$nk((0,w.localize)(0,null,this.y(I)),6);await this.x(I,b);const l={metadata:(0,y.$4m)(f.apiNotebook.metadata,W=>!(u.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of f.apiNotebook.getCells()){const O=new g.$tL(W.kind,W.document.getText(),W.document.languageId,W.mime,u.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);O.metadata=(0,y.$4m)(W.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),l.cells.push(O)}const R=await u.serializer.serializeNotebook(l,S);await this.s.value.writeFile(I,R);const B=this.s.getFileSystemProviderExtUri(I.scheme),V=await this.s.value.stat(I);return{name:B.basename(I),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$yk({mtime:V.mtime,size:V.size}),children:void 0}}async x(n,a){const E=await this.s.value.stat(n);if(typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==P.$xk&&typeof E.mtime=="number"&&typeof E.size=="number"&&a.mtime<E.mtime&&a.etag!==P.$yk({mtime:a.mtime,size:E.size}))throw new P.$nk((0,w.localize)(1,null),3,a)}y(n){return n.scheme===$.Schemas.file?n.fsPath:n.toString()}z(n,a,E){if(this.h.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const b=new s.$Ucc(a,this.d,n,E.visibleRanges.map(p.NotebookRange.to),E.selections.map(p.NotebookRange.to),typeof E.viewColumn=="number"?p.ViewColumn.to(E.viewColumn):void 0);this.h.set(a,b)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const E of n.value.removedDocuments){const b=m.URI.revive(E),S=this.g.get(b);S&&(S.dispose(),this.g.delete(b),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(S.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===b.toString()&&this.h.delete(I.id)}if(n.value.addedDocuments){const E=[];for(const b of n.value.addedDocuments){const S=m.URI.revive(b.uri);if(this.g.has(S))throw new Error(`adding EXISTING notebook ${S} `);const I=new i.$Tcc(this.c,this.q,this.r,S,b);E.push(...b.cells.map(u=>i.$Scc.asModelAddData(I.apiNotebook,u))),this.g.get(S)?.dispose(),this.g.set(S,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this.m.fire(I.apiNotebook)}}if(n.value.addedEditors)for(const E of n.value.addedEditors){if(this.h.has(E.id))return;const b=m.URI.revive(E.documentUri),S=this.g.get(b);S&&this.z(S,E.id,E)}const a=[];if(n.value.removedEditors)for(const E of n.value.removedEditors){const b=this.h.get(E);b&&(this.h.delete(E),this.k?.id===b.id&&(this.k=void 0),a.push(b))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(b=>this.h.get(b)).filter(b=>!!b);const E=new Set;this.l.forEach(b=>E.add(b.id));for(const b of this.h.values()){const S=E.has(b.id);b._acceptVisibility(S)}this.l=[...this.h.values()].map(b=>b).filter(b=>b.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const a=v.$sM.String.with("notebookType","A notebook type"),E=new v.$uM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[a,new v.$sM("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>M.$Fd.wrap(S))],new v.$tM("Notebook Data",S=>p.NotebookData.to(S.value))),b=new v.$uM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[a,new v.$sM("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new t.$gv(p.NotebookData.from(S)))],new v.$tM("Bytes",S=>S.buffer));n.registerApiCommand(E),n.registerApiCommand(b)}}e.$Vcc=r}),define(Ae[245],Re([1,0,18,12,21,5,6,28,2,20,14,55,3,31,8,7,77,198,26,46]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;let y=class{constructor(S,I,u,f,l){this.m=I,this.n=u,this.o=f,this.q=l,this.b=new h.$zi,this.c=new h.$zi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$jbc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new F.$fd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=S.getProxy(c.$6J.MainThreadNotebookKernels);const R=new v.$uM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$sM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],v.$tM.Void);this.o.registerApiCommand(R)}createNotebookController(S,I,u,f,l,R){for(const Ee of this.j.values())if(Ee.controller.id===I&&m.$Vl.equals(S.identifier,Ee.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${S.identifier.value}, ${I}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${S.identifier}'`);let W=!1;const O=new F.$fd,N=new F.$fd,ee={id:E(S.identifier,I),notebookType:u,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:f||S.identifier.value,preloads:R?R.map(p.NotebookRendererScript.from):[]};let Z=l??U,ye;this.a.$addKernel(B,ee).catch(Ee=>{console.log(Ee),W=!0});let De=0;const Pe=()=>{if(W)return;const Ee=++De;Promise.resolve().then(()=>{Ee===De&&this.a.$updateKernel(B,ee)})},Y=new h.$zi,le={get id(){return I},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(Ee){ee.label=Ee??S.displayName??S.name,Pe()},get detail(){return ee.detail??""},set detail(Ee){ee.detail=Ee,Pe()},get description(){return ee.description??""},set description(Ee){ee.description=Ee,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(Ee){ee.supportedLanguages=Ee,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(Ee){ee.supportsExecutionOrder=Ee,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(Ee){Z=Ee??U},get interruptHandler(){return ye},set interruptHandler(Ee){ye=Ee,ee.supportsInterrupt=!!Ee,Pe()},createNotebookCellExecution(Ee){if(W)throw new Error("notebook controller is DISPOSED");if(!Y.has(Ee.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.notebook.uri.toString()}`);return V._createNotebookCellExecution(Ee,E(S.identifier,this.id))},createNotebookExecution(Ee){if((0,s.$4E)(S,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Y.has(Ee.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.uri.toString()}`);return V._createNotebookExecution(Ee,E(S.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),O.dispose(),N.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(Ee,ce){ce===g.NotebookControllerAffinity2.Hidden&&(0,s.$4E)(S,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,Ee.uri,ce)},onDidReceiveMessage:N.event,postMessage(Ee,ce){return(0,s.$4E)(S,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),Ee)},asWebviewUri(Ee){return(0,s.$4E)(S,"notebookMessaging"),(0,t.$cpb)(Ee,V.m.remote)}};return this.j.set(B,{extensionId:S.identifier,controller:le,onDidReceiveMessage:N,onDidChangeSelection:O,associatedNotebooks:Y}),le}getIdByController(S){for(const[I,u]of this.j)if(u.controller===S)return E(u.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,I){const u=this.f++,f=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(u,I);const l={dispose:()=>{this.e.delete(u),f.a.$removeKernelDetectionTask(u)}};return this.e.set(u,l),l}registerKernelSourceActionProvider(S,I,u){const f=this.h++,l=typeof u.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,R=this;this.g.set(f,u),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,I);let B;return l!==void 0&&(B=u.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(l))),{dispose:()=>{this.g.delete(f),R.a.$removeKernelSourceActionProvider(f,f),B?.dispose()}}}async $provideKernelSourceActions(S,I){const u=this.g.get(S);if(u){const f=new A.$jc;return this.i.add([f]),(await u.provideNotebookKernelSourceActions(I)??[]).map(R=>p.NotebookKernelSourceAction.from(R,this.o.converter,f))}return[]}$acceptNotebookAssociation(S,I,u){const f=this.j.get(S);if(f){const l=this.n.getNotebookDocument(k.URI.revive(I));u?f.associatedNotebooks.set(l.uri,!0):f.associatedNotebooks.delete(l.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,l.uri.toString(),u),f.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(S,I,u){const f=this.j.get(S);if(!f)return;const l=this.n.getNotebookDocument(k.URI.revive(I)),R=[];for(const B of u){const V=l.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,l.uri.toString(),R.length),await f.controller.executeHandler.call(f.controller,R,l.apiNotebook,f.controller)}catch(B){this.q.error(`NotebookController[${S}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(S,I,u){const f=this.j.get(S);if(!f)return;const l=this.n.getNotebookDocument(k.URI.revive(I));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,l.apiNotebook);else for(const R of u){const B=l.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(f.controller.interruptHandler){const R=this.c.get(l.uri);u.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(S,I,u){const f=this.j.get(S);if(!f)return;const l=this.n.getEditorById(I);f.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}$cellExecutionChanged(S,I,u){const l=this.n.getNotebookDocument(k.URI.revive(S)).getCell(I);if(l){const R=u?p.NotebookCellExecutionState.to(u):g.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:l.apiCell,state:R})}}_createNotebookCellExecution(S,I){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const l=new r(I,f,this.a);this.b.set(f.uri,l);const R=l.onDidChangeState(()=>{l.state===$.Resolved&&(l.dispose(),R.dispose(),this.b.delete(f.uri))});return l.asApiObject()}_createNotebookExecution(S,I){const u=this.n.getNotebookDocument(S.uri),f=S.getCells().find(B=>{const V=u.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const l=new n(I,u,this.a),R=l.onDidChangeState(()=>{l.state===o.Resolved&&(l.dispose(),R.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[l,R]),l.asApiObject()}};e.$0cc=y,e.$0cc=y=Ke([qe(4,P.$5i)],y);var $;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})($||($={}));class r extends A.$kc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.m=I,this.n=u,this.b=r.a++,this.c=new F.$fd,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new C.$pd),this.h=new a(10,f=>this.s(f)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const I=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new d.$gv(I))}t(){if(this.f===$.Init)throw new Error("Must call start before modifying cell output");if(this.f===$.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let I=this.m;if(S&&(I=this.m.notebook.getCellFromApiCell(S)),!I)throw new Error("INVALID cell");return I.handle}y(S){return S.map(I=>{const u=g.$wL.ensureUniqueMimeTypes(I.items,!0);return u===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:u,id:I.id,metadata:I.metadata})})}async z(S,I,u){const f=this.w(I),l=this.y((0,w.$1b)(S));return this.r({editType:i.CellExecutionUpdateType.Output,cellHandle:f,append:u,outputs:l})}async C(S,I,u){return S=g.$wL.ensureUniqueMimeTypes((0,w.$1b)(S),!0),this.r({editType:i.CellExecutionUpdateType.OutputItems,items:S.map(p.NotebookCellOutputItem.from),outputId:I.id,append:u})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(u){S.j=u,S.s([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(u){if(S.f===$.Resolved||S.f===$.Started)throw new Error("Cannot call start again");S.f=$.Started,S.c.fire(),S.s({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,f){if(S.f===$.Resolved)throw new Error("Cannot call resolve twice");S.f=$.Resolved,S.c.fire(),S.h.flush(),S.n.$completeExecution(S.b,new d.$gv({runEndTime:f,lastRunSuccess:u}))},clearOutput(u){return S.t(),S.z([],u,!1)},appendOutput(u,f){return S.t(),S.z(u,f,!0)},replaceOutput(u,f){return S.t(),S.z(u,f,!1)},appendOutputItems(u,f){return S.t(),S.C(u,f,!0)},replaceOutputItems(u,f){return S.t(),S.C(u,f,!1)}})}}var o;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(o||(o={}));class n extends A.$kc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.h=I,this.j=u,this.b=n.a++,this.c=new F.$fd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new C.$pd),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===o.Resolved||this.f===o.Started)throw new Error("Cannot call start again");this.f=o.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===o.Resolved)throw new Error("Cannot call resolve twice");this.f=o.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(S,I){this.e=S,this.f=I,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new M.$2g,this.b=Date.now(),(0,M.$Hg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>S.complete())}}function E(b,S){return`${b.value}/${S}`}e.$$cc=E}),define(Ae[246],Re([1,0,5,3,104]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class F{constructor(h,k){this.c=k,this.a=new Map,this.b=h.getProxy(M.$6J.MainThreadNotebookRenderers)}$postRendererMessage(h,k,m){const P=this.c.getEditorById(h);this.a.get(k)?.fire({editor:P.apiEditor,message:m})}createRendererMessaging(h,k){if(!h.contributes?.notebookRenderer?.some(P=>P.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(P,D,c)=>this.d(k).event(P,D,c),postMessage:(P,D)=>{C.$Ucc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const c=D&&C.$Ucc.apiEditorsToExtHost.get(D);return this.b.$postMessage(c?.id,k,P)}}}d(h){let k=this.a.get(h);return k||(k=new w.$fd({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(h)}}),this.a.set(h,k),k)}}e.$_cc=F}),define(Ae[247],Re([1,0,6,16,2,26,3]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class h{constructor(m){this.b=new Map,this.a=m.getProxy(A.$6J.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,P,D){if((0,F.$4E)(m,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,m.identifier.value),(0,w.$ic)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(m,P,D,c){const v=this.b.get(m);if(!v)throw new Error(`Unknown handler with id: ${m}`);return v.saveProfile(P,D,c)}async $readProfile(m,P,D){const c=this.b.get(m);if(!c)throw new Error(`Unknown handler with id: ${m}`);return c.readProfile((0,M.$jf)(P)?P:C.URI.revive(P),D)}}e.$ddc=h}),define(Ae[248],Re([1,0,2,3,12,8]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class A{static{this.a=0}constructor(k,m){this.d=m,this.c=new Map,this.b=k.getProxy(M.$6J.MainThreadQuickDiff)}$provideOriginalResource(k,m,P){const D=w.URI.revive(m),c=this.c.get(k);return c?(0,C.$zg)(()=>c.provideOriginalResource(D,P)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(k,m,P,D){const c=A.a++;return this.c.set(c,m),this.b.$registerQuickDiffProvider(c,F.DocumentSelector.from(k,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$edc=A}),define(Ae[249],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;function p(g,t,i){const s=g.getProxy(F.$6J.MainThreadQuickOpen);class d{constructor(S,I){this.e=new Map,this.f=0,this.a=S,this.b=I}showQuickPick(S,I,u,f=w.CancellationToken.None){this.c=void 0;const l=Promise.resolve(I),R=++this.f,B=s.$show(R,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},f),V={},U=B.then(()=>V);return Promise.race([U,l]).then(W=>{if(W===V)return;const O=(0,c.$3E)(S,"quickPickItemTooltip");return l.then(N=>{const ee=[];for(let Z=0;Z<N.length;Z++){const ye=N[Z];if(typeof ye=="string")ee.push({label:ye,handle:Z});else if(ye.kind===h.QuickPickItemKind.Separator)ee.push({type:"separator",label:ye.label});else{ye.tooltip&&!O&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=ye.iconPath?n(ye.iconPath):void 0;ee.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:O?v.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Z})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Z=>{u.onDidSelectItem(N[Z])}),s.$setItems(R,ee),B.then(Z=>{if(typeof Z=="number")return N[Z];if(Array.isArray(Z))return Z.map(ye=>N[ye])})})}).then(void 0,W=>{if(!(0,k.$2)(W))return s.$setError(R,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,I=w.CancellationToken.None){return this.d=S?.validateInput,s.$input(S,typeof this.d=="function",I).then(void 0,u=>{if(!(0,k.$2)(u))return Promise.reject(u)})}async $validateInput(S){if(!this.d)return;const I=await this.d(S);if(!I||typeof I=="string")return I;let u;switch(I.severity){case h.InputBoxValidationSeverity.Info:u=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:u}}async showWorkspaceFolderPick(S,I=w.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!u)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(l=>l.uri.toString()===u.uri.toString())}createQuickPick(S){const I=new a(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(S){const I=new E(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(S,I){this.e.get(S)?._fireDidChangeValue(I)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,I){const u=this.e.get(S);u instanceof a&&u._fireDidChangeActive(I)}$onDidChangeSelection(S,I){const u=this.e.get(S);u instanceof a&&u._fireDidChangeSelection(I)}$onDidTriggerButton(S,I){this.e.get(S)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(S,I,u){const f=this.e.get(S);f instanceof a&&f._fireDidTriggerItemButton(I,u)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class y{static{this.a=1}constructor(S,I){this.x=S,this.y=I,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$fd,this.q=new M.$fd,this.r=new M.$fd,this.s=new M.$fd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((I,u)=>{const f=I===h.$pL.Back?-1:u;this.o.set(f,I)}),this.z({buttons:S.map((I,u)=>({...n(I.iconPath),tooltip:I.tooltip,handle:I===h.$pL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const I=this.o.get(S);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$fc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(S){if(!this.v){for(const I of Object.keys(S)){const u=S[I];this.u[I]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}function $(b){if(b instanceof h.$2K)return{id:b.id};const S=o(b),I=r(b);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof I=="string"?A.URI.file(I):I}}function r(b){return typeof b=="object"&&"light"in b?b.light:b}function o(b){return typeof b=="object"&&"dark"in b?b.dark:b}function n(b){const S=$(b);let I,u;return"id"in S?u=D.ThemeIcon.asClassName(S):I=S,{iconPath:I,iconClass:u}}class a extends y{constructor(S,I){super(S.identifier,I),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$fd,this.L=[],this.M=new M.$fd,this.N=new M.$fd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((f,l)=>{this.C.set(l,f),this.D.set(f,l)});const I=(0,c.$3E)(this.O,"quickPickItemTooltip"),u=[];for(let f=0;f<S.length;f++){const l=S[f];if(l.kind===h.QuickPickItemKind.Separator)u.push({type:"separator",label:l.label});else{l.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=l.iconPath?n(l.iconPath):void 0;u.push({handle:f,label:l.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(l.tooltip):void 0,buttons:l.buttons?.map((B,V)=>({...n(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(S){const I=(0,m.$Fb)(S.map(u=>this.C.get(u)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(S){const I=(0,m.$Fb)(S.map(u=>this.C.get(u)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(S,I){const u=this.C.get(S);if(!u||!u.buttons||!u.buttons.length)return;const f=u.buttons[I];f&&this.N.fire({button:f,item:u})}}class E extends y{constructor(S,I){super(S.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new d(t,i)}e.$fcc=p}),define(Ae[250],Re([1,0,2,5,65,6,12,3,18,132,14,20,40,8,26,13]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0;function i(f){if(f)return typeof f.iconPath=="string"?w.URI.file(f.iconPath):w.URI.isUri(f.iconPath)||c.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function s(f){if(f.icon){if(w.URI.isUri(f.icon))return f.icon;if(c.ThemeIcon.isThemeIcon(f.icon))return f.icon;{const l=f.icon;return{light:l.light,dark:l.dark}}}else return}function d(f,l){if(!f.iconPath&&!l.iconPath)return 0;if(f.iconPath){if(!l.iconPath)return 1}else return-1;const R=typeof f.iconPath=="string"?f.iconPath:w.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,B=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,m.$hq)(R,B)}function y(f,l){let R=0;if(f.strikeThrough!==l.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==l.faded)return f.faded?1:-1;if(f.tooltip!==l.tooltip)return(f.tooltip||"").localeCompare(l.tooltip||"");if(R=d(f,l),R!==0)return R;if(f.light&&l.light)R=d(f.light,l.light);else{if(f.light)return 1;if(l.light)return-1}if(R!==0)return R;if(f.dark&&l.dark)R=d(f.dark,l.dark);else{if(f.dark)return 1;if(l.dark)return-1}return R}function $(f,l){if(f.command!==l.command)return f.command<l.command?-1:1;if(f.title!==l.title)return f.title<l.title?-1:1;if(f.tooltip!==l.tooltip){if(f.tooltip!==void 0&&l.tooltip!==void 0)return f.tooltip<l.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(f.arguments===l.arguments)return 0;if(f.arguments)if(l.arguments){if(f.arguments.length!==l.arguments.length)return f.arguments.length-l.arguments.length}else return 1;else return-1;for(let R=0;R<f.arguments.length;R++){const B=f.arguments[R],V=l.arguments[R];if(B!==V)return B<V?-1:1}return 0}function r(f,l){let R=(0,m.$hq)(f.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(R!==0)return R;if(f.command&&l.command)R=$(f.command,l.command);else{if(f.command)return 1;if(l.command)return-1}if(R!==0)return R;if(f.decorations&&l.decorations)R=y(f.decorations,l.decorations);else{if(f.decorations)return 1;if(l.decorations)return-1}return R}function o(f,l){for(let R=0;R<f.length;R++)if(f[R]!==l[R])return!1;return!0}function n(f,l){return f.command===l.command&&f.title===l.title&&f.tooltip===l.tooltip&&(f.arguments&&l.arguments?o(f.arguments,l.arguments):f.arguments===l.arguments)}function a(f,l){return(0,k.$sb)(f,l,n)}function E(f,l){return f===l?!0:!f||!l?!1:f.id===l.id&&f.label===l.label&&f.upstream?.id===l.upstream?.id&&f.upstream?.label===l.upstream?.label}class b{#e;#t;get value(){return this.d}set value(l){l=l??"",this.#e.$setInputBoxValue(this.l,l),this.n(l)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(l){this.#e.$setInputBoxPlaceholder(this.l,l),this.f=l}get validateInput(){return(0,p.$4E)(this.k,"scmValidation"),this.g}set validateInput(l){if((0,p.$4E)(this.k,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=l,this.#e.$setValidationProviderIsEnabled(this.l,!!l)}get enabled(){return this.h}set enabled(l){l=!!l,this.h!==l&&(this.h=l,this.#e.$setInputBoxEnablement(this.l,l))}get visible(){return this.j}set visible(l){l=!!l,this.j!==l&&(this.j=l,this.#e.$setInputBoxVisibility(this.l,l))}get document(){return(0,p.$4E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(l,R,B,V,U){this.k=l,this.l=V,this.m=U,this.d="",this.e=new M.$fd,this.f="",this.h=!0,this.j=!0,this.#t=R,this.#e=B}showValidationMessage(l,R){(0,p.$4E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,l,R)}$onInputBoxValueChange(l){this.n(l)}n(l){this.d=l,this.e.fire(l)}}e.$gcc=b;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(l){this.v=l,this.q.$updateGroupLabel(this.t,this.handle,l)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(l){this.p=l,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(l){this.f=[...l],this.k.fire()}constructor(l,R,B,V,U){this.q=l,this.s=R,this.t=B,this.u=V,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$fd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$fd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(l){return this.g.get(l)}$executeResourceCommand(l,R){const B=this.h.get(l);return B?(0,A.$zg)(()=>this.s.executeCommand(B.command,...B.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this.f].sort(r),B=(0,k.$Bb)(this.o,l,r).map(W=>{const O=W.toInsert.map(N=>{const ee=this.e++;this.g.set(ee,N);const Z=N.resourceUri;let ye;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const q=new F.$jc;ye=this.s.converter.toInternal(N.command,q),this.j.set(ee,q)}else this.h.set(ee,N.command);const De=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||De,Y=N.decorations&&i(N.decorations.dark)||De,le=[Pe,Y],Ee=N.decorations&&N.decorations.tooltip||"",ce=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[ee,Z,le,Ee,ce,$e,ie,ye],handle:ee}});return{start:W.start,deleteCount:W.deleteCount,toInsert:O}}),V=B.map(({start:W,deleteCount:O,toInsert:N})=>[W,O,N.map(ee=>ee.rawResource)]),U=B.reverse();for(const{start:W,deleteCount:O,toInsert:N}of U){const ee=N.map(ye=>ye.handle),Z=this.n.splice(W,O,...ee);for(const ye of Z)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=l,V}dispose(){this.l=!0,this.m.fire()}}class I{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(l){this.g!==l&&(this.g=l,this.#e.$updateSourceControl(this.x,{count:l}))}get quickDiffProvider(){return this.h}set quickDiffProvider(l){this.h=l;let R;(0,p.$3E)(this.y,"quickDiffProvider")&&(R=l?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!l,quickDiffLabel:R})}get historyProvider(){return(0,p.$4E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(l){(0,p.$4E)(this.y,"scmHistoryProvider"),this.j=l,this.k.value=new F.$jc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!l}),l&&(this.k.value.add(l.onDidChangeCurrentHistoryItemGroup(()=>{E(this.l,l?.currentHistoryItemGroup)||(this.l=l?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(l.onDidChangeActionButton(()=>{(0,p.$4E)(this.y,"scmActionButton"),this.m.value=new F.$jc;const R=l.actionButton!==void 0?{command:this.z.converter.toInternal(l.actionButton.command,this.m.value),description:l.actionButton.description,enabled:l.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,R??null)})))}get commitTemplate(){return this.n}set commitTemplate(l){l!==this.n&&(this.n=l,this.#e.$updateSourceControl(this.x,{commitTemplate:l}))}get acceptInputCommand(){return this.p}set acceptInputCommand(l){this.o.value=new F.$jc,this.p=l;const R=this.z.converter.toInternal(l,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:R})}get actionButton(){return(0,p.$4E)(this.y,"scmActionButton"),this.s}set actionButton(l){(0,p.$4E)(this.y,"scmActionButton"),this.q.value=new F.$jc,this.s=l;const R=l!==void 0?{command:this.z.converter.toInternal(l.command,this.q.value),secondaryCommands:l.secondaryCommands?.map(B=>B.map(V=>this.z.converter.toInternal(V,this.q.value))),description:l.description,enabled:l.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:R??null})}get statusBarCommands(){return this.u}set statusBarCommands(l){if(this.u&&l&&a(this.u,l))return;this.t.value=new F.$jc,this.u=l;const R=(l||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:R})}get selected(){return this.v}constructor(l,R,B,V,U,W,O){this.y=l,this.z=V,this.A=U,this.B=W,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$lc,this.m=new F.$lc,this.n=void 0,this.o=new F.$lc,this.p=void 0,this.q=new F.$lc,this.t=new F.$lc,this.u=void 0,this.v=!1,this.w=new M.$fd,this.onDidChangeSelection=this.w.event,this.x=I.d++,this.D=new Map,this.E=new Set,this.#e=B;const N=w.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new b(l,R,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,U,W,O,N)}createResourceGroup(l,R){const B=new S(this.#e,this.z,this.x,l,R),V=M.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,V),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const l=[],R=[];for(const[B,V]of this.D){V.dispose();const U=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});M.Event.once(B.onDidDispose)(()=>{this.E.delete(B),U.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),l.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&R.push([B.handle,W]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,l,R),this.D.clear()}eventuallyUpdateResourceStates(){const l=[];this.E.forEach(R=>{const B=R._takeResourceStateSnapshot();B.length!==0&&l.push([R.handle,B])}),l.length>0&&this.#e.$spliceResourceStates(this.x,l),this.E.clear()}getResourceGroup(l){return this.e.get(l)}setSelectionState(l){this.v=l,this.w.fire(l)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(l=>l.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$7g)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$7g)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(l,R,B,V){this.l=R,this.m=B,this.n=V,this.g=new Map,this.h=new D.$Xl,this.j=new M.$fd,this.e=l.getProxy(h.$6J.MainThreadSCM),this.f=l.getProxy(h.$6J.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const W=this.g.get(U.sourceControlHandle);if(!W)return U;const O=W.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const W=this.g.get(U.sourceControlHandle);return W?W.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const W=this.g.get(U.handle);return W||U}return U}})}createSourceControl(l,R,B,V){this.n.trace("ExtHostSCM#createSourceControl",l.identifier.value,R,B,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const U=t.d++,W=new I(l,this.m,this.e,this.l,R,B,V);this.g.set(U,W);const O=this.h.get(l.identifier)||[];return O.push(W),this.h.set(l.identifier,O),W}getLastInputBox(l){this.n.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const R=this.h.get(l.identifier),B=R&&R[R.length-1];return B&&B.inputBox}$provideOriginalResource(l,R,B){const V=w.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",l,V.toString());const U=this.g.get(l);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$zg)(()=>U.quickDiffProvider.provideOriginalResource(V,B)).then(W=>W||null)}$onInputBoxValueChange(l,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",l);const B=this.g.get(l);return B&&B.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(l,R,B,V){this.n.trace("ExtHostSCM#$executeResourceCommand",l,R,B);const U=this.g.get(l);if(!U)return Promise.resolve(void 0);const W=U.getResourceGroup(R);return W?W.$executeResourceCommand(B,V):Promise.resolve(void 0)}$validateInput(l,R,B){this.n.trace("ExtHostSCM#$validateInput",l);const V=this.g.get(l);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$zg)(()=>V.inputBox.validateInput(R,B)).then(U=>{if(!U)return Promise.resolve(void 0);const W=v.MarkdownString.fromStrict(U.message);return W?Promise.resolve([W,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this.g.get(l)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=l,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(l,R,B){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupBase(R,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(l,R,B,V){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,B,V)??void 0}async $provideHistoryItems(l,R,B,V){return(await this.g.get(l)?.historyProvider?.provideHistoryItems(R,B,V))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:s(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(l,R,B){return await this.g.get(l)?.historyProvider?.provideHistoryItemChanges(R,B)??void 0}};e.$hcc=u,e.$hcc=u=t=Ke([qe(3,P.$5i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;class F{constructor(h){this.b=new M.$fd,this.onDidChangePassword=this.b.event,this.a=h.getProxy(w.$6J.MainThreadSecretState)}async $onDidChangePassword(h){this.b.fire(h)}get(h,k){return this.a.$getPassword(h,k)}store(h,k,m){return this.a.$setPassword(h,k,m)}delete(h,k){return this.a.$deletePassword(h,k)}}e.$Ybc=F,e.$Zbc=(0,C.$Bh)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class F{static{this.a=0}constructor(h,k){this.d=k,this.c=new Map,this.b=h.getProxy(w.$6J.MainThreadShare)}async $provideShare(h,k,m){return await this.c.get(h)?.provideShare({selection:M.Range.to(k.selection),resourceUri:C.URI.revive(k.resourceUri)},m)??void 0}registerShareProvider(h,k){const m=F.a++;return this.c.set(m,k),this.b.$registerShareProvider(m,M.DocumentSelector.from(h,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.$jdc=F}),define(Ae[252],Re([1,0,7,3,154,6,8,16]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$3K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$3K("statusBarItem.warningForeground")]])}#e;#t;constructor(c,v,p,g,t,i=w.StatusBarAlignment.Left,s){if(this.i=!1,this.k="",this.q=new F.$jc,this.#e=c,this.#t=v,t&&g){this.c=(0,w.$FK)(g.identifier,t);const d=p.get(this.c);d&&(i=d.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,s=d.priority,this.j=!0,this.name=d.name,this.text=d.text,this.tooltip=d.tooltip,this.command=d.command,this.accessibilityInformation=d.accessibilityInformation)}else this.c=String(k.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(s)}u(c){if((0,h.$nf)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!k.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new F.$jc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let v;this.m?v=this.m:v=(0,C.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=k.b.get(this.o.id));const g=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,v,this.k,g,this.r?.internal,p,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$icc=k;class m{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const v={message:c};return this.b.unshift(v),this.c(),new w.$8J(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(c,v){this.e=new Map,this.a=c.getProxy(M.$6J.MainThreadStatusBar),this.b=v,this.c=new m(this)}$acceptStaticEntries(c){for(const v of c)this.e.set(v.entryId,v)}createStatusBarEntry(c,v,p,g){return new k(this.a,this.b,this.e,c,v,p,g)}setStatusBarMessage(c,v){const p=this.c.setMessage(c);let g;return typeof v=="number"?g=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new w.$8J(()=>{p.dispose(),clearTimeout(g)})}}e.$jcc=P}),define(Ae[84],Re([1,0,3,5,4]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=void 0;class F{constructor(h,k){this.c=k,this.b=new M.$fd,this.onDidChangeStorage=this.b.event,this.a=h.getProxy(w.$6J.MainThreadStorage)}registerExtensionStorageKeysToSync(h,k){this.a.$registerExtensionStorageKeysToSync(h,k)}async initializeExtensionStorage(h,k,m){const P=await this.a.$initializeExtensionStorage(h,k);let D;return P&&(D=this.d(h,k,P)),D||m}setValue(h,k,m){return this.a.$setValue(h,k,m)}$acceptValue(h,k,m){const P=this.d(h,k,m);P&&this.b.fire({shared:h,key:k,value:P})}d(h,k,m){try{return JSON.parse(m)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${h}): ${P}`)}}}e.$Mbc=F,e.$Nbc=(0,C.$Bh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=void 0,e.$Sbc=(0,w.$Bh)("IExtensionStoragePaths");let h=class{constructor(m,P,D){this.d=P,this.f=D,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(m){return A.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,P=await this.g(m);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(m){if(this.c)return A.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return A.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Tbc=h,e.$Tbc=h=Ke([qe(0,M.$kM),qe(1,C.$5i),qe(2,F.$Rbc)],h)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,12,8,31]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=e.$Vbc=e.$Ubc=void 0,e.$Ubc=(0,C.$Bh)("IExtHostTerminalService");class d{constructor(u,f,l,R){this.l=u,this._id=f,this.m=l,this.n=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(V,U=!0){B.q(),B.l.$sendText(B._id,V,U)},show(V){B.q(),B.l.$show(B._id,V)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:E(u.iconPath)??void 0,color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(u.location,f?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,f,l,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:l,color:g.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.o(u,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,f){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,f){this.h=Object.freeze({code:u,reason:f})}setDimensions(u,f){return u===this.d&&f===this.g||u===0||f===0?!1:(this.d=u,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(f=>{f!==u&&(this.b=Promise.resolve(u))})}}e.$Vbc=d;class y{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$fd,this.onProcessData=this.a.event,this.b=new w.$fd,this.d=new w.$fd,this.onDidChangeProperty=this.d.event,this.f=new w.$fd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,f){this.g.setDimensions?.({columns:u,rows:f})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let $=1,r=class extends h.$kc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,f,l){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new h.$lc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$fd,this.onDidCloseTerminal=this.H.event,this.I=new w.$fd,this.onDidOpenTerminal=this.I.event,this.J=new w.$fd,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$fd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$fd,this.onDidChangeTerminalState=this.M.event,this.N=new w.$fd,this.onDidChangeShell=this.N.event,this.O=new w.$fd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$fd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=l.getProxy(M.$6J.MainThreadTerminalService),this.y=new p.$Xkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:R=>{const B=V=>{const U=V;return this.W(U.instanceId)?.value};switch(R?.$mid){case 15:return B(R);default:{if(Array.isArray(R))for(let V=0;V<R.length&&R[V].$mid===15;V++)R[V]=B(R[V]);return R}}}}),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,f){const l=new d(this.a,(0,v.$4f)(),u,u.name),R=new y(u.pty);return l.createExtensionTerminal(u.location,this.R(u,f).resolvedExtHostIdentifier,E(u.iconPath),b(u.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(l),l.value}R(u,f){if(f=f||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const l=u.location.parentTerminal;if(l){const R=this.f.find(B=>B.value===l);R&&(f.resolvedExtHostIdentifier=R._id)}}else u.location&&typeof u.location!="object"?f.location=u.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(u,f){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const R=new y(f),B=this.S(u,R);this.h[u]=B}async $acceptActiveTerminalChanged(u){const f=this.b;if(u===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const l=this.W(u);l&&(this.b=l,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,f){const l=this.W(u);l&&this.O.fire({terminal:l.value,data:f})}async $acceptTerminalDimensions(u,f,l){const R=this.W(u);R&&R.setDimensions(f,l)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(u,f){const l=this.W(u);l&&this.P.fire({terminal:l.value,...f})}async $acceptTerminalMaximumDimensions(u,f,l){this.g.get(u)?.resize(f,l)}async $acceptTerminalTitleChange(u,f){const l=this.W(u);l&&(l.name=f)}async $acceptTerminalClosed(u,f,l){const R=this.Y(this.f,u);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(f,l),this.H.fire(B.value)}}$acceptTerminalOpened(u,f,l,R){if(f){const U=this.Y(this.f,f);if(U!==null){this.f[U]._id=u,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:F.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new d(this.a,u,B,l);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,f){this.W(u)?._setProcessId(f)}async $startExtensionTerminal(u,f){const l=this.W(u);if(!l)return{message:(0,m.localize)(0,null,u)};l.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async U=>{U===l.value&&(V.dispose(),B())})});const R=this.g.get(u);R?R.startSendingEvents(f):this.j[u]={initialDimensions:f}}S(u,f){const l=new h.$jc;l.add(f.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),l.add(f.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.y.startBuffering(u,f.onProcessData),l.add(f.onProcessExit(B=>this.U(u,B))),this.g.set(u,f);const R=this.j[u];return R&&f instanceof y&&(f.startSendingEvents(R.initialDimensions),delete this.j[u]),l}$acceptProcessAckDataEvent(u,f){this.g.get(u)?.acknowledgeDataEvent(f)}$acceptProcessInput(u,f){this.g.get(u)?.input(f)}$acceptTerminalInteraction(u){const f=this.W(u);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(u,f){this.W(u)?.setSelection(f)}$acceptProcessResize(u,f,l){try{this.g.get(u)?.resize(f,l)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(u,f){this.g.get(u)?.shutdown(f)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(f=>this.a.$sendProcessProperty(u,{type:"cwd",value:f}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new k.$8J(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,f,l){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,l),this.a.$registerProfileProvider(f,u.identifier.value),new k.$8J(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(u,f,l){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,l),this.a.$registerQuickFixProvider(u,f),new k.$8J(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,f){const l=new c.$pd().token;if(l.isCancellationRequested)return;const R=this.D.get(u);if(!R)return;const B=await R.provideTerminalQuickFixes(f,l);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new h.$jc;if(this.w.value=V,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const U=[];for(const W of B){const O=i.TerminalQuickFix.from(W,this.Q.converter,V);O&&U.push(O)}return U}async $createContributedProfileTerminal(u,f){const l=new c.$pd().token;let R=await this.C.get(u)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,f);return}this.createTerminalFromOptions(R.options,f)}}async $provideLinks(u,f){const l=this.W(u);if(!l)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const B=new c.$pd;this.G.set(u,B);const V=[],U={terminal:l.value,line:f},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async Z=>{B.token.onCancellationRequested(()=>Z({provider:ee,links:[]}));const ye=await ee.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||Z({provider:ee,links:ye})}));const O=await Promise.all(W);if(B.token.isCancellationRequested)return[];const N=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(Z=>{const ye={id:$++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return N.set(ye.id,{provider:ee.provider,link:Z}),ye}));return this.F.set(u,N),V}$activateLink(u,f){const l=this.F.get(u)?.get(f);l&&l.provider.handleTerminalLink(l.link)}U(u,f){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const l=this.h[u];l&&(l.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,f)}W(u){return this.X(this.f,u)}X(u,f){const l=this.Y(u,f);return l!==null?u[l]:null}Y(u,f){const l=u.findIndex(R=>R._id===f);return l===-1?null:l}getEnvironmentVariableCollection(u){let f=this.n.get(u.identifier.value);return f||(f=new o,this.$(u.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(u,f){const l=(0,D.$ar)(f.map),R=(0,D.$br)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(u,f.persistent,l.length===0?void 0:l,R)}$initEnvironmentVariableCollections(u){u.forEach(f=>{const l=f[0],R=new o(f[1]);this.$(l,R)})}$acceptDefaultProfile(u,f){const l=this.s;this.s=u,this.u=f,l?.path!==u.path&&this.N.fire(u.path)}$(u,f){this.n.set(u,f),f.onDidChangeCollection(()=>{this.Z(u,f)})}};e.$Wbc=r,e.$Wbc=r=Ke([qe(1,s.$qM),qe(2,A.$7L)],r);class o{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$fd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const f=this.h(u);let l=this.a.get(f);return l||(l=new n(this,u),this.a.set(f,l),l.onDidChangeCollection(()=>this.d.fire())),l}replace(u,f,l,R){this.f(u,{value:f,type:k.EnvironmentVariableMutatorType.Replace,options:l??{applyAtProcessCreation:!0},scope:R})}append(u,f,l,R){this.f(u,{value:f,type:k.EnvironmentVariableMutatorType.Append,options:l??{applyAtProcessCreation:!0},scope:R})}prepend(u,f,l,R){this.f(u,{value:f,type:k.EnvironmentVariableMutatorType.Prepend,options:l??{applyAtProcessCreation:!0},scope:R})}f(u,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const l=this.g(u,f.scope),R=this.map.get(l),B=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==f.value||R.type!==f.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const V=this.g(u,f.scope),U={variable:u,...f,options:B};this.map.set(V,U),this.d.fire()}}get(u,f){const l=this.g(u,f),R=this.map.get(l);return R?S(R):void 0}g(u,f){const l=this.h(f);return l.length?`${u}:::${l}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const f=new Map;for(const[l,R]of this.map)this.h(R.scope)===this.h(u)&&f.set(R.variable,S(R));return f}delete(u,f){const l=this.g(u,f);this.map.delete(l),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[f,l]of this.map)l.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(f);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,f){const l=this.h(f),R=this.descriptionMap.get(l);if(!R||R.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const V={description:B,scope:f};this.descriptionMap.set(l,V),this.d.fire()}}getDescription(u){const f=this.h(u);return this.descriptionMap.get(f)?.description}k(u){const f=this.h(u);this.descriptionMap.delete(f)}}class n{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,f){this.b=u,this.d=f,this.a=new w.$fd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,f,l){this.b.replace(u,f,l,this.d)}append(u,f,l){this.b.append(u,f,l,this.d)}prepend(u,f,l){this.b.prepend(u,f,l,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,f){this.b.getVariableMap(this.d).forEach((l,R)=>u.call(f,R,l,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let a=class extends r{constructor(u,f){super(!1,u,f)}createTerminal(u,f,l){throw new P.$0}createTerminalFromOptions(u,f){throw new P.$0}};e.$Xbc=a,e.$Xbc=a=Ke([qe(0,s.$qM),qe(1,A.$7L)],a);function E(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return g.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const u={...I};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[253],Re([1,0,282,12,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,57,26]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0;let r=class{constructor(U,W,O){this.k=O,this.d=new A.$fd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(v.$6J.MainThreadTesting),this.j=new l(this.g),this.h=new E(this.g),W.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ee=N,Z=ee.tests[ee.tests.length-1].item.extId;return this.f.get(s.$XI.root(Z))?.collection.tree.get(Z)?.actual??(0,g.$gM)(N)}case 18:{const{extId:ee,message:Z}=N;return{test:this.f.get(s.$XI.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(Z)}}default:return N}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await W.executeCommand("_testing.getExplorerSelection"),ee=Z=>{const ye=this.f.get(s.$XI.root(Z));if(ye)return s.$XI.isRoot(Z)?ye.controller:ye.collection.tree.get(Z)?.actual};return{include:N?.include.map(ee).filter(D.$rf)||[],exclude:N?.exclude.map(ee).filter(D.$rf)||[]}})}createTestController(U,W,O,N){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new m.$jc,Z=ee.add(new g.$jM(W,O,this.k));Z.root.label=O;const ye=new Map,De=this.g,Pe={items:Z.root.children,get label(){return O},set label(le){O=le,Z.root.label=le,De.$updateController(W,{label:O})},get refreshHandler(){return N},set refreshHandler(le){N=le,De.$updateController(W,{canRefresh:!!le})},get id(){return W},createRunProfile:(le,Ee,ce,$e,ie,z)=>{let q=(0,k.$pi)(le);for(;ye.has(q);)q++;return new R(this.g,ye,W,q,le,Ee,ce,$e,ie,z)},createTestItem(le,Ee,ce){return new g.$hM(W,le,Ee,ce)},createTestRun:(le,Ee,ce=!0)=>this.h.createTestRun(U,W,Z,le,Ee,ce),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const Ee=le instanceof Array?le:[le];this.g.$markTestRetired(Ee.map(ce=>s.$XI.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(le){Z.resolveHandler=le},get resolveHandler(){return Z.resolveHandler},dispose:()=>{ee.dispose()}};De.$registerTestController(W,O,!!N),ee.add((0,m.$ic)(()=>De.$unregisterTestController(W)));const Y={controller:Pe,collection:Z,profiles:ye,extension:U};return this.f.set(W,Y),ee.add((0,m.$ic)(()=>this.f.delete(W))),ee.add(Z.onDidGenerateDiff(le=>De.$publishDiff(W,le.map(y.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,W=F.CancellationToken.None){const O=b(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>s.$XI.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,W,O){return(0,w.$pb)(this.h.trackers,ee=>ee.id===U?ee.getCoverage(W):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,W,O,N){return(0,w.$pb)(this.h.trackers,Z=>Z.id===U?Z.getCoverage(W):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,W){this.f.get(U)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(U,W){await this.f.get(U)?.controller.refreshHandler?.(W)}$publishTestResults(U){this.results=Object.freeze(U.map(W=>(0,P.$Wm)(t.TestResults.to(W))).concat(this.results).sort((W,O)=>O.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,W){const O=this.f.get(s.$XI.fromString(U).controllerId)?.collection;O&&(await O.expand(U,W<0?1/0:W),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(y.TestsDiffOp.deserialize))}async $runControllerTests(U,W){return Promise.all(U.map(O=>this.l(O,!1,W)))}async $startContinuousRun(U,W){const O=new F.$pd(W),N=await Promise.all(U.map(ee=>this.l(ee,!0,O.token)));return!W.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),O.dispose(!0),N}async l(U,W,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:ee,profiles:Z,extension:ye}=N,De=Z.get(U.profileId);if(!De)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(D.$rf),Y=U.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(D.$rf).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const le=new i.$DL(Pe.some(ce=>ce.actual instanceof g.$iM)?void 0:Pe.map(ce=>ce.actual),Y.map(ce=>ce.actual),De,W),Ee=(0,y.$ZI)(U)&&this.h.prepareForMainThreadTestRun(le,S.fromInternal(U,N.collection),ye,O);try{return await De.runHandler(le,O),{}}catch(ce){return{error:String(ce)}}finally{Ee&&(Ee.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$5cc=r,e.$5cc=r=Ke([qe(0,p.$7L)],r);const o=1e4;var n;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(n||(n={}));class a extends m.$kc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,W,O,N){super(),this.s=U,this.u=W,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$fd),this.onEnd=this.m.event,this.j=this.B(new F.$pd(N));const ee=this.B(new M.$Sg(()=>this.y(),o));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const W=this.s.id,O=this.s.controllerId,N=(0,c.$4f)(),ee=new I(this.u,W,N),Z=Y=>(le,...Ee)=>{if(De){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.s.isIncluded(le)&&(this.C(le),Y(le,...Ee))},ye=(Y,le)=>{const Ee=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Ee.some(ce=>ce.contextValue!==void 0)&&(0,$.$4E)(this.w,"testMessageContextValue"),Y.uri&&Y.range){const ce={range:t.Range.from(Y.range),uri:Y.uri};for(const $e of Ee)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),Ee)};let De=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Y){ee.coverageProvider=Y},enqueued:Z(Y=>{this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),1)}),skipped:Z(Y=>{this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),5)}),started:Z(Y=>{this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),2)}),errored:Z((Y,le,Ee)=>{ye(Y,le),this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),6,Ee)}),failed:Z((Y,le,Ee)=>{ye(Y,le),this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,O).toString(),4,Ee)}),passed:Z((Y,le)=>{this.u.$updateTestStateInRun(W,N,s.$XI.fromExtHostTestItem(Y,this.s.controllerId).toString(),3,le)}),appendOutput:(Y,le,Ee)=>{De||(Ee&&(this.s.isIncluded(Ee)?this.C(Ee):Ee=void 0),this.u.$appendOutputToRun(W,N,C.$Fd.fromString(Y),le&&t.location.from(le),Ee&&s.$XI.fromExtHostTestItem(Ee,O).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(W,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof g.$hM))throw new d.$YL(U.id);if(this.h.has(s.$XI.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const W=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(W.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class E{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,W,O,N){return this.g(U,W,O,N)}cancelRunById(U){for(const W of this.d.values())if(W.id===U){W.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,W,O,N,ee,Z){const ye=this.d.get(N);if(ye)return ye.createRun(ee);const De=S.fromPublic(W,O,N,Z),Pe=b(N);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!N.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(le=>s.$XI.fromExtHostTestItem(le,O.root.id).toString())??[],id:De.id,include:N.include?.map(le=>s.$XI.fromExtHostTestItem(le,O.root.id).toString())??[O.root.id],persist:Z});const Y=this.g(N,De,U);return A.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),Y.dispose()}),Y.createRun(ee)}g(U,W,O,N){const ee=new a(W,this.f,O,N);return this.d.set(U,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(U)),ee}}e.$6cc=E;const b=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class S{static fromPublic(U,W,O,N){return new S(U,(0,c.$4f)(),O.include?.map(ee=>s.$XI.fromExtHostTestItem(ee,U).toString())??[U],O.exclude?.map(ee=>s.$XI.fromExtHostTestItem(ee,U).toString())??[],N,W)}static fromInternal(U,W){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,W)}constructor(U,W,O,N,ee,Z){this.controllerId=U,this.id=W,this.isPersisted=ee,this.colllection=Z,this.d=O.map(ye=>ye+"\0"),this.f=N.map(ye=>ye+"\0")}isIncluded(U){const W=s.$XI.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(W===O||W.startsWith(O))return!1;for(const O of this.d)if(W===O||W.startsWith(O))return!0;return!1}}e.$7cc=S;class I{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,W,O){this.g=U,this.h=W,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(U,W){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,W)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const W=s.$XI.parentId(U.item.extId);if(W&&this.h.has(W.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:W,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...W].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends y.$5I{constructor(){super(...arguments),this.s=new A.$fd,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,W){return{...U,revived:t.TestItem.toPlain(U.item),depth:W?W.depth+1:0,children:new Set}}p(){return new u(this.s)}}class l{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(W=>W.revived)},dispose:(0,h.$bb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class R{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,W,O,N,ee,Z,ye,De=!1,Pe=void 0,Y=!1){this.controllerId=O,this.profileId=N,this.f=ee,this.kind=Z,this.runHandler=ye,this.g=De,this._tag=Pe,this.h=Y,this.#e=U,this.#t=W,W.set(N,this);const le=B[Z];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:le,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:Y})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$8cc=R;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[254],Re([1,0,18,9,5,3,106,8,7]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class m{constructor(D,c){this.i=c,this.a=new C.$fd({onListenerError:M.$Z}),this.b=new C.$fd({onListenerError:M.$Z}),this.c=new C.$fd({onListenerError:M.$Z}),this.d=new C.$fd({onListenerError:M.$Z}),this.f=new C.$fd({onListenerError:M.$Z}),this.g=new C.$fd({onListenerError:M.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(F.$6J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const c=this.i.allEditors();return D?c:c.map(v=>v.value)}async showTextDocument(D,c,v){let p;typeof c=="number"?p={position:h.ViewColumn.from(c),preserveFocus:v}:typeof c=="object"?p={position:h.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?h.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:p={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(D.uri,p),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,c){return new A.$bM(this.h,D,c).value}$acceptEditorPropertiesChanged(D,c){const v=this.i.getEditor(D);if(!v)throw new Error("unknown text editor");if(c.options&&v._acceptOptions(c.options),c.selections){const p=c.selections.selections.map(h.Selection.to);v._acceptSelections(p)}if(c.visibleRanges){const p=w.$Fb(c.visibleRanges.map(h.Range.to));v._acceptVisibleRanges(p)}if(c.options&&this.b.fire({textEditor:v.value,options:{...c.options,lineNumbers:h.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const p=k.TextEditorSelectionChangeKind.fromValue(c.selections.source),g=c.selections.selections.map(h.Selection.to);this.a.fire({textEditor:v.value,selections:g,kind:p})}if(c.visibleRanges){const p=w.$Fb(c.visibleRanges.map(h.Range.to));this.c.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const c in D){const v=this.i.getEditor(c);if(!v)throw new Error("Unknown text editor");const p=h.ViewColumn.to(D[c]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this.d.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$kcc=m}),define(Ae[255],Re([1,0,2,4,3,6,7,8,20,16]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=void 0,e.$Ycc=(0,M.$Bh)("IExtHostTimeline");class P{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(C.$6J.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&k.$Vl.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:w.URI.revive(g.uri);return this.c.get(g.source)?.get(D(i))?.get(g.handle)}else return;return g}})}async $getTimeline(v,p,g,t){return this.b.get(v)?.provider.provideTimeline(w.URI.revive(p),g,t)}registerTimelineProvider(v,p,g,t){const i=new F.$jc,s=this.d(p.id,t,i).bind(this);let d;p.onDidChange&&(d=p.onDidChange($=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...$,id:p.id}),this));const y=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline($,r,o){r?.resetCache&&(i.clear(),y.get(p.id)?.clear());const n=await p.provideTimeline($,r,o);if(n==null)return;const a=s($,r);return{...n,source:p.id,items:n.items.map(a)}},dispose(){for(const $ of y.values())$.get(p.id)?.clear();d?.dispose(),i.dispose()}},g)}d(v,p,g){return(t,i)=>{let s;if(i?.cacheResults){let d=this.c.get(v);d===void 0&&(d=new Map,this.c.set(v,d));const y=D(t);s=d.get(y),s===void 0&&(s=new Map,d.set(y,s))}return d=>{const{iconPath:y,...$}=d,r=`${v}|${d.id??d.timestamp}`;s?.set(r,d);let o,n,a;d.iconPath&&(y instanceof A.$2K?a={id:y.id,color:y.color}:w.URI.isUri(y)?(o=y,n=y):{light:o,dark:n}=y);let E;return A.$vK.isMarkdownString($.tooltip)?E=h.MarkdownString.from($.tooltip):(0,m.$jf)($.tooltip)?E=$.tooltip:A.$vK.isMarkdownString($.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=h.MarkdownString.from($.detail)):(0,m.$jf)($.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=$.detail),{...$,id:$.id??void 0,handle:r,source:v,command:d.command?p.toInternal(d.command,g):void 0,icon:o,iconDark:n,themeIcon:a,tooltip:E,accessibilityInformation:d.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,F.$ic)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Zcc=P;function D(c){return c?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asb=e.$zsb=e.TunnelDtoConverter=void 0;class v extends k.$9u{}var p;(function(t){function i(d){return{remoteAddress:d.remoteAddress,localAddress:d.localAddress,public:!!d.public,privacy:d.privacy??(d.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:d.protocol}}t.fromApiTunnel=i;function s(d){return{remoteAddress:{host:d.tunnelRemoteHost,port:d.tunnelRemotePort},localAddress:d.localAddress,public:d.privacy!==k.TunnelPrivacyId.ConstantPrivate&&d.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:d.privacy,protocol:d.protocol}}t.fromServiceTunnel=s})(p||(e.TunnelDtoConverter=p={})),e.$zsb=(0,A.$Bh)("IExtHostTunnelService");let g=class extends C.$kc{constructor(i,s,d){super(),this.s=d,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$fd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(m.$6J.MainThreadTunnelService)}async openTunnel(i,s){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const d=await this.a.$openTunnel(s,i.displayName);if(d){const y=new v(d.remoteAddress,d.localAddress,()=>this.a.$closeTunnel(d.remoteAddress));return this.B(y),y}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,s){const d=this.u();return this.r.set(d,{selector:i,provider:s}),this.a.$registerPortsAttributesProvider(i,d),new c.$8J(()=>{this.r.delete(d),this.a.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(i,s,d,y,$){const r=[];for(const n of i){const a=this.r.get(n);if(!a)return[];r.push(...await Promise.all(s.map(async E=>{let b;try{b=await a.provider.providePortAttributes({port:E,pid:d,commandLine:y},$)}catch{b=await a.provider.providePortAttributes(E,d,y,$)}return{providedAttributes:b,port:E}})))}const o=r.filter(n=>!!n.providedAttributes);return o.length>0?o.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(y,$)=>await i.provideTunnel(y,$,new w.$pd().token)??void 0;const d=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(d),Promise.resolve((0,C.$ic)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,s){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const d=i.tunnelFactory??(s?this.w(s):void 0);if(d){this.b=d;let y=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&y.length===0&&(y=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const $=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:y}:void 0;this.a.$setTunnelProvider($)}}else this.b=void 0;return(0,C.$ic)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,s){if(this.g.has(i.host)){const d=this.g.get(i.host);d.has(i.port)&&(s&&d.get(i.port).disposeListener.dispose(),await d.get(i.port).tunnel.dispose(),d.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,s){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this.b(i,s);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const y=await d;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),y===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const $=this.B(y.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(y.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:y,disposeListener:$}),p.fromApiTunnel(y)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(d){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),d instanceof Error)return d.message}}async $applyCandidateFilter(i){const s=await Promise.all(i.map(y=>this.f(y.host,y.port,y.detail??""))),d=i.filter((y,$)=>s[$]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(y=>y.port).join(", ")} to ${d.map(y=>y.port).join(", ")}`),d}};e.$Asb=g,e.$Asb=g=Ke([qe(0,D.$7L),qe(1,P.$kM),qe(2,h.$5i)],g)}),define(Ae[256],Re([1,0,6,13,2,3]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(F.$6J.MainThreadUriOpeners)}registerExternalUriOpener(k,m,P,D){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const c=D.schemes.find(v=>!A.a.has(v));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(m,P),this.b.$registerUriOpener(m,D.schemes,k,D.label),(0,w.$ic)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(k,m,P){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener with id: ${k}`);const c=C.URI.revive(m);return D.canOpenExternalUri(c,P)}async $openUri(k,m,P){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener id: '${k}'`);return D.openExternalUri(C.URI.revive(m.resolvedUri),{sourceUri:C.URI.revive(m.sourceUri)},P)}}e.$9cc=A}),define(Ae[257],Re([1,0,3,2,6,9,20]),function(ve,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class h{static{this.a=0}constructor(m){this.c=new A.$Wl,this.d=new Map,this.b=m.getProxy(w.$6J.MainThreadUrls)}registerUriHandler(m,P){const D=m.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const c=h.a++;return this.c.add(D),this.d.set(c,P),this.b.$registerUriHandler(c,D,m.displayName||m.name),(0,C.$ic)(()=>{this.c.delete(D),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(m,P){const D=this.d.get(m);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(P))}catch(c){(0,F.$Y)(c)}return Promise.resolve(void 0)}async createAppUri(m){return M.URI.revive(await this.b.$createAppUri(m))}}e.$mcc=h}),define(Ae[64],Re([1,0,5,6,13,24,2,170,192,77,3]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=e.$qcc=e.$pcc=e.$occ=e.$ncc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(y,$,r,o,n,a,E){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$fd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$fd,this._onDidDispose=this.#h.event,this.#e=y,this.#t=$,this.#r=r,this.#l=o,this.#u=n,this.#n=a,this.#c=c(a),this.#d=v(a),this.#i=E}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(y){return this.#a=!0,(0,m.$cpb)(y,this.#l)}get cspSource(){const y=this.#n.extensionLocation;if(y.scheme===C.Schemas.https||y.scheme===C.Schemas.http){let $=y.toString();return $.endsWith("/")||($+="/"),$+" "+m.$bpb}return m.$bpb}get html(){return this.a(),this.#s}set html(y){this.a(),this.#s!==y&&(this.#s=y,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(y)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(y)))}get options(){return this.a(),this.#r}set options(y){this.a(),F.$Zm(this.#r,y)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,y)),this.#r=y}async postMessage(y){if(this.#o)return!1;const $=(0,k.$dcb)(y,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,$.message,...$.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(y){if(!this.#d)return y;const $=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return y.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,n,a,E,b,S)=>{const I=A.URI.from({scheme:E||"file",path:decodeURIComponent(b)}),u=(0,m.$cpb)(I,{isRemote:$,authority:r}).toString();return`${n}${u}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,n,a,E,b,S)=>{const I=A.URI.from({scheme:E||"file",path:decodeURIComponent(b)}),u=(0,m.$cpb)(I,{isRemote:$,authority:r}).toString();return`${n}${u}${S}`})}}e.$ncc=D;function c(d){try{const y=(0,h.$Do)((0,h.$Co)(d.engines.vscode));return!!y&&y.majorBase>=1&&y.minorBase>=57}catch{return!1}}e.$occ=c;function v(d){try{const y=(0,h.$Do)((0,h.$Co)(d.engines.vscode));return y?y.majorBase<1||y.majorBase===1&&y.minorBase<60:!1}catch{return!1}}class p extends M.$kc{constructor(y,$,r,o,n){super(),this.c=$,this.f=r,this.g=o,this.h=n,this.b=new Map,this.a=y.getProxy(P.$6J.MainThreadWebviews)}dispose(){super.dispose();for(const y of this.b.values())y.dispose();this.b.clear()}$onMessage(y,$,r){const o=this.j(y);if(o){const{message:n}=(0,k.$ecb)($,r.value);o._onMessageEmitter.fire(n)}}$onMissingCsp(y,$){this.g.warn(`${$} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(y,$,r){const o=new D(y,this.a,i($),this.c,this.f,r,this.h);this.b.set(y,o);const n=o._onDidDispose(()=>{n.dispose(),this.deleteWebview(y)});return o}deleteWebview(y){this.b.delete(y)}j(y){return this.b.get(y)}}e.$pcc=p;function g(d){return{id:d.identifier,location:d.extensionLocation}}e.$qcc=g;function t(d,y,$){return{enableCommandUris:$.enableCommandUris,enableScripts:$.enableScripts,enableForms:$.enableForms,portMapping:$.portMapping,localResourceRoots:$.localResourceRoots||s(d,y)}}e.$rcc=t;function i(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(y=>A.URI.from(y))}}function s(d,y){return[...(y?.getWorkspaceFolders()||[]).map($=>$.uri),d.extensionLocation]}}),define(Ae[258],Re([1,0,21,93,6,13,23,2,8,64,55,3,7]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class v{constructor(o,n){this.document=o,this.b=n,this.a=1,this.c=new P.$jbc("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,n){await this.f(o).undo(),n||this.disposeBackup()}async redo(o,n){await this.f(o).redo(),n||this.disposeBackup()}disposeEdits(o){for(const n of o)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=$(this.document.uri)+this.a++;return(0,A.$ig)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const n=this.c.get(o,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this.a=new Map}get(o,n){return this.a.get(this.b(o,n))}add(o,n,a){const E=this.b(o,n.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${o} resource:${n.uri}`);const b=new v(n,a);return this.a.set(E,b),b}delete(o,n){const a=this.b(o,n.uri);this.a.delete(a)}b(o,n){return`${o}@@@${n}`}}var g;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(o,n,a){return this.b(0,o,n,a)}addCustomProvider(o,n,a){return this.b(1,o,n,a)}get(o){return this.a.get(o)}b(o,n,a,E){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:o,extension:a,provider:E}),new c.$8J(()=>this.a.delete(n))}}class i{constructor(o,n,a,E,b){this.d=n,this.f=a,this.g=E,this.h=b,this.b=new t,this.c=new p,this.a=o.getProxy(D.$6J.MainThreadCustomEditors)}registerCustomEditorProvider(o,n,a,E){const b=new C.$jc;return d(a)?(b.add(this.b.addTextProvider(n,o,a)),this.a.$registerTextEditorProvider((0,m.$qcc)(o),n,E.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,m.$occ)(o))):(b.add(this.b.addCustomProvider(n,o,a)),s(a)&&b.add(a.onDidChangeCustomDocument(S=>{const I=this.i(n,S.document.uri);if(y(S)){const u=I.addEdit(S);this.a.$onDidEdit(S.document.uri,n,u,S.label)}else this.a.$onContentChange(S.document.uri,n)})),this.a.$registerCustomEditorProvider((0,m.$qcc)(o),n,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,m.$occ)(o))),c.$8J.from(b,new c.$8J(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(o,n,a,E,b){const S=this.b.get(n);if(!S)throw new Error(`No provider found for '${n}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${n}'`);const I=h.URI.revive(o),u=await S.provider.openCustomDocument(I,{backupId:a,untitledDocumentData:E?.buffer},b);let f;return s(S.provider)&&this.f&&(f=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(n,u,f),{editable:s(S.provider)}}async $disposeCustomDocument(o,n){const a=this.b.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${n}'`);const E=h.URI.revive(o),{document:b}=this.i(n,E);this.c.delete(n,b),b.dispose()}async $resolveCustomEditor(o,n,a,E,b,S){const I=this.b.get(a);if(!I)throw new Error(`No provider found for '${a}'`);const u=k.ViewColumn.to(b),f=this.g.createNewWebview(n,E.contentOptions,I.extension),l=this.h.createNewWebviewPanel(n,a,E.title,u,E.options,f,E.active),R=h.URI.revive(o);switch(I.type){case 1:{const{document:B}=this.i(a,R);return I.provider.resolveCustomEditor(B,l,S)}case 0:{const B=this.d.getDocument(R);return I.provider.resolveCustomTextEditor(B,l,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,n,a){this.i(n,o).disposeEdits(a)}async $onMoveCustomEditor(o,n,a){const E=this.b.get(a);if(!E)throw new Error(`No provider found for '${a}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const b=this.h.getWebviewPanel(o);if(!b)throw new Error("No webview found");const S=h.URI.revive(n),I=this.d.getDocument(S);await E.provider.moveCustomTextEditor(I,b,w.CancellationToken.None)}async $undo(o,n,a,E){return this.i(n,o).undo(a,E)}async $redo(o,n,a,E){return this.i(n,o).redo(a,E)}async $revert(o,n,a){const E=this.i(n,o);await this.j(n).revertCustomDocument(E.document,a),E.disposeBackup()}async $onSave(o,n,a){const E=this.i(n,o);await this.j(n).saveCustomDocument(E.document,a),E.disposeBackup()}async $onSaveAs(o,n,a,E){const b=this.i(n,o);return this.j(n).saveCustomDocumentAs(b.document,h.URI.revive(a),E)}async $backup(o,n,a){const E=this.i(n,o),S=await this.j(n).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},a);return E.updateBackup(S),S.id}i(o,n){const a=this.c.get(o,h.URI.revive(n));if(!a)throw new Error("No custom document found");return a}j(o){const a=this.b.get(o)?.provider;if(!a||!s(a))throw new Error("Custom document is not editable");return a}}e.$3cc=i;function s(r){return!!r.onDidChangeCustomDocument}function d(r){return typeof r.resolveCustomTextEditor=="function"}function y(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function $(r){const o=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,M.$pi)(o)+""}}),define(Ae[259],Re([1,0,5,6,2,36,8,64,3,7]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class P extends M.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(p,g,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$fd),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$fd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=g,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#s}set iconPath(p){this.c(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,C.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!g})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends M.$kc{static c(){return(0,F.$4f)()}constructor(p,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(k.$6J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,g,t,i,s={}){const d=typeof i=="object"?i.viewColumn:i,y={viewColumn:A.ViewColumn.from(d),preserveFocus:typeof i=="object"&&!!i.preserveFocus},$=(0,h.$occ)(p),r=D.c();this.f.$createWebviewPanel((0,h.$qcc)(p),r,g,{title:t,panelOptions:c(s),webviewOptions:(0,h.$rcc)(p,this.m,s),serializeBuffersForPostMessage:$},y);const o=this.j.createNewWebview(r,s,p);return this.createNewWebviewPanel(r,g,t,d,s,o,!0)}$onDidChangeWebviewPanelViewStates(p){const g=Object.keys(p);g.sort((t,i)=>{const s=p[t],d=p[i];return s.active?1:d.active?-1:+s.visible-+d.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const s=p[t];i._updateViewState({active:s.active,visible:s.visible,viewColumn:A.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:p}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,h.$occ)(p)}),new m.$8J(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(p,g,t,i){const s=this.h.get(g);if(!s)throw new Error(`No serializer found for '${g}'`);const{serializer:d,extension:y}=s,$=this.j.createNewWebview(p,t.webviewOptions,y),r=this.createNewWebviewPanel(p,g,t.title,i,t.panelOptions,$,t.active);await d.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,g,t,i,s,d,y){const $=new P(p,this.f,d,{viewType:g,title:t,viewColumn:i,panelOptions:s,active:y});return this.g.set(p,$),$}getWebviewPanel(p){return this.g.get(p)}}e.$2cc=D;function c(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[260],Re([1,0,5,6,64,8,3,7]),function(ve,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class k extends M.$kc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,c,v,p,g,t){super(),this.#u=!1,this.#a=this.B(new w.$fd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$fd),this.onDidDispose=this.#c.event,this.#i=v,this.#s=p,this.#e=D,this.#t=c,this.#l=g,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class m{constructor(D,c){this.d=c,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$6J.MainThreadWebviewViews)}registerWebviewViewProvider(D,c,v,p){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:v,extension:D}),this.a.$registerWebviewViewProvider((0,C.$qcc)(D),c,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$occ)(D)}),new h.$8J(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(D,c,v,p,g){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:s}=t,d=this.d.createNewWebview(D,{},s),y=new k(D,this.a,c,v,d,!0);this.c.set(D,y),await i.resolveWebviewView(y,{state:p},g)}async $onDidChangeWebviewViewVisibility(D,c){this.e(D)._setVisible(c)}async $disposeWebviewView(D){const c=this.e(D);this.c.delete(D),c.dispose(),this.d.deleteWebview(D)}e(D){const c=this.c.get(D);if(!c)throw new Error("No webview found");return c}}e.$1cc=m}),define(Ae[109],Re([1,0,5,3,2,13,15,4,17,26]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,m.$4E)(v,"windowActivity"),p.active}}}constructor(v){this.c=new w.$fd,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=v.getProxy(M.$6J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let g;if(typeof v=="string"){g=v;try{v=C.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,A.$me)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,g,p)}async asExternalUri(v,p){if((0,A.$me)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(v,p);return C.URI.from(g)}};e.$scc=D,e.$scc=D=P=Ke([qe(0,k.$7L)],D),e.$tcc=(0,h.$Bh)("IExtHostWindow")}),define(Ae[261],Re([1,0,228,27,17]),function(ve,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;let F=class extends w.$sdc{constructor(h,k){super(h,k)}f(h,k,m){k.apply(console,m)}};e.$zfc=F,e.$zfc=F=Ke([qe(0,C.$7L),qe(1,M.$kM)],F)}),define(Ae[262],Re([1,0,12,25,21,9,5,6,133,216,46]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$X3b=e.ResponsiveState=e.RequestInitiator=e.$W3b=e.$V3b=void 0;function c(l,R){try{return JSON.stringify(l,R)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class g{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(l,R=null,B=!1){const V=[];return{jsonString:(B?c:JSON.stringify)(l,(W,O)=>{if(typeof O>"u")return p;if(typeof O=="object"){if(O instanceof M.$Fd){const N=V.push(O)-1;return{[v]:N}}if(R)return R(W,O)}return O}),referencedBuffers:V}}e.$V3b=t;function i(l,R,B){return JSON.parse(l,(V,U)=>{if(U){const W=U[v];if(typeof W=="number")return R[W];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.$W3b=i;function s(l,R){return JSON.stringify(l,R)}function d(l){return l?(R,B)=>B&&B.$mid===1?l.transformOutgoing(B):B:null}var y;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));var $;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})($||(e.ResponsiveState=$={}));const r=()=>{},o=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class a extends h.$kc{static{D=o}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[D]=!0,this.b=this.B(new A.$fd),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=d(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,W=P.$dv.count;U<W;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$Sg(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(F.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+a.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+a.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,k.$Em)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(U,W)=>(typeof W=="string"&&!U[W]&&W.charCodeAt(0)===36&&(U[W]=(...O)=>this.U(R,W,O)),W===n?B:U[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const U=R[B];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=b.read(R,0),U=V.readUInt8(),W=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestJSONArgs(V);this.g&&(ee=(0,k.$Em)(ee,this.g)),this.M(B,W,O,N,ee,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestMixedArgs(V);this.g&&(ee=(0,k.$Em)(ee,this.g)),this.M(B,W,O,N,ee,U===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let O=I.deserializeReplyOKJSON(V);this.g&&(O=(0,k.$Em)(O,this.g)),this.O(B,W,O);break}case 10:{const O=I.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,O);break}case 8:{const O=I.deserializeReplyOKVSBuffer(V);this.O(B,W,O);break}case 11:{let O=I.deserializeReplyErrError(V);this.g&&(O=(0,k.$Em)(O,this.g)),this.P(B,W,O);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,U,W,O){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$fv)(V)}.${U}(`,W);const N=String(B);let ee,Z;if(O){const De=new C.$pd;W.push(De.token),ee=this.Q(V,U,W),Z=()=>De.cancel()}else ee=this.Q(V,U,W),Z=r;this.u[N]=Z;const ye=I.serializeAcknowledged(B);this.f?.logOutgoing(ye.byteLength,B,1,"ack"),this.c.send(ye),ee.then(De=>{delete this.u[N];const Pe=I.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",De),this.c.send(Pe)},De=>{delete this.u[N];const Pe=I.serializeReplyErr(B,De);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",De),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),W.resolveErr(O)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(U){return Promise.reject(U)}}S(R,B,V){const U=this.m[R];if(!U)throw new Error("Unknown actor "+(0,P.$fv)(R));const W=U[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$fv)(R));return W.apply(U,V)}U(R,B,V){if(this.j)return new m.$U3b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(F.$4());const W=I.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),ee=new m.$T3b,Z=new h.$jc;U&&Z.add(U.onCancellationRequested(()=>{const De=I.serializeCancel(O);this.f?.logOutgoing(De.byteLength,O,0,"cancel"),this.c.send(I.serializeCancel(O))})),this.w[N]=new E(ee,Z),this.F(O);const ye=I.serializeRequest(O,R,B,W,!!U);return this.f?.logOutgoing(ye.byteLength,O,0,`request: ${(0,P.$fv)(R)}.${B}(`,V),this.c.send(ye),ee}}e.$X3b=a;class E{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class b{static alloc(R,B,V){const U=new b(M.$Fd.alloc(V+1+4),0);return U.writeUInt8(R),U.writeUInt32(B),U}static read(R,B){return new b(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,U=R.length;V<U;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let O=0;O<W.buffers.length;++O)B+=this.sizeVSBuffer(W.buffers[O]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const U=R[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let W=0;W<U.buffers.length;++W)this.writeBuffer(U.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),O=this.readLongString(),N=[];for(let ee=0;ee<W;++ee)N.push(this.readVSBuffer());B[V]=new P.$gv(i(O,N,null));break}case 4:B[V]=void 0;break}return B}}var S;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(S||(S={}));class I{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof M.$Fd||R[B]instanceof P.$gv||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let U=0,W=R.length;U<W;U++){const O=R[U];if(O instanceof M.$Fd)V[U]={type:2,value:O};else if(typeof O>"u")V[U]={type:4};else if(O instanceof P.$gv){const{jsonString:N,referencedBuffers:ee}=t(O.value,B);V[U]={type:3,value:M.$Fd.fromString(N),buffers:ee}}else V[U]={type:1,value:M.$Fd.fromString(s(O,B))}}return{type:1,args:V}}return{type:0,args:s(R,B)}}static serializeRequest(R,B,V,U,W){switch(U.type){case 0:return this.b(R,B,V,U.args,W);case 1:return this.c(R,B,V,U.args,W)}}static b(R,B,V,U,W){const O=M.$Fd.fromString(V),N=M.$Fd.fromString(U);let ee=0;ee+=b.sizeUInt8(),ee+=b.sizeShortString(O),ee+=b.sizeLongString(N);const Z=b.alloc(W?2:1,R,ee);return Z.writeUInt8(B),Z.writeShortString(O),Z.writeLongString(N),Z.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(U)}}static c(R,B,V,U,W){const O=M.$Fd.fromString(V);let N=0;N+=b.sizeUInt8(),N+=b.sizeShortString(O),N+=b.sizeMixedArray(U);const ee=b.alloc(W?4:3,R,N);return ee.writeUInt8(B),ee.writeShortString(O),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readMixedArray(),W=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const ee=U[O];typeof ee=="string"?W[O]=JSON.parse(ee):W[O]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return b.alloc(5,R,0).buffer}static serializeCancel(R){return b.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof M.$Fd)return this.e(R,B);if(B instanceof P.$gv){const{jsonString:U,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,U,W)}else return this.f(R,c(B,V))}static d(R){return b.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=b.sizeVSBuffer(B);const U=b.alloc(8,R,V);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=M.$Fd.fromString(B);let U=0;U+=b.sizeLongString(V);const W=b.alloc(9,R,U);return W.writeLongString(V),W.buffer}static g(R,B,V){const U=M.$Fd.fromString(B);let W=0;W+=b.sizeUInt32,W+=b.sizeLongString(U);for(const N of V)W+=b.sizeVSBuffer(N);const O=b.alloc(10,R,W);O.writeUInt32(V.length),O.writeLongString(U);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),U=R.readLongString(),W=[];for(let O=0;O<V;++O)W.push(R.readVSBuffer());return new P.$gv(i(U,W,B))}static serializeReplyErr(R,B){const V=B?c(F.$1(B),null):void 0;if(typeof V!="string")return this.h(R);const U=M.$Fd.fromString(V);let W=0;W+=b.sizeLongString(U);const O=b.alloc(11,R,W);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return b.alloc(12,R,0).buffer}}var u;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var f;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(f||(f={}))}),define(Ae[263],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;const w=function(F){const A=h=>{globalThis.removeEventListener("message",A);const k=h.data;Object.defineProperties(globalThis,{postMessage:{value(m,P){k.postMessage(m,P)}},onmessage:{get(){return k.onmessage},set(m){k.onmessage=m}}}),k.addEventListener("message",m=>{globalThis.dispatchEvent(new MessageEvent("message",{data:m.data,ports:m.ports?[...m.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(F,A,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${w})('${A}'))`,m=new Blob([k],{type:"application/javascript"}),P=URL.createObjectURL(m),D=new MessageChannel,c=P,v={type:"_newWorker",id:c,port:D.port2,url:P,options:h};F(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:c}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const g=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(g)}),D.port1.addEventListener("message",p=>{const g=new MessageEvent("message",{data:p.data});this.dispatchEvent(g)}),D.port1.start()}}e.$Bfc=M}),define(Ae[264],Re([1,0,5,30,32,4]),function(ve,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=e.OutputChannelUpdateMode=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=void 0,e.$dJ="text/x-code-output",e.$eJ="output",e.$fJ="Log",e.$gJ="text/x-code-log-output",e.$hJ="log",e.$iJ="log",e.$jJ="workbench.panel.output",e.$kJ=new C.$2i("inOutput",!1),e.$lJ=new C.$2i("activeLogOutput",!1),e.$mJ=new C.$2i("outputView.scrollLock",!1),e.$nJ=(0,F.$Bh)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$oJ={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.a=new Map,this.b=new w.$fd,this.onDidRegisterChannel=this.b.event,this.c=new w.$fd,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(P=>m.push(P)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}M.$8m.add(e.$oJ.OutputChannels,new h),e.$pJ=new C.$2i("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,264,62,27,39,130,25,16,38,5,6]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;class i extends A.$$i{get disposed(){return this.n}constructor($,r,o,n,a){super(),this.id=$,this.name=r,this.r=o,this.s=n,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine($){this.append($+`
`)}append($){this.info($)}clear(){const $=this.m;this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Clear,$)}replace($){const r=this.m;this.info($),this.s.$update(this.id,h.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show($,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof $=="boolean"?$:r))}hide(){this.s.$close(this.id)}g($,r){this.m+=c.$Fd.fromString(r).byteLength,(0,A.log)(this.r,$,r),this.visible&&(this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class s extends i{appendLine($){this.append($)}}let d=class{constructor($,r,o,n,a,E){this.i=r,this.j=o,this.k=n,this.l=a,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=$.getProxy(w.$6J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel($){this.h=$;for(const[r,o]of this.g)o.visible=r===this.h}createOutputChannel($,r,o){if($=$.trim(),!$)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,a=(0,v.$jf)(r)?r:void 0;if((0,v.$jf)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const b=this.i.environment.extensionLogLevel?.find(([I])=>F.$Vl.equals(o.identifier,I))?.[1];b&&(E=(0,A.$ij)(b));const S=n?this.o($,E,o):this.n($,a,o);return S.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),n?this.r($,E??this.m.getLevel(),S):this.q($,S)}async n($,r,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,a=this.k.extUri.joinPath(n,`${this.f++}-${$.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register($,a,r,o.identifier.value);return new i(b,$,E,this.a,o)}async o($,r,o){const n=await this.p(o),a=$.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(n,`${a}.log`),b=`${o.identifier.value}.${a}`,S=this.l.createLogger(E,{id:b,name:$,logLevel:r,extensionId:o.identifier.value});return new s(b,$,S,this.a,o)}p($){let r=this.d.get($.identifier.value);if(!r){const o=this.k.extUri.joinPath(this.i.logsLocation,$.identifier.value);this.d.set($.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(o)}catch(n){if((0,p.$ik)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return o})())}return r}q($,r){let o=!1;const n=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return $},append(a){n(),r.then(E=>E.append(a))},appendLine(a){n(),r.then(E=>E.appendLine(a))},clear(){n(),r.then(a=>a.clear())},replace(a){n(),r.then(E=>E.replace(a))},show(a,E){n(),r.then(b=>b.show(a,E))},hide(){n(),r.then(a=>a.hide())},dispose(){o=!0,r.then(a=>a.dispose())}}}r($,r,o){const n=new t.$jc,a=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},E=n.add(new g.$fd);function b(S){r=S,E.fire(S)}return o.then(S=>{n.add(S),S.logLevel!==r&&b(S.logLevel),n.add(S.onDidChangeLogLevel(I=>b(I)))}),{...this.q($,o),get logLevel(){return r},onDidChangeLogLevel:E.event,trace(S,...I){a(),o.then(u=>u.trace(S,...I))},debug(S,...I){a(),o.then(u=>u.debug(S,...I))},info(S,...I){a(),o.then(u=>u.info(S,...I))},warn(S,...I){a(),o.then(u=>u.warn(S,...I))},error(S,...I){a(),o.then(u=>u.error(S,...I))},dispose(){n.dispose()}}}};e.$ccc=d,e.$ccc=d=Ke([qe(0,C.$7L),qe(1,m.$kM),qe(2,k.$Rbc),qe(3,P.$mbc),qe(4,A.$6i),qe(5,A.$5i)],d),e.$dcc=(0,M.$Bh)("IExtHostOutputService")}),define(Ae[265],Re([1,0,4,12]),function(ve,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0,e.$jm=(0,w.$Bh)("remoteAgentService"),e.$km=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let h=0;h<this.maxSampleCount;h++){const k=await C.getRoundTripTime();if(k===void 0)return;F=Math.min(F,k/2),await(0,M.$Hg)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(F):A=this.initial.reduce((h,k)=>h+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:F,average:this.average.reduce((h,k)=>h+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[266],Re([1,0,42,13,19,22,23,2,4,187,54,209,265]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=e.$HJ=void 0,e.$HJ=(0,k.$Bh)("pathService");let p=v=class{constructor(t,i,s,d){this.d=t,this.e=i,this.f=s,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??t})()}hasValidBasename(t,i,s){return typeof i=="string"||typeof i>"u"?this.a.then(d=>this.h(t,d,i)):this.h(t,i,s)}h(t,i,s){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Gf)(s??(0,A.$fg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const s=(0,m.$EJ)(i.getWorkspace());if(s)return s;const d=i.getWorkspace().folders[0];if(d)return d.uri.scheme;const y=i.getWorkspace().configuration;return y?y.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$5d:C.$6d)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const d=t.indexOf("/",2);d===-1?(i=t.substring(2),t="/"):(i=t.substring(2,d),t=t.substring(d)||"/")}return h.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$IJ=p,e.$IJ=p=v=Ke([qe(1,c.$jm),qe(2,D.$qJ),qe(3,P.$Kh)],p)}),define(Ae[111],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qI=e.$pI=void 0;class w{constructor(A,h){this.line=A,this.character=h}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,h){return new w(0,0)}with(A){return new w(0,0)}}e.$pI=w;class M{constructor(A,h,k,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,h),this.end=new w(k,m)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$qI=M;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,111,12]),function(ve,e,w,M,C,F,A,h,k,m,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.SearchErrorCode=e.$FI=e.$EI=e.SearchSortOrder=e.ViewMode=e.$DI=e.$CI=e.$BI=e.$AI=e.SearchCompletionExitCode=e.$zI=e.$yI=e.$xI=e.QueryType=e.SearchProviderType=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$rI="workbench.view.search",e.$sI="workbench.panel.search",e.$tI="workbench.view.search",e.$uI="search-result",e.$vI="search.exclude";const c="\u27EA ",v=" characters skipped \u27EB",p=(c.length+v.length+5)*2;e.$wI=(0,h.$Bh)("searchService");var g;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Y){return!!Y.preview}e.$xI=i;function s(Y){return!!Y.resource}e.$yI=s;function d(Y){return!!Y.message}e.$zI=d;var y;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(y||(e.SearchCompletionExitCode=y={}));class ${constructor(le){this.resource=le,this.results=[]}}e.$AI=$;class r{constructor(le,Ee,ce,$e){this.ranges=Ee,this.webviewIndex=$e;const ie=Array.isArray(Ee)?Ee:[Ee];if(ce&&ce.matchLines===1&&o(ie)){le=(0,A.$cf)(le,ce.matchLines);let z="",q=0,ue=0;const we=Math.floor(ce.charsPerLine/5),be=[];for(const ge of ie){const ke=Math.max(ge.startColumn-we,0),re=ge.startColumn+ce.charsPerLine;if(ke>ue+we+p){const he=c+(ke-ue)+v;z+=he+le.slice(ke,re),q+=ke-(ue+he.length)}else z+=le.slice(ue,re);be.push(new a(0,ge.startColumn-q,ge.endColumn-q)),ue=re}this.preview={text:z,matches:Array.isArray(this.ranges)?be:be[0]}}else{const z=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:le,matches:(0,w.$Zb)(Ee,q=>new n(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$BI=r;function o(Y){const le=Y[0].startLineNumber;for(const Ee of Y)if(Ee.startLineNumber!==le||Ee.endLineNumber!==le)return!1;return!0}class n{constructor(le,Ee,ce,$e){this.startLineNumber=le,this.startColumn=Ee,this.endLineNumber=ce,this.endColumn=$e}}e.$CI=n;class a extends n{constructor(le,Ee,ce){super(le,Ee,le,ce)}}e.$DI=a;var E;(function(Y){Y.List="list",Y.Tree="tree"})(E||(e.ViewMode=E={}));var b;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function S(Y,le=!0){const Ee=Y&&Y.files&&Y.files.exclude,ce=le&&Y&&Y.search&&Y.search.exclude;if(!Ee&&!ce)return;if(!Ee||!ce)return Ee||ce;let $e=Object.create(null);return $e=C.$Ym($e,C.$Vm(Ee)),$e=C.$Ym($e,C.$Vm(ce),!0),$e}e.$EI=S;function I(Y,le){return Y.excludePattern&&M.$qj(Y.excludePattern,le)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&M.$qj(Y.includePattern,le)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(Ee=>{const ce=Ee.folder.fsPath;if(F.$If(le,ce)){const $e=k.$$d(ce,le);return!Ee.includePattern||!!M.$qj(Ee.includePattern,$e)}else return!1}):!1:!0}e.$FI=I;var u;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class f extends Error{constructor(le,Ee){super(le),this.code=Ee}}e.$GI=f;function l(Y){const le=Y.message;if((0,m.$2)(Y))return new f(le,u.canceled);try{const Ee=JSON.parse(le);return new f(Ee.message,Ee.code)}catch{return new f(le,u.other)}}e.$HI=l;function R(Y){const le={message:Y.message,code:Y.code};return new Error(JSON.stringify(le))}e.$II=R;function B(Y){return Y.type==="error"?!0:Y.type==="success"}e.$JI=B;function V(Y){return Y.type==="success"}e.$KI=V;function U(Y){return!!Y.path}e.$LI=U;function W(Y,le){const Ee=Y.searchPath?Y.searchPath:Y.relativePath;return(0,A.$_e)(Ee,le)}e.$MI=W;class O{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NI=O;function N(Y,le){const Ee={...Y||{},...le||{}};return Object.keys(Ee).filter(ce=>{const $e=Ee[ce];return typeof $e=="boolean"&&$e})}e.$OI=N;class ee{constructor(le,Ee){this.c=null,this.a={...le.excludePattern||{},...Ee.excludePattern||{}},this.b=M.$rj(this.a);let ce=le.includePattern;Ee.includePattern&&(ce?ce={...ce,...Ee.includePattern}:ce=Ee.includePattern),ce&&(this.c=M.$rj(ce))}matchesExcludesSync(le,Ee,ce){return!!(this.b&&this.b(le,Ee,ce))}includedInQuerySync(le,Ee,ce){return!(this.b&&this.b(le,Ee,ce)||this.c&&!this.c(le,Ee,ce))}includedInQuery(le,Ee,ce){const $e=this.b(le,Ee,ce),ie=()=>this.c?!!this.c(le,Ee,ce):!0;return(0,D.$tg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$PI=ee;function Z(Y){for(const le in Y)if(typeof Y[le]!="boolean")return!0;return!1}function ye(Y){if(!Y)return;let le;return Ee=>(le||(le=(Y()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),le.then(ce=>!!ce[Ee]))}e.$QI=ye;function De(Y){if(!Y)return;let le;return Ee=>{if(!le){const ce=Y();le=ce?Pe(ce):{}}return!!le[Ee]}}e.$RI=De;function Pe(Y){const le={};for(const Ee of Y)le[Ee]=!0;return le}}),define(Ae[33],Re([1,0,18,12,21,5,6,48,13,118,23,15,2,159,4,14,176,54,39,27,17,8,7,56,47,3]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=void 0;function E(B,V,U){return new P.$0f(W=>u(W,U)).isEqual(B,V)}function b(B,V,U){return E(B.uri,V.uri,U)?0:(0,D.$Fe)(B.uri.toString(),V.uri.toString())}function S(B,V,U){return B.index!==V.index?B.index<V.index?-1:1:E(B.uri,V.uri,U)?(0,D.$Fe)(B.name,V.name):(0,D.$Fe)(B.uri.toString(),V.uri.toString())}function I(B,V,U,W){const O=B.slice(0).sort((ee,Z)=>U(ee,Z,W)),N=V.slice(0).sort((ee,Z)=>U(ee,Z,W));return(0,w.$Cb)(O,N,(ee,Z)=>U(ee,Z,W))}function u(B,V){const U=V.getCapabilities(B.scheme);return!(U&&U&1024)}class f extends i.$Uh{static toExtHostWorkspace(V,U,W,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:Z,configuration:ye,transient:De,isUntitled:Pe}=V,Y=[],le=U;U?Z.forEach((ie,z)=>{const q=c.URI.revive(ie.uri),ue=f.o(W||U,q,O);ue?(ue.name=ie.name,ue.index=ie.index,Y.push(ue)):Y.push({uri:q,name:ie.name,index:z})}):Y.push(...Z.map(({uri:ie,name:z,index:q})=>({uri:c.URI.revive(ie),name:z,index:q}))),Y.sort((ie,z)=>ie.index<z.index?-1:1);const Ee=new f(N,ee,Y,!!De,ye?c.URI.revive(ye):null,!!Pe,ie=>u(ie,O)),{added:ce,removed:$e}=I(le?le.workspaceFolders:[],Ee.workspaceFolders,b,O);return{workspace:Ee,added:ce,removed:$e}}static o(V,U,W){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(E(N.uri,U,W))return N}}constructor(V,U,W,O,N,ee,Z){super(V,W.map(ye=>new i.$Vh(ye)),O,N,Z),this.t=U,this.u=ee,this.q=[],this.s=h.$Hh.forUris(Z),W.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$hg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let l=class{constructor(V,U,W,O,N){this.c=new F.$fd,this.onDidChangeWorkspace=this.c.event,this.g=new F.$fd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$hd,this.B=new Map,this.h=O,this.s=W,this.t=N,this.j=new m.$Jl,this.k=new M.$Fg,this.o=V.getProxy(a.$6J.MainThreadWorkspace),this.q=V.getProxy(a.$6J.MainThreadMessageService);const ee=U.workspace;this.l=ee?new f(ee.id,ee.name,[],!!ee.transient,ee.configuration?c.URI.revive(ee.configuration):null,!!ee.isUntitled,Z=>u(Z,W)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,P.$fg)((0,P.$hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,W,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{c.URI.isUri(Pe.uri)&&!N.some(Y=>E(Y.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$eg)(Pe.uri)})}),this.n||[U,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&N.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+W>ee.length)return!1;const Z=ee.slice(0);Z.splice(U,W,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$eg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Z.length;Pe++){const Y=Z[Pe];if(Z.some((le,Ee)=>Ee!==Pe&&E(Y.uri,le.uri,this.s)))return!1}Z.forEach((Pe,Y)=>Pe.index=Y);const{added:ye,removed:De}=I(ee,Z,S,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,W,N).then(void 0,Y=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,Pe,Y.toString()),le,[])})}return this.y(Z),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let W,O="";if(typeof V=="string"?(W=c.URI.file(V),O=V):typeof V<"u"&&(W=V,O=V.fsPath),!W)return O;const N=this.getWorkspaceFolder(W,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,P.$kg)(N.uri,W);return U&&N.name&&(ee=`${N.name}/${ee}`),ee}y(V){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:W,removed:O}=f.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:O}))}findFiles(V,U,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:ye}=R($.GlobPattern.from(V));return this.o.$startFileSearch(Z??null,ye??null,ee??null,W??null,N).then(De=>Array.isArray(De)?De.map(Pe=>c.URI.revive(Pe)):[])}async findTextInFiles(V,U,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),Z=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:De}=R($.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Y={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Z,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:Pe},le=!1;if(this.u[ee]=Ee=>{if(le)return;const ce=c.URI.revive(Ee.resource);Ee.results.forEach($e=>{(0,n.$xI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Zb)($e.preview.matches,ie=>new r.$0J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Zb)($e.ranges,ie=>new r.$0J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(V,De??null,Y,ee,N);return delete this.u[ee],Ee||{}}catch(Ee){throw delete this.u[ee],Ee}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return c.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return c.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,W),(0,A.$ic)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const O=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(W,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,U,W,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(c.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const Z=await ee.provideEditSessionIdentityMatch?.(U,W,O);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(V){return(U,W,O)=>{const N=function(Z){U.call(W,Z)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,U,W){const O=await this.resolveWorkspaceFolder(c.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,ee)=>{const Z=Date.now();await Promise.resolve(N),Date.now()-Z>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,W),(0,A.$ic)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,U,W){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(c.URI.revive(V),U,W);if(N)return N}async $provideCanonicalUri(V,U,W){return this.provideCanonicalUri(c.URI.revive(V),{targetScheme:U},W)}};e.$ybc=l,e.$ybc=l=Ke([qe(0,y.$7L),qe(1,d.$kM),qe(2,s.$mbc),qe(3,g.$5i),qe(4,o.$wbc)],l),e.$zbc=(0,p.$Bh)("IExtHostWorkspace");function R(B){let V,U;return B&&(typeof B=="string"?V=B:(V=B.pattern,U=c.URI.revive(B.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,12,4,17,14,2]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=e.$Abc=void 0;function g(o,n){if(n){const a=n.split(".");let E=o;for(let b=0;E&&b<a.length;b++)E=E[a[b]];return E}}function t(o){return o instanceof p.URI}function i(o){return o&&o.uri instanceof p.URI&&o.languageId&&typeof o.languageId=="string"}function s(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function d(o){return o&&o.uri instanceof p.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function y(o){if(t(o))return{resource:o};if(i(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(s(o))return{overrideIdentifier:o.languageId};if(d(o))return{resource:o.uri};if(o===null)return{resource:null}}let $=class{constructor(n,a,E){this.a=n.getProxy(F.$6J.MainThreadConfiguration),this.c=a,this.b=E,this.d=new P.$Fg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,a){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(n,a))}};e.$Abc=$,e.$Abc=$=Ke([qe(0,c.$7L),qe(1,C.$zbc),qe(2,v.$5i)],$);class r{constructor(n,a,E,b){this.a=new M.$fd,this.b=n,this.f=b,this.c=a,this.e=h.$tn.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,a){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=h.$tn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(a,E))}getConfiguration(n,a,E){const b=y(a)||{},S=this.g(n?g(this.e.getValue(void 0,b,this.c.workspace),n):this.e.getValue(void 0,b,this.c.workspace));n&&this.h(n,b,E?.identifier);function I(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(f){return typeof g(S,f)<"u"},get:(f,l)=>{this.h(n?`${n}.${f}`:f,b,E?.identifier);let R=g(S,f);if(typeof R>"u")R=l;else{let B;const V=(U,W)=>{if((0,m.$lf)(U)){let O;const N=()=>{B=B||(0,w.$Vm)(S),O=O||g(B,W)};return new Proxy(U,{get:(ee,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return N(),()=>O;if(B)return O=O||g(B,W),O[Z];const ye=ee[Z];return typeof Z=="string"?V(ye,`${W}.${Z}`):ye},set:(ee,Z,ye)=>(N(),O&&(O[Z]=ye),!0),deleteProperty:(ee,Z)=>(N(),O&&delete O[Z],!0),defineProperty:(ee,Z,ye)=>(N(),O&&Object.defineProperty(O,Z,ye),!0)})}return Array.isArray(U)?(0,w.$Vm)(U):U};R=V(R,f)}return R},update:(f,l,R,B)=>{f=n?`${n}.${f}`:f;const V=I(R);return l!==void 0?this.b.$updateConfigurationOption(V,f,l,b,B):this.b.$removeConfigurationOption(V,f,b,B)},inspect:f=>{f=n?`${n}.${f}`:f;const l=this.e.inspect(f,b,this.c.workspace);if(l)return{key:f,defaultValue:(0,w.$Vm)(l.policy?.value??l.default?.value),globalValue:(0,w.$Vm)(l.user?.value??l.application?.value),workspaceValue:(0,w.$Vm)(l.workspace?.value),workspaceFolderValue:(0,w.$Vm)(l.workspaceFolder?.value),defaultLanguageValue:(0,w.$Vm)(l.default?.override),globalLanguageValue:(0,w.$Vm)(l.user?.override??l.application?.override),workspaceLanguageValue:(0,w.$Vm)(l.workspace?.override),workspaceFolderLanguageValue:(0,w.$Vm)(l.workspaceFolder?.override),languageIds:(0,w.$Vm)(l.overrideIdentifiers)}}};return typeof S=="object"&&(0,w.$Ym)(u,S,!1),Object.freeze(u)}g(n){const a=E=>(0,m.$lf)(E)?new Proxy(E,{get:(b,S)=>a(b[S]),set:(b,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(b,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(b,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return a(n)}h(n,a,E){const b=k.$kn.test(n)?4:this.d.get(n),S=E?`[${E.value}] `:"";if(b===4){typeof a?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){a?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,a){const E=new h.$vn(n,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,S)=>E.affectsConfiguration(b,y(S))})}k(n){return n.reduce((a,E)=>(a.set(E[0],E[1]),a),new Map)}}e.$Bbc=r,e.$Cbc=(0,D.$Bh)("IExtHostConfiguration")}),define(Ae[112],Re([1,0,2,12,5,3,7,33,60,34,21,63,17,27,4,13,22,14,80,215,9]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=e.$ycc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var $;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})($||($={}));var r;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(r||(r={}));var o;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(o||(o={}));var n;(function(V){function U(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}V.is=U;function W(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=o.from(N.options)),ee}V.from=W;function O(N){if(N!=null)return new A.$PK(N.process,N.args,N.options)}V.to=O})(n||(n={}));var a;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(a||(a={}));var E;(function(V){function U(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=U;function W(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=a.from(N.options)),ee}V.from=W;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$QK(N.commandLine,N.options):new A.$QK(N.command,N.args?N.args:[],N.options)}V.to=O})(E||(E={}));var b;(function(V){function U(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=U;function W(N){return{customExecution:"customExecution"}}V.from=W;function O(N,ee){return ee.get(N)}V.to=O})(b||(e.CustomExecutionDTO=b={}));var S;(function(V){function U(W,O){let N;return W.scope!==void 0&&typeof W.scope!="number"?N=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=d.$GF),{id:W._id,workspaceFolder:N}}V.from=U})(S||(e.TaskHandleDTO=S={}));var I;(function(V){function U(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=U})(I||(I={}));var u;(function(V){function U(N,ee){if(N==null)return[];const Z=[];for(const ye of N){const De=W(ye,ee);De&&Z.push(De)}return Z}V.fromMany=U;function W(N,ee){if(N==null)return;let Z;N.execution instanceof A.$PK?Z=n.from(N.execution):N.execution instanceof A.$QK?Z=E.from(N.execution):N.execution&&N.execution instanceof A.$RK&&(Z=b.from(N.execution));const ye=$.from(N.definition);let De;return N.scope?typeof N.scope=="number"?De=N.scope:De=N.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:De},execution:Z,isBackground:N.isBackground,group:I.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=W;async function O(N,ee,Z){if(N==null)return;let ye;n.is(N.execution)?ye=n.to(N.execution):E.is(N.execution)?ye=E.to(N.execution):b.is(N.execution)&&(ye=b.to(N._id,Z));const De=$.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!De||!Pe)return;const Y=new A.$SK(De,Pe,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(Y.isBackground=N.isBackground),N.group!==void 0&&(Y.group=A.$OK.from(N.group._id),Y.group&&N.group.isDefault&&(Y.group=new A.$OK(Y.group.id,Y.group.label),N.group.isDefault===!0&&(Y.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Y.presentationOptions=r.to(N.presentationOptions)),N._id&&(Y._id=N._id),N.detail&&(Y.detail=N.detail),Y}V.to=O})(u||(e.TaskDTO=u={}));var f;(function(V){function U(O){return O}V.from=U;function W(O){if(O)return Object.assign(Object.create(null),O)}V.to=W})(f||(f={}));class l{#e;constructor(U,W,O){this._id=W,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let R=class{constructor(U,W,O,N,ee,Z,ye,De){this.q=new C.$fd,this.r=new C.$fd,this.s=new C.$fd,this.t=new C.$fd,this.a=U.getProxy(F.$6J.MainThreadTask),this.b=O,this.c=N,this.d=ee,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,W,O){if(!O)return new A.$8J(()=>{});const N=this.w();return this.j.set(N,{type:W,provider:O,extension:U}),this.a.$registerTaskProvider(N,W),new A.$8J(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,W){this.a.$registerTaskSystem(U,W)}fetchTasks(U){return this.a.$fetchTasks(f.from(U)).then(async W=>{const O=[];for(const N of W){const ee=await u.to(N,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const U=[];return this.k.forEach(W=>U.push(W)),U}terminateTask(U){if(!(U instanceof l))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,W,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(W,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const W=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const W=await this.y(U.id);this.s.fire({execution:W,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const W=await this.y(U.id);this.t.fire({execution:W,exitCode:U.exitCode})}$provideTasks(U,W){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,M.$zg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(Z=>this.u(W,N,O,Z));return new Promise(Z=>{ee.then(ye=>{Promise.all(N).then(()=>{Z(ye)})})})}async $resolveTask(U,W){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(W.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(W,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const Z=u.from(ee,O.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(Z.execution)&&await this.x(Z,ee,!0),await this.v(Z)}w(){return this.h++}async x(U,W,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,W.execution)),this.m.set(N,W.execution)}async y(U,W){if(typeof U=="string"){const ee=this.l.get(U);if(!ee)throw new y.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(U.id);if(O)return O;const N=new Promise((ee,Z)=>{function ye(De,Pe,Y){Y?ee(new l(De,Pe.id,Y)):Z("Unexpected: Task does not exist.")}W?ye(this,U,W):u.to(U.task,this.b,this.m).then(De=>ye(this,U,De))});return this.l.set(U.id,N),N.then(ee=>(this.k.set(U.id,ee),ee),ee=>Promise.reject(ee))}z(U,W){U._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$ycc=R,e.$ycc=R=Ke([qe(0,c.$7L),qe(1,v.$kM),qe(2,h.$zbc),qe(3,k.$fM),qe(4,m.$Cbc),qe(5,D.$Ubc),qe(6,i.$5i),qe(7,s.$pbc)],R);let B=class extends R{constructor(U,W,O,N,ee,Z,ye,De){super(U,W,O,N,ee,Z,ye,De),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(W,U);if(O===void 0)throw new Error("Task is not valid");if(b.is(O.execution))await this.x(O,W,!1);else throw new y.$0;const N=await this.y(await this.a.$getTaskExecution(O),W);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),N}u(U,W,O,N){const ee=[];if(N)for(const Z of N){this.z(Z,O),(!Z.definition||!U[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=u.from(Z,O.extension);ye&&b.is(ye.execution)?(ee.push(ye),W.push(this.x(ye,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(U){if(b.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,W,O){}};e.$zcc=B,e.$zcc=B=Ke([qe(0,c.$7L),qe(1,v.$kM),qe(2,h.$zbc),qe(3,k.$fM),qe(4,m.$Cbc),qe(5,D.$Ubc),qe(6,i.$5i),qe(7,s.$pbc)],B),e.$Acc=(0,p.$Bh)("IExtHostTask")}),define(Ae[267],Re([1,0,19,21,41,37,23,59,47]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class m{constructor(c,v,p){this.k=c,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&F.$rj(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&F.$rj(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const v=this.k.folderQueries||[];return new Promise((p,g)=>{const t=i=>{this.f++,c(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const s=i.toString(),d=w.$ae(s);this.j&&this.j(s,d)||this.v(t,{base:i,basename:d})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,C.$mi)(i)))})})}async p(c,v){const p=new M.$pd,g=this.q(c),t=this.r(),i=new k.$PI(this.k,c),s=!i.hasSiblingExcludeClauses();let d;try{this.h.add(p),d=h.$bd.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,p.token),$=d.elapsed(),r=h.$bd.create();return this.g&&!this.e||(y&&y.forEach(o=>{const n=w.$6d.relative(c.folder.path,o.path);if(s){const a=w.$ae(o.path);this.v(v,{base:c.folder,relativePath:n,basename:a});return}this.s(t,c.folder,n,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:$,postProcessTime:r.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(c){const v=(0,k.$OI)(this.k.includePattern,c.includePattern),p=(0,k.$OI)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:p,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},v,p,g){if(p===this.a){const i=w.$ae(this.a);this.v(g,{base:v,relativePath:this.a,basename:i})}function t(i){const s=w.$ae(i),d=w.$_d(i);let y=c[d];y||(y=c[d]=[],t(d)),y.push({base:v,relativePath:i,basename:s})}t(p)}u({rootEntries:c,pathToEntries:v},p,g){const t=this,i=this.a;function s(d){const y=(0,k.$RI)(()=>d.map($=>$.basename));for(let $=0,r=d.length;$<r;$++){const o=d[$],{relativePath:n,basename:a}=o;if(p.matchesExcludesSync(n,a,i!==a?y:void 0))continue;const E=v[n];if(E)s(E);else{if(n===i)continue;t.v(g,o)}if(t.e)break}}s(c)}v(c,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(v))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,v,p,g){const t=this.c(c.cacheKey),i=new m(c,v,t&&t.token);let s=0;const d=y=>{s+=y.length,p(y.map($=>this.d($)))};return this.e(i,P.a,d,g).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:y.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new M.$pd),this.b.get(c)}d(c){return c.relativePath?{resource:A.$ig(c.base,c.relativePath)}:{resource:c.base}}e(c,v,p,g){const t=g.onCancellationRequested(()=>{c.cancel()}),i=d=>{d&&(s.push(d),v>0&&s.length>=v&&(p(s),s=[]))};let s=[];return c.search(i).then(d=>(s.length&&p(s),t.dispose(),d),d=>(s.length&&p(s),t.dispose(),Promise.reject(d)))}}e.$Kcc=P}),define(Ae[268],Re([1,0,18,100,37,90,28,13,19,23,15,16,2,283,168,43,14,54,103,266,47]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=void 0;let $=class{constructor(f,l,R,B,V){this.a=f,this.b=l,this.c=R,this.d=B,this.e=V}text(f,l,R={}){f=this.f(f,R);const B=this.a.getValue(),V=l&&l.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(l?.map(i.$Wh),R),type:2,contentPattern:f,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(f,l){const R=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const B={...f,wordSeparators:R.editor.wordSeparators};return this.j(f,l)&&(B.isCaseSensitive=!0),this.k(f)&&(B.isMultiline=!0),l.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=l.notebookSearchConfig.includeMarkupInput),l.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=l.notebookSearchConfig.includeMarkupPreview),l.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=l.notebookSearchConfig.includeCodeInput),l.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=l.notebookSearchConfig.includeOutput),B}file(f,l={}){return{...this.h(f,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}g(f,l){return f?(f=Array.isArray(f)?f.map(E):E(f),l?this.parseSearchPaths(f):{pattern:o(...Array.isArray(f)?f:[f])}):{}}h(f=[],l={}){const R=this.g(l.includePattern,l.expandPatterns),B=this.g(l.excludePattern,l.expandPatterns),V=f.length>1,U=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.q(N,l,B)):f.map(N=>this.r(N,l,B,V))).filter(N=>!!N),W={_reason:l._reason,folderQueries:U,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const N=w.$Fb(w.$Pb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(ye=>(0,y.$FI)(W,ye.fsPath)),Z=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...W,...Z}}const O=l.extraFileResources&&l.extraFileResources.filter(N=>(0,y.$FI)(W,N.fsPath));return W.extraFileResources=O&&O.length?O:void 0,W}i(f){const l=[],R=new A.$zi,B={};let V=!1;return f.forEach(U=>{if(U.scheme===h.Schemas.walkThrough)return;if((0,m.$mg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:k.$_d(U.fsPath)});let N=R.get(O);N||(V=!0,N={folder:O,includePattern:{}},l.push(N),R.set(O,N));const ee=k.$$d(O.fsPath,U.fsPath);(0,D.$uf)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,B[U.fsPath]=!0)}),{folderQueries:l,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(f,l){if(l.isSmartCase){if(f.isRegExp){if(P.$af(f.pattern,!0))return!0}else if(P.$af(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,v.$kB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const l=Z=>k.$8d(Z)||/^\.\.?([\/\\]|$)/.test(Z),B=(Array.isArray(f)?f:n(f)).map(Z=>{const ye=this.e.resolvedUserHome;return ye?(0,F.$kv)(Z,ye.scheme===h.Schemas.file?ye.fsPath:ye.path):Z}),V=M.$I(B,Z=>l(Z)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Z=>P.$ve(Z,"/")).map(Z=>P.$ve(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),a(Z))),W={},O=this.m(V.searchPaths||[]);O&&O.length&&(W.searchPaths=O);const N=w.$Pb(U),ee=o(...N);return ee&&(W.pattern=ee),W}l(f,l){return l.disregardExcludeSettings?void 0:(0,y.$EI)(f,!l.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const l=f.flatMap(B=>{let{pathPortion:V,globPortion:U}=r(B);return U&&(U=b(U)),this.n(V).flatMap(O=>this.o(O,U))}),R=new Map;return l.forEach(B=>{const V=B.searchPath.toString(),U=R.get(V);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?o(B.pattern):void 0})}),Array.from(R.values())}n(f){if(k.$8d(f)){const l=this.b.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==h.Schemas.file?[{searchPath:l[0].uri.with({path:f})}]:[{searchPath:c.URI.file(k.$7d(f))}]}if(this.b.getWorkbenchState()===2){const l=this.b.getWorkspace().folders[0].uri;if(f=E(f),f.startsWith("../")||f===".."){const B=k.$6d.resolve(l.path,f);return[{searchPath:l.with({path:B})}]}const R=b(f);return[{searchPath:l,pattern:R}]}else{if(f==="./"||f===".\\")return[];{const l=f.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const U=l.match(new RegExp(`^${P.$qe(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(D.$rf);if(B.length)return B.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&b(U)}});{const V=f.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:f,W=p.localize(0,null,U);throw new Error(W)}}}}o(f,l){const R=f.pattern&&l?`${f.pattern}/${l}`:f.pattern||l,B=[{searchPath:f.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:f.searchPath,pattern:R+"/**"}),B}q(f,l,R){const B=this.r((0,i.$Wh)(f.searchPath),l,R,!1);return B?{...B,includePattern:f.pattern}:null}r(f,l,R,B){let V;const U=c.URI.isUri(f)?f:f.uri;if(R.searchPaths){const Z=R.searchPaths.filter(ye=>(0,m.$bg)(ye.searchPath,U))[0];if(Z&&!Z.pattern)return null;Z&&(V=Z.pattern)}const W=this.a.getValue({resource:U}),N={...this.l(W,l)||{},...V||{}},ee=c.URI.isUri(f)?(0,m.$fg)(f):f.name;return{folder:U,folderName:B?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof l.disregardParentIgnoreFiles=="boolean"?l.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!W.search.followSymlinks}}};e.$JJ=$,e.$JJ=$=Ke([qe(0,g.$8h),qe(1,i.$Kh),qe(2,s.$7B),qe(3,t.$5i),qe(4,d.$HJ)],$);function r(u){const f=u.match(/[\*\{\}\(\)\[\]\?]/);if(f){const l=f.index,R=u.substr(0,l).match(/[/|\\][^/\\]*$/);if(R){let B=u.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((f,l)=>(f[l]=!0,f),Object.create(null)):void 0}function n(u){return C.$pj(u,",").map(f=>f.trim()).filter(f=>!!f.length)}function a(u){return[`**/${u}/**`,`**/${u}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function E(u){return u.replace(/\\/g,"/")}function b(u){return E(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(u){return u.replace(/([?*[\]])/g,"[$1]")}function I(u,f){u=w.$Kb(u,B=>B.toString());const l=[],R=f.getWorkspace();return u&&u.forEach(B=>{let V;if(f.getWorkbenchState()===2)V=(0,m.$kg)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const U=f.getWorkspaceFolder(B);if(U){const W=U.name;if(R.folders.filter(N=>N.name===W).length===1){const N=(0,m.$kg)(U.uri,B);N===""?V=`./${U.name}`:V=`./${U.name}/${N}`}else V=B.fsPath}}V&&l.push(S(V))}),l}e.$KJ=I}),define(Ae[269],Re([1,0,23,2,21,9,4,268,47,54]),function(ve,e,w,M,C,F,A,h,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flb=e.$Elb=void 0;const P=7e3;function D(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const s=[],d=[];for(const a of i)if(/^workspaceContains:/.test(a)){const E=a.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||g.forceUsingSearch?d.push(E):s.push(E)}if(s.length===0&&d.length===0)return Promise.resolve(void 0);let y;const $=new Promise((a,E)=>{y=a}),r=a=>y({activationEvent:a}),o=Promise.all(s.map(a=>c(g,a,r))).then(()=>{}),n=v(g,t.identifier,d,r);return Promise.all([o,n]).then(()=>{y(void 0)}),$}e.$Elb=D;async function c(g,t,i){for(const s of g.folders)if(await g.exists(w.$ig(M.URI.revive(s),t))){i(`workspaceContains:${t}`);return}}async function v(g,t,i,s){if(i.length===0)return Promise.resolve(void 0);const d=new C.$pd,y=g.checkExists(g.folders,i,d.token),$=setTimeout(async()=>{d.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let r=!1;try{r=await y}catch(o){F.$2(o)||F.$Y(o)}d.dispose(),clearTimeout($),r&&s(`workspaceContains:${i.join(",")}`)}function p(g,t,i,s){const d=g.get(A.$Ah),y=g.get(k.$wI),r=d.createInstance(h.$JJ).file(t.map(o=>(0,m.$Wh)(M.URI.revive(o))),{_reason:"checkExists",includePattern:i,exists:!0});return y.fileSearch(r,s).then(o=>!!o.limitHit,o=>F.$2(o)?!1:Promise.reject(o))}e.$Flb=p}),define(Ae[35],Re([1,0,149,19,87,23,12,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,72,86,63,5,269,83,191,13,81,59,22,82]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o,n,a,E,b,S,I,u,f,l,R,B,V,U,W,O,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=e.$8bc=e.$7bc=e.$6bc=void 0,e.$6bc=(0,n.$Bh)("IHostUtils");let Z=ee=class extends h.$kc{constructor(ie,z,q,ue,we,be,ge,ke,re,he,se,oe){super(),this.X=oe,this.a=this.B(new f.$fd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=ge,this.j=ue,this.m=we,this.s=be,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(D.$6J.MainThreadWorkspace),this.z=this.g.getProxy(D.$6J.MainThreadTelemetry),this.C=this.g.getProxy(D.$6J.MainThreadExtensionService),this.D=new A.$Fg,this.F=new A.$Fg,this.G=new A.$Fg,this.H=new A.$Fg,this.I=new ce(this.f.extensions.activationEvents),this.L=new i.$O3b(this.I,this.f.extensions.allExtensions);const fe=new d.$Wl(this.f.extensions.myExtensions);this.J=new i.$O3b(this.I,le(this.L,fe)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new p.$Mbc(this.g,this.s),this.N=new R.$Ybc(this.g),this.O=ke,this.h=ie.createChild(new S.$zh([p.$Nbc,this.M],[R.$Zbc,this.N])),this.P=this.B(new v.$Lbc(this.J,this.L,{onExtensionActivationError:(Ie,T,K)=>{this.C.$onExtensionActivationError(Ie,s.$1(T),K)},actualActivateExtension:async(Ie,T)=>{if(i.$O3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,T),new v.$Kbc;const K=this.J.getExtensionDescription(Ie);return this.db(K,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){s.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),s.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Hg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new d.$Vl(z.identifier.value),extensionLocation:m.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return m.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Ee(ie))),this.Q}async bb(ie){const z=k.$Hh.forUris(q=>F.$_f.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const ue=await this.ab(q.extensionLocation);z.set(ue,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(ue)}try{(0,h.$fc)(q.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(ue)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const ue=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(ie,z,"success",ue),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,ue){const we=De(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...ue||{},outcome:q})}fb(ie,z){const q=De(ie,z);this.z.$publicLog2("activatePlugin",q);const ue=this.ub(ie);if(!ue)return Promise.resolve(new v.$Jbc(v.$Gbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new v.$Hbc(z.startup);return Promise.all([this.vb(ie,(0,F.$ig)(ie.extensionLocation,ue),we),this.gb(ie)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,be[0],be[1],we))).then(be=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),be))}gb(ie){const z=new $.$Pbc(ie,this.M),q=new $.$Obc(ie.identifier.value,!1,this.M),ue=new B.$1bc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,be=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const ge=this;let ke,re;const he=(0,t.$3E)(ie,"ipc")?this.f.messagePorts?.get(d.$Vl.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:ue,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return M.$9d(ie.extensionLocation.fsPath,se)},get storagePath(){return ge.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return ge.O.globalValue(ie).fsPath},get logPath(){return M.$9d(ge.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return m.URI.joinPath(ge.f.logsLocation,ie.identifier.value)},get storageUri(){return ge.O.workspaceValue(ie)},get globalStorageUri(){return ge.O.globalValue(ie)},get extensionMode(){return we},get extension(){return ke===void 0&&(ke=new Y(ge,ie.identifier,ie,be,!1)),ke},get extensionRuntime(){return(0,t.$4E)(ie,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=f.Event.buffer(f.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,q,ue,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,ue,we).then(be=>new v.$Ibc(!1,null,we.build(),q,be,ue.subscriptions))}static ib(ie,z,q,ue,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const be=typeof global=="object"?global:self,ge=q.activate.apply(be,[ue]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ge).then(ke=>(we.activateResolveStop(),ke))}catch(be){return Promise.reject(be)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const ue=Date.now();(0,O.$A)(()=>{for(let we=z;we<ie.length;we+=1){const be=ie[we];for(const ge of be.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-ue>50){this.kb(ie,we);break}else this.jb(be,ge)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const ue of q)if(ue.activationEvents)for(const we of ue.activationEvents)we==="onStartupFinished"&&this.jb(ue,we)})}mb(){const ie=this.Z("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.nb(be.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),ue=this.pb(),we=Promise.all([ue,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Hg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:ie.map(be=>be.uri),forceUsingSearch:q||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ge,ke)=>this.y.$checkExists(be,ge,ke)},we=await(0,l.$Elb)(ue,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,be=>this.s.error(be))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new v.$Hbc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((ue,we)=>{const be=(re,he)=>{re?(O.$s&&this.s.error("Test runner called back with error",re),we(re)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof he=="number"&&he>0?1:0))},ge=(0,F.$9f)(z),ke=q.run(ge,be);ke&&ke.then&&ke.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),ue(0)}).catch(re=>{O.$s&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Hg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,h.$ic)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$bK("Not an authority that can be resolved!",o.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=W.$bd.create(!1),ue=()=>`[resolveAuthority(${(0,o.$Nk)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${ue()}${Q}`),be=Q=>this.s.warn(`${ue()}${Q}`),ge=(Q,J=void 0)=>this.s.error(`${ue()}${Q}`,J),ke=Q=>{if(Q instanceof r.$bK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Q);if(!J)throw ge(`no resolver for ${x}`),new r.$bK(`No remote extension installed to resolve ${x}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$bK)||Q._code!==o.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return be(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return ke(Q)}const oe=new A.$Rg;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[Q,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$aK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$bK(`Exec server was not available for ${ae}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Oe){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),ge("returned an error",Oe),oe.dispose(),ke(Oe)}oe.dispose();const T={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$aK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(r.$aK.isManagedResolvedAuthority(fe)){const Q=z;this.X.setFactory(Q,fe.makeConnection),G={authority:ie,connectTo:new o.$Kk(Q),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new o.$Lk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:T}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,o.$Nk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const ue=m.URI.revive(z);if(typeof q.getCanonicalURI>"u")return ue;const we=await(0,A.$zg)(()=>q.getCanonicalURI(ue));return we||ue}$startExtensionHost(ie){ie.toAdd.forEach(ue=>ue.extensionLocation=m.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(be=>be.extensionLocation=m.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie),ue=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=y.$Fd.alloc(ie),q=Math.random()%256;for(let ue=0;ue<ie;ue++)z.writeUInt8(q,ue);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$7bc=Z,e.$7bc=Z=ee=Ke([qe(0,n.$Ah),qe(1,e.$6bc),qe(2,b.$7L),qe(3,g.$zbc),qe(4,c.$Cbc),qe(5,P.$5i),qe(6,a.$kM),qe(7,E.$Sbc),qe(8,I.$zsb),qe(9,u.$Ubc),qe(10,U.$3bc),qe(11,N.$4bc)],Z);function ye($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const ue=new i.$O3b($e,ie.getAllExtensionDescriptions());ue.deltaExtensions(q.toAdd,q.toRemove);const we=new d.$Wl(z.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of q.myToRemove)we.delete(ge);for(const ge of q.myToAdd)we.add(ge);const be=le(ue,we);return{globalRegistry:ue,myExtensions:be}}function De($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$8bc=(0,n.$Bh)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(ie,z,q,ue,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=M.$7d((0,F.$9f)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=ue,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9bc=Y;function le($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Ee{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$0bc=Ee;class ce{constructor(ie){this.a=new d.$Xl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[270],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;let g=class{constructor(y,$,r,o,n,a,E){this.c=y,this.d=$,this.e=r,this.f=o,this.g=n,this.h=a,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const y=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const $=await this.g.getExtensionPathIndex();this.register(new i(this.c,$,this.d,y,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(s,$,this.h.environment.appUriScheme))}register(y){if("nodeModuleName"in y)if(Array.isArray(y.nodeModuleName))for(const $ of y.nodeModuleName)this.a.set($,y);else this.a.set(y.nodeModuleName,y);typeof y.alternativeModuleName=="function"&&this.b.push($=>y.alternativeModuleName($))}};e.$udc=g,e.$udc=g=Ke([qe(2,P.$Ah),qe(3,F.$Cbc),qe(4,D.$8bc),qe(5,m.$kM),qe(6,c.$5i)],g);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(y){if(y.environment.appRoot&&p.a.size){const $=(0,v.$qe)(this.c(y.environment.appRoot.fsPath)),r="[a-z0-9_.-]",o=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${$}/${n}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(y){if(!this.b)return;const $=this.b.exec(this.c(y));if(!$)return;const[,r,o,n]=$,a=p.a.get(o);if(a!==void 0)return console.warn(`${o} as been renamed to ${a}, please update your imports`),r+a+n}c(y){return y.replace(/\\/g,"/")}};t=p=Ke([qe(0,m.$kM)],t);class i{constructor(y,$,r,o,n){this.c=y,this.d=$,this.e=r,this.f=o,this.g=n,this.nodeModuleName="vscode",this.a=new h.$Xl}load(y,$){const r=this.d.findSubstr($);if(r){let o=this.a.get(r.identifier);return o||(o=this.c(r,this.e,this.f),this.a.set(r.identifier,o)),o}if(!this.b){let o="";this.d.forEach((n,a)=>o+=`	${a} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${$}. These are the extension path mappings: 
${o}`),this.b=this.c(A.$XE,this.e,this.f)}return this.b}}let s=class{constructor(y,$,r){this.e=y,this.f=$,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$6J.MainThreadTelemetry);const o=r.getProxy(C.$6J.MainThreadWindow);this.c=(n,a)=>{const E=M.URI.parse(n);return a?this.g(n,a):E.scheme==="http"||E.scheme==="https"?o.$openUri(E,n,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?o.$openUri(E,n,{}):this.g(n,a)}}load(y,$,r){const o=this.e.findSubstr($);return o&&(this.a=o.identifier.value,this.h()),this.b=r(y),this.c}g(y,$){return this.i(),this.b(y,$)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=Ke([qe(2,k.$7L)],s)}),define(Ae[113],Re([1,0,66,6,19,74,4,60,61,35,7,33,201,34]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0,e.$Dcc=(0,A.$Bh)("IExtHostVariableResolverProvider");class p extends c.$8M{constructor(i,s,d,y,$,r,o){function n(){if(d){const a=d.activeEditor();if(a)return a.document.uri;const E=y.tabGroups.all.find(b=>b.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof P.$NL||E.input instanceof P.$SL)return E.input.modified;if(E.input instanceof P.$ML||E.input instanceof P.$RL||E.input instanceof P.$PL)return E.input.uri}}}super({getFolderUri:a=>{const E=r.folders.filter(b=>b.name===a);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(a,E)=>$.getConfiguration(void 0,a).get(E),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=n();if(a)return C.$7d(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const a=n();if(a){const E=s.getWorkspaceFolder(a);if(E)return C.$7d(E.uri.fsPath)}}},getSelectedText:()=>{if(d){const a=d.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(d){const a=d.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>i.getExtension(a)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(F.env))}}let g=class extends M.$kc{constructor(i,s,d,y,$){super(),this.b=i,this.c=s,this.g=d,this.h=y,this.j=$,this.a=new w.$T(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,r,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ecc=g,e.$Ecc=g=Ke([qe(0,m.$8bc),qe(1,D.$zbc),qe(2,h.$fM),qe(3,v.$Cbc),qe(4,k.$Bcc)],g)}),define(Ae[114],Re([1,0,12,5,2,4,3,61,35,17,7,33,194,196,34,113]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=void 0,e.$Fcc=(0,F.$Bh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,n,a,E,b,S){this.E=n,this.F=a,this.G=E,this.H=b,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$fd,this.n=new M.$fd,this.o=new M.$fd,this.u=new M.$fd,this.k=o.getProxy(A.$6J.MainThreadDebugService),this.y=new M.$fd,this.A=new M.$fd,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(u=>{this.J(I)}),this.J(I)})}asDebugSourceUri(o,n){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let E=`debug:${encodeURIComponent(a.path||"")}`,b="?";return n&&(E+=`${b}session=${encodeURIComponent(n.id)}`,b="&"),E+=`${b}ref=${a.sourceReference}`,C.URI.parse(E)}else{if(a.path)return C.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(o){const n=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const E=a.contributes.debuggers;if(E&&E.length>0)for(const b of E)(0,v.$jF)(b)&&n.push(b.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const o=[];return this.w.forEach(n=>o.push(n)),o}addBreakpoints(o){const n=o.filter(b=>{const S=b.id;return this.w.has(S)?!1:(this.w.set(S,b),!0)});this.U(n,[],[]);const a=[],E=new Map;for(const b of n)if(b instanceof P.$7K){let S=E.get(b.location.uri.toString());S||(S={type:"sourceMulti",uri:b.location.uri,lines:[]},E.set(b.location.uri.toString(),S),a.push(S)),S.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof P.$8K&&a.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this.k.$registerBreakpoints(a)}removeBreakpoints(o){const n=o.filter(S=>this.w.delete(S.id));this.U([],n,[]);const a=n.filter(S=>S instanceof P.$7K).map(S=>S.id),E=n.filter(S=>S instanceof P.$8K).map(S=>S.id),b=n.filter(S=>S instanceof P.$9K).map(S=>S.id);return this.k.$unregisterBreakpoints(a,E,b)}startDebugging(o,n,a){return this.k.$startDebugging(o?o.uri:void 0,n,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,n,a){if(!n)return new P.$8J(()=>{});const E=this.d++;return this.f.push({type:o,handle:E,provider:n}),this.k.$registerDebugConfigurationProvider(o,a,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,E),new P.$8J(()=>{this.f=this.f.filter(b=>b.provider!==n),this.k.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,n,a){if(!a)return new P.$8J(()=>{});if(!this.Q(o,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:n,handle:E,factory:a}),this.k.$registerDebugAdapterDescriptorFactory(n,E),new P.$8J(()=>{this.h=this.h.filter(b=>b.factory!==a),this.k.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,n){if(!n)return new P.$8J(()=>{});const a=this.i++;return this.j.push({type:o,handle:a,factory:n}),new P.$8J(()=>{this.j=this.j.filter(E=>E.factory!==n)})}async $runInTerminal(o,n){return Promise.resolve(void 0)}async $substituteVariables(o,n){let a;const E=await this.W(o);return E&&(a={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(a,n)}K(o,n){if(o.type==="implementation")return new y(o.implementation)}L(){}async $startDASession(o,n){const a=this,E=await this.V(n);return this.S(this.N(E.type),E).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const S=this.M(b),I=this.K(S,E);if(!I)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const u=I;return this.B.set(o,u),this.R(E).then(f=>(f&&this.C.set(o,f),u.onMessage(async l=>{if(l.type==="request"&&l.command==="handshake"){const R=l,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},u.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,u.sendResponse(B)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(l),l=(0,v.$oF)(l,!0),a.k.$acceptDAMessage(o,l)}),u.onError(l=>{f&&f.onError&&f.onError(l),this.k.$acceptDAError(o,l.name,l.message,l.stack)}),u.onExit(l=>{f&&f.onExit&&f.onExit(l??void 0,void 0),this.k.$acceptDAExit(o,l??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),u.startSession()))})}$sendDAMessage(o,n){n=(0,v.$nF)(n,!1);const a=this.C.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(n),this.B.get(o)?.sendMessage(n)}$stopDASession(o){const n=this.C.get(o);this.C.delete(o),n&&n.onWillStopSession&&n.onWillStopSession();const a=this.B.get(o);return this.B.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const n=[],a=[],E=[];if(o.added)for(const b of o.added){const S=b.id;if(S&&!this.w.has(S)){let I;if(b.type==="function")I=new P.$8K(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")I=new P.$9K(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const u=C.URI.revive(b.uri);I=new P.$7K(new P.$hK(u,new P.$9J(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}(0,P.$5K)(I,S),this.w.set(S,I),n.push(I)}}if(o.removed)for(const b of o.removed){const S=this.w.get(b);S&&(this.w.delete(b),a.push(S))}if(o.changed){for(const b of o.changed)if(b.id){const S=this.w.get(b.id);if(S){if(S instanceof P.$8K&&b.type==="function"){const I=S;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.functionName=b.functionName}else if(S instanceof P.$7K&&b.type==="source"){const I=S;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.location=new P.$hK(C.URI.revive(b.uri),new P.$9J(b.line,b.character))}E.push(S)}}}this.U(n,a,E)}async $acceptStackFrameFocus(o){let n;const a=o.sessionId?await this.V(o.sessionId):void 0;if(!a)throw new Error("no DebugSession found for debug focus context");o.kind==="thread"?n=new P.$cL(a,o.threadId):n=new P.$bL(a,o.threadId,o.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(o,n,a){return(0,w.$zg)(async()=>{const E=this.P(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.W(n);return E.provideDebugConfigurations(b,a)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,n,a,E){return(0,w.$zg)(async()=>{const b=this.P(o);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(n);return b.resolveDebugConfiguration(S,a,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,n,a,E){return(0,w.$zg)(async()=>{const b=this.P(o);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(n);return b.resolveDebugConfigurationWithSubstitutedVariables(S,a,E)})}async $provideDebugAdapter(o,n){const a=this.O(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.V(n);return this.S(a,E).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.M(b)})}async $acceptDebugSessionStarted(o){const n=await this.V(o);this.m.fire(n)}async $acceptDebugSessionTerminated(o){const n=await this.V(o);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,n){(await this.V(o))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(o,n){const E={session:await this.V(o),event:n.event,body:n.body};this.u.fire(E)}M(o){if(o instanceof P.$0K)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof P.$$K)return{type:"server",port:o.port,host:o.host};if(o instanceof P.$_K)return{type:"pipeServer",path:o.path};if(o instanceof P.$aL)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}N(o){const n=this.h.filter(a=>a.type===o);if(n.length>0)return n[0].factory}O(o){const n=this.h.filter(a=>a.handle===o);if(n.length>0)return n[0].factory}P(o){const n=this.f.filter(a=>a.handle===o);if(n.length>0)return n[0].provider}Q(o,n){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const E of a)if(E.label&&E.type&&E.type===n)return!0}}return!1}R(o){const a=o.configuration.type,E=this.j.filter(b=>b.type===a||b.type==="*").map(b=>(0,w.$zg)(()=>b.factory.createDebugAdapterTracker(o)).then(S=>S,S=>null));return Promise.race([Promise.all(E).then(b=>{const S=b.filter(I=>!!I);if(S.length>0)return new d(S)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async S(o,n){const a=n.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new P.$$K(a));if(o){const b=await this.F.getExtensionRegistry();return(0,w.$zg)(()=>o.createDebugAdapterDescriptor(n,this.T(n,b))).then(S=>{if(S)return S})}const E=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,E))}T(o,n){}U(o,n,a){(o.length>0||n.length>0||a.length>0)&&this.y.fire(Object.freeze({added:o,removed:n,changed:a}))}async V(o){if(o)if(typeof o=="string"){const n=this.l.get(o);if(n)return n}else{let n=this.l.get(o.id);if(!n){const a=await this.W(o.folderUri),E=o.parent?this.l.get(o.parent):void 0;n=new i(this.k,o.id,o.type,o.name,a,o.configuration,E),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(o){if(o){const n=C.URI.revive(o);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$Gcc=t,e.$Gcc=t=Ke([qe(0,m.$7L),qe(1,D.$zbc),qe(2,k.$8bc),qe(3,p.$Cbc),qe(4,h.$Bcc),qe(5,g.$Dcc)],t);class i{constructor(o,n,a,E,b,S,I){this.d=o,this.f=n,this.g=a,this.h=E,this.i=b,this.j=S,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,n){return this.d.$customDebugAdapterRequest(this.f,o,n)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.$Hcc=i;class s{constructor(o){this.value=Object.freeze({append(n){o.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$Icc=s;class d{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(n=>n.onError?n.onError(o):void 0)}onExit(o,n){this.d.forEach(a=>a.onExit?a.onExit(o,n):void 0)}}class y extends c.$Jcb{constructor(o){super(),this.h=o,o.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends t{constructor(o,n,a,E,b,S){super(o,n,a,E,b,S)}};e.$Jcc=$,e.$Jcc=$=Ke([qe(0,m.$7L),qe(1,D.$zbc),qe(2,k.$8bc),qe(3,p.$Cbc),qe(4,h.$Bcc),qe(5,g.$Dcc)],$)}),define(Ae[271],Re([1,0,9,87,2,3,262,14,71,72,27,173,17,56,35,58]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;class t{static async installEarlyHandler(d){Error.stackTraceLimit=100;const y=d.get(h.$5i),r=d.get(c.$7L).getProxy(F.$6J.MainThreadErrors);w.setUnexpectedErrorHandler(o=>{y.error(o);const n=w.$1(o);r.$onUnexpectedError(n)})}static async installFullHandler(d){const y=d.get(h.$5i),$=d.get(c.$7L),r=d.get(p.$8bc),o=d.get(g.$oM),n=$.getProxy(F.$6J.MainThreadExtensionService),a=$.getProxy(F.$6J.MainThreadErrors),E=await r.getExtensionPathIndex(),b=new WeakMap;function S(f,l){if(b.has(f))return b.get(f).stack;let R="",B,V;for(const W of l)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=E.findSubstr(C.URI.file(V)));const U=`${f.name||"Error"}: ${f.message||""}${R}`;return b.set(f,{extensionIdentifier:B?.identifier,stack:U}),U}const I=Symbol("prepareStackTrace wrapped");let u=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(f){if(f===S||!f||f[I]){u=f||S;return}u=function(l,R){return S(l,R),f.call(Error,l,R)},Object.assign(u,{[I]:!0})}}),w.setUnexpectedErrorHandler(f=>{y.error(f);const l=w.$1(f),R=b.get(f);if(!R?.extensionIdentifier){a.$onUnexpectedError(l);return}n.$onExtensionRuntimeError(R.extensionIdentifier,l);const B=o.onExtensionError(R.extensionIdentifier,f);y.trace("forwarded error to extension?",B,R)})}}e.$vdc=t;class i{constructor(d,y,$,r,o){this.a=$,this.b=new A.$X3b(d,null,r),y=i.e(y,this.b);const n=new m.$zh(...(0,k.$nr)());n.set(P.$kM,{_serviceBrand:void 0,...y,messagePorts:o}),n.set(c.$7L,new c.$8L(this.b)),n.set(v.$wbc,new v.$xbc(r)),n.set(p.$6bc,$);const a=new D.$6p(n,!0);a.invokeFunction(t.installEarlyHandler),this.d=a.invokeFunction(E=>E.get(h.$5i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=a.invokeFunction(E=>E.get(p.$8bc)),this.c.initialize(),a.invokeFunction(t.installFullHandler)}async asBrowserUri(d){const y=this.b.getProxy(F.$6J.MainThreadExtensionService);return C.URI.revive(await y.$asBrowserUri(d))}terminate(d){this.c.terminate(d)}static e(d,y){d.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(y.transformIncomingURIs(r.extensionLocation))}),d.environment.appRoot=C.URI.revive(y.transformIncomingURIs(d.environment.appRoot));const $=d.environment.extensionDevelopmentLocationURI;return $&&(d.environment.extensionDevelopmentLocationURI=$.map(r=>C.URI.revive(y.transformIncomingURIs(r)))),d.environment.extensionTestsLocationURI=C.URI.revive(y.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=C.URI.revive(y.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=C.URI.revive(y.transformIncomingURIs(d.environment.workspaceStorageHome)),d.environment.extensionTelemetryLogResource=C.URI.revive(y.transformIncomingURIs(d.environment.extensionTelemetryLogResource)),d.nlsBaseUrl=C.URI.revive(y.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=C.URI.revive(y.transformIncomingURIs(d.logsLocation)),d.workspace=y.transformIncomingURIs(d.workspace),d}}e.$wdc=i}),define(Ae[272],Re([1,0,18,12,21,41,13,19,23,2,47]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=e.$Mcc=e.$Lcc=void 0;class D{constructor(s,d,y,$){this.d=s,this.e=d,this.f=y,this.g=$,this.a=null,this.b=!1,this.c=0}search(s,d){const y=this.d.folderQueries||[],$=new C.$pd(d);return new Promise((r,o)=>{this.a=new v(s);let n=!1;const a=(E,b)=>{if(!n&&!this.b){const S=this.h(E);g(E)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,n=!0,$.cancel(),E=this.j(E,this.d.maxResults-this.c));const I=this.h(E);this.c+=I,(I>0||!g(E))&&this.a.add(E,b)}};Promise.all(y.map((E,b)=>this.k(E,S=>a(S,b),$.token))).then(E=>{$.dispose(),this.a.flush();const b=E.some(S=>!!S&&!!S.limitHit);r({limitHit:this.b||b,messages:(0,w.$Pb)(E.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},E=>{$.dispose();const b=(0,F.$mi)(E);o(new Error(b))})})}h(s){return g(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,d){const y=Array.isArray(s.ranges)?s.ranges:[s.ranges],$=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:y.slice(0,d),preview:{matches:$.slice(0,d),text:s.preview.text},uri:s.uri}}async k(s,d,y){const $=new P.$PI(this.d,s),r=[],o={report:E=>{if(!this.l(E))return;const b=s.folder.scheme===A.Schemas.file?(0,P.$QI)(()=>this.f.readdir(k.$hg(E.uri))):void 0,S=k.$kg(s.folder,E.uri);if(S){const I=$.includedInQuery(S,h.$ae(S),b);(0,M.$tg)(I)?r.push(I.then(u=>{u&&d(E)})):I&&d(E)}}},n=this.n(s),a=await this.e.provideTextSearchResults(c(this.d.contentPattern),n,o,y);return r.length&&await Promise.all(r),a}l(s){if(g(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const d=(0,P.$OI)(this.d.includePattern,s.includePattern),y=(0,P.$OI)(this.d.excludePattern,s.excludePattern),$={folder:m.URI.from(s.folder),excludes:y,includes:d,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return $.usePCRE2=this.d.usePCRE2,$}}e.$Lcc=D;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new t(512,d=>this.g(d))}add(s,d){this.d&&(this.b!==d||!k.$bg(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=d,this.d={resource:s.uri,results:[]}),this.d.results.push(p(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$Mcc=v;function p(i){return g(i)?{preview:{matches:(0,w.$Zb)(i.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:i.preview.text},ranges:(0,w.$Zb)(i.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$Ncc=g;class t{static{this.a=4e3}static{this.b=50}constructor(s,d){this.g=s,this.h=d,this.c=0,this.d=[],this.e=0}addItem(s,d){s&&this.j(s,d)}addItems(s,d){s&&this.k(s,d)}j(s,d){this.d.push(s),this.e+=d,this.l()}k(s,d){this.d=this.d.concat(s),this.e+=d,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Occ=t}),define(Ae[115],Re([1,0,6,3,4,267,17,56,14,2,272]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=void 0,e.$Pcc=(0,C.$Bh)("IExtHostSearch");let D=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(M.$6J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$Kcc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,w.$ic)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,w.$ic)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,s){const d=c(i),y=this.h.get(g);if(y)return this.j.fileSearch(d,y,$=>{this.c.$handleFileMatch(g,t,$.map(r=>r.resource))},s);throw new Error("unknown provider: "+g)}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,s){const d=this.e.get(g);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const y=c(i);return this.q(y,d).search(r=>this.c.$handleTextMatch(g,t,r),s)}$enableExtensionHostSearch(){}q(g,t){return new P.$Lcc(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Qcc=D,e.$Qcc=D=Ke([qe(0,A.$7L),qe(1,h.$wbc),qe(2,k.$5i)],D);function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>m.URI.revive(g))}}e.$Rcc=c;function v(p){return{...p,folder:m.URI.revive(p.folder)}}}),define(Ae[273],Re([1,0,21,9,5,29,2,136,284,125,134,38,3,79,226,225,31,227,34,229,230,231,204,232,60,35,234,235,240,241,243,110,208,249,250,252,84,63,254,211,8,7,53,257,64,109,33,20,199,239,52,108,112,114,115,14,56,17,27,244,197,86,80,218,255,85,62,260,258,259,219,39,253,256,83,61,58,245,111,246,13,95,207,190,237,6,26,195,81,186,247,248,220,236,206,238,82,251,222,223,224,217,233,221]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o,n,a,E,b,S,I,u,f,l,R,B,V,U,W,O,N,ee,Z,ye,De,Pe,Y,le,Ee,ce,$e,ie,z,q,ue,we,be,ge,ke,re,he,se,oe,fe,Ie,T,K,G,Q,J,x,ae,Oe,Ue,Qe,He,et,Ye,xe,it,tt,ze,st,_,X,pe,je,Ne,Xe,nt,dt,wt,Pt,Xt,Kt,pt,jt,Nt,Bt,At,Rt,zt,Wt,Jt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;function qt(ot){const ft=ot.get(re.$kM),Mt=ot.get(Oe.$mbc),Tt=ot.get(G.$Rbc),It=ot.get(a.$8bc),ht=ot.get(le.$zbc),Dt=ot.get(Ye.$oM),kt=ot.get(s.$Cbc),Ft=ot.get(ge.$wbc),Ve=ot.get(ke.$7L),Ce=ot.get(U.$Nbc),Me=ot.get(K.$Sbc),me=ot.get(be.$6i),H=ot.get(be.$5i),Te=ot.get(oe.$zsb),Be=ot.get(fe.$pbc),Ge=ot.get(Y.$tcc),We=ot.get(He.$Zbc),_e=ot.get(et.$Bcc),$t=ot.get(Nt.$4bc);Ve.set(c.$7J.ExtHostFileSystemInfo,Mt),Ve.set(c.$7J.ExtHostLogLevelServiceShape,me),Ve.set(c.$7J.ExtHostWorkspace,ht),Ve.set(c.$7J.ExtHostConfiguration,kt),Ve.set(c.$7J.ExtHostExtensionService,It),Ve.set(c.$7J.ExtHostStorage,Ce),Ve.set(c.$7J.ExtHostTunnelService,Te),Ve.set(c.$7J.ExtHostWindow,Ge),Ve.set(c.$7J.ExtHostSecretState,We),Ve.set(c.$7J.ExtHostTelemetry,Dt),Ve.set(c.$7J.ExtHostEditorTabs,_e),Ve.set(c.$7J.ExtHostManagedSockets,$t);const Ct=Ve.set(c.$7J.ExtHostDecorations,ot.get(z.$xcc)),bt=Ve.set(c.$7J.ExtHostDocumentsAndEditors,ot.get(n.$fM)),ut=Ve.set(c.$7J.ExtHostCommands,ot.get(t.$qM)),mt=Ve.set(c.$7J.ExtHostTerminalService,ot.get(W.$Ubc)),yt=Ve.set(c.$7J.ExtHostDebugService,ot.get(ue.$Fcc)),gi=Ve.set(c.$7J.ExtHostSearch,ot.get(we.$Pcc)),Ht=Ve.set(c.$7J.ExtHostTask,ot.get(q.$Acc)),Zt=Ve.set(c.$7J.ExtHostOutputService,ot.get(f.$dcc)),si=Ve.set(c.$7J.ExtHostLocalization,ot.get(nt.$3bc)),Di=Ve.set(c.$7J.ExtHostUrls,new De.$mcc(Ve)),St=Ve.set(c.$7J.ExtHostDocuments,new o.$kbc(Ve,bt)),Zi=Ve.set(c.$7J.ExtHostDocumentContentProviders,new $.$Ebc(Ve,bt,H)),un=Ve.set(c.$7J.ExtHostDocumentSaveParticipant,new r.$Fbc(H,St,Ve.getProxy(c.$6J.MainThreadBulkEdits))),vt=Ve.set(c.$7J.ExtHostNotebook,new he.$Vcc(Ve,ut,bt,St,Tt)),mi=Ve.set(c.$7J.ExtHostNotebookDocuments,new X.$bdc(vt)),$i=Ve.set(c.$7J.ExtHostNotebookEditors,new _.$adc(H,vt)),oi=Ve.set(c.$7J.ExtHostNotebookKernels,new xe.$0cc(Ve,ft,vt,ut,H)),ki=Ve.set(c.$7J.ExtHostNotebookRenderers,new tt.$_cc(Ve,vt)),Si=Ve.set(c.$7J.ExtHostNotebookDocumentSaveParticipant,new pt.$hdc(H,vt,Ve.getProxy(c.$6J.MainThreadBulkEdits))),Lt=Ve.set(c.$7J.ExtHostEditors,new O.$kcc(Ve,bt)),pi=Ve.set(c.$7J.ExtHostTreeViews,new N.$lcc(Ve.getProxy(c.$6J.MainThreadTreeViews),ut,H)),Ii=Ve.set(c.$7J.ExtHostEditorInsets,new ce.$ucc(Ve.getProxy(c.$6J.MainThreadEditorInsets),Lt,ft.remote)),ai=Ve.set(c.$7J.ExtHostDiagnostics,new d.$obc(Ve,H,Mt,bt)),ci=Ve.set(c.$7J.ExtHostLanguages,new I.$acc(Ve,St,ut.converter,Ft)),ct=Ve.set(c.$7J.ExtHostLanguageFeatures,new S.$sbc(Ve,Ft,St,ut,ai,H,Be,Dt)),Ci=Ve.set(c.$7J.ExtHostFileSystem,new E.$$bc(Ve,ct)),Yt=Ve.set(c.$7J.ExtHostFileSystemEventService,new b.$_bc(Ve,H,bt)),ii=Ve.set(c.$7J.ExtHostQuickOpen,(0,R.$fcc)(Ve,ht,ut)),vi=Ve.set(c.$7J.ExtHostSCM,new B.$hcc(Ve,ut,St,H)),Yi=Ve.set(c.$7J.ExtHostQuickDiff,new Pt.$edc(Ve,Ft)),Pi=Ve.set(c.$7J.ExtHostShare,new Bt.$jdc(Ve,Ft)),Ai=Ve.set(c.$7J.ExtHostComments,(0,i.$vbc)(Ve,ut,St)),Ri=Ve.set(c.$7J.ExtHostProgress,new l.$ecc(Ve.getProxy(c.$6J.MainThreadProgress))),_i=Ve.set(c.$7J.ExtHosLabelService,new $e.$vcc(Ve)),Mi=Ve.set(c.$7J.ExtHostTheming,new se.$Wcc(Ve)),ui=Ve.set(c.$7J.ExtHostAuthentication,new Ie.$Xcc(Ve)),xi=Ve.set(c.$7J.ExtHostTimeline,new T.$Zcc(Ve,ut)),Ti=Ve.set(c.$7J.ExtHostWebviews,new Pe.$pcc(Ve,ft.remote,ht,H,Be)),Fi=Ve.set(c.$7J.ExtHostWebviewPanels,new x.$2cc(Ve,Ti,ht)),Li=Ve.set(c.$7J.ExtHostCustomEditors,new J.$3cc(Ve,St,Me,Ti,Fi)),Oi=Ve.set(c.$7J.ExtHostWebviewViews,new Q.$1cc(Ve,Ti)),hi=Ve.set(c.$7J.ExtHostTesting,new Ue.$5cc(Ve,ut,bt)),ln=Ve.set(c.$7J.ExtHostUriOpeners,new Qe.$9cc(Ve)),en=Ve.set(c.$7J.ExtHostProfileContentHandlers,new wt.$ddc(Ve));Ve.set(c.$7J.ExtHostInteractive,new pe.$cdc(Ve,vt,bt,ut,H));const Ni=Ve.set(c.$7J.ExtHostInlineChat,new Kt.$gdc(Ve,ut,St,H)),di=Ve.set(c.$7J.ExtHostChatProvider,new At.$kdc(Ve,H)),tn=Ve.set(c.$7J.ExtHostChatSlashCommands,new Rt.$ldc(Ve,di,H)),nn=Ve.set(c.$7J.ExtHostChatAgents,new Vt.$pdc(Ve,di,H)),hn=Ve.set(c.$7J.ExtHostChatVariables,new zt.$mdc(Ve)),ni=Ve.set(c.$7J.ExtHostChat,new Xt.$fdc(Ve,H)),zi=Ve.set(c.$7J.ExtHostAiRelatedInformation,new Wt.$ndc(Ve)),xt=Ve.set(c.$7J.ExtHostAiEmbeddingVector,new Jt.$odc(Ve)),bi=Ve.set(c.$7J.ExtHostIssueReporter,new jt.$idc(Ve)),rn=Ve.set(c.$7J.ExtHostStatusBar,new V.$jcc(Ve,ut.converter)),Gt=Object.values(c.$7J);Ve.assertRegistered(Gt);const wi=new ae.$4cc(Ve,bt),sn=new g.$ubc(Ve),yi=new u.$bcc(Ve,H),Ui=new y.$Dbc(Ve);return p.$tbc.register(ut),function(Le,ei,ji){const gt=function(){let te=!Le.isUnderDevelopment;function de(){te||(H.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")de();else{const Et=rt;typeof Et.scheme>"u"&&de(),typeof Et.exclusive=="boolean"&&(0,Ne.$4E)(Le,"documentFiltersExclusive")}return rt}}(),dn={getSession(te,de,Fe){return ui.getSession(Le,te,de,Fe)},getSessions(te,de){return(0,Ne.$4E)(Le,"authGetSessions"),ui.getSessions(Le,te,de)},async hasSession(te,de){return(0,Ne.$4E)(Le,"authSession"),!!await ui.getSession(Le,te,de,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(te,de,Fe,rt){return ui.registerAuthenticationProvider(te,de,Fe,rt)}},fn={registerCommand(te,de,Fe){return ut.registerCommand(!0,te,de,Fe,void 0,Le)},registerTextEditorCommand(te,de,Fe){return ut.registerCommand(!0,te,(...rt)=>{const Et=Lt.getActiveTextEditor();if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return Et.edit(Ot=>{de.apply(Fe,[Et,Ot,...rt])}).then(Ot=>{Ot||H.warn("Edits from command "+te+" were not applied.")},Ot=>{H.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,de,Fe)=>((0,Ne.$4E)(Le,"diffCommand"),ut.registerCommand(!0,te,async(...rt)=>{const Et=bt.activeEditor(!0);if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(Et.id);de.apply(Fe,[Ot,...rt])},void 0,void 0,Le)),executeCommand(te,...de){return ut.executeCommand(te,...de)},getCommands(te=!1){return ut.getCommands(te)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$4E)(Le,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$4E)(Le,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$nM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ye.$mM.validateSender(te),Dt.instantiateLogger(Le,te,de)},openExternal(te,de){return Ge.openUri(te,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ft.environment.appUriScheme)return Di.createAppUri(te);try{return await Ge.asExternalUri(te,{allowTunneling:!!ft.remote.authority})}catch(de){if((0,st.$TT)(te,ze.Schemas.http)||(0,st.$TT)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Pk)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.$4E)(Le,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$4E)(Le,"handleIssueUri"),bi.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Ne.$4E)(Le,"resolvers"),ft.quality},get appCommit(){return(0,Ne.$4E)(Le,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(te,de,Fe){return hi.createTestController(Le,te,de,Fe)},createTestObserver(){return(0,Ne.$4E)(Le,"testObserver"),hi.createTestObserver()},runTests(te){return(0,Ne.$4E)(Le,"testObserver"),hi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$4E)(Le,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ne.$4E)(Le,"testObserver"),hi.results}},fi=ft.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,an={getExtension(te,de){(0,Ne.$3E)(Le,"extensionsAny")||(de=!1);const Fe=ei.mine.getExtensionDescription(te);if(Fe)return new a.$9bc(It,Le.identifier,Fe,fi,!1);if(de){const rt=ei.all.getExtensionDescription(te);if(rt)return new a.$9bc(It,Le.identifier,rt,fi,!0)}},get all(){const te=[];for(const de of ei.mine.getAllExtensionDescriptions())te.push(new a.$9bc(It,Le.identifier,de,fi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$4E)(Le,"extensionsAny");const te=new Ee.$Wl(ei.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),de=[];for(const Fe of ei.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);de.push(new a.$9bc(It,Le.identifier,Fe,fi,rt))}return de},get onDidChange(){return(0,Ne.$3E)(Le,"extensionsAny")?C.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(te){return ai.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:te=>ai.getDiagnostics(te),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(te,de){return ci.changeLanguage(te.uri,de)},match(te,de){const Fe=St.getDocumentData(de.uri)?.notebook;return(0,P.$gE)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,de,Fe){return ct.registerCodeActionProvider(Le,gt(te),de,Fe)},registerDocumentPasteEditProvider(te,de,Fe){return(0,Ne.$4E)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,gt(te),de,Fe)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Le,gt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Le,gt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Le,gt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Le,gt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Le,gt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Le,gt(te),de,Le.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Le,gt(te),de,Le.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Le,gt(te),de,Le.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Le,gt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Le,gt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Le,gt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Le,gt(te),de)},registerDocumentSymbolProvider(te,de,Fe){return ct.registerDocumentSymbolProvider(Le,gt(te),de,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Le,gt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Le,gt(te),de)},registerOnTypeFormattingEditProvider(te,de,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Le,gt(te),de,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Fe){return ct.registerDocumentSemanticTokensProvider(Le,gt(te),de,Fe)},registerDocumentRangeSemanticTokensProvider(te,de,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Le,gt(te),de,Fe)},registerSignatureHelpProvider(te,de,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Le,gt(te),de,Fe):ct.registerSignatureHelpProvider(Le,gt(te),de,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,de,...Fe){return ct.registerCompletionItemProvider(Le,gt(te),de,Fe)},registerInlineCompletionItemProvider(te,de,Fe){return de.handleDidShowCompletionItem&&(0,Ne.$4E)(Le,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$4E)(Le,"inlineCompletionsAdditions"),Fe&&(0,Ne.$4E)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,gt(te),de,Fe)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Le,gt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Le,gt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Le,gt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Le,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Le,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Le,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Le,te,de),getTokenInformationAtPosition(te,de){return(0,Ne.$4E)(Le,"tokenInformation"),ci.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Le,te,de)},createLanguageStatusItem(te,de){return ci.createLanguageStatusItem(Le,te,de)},registerDocumentDropEditProvider(te,de,Fe){return ct.registerDocumentOnDropEditProvider(Le,te,de,(0,Ne.$3E)(Le,"dropMetadata")?Fe:void 0)}},mn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(te,de,Fe){const rt=await(A.URI.isUri(te)?Promise.resolve(Bi.openTextDocument(te)):Promise.resolve(te));return Lt.showTextDocument(rt,de,Fe)},createTextEditorDecorationType(te){return Lt.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,de,Fe){return Lt.onDidChangeActiveTextEditor(te,de,Fe)},onDidChangeVisibleTextEditors(te,de,Fe){return Lt.onDidChangeVisibleTextEditors(te,de,Fe)},onDidChangeTextEditorSelection(te,de,Fe){return Lt.onDidChangeTextEditorSelection(te,de,Fe)},onDidChangeTextEditorOptions(te,de,Fe){return Lt.onDidChangeTextEditorOptions(te,de,Fe)},onDidChangeTextEditorVisibleRanges(te,de,Fe){return Lt.onDidChangeTextEditorVisibleRanges(te,de,Fe)},onDidChangeTextEditorViewColumn(te,de,Fe){return Lt.onDidChangeTextEditorViewColumn(te,de,Fe)},onDidCloseTerminal(te,de,Fe){return mt.onDidCloseTerminal(te,de,Fe)},onDidOpenTerminal(te,de,Fe){return mt.onDidOpenTerminal(te,de,Fe)},onDidChangeActiveTerminal(te,de,Fe){return mt.onDidChangeActiveTerminal(te,de,Fe)},onDidChangeTerminalDimensions(te,de,Fe){return(0,Ne.$4E)(Le,"terminalDimensions"),mt.onDidChangeTerminalDimensions(te,de,Fe)},onDidChangeTerminalState(te,de,Fe){return mt.onDidChangeTerminalState(te,de,Fe)},onDidWriteTerminalData(te,de,Fe){return(0,Ne.$4E)(Le,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(te,de,Fe)},onDidExecuteTerminalCommand(te,de,Fe){return(0,Ne.$4E)(Le,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(te,de,Fe)},get state(){return Ge.getState(Le)},onDidChangeWindowState(te,de,Fe){return Ge.onDidChangeWindowState(te,de,Fe)},showInformationMessage(te,...de){return yi.showMessage(Le,F.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return yi.showMessage(Le,F.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return yi.showMessage(Le,F.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Fe){return ii.showQuickPick(Le,te,de,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return Ui.showOpenDialog(Le,te)},showSaveDialog(te){return Ui.showSaveDialog(te)},createStatusBarItem(te,de,Fe){let rt,Et,Ot;return typeof te=="string"?(rt=te,Et=de,Ot=Fe):(Et=te,Ot=de),rn.createStatusBarEntry(Le,rt,Et,Ot)},setStatusBarMessage(te,de){return rn.setStatusBarMessage(te,de)},withScmProgress(te){return Be.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ri.withProgress(Le,{location:Z.ProgressLocation.SourceControl},(de,Fe)=>te({report(rt){}}))},withProgress(te,de){return Ri.withProgress(Le,te,de)},createOutputChannel(te,de){return Zt.createOutputChannel(te,de,Le)},createWebviewPanel(te,de,Fe,rt){return Fi.createWebviewPanel(Le,te,de,Fe,rt)},createWebviewTextEditorInset(te,de,Fe,rt){return(0,Ne.$4E)(Le,"editorInsets"),Ii.createWebviewEditorInset(te,de,Fe,rt,Le)},createTerminal(te,de,Fe){return typeof te=="object"?"pty"in te?mt.createExtensionTerminal(te):mt.createTerminalFromOptions(te):mt.createTerminal(te,de,Fe)},registerTerminalLinkProvider(te){return mt.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return mt.registerProfileProvider(Le,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Ne.$4E)(Le,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(te,Le.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Le)},createTreeView(te,de){return pi.createTreeView(te,de,Le)},registerWebviewPanelSerializer:(te,de)=>Fi.registerWebviewPanelSerializer(Le,te,de),registerCustomEditorProvider:(te,de,Fe={})=>Li.registerCustomEditorProvider(Le,te,de,Fe),registerFileDecorationProvider(te){return Ct.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return Di.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(te,de,Fe){return Mi.onDidChangeActiveColorTheme(te,de,Fe)},registerWebviewViewProvider(te,de,Fe){return Oi.registerWebviewViewProvider(Le,te,de,Fe?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Fe){return vt.onDidChangeActiveNotebookEditor(te,de,Fe)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Fe){return $i.onDidChangeNotebookEditorSelection(te,de,Fe)},onDidChangeNotebookEditorVisibleRanges(te,de,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Fe)},showNotebookDocument(te,de){return vt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Fe){return(0,Ne.$4E)(Le,"externalUriOpener"),ln.registerExternalUriOpener(Le.identifier,te,de,Fe)},registerProfileContentHandler(te,de){return(0,Ne.$4E)(Le,"profileContentHandlers"),en.registrProfileContentHandler(Le,te,de)},registerQuickDiffProvider(te,de,Fe,rt){return(0,Ne.$4E)(Le,"quickDiffProvider"),Yi.registerQuickDiffProvider(gt(te),de,Fe,rt)},get tabGroups(){return _e.tabGroups},registerShareProvider(te,de){return(0,Ne.$4E)(Le,"shareProvider"),Pi.registerShareProvider(gt(te),de)}},Bi={get rootPath(){return Be.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new M.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new M.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new M.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Fe)=>ht.updateWorkspaceFolders(Le,te,de||0,...Fe),onDidChangeWorkspaceFolders:function(te,de,Fe){return ht.onDidChangeWorkspace(te,de,Fe)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Fe,rt)=>ht.findFiles(te,de,Fe,Le.identifier,rt),findTextInFiles:(te,de,Fe,rt)=>{(0,Ne.$4E)(Le,"findTextInFiles");let Et,Ot;return typeof de=="object"?(Et=de,Ot=Fe):(Et={},Ot=de,rt=Fe),ht.findTextInFiles(te,Et||{},Ot,Le.identifier,rt)},save:te=>((0,Ne.$4E)(Le,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.$4E)(Le,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return wi.applyWorkspaceEdit(te,Le,de)},createFileSystemWatcher:(te,de,Fe,rt)=>Yt.createFileSystemWatcher(ht,Le,te,de,Fe,rt),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$7("textDocuments")},openTextDocument(te){let de;const Fe=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Fe||typeof Fe=="object")de=St.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>St.ensureDocumentData(rt).then(Et=>Et.document))},onDidOpenTextDocument:(te,de,Fe)=>St.onDidAddDocument(te,de,Fe),onDidCloseTextDocument:(te,de,Fe)=>St.onDidRemoveDocument(te,de,Fe),onDidChangeTextDocument:(te,de,Fe)=>St.onDidChangeDocument(te,de,Fe),onDidSaveTextDocument:(te,de,Fe)=>St.onDidSaveDocument(te,de,Fe),onWillSaveTextDocument:(te,de,Fe)=>un.getOnWillSaveTextDocumentEvent(Le)(te,de,Fe),get notebookDocuments(){return vt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Fe;if(A.URI.isUri(te))Fe=te,await vt.openNotebookDocument(te);else if(typeof te=="string")Fe=A.URI.revive(await vt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,de,Fe){return mi.onDidSaveNotebookDocument(te,de,Fe)},onDidChangeNotebookDocument(te,de,Fe){return mi.onDidChangeNotebookDocument(te,de,Fe)},onWillSaveNotebookDocument(te,de,Fe){return Si.getOnWillSaveNotebookDocumentEvent(Le)(te,de,Fe)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Fe,rt){return vt.registerNotebookSerializer(Le,te,de,Fe,(0,Ne.$3E)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Fe)=>ji.onDidChangeConfiguration(te,de,Fe),getConfiguration(te,de){return de=arguments.length===1?void 0:de,ji.getConfiguration(te,de,Le)},registerTextDocumentContentProvider(te,de){return Zi.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Be.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Le,te,de)),registerFileSystemProvider(te,de,Fe){return(0,je.$hc)(Ci.registerFileSystemProvider(Le,te,de,Fe),Tt.addFileSystemProvider(te,de,Fe))},get fs(){return Tt.value},registerFileSearchProvider:(te,de)=>((0,Ne.$4E)(Le,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Ne.$4E)(Le,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Ne.$4E)(Le,"resolvers"),It.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Ne.$4E)(Le,"resolvers"),_i.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$4E)(Le,"resolvers"),It.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Fe)=>Yt.onDidCreateFile(te,de,Fe),onDidDeleteFiles:(te,de,Fe)=>Yt.onDidDeleteFile(te,de,Fe),onDidRenameFiles:(te,de,Fe)=>Yt.onDidRenameFile(te,de,Fe),onWillCreateFiles:(te,de,Fe)=>Yt.getOnWillCreateFileEvent(Le)(te,de,Fe),onWillDeleteFiles:(te,de,Fe)=>Yt.getOnWillDeleteFileEvent(Le)(te,de,Fe),onWillRenameFiles:(te,de,Fe)=>Yt.getOnWillRenameFileEvent(Le)(te,de,Fe),openTunnel:te=>((0,Ne.$4E)(Le,"tunnels"),Te.openTunnel(Le,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ne.$4E)(Le,"tunnels"),Te.getTunnels()},onDidChangeTunnels:(te,de,Fe)=>((0,Ne.$4E)(Le,"tunnels"),Te.onDidChangeTunnels(te,de,Fe)),registerPortAttributesProvider:(te,de)=>((0,Ne.$4E)(Le,"portsAttributes"),Te.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Ne.$4E)(Le,"tunnelFactory"),Te.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Ne.$4E)(Le,"timeline"),xi.registerTimelineProvider(te,de,Le.identifier,ut.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.$4E)(Le,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Fe)=>ht.onDidGrantWorkspaceTrust(te,de,Fe),registerEditSessionIdentityProvider:(te,de)=>((0,Ne.$4E)(Le,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Fe)=>((0,Ne.$4E)(Le,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Le)(te,de,Fe)),registerCanonicalUriProvider:(te,de)=>((0,Ne.$4E)(Le,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Fe)=>((0,Ne.$4E)(Le,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Fe))},cn={get inputBox(){return Be.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Le)},createSourceControl(te,de,Fe){return vi.createSourceControl(Le,te,de,Fe)}},Wi={createCommentController(te,de){return Ai.createCommentController(Le,te,de)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,de,Fe){return yt.onDidStartDebugSession(te,de,Fe)},onDidTerminateDebugSession(te,de,Fe){return yt.onDidTerminateDebugSession(te,de,Fe)},onDidChangeActiveDebugSession(te,de,Fe){return yt.onDidChangeActiveDebugSession(te,de,Fe)},onDidReceiveDebugSessionCustomEvent(te,de,Fe){return yt.onDidReceiveDebugSessionCustomEvent(te,de,Fe)},onDidChangeBreakpoints(te,de,Fe){return yt.onDidChangeBreakpoints(te,de,Fe)},onDidChangeStackFrameFocus(te,de,Fe){return(0,Ne.$4E)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(te,de,Fe)},registerDebugConfigurationProvider(te,de,Fe){return yt.registerDebugConfigurationProvider(te,de,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return yt.registerDebugAdapterDescriptorFactory(Le,te,de)},registerDebugAdapterTrackerFactory(te,de){return yt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?yt.startDebugging(te,de,{parentSession:Fe}):yt.startDebugging(te,de,Fe||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,de){return yt.asDebugSourceUri(te,de)}},qi={registerTaskProvider:(te,de)=>Ht.registerTaskProvider(Le,te,de),fetchTasks:te=>Ht.fetchTasks(te),executeTask:te=>Ht.executeTask(Le,te),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(te,de,Fe)=>Ht.onDidStartTask(te,de,Fe),onDidEndTask:(te,de,Fe)=>Ht.onDidEndTask(te,de,Fe),onDidStartTaskProcess:(te,de,Fe)=>Ht.onDidStartTaskProcess(te,de,Fe),onDidEndTaskProcess:(te,de,Fe)=>Ht.onDidEndTaskProcess(te,de,Fe)},li={createNotebookController(te,de,Fe,rt,Et){return oi.createNotebookController(Le,te,de,Fe,rt,(0,Ne.$3E)(Le,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>vt.registerNotebookCellStatusBarItemProvider(Le,te,de),createRendererMessaging(te){return ki.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$4E)(Le,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,de){return(0,Ne.$4E)(Le,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Le,te,de)},onDidChangeNotebookCellExecutionState(te,de,Fe){return(0,Ne.$4E)(Le,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(te,de,Fe)}},Ki={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return si.getMessage(Le.identifier.value,{message:de,args:Fe})}return si.getMessage(Le.identifier.value,te[0])},get bundle(){return si.getBundle(Le.identifier.value)},get uri(){return si.getBundleUri(Le.identifier.value)}},Ji={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Ne.$4E)(Le,"interactive"),Ni.registerProvider(Le,te,de={label:de?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,de){return(0,Ne.$4E)(Le,"interactive"),ni.registerChatProvider(Le,te,de)},addInteractiveRequest(te){return(0,Ne.$4E)(Le,"interactive"),ni.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,Ne.$4E)(Le,"interactive"),ni.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Ne.$4E)(Le,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(te,de){return(0,Ne.$4E)(Le,"interactive"),ni.transferChatSession(te,de)}},Hi={getRelatedInformation(te,de){return(0,Ne.$4E)(Le,"aiRelatedInformation"),zi.getRelatedInformation(Le,te,de)},registerRelatedInformationProvider(te,de){return(0,Ne.$4E)(Le,"aiRelatedInformation"),zi.registerRelatedInformationProvider(Le,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Ne.$4E)(Le,"aiRelatedInformation"),xt.registerEmbeddingVectorProvider(Le,te,de)}},Gi={registerChatResponseProvider(te,de,Fe){return(0,Ne.$4E)(Le,"chatProvider"),di.registerProvider(Le.identifier,te,de,Fe)},registerSlashCommand(te,de,Fe){return(0,Ne.$4E)(Le,"chatSlashCommands"),tn.registerCommand(Le.identifier,te,de,Fe??{description:""})},requestChatAccess(te){return(0,Ne.$4E)(Le,"chatRequestAccess"),di.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,de,Fe){return(0,Ne.$4E)(Le,"chatVariables"),hn.registerVariableResolver(Le,te,de,Fe)},registerMappedEditsProvider(te,de){return(0,Ne.$4E)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,de)},registerAgent(te,de,Fe){return(0,Ne.$4E)(Le,"chatAgents"),nn.registerAgent(Le.identifier,te,de,Fe)}};return{version:ft.version,ai:Hi,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ji,l10n:Ki,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:Z.$6K,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatMessage:Z.$VL,ChatMessageRole:Z.ChatMessageRole,ChatVariableLevel:Z.ChatVariableLevel,CallHierarchyIncomingCall:Z.$sK,CallHierarchyItem:Z.$rK,CallHierarchyOutgoingCall:Z.$tK,CancellationError:M.$3,CancellationTokenSource:w.$pd,CandidatePortSource:c.CandidatePortSource,CodeAction:Z.$oK,CodeActionKind:Z.$pK,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$uK,Color:Z.$HK,ColorInformation:Z.$IK,ColorPresentation:Z.$JK,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CompletionItem:Z.$BK,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$CK,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$RK,DebugAdapterExecutable:Z.$0K,DebugAdapterInlineImplementation:Z.$aL,DebugAdapterNamedPipeServer:Z.$_K,DebugAdapterServer:Z.$$K,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$jK,DiagnosticRelatedInformation:Z.$iK,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$8J,DocumentHighlight:Z.$lK,DocumentHighlightKind:Z.DocumentHighlightKind,DocumentLink:Z.$GK,DocumentSymbol:Z.$nK,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$dL,InlineValueText:Z.$eL,InlineValueVariableLookup:Z.$fL,InlineValueEvaluatableExpression:Z.$gL,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:C.$fd,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$qL,FileDecoration2:Z.$qL,FileSystemError:Z.$iL,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Z.$jL,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$8K,InlineCompletionItem:Z.$DK,InlineCompletionList:Z.$EK,Hover:Z.$kK,IndentAction:m.IndentAction,Location:Z.$hK,MarkdownString:Z.$vK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:Z.$wK,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$9J,ProcessExecution:Z.$PK,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$pL,Range:Z.$0J,RelativePattern:Z.$4K,Selection:Z.$$J,SelectionRange:Z.$qK,SemanticTokens:Z.$mL,SemanticTokensBuilder:Z.$lL,SemanticTokensEdit:Z.$nL,SemanticTokensEdits:Z.$oL,SemanticTokensLegend:Z.$kL,ShellExecution:Z.$QK,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$yK,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$xK,SnippetString:Z.$gK,SourceBreakpoint:Z.$7K,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$mK,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$SK,TaskGroup:Z.$OK,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$KK,TerminalQuickFixExecuteTerminalCommand:Z.$MK,TerminalQuickFixOpener:Z.$LK,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$NK,TerminalExitReason:Z.TerminalExitReason,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$cK,SnippetTextEdit:Z.$eK,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$3K,ThemeIcon:Z.$2K,TreeItem:Z.$TK,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$LL,UIKind:v.UIKind,Uri:A.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$fK,DocumentDropEdit:Z.$ZK,DocumentPasteEdit:Z.$1K,InlayHint:Z.$AK,InlayHintLabelPart:Z.$zK,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$bK,ResolvedAuthority:Z.$_J,ManagedResolvedAuthority:Z.$aK,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$AL,NotebookRange:Z.$sL,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$tL,NotebookData:Z.$uL,NotebookRendererScript:Z.$yL,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$wL,NotebookCellOutputItem:Z.$vL,NotebookCellStatusBarItem:Z.$xL,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$dK,NotebookKernelSourceAction:Z.$zL,PortAttributes:Z.$CL,LinkedEditingRanges:Z.$BL,TestResultState:Z.TestResultState,TestRunRequest:Z.$DL,TestMessage:Z.$EL,TestMessage2:Z.$EL,TestTag:Z.$FL,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Z.$YK,DataTransferItem:Z.$UK,CoveredCount:Z.$GL,FileCoverage:Z.$HL,StatementCoverage:Z.$IL,BranchCoverage:Z.$JL,FunctionCoverage:Z.$KL,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$ML,TabInputTextDiff:Z.$NL,TabInputTextMerge:Z.$OL,TabInputCustom:Z.$PL,TabInputNotebook:Z.$RL,TabInputNotebookDiff:Z.$SL,TabInputWebview:Z.$QL,TabInputTerminal:Z.$TL,TabInputInteractiveWindow:Z.$UL,TelemetryTrustedValue:ye.$_n,LogLevel:be.LogLevel,EditSessionIdentityMatch:dt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Z.$bL,ThreadFocus:Z.$cL,RelatedInformationType:Z.RelatedInformationType}}}e.$qdc=qt}),define(Ae[274],Re([1,0,71,110,33,108,34,31,60,63,112,114,115,84,86,80,109,62,39,83,58,61,242,14,113,81,82]),function(ve,e,w,M,C,F,A,h,k,m,P,D,c,v,p,g,t,i,s,d,y,$,r,o,n,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$mr)(a.$3bc,a.$2bc,1),(0,w.$mr)(o.$6i,r.$rdc,1),(0,w.$mr)(g.$pbc,g.$qbc,1),(0,w.$mr)(h.$qM,h.$pM,0),(0,w.$mr)(A.$Cbc,A.$Abc,0),(0,w.$mr)(i.$Rbc,i.$Qbc,0),(0,w.$mr)(D.$Fcc,D.$Jcc,0),(0,w.$mr)(F.$xcc,F.$wcc,0),(0,w.$mr)(k.$fM,k.$eM,0),(0,w.$mr)(E.$4bc,E.$5bc,0),(0,w.$mr)(s.$mbc,s.$lbc,0),(0,w.$mr)(M.$dcc,M.$ccc,1),(0,w.$mr)(c.$Pcc,c.$Qcc,0),(0,w.$mr)(v.$Nbc,v.$Mbc,0),(0,w.$mr)(P.$Acc,P.$zcc,0),(0,w.$mr)(m.$Ubc,m.$Xbc,0),(0,w.$mr)(p.$zsb,p.$Asb,0),(0,w.$mr)(t.$tcc,t.$scc,0),(0,w.$mr)(C.$zbc,C.$ybc,0),(0,w.$mr)(d.$Zbc,d.$Ybc,0),(0,w.$mr)(y.$oM,y.$lM,0),(0,w.$mr)($.$Bcc,$.$Ccc,0),(0,w.$mr)(n.$Dcc,n.$Ecc,0)}),define(Ae[275],Re([1,0,273,35,2,270,7,12,261]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class m extends F.$udc{j(){}getModule(v,p){for(const g of this.b){const t=g(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends M.$7bc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(k.$zfc);const v=this.h.invokeFunction(w.$qdc);this.r=this.h.createInstance(m,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,g){p=p.with({path:D(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri(p)),s=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),s.status!==200)throw new Error(s.statusText);const d=await s.text(),y=`${p.toString(!0)}#vscode-extension`,$=`${d}
//# sourceURL=${y}`;let r;try{r=new Function("module","exports","require",$)}catch(E){throw console.error(t?`Loading code for extension ${t} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${p.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}v&&await this.w.initializeLocalizedMessages(v);const o={},n={exports:o},a=E=>{const b=this.r.getModule(E,p);if(b===void 0)throw new Error(`Cannot load module '${E}'`);return b};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,o,a),n.exports!==o?n.exports:o}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,h.$Hg)(10)}}e.$Afc=P;function D(c,v){return c.endsWith(v)?c:c+v}}),define(Ae[276],Re([1,0,70,71,14,35,188,85,275]),function(ve,e,w,M,C,F,A,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$mr)(C.$5i,new w.$yh(A.$tdc,[!0],!0)),(0,M.$mr)(F.$8bc,k.$Afc,0),(0,M.$mr)(h.$Sbc,h.$Tbc,0)}),define(Ae[285],Re([1,0,25,5,79,271,263,19,87,13,2,274,276]),function(ve,e,w,M,C,F,A,h,k,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function g(r){self.fetch=async function(o,n){return o instanceof Request||v(String(o))&&(o=(await r(P.URI.parse(String(o)))).toString(!0)),p(o,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,n,a,E,b){(async()=>(v(n.toString())&&(n=(await r(P.URI.parse(n.toString()))).toString(!0)),super.open(o,n,a??!0,E,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(o,n){if(/^file:/i.test(o.toString()))o=m.$2f.uriToBrowserUri(P.URI.parse(o.toString())).toString(!0);else if(/^vscode-remote:/i.test(o.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(u){function f(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const l=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?l(B,V):l(f(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,U,W,O){return super.open(B,f(V),U??!0,W,O)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(f))},R(u)}.toString()}('${o}'))`;n=n||{},n.name=n.name||h.$ae(o.toString());const b=new Blob([E],{type:"application/javascript"}),S=URL.createObjectURL(b);return new r(S,n)}}else self.Worker=class extends A.$Bfc{constructor(r,o){super(c,r,{name:h.$ae(r.toString()),...o})}};const t=new class{constructor(){this.pid=void 0}exit(r){D()}};class i{constructor(){const o=new MessageChannel,n=new M.$fd;let a=!1;c(o.port2,[o.port2]),o.port1.onmessage=E=>{const{data:b}=E;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const S=w.$Fd.wrap(new Uint8Array(b,0,b.byteLength));if((0,C.$5l)(S,2)){a=!0,d("received terminate message from renderer");return}n.fire(S)},this.protocol={onMessage:n.event,send:E=>{if(!a){const b=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);o.port1.postMessage(b,[b])}}}}}function s(r){return new Promise(o=>{const n=r.onMessage(a=>{n.dispose();const E=JSON.parse(a.toString());r.send((0,C.$4l)(0)),o({protocol:r,initData:E})});r.send((0,C.$4l)(1))})}let d=r=>D();function y(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function $(){k.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(o){y(o)&&s(r.protocol).then(n=>{k.mark("code/extHost/didWaitForInitData");const a=new F.$wdc(n.protocol,n.initData,t,null,o.data);g(E=>a.asBrowserUri(E)),d=E=>a.terminate(E)})}}}e.create=$})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/workbench/api/worker/extensionHostWorker.js.map
