/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(F){for(var e=[],C=0,k=F.length;C<k;C++)e[C]=q[F[C]];return e};define(q[21],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class C{static get(){const v=new Map,T=new Map,r=new Map,l=new Map;function t(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function a(o,n){const i=o.get(n.detail);i&&(i>=0||o.set(n.detail,i+n.timestamp))}let h=[];typeof F=="function"&&typeof F.getStats=="function"&&(h=F.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of h)switch(o.type){case 10:t(v,o);break;case 11:case 12:a(v,o);break;case 21:t(T,o);break;case 22:a(T,o);break;case 33:t(r,o);break;case 34:a(r,o);break;case 31:t(l,o);break;case 32:a(l,o);break}let c=0;r.forEach(o=>c+=o);function g(o){const n=[];return o.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:g(v),amdInvoke:g(T),nodeRequire:g(r),nodeEval:g(l),nodeRequireTotal:c}}static toMarkdownTable(v,T){let r="";const l=[];return v.forEach((t,a)=>{l[a]=t.length}),T.forEach(t=>{t.forEach((a,h)=>{typeof a>"u"&&(a=t[h]="-");const c=a.toString().length;l[h]=Math.max(c,l[h])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(l[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(l[a])} `}),r+=`|
`,T.forEach(t=>{t.forEach((a,h)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(l[h]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=C}),define(q[4],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vc=e.$Uc=e.$Tc=void 0;let C;function k(i){C=i}e.$Tc=k;function v(){return C}e.$Uc=v;class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([l(o("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[l(" "),a(h(s.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),a(h(s.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),a(h(s.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleDerivedRecomputed(s,d){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([t("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Vc=T;function r(i){const s=new Array,d=[];let w="";function N(S){if("length"in S)for(const f of S)f&&N(f);else"text"in S?(w+=`%c${S.text}`,s.push(S.style),S.data&&d.push(...S.data)):"data"in S&&d.push(...S.data)}N(i);const P=[w,...s];return P.push(...d),P}function l(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function d(N){return Object.entries(N).reduce((P,[S,f])=>`${P}${S}:${f};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:d(w)}}function h(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?c(i,s):g(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function c(i,s){let d="[ ",w=!0;for(const N of i){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${h(N,s-d.length)}`}return d+=" ]",d}function g(i,s){let d="{ ",w=!0;for(const[N,P]of Object.entries(i)){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${N}: ${h(P,s-d.length)}`}return d+=" }",d}function o(i,s){let d="";for(let w=1;w<=s;w++)d+=i;return d}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],K([0,1,4]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=void 0;let k;function v(s){k=s}e.$2c=v;class T{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,w){const N=w===void 0?void 0:d,P=w===void 0?d:w;return k({owner:N,debugName:()=>{const S=c(P);if(S!==void 0)return S;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(P.toString());if(y)return`${this.debugName}.${y[2]}`;if(!N)return`${this.debugName} (mapped)`}},S=>P(this.read(S),S))}}e.$3c=T;class r extends T{constructor(){super(...arguments),this.c=new Set}addObserver(d){const w=this.c.size;this.c.add(d),w===0&&this.f()}removeObserver(d){this.c.delete(d)&&this.c.size===0&&this.g()}f(){}g(){}}e.$4c=r;function l(s,d){const w=new a(s,d);try{s(w)}finally{w.finish()}}e.$5c=l;function t(s,d,w){s?d(s):l(d,w)}e.$6c=t;class a{constructor(d,w){this._fn=d,this.b=w,this.a=[],(0,C.$Uc)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(d,w){this.a.push({observer:d,observable:w}),d.beginUpdate(w)}finish(){const d=this.a;this.a=null;for(const{observer:w,observable:N}of d)w.endUpdate(N);(0,C.$Uc)()?.handleEndTransaction()}}e.$7c=a;function h(s,d,w,N){let P;if(s!==void 0)if(typeof s=="function"){if(P=s(),P!==void 0)return P}else return s;if(d!==void 0&&(P=c(d),P!==void 0))return P;if(w!==void 0){for(const S in w)if(w[S]===N)return S}}e.$8c=h;function c(s){const d=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(N?N[1]:void 0)?.trim()}e.$9c=c;function g(s,d){return typeof s=="string"?new o(void 0,s,d):new o(s,void 0,d)}e.$0c=g;class o extends r{get debugName(){return h(this.d,void 0,this.b,this)??"ObservableValue"}constructor(d,w,N){super(),this.b=d,this.d=w,this.a=N}get(){return this.a}set(d,w,N){if(this.a===d)return;let P;w||(w=P=new a(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.a;this.e(d),(0,C.$Uc)()?.handleObservableChanged(this,{oldValue:S,newValue:d,change:N,didChange:!0,hadValue:!0});for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,N)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(d){this.a=d}}e.$$c=o;function n(s,d){return typeof s=="string"?new i(void 0,s,d):new i(s,void 0,d)}e.$_c=n;class i extends o{e(d){this.a!==d&&(this.a&&this.a.dispose(),this.a=d)}dispose(){this.a?.dispose()}}e.$ad=i}),define(q[9],K([0,1,42,2,5,4]),function(F,e,C,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.$zc=r;function l(n){return new g(void 0,n,void 0,void 0)}e.$Ac=l;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Bc=t;function a(n,i){const s=new k.$jc,d=t({debugName:n.debugName??(()=>(0,v.$9c)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,k.$ic)(()=>{d.dispose(),s.dispose()})}e.$Cc=a;function h(n){const i=new k.$jc,s=r({debugName:()=>(0,v.$9c)(n)||"(anonymous)"},d=>{i.clear(),n(d,i)});return(0,k.$ic)(()=>{s.dispose(),i.dispose()})}e.$Dc=h;var c;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$9c)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,d,w){this.h=i,this._runFn=s,this.i=d,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,T.$Uc)()?.handleAutorunCreated(this),this.k(),(0,k.$bc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$cc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,T.$Uc)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,T.$Uc)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,C.$xc)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Ec=g,function(n){n.Observer=g}(l||(e.$Ac=l={}));function o(n,i){let s;return r({debugName:()=>(0,v.$9c)(i)},d=>{const w=n.read(d),N=s;s=w,i({lastValue:N,newValue:w})})}e.$Fc=o}),define(q[10],K([0,1,6,2,5,4]),function(F,e,C,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=void 0;const r=(o,n)=>o===n;function l(o,n){return n!==void 0?new g(o,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,o,void 0,void 0,void 0,r)}e.$Wc=l;function t(o,n){return new g(o.owner,o.debugName,n,void 0,void 0,void 0,o.equalityComparer??r)}e.$Xc=t;function a(o,n){return new g(o.owner,o.debugName,n,o.createEmptyChangeSummary,o.handleChange,void 0,o.equalityComparer??r)}e.$Yc=a;function h(o,n){let i,s;n===void 0?(i=o,s=void 0):(s=o,i=n);const d=new k.$jc;return new g(s,()=>(0,v.$9c)(i)??"(anonymous)",w=>(d.clear(),i(w,d)),void 0,void 0,()=>d.dispose(),r)}e.$Zc=h,(0,v.$2c)(l);var c;(function(o){o[o.initial=0]="initial",o[o.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",o[o.stale=2]="stale",o[o.upToDate=3]="upToDate"})(c||(c={}));class g extends v.$4c{get debugName(){return(0,v.$8c)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,d,w,N=void 0,P){super(),this.m=n,this.n=i,this._computeFn=s,this.p=d,this.q=w,this.s=N,this.t=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,T.$Uc)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const d=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,d)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,T.$Uc)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new C.$ab}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,d=this.e===3;if(s&&(this.e===1||d)&&(this.e=2,d))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$1c=g}),define(q[22],K([0,1,2,9,5,10,4]),function(F,e,C,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;function l(m){return new t(m)}e.$Gc=l;class t extends v.$3c{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function a(m){const O=(0,v.$0c)("promiseValue",{});return m.then(j=>{O.set({value:j},void 0)}),O}e.$Hc=a;function h(m,O){return new Promise(j=>{let $=!1,A=!1;const R=(0,k.$Ac)(z=>{const I=m.read(z);O(I)&&($?R.dispose():A=!0,j(I))});$=!0,A&&R.dispose()})}e.$Ic=h;function c(m,O){return new g(m,O)}e.$Jc=c;class g extends v.$4c{constructor(O,j){super(),this.h=O,this._getValue=j,this.b=!1,this.k=$=>{const A=this._getValue($),R=!this.b||this.a!==A;(0,r.$Uc)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:A,change:void 0,didChange:R,hadValue:this.b}),R&&(this.a=A,this.b&&(0,v.$5c)(z=>{for(const I of this.c)z.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const z=this.i();return"Event fired"+(z?`: ${z}`:"")}),this.b=!0)}}i(){return(0,v.$9c)(this._getValue)}get debugName(){const O=this.i();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Kc=g,function(m){m.Observer=g}(c||(e.$Jc=c={}));function o(m,O){return new n(m,O)}e.$Lc=o;class n extends v.$4c{constructor(O,j){super(),this.debugName=O,this.b=j,this.h=()=>{(0,v.$5c)($=>{for(const A of this.c)$.updateObserver(A,this),A.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$Mc=i;class s extends v.$4c{get debugName(){return(0,v.$8c)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,j){super(),this.a=O,this.b=j}trigger(O,j){if(!O){(0,v.$5c)($=>{this.trigger($,j)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,j)}get(){}}function d(m,O,j){const $=(0,v.$0c)("debounced",void 0);let A;return j.add((0,k.$Ac)(R=>{const z=m.read(R);A&&clearTimeout(A),A=setTimeout(()=>{(0,v.$5c)(I=>{$.set(z,I)})},O)})),$}e.$Nc=d;function w(m,O,j){const $=(0,v.$0c)("triggeredRecently",!1);let A;return j.add(m(()=>{$.set(!0,void 0),A&&clearTimeout(A),A=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$Oc=w;function N(m){const O=new S(!1);return m.addObserver(O),(0,C.$ic)(()=>{m.removeObserver(O)})}e.$Pc=N;function P(m){const O=new S(!0);return m.addObserver(O),m.reportChanges(),(0,C.$ic)(()=>{m.removeObserver(O)})}e.$Qc=P;class S{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,j){}}function f(m){let O;return(0,T.$Wc)($=>(O=m($,O),O))}e.$Rc=f;function y(m,O){let j;const $=(0,v.$0c)("derivedObservableWithWritableCache.counter",0),A=(0,T.$Wc)(m,R=>($.read(R),j=O(R,j),j));return Object.assign(A,{clearCache:R=>{j=void 0,$.set($.get()+1,R)}})}e.$Sc=y}),define(q[11],K([0,1,5,10,9,22,4]),function(F,e,C,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return C.$0c}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return C.$_c}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return C.$5c}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return C.$6c}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$Wc}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$Xc}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$Yc}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$Zc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$Ac}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Fc}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Bc}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Dc}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$zc}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Cc}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return T.$Gc}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return T.$Nc}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return T.$Rc}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return T.$Sc}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return T.$Pc}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return T.$Qc}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return T.$Jc}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return T.$Hc}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return T.$Mc}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return T.$Lc}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return T.$Ic}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return T.$Oc}}),!1&&(0,r.$Tc)(new r.$Vc)}),define(q[23],K([0,1,6,2]),function(F,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function v(P){const S=P;return S?typeof S.read=="function":!1}e.$qd=v;function T(P){const S=P;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}e.$rd=T;function r(P){const S=P;return S?T(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$sd=r;function l(P,S){return new t(P,S)}e.$td=l;class t{constructor(S,f){this.e=S,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(f=>f(S))}h(S){this.c.error.length===0?(0,C.$Y)(S):this.c.error.slice(0).forEach(f=>f(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,f){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(S,f){if(this.a.destroyed)return;let y;switch(S){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(f);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(P,S){const f=[];let y;for(;(y=P.read())!==null;)f.push(y);return S(f)}e.$ud=a;function h(P,S,f){const y=[];let m;for(;(m=P.read())!==null&&y.length<f;)y.push(m);return m===null&&y.length>0?S(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const O=m;return m=void 0,O}return P.read()}}}e.$vd=h;function c(P,S){return new Promise((f,y)=>{const m=[];g(P,{onData:O=>{S&&m.push(O)},onError:O=>{S?y(O):f(void 0)},onEnd:()=>{f(S?S(m):void 0)}})})}e.$wd=c;function g(P,S,f){P.on("error",y=>{f?.isCancellationRequested||S.onError(y)}),P.on("end",()=>{f?.isCancellationRequested||S.onEnd()}),P.on("data",y=>{f?.isCancellationRequested||S.onData(y)})}e.$xd=g;function o(P,S){return new Promise((f,y)=>{const m=new k.$jc,O=[],j=R=>{if(O.push(R),O.length>S)return m.dispose(),P.pause(),f({stream:P,buffer:O,ended:!1})},$=R=>(m.dispose(),y(R)),A=()=>(m.dispose(),f({stream:P,buffer:O,ended:!0}));m.add((0,k.$ic)(()=>P.removeListener("error",$))),P.on("error",$),m.add((0,k.$ic)(()=>P.removeListener("end",A))),P.on("end",A),m.add((0,k.$ic)(()=>P.removeListener("data",j))),P.on("data",j)})}e.$yd=o;function n(P,S){const f=l(S);return f.end(P),f}e.$zd=n;function i(){const P=l(()=>{throw new Error("not supported")});return P.end(),P}e.$Ad=i;function s(P){let S=!1;return{read:()=>S?null:(S=!0,P)}}e.$Bd=s;function d(P,S,f){const y=l(f);return g(P,{onData:m=>y.write(S.data(m)),onError:m=>y.error(S.error?S.error(m):m),onEnd:()=>y.end()}),y}e.$Cd=d;function w(P,S,f){let y=!1;return{read:()=>{const m=S.read();return y?m:(y=!0,m!==null?f([P,m]):P)}}}e.$Dd=w;function N(P,S,f){let y=!1;const m=l(f);return g(S,{onData:O=>y?m.write(O):(y=!0,m.write(f([P,O]))),onError:O=>m.error(O),onEnd:()=>{y||(y=!0,m.write(P)),m.end()}}),m}e.$Ed=N}),define(q[12],K([0,1,43,23]),function(F,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const v=typeof Buffer<"u",T=new C.$T(()=>new Uint8Array(256));let r,l;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let G=0,V=b.length;G<V;G++)U.buffer[G]=b[G];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let H=0,_=b.length;H<_;H++)U+=b[H].byteLength}const G=t.alloc(U);let V=0;for(let H=0,_=b.length;H<_;H++){const W=b[H];G.set(W,V),V+=W.byteLength}return G}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){o(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,U){d(this.buffer,b,U)}indexOf(b,U=0){return a(this.buffer,b instanceof t?b.buffer:b,U)}}e.$Fd=t;function a(I,b,U=0){const G=b.byteLength,V=I.byteLength;if(G===0)return 0;if(G===1)return I.indexOf(b[0]);if(G>V-U)return-1;const H=T.value;H.fill(b.length);for(let X=0;X<b.length;X++)H[b[X]]=b.length-X-1;let _=U+b.length-1,W=_,p=-1;for(;_<V;)if(I[_]===b[W]){if(W===0){p=_;break}_--,W--}else _+=Math.max(b.length-W,H[I[_]]),W=b.length-1;return p}e.$Gd=a;function h(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Hd=h;function c(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255}e.$Id=c;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Jd=g;function o(I,b,U){I[U+3]=b,b=b>>>8,I[U+2]=b,b=b>>>8,I[U+1]=b,b=b>>>8,I[U]=b}e.$Kd=o;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Ld=n;function i(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255,b=b>>>8,I[U+2]=b&255,b=b>>>8,I[U+3]=b&255}e.$Md=i;function s(I,b){return I[b]}e.$Nd=s;function d(I,b,U){I[U]=b}e.$Od=d;function w(I){return k.$ud(I,b=>t.concat(b))}e.$Pd=w;function N(I){return k.$Bd(I)}e.$Qd=N;function P(I){return k.$wd(I,b=>t.concat(b))}e.$Rd=P;async function S(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await P(I.stream)])}e.$Sd=S;function f(I){return k.$zd(I,b=>t.concat(b))}e.$Td=f;function y(I){return k.$Cd(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Ud=y;function m(I){return k.$td(b=>t.concat(b),I)}e.$Vd=m;function O(I,b){return k.$Dd(I,b,U=>t.concat(U))}e.$Wd=O;function j(I,b){return k.$Ed(I,b,U=>t.concat(U))}e.$Xd=j;function $(I){let b=0,U=0,G=0;const V=new Uint8Array(Math.floor(I.length/4*3)),H=W=>{switch(U){case 3:V[G++]=b|W,U=0;break;case 2:V[G++]=b|W>>>2,b=W<<6,U=3;break;case 1:V[G++]=b|W>>>4,b=W<<4,U=2;break;default:b=W<<2,U=1}};for(let W=0;W<I.length;W++){const p=I.charCodeAt(W);if(p>=65&&p<=90)H(p-65);else if(p>=97&&p<=122)H(p-97+26);else if(p>=48&&p<=57)H(p-48+52);else if(p===43||p===45)H(62);else if(p===47||p===95)H(63);else{if(p===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const _=G;for(;U>0;)H(0);return t.wrap(V).slice(0,_)}e.$Yd=$;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},b=!0,U=!1){const G=U?R:A;let V="";const H=I.byteLength%3;let _=0;for(;_<I.byteLength-H;_+=3){const W=I[_+0],p=I[_+1],X=I[_+2];V+=G[W>>>2],V+=G[(W<<4|p>>>4)&63],V+=G[(p<<2|X>>>6)&63],V+=G[X&63]}if(H===1){const W=I[_+0];V+=G[W>>>2],V+=G[W<<4&63],b&&(V+="==")}else if(H===2){const W=I[_+0],p=I[_+1];V+=G[W>>>2],V+=G[(W<<4|p>>>4)&63],V+=G[p<<2&63],b&&(V+="=")}return V}e.$Zd=z}),define(q[24],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(q[13],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.StringEOL=void 0;var C;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function k(v){let T=0,r=0,l=0,t=0;for(let a=0,h=v.length;a<h;a++){const c=v.charCodeAt(a);c===13?(T===0&&(r=a),T++,a+1<h&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,l=a+1):c===10&&(t|=1,T===0&&(r=a),T++,l=a+1)}return T===0&&(r=v.length),[T,r,v.length-l,t]}e.$Ws=k}),define(q[14],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(C||(e.LanguageId=C={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var T;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class l{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(c+=" mtki"),g&2&&(c+=" mtkb"),g&4&&(c+=" mtku"),g&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,h){const c=this.getForeground(a),g=this.getFontStyle(a);let o=`color: ${h[c]};`;g&1&&(o+="font-style: italic;"),g&2&&(o+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(a){const h=this.getForeground(a),c=this.getFontStyle(a);return{foreground:h,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$Us=l}),define(q[25],K([0,1,26]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=void 0;class k{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,l){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=l}replace(r,l,t){if(r>=this.a.length)return;if(l===0){this.insert(r,t);return}else if(t===0){this.delete(r,l);return}const a=this.a.slice(0,r),h=this.a.slice(r+l),c=v(t,this.b);this.a=a.concat(c,h)}delete(r,l){l===0||r>=this.a.length||this.a.splice(r,l)}insert(r,l){if(l===0||r>=this.a.length)return;const t=[];for(let a=0;a<l;a++)t[a]=this.b;this.a=(0,C.$Ub)(this.a,r,t)}}e.$zB=k;function v(T,r){const l=[];for(let t=0;t<T;t++)l[t]=r;return l}}),define(q[7],K([0,1,14]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,l){const t=k.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new k(a,r,l)}constructor(r,l,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(r){return r instanceof k?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,l,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=l<<1,h=a+(t<<1);for(let c=a;c<h;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const l=this.a[(r<<1)+1],t=C.$Us.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const l=this.a[(r<<1)+1];return C.$Us.getTokenType(l)}getForeground(r){const l=this.a[(r<<1)+1];return C.$Us.getForeground(l)}getClassName(r){const l=this.a[(r<<1)+1];return C.$Us.getClassNameFromMetadata(l)}getInlineStyle(r,l){const t=this.a[(r<<1)+1];return C.$Us.getInlineStyleFromMetadata(t,l)}getPresentation(r){const l=this.a[(r<<1)+1];return C.$Us.getPresentationFromMetadata(l)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return k.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,l,t){return new v(this,r,l,t)}static convertToEndOffset(r,l){const a=(r.length>>>1)-1;for(let h=0;h<a;h++)r[h<<1]=r[h+1<<1];r[a<<1]=l}static findIndexInTokensArray(r,l){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const h=t+Math.floor((a-t)/2),c=r[h<<1];if(c===l)return h+1;c<l?t=h+1:c>l&&(a=h)}return t}withInserted(r){if(r.length===0)return this;let l=0,t=0,a="";const h=new Array;let c=0;for(;;){const g=l<this.b?this.a[l<<1]:-1,o=t<r.length?r[t]:null;if(g!==-1&&(o===null||g<=o.offset)){a+=this.c.substring(c,g);const n=this.a[(l<<1)+1];h.push(a.length,n),l++,c=g}else if(o){if(o.offset>c){a+=this.c.substring(c,o.offset);const n=this.a[(l<<1)+1];h.push(a.length,n),c=o.offset}a+=o.text,h.push(a.length,o.tokenMetadata),t++}else break}return new k(new Uint32Array(h),a,this.d)}}e.$Xs=k;class v{constructor(r,l,t,a){this.a=r,this.b=l,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(l),this.f=0;for(let h=this.e,c=r.getCount();h<c&&!(r.getStartOffset(h)>=t);h++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const l=this.a.getEndOffset(this.e+r);return Math.min(this.c,l)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,l){return this.a.getInlineStyle(this.e+r,l)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],K([0,1,7]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.$Ys=void 0,e.$Ys=new Uint32Array(0).buffer;class k{static deleteBeginning(r,l){return r===null||r===e.$Ys?r:k.delete(r,0,l)}static deleteEnding(r,l){if(r===null||r===e.$Ys)return r;const t=v(r),a=t[t.length-2];return k.delete(r,l,a)}static delete(r,l,t){if(r===null||r===e.$Ys||l===t)return r;const a=v(r),h=a.length>>>1;if(l===0&&a[a.length-2]===t)return e.$Ys;const c=C.$Xs.findIndexInTokensArray(a,l),g=c>0?a[c-1<<1]:0,o=a[c<<1];if(t<o){const w=t-l;for(let N=c;N<h;N++)a[N<<1]-=w;return r}let n,i;g!==l?(a[c<<1]=l,n=c+1<<1,i=l):(n=c<<1,i=g);const s=t-l;for(let w=c+1;w<h;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const d=new Uint32Array(n);return d.set(a.subarray(0,n),0),d.buffer}static append(r,l){if(l===e.$Ys)return r;if(r===e.$Ys)return l;if(r===null)return r;if(l===null)return null;const t=v(r),a=v(l),h=a.length>>>1,c=new Uint32Array(t.length+a.length);c.set(t,0);let g=t.length;const o=t[t.length-2];for(let n=0;n<h;n++)c[g++]=a[n<<1]+o,c[g++]=a[(n<<1)+1];return c.buffer}static insert(r,l,t){if(r===null||r===e.$Ys)return r;const a=v(r),h=a.length>>>1;let c=C.$Xs.findIndexInTokensArray(a,l);c>0&&a[c-1<<1]===l&&c--;for(let g=c;g<h;g++)a[g<<1]+=t;return r}}e.$Zs=k;function v(T){return T instanceof Uint32Array?T:new Uint32Array(T)}e.$1s=v}),define(q[28],K([0,1,26,12,44,13,27,15]),function(F,e,C,k,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class t{static deserialize(h,c,g){const o=new Uint32Array(h.buffer),n=(0,k.$Jd)(h,c);c+=4;const i=(0,k.$Jd)(h,c);c+=4;const s=[];for(let d=0;d<i;d++){const w=(0,k.$Jd)(h,c);c+=4,s.push(o.subarray(c/4,c/4+w/4)),c+=w}return g.push(new t(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,c){this.a=h,this.b=c}getLineRange(){return new l.$ts(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let c=0;c<this.b.length;c++){const g=this.b[c];if(!(g instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=g.byteLength}return h}serialize(h,c){(0,k.$Kd)(h,this.a,c),c+=4,(0,k.$Kd)(h,this.b.length,c),c+=4;for(let g=0;g<this.b.length;g++){const o=this.b[g];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,k.$Kd)(h,o.byteLength,c),c+=4,h.set(new Uint8Array(o.buffer),c),c+=o.byteLength}return c}applyEdit(h,c){const[g,o]=(0,T.$Ws)(c);this.c(h),this.d(new v.$js(h.startLineNumber,h.startColumn),g,o)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const c=h.startLineNumber-this.a,g=h.endLineNumber-this.a;if(g<0){const o=g-c;this.a-=o;return}if(!(c>=this.b.length)){if(c<0&&g>=this.b.length){this.a=0,this.b=[];return}if(c===g){this.b[c]=r.$Zs.delete(this.b[c],h.startColumn-1,h.endColumn-1);return}if(c>=0)if(this.b[c]=r.$Zs.deleteEnding(this.b[c],h.startColumn-1),g<this.b.length){const o=r.$Zs.deleteBeginning(this.b[g],h.endColumn-1);this.b[c]=r.$Zs.append(this.b[c],o),this.b.splice(c+1,g-c)}else this.b[c]=r.$Zs.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const o=-c;this.a-=o,this.b[g]=r.$Zs.deleteBeginning(this.b[g],h.endColumn-1),this.b=this.b.slice(g)}}}d(h,c,g){if(c===0&&g===0)return;const o=h.lineNumber-this.a;if(o<0){this.a+=c;return}if(!(o>=this.b.length)){if(c===0){this.b[o]=r.$Zs.insert(this.b[o],h.column-1,g);return}this.b[o]=r.$Zs.deleteEnding(this.b[o],h.column-1),this.b[o]=r.$Zs.insert(this.b[o],h.column-1,g),this.e(h.lineNumber,c)}}e(h,c){if(c===0)return;const g=[];for(let o=0;o<c;o++)g[o]=null;this.b=C.$Ub(this.b,h,g)}}e.$2s=t}),define(q[16],K([0,1,12,28]),function(F,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=void 0;class v{static deserialize(r){let l=0;const t=(0,C.$Jd)(r,l);l+=4;const a=[];for(let h=0;h<t;h++)l=k.$2s.deserialize(r,l,a);return a}constructor(){this.a=[]}add(r,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(l);return}}this.a.push(new k.$2s(r,[l]))}finalize(){return this.a}serialize(){const r=this.b(),l=new Uint8Array(r);return this.c(l),l}b(){let r=0;r+=4;for(let l=0;l<this.a.length;l++)r+=this.a[l].serializeSize();return r}c(r){let l=0;(0,C.$Kd)(r,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(r,l)}}e.$AB=v}),define(q[29],K([0,1,30,3,31,45]),function(F,e,C,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function r($){return $===47||$===92}e.$Bf=r;function l($){return $.replace(/[\\/]/g,C.$6d.sep)}e.$Cf=l;function t($){return $.indexOf("/")===-1&&($=l($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Df=t;function a($,A=C.$6d.sep){if(!$)return"";const R=$.length,z=$.charCodeAt(0);if(r(z)){if(r($.charCodeAt(1))&&!r($.charCodeAt(2))){let b=3;const U=b;for(;b<R&&!r($.charCodeAt(b));b++);if(U!==b&&!r($.charCodeAt(b+1))){for(b+=1;b<R;b++)if(r($.charCodeAt(b)))return $.slice(0,b+1).replace(/[\\/]/g,A)}}return A}else if(d(z)&&$.charCodeAt(1)===58)return r($.charCodeAt(2))?$.slice(0,2)+A:$.slice(0,2);let I=$.indexOf("://");if(I!==-1){for(I+=3;I<R;I++)if(r($.charCodeAt(I)))return $.slice(0,I+1)}return""}e.$Ef=a;function h($){if(!k.$i||!$||$.length<5)return!1;let A=$.charCodeAt(0);if(A!==92||(A=$.charCodeAt(1),A!==92))return!1;let R=2;const z=R;for(;R<$.length&&(A=$.charCodeAt(R),A!==92);R++);return!(z===R||(A=$.charCodeAt(R+1),isNaN(A)||A===92))}e.$Ff=h;const c=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n($,A=k.$i){const R=A?c:g;return!(!$||$.length===0||/^\s+$/.test($)||(R.lastIndex=0,R.test($))||A&&o.test($)||$==="."||$===".."||A&&$[$.length-1]==="."||A&&$.length!==$.trim().length||$.length>255)}e.$Gf=n;function i($,A,R){const z=$===A;return!R||z?z:!$||!A?!1:(0,v.$Me)($,A)}e.$Hf=i;function s($,A,R,z=C.sep){if($===A)return!0;if(!$||!A||A.length>$.length)return!1;if(R){if(!(0,v.$Ne)($,A))return!1;if(A.length===$.length)return!0;let b=A.length;return A.charAt(A.length-1)===z&&b--,$.charAt(b)===z}return A.charAt(A.length-1)!==z&&(A+=z),$.indexOf(A)===0}e.$If=s;function d($){return $>=65&&$<=90||$>=97&&$<=122}e.$Jf=d;function w($,A){return k.$i&&$.endsWith(":")&&($+=C.sep),(0,C.$8d)($)||($=(0,C.$9d)(A,$)),$=(0,C.$7d)($),k.$i?($=(0,v.$ve)($,C.sep),$.endsWith(":")&&($+=C.sep)):($=(0,v.$ve)($,C.sep),$||($=C.sep)),$}e.$Kf=w;function N($){const A=(0,C.$7d)($);return k.$i?$.length>3?!1:P(A)&&($.length===2||A.charCodeAt(2)===92):A===C.$6d.sep}e.$Lf=N;function P($,A=k.$i){return A?d($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Mf=P;function S($,A=k.$i){return P($,A)?$[0]:void 0}e.$Nf=S;function f($,A,R){return A.length>$.length?-1:$===A?0:(R&&($=$.toLowerCase(),A=A.toLowerCase()),$.indexOf(A))}e.$Of=f;function y($){const A=$.split(":");let R,z,I;for(const b of A){const U=Number(b);(0,T.$nf)(U)?z===void 0?z=U:I===void 0&&(I=U):R=R?[R,b].join(":"):b}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$Pf=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function j($,A,R=8){let z="";for(let b=0;b<R;b++){let U;b===0&&k.$i&&!A&&(R===3||R===4)?U=O:U=m,z+=U.charAt(Math.floor(Math.random()*U.length))}let I;return A?I=`${A}-${z}`:I=z,$?(0,C.$9d)($,I):I}e.$Qf=j}),define(q[17],K([0,1,6,3,8]),function(F,e,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${T.vscodeRemoteResource}`}set(h,c,g){this.a[h]=c,this.b[h]=g}setConnectionToken(h,c){this.c[h]=c}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return C.$Y(s),h}const c=h.authority;let g=this.a[c];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const o=this.b[c],n=this.c[c];let i=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(i+=`&${e.$Vf}=${encodeURIComponent(n)}`),v.URI.from({scheme:k.$o?this.d:T.vscodeRemoteResource,authority:`${g}:${o}`,path:this.f,query:i})}}e.$Wf=new r,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(h){const c=this.b(h,F);return this.uriToBrowserUri(c)}uriToBrowserUri(h){return h.scheme===T.vscodeRemote?e.$Wf.rewrite(h):h.scheme===T.file&&(k.$m||k.$p&&k.$g.origin===`${T.vscodeFileResource}://${l.a}`)?h.with({scheme:T.vscodeFileResource,authority:h.authority||l.a,query:null,fragment:null}):h}asFileUri(h){const c=this.b(h,F);return this.uriToFileUri(c)}uriToFileUri(h){return h.scheme===T.vscodeFileResource?h.with({scheme:T.file,authority:h.authority!==l.a?h.authority:null,query:null,fragment:null}):h}b(h,c){return v.URI.isUri(h)?h:v.URI.parse(c.toUrl(h))}}e.$2f=new l;var t;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const c="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(c);if(s)return h.get(s)}a.getHeadersFromQuery=g;function o(n,i,s){if(!globalThis.crossOriginIsolated)return;const d=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(c,d):n[c]=d}a.addSearchParam=o})(t||(e.COI=t={}))}),define(q[32],K([0,1,21,17,3,8]),function(F,e,C,k,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class r{constructor(g,o,n){this.id=g,this.dependencies=o,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,o,n)=>{typeof g!="string"&&(n=o,o=g,g=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new r(g,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const o=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!o)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(g){return new Promise((o,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",d),i.removeEventListener("error",w)},d=N=>{s(),o(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",d),i.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((o,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),o(this.c.pop())}catch(i){n(i)}})}async j(g){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=T.URI.parse(g).fsPath,d=o.readFileSync(s).toString(),w=i.wrap(d.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(c,g,o){if(C.$R){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${o&&!v.$o?k.$Zf:k.$Yf}/${n}`;i=k.$2f.asBrowserUri(N).toString(!0)}const s=l.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([c],n,i)})}e.$cC=h}),define(q[18],K([0,1,29,17,30,3,31,8]),function(F,e,C,k,v,T,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function t(o){return(0,l.$Tf)(o,!0)}e.$9f=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Fe)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return C.$If(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$ng)(n.authority,i.authority))return C.$If(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$fg)(n)||n.authority}basename(n){return v.$6d.basename(n.path)}extname(n){return v.$6d.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(v.$_d(t(n))).path:(i=v.$6d.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(v.$7d(t(n))).path:i=v.$6d.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$ng)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const w=v.$$d(t(n),t(i));return T.$i?C.$Cf(w):w}let s=n.path||"/";const d=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,d.length);w<N&&!(s.charCodeAt(w)!==d.charCodeAt(w)&&s.charAt(w).toLowerCase()!==d.charAt(w).toLowerCase());w++);s=d.substr(0,w)+s.substr(w)}return v.$6d.relative(s,d)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const s=l.URI.file(v.$0d(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=C.$Df(i),n.with({path:v.$6d.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Me)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===k.Schemas.file){const s=t(n);return s.length>C.$Ef(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$og)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===k.Schemas.file){const d=t(n);s=d!==void 0&&d.length===C.$Ef(d).length&&d[d.length-1]===i}else{i="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$og)(n,i)?n.with({path:n.path+"/"}):n}}e.$0f=a,e.$$f=new a(()=>!1),e.$_f=new a(o=>o.scheme===k.Schemas.file?!T.$k:!0),e.$ag=new a(o=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function h(o,n){const i=[];for(let s=0;s<o.length;s++){const d=n(o[s]);o.some((w,N)=>N===s?!1:(0,e.$cg)(d,n(w)))||i.push(o[s])}return i}e.$rg=h;var c;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[P,S]=N.split(":");P&&S&&s.set(P,S)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(o.META_DATA_MIME,w),s}o.parseMetaData=n})(c||(e.DataUri=c={}));function g(o,n,i){if(n){let s=o.path;return s&&s[0]!==v.$6d.sep&&(s=v.$6d.sep+s),o.with({scheme:i,authority:n,path:s})}return o.with({scheme:i})}e.$sg=g}),define(q[19],K([0,1,46,6,33,2,18,3,24]),function(F,e,C,k,v,T,r,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function a(M){return!!M&&typeof M.then=="function"}e.$tg=a;function h(M){const u=new C.$pd,E=M(u.token),L=new Promise((B,D)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),u.dispose(),D(new k.$3)});Promise.resolve(E).then(J=>{Y.dispose(),u.dispose(),B(J)},J=>{Y.dispose(),u.dispose(),D(J)})});return new class{cancel(){u.cancel()}then(B,D){return L.then(B,D)}catch(B){return this.then(void 0,B)}finally(B){return L.finally(B)}}}e.$ug=h;function c(M,u,E){return new Promise((L,B)=>{const D=u.onCancellationRequested(()=>{D.dispose(),L(E)});M.then(L,B).finally(()=>D.dispose())})}e.$vg=c;function g(M,u){return new Promise((E,L)=>{const B=u.onCancellationRequested(()=>{B.dispose(),L(new k.$3)});M.then(E,L).finally(()=>B.dispose())})}e.$wg=g;async function o(M){let u=-1;const E=M.map((L,B)=>L.then(D=>(u=B,D)));try{return await Promise.race(E)}finally{M.forEach((L,B)=>{B!==u&&L.cancel()})}}e.$xg=o;function n(M,u,E){let L;const B=setTimeout(()=>{L?.(void 0),E?.()},u);return Promise.race([M.finally(()=>clearTimeout(B)),new Promise(D=>L=D)])}e.$yg=n;function i(M){return new Promise((u,E)=>{const L=M();a(L)?L.then(u,E):u(L)})}e.$zg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const E=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(E,E).then(L)})}return new Promise((E,L)=>{this.b.then(E,L)})}return this.a=u(),new Promise((E,L)=>{this.a.then(B=>{this.a=null,E(B)},B=>{this.a=null,L(B)})})}dispose(){this.f=!0}}e.$Ag=s;class d{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Bg=d;class w{constructor(){this.a=new Map}queue(u,E){const B=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(u)===B&&this.a.delete(u)});return this.a.set(u,B),B}}e.$Cg=w;const N=(M,u)=>{let E=!0;const L=setTimeout(()=>{E=!1,u()},M);return{isTriggered:()=>E,dispose:()=>{clearTimeout(L),E=!1}}},P=M=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,M())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class S{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,E=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((B,D)=>{this.d=B,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$cd?P(L):N(E,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=S;class f{constructor(u){this.a=new S(u),this.b=new s}trigger(u,E){return this.a.trigger(()=>this.b.queue(u),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=f;class y{constructor(){this.a=!1,this.b=new Promise((u,E)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=y;class m extends y{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Gg=m;function O(M,u){return u?new Promise((E,L)=>{const B=setTimeout(()=>{D.dispose(),E()},M),D=u.onCancellationRequested(()=>{clearTimeout(B),D.dispose(),L(new k.$3)})}):h(E=>O(M,E))}e.$Hg=O;function j(M,u=0,E){const L=setTimeout(()=>{M(),E&&B.dispose()},u),B=(0,T.$ic)(()=>{clearTimeout(L),E?.deleteAndLeak(B)});return E?.add(B),B}e.$Ig=j;function $(M){const u=[];let E=0;const L=M.length;function B(){return E<L?M[E++]():null}function D(Y){Y!=null&&u.push(Y);const J=B();return J?J.then(D):Promise.resolve(u)}return Promise.resolve(null).then(D)}e.$Jg=$;function A(M,u=L=>!!L,E=null){let L=0;const B=M.length,D=()=>{if(L>=B)return Promise.resolve(E);const Y=M[L++];return Promise.resolve(Y()).then(Q=>u(Q)?Promise.resolve(Q):D())};return D()}e.$Kg=A;function R(M,u=L=>!!L,E=null){if(M.length===0)return Promise.resolve(E);let L=M.length;const B=()=>{L=-1;for(const D of M)D.cancel?.()};return new Promise((D,Y)=>{for(const J of M)J.then(Q=>{--L>=0&&u(Q)?(B(),D(Q)):L===0&&D(E)}).catch(Q=>{--L>=0&&(B(),Y(Q))})})}e.$Lg=R;class z{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new v.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((E,L)=>{this.f.push({factory:u,c:E,e:L}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const E=u.factory();E.then(u.c,u.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=z;class I extends z{constructor(){super(1)}}e.$Ng=I;class b{constructor(){this.a=new x,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$Og=b;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new te;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,E=r.$$f){const L=E.getComparisonKey(u);let B=this.a.get(L);if(!B){B=new I;const D=this.f++,Y=v.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(L),this.h(),this.d?.deleteAndDispose(D),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$sc),this.d.set(D,Y),this.a.set(L,B)}return B}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=U;class G{constructor(u,E){this.a=-1,typeof u=="function"&&typeof E=="number"&&this.setIfNotSet(u,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},E)}setIfNotSet(u,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},E))}}e.$Qg=G;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setInterval(()=>{u()},E)}}e.$Rg=V;class H{constructor(u,E){this.b=-1,this.a=u,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=H;class _{constructor(u,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=u,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=_;class W extends H{constructor(u,E){super(u,E),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$Ug=W;class p extends T.$kc{constructor(u,E){super(),this.g=u,this.h=E,this.a=[],this.b=this.B(new T.$lc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of u)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=p,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=M=>{(0,l.$A)(()=>{if(u)return;const E=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:e.$Wg=(M,u)=>{const E=requestIdleCallback(M,typeof u=="number"?{timeout:u}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(E))}}}}();class X{constructor(u){this.d=!1,this.a=()=>{try{this.f=u()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=X;async function re(M,u,E){let L;for(let B=0;B<E;B++)try{return await M()}catch(D){L=D,await O(u)}throw L}e.$Yg=re;class x{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,E,L){return this.a={taskId:u,cancel:()=>L?.(),promise:E},E.then(()=>this.d(u),()=>this.d(u)),E}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let E,L;const B=new Promise((D,Y)=>{E=D,L=Y});this.b={run:u,promise:B,promiseResolve:E,promiseReject:L}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=x;class ae{constructor(u,E=()=>Date.now()){this.d=u,this.f=E,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$1g=ae;var ee;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,E)=>{this.a=u,this.b=E})}complete(u){return new Promise(E=>{this.a(u),this.d={outcome:0,value:u},E()})}error(u){return new Promise(E=>{this.b(u),this.d={outcome:1,value:u},E()})}cancel(){return this.error(new k.$3)}}e.$2g=te;var ne;(function(M){async function u(L){let B;const D=await Promise.all(L.map(Y=>Y.then(J=>J,J=>{B||(B=J)})));if(typeof B<"u")throw B;return D}M.settled=u;function E(L){return new Promise(async(B,D)=>{try{await L(B,D)}catch(Y){D(Y)}})}M.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class Z{static fromArray(u){return new Z(E=>{E.emitMany(u)})}static fromPromise(u){return new Z(async E=>{E.emitMany(await u)})}static fromPromises(u){return new Z(async E=>{await Promise.all(u.map(async L=>E.emitOne(await L)))})}static merge(u){return new Z(async E=>{await Promise.all(u.map(async L=>{for await(const B of L)E.emitOne(B)}))})}static{this.EMPTY=Z.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$fd,queueMicrotask(async()=>{const E={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(u(E)),this.j()}catch(L){this.k(L)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,E){return new Z(async L=>{for await(const B of u)L.emitOne(E(B))})}map(u){return Z.map(this,u)}static filter(u,E){return new Z(async L=>{for await(const B of u)E(B)&&L.emitOne(B)})}filter(u){return Z.filter(this,u)}static coalesce(u){return Z.filter(u,E=>!!E)}coalesce(){return Z.coalesce(this)}static async toPromise(u){const E=[];for await(const L of u)E.push(L);return E}toPromise(){return Z.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$3g=Z;class se extends Z{constructor(u,E){super(E),this.l=u}cancel(){this.l.cancel()}}e.$4g=se;function ce(M){const u=new C.$pd,E=M(u.token);return new se(u,async L=>{const B=u.token.onCancellationRequested(()=>{B.dispose(),u.dispose(),L.reject(new k.$3)});try{for await(const D of E){if(u.token.isCancellationRequested)return;L.emitOne(D)}B.dispose(),u.dispose()}catch(D){B.dispose(),u.dispose(),L.reject(D)}})}e.$5g=ce}),define(q[20],K([0,1,34]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yB=e.$xB=e.$wB=void 0,e.$wB=new class{clone(){return this}equals(T){return this===T}};function k(T,r){return new C.$5s([new C.$4s(0,"",T)],r)}e.$xB=k;function v(T,r){const l=new Uint32Array(2);return l[0]=0,l[1]=(T<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new C.$6s(l,r===null?e.$wB:r)}e.$yB=v}),define(q[35],K([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,C,k,v,T,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=void 0;var o;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(f,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$BB=n;class i extends n{constructor(f,y,m,O){super(f,y),this._textModel=m,this._languageIdCodec=O}updateTokensUntilLine(f,y){const m=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>y)break;const j=this._textModel.getLineContent(O.lineNumber),$=N(this._languageIdCodec,m,this.tokenizationSupport,j,!0,O.startState);f.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,y){const m=this.getStartState(f.lineNumber);if(!m)return 0;const O=this._textModel.getLanguageId(),j=this._textModel.getLineContent(f.lineNumber),$=j.substring(0,f.column-1)+y+j.substring(f.column-1),A=N(this._languageIdCodec,O,this.tokenizationSupport,$,!0,m),R=new g.$Xs(A.tokens,$,this._languageIdCodec);if(R.getCount()===0)return 0;const z=R.findTokenIndexAtOffset(f.column-1);return R.getStandardTokenType(z)}tokenizeLineWithEdit(f,y,m){const O=f.lineNumber,j=f.column,$=this.getStartState(O);if(!$)return null;const A=this._textModel.getLineContent(O),R=A.substring(0,j-1)+m+A.substring(j-1+y),z=this._textModel.getLanguageIdAtPosition(O,0),I=N(this._languageIdCodec,z,this.tokenizationSupport,R,!0,$);return new g.$Xs(I.tokens,R,this._languageIdCodec)}isCheapToTokenize(f){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<y||f===y&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let O=this.b(y);const j=this._textModel.getLanguageId();for(let $=y;$<=m;$++){const A=this._textModel.getLineContent($),R=N(this._languageIdCodec,j,this.tokenizationSupport,A,!0,O);f.add($,R.tokens),O=R.endState}return{heuristicTokens:!0}}b(f){let y=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let O=null;for(let A=f-1;y>1&&A>=1;A--){const R=this._textModel.getLineFirstNonWhitespaceColumn(A);if(R!==0&&R<y&&(m.push(this._textModel.getLineContent(A)),y=R,O=this.getStartState(A),O))break}O||(O=this.tokenizationSupport.getInitialState()),m.reverse();const j=this._textModel.getLanguageId();let $=O;for(const A of m)$=N(this._languageIdCodec,j,this.tokenizationSupport,A,!1,$).endState;return $}}e.$CB=i;class s{constructor(f){this.d=f,this.a=new d,this.b=new w,this.b.addRange(new t.$rs(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,y){if(!y)throw new k.$ab("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,y);return m&&f<this.d&&this.b.addRange(new t.$rs(f+1,f+2)),m}acceptChange(f,y){this.d+=y-f.length,this.a.acceptChange(f,y),this.b.addRangeAndResize(new t.$rs(f.startLineNumber,f.endLineNumberExclusive),y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Ws)(y.text);this.acceptChange(new l.$ts(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$rs(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,y){return f===1?y:this.getEndState(f-1)}getFirstInvalidLine(f){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,f);if(!m)throw new k.$ab("Start state must be defined");return{lineNumber:y,startState:m}}}e.$DB=s;class d{constructor(){this.a=new h.$zB(null)}getEndState(f){return this.a.get(f)}setEndState(f,y){const m=this.a.get(f);return m&&m.equals(y)?!1:(this.a.set(f,y),!0)}acceptChange(f,y){let m=f.length;y>0&&m>0&&(m--,y--),this.a.replace(f.startLineNumber,m,y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Ws)(y.text);this.acceptChange(new l.$ts(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$EB=d;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$rs(f.start+1,f.endExclusive),f.start}delete(f){const y=this.a.findIndex(m=>m.contains(f));if(y!==-1){const m=this.a[y];m.start===f?m.endExclusive===f+1?this.a.splice(y,1):this.a[y]=new t.$rs(f+1,m.endExclusive):m.endExclusive===f+1?this.a[y]=new t.$rs(m.start,f):this.a.splice(y,1,new t.$rs(m.start,f),new t.$rs(f+1,m.endExclusive))}}addRange(f){t.$rs.addRange(f,this.a)}addRangeAndResize(f,y){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let O=m;for(;!(O>=this.a.length||f.endExclusive<this.a[O].start);)O++;const j=y-f.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(j);if(m===O){const $=new t.$rs(f.start,f.start+y);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),A=Math.max(f.endExclusive,this.a[O-1].endExclusive),R=new t.$rs($,A+j);R.isEmpty?this.a.splice(m,O-m):this.a.splice(m,O-m,R)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$FB=w;function N(S,f,y,m,O,j){let $=null;if(y)try{$=y.tokenizeEncoded(m,O,j.clone())}catch(A){(0,k.$Y)(A)}return $||($=(0,a.$yB)(S.encodeLanguageId(f),j)),g.$Xs.convertToEndOffset($.tokens,m.length),$}class P{constructor(f,y){this.b=f,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,C.$Wg)(f=>{this.f=!1,this.h(f)}))}h(f){const y=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$A)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),y=new c.$AB,m=T.$bd.create(!1);do if(m.elapsed()>1||this.l(y)>=f)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(f,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,y){this.b.store.invalidateEndStateRange(new l.$ts(f,y))}}e.$GB=P}),define(q[37],K([0,1,33,2,36,14,34]),function(F,e,C,k,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GBb=void 0;class l extends k.$kc{constructor(a,h,c,g,o,n,i){super(),this.c=a,this.f=h,this.g=c,this.h=g,this.j=o,this.m=n,this.n=i,this.a=[],this.b=this.B(new C.$fd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,h,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,h){if(this.h)return this.h(a,h)}tokenizeEncoded(a,h,c){const g=Math.random()*1e4<1,o=this.n||g,n=o?new v.$bd(!0):void 0,i=this.c.tokenizeLine2(a,c,500);if(o){const d=n.elapsed();(g||d>32)&&this.m(d,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$6s(i.tokens,c);if(this.g){const d=this.a,w=i.tokens;for(let N=0,P=w.length>>>1;N<P;N++){const S=w[(N<<1)+1],f=T.$Us.getLanguageId(S);d[f]||(d[f]=!0,this.b.fire(f))}}let s;return c.equals(i.ruleStack)?s=c:s=i.ruleStack,new r.$6s(i.tokens,s)}}e.$GBb=l}),define(q[38],K([0,1,20,2,11]),function(F,e,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HBb=void 0;class T extends k.$kc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,a){super(),this.a=l,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,a){throw new Error("Not supported!")}tokenizeEncoded(l,t,a){return l.length>=this.c.get()?(0,C.$yB)(this.a,a):this.b.tokenizeEncoded(l,t,a)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$HBb=T}),define(q[39],K([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,C,k,v,T,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MBb=void 0;class o extends l.$Mu{constructor(s,d,w,N,P,S,f,y){super(s,d,w,N),this.s=P,this.t=S,this.u=f,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new k.$Sg(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$ts(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,w=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!w)){if(w.grammar){const N=new g.$HBb(this.u,new c.$GBb(w.grammar,w.initialState,!1,void 0,()=>!1,(P,S,f)=>{this.s.reportTokenizationTime(P,s,w.sourceExtensionId,S,f)},!1),this.c);this.a=new t.$BB(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,C.$cC)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const w=new a.$AB,N=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||d>200)break;d++;const y=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const j=this.m(f.startState,m.endState);N.setState(f.lineNumber,j)}else N.setState(f.lineNumber,null);if(h.$Xs.convertToEndOffset(m.tokens,y.length),w.add(f.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(d===0)break;const P=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),P),new Date().getTime()-s>20){(0,T.$A)(()=>this.w());return}}}}e.$MBb=o;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],K([0,1,18]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JBb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(T){if(this.a[T.scopeName]){const r=this.a[T.scopeName];C.$bg(r.location,T.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${T.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${T.location.toString()}`)}this.a[T.scopeName]=T}getGrammarDefinition(T){return this.a[T]||null}}e.$JBb=k}),define(q[41],K([0,1,2,40]),function(F,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LBb=e.$KBb=void 0,e.$KBb="No TM Grammar registered for this language.";class v extends C.$kc{constructor(r,l,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new k.$JBb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async h=>{const c=this.c.getGrammarDefinition(h);if(!c)return this.a.logTrace(`No grammar found for scope ${h}`),null;const g=c.location;try{const o=await this.a.readFile(g);return t.parseRawGrammar(o,g.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${g}`,o),null}},getInjections:h=>{const c=h.split(".");let g=[];for(let o=1;o<=c.length;o++){const n=c.slice(0,o).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const h of l){if(this.c.register(h),h.injectTo){for(const c of h.injectTo){let g=this.f[c];g||(this.f[c]=g=[]),g.push(h.scopeName)}if(h.embeddedLanguages)for(const c of h.injectTo){let g=this.g[c];g||(this.g[c]=g=[]),g.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(r){return this.h.has(r)}setTheme(r,l){this.j.setTheme(r,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,l){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$KBb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$KBb);const h=a.embeddedLanguages;if(this.g[t]){const o=this.g[t];for(const n of o)for(const i of Object.keys(n))h[i]=n[i]}const c=Object.keys(h).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:h,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$KBb):o}return{languageId:r,grammar:g,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$LBb=v}),define(q[49],K([0,1,8,41,39]),function(F,e,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function T(l,t){return new r(l,t)}e.create=T;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const h=a.grammarDefinitions.map(c=>({location:C.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(h)}async g(t){const a=this.f.textmateMainUri,h=await new Promise((i,s)=>{F([a],i,s)}),c=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(o);const n=Promise.resolve({createOnigScanner:i=>c.createOnigScanner(i),createOnigString:i=>c.createOnigString(i)});return new k.$LBb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,h,n)}acceptNewModel(t){const a=C.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$MBb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,g){const o=await h.d;return o?(h.c[g]||(h.c[g]=o.createGrammar(c,g)),h.c[g]):Promise.resolve(null)},setTokensAndStates(c,g,o){h.a.setTokensAndStates(t.controllerId,c,g,o)},reportTokenizationTime(c,g,o,n,i){h.a.reportTokenizationTime(c,g,o,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,h){this.b.get(t).retokenize(a,h)}acceptModelLanguageChanged(t,a,h){this.b.get(t).onLanguageId(a,h)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c72447e8d8aaa7497c9a4bd68bc4301584b92beb/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
